(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define gerbil/tools/gxprof#main
    (lambda _args179_
      (let* ((_args180188_ _args179_)
             (_else182196_
              (lambda () (displayln '"Usage: gxprof exe-module-path arg ...")))
             (_K184209_
              (lambda (_args199_ _mod200_)
                (_gx#load-expander!)
                (let* ((_ctx202_
                        (gx#import-module__%
                         (gerbil/tools/gxprof#module-path _mod200_)
                         '#f
                         '#t))
                       (_main-id204_
                        (gerbil/tools/gxprof#find-runtime-symbol
                         _ctx202_
                         'main))
                       (_main-fn206_ (eval _main-id204_)))
                  (gerbil/tools/gxprof#profile _main-fn206_ _args199_)))))
        (if (let () (declare (not safe)) (##pair? _args180188_))
            (let ((_hd185212_
                   (let () (declare (not safe)) (##car _args180188_)))
                  (_tl186214_
                   (let () (declare (not safe)) (##cdr _args180188_))))
              (let* ((_mod217_ _hd185212_) (_args219_ _tl186214_))
                (_K184209_ _args219_ _mod217_)))
            (_else182196_)))))
  (define gerbil/tools/gxprof#module-path
    (lambda (_str177_)
      (if (and (> (string-length _str177_) '0)
               (eq? (string-ref _str177_ '0) '#\:))
          (string->symbol _str177_)
          _str177_)))
  (define gerbil/tools/gxprof#find-export-binding
    (lambda (_ctx127_ _id128_)
      (let ((_$e174_ (find (lambda (_e129131_)
                             (let* ((_g133143_ _e129131_)
                                    (_else135151_ (lambda () '#f))
                                    (_K137155_ (lambda () '#t)))
                               (if (let ()
                                     (declare (not safe))
                                     (##structure-direct-instance-of?
                                      _g133143_
                                      'gx#module-export::t))
                                   (let* ((_e138158_
                                           (let ()
                                             (declare (not safe))
                                             (##vector-ref _g133143_ '1)))
                                          (_e139161_
                                           (let ()
                                             (declare (not safe))
                                             (##vector-ref _g133143_ '2)))
                                          (_e140164_
                                           (let ()
                                             (declare (not safe))
                                             (##vector-ref _g133143_ '3))))
                                     (if (let ()
                                           (declare (not safe))
                                           (##eq? _e140164_ '0))
                                         (let ((_e141167_
                                                (let ()
                                                  (declare (not safe))
                                                  (##vector-ref
                                                   _g133143_
                                                   '4))))
                                           (if ((lambda (_g169171_)
                                                  (eq? _g169171_ _id128_))
                                                _e141167_)
                                               (_K137155_)
                                               (_else135151_)))
                                         (_else135151_)))
                                   (_else135151_))))
                           (##structure-ref
                            _ctx127_
                            '9
                            gx#module-context::t
                            '#f))))
        (if _$e174_ (gx#core-resolve-module-export _$e174_) '#f))))
  (define gerbil/tools/gxprof#find-runtime-symbol
    (lambda (_ctx119_ _id120_)
      (let ((_$e122_ (gerbil/tools/gxprof#find-export-binding
                      _ctx119_
                      _id120_)))
        (if _$e122_
            ((lambda (_bind125_)
               (if (let ()
                     (declare (not safe))
                     (##structure-instance-of?
                      _bind125_
                      'gx#runtime-binding::t))
                   '#!void
                   (error '"export is not a runtime binding" _id120_))
               (##structure-ref _bind125_ '1 gx#binding::t '#f))
             _$e122_)
            (error '"module does not export symbol"
                   (##structure-ref _ctx119_ '1 gx#expander-context::t '#f)
                   _id120_)))))
  (define gerbil/tools/gxprof#profile
    (lambda (_fun109_ _args110_)
      (with-unwind-protect
       (lambda ()
         (dynamic-wind
          gerbil/tools/gxprof#profile-start!
          (lambda () (apply _fun109_ _args110_))
          gerbil/tools/gxprof#profile-end!))
       (lambda ()
         (call-with-output-file
          '"gxprof.out"
          (lambda (_g114116_)
            (gerbil/tools/gxprof#write-samples
             gerbil/tools/gxprof#samples
             _g114116_)))))))
  (define gerbil/tools/gxprof#samples '())
  (define gerbil/tools/gxprof#profile-start!
    (lambda ()
      (let ((__tmp7001 (exact->inexact '1/1000)))
        (declare (not safe))
        (##set-heartbeat-interval! __tmp7001))
      (let ()
        (declare (not safe))
        (##interrupt-vector-set! '2 gerbil/tools/gxprof#profile-heartbeat!))))
  (define gerbil/tools/gxprof#profile-end!
    (lambda ()
      (let ((__tmp7002 (exact->inexact '1/100)))
        (declare (not safe))
        (##set-heartbeat-interval! __tmp7002))
      (let ()
        (declare (not safe))
        (##interrupt-vector-set! '2 ##thread-heartbeat!))))
  (define gerbil/tools/gxprof#profile-heartbeat!
    (lambda ()
      (let ((__tmp7003
             (lambda (_cont105_)
               (let () (declare (not safe)) (##thread-heartbeat!))
               (set! gerbil/tools/gxprof#samples
                     (cons (gerbil/tools/gxprof#continuation->sample _cont105_)
                           gerbil/tools/gxprof#samples)))))
        (declare (not safe))
        (##continuation-capture __tmp7003))))
  (define gerbil/tools/gxprof#continuation->sample
    (lambda (_cont95_)
      (let _lp97_ ((_cont99_
                    (let ()
                      (declare (not safe))
                      (##continuation-next-frame _cont95_ '#t)))
                   (_bt100_ '()))
        (if _cont99_
            (let ((_trace102_
                   (let ()
                     (declare (not safe))
                     (##continuation-creator _cont99_))))
              (_lp97_ (let ()
                        (declare (not safe))
                        (##continuation-next-frame _cont99_ '#t))
                      (cons _trace102_ _bt100_)))
            (reverse _bt100_)))))
  (define gerbil/tools/gxprof#write-samples
    (lambda (_samples78_ _port79_)
      (letrec* ((_traces81_ (make-table 'test: eq?))
                (_trace->name82_
                 (lambda (_trace88_)
                   (let ((_$e90_ (table-ref _traces81_ _trace88_ '#f)))
                     (if _$e90_
                         (values _$e90_)
                         (let ((_name93_
                                (let ()
                                  (declare (not safe))
                                  (##procedure-name _trace88_))))
                           (table-set! _traces81_ _trace88_ _name93_)
                           _name93_))))))
        (let ((_samples/names86_
               (map (lambda (_bt84_) (map _trace->name82_ _bt84_))
                    _samples78_)))
          (write _samples/names86_ _port79_))))))
