(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define scheme/process-context-impl#get-environment-variable
    (lambda (_var3659_) (getenv _var3659_ '#f)))
  (c-declare
   "#include <unistd.h>\nextern char **environ;\nstatic int ffi_count_envvars ()\n{\n int x;\n char **env;\n for (env = environ;\n      *env;\n      ++env) ++x;\n return x;\n}\n\nstatic char *ffi_get_envvar (int x)\n{\n return environ[x];\n}")
  (define-macro (define-c-lambda id args ret #!optional (name #f))
    (let ((name (or name (##symbol->string id))))
      `(define ,id (c-lambda ,args ,ret ,name))))
  (define-c-lambda
   scheme/process-context-impl#count-envvars
   ()
   int
   "ffi_count_envvars")
  (define-c-lambda
   scheme/process-context-impl#get-envvar
   (int)
   char-string
   "ffi_get_envvar")
  (define-c-lambda scheme/process-context-impl#_exit (int) void "_exit")
  (define scheme/process-context-impl#get-environment-variables
    (lambda ()
      (letrec ((_envvar3646_
                (lambda (_str3655_)
                  (let ((_ix3657_ (string-index _str3655_ '#\=)))
                    (cons (substring _str3655_ '0 _ix3657_)
                          (substring
                           _str3655_
                           (fx+ _ix3657_ '1)
                           (string-length _str3655_)))))))
        (let ((_count3648_ (scheme/process-context-impl#count-envvars)))
          (let _lp3650_ ((_x3652_ '0) (_vars3653_ '()))
            (if (fx< _x3652_ _count3648_)
                (_lp3650_
                 (fx+ _x3652_ '1)
                 (cons (_envvar3646_
                        (scheme/process-context-impl#get-envvar _x3652_))
                       _vars3653_))
                (reverse _vars3653_)))))))
  (define scheme/process-context-impl#r7rs-exit__%
    (lambda (_normally?3635_) (exit (if _normally?3635_ '0 '1))))
  (define scheme/process-context-impl#r7rs-exit__0
    (lambda ()
      (let ((_normally?3641_ '#t))
        (scheme/process-context-impl#r7rs-exit__% _normally?3641_))))
  (define scheme/process-context-impl#r7rs-exit
    (lambda _g10782_
      (let ((_g10781_ (let () (declare (not safe)) (##length _g10782_))))
        (cond ((let () (declare (not safe)) (##fx= _g10781_ 0))
               (apply scheme/process-context-impl#r7rs-exit__0 _g10782_))
              ((let () (declare (not safe)) (##fx= _g10781_ 1))
               (apply scheme/process-context-impl#r7rs-exit__% _g10782_))
              (else
               (##raise-wrong-number-of-arguments-exception
                scheme/process-context-impl#r7rs-exit
                _g10782_)))))))
