(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/actor/rpc/base#!rpc-protocol::t
    (make-struct-type
     'std/actor/rpc/base#!rpc-protocol::t
     '#f
     '2
     '!rpc-protocol
     '()
     '#f
     '(connect accept)))
  (define std/actor/rpc/base#!rpc-protocol?
    (make-struct-predicate std/actor/rpc/base#!rpc-protocol::t))
  (define std/actor/rpc/base#make-!rpc-protocol
    (lambda _$args253872_
      (apply make-struct-instance
             std/actor/rpc/base#!rpc-protocol::t
             _$args253872_)))
  (define std/actor/rpc/base#!rpc-protocol-connect
    (make-struct-field-accessor std/actor/rpc/base#!rpc-protocol::t '0))
  (define std/actor/rpc/base#!rpc-protocol-accept
    (make-struct-field-accessor std/actor/rpc/base#!rpc-protocol::t '1))
  (define std/actor/rpc/base#!rpc-protocol-connect-set!
    (make-struct-field-mutator std/actor/rpc/base#!rpc-protocol::t '0))
  (define std/actor/rpc/base#!rpc-protocol-accept-set!
    (make-struct-field-mutator std/actor/rpc/base#!rpc-protocol::t '1))
  (define std/actor/rpc/base#xdr-read-uuid
    (lambda (_buffer253868_)
      (let ((_bytes253870_ (make-u8vector std/misc/uuid#uuid-length)))
        (std/net/bio/input#bio-read-bytes _bytes253870_ _buffer253868_)
        (let ()
          (declare (not safe))
          (##structure std/misc/uuid#uuid::t _bytes253870_ '#f)))))
  (define std/actor/rpc/base#xdr-write-uuid
    (lambda (_obj253865_ _buffer253866_)
      (std/net/bio/output#bio-write-subu8vector
       (##direct-structure-ref _obj253865_ '1 std/misc/uuid#uuid::t '#f)
       '0
       std/misc/uuid#uuid-length
       _buffer253866_)))
  (table-set!
   std/actor/xdr#+xdr-default-type-registry+
   (let () (declare (not safe)) (##type-id std/misc/uuid#uuid::t))
   (let ()
     (declare (not safe))
     (##structure
      std/actor/xdr#XDR::t
      std/actor/rpc/base#xdr-read-uuid
      std/actor/rpc/base#xdr-write-uuid)))
  (table-set!
   std/actor/xdr#+xdr-default-type-registry+
   (let () (declare (not safe)) (##type-id std/actor/message#actor-error::t))
   (let ((__tmp310444
          (lambda (_buffer253862_)
            (std/actor/xdr#xdr-read-struct
             std/actor/message#actor-error::t
             _buffer253862_))))
     (declare (not safe))
     (##structure
      std/actor/xdr#XDR::t
      __tmp310444
      std/actor/xdr#xdr-write-struct)))
  (table-set!
   std/actor/xdr#+xdr-default-type-registry+
   (let () (declare (not safe)) (##type-id std/actor/proto#remote-error::t))
   (let ((__tmp310445
          (lambda (_buffer253859_)
            (std/actor/xdr#xdr-read-struct
             std/actor/proto#remote-error::t
             _buffer253859_))))
     (declare (not safe))
     (##structure
      std/actor/xdr#XDR::t
      __tmp310445
      std/actor/xdr#xdr-write-struct)))
  (table-set!
   std/actor/xdr#+xdr-default-type-registry+
   (let () (declare (not safe)) (##type-id std/actor/proto#rpc-error::t))
   (let ((__tmp310446
          (lambda (_buffer253856_)
            (std/actor/xdr#xdr-read-struct
             std/actor/proto#rpc-error::t
             _buffer253856_))))
     (declare (not safe))
     (##structure
      std/actor/xdr#XDR::t
      __tmp310446
      std/actor/xdr#xdr-write-struct)))
  (define std/actor/rpc/base#rpc::proto
    (let ((__tmp310447 (hash-copy std/actor/xdr#+xdr-default-type-registry+)))
      (declare (not safe))
      (##structure
       std/actor/proto#!protocol::t
       'std/actor#rpc
       '()
       __tmp310447)))
  (define std/actor/rpc/base#rpc.connect::t
    (make-struct-type
     'std/actor#rpc.connect::t
     '#f
     '3
     'rpc.connect
     '((final: . #t))
     '#f
     '(id address proto)))
  (define std/actor/rpc/base#rpc.connect?
    (make-struct-predicate std/actor/rpc/base#rpc.connect::t))
  (define std/actor/rpc/base#make-rpc.connect
    (lambda _$args253853_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.connect::t
             _$args253853_)))
  (define std/actor/rpc/base#rpc.connect-id
    (make-struct-field-accessor std/actor/rpc/base#rpc.connect::t '0))
  (define std/actor/rpc/base#rpc.connect-address
    (make-struct-field-accessor std/actor/rpc/base#rpc.connect::t '1))
  (define std/actor/rpc/base#rpc.connect-proto
    (make-struct-field-accessor std/actor/rpc/base#rpc.connect::t '2))
  (define std/actor/rpc/base#rpc.connect-id-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.connect::t '0))
  (define std/actor/rpc/base#rpc.connect-address-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.connect::t '1))
  (define std/actor/rpc/base#rpc.connect-proto-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.connect::t '2))
  (define std/actor/rpc/base#xdr-rpc.connect-read
    (lambda (_buffer253851_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.connect::t
       _buffer253851_)))
  (define std/actor/rpc/base#xdr-rpc.connect-write
    (lambda (_obj253848_ _buffer253849_)
      (std/actor/xdr#xdr-write-struct _obj253848_ _buffer253849_)))
  (define std/actor/rpc/base#rpc.connect::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.connect-read
       std/actor/rpc/base#xdr-rpc.connect-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.connect::t
   std/actor/rpc/base#rpc.connect::xdr)
  (define std/actor/rpc/base#rpc.register::t
    (make-struct-type
     'std/actor#rpc.register::t
     '#f
     '2
     'rpc.register
     '((final: . #t))
     '#f
     '(id proto)))
  (define std/actor/rpc/base#rpc.register?
    (make-struct-predicate std/actor/rpc/base#rpc.register::t))
  (define std/actor/rpc/base#make-rpc.register
    (lambda _$args253845_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.register::t
             _$args253845_)))
  (define std/actor/rpc/base#rpc.register-id
    (make-struct-field-accessor std/actor/rpc/base#rpc.register::t '0))
  (define std/actor/rpc/base#rpc.register-proto
    (make-struct-field-accessor std/actor/rpc/base#rpc.register::t '1))
  (define std/actor/rpc/base#rpc.register-id-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.register::t '0))
  (define std/actor/rpc/base#rpc.register-proto-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.register::t '1))
  (define std/actor/rpc/base#xdr-rpc.register-read
    (lambda (_buffer253843_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.register::t
       _buffer253843_)))
  (define std/actor/rpc/base#xdr-rpc.register-write
    (lambda (_obj253840_ _buffer253841_)
      (std/actor/xdr#xdr-write-struct _obj253840_ _buffer253841_)))
  (define std/actor/rpc/base#rpc.register::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.register-read
       std/actor/rpc/base#xdr-rpc.register-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.register::t
   std/actor/rpc/base#rpc.register::xdr)
  (define std/actor/rpc/base#rpc.unregister::t
    (make-struct-type
     'std/actor#rpc.unregister::t
     '#f
     '1
     'rpc.unregister
     '((final: . #t))
     '#f
     '(id)))
  (define std/actor/rpc/base#rpc.unregister?
    (make-struct-predicate std/actor/rpc/base#rpc.unregister::t))
  (define std/actor/rpc/base#make-rpc.unregister
    (lambda _$args253837_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.unregister::t
             _$args253837_)))
  (define std/actor/rpc/base#rpc.unregister-id
    (make-struct-field-accessor std/actor/rpc/base#rpc.unregister::t '0))
  (define std/actor/rpc/base#rpc.unregister-id-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.unregister::t '0))
  (define std/actor/rpc/base#xdr-rpc.unregister-read
    (lambda (_buffer253835_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.unregister::t
       _buffer253835_)))
  (define std/actor/rpc/base#xdr-rpc.unregister-write
    (lambda (_obj253832_ _buffer253833_)
      (std/actor/xdr#xdr-write-struct _obj253832_ _buffer253833_)))
  (define std/actor/rpc/base#rpc.unregister::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.unregister-read
       std/actor/rpc/base#xdr-rpc.unregister-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.unregister::t
   std/actor/rpc/base#rpc.unregister::xdr)
  (define std/actor/rpc/base#rpc.resolve::t
    (make-struct-type
     'std/actor#rpc.resolve::t
     '#f
     '1
     'rpc.resolve
     '((final: . #t))
     '#f
     '(id)))
  (define std/actor/rpc/base#rpc.resolve?
    (make-struct-predicate std/actor/rpc/base#rpc.resolve::t))
  (define std/actor/rpc/base#make-rpc.resolve
    (lambda _$args253829_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.resolve::t
             _$args253829_)))
  (define std/actor/rpc/base#rpc.resolve-id
    (make-struct-field-accessor std/actor/rpc/base#rpc.resolve::t '0))
  (define std/actor/rpc/base#rpc.resolve-id-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.resolve::t '0))
  (define std/actor/rpc/base#xdr-rpc.resolve-read
    (lambda (_buffer253827_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.resolve::t
       _buffer253827_)))
  (define std/actor/rpc/base#xdr-rpc.resolve-write
    (lambda (_obj253824_ _buffer253825_)
      (std/actor/xdr#xdr-write-struct _obj253824_ _buffer253825_)))
  (define std/actor/rpc/base#rpc.resolve::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.resolve-read
       std/actor/rpc/base#xdr-rpc.resolve-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.resolve::t
   std/actor/rpc/base#rpc.resolve::xdr)
  (define std/actor/rpc/base#rpc.server-address::t
    (make-struct-type
     'std/actor#rpc.server-address::t
     '#f
     '0
     'rpc.server-address
     '((final: . #t))
     '#f
     '()))
  (define std/actor/rpc/base#rpc.server-address?
    (make-struct-predicate std/actor/rpc/base#rpc.server-address::t))
  (define std/actor/rpc/base#make-rpc.server-address
    (lambda _$args253821_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.server-address::t
             _$args253821_)))
  (define std/actor/rpc/base#xdr-rpc.server-address-read
    (lambda (_buffer253819_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.server-address::t
       _buffer253819_)))
  (define std/actor/rpc/base#xdr-rpc.server-address-write
    (lambda (_obj253816_ _buffer253817_)
      (std/actor/xdr#xdr-write-struct _obj253816_ _buffer253817_)))
  (define std/actor/rpc/base#rpc.server-address::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.server-address-read
       std/actor/rpc/base#xdr-rpc.server-address-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.server-address::t
   std/actor/rpc/base#rpc.server-address::xdr)
  (define std/actor/rpc/base#rpc.connection-accept::t
    (make-struct-type
     'std/actor#rpc.connection-accept::t
     '#f
     '2
     'rpc.connection-accept
     '((final: . #t))
     '#f
     '(sock sa)))
  (define std/actor/rpc/base#rpc.connection-accept?
    (make-struct-predicate std/actor/rpc/base#rpc.connection-accept::t))
  (define std/actor/rpc/base#make-rpc.connection-accept
    (lambda _$args253813_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.connection-accept::t
             _$args253813_)))
  (define std/actor/rpc/base#rpc.connection-accept-sock
    (make-struct-field-accessor
     std/actor/rpc/base#rpc.connection-accept::t
     '0))
  (define std/actor/rpc/base#rpc.connection-accept-sa
    (make-struct-field-accessor
     std/actor/rpc/base#rpc.connection-accept::t
     '1))
  (define std/actor/rpc/base#rpc.connection-accept-sock-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.connection-accept::t '0))
  (define std/actor/rpc/base#rpc.connection-accept-sa-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.connection-accept::t '1))
  (define std/actor/rpc/base#xdr-rpc.connection-accept-read
    (lambda (_buffer253811_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.connection-accept::t
       _buffer253811_)))
  (define std/actor/rpc/base#xdr-rpc.connection-accept-write
    (lambda (_obj253808_ _buffer253809_)
      (std/actor/xdr#xdr-write-struct _obj253808_ _buffer253809_)))
  (define std/actor/rpc/base#rpc.connection-accept::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.connection-accept-read
       std/actor/rpc/base#xdr-rpc.connection-accept-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.connection-accept::t
   std/actor/rpc/base#rpc.connection-accept::xdr)
  (define std/actor/rpc/base#rpc.connection-shutdown::t
    (make-struct-type
     'std/actor#rpc.connection-shutdown::t
     '#f
     '0
     'rpc.connection-shutdown
     '((final: . #t))
     '#f
     '()))
  (define std/actor/rpc/base#rpc.connection-shutdown?
    (make-struct-predicate std/actor/rpc/base#rpc.connection-shutdown::t))
  (define std/actor/rpc/base#make-rpc.connection-shutdown
    (lambda _$args253805_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.connection-shutdown::t
             _$args253805_)))
  (define std/actor/rpc/base#xdr-rpc.connection-shutdown-read
    (lambda (_buffer253803_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.connection-shutdown::t
       _buffer253803_)))
  (define std/actor/rpc/base#xdr-rpc.connection-shutdown-write
    (lambda (_obj253800_ _buffer253801_)
      (std/actor/xdr#xdr-write-struct _obj253800_ _buffer253801_)))
  (define std/actor/rpc/base#rpc.connection-shutdown::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.connection-shutdown-read
       std/actor/rpc/base#xdr-rpc.connection-shutdown-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.connection-shutdown::t
   std/actor/rpc/base#rpc.connection-shutdown::xdr)
  (define std/actor/rpc/base#rpc.connection-close::t
    (make-struct-type
     'std/actor#rpc.connection-close::t
     '#f
     '0
     'rpc.connection-close
     '((final: . #t))
     '#f
     '()))
  (define std/actor/rpc/base#rpc.connection-close?
    (make-struct-predicate std/actor/rpc/base#rpc.connection-close::t))
  (define std/actor/rpc/base#make-rpc.connection-close
    (lambda _$args253797_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.connection-close::t
             _$args253797_)))
  (define std/actor/rpc/base#xdr-rpc.connection-close-read
    (lambda (_buffer253795_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.connection-close::t
       _buffer253795_)))
  (define std/actor/rpc/base#xdr-rpc.connection-close-write
    (lambda (_obj253792_ _buffer253793_)
      (std/actor/xdr#xdr-write-struct _obj253792_ _buffer253793_)))
  (define std/actor/rpc/base#rpc.connection-close::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.connection-close-read
       std/actor/rpc/base#xdr-rpc.connection-close-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.connection-close::t
   std/actor/rpc/base#rpc.connection-close::xdr)
  (define std/actor/rpc/base#rpc.monitor::t
    (make-struct-type
     'std/actor#rpc.monitor::t
     '#f
     '1
     'rpc.monitor
     '((final: . #t))
     '#f
     '(remote)))
  (define std/actor/rpc/base#rpc.monitor?
    (make-struct-predicate std/actor/rpc/base#rpc.monitor::t))
  (define std/actor/rpc/base#make-rpc.monitor
    (lambda _$args253789_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.monitor::t
             _$args253789_)))
  (define std/actor/rpc/base#rpc.monitor-remote
    (make-struct-field-accessor std/actor/rpc/base#rpc.monitor::t '0))
  (define std/actor/rpc/base#rpc.monitor-remote-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.monitor::t '0))
  (define std/actor/rpc/base#xdr-rpc.monitor-read
    (lambda (_buffer253787_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.monitor::t
       _buffer253787_)))
  (define std/actor/rpc/base#xdr-rpc.monitor-write
    (lambda (_obj253784_ _buffer253785_)
      (std/actor/xdr#xdr-write-struct _obj253784_ _buffer253785_)))
  (define std/actor/rpc/base#rpc.monitor::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.monitor-read
       std/actor/rpc/base#xdr-rpc.monitor-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.monitor::t
   std/actor/rpc/base#rpc.monitor::xdr)
  (define std/actor/rpc/base#rpc.unmonitor::t
    (make-struct-type
     'std/actor#rpc.unmonitor::t
     '#f
     '1
     'rpc.unmonitor
     '((final: . #t))
     '#f
     '(remote)))
  (define std/actor/rpc/base#rpc.unmonitor?
    (make-struct-predicate std/actor/rpc/base#rpc.unmonitor::t))
  (define std/actor/rpc/base#make-rpc.unmonitor
    (lambda _$args253781_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.unmonitor::t
             _$args253781_)))
  (define std/actor/rpc/base#rpc.unmonitor-remote
    (make-struct-field-accessor std/actor/rpc/base#rpc.unmonitor::t '0))
  (define std/actor/rpc/base#rpc.unmonitor-remote-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.unmonitor::t '0))
  (define std/actor/rpc/base#xdr-rpc.unmonitor-read
    (lambda (_buffer253779_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.unmonitor::t
       _buffer253779_)))
  (define std/actor/rpc/base#xdr-rpc.unmonitor-write
    (lambda (_obj253776_ _buffer253777_)
      (std/actor/xdr#xdr-write-struct _obj253776_ _buffer253777_)))
  (define std/actor/rpc/base#rpc.unmonitor::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.unmonitor-read
       std/actor/rpc/base#xdr-rpc.unmonitor-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.unmonitor::t
   std/actor/rpc/base#rpc.unmonitor::xdr)
  (define std/actor/rpc/base#rpc.disconnect::t
    (make-struct-type
     'std/actor#rpc.disconnect::t
     '#f
     '1
     'rpc.disconnect
     '((final: . #t))
     '#f
     '(remote)))
  (define std/actor/rpc/base#rpc.disconnect?
    (make-struct-predicate std/actor/rpc/base#rpc.disconnect::t))
  (define std/actor/rpc/base#make-rpc.disconnect
    (lambda _$args253773_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.disconnect::t
             _$args253773_)))
  (define std/actor/rpc/base#rpc.disconnect-remote
    (make-struct-field-accessor std/actor/rpc/base#rpc.disconnect::t '0))
  (define std/actor/rpc/base#rpc.disconnect-remote-set!
    (make-struct-field-mutator std/actor/rpc/base#rpc.disconnect::t '0))
  (define std/actor/rpc/base#xdr-rpc.disconnect-read
    (lambda (_buffer253771_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.disconnect::t
       _buffer253771_)))
  (define std/actor/rpc/base#xdr-rpc.disconnect-write
    (lambda (_obj253768_ _buffer253769_)
      (std/actor/xdr#xdr-write-struct _obj253768_ _buffer253769_)))
  (define std/actor/rpc/base#rpc.disconnect::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.disconnect-read
       std/actor/rpc/base#xdr-rpc.disconnect-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.disconnect::t
   std/actor/rpc/base#rpc.disconnect::xdr)
  (define std/actor/rpc/base#rpc.shutdown::t
    (make-struct-type
     'std/actor#rpc.shutdown::t
     '#f
     '0
     'rpc.shutdown
     '((final: . #t))
     '#f
     '()))
  (define std/actor/rpc/base#rpc.shutdown?
    (make-struct-predicate std/actor/rpc/base#rpc.shutdown::t))
  (define std/actor/rpc/base#make-rpc.shutdown
    (lambda _$args253765_
      (apply make-struct-instance
             std/actor/rpc/base#rpc.shutdown::t
             _$args253765_)))
  (define std/actor/rpc/base#xdr-rpc.shutdown-read
    (lambda (_buffer253763_)
      (std/actor/xdr#xdr-read-struct
       std/actor/rpc/base#rpc.shutdown::t
       _buffer253763_)))
  (define std/actor/rpc/base#xdr-rpc.shutdown-write
    (lambda (_obj253758_ _buffer253760_)
      (std/actor/xdr#xdr-write-struct _obj253758_ _buffer253760_)))
  (define std/actor/rpc/base#rpc.shutdown::xdr
    (let ()
      (declare (not safe))
      (##structure
       std/actor/xdr#XDR::t
       std/actor/rpc/base#xdr-rpc.shutdown-read
       std/actor/rpc/base#xdr-rpc.shutdown-write)))
  (table-set!
   (##direct-structure-ref
    std/actor/rpc/base#rpc::proto
    '3
    std/actor/proto#!protocol::t
    '#f)
   'std/actor#rpc.shutdown::t
   std/actor/rpc/base#rpc.shutdown::xdr)
  (define std/actor/rpc/base#null-uuid
    (std/misc/uuid#u8vector->uuid (make-u8vector std/misc/uuid#uuid-length)))
  (define std/actor/rpc/base#rpc-monitor__%
    (lambda (_thread253738_ _msg253739_)
      (letrec ((_thread-monitor253741_
                (lambda (_server253743_ _thread253744_ _msg253745_)
                  (with-exception-catcher
                   values
                   (lambda () (thread-join! _thread253744_)))
                  (thread-send _server253743_ _msg253745_))))
        (gerbil/gambit/threads#spawn/name
         'rpc-monitor
         _thread-monitor253741_
         (current-thread)
         _thread253738_
         _msg253739_))))
  (define std/actor/rpc/base#rpc-monitor__0
    (lambda (_thread253751_)
      (let ((_msg253753_ _thread253751_))
        (std/actor/rpc/base#rpc-monitor__% _thread253751_ _msg253753_))))
  (define std/actor/rpc/base#rpc-monitor
    (lambda _g310449_
      (let ((_g310448_ (let () (declare (not safe)) (##length _g310449_))))
        (cond ((let () (declare (not safe)) (##fx= _g310448_ 1))
               (apply std/actor/rpc/base#rpc-monitor__0 _g310449_))
              ((let () (declare (not safe)) (##fx= _g310448_ 2))
               (apply std/actor/rpc/base#rpc-monitor__% _g310449_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/rpc/base#rpc-monitor
                _g310449_))))))
  (define std/actor/rpc/base#make-uuid-table
    (lambda ()
      (make-table 'test: std/misc/uuid#uuid=? 'hash: std/misc/uuid#uuid-hash)))
  (define std/actor/rpc/base#+protocols+ (std/actor/rpc/base#make-uuid-table))
  (define std/actor/rpc/base#bind-protocol!
    (lambda (_id253733_ _proto253734_)
      (if (let ()
            (declare (not safe))
            (##structure-direct-instance-of?
             _proto253734_
             'std/actor/proto#!protocol::t))
          '#!void
          (error '"Bad protocol" _proto253734_))
      (table-set!
       std/actor/rpc/base#+protocols+
       (std/misc/uuid#UUID _id253733_)
       _proto253734_)))
  (define std/actor/rpc/base#lookup-protocol
    (lambda (_uuid253731_)
      (table-ref std/actor/rpc/base#+protocols+ _uuid253731_ '#f)))
  (define std/actor/rpc/base#make-actor-table
    (lambda ()
      (let ((__obj310443 (make-object std/misc/sync#sync-hash::t '2)))
        (std/misc/sync#sync-hash:::init!
         __obj310443
         (std/actor/rpc/base#make-uuid-table))
        __obj310443)))
  (define std/actor/rpc/base#actor-table-put!
    (lambda (_at253725_ _uuid253726_ _actor253727_ _proto253728_)
      (std/misc/sync#sync-hash-put!
       _at253725_
       _uuid253726_
       (values _actor253727_ _proto253728_)))))
