(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/actor/rpc/proto/message#rpc-proto-connect-hello '12)
  (define std/actor/rpc/proto/message#rpc-proto-connect-accept '1)
  (define std/actor/rpc/proto/message#rpc-proto-connect-reject '2)
  (define std/actor/rpc/proto/message#rpc-proto-challenge '3)
  (define std/actor/rpc/proto/message#rpc-proto-response '4)
  (define std/actor/rpc/proto/message#rpc-proto-key-exchange '5)
  (define std/actor/rpc/proto/message#rpc-proto-keep-alive '6)
  (define std/actor/rpc/proto/message#rpc-proto-message '7)
  (define std/actor/rpc/proto/message#rpc-proto-message-raw '0)
  (define std/actor/rpc/proto/message#rpc-proto-message-call '1)
  (define std/actor/rpc/proto/message#rpc-proto-message-value '2)
  (define std/actor/rpc/proto/message#rpc-proto-message-error '3)
  (define std/actor/rpc/proto/message#rpc-proto-message-event '4)
  (define std/actor/rpc/proto/message#rpc-proto-message-stream '5)
  (define std/actor/rpc/proto/message#rpc-proto-message-yield '6)
  (define std/actor/rpc/proto/message#rpc-proto-message-end '7)
  (define std/actor/rpc/proto/message#rpc-proto-message-continue '8)
  (define std/actor/rpc/proto/message#rpc-proto-message-close '9)
  (define std/actor/rpc/proto/message#rpc-proto-message-abort '10)
  (define std/actor/rpc/proto/message#rpc-proto-message-sync '11)
  (define std/actor/rpc/proto/message#rpc-proto-message-max-length
    (expt '2 '20))
  (define std/actor/rpc/proto/message#rpc-proto-null '0)
  (define std/actor/rpc/proto/message#rpc-proto-cookie '1)
  (define std/actor/rpc/proto/message#rpc-proto-cipher '2)
  (define std/actor/rpc/proto/message#rpc-proto-cookie-cipher '3)
  (define std/actor/rpc/proto/message#rpc-proto-marshal-message
    (lambda (_msg254239_ _proto254240_)
      (let ((_outp254242_
             (std/net/bio/buffer#open-serializer-output-buffer__0)))
        (std/actor/rpc/proto/message#rpc-proto-write-message
         _msg254239_
         _outp254242_
         _proto254240_)
        _outp254242_)))
  (define std/actor/rpc/proto/message#rpc-proto-write-message
    (lambda (_msg253970_ _buffer253971_ _proto253972_)
      (let* ((_msg253973253981_ _msg253970_)
             (_E253975253985_
              (lambda () (error '"No clause matching" _msg253973253981_)))
             (_K253976254223_
              (lambda (_dest253988_ _content253989_)
                (if _proto253972_
                    (std/actor/xdr#current-xdr-type-registry
                     (##direct-structure-ref
                      _proto253972_
                      '3
                      std/actor/proto#!protocol::t
                      '#f))
                    (std/actor/xdr#current-xdr-type-registry
                     std/actor/xdr#+xdr-default-type-registry+))
                (if (##structure-instance-of?
                     _content253989_
                     'std/actor/proto#!rpc::t)
                    (let* ((_content253990254032_ _content253989_)
                           (_else254002254040_
                            (lambda ()
                              (std/actor/proto#raise-rpc-io-error
                               'rpc-proto-write-message
                               '"unknown rpc message type"
                               _content253989_))))
                      (let ((_K254028254210_
                             (lambda (_k254207_ _e254208_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-call
                                _buffer253971_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest253988_
                                _buffer253971_)
                               (std/actor/xdr#xdr-write-uint
                                _k254207_
                                _buffer253971_)
                               (std/actor/xdr#xdr-write
                                _e254208_
                                _buffer253971_)))
                            (_K254025254191_
                             (lambda (_k254188_ _e254189_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-value
                                _buffer253971_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest253988_
                                _buffer253971_)
                               (std/actor/xdr#xdr-write-uint
                                _k254188_
                                _buffer253971_)
                               (std/actor/xdr#xdr-write
                                _e254189_
                                _buffer253971_)))
                            (_K254022254171_
                             (lambda (_k254168_ _e254169_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-error
                                _buffer253971_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest253988_
                                _buffer253971_)
                               (std/actor/xdr#xdr-write-uint
                                _k254168_
                                _buffer253971_)
                               (std/actor/xdr#xdr-write
                                _e254169_
                                _buffer253971_)))
                            (_K254020254156_
                             (lambda (_e254154_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-event
                                _buffer253971_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest253988_
                                _buffer253971_)
                               (std/actor/xdr#xdr-write
                                _e254154_
                                _buffer253971_)))
                            (_K254017254137_
                             (lambda (_k254134_ _e254135_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-stream
                                _buffer253971_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest253988_
                                _buffer253971_)
                               (std/actor/xdr#xdr-write-uint
                                _k254134_
                                _buffer253971_)
                               (std/actor/xdr#xdr-write
                                _e254135_
                                _buffer253971_)))
                            (_K254014254117_
                             (lambda (_k254114_ _e254115_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-yield
                                _buffer253971_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest253988_
                                _buffer253971_)
                               (std/actor/xdr#xdr-write-uint
                                _k254114_
                                _buffer253971_)
                               (std/actor/xdr#xdr-write
                                _e254115_
                                _buffer253971_)))
                            (_K254012254102_
                             (lambda (_k254100_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-end
                                _buffer253971_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest253988_
                                _buffer253971_)
                               (std/actor/xdr#xdr-write-uint
                                _k254100_
                                _buffer253971_)))
                            (_K254010254088_
                             (lambda (_k254086_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-continue
                                _buffer253971_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest253988_
                                _buffer253971_)
                               (std/actor/xdr#xdr-write-uint
                                _k254086_
                                _buffer253971_)))
                            (_K254008254074_
                             (lambda (_k254072_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-close
                                _buffer253971_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest253988_
                                _buffer253971_)
                               (std/actor/xdr#xdr-write-uint
                                _k254072_
                                _buffer253971_)))
                            (_K254006254060_
                             (lambda (_k254058_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-abort
                                _buffer253971_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest253988_
                                _buffer253971_)
                               (std/actor/xdr#xdr-write-uint
                                _k254058_
                                _buffer253971_)))
                            (_K254004254046_
                             (lambda (_k254044_)
                               (std/net/bio/output#bio-write-u8
                                std/actor/rpc/proto/message#rpc-proto-message-sync
                                _buffer253971_)
                               (std/actor/rpc/base#xdr-write-uuid
                                _dest253988_
                                _buffer253971_)
                               (std/actor/xdr#xdr-write-uint
                                _k254044_
                                _buffer253971_))))
                        (let* ((_try-match254001254054_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content253990254032_
                                       'std/actor/proto#!sync::t)
                                      (let* ((_e254005254049_
                                              (##vector-ref
                                               _content253990254032_
                                               '1))
                                             (_k254052_ _e254005254049_))
                                        (_K254004254046_ _k254052_))
                                      (_else254002254040_))))
                               (_try-match254000254068_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content253990254032_
                                       'std/actor/proto#!abort::t)
                                      (let* ((_e254007254063_
                                              (##vector-ref
                                               _content253990254032_
                                               '1))
                                             (_k254066_ _e254007254063_))
                                        (_K254006254060_ _k254066_))
                                      (_try-match254001254054_))))
                               (_try-match253999254082_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content253990254032_
                                       'std/actor/proto#!close::t)
                                      (let* ((_e254009254077_
                                              (##vector-ref
                                               _content253990254032_
                                               '1))
                                             (_k254080_ _e254009254077_))
                                        (_K254008254074_ _k254080_))
                                      (_try-match254000254068_))))
                               (_try-match253998254096_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content253990254032_
                                       'std/actor/proto#!continue::t)
                                      (let* ((_e254011254091_
                                              (##vector-ref
                                               _content253990254032_
                                               '1))
                                             (_k254094_ _e254011254091_))
                                        (_K254010254088_ _k254094_))
                                      (_try-match253999254082_))))
                               (_try-match253997254110_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content253990254032_
                                       'std/actor/proto#!end::t)
                                      (let* ((_e254013254105_
                                              (##vector-ref
                                               _content253990254032_
                                               '1))
                                             (_k254108_ _e254013254105_))
                                        (_K254012254102_ _k254108_))
                                      (_try-match253998254096_))))
                               (_try-match253996254130_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content253990254032_
                                       'std/actor/proto#!yield::t)
                                      (let* ((_e254015254120_
                                              (##vector-ref
                                               _content253990254032_
                                               '1))
                                             (_e254016254125_
                                              (##vector-ref
                                               _content253990254032_
                                               '2)))
                                        (let ((_e254123_ _e254015254120_)
                                              (_k254128_ _e254016254125_))
                                          (_K254014254117_
                                           _k254128_
                                           _e254123_)))
                                      (_try-match253997254110_))))
                               (_try-match253995254150_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content253990254032_
                                       'std/actor/proto#!stream::t)
                                      (let* ((_e254018254140_
                                              (##vector-ref
                                               _content253990254032_
                                               '1))
                                             (_e254019254145_
                                              (##vector-ref
                                               _content253990254032_
                                               '2)))
                                        (let ((_e254143_ _e254018254140_)
                                              (_k254148_ _e254019254145_))
                                          (_K254017254137_
                                           _k254148_
                                           _e254143_)))
                                      (_try-match253996254130_))))
                               (_try-match253994254164_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content253990254032_
                                       'std/actor/proto#!event::t)
                                      (let* ((_e254021254159_
                                              (##vector-ref
                                               _content253990254032_
                                               '1))
                                             (_e254162_ _e254021254159_))
                                        (_K254020254156_ _e254162_))
                                      (_try-match253995254150_))))
                               (_try-match253993254184_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content253990254032_
                                       'std/actor/proto#!error::t)
                                      (let* ((_e254023254174_
                                              (##vector-ref
                                               _content253990254032_
                                               '1))
                                             (_e254024254179_
                                              (##vector-ref
                                               _content253990254032_
                                               '2)))
                                        (let ((_e254177_ _e254023254174_)
                                              (_k254182_ _e254024254179_))
                                          (_K254022254171_
                                           _k254182_
                                           _e254177_)))
                                      (_try-match253994254164_))))
                               (_try-match253992254204_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content253990254032_
                                       'std/actor/proto#!value::t)
                                      (let* ((_e254026254194_
                                              (##vector-ref
                                               _content253990254032_
                                               '1))
                                             (_e254027254199_
                                              (##vector-ref
                                               _content253990254032_
                                               '2)))
                                        (let ((_e254197_ _e254026254194_)
                                              (_k254202_ _e254027254199_))
                                          (_K254025254191_
                                           _k254202_
                                           _e254197_)))
                                      (_try-match253993254184_)))))
                          (if (##structure-direct-instance-of?
                               _content253990254032_
                               'std/actor/proto#!call::t)
                              (let* ((_e254029254213_
                                      (##vector-ref _content253990254032_ '1))
                                     (_e254030254218_
                                      (##vector-ref _content253990254032_ '2)))
                                (let ((_e254216_ _e254029254213_)
                                      (_k254221_ _e254030254218_))
                                  (_K254028254210_ _k254221_ _e254216_)))
                              (_try-match253992254204_)))))
                    (begin
                      (std/net/bio/output#bio-write-u8
                       std/actor/rpc/proto/message#rpc-proto-message-raw
                       _buffer253971_)
                      (std/actor/xdr#xdr-write
                       _content253989_
                       _buffer253971_))))))
        (if (##structure-direct-instance-of?
             _msg253973253981_
             'std/actor/message#message::t)
            (let* ((_e253977254226_ (##vector-ref _msg253973253981_ '1))
                   (_content254229_ _e253977254226_)
                   (_e253978254231_ (##vector-ref _msg253973253981_ '2))
                   (_e253979254234_ (##vector-ref _msg253973253981_ '3))
                   (_dest254237_ _e253979254234_))
              (_K253976254223_ _dest254237_ _content254229_))
            (_E253975253985_)))))
  (define std/actor/rpc/proto/message#rpc-proto-read-envelope
    (lambda (_buffer253943_)
      (let* ((_type253945_ (std/net/bio/input#bio-read-u8 _buffer253943_))
             (_dest253947_ (std/actor/rpc/base#xdr-read-uuid _buffer253943_)))
        (##structure
         std/actor/message#message::t
         (if (eq? _type253945_
                  std/actor/rpc/proto/message#rpc-proto-message-call)
             (let ((_k253950_ (std/actor/xdr#xdr-read-uint _buffer253943_)))
               (##structure std/actor/proto#!call::t '#!void _k253950_))
             (if (eq? _type253945_
                      std/actor/rpc/proto/message#rpc-proto-message-value)
                 (let ((_k253952_
                        (std/actor/xdr#xdr-read-uint _buffer253943_)))
                   (##structure std/actor/proto#!value::t '#!void _k253952_))
                 (if (eq? _type253945_
                          std/actor/rpc/proto/message#rpc-proto-message-error)
                     (let ((_k253954_
                            (std/actor/xdr#xdr-read-uint _buffer253943_)))
                       (##structure
                        std/actor/proto#!error::t
                        '#!void
                        _k253954_))
                     (if (eq? _type253945_
                              std/actor/rpc/proto/message#rpc-proto-message-event)
                         (##structure std/actor/proto#!event::t '#!void)
                         (if (eq? _type253945_
                                  std/actor/rpc/proto/message#rpc-proto-message-raw)
                             '#!void
                             (if (eq? _type253945_
                                      std/actor/rpc/proto/message#rpc-proto-message-stream)
                                 (let ((_k253956_
                                        (std/actor/xdr#xdr-read-uint
                                         _buffer253943_)))
                                   (##structure
                                    std/actor/proto#!stream::t
                                    '#!void
                                    _k253956_))
                                 (if (eq? _type253945_
                                          std/actor/rpc/proto/message#rpc-proto-message-yield)
                                     (let ((_k253958_
                                            (std/actor/xdr#xdr-read-uint
                                             _buffer253943_)))
                                       (##structure
                                        std/actor/proto#!yield::t
                                        '#!void
                                        _k253958_))
                                     (if (eq? _type253945_
                                              std/actor/rpc/proto/message#rpc-proto-message-end)
                                         (let ((_k253960_
                                                (std/actor/xdr#xdr-read-uint
                                                 _buffer253943_)))
                                           (##structure
                                            std/actor/proto#!end::t
                                            _k253960_))
                                         (if (eq? _type253945_
                                                  std/actor/rpc/proto/message#rpc-proto-message-continue)
                                             (let ((_k253962_
                                                    (std/actor/xdr#xdr-read-uint
                                                     _buffer253943_)))
                                               (##structure
                                                std/actor/proto#!continue::t
                                                _k253962_))
                                             (if (eq? _type253945_
                                                      std/actor/rpc/proto/message#rpc-proto-message-close)
                                                 (let ((_k253964_
                                                        (std/actor/xdr#xdr-read-uint
                                                         _buffer253943_)))
                                                   (##structure
                                                    std/actor/proto#!close::t
                                                    _k253964_))
                                                 (if (eq? _type253945_
                                                          std/actor/rpc/proto/message#rpc-proto-message-abort)
                                                     (let ((_k253966_
                                                            (std/actor/xdr#xdr-read-uint
                                                             _buffer253943_)))
                                                       (##structure
                                                        std/actor/proto#!abort::t
                                                        _k253966_))
                                                     (if (eq? _type253945_
                                                              std/actor/rpc/proto/message#rpc-proto-message-sync)
                                                         (let ((_k253968_
                                                                (std/actor/xdr#xdr-read-uint
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _buffer253943_)))
                   (##structure std/actor/proto#!sync::t _k253968_))
                 (std/actor/proto#raise-rpc-io-error
                  'rpc-proto-read-message
                  '"unmarshal error; unexpected message type"
                  _type253945_)))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
         '#!void
         _dest253947_
         '#f))))
  (define std/actor/rpc/proto/message#rpc-proto-read-payload!
    (lambda (_msg253876_ _buffer253877_ _proto253878_)
      (std/actor/xdr#current-xdr-type-registry
       (##direct-structure-ref
        _proto253878_
        '3
        std/actor/proto#!protocol::t
        '#f))
      (let* ((_value253880_
              (##direct-structure-ref
               _msg253876_
               '1
               std/actor/message#message::t
               '#f))
             (_value253881253891_ _value253880_)
             (_else253885253899_ (lambda () '#!void)))
        (let ((_K253889253928_
               (lambda ()
                 (let ((_payload253926_
                        (std/actor/xdr#xdr-read _buffer253877_)))
                   (##vector-set! _value253880_ '1 _payload253926_))))
              (_K253888253919_
               (lambda ()
                 (let* ((_payload253914_
                         (std/actor/xdr#xdr-read _buffer253877_))
                        (_e253916_
                         (if (string? _payload253914_)
                             (make-struct-instance
                              std/actor/proto#remote-error::t
                              'rpc
                              _payload253914_)
                             _payload253914_)))
                   (##vector-set! _value253880_ '1 _e253916_))))
              (_K253887253906_
               (lambda ()
                 (let ((_payload253904_
                        (std/actor/xdr#xdr-read _buffer253877_)))
                   (##direct-structure-set!
                    _msg253876_
                    _payload253904_
                    '1
                    std/actor/message#message::t
                    '#f)))))
          (let* ((_try-match253884253909_
                  (lambda ()
                    (if (eq? _value253881253891_ '#!void)
                        (_K253887253906_)
                        '#!void)))
                 (_try-match253883253922_
                  (lambda ()
                    (if (##structure-direct-instance-of?
                         _value253881253891_
                         'std/actor/proto#!error::t)
                        (_K253888253919_)
                        (_try-match253884253909_)))))
            (if (or (##structure-direct-instance-of?
                     _value253881253891_
                     'std/actor/proto#!call::t)
                    (##structure-direct-instance-of?
                     _value253881253891_
                     'std/actor/proto#!value::t)
                    (##structure-direct-instance-of?
                     _value253881253891_
                     'std/actor/proto#!event::t)
                    (##structure-direct-instance-of?
                     _value253881253891_
                     'std/actor/proto#!stream::t)
                    (##structure-direct-instance-of?
                     _value253881253891_
                     'std/actor/proto#!yield::t))
                (_K253889253928_)
                (_try-match253883253922_))))))))
