(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/coroutine#current-coroutine (make-parameter '#f))
  (define std/coroutine#cort::t
    (make-struct-type
     'std/coroutine#cort::t
     '#f
     '3
     'cort
     '((final: . #t))
     '#f
     '(k end? res)))
  (define std/coroutine#cort? (make-struct-predicate std/coroutine#cort::t))
  (define std/coroutine#make-cort
    (lambda _$args20093_
      (apply make-struct-instance std/coroutine#cort::t _$args20093_)))
  (define std/coroutine#cort-k
    (make-struct-field-accessor std/coroutine#cort::t '0))
  (define std/coroutine#cort-end?
    (make-struct-field-accessor std/coroutine#cort::t '1))
  (define std/coroutine#cort-res
    (make-struct-field-accessor std/coroutine#cort::t '2))
  (define std/coroutine#cort-k-set!
    (make-struct-field-mutator std/coroutine#cort::t '0))
  (define std/coroutine#cort-end?-set!
    (make-struct-field-mutator std/coroutine#cort::t '1))
  (define std/coroutine#cort-res-set!
    (make-struct-field-mutator std/coroutine#cort::t '2))
  (define std/coroutine#cothr::t
    (make-struct-type
     'std/coroutine#cothr::t
     '#f
     '4
     'cothr
     '((final: . #t))
     '#f
     '(mx cv state val)))
  (define std/coroutine#cothr? (make-struct-predicate std/coroutine#cothr::t))
  (define std/coroutine#make-cothr
    (lambda _$args20090_
      (apply make-struct-instance std/coroutine#cothr::t _$args20090_)))
  (define std/coroutine#cothr-mx
    (make-struct-field-accessor std/coroutine#cothr::t '0))
  (define std/coroutine#cothr-cv
    (make-struct-field-accessor std/coroutine#cothr::t '1))
  (define std/coroutine#cothr-state
    (make-struct-field-accessor std/coroutine#cothr::t '2))
  (define std/coroutine#cothr-val
    (make-struct-field-accessor std/coroutine#cothr::t '3))
  (define std/coroutine#cothr-mx-set!
    (make-struct-field-mutator std/coroutine#cothr::t '0))
  (define std/coroutine#cothr-cv-set!
    (make-struct-field-mutator std/coroutine#cothr::t '1))
  (define std/coroutine#cothr-state-set!
    (make-struct-field-mutator std/coroutine#cothr::t '2))
  (define std/coroutine#cothr-val-set!
    (make-struct-field-mutator std/coroutine#cothr::t '3))
  (define std/coroutine#coroutine
    (lambda (_proc20084_ . _args20085_)
      (call-with-current-continuation
       (lambda (_k20087_)
         (std/coroutine#coroutine-start!
          _k20087_
          (if (null? _args20085_)
              _proc20084_
              (lambda () (apply _proc20084_ _args20085_))))))))
  (define std/coroutine#cothread
    (lambda (_proc20075_ . _args20076_)
      (let* ((_cothr20078_
              (let ((__tmp283123 (make-mutex 'coroutine))
                    (__tmp283122 (make-condition-variable 'coroutine)))
                (declare (not safe))
                (##structure
                 std/coroutine#cothr::t
                 __tmp283123
                 __tmp283122
                 'run
                 '#f)))
             (_thread20081_
              (make-thread
               (lambda ()
                 (std/coroutine#cothread-start!
                  _cothr20078_
                  _proc20075_
                  _args20076_))
               'cothread)))
        (thread-specific-set! _thread20081_ _cothr20078_)
        (thread-start! _thread20081_))))
  (define std/coroutine#cothread?
    (lambda (_thread20073_)
      (if (thread? _thread20073_)
          (let ((__tmp283124 (thread-specific _thread20073_)))
            (declare (not safe))
            (##structure-direct-instance-of?
             __tmp283124
             'std/coroutine#cothr::t))
          '#f)))
  (define std/coroutine#continue
    (lambda (_c20070_ . _args20071_)
      (if (let ()
            (declare (not safe))
            (##structure-direct-instance-of? _c20070_ 'std/coroutine#cort::t))
          (std/coroutine#coroutine-continue! _c20070_ _args20071_)
          (if (std/coroutine#cothread? _c20070_)
              (std/coroutine#cothread-continue!
               (thread-specific _c20070_)
               _args20071_)
              (error '"Illegal argument; not continuable" _c20070_)))))
  (define std/coroutine#yield
    (lambda _args20061_
      (let ((_$e20063_ (std/coroutine#current-coroutine)))
        (if _$e20063_
            ((lambda (_g2006520067_)
               (std/coroutine#coroutine-yield! _g2006520067_ _args20061_))
             _$e20063_)
            (if (let ((__tmp283125 (thread-specific (current-thread))))
                  (declare (not safe))
                  (##structure-direct-instance-of?
                   __tmp283125
                   'std/coroutine#cothr::t))
                (std/coroutine#cothread-yield!
                 (thread-specific (current-thread))
                 _args20061_)
                (error '"Not in a coroutine continuation"))))))
  (define std/coroutine#coroutine-start!
    (lambda (_k20049_ _thunk20050_)
      (let ((_c20052_
             (let ()
               (declare (not safe))
               (##structure std/coroutine#cort::t '#f '#f '#f))))
        (call-with-parameters
         (lambda ()
           (call-with-current-continuation
            (lambda (_kk20055_)
              (##direct-structure-set!
               _c20052_
               _kk20055_
               '1
               std/coroutine#cort::t
               '#f)
              (_k20049_ _c20052_)))
           (call-with-values
            _thunk20050_
            (lambda _res20057_
              (let ((_k20059_
                     (##direct-structure-ref
                      _c20052_
                      '1
                      std/coroutine#cort::t
                      '#f)))
                (##direct-structure-set!
                 _c20052_
                 '#t
                 '2
                 std/coroutine#cort::t
                 '#f)
                (##direct-structure-set!
                 _c20052_
                 _res20057_
                 '3
                 std/coroutine#cort::t
                 '#f)
                (##direct-structure-set!
                 _c20052_
                 '#f
                 '1
                 std/coroutine#cort::t
                 '#f)
                (apply _k20059_ _res20057_)))))
         std/coroutine#current-coroutine
         _c20052_))))
  (define std/coroutine#coroutine-continue!
    (lambda (_c20008_ _args20009_)
      (let* ((_c2001020018_ _c20008_)
             (_E2001220022_
              (lambda () (error '"No clause matching" _c2001020018_)))
             (_K2001320031_
              (lambda (_res20025_ _end?20026_ _k20027_)
                (if _end?20026_
                    (apply values _res20025_)
                    (call-with-current-continuation
                     (lambda (_kk20029_)
                       (##direct-structure-set!
                        _c20008_
                        _kk20029_
                        '1
                        std/coroutine#cort::t
                        '#f)
                       (apply _k20027_ _args20009_)))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _c2001020018_
               'std/coroutine#cort::t))
            (let* ((_e2001420034_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c2001020018_ '1)))
                   (_k20037_ _e2001420034_)
                   (_e2001520039_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c2001020018_ '2)))
                   (_end?20042_ _e2001520039_)
                   (_e2001620044_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c2001020018_ '3)))
                   (_res20047_ _e2001620044_))
              (_K2001320031_ _res20047_ _end?20042_ _k20037_))
            (_E2001220022_)))))
  (define std/coroutine#coroutine-yield!
    (lambda (_c19981_ _args19982_)
      (let* ((_c1998319989_ _c19981_)
             (_E1998519993_
              (lambda () (error '"No clause matching" _c1998319989_)))
             (_K1998620000_
              (lambda (_k19996_)
                (call-with-current-continuation
                 (lambda (_kk19998_)
                   (##direct-structure-set!
                    _c19981_
                    _kk19998_
                    '1
                    std/coroutine#cort::t
                    '#f)
                   (apply _k19996_ _args19982_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _c1998319989_
               'std/coroutine#cort::t))
            (let* ((_e1998720003_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1998319989_ '1)))
                   (_k20006_ _e1998720003_))
              (_K1998620000_ _k20006_))
            (_E1998519993_)))))
  (define std/coroutine#cothread-start!
    (lambda (_c19967_ _proc19968_ _args19969_)
      (call-with-parameters
       (lambda ()
         (with-exception-catcher
          (lambda (_g1997119973_)
            (if '#t
                (let ((_e19976_ _g1997119973_))
                  (std/coroutine#cothread-signal! _c19967_ 'error _e19976_))
                (raise _g1997119973_)))
          (lambda ()
            (std/coroutine#cothread-wait! _c19967_)
            (let ((_val19979_ (apply _proc19968_ _args19969_)))
              (std/coroutine#cothread-signal! _c19967_ 'end _val19979_)))))
       std/coroutine#current-coroutine
       '#f)))
  (define std/coroutine#cothread-stop!__%
    (lambda (_thread19952_ _val19953_)
      (if (thread? _thread19952_)
          (let ((_spec19955_ (thread-specific _thread19952_)))
            (if (let ()
                  (declare (not safe))
                  (##structure-direct-instance-of?
                   _spec19955_
                   'std/coroutine#cothr::t))
                (std/coroutine#cothread-signal! _spec19955_ 'end _val19953_)
                (error '"Not a coroutine thread" _thread19952_ _spec19955_)))
          (error '"Expected coroutine thread" _thread19952_))))
  (define std/coroutine#cothread-stop!__0
    (lambda (_thread19960_)
      (let ((_val19962_ '#!void))
        (std/coroutine#cothread-stop!__% _thread19960_ _val19962_))))
  (define std/coroutine#cothread-stop!
    (lambda _g283127_
      (let ((_g283126_ (let () (declare (not safe)) (##length _g283127_))))
        (cond ((let () (declare (not safe)) (##fx= _g283126_ 1))
               (apply std/coroutine#cothread-stop!__0 _g283127_))
              ((let () (declare (not safe)) (##fx= _g283126_ 2))
               (apply std/coroutine#cothread-stop!__% _g283127_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/coroutine#cothread-stop!
                _g283127_))))))
  (define std/coroutine#cothread-continue!
    (lambda (_c19893_ _val19894_)
      (let* ((_c1989519904_ _c19893_)
             (_E1989719908_
              (lambda () (error '"No clause matching" _c1989519904_)))
             (_K1989819928_
              (lambda (_kont19911_ _state19912_ _cv19913_ _mx19914_)
                (mutex-lock! _mx19914_)
                (let ((_$e19916_ _state19912_))
                  (if (eq? 'run _$e19916_)
                      (begin
                        (##direct-structure-set!
                         _c19893_
                         _val19894_
                         '4
                         std/coroutine#cothr::t
                         '#f)
                        (##direct-structure-set!
                         _c19893_
                         'continue
                         '3
                         std/coroutine#cothr::t
                         '#f)
                        (condition-variable-signal! _cv19913_)
                        (mutex-unlock! _mx19914_ _cv19913_)
                        (let _lp19919_ ()
                          (mutex-lock! _mx19914_)
                          (let ((_state19922_
                                 (##direct-structure-ref
                                  _c19893_
                                  '3
                                  std/coroutine#cothr::t
                                  '#f))
                                (_kont19923_
                                 (##direct-structure-ref
                                  _c19893_
                                  '4
                                  std/coroutine#cothr::t
                                  '#f)))
                            (let ((_$e19925_ _state19922_))
                              (if (eq? 'continue _$e19925_)
                                  (begin
                                    (mutex-unlock! _mx19914_ _cv19913_)
                                    (_lp19919_))
                                  (if (eq? 'yield _$e19925_)
                                      (begin
                                        (##direct-structure-set!
                                         _c19893_
                                         'run
                                         '3
                                         std/coroutine#cothr::t
                                         '#f)
                                        (mutex-unlock! _mx19914_)
                                        _kont19923_)
                                      (if (eq? 'end _$e19925_)
                                          (begin
                                            (mutex-unlock! _mx19914_)
                                            _kont19923_)
                                          (if (eq? 'error _$e19925_)
                                              (begin
                                                (mutex-unlock! _mx19914_)
                                                (raise _kont19923_))
                                              (begin
                                                (mutex-unlock! _mx19914_)
                                                (error '"Illegal cothread state"
                                                       _state19922_))))))))))
                      (if (eq? 'end _$e19916_)
                          (begin (mutex-unlock! _mx19914_) _kont19911_)
                          (if (eq? 'error _$e19916_)
                              (begin
                                (mutex-unlock! _mx19914_)
                                (raise _kont19911_))
                              (error '"Illegal cothread state"
                                     _state19912_))))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _c1989519904_
               'std/coroutine#cothr::t))
            (let* ((_e1989919931_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1989519904_ '1)))
                   (_mx19934_ _e1989919931_)
                   (_e1990019936_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1989519904_ '2)))
                   (_cv19939_ _e1990019936_)
                   (_e1990119941_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1989519904_ '3)))
                   (_state19944_ _e1990119941_)
                   (_e1990219946_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1989519904_ '4)))
                   (_kont19949_ _e1990219946_))
              (_K1989819928_ _kont19949_ _state19944_ _cv19939_ _mx19934_))
            (_E1989719908_)))))
  (define std/coroutine#cothread-yield!
    (lambda (_c19888_ _args19889_)
      (let ((_kont19891_
             (std/coroutine#cothread-yield-values!
              _c19888_
              (apply values _args19889_))))
        (std/coroutine#cothread-wait! _c19888_)
        _kont19891_)))
  (define std/coroutine#cothread-yield-values!
    (lambda (_c19839_ _val19840_)
      (let* ((_c1984119850_ _c19839_)
             (_E1984319854_
              (lambda () (error '"No clause matching" _c1984119850_)))
             (_K1984419865_
              (lambda (_kont19857_ _state19858_ _cv19859_ _mx19860_)
                (mutex-lock! _mx19860_)
                (let ((_$e19862_ _state19858_))
                  (if (eq? 'continue _$e19862_)
                      (begin
                        (##direct-structure-set!
                         _c19839_
                         _val19840_
                         '4
                         std/coroutine#cothr::t
                         '#f)
                        (##direct-structure-set!
                         _c19839_
                         'yield
                         '3
                         std/coroutine#cothr::t
                         '#f)
                        (condition-variable-signal! _cv19859_)
                        (mutex-unlock! _mx19860_)
                        _kont19857_)
                      (begin
                        (mutex-unlock! _mx19860_)
                        (error '"Illegal cothread state" _state19858_)))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _c1984119850_
               'std/coroutine#cothr::t))
            (let* ((_e1984519868_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1984119850_ '1)))
                   (_mx19871_ _e1984519868_)
                   (_e1984619873_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1984119850_ '2)))
                   (_cv19876_ _e1984619873_)
                   (_e1984719878_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1984119850_ '3)))
                   (_state19881_ _e1984719878_)
                   (_e1984819883_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1984119850_ '4)))
                   (_kont19886_ _e1984819883_))
              (_K1984419865_ _kont19886_ _state19881_ _cv19876_ _mx19871_))
            (_E1984319854_)))))
  (define std/coroutine#cothread-signal!
    (lambda (_c19806_ _state19807_ _val19808_)
      (let* ((_c1980919816_ _c19806_)
             (_E1981119820_
              (lambda () (error '"No clause matching" _c1980919816_)))
             (_K1981219826_
              (lambda (_cv19823_ _mx19824_)
                (mutex-lock! _mx19824_)
                (if (memq (##direct-structure-ref
                           _c19806_
                           '3
                           std/coroutine#cothr::t
                           '#f)
                          '(end error))
                    '#!void
                    (begin
                      (##direct-structure-set!
                       _c19806_
                       _val19808_
                       '4
                       std/coroutine#cothr::t
                       '#f)
                      (##direct-structure-set!
                       _c19806_
                       _state19807_
                       '3
                       std/coroutine#cothr::t
                       '#f)
                      (condition-variable-signal! _cv19823_)))
                (mutex-unlock! _mx19824_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _c1980919816_
               'std/coroutine#cothr::t))
            (let* ((_e1981319829_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1980919816_ '1)))
                   (_mx19832_ _e1981319829_)
                   (_e1981419834_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1980919816_ '2)))
                   (_cv19837_ _e1981419834_))
              (_K1981219826_ _cv19837_ _mx19832_))
            (_E1981119820_)))))
  (define std/coroutine#cothread-wait!
    (lambda (_c19764_)
      (let* ((_c1976519772_ _c19764_)
             (_E1976719776_
              (lambda () (error '"No clause matching" _c1976519772_)))
             (_K1976819793_
              (lambda (_cv19779_ _mx19780_)
                (let _lp19782_ ()
                  (mutex-lock! _mx19780_)
                  (let* ((_state19785_
                          (##direct-structure-ref
                           _c19764_
                           '3
                           std/coroutine#cothr::t
                           '#f))
                         (_$e19787_ _state19785_))
                    (if (or (eq? 'run _$e19787_) (eq? 'yield _$e19787_))
                        (begin (mutex-unlock! _mx19780_ _cv19779_) (_lp19782_))
                        (if (eq? 'continue _$e19787_)
                            (mutex-unlock! _mx19780_)
                            (begin
                              (mutex-unlock! _mx19780_)
                              (error '"Illegal cothread state"
                                     _state19785_)))))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _c1976519772_
               'std/coroutine#cothr::t))
            (let* ((_e1976919796_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1976519772_ '1)))
                   (_mx19799_ _e1976919796_)
                   (_e1977019801_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _c1976519772_ '2)))
                   (_cv19804_ _e1977019801_))
              (_K1976819793_ _cv19804_ _mx19799_))
            (_E1976719776_))))))
