(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/crypto/bn#BN->bytes
    (lambda (_bn210158_)
      (let* ((_bytes210160_
              (make-u8vector (std/crypto/libcrypto#BN_num_bytes _bn210158_)))
             (_count210162_
              (std/crypto/libcrypto#BN_bn2bin _bn210158_ _bytes210160_)))
        (if (let ((__tmp301621 (u8vector-length _bytes210160_)))
              (declare (not safe))
              (##fx< _count210162_ __tmp301621))
            (u8vector-shrink! _bytes210160_ _count210162_)
            _bytes210160_))))
  (define std/crypto/bn#bytes->BN__%
    (lambda (_bytes210128_ _start210129_ _end210130_)
      (if (u8vector? _bytes210128_)
          (let* ((_end210135_
                  (let ((_$e210132_ _end210130_))
                    (if _$e210132_
                        _$e210132_
                        (u8vector-length _bytes210128_))))
                 (_$e210137_
                  (std/crypto/libcrypto#BN_bin2bn
                   _bytes210128_
                   _start210129_
                   _end210135_)))
            (if _$e210137_
                _$e210137_
                (error '"error decoding BN; NULL pointer" _bytes210128_)))
          (error '"bad argument; expected bytes" _bytes210128_))))
  (define std/crypto/bn#bytes->BN__0
    (lambda (_bytes210143_)
      (let* ((_start210145_ '0) (_end210147_ '#f))
        (std/crypto/bn#bytes->BN__% _bytes210143_ _start210145_ _end210147_))))
  (define std/crypto/bn#bytes->BN__1
    (lambda (_bytes210149_ _start210150_)
      (let ((_end210152_ '#f))
        (std/crypto/bn#bytes->BN__% _bytes210149_ _start210150_ _end210152_))))
  (define std/crypto/bn#bytes->BN
    (lambda _g301623_
      (let ((_g301622_ (let () (declare (not safe)) (##length _g301623_))))
        (cond ((let () (declare (not safe)) (##fx= _g301622_ 1))
               (apply std/crypto/bn#bytes->BN__0 _g301623_))
              ((let () (declare (not safe)) (##fx= _g301622_ 2))
               (apply std/crypto/bn#bytes->BN__1 _g301623_))
              ((let () (declare (not safe)) (##fx= _g301622_ 3))
               (apply std/crypto/bn#bytes->BN__% _g301623_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/bn#bytes->BN
                _g301623_)))))))
