(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/crypto/etc#libcrypto-error::t
    (make-struct-type
     'std/crypto/etc#libcrypto-error::t
     error::t
     '0
     'libcrypto-error
     '()
     ':init!
     '()))
  (define std/crypto/etc#libcrypto-error?
    (make-struct-predicate std/crypto/etc#libcrypto-error::t))
  (define std/crypto/etc#make-libcrypto-error
    (lambda _$args173978_
      (apply make-struct-instance
             std/crypto/etc#libcrypto-error::t
             _$args173978_)))
  (define std/crypto/etc#libcrypto-error:::init!
    (lambda (_self173965_ _errno173966_ _irritants173967_)
      (if (let ((__tmp301383
                 (let () (declare (not safe)) (##vector-length _self173965_))))
            (declare (not safe))
            (##fx< '3 __tmp301383))
          (begin
            (let ((__tmp301384
                   (let ((_$e173969_
                          (std/crypto/libcrypto#ERR_reason_error_string
                           _errno173966_)))
                     (if _$e173969_ _$e173969_ '"Unknown error"))))
              (declare (not safe))
              (##vector-set! _self173965_ '1 __tmp301384))
            (let ((__tmp301385 (cons _errno173966_ _irritants173967_)))
              (declare (not safe))
              (##vector-set! _self173965_ '2 __tmp301385))
            (let ((__tmp301386
                   (string-append
                    (let ((_$e173972_
                           (std/crypto/libcrypto#ERR_lib_error_string
                            _errno173966_)))
                      (if _$e173972_ _$e173972_ '"?"))
                    '":"
                    (let ((_$e173975_
                           (std/crypto/libcrypto#ERR_func_error_string
                            _errno173966_)))
                      (if _$e173975_ _$e173975_ '"?")))))
              (declare (not safe))
              (##vector-set! _self173965_ '3 __tmp301386)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self173965_))))
  (bind-method!
   std/crypto/etc#libcrypto-error::t
   ':init!
   std/crypto/etc#libcrypto-error:::init!
   '#f)
  (define std/crypto/etc#libcrypto-error::display-exception
    (lambda (_self173840_ _port173841_)
      (std/format#fprintf
       _port173841_
       '"Libcrypto error [~a]: ~a ~a~n"
       (error-trace _self173840_)
       (error-message _self173840_)
       (error-irritants _self173840_))))
  (bind-method!
   std/crypto/etc#libcrypto-error::t
   'display-exception
   std/crypto/etc#libcrypto-error::display-exception
   '#f)
  (define std/crypto/etc#raise-libcrypto-error
    (lambda _irritants173716_
      (raise (make-struct-instance
              std/crypto/etc#libcrypto-error::t
              (std/crypto/libcrypto#ERR_get_error)
              _irritants173716_))))
  (define std/crypto/etc#call-with-binary-input
    (lambda (_proc173712_ _in173713_ . _args173714_)
      (if (u8vector? _in173713_)
          (apply std/crypto/etc#call-with-binary-input-u8vector
                 _proc173712_
                 _in173713_
                 _args173714_)
          (if (string? _in173713_)
              (apply std/crypto/etc#call-with-binary-input-string
                     _proc173712_
                     _in173713_
                     _args173714_)
              (if (input-port? _in173713_)
                  (apply std/crypto/etc#call-with-binary-input-port
                         _proc173712_
                         _in173713_
                         _args173714_)
                  (error '"Unexpected input source" _in173713_))))))
  (define std/crypto/etc#call-with-binary-input-u8vector__0
    (lambda (_proc173700_ _in173701_)
      (_proc173700_
       _in173701_
       '0
       (let () (declare (not safe)) (##u8vector-length _in173701_)))))
  (define std/crypto/etc#call-with-binary-input-u8vector__1
    (lambda (_proc173703_ _in173704_ _start173705_)
      (_proc173703_
       _in173704_
       _start173705_
       (let () (declare (not safe)) (##u8vector-length _in173704_)))))
  (define std/crypto/etc#call-with-binary-input-u8vector__2
    (lambda (_proc173707_ _in173708_ _start173709_ _end173710_)
      (_proc173707_ _in173708_ _start173709_ _end173710_)))
  (define std/crypto/etc#call-with-binary-input-u8vector
    (lambda _g301388_
      (let ((_g301387_ (let () (declare (not safe)) (##length _g301388_))))
        (cond ((let () (declare (not safe)) (##fx= _g301387_ 2))
               (apply std/crypto/etc#call-with-binary-input-u8vector__0
                      _g301388_))
              ((let () (declare (not safe)) (##fx= _g301387_ 3))
               (apply std/crypto/etc#call-with-binary-input-u8vector__1
                      _g301388_))
              ((let () (declare (not safe)) (##fx= _g301387_ 4))
               (apply std/crypto/etc#call-with-binary-input-u8vector__2
                      _g301388_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/etc#call-with-binary-input-u8vector
                _g301388_))))))
  (define std/crypto/etc#call-with-binary-input-string__0
    (lambda (_proc173688_ _in173689_)
      (std/crypto/etc#call-with-binary-input-u8vector__0
       _proc173688_
       (std/text/utf8#string->utf8__0 _in173689_))))
  (define std/crypto/etc#call-with-binary-input-string__1
    (lambda (_proc173691_ _in173692_ _start173693_)
      (std/crypto/etc#call-with-binary-input-u8vector__0
       _proc173691_
       (std/text/utf8#utf8-encode
        _in173692_
        _start173693_
        (let () (declare (not safe)) (##string-length _in173692_))))))
  (define std/crypto/etc#call-with-binary-input-string__2
    (lambda (_proc173695_ _in173696_ _start173697_ _end173698_)
      (std/crypto/etc#call-with-binary-input-u8vector__0
       _proc173695_
       (std/text/utf8#utf8-encode _in173696_ _start173697_ _end173698_))))
  (define std/crypto/etc#call-with-binary-input-string
    (lambda _g301390_
      (let ((_g301389_ (let () (declare (not safe)) (##length _g301390_))))
        (cond ((let () (declare (not safe)) (##fx= _g301389_ 2))
               (apply std/crypto/etc#call-with-binary-input-string__0
                      _g301390_))
              ((let () (declare (not safe)) (##fx= _g301389_ 3))
               (apply std/crypto/etc#call-with-binary-input-string__1
                      _g301390_))
              ((let () (declare (not safe)) (##fx= _g301389_ 4))
               (apply std/crypto/etc#call-with-binary-input-string__2
                      _g301390_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/etc#call-with-binary-input-string
                _g301390_))))))
  (define std/crypto/etc#call-with-binary-input-port__%
    (lambda (_proc173672_ _in173673_ _fill?173674_)
      (if (macro-byte-input-port? _in173673_)
          (std/crypto/etc#call-with-binary-input-byte-port
           _proc173672_
           _in173673_
           _fill?173674_)
          (if (macro-character-input-port? _in173673_)
              (std/crypto/etc#call-with-binary-input-character-port
               _proc173672_
               _in173673_
               _fill?173674_)
              (error '"Unusable input-port; need a character or byte port"
                     _in173673_)))))
  (define std/crypto/etc#call-with-binary-input-port__0
    (lambda (_proc173679_ _in173680_)
      (let ((_fill?173682_ '#t))
        (std/crypto/etc#call-with-binary-input-port__%
         _proc173679_
         _in173680_
         _fill?173682_))))
  (define std/crypto/etc#call-with-binary-input-port
    (lambda _g301392_
      (let ((_g301391_ (let () (declare (not safe)) (##length _g301392_))))
        (cond ((let () (declare (not safe)) (##fx= _g301391_ 2))
               (apply std/crypto/etc#call-with-binary-input-port__0 _g301392_))
              ((let () (declare (not safe)) (##fx= _g301391_ 3))
               (apply std/crypto/etc#call-with-binary-input-port__% _g301392_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/etc#call-with-binary-input-port
                _g301392_))))))
  (define std/crypto/etc#call-with-binary-input-byte-port
    (lambda (_proc173657_ _in173658_ _fill?173659_)
      (let ((_bytes173661_
             (std/crypto/etc#drain-input-character-buffer _in173658_)))
        (if _bytes173661_
            (_proc173657_
             _bytes173661_
             '0
             (let () (declare (not safe)) (##u8vector-length _bytes173661_)))
            '#!void))
      (let ((_buf173663_ (let () (declare (not safe)) (##make-u8vector '1024)))
            (_need173664_ (if _fill?173659_ '1 absent-obj)))
        (let _lp173666_ ()
          (let ((_rd173669_
                 (let ()
                   (declare (not safe))
                   (##read-subu8vector
                    _buf173663_
                    '0
                    '1024
                    _in173658_
                    _need173664_))))
            (if (let () (declare (not safe)) (##fxzero? _rd173669_))
                '#!void
                (begin
                  (_proc173657_ _buf173663_ '0 _rd173669_)
                  (_lp173666_))))))))
  (define std/crypto/etc#call-with-binary-input-character-port
    (lambda (_proc173643_ _in173644_ _fill?173645_)
      (let ((_buf173647_ (let () (declare (not safe)) (##make-string '512)))
            (_need173648_ (if _fill?173645_ '1 absent-obj)))
        (let _lp173650_ ()
          (let ((_rd173653_
                 (let ()
                   (declare (not safe))
                   (##read-substring
                    _buf173647_
                    '0
                    '512
                    _in173644_
                    _need173648_))))
            (if (let () (declare (not safe)) (##fxzero? _rd173653_))
                '#!void
                (let ((_bytes173655_
                       (std/text/utf8#utf8-encode _buf173647_ '0 _rd173653_)))
                  (_proc173643_
                   _bytes173655_
                   '0
                   (let ()
                     (declare (not safe))
                     (##u8vector-length _bytes173655_)))
                  (_lp173650_))))))))
  (define std/crypto/etc#drain-input-character-buffer
    (lambda (_port173638_)
      (gerbil/gambit/threads#with-lock
       (macro-port-mutex _port173638_)
       (lambda ()
         (if (let ((__tmp301394 (macro-character-port-rlo _port173638_))
                   (__tmp301393 (macro-character-port-rhi _port173638_)))
               (declare (not safe))
               (##fx< __tmp301394 __tmp301393))
             (let ((_buf173641_
                    (std/text/utf8#utf8-encode
                     (macro-character-port-rbuf _port173638_)
                     (macro-character-port-rlo _port173638_)
                     (macro-character-port-rhi _port173638_))))
               (macro-character-port-rlo-set!
                _port173638_
                (macro-character-port-rhi _port173638_))
               _buf173641_)
             '#f)))))
  (define std/crypto/etc#*urandom* (open-input-file '"/dev/urandom"))
  (define std/crypto/etc#random-bytes
    (lambda (_len173634_)
      (let ((_bytes173636_ (make-u8vector _len173634_)))
        (std/crypto/etc#random-bytes!__% _bytes173636_ '0 _len173634_)
        _bytes173636_)))
  (define std/crypto/etc#random-bytes!__%
    (lambda (_bytes173610_ _start173611_ _end173612_)
      (let ((_count173614_
             (read-subu8vector
              _bytes173610_
              _start173611_
              _end173612_
              std/crypto/etc#*urandom*)))
        (if (eq? _count173614_
                 (let ()
                   (declare (not safe))
                   (##fx- _end173612_ _start173611_)))
            '#!void
            (error '"Could not read enough random bytes"
                   _count173614_
                   _start173611_
                   _end173612_)))))
  (define std/crypto/etc#random-bytes!__0
    (lambda (_bytes173619_)
      (let* ((_start173621_ '0) (_end173623_ (u8vector-length _bytes173619_)))
        (std/crypto/etc#random-bytes!__%
         _bytes173619_
         _start173621_
         _end173623_))))
  (define std/crypto/etc#random-bytes!__1
    (lambda (_bytes173625_ _start173626_)
      (let ((_end173628_ (u8vector-length _bytes173625_)))
        (std/crypto/etc#random-bytes!__%
         _bytes173625_
         _start173626_
         _end173628_))))
  (define std/crypto/etc#random-bytes!
    (lambda _g301396_
      (let ((_g301395_ (let () (declare (not safe)) (##length _g301396_))))
        (cond ((let () (declare (not safe)) (##fx= _g301395_ 1))
               (apply std/crypto/etc#random-bytes!__0 _g301396_))
              ((let () (declare (not safe)) (##fx= _g301395_ 2))
               (apply std/crypto/etc#random-bytes!__1 _g301396_))
              ((let () (declare (not safe)) (##fx= _g301395_ 3))
               (apply std/crypto/etc#random-bytes!__% _g301396_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/etc#random-bytes!
                _g301396_)))))))
