(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/db/conpool#errorf
    (lambda (_fmt259965_ . _args259966_)
      (std/logger#log-message 'connpool '0 _fmt259965_ _args259966_)))
  (define std/db/conpool#warnf
    (lambda (_fmt259962_ . _args259963_)
      (std/logger#log-message 'connpool '1 _fmt259962_ _args259963_)))
  (define std/db/conpool#infof
    (lambda (_fmt259959_ . _args259960_)
      (std/logger#log-message 'connpool '2 _fmt259959_ _args259960_)))
  (define std/db/conpool#debugf
    (lambda (_fmt259956_ . _args259957_)
      (std/logger#log-message 'connpool '3 _fmt259956_ _args259957_)))
  (define std/db/conpool#verbosef
    (lambda (_fmt259951_ . _args259953_)
      (std/logger#log-message 'connpool '4 _fmt259951_ _args259953_)))
  (define std/db/conpool#conpool::t
    (make-struct-type
     'std/db/conpool#conpool::t
     '#f
     '6
     'conpool
     '((final: . #t))
     ':init!
     '(e mx cv conns out max)))
  (define std/db/conpool#conpool?
    (make-struct-predicate std/db/conpool#conpool::t))
  (define std/db/conpool#make-conpool
    (lambda _$args259948_
      (apply make-struct-instance std/db/conpool#conpool::t _$args259948_)))
  (define std/db/conpool#conpool-e
    (make-struct-field-accessor std/db/conpool#conpool::t '0))
  (define std/db/conpool#conpool-mx
    (make-struct-field-accessor std/db/conpool#conpool::t '1))
  (define std/db/conpool#conpool-cv
    (make-struct-field-accessor std/db/conpool#conpool::t '2))
  (define std/db/conpool#conpool-conns
    (make-struct-field-accessor std/db/conpool#conpool::t '3))
  (define std/db/conpool#conpool-out
    (make-struct-field-accessor std/db/conpool#conpool::t '4))
  (define std/db/conpool#conpool-max
    (make-struct-field-accessor std/db/conpool#conpool::t '5))
  (define std/db/conpool#conpool-e-set!
    (make-struct-field-mutator std/db/conpool#conpool::t '0))
  (define std/db/conpool#conpool-mx-set!
    (make-struct-field-mutator std/db/conpool#conpool::t '1))
  (define std/db/conpool#conpool-cv-set!
    (make-struct-field-mutator std/db/conpool#conpool::t '2))
  (define std/db/conpool#conpool-conns-set!
    (make-struct-field-mutator std/db/conpool#conpool::t '3))
  (define std/db/conpool#conpool-out-set!
    (make-struct-field-mutator std/db/conpool#conpool::t '4))
  (define std/db/conpool#conpool-max-set!
    (make-struct-field-mutator std/db/conpool#conpool::t '5))
  (define std/db/conpool#conpool:::init!__%
    (lambda (_self259932_ _connect259933_ _max259934_)
      (if (let ((__tmp311172
                 (let () (declare (not safe)) (##vector-length _self259932_))))
            (declare (not safe))
            (##fx< '6 __tmp311172))
          (begin
            (let ()
              (declare (not safe))
              (##vector-set! _self259932_ '1 _connect259933_))
            (let ((__tmp311173 (make-mutex)))
              (declare (not safe))
              (##vector-set! _self259932_ '2 __tmp311173))
            (let ((__tmp311174 (make-condition-variable)))
              (declare (not safe))
              (##vector-set! _self259932_ '3 __tmp311174))
            (let () (declare (not safe)) (##vector-set! _self259932_ '4 '()))
            (let () (declare (not safe)) (##vector-set! _self259932_ '5 '()))
            (let ()
              (declare (not safe))
              (##vector-set! _self259932_ '6 _max259934_)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self259932_))))
  (define std/db/conpool#conpool:::init!__0
    (lambda (_self259939_ _connect259940_)
      (let ((_max259942_ '#f))
        (std/db/conpool#conpool:::init!__%
         _self259939_
         _connect259940_
         _max259942_))))
  (define std/db/conpool#conpool:::init!
    (lambda _g311176_
      (let ((_g311175_ (let () (declare (not safe)) (##length _g311176_))))
        (cond ((let () (declare (not safe)) (##fx= _g311175_ 2))
               (apply std/db/conpool#conpool:::init!__0 _g311176_))
              ((let () (declare (not safe)) (##fx= _g311175_ 3))
               (apply std/db/conpool#conpool:::init!__% _g311176_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/conpool#conpool:::init!
                _g311176_))))))
  (bind-method!
   std/db/conpool#conpool::t
   ':init!
   std/db/conpool#conpool:::init!
   '#f)
  (define std/db/conpool#conpool-get__%
    (lambda (_cp259691_ _timeo259692_)
      (let* ((_cp259693259704_ _cp259691_)
             (_E259695259708_
              (lambda () (error '"No clause matching" _cp259693259704_)))
             (_K259696259767_
              (lambda (_max259711_
                       _out259712_
                       _cv259713_
                       _mx259714_
                       _connect259715_)
                (let _lp259717_ ()
                  (mutex-lock! _mx259714_)
                  (let* ((_g259719259727_
                          (##direct-structure-ref
                           _cp259691_
                           '4
                           std/db/conpool#conpool::t
                           '#f))
                         (_else259721259749_
                          (lambda ()
                            (if (or (not _max259711_)
                                    (fx< (length _out259712_) _max259711_))
                                (let ((_conn259745_
                                       (with-exception-catcher
                                        (lambda (_g259737259739_)
                                          (if '#t
                                              (let ((_e259742_
                                                     _g259737259739_))
                                                (mutex-unlock! _mx259714_)
                                                (raise _e259742_))
                                              (raise _g259737259739_)))
                                        (lambda () (_connect259715_)))))
                                  (##direct-structure-set!
                                   _cp259691_
                                   (cons _conn259745_ _out259712_)
                                   '5
                                   std/db/conpool#conpool::t
                                   '#f)
                                  (mutex-unlock! _mx259714_)
                                  _conn259745_)
                                (let ((_res259747_
                                       (mutex-unlock!
                                        _mx259714_
                                        _cv259713_
                                        _timeo259692_)))
                                  (if _res259747_
                                      (_lp259717_)
                                      (std/error#raise-timeout
                                       'conpool-get
                                       '"Error getting connection; timeout"))))))
                         (_K259723259755_
                          (lambda (_rest259752_ _conn259753_)
                            (##direct-structure-set!
                             _cp259691_
                             _rest259752_
                             '4
                             std/db/conpool#conpool::t
                             '#f)
                            (##direct-structure-set!
                             _cp259691_
                             (cons _conn259753_ _out259712_)
                             '5
                             std/db/conpool#conpool::t
                             '#f)
                            (mutex-unlock! _mx259714_)
                            _conn259753_)))
                    (if (let () (declare (not safe)) (##pair? _g259719259727_))
                        (let ((_hd259724259758_
                               (let ()
                                 (declare (not safe))
                                 (##car _g259719259727_)))
                              (_tl259725259760_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _g259719259727_))))
                          (let* ((_conn259763_ _hd259724259758_)
                                 (_rest259765_ _tl259725259760_))
                            (_K259723259755_ _rest259765_ _conn259763_)))
                        (_else259721259749_)))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _cp259693259704_
               'std/db/conpool#conpool::t))
            (let* ((_e259697259770_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259693259704_ '1)))
                   (_connect259773_ _e259697259770_)
                   (_e259698259775_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259693259704_ '2)))
                   (_mx259778_ _e259698259775_)
                   (_e259699259780_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259693259704_ '3)))
                   (_cv259783_ _e259699259780_)
                   (_e259700259785_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259693259704_ '4)))
                   (_e259701259788_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259693259704_ '5)))
                   (_out259791_ _e259701259788_)
                   (_e259702259793_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259693259704_ '6)))
                   (_max259796_ _e259702259793_))
              (_K259696259767_
               _max259796_
               _out259791_
               _cv259783_
               _mx259778_
               _connect259773_))
            (_E259695259708_)))))
  (define std/db/conpool#conpool-get__0
    (lambda (_cp259801_)
      (let ((_timeo259803_ absent-obj))
        (std/db/conpool#conpool-get__% _cp259801_ _timeo259803_))))
  (define std/db/conpool#conpool-get
    (lambda _g311178_
      (let ((_g311177_ (let () (declare (not safe)) (##length _g311178_))))
        (cond ((let () (declare (not safe)) (##fx= _g311177_ 1))
               (apply std/db/conpool#conpool-get__0 _g311178_))
              ((let () (declare (not safe)) (##fx= _g311177_ 2))
               (apply std/db/conpool#conpool-get__% _g311178_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/conpool#conpool-get
                _g311178_))))))
  (define std/db/conpool#conpool-put
    (lambda (_cp259640_ _conn259641_)
      (let* ((_cp259642259652_ _cp259640_)
             (_E259644259656_
              (lambda () (error '"No clause matching" _cp259642259652_)))
             (_K259645259664_
              (lambda (_out259659_ _conns259660_ _cv259661_ _mx259662_)
                (mutex-lock! _mx259662_)
                (##direct-structure-set!
                 _cp259640_
                 (cons _conn259641_ _conns259660_)
                 '4
                 std/db/conpool#conpool::t
                 '#f)
                (##direct-structure-set!
                 _cp259640_
                 (remq _conn259641_ _out259659_)
                 '5
                 std/db/conpool#conpool::t
                 '#f)
                (condition-variable-signal! _cv259661_)
                (mutex-unlock! _mx259662_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _cp259642259652_
               'std/db/conpool#conpool::t))
            (let* ((_e259646259667_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259642259652_ '1)))
                   (_e259647259670_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259642259652_ '2)))
                   (_mx259673_ _e259647259670_)
                   (_e259648259675_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259642259652_ '3)))
                   (_cv259678_ _e259648259675_)
                   (_e259649259680_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259642259652_ '4)))
                   (_conns259683_ _e259649259680_)
                   (_e259650259685_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259642259652_ '5)))
                   (_out259688_ _e259650259685_))
              (_K259645259664_
               _out259688_
               _conns259683_
               _cv259678_
               _mx259673_))
            (_E259644259656_)))))
  (define std/db/conpool#conpool-release
    (lambda (_cp259590_ _conn259591_)
      (let* ((_cp259592259602_ _cp259590_)
             (_E259594259606_
              (lambda () (error '"No clause matching" _cp259592259602_)))
             (_K259595259614_
              (lambda (_out259609_ _conns259610_ _cv259611_ _mx259612_)
                (mutex-lock! _mx259612_)
                (##direct-structure-set!
                 _cp259590_
                 (remq _conn259591_ _out259609_)
                 '5
                 std/db/conpool#conpool::t
                 '#f)
                (mutex-unlock! _mx259612_)
                (let ((__method311170 (method-ref _conn259591_ 'destroy)))
                  (if __method311170
                      (__method311170 _conn259591_)
                      (error '"Missing method" _conn259591_ 'destroy))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _cp259592259602_
               'std/db/conpool#conpool::t))
            (let* ((_e259596259617_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259592259602_ '1)))
                   (_e259597259620_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259592259602_ '2)))
                   (_mx259623_ _e259597259620_)
                   (_e259598259625_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259592259602_ '3)))
                   (_cv259628_ _e259598259625_)
                   (_e259599259630_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259592259602_ '4)))
                   (_conns259633_ _e259599259630_)
                   (_e259600259635_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cp259592259602_ '5)))
                   (_out259638_ _e259600259635_))
              (_K259595259614_
               _out259638_
               _conns259633_
               _cv259628_
               _mx259623_))
            (_E259594259606_)))))
  (define std/db/conpool#conpool-close
    (lambda (_cp259529_)
      (letrec ((_close259531_
                (lambda (_conn259581_)
                  (with-exception-catcher
                   (lambda (_g259582259584_)
                     (if '#t
                         (let ((_e259587_ _g259582259584_))
                           (std/db/conpool#errorf
                            '"error closing connection: ~a"
                            _e259587_))
                         (raise _g259582259584_)))
                   (lambda ()
                     (let ((__method311171 (method-ref _conn259581_ 'destroy)))
                       (if __method311171
                           (__method311171 _conn259581_)
                           (error '"Missing method"
                                  _conn259581_
                                  'destroy))))))))
        (let* ((_cp259532259542_ _cp259529_)
               (_E259534259546_
                (lambda () (error '"No clause matching" _cp259532259542_)))
               (_K259535259555_
                (lambda (_out259549_ _conns259550_ _cv259551_ _mx259552_)
                  (mutex-lock! _mx259552_)
                  (for-each _close259531_ _conns259550_)
                  (for-each _close259531_ _out259549_)
                  (##direct-structure-set!
                   _cp259529_
                   (lambda () (error '"Connection pool is closed"))
                   '1
                   std/db/conpool#conpool::t
                   '#f)
                  (##direct-structure-set!
                   _cp259529_
                   '()
                   '4
                   std/db/conpool#conpool::t
                   '#f)
                  (##direct-structure-set!
                   _cp259529_
                   '()
                   '5
                   std/db/conpool#conpool::t
                   '#f)
                  (mutex-unlock! _mx259552_))))
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _cp259532259542_
                 'std/db/conpool#conpool::t))
              (let* ((_e259536259558_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cp259532259542_ '1)))
                     (_e259537259561_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cp259532259542_ '2)))
                     (_mx259564_ _e259537259561_)
                     (_e259538259566_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cp259532259542_ '3)))
                     (_cv259569_ _e259538259566_)
                     (_e259539259571_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cp259532259542_ '4)))
                     (_conns259574_ _e259539259571_)
                     (_e259540259576_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cp259532259542_ '5)))
                     (_out259579_ _e259540259576_))
                (_K259535259555_
                 _out259579_
                 _conns259574_
                 _cv259569_
                 _mx259564_))
              (_E259534259546_)))))))
