(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/db/leveldb#leveldb-error::t
    (make-struct-type
     'std/db/leveldb#leveldb-error::t
     error::t
     '0
     'leveldb-error
     '()
     '#f
     '()))
  (define std/db/leveldb#leveldb-error?
    (make-struct-predicate std/db/leveldb#leveldb-error::t))
  (define std/db/leveldb#make-leveldb-error
    (lambda _$args277474_
      (apply make-struct-instance
             std/db/leveldb#leveldb-error::t
             _$args277474_)))
  (define std/db/leveldb#raise-leveldb-error
    (lambda (_where277471_ _what277472_)
      (raise (make-struct-instance
              std/db/leveldb#leveldb-error::t
              _what277472_
              '()
              _where277471_))))
  (define std/db/leveldb#raise-leveldb-error/errptr
    (lambda (_where277468_ _errptr277469_)
      (raise (make-struct-instance
              std/db/leveldb#leveldb-error::t
              (std/db/_leveldb#errptr_str _errptr277469_)
              '()
              _where277468_))))
  (define std/db/leveldb#fixnum-positive?
    (lambda (_obj277466_)
      (if (fixnum? _obj277466_)
          (let () (declare (not safe)) (##fxpositive? _obj277466_))
          '#f)))
  (define std/db/leveldb#value-bytes
    (lambda (_key277464_)
      (if (u8vector? _key277464_)
          _key277464_
          (if (string? _key277464_)
              (std/text/utf8#string->utf8__0 _key277464_)
              (error '"Bad argument: expected u8vector or string"
                     _key277464_)))))
  (define std/db/leveldb#leveldb::t
    (make-struct-type
     'std/db/leveldb#leveldb::t
     '#f
     '2
     'leveldb
     '((final: . #t))
     '#f
     '(db opt)))
  (define std/db/leveldb#leveldb?
    (make-struct-predicate std/db/leveldb#leveldb::t))
  (define std/db/leveldb#make-leveldb
    (lambda _$args277461_
      (apply make-struct-instance std/db/leveldb#leveldb::t _$args277461_)))
  (define std/db/leveldb#leveldb-db
    (make-struct-field-accessor std/db/leveldb#leveldb::t '0))
  (define std/db/leveldb#leveldb-opt
    (make-struct-field-accessor std/db/leveldb#leveldb::t '1))
  (define std/db/leveldb#leveldb-db-set!
    (make-struct-field-mutator std/db/leveldb#leveldb::t '0))
  (define std/db/leveldb#leveldb-opt-set!
    (make-struct-field-mutator std/db/leveldb#leveldb::t '1))
  (define std/db/leveldb#leveldb-opts::t
    (make-struct-type
     'std/db/leveldb#leveldb-opts::t
     '#f
     '3
     'leveldb-opts
     '((final: . #t))
     '#f
     '(e cache filter)))
  (define std/db/leveldb#leveldb-opts?
    (make-struct-predicate std/db/leveldb#leveldb-opts::t))
  (define std/db/leveldb#make-leveldb-opts
    (lambda _$args277458_
      (apply make-struct-instance
             std/db/leveldb#leveldb-opts::t
             _$args277458_)))
  (define std/db/leveldb#leveldb-opts-e
    (make-struct-field-accessor std/db/leveldb#leveldb-opts::t '0))
  (define std/db/leveldb#leveldb-opts-cache
    (make-struct-field-accessor std/db/leveldb#leveldb-opts::t '1))
  (define std/db/leveldb#leveldb-opts-filter
    (make-struct-field-accessor std/db/leveldb#leveldb-opts::t '2))
  (define std/db/leveldb#leveldb-opts-e-set!
    (make-struct-field-mutator std/db/leveldb#leveldb-opts::t '0))
  (define std/db/leveldb#leveldb-opts-cache-set!
    (make-struct-field-mutator std/db/leveldb#leveldb-opts::t '1))
  (define std/db/leveldb#leveldb-opts-filter-set!
    (make-struct-field-mutator std/db/leveldb#leveldb-opts::t '2))
  (define std/db/leveldb#leveldb-itor::t
    (make-struct-type
     'std/db/leveldb#leveldb-itor::t
     '#f
     '1
     'leveldb-itor
     '((final: . #t))
     '#f
     '(e)))
  (define std/db/leveldb#leveldb-itor?
    (make-struct-predicate std/db/leveldb#leveldb-itor::t))
  (define std/db/leveldb#make-leveldb-itor
    (lambda _$args277455_
      (apply make-struct-instance
             std/db/leveldb#leveldb-itor::t
             _$args277455_)))
  (define std/db/leveldb#leveldb-itor-e
    (make-struct-field-accessor std/db/leveldb#leveldb-itor::t '0))
  (define std/db/leveldb#leveldb-itor-e-set!
    (make-struct-field-mutator std/db/leveldb#leveldb-itor::t '0))
  (define std/db/leveldb#leveldb-open__%
    (lambda (_name277437_ _opts277438_)
      (let* ((_errptr277440_ (std/db/leveldb#get-errptr))
             (_ptr277442_
              (std/db/_leveldb#leveldb_open
               (##direct-structure-ref
                _opts277438_
                '1
                std/db/leveldb#leveldb-opts::t
                '#f)
               _name277437_
               _errptr277440_)))
        (if _ptr277442_
            (let ()
              (declare (not safe))
              (##structure std/db/leveldb#leveldb::t _ptr277442_ _opts277438_))
            (std/db/leveldb#raise-leveldb-error/errptr
             'leveldb-open
             _errptr277440_)))))
  (define std/db/leveldb#leveldb-open__0
    (lambda (_name277448_)
      (let ((_opts277450_ (std/db/leveldb#leveldb-default-options)))
        (std/db/leveldb#leveldb-open__% _name277448_ _opts277450_))))
  (define std/db/leveldb#leveldb-open
    (lambda _g312742_
      (let ((_g312741_ (let () (declare (not safe)) (##length _g312742_))))
        (cond ((let () (declare (not safe)) (##fx= _g312741_ 1))
               (apply std/db/leveldb#leveldb-open__0 _g312742_))
              ((let () (declare (not safe)) (##fx= _g312741_ 2))
               (apply std/db/leveldb#leveldb-open__% _g312742_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#leveldb-open
                _g312742_))))))
  (define std/db/leveldb#leveldb-close
    (lambda (_ldb277412_)
      (let* ((_ldb277413277419_ _ldb277412_)
             (_E277415277423_
              (lambda () (error '"No clause matching" _ldb277413277419_)))
             (_K277416277428_
              (lambda (_db277426_)
                (if _db277426_
                    (begin
                      (std/db/_leveldb#leveldb_close _db277426_)
                      (##direct-structure-set!
                       _ldb277412_
                       '#f
                       '1
                       std/db/leveldb#leveldb::t
                       '#f))
                    '#!void))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ldb277413277419_
               'std/db/leveldb#leveldb::t))
            (let* ((_e277417277431_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ldb277413277419_ '1)))
                   (_db277434_ _e277417277431_))
              (_K277416277428_ _db277434_))
            (_E277415277423_)))))
  (define std/db/leveldb#leveldb::destroy std/db/leveldb#leveldb-close)
  (bind-method!
   std/db/leveldb#leveldb::t
   'destroy
   std/db/leveldb#leveldb::destroy
   '#f)
  (define std/db/leveldb#leveldb-put__%
    (lambda (_ldb277238_ _key277239_ _val277240_ _opts277241_)
      (let* ((_ldb277242277248_ _ldb277238_)
             (_E277244277252_
              (lambda () (error '"No clause matching" _ldb277242277248_)))
             (_K277245277268_
              (lambda (_db277255_)
                (if _db277255_
                    (let ((_keyx277257_
                           (std/db/leveldb#value-bytes _key277239_))
                          (_valx277258_
                           (std/db/leveldb#value-bytes _val277240_))
                          (_errptr277259_ (std/db/leveldb#get-errptr)))
                      (std/db/_leveldb#leveldb_put
                       _db277255_
                       _opts277241_
                       _keyx277257_
                       _valx277258_
                       _errptr277259_)
                      (let ((_$e277261_
                             (std/db/_leveldb#errptr_str _errptr277259_)))
                        (if _$e277261_
                            ((lambda (_g277263277265_)
                               (std/db/leveldb#raise-leveldb-error
                                'leveldb-put
                                _g277263277265_))
                             _$e277261_)
                            '#!void)))
                    (error '"LevelDB database has been closed")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ldb277242277248_
               'std/db/leveldb#leveldb::t))
            (let* ((_e277246277271_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ldb277242277248_ '1)))
                   (_db277274_ _e277246277271_))
              (_K277245277268_ _db277274_))
            (_E277244277252_)))))
  (define std/db/leveldb#leveldb-put__0
    (lambda (_ldb277279_ _key277280_ _val277281_)
      (let ((_opts277283_ (std/db/leveldb#leveldb-default-write-options)))
        (std/db/leveldb#leveldb-put__%
         _ldb277279_
         _key277280_
         _val277281_
         _opts277283_))))
  (define std/db/leveldb#leveldb-put
    (lambda _g312744_
      (let ((_g312743_ (let () (declare (not safe)) (##length _g312744_))))
        (cond ((let () (declare (not safe)) (##fx= _g312743_ 3))
               (apply std/db/leveldb#leveldb-put__0 _g312744_))
              ((let () (declare (not safe)) (##fx= _g312743_ 4))
               (apply std/db/leveldb#leveldb-put__% _g312744_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#leveldb-put
                _g312744_))))))
  (define std/db/leveldb#leveldb-get__%
    (lambda (_ldb277185_ _key277186_ _opts277187_)
      (let* ((_ldb277188277194_ _ldb277185_)
             (_E277190277198_
              (lambda () (error '"No clause matching" _ldb277188277194_)))
             (_K277191277217_
              (lambda (_db277201_)
                (if _db277201_
                    (let* ((_keyx277203_
                            (std/db/leveldb#value-bytes _key277186_))
                           (_errptr277205_ (std/db/leveldb#get-errptr))
                           (_slice277207_
                            (std/db/_leveldb#leveldb_get
                             _db277201_
                             _opts277187_
                             _keyx277203_
                             _errptr277205_)))
                      (if _slice277207_
                          (std/db/leveldb#slice->bytes _slice277207_)
                          (let ((_$e277210_
                                 (std/db/_leveldb#errptr_str _errptr277205_)))
                            (if _$e277210_
                                ((lambda (_g277212277214_)
                                   (std/db/leveldb#raise-leveldb-error
                                    'leveldb-get
                                    _g277212277214_))
                                 _$e277210_)
                                '#f))))
                    (error '"LevelDB database has been closed")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ldb277188277194_
               'std/db/leveldb#leveldb::t))
            (let* ((_e277192277220_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ldb277188277194_ '1)))
                   (_db277223_ _e277192277220_))
              (_K277191277217_ _db277223_))
            (_E277190277198_)))))
  (define std/db/leveldb#leveldb-get__0
    (lambda (_ldb277228_ _key277229_)
      (let ((_opts277231_ (std/db/leveldb#leveldb-default-read-options)))
        (std/db/leveldb#leveldb-get__% _ldb277228_ _key277229_ _opts277231_))))
  (define std/db/leveldb#leveldb-get
    (lambda _g312746_
      (let ((_g312745_ (let () (declare (not safe)) (##length _g312746_))))
        (cond ((let () (declare (not safe)) (##fx= _g312745_ 2))
               (apply std/db/leveldb#leveldb-get__0 _g312746_))
              ((let () (declare (not safe)) (##fx= _g312745_ 3))
               (apply std/db/leveldb#leveldb-get__% _g312746_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#leveldb-get
                _g312746_))))))
  (define std/db/leveldb#leveldb-delete__%
    (lambda (_ldb277136_ _key277137_ _opts277138_)
      (let* ((_ldb277139277145_ _ldb277136_)
             (_E277141277149_
              (lambda () (error '"No clause matching" _ldb277139277145_)))
             (_K277142277164_
              (lambda (_db277152_)
                (if _db277152_
                    (let ((_keyx277154_
                           (std/db/leveldb#value-bytes _key277137_))
                          (_errptr277155_ (std/db/leveldb#get-errptr)))
                      (std/db/_leveldb#leveldb_delete
                       _db277152_
                       _opts277138_
                       _keyx277154_
                       _errptr277155_)
                      (let ((_$e277157_
                             (std/db/_leveldb#errptr_str _errptr277155_)))
                        (if _$e277157_
                            ((lambda (_g277159277161_)
                               (std/db/leveldb#raise-leveldb-error
                                'leveldb-delete
                                _g277159277161_))
                             _$e277157_)
                            '#!void)))
                    (error '"LevelDB database has been closed")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ldb277139277145_
               'std/db/leveldb#leveldb::t))
            (let* ((_e277143277167_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ldb277139277145_ '1)))
                   (_db277170_ _e277143277167_))
              (_K277142277164_ _db277170_))
            (_E277141277149_)))))
  (define std/db/leveldb#leveldb-delete__0
    (lambda (_ldb277175_ _key277176_)
      (let ((_opts277178_ (std/db/leveldb#leveldb-default-write-options)))
        (std/db/leveldb#leveldb-delete__%
         _ldb277175_
         _key277176_
         _opts277178_))))
  (define std/db/leveldb#leveldb-delete
    (lambda _g312748_
      (let ((_g312747_ (let () (declare (not safe)) (##length _g312748_))))
        (cond ((let () (declare (not safe)) (##fx= _g312747_ 2))
               (apply std/db/leveldb#leveldb-delete__0 _g312748_))
              ((let () (declare (not safe)) (##fx= _g312747_ 3))
               (apply std/db/leveldb#leveldb-delete__% _g312748_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#leveldb-delete
                _g312748_))))))
  (define std/db/leveldb#leveldb-write__%
    (lambda (_ldb277088_ _batch277089_ _opts277090_)
      (let* ((_ldb277091277097_ _ldb277088_)
             (_E277093277101_
              (lambda () (error '"No clause matching" _ldb277091277097_)))
             (_K277094277115_
              (lambda (_db277104_)
                (if _db277104_
                    (let ((_errptr277106_ (std/db/leveldb#get-errptr)))
                      (std/db/_leveldb#leveldb_write
                       _db277104_
                       _opts277090_
                       _batch277089_
                       _errptr277106_)
                      (let ((_$e277108_
                             (std/db/_leveldb#errptr_str _errptr277106_)))
                        (if _$e277108_
                            ((lambda (_g277110277112_)
                               (std/db/leveldb#raise-leveldb-error
                                'leveldb-write
                                _g277110277112_))
                             _$e277108_)
                            '#!void)))
                    (error '"LevelDB database has been closed")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ldb277091277097_
               'std/db/leveldb#leveldb::t))
            (let* ((_e277095277118_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ldb277091277097_ '1)))
                   (_db277121_ _e277095277118_))
              (_K277094277115_ _db277121_))
            (_E277093277101_)))))
  (define std/db/leveldb#leveldb-write__0
    (lambda (_ldb277126_ _batch277127_)
      (let ((_opts277129_ (std/db/leveldb#leveldb-default-write-options)))
        (std/db/leveldb#leveldb-write__%
         _ldb277126_
         _batch277127_
         _opts277129_))))
  (define std/db/leveldb#leveldb-write
    (lambda _g312750_
      (let ((_g312749_ (let () (declare (not safe)) (##length _g312750_))))
        (cond ((let () (declare (not safe)) (##fx= _g312749_ 2))
               (apply std/db/leveldb#leveldb-write__0 _g312750_))
              ((let () (declare (not safe)) (##fx= _g312749_ 3))
               (apply std/db/leveldb#leveldb-write__% _g312750_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#leveldb-write
                _g312750_))))))
  (define std/db/leveldb#leveldb-key?__%
    (lambda (_ldb277035_ _key277036_ _opts277037_)
      (let* ((_ldb277038277044_ _ldb277035_)
             (_E277040277048_
              (lambda () (error '"No clause matching" _ldb277038277044_)))
             (_K277041277067_
              (lambda (_db277051_)
                (if _db277051_
                    (let* ((_keyx277053_
                            (std/db/leveldb#value-bytes _key277036_))
                           (_errptr277055_ (std/db/leveldb#get-errptr))
                           (_slice277057_
                            (std/db/_leveldb#leveldb_get
                             _db277051_
                             _opts277037_
                             _keyx277053_
                             _errptr277055_)))
                      (if _slice277057_
                          '#t
                          (let ((_$e277060_
                                 (std/db/_leveldb#errptr_str _errptr277055_)))
                            (if _$e277060_
                                ((lambda (_g277062277064_)
                                   (std/db/leveldb#raise-leveldb-error
                                    'leveldb-key?
                                    _g277062277064_))
                                 _$e277060_)
                                '#f))))
                    (error '"LevelDB database has been closed")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ldb277038277044_
               'std/db/leveldb#leveldb::t))
            (let* ((_e277042277070_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ldb277038277044_ '1)))
                   (_db277073_ _e277042277070_))
              (_K277041277067_ _db277073_))
            (_E277040277048_)))))
  (define std/db/leveldb#leveldb-key?__0
    (lambda (_ldb277078_ _key277079_)
      (let ((_opts277081_ (std/db/leveldb#leveldb-default-read-options)))
        (std/db/leveldb#leveldb-key?__%
         _ldb277078_
         _key277079_
         _opts277081_))))
  (define std/db/leveldb#leveldb-key?
    (lambda _g312752_
      (let ((_g312751_ (let () (declare (not safe)) (##length _g312752_))))
        (cond ((let () (declare (not safe)) (##fx= _g312751_ 2))
               (apply std/db/leveldb#leveldb-key?__0 _g312752_))
              ((let () (declare (not safe)) (##fx= _g312751_ 3))
               (apply std/db/leveldb#leveldb-key?__% _g312752_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#leveldb-key?
                _g312752_))))))
  (define std/db/leveldb#slice->bytes
    (lambda (_slice277027_)
      (let* ((_len277029_ (std/db/_leveldb#slice_len _slice277027_))
             (_bytes277031_ (make-u8vector _len277029_)))
        (std/db/_leveldb#slice_bytes _slice277027_ _bytes277031_)
        _bytes277031_)))
  (define std/db/leveldb#errptr-key 'std/db/leveldb#errptr)
  (define std/db/leveldb#get-errptr
    (lambda ()
      (let ((_$e277017_
             (gerbil/gambit/threads#thread-local-get
              std/db/leveldb#errptr-key)))
        (if _$e277017_
            ((lambda (_errptr277020_)
               (std/db/_leveldb#errptr_clear _errptr277020_)
               _errptr277020_)
             _$e277017_)
            (let ((_errptr277025_
                   (let ((_ptr277022_ (std/db/_leveldb#make_errptr)))
                     (if _ptr277022_
                         _ptr277022_
                         (std/db/leveldb#raise-leveldb-error
                          'get-errptr
                          '"Error allocating pointer")))))
              (gerbil/gambit/threads#thread-local-set!
               std/db/leveldb#errptr-key
               _errptr277025_)
              _errptr277025_)))))
  (define std/db/leveldb#leveldb-writebatch
    (lambda ()
      (let ((_ptr277013_ (std/db/_leveldb#leveldb_writebatch_create)))
        (if _ptr277013_
            _ptr277013_
            (std/db/leveldb#raise-leveldb-error
             'leveldb_writebatch_create
             '"Error allocating pointer")))))
  (define std/db/leveldb#leveldb-writebatch-clear
    (lambda (_batch277010_)
      (std/db/_leveldb#leveldb_writebatch_clear _batch277010_)))
  (define std/db/leveldb#leveldb-writebatch-put
    (lambda (_batch277003_ _key277004_ _val277005_)
      (let ((_keyx277007_ (std/db/leveldb#value-bytes _key277004_))
            (_valx277008_ (std/db/leveldb#value-bytes _val277005_)))
        (std/db/_leveldb#leveldb_writebatch_put
         _batch277003_
         _keyx277007_
         _valx277008_))))
  (define std/db/leveldb#leveldb-writebatch-delete
    (lambda (_batch276998_ _key276999_)
      (let ((_keyx277001_ (std/db/leveldb#value-bytes _key276999_)))
        (std/db/_leveldb#leveldb_writebatch_delete
         _batch276998_
         _keyx277001_))))
  (define std/db/leveldb#leveldb-iterator__%
    (lambda (_ldb276958_ _opts276959_)
      (let* ((_ldb276960276966_ _ldb276958_)
             (_E276962276970_
              (lambda () (error '"No clause matching" _ldb276960276966_)))
             (_K276963276980_
              (lambda (_db276973_)
                (if _db276973_
                    (let ((_lit276978_
                           (let ((__tmp312753
                                  (let ((_ptr276975_
                                         (std/db/_leveldb#leveldb_create_iterator
                                          _db276973_
                                          _opts276959_)))
                                    (if _ptr276975_
                                        _ptr276975_
                                        (std/db/leveldb#raise-leveldb-error
                                         'leveldb_create_iterator
                                         '"Error allocating pointer")))))
                             (declare (not safe))
                             (##structure
                              std/db/leveldb#leveldb-itor::t
                              __tmp312753))))
                      (make-will
                       _lit276978_
                       std/db/leveldb#leveldb-iterator-close)
                      _lit276978_)
                    (error '"LevelDB database has been closed")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ldb276960276966_
               'std/db/leveldb#leveldb::t))
            (let* ((_e276964276983_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ldb276960276966_ '1)))
                   (_db276986_ _e276964276983_))
              (_K276963276980_ _db276986_))
            (_E276962276970_)))))
  (define std/db/leveldb#leveldb-iterator__0
    (lambda (_ldb276991_)
      (let ((_opts276993_ (std/db/leveldb#leveldb-default-read-options)))
        (std/db/leveldb#leveldb-iterator__% _ldb276991_ _opts276993_))))
  (define std/db/leveldb#leveldb-iterator
    (lambda _g312755_
      (let ((_g312754_ (let () (declare (not safe)) (##length _g312755_))))
        (cond ((let () (declare (not safe)) (##fx= _g312754_ 1))
               (apply std/db/leveldb#leveldb-iterator__0 _g312755_))
              ((let () (declare (not safe)) (##fx= _g312754_ 2))
               (apply std/db/leveldb#leveldb-iterator__% _g312755_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#leveldb-iterator
                _g312755_))))))
  (define std/db/leveldb#leveldb-iterator-close
    (lambda (_lit276933_)
      (let* ((_lit276934276940_ _lit276933_)
             (_E276936276944_
              (lambda () (error '"No clause matching" _lit276934276940_)))
             (_K276937276949_
              (lambda (_itor276947_)
                (if _itor276947_
                    (begin
                      (std/db/_leveldb#leveldb_iter_destroy _itor276947_)
                      (##direct-structure-set!
                       _lit276933_
                       '#f
                       '1
                       std/db/leveldb#leveldb-itor::t
                       '#f))
                    '#!void))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _lit276934276940_
               'std/db/leveldb#leveldb-itor::t))
            (let* ((_e276938276952_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _lit276934276940_ '1)))
                   (_itor276955_ _e276938276952_))
              (_K276937276949_ _itor276955_))
            (_E276936276944_)))))
  (define std/db/leveldb#leveldb-itor::destroy
    std/db/leveldb#leveldb-iterator-close)
  (bind-method!
   std/db/leveldb#leveldb-itor::t
   'destroy
   std/db/leveldb#leveldb-itor::destroy
   '#f)
  (define std/db/leveldb#leveldb-iterator-valid?
    (lambda (_lit276787_)
      (let* ((_lit276788276794_ _lit276787_)
             (_E276790276798_
              (lambda () (error '"No clause matching" _lit276788276794_)))
             (_K276791276803_
              (lambda (_itor276801_)
                (if _itor276801_
                    (eq? (std/db/_leveldb#leveldb_iter_valid _itor276801_) '1)
                    (error '"Iterator has been finalized")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _lit276788276794_
               'std/db/leveldb#leveldb-itor::t))
            (let* ((_e276792276806_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _lit276788276794_ '1)))
                   (_itor276809_ _e276792276806_))
              (_K276791276803_ _itor276809_))
            (_E276790276798_)))))
  (define std/db/leveldb#leveldb-iterator-seek-first
    (lambda (_lit276763_)
      (let* ((_lit276764276770_ _lit276763_)
             (_E276766276774_
              (lambda () (error '"No clause matching" _lit276764276770_)))
             (_K276767276779_
              (lambda (_itor276777_)
                (if _itor276777_
                    (std/db/_leveldb#leveldb_iter_seek_to_first _itor276777_)
                    (error '"Iterator has been finalized")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _lit276764276770_
               'std/db/leveldb#leveldb-itor::t))
            (let* ((_e276768276782_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _lit276764276770_ '1)))
                   (_itor276785_ _e276768276782_))
              (_K276767276779_ _itor276785_))
            (_E276766276774_)))))
  (define std/db/leveldb#leveldb-iterator-seek-last
    (lambda (_lit276739_)
      (let* ((_lit276740276746_ _lit276739_)
             (_E276742276750_
              (lambda () (error '"No clause matching" _lit276740276746_)))
             (_K276743276755_
              (lambda (_itor276753_)
                (if _itor276753_
                    (std/db/_leveldb#leveldb_iter_seek_to_last _itor276753_)
                    (error '"Iterator has been finalized")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _lit276740276746_
               'std/db/leveldb#leveldb-itor::t))
            (let* ((_e276744276758_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _lit276740276746_ '1)))
                   (_itor276761_ _e276744276758_))
              (_K276743276755_ _itor276761_))
            (_E276742276750_)))))
  (define std/db/leveldb#leveldb-iterator-seek
    (lambda (_lit276712_ _key276713_)
      (let* ((_lit276714276720_ _lit276712_)
             (_E276716276724_
              (lambda () (error '"No clause matching" _lit276714276720_)))
             (_K276717276731_
              (lambda (_itor276727_)
                (if _itor276727_
                    (let ((_keyx276729_
                           (std/db/leveldb#value-bytes _key276713_)))
                      (std/db/_leveldb#leveldb_iter_seek
                       _itor276727_
                       _keyx276729_))
                    (error '"Iterator has been finalized")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _lit276714276720_
               'std/db/leveldb#leveldb-itor::t))
            (let* ((_e276718276734_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _lit276714276720_ '1)))
                   (_itor276737_ _e276718276734_))
              (_K276717276731_ _itor276737_))
            (_E276716276724_)))))
  (define std/db/leveldb#leveldb-iterator-next
    (lambda (_lit276688_)
      (let* ((_lit276689276695_ _lit276688_)
             (_E276691276699_
              (lambda () (error '"No clause matching" _lit276689276695_)))
             (_K276692276704_
              (lambda (_itor276702_)
                (if _itor276702_
                    (std/db/_leveldb#leveldb_iter_next _itor276702_)
                    (error '"Iterator has been finalized")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _lit276689276695_
               'std/db/leveldb#leveldb-itor::t))
            (let* ((_e276693276707_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _lit276689276695_ '1)))
                   (_itor276710_ _e276693276707_))
              (_K276692276704_ _itor276710_))
            (_E276691276699_)))))
  (define std/db/leveldb#leveldb-iterator-prev
    (lambda (_lit276664_)
      (let* ((_lit276665276671_ _lit276664_)
             (_E276667276675_
              (lambda () (error '"No clause matching" _lit276665276671_)))
             (_K276668276680_
              (lambda (_itor276678_)
                (if _itor276678_
                    (std/db/_leveldb#leveldb_iter_prev _itor276678_)
                    (error '"Iterator has been finalized")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _lit276665276671_
               'std/db/leveldb#leveldb-itor::t))
            (let* ((_e276669276683_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _lit276665276671_ '1)))
                   (_itor276686_ _e276669276683_))
              (_K276668276680_ _itor276686_))
            (_E276667276675_)))))
  (define std/db/leveldb#leveldb-iterator-key
    (lambda (_lit276634_)
      (let* ((_lit276635276641_ _lit276634_)
             (_E276637276645_
              (lambda () (error '"No clause matching" _lit276635276641_)))
             (_K276638276656_
              (lambda (_itor276648_)
                (if _itor276648_
                    (let ((_slice276649276651_
                           (std/db/_leveldb#leveldb_iter_key _itor276648_)))
                      (if _slice276649276651_
                          (let ((_slice276654_ _slice276649276651_))
                            (std/db/leveldb#slice->bytes _slice276654_))
                          '#f))
                    (error '"Iterator has been finalized")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _lit276635276641_
               'std/db/leveldb#leveldb-itor::t))
            (let* ((_e276639276659_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _lit276635276641_ '1)))
                   (_itor276662_ _e276639276659_))
              (_K276638276656_ _itor276662_))
            (_E276637276645_)))))
  (define std/db/leveldb#leveldb-iterator-value
    (lambda (_lit276604_)
      (let* ((_lit276605276611_ _lit276604_)
             (_E276607276615_
              (lambda () (error '"No clause matching" _lit276605276611_)))
             (_K276608276626_
              (lambda (_itor276618_)
                (if _itor276618_
                    (let ((_slice276619276621_
                           (std/db/_leveldb#leveldb_iter_value _itor276618_)))
                      (if _slice276619276621_
                          (let ((_slice276624_ _slice276619276621_))
                            (std/db/leveldb#slice->bytes _slice276624_))
                          '#f))
                    (error '"Iterator has been finalized")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _lit276605276611_
               'std/db/leveldb#leveldb-itor::t))
            (let* ((_e276609276629_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _lit276605276611_ '1)))
                   (_itor276632_ _e276609276629_))
              (_K276608276626_ _itor276632_))
            (_E276607276615_)))))
  (define std/db/leveldb#leveldb-iterator-error__%
    (lambda (_lit276560_ _raise?276561_)
      (let* ((_lit276562276568_ _lit276560_)
             (_E276564276572_
              (lambda () (error '"No clause matching" _lit276562276568_)))
             (_K276565276586_
              (lambda (_itor276575_)
                (if _itor276575_
                    (let ((_errptr276577_ (std/db/leveldb#get-errptr)))
                      (std/db/_leveldb#leveldb_iter_get_error
                       _itor276575_
                       _errptr276577_)
                      (if (not _raise?276561_)
                          (std/db/_leveldb#errptr_str _errptr276577_)
                          (let ((_$e276579_
                                 (std/db/_leveldb#errptr_str _errptr276577_)))
                            (if _$e276579_
                                ((lambda (_g276581276583_)
                                   (std/db/leveldb#raise-leveldb-error
                                    'leveldb-iterator-error
                                    _g276581276583_))
                                 _$e276579_)
                                '#f))))
                    (error '"Iterator has been finalized")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _lit276562276568_
               'std/db/leveldb#leveldb-itor::t))
            (let* ((_e276566276589_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _lit276562276568_ '1)))
                   (_itor276592_ _e276566276589_))
              (_K276565276586_ _itor276592_))
            (_E276564276572_)))))
  (define std/db/leveldb#leveldb-iterator-error__0
    (lambda (_lit276597_)
      (let ((_raise?276599_ '#t))
        (std/db/leveldb#leveldb-iterator-error__%
         _lit276597_
         _raise?276599_))))
  (define std/db/leveldb#leveldb-iterator-error
    (lambda _g312757_
      (let ((_g312756_ (let () (declare (not safe)) (##length _g312757_))))
        (cond ((let () (declare (not safe)) (##fx= _g312756_ 1))
               (apply std/db/leveldb#leveldb-iterator-error__0 _g312757_))
              ((let () (declare (not safe)) (##fx= _g312756_ 2))
               (apply std/db/leveldb#leveldb-iterator-error__% _g312757_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#leveldb-iterator-error
                _g312757_))))))
  (define std/db/leveldb#leveldb-iter-state::t
    (make-struct-type
     'std/db/leveldb#leveldb-iter-state::t
     '#f
     '4
     'leveldb-iter-state
     '((final: . #t))
     '#f
     '(itor value start limit)))
  (define std/db/leveldb#leveldb-iter-state?
    (make-struct-predicate std/db/leveldb#leveldb-iter-state::t))
  (define std/db/leveldb#make-leveldb-iter-state
    (lambda _$args276556_
      (apply make-struct-instance
             std/db/leveldb#leveldb-iter-state::t
             _$args276556_)))
  (define std/db/leveldb#leveldb-iter-state-itor
    (make-struct-field-accessor std/db/leveldb#leveldb-iter-state::t '0))
  (define std/db/leveldb#leveldb-iter-state-value
    (make-struct-field-accessor std/db/leveldb#leveldb-iter-state::t '1))
  (define std/db/leveldb#leveldb-iter-state-start
    (make-struct-field-accessor std/db/leveldb#leveldb-iter-state::t '2))
  (define std/db/leveldb#leveldb-iter-state-limit
    (make-struct-field-accessor std/db/leveldb#leveldb-iter-state::t '3))
  (define std/db/leveldb#leveldb-iter-state-itor-set!
    (make-struct-field-mutator std/db/leveldb#leveldb-iter-state::t '0))
  (define std/db/leveldb#leveldb-iter-state-value-set!
    (make-struct-field-mutator std/db/leveldb#leveldb-iter-state::t '1))
  (define std/db/leveldb#leveldb-iter-state-start-set!
    (make-struct-field-mutator std/db/leveldb#leveldb-iter-state::t '2))
  (define std/db/leveldb#leveldb-iter-state-limit-set!
    (make-struct-field-mutator std/db/leveldb#leveldb-iter-state::t '3))
  (define std/db/leveldb#in-leveldb__%
    (lambda (_db276534_ _start276535_ _limit276536_)
      (std/db/leveldb#iter-leveldb
       (let ((__tmp312760 (std/db/leveldb#leveldb-iterator__0 _db276534_))
             (__tmp312759
              (if _start276535_
                  (std/db/leveldb#value-bytes _start276535_)
                  '#f))
             (__tmp312758
              (if _limit276536_
                  (std/db/leveldb#value-bytes _limit276536_)
                  '#f)))
         (declare (not safe))
         (##structure
          std/db/leveldb#leveldb-iter-state::t
          __tmp312760
          std/db/leveldb#iter-nil
          __tmp312759
          __tmp312758))
       std/db/leveldb#leveldb-iter-key-value)))
  (define std/db/leveldb#in-leveldb__0
    (lambda (_db276541_)
      (let* ((_start276543_ '#f) (_limit276545_ '#f))
        (std/db/leveldb#in-leveldb__%
         _db276541_
         _start276543_
         _limit276545_))))
  (define std/db/leveldb#in-leveldb__1
    (lambda (_db276547_ _start276548_)
      (let ((_limit276550_ '#f))
        (std/db/leveldb#in-leveldb__%
         _db276547_
         _start276548_
         _limit276550_))))
  (define std/db/leveldb#in-leveldb
    (lambda _g312762_
      (let ((_g312761_ (let () (declare (not safe)) (##length _g312762_))))
        (cond ((let () (declare (not safe)) (##fx= _g312761_ 1))
               (apply std/db/leveldb#in-leveldb__0 _g312762_))
              ((let () (declare (not safe)) (##fx= _g312761_ 2))
               (apply std/db/leveldb#in-leveldb__1 _g312762_))
              ((let () (declare (not safe)) (##fx= _g312761_ 3))
               (apply std/db/leveldb#in-leveldb__% _g312762_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#in-leveldb
                _g312762_))))))
  (define std/db/leveldb#in-leveldb-keys__%
    (lambda (_db276511_ _start276512_ _limit276513_)
      (std/db/leveldb#iter-leveldb
       (let ((__tmp312765 (std/db/leveldb#leveldb-iterator__0 _db276511_))
             (__tmp312764
              (if _start276512_
                  (std/db/leveldb#value-bytes _start276512_)
                  '#f))
             (__tmp312763
              (if _limit276513_
                  (std/db/leveldb#value-bytes _limit276513_)
                  '#f)))
         (declare (not safe))
         (##structure
          std/db/leveldb#leveldb-iter-state::t
          __tmp312765
          std/db/leveldb#iter-nil
          __tmp312764
          __tmp312763))
       std/db/leveldb#leveldb-iter-key)))
  (define std/db/leveldb#in-leveldb-keys__0
    (lambda (_db276518_)
      (let* ((_start276520_ '#f) (_limit276522_ '#f))
        (std/db/leveldb#in-leveldb-keys__%
         _db276518_
         _start276520_
         _limit276522_))))
  (define std/db/leveldb#in-leveldb-keys__1
    (lambda (_db276524_ _start276525_)
      (let ((_limit276527_ '#f))
        (std/db/leveldb#in-leveldb-keys__%
         _db276524_
         _start276525_
         _limit276527_))))
  (define std/db/leveldb#in-leveldb-keys
    (lambda _g312767_
      (let ((_g312766_ (let () (declare (not safe)) (##length _g312767_))))
        (cond ((let () (declare (not safe)) (##fx= _g312766_ 1))
               (apply std/db/leveldb#in-leveldb-keys__0 _g312767_))
              ((let () (declare (not safe)) (##fx= _g312766_ 2))
               (apply std/db/leveldb#in-leveldb-keys__1 _g312767_))
              ((let () (declare (not safe)) (##fx= _g312766_ 3))
               (apply std/db/leveldb#in-leveldb-keys__% _g312767_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#in-leveldb-keys
                _g312767_))))))
  (define std/db/leveldb#iter-leveldb
    (lambda (_state276452_ _value-e276453_)
      (letrec ((_next276455_
                (lambda (_it276484_)
                  (let* ((_it276485276491_ _it276484_)
                         (_E276487276495_
                          (lambda ()
                            (error '"No clause matching" _it276485276491_)))
                         (_K276488276502_
                          (lambda (_state276498_)
                            (let ((_r276500_ (_value-e276453_ _state276498_)))
                              (if (std/iter#iter-end? _r276500_)
                                  '#!void
                                  (std/db/leveldb#leveldb-iter-next
                                   _state276498_))
                              _r276500_))))
                    (if (let ()
                          (declare (not safe))
                          (##structure-direct-instance-of?
                           _it276485276491_
                           'std/iter#iterator::t))
                        (let* ((_e276489276505_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref _it276485276491_ '1)))
                               (_state276508_ _e276489276505_))
                          (_K276488276502_ _state276508_))
                        (_E276487276495_)))))
               (_fini276456_
                (lambda (_it276460_)
                  (let* ((_it276461276467_ _it276460_)
                         (_E276463276471_
                          (lambda ()
                            (error '"No clause matching" _it276461276467_)))
                         (_K276464276476_
                          (lambda (_state276474_)
                            (if _state276474_
                                (begin
                                  (std/db/leveldb#leveldb-iter-fini
                                   _state276474_)
                                  (##direct-structure-set!
                                   _it276460_
                                   '#f
                                   '1
                                   std/iter#iterator::t
                                   '#f))
                                '#!void))))
                    (if (let ()
                          (declare (not safe))
                          (##structure-direct-instance-of?
                           _it276461276467_
                           'std/iter#iterator::t))
                        (let* ((_e276465276479_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref _it276461276467_ '1)))
                               (_state276482_ _e276465276479_))
                          (_K276464276476_ _state276482_))
                        (_E276463276471_))))))
        (let ((_it276458_
               (let ((__obj312740 (make-object std/iter#iterator::t '3)))
                 (if (let ((__tmp312768
                            (let ()
                              (declare (not safe))
                              (##vector-length __obj312740))))
                       (declare (not safe))
                       (##fx< '3 __tmp312768))
                     (begin
                       (let ()
                         (declare (not safe))
                         (##vector-set! __obj312740 '1 _state276452_))
                       (let ()
                         (declare (not safe))
                         (##vector-set! __obj312740 '2 _next276455_))
                       (let ()
                         (declare (not safe))
                         (##vector-set! __obj312740 '3 _fini276456_)))
                     (error '"struct-instance-init!: too many arguments for struct"
                            __obj312740))
                 __obj312740)))
          (make-will _it276458_ _fini276456_)
          (std/db/leveldb#leveldb-iter-start _state276452_)
          _it276458_))))
  (define std/db/leveldb#leveldb-iter-start
    (lambda (_state276407_)
      (let* ((_state276408276417_ _state276407_)
             (_E276410276421_
              (lambda () (error '"No clause matching" _state276408276417_)))
             (_K276411276429_
              (lambda (_limit276424_ _start276425_ _nil276426_ _itor276427_)
                (if _start276425_
                    (std/db/leveldb#leveldb-iterator-seek
                     _itor276427_
                     _start276425_)
                    (std/db/leveldb#leveldb-iterator-seek-first _itor276427_))
                (##direct-structure-set!
                 _state276407_
                 (if (std/db/leveldb#leveldb-iterator-valid? _itor276427_)
                     (if (and _start276425_
                              (equal? _start276425_ _limit276424_))
                         std/iter#iter-end
                         std/db/leveldb#iter-nil)
                     std/iter#iter-end)
                 '2
                 std/db/leveldb#leveldb-iter-state::t
                 '#f))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _state276408276417_
               'std/db/leveldb#leveldb-iter-state::t))
            (let* ((_e276412276432_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276408276417_ '1)))
                   (_itor276435_ _e276412276432_)
                   (_e276413276437_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276408276417_ '2)))
                   (_nil276440_ _e276413276437_)
                   (_e276414276442_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276408276417_ '3)))
                   (_start276445_ _e276414276442_)
                   (_e276415276447_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276408276417_ '4)))
                   (_limit276450_ _e276415276447_))
              (_K276411276429_
               _limit276450_
               _start276445_
               _nil276440_
               _itor276435_))
            (_E276410276421_)))))
  (define std/db/leveldb#leveldb-iter-key-value
    (lambda (_state276369_)
      (let* ((_state276370276377_ _state276369_)
             (_E276372276381_
              (lambda () (error '"No clause matching" _state276370276377_)))
             (_K276373276394_
              (lambda (_value276384_ _itor276385_)
                (if (std/db/leveldb#iter-nil? _value276384_)
                    (let* ((_key276387_
                            (std/db/leveldb#leveldb-iterator-key _itor276385_))
                           (_val276389_
                            (std/db/leveldb#leveldb-iterator-value
                             _itor276385_))
                           (_value276391_ (values _key276387_ _val276389_)))
                      (##direct-structure-set!
                       _state276369_
                       _value276391_
                       '2
                       std/db/leveldb#leveldb-iter-state::t
                       '#f)
                      _value276391_)
                    _value276384_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _state276370276377_
               'std/db/leveldb#leveldb-iter-state::t))
            (let* ((_e276374276397_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276370276377_ '1)))
                   (_itor276400_ _e276374276397_)
                   (_e276375276402_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276370276377_ '2)))
                   (_value276405_ _e276375276402_))
              (_K276373276394_ _value276405_ _itor276400_))
            (_E276372276381_)))))
  (define std/db/leveldb#leveldb-iter-key
    (lambda (_state276336_)
      (let* ((_state276337276344_ _state276336_)
             (_E276339276348_
              (lambda () (error '"No clause matching" _state276337276344_)))
             (_K276340276356_
              (lambda (_value276351_ _itor276352_)
                (if (std/db/leveldb#iter-nil? _value276351_)
                    (let ((_value276354_
                           (std/db/leveldb#leveldb-iterator-key _itor276352_)))
                      (##direct-structure-set!
                       _state276336_
                       _value276354_
                       '2
                       std/db/leveldb#leveldb-iter-state::t
                       '#f)
                      _value276354_)
                    _value276351_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _state276337276344_
               'std/db/leveldb#leveldb-iter-state::t))
            (let* ((_e276341276359_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276337276344_ '1)))
                   (_itor276362_ _e276341276359_)
                   (_e276342276364_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276337276344_ '2)))
                   (_value276367_ _e276342276364_))
              (_K276340276356_ _value276367_ _itor276362_))
            (_E276339276348_)))))
  (define std/db/leveldb#leveldb-iter-next
    (lambda (_state276294_)
      (let* ((_state276295276304_ _state276294_)
             (_E276297276308_
              (lambda () (error '"No clause matching" _state276295276304_)))
             (_K276298276315_
              (lambda (_limit276311_ _start276312_ _itor276313_)
                (std/db/leveldb#leveldb-iterator-next _itor276313_)
                (##direct-structure-set!
                 _state276294_
                 (if (std/db/leveldb#leveldb-iterator-valid? _itor276313_)
                     (if (and _limit276311_
                              (equal? (std/db/leveldb#leveldb-iterator-key
                                       _itor276313_)
                                      _limit276311_))
                         std/iter#iter-end
                         std/db/leveldb#iter-nil)
                     std/iter#iter-end)
                 '2
                 std/db/leveldb#leveldb-iter-state::t
                 '#f))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _state276295276304_
               'std/db/leveldb#leveldb-iter-state::t))
            (let* ((_e276299276318_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276295276304_ '1)))
                   (_itor276321_ _e276299276318_)
                   (_e276300276323_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276295276304_ '2)))
                   (_e276301276326_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276295276304_ '3)))
                   (_start276329_ _e276301276326_)
                   (_e276302276331_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276295276304_ '4)))
                   (_limit276334_ _e276302276331_))
              (_K276298276315_ _limit276334_ _start276329_ _itor276321_))
            (_E276297276308_)))))
  (define std/db/leveldb#leveldb-iter-fini
    (lambda (_state276270_)
      (let* ((_state276271276277_ _state276270_)
             (_E276273276281_
              (lambda () (error '"No clause matching" _state276271276277_)))
             (_K276274276286_
              (lambda (_itor276284_)
                (std/db/leveldb#leveldb-iterator-close _itor276284_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _state276271276277_
               'std/db/leveldb#leveldb-iter-state::t))
            (let* ((_e276275276289_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _state276271276277_ '1)))
                   (_itor276292_ _e276275276289_))
              (std/db/leveldb#leveldb-iterator-close _itor276292_))
            (_E276273276281_)))))
  (define std/db/leveldb#iter-nil '#&nil)
  (define std/db/leveldb#iter-nil?
    (lambda (_o276268_) (eq? std/db/leveldb#iter-nil _o276268_)))
  (define std/db/leveldb#leveldb-compact-range
    (lambda (_ldb276239_ _start-key276240_ _end-key276241_)
      (let* ((_ldb276242276248_ _ldb276239_)
             (_E276244276252_
              (lambda () (error '"No clause matching" _ldb276242276248_)))
             (_K276245276260_
              (lambda (_db276255_)
                (if _db276255_
                    (let ((_startx276257_
                           (std/db/leveldb#value-bytes _start-key276240_))
                          (_endx276258_
                           (std/db/leveldb#value-bytes _end-key276241_)))
                      (std/db/_leveldb#leveldb_compact_range
                       _db276255_
                       _startx276257_
                       _endx276258_))
                    (error '"LevelDB database has been closed")))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ldb276242276248_
               'std/db/leveldb#leveldb::t))
            (let* ((_e276246276263_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ldb276242276248_ '1)))
                   (_db276266_ _e276246276263_))
              (_K276245276260_ _db276266_))
            (_E276244276252_)))))
  (define std/db/leveldb#leveldb-destroy-db__%
    (lambda (_name276217_ _opts276218_)
      (let ((_errptr276220_ (std/db/leveldb#get-errptr)))
        (std/db/_leveldb#leveldb_destroy_db
         (##direct-structure-ref
          _opts276218_
          '1
          std/db/leveldb#leveldb-opts::t
          '#f)
         _name276217_
         _errptr276220_)
        (let ((_$e276222_ (std/db/_leveldb#errptr_str _errptr276220_)))
          (if _$e276222_
              ((lambda (_g276224276226_)
                 (std/db/leveldb#raise-leveldb-error
                  'leveldb-destroy-db
                  _g276224276226_))
               _$e276222_)
              '#!void)))))
  (define std/db/leveldb#leveldb-destroy-db__0
    (lambda (_name276232_)
      (let ((_opts276234_ (std/db/leveldb#leveldb-default-options)))
        (std/db/leveldb#leveldb-destroy-db__% _name276232_ _opts276234_))))
  (define std/db/leveldb#leveldb-destroy-db
    (lambda _g312770_
      (let ((_g312769_ (let () (declare (not safe)) (##length _g312770_))))
        (cond ((let () (declare (not safe)) (##fx= _g312769_ 1))
               (apply std/db/leveldb#leveldb-destroy-db__0 _g312770_))
              ((let () (declare (not safe)) (##fx= _g312769_ 2))
               (apply std/db/leveldb#leveldb-destroy-db__% _g312770_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#leveldb-destroy-db
                _g312770_))))))
  (define std/db/leveldb#leveldb-repair-db__%
    (lambda (_name276194_ _opts276195_)
      (let ((_errptr276197_ (std/db/leveldb#get-errptr)))
        (std/db/_leveldb#leveldb_repair_db
         (##direct-structure-ref
          _opts276195_
          '1
          std/db/leveldb#leveldb-opts::t
          '#f)
         _name276194_
         _errptr276197_)
        (let ((_$e276199_ (std/db/_leveldb#errptr_str _errptr276197_)))
          (if _$e276199_
              ((lambda (_g276201276203_)
                 (std/db/leveldb#raise-leveldb-error
                  'leveldb-repair-db
                  _g276201276203_))
               _$e276199_)
              '#!void)))))
  (define std/db/leveldb#leveldb-repair-db__0
    (lambda (_name276209_)
      (let ((_opts276211_ (std/db/leveldb#leveldb-default-options)))
        (std/db/leveldb#leveldb-repair-db__% _name276209_ _opts276211_))))
  (define std/db/leveldb#leveldb-repair-db
    (lambda _g312772_
      (let ((_g312771_ (let () (declare (not safe)) (##length _g312772_))))
        (cond ((let () (declare (not safe)) (##fx= _g312771_ 1))
               (apply std/db/leveldb#leveldb-repair-db__0 _g312772_))
              ((let () (declare (not safe)) (##fx= _g312771_ 2))
               (apply std/db/leveldb#leveldb-repair-db__% _g312772_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/leveldb#leveldb-repair-db
                _g312772_))))))
  (define std/db/leveldb#leveldb-options__%
    (lambda (_g312773_
             _create-if-missing276108276120_
             _error-if-exists276109276122_
             _paranoid-checks276110276124_
             _compression276111276126_
             _write-buffer-size276112276128_
             _max-open-files276113276130_
             _block-size276114276132_
             _block-restart-interval276115276134_
             _lru-cache-capacity276116276136_
             _bloom-filter-bits276117276138_)
      (let* ((_create-if-missing276141_
              (if (eq? _create-if-missing276108276120_ absent-value)
                  '#t
                  _create-if-missing276108276120_))
             (_error-if-exists276143_
              (if (eq? _error-if-exists276109276122_ absent-value)
                  '#f
                  _error-if-exists276109276122_))
             (_paranoid-checks276145_
              (if (eq? _paranoid-checks276110276124_ absent-value)
                  '#f
                  _paranoid-checks276110276124_))
             (_compression276147_
              (if (eq? _compression276111276126_ absent-value)
                  '#t
                  _compression276111276126_))
             (_write-buffer-size276149_
              (if (eq? _write-buffer-size276112276128_ absent-value)
                  '#f
                  _write-buffer-size276112276128_))
             (_max-open-files276151_
              (if (eq? _max-open-files276113276130_ absent-value)
                  '#f
                  _max-open-files276113276130_))
             (_block-size276153_
              (if (eq? _block-size276114276132_ absent-value)
                  '#f
                  _block-size276114276132_))
             (_block-restart-interval276155_
              (if (eq? _block-restart-interval276115276134_ absent-value)
                  '#f
                  _block-restart-interval276115276134_))
             (_lru-cache-capacity276157_
              (if (eq? _lru-cache-capacity276116276136_ absent-value)
                  '#f
                  _lru-cache-capacity276116276136_))
             (_bloom-filter-bits276159_
              (if (eq? _bloom-filter-bits276117276138_ absent-value)
                  '#f
                  _bloom-filter-bits276117276138_))
             (_opts276164_
              (let ((_ptr276161_ (std/db/_leveldb#leveldb_options_create)))
                (if _ptr276161_
                    _ptr276161_
                    (std/db/leveldb#raise-leveldb-error
                     'leveldb_options_create
                     '"Error allocating pointer")))))
        (if _create-if-missing276141_
            (std/db/_leveldb#leveldb_options_set_create_if_missing
             _opts276164_
             '1)
            '#!void)
        (if _error-if-exists276143_
            (std/db/_leveldb#leveldb_options_set_error_if_exists
             _opts276164_
             '1)
            '#!void)
        (if _paranoid-checks276145_
            (std/db/_leveldb#leveldb_options_set_paranoid_checks
             _opts276164_
             '1)
            '#!void)
        (std/db/_leveldb#leveldb_options_set_compression
         _opts276164_
         (if _compression276147_ '1 '0))
        (if _write-buffer-size276149_
            (if (std/db/leveldb#fixnum-positive? _write-buffer-size276149_)
                (std/db/_leveldb#leveldb_options_set_write_buffer_size
                 _opts276164_
                 _write-buffer-size276149_)
                (error '"Bad write buffer size; expected positive fixnum"
                       _write-buffer-size276149_))
            '#!void)
        (if _max-open-files276151_
            (if (fixnum? _max-open-files276151_)
                (std/db/_leveldb#leveldb_options_set_max_open_files
                 _opts276164_
                 _max-open-files276151_)
                (error '"Bad max open files; expected fixnum"))
            '#!void)
        (if _block-size276153_
            (if (std/db/leveldb#fixnum-positive? _block-size276153_)
                (std/db/_leveldb#leveldb_options_set_block_size
                 _opts276164_
                 _block-size276153_)
                (error '"Bad block size; expected positive fixnum"))
            '#!void)
        (if _block-restart-interval276155_
            (if (fixnum? _block-restart-interval276155_)
                (std/db/_leveldb#leveldb_options_set_block_restart_interval
                 _opts276164_
                 _block-restart-interval276155_)
                (error '"Bad block restart interval; expected fixnum"))
            '#!void)
        (letrec* ((_cache276166_
                   (if _lru-cache-capacity276157_
                       (if (std/db/leveldb#fixnum-positive?
                            _lru-cache-capacity276157_)
                           (let ((_ptr276177_
                                  (let ((_ptr276174_
                                         (std/db/_leveldb#leveldb_cache_create_lru
                                          _lru-cache-capacity276157_)))
                                    (if _ptr276174_
                                        _ptr276174_
                                        (std/db/leveldb#raise-leveldb-error
                                         'leveldb_cache_create_lru
                                         '"Error allocating pointer")))))
                             (std/db/_leveldb#leveldb_options_set_cache
                              _opts276164_
                              _ptr276177_)
                             _ptr276177_)
                           (error '"Bad lru cache size; expected positive fixnum"))
                       '#!void))
                  (_bloom-filter276167_
                   (if _bloom-filter-bits276159_
                       (if (std/db/leveldb#fixnum-positive?
                            _bloom-filter-bits276159_)
                           (let ((_ptr276172_
                                  (let ((_ptr276169_
                                         (std/db/_leveldb#leveldb_filterpolicy_create_bloom
                                          _bloom-filter-bits276159_)))
                                    (if _ptr276169_
                                        _ptr276169_
                                        (std/db/leveldb#raise-leveldb-error
                                         'leveldb_filterpolicy_create_bloom
                                         '"Error allocating pointer")))))
                             (std/db/_leveldb#leveldb_options_set_filter_policy
                              _opts276164_
                              _ptr276172_)
                             _ptr276172_)
                           (error '"Bad bloom filter bits; expected positive fixnum"))
                       '#!void)))
          (let ()
            (declare (not safe))
            (##structure
             std/db/leveldb#leveldb-opts::t
             _opts276164_
             _cache276166_
             _bloom-filter276167_))))))
  (define std/db/leveldb#leveldb-options__@
    (lambda (_keys276107276182_ . _args276184_)
      (apply std/db/leveldb#leveldb-options__%
             _keys276107276182_
             (table-ref _keys276107276182_ 'create-if-missing: absent-value)
             (table-ref _keys276107276182_ 'error-if-exists: absent-value)
             (table-ref _keys276107276182_ 'paranoid-checks: absent-value)
             (table-ref _keys276107276182_ 'compression: absent-value)
             (table-ref _keys276107276182_ 'write-buffer-size: absent-value)
             (table-ref _keys276107276182_ 'max-open-files: absent-value)
             (table-ref _keys276107276182_ 'block-size: absent-value)
             (table-ref
              _keys276107276182_
              'block-restart-interval:
              absent-value)
             (table-ref _keys276107276182_ 'lru-cache-capacity: absent-value)
             (table-ref _keys276107276182_ 'bloom-filter-bits: absent-value)
             _args276184_)))
  (define std/db/leveldb#leveldb-options
    (lambda _args276118276190_
      (apply keyword-dispatch
             '#(#f
                #f
                bloom-filter-bits:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                error-if-exists:
                #f
                #f
                block-restart-interval:
                #f
                #f
                write-buffer-size:
                #f
                #f
                #f
                #f
                lru-cache-capacity:
                max-open-files:
                #f
                #f
                compression:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                paranoid-checks:
                block-size:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                create-if-missing:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f)
             std/db/leveldb#leveldb-options__@
             _args276118276190_)))
  (define std/db/leveldb#leveldb-default-options
    (lambda () (force std/db/leveldb#default-options)))
  (define std/db/leveldb#default-options
    (make-promise
     (lambda ()
       (std/db/leveldb#leveldb-options__%
        '#f
        absent-value
        absent-value
        absent-value
        absent-value
        absent-value
        absent-value
        absent-value
        absent-value
        absent-value
        absent-value))))
  (define std/db/leveldb#leveldb-read-options__%
    (lambda (_g312774_ _verify-checksums276072276076_ _fill-cache276073276078_)
      (let* ((_verify-checksums276081_
              (if (eq? _verify-checksums276072276076_ absent-value)
                  '#f
                  _verify-checksums276072276076_))
             (_fill-cache276083_
              (if (eq? _fill-cache276073276078_ absent-value)
                  '#f
                  _fill-cache276073276078_))
             (_opts276088_
              (let ((_ptr276085_ (std/db/_leveldb#leveldb_readoptions_create)))
                (if _ptr276085_
                    _ptr276085_
                    (std/db/leveldb#raise-leveldb-error
                     'leveldb_readoptions_create
                     '"Error allocating pointer")))))
        (if _verify-checksums276081_
            (std/db/_leveldb#leveldb_readoptions_set_verify_checksums
             _opts276088_
             '1)
            '#!void)
        (if _fill-cache276083_
            (std/db/_leveldb#leveldb_readoptions_set_fill_cache
             _opts276088_
             '1)
            '#!void)
        _opts276088_)))
  (define std/db/leveldb#leveldb-read-options__@
    (lambda (_keys276071276093_ . _args276095_)
      (apply std/db/leveldb#leveldb-read-options__%
             _keys276071276093_
             (table-ref _keys276071276093_ 'verify-checksums: absent-value)
             (table-ref _keys276071276093_ 'fill-cache: absent-value)
             _args276095_)))
  (define std/db/leveldb#leveldb-read-options
    (lambda _args276074276101_
      (apply keyword-dispatch
             '#(#f verify-checksums: #f fill-cache:)
             std/db/leveldb#leveldb-read-options__@
             _args276074276101_)))
  (define std/db/leveldb#leveldb-default-read-options
    (lambda () (force std/db/leveldb#default-read-options)))
  (define std/db/leveldb#default-read-options
    (make-promise
     (lambda ()
       (std/db/leveldb#leveldb-read-options__%
        '#f
        absent-value
        absent-value))))
  (define std/db/leveldb#leveldb-write-options__%
    (lambda (_g312775_ _sync276041276044_)
      (let* ((_sync276047_
              (if (eq? _sync276041276044_ absent-value)
                  '#f
                  _sync276041276044_))
             (_opts276052_
              (let ((_ptr276049_
                     (std/db/_leveldb#leveldb_writeoptions_create)))
                (if _ptr276049_
                    _ptr276049_
                    (std/db/leveldb#raise-leveldb-error
                     'leveldb_writeoptions_create
                     '"Error allocating pointer")))))
        (if _sync276047_
            (std/db/_leveldb#leveldb_writeoptions_set_sync _opts276052_ '1)
            '#!void)
        _opts276052_)))
  (define std/db/leveldb#leveldb-write-options__@
    (lambda (_keys276040276057_ . _args276059_)
      (apply std/db/leveldb#leveldb-write-options__%
             _keys276040276057_
             (table-ref _keys276040276057_ 'sync: absent-value)
             _args276059_)))
  (define std/db/leveldb#leveldb-write-options
    (lambda _args276042276065_
      (apply keyword-dispatch
             '#(sync:)
             std/db/leveldb#leveldb-write-options__@
             _args276042276065_)))
  (define std/db/leveldb#leveldb-default-write-options
    (lambda () (force std/db/leveldb#default-write-options)))
  (define std/db/leveldb#default-write-options
    (make-promise
     (lambda () (std/db/leveldb#leveldb-write-options__% '#f absent-value)))))
