(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/db/postgresql#postgresql-connection::t
    (make-struct-type
     'std/db/postgresql#postgresql-connection::t
     std/db/dbi#connection::t
     '4
     'postgresql-connection
     '((print: host port user db) (final: . #t))
     ':init!
     '(host port user db)))
  (define std/db/postgresql#postgresql-connection?
    (make-struct-predicate std/db/postgresql#postgresql-connection::t))
  (define std/db/postgresql#make-postgresql-connection
    (lambda _$args272264_
      (apply make-struct-instance
             std/db/postgresql#postgresql-connection::t
             _$args272264_)))
  (define std/db/postgresql#postgresql-connection-host
    (make-struct-field-accessor std/db/postgresql#postgresql-connection::t '0))
  (define std/db/postgresql#postgresql-connection-port
    (make-struct-field-accessor std/db/postgresql#postgresql-connection::t '1))
  (define std/db/postgresql#postgresql-connection-user
    (make-struct-field-accessor std/db/postgresql#postgresql-connection::t '2))
  (define std/db/postgresql#postgresql-connection-db
    (make-struct-field-accessor std/db/postgresql#postgresql-connection::t '3))
  (define std/db/postgresql#postgresql-connection-host-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-connection::t '0))
  (define std/db/postgresql#postgresql-connection-port-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-connection::t '1))
  (define std/db/postgresql#postgresql-connection-user-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-connection::t '2))
  (define std/db/postgresql#postgresql-connection-db-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-connection::t '3))
  (define std/db/postgresql#postgresql-connection:::init!
    (lambda (_self272257_
             _driver272258_
             _host272259_
             _port272260_
             _user272261_
             _db272262_)
      (if (let ((__tmp312545
                 (let () (declare (not safe)) (##vector-length _self272257_))))
            (declare (not safe))
            (##fx< '8 __tmp312545))
          (begin
            (let ()
              (declare (not safe))
              (##vector-set! _self272257_ '1 _driver272258_))
            (let () (declare (not safe)) (##vector-set! _self272257_ '2 '#f))
            (let () (declare (not safe)) (##vector-set! _self272257_ '3 '#f))
            (let () (declare (not safe)) (##vector-set! _self272257_ '4 '#f))
            (let ()
              (declare (not safe))
              (##vector-set! _self272257_ '5 _host272259_))
            (let ()
              (declare (not safe))
              (##vector-set! _self272257_ '6 _port272260_))
            (let ()
              (declare (not safe))
              (##vector-set! _self272257_ '7 _user272261_))
            (let ()
              (declare (not safe))
              (##vector-set! _self272257_ '8 _db272262_)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self272257_))))
  (bind-method!
   std/db/postgresql#postgresql-connection::t
   ':init!
   std/db/postgresql#postgresql-connection:::init!
   '#f)
  (define std/db/postgresql#postgresql-connect__%
    (lambda (_g312546_
             _host272091272098_
             _port272092272100_
             _user272093272102_
             _passwd272094272104_
             _db272095272106_)
      (let* ((_host272109_
              (if (eq? _host272091272098_ absent-value)
                  '"127.0.0.1"
                  _host272091272098_))
             (_port272111_
              (if (eq? _port272092272100_ absent-value)
                  '5432
                  _port272092272100_))
             (_user272113_
              (if (eq? _user272093272102_ absent-value)
                  (error '"Missing required keyword argument" 'user:)
                  _user272093272102_))
             (_passwd272115_
              (if (eq? _passwd272094272104_ absent-value)
                  (error '"Missing required keyword argument" 'passwd:)
                  _passwd272094272104_))
             (_db272117_
              (if (eq? _db272095272106_ absent-value) '#f _db272095272106_))
             (_driver272119_
              (std/db/postgresql-driver#postgresql-connect!
               _host272109_
               _port272111_
               _user272113_
               _passwd272115_
               _db272117_))
             (__obj312539
              (make-object std/db/postgresql#postgresql-connection::t '8)))
        (std/db/postgresql#postgresql-connection:::init!
         __obj312539
         _driver272119_
         _host272109_
         _port272111_
         _user272113_
         _db272117_)
        __obj312539)))
  (define std/db/postgresql#postgresql-connect__@
    (lambda (_keys272090272124_ . _args272126_)
      (apply std/db/postgresql#postgresql-connect__%
             _keys272090272124_
             (table-ref _keys272090272124_ 'host: absent-value)
             (table-ref _keys272090272124_ 'port: absent-value)
             (table-ref _keys272090272124_ 'user: absent-value)
             (table-ref _keys272090272124_ 'passwd: absent-value)
             (table-ref _keys272090272124_ 'db: absent-value)
             _args272126_)))
  (define std/db/postgresql#postgresql-connect
    (lambda _args272096272132_
      (apply keyword-dispatch
             '#(#f passwd: #f #f port: host: user: #f #f db:)
             std/db/postgresql#postgresql-connect__@
             _args272096272132_)))
  (define std/db/postgresql#postgresql-connection::close
    (lambda (_self272087_)
      (std/db/postgresql-driver#postgresql-close! _self272087_)))
  (bind-method!
   std/db/postgresql#postgresql-connection::t
   'close
   std/db/postgresql#postgresql-connection::close
   '#f)
  (define std/db/postgresql#postgresql-command::t
    (make-struct-type
     'std/db/postgresql#postgresql-command::t
     std/db/dbi#statement::t
     '5
     'postgresql-command
     '((print: complete))
     ':init!
     '(conn complete notices input token)))
  (define std/db/postgresql#postgresql-command?
    (make-struct-predicate std/db/postgresql#postgresql-command::t))
  (define std/db/postgresql#make-postgresql-command
    (lambda _$args271962_
      (apply make-struct-instance
             std/db/postgresql#postgresql-command::t
             _$args271962_)))
  (define std/db/postgresql#postgresql-command-conn
    (make-struct-field-accessor std/db/postgresql#postgresql-command::t '0))
  (define std/db/postgresql#postgresql-command-complete
    (make-struct-field-accessor std/db/postgresql#postgresql-command::t '1))
  (define std/db/postgresql#postgresql-command-notices
    (make-struct-field-accessor std/db/postgresql#postgresql-command::t '2))
  (define std/db/postgresql#postgresql-command-input
    (make-struct-field-accessor std/db/postgresql#postgresql-command::t '3))
  (define std/db/postgresql#postgresql-command-token
    (make-struct-field-accessor std/db/postgresql#postgresql-command::t '4))
  (define std/db/postgresql#postgresql-command-conn-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-command::t '0))
  (define std/db/postgresql#postgresql-command-complete-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-command::t '1))
  (define std/db/postgresql#postgresql-command-notices-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-command::t '2))
  (define std/db/postgresql#postgresql-command-input-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-command::t '3))
  (define std/db/postgresql#postgresql-command-token-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-command::t '4))
  (define std/db/postgresql#!unnamed::t
    (make-struct-type
     'std/db/postgresql#!unnamed::t
     '#f
     '0
     '!unnamed
     '((final: . #t))
     '#f
     '()))
  (define std/db/postgresql#!unnamed?
    (make-struct-predicate std/db/postgresql#!unnamed::t))
  (define std/db/postgresql#make-!unnamed
    (lambda _$args271959_
      (apply make-struct-instance
             std/db/postgresql#!unnamed::t
             _$args271959_)))
  (define std/db/postgresql#unnamed-command
    (let () (declare (not safe)) (##structure std/db/postgresql#!unnamed::t)))
  (define std/db/postgresql#postgresql-command:::init!__%
    (lambda (_g312547_
             _name271930271934_
             _complete271931271936_
             _self271938_
             _conn271939_)
      (let* ((_name271941_
              (if (eq? _name271930271934_ absent-value)
                  std/db/postgresql#unnamed-command
                  _name271930271934_))
             (_complete271943_
              (if (eq? _complete271931271936_ absent-value)
                  '#f
                  _complete271931271936_)))
        (if (let ((__tmp312548
                   (let ()
                     (declare (not safe))
                     (##vector-length _self271938_))))
              (declare (not safe))
              (##fx< '4 __tmp312548))
            (begin
              (let ()
                (declare (not safe))
                (##vector-set! _self271938_ '1 _name271941_))
              (let ()
                (declare (not safe))
                (##vector-set! _self271938_ '2 _conn271939_))
              (let ()
                (declare (not safe))
                (##vector-set! _self271938_ '3 _complete271943_))
              (let ()
                (declare (not safe))
                (##vector-set! _self271938_ '4 '())))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self271938_)))))
  (define std/db/postgresql#postgresql-command:::init!__@
    (lambda (_keys271929271948_ . _args271950_)
      (apply std/db/postgresql#postgresql-command:::init!__%
             _keys271929271948_
             (table-ref _keys271929271948_ 'name: absent-value)
             (table-ref _keys271929271948_ 'complete: absent-value)
             _args271950_)))
  (define std/db/postgresql#postgresql-command:::init!
    (lambda _args271932271956_
      (apply keyword-dispatch
             '#(name: #f complete:)
             std/db/postgresql#postgresql-command:::init!__@
             _args271932271956_)))
  (bind-method!
   std/db/postgresql#postgresql-command::t
   ':init!
   std/db/postgresql#postgresql-command:::init!
   '#f)
  (define std/db/postgresql#postgresql-command::query-start void)
  (bind-method!
   std/db/postgresql#postgresql-command::t
   'query-start
   std/db/postgresql#postgresql-command::query-start
   '#f)
  (define std/db/postgresql#postgresql-command::query-fini
    std/db/postgresql#postgresql-command::reset)
  (bind-method!
   std/db/postgresql#postgresql-command::t
   'query-fini
   std/db/postgresql#postgresql-command::query-fini
   '#f)
  (define std/db/postgresql#postgresql-command::query-fetch
    (lambda _g312549_ std/iter#iter-end))
  (bind-method!
   std/db/postgresql#postgresql-command::t
   'query-fetch
   std/db/postgresql#postgresql-command::query-fetch
   '#f)
  (define std/db/postgresql#postgresql-command::query-row
    std/db/postgresql#postgresql-command-complete)
  (bind-method!
   std/db/postgresql#postgresql-command::t
   'query-row
   std/db/postgresql#postgresql-command::query-row
   '#f)
  (define std/db/postgresql#postgresql-command::columns (lambda _g312550_ '()))
  (bind-method!
   std/db/postgresql#postgresql-command::t
   'columns
   std/db/postgresql#postgresql-command::columns
   '#f)
  (define std/db/postgresql#wrap-notice-handler
    (lambda (_cmd271189_ _thunk271190_)
      (std/db/postgresql-driver#with-postgresql-notice-handler
       (##structure-ref
        _cmd271189_
        '2
        std/db/postgresql#postgresql-command::t
        '#f)
       (lambda _args271192_
         (##structure-set!
          _cmd271189_
          (cons _args271192_
                (##structure-ref
                 _cmd271189_
                 '4
                 std/db/postgresql#postgresql-command::t
                 '#f))
          '4
          std/db/postgresql#postgresql-command::t
          '#f))
       _thunk271190_)))
  (define std/db/postgresql#postgresql-command::reset
    (lambda (_self271181_)
      (let ((_token271182271184_
             (##structure-ref
              _self271181_
              '6
              std/db/postgresql#postgresql-command::t
              '#f)))
        (if _token271182271184_
            (let ((_token271187_ _token271182271184_))
              (std/db/postgresql-driver#postgresql-reset!
               (##structure-ref
                _self271181_
                '2
                std/db/postgresql#postgresql-command::t
                '#f)
               _token271187_)
              (##structure-set!
               _self271181_
               '#f
               '6
               std/db/postgresql#postgresql-command::t
               '#f)
              (##structure-set!
               _self271181_
               '#f
               '5
               std/db/postgresql#postgresql-command::t
               '#f))
            '#f))))
  (define std/db/postgresql#postgresql-command::reset::specialize
    (lambda (__t312459)
      (let* ((__class312460
              (struct-subtype?
               std/db/postgresql#postgresql-command::t
               __t312459))
             (__specializer312461
              (lambda (_self271181_)
                (let ((_token271182271184_
                       (if __class312460
                           (let ()
                             (declare (not safe))
                             (##unchecked-structure-ref
                              _self271181_
                              '6
                              std/db/postgresql#postgresql-command::t
                              '#f))
                           (error '"Type error; concrete type is not a subclass of expected type"
                                  std/db/postgresql#postgresql-command::t
                                  _self271181_))))
                  (if _token271182271184_
                      (let ((_token271187_ _token271182271184_))
                        (std/db/postgresql-driver#postgresql-reset!
                         (if __class312460
                             (let ()
                               (declare (not safe))
                               (##unchecked-structure-ref
                                _self271181_
                                '2
                                std/db/postgresql#postgresql-command::t
                                '#f))
                             (error '"Type error; concrete type is not a subclass of expected type"
                                    std/db/postgresql#postgresql-command::t
                                    _self271181_))
                         _token271187_)
                        (if __class312460
                            (let ()
                              (declare (not safe))
                              (##unchecked-structure-set!
                               _self271181_
                               '#f
                               '6
                               std/db/postgresql#postgresql-command::t
                               '#f))
                            (error '"Type error; concrete type is not a subclass of expected type"
                                   std/db/postgresql#postgresql-command::t
                                   _self271181_))
                        (if __class312460
                            (let ()
                              (declare (not safe))
                              (##unchecked-structure-set!
                               _self271181_
                               '#f
                               '5
                               std/db/postgresql#postgresql-command::t
                               '#f))
                            (error '"Type error; concrete type is not a subclass of expected type"
                                   std/db/postgresql#postgresql-command::t
                                   _self271181_)))
                      '#f)))))
        (if __class312460
            std/db/postgresql#postgresql-command::reset::specialize::unchecked
            __specializer312461))))
  (define std/db/postgresql#postgresql-command::reset::specialize::unchecked
    (lambda (_self271181_)
      (let ((_token271182271184_
             (let ()
               (declare (not safe))
               (##unchecked-structure-ref
                _self271181_
                '6
                std/db/postgresql#postgresql-command::t
                '#f))))
        (if _token271182271184_
            (let ((_token271187_ _token271182271184_))
              (std/db/postgresql-driver#postgresql-reset!
               (let ()
                 (declare (not safe))
                 (##unchecked-structure-ref
                  _self271181_
                  '2
                  std/db/postgresql#postgresql-command::t
                  '#f))
               _token271187_)
              (let ()
                (declare (not safe))
                (##unchecked-structure-set!
                 _self271181_
                 '#f
                 '6
                 std/db/postgresql#postgresql-command::t
                 '#f))
              (let ()
                (declare (not safe))
                (##unchecked-structure-set!
                 _self271181_
                 '#f
                 '5
                 std/db/postgresql#postgresql-command::t
                 '#f)))
            '#f))))
  (bind-specializer!
   std/db/postgresql#postgresql-command::reset
   std/db/postgresql#postgresql-command::reset::specialize)
  (bind-method!
   std/db/postgresql#postgresql-command::t
   'reset
   std/db/postgresql#postgresql-command::reset
   '#f)
  (define std/db/postgresql#postgresql-statement::t
    (make-struct-type
     'std/db/postgresql#postgresql-statement::t
     std/db/postgresql#postgresql-command::t
     '4
     'postgresql-statement
     '((final: . #t))
     ':init!
     '(cols params bind row)))
  (define std/db/postgresql#postgresql-statement?
    (make-struct-predicate std/db/postgresql#postgresql-statement::t))
  (define std/db/postgresql#make-postgresql-statement
    (lambda _$args271056_
      (apply make-struct-instance
             std/db/postgresql#postgresql-statement::t
             _$args271056_)))
  (define std/db/postgresql#postgresql-statement-cols
    (make-struct-field-accessor std/db/postgresql#postgresql-statement::t '0))
  (define std/db/postgresql#postgresql-statement-params
    (make-struct-field-accessor std/db/postgresql#postgresql-statement::t '1))
  (define std/db/postgresql#postgresql-statement-bind
    (make-struct-field-accessor std/db/postgresql#postgresql-statement::t '2))
  (define std/db/postgresql#postgresql-statement-row
    (make-struct-field-accessor std/db/postgresql#postgresql-statement::t '3))
  (define std/db/postgresql#postgresql-statement-cols-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-statement::t '0))
  (define std/db/postgresql#postgresql-statement-params-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-statement::t '1))
  (define std/db/postgresql#postgresql-statement-bind-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-statement::t '2))
  (define std/db/postgresql#postgresql-statement-row-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-statement::t '3))
  (define std/db/postgresql#postgresql-statement:::init!__%
    (lambda (_g312551_
             _name271026271030_
             _params271027271032_
             _self271034_
             _conn271035_
             _cols271036_)
      (let* ((_name271038_
              (if (eq? _name271026271030_ absent-value)
                  std/db/postgresql#unnamed-command
                  _name271026271030_))
             (_params271040_
              (if (eq? _params271027271032_ absent-value)
                  '()
                  _params271027271032_)))
        (if (let ((__tmp312552
                   (let ()
                     (declare (not safe))
                     (##vector-length _self271034_))))
              (declare (not safe))
              (##fx< '8 __tmp312552))
            (begin
              (let ()
                (declare (not safe))
                (##vector-set! _self271034_ '1 _name271038_))
              (let ()
                (declare (not safe))
                (##vector-set! _self271034_ '2 _conn271035_))
              (let () (declare (not safe)) (##vector-set! _self271034_ '3 '#f))
              (let () (declare (not safe)) (##vector-set! _self271034_ '4 '()))
              (let () (declare (not safe)) (##vector-set! _self271034_ '5 '#f))
              (let () (declare (not safe)) (##vector-set! _self271034_ '6 '#f))
              (let ()
                (declare (not safe))
                (##vector-set! _self271034_ '7 _cols271036_))
              (let ()
                (declare (not safe))
                (##vector-set! _self271034_ '8 _params271040_)))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self271034_)))))
  (define std/db/postgresql#postgresql-statement:::init!__@
    (lambda (_keys271025271045_ . _args271047_)
      (apply std/db/postgresql#postgresql-statement:::init!__%
             _keys271025271045_
             (table-ref _keys271025271045_ 'name: absent-value)
             (table-ref _keys271025271045_ 'params: absent-value)
             _args271047_)))
  (define std/db/postgresql#postgresql-statement:::init!
    (lambda _args271028271053_
      (apply keyword-dispatch
             '#(name: params:)
             std/db/postgresql#postgresql-statement:::init!__@
             _args271028271053_)))
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   ':init!
   std/db/postgresql#postgresql-statement:::init!
   '#f)
  (define std/db/postgresql#postgresql-statement::query-row
    (lambda (_self270900_)
      (##direct-structure-ref
       _self270900_
       '10
       std/db/postgresql#postgresql-statement::t
       '#f)))
  (define std/db/postgresql#postgresql-statement::query-row::specialize
    (lambda (__t312462)
      (let* ((__class312463
              (struct-subtype?
               std/db/postgresql#postgresql-statement::t
               __t312462))
             (__specializer312464
              (lambda (_self270900_)
                (if __class312463
                    (let ()
                      (declare (not safe))
                      (##unchecked-structure-ref
                       _self270900_
                       '10
                       std/db/postgresql#postgresql-statement::t
                       '#f))
                    (error '"Type error; concrete type is not a subclass of expected type"
                           std/db/postgresql#postgresql-statement::t
                           _self270900_)))))
        (if __class312463
            std/db/postgresql#postgresql-statement::query-row::specialize::unchecked
            __specializer312464))))
  (define std/db/postgresql#postgresql-statement::query-row::specialize::unchecked
    (lambda (_self270900_)
      (let ()
        (declare (not safe))
        (##unchecked-structure-ref
         _self270900_
         '10
         std/db/postgresql#postgresql-statement::t
         '#f))))
  (bind-specializer!
   std/db/postgresql#postgresql-statement::query-row
   std/db/postgresql#postgresql-statement::query-row::specialize)
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   'query-row
   std/db/postgresql#postgresql-statement::query-row
   '#f)
  (define std/db/postgresql#postgresql-statement::columns
    (lambda (_self270776_)
      (map car
           (##direct-structure-ref
            _self270776_
            '7
            std/db/postgresql#postgresql-statement::t
            '#f))))
  (define std/db/postgresql#postgresql-statement::columns::specialize
    (lambda (__t312465)
      (let* ((__class312466
              (struct-subtype?
               std/db/postgresql#postgresql-statement::t
               __t312465))
             (__specializer312467
              (lambda (_self270776_)
                (map car
                     (if __class312466
                         (let ()
                           (declare (not safe))
                           (##unchecked-structure-ref
                            _self270776_
                            '7
                            std/db/postgresql#postgresql-statement::t
                            '#f))
                         (error '"Type error; concrete type is not a subclass of expected type"
                                std/db/postgresql#postgresql-statement::t
                                _self270776_))))))
        (if __class312466
            std/db/postgresql#postgresql-statement::columns::specialize::unchecked
            __specializer312467))))
  (define std/db/postgresql#postgresql-statement::columns::specialize::unchecked
    (lambda (_self270776_)
      (map car
           (let ()
             (declare (not safe))
             (##unchecked-structure-ref
              _self270776_
              '7
              std/db/postgresql#postgresql-statement::t
              '#f)))))
  (bind-specializer!
   std/db/postgresql#postgresql-statement::columns
   std/db/postgresql#postgresql-statement::columns::specialize)
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   'columns
   std/db/postgresql#postgresql-statement::columns
   '#f)
  (define std/db/postgresql#postgresql-statement::query-fini
    std/db/postgresql#postgresql-statement::reset)
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   'query-fini
   std/db/postgresql#postgresql-statement::query-fini
   '#f)
  (define std/db/postgresql#postgresql-statement-in-query?
    (lambda (_stmt270530_)
      (let ((__tmp312553
             (##structure-ref _stmt270530_ '1 std/db/dbi#statement::t '#f)))
        (declare (not safe))
        (##structure-direct-instance-of?
         __tmp312553
         'std/db/postgresql#!unnamed::t))))
  (define std/db/postgresql#postgresql-statement::query-start
    (lambda (_self270461_)
      (std/db/postgresql#wrap-notice-handler
       _self270461_
       (lambda ()
         (if (std/db/postgresql#postgresql-statement-in-query? _self270461_)
             '#!void
             (let* ((_self270463270477_ _self270461_)
                    (_E270465270481_
                     (lambda ()
                       (error '"No clause matching" _self270463270477_)))
                    (_K270466270494_
                     (lambda (_bind270484_ _conn270485_ _name270486_)
                       (let ((_g312554_
                              (std/db/postgresql-driver#postgresql-query!
                               _conn270485_
                               _name270486_
                               (let ((_$e270488_ _bind270484_))
                                 (if _$e270488_ _$e270488_ '())))))
                         (begin
                           (let ((_g312555_
                                  (let ()
                                    (declare (not safe))
                                    (if (##values? _g312554_)
                                        (##vector-length _g312554_)
                                        1))))
                             (if (not (let ()
                                        (declare (not safe))
                                        (##fx= _g312555_ 2)))
                                 (error "Context expects 2 values" _g312555_)))
                           (let ((_inp270491_
                                  (let ()
                                    (declare (not safe))
                                    (##vector-ref _g312554_ 0)))
                                 (_token270492_
                                  (let ()
                                    (declare (not safe))
                                    (##vector-ref _g312554_ 1))))
                             (begin
                               (##structure-set!
                                _self270461_
                                _token270492_
                                '6
                                std/db/postgresql#postgresql-command::t
                                '#f)
                               (##structure-set!
                                _self270461_
                                _inp270491_
                                '5
                                std/db/postgresql#postgresql-command::t
                                '#f)
                               (##direct-structure-set!
                                _self270461_
                                '#f
                                '10
                                std/db/postgresql#postgresql-statement::t
                                '#f))))))))
               (if (let ()
                     (declare (not safe))
                     (##structure-direct-instance-of?
                      _self270463270477_
                      'std/db/postgresql#postgresql-statement::t))
                   (let* ((_e270467270497_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270463270477_ '1)))
                          (_name270500_ _e270467270497_)
                          (_e270468270502_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270463270477_ '2)))
                          (_conn270505_ _e270468270502_)
                          (_e270469270507_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270463270477_ '3)))
                          (_e270470270510_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270463270477_ '4)))
                          (_e270471270513_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270463270477_ '5)))
                          (_e270472270516_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270463270477_ '6)))
                          (_e270473270519_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270463270477_ '7)))
                          (_e270474270522_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270463270477_ '8)))
                          (_e270475270525_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270463270477_ '9)))
                          (_bind270528_ _e270475270525_))
                     (_K270466270494_ _bind270528_ _conn270505_ _name270500_))
                   (_E270465270481_))))))))
  (define std/db/postgresql#postgresql-statement::query-start::specialize
    (lambda (__t312468)
      (let ((__class312469
             (struct-subtype?
              std/db/postgresql#postgresql-statement::t
              __t312468))
            (__class312470
             (struct-subtype?
              std/db/postgresql#postgresql-command::t
              __t312468)))
        (let ((__specializer312471
               (lambda (_self270461_)
                 (std/db/postgresql#wrap-notice-handler
                  _self270461_
                  (lambda ()
                    (if (std/db/postgresql#postgresql-statement-in-query?
                         _self270461_)
                        '#!void
                        (let* ((_self270463270477_ _self270461_)
                               (_E270465270481_
                                (lambda ()
                                  (error '"No clause matching"
                                         _self270463270477_)))
                               (_K270466270494_
                                (lambda (_bind270484_
                                         _conn270485_
                                         _name270486_)
                                  (let ((_g312556_
                                         (std/db/postgresql-driver#postgresql-query!
                                          _conn270485_
                                          _name270486_
                                          (let ((_$e270488_ _bind270484_))
                                            (if _$e270488_ _$e270488_ '())))))
                                    (begin
                                      (let ((_g312557_
                                             (let ()
                                               (declare (not safe))
                                               (if (##values? _g312556_)
                                                   (##vector-length _g312556_)
                                                   1))))
                                        (if (not (let ()
                                                   (declare (not safe))
                                                   (##fx= _g312557_ 2)))
                                            (error "Context expects 2 values"
                                                   _g312557_)))
                                      (let ((_inp270491_
                                             (let ()
                                               (declare (not safe))
                                               (##vector-ref _g312556_ 0)))
                                            (_token270492_
                                             (let ()
                                               (declare (not safe))
                                               (##vector-ref _g312556_ 1))))
                                        (begin
                                          (if __class312470
                                              (let ()
                                                (declare (not safe))
                                                (##unchecked-structure-set!
                                                 _self270461_
                                                 _token270492_
                                                 '6
                                                 std/db/postgresql#postgresql-command::t
                                                 '#f))
                                              (error '"Type error; concrete type is not a subclass of expected type"
                                                     std/db/postgresql#postgresql-command::t
                                                     _self270461_))
                                          (if __class312470
                                              (let ()
                                                (declare (not safe))
                                                (##unchecked-structure-set!
                                                 _self270461_
                                                 _inp270491_
                                                 '5
                                                 std/db/postgresql#postgresql-command::t
                                                 '#f))
                                              (error '"Type error; concrete type is not a subclass of expected type"
                                                     std/db/postgresql#postgresql-command::t
                                                     _self270461_))
                                          (if __class312469
                                              (let ()
                                                (declare (not safe))
                                                (##unchecked-structure-set!
                                                 _self270461_
                                                 '#f
                                                 '10
                                                 std/db/postgresql#postgresql-statement::t
                                                 '#f))
                                              (error '"Type error; concrete type is not a subclass of expected type"
                                                     std/db/postgresql#postgresql-statement::t
                                                     _self270461_)))))))))
                          (if (let ()
                                (declare (not safe))
                                (##structure-direct-instance-of?
                                 _self270463270477_
                                 'std/db/postgresql#postgresql-statement::t))
                              (let* ((_e270467270497_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _self270463270477_ '1)))
                                     (_name270500_ _e270467270497_)
                                     (_e270468270502_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _self270463270477_ '2)))
                                     (_conn270505_ _e270468270502_)
                                     (_e270469270507_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _self270463270477_ '3)))
                                     (_e270470270510_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _self270463270477_ '4)))
                                     (_e270471270513_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _self270463270477_ '5)))
                                     (_e270472270516_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _self270463270477_ '6)))
                                     (_e270473270519_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _self270463270477_ '7)))
                                     (_e270474270522_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _self270463270477_ '8)))
                                     (_e270475270525_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _self270463270477_ '9)))
                                     (_bind270528_ _e270475270525_))
                                (_K270466270494_
                                 _bind270528_
                                 _conn270505_
                                 _name270500_))
                              (_E270465270481_)))))))))
          (if __class312469
              (if __class312470
                  std/db/postgresql#postgresql-statement::query-start::specialize::unchecked
                  __specializer312471)
              __specializer312471)))))
  (define std/db/postgresql#postgresql-statement::query-start::specialize::unchecked
    (lambda (_self270461_)
      (std/db/postgresql#wrap-notice-handler
       _self270461_
       (lambda ()
         (if (std/db/postgresql#postgresql-statement-in-query? _self270461_)
             '#!void
             (let* ((_self270463270477_ _self270461_)
                    (_E270465270481_
                     (lambda ()
                       (error '"No clause matching" _self270463270477_)))
                    (_K270466270494_
                     (lambda (_bind270484_ _conn270485_ _name270486_)
                       (let ((_g312558_
                              (std/db/postgresql-driver#postgresql-query!
                               _conn270485_
                               _name270486_
                               (let ((_$e270488_ _bind270484_))
                                 (if _$e270488_ _$e270488_ '())))))
                         (begin
                           (let ((_g312559_
                                  (let ()
                                    (declare (not safe))
                                    (if (##values? _g312558_)
                                        (##vector-length _g312558_)
                                        1))))
                             (if (not (let ()
                                        (declare (not safe))
                                        (##fx= _g312559_ 2)))
                                 (error "Context expects 2 values" _g312559_)))
                           (let ((_inp270491_
                                  (let ()
                                    (declare (not safe))
                                    (##vector-ref _g312558_ 0)))
                                 (_token270492_
                                  (let ()
                                    (declare (not safe))
                                    (##vector-ref _g312558_ 1))))
                             (begin
                               (let ()
                                 (declare (not safe))
                                 (##unchecked-structure-set!
                                  _self270461_
                                  _token270492_
                                  '6
                                  std/db/postgresql#postgresql-command::t
                                  '#f))
                               (let ()
                                 (declare (not safe))
                                 (##unchecked-structure-set!
                                  _self270461_
                                  _inp270491_
                                  '5
                                  std/db/postgresql#postgresql-command::t
                                  '#f))
                               (let ()
                                 (declare (not safe))
                                 (##unchecked-structure-set!
                                  _self270461_
                                  '#f
                                  '10
                                  std/db/postgresql#postgresql-statement::t
                                  '#f)))))))))
               (if (let ()
                     (declare (not safe))
                     (##structure-direct-instance-of?
                      _self270463270477_
                      'std/db/postgresql#postgresql-statement::t))
                   (let* ((_e270467270497_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270463270477_ '1)))
                          (_name270500_ _e270467270497_)
                          (_e270468270502_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270463270477_ '2)))
                          (_conn270505_ _e270468270502_)
                          (_e270469270507_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270463270477_ '3)))
                          (_e270470270510_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270463270477_ '4)))
                          (_e270471270513_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270463270477_ '5)))
                          (_e270472270516_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270463270477_ '6)))
                          (_e270473270519_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270463270477_ '7)))
                          (_e270474270522_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270463270477_ '8)))
                          (_e270475270525_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _self270463270477_ '9)))
                          (_bind270528_ _e270475270525_))
                     (_K270466270494_ _bind270528_ _conn270505_ _name270500_))
                   (_E270465270481_))))))))
  (bind-specializer!
   std/db/postgresql#postgresql-statement::query-start
   std/db/postgresql#postgresql-statement::query-start::specialize)
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   'query-start
   std/db/postgresql#postgresql-statement::query-start
   '#f)
  (define std/db/postgresql#postgresql-statement::query-fetch
    (lambda (_self270299_)
      (letrec ((_result->row270301_
                (lambda (_cols270335_)
                  (let ((_res270337_
                         (map _result->value270302_
                              _cols270335_
                              (##direct-structure-ref
                               _self270299_
                               '7
                               std/db/postgresql#postgresql-statement::t
                               '#f))))
                    (if (null? _res270337_)
                        '#f
                        (if (null? (cdr _res270337_))
                            (car _res270337_)
                            (list->vector _res270337_))))))
               (_result->value270302_
                (lambda (_res270330_ _col270331_)
                  (if _res270330_
                      (let ((_type-oid270333_ (list-ref _col270331_ '3)))
                        (_value-e270303_ _res270330_ _type-oid270333_))
                      '#f)))
               (_value-e270303_
                (lambda (_res270320_ _type-oid270321_)
                  (let ((_$e270323_
                         (std/db/postgresql#catalog-deserializer
                          (std/db/postgresql#current-catalog)
                          _type-oid270321_)))
                    (if _$e270323_
                        ((lambda (_g270325270327_)
                           (_g270325270327_ _res270320_))
                         _$e270323_)
                        _res270320_)))))
        (let ((_$e270305_
               (##structure-ref
                _self270299_
                '5
                std/db/postgresql#postgresql-command::t
                '#f)))
          (if _$e270305_
              ((lambda (_inp270308_)
                 (let _again270310_ ()
                   (let ((_next270313_
                          (std/misc/channel#channel-get__0 _inp270308_)))
                     (if (or (eof-object? _next270313_)
                             (let ()
                               (declare (not safe))
                               (##structure-direct-instance-of?
                                _next270313_
                                'std/db/postgresql-driver#postgresql-CommandComplete::t)))
                         (begin
                           (if (let ()
                                 (declare (not safe))
                                 (##structure-direct-instance-of?
                                  _next270313_
                                  'std/db/postgresql-driver#postgresql-CommandComplete::t))
                               (##structure-set!
                                _self270299_
                                (##structure-ref
                                 _next270313_
                                 '2
                                 std/db/postgresql-driver#postgresql-message::t
                                 '#f)
                                '3
                                std/db/postgresql#postgresql-command::t
                                '#f)
                               '#!void)
                           (##structure-set!
                            _self270299_
                            '#f
                            '6
                            std/db/postgresql#postgresql-command::t
                            '#f)
                           (##structure-set!
                            _self270299_
                            '#f
                            '5
                            std/db/postgresql#postgresql-command::t
                            '#f)
                           (##direct-structure-set!
                            _self270299_
                            '#f
                            '10
                            std/db/postgresql#postgresql-statement::t
                            '#f)
                           std/iter#iter-end)
                         (if (exception? _next270313_)
                             (raise _next270313_)
                             (if (let ()
                                   (declare (not safe))
                                   (##structure-direct-instance-of?
                                    _next270313_
                                    'std/actor/proto#!token::t))
                                 (begin
                                   (std/db/postgresql-driver#postgresql-continue!
                                    (##structure-ref
                                     _self270299_
                                     '2
                                     std/db/postgresql#postgresql-command::t
                                     '#f)
                                    _next270313_)
                                   (_again270310_))
                                 (let ((_row270318_
                                        (_result->row270301_ _next270313_)))
                                   (##direct-structure-set!
                                    _self270299_
                                    _row270318_
                                    '10
                                    std/db/postgresql#postgresql-statement::t
                                    '#f)
                                   '#!void)))))))
               _$e270305_)
              std/iter#iter-end)))))
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   'query-fetch
   std/db/postgresql#postgresql-statement::query-fetch
   '#f)
  (define std/db/postgresql#postgresql-connection::prepare
    (lambda (_self270168_ _sql270169_)
      (let* ((_name270171_ (symbol->string (gensym 'stmt)))
             (_g312560_
              (std/db/postgresql-driver#postgresql-prepare-statement!
               _self270168_
               _name270171_
               _sql270169_)))
        (begin
          (let ((_g312561_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g312560_) (##vector-length _g312560_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g312561_ 2)))
                (error "Context expects 2 values" _g312561_)))
          (let ((_params270173_
                 (let () (declare (not safe)) (##vector-ref _g312560_ 0)))
                (_cols270174_
                 (let () (declare (not safe)) (##vector-ref _g312560_ 1))))
            (let ()
              (let ((__obj312540
                     (make-object
                      std/db/postgresql#postgresql-statement::t
                      '10)))
                (std/db/postgresql#postgresql-statement:::init!__%
                 '#f
                 _name270171_
                 _params270173_
                 __obj312540
                 _self270168_
                 _cols270174_)
                __obj312540)))))))
  (bind-method!
   std/db/postgresql#postgresql-connection::t
   'prepare
   std/db/postgresql#postgresql-connection::prepare
   '#f)
  (define std/db/postgresql#postgresql-statement::bind
    (lambda (_self270026_ . _args270027_)
      (letrec ((_value->binding270029_
                (lambda (_type-oid270036_ _arg270037_)
                  (if (not _arg270037_)
                      (if (fx= _type-oid270036_ '16)
                          (std/db/postgresql#serialize-boolean _arg270037_)
                          '#f)
                      (if (string? _arg270037_)
                          _arg270037_
                          (let ((_$e270039_
                                 (std/db/postgresql#catalog-serializer
                                  (std/db/postgresql#current-catalog)
                                  _type-oid270036_)))
                            (if _$e270039_
                                ((lambda (_g270041270043_)
                                   (_g270041270043_ _arg270037_))
                                 _$e270039_)
                                (error '"Cannot bind; Parameter type oid not in (current-catalog)"
                                       _type-oid270036_
                                       _arg270037_))))))))
        (let* ((_params270031_
                (##direct-structure-ref
                 _self270026_
                 '8
                 std/db/postgresql#postgresql-statement::t
                 '#f))
               (_bind270033_
                (map _value->binding270029_ _params270031_ _args270027_)))
          (##direct-structure-set!
           _self270026_
           _bind270033_
           '9
           std/db/postgresql#postgresql-statement::t
           '#f)
          '#!void))))
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   'bind
   std/db/postgresql#postgresql-statement::bind
   '#f)
  (define std/db/postgresql#postgresql-statement::clear
    (lambda (_self269902_)
      (##direct-structure-set!
       _self269902_
       '#f
       '9
       std/db/postgresql#postgresql-statement::t
       '#f)))
  (define std/db/postgresql#postgresql-statement::clear::specialize
    (lambda (__t312472)
      (let* ((__class312473
              (struct-subtype?
               std/db/postgresql#postgresql-statement::t
               __t312472))
             (__specializer312474
              (lambda (_self269902_)
                (if __class312473
                    (let ()
                      (declare (not safe))
                      (##unchecked-structure-set!
                       _self269902_
                       '#f
                       '9
                       std/db/postgresql#postgresql-statement::t
                       '#f))
                    (error '"Type error; concrete type is not a subclass of expected type"
                           std/db/postgresql#postgresql-statement::t
                           _self269902_)))))
        (if __class312473
            std/db/postgresql#postgresql-statement::clear::specialize::unchecked
            __specializer312474))))
  (define std/db/postgresql#postgresql-statement::clear::specialize::unchecked
    (lambda (_self269902_)
      (let ()
        (declare (not safe))
        (##unchecked-structure-set!
         _self269902_
         '#f
         '9
         std/db/postgresql#postgresql-statement::t
         '#f))))
  (bind-specializer!
   std/db/postgresql#postgresql-statement::clear
   std/db/postgresql#postgresql-statement::clear::specialize)
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   'clear
   std/db/postgresql#postgresql-statement::clear
   '#f)
  (define std/db/postgresql#postgresql-statement::exec
    (lambda (_self269709_)
      (let* ((_self269710269724_ _self269709_)
             (_E269712269728_
              (lambda () (error '"No clause matching" _self269710269724_)))
             (_K269713269744_
              (lambda (_bind269731_ _conn269732_ _name269733_)
                (std/db/postgresql#wrap-notice-handler
                 _self269709_
                 (lambda ()
                   (let* ((_comp269739_
                           (std/db/postgresql-driver#postgresql-exec!
                            _conn269732_
                            _name269733_
                            (let ((_$e269736_ _bind269731_))
                              (if _$e269736_ _$e269736_ '()))))
                          (_$r269741_ _comp269739_))
                     (##structure-set!
                      _self269709_
                      _comp269739_
                      '3
                      std/db/postgresql#postgresql-command::t
                      '#f)
                     _$r269741_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _self269710269724_
               'std/db/postgresql#postgresql-statement::t))
            (let* ((_e269714269747_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269710269724_ '1)))
                   (_name269750_ _e269714269747_)
                   (_e269715269752_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269710269724_ '2)))
                   (_conn269755_ _e269715269752_)
                   (_e269716269757_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269710269724_ '3)))
                   (_e269717269760_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269710269724_ '4)))
                   (_e269718269763_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269710269724_ '5)))
                   (_e269719269766_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269710269724_ '6)))
                   (_e269720269769_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269710269724_ '7)))
                   (_e269721269772_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269710269724_ '8)))
                   (_e269722269775_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269710269724_ '9)))
                   (_bind269778_ _e269722269775_))
              (_K269713269744_ _bind269778_ _conn269755_ _name269750_))
            (_E269712269728_)))))
  (define std/db/postgresql#postgresql-statement::exec::specialize
    (lambda (__t312475)
      (let* ((__class312476
              (struct-subtype?
               std/db/postgresql#postgresql-command::t
               __t312475))
             (__specializer312477
              (lambda (_self269709_)
                (let* ((_self269710269724_ _self269709_)
                       (_E269712269728_
                        (lambda ()
                          (error '"No clause matching" _self269710269724_)))
                       (_K269713269744_
                        (lambda (_bind269731_ _conn269732_ _name269733_)
                          (std/db/postgresql#wrap-notice-handler
                           _self269709_
                           (lambda ()
                             (let* ((_comp269739_
                                     (std/db/postgresql-driver#postgresql-exec!
                                      _conn269732_
                                      _name269733_
                                      (let ((_$e269736_ _bind269731_))
                                        (if _$e269736_ _$e269736_ '()))))
                                    (_$r269741_ _comp269739_))
                               (if __class312476
                                   (let ()
                                     (declare (not safe))
                                     (##unchecked-structure-set!
                                      _self269709_
                                      _comp269739_
                                      '3
                                      std/db/postgresql#postgresql-command::t
                                      '#f))
                                   (error '"Type error; concrete type is not a subclass of expected type"
                                          std/db/postgresql#postgresql-command::t
                                          _self269709_))
                               _$r269741_))))))
                  (if (let ()
                        (declare (not safe))
                        (##structure-direct-instance-of?
                         _self269710269724_
                         'std/db/postgresql#postgresql-statement::t))
                      (let* ((_e269714269747_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269710269724_ '1)))
                             (_name269750_ _e269714269747_)
                             (_e269715269752_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269710269724_ '2)))
                             (_conn269755_ _e269715269752_)
                             (_e269716269757_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269710269724_ '3)))
                             (_e269717269760_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269710269724_ '4)))
                             (_e269718269763_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269710269724_ '5)))
                             (_e269719269766_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269710269724_ '6)))
                             (_e269720269769_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269710269724_ '7)))
                             (_e269721269772_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269710269724_ '8)))
                             (_e269722269775_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269710269724_ '9)))
                             (_bind269778_ _e269722269775_))
                        (_K269713269744_
                         _bind269778_
                         _conn269755_
                         _name269750_))
                      (_E269712269728_))))))
        (if __class312476
            std/db/postgresql#postgresql-statement::exec::specialize::unchecked
            __specializer312477))))
  (define std/db/postgresql#postgresql-statement::exec::specialize::unchecked
    (lambda (_self269709_)
      (let* ((_self269710269724_ _self269709_)
             (_E269712269728_
              (lambda () (error '"No clause matching" _self269710269724_)))
             (_K269713269744_
              (lambda (_bind269731_ _conn269732_ _name269733_)
                (std/db/postgresql#wrap-notice-handler
                 _self269709_
                 (lambda ()
                   (let* ((_comp269739_
                           (std/db/postgresql-driver#postgresql-exec!
                            _conn269732_
                            _name269733_
                            (let ((_$e269736_ _bind269731_))
                              (if _$e269736_ _$e269736_ '()))))
                          (_$r269741_ _comp269739_))
                     (let ()
                       (declare (not safe))
                       (##unchecked-structure-set!
                        _self269709_
                        _comp269739_
                        '3
                        std/db/postgresql#postgresql-command::t
                        '#f))
                     _$r269741_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _self269710269724_
               'std/db/postgresql#postgresql-statement::t))
            (let* ((_e269714269747_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269710269724_ '1)))
                   (_name269750_ _e269714269747_)
                   (_e269715269752_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269710269724_ '2)))
                   (_conn269755_ _e269715269752_)
                   (_e269716269757_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269710269724_ '3)))
                   (_e269717269760_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269710269724_ '4)))
                   (_e269718269763_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269710269724_ '5)))
                   (_e269719269766_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269710269724_ '6)))
                   (_e269720269769_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269710269724_ '7)))
                   (_e269721269772_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269710269724_ '8)))
                   (_e269722269775_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269710269724_ '9)))
                   (_bind269778_ _e269722269775_))
              (_K269713269744_ _bind269778_ _conn269755_ _name269750_))
            (_E269712269728_)))))
  (bind-specializer!
   std/db/postgresql#postgresql-statement::exec
   std/db/postgresql#postgresql-statement::exec::specialize)
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   'exec
   std/db/postgresql#postgresql-statement::exec
   '#f)
  (define std/db/postgresql#postgresql-statement::finalize
    (lambda (_self269556_)
      (let* ((_self269557269564_ _self269556_)
             (_E269559269568_
              (lambda () (error '"No clause matching" _self269557269564_)))
             (_K269560269574_
              (lambda (_conn269571_ _name269572_)
                (std/db/postgresql#postgresql-statement::reset _self269556_)
                (##structure-set!
                 _self269556_
                 '#f
                 '3
                 std/db/postgresql#postgresql-command::t
                 '#f)
                (std/db/postgresql-driver#postgresql-close-statement!
                 _conn269571_
                 _name269572_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _self269557269564_
               'std/db/postgresql#postgresql-statement::t))
            (let* ((_e269561269577_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269557269564_ '1)))
                   (_name269580_ _e269561269577_)
                   (_e269562269582_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269557269564_ '2)))
                   (_conn269585_ _e269562269582_))
              (_K269560269574_ _conn269585_ _name269580_))
            (_E269559269568_)))))
  (define std/db/postgresql#postgresql-statement::finalize::specialize
    (lambda (__t312478)
      (let* ((__class312479
              (struct-subtype?
               std/db/postgresql#postgresql-command::t
               __t312478))
             (__specializer312480
              (lambda (_self269556_)
                (let* ((_self269557269564_ _self269556_)
                       (_E269559269568_
                        (lambda ()
                          (error '"No clause matching" _self269557269564_)))
                       (_K269560269574_
                        (lambda (_conn269571_ _name269572_)
                          (std/db/postgresql#postgresql-statement::reset
                           _self269556_)
                          (if __class312479
                              (let ()
                                (declare (not safe))
                                (##unchecked-structure-set!
                                 _self269556_
                                 '#f
                                 '3
                                 std/db/postgresql#postgresql-command::t
                                 '#f))
                              (error '"Type error; concrete type is not a subclass of expected type"
                                     std/db/postgresql#postgresql-command::t
                                     _self269556_))
                          (std/db/postgresql-driver#postgresql-close-statement!
                           _conn269571_
                           _name269572_))))
                  (if (let ()
                        (declare (not safe))
                        (##structure-direct-instance-of?
                         _self269557269564_
                         'std/db/postgresql#postgresql-statement::t))
                      (let* ((_e269561269577_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269557269564_ '1)))
                             (_name269580_ _e269561269577_)
                             (_e269562269582_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _self269557269564_ '2)))
                             (_conn269585_ _e269562269582_))
                        (_K269560269574_ _conn269585_ _name269580_))
                      (_E269559269568_))))))
        (if __class312479
            std/db/postgresql#postgresql-statement::finalize::specialize::unchecked
            __specializer312480))))
  (define std/db/postgresql#postgresql-statement::finalize::specialize::unchecked
    (lambda (_self269556_)
      (let* ((_self269557269564_ _self269556_)
             (_E269559269568_
              (lambda () (error '"No clause matching" _self269557269564_)))
             (_K269560269574_
              (lambda (_conn269571_ _name269572_)
                (std/db/postgresql#postgresql-statement::reset _self269556_)
                (let ()
                  (declare (not safe))
                  (##unchecked-structure-set!
                   _self269556_
                   '#f
                   '3
                   std/db/postgresql#postgresql-command::t
                   '#f))
                (std/db/postgresql-driver#postgresql-close-statement!
                 _conn269571_
                 _name269572_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _self269557269564_
               'std/db/postgresql#postgresql-statement::t))
            (let* ((_e269561269577_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269557269564_ '1)))
                   (_name269580_ _e269561269577_)
                   (_e269562269582_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self269557269564_ '2)))
                   (_conn269585_ _e269562269582_))
              (_K269560269574_ _conn269585_ _name269580_))
            (_E269559269568_)))))
  (bind-specializer!
   std/db/postgresql#postgresql-statement::finalize
   std/db/postgresql#postgresql-statement::finalize::specialize)
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   'finalize
   std/db/postgresql#postgresql-statement::finalize
   '#f)
  (define std/db/postgresql#postgresql-statement::reset
    (lambda (_self269432_)
      (std/db/postgresql#postgresql-command::reset _self269432_)
      (##direct-structure-set!
       _self269432_
       '#f
       '10
       std/db/postgresql#postgresql-statement::t
       '#f)))
  (define std/db/postgresql#postgresql-statement::reset::specialize
    (lambda (__t312481)
      (let* ((__class312482
              (struct-subtype?
               std/db/postgresql#postgresql-statement::t
               __t312481))
             (__specializer312483
              (lambda (_self269432_)
                (std/db/postgresql#postgresql-command::reset _self269432_)
                (if __class312482
                    (let ()
                      (declare (not safe))
                      (##unchecked-structure-set!
                       _self269432_
                       '#f
                       '10
                       std/db/postgresql#postgresql-statement::t
                       '#f))
                    (error '"Type error; concrete type is not a subclass of expected type"
                           std/db/postgresql#postgresql-statement::t
                           _self269432_)))))
        (if __class312482
            std/db/postgresql#postgresql-statement::reset::specialize::unchecked
            __specializer312483))))
  (define std/db/postgresql#postgresql-statement::reset::specialize::unchecked
    (lambda (_self269432_)
      (std/db/postgresql#postgresql-command::reset _self269432_)
      (let ()
        (declare (not safe))
        (##unchecked-structure-set!
         _self269432_
         '#f
         '10
         std/db/postgresql#postgresql-statement::t
         '#f))))
  (bind-specializer!
   std/db/postgresql#postgresql-statement::reset
   std/db/postgresql#postgresql-statement::reset::specialize)
  (bind-method!
   std/db/postgresql#postgresql-statement::t
   'reset
   std/db/postgresql#postgresql-statement::reset
   '#f)
  (define std/db/postgresql#postgresql-query::t
    (make-struct-type
     'std/db/postgresql#postgresql-query::t
     std/db/postgresql#postgresql-command::t
     '3
     'postgresql-query
     '((print: greedy str) (final: . #t))
     ':init!
     '(str cmd greedy)))
  (define std/db/postgresql#postgresql-query?
    (make-struct-predicate std/db/postgresql#postgresql-query::t))
  (define std/db/postgresql#make-postgresql-query
    (lambda _$args269307_
      (apply make-struct-instance
             std/db/postgresql#postgresql-query::t
             _$args269307_)))
  (define std/db/postgresql#postgresql-query-str
    (make-struct-field-accessor std/db/postgresql#postgresql-query::t '0))
  (define std/db/postgresql#postgresql-query-cmd
    (make-struct-field-accessor std/db/postgresql#postgresql-query::t '1))
  (define std/db/postgresql#postgresql-query-greedy
    (make-struct-field-accessor std/db/postgresql#postgresql-query::t '2))
  (define std/db/postgresql#postgresql-query-str-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-query::t '0))
  (define std/db/postgresql#postgresql-query-cmd-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-query::t '1))
  (define std/db/postgresql#postgresql-query-greedy-set!
    (make-struct-field-mutator std/db/postgresql#postgresql-query::t '2))
  (define std/db/postgresql#postgresql-query:::init!__%
    (lambda (_g312562_
             _greedy269282269285_
             _self269287_
             _conn269288_
             _str269289_)
      (let ((_greedy269291_
             (if (eq? _greedy269282269285_ absent-value)
                 '#t
                 _greedy269282269285_)))
        (if (let ((__tmp312563
                   (let ()
                     (declare (not safe))
                     (##vector-length _self269287_))))
              (declare (not safe))
              (##fx< '9 __tmp312563))
            (begin
              (let ()
                (declare (not safe))
                (##vector-set!
                 _self269287_
                 '1
                 std/db/postgresql#unnamed-command))
              (let ()
                (declare (not safe))
                (##vector-set! _self269287_ '2 _conn269288_))
              (let () (declare (not safe)) (##vector-set! _self269287_ '3 '#f))
              (let () (declare (not safe)) (##vector-set! _self269287_ '4 '()))
              (let () (declare (not safe)) (##vector-set! _self269287_ '5 '#f))
              (let () (declare (not safe)) (##vector-set! _self269287_ '6 '#f))
              (let ()
                (declare (not safe))
                (##vector-set! _self269287_ '7 _str269289_))
              (let () (declare (not safe)) (##vector-set! _self269287_ '8 '#f))
              (let ()
                (declare (not safe))
                (##vector-set! _self269287_ '9 _greedy269291_)))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self269287_)))))
  (define std/db/postgresql#postgresql-query:::init!__@
    (lambda (_keys269281269296_ . _args269298_)
      (apply std/db/postgresql#postgresql-query:::init!__%
             _keys269281269296_
             (table-ref _keys269281269296_ 'greedy: absent-value)
             _args269298_)))
  (define std/db/postgresql#postgresql-query:::init!
    (lambda _args269283269304_
      (apply keyword-dispatch
             '#(greedy:)
             std/db/postgresql#postgresql-query:::init!__@
             _args269283269304_)))
  (bind-method!
   std/db/postgresql#postgresql-query::t
   ':init!
   std/db/postgresql#postgresql-query:::init!
   '#f)
  (define std/db/postgresql#postgresql-query::exec
    (lambda (_self269103_)
      (std/db/postgresql#postgresql-query::query-start _self269103_)
      (std/db/postgresql#wrap-notice-handler
       _self269103_
       (lambda ()
         (let* ((_self269105269117_ _self269103_)
                (_E269107269121_
                 (lambda () (error '"No clause matching" _self269105269117_)))
                (_K269108269128_
                 (lambda (_str269124_ _token269125_ _conn269126_)
                   (std/db/postgresql-driver#postgresql-reset!
                    _conn269126_
                    _token269125_))))
           (if (let ()
                 (declare (not safe))
                 (##structure-direct-instance-of?
                  _self269105269117_
                  'std/db/postgresql#postgresql-query::t))
               (let* ((_e269109269131_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self269105269117_ '1)))
                      (_e269110269134_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self269105269117_ '2)))
                      (_conn269137_ _e269110269134_)
                      (_e269111269139_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self269105269117_ '3)))
                      (_e269112269142_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self269105269117_ '4)))
                      (_e269113269145_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self269105269117_ '5)))
                      (_e269114269148_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self269105269117_ '6)))
                      (_token269151_ _e269114269148_)
                      (_e269115269153_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self269105269117_ '7)))
                      (_str269156_ _e269115269153_))
                 (_K269108269128_ _str269156_ _token269151_ _conn269137_))
               (_E269107269121_)))))))
  (bind-method!
   std/db/postgresql#postgresql-query::t
   'exec
   std/db/postgresql#postgresql-query::exec
   '#f)
  (define std/db/postgresql#postgresql-query::query-row
    std/db/postgresql#postgresql-query-cmd)
  (bind-method!
   std/db/postgresql#postgresql-query::t
   'query-row
   std/db/postgresql#postgresql-query::query-row
   '#f)
  (define std/db/postgresql#postgresql-query::query-start
    (lambda (_self268804_)
      (std/db/postgresql#wrap-notice-handler
       _self268804_
       (lambda ()
         (let* ((_self268806268818_ _self268804_)
                (_E268808268822_
                 (lambda () (error '"No clause matching" _self268806268818_)))
                (_K268809268831_
                 (lambda (_str268825_ _conn268826_)
                   (let ((_g312564_
                          (std/db/postgresql-driver#postgresql-simple-query!
                           _conn268826_
                           _str268825_)))
                     (begin
                       (let ((_g312565_
                              (let ()
                                (declare (not safe))
                                (if (##values? _g312564_)
                                    (##vector-length _g312564_)
                                    1))))
                         (if (not (let ()
                                    (declare (not safe))
                                    (##fx= _g312565_ 2)))
                             (error "Context expects 2 values" _g312565_)))
                       (let ((_inp268828_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _g312564_ 0)))
                             (_token268829_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _g312564_ 1))))
                         (begin
                           (##structure-set!
                            _self268804_
                            _token268829_
                            '6
                            std/db/postgresql#postgresql-command::t
                            '#f)
                           (##structure-set!
                            _self268804_
                            _inp268828_
                            '5
                            std/db/postgresql#postgresql-command::t
                            '#f))))))))
           (if (let ()
                 (declare (not safe))
                 (##structure-direct-instance-of?
                  _self268806268818_
                  'std/db/postgresql#postgresql-query::t))
               (let* ((_e268810268834_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268806268818_ '1)))
                      (_e268811268837_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268806268818_ '2)))
                      (_conn268840_ _e268811268837_)
                      (_e268812268842_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268806268818_ '3)))
                      (_e268813268845_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268806268818_ '4)))
                      (_e268814268848_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268806268818_ '5)))
                      (_e268815268851_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268806268818_ '6)))
                      (_e268816268854_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268806268818_ '7)))
                      (_str268857_ _e268816268854_))
                 (_K268809268831_ _str268857_ _conn268840_))
               (_E268808268822_)))))))
  (define std/db/postgresql#postgresql-query::query-start::specialize
    (lambda (__t312484)
      (let* ((__class312485
              (struct-subtype?
               std/db/postgresql#postgresql-command::t
               __t312484))
             (__specializer312486
              (lambda (_self268804_)
                (std/db/postgresql#wrap-notice-handler
                 _self268804_
                 (lambda ()
                   (let* ((_self268806268818_ _self268804_)
                          (_E268808268822_
                           (lambda ()
                             (error '"No clause matching" _self268806268818_)))
                          (_K268809268831_
                           (lambda (_str268825_ _conn268826_)
                             (let ((_g312566_
                                    (std/db/postgresql-driver#postgresql-simple-query!
                                     _conn268826_
                                     _str268825_)))
                               (begin
                                 (let ((_g312567_
                                        (let ()
                                          (declare (not safe))
                                          (if (##values? _g312566_)
                                              (##vector-length _g312566_)
                                              1))))
                                   (if (not (let ()
                                              (declare (not safe))
                                              (##fx= _g312567_ 2)))
                                       (error "Context expects 2 values"
                                              _g312567_)))
                                 (let ((_inp268828_
                                        (let ()
                                          (declare (not safe))
                                          (##vector-ref _g312566_ 0)))
                                       (_token268829_
                                        (let ()
                                          (declare (not safe))
                                          (##vector-ref _g312566_ 1))))
                                   (begin
                                     (if __class312485
                                         (let ()
                                           (declare (not safe))
                                           (##unchecked-structure-set!
                                            _self268804_
                                            _token268829_
                                            '6
                                            std/db/postgresql#postgresql-command::t
                                            '#f))
                                         (error '"Type error; concrete type is not a subclass of expected type"
                                                std/db/postgresql#postgresql-command::t
                                                _self268804_))
                                     (if __class312485
                                         (let ()
                                           (declare (not safe))
                                           (##unchecked-structure-set!
                                            _self268804_
                                            _inp268828_
                                            '5
                                            std/db/postgresql#postgresql-command::t
                                            '#f))
                                         (error '"Type error; concrete type is not a subclass of expected type"
                                                std/db/postgresql#postgresql-command::t
                                                _self268804_)))))))))
                     (if (let ()
                           (declare (not safe))
                           (##structure-direct-instance-of?
                            _self268806268818_
                            'std/db/postgresql#postgresql-query::t))
                         (let* ((_e268810268834_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _self268806268818_ '1)))
                                (_e268811268837_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _self268806268818_ '2)))
                                (_conn268840_ _e268811268837_)
                                (_e268812268842_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _self268806268818_ '3)))
                                (_e268813268845_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _self268806268818_ '4)))
                                (_e268814268848_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _self268806268818_ '5)))
                                (_e268815268851_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _self268806268818_ '6)))
                                (_e268816268854_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _self268806268818_ '7)))
                                (_str268857_ _e268816268854_))
                           (_K268809268831_ _str268857_ _conn268840_))
                         (_E268808268822_))))))))
        (if __class312485
            std/db/postgresql#postgresql-query::query-start::specialize::unchecked
            __specializer312486))))
  (define std/db/postgresql#postgresql-query::query-start::specialize::unchecked
    (lambda (_self268804_)
      (std/db/postgresql#wrap-notice-handler
       _self268804_
       (lambda ()
         (let* ((_self268806268818_ _self268804_)
                (_E268808268822_
                 (lambda () (error '"No clause matching" _self268806268818_)))
                (_K268809268831_
                 (lambda (_str268825_ _conn268826_)
                   (let ((_g312568_
                          (std/db/postgresql-driver#postgresql-simple-query!
                           _conn268826_
                           _str268825_)))
                     (begin
                       (let ((_g312569_
                              (let ()
                                (declare (not safe))
                                (if (##values? _g312568_)
                                    (##vector-length _g312568_)
                                    1))))
                         (if (not (let ()
                                    (declare (not safe))
                                    (##fx= _g312569_ 2)))
                             (error "Context expects 2 values" _g312569_)))
                       (let ((_inp268828_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _g312568_ 0)))
                             (_token268829_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _g312568_ 1))))
                         (begin
                           (let ()
                             (declare (not safe))
                             (##unchecked-structure-set!
                              _self268804_
                              _token268829_
                              '6
                              std/db/postgresql#postgresql-command::t
                              '#f))
                           (let ()
                             (declare (not safe))
                             (##unchecked-structure-set!
                              _self268804_
                              _inp268828_
                              '5
                              std/db/postgresql#postgresql-command::t
                              '#f)))))))))
           (if (let ()
                 (declare (not safe))
                 (##structure-direct-instance-of?
                  _self268806268818_
                  'std/db/postgresql#postgresql-query::t))
               (let* ((_e268810268834_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268806268818_ '1)))
                      (_e268811268837_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268806268818_ '2)))
                      (_conn268840_ _e268811268837_)
                      (_e268812268842_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268806268818_ '3)))
                      (_e268813268845_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268806268818_ '4)))
                      (_e268814268848_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268806268818_ '5)))
                      (_e268815268851_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268806268818_ '6)))
                      (_e268816268854_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _self268806268818_ '7)))
                      (_str268857_ _e268816268854_))
                 (_K268809268831_ _str268857_ _conn268840_))
               (_E268808268822_)))))))
  (bind-specializer!
   std/db/postgresql#postgresql-query::query-start
   std/db/postgresql#postgresql-query::query-start::specialize)
  (bind-method!
   std/db/postgresql#postgresql-query::t
   'query-start
   std/db/postgresql#postgresql-query::query-start
   '#f)
  (define std/db/postgresql#postgresql-query::query-fetch
    (lambda (_self268599_)
      (letrec* ((_greedy-in268601_ '#f))
        (std/db/postgresql#wrap-notice-handler
         _self268599_
         (lambda ()
           (let* ((_self268603268617_ _self268599_)
                  (_E268605268621_
                   (lambda ()
                     (error '"No clause matching" _self268603268617_)))
                  (_K268606268642_
                   (lambda (_greedy268624_
                            _cmd268625_
                            _token268626_
                            _inp268627_
                            _conn268628_)
                     (if (not _inp268627_)
                         std/iter#iter-end
                         (let _again268630_ ()
                           (let ((_next268633_
                                  (std/misc/channel#channel-get__0
                                   _inp268627_)))
                             (if (eof-object? _next268633_)
                                 (begin
                                   (##structure-set!
                                    _self268599_
                                    '#f
                                    '6
                                    std/db/postgresql#postgresql-command::t
                                    '#f)
                                   (##structure-set!
                                    _self268599_
                                    '#f
                                    '5
                                    std/db/postgresql#postgresql-command::t
                                    '#f)
                                   (##structure-set!
                                    _self268599_
                                    '#t
                                    '3
                                    std/db/postgresql#postgresql-command::t
                                    '#f)
                                   std/iter#iter-end)
                                 (if (exception? _next268633_)
                                     (raise _next268633_)
                                     (if (let ()
                                           (declare (not safe))
                                           (##structure-direct-instance-of?
                                            _next268633_
                                            'std/actor/proto#!token::t))
                                         (begin
                                           (std/db/postgresql-driver#postgresql-continue!
                                            (##structure-ref
                                             _self268599_
                                             '2
                                             std/db/postgresql#postgresql-command::t
                                             '#f)
                                            _next268633_)
                                           (_again268630_))
                                         (if (let ()
                                               (declare (not safe))
                                               (##structure-direct-instance-of?
                                                _next268633_
                                                'std/db/postgresql-driver#postgresql-CommandComplete::t))
                                             (let ((_comp268635_
                                                    (##structure-ref
                                                     _next268633_
                                                     '2
                                                     std/db/postgresql-driver#postgresql-message::t
                                                     '#f)))
                                               (if (and _cmd268625_
                                                        (not _greedy268624_))
                                                   (##structure-set!
                                                    _cmd268625_
                                                    '#f
                                                    '5
                                                    std/db/postgresql#postgresql-command::t
                                                    '#f)
                                                   '#!void)
                                               (if _greedy-in268601_
                                                   (begin
                                                     (std/misc/channel#channel-sync
                                                      _greedy-in268601_
                                                      _next268633_)
                                                     (set! _greedy-in268601_
                                                           '#f))
                                                   '#!void)
                                               (if (or (not _cmd268625_)
                                                       (##structure-ref
                                                        _cmd268625_
                                                        '3
                                                        std/db/postgresql#postgresql-command::t
                                                        '#f))
                                                   (##direct-structure-set!
                                                    _self268599_
                                                    (let ((__obj312541
                                                           (make-object
                                                            std/db/postgresql#postgresql-command::t
                                                            '6)))
                                                      (std/db/postgresql#postgresql-command:::init!__%
                                                       '#f
                                                       absent-value
                                                       _comp268635_
                                                       __obj312541
                                                       _conn268628_)
                                                      __obj312541)
                                                    '8
                                                    std/db/postgresql#postgresql-query::t
                                                    '#f)
                                                   (##structure-set!
                                                    _cmd268625_
                                                    _comp268635_
                                                    '3
                                                    std/db/postgresql#postgresql-command::t
                                                    '#f))
                                               (if (not _greedy268624_)
                                                   (begin
                                                     (##direct-structure-set!
                                                      _self268599_
                                                      '#f
                                                      '8
                                                      std/db/postgresql#postgresql-query::t
                                                      '#f)
                                                     (set! _cmd268625_ '#f)
                                                     (_again268630_))
                                                   '#!void))
                                             (if (let ()
                                                   (declare (not safe))
                                                   (##structure-direct-instance-of?
                                                    _next268633_
                                                    'std/db/postgresql-driver#postgresql-RowDescription::t))
                                                 (let ((_stmt268640_
                                                        (let ((__obj312542
                                                               (make-object
                                                                std/db/postgresql#postgresql-statement::t
                                                                '10)))
                                                          (std/db/postgresql#postgresql-statement:::init!__%
                                                           '#f
                                                           absent-value
                                                           absent-value
                                                           __obj312542
                                                           _conn268628_
                                                           (##structure-ref
                                                            _next268633_
                                                            '2
                                                            std/db/postgresql-driver#postgresql-message::t
                                                            '#f))
                                                          __obj312542)))
                                                   (##direct-structure-set!
                                                    _self268599_
                                                    _stmt268640_
                                                    '8
                                                    std/db/postgresql#postgresql-query::t
                                                    '#f)
                                                   (set! _cmd268625_
                                                         _stmt268640_)
                                                   (if (not _greedy268624_)
                                                       (begin
                                                         (##structure-set!
                                                          _stmt268640_
                                                          _inp268627_
                                                          '5
                                                          std/db/postgresql#postgresql-command::t
                                                          '#f)
                                                         '#!void)
                                                       (begin
                                                         (set! _greedy-in268601_
                                                               (let ((__obj312543
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              (make-object std/misc/channel#channel::t '5)))
                         (std/misc/channel#channel:::init!__0 __obj312543)
                         __obj312543))
                 (##structure-set!
                  _stmt268640_
                  _greedy-in268601_
                  '5
                  std/db/postgresql#postgresql-command::t
                  '#f)
                 (_again268630_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (begin
                                                   (if _greedy-in268601_
                                                       (std/misc/channel#channel-sync
                                                        _greedy-in268601_
                                                        _next268633_)
                                                       '#!void)
                                                   (_again268630_)))))))))))))
             (if (let ()
                   (declare (not safe))
                   (##structure-direct-instance-of?
                    _self268603268617_
                    'std/db/postgresql#postgresql-query::t))
                 (let* ((_e268607268645_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _self268603268617_ '1)))
                        (_e268608268648_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _self268603268617_ '2)))
                        (_conn268651_ _e268608268648_)
                        (_e268609268653_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _self268603268617_ '3)))
                        (_e268610268656_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _self268603268617_ '4)))
                        (_e268611268659_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _self268603268617_ '5)))
                        (_inp268662_ _e268611268659_)
                        (_e268612268664_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _self268603268617_ '6)))
                        (_token268667_ _e268612268664_)
                        (_e268613268669_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _self268603268617_ '7)))
                        (_e268614268672_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _self268603268617_ '8)))
                        (_cmd268675_ _e268614268672_)
                        (_e268615268677_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _self268603268617_ '9)))
                        (_greedy268680_ _e268615268677_))
                   (_K268606268642_
                    _greedy268680_
                    _cmd268675_
                    _token268667_
                    _inp268662_
                    _conn268651_))
                 (_E268605268621_))))))))
  (bind-method!
   std/db/postgresql#postgresql-query::t
   'query-fetch
   std/db/postgresql#postgresql-query::query-fetch
   '#f)
  (define std/db/postgresql#catalog::t
    (make-struct-type
     'std/db/postgresql#catalog::t
     '#f
     '2
     'catalog
     '((final: . #t))
     ':init!
     '(s d)))
  (define std/db/postgresql#catalog?
    (make-struct-predicate std/db/postgresql#catalog::t))
  (define std/db/postgresql#make-catalog
    (lambda _$args268474_
      (apply make-struct-instance std/db/postgresql#catalog::t _$args268474_)))
  (define std/db/postgresql#catalog-s
    (make-struct-field-accessor std/db/postgresql#catalog::t '0))
  (define std/db/postgresql#catalog-d
    (make-struct-field-accessor std/db/postgresql#catalog::t '1))
  (define std/db/postgresql#catalog-s-set!
    (make-struct-field-mutator std/db/postgresql#catalog::t '0))
  (define std/db/postgresql#catalog-d-set!
    (make-struct-field-mutator std/db/postgresql#catalog::t '1))
  (define std/db/postgresql#catalog:::init!
    (lambda (_self268466_ . _mixin268467_)
      (let ((_s268469_ (make-table 'test: eq?))
            (_d268470_ (make-table 'test: eq?)))
        (for-each
         (lambda (_mixin268472_)
           (hash-merge!
            _s268469_
            (##direct-structure-ref
             _mixin268472_
             '1
             std/db/postgresql#catalog::t
             '#f))
           (hash-merge!
            _d268470_
            (##direct-structure-ref
             _mixin268472_
             '2
             std/db/postgresql#catalog::t
             '#f)))
         _mixin268467_)
        (if (let ((__tmp312570
                   (let ()
                     (declare (not safe))
                     (##vector-length _self268466_))))
              (declare (not safe))
              (##fx< '2 __tmp312570))
            (begin
              (let ()
                (declare (not safe))
                (##vector-set! _self268466_ '1 _s268469_))
              (let ()
                (declare (not safe))
                (##vector-set! _self268466_ '2 _d268470_)))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self268466_)))))
  (bind-method!
   std/db/postgresql#catalog::t
   ':init!
   std/db/postgresql#catalog:::init!
   '#f)
  (define std/db/postgresql#catalog-serializer
    (lambda (_c268341_ _oid268342_)
      (table-ref
       (##direct-structure-ref _c268341_ '1 std/db/postgresql#catalog::t '#f)
       _oid268342_
       '#f)))
  (define std/db/postgresql#catalog-deserializer
    (lambda (_c268338_ _oid268339_)
      (table-ref
       (##direct-structure-ref _c268338_ '2 std/db/postgresql#catalog::t '#f)
       _oid268339_
       '#f)))
  (define std/db/postgresql#serialize-boolean
    (lambda (_arg268336_) (if _arg268336_ '"t" '"f")))
  (define std/db/postgresql#deserialize-boolean
    (lambda (_str268334_)
      (if (member _str268334_ '("t" "true" "TRUE" "y" "yes" "on" "1"))
          '#t
          '#f)))
  (define std/db/postgresql#serialize-date
    (lambda (_date268332_)
      (std/srfi/19#date->string _date268332_ '"~Y-~m-~d")))
  (define std/db/postgresql#deserialize-date
    (lambda (_str268330_) (std/srfi/19#string->date _str268330_ '"~Y-~m-~d")))
  (define std/db/postgresql#serialize-timestamp
    (lambda (_date268328_)
      (std/srfi/19#date->string _date268328_ '"~Y-~m-~d ~H:~M:~S")))
  (define std/db/postgresql#deserialize-timestamp
    (lambda (_str268326_)
      (std/srfi/19#string->date _str268326_ '"~Y-~m-~d ~H:~M:~S")))
  (define std/db/postgresql#serialize-timestamptz
    (lambda (_date268324_)
      (std/srfi/19#date->string _date268324_ '"~Y-~m-~d ~H:~M:~S~z")))
  (define std/db/postgresql#deserialize-timestamptz
    (lambda (_str268322_)
      (std/srfi/19#string->date _str268322_ '"~Y-~m-~d ~H:~M:~S~z")))
  (define std/db/postgresql#identity-string
    (lambda (_obj268320_)
      (if (string? _obj268320_)
          _obj268320_
          (error '"Bad argument; expected string" _obj268320_))))
  (define std/db/postgresql#default-catalog
    (let ((__obj312544 (make-object std/db/postgresql#catalog::t '2)))
      (std/db/postgresql#catalog:::init! __obj312544)
      __obj312544))
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '16
   std/db/postgresql#serialize-boolean)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '16
   std/db/postgresql#deserialize-boolean)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '20
   number->string)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '21
   number->string)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '23
   number->string)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '700
   number->string)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '701
   number->string)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '1700
   number->string)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '20
   string->number)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '21
   string->number)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '23
   string->number)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '700
   string->number)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '701
   string->number)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '1700
   string->number)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '18
   std/db/postgresql#identity-string)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '25
   std/db/postgresql#identity-string)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '1042
   std/db/postgresql#identity-string)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '1043
   std/db/postgresql#identity-string)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '18
   identity)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '25
   identity)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '1042
   identity)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '1043
   identity)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '1082
   std/db/postgresql#serialize-date)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '1082
   std/db/postgresql#deserialize-date)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '1114
   std/db/postgresql#serialize-timestamp)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '1114
   std/db/postgresql#deserialize-timestamp)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '1
    std/db/postgresql#catalog::t
    '#f)
   '1184
   std/db/postgresql#serialize-timestamptz)
  (table-set!
   (##direct-structure-ref
    std/db/postgresql#default-catalog
    '2
    std/db/postgresql#catalog::t
    '#f)
   '1184
   std/db/postgresql#deserialize-timestamptz)
  (define std/db/postgresql#current-catalog
    (make-parameter std/db/postgresql#default-catalog)))
