(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/db/sqlite#sqlite-connection::t
    (make-struct-type
     'std/db/sqlite#sqlite-connection::t
     std/db/dbi#connection::t
     '0
     'sqlite-connection
     '((final: . #t))
     '#f
     '()))
  (define std/db/sqlite#sqlite-connection?
    (make-struct-predicate std/db/sqlite#sqlite-connection::t))
  (define std/db/sqlite#make-sqlite-connection
    (lambda _$args274161_
      (apply make-struct-instance
             std/db/sqlite#sqlite-connection::t
             _$args274161_)))
  (define std/db/sqlite#sqlite-statement::t
    (make-struct-type
     'std/db/sqlite#sqlite-statement::t
     std/db/dbi#statement::t
     '0
     'sqlite-statement
     '((final: . #t))
     '#f
     '()))
  (define std/db/sqlite#sqlite-statement?
    (make-struct-predicate std/db/sqlite#sqlite-statement::t))
  (define std/db/sqlite#make-sqlite-statement
    (lambda _$args274158_
      (apply make-struct-instance
             std/db/sqlite#sqlite-statement::t
             _$args274158_)))
  (define std/db/sqlite#sqlite-connection:::init!
    std/db/dbi#connection:::init!)
  (bind-method!
   std/db/sqlite#sqlite-connection::t
   ':init!
   std/db/sqlite#sqlite-connection:::init!
   '#f)
  (define std/db/sqlite#raise-sqlite-error
    (lambda (_where274031_ _err274032_)
      (let ((_errstr274034_ (std/db/_sqlite#sqlite3_errstr _err274032_)))
        (std/db/dbi#raise-sql-error
         _where274031_
         (std/format#format '"SQLite error: ~a" _errstr274034_)
         _err274032_))))
  (define std/db/sqlite#sqlite-open__%
    (lambda (_file274013_ _flags274014_)
      (let* ((_ptr274016_ (std/db/_sqlite#make_sqlite3_ptr_ptr))
             (_r274018_
              (std/db/_sqlite#sqlite3_open
               _ptr274016_
               _file274013_
               _flags274014_)))
        (if (let ()
              (declare (not safe))
              (##fx= _r274018_ std/db/_sqlite#SQLITE_OK))
            (let ((__obj312649
                   (make-object std/db/sqlite#sqlite-connection::t '4)))
              (if (let ((__tmp312650
                         (let ()
                           (declare (not safe))
                           (##vector-length __obj312649))))
                    (declare (not safe))
                    (##fx< '1 __tmp312650))
                  (let ((__tmp312651 (std/db/_sqlite#sqlite3_ptr _ptr274016_)))
                    (declare (not safe))
                    (##vector-set! __obj312649 '1 __tmp312651))
                  (error '"struct-instance-init!: too many arguments for struct"
                         __obj312649))
              __obj312649)
            (std/db/sqlite#raise-sqlite-error 'sqlite-open _r274018_)))))
  (define std/db/sqlite#sqlite-open__0
    (lambda (_file274024_)
      (let ((_flags274026_
             (fxior std/db/_sqlite#SQLITE_OPEN_READWRITE
                    std/db/_sqlite#SQLITE_OPEN_CREATE)))
        (std/db/sqlite#sqlite-open__% _file274024_ _flags274026_))))
  (define std/db/sqlite#sqlite-open
    (lambda _g312653_
      (let ((_g312652_ (let () (declare (not safe)) (##length _g312653_))))
        (cond ((let () (declare (not safe)) (##fx= _g312652_ 1))
               (apply std/db/sqlite#sqlite-open__0 _g312653_))
              ((let () (declare (not safe)) (##fx= _g312652_ 2))
               (apply std/db/sqlite#sqlite-open__% _g312653_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/sqlite#sqlite-open
                _g312653_))))))
  (define std/db/sqlite#sqlite-connection::close
    (lambda (_self274010_)
      (std/db/_sqlite#sqlite3_close
       (##structure-ref _self274010_ '1 std/db/dbi#connection::t '#f))))
  (define std/db/sqlite#sqlite-connection::close::specialize
    (lambda (__t312634)
      (let* ((__class312635
              (struct-subtype? std/db/dbi#connection::t __t312634))
             (__specializer312636
              (lambda (_self274010_)
                (std/db/_sqlite#sqlite3_close
                 (if __class312635
                     (let ()
                       (declare (not safe))
                       (##unchecked-structure-ref
                        _self274010_
                        '1
                        std/db/dbi#connection::t
                        '#f))
                     (error '"Type error; concrete type is not a subclass of expected type"
                            std/db/dbi#connection::t
                            _self274010_))))))
        (if __class312635
            std/db/sqlite#sqlite-connection::close::specialize::unchecked
            __specializer312636))))
  (define std/db/sqlite#sqlite-connection::close::specialize::unchecked
    (lambda (_self274010_)
      (std/db/_sqlite#sqlite3_close
       (let ()
         (declare (not safe))
         (##unchecked-structure-ref
          _self274010_
          '1
          std/db/dbi#connection::t
          '#f)))))
  (bind-specializer!
   std/db/sqlite#sqlite-connection::close
   std/db/sqlite#sqlite-connection::close::specialize)
  (bind-method!
   std/db/sqlite#sqlite-connection::t
   'close
   std/db/sqlite#sqlite-connection::close
   '#f)
  (define std/db/sqlite#sqlite-connection::prepare
    (lambda (_self273880_ _sql273881_)
      (let* ((_ptr273883_ (std/db/_sqlite#make_sqlite3_stmt_ptr_ptr))
             (_r273885_
              (std/db/_sqlite#sqlite3_prepare
               _ptr273883_
               (##structure-ref _self273880_ '1 std/db/dbi#connection::t '#f)
               _sql273881_)))
        (if (let ()
              (declare (not safe))
              (##fx= _r273885_ std/db/_sqlite#SQLITE_OK))
            (let ((__tmp312654 (std/db/_sqlite#sqlite3_stmt_ptr _ptr273883_)))
              (declare (not safe))
              (##structure std/db/sqlite#sqlite-statement::t __tmp312654))
            (std/db/sqlite#raise-sqlite-error 'sqlite-prepare _r273885_)))))
  (define std/db/sqlite#sqlite-connection::prepare::specialize
    (lambda (__t312637)
      (let* ((__class312638
              (struct-subtype? std/db/dbi#connection::t __t312637))
             (__specializer312639
              (lambda (_self273880_ _sql273881_)
                (let* ((_ptr273883_ (std/db/_sqlite#make_sqlite3_stmt_ptr_ptr))
                       (_r273885_
                        (std/db/_sqlite#sqlite3_prepare
                         _ptr273883_
                         (if __class312638
                             (let ()
                               (declare (not safe))
                               (##unchecked-structure-ref
                                _self273880_
                                '1
                                std/db/dbi#connection::t
                                '#f))
                             (error '"Type error; concrete type is not a subclass of expected type"
                                    std/db/dbi#connection::t
                                    _self273880_))
                         _sql273881_)))
                  (if (let ()
                        (declare (not safe))
                        (##fx= _r273885_ std/db/_sqlite#SQLITE_OK))
                      (let ((__tmp312655
                             (std/db/_sqlite#sqlite3_stmt_ptr _ptr273883_)))
                        (declare (not safe))
                        (##structure
                         std/db/sqlite#sqlite-statement::t
                         __tmp312655))
                      (std/db/sqlite#raise-sqlite-error
                       'sqlite-prepare
                       _r273885_))))))
        (if __class312638
            std/db/sqlite#sqlite-connection::prepare::specialize::unchecked
            __specializer312639))))
  (define std/db/sqlite#sqlite-connection::prepare::specialize::unchecked
    (lambda (_self273880_ _sql273881_)
      (let* ((_ptr273883_ (std/db/_sqlite#make_sqlite3_stmt_ptr_ptr))
             (_r273885_
              (std/db/_sqlite#sqlite3_prepare
               _ptr273883_
               (let ()
                 (declare (not safe))
                 (##unchecked-structure-ref
                  _self273880_
                  '1
                  std/db/dbi#connection::t
                  '#f))
               _sql273881_)))
        (if (let ()
              (declare (not safe))
              (##fx= _r273885_ std/db/_sqlite#SQLITE_OK))
            (let ((__tmp312656 (std/db/_sqlite#sqlite3_stmt_ptr _ptr273883_)))
              (declare (not safe))
              (##structure std/db/sqlite#sqlite-statement::t __tmp312656))
            (std/db/sqlite#raise-sqlite-error 'sqlite-prepare _r273885_)))))
  (bind-specializer!
   std/db/sqlite#sqlite-connection::prepare
   std/db/sqlite#sqlite-connection::prepare::specialize)
  (bind-method!
   std/db/sqlite#sqlite-connection::t
   'prepare
   std/db/sqlite#sqlite-connection::prepare
   '#f)
  (define std/db/sqlite#sqlite-statement::finalize
    (lambda (_self273756_)
      (std/db/_sqlite#sqlite3_finalize
       (##structure-ref _self273756_ '1 std/db/dbi#statement::t '#f))))
  (define std/db/sqlite#sqlite-statement::finalize::specialize
    (lambda (__t312640)
      (let* ((__class312641
              (struct-subtype? std/db/dbi#statement::t __t312640))
             (__specializer312642
              (lambda (_self273756_)
                (std/db/_sqlite#sqlite3_finalize
                 (if __class312641
                     (let ()
                       (declare (not safe))
                       (##unchecked-structure-ref
                        _self273756_
                        '1
                        std/db/dbi#statement::t
                        '#f))
                     (error '"Type error; concrete type is not a subclass of expected type"
                            std/db/dbi#statement::t
                            _self273756_))))))
        (if __class312641
            std/db/sqlite#sqlite-statement::finalize::specialize::unchecked
            __specializer312642))))
  (define std/db/sqlite#sqlite-statement::finalize::specialize::unchecked
    (lambda (_self273756_)
      (std/db/_sqlite#sqlite3_finalize
       (let ()
         (declare (not safe))
         (##unchecked-structure-ref
          _self273756_
          '1
          std/db/dbi#statement::t
          '#f)))))
  (bind-specializer!
   std/db/sqlite#sqlite-statement::finalize
   std/db/sqlite#sqlite-statement::finalize::specialize)
  (bind-method!
   std/db/sqlite#sqlite-statement::t
   'finalize
   std/db/sqlite#sqlite-statement::finalize
   '#f)
  (define std/db/sqlite#sqlite-statement::bind
    (lambda (_self273529_ . _args273530_)
      (let* ((_self273531273537_ _self273529_)
             (_E273533273541_
              (lambda () (error '"No clause matching" _self273531273537_)))
             (_K273534273626_
              (lambda (_stmt273544_)
                (let* ((_params273546_
                        (std/db/_sqlite#sqlite3_bind_parameter_count
                         _stmt273544_))
                       (_g312657_
                        (if (= _params273546_ (length _args273530_))
                            '#!void
                            (error '"bind parameters do not match statement count"
                                   _args273530_
                                   _params273546_))))
                  (let* ((_g273549273556_ (std/iter#iter _args273530_))
                         (_g273550273559_
                          (std/iter#iter
                           (std/iter#in-iota__1 _params273546_ '1)))
                         (_g273551273562_
                          (let ()
                            (declare (not safe))
                            (##unchecked-structure-ref
                             _g273549273556_
                             '2
                             std/iter#iterator::t
                             '#f)))
                         (_g273552273565_
                          (let ()
                            (declare (not safe))
                            (##unchecked-structure-ref
                             _g273550273559_
                             '2
                             std/iter#iterator::t
                             '#f)))
                         (_iter-do273597_
                          (lambda (_g273553273568_ _g273554273570_)
                            (let ((_g273572273578_ _g273553273568_)
                                  (_g273573273580_ _g273554273570_))
                              (let* ((_E273575273584_
                                      (lambda ()
                                        (error '"No clause matching"
                                               _g273572273578_
                                               _g273573273580_)))
                                     (_K273576273590_
                                      (lambda (_arg273587_ _param273588_)
                                        (if (not _arg273587_)
                                            (std/db/_sqlite#sqlite3_bind_null
                                             _stmt273544_
                                             _param273588_)
                                            (if (number? _arg273587_)
                                                (if (integer? _arg273587_)
                                                    (if (< (abs _arg273587_)
                                                           (expt '2 '32))
                                                        (std/db/_sqlite#sqlite3_bind_int
                                                         _stmt273544_
                                                         _param273588_
                                                         _arg273587_)
                                                        (std/db/_sqlite#sqlite3_bind_int64
                                                         _stmt273544_
                                                         _param273588_
                                                         _arg273587_))
                                                    (if (real? _arg273587_)
                                                        (std/db/_sqlite#sqlite3_bind_double
                                                         _stmt273544_
                                                         _param273588_
                                                         (exact->inexact
                                                          _arg273587_))
                                                        (error '"cannot bind number; not a real"
                                                               _arg273587_)))
                                                (if (string? _arg273587_)
                                                    (std/db/_sqlite#sqlite3_bind_text
                                                     _stmt273544_
                                                     _param273588_
                                                     _arg273587_)
                                                    (if (u8vector? _arg273587_)
                                                        (std/db/_sqlite#sqlite3_bind_blob
                                                         _stmt273544_
                                                         _param273588_
                                                         _arg273587_)
                                                        (if error
                                                            _arg273587_
                                                            '#!void)))))))
                                     (_arg273593_ _g273572273578_)
                                     (_param273595_ _g273573273580_))
                                (_K273576273590_
                                 _arg273593_
                                 _param273595_))))))
                    (declare (not safe))
                    (begin
                      (let _lp273602_ ()
                        (let ((_g273553273606_
                               (_g273551273562_ _g273549273556_))
                              (_g273554273607_
                               (_g273552273565_ _g273550273559_)))
                          (if (or (eq? std/iter#iter-end _g273553273606_)
                                  (eq? std/iter#iter-end _g273554273607_))
                              '#!void
                              (begin
                                (_iter-do273597_
                                 _g273553273606_
                                 _g273554273607_)
                                (_lp273602_)))))
                      (let ((_$e273612_
                             (##unchecked-structure-ref
                              _g273549273556_
                              '3
                              std/iter#iterator::t
                              '#f)))
                        (if _$e273612_
                            ((lambda (_g273614273616_)
                               (_g273614273616_ _g273549273556_))
                             _$e273612_)
                            '#!void))
                      (let ((_$e273619_
                             (##unchecked-structure-ref
                              _g273550273559_
                              '3
                              std/iter#iterator::t
                              '#f)))
                        (if _$e273619_
                            ((lambda (_g273621273623_)
                               (_g273621273623_ _g273550273559_))
                             _$e273619_)
                            '#!void))
                      '#!void))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _self273531273537_
               'std/db/sqlite#sqlite-statement::t))
            (let* ((_e273535273629_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self273531273537_ '1)))
                   (_stmt273632_ _e273535273629_))
              (_K273534273626_ _stmt273632_))
            (_E273533273541_)))))
  (bind-method!
   std/db/sqlite#sqlite-statement::t
   'bind
   std/db/sqlite#sqlite-statement::bind
   '#f)
  (define std/db/sqlite#sqlite-statement::clear
    (lambda (_self273405_)
      (std/db/_sqlite#sqlite3_clear_bindings
       (##structure-ref _self273405_ '1 std/db/dbi#statement::t '#f))))
  (define std/db/sqlite#sqlite-statement::clear::specialize
    (lambda (__t312643)
      (let* ((__class312644
              (struct-subtype? std/db/dbi#statement::t __t312643))
             (__specializer312645
              (lambda (_self273405_)
                (std/db/_sqlite#sqlite3_clear_bindings
                 (if __class312644
                     (let ()
                       (declare (not safe))
                       (##unchecked-structure-ref
                        _self273405_
                        '1
                        std/db/dbi#statement::t
                        '#f))
                     (error '"Type error; concrete type is not a subclass of expected type"
                            std/db/dbi#statement::t
                            _self273405_))))))
        (if __class312644
            std/db/sqlite#sqlite-statement::clear::specialize::unchecked
            __specializer312645))))
  (define std/db/sqlite#sqlite-statement::clear::specialize::unchecked
    (lambda (_self273405_)
      (std/db/_sqlite#sqlite3_clear_bindings
       (let ()
         (declare (not safe))
         (##unchecked-structure-ref
          _self273405_
          '1
          std/db/dbi#statement::t
          '#f)))))
  (bind-specializer!
   std/db/sqlite#sqlite-statement::clear
   std/db/sqlite#sqlite-statement::clear::specialize)
  (bind-method!
   std/db/sqlite#sqlite-statement::t
   'clear
   std/db/sqlite#sqlite-statement::clear
   '#f)
  (define std/db/sqlite#sqlite-statement::reset
    (lambda (_self273281_)
      (std/db/_sqlite#sqlite3_reset
       (##structure-ref _self273281_ '1 std/db/dbi#statement::t '#f))))
  (define std/db/sqlite#sqlite-statement::reset::specialize
    (lambda (__t312646)
      (let* ((__class312647
              (struct-subtype? std/db/dbi#statement::t __t312646))
             (__specializer312648
              (lambda (_self273281_)
                (std/db/_sqlite#sqlite3_reset
                 (if __class312647
                     (let ()
                       (declare (not safe))
                       (##unchecked-structure-ref
                        _self273281_
                        '1
                        std/db/dbi#statement::t
                        '#f))
                     (error '"Type error; concrete type is not a subclass of expected type"
                            std/db/dbi#statement::t
                            _self273281_))))))
        (if __class312647
            std/db/sqlite#sqlite-statement::reset::specialize::unchecked
            __specializer312648))))
  (define std/db/sqlite#sqlite-statement::reset::specialize::unchecked
    (lambda (_self273281_)
      (std/db/_sqlite#sqlite3_reset
       (let ()
         (declare (not safe))
         (##unchecked-structure-ref
          _self273281_
          '1
          std/db/dbi#statement::t
          '#f)))))
  (bind-specializer!
   std/db/sqlite#sqlite-statement::reset
   std/db/sqlite#sqlite-statement::reset::specialize)
  (bind-method!
   std/db/sqlite#sqlite-statement::t
   'reset
   std/db/sqlite#sqlite-statement::reset
   '#f)
  (define std/db/sqlite#sqlite-statement::exec
    (lambda (_self273130_)
      (let* ((_self273131273137_ _self273130_)
             (_E273133273141_
              (lambda () (error '"No clause matching" _self273131273137_)))
             (_K273134273151_
              (lambda (_stmt273144_)
                (let ((_r273146_ (std/db/_sqlite#sqlite3_step _stmt273144_)))
                  (if (or (eq? _r273146_ std/db/_sqlite#SQLITE_DONE)
                          (eq? _r273146_ std/db/_sqlite#SQLITE_ROW))
                      '#!void
                      (std/db/sqlite#raise-sqlite-error
                       'sqlite-exec
                       _r273146_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _self273131273137_
               'std/db/sqlite#sqlite-statement::t))
            (let* ((_e273135273154_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self273131273137_ '1)))
                   (_stmt273157_ _e273135273154_))
              (_K273134273151_ _stmt273157_))
            (_E273133273141_)))))
  (bind-method!
   std/db/sqlite#sqlite-statement::t
   'exec
   std/db/sqlite#sqlite-statement::exec
   '#f)
  (define std/db/sqlite#sqlite-statement::query-start void)
  (bind-method!
   std/db/sqlite#sqlite-statement::t
   'query-start
   std/db/sqlite#sqlite-statement::query-start
   '#f)
  (define std/db/sqlite#sqlite-statement::query-fetch
    (lambda (_self272860_)
      (let* ((_self272861272867_ _self272860_)
             (_E272863272871_
              (lambda () (error '"No clause matching" _self272861272867_)))
             (_K272864272878_
              (lambda (_stmt272874_)
                (let ((_r272876_ (std/db/_sqlite#sqlite3_step _stmt272874_)))
                  (if (eq? _r272876_ std/db/_sqlite#SQLITE_ROW)
                      '#!void
                      (if (eq? _r272876_ std/db/_sqlite#SQLITE_DONE)
                          std/iter#iter-end
                          (std/db/sqlite#raise-sqlite-error
                           'sqlite-query-fetch
                           _r272876_)))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _self272861272867_
               'std/db/sqlite#sqlite-statement::t))
            (let* ((_e272865272881_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self272861272867_ '1)))
                   (_stmt272884_ _e272865272881_))
              (_K272864272878_ _stmt272884_))
            (_E272863272871_)))))
  (bind-method!
   std/db/sqlite#sqlite-statement::t
   'query-fetch
   std/db/sqlite#sqlite-statement::query-fetch
   '#f)
  (define std/db/sqlite#sqlite-statement::query-row
    (lambda (_self272668_)
      (let* ((_self272669272675_ _self272668_)
             (_E272671272679_
              (lambda () (error '"No clause matching" _self272669272675_)))
             (_K272672272730_
              (lambda (_stmt272682_)
                (letrec ((_column-e272684_
                          (lambda (_col272721_)
                            (let ((_t272723_
                                   (std/db/_sqlite#sqlite3_column_type
                                    _stmt272682_
                                    _col272721_)))
                              (if (eq? _t272723_ std/db/_sqlite#SQLITE_INTEGER)
                                  (std/db/_sqlite#sqlite3_column_int64
                                   _stmt272682_
                                   _col272721_)
                                  (if (eq? _t272723_
                                           std/db/_sqlite#SQLITE_FLOAT)
                                      (std/db/_sqlite#sqlite3_column_double
                                       _stmt272682_
                                       _col272721_)
                                      (if (eq? _t272723_
                                               std/db/_sqlite#SQLITE_TEXT)
                                          (std/db/_sqlite#sqlite3_column_text
                                           _stmt272682_
                                           _col272721_)
                                          (if (eq? _t272723_
                                                   std/db/_sqlite#SQLITE_NULL)
                                              '#f
                                              (if (eq? _t272723_
                                                       std/db/_sqlite#SQLITE_BLOB)
                                                  (let* ((_count272725_
                                                          (std/db/_sqlite#sqlite3_column_bytes
                                                           _stmt272682_
                                                           _col272721_))
                                                         (_bytes272727_
                                                          (make-u8vector
                                                           _count272725_)))
                                                    (std/db/_sqlite#sqlite3_column_blob
                                                     _stmt272682_
                                                     _col272721_
                                                     _bytes272727_)
                                                    _bytes272727_)
                                                  (error '"Unexpected column type"
                                                         _t272723_))))))))))
                  (let* ((_count272686_
                          (std/db/_sqlite#sqlite3_column_count _stmt272682_))
                         (_$e272688_ _count272686_))
                    (if (eq? '0 _$e272688_)
                        '#!void
                        (if (eq? '1 _$e272688_)
                            (_column-e272684_ '0)
                            (list->vector
                             (let ((_iter-do272696_
                                    (lambda (_n272691_)
                                      (let ((_x272694_ _n272691_))
                                        (_column-e272684_ _x272694_))))
                                   (_$count272698_ _count272686_)
                                   (_$start272700_ '0)
                                   (_$step272702_ '1))
                               (let ((_root272705_ (cons '#f '())))
                                 (let _lp272708_ ((_i272711_ '0)
                                                  (_val272713_ _$start272700_)
                                                  (_tl272715_ _root272705_))
                                   (if (fx< _i272711_ _$count272698_)
                                       (_lp272708_
                                        (let ()
                                          (declare (not safe))
                                          (##fx+ _i272711_ '1))
                                        (+ _val272713_ _$step272702_)
                                        (let ((_tl*272718_
                                               (cons (_iter-do272696_
                                                      _val272713_)
                                                     '())))
                                          (let ()
                                            (declare (not safe))
                                            (##set-cdr!
                                             _tl272715_
                                             _tl*272718_))
                                          _tl*272718_))
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _root272705_))))))))))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _self272669272675_
               'std/db/sqlite#sqlite-statement::t))
            (let* ((_e272673272733_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self272669272675_ '1)))
                   (_stmt272736_ _e272673272733_))
              (_K272672272730_ _stmt272736_))
            (_E272671272679_)))))
  (bind-method!
   std/db/sqlite#sqlite-statement::t
   'query-row
   std/db/sqlite#sqlite-statement::query-row
   '#f)
  (define std/db/sqlite#sqlite-statement::query-fini
    std/db/sqlite#sqlite-statement::reset)
  (bind-method!
   std/db/sqlite#sqlite-statement::t
   'query-fini
   std/db/sqlite#sqlite-statement::query-fini
   '#f)
  (define std/db/sqlite#sqlite-statement::columns
    (lambda (_self272391_)
      (let* ((_self272392272398_ _self272391_)
             (_E272394272402_
              (lambda () (error '"No clause matching" _self272392272398_)))
             (_K272395272416_
              (lambda (_stmt272405_)
                (let ((_count272407_
                       (std/db/_sqlite#sqlite3_column_count _stmt272405_)))
                  (let _lp272409_ ((_k272411_ '0) (_cols272412_ '()))
                    (if (let ()
                          (declare (not safe))
                          (##fx< _k272411_ _count272407_))
                        (let ((_name272414_
                               (std/db/_sqlite#sqlite3_column_name
                                _stmt272405_
                                _k272411_)))
                          (_lp272409_
                           (let () (declare (not safe)) (##fx+ _k272411_ '1))
                           (cons _name272414_ _cols272412_)))
                        (reverse _cols272412_)))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _self272392272398_
               'std/db/sqlite#sqlite-statement::t))
            (let* ((_e272396272419_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _self272392272398_ '1)))
                   (_stmt272422_ _e272396272419_))
              (_K272395272416_ _stmt272422_))
            (_E272394272402_)))))
  (bind-method!
   std/db/sqlite#sqlite-statement::t
   'columns
   std/db/sqlite#sqlite-statement::columns
   '#f))
