(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/debug/memleak#heap-summary
    (lambda ()
      (let () (declare (not safe)) (##gc))
      (let* ((_mem56291_ (std/debug/heap#memory-usage))
             (_g293945_ (std/debug/heap#count-still1)))
        (begin
          (let ((_g293946_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g293945_) (##vector-length _g293945_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g293946_ 2)))
                (error "Context expects 2 values" _g293946_)))
          (let ((_still56293_
                 (let () (declare (not safe)) (##vector-ref _g293945_ 0)))
                (_refcounted56294_
                 (let () (declare (not safe)) (##vector-ref _g293945_ 1))))
            (let* ((_live56296_
                    (std/debug/heap#walk-heap!__%
                     '#f
                     absent-value
                     absent-value))
                   (_heap-stats56298_ (make-table 'test: eq?))
                   (_frame-stats56300_ (make-table 'test: eq?)))
              (table-for-each
               (lambda (_obj56303_ _g293947_)
                 (let ((_t56305_ (std/generic/dispatch#type-of _obj56303_)))
                   (hash-update! _heap-stats56298_ _t56305_ 1+ '0)
                   (if (eq? _t56305_ 'frame)
                       (let ((_c56307_
                              (std/debug/memleak#frame-creator-name
                               _obj56303_)))
                         (hash-update! _frame-stats56300_ _c56307_ 1+ '0))
                       '#!void)))
               _live56296_)
              (vector _mem56291_
                      (cons (table-length _live56296_)
                            (cons _still56293_ (cons _refcounted56294_ '())))
                      _heap-stats56298_
                      _frame-stats56300_)))))))
  (define std/debug/memleak#heap-summary-delta
    (lambda (_old56205_ _new56206_)
      (let ((_old5620756221_ _old56205_) (_new5620856223_ _new56206_))
        (let* ((_E5621056227_
                (lambda ()
                  (error '"No clause matching"
                         _old5620756221_
                         _new5620856223_)))
               (_K5621156247_
                (lambda (_frame-old56230_
                         _heap-old56231_
                         _counts-old56232_
                         _mem-old56233_
                         _frame-new56234_
                         _heap-new56235_
                         _counts-new56236_
                         _mem-new56237_)
                  (let ((_mem-delta56242_
                         (map (lambda (_a56239_ _b56240_)
                                (cons (car _a56239_)
                                      (- (cdr _a56239_) (cdr _b56240_))))
                              _mem-new56237_
                              _mem-old56233_))
                        (_counts-delta56243_
                         (map - _counts-new56236_ _counts-old56232_))
                        (_heap-delta56244_
                         (std/debug/memleak#hash-delta
                          _heap-new56235_
                          _heap-old56231_))
                        (_frame-delta56245_
                         (std/debug/memleak#hash-delta
                          _frame-new56234_
                          _frame-old56230_)))
                    (vector _mem-delta56242_
                            _counts-delta56243_
                            _heap-delta56244_
                            _frame-delta56245_)))))
          (if (let () (declare (not safe)) (##vector? _old5620756221_))
              (if (let ((__tmp293948
                         (let ()
                           (declare (not safe))
                           (##vector-length _old5620756221_))))
                    (declare (not safe))
                    (##fx= __tmp293948 '4))
                  (let* ((_e5621656250_
                          (let ()
                            (declare (not safe))
                            (##vector-ref _old5620756221_ '0)))
                         (_mem-old56253_ _e5621656250_)
                         (_e5621756255_
                          (let ()
                            (declare (not safe))
                            (##vector-ref _old5620756221_ '1)))
                         (_counts-old56258_ _e5621756255_)
                         (_e5621856260_
                          (let ()
                            (declare (not safe))
                            (##vector-ref _old5620756221_ '2)))
                         (_heap-old56263_ _e5621856260_)
                         (_e5621956265_
                          (let ()
                            (declare (not safe))
                            (##vector-ref _old5620756221_ '3)))
                         (_frame-old56268_ _e5621956265_))
                    (if (let ()
                          (declare (not safe))
                          (##vector? _new5620856223_))
                        (if (let ((__tmp293949
                                   (let ()
                                     (declare (not safe))
                                     (##vector-length _new5620856223_))))
                              (declare (not safe))
                              (##fx= __tmp293949 '4))
                            (let* ((_e5621256270_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _new5620856223_ '0)))
                                   (_mem-new56273_ _e5621256270_)
                                   (_e5621356275_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _new5620856223_ '1)))
                                   (_counts-new56278_ _e5621356275_)
                                   (_e5621456280_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _new5620856223_ '2)))
                                   (_heap-new56283_ _e5621456280_)
                                   (_e5621556285_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _new5620856223_ '3)))
                                   (_frame-new56288_ _e5621556285_))
                              (_K5621156247_
                               _frame-old56268_
                               _heap-old56263_
                               _counts-old56258_
                               _mem-old56253_
                               _frame-new56288_
                               _heap-new56283_
                               _counts-new56278_
                               _mem-new56273_))
                            (_E5621056227_))
                        (_E5621056227_)))
                  (_E5621056227_))
              (_E5621056227_))))))
  (define std/debug/memleak#hash-delta
    (lambda (_new56189_ _old56190_)
      (letrec* ((_delta56192_ (make-table 'test: eq?)))
        (table-for-each
         (lambda (_key56194_ _count56195_)
           (let ((_$e56197_ (table-ref _old56190_ _key56194_ '#f)))
             (if _$e56197_
                 ((lambda (_old-count56200_)
                    (table-set!
                     _delta56192_
                     _key56194_
                     (- _count56195_ _old-count56200_)))
                  _$e56197_)
                 (table-set! _delta56192_ _key56194_ _count56195_))))
         _new56189_)
        (table-for-each
         (lambda (_key56202_ _count56203_)
           (if (table-ref _delta56192_ _key56202_ '#f)
               '#!void
               (table-set! _delta56192_ _key56202_ (- _count56203_))))
         _old56190_)
        _delta56192_)))
  (define std/debug/memleak#dump-heap-summary!__%
    (lambda (_summary56054_ _port56055_)
      (letrec ((_display-pair56057_
                (lambda (_el56149_)
                  (let* ((_el5615056157_ _el56149_)
                         (_E5615256161_
                          (lambda ()
                            (error '"No clause matching" _el5615056157_)))
                         (_K5615356167_
                          (lambda (_val56164_ _key56165_)
                            (if (zero? _val56164_)
                                '#!void
                                (displayln _key56165_ '": " _val56164_)))))
                    (if (let () (declare (not safe)) (##pair? _el5615056157_))
                        (let ((_hd5615456170_
                               (let ()
                                 (declare (not safe))
                                 (##car _el5615056157_)))
                              (_tl5615556172_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _el5615056157_))))
                          (let* ((_key56175_ _hd5615456170_)
                                 (_val56177_ _tl5615556172_))
                            (_K5615356167_ _val56177_ _key56175_)))
                        (_E5615256161_)))))
               (_cmp-count56058_
                (lambda (_a56146_ _b56147_) (> (cdr _a56146_) (cdr _b56147_))))
               (_display-list?56059_
                (lambda (_lst56142_)
                  (find (lambda (_el56144_) (not (zero? (cdr _el56144_))))
                        _lst56142_))))
        (call-with-parameters
         (lambda ()
           (let* ((_summary5606156076_ _summary56054_)
                  (_E5606356080_
                   (lambda ()
                     (error '"No clause matching" _summary5606156076_)))
                  (_K5606456100_
                   (lambda (_frame56083_
                            _heap56084_
                            _refcounted56085_
                            _still56086_
                            _live56087_
                            _mem56088_)
                     (displayln '"==================================")
                     (displayln
                      '"timestamp: "
                      (let () (declare (not safe)) (##current-time-point)))
                     (let ((_lst56092_
                            (filter (lambda (_el56090_)
                                      (not (eq? (car _el56090_) 'gc-alloc)))
                                    _mem56088_)))
                       (if (_display-list?56059_ _lst56092_)
                           (begin
                             (displayln '"=== memory usage ===")
                             (for-each _display-pair56057_ _lst56092_))
                           '#!void))
                     (let ((_lst56094_
                            (cons (cons 'objects _live56087_)
                                  (cons (cons 'still _still56086_)
                                        (cons (cons 'refcounted
                                                    _refcounted56085_)
                                              '())))))
                       (if (_display-list?56059_ _lst56094_)
                           (begin
                             (displayln '"=== heap summary ===")
                             (for-each _display-pair56057_ _lst56094_))
                           '#!void))
                     (let ((_lst56096_
                            (std/sort#sort
                             (table->list _heap56084_)
                             _cmp-count56058_)))
                       (if (_display-list?56059_ _lst56096_)
                           (begin
                             (displayln '"=== heap type counts ===")
                             (for-each _display-pair56057_ _lst56096_))
                           '#!void))
                     (let ((_lst56098_
                            (std/sort#sort
                             (table->list _frame56083_)
                             _cmp-count56058_)))
                       (if (_display-list?56059_ _lst56098_)
                           (begin
                             (displayln '"=== frame counts ===")
                             (for-each _display-pair56057_ _lst56098_))
                           '#!void))
                     (displayln '"=================================="))))
             (if (let () (declare (not safe)) (##vector? _summary5606156076_))
                 (if (let ((__tmp293950
                            (let ()
                              (declare (not safe))
                              (##vector-length _summary5606156076_))))
                       (declare (not safe))
                       (##fx= __tmp293950 '4))
                     (let* ((_e5606556103_
                             (let ()
                               (declare (not safe))
                               (##vector-ref _summary5606156076_ '0)))
                            (_mem56106_ _e5606556103_)
                            (_e5606656108_
                             (let ()
                               (declare (not safe))
                               (##vector-ref _summary5606156076_ '1))))
                       (if (let ()
                             (declare (not safe))
                             (##pair? _e5606656108_))
                           (let ((_hd5606956111_
                                  (let ()
                                    (declare (not safe))
                                    (##car _e5606656108_)))
                                 (_tl5607056113_
                                  (let ()
                                    (declare (not safe))
                                    (##cdr _e5606656108_))))
                             (let ((_live56116_ _hd5606956111_))
                               (if (let ()
                                     (declare (not safe))
                                     (##pair? _tl5607056113_))
                                   (let ((_hd5607156118_
                                          (let ()
                                            (declare (not safe))
                                            (##car _tl5607056113_)))
                                         (_tl5607256120_
                                          (let ()
                                            (declare (not safe))
                                            (##cdr _tl5607056113_))))
                                     (let ((_still56123_ _hd5607156118_))
                                       (if (let ()
                                             (declare (not safe))
                                             (##pair? _tl5607256120_))
                                           (let ((_hd5607356125_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##car _tl5607256120_)))
                                                 (_tl5607456127_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##cdr _tl5607256120_))))
                                             (let ((_refcounted56130_
                                                    _hd5607356125_))
                                               (if (let ()
                                                     (declare (not safe))
                                                     (##null? _tl5607456127_))
                                                   (let* ((_e5606756132_
                                                           (let ()
                                                             (declare
                                                               (not safe))
                                                             (##vector-ref
                                                              _summary5606156076_
                                                              '2)))
                                                          (_heap56135_
                                                           _e5606756132_)
                                                          (_e5606856137_
                                                           (let ()
                                                             (declare
                                                               (not safe))
                                                             (##vector-ref
                                                              _summary5606156076_
                                                              '3)))
                                                          (_frame56140_
                                                           _e5606856137_))
                                                     (_K5606456100_
                                                      _frame56140_
                                                      _heap56135_
                                                      _refcounted56130_
                                                      _still56123_
                                                      _live56116_
                                                      _mem56106_))
                                                   (_E5606356080_))))
                                           (_E5606356080_))))
                                   (_E5606356080_))))
                           (_E5606356080_)))
                     (_E5606356080_))
                 (_E5606356080_))))
         current-output-port
         _port56055_))))
  (define std/debug/memleak#dump-heap-summary!__0
    (lambda (_summary56182_)
      (let ((_port56184_ (current-error-port)))
        (std/debug/memleak#dump-heap-summary!__% _summary56182_ _port56184_))))
  (define std/debug/memleak#dump-heap-summary!
    (lambda _g293952_
      (let ((_g293951_ (let () (declare (not safe)) (##length _g293952_))))
        (cond ((let () (declare (not safe)) (##fx= _g293951_ 1))
               (apply std/debug/memleak#dump-heap-summary!__0 _g293952_))
              ((let () (declare (not safe)) (##fx= _g293951_ 2))
               (apply std/debug/memleak#dump-heap-summary!__% _g293952_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/debug/memleak#dump-heap-summary!
                _g293952_))))))
  (define std/debug/memleak#watch-heap!__%__%
    (lambda (__5599655999_
             _initial-delay5599256001_
             _period5599356003_
             _dump!5599456005_
             _port56007_)
      (let* ((_initial-delay56009_
              (if (eq? _initial-delay5599256001_ absent-value)
                  '60
                  _initial-delay5599256001_))
             (_period56011_
              (if (eq? _period5599356003_ absent-value)
                  (* '60 '15)
                  _period5599356003_))
             (_dump!56013_
              (if (eq? _dump!5599456005_ absent-value)
                  std/debug/memleak#dump-heap-summary!
                  _dump!5599456005_)))
        (thread-sleep! _initial-delay56009_)
        (let ((_summary56015_ (std/debug/memleak#heap-summary)))
          (_dump!56013_ _summary56015_ _port56007_)
          (force-output _port56007_)
          (let _lp56017_ ((_prev-summary56019_ _summary56015_))
            (thread-sleep! _period56011_)
            (let ((_summary56021_ (std/debug/memleak#heap-summary)))
              (_dump!56013_
               (std/debug/memleak#heap-summary-delta
                _prev-summary56019_
                _summary56021_)
               _port56007_)
              (force-output _port56007_)
              (_lp56017_ _summary56021_)))))))
  (define std/debug/memleak#watch-heap!__%__0
    (lambda (__5599656026_
             _initial-delay5599256027_
             _period5599356028_
             _dump!5599456029_)
      (let ((_port56031_ (current-error-port)))
        (std/debug/memleak#watch-heap!__%__%
         __5599656026_
         _initial-delay5599256027_
         _period5599356028_
         _dump!5599456029_
         _port56031_))))
  (define std/debug/memleak#watch-heap!__%
    (lambda _g293954_
      (let ((_g293953_ (let () (declare (not safe)) (##length _g293954_))))
        (cond ((let () (declare (not safe)) (##fx= _g293953_ 4))
               (apply std/debug/memleak#watch-heap!__%__0 _g293954_))
              ((let () (declare (not safe)) (##fx= _g293953_ 5))
               (apply std/debug/memleak#watch-heap!__%__% _g293954_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/debug/memleak#watch-heap!__%
                _g293954_))))))
  (define std/debug/memleak#watch-heap!__@
    (lambda (_keys5599156042_ . _args56044_)
      (apply std/debug/memleak#watch-heap!__%
             _keys5599156042_
             (table-ref _keys5599156042_ 'delay: absent-value)
             (table-ref _keys5599156042_ 'period: absent-value)
             (table-ref _keys5599156042_ 'dump: absent-value)
             _args56044_)))
  (define std/debug/memleak#watch-heap!
    (lambda _args5599556050_
      (apply keyword-dispatch
             '#(#f #f delay: #f period: dump:)
             std/debug/memleak#watch-heap!__@
             _args5599556050_)))
  (define std/debug/memleak#frame-creator
    (lambda (_frame55988_)
      (let ((__tmp293955
             (let ()
               (declare (not safe))
               (##make-continuation _frame55988_ '#f))))
        (declare (not safe))
        (##continuation-creator __tmp293955))))
  (define std/debug/memleak#frame-creator-name
    (lambda (_frame55984_)
      (let ((_creator55986_ (std/debug/memleak#frame-creator _frame55984_)))
        (if (procedure? _creator55986_)
            (let () (declare (not safe)) (##procedure-name _creator55986_))
            '#f)))))
