(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/make#default-gambit-gsc
    '"@@HOMEBREW_PREFIX@@/opt/gambit-scheme/bin/gsc")
  (define std/make#default-gerbil-gxc
    '"@@HOMEBREW_CELLAR@@/gerbil-scheme/0.17_3/bin/gxc")
  (define std/make#force-outputs
    (lambda () (force-output (current-error-port)) (force-output)))
  (define std/make#message
    (lambda _lst41447_ (apply displayln _lst41447_) (std/make#force-outputs)))
  (define std/make#writeln
    (lambda (_x41445_) (write _x41445_) (newline) (std/make#force-outputs)))
  (define std/make#prefix/
    (lambda (_prefix41442_ _path41443_)
      (if _prefix41442_
          (string-append _prefix41442_ '"/" _path41443_)
          _path41443_)))
  (define std/make#vector-for-each
    (lambda (_f41433_ _v41434_)
      (letrec* ((_l41436_ (vector-length _v41434_)))
        (let _loop41438_ ((_i41440_ '0))
          (if (< _i41440_ _l41436_)
              (begin
                (_f41433_ _i41440_ (vector-ref _v41434_ _i41440_))
                (_loop41438_ (+ '1 _i41440_)))
              '#!void)))))
  (define std/make#vector-ensure-ref
    (lambda (_v41424_ _i41425_ _f41426_)
      (let ((_$e41428_ (vector-ref _v41424_ _i41425_)))
        (if _$e41428_
            _$e41428_
            (let ((_x41431_ (_f41426_)))
              (vector-set! _v41424_ _i41425_ _x41431_)
              _x41431_)))))
  (define std/make#settings::t
    (make-struct-type
     'std/make#settings::t
     '#f
     '13
     'settings
     '((transparent: . #t))
     ':init!
     '(srcdir libdir
              bindir
              prefix
              force
              optimize
              debug
              static
              static-debug
              verbose
              build-deps
              libdir-prefix
              parallelize)))
  (define std/make#settings? (make-struct-predicate std/make#settings::t))
  (define std/make#make-settings
    (lambda _$args41421_
      (apply make-struct-instance std/make#settings::t _$args41421_)))
  (define std/make#settings-srcdir
    (make-struct-field-accessor std/make#settings::t '0))
  (define std/make#settings-libdir
    (make-struct-field-accessor std/make#settings::t '1))
  (define std/make#settings-bindir
    (make-struct-field-accessor std/make#settings::t '2))
  (define std/make#settings-prefix
    (make-struct-field-accessor std/make#settings::t '3))
  (define std/make#settings-force
    (make-struct-field-accessor std/make#settings::t '4))
  (define std/make#settings-optimize
    (make-struct-field-accessor std/make#settings::t '5))
  (define std/make#settings-debug
    (make-struct-field-accessor std/make#settings::t '6))
  (define std/make#settings-static
    (make-struct-field-accessor std/make#settings::t '7))
  (define std/make#settings-static-debug
    (make-struct-field-accessor std/make#settings::t '8))
  (define std/make#settings-verbose
    (make-struct-field-accessor std/make#settings::t '9))
  (define std/make#settings-build-deps
    (make-struct-field-accessor std/make#settings::t '10))
  (define std/make#settings-libdir-prefix
    (make-struct-field-accessor std/make#settings::t '11))
  (define std/make#settings-parallelize
    (make-struct-field-accessor std/make#settings::t '12))
  (define std/make#settings-srcdir-set!
    (make-struct-field-mutator std/make#settings::t '0))
  (define std/make#settings-libdir-set!
    (make-struct-field-mutator std/make#settings::t '1))
  (define std/make#settings-bindir-set!
    (make-struct-field-mutator std/make#settings::t '2))
  (define std/make#settings-prefix-set!
    (make-struct-field-mutator std/make#settings::t '3))
  (define std/make#settings-force-set!
    (make-struct-field-mutator std/make#settings::t '4))
  (define std/make#settings-optimize-set!
    (make-struct-field-mutator std/make#settings::t '5))
  (define std/make#settings-debug-set!
    (make-struct-field-mutator std/make#settings::t '6))
  (define std/make#settings-static-set!
    (make-struct-field-mutator std/make#settings::t '7))
  (define std/make#settings-static-debug-set!
    (make-struct-field-mutator std/make#settings::t '8))
  (define std/make#settings-verbose-set!
    (make-struct-field-mutator std/make#settings::t '9))
  (define std/make#settings-build-deps-set!
    (make-struct-field-mutator std/make#settings::t '10))
  (define std/make#settings-libdir-prefix-set!
    (make-struct-field-mutator std/make#settings::t '11))
  (define std/make#settings-parallelize-set!
    (make-struct-field-mutator std/make#settings::t '12))
  (define std/make#settings:::init!__%
    (lambda (_g304823_
             _srcdir_4131941333_
             _libdir_4132041335_
             _bindir_4132141337_
             _prefix_4132241339_
             _force?4132341341_
             _optimize4132441343_
             _debug4132541345_
             _static4132641347_
             _static-debug4132741349_
             _verbose4132841351_
             _build-deps_4132941353_
             _parallelize_4133041355_
             _self41357_)
      (let* ((_srcdir_41359_
              (if (eq? _srcdir_4131941333_ absent-value)
                  '#f
                  _srcdir_4131941333_))
             (_libdir_41361_
              (if (eq? _libdir_4132041335_ absent-value)
                  '#f
                  _libdir_4132041335_))
             (_bindir_41363_
              (if (eq? _bindir_4132141337_ absent-value)
                  '#f
                  _bindir_4132141337_))
             (_prefix_41365_
              (if (eq? _prefix_4132241339_ absent-value)
                  '#f
                  _prefix_4132241339_))
             (_force?41367_
              (if (eq? _force?4132341341_ absent-value)
                  '#f
                  _force?4132341341_))
             (_optimize41369_
              (if (eq? _optimize4132441343_ absent-value)
                  '#t
                  _optimize4132441343_))
             (_debug41371_
              (if (eq? _debug4132541345_ absent-value) 'env _debug4132541345_))
             (_static41373_
              (if (eq? _static4132641347_ absent-value)
                  '#t
                  _static4132641347_))
             (_static-debug41375_
              (if (eq? _static-debug4132741349_ absent-value)
                  '#f
                  _static-debug4132741349_))
             (_verbose41377_
              (if (eq? _verbose4132841351_ absent-value)
                  '#f
                  _verbose4132841351_))
             (_build-deps_41379_
              (if (eq? _build-deps_4132941353_ absent-value)
                  '#f
                  _build-deps_4132941353_))
             (_parallelize_41381_
              (if (eq? _parallelize_4133041355_ absent-value)
                  '#f
                  _parallelize_4133041355_)))
        (letrec* ((_gerbil-path41383_ (getenv '"GERBIL_PATH" '"~/.gerbil"))
                  (_srcdir41384_
                   (let ((_$e41404_ _srcdir_41359_))
                     (if _$e41404_
                         _$e41404_
                         (error '"srcdir must be specified"))))
                  (_libdir41385_
                   (let ((_$e41401_ _libdir_41361_))
                     (if _$e41401_
                         _$e41401_
                         (path-expand '"lib" _gerbil-path41383_))))
                  (_bindir41386_
                   (let ((_$e41398_ _bindir_41363_))
                     (if _$e41398_
                         _$e41398_
                         (path-expand '"bin" _gerbil-path41383_))))
                  (_prefix41387_
                   (let ((_$e41395_ _prefix_41365_))
                     (if _$e41395_
                         _$e41395_
                         (std/make#read-package-prefix _srcdir41384_))))
                  (_libdir-prefix41388_
                   (if _prefix41387_
                       (path-expand _prefix41387_ _libdir41385_)
                       _libdir41385_))
                  (_build-deps41389_
                   (path-expand
                    (let ((_$e41392_ _build-deps_41379_))
                      (if _$e41392_ _$e41392_ '"build-deps"))
                    _srcdir41384_))
                  (_parallelize41390_
                   (std/make#gerbil-build-cores__% _parallelize41390_)))
          (if (let ((__tmp304824
                     (let ()
                       (declare (not safe))
                       (##vector-length _self41357_))))
                (declare (not safe))
                (##fx< '13 __tmp304824))
              (begin
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41357_ '1 _srcdir41384_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41357_ '2 _libdir41385_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41357_ '3 _bindir41386_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41357_ '4 _prefix41387_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41357_ '5 _force?41367_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41357_ '6 _optimize41369_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41357_ '7 _debug41371_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41357_ '8 _static41373_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41357_ '9 _static-debug41375_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41357_ '10 _verbose41377_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41357_ '11 _build-deps41389_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41357_ '12 _libdir-prefix41388_))
                (let ()
                  (declare (not safe))
                  (##vector-set! _self41357_ '13 _parallelize41390_)))
              (error '"struct-instance-init!: too many arguments for struct"
                     _self41357_))))))
  (define std/make#settings:::init!__@
    (lambda (_keys4131841410_ . _args41412_)
      (apply std/make#settings:::init!__%
             _keys4131841410_
             (table-ref _keys4131841410_ 'srcdir: absent-value)
             (table-ref _keys4131841410_ 'libdir: absent-value)
             (table-ref _keys4131841410_ 'bindir: absent-value)
             (table-ref _keys4131841410_ 'prefix: absent-value)
             (table-ref _keys4131841410_ 'force: absent-value)
             (table-ref _keys4131841410_ 'optimize: absent-value)
             (table-ref _keys4131841410_ 'debug: absent-value)
             (table-ref _keys4131841410_ 'static: absent-value)
             (table-ref _keys4131841410_ 'static-debug: absent-value)
             (table-ref _keys4131841410_ 'verbose: absent-value)
             (table-ref _keys4131841410_ 'build-deps: absent-value)
             (table-ref _keys4131841410_ 'parallelize: absent-value)
             _args41412_)))
  (define std/make#settings:::init!
    (lambda _args4133141418_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                srcdir:
                #f
                #f
                #f
                #f
                #f
                #f
                force:
                #f
                #f
                #f
                #f
                #f
                libdir:
                #f
                optimize:
                #f
                #f
                #f
                parallelize:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                bindir:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                static:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                prefix:
                build-deps:
                #f
                #f
                #f
                static-debug:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                verbose:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                debug:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f)
             std/make#settings:::init!__@
             _args4133141418_)))
  (bind-method! std/make#settings::t ':init! std/make#settings:::init! '#f)
  (define std/make#gerbil-build-cores__%
    (lambda (_cpu-count-spec41183_)
      (if (real? _cpu-count-spec41183_)
          _cpu-count-spec41183_
          (if (eq? _cpu-count-spec41183_ '#t)
              (with-exception-catcher
               (lambda (_g304825_) '0)
               (lambda () (string->number (getenv '"GERBIL_BUILD_CORES"))))
              '0))))
  (define std/make#gerbil-build-cores__0
    (lambda ()
      (let ((_cpu-count-spec41191_ '#t))
        (std/make#gerbil-build-cores__% _cpu-count-spec41191_))))
  (define std/make#gerbil-build-cores
    (lambda _g304827_
      (let ((_g304826_ (let () (declare (not safe)) (##length _g304827_))))
        (cond ((let () (declare (not safe)) (##fx= _g304826_ 0))
               (apply std/make#gerbil-build-cores__0 _g304827_))
              ((let () (declare (not safe)) (##fx= _g304826_ 1))
               (apply std/make#gerbil-build-cores__% _g304827_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/make#gerbil-build-cores
                _g304827_))))))
  (define std/make#settings-verbose>=?
    (lambda (_settings41177_ _level41178_)
      (letrec* ((_verbose41180_
                 (##structure-ref
                  _settings41177_
                  '10
                  std/make#settings::t
                  '#f)))
        (if (real? _level41178_)
            (if (real? _verbose41180_) (>= _verbose41180_ _level41178_) '#f)
            '#f))))
  (define std/make#read-package-prefix
    (lambda (_srcdir41166_)
      (let* ((_plist41169_
              (with-exception-catcher
               false
               (lambda ()
                 (call-with-input-file
                  (path-expand '"gerbil.pkg" _srcdir41166_)
                  read))))
             (_pkg4117041172_ (pgetq 'package: _plist41169_)))
        (if _pkg4117041172_
            (let ((_pkg41175_ _pkg4117041172_))
              (if (symbol? _pkg41175_) (symbol->string _pkg41175_) '#f))
            '#f))))
  (define std/make#spec-type
    (lambda (_spec41126_)
      (let* ((_spec4112741137_ _spec41126_)
             (_else4113041145_
              (lambda () (error '"Bad buildspec" _spec41126_))))
        (let ((_K4113541163_ (lambda () 'gxc:))
              (_K4113241151_ (lambda (_type41149_) _type41149_)))
          (let ((_try-match4112941159_
                 (lambda ()
                   (if (let () (declare (not safe)) (##pair? _spec4112741137_))
                       (let ((_hd4113341154_
                              (let ()
                                (declare (not safe))
                                (##car _spec4112741137_))))
                         (if (keyword? _hd4113341154_)
                             (let ((_type41157_ _hd4113341154_))
                               (_K4113241151_ _type41157_))
                             (_else4113041145_)))
                       (_else4113041145_)))))
            (if (string? _spec4112741137_)
                (_K4113541163_)
                (_try-match4112941159_)))))))
  (define std/make#spec-file
    (lambda (_spec40896_ _settings40897_)
      (let* ((_spec4089840946_ _spec40896_)
             (_else4090740954_
              (lambda () (error '"Bad buildspec" _spec40896_))))
        (let ((_K4094441121_
               (lambda (_modf41119_)
                 (std/make#source-path _modf41119_ '".ss" _settings40897_)))
              (_K4093941099_
               (lambda (_opts41096_ _modf41097_)
                 (std/make#source-path _modf41097_ '".ss" _settings40897_)))
              (_K4093441075_
               (lambda (_opts41072_ _modf41073_)
                 (std/make#source-path _modf41073_ '".scm" _settings40897_)))
              (_K4092941051_
               (lambda (_deps41048_ _modf41049_)
                 (std/make#source-path _modf41049_ '".ssi" _settings40897_)))
              (_K4092441027_
               (lambda (_opts41024_ _modf41025_)
                 (std/make#source-path _modf41025_ '".ss" _settings40897_)))
              (_K4091941003_
               (lambda (_opts41000_ _modf41001_)
                 (std/make#source-path _modf41001_ '".ss" _settings40897_)))
              (_K4091440981_
               (lambda (_file40979_)
                 (std/make#static-file-path _file40979_ _settings40897_)))
              (_K4090940960_ (lambda (_file40958_) _file40958_)))
          (let ((_try-match4090041116_
                 (lambda ()
                   (if (let () (declare (not safe)) (##pair? _spec4089840946_))
                       (let ((_tl4094141104_
                              (let ()
                                (declare (not safe))
                                (##cdr _spec4089840946_)))
                             (_hd4094041102_
                              (let ()
                                (declare (not safe))
                                (##car _spec4089840946_))))
                         (if (let ()
                               (declare (not safe))
                               (##eq? _hd4094041102_ 'gxc:))
                             (if (let ()
                                   (declare (not safe))
                                   (##pair? _tl4094141104_))
                                 (let ((_tl4094341109_
                                        (let ()
                                          (declare (not safe))
                                          (##cdr _tl4094141104_)))
                                       (_hd4094241107_
                                        (let ()
                                          (declare (not safe))
                                          (##car _tl4094141104_))))
                                   (let ((_modf41112_ _hd4094241107_)
                                         (_opts41114_ _tl4094341109_))
                                     (_K4093941099_ _opts41114_ _modf41112_)))
                                 (_else4090740954_))
                             (if (let ()
                                   (declare (not safe))
                                   (##eq? _hd4094041102_ 'gsc:))
                                 (if (let ()
                                       (declare (not safe))
                                       (##pair? _tl4094141104_))
                                     (let ((_tl4093841085_
                                            (let ()
                                              (declare (not safe))
                                              (##cdr _tl4094141104_)))
                                           (_hd4093741083_
                                            (let ()
                                              (declare (not safe))
                                              (##car _tl4094141104_))))
                                       (let ((_modf41088_ _hd4093741083_)
                                             (_opts41090_ _tl4093841085_))
                                         (_K4093441075_
                                          _opts41090_
                                          _modf41088_)))
                                     (_else4090740954_))
                                 (if (let ()
                                       (declare (not safe))
                                       (##eq? _hd4094041102_ 'ssi:))
                                     (if (let ()
                                           (declare (not safe))
                                           (##pair? _tl4094141104_))
                                         (let ((_tl4093341061_
                                                (let ()
                                                  (declare (not safe))
                                                  (##cdr _tl4094141104_)))
                                               (_hd4093241059_
                                                (let ()
                                                  (declare (not safe))
                                                  (##car _tl4094141104_))))
                                           (let ((_modf41064_ _hd4093241059_)
                                                 (_deps41066_ _tl4093341061_))
                                             (_K4092941051_
                                              _deps41066_
                                              _modf41064_)))
                                         (_else4090740954_))
                                     (if (let ()
                                           (declare (not safe))
                                           (##eq? _hd4094041102_ 'exe:))
                                         (if (let ()
                                               (declare (not safe))
                                               (##pair? _tl4094141104_))
                                             (let ((_tl4092841037_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##cdr _tl4094141104_)))
                                                   (_hd4092741035_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##car _tl4094141104_))))
                                               (let ((_modf41040_
                                                      _hd4092741035_)
                                                     (_opts41042_
                                                      _tl4092841037_))
                                                 (_K4092441027_
                                                  _opts41042_
                                                  _modf41040_)))
                                             (_else4090740954_))
                                         (if (let ()
                                               (declare (not safe))
                                               (##eq? _hd4094041102_
                                                      'static-exe:))
                                             (if (let ()
                                                   (declare (not safe))
                                                   (##pair? _tl4094141104_))
                                                 (let ((_tl4092341013_
                                                        (let ()
                                                          (declare (not safe))
                                                          (##cdr _tl4094141104_)))
                                                       (_hd4092241011_
                                                        (let ()
                                                          (declare (not safe))
                                                          (##car _tl4094141104_))))
                                                   (let ((_modf41016_
                                                          _hd4092241011_)
                                                         (_opts41018_
                                                          _tl4092341013_))
                                                     (_K4091941003_
                                                      _opts41018_
                                                      _modf41016_)))
                                                 (_else4090740954_))
                                             (if (let ()
                                                   (declare (not safe))
                                                   (##eq? _hd4094041102_
                                                          'static-include:))
                                                 (if (let ()
                                                       (declare (not safe))
                                                       (##pair? _tl4094141104_))
                                                     (let ((_tl4091840991_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##cdr _tl4094141104_)))
                                                           (_hd4091740989_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##car _tl4094141104_))))
                                                       (if (let ()
                                                             (declare
                                                               (not safe))
                                                             (##null? _tl4091840991_))
                                                           (let ((_file40994_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _hd4091740989_))
                     (_K4091440981_ _file40994_))
                   (_else4090740954_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_else4090740954_))
                                                 (if (let ()
                                                       (declare (not safe))
                                                       (##eq? _hd4094041102_
                                                              'copy:))
                                                     (if (let ()
                                                           (declare (not safe))
                                                           (##pair? _tl4094141104_))
                                                         (let ((_tl4091340970_
                                                                (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (declare (not safe))
                          (##cdr _tl4094141104_)))
                       (_hd4091240968_
                        (let () (declare (not safe)) (##car _tl4094141104_))))
                   (if (let () (declare (not safe)) (##null? _tl4091340970_))
                       (let ((_file40973_ _hd4091240968_))
                         (_K4090940960_ _file40973_))
                       (_else4090740954_)))
                 (_else4090740954_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_else4090740954_)))))))))
                       (_else4090740954_)))))
            (if (string? _spec4089840946_)
                (let ((_modf41124_ _spec4089840946_))
                  (_K4094441121_ _modf41124_))
                (_try-match4090041116_)))))))
  (define std/make#spec-inputs
    (lambda (_spec40889_ _settings40890_)
      (cons (std/make#spec-file _spec40889_ _settings40890_)
            (foldr1 cons
                    (std/srfi/1#append-map
                     (lambda (_g4089140893_)
                       (std/make#spec-inputs _g4089140893_ _settings40890_))
                     (std/make#spec-submodules _spec40889_))
                    (std/make#spec-extra-inputs
                     _spec40889_
                     _settings40890_)))))
  (define std/make#spec-extra-inputs
    (lambda (_spec40841_ _settings40842_)
      (let* ((_spec4084340856_ _spec40841_)
             (_E4084740860_
              (lambda () (error '"No clause matching" _spec4084340856_))))
        (let ((_K4085240883_
               (lambda ()
                 (pgetq 'extra-inputs: (std/make#spec-plist _spec40841_) '())))
              (_K4084940873_
               (lambda ()
                 (pgetq 'extra-inputs: (std/make#spec-plist _spec40841_) '())))
              (_K4084840865_ (lambda () '())))
          (if (let () (declare (not safe)) (##pair? _spec4084340856_))
              (let ((_hd4085340886_
                     (let () (declare (not safe)) (##car _spec4084340856_))))
                (if (let () (declare (not safe)) (##eq? _hd4085340886_ 'gxc:))
                    (_K4085240883_)
                    (if (let ()
                          (declare (not safe))
                          (##eq? _hd4085340886_ 'gsc:))
                        (_K4084940873_)
                        (_K4084840865_))))
              (_K4084840865_))))))
  (define std/make#spec-submodules
    (lambda (_spec40784_)
      (let* ((_spec4078540800_ _spec40784_)
             (_E4078940804_
              (lambda () (error '"No clause matching" _spec4078540800_))))
        (let ((_K4079640835_
               (lambda ()
                 (pgetq 'submodules: (std/make#spec-plist _spec40784_) '())))
              (_K4079140818_ (lambda (_submodules40816_) _submodules40816_))
              (_K4079040809_ (lambda () '())))
          (if (let () (declare (not safe)) (##pair? _spec4078540800_))
              (let ((_hd4079740838_
                     (let () (declare (not safe)) (##car _spec4078540800_))))
                (if (let () (declare (not safe)) (##eq? _hd4079740838_ 'gxc:))
                    (_K4079640835_)
                    (let ((_tl4079340823_
                           (let ()
                             (declare (not safe))
                             (##cdr _spec4078540800_))))
                      (if (let ()
                            (declare (not safe))
                            (##eq? _hd4079740838_ 'ssi:))
                          (if (let ()
                                (declare (not safe))
                                (##pair? _tl4079340823_))
                              (let* ((_tl4079540826_
                                      (let ()
                                        (declare (not safe))
                                        (##cdr _tl4079340823_)))
                                     (_submodules40829_ _tl4079540826_))
                                (_K4079140818_ _submodules40829_))
                              (_K4079040809_))
                          (_K4079040809_)))))
              (_K4079040809_))))))
  (define std/make#spec-plist
    (lambda (_spec40707_)
      (let* ((_spec4070840727_ _spec40707_)
             (_E4071140731_
              (lambda () (error '"No clause matching" _spec4070840727_))))
        (let ((_K4071340744_ (lambda (_plist40742_) _plist40742_))
              (_K4071240736_ (lambda () '())))
          (let ((___match304615304616_
                 (lambda (_hd4071440747_
                          _tl4071540749_
                          _tl4071740756_
                          _hd4071840759_)
                   (letrec ((_splice-rest4072140762_
                             (lambda (_rest4072540769_ _plist40771_)
                               (if (let ()
                                     (declare (not safe))
                                     (##null? _rest4072540769_))
                                   (_K4071340744_ _plist40771_)
                                   (_K4071240736_))))
                            (_splice-try4072340764_
                             (lambda (_hd4072440773_
                                      _rest4072540775_
                                      _plist4072040776_)
                               (let ((_plist40779_ _hd4072440773_))
                                 (_splice-loop4072240766_
                                  (let ()
                                    (declare (not safe))
                                    (##cdr _rest4072540775_))
                                  (cons _plist40779_ _plist4072040776_)))))
                            (_splice-loop4072240766_
                             (lambda (_rest4072540781_ _plist4072040782_)
                               (if (pair? _rest4072540781_)
                                   (_splice-try4072340764_
                                    (let ()
                                      (declare (not safe))
                                      (##car _rest4072540781_))
                                    _rest4072540781_
                                    _plist4072040782_)
                                   (_splice-rest4072140762_
                                    _rest4072540781_
                                    (reverse _plist4072040782_))))))
                     (_splice-loop4072240766_ _hd4071840759_ '())))))
            (if (let () (declare (not safe)) (##pair? _spec4070840727_))
                (let ((_tl4071540749_
                       (let () (declare (not safe)) (##cdr _spec4070840727_)))
                      (_hd4071440747_
                       (let () (declare (not safe)) (##car _spec4070840727_))))
                  (if ((lambda (_g4075140753_)
                         (member _g4075140753_ '(gxc: gsc:)))
                       _hd4071440747_)
                      (if (let ()
                            (declare (not safe))
                            (##pair? _tl4071540749_))
                          (let ((_tl4071740756_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _tl4071540749_))))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl4071740756_))
                                (let ((_hd4071840759_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl4071740756_))))
                                  (___match304615304616_
                                   _hd4071440747_
                                   _tl4071540749_
                                   _tl4071740756_
                                   _hd4071840759_))
                                (_K4071240736_)))
                          (_K4071240736_))
                      (_K4071240736_)))
                (_K4071240736_)))))))
  (define std/make#spec-outputs
    (lambda (_spec40473_ _settings40474_)
      (let* ((_spec4047540523_ _spec40473_)
             (_else4048440531_
              (lambda () (error '"Bad buildspec" _spec40473_))))
        (let ((_K4052140702_
               (lambda (_modf40700_)
                 (std/make#gxc-outputs _modf40700_ '#f _settings40474_)))
              (_K4051640680_
               (lambda (_opts40677_ _modf40678_)
                 (std/make#gxc-outputs
                  _modf40678_
                  _opts40677_
                  _settings40474_)))
              (_K4051140656_
               (lambda (_opts40653_ _modf40654_)
                 (cons (std/make#gsc-c-path _modf40654_ _settings40474_) '())))
              (_K4050640632_
               (lambda (_submodules40625_ _modf40626_)
                 (cons (std/make#library-path
                        _modf40626_
                        '".ssi"
                        _settings40474_)
                       (std/srfi/1#append-map
                        (lambda (_g4062740629_)
                          (std/make#spec-outputs
                           _g4062740629_
                           _settings40474_))
                        _submodules40625_))))
              (_K4050140604_
               (lambda (_opts40601_ _modf40602_)
                 (cons (std/make#library-path
                        _modf40602_
                        '".ssi"
                        _settings40474_)
                       (cons (std/make#binary-path
                              _modf40602_
                              _opts40601_
                              _settings40474_)
                             '()))))
              (_K4049640580_
               (lambda (_opts40577_ _modf40578_)
                 (cons (std/make#binary-path
                        _modf40578_
                        _opts40577_
                        _settings40474_)
                       (cons (std/make#static-path _modf40578_ _settings40474_)
                             '()))))
              (_K4049140558_
               (lambda (_file40556_)
                 (cons (std/make#static-file-path _file40556_ _settings40474_)
                       '())))
              (_K4048640537_
               (lambda (_file40535_)
                 (cons (std/make#library-path _file40535_ '#f _settings40474_)
                       '()))))
          (let ((_try-match4047740697_
                 (lambda ()
                   (if (let () (declare (not safe)) (##pair? _spec4047540523_))
                       (let ((_tl4051840685_
                              (let ()
                                (declare (not safe))
                                (##cdr _spec4047540523_)))
                             (_hd4051740683_
                              (let ()
                                (declare (not safe))
                                (##car _spec4047540523_))))
                         (if (let ()
                               (declare (not safe))
                               (##eq? _hd4051740683_ 'gxc:))
                             (if (let ()
                                   (declare (not safe))
                                   (##pair? _tl4051840685_))
                                 (let ((_tl4052040690_
                                        (let ()
                                          (declare (not safe))
                                          (##cdr _tl4051840685_)))
                                       (_hd4051940688_
                                        (let ()
                                          (declare (not safe))
                                          (##car _tl4051840685_))))
                                   (let ((_modf40693_ _hd4051940688_)
                                         (_opts40695_ _tl4052040690_))
                                     (_K4051640680_ _opts40695_ _modf40693_)))
                                 (_else4048440531_))
                             (if (let ()
                                   (declare (not safe))
                                   (##eq? _hd4051740683_ 'gsc:))
                                 (if (let ()
                                       (declare (not safe))
                                       (##pair? _tl4051840685_))
                                     (let ((_tl4051540666_
                                            (let ()
                                              (declare (not safe))
                                              (##cdr _tl4051840685_)))
                                           (_hd4051440664_
                                            (let ()
                                              (declare (not safe))
                                              (##car _tl4051840685_))))
                                       (let ((_modf40669_ _hd4051440664_)
                                             (_opts40671_ _tl4051540666_))
                                         (_K4051140656_
                                          _opts40671_
                                          _modf40669_)))
                                     (_else4048440531_))
                                 (if (let ()
                                       (declare (not safe))
                                       (##eq? _hd4051740683_ 'ssi:))
                                     (if (let ()
                                           (declare (not safe))
                                           (##pair? _tl4051840685_))
                                         (let ((_tl4051040642_
                                                (let ()
                                                  (declare (not safe))
                                                  (##cdr _tl4051840685_)))
                                               (_hd4050940640_
                                                (let ()
                                                  (declare (not safe))
                                                  (##car _tl4051840685_))))
                                           (let ((_modf40645_ _hd4050940640_)
                                                 (_submodules40647_
                                                  _tl4051040642_))
                                             (_K4050640632_
                                              _submodules40647_
                                              _modf40645_)))
                                         (_else4048440531_))
                                     (if (let ()
                                           (declare (not safe))
                                           (##eq? _hd4051740683_ 'exe:))
                                         (if (let ()
                                               (declare (not safe))
                                               (##pair? _tl4051840685_))
                                             (let ((_tl4050540614_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##cdr _tl4051840685_)))
                                                   (_hd4050440612_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##car _tl4051840685_))))
                                               (let ((_modf40617_
                                                      _hd4050440612_)
                                                     (_opts40619_
                                                      _tl4050540614_))
                                                 (_K4050140604_
                                                  _opts40619_
                                                  _modf40617_)))
                                             (_else4048440531_))
                                         (if (let ()
                                               (declare (not safe))
                                               (##eq? _hd4051740683_
                                                      'static-exe:))
                                             (if (let ()
                                                   (declare (not safe))
                                                   (##pair? _tl4051840685_))
                                                 (let ((_tl4050040590_
                                                        (let ()
                                                          (declare (not safe))
                                                          (##cdr _tl4051840685_)))
                                                       (_hd4049940588_
                                                        (let ()
                                                          (declare (not safe))
                                                          (##car _tl4051840685_))))
                                                   (let ((_modf40593_
                                                          _hd4049940588_)
                                                         (_opts40595_
                                                          _tl4050040590_))
                                                     (_K4049640580_
                                                      _opts40595_
                                                      _modf40593_)))
                                                 (_else4048440531_))
                                             (if (let ()
                                                   (declare (not safe))
                                                   (##eq? _hd4051740683_
                                                          'static-include:))
                                                 (if (let ()
                                                       (declare (not safe))
                                                       (##pair? _tl4051840685_))
                                                     (let ((_tl4049540568_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##cdr _tl4051840685_)))
                                                           (_hd4049440566_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##car _tl4051840685_))))
                                                       (if (let ()
                                                             (declare
                                                               (not safe))
                                                             (##null? _tl4049540568_))
                                                           (let ((_file40571_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _hd4049440566_))
                     (_K4049140558_ _file40571_))
                   (_else4048440531_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_else4048440531_))
                                                 (if (let ()
                                                       (declare (not safe))
                                                       (##eq? _hd4051740683_
                                                              'copy:))
                                                     (if (let ()
                                                           (declare (not safe))
                                                           (##pair? _tl4051840685_))
                                                         (let ((_tl4049040547_
                                                                (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (declare (not safe))
                          (##cdr _tl4051840685_)))
                       (_hd4048940545_
                        (let () (declare (not safe)) (##car _tl4051840685_))))
                   (if (let () (declare (not safe)) (##null? _tl4049040547_))
                       (let ((_file40550_ _hd4048940545_))
                         (_K4048640537_ _file40550_))
                       (_else4048440531_)))
                 (_else4048440531_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_else4048440531_)))))))))
                       (_else4048440531_)))))
            (if (string? _spec4047540523_)
                (let ((_modf40705_ _spec4047540523_))
                  (_K4052140702_ _modf40705_))
                (_try-match4047740697_)))))))
  (define std/make#spec-backgroundable?
    (lambda (_spec40468_)
      (let ((_$e40470_ (std/make#spec-type _spec40468_)))
        (if (eq? 'gxc: _$e40470_)
            (not (pgetq 'foreground: (std/make#spec-plist _spec40468_)))
            (if (eq? 'gsc: _$e40470_) '#t '#f)))))
  (define std/make#cache (make-parameter '#f))
  (define std/make#cache-put!
    (lambda (_key40463_ _value40464_)
      (letrec* ((_c40466_ (std/make#cache)))
        (if _c40466_ (table-set! _c40466_ _key40463_ _value40464_) '#!void)
        _value40464_)))
  (define std/make#cache-remove!
    (lambda (_key40459_)
      (letrec* ((_c40461_ (std/make#cache)))
        (if _c40461_ (table-set! _c40461_ _key40459_) '#!void))))
  (define std/make#call-with-cache__%
    (lambda (_key40444_ _thunk40445_)
      (letrec* ((_c40447_ (std/make#cache)))
        (if _c40447_
            (std/misc/hash#hash-ensure-ref _c40447_ _key40444_ _thunk40445_)
            (_thunk40445_)))))
  (define std/make#call-with-cache__0
    (lambda (_key40452_)
      (let ((_thunk40454_ false))
        (std/make#call-with-cache__% _key40452_ _thunk40454_))))
  (define std/make#call-with-cache
    (lambda _g304829_
      (let ((_g304828_ (let () (declare (not safe)) (##length _g304829_))))
        (cond ((let () (declare (not safe)) (##fx= _g304828_ 1))
               (apply std/make#call-with-cache__0 _g304829_))
              ((let () (declare (not safe)) (##fx= _g304828_ 2))
               (apply std/make#call-with-cache__% _g304829_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/make#call-with-cache
                _g304829_))))))
  (define std/make#call-with-fresh-cache
    (lambda (_thunk40437_)
      (call-with-parameters
       (lambda () (_thunk40437_))
       std/make#cache
       (let ((_ht40440_ (make-table 'size: '0))) _ht40440_))))
  (define std/make#modification-time
    (lambda (_file40429_)
      (call-with-current-continuation
       (lambda (_return40431_)
         (letrec* ((_info40433_
                    (with-exception-catcher
                     (lambda (_g304830_) (_return40431_ '#f))
                     (lambda () (file-info _file40429_ '#t)))))
           (time->seconds (file-info-last-modification-time _info40433_)))))))
  (define std/make#modification-time/cache
    (lambda (_file40426_)
      (std/make#call-with-cache__%
       (cons 'modification-time (cons _file40426_ '()))
       (lambda () (std/make#modification-time _file40426_)))))
  (define std/make#file-timestamp
    (lambda (_file40421_)
      (let ((_$e40423_ (std/make#modification-time/cache _file40421_)))
        (if _$e40423_ _$e40423_ '+inf.0))))
  (define std/make#module-strip-nesting
    (lambda (_module40412_)
      (letrec* ((_name40414_ (symbol->string _module40412_)))
        (let ((_$e40416_ (string-rindex _name40414_ '#\$)))
          (if _$e40416_
              ((lambda (_ix40419_)
                 (string->symbol (substring _name40414_ '0 _ix40419_)))
               _$e40416_)
              _module40412_)))))
  (define std/make#library-symbol
    (lambda (_module40410_)
      (make-symbol '":" (std/make#module-strip-nesting _module40410_))))
  (define std/make#library-file
    (lambda (_library40405_)
      (with-exception-catcher
       (lambda (_e40407_)
         (error '"missing library"
                'context:
                'library-file
                'library:
                _library40405_
                'symbol:
                (std/make#library-symbol _library40405_)
                'load-path:
                (let ((__values304819 (load-path)))
                  (if (let () (declare (not safe)) (##values? __values304819))
                      (let ()
                        (declare (not safe))
                        (##vector->list __values304819))
                      (list __values304819)))
                'error-message:
                (error-message _e40407_)
                'error:
                _e40407_))
       (lambda ()
         (gx#core-resolve-library-module-path
          (std/make#library-symbol _library40405_))))))
  (define std/make#library-timestamp
    (lambda (_library40403_)
      (std/make#file-timestamp (std/make#library-file _library40403_))))
  (define std/make#build-deps-tag 'gerbil-build-deps-v2:)
  (define std/make#read-build-deps
    (lambda (_file40361_)
      (let* ((_g4036240372_
              (with-exception-catcher
               void
               (lambda () (call-with-input-file _file40361_ read))))
             (_E4036540376_
              (lambda () (error '"No clause matching" _g4036240372_))))
        (let ((_K4036740389_ (lambda (_s40387_) _s40387_))
              (_K4036640381_ (lambda () '())))
          (if (let () (declare (not safe)) (##pair? _g4036240372_))
              (let ((_tl4036940394_
                     (let () (declare (not safe)) (##cdr _g4036240372_)))
                    (_hd4036840392_
                     (let () (declare (not safe)) (##car _g4036240372_))))
                (if ((lambda (_g4039640398_)
                       (equal? _g4039640398_ std/make#build-deps-tag))
                     _hd4036840392_)
                    (let ((_s40401_ _tl4036940394_)) (_K4036740389_ _s40401_))
                    (_K4036640381_)))
              (_K4036640381_))))))
  (define std/make#write-build-deps
    (lambda (_file40356_ _build-deps40357_)
      (create-directory* (path-directory _file40356_))
      (call-with-output-file
       _file40356_
       (lambda (_port40359_)
         (pretty-print
          (cons std/make#build-deps-tag _build-deps40357_)
          _port40359_)
         (newline _port40359_)))))
  (define std/make#make
    (lambda _args40312_
      (letrec* ((_g304831_
                 (let ((_g304832_
                        (std/misc/list#separate-keyword-arguments__%
                         _args40312_
                         '#t)))
                   (let ((_g304833_
                          (let ()
                            (declare (not safe))
                            (if (##values? _g304832_)
                                (##vector-length _g304832_)
                                1))))
                     (if (not (let ()
                                (declare (not safe))
                                (##fx= _g304833_ 2)))
                         (error "Context expects 2 values" _g304833_)))
                   _g304832_))
                (_positionals40314_
                 (let () (declare (not safe)) (##vector-ref _g304831_ 0)))
                (_keywords40315_
                 (let () (declare (not safe)) (##vector-ref _g304831_ 1)))
                (_buildspec40316_
                 (let* ((_positionals4032040329_ _positionals40314_)
                        (_E4032340333_
                         (lambda ()
                           (error '"No clause matching"
                                  _positionals4032040329_))))
                   (let ((_K4032540346_ (lambda (_x40344_) _x40344_))
                         (_K4032440338_
                          (lambda ()
                            (error '"invalid arguments"
                                   std/make#make
                                   _positionals40314_))))
                     (if (let ()
                           (declare (not safe))
                           (##pair? _positionals4032040329_))
                         (let ((_tl4032740351_
                                (let ()
                                  (declare (not safe))
                                  (##cdr _positionals4032040329_)))
                               (_hd4032640349_
                                (let ()
                                  (declare (not safe))
                                  (##car _positionals4032040329_))))
                           (if (let ()
                                 (declare (not safe))
                                 (##null? _tl4032740351_))
                               (let ((_x40354_ _hd4032640349_))
                                 (_K4032540346_ _x40354_))
                               (_K4032440338_)))
                         (_K4032440338_)))))
                (_settings40317_
                 (apply std/make#make-settings _keywords40315_)))
        (call-with-parameters
         (lambda ()
           (std/make#call-with-fresh-cache
            (lambda () (std/make#%make _buildspec40316_ _settings40317_))))
         current-directory
         (##structure-ref _settings40317_ '1 std/make#settings::t '#f)
         gx#current-expander-compiling?
         '#t))))
  (define std/make#%make
    (lambda (_buildspec39919_ _settings39920_)
      (letrec* ((_force?39922_
                 (##structure-ref _settings39920_ '5 std/make#settings::t '#f))
                (_build-deps-file39923_
                 (##structure-ref
                  _settings39920_
                  '11
                  std/make#settings::t
                  '#f))
                (_verbose39924_
                 (##structure-ref
                  _settings39920_
                  '10
                  std/make#settings::t
                  '#f))
                (_verbose>=?39925_
                 (lambda (_n40310_)
                   (std/make#settings-verbose>=? _settings39920_ _n40310_)))
                (_g304834_
                 (let ((_g304835_
                        (if (_verbose>=?39925_ '3)
                            (std/make#writeln
                             (cons 'Step:
                                   (cons '0
                                         (cons 'settings:
                                               (cons _settings39920_ '())))))
                            '#!void)))
                   #!void
                   _g304835_))
                (_spec@39926_
                 (list->vector
                  (std/make#normalize-buildspec _buildspec39919_)))
                (_nspec39927_ (vector-length _spec@39926_))
                (_specvec39928_ (lambda () (make-vector _nspec39927_ '#f)))
                (_spec-index%39929_
                 (std/misc/hash#invert-hash<-vector__%
                  '#f
                  absent-value
                  absent-value
                  absent-value
                  absent-value
                  _spec@39926_))
                (_id@39930_ (_specvec39928_))
                (_id-index%39931_
                 (let ((_ht40306_ (make-table 'size: '0))) _ht40306_))
                (_deps@39932_ (_specvec39928_))
                (_timestamp%39933_
                 (let ((_ht40303_ (make-table 'size: '0))) _ht40303_))
                (_blocked-by@39934_ (_specvec39928_))
                (_blocking@39935_ (_specvec39928_))
                (_ready-fg39936_
                 (let ((__obj304820
                        (make-object std/misc/pqueue#pqueue::t '3)))
                   (std/misc/pqueue#pqueue:::init!__1 __obj304820 identity <)
                   __obj304820))
                (_ready-bg39937_
                 (let ((__obj304821
                        (make-object std/misc/pqueue#pqueue::t '3)))
                   (std/misc/pqueue#pqueue:::init!__1 __obj304821 identity >)
                   __obj304821))
                (_g304837_
                 (let ((_g304838_
                        (if (_verbose>=?39925_ '3)
                            (std/make#writeln
                             (cons 'Step:
                                   (cons '1
                                         (cons 'spec@:
                                               (cons _spec@39926_ '())))))
                            '#!void)))
                   #!void
                   _g304838_))
                (_dependency-timestamp39938_
                 (lambda (_dep40298_)
                   (with-exception-catcher
                    (lambda (_g304840_) '+inf.0)
                    (lambda ()
                      (std/misc/hash#hash-ensure-ref
                       _timestamp%39933_
                       _dep40298_
                       (lambda () (std/make#library-timestamp _dep40298_)))))))
                (_g304841_
                 (let ((_g304842_
                        (let ((_build-deps-timestamp3993939942_
                               (std/make#modification-time/cache
                                _build-deps-file39923_))
                              (_previous@3994039944_
                               (std/make#read-build-deps
                                _build-deps-file39923_)))
                          (if _build-deps-timestamp3993939942_
                              (if _previous@3994039944_
                                  (let ((_build-deps-timestamp39947_
                                         _build-deps-timestamp3993939942_)
                                        (_previous@39948_
                                         _previous@3994039944_))
                                    (letrec* ((_previous-out-of-date%39950_
                                               (let ((_ht39976_
                                                      (make-table 'size: '0)))
                                                 _ht39976_))
                                              (_previous-file-up-to-date?39951_
                                               (lambda (_file39974_)
                                                 (<= (std/make#file-timestamp
                                                      _file39974_)
                                                     _build-deps-timestamp39947_)))
                                              (_previous-dependency-up-to-date?39952_
                                               (lambda (_dep39969_)
                                                 (let ((_$e39971_
                                                        (table-ref
                                                         _id-index%39931_
                                                         _dep39969_
                                                         '#f)))
                                                   (if _$e39971_
                                                       _$e39971_
                                                       (if (not (table-ref
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _previous-out-of-date%39950_
                         _dep39969_
                         '#f))
                   (<= (_dependency-timestamp39938_ _dep39969_)
                       _build-deps-timestamp39947_)
                   '#f)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (_previous-entry-up-to-date?39953_
                                               (lambda (_spec39966_
                                                        _deps39967_)
                                                 (if (andmap1 _previous-file-up-to-date?39951_
                                                              (std/make#spec-inputs
                                                               _spec39966_
                                                               _settings39920_))
                                                     (andmap1 _previous-dependency-up-to-date?39952_
                                                              _deps39967_)
                                                     '#f)))
                                              (_consider-previous39954_
                                               (lambda (_id39960_
                                                        _spec39961_
                                                        _deps39962_)
                                                 (if (_verbose>=?39925_ '7)
                                                     (std/make#writeln
                                                      (cons 'previous:
                                                            (cons _id39960_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (cons 'spec:
                                (cons _spec39961_
                                      (cons 'deps:
                                            (cons _deps39962_
                                                  (cons 'target:
                                                        (cons (table-ref
                                                               _spec-index%39929_
                                                               _spec39961_
                                                               '#f)
                                                              (cons 'up-to-date?:
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            (cons (if (table-ref
                                       _spec-index%39929_
                                       _spec39961_
                                       '#f)
                                      (_previous-entry-up-to-date?39953_
                                       _spec39961_
                                       _deps39962_)
                                      '#f)
                                  '())))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     '#!void)
                                                 (letrec* ((_target39964_
                                                            (table-ref
                                                             _spec-index%39929_
                                                             _spec39961_
                                                             '#f)))
                                                   (if (and _target39964_
                                                            (_previous-entry-up-to-date?39953_
                                                             _spec39961_
                                                             _deps39962_))
                                                       (begin
                                                         (vector-set!
                                                          _id@39930_
                                                          _target39964_
                                                          _id39960_)
                                                         (table-set!
                                                          _id-index%39931_
                                                          _id39960_
                                                          _target39964_)
                                                         (vector-set!
                                                          _deps@39932_
                                                          _target39964_
                                                          _deps39962_))
                                                       (table-set!
                                                        _previous-out-of-date%39950_
                                                        _id39960_
                                                        '#t))))))
                                      (for-each
                                       (lambda (_g3995539957_)
                                         (apply _consider-previous39954_
                                                _g3995539957_))
                                       _previous@39948_)))
                                  '#f)
                              '#f))))
                   #!void
                   _g304842_))
                (_g304844_
                 (let ((_g304845_
                        (if (_verbose>=?39925_ '3)
                            (std/make#writeln
                             (cons 'Step:
                                   (cons '2
                                         (cons 'previous-up-to-date:
                                               (cons (std/misc/hash#hash->list/sort
                                                      _id-index%39931_
                                                      std/misc/symbol#symbol<?)
                                                     '())))))
                            '#!void)))
                   #!void
                   _g304845_))
                (_g304847_
                 (let ((_g304848_
                        ((lambda (_g3997839980_)
                           (std/make#vector-for-each
                            _g3997839980_
                            _spec@39926_))
                         (lambda (_target39983_ _spec39984_)
                           (if (_verbose>=?39925_ '7)
                               (std/make#writeln
                                (cons 'Step:
                                      (cons '3.
                                            (cons 'target:
                                                  (cons _target39983_
                                                        (cons _spec39984_
                                                              '()))))))
                               '#!void)
                           (if (vector-ref _id@39930_ _target39983_)
                               '#!void
                               (let ((_g304850_
                                      (std/make#file-dependencies
                                       (std/make#spec-file
                                        _spec39984_
                                        _settings39920_)
                                       _settings39920_)))
                                 (begin
                                   (let ((_g304851_
                                          (let ()
                                            (declare (not safe))
                                            (if (##values? _g304850_)
                                                (##vector-length _g304850_)
                                                1))))
                                     (if (not (let ()
                                                (declare (not safe))
                                                (##fx= _g304851_ 2)))
                                         (error "Context expects 2 values"
                                                _g304851_)))
                                   (let ((_id39986_
                                          (let ()
                                            (declare (not safe))
                                            (##vector-ref _g304850_ 0)))
                                         (_deps39987_
                                          (let ()
                                            (declare (not safe))
                                            (##vector-ref _g304850_ 1))))
                                     (begin
                                       (if (_verbose>=?39925_ '7)
                                           (std/make#writeln
                                            (cons _target39983_
                                                  (cons _spec39984_
                                                        (cons _id39986_
                                                              (cons _deps39987_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            '())))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                           '#!void)
                                       (vector-set!
                                        _id@39930_
                                        _target39983_
                                        _id39986_)
                                       (table-set!
                                        _id-index%39931_
                                        _id39986_
                                        _target39983_)
                                       (vector-set!
                                        _deps@39932_
                                        _target39983_
                                        _deps39987_))))))))))
                   #!void
                   _g304848_))
                (_g304852_
                 (let ((_g304853_
                        (if (_verbose>=?39925_ '3)
                            (std/make#writeln
                             (cons 'Step:
                                   (cons '3
                                         (cons 'deps:
                                               (cons (apply std/srfi/1#srfi-1-map
                                                            list
                                                            (map vector->list
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (cons _id@39930_
                               (cons _spec@39926_ (cons _deps@39932_ '())))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     '())))))
                            '#!void)))
                   #!void
                   _g304853_))
                (_blockings39988_
                 (lambda (_blocks40284_)
                   (let _loop40286_ ((_i40288_ (- _nspec39927_ '1))
                                     (_l40289_ '()))
                     (if (> '0 _i40288_)
                         _l40289_
                         (let* ((_h140291_ (vector-ref _blocks40284_ _i40288_))
                                (_h240293_
                                 (if _h140291_ (hash-keys _h140291_) '#f))
                                (_h340295_
                                 (if _h240293_
                                     (if (pair? _h240293_) _h240293_ '#f)
                                     '#f)))
                           (_loop40286_
                            (- _i40288_ '1)
                            (if _h340295_
                                (cons (cons _i40288_ (cons _h340295_ '()))
                                      _l40289_)
                                _l40289_)))))))
                (_init-walk39989_
                 (lambda ()
                   (if (_verbose>=?39925_ '8)
                       (std/make#writeln
                        (cons 'ready-fg:
                              (cons (std/misc/pqueue#pqueue-contents
                                     _ready-fg39936_)
                                    (cons 'ready-bg:
                                          (cons (std/misc/pqueue#pqueue-contents
                                                 _ready-bg39937_)
                                                (cons 'blocked-by:
                                                      (cons (_blockings39988_
                                                             _blocked-by@39934_)
                                                            (cons 'len:
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (cons (length (_blockings39988_ _blocked-by@39934_))
                                (cons 'blocking:
                                      (cons (_blockings39988_ _blocking@39935_)
                                            (cons 'len:
                                                  (cons (length (_blockings39988_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _blocking@39935_))
                '())))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                       '#!void)
                   (let ((_g4024640248_ (_blockings39988_ _blocked-by@39934_)))
                     (if (null? _g4024640248_)
                         '#!void
                         (std/assert#assert!/fail
                          '"\"make.ss\"@358.14"
                          '(null? (blockings blocked-by@))
                          (cons (cons '(blockings blocked-by@) _g4024640248_)
                                '()))))
                   (let ((_g4025040252_ (_blockings39988_ _blocking@39935_)))
                     (if (null? _g4025040252_)
                         '#!void
                         (std/assert#assert!/fail
                          '"\"make.ss\"@359.14"
                          '(null? (blockings blocking@))
                          (cons (cons '(blockings blocking@) _g4025040252_)
                                '()))))
                   (let ((_ready-fg4025440256_ _ready-fg39936_))
                     (if (std/misc/pqueue#pqueue-empty? _ready-fg4025440256_)
                         '#!void
                         (std/assert#assert!/fail
                          '"\"make.ss\"@360.14"
                          '(pqueue-empty? ready-fg)
                          (cons (cons 'ready-fg _ready-fg4025440256_) '()))))
                   (let ((_ready-bg4025840260_ _ready-bg39937_))
                     (if (std/misc/pqueue#pqueue-empty? _ready-bg4025840260_)
                         '#!void
                         (std/assert#assert!/fail
                          '"\"make.ss\"@361.14"
                          '(pqueue-empty? ready-bg)
                          (cons (cons 'ready-bg _ready-bg4025840260_) '()))))
                   ((lambda (_g4026240264_)
                      (std/make#vector-for-each _g4026240264_ _deps@39932_))
                    (lambda (_target40267_ _deps40268_)
                      ((lambda (_g4026940271_)
                         (for-each _g4026940271_ _deps40268_))
                       (lambda (_dep40274_)
                         (let ((_other-target40276_
                                (table-ref _id-index%39931_ _dep40274_ '#f)))
                           (if _other-target40276_
                               (begin
                                 (table-set!
                                  (std/make#vector-ensure-ref
                                   _blocked-by@39934_
                                   _target40267_
                                   make-hash-table)
                                  _other-target40276_
                                  '#t)
                                 (table-set!
                                  (std/make#vector-ensure-ref
                                   _blocking@39935_
                                   _other-target40276_
                                   make-hash-table)
                                  _target40267_
                                  '#t))
                               '#!void))))))
                   ((lambda (_g4027740279_)
                      (std/make#vector-for-each _g4027740279_ _spec@39926_))
                    (lambda (_target40282_ _g304855_)
                      (if (vector-ref _blocked-by@39934_ _target40282_)
                          '#!void
                          (std/misc/pqueue#pqueue-push!
                           _ready-fg39936_
                           _target40282_))))))
                (_mark-built39990_
                 (lambda (_target40230_ . _g304856_)
                   (let ((_blocking4023140233_
                          (vector-ref _blocking@39935_ _target40230_)))
                     (if _blocking4023140233_
                         (let ((_blocking40236_ _blocking4023140233_))
                           ((lambda (_g4023740239_)
                              (table-for-each _g4023740239_ _blocking40236_))
                            (lambda (_unblocked40242_ _g304857_)
                              (table-set! _blocking40236_ _unblocked40242_)
                              (letrec* ((_blocked-by40244_
                                         (vector-ref
                                          _blocked-by@39934_
                                          _unblocked40242_)))
                                (table-set! _blocked-by40244_ _target40230_)
                                (if (std/misc/hash#hash-empty?
                                     _blocked-by40244_)
                                    (std/misc/pqueue#pqueue-push!
                                     _ready-fg39936_
                                     _unblocked40242_)
                                    '#!void)))))
                         '#f))))
                (_g304858_
                 (let ((_g304859_ (_init-walk39989_))) #!void _g304859_))
                (_build-list39991_
                 (let* ((_head40060_ (cons '#f '())) (_tail40063_ _head40060_))
                   (std/misc/concurrent-plan#perform-plan/threads__%
                    '#f
                    void
                    (lambda (_val40224_)
                      (let ((_new-tail40227_ (cons _val40224_ '())))
                        (let ()
                          (declare (not safe))
                          (##set-cdr! _tail40063_ _new-tail40227_))
                        (set! _tail40063_ _new-tail40227_)))
                    _mark-built39990_
                    void
                    '#t
                    '1
                    _ready-fg39936_
                    _ready-bg39937_)
                   (let () (declare (not safe)) (##cdr _head40060_))))
                (_g304861_
                 (let ((_g304862_
                        (std/make#write-build-deps
                         _build-deps-file39923_
                         (map (lambda (_target39993_)
                                (map (lambda (_g3999439996_)
                                       (vector-ref
                                        _g3999439996_
                                        _target39993_))
                                     (cons _id@39930_
                                           (cons _spec@39926_
                                                 (cons _deps@39932_ '())))))
                              _build-list39991_))))
                   #!void
                   _g304862_))
                (_g304864_
                 (let ((_g304865_
                        (if (= (length _build-list39991_) _nspec39927_)
                            '#!void
                            (error '"Circular dependency in build??? Remove build-deps and try again?"))))
                   #!void
                   _g304865_))
                (_g304867_
                 (let ((_g304868_
                        (if (_verbose>=?39925_ '3)
                            (std/make#writeln
                             (cons 'Step:
                                   (cons '4
                                         (cons 'build-deps:
                                               (cons _build-deps-file39923_
                                                     '())))))
                            '#!void)))
                   #!void
                   _g304868_))
                (_compute-timestamp39998_
                 (lambda (_target40046_)
                   (letrec* ((_spec40048_
                              (vector-ref _spec@39926_ _target40046_))
                             (_deps40049_
                              (vector-ref _deps@39932_ _target40046_))
                             (_inputs40050_
                              (std/make#spec-inputs
                               _spec40048_
                               _settings39920_))
                             (_outputs40051_
                              (std/make#spec-outputs
                               _spec40048_
                               _settings39920_))
                             (_dep-timestamps40052_
                              (map _dependency-timestamp39938_ _deps40049_))
                             (_in-timestamps40053_
                              (map std/make#file-timestamp _inputs40050_))
                             (_out-timestamps40054_
                              (map std/make#file-timestamp _outputs40051_))
                             (_dep-max40055_
                              (std/misc/number#xmax/list
                               _dep-timestamps40052_))
                             (_in-max40056_
                              (std/misc/number#xmax__0
                               _dep-max40055_
                               (std/misc/number#xmax/list
                                _in-timestamps40053_)))
                             (_out-min40057_
                              (std/misc/number#xmin/list
                               _out-timestamps40054_))
                             (_out-max40058_
                              (std/misc/number#xmax/list
                               _out-timestamps40054_)))
                     (if (_verbose>=?39925_ '6)
                         (std/make#writeln
                          (cons 'compute-timestamp:
                                (cons (cons 'target: (cons _target40046_ '()))
                                      (cons (cons 'spec:
                                                  (cons _spec40048_ '()))
                                            (cons (cons 'in-max:
                                                        (cons _in-max40056_
                                                              '()))
                                                  (cons (cons 'out-min:
                                                              (cons _out-min40057_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            '()))
                (cons (cons 'out-max: (cons _out-max40058_ '()))
                      (cons (cons 'deps:
                                  (cons (std/srfi/1#map2
                                         list
                                         _dep-timestamps40052_
                                         _deps40049_)
                                        '()))
                            (cons (cons 'ins:
                                        (cons (std/srfi/1#map2
                                               list
                                               _in-timestamps40053_
                                               _inputs40050_)
                                              '()))
                                  (cons (cons 'outs:
                                              (cons (std/srfi/1#map2
                                                     list
                                                     _outputs40051_
                                                     _out-timestamps40054_)
                                                    '()))
                                        (cons (cons 'result:
                                                    (cons (if (<= _in-max40056_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _out-min40057_)
                      _out-max40058_
                      '+inf.0)
                  '()))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              '())))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                         '#!void)
                     (if (<= _in-max40056_ _out-min40057_)
                         _out-max40058_
                         '+inf.0))))
                (_compute-new-timestamp39999_
                 (lambda (_target40036_)
                   (letrec* ((_spec40038_
                              (vector-ref _spec@39926_ _target40036_))
                             (_outputs40039_
                              (std/make#spec-outputs
                               _spec40038_
                               _settings39920_))
                             (_g304870_
                              (let ((_g304871_
                                     (for-each
                                      (lambda (_x40041_)
                                        (std/make#cache-remove!
                                         (cons 'modification-time
                                               (cons _x40041_ '()))))
                                      _outputs40039_)))
                                #!void
                                _g304871_))
                             (_out-timestamp40042_
                              (std/misc/number#xmax/map__0
                               std/make#file-timestamp
                               _outputs40039_)))
                     (begin
                       (if (< _out-timestamp40042_ '+inf.0)
                           '#!void
                           (begin
                             (if _verbose39924_
                                 (std/make#writeln
                                  (cons 'compute-timestamp-failed:
                                        (cons _spec40038_
                                              (cons (map (lambda (_x40044_)
                                                           (cons _x40044_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (cons (std/make#file-timestamp _x40044_) '())))
                 _outputs40039_)
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                    '()))))
                                 '#!void)
                             (error '"Build failed to generate expected outputs"
                                    _spec40038_
                                    _outputs40039_)))
                       _out-timestamp40042_))))
                (_target<-item40000_
                 (lambda (_item40034_)
                   (if (<= '0 _item40034_)
                       _item40034_
                       (bitwise-not _item40034_))))
                (_perform40001_
                 (lambda (_target40032_)
                   (if (<= '0 _target40032_)
                       (_fg-perform40002_ _target40032_)
                       (_bg-perform40004_ _target40032_))))
                (_fg-perform40002_
                 (lambda (_target40026_)
                   (letrec* ((_spec40028_
                              (vector-ref _spec@39926_ _target40026_))
                             (_id40029_ (vector-ref _id@39930_ _target40026_)))
                     (if (_verbose>=?39925_ '7)
                         (std/make#writeln
                          (cons 'Perform:
                                (cons _target40026_
                                      (cons _spec40028_
                                            (cons _id40029_
                                                  (cons (table-ref
                                                         _timestamp%39933_
                                                         _id40029_
                                                         '#f)
                                                        '()))))))
                         '#!void)
                     (if (and (not _force?39922_)
                              (< (std/misc/hash#hash-ensure-ref
                                  _timestamp%39933_
                                  _id40029_
                                  (lambda ()
                                    (_compute-timestamp39998_ _target40026_)))
                                 '+inf.0))
                         (begin
                           (if (_verbose>=?39925_ '5)
                               (std/make#writeln
                                (cons 'Up-to-date:
                                      (cons _target40026_
                                            (cons _spec40028_
                                                  (cons (table-ref
                                                         _timestamp%39933_
                                                         _id40029_)
                                                        '())))))
                               '#!void)
                           (table-ref _timestamp%39933_ _id40029_))
                         (if (std/make#spec-backgroundable? _spec40028_)
                             (begin
                               (std/misc/pqueue#pqueue-push!
                                _ready-bg39937_
                                (bitwise-not _target40026_))
                               '+inf.0)
                             (_build-target40003_ _target40026_))))))
                (_build-target40003_
                 (lambda (_target40024_)
                   (std/make#build
                    (vector-ref _spec@39926_ _target40024_)
                    _settings39920_)
                   (_compute-new-timestamp39999_ _target40024_)))
                (_bg-perform40004_
                 (lambda (_target40022_)
                   (_build-target40003_ (bitwise-not _target40022_))))
                (_on-success40005_
                 (lambda (_item40015_ _timestamp40016_)
                   (letrec* ((_target40018_ (_target<-item40000_ _item40015_))
                             (_spec40019_
                              (vector-ref _spec@39926_ _target40018_))
                             (_id40020_ (vector-ref _id@39930_ _target40018_)))
                     (if (_verbose>=?39925_ '7)
                         (std/make#writeln
                          (cons 'on-success:
                                (cons _item40015_
                                      (cons _target40018_
                                            (cons _id40020_
                                                  (cons _spec40019_
                                                        (cons _timestamp40016_
                                                              '())))))))
                         '#!void)
                     (if (< _timestamp40016_ '+inf.0)
                         (begin
                           (table-set!
                            _timestamp%39933_
                            _id40020_
                            _timestamp40016_)
                           (_mark-built39990_ _target40018_))
                         '#!void))))
                (_on-failure40006_
                 (lambda (_item40012_ _exception40013_)
                   (error '"Failure to build"
                          (vector-ref
                           _spec@39926_
                           (_target<-item40000_ _item40012_))
                          (error-message _exception40013_)))))
        (begin
          (create-directory*
           (##structure-ref _settings39920_ '3 std/make#settings::t '#f))
          (create-directory*
           (##structure-ref _settings39920_ '2 std/make#settings::t '#f))
          (if (##structure-ref _settings39920_ '8 std/make#settings::t '#f)
              (create-directory*
               (path-expand
                '"static"
                (##structure-ref _settings39920_ '2 std/make#settings::t '#f)))
              '#!void)
          (_init-walk39989_)
          (if (_verbose>=?39925_ '6)
              (std/make#writeln
               (cons 'Step:
                     (cons '5.
                           (cons 'queue:
                                 (cons (std/sort#sort
                                        (std/misc/pqueue#pqueue-contents
                                         _ready-fg39936_)
                                        <)
                                       '())))))
              '#!void)
          (std/misc/concurrent-plan#perform-plan/threads__%
           '#f
           _perform40001_
           (if (_verbose>=?39925_ '8)
               (lambda (_item40008_)
                 (letrec* ((_target40010_ (_target<-item40000_ _item40008_)))
                   (std/make#writeln
                    (cons 'announcing:
                          (cons _item40008_
                                (cons (vector-ref _spec@39926_ _target40010_)
                                      '()))))))
               void)
           _on-success40005_
           _on-failure40006_
           '#f
           (max (##structure-ref _settings39920_ '13 std/make#settings::t '#f)
                '1)
           _ready-fg39936_
           _ready-bg39937_)
          (if (_verbose>=?39925_ '3)
              (std/make#writeln
               (cons 'Step: (cons '5 (cons '"All built" '()))))
              '#!void)))))
  (define std/make#file-dependencies
    (lambda (_file39889_ _settings39890_)
      (letrec* ((_ht39892_ (make-table 'test: eq?))
                (_q39893_
                 (let ((__obj304822 (make-object std/misc/queue#queue::t '3)))
                   (std/misc/queue#queue:::init! __obj304822)
                   __obj304822))
                (_mod39894_
                 (with-cons-load-path
                  (lambda () (gx#import-module__0 _file39889_))
                  (##structure-ref
                   _settings39890_
                   '1
                   std/make#settings::t
                   '#f)))
                (_mod-id39895_
                 (##structure-ref _mod39894_ '1 gx#expander-context::t '#f))
                (_consider39896_
                 (lambda (_m39904_)
                   (let ((_id3990539907_
                          (##structure-ref
                           _m39904_
                           '1
                           gx#expander-context::t
                           '#f)))
                     (if _id3990539907_
                         (let* ((_id39910_ _id3990539907_)
                                (_module-id39912_
                                 (std/make#module-strip-nesting _id39910_)))
                           (if (eq? _module-id39912_ _mod-id39895_)
                               (for-each
                                (lambda (_g3991339915_)
                                  (std/misc/queue#enqueue!
                                   _q39893_
                                   _g3991339915_))
                                (cons (gx#core-context-prelude__% _m39904_)
                                      (##structure-ref
                                       _m39904_
                                       '8
                                       gx#module-context::t
                                       '#f)))
                               (table-set! _ht39892_ _module-id39912_ '#t)))
                         '#f)))))
        (_consider39896_ _mod39894_)
        (let _lp39898_ ()
          (if (std/misc/queue#queue-empty? _q39893_)
              '#!void
              (begin
                (let ((_hd39902_ (std/misc/queue#dequeue!__% _q39893_ '#f)))
                  (if (let ()
                        (declare (not safe))
                        (##structure-instance-of?
                         _hd39902_
                         'gx#module-context::t))
                      (_consider39896_ _hd39902_)
                      (if (let ()
                            (declare (not safe))
                            (##structure-instance-of?
                             _hd39902_
                             'gx#prelude-context::t))
                          (_consider39896_ _hd39902_)
                          (if (let ()
                                (declare (not safe))
                                (##structure-direct-instance-of?
                                 _hd39902_
                                 'gx#module-import::t))
                              (std/misc/queue#enqueue!
                               _q39893_
                               (##direct-structure-ref
                                _hd39902_
                                '1
                                gx#module-import::t
                                '#f))
                              (if (let ()
                                    (declare (not safe))
                                    (##structure-direct-instance-of?
                                     _hd39902_
                                     'gx#module-export::t))
                                  (std/misc/queue#enqueue!
                                   _q39893_
                                   (##direct-structure-ref
                                    _hd39902_
                                    '1
                                    gx#module-export::t
                                    '#f))
                                  (if (let ()
                                        (declare (not safe))
                                        (##structure-direct-instance-of?
                                         _hd39902_
                                         'gx#import-set::t))
                                      (std/misc/queue#enqueue!
                                       _q39893_
                                       (##direct-structure-ref
                                        _hd39902_
                                        '1
                                        gx#import-set::t
                                        '#f))
                                      (error '"Unexpected module import"
                                             _hd39902_)))))))
                (_lp39898_))))
        (values _mod-id39895_
                (std/sort#sort
                 (hash-keys _ht39892_)
                 std/misc/symbol#symbol<?)))))
  (define std/make#normalize-buildspec
    (lambda (_buildspec39590_)
      (letrec* ((_submodules39592_ '())
                (_get-submodules39593_
                 (lambda ()
                   (let ((_$r39886_ (reverse _submodules39592_)))
                     (set! _submodules39592_ '())
                     _$r39886_)))
                (_no-submodules39594_
                 (lambda (_spec39883_)
                   (if (null? _submodules39592_)
                       '#!void
                       (error '"incompatible sequence of build specifications"
                              (reverse (cons _spec39883_
                                             _submodules39592_))))))
                (_push-submodule39595_
                 (lambda (_spec39881_)
                   (set! _submodules39592_
                         (cons _spec39881_ _submodules39592_)))))
        (let* ((_head39597_ (cons '#f '())) (_tail39600_ _head39597_))
          ((lambda (_g3976039762_) (for-each _g3976039762_ _buildspec39590_))
           (lambda (_spec39765_)
             (let ((_$e39767_ (std/make#spec-type _spec39765_)))
               (if (eq? 'gxc: _$e39767_)
                   (let ((_s39770_ (_get-submodules39593_)))
                     (if (null? _s39770_)
                         (let ((_new-tail39772_ (cons _spec39765_ '())))
                           (let ()
                             (declare (not safe))
                             (##set-cdr! _tail39600_ _new-tail39772_))
                           (set! _tail39600_ _new-tail39772_))
                         (let ((_new-tail39863_
                                (cons (let* ((_spec3977439793_ _spec39765_)
                                             (_E3977839797_
                                              (lambda ()
                                                (error '"No clause matching"
                                                       _spec3977439793_))))
                                        (let ((_K3978539839_
                                               (lambda (_args39835_
                                                        _plist39836_
                                                        _name39837_)
                                                 (cons 'gxc:
                                                       (cons _name39837_
                                                             (cons (std/misc/plist#psetq
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _plist39836_
                            'submodules:
                            (append (pgetq _plist39836_ 'submodules:)
                                    _s39770_))
                           '())))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (_K3978039815_
                                               (lambda (_args39812_
                                                        _name39813_)
                                                 (cons 'gxc:
                                                       (cons _name39813_
                                                             (cons (cons 'submodules:
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                                 (cons _s39770_ '()))
                           _args39812_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (_K3977939803_
                                               (lambda (_spec39801_)
                                                 (cons 'gxc:
                                                       (cons _spec39801_
                                                             (cons (cons 'submodules:
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                                 (cons _s39770_ '()))
                           '()))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                          (let ((_try-match3977739808_
                                                 (lambda ()
                                                   (if (string? _spec3977439793_)
                                                       (let ((_spec39806_
                                                              _spec3977439793_))
                                                         (_K3977939803_
                                                          _spec39806_))
                                                       (_E3977839797_)))))
                                            (if (let ()
                                                  (declare (not safe))
                                                  (##pair? _spec3977439793_))
                                                (let ((_tl3978739844_
                                                       (let ()
                                                         (declare (not safe))
                                                         (##cdr _spec3977439793_)))
                                                      (_hd3978639842_
                                                       (let ()
                                                         (declare (not safe))
                                                         (##car _spec3977439793_))))
                                                  (if (let ()
                                                        (declare (not safe))
                                                        (##eq? _hd3978639842_
                                                               'gxc:))
                                                      (if (let ()
                                                            (declare
                                                              (not safe))
                                                            (##pair? _tl3978739844_))
                                                          (let ((_tl3978939849_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (let () (declare (not safe)) (##cdr _tl3978739844_)))
                        (_hd3978839847_
                         (let () (declare (not safe)) (##car _tl3978739844_))))
                    (if (let () (declare (not safe)) (##pair? _tl3978939849_))
                        (let ((_tl3979139856_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl3978939849_)))
                              (_hd3979039854_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl3978939849_))))
                          (if (pair? _hd3979039854_)
                              (let ((_name39852_ _hd3978839847_)
                                    (_plist39859_ _hd3979039854_)
                                    (_args39861_ _tl3979139856_))
                                (_K3978539839_
                                 _args39861_
                                 _plist39859_
                                 _name39852_))
                              (let ((_name39828_ _hd3978839847_)
                                    (_args39830_ _tl3978939849_))
                                (_K3978039815_ _args39830_ _name39828_))))
                        (let ((_name39828_ _hd3978839847_)
                              (_args39830_ _tl3978939849_))
                          (_K3978039815_ _args39830_ _name39828_))))
                  (if (string? _spec3977439793_)
                      (let ((_spec39806_ _spec3977439793_))
                        (_K3977939803_ _spec39806_))
                      (_E3977839797_)))
              (if (string? _spec3977439793_)
                  (let ((_spec39806_ _spec3977439793_))
                    (_K3977939803_ _spec39806_))
                  (_E3977839797_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                (_try-match3977739808_)))))
                                      '())))
                           (let ()
                             (declare (not safe))
                             (##set-cdr! _tail39600_ _new-tail39863_))
                           (set! _tail39600_ _new-tail39863_))))
                   (if (or (eq? 'exe: _$e39767_) (eq? 'static-exe: _$e39767_))
                       (begin
                         (_no-submodules39594_ _spec39765_)
                         (let ((_new-tail39869_ (cons _spec39765_ '())))
                           (let ()
                             (declare (not safe))
                             (##set-cdr! _tail39600_ _new-tail39869_))
                           (set! _tail39600_ _new-tail39869_)))
                       (if (or (eq? 'gsc: _$e39767_)
                               (eq? 'static-include: _$e39767_)
                               (eq? 'copy: _$e39767_))
                           (_push-submodule39595_ _spec39765_)
                           (if (eq? 'ssi: _$e39767_)
                               (let ((_new-tail39878_
                                      (cons (append _spec39765_
                                                    (_get-submodules39593_))
                                            '())))
                                 (let ()
                                   (declare (not safe))
                                   (##set-cdr! _tail39600_ _new-tail39878_))
                                 (set! _tail39600_ _new-tail39878_))
                               (error '"Unrecognized spec type"
                                      _spec39765_))))))))
          (_no-submodules39594_ '#!eof)
          (let () (declare (not safe)) (##cdr _head39597_))))))
  (define std/make#shell-config
    (lambda (_cmd39582_ . _args39583_)
      (let* ((_proc39585_
              (open-input-process
               (cons 'path:
                     (cons _cmd39582_
                           (cons 'arguments: (cons _args39583_ '()))))))
             (_status39587_ (process-status _proc39585_)))
        (if (zero? _status39587_)
            '#!void
            (error '"Error executing config script"
                   _cmd39582_
                   _args39583_
                   _status39587_))
        (read-line _proc39585_))))
  (define std/make#env-ldflags
    (lambda ()
      (let ((_$e39575_ (getenv '"LDFLAGS" '#f)))
        (if _$e39575_
            ((lambda (_flags39578_)
               (lambda (_lib39580_)
                 (string-append _flags39578_ '" " _lib39580_)))
             _$e39575_)
            identity))))
  (define std/make#env-cppflags
    (lambda ()
      (let ((_$e39567_ (getenv '"CPPFLAGS" '#f)))
        (if _$e39567_
            ((lambda (_flags39570_)
               (lambda (_more39572_)
                 (if (string-empty? _more39572_)
                     _flags39570_
                     (string-append _flags39570_ '" " _more39572_))))
             _$e39567_)
            identity))))
  (define std/make#include-gambit-sharp
    (lambda ()
      (if (gerbil-runtime-smp?)
          '("-e"
            "(define-cond-expand-feature|enable-smp|)"
            "-e"
            "(include \"~~lib/_gambit#.scm\")")
          '("-e" "(include \"~~lib/_gambit#.scm\")"))))
  (define std/make#build
    (lambda (_spec39331_ _settings39332_)
      (let* ((_spec3933339381_ _spec39331_)
             (_else3934239389_
              (lambda () (error '"Bad buildspec" _spec39331_))))
        (let ((_K3937939560_
               (lambda (_modf39558_)
                 (std/make#gxc-compile__%
                  _modf39558_
                  '#f
                  _settings39332_
                  '#t)))
              (_K3937439538_
               (lambda (_opts39535_ _modf39536_)
                 (std/make#gxc-compile__%
                  _modf39536_
                  _opts39535_
                  _settings39332_
                  '#t)))
              (_K3936939514_
               (lambda (_opts39511_ _modf39512_)
                 (std/make#gsc-compile
                  _modf39512_
                  _opts39511_
                  _settings39332_)))
              (_K3936439490_
               (lambda (_submodules39483_ _modf39484_)
                 (for-each
                  (lambda (_g3948539487_)
                    (std/make#build _g3948539487_ _settings39332_))
                  _submodules39483_)
                 (std/make#compile-ssi _modf39484_ '() _settings39332_)))
              (_K3935939462_
               (lambda (_opts39459_ _modf39460_)
                 (std/make#compile-exe
                  _modf39460_
                  _opts39459_
                  _settings39332_)))
              (_K3935439438_
               (lambda (_opts39435_ _modf39436_)
                 (std/make#compile-static-exe
                  _modf39436_
                  _opts39435_
                  _settings39332_)))
              (_K3934939416_
               (lambda (_file39414_)
                 (std/make#copy-static _file39414_ _settings39332_)))
              (_K3934439395_
               (lambda (_file39393_)
                 (std/make#copy-compiled _file39393_ _settings39332_))))
          (let ((_try-match3933539555_
                 (lambda ()
                   (if (let () (declare (not safe)) (##pair? _spec3933339381_))
                       (let ((_tl3937639543_
                              (let ()
                                (declare (not safe))
                                (##cdr _spec3933339381_)))
                             (_hd3937539541_
                              (let ()
                                (declare (not safe))
                                (##car _spec3933339381_))))
                         (if (let ()
                               (declare (not safe))
                               (##eq? _hd3937539541_ 'gxc:))
                             (if (let ()
                                   (declare (not safe))
                                   (##pair? _tl3937639543_))
                                 (let ((_tl3937839548_
                                        (let ()
                                          (declare (not safe))
                                          (##cdr _tl3937639543_)))
                                       (_hd3937739546_
                                        (let ()
                                          (declare (not safe))
                                          (##car _tl3937639543_))))
                                   (let ((_modf39551_ _hd3937739546_)
                                         (_opts39553_ _tl3937839548_))
                                     (_K3937439538_ _opts39553_ _modf39551_)))
                                 (_else3934239389_))
                             (if (let ()
                                   (declare (not safe))
                                   (##eq? _hd3937539541_ 'gsc:))
                                 (if (let ()
                                       (declare (not safe))
                                       (##pair? _tl3937639543_))
                                     (let ((_tl3937339524_
                                            (let ()
                                              (declare (not safe))
                                              (##cdr _tl3937639543_)))
                                           (_hd3937239522_
                                            (let ()
                                              (declare (not safe))
                                              (##car _tl3937639543_))))
                                       (let ((_modf39527_ _hd3937239522_)
                                             (_opts39529_ _tl3937339524_))
                                         (_K3936939514_
                                          _opts39529_
                                          _modf39527_)))
                                     (_else3934239389_))
                                 (if (let ()
                                       (declare (not safe))
                                       (##eq? _hd3937539541_ 'ssi:))
                                     (if (let ()
                                           (declare (not safe))
                                           (##pair? _tl3937639543_))
                                         (let ((_tl3936839500_
                                                (let ()
                                                  (declare (not safe))
                                                  (##cdr _tl3937639543_)))
                                               (_hd3936739498_
                                                (let ()
                                                  (declare (not safe))
                                                  (##car _tl3937639543_))))
                                           (let ((_modf39503_ _hd3936739498_)
                                                 (_submodules39505_
                                                  _tl3936839500_))
                                             (_K3936439490_
                                              _submodules39505_
                                              _modf39503_)))
                                         (_else3934239389_))
                                     (if (let ()
                                           (declare (not safe))
                                           (##eq? _hd3937539541_ 'exe:))
                                         (if (let ()
                                               (declare (not safe))
                                               (##pair? _tl3937639543_))
                                             (let ((_tl3936339472_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##cdr _tl3937639543_)))
                                                   (_hd3936239470_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##car _tl3937639543_))))
                                               (let ((_modf39475_
                                                      _hd3936239470_)
                                                     (_opts39477_
                                                      _tl3936339472_))
                                                 (_K3935939462_
                                                  _opts39477_
                                                  _modf39475_)))
                                             (_else3934239389_))
                                         (if (let ()
                                               (declare (not safe))
                                               (##eq? _hd3937539541_
                                                      'static-exe:))
                                             (if (let ()
                                                   (declare (not safe))
                                                   (##pair? _tl3937639543_))
                                                 (let ((_tl3935839448_
                                                        (let ()
                                                          (declare (not safe))
                                                          (##cdr _tl3937639543_)))
                                                       (_hd3935739446_
                                                        (let ()
                                                          (declare (not safe))
                                                          (##car _tl3937639543_))))
                                                   (let ((_modf39451_
                                                          _hd3935739446_)
                                                         (_opts39453_
                                                          _tl3935839448_))
                                                     (_K3935439438_
                                                      _opts39453_
                                                      _modf39451_)))
                                                 (_else3934239389_))
                                             (if (let ()
                                                   (declare (not safe))
                                                   (##eq? _hd3937539541_
                                                          'static-include:))
                                                 (if (let ()
                                                       (declare (not safe))
                                                       (##pair? _tl3937639543_))
                                                     (let ((_tl3935339426_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##cdr _tl3937639543_)))
                                                           (_hd3935239424_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##car _tl3937639543_))))
                                                       (if (let ()
                                                             (declare
                                                               (not safe))
                                                             (##null? _tl3935339426_))
                                                           (let ((_file39429_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _hd3935239424_))
                     (_K3934939416_ _file39429_))
                   (_else3934239389_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_else3934239389_))
                                                 (if (let ()
                                                       (declare (not safe))
                                                       (##eq? _hd3937539541_
                                                              'copy:))
                                                     (if (let ()
                                                           (declare (not safe))
                                                           (##pair? _tl3937639543_))
                                                         (let ((_tl3934839405_
                                                                (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (declare (not safe))
                          (##cdr _tl3937639543_)))
                       (_hd3934739403_
                        (let () (declare (not safe)) (##car _tl3937639543_))))
                   (if (let () (declare (not safe)) (##null? _tl3934839405_))
                       (let ((_file39408_ _hd3934739403_))
                         (_K3934439395_ _file39408_))
                       (_else3934239389_)))
                 (_else3934239389_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_else3934239389_)))))))))
                       (_else3934239389_)))))
            (if (string? _spec3933339381_)
                (let ((_modf39563_ _spec3933339381_))
                  (_K3937939560_ _modf39563_))
                (_try-match3933539555_)))))))
  (define std/make#gxc-outputs
    (lambda (_mod39327_ _opts39328_ _settings39329_)
      (cons (std/make#library-path _mod39327_ '".ssi" _settings39329_)
            (if (##structure-ref _settings39329_ '8 std/make#settings::t '#f)
                (cons (std/make#static-path _mod39327_ _settings39329_) '())
                '()))))
  (define std/make#gsc-compile-opts
    (lambda (_opts39261_)
      (let* ((_opts3926239277_ _opts39261_)
             (_E3926539281_
              (lambda () (error '"No clause matching" _opts3926239277_))))
        (let ((_K3926739295_
               (lambda (_rest39292_ _plist39293_)
                 (std/misc/list#listify _rest39292_)))
              (_K3926639286_ (lambda () (std/misc/list#listify _opts39261_))))
          (let ((___match304817304818_
                 (lambda (_hd3926839298_ _tl3926939300_)
                   (letrec ((_splice-rest3927139303_
                             (lambda (_rest3927539310_ _plist39312_)
                               (if (let ()
                                     (declare (not safe))
                                     (##null? _rest3927539310_))
                                   (let ((_rest39314_ _tl3926939300_))
                                     (_K3926739295_ _rest39314_ _plist39312_))
                                   (_K3926639286_))))
                            (_splice-try3927339305_
                             (lambda (_hd3927439316_
                                      _rest3927539318_
                                      _plist3927039319_)
                               (let ((_plist39322_ _hd3927439316_))
                                 (_splice-loop3927239307_
                                  (let ()
                                    (declare (not safe))
                                    (##cdr _rest3927539318_))
                                  (cons _plist39322_ _plist3927039319_)))))
                            (_splice-loop3927239307_
                             (lambda (_rest3927539324_ _plist3927039325_)
                               (if (pair? _rest3927539324_)
                                   (_splice-try3927339305_
                                    (let ()
                                      (declare (not safe))
                                      (##car _rest3927539324_))
                                    _rest3927539324_
                                    _plist3927039325_)
                                   (_splice-rest3927139303_
                                    _rest3927539324_
                                    (reverse _plist3927039325_))))))
                     (_splice-loop3927239307_ _hd3926839298_ '())))))
            (if (let () (declare (not safe)) (##pair? _opts3926239277_))
                (let ((_tl3926939300_
                       (let () (declare (not safe)) (##cdr _opts3926239277_)))
                      (_hd3926839298_
                       (let () (declare (not safe)) (##car _opts3926239277_))))
                  (___match304817304818_ _hd3926839298_ _tl3926939300_))
                (_K3926639286_)))))))
  (define std/make#gxc-compile__%
    (lambda (_mod39222_ _opts39223_ _settings39224_ _invoke-gsc?39225_)
      (std/make#message '"... compile " _mod39222_)
      (letrec* ((_foreground?39227_
                 (if (pair? _opts39223_)
                     (if (pair? (car _opts39223_))
                         (pgetq 'foreground: (car _opts39223_))
                         '#f)
                     '#f))
                (_gsc-opts39228_ (std/make#gsc-compile-opts _opts39223_))
                (_srcpath39229_
                 (std/make#source-path _mod39222_ '".ss" _settings39224_)))
        (if (or _foreground?39227_
                (> '1
                   (##structure-ref
                    _settings39224_
                    '13
                    std/make#settings::t
                    '#f)))
            (let ((_gxc-opts39234_
                   (cons 'invoke-gsc:
                         (cons _invoke-gsc?39225_
                               (cons 'keep-scm:
                                     (cons (not _invoke-gsc?39225_)
                                           (cons 'output-dir:
                                                 (cons (##structure-ref
                                                        _settings39224_
                                                        '2
                                                        std/make#settings::t
                                                        '#f)
                                                       (cons 'optimize:
                                                             (cons (##structure-ref
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _settings39224_
                            '6
                            std/make#settings::t
                            '#f)
                           (cons 'debug:
                                 (cons (##structure-ref
                                        _settings39224_
                                        '7
                                        std/make#settings::t
                                        '#f)
                                       (cons 'generate-ssxi:
                                             (cons '#t
                                                   (cons 'static:
                                                         (cons (##structure-ref
                                                                _settings39224_
                                                                '8
                                                                std/make#settings::t
                                                                '#f)
                                                               (cons 'verbose:
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                             (cons (std/make#settings-verbose>=?
                                    _settings39224_
                                    '9)
                                   (if _gsc-opts39228_
                                       (cons 'gsc-options:
                                             (cons _gsc-opts39228_ '()))
                                       '())))))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
              (gxc#compile-file__% _srcpath39229_ _gxc-opts39234_))
            (let* ((_arguments39238_
                    (cons '"-d"
                          (cons (##structure-ref
                                 _settings39224_
                                 '2
                                 std/make#settings::t
                                 '#f)
                                (foldr1 cons
                                        (foldr1 cons
                                                (foldr1 cons
                                                        (foldr1 cons
                                                                (foldr1 cons
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                                (foldr1 cons
                                        (cons _srcpath39229_ '())
                                        (if _gsc-opts39228_
                                            (std/srfi/1#append-map
                                             (lambda (_x39236_)
                                               (cons '"-gsc-flag"
                                                     (cons _x39236_ '())))
                                             _gsc-opts39228_)
                                            '()))
                                (if (std/make#settings-verbose>=?
                                     _settings39224_
                                     '9)
                                    (cons '"-v" '())
                                    '()))
                        (if (##structure-ref
                             _settings39224_
                             '8
                             std/make#settings::t
                             '#f)
                            (cons '"-static" '())
                            '()))
                (if (##structure-ref
                     _settings39224_
                     '7
                     std/make#settings::t
                     '#f)
                    (cons '"-g" '())
                    '()))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                (if (##structure-ref
                                                     _settings39224_
                                                     '6
                                                     std/make#settings::t
                                                     '#f)
                                                    (cons '"-O" '())
                                                    '()))
                                        (if (not _invoke-gsc?39225_)
                                            (cons '"-s" (cons '"-S" '()))
                                            '())))))
                   (___39240_
                    (if (std/make#settings-verbose>=? _settings39224_ '7)
                        (std/make#writeln
                         (cons 'invoking:
                               (cons (std/make#gerbil-gxc) _arguments39238_)))
                        '#!void))
                   (_proc39242_
                    (open-process
                     (cons 'path:
                           (cons (std/make#gerbil-gxc)
                                 (cons 'arguments:
                                       (cons _arguments39238_
                                             (cons 'stdout-redirection:
                                                   (cons '#f '()))))))))
                   (_status39244_ (process-status _proc39242_)))
              (close-port _proc39242_)
              (if (zero? _status39244_)
                  '#!void
                  (error '"Compilation error; gxc exited with nonzero status"
                         _status39244_)))))))
  (define std/make#gxc-compile__0
    (lambda (_mod39250_ _opts39251_ _settings39252_)
      (let ((_invoke-gsc?39254_ '#t))
        (std/make#gxc-compile__%
         _mod39250_
         _opts39251_
         _settings39252_
         _invoke-gsc?39254_))))
  (define std/make#gxc-compile
    (lambda _g304874_
      (let ((_g304873_ (let () (declare (not safe)) (##length _g304874_))))
        (cond ((let () (declare (not safe)) (##fx= _g304873_ 3))
               (apply std/make#gxc-compile__0 _g304874_))
              ((let () (declare (not safe)) (##fx= _g304873_ 4))
               (apply std/make#gxc-compile__% _g304874_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/make#gxc-compile
                _g304874_))))))
  (define std/make#gsc-libpath
    (lambda (_mod39211_ _settings39212_)
      (letrec* ((_libdir-prefix39214_
                 (##structure-ref
                  _settings39212_
                  '12
                  std/make#settings::t
                  '#f)))
        (let ((_$e39216_ (string-rindex _mod39211_ '#\/)))
          (if _$e39216_
              ((lambda (_ix39219_)
                 (path-expand
                  (substring _mod39211_ '0 _ix39219_)
                  _libdir-prefix39214_))
               _$e39216_)
              _libdir-prefix39214_)))))
  (define std/make#gsc-base
    (lambda (_mod39204_)
      (let ((_$e39206_ (string-rindex _mod39204_ '#\/)))
        (if _$e39206_
            ((lambda (_ix39209_)
               (substring
                _mod39204_
                (fx+ _ix39209_ '1)
                (string-length _mod39204_)))
             _$e39206_)
            _mod39204_))))
  (define std/make#gsc-c-path
    (lambda (_modf39190_ _settings39191_)
      (letrec* ((_mod39193_ (path-strip-extension _modf39190_))
                (_libpath39194_
                 (std/make#gsc-libpath _mod39193_ _settings39191_))
                (_base39195_ (std/make#gsc-base _mod39193_)))
        (let _lp39197_ ((_n39199_ '1) (_cpath39200_ '#f))
          (let ((_next39202_
                 (path-expand
                  (string-append _base39195_ '".o" (number->string _n39199_))
                  _libpath39194_)))
            (if (file-exists? _next39202_)
                (_lp39197_ (fx+ _n39199_ '1) _next39202_)
                _cpath39200_))))))
  (define std/make#gsc-compile
    (lambda (_mod39175_ _opts39176_ _settings39177_)
      (letrec* ((_gsc-opts39179_ (std/make#gsc-compile-opts _opts39176_))
                (_srcpath39180_
                 (std/make#source-path _mod39175_ '".scm" _settings39177_))
                (_libpath39181_
                 (std/make#gsc-libpath _mod39175_ _settings39177_)))
        (create-directory* _libpath39181_)
        (std/make#message '"... compile foreign " _mod39175_)
        (let* ((_proc39183_
                (open-process
                 (cons 'path:
                       (cons (std/make#gerbil-gsc)
                             (cons 'arguments:
                                   (cons (cons '"-o"
                                               (cons _libpath39181_
                                                     (foldr1 cons
                                                             (cons _srcpath39180_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           '())
                     _gsc-opts39179_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                         (cons 'stdout-redirection:
                                               (cons '#f '()))))))))
               (_status39185_ (process-status _proc39183_)))
          (close-port _proc39183_)
          (if (zero? _status39185_)
              '#!void
              (error '"Compilation error; gsc exited with nonzero status"
                     _status39185_)))
        (if (##structure-ref _settings39177_ '8 std/make#settings::t '#f)
            (let ((_statpath39188_
                   (std/make#static-path _mod39175_ _settings39177_)))
              (if (file-exists? _statpath39188_)
                  (delete-file _statpath39188_)
                  '#!void)
              (copy-file _srcpath39180_ _statpath39188_))
            '#!void))))
  (define std/make#gerbil-gsc
    (lambda () (getenv '"GERBIL_GSC" std/make#default-gambit-gsc)))
  (define std/make#gerbil-gxc
    (lambda () (getenv '"GERBIL_GXC" std/make#default-gerbil-gxc)))
  (define std/make#compile-ssi
    (lambda (_mod39156_ _deps39157_ _settings39158_)
      (letrec* ((_srcpath39160_
                 (std/make#source-path _mod39156_ '".ssi" _settings39158_))
                (_libpath39161_
                 (std/make#library-path _mod39156_ '".ssi" _settings39158_))
                (_rtpath39162_
                 (std/make#library-path
                  _mod39156_
                  '"__rt.scm"
                  _settings39158_))
                (_prefix39163_
                 (##structure-ref
                  _settings39158_
                  '4
                  std/make#settings::t
                  '#f)))
        (std/make#message '"... copy ssi " _mod39156_)
        (create-directory* (path-directory _libpath39161_))
        (if (file-exists? _libpath39161_) (delete-file _libpath39161_) '#!void)
        (copy-file _srcpath39160_ _libpath39161_)
        (std/make#message '"... compile loader " _mod39156_)
        (with-output-to-file
         _rtpath39162_
         (lambda ()
           (for-each
            (lambda (_dep39166_)
              (pretty-print (cons 'load-module (cons _dep39166_ '()))))
            _deps39157_)
           (pretty-print
            (cons 'load-module
                  (cons (std/make#prefix/ _prefix39163_ _mod39156_) '())))))
        (let* ((_proc39168_
                (open-process
                 (cons 'path:
                       (cons (std/make#gerbil-gsc)
                             (cons 'arguments:
                                   (cons (cons _rtpath39162_ '())
                                         (cons 'stdout-redirection:
                                               (cons '#f '()))))))))
               (_status39170_ (process-status _proc39168_)))
          (close-port _proc39168_)
          (if (zero? _status39170_)
              '#!void
              (error '"Compilation error; gsc exited with nonzero status"
                     _status39170_))
          (delete-file _rtpath39162_)))))
  (define std/make#compile-exe
    (lambda (_mod39147_ _opts39148_ _settings39149_)
      (letrec* ((_srcpath39151_
                 (std/make#source-path _mod39147_ '".ss" _settings39149_))
                (_binpath39152_
                 (std/make#binary-path _mod39147_ _opts39148_ _settings39149_))
                (_gsc-opts39153_ (std/make#compile-exe-gsc-opts _opts39148_))
                (_gxc-opts39154_
                 (cons 'invoke-gsc:
                       (cons '#t
                             (cons 'output-file:
                                   (cons _binpath39152_
                                         (cons 'verbose:
                                               (cons (std/make#settings-verbose>=?
                                                      _settings39149_
                                                      '9)
                                                     '()))))))))
        (std/make#gxc-compile__0 _mod39147_ _gsc-opts39153_ _settings39149_)
        (std/make#message
         '"... compile exe "
         _mod39147_
         '" -> "
         _binpath39152_)
        (gxc#compile-exe-stub__% _srcpath39151_ _gxc-opts39154_))))
  (define std/make#compile-exe-gsc-opts
    (lambda (_opts39105_)
      (let* ((_opts3910639116_ _opts39105_)
             (_else3910839124_ (lambda () _opts39105_))
             (_K3911039130_
              (lambda (_rest39127_ _opt39128_)
                (std/make#compile-exe-gsc-opts _rest39127_))))
        (if (let () (declare (not safe)) (##pair? _opts3910639116_))
            (let ((_hd3911139133_
                   (let () (declare (not safe)) (##car _opts3910639116_)))
                  (_tl3911239135_
                   (let () (declare (not safe)) (##cdr _opts3910639116_))))
              (if (keyword? _hd3911139133_)
                  (if (let () (declare (not safe)) (##pair? _tl3911239135_))
                      (let ((_hd3911339138_
                             (let ()
                               (declare (not safe))
                               (##car _tl3911239135_)))
                            (_tl3911439140_
                             (let ()
                               (declare (not safe))
                               (##cdr _tl3911239135_))))
                        (let* ((_opt39143_ _hd3911339138_)
                               (_rest39145_ _tl3911439140_))
                          (_K3911039130_ _rest39145_ _opt39143_)))
                      (_else3910839124_))
                  (_else3910839124_)))
            (_else3910839124_)))))
  (define std/make#make-settings-static
    (lambda (_settings39101_)
      (letrec* ((_s39103_ (struct-copy _settings39101_)))
        (##structure-set! _s39103_ '#t '8 std/make#settings::t '#f)
        _s39103_)))
  (define std/make#compile-static-exe
    (lambda (_mod39092_ _opts39093_ _settings39094_)
      (letrec* ((_srcpath39096_
                 (std/make#source-path _mod39092_ '".ss" _settings39094_))
                (_binpath39097_
                 (std/make#binary-path _mod39092_ _opts39093_ _settings39094_))
                (_gsc-opts39098_ (std/make#compile-exe-gsc-opts _opts39093_))
                (_gxc-opts39099_
                 (cons 'invoke-gsc:
                       (cons '#t
                             (cons 'output-file:
                                   (cons _binpath39097_
                                         (cons 'verbose:
                                               (cons (std/make#settings-verbose>=?
                                                      _settings39094_
                                                      '9)
                                                     (cons 'debug:
                                                           (cons (##structure-ref
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _settings39094_
                          '9
                          std/make#settings::t
                          '#f)
                         (if _gsc-opts39098_
                             (cons 'gsc-options: (cons _gsc-opts39098_ '()))
                             '())))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
        (std/make#gxc-compile__0
         _mod39092_
         _gsc-opts39098_
         (std/make#make-settings-static _settings39094_))
        (std/make#message
         '"... compile static exe "
         _mod39092_
         '" -> "
         _binpath39097_)
        (gxc#compile-static-exe__% _srcpath39096_ _gxc-opts39099_))))
  (define std/make#copy-static
    (lambda (_file39087_ _settings39088_)
      (letrec* ((_spath39090_
                 (std/make#static-file-path _file39087_ _settings39088_)))
        (std/make#message '"... copy static include " _file39087_)
        (if (file-exists? _spath39090_) (delete-file _spath39090_) '#!void)
        (copy-file _file39087_ _spath39090_))))
  (define std/make#copy-compiled
    (lambda (_file39081_ _settings39082_)
      (letrec* ((_srcpath39084_
                 (std/make#source-path _file39081_ '#f _settings39082_))
                (_libpath39085_
                 (std/make#library-path _file39081_ '#f _settings39082_)))
        (std/make#message '"... copy std/" _file39081_)
        (if (file-exists? _libpath39085_) (delete-file _libpath39085_) '#!void)
        (copy-file _srcpath39084_ _libpath39085_))))
  (define std/make#source-path
    (lambda (_mod39077_ _ext39078_ _settings39079_)
      (path-expand
       (std/misc/path#path-default-extension _mod39077_ _ext39078_)
       (##structure-ref _settings39079_ '1 std/make#settings::t '#f))))
  (define std/make#library-path
    (lambda (_mod39073_ _ext39074_ _settings39075_)
      (path-expand
       (std/misc/path#path-force-extension _mod39073_ _ext39074_)
       (##structure-ref _settings39075_ '12 std/make#settings::t '#f))))
  (define std/make#binary-path
    (lambda (_mod39053_ _opts39054_ _settings39055_)
      (let* ((_bindir39057_
              (##structure-ref _settings39055_ '3 std/make#settings::t '#f))
             (_g304875_
              (if _bindir39057_ '#!void (error '"bindir must be specified")))
             (_bin39068_
              (let ((_$e39060_ (pgetq 'bin: _opts39054_)))
                (if _$e39060_
                    (values _$e39060_)
                    (let ((_$e39063_ (string-rindex _mod39053_ '#\/)))
                      (if _$e39063_
                          ((lambda (_ix39066_)
                             (substring
                              _mod39053_
                              (fx+ _ix39066_ '1)
                              (string-length _mod39053_)))
                           _$e39063_)
                          _mod39053_)))))
             (_bin39070_
              (if (string-empty? (path-extension _bin39068_))
                  _bin39068_
                  (path-strip-extension _bin39068_))))
        (path-expand _bin39070_ _bindir39057_))))
  (define std/make#static-path
    (lambda (_mod39039_ _settings39040_)
      (let* ((_libdir39042_
              (##structure-ref _settings39040_ '2 std/make#settings::t '#f))
             (_staticdir39044_ (path-expand '"static" _libdir39042_))
             (_mod39046_
              (std/make#prefix/
               (##structure-ref _settings39040_ '4 std/make#settings::t '#f)
               _mod39039_))
             (_base39048_ (string-join (string-split _mod39046_ '#\/) '"__"))
             (_scm39050_
              (std/misc/path#path-force-extension _base39048_ '".scm")))
        (path-expand _scm39050_ _staticdir39044_))))
  (define std/make#static-file-path
    (lambda (_file39029_ _settings39030_)
      (let* ((_libdir39032_
              (##structure-ref _settings39030_ '2 std/make#settings::t '#f))
             (_staticdir39034_ (path-expand '"static" _libdir39032_))
             (_filename39036_ (path-strip-directory _file39029_)))
        (path-expand _filename39036_ _staticdir39034_))))
  (define std/make#pkg-config
    (lambda (_lib39026_ . _args39027_)
      (apply std/make#shell-config
             '"pkg-config"
             '"--silence-errors"
             _lib39026_
             _args39027_)))
  (define std/make#pkg-config-libs
    (lambda _libs39022_
      (string-join
       (map (lambda (_l39024_) (std/make#pkg-config _l39024_ '"--libs"))
            _libs39022_)
       '" ")))
  (define std/make#pkg-config-cflags
    (lambda _libs39018_
      (string-join
       (map (lambda (_l39020_) (std/make#pkg-config _l39020_ '"--cflags"))
            _libs39018_)
       '" ")))
  (define std/make#ldflags
    (lambda (_lib39008_ _flags39009_)
      (with-exception-catcher
       (lambda (_g3901039012_)
         (if '#t
             (let ((_e39015_ _g3901039012_))
               ((std/make#env-ldflags) _flags39009_))
             (raise _g3901039012_)))
       (lambda () (std/make#pkg-config-libs _lib39008_)))))
  (define std/make#cppflags
    (lambda (_lib38998_ _flags38999_)
      (with-exception-catcher
       (lambda (_g3900039002_)
         (if '#t
             (let ((_e39005_ _g3900039002_))
               ((std/make#env-cppflags) _flags38999_))
             (raise _g3900039002_)))
       (lambda () (std/make#pkg-config-cflags _lib38998_))))))
