(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/misc/channel#channel::t
    (make-struct-type
     'std/misc/channel#channel::t
     '#f
     '5
     'channel
     '((final: . #t))
     ':init!
     '(q mx cv limit eof)))
  (define std/misc/channel#channel?
    (make-struct-predicate std/misc/channel#channel::t))
  (define std/misc/channel#make-channel
    (lambda _$args230593_
      (apply make-struct-instance std/misc/channel#channel::t _$args230593_)))
  (define std/misc/channel#channel-q
    (make-struct-field-accessor std/misc/channel#channel::t '0))
  (define std/misc/channel#channel-mx
    (make-struct-field-accessor std/misc/channel#channel::t '1))
  (define std/misc/channel#channel-cv
    (make-struct-field-accessor std/misc/channel#channel::t '2))
  (define std/misc/channel#channel-limit
    (make-struct-field-accessor std/misc/channel#channel::t '3))
  (define std/misc/channel#channel-eof
    (make-struct-field-accessor std/misc/channel#channel::t '4))
  (define std/misc/channel#channel-q-set!
    (make-struct-field-mutator std/misc/channel#channel::t '0))
  (define std/misc/channel#channel-mx-set!
    (make-struct-field-mutator std/misc/channel#channel::t '1))
  (define std/misc/channel#channel-cv-set!
    (make-struct-field-mutator std/misc/channel#channel::t '2))
  (define std/misc/channel#channel-limit-set!
    (make-struct-field-mutator std/misc/channel#channel::t '3))
  (define std/misc/channel#channel-eof-set!
    (make-struct-field-mutator std/misc/channel#channel::t '4))
  (define std/misc/channel#&channel-q
    (make-struct-field-unchecked-accessor std/misc/channel#channel::t '0))
  (define std/misc/channel#&channel-mx
    (make-struct-field-unchecked-accessor std/misc/channel#channel::t '1))
  (define std/misc/channel#&channel-cv
    (make-struct-field-unchecked-accessor std/misc/channel#channel::t '2))
  (define std/misc/channel#&channel-limit
    (make-struct-field-unchecked-accessor std/misc/channel#channel::t '3))
  (define std/misc/channel#&channel-eof
    (make-struct-field-unchecked-accessor std/misc/channel#channel::t '4))
  (define std/misc/channel#&channel-q-set!
    (make-struct-field-unchecked-mutator std/misc/channel#channel::t '0))
  (define std/misc/channel#&channel-mx-set!
    (make-struct-field-unchecked-mutator std/misc/channel#channel::t '1))
  (define std/misc/channel#&channel-cv-set!
    (make-struct-field-unchecked-mutator std/misc/channel#channel::t '2))
  (define std/misc/channel#&channel-limit-set!
    (make-struct-field-unchecked-mutator std/misc/channel#channel::t '3))
  (define std/misc/channel#&channel-eof-set!
    (make-struct-field-unchecked-mutator std/misc/channel#channel::t '4))
  (define std/misc/channel#channel:::init!__%
    (lambda (_self230580_ _limit230581_)
      (if (let ((__tmp303016
                 (let () (declare (not safe)) (##vector-length _self230580_))))
            (declare (not safe))
            (##fx< '5 __tmp303016))
          (begin
            (let ((__tmp303017
                   (let ((__obj303014
                          (make-object std/misc/queue#queue::t '3)))
                     (std/misc/queue#queue:::init! __obj303014)
                     __obj303014)))
              (declare (not safe))
              (##vector-set! _self230580_ '1 __tmp303017))
            (let ((__tmp303018 (make-mutex 'channel)))
              (declare (not safe))
              (##vector-set! _self230580_ '2 __tmp303018))
            (let ((__tmp303019 (make-condition-variable 'channel)))
              (declare (not safe))
              (##vector-set! _self230580_ '3 __tmp303019))
            (let ()
              (declare (not safe))
              (##vector-set! _self230580_ '4 _limit230581_))
            (let () (declare (not safe)) (##vector-set! _self230580_ '5 '#f)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self230580_))))
  (define std/misc/channel#channel:::init!__0
    (lambda (_self230586_)
      (let ((_limit230588_ '#f))
        (std/misc/channel#channel:::init!__% _self230586_ _limit230588_))))
  (define std/misc/channel#channel:::init!
    (lambda _g303021_
      (let ((_g303020_ (let () (declare (not safe)) (##length _g303021_))))
        (cond ((let () (declare (not safe)) (##fx= _g303020_ 1))
               (apply std/misc/channel#channel:::init!__0 _g303021_))
              ((let () (declare (not safe)) (##fx= _g303020_ 2))
               (apply std/misc/channel#channel:::init!__% _g303021_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/channel#channel:::init!
                _g303021_))))))
  (bind-method!
   std/misc/channel#channel::t
   ':init!
   std/misc/channel#channel:::init!
   '#f)
  (define std/misc/channel#channel-put__%
    (lambda (_ch230390_ _val230391_ _timeo230392_)
      (let* ((_timeo230394_ (std/misc/timeout#make-timeout__0 _timeo230392_))
             (_ch230395230404_ _ch230390_)
             (_E230397230408_
              (lambda () (error '"No clause matching" _ch230395230404_)))
             (_K230398230422_
              (lambda (_limit230411_ _cv230412_ _mx230413_ _q230414_)
                (let _lp230416_ ()
                  (mutex-lock! _mx230413_)
                  (if (let ()
                        (declare (not safe))
                        (##unchecked-structure-ref
                         _ch230390_
                         '5
                         std/misc/channel#channel::t
                         '#f))
                      (begin
                        (mutex-unlock! _mx230413_)
                        (std/error#raise-io-error
                         'channel-put
                         '"channel is closed"
                         _ch230390_))
                      (if (or (not _limit230411_)
                              (let ((__tmp303022
                                     (##direct-structure-ref
                                      _q230414_
                                      '3
                                      std/misc/queue#queue::t
                                      '#f)))
                                (declare (not safe))
                                (##fx< __tmp303022 _limit230411_)))
                          (begin
                            (std/misc/queue#enqueue! _q230414_ _val230391_)
                            (if (let ((__tmp303023
                                       (##direct-structure-ref
                                        _q230414_
                                        '3
                                        std/misc/queue#queue::t
                                        '#f)))
                                  (declare (not safe))
                                  (##fx= __tmp303023 '1))
                                (condition-variable-broadcast! _cv230412_)
                                '#!void)
                            (mutex-unlock! _mx230413_)
                            '#t)
                          (if (mutex-unlock!
                               _mx230413_
                               _cv230412_
                               _timeo230394_)
                              (_lp230416_)
                              '#f)))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ch230395230404_
               'std/misc/channel#channel::t))
            (let* ((_e230399230425_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230395230404_ '1)))
                   (_q230428_ _e230399230425_)
                   (_e230400230430_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230395230404_ '2)))
                   (_mx230433_ _e230400230430_)
                   (_e230401230435_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230395230404_ '3)))
                   (_cv230438_ _e230401230435_)
                   (_e230402230440_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230395230404_ '4)))
                   (_limit230443_ _e230402230440_))
              (_K230398230422_ _limit230443_ _cv230438_ _mx230433_ _q230428_))
            (_E230397230408_)))))
  (define std/misc/channel#channel-put__0
    (lambda (_ch230448_ _val230449_)
      (let ((_timeo230451_ '#f))
        (std/misc/channel#channel-put__%
         _ch230448_
         _val230449_
         _timeo230451_))))
  (define std/misc/channel#channel-put
    (lambda _g303025_
      (let ((_g303024_ (let () (declare (not safe)) (##length _g303025_))))
        (cond ((let () (declare (not safe)) (##fx= _g303024_ 2))
               (apply std/misc/channel#channel-put__0 _g303025_))
              ((let () (declare (not safe)) (##fx= _g303024_ 3))
               (apply std/misc/channel#channel-put__% _g303025_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/channel#channel-put
                _g303025_))))))
  (define std/misc/channel#channel-try-put
    (lambda (_ch230340_ _val230341_)
      (let* ((_ch230342230351_ _ch230340_)
             (_E230344230355_
              (lambda () (error '"No clause matching" _ch230342230351_)))
             (_K230345230366_
              (lambda (_limit230358_ _cv230359_ _mx230360_ _q230361_)
                (mutex-lock! _mx230360_)
                (if (let ()
                      (declare (not safe))
                      (##unchecked-structure-ref
                       _ch230340_
                       '5
                       std/misc/channel#channel::t
                       '#f))
                    (begin
                      (mutex-unlock! _mx230360_)
                      (std/error#raise-io-error
                       'channel-try-put
                       '"channel is closed"
                       _ch230340_))
                    (if (or (not _limit230358_)
                            (let ((__tmp303026
                                   (##direct-structure-ref
                                    _q230361_
                                    '3
                                    std/misc/queue#queue::t
                                    '#f)))
                              (declare (not safe))
                              (##fx< __tmp303026 _limit230358_)))
                        (begin
                          (std/misc/queue#enqueue! _q230361_ _val230341_)
                          (if (let ((__tmp303027
                                     (##direct-structure-ref
                                      _q230361_
                                      '3
                                      std/misc/queue#queue::t
                                      '#f)))
                                (declare (not safe))
                                (##fx= __tmp303027 '1))
                              (condition-variable-broadcast! _cv230359_)
                              '#!void)
                          (mutex-unlock! _mx230360_)
                          '#t)
                        (begin (mutex-unlock! _mx230360_) '#f))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ch230342230351_
               'std/misc/channel#channel::t))
            (let* ((_e230346230369_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230342230351_ '1)))
                   (_q230372_ _e230346230369_)
                   (_e230347230374_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230342230351_ '2)))
                   (_mx230377_ _e230347230374_)
                   (_e230348230379_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230342230351_ '3)))
                   (_cv230382_ _e230348230379_)
                   (_e230349230384_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230342230351_ '4)))
                   (_limit230387_ _e230349230384_))
              (_K230345230366_ _limit230387_ _cv230382_ _mx230377_ _q230372_))
            (_E230344230355_)))))
  (define std/misc/channel#channel-sync
    (lambda (_ch230290_ . _vals230291_)
      (let* ((_ch230292230301_ _ch230290_)
             (_E230294230305_
              (lambda () (error '"No clause matching" _ch230292230301_)))
             (_K230295230317_
              (lambda (_limit230308_ _cv230309_ _mx230310_ _q230311_)
                (mutex-lock! _mx230310_)
                (if (let ()
                      (declare (not safe))
                      (##unchecked-structure-ref
                       _ch230290_
                       '5
                       std/misc/channel#channel::t
                       '#f))
                    (begin
                      (mutex-unlock! _mx230310_)
                      (std/error#raise-io-error
                       'channel-sync
                       '"channel is closed"
                       _ch230290_))
                    (begin
                      (if (null? _vals230291_)
                          '#!void
                          (begin
                            (for-each
                             (lambda (_g230312230314_)
                               (std/misc/queue#enqueue!
                                _q230311_
                                _g230312230314_))
                             _vals230291_)
                            (condition-variable-broadcast! _cv230309_)))
                      (mutex-unlock! _mx230310_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ch230292230301_
               'std/misc/channel#channel::t))
            (let* ((_e230296230320_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230292230301_ '1)))
                   (_q230323_ _e230296230320_)
                   (_e230297230325_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230292230301_ '2)))
                   (_mx230328_ _e230297230325_)
                   (_e230298230330_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230292230301_ '3)))
                   (_cv230333_ _e230298230330_)
                   (_e230299230335_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230292230301_ '4)))
                   (_limit230338_ _e230299230335_))
              (_K230295230317_ _limit230338_ _cv230333_ _mx230328_ _q230323_))
            (_E230294230305_)))))
  (define std/misc/channel#channel-get__%
    (lambda (_ch230218_ _timeo230219_ _default230220_)
      (let* ((_timeo230222_ (std/misc/timeout#make-timeout__0 _timeo230219_))
             (_ch230223230232_ _ch230218_)
             (_E230225230236_
              (lambda () (error '"No clause matching" _ch230223230232_)))
             (_K230226230249_
              (lambda (_limit230239_ _cv230240_ _mx230241_ _q230242_)
                (let _lp230244_ ()
                  (mutex-lock! _mx230241_)
                  (if (std/misc/queue#queue-empty? _q230242_)
                      (if (let ()
                            (declare (not safe))
                            (##unchecked-structure-ref
                             _ch230218_
                             '5
                             std/misc/channel#channel::t
                             '#f))
                          (begin (mutex-unlock! _mx230241_) '#!eof)
                          (if (mutex-unlock!
                               _mx230241_
                               _cv230240_
                               _timeo230222_)
                              (_lp230244_)
                              _default230220_))
                      (let ((_next230247_
                             (std/misc/queue#dequeue!__0 _q230242_)))
                        (if (and _limit230239_
                                 (let ((__tmp303029
                                        (##direct-structure-ref
                                         _q230242_
                                         '3
                                         std/misc/queue#queue::t
                                         '#f))
                                       (__tmp303028
                                        (let ()
                                          (declare (not safe))
                                          (##fx- _limit230239_ '1))))
                                   (declare (not safe))
                                   (##fx= __tmp303029 __tmp303028)))
                            (condition-variable-broadcast! _cv230240_)
                            '#!void)
                        (mutex-unlock! _mx230241_)
                        _next230247_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ch230223230232_
               'std/misc/channel#channel::t))
            (let* ((_e230227230252_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230223230232_ '1)))
                   (_q230255_ _e230227230252_)
                   (_e230228230257_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230223230232_ '2)))
                   (_mx230260_ _e230228230257_)
                   (_e230229230262_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230223230232_ '3)))
                   (_cv230265_ _e230229230262_)
                   (_e230230230267_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230223230232_ '4)))
                   (_limit230270_ _e230230230267_))
              (_K230226230249_ _limit230270_ _cv230265_ _mx230260_ _q230255_))
            (_E230225230236_)))))
  (define std/misc/channel#channel-get__0
    (lambda (_ch230275_)
      (let* ((_timeo230277_ '#f) (_default230279_ '#f))
        (std/misc/channel#channel-get__%
         _ch230275_
         _timeo230277_
         _default230279_))))
  (define std/misc/channel#channel-get__1
    (lambda (_ch230281_ _timeo230282_)
      (let ((_default230284_ '#f))
        (std/misc/channel#channel-get__%
         _ch230281_
         _timeo230282_
         _default230284_))))
  (define std/misc/channel#channel-get
    (lambda _g303031_
      (let ((_g303030_ (let () (declare (not safe)) (##length _g303031_))))
        (cond ((let () (declare (not safe)) (##fx= _g303030_ 1))
               (apply std/misc/channel#channel-get__0 _g303031_))
              ((let () (declare (not safe)) (##fx= _g303030_ 2))
               (apply std/misc/channel#channel-get__1 _g303031_))
              ((let () (declare (not safe)) (##fx= _g303030_ 3))
               (apply std/misc/channel#channel-get__% _g303031_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/channel#channel-get
                _g303031_))))))
  (define std/misc/channel#channel-try-get__%
    (lambda (_ch230159_ _default230160_)
      (let* ((_ch230161230170_ _ch230159_)
             (_E230163230174_
              (lambda () (error '"No clause matching" _ch230161230170_)))
             (_K230164230184_
              (lambda (_limit230177_ _cv230178_ _mx230179_ _q230180_)
                (mutex-lock! _mx230179_)
                (if (std/misc/queue#queue-empty? _q230180_)
                    (begin
                      (mutex-unlock! _mx230179_)
                      (if (let ()
                            (declare (not safe))
                            (##unchecked-structure-ref
                             _ch230159_
                             '5
                             std/misc/channel#channel::t
                             '#f))
                          '#!eof
                          _default230160_))
                    (let ((_next230182_
                           (std/misc/queue#dequeue!__0 _q230180_)))
                      (if (and _limit230177_
                               (let ((__tmp303033
                                      (##direct-structure-ref
                                       _q230180_
                                       '3
                                       std/misc/queue#queue::t
                                       '#f))
                                     (__tmp303032
                                      (let ()
                                        (declare (not safe))
                                        (##fx- _limit230177_ '1))))
                                 (declare (not safe))
                                 (##fx= __tmp303033 __tmp303032)))
                          (condition-variable-broadcast! _cv230178_)
                          '#!void)
                      (mutex-unlock! _mx230179_)
                      _next230182_)))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ch230161230170_
               'std/misc/channel#channel::t))
            (let* ((_e230165230187_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230161230170_ '1)))
                   (_q230190_ _e230165230187_)
                   (_e230166230192_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230161230170_ '2)))
                   (_mx230195_ _e230166230192_)
                   (_e230167230197_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230161230170_ '3)))
                   (_cv230200_ _e230167230197_)
                   (_e230168230202_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230161230170_ '4)))
                   (_limit230205_ _e230168230202_))
              (_K230164230184_ _limit230205_ _cv230200_ _mx230195_ _q230190_))
            (_E230163230174_)))))
  (define std/misc/channel#channel-try-get__0
    (lambda (_ch230210_)
      (let ((_default230212_ '#f))
        (std/misc/channel#channel-try-get__% _ch230210_ _default230212_))))
  (define std/misc/channel#channel-try-get
    (lambda _g303035_
      (let ((_g303034_ (let () (declare (not safe)) (##length _g303035_))))
        (cond ((let () (declare (not safe)) (##fx= _g303034_ 1))
               (apply std/misc/channel#channel-try-get__0 _g303035_))
              ((let () (declare (not safe)) (##fx= _g303034_ 2))
               (apply std/misc/channel#channel-try-get__% _g303035_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/channel#channel-try-get
                _g303035_))))))
  (define std/misc/channel#channel-close
    (lambda (_ch230109_)
      (let* ((_ch230110230120_ _ch230109_)
             (_E230112230124_
              (lambda () (error '"No clause matching" _ch230110230120_)))
             (_K230113230132_
              (lambda (_eof230127_ _cv230128_ _mx230129_ _q230130_)
                (if _eof230127_
                    '#!void
                    (begin
                      (mutex-lock! _mx230129_)
                      (let ()
                        (declare (not safe))
                        (##unchecked-structure-set!
                         _ch230109_
                         '#t
                         '5
                         std/misc/channel#channel::t
                         '#f))
                      (condition-variable-broadcast!
                       (##direct-structure-ref
                        _ch230109_
                        '3
                        std/misc/channel#channel::t
                        '#f))
                      (mutex-unlock! _mx230129_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ch230110230120_
               'std/misc/channel#channel::t))
            (let* ((_e230114230135_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230110230120_ '1)))
                   (_q230138_ _e230114230135_)
                   (_e230115230140_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230110230120_ '2)))
                   (_mx230143_ _e230115230140_)
                   (_e230116230145_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230110230120_ '3)))
                   (_cv230148_ _e230116230145_)
                   (_e230117230150_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230110230120_ '4)))
                   (_e230118230153_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ch230110230120_ '5)))
                   (_eof230156_ _e230118230153_))
              (_K230113230132_ _eof230156_ _cv230148_ _mx230143_ _q230138_))
            (_E230112230124_)))))
  (define std/misc/channel#channel::destroy std/misc/channel#channel-close)
  (bind-method!
   std/misc/channel#channel::t
   'destroy
   std/misc/channel#channel::destroy
   '#f)
  (define std/misc/channel#channel-closed?
    (lambda (_ch229985_)
      (##direct-structure-ref _ch229985_ '5 std/misc/channel#channel::t '#f)))
  (define std/misc/channel#:iter::channel
    (lambda (_ch229983_) (std/misc/channel#iter-channel _ch229983_)))
  (std/generic/dispatch#generic-bind!
   std/iter#:iter::t
   (cons (std/generic/dispatch#type-linearize-class
          std/misc/channel#channel::t)
         '())
   std/misc/channel#:iter::channel)
  (define std/misc/channel#iter-channel
    (lambda (_ch229887_)
      (letrec ((_next229889_
                (lambda (_it229891_)
                  (let* ((_it229892229898_ _it229891_)
                         (_E229894229902_
                          (lambda ()
                            (error '"No clause matching" _it229892229898_)))
                         (_K229895229909_
                          (lambda (_ch229905_)
                            (let ((_val229907_
                                   (std/misc/channel#channel-get__0
                                    _ch229905_)))
                              (if (eof-object? _val229907_)
                                  std/iter#iter-end
                                  _val229907_)))))
                    (if (let ()
                          (declare (not safe))
                          (##structure-direct-instance-of?
                           _it229892229898_
                           'std/iter#iterator::t))
                        (let* ((_e229896229912_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref _it229892229898_ '1)))
                               (_ch229915_ _e229896229912_))
                          (_K229895229909_ _ch229915_))
                        (_E229894229902_))))))
        (let ((__obj303015 (make-object std/iter#iterator::t '3)))
          (std/iter#iterator:::init!__0 __obj303015 _ch229887_ _next229889_)
          __obj303015)))))
