(declare (block) (standard-bindings) (extended-bindings))
(begin
  (bind-method! (macro-type-port) 'destroy close-port)
  (define std/misc/ports#copy-port
    (lambda (_in231043_ _out231044_)
      (if (not (input-port? _in231043_))
          (error '"Expected input port" _in231043_)
          (if (not (output-port? _out231044_))
              (error '"Expected output port" _out231044_)
              (if (macro-byte-port? _in231043_)
                  (if (macro-byte-port? _out231044_)
                      (std/misc/ports#try-copy-byte-port
                       _in231043_
                       _out231044_)
                      (if (macro-character-port? _out231044_)
                          (std/misc/ports#copy-character-port
                           _in231043_
                           _out231044_)
                          (std/misc/ports#copy-object-port
                           _in231043_
                           _out231044_)))
                  (if (macro-character-port? _in231043_)
                      (if (macro-character-port? _out231044_)
                          (std/misc/ports#copy-character-port
                           _in231043_
                           _out231044_)
                          (std/misc/ports#copy-object-port
                           _in231043_
                           _out231044_))
                      (std/misc/ports#copy-object-port
                       _in231043_
                       _out231044_)))))))
  (define std/misc/ports#try-copy-byte-port
    (lambda (_in231037_ _out231038_)
      (macro-port-mutex-lock! _in231037_)
      (if (or (let ((__tmp303050 (macro-character-port-rlo _in231037_))
                    (__tmp303049 (macro-character-port-rhi _in231037_)))
                (declare (not safe))
                (##fx< __tmp303050 __tmp303049))
              (macro-character-port-peek-eof? _in231037_))
          (std/misc/ports#copy-character-port/lock _in231037_ _out231038_)
          (std/misc/ports#copy-byte-port/lock _in231037_ _out231038_))))
  (define std/misc/ports#copy-character-port
    (lambda (_in231034_ _out231035_)
      (macro-port-mutex-lock! _in231034_)
      (std/misc/ports#copy-character-port/lock _in231034_ _out231035_)))
  (define std/misc/ports#copy-byte-port/lock
    (lambda (_in231009_ _out231010_)
      (letrec ((_loop231012_
                (lambda ()
                  (let ((_rlo231022_ (macro-byte-port-rlo _in231009_))
                        (_rhi231023_ (macro-byte-port-rhi _in231009_)))
                    (if (let ()
                          (declare (not safe))
                          (##fx< _rlo231022_ _rhi231023_))
                        (let ((_rbuf231025_ (macro-byte-port-rbuf _in231009_)))
                          (with-exception-catcher
                           (lambda (_g231026231028_)
                             (if '#t
                                 (let ((_e231031_ _g231026231028_))
                                   (if (eq? _in231009_ _out231010_)
                                       '#!void
                                       (macro-port-mutex-unlock! _in231009_))
                                   (raise _e231031_))
                                 (raise _g231026231028_)))
                           (lambda ()
                             (if (eq? _in231009_ _out231010_)
                                 (macro-port-mutex-unlock! _in231009_)
                                 '#!void)
                             (write-subu8vector
                              _rbuf231025_
                              _rlo231022_
                              _rhi231023_
                              _out231010_)
                             (if (eq? _in231009_ _out231010_)
                                 (macro-port-mutex-lock! _in231009_)
                                 '#!void)))
                          (macro-byte-port-rlo-set! _in231009_ _rhi231023_)
                          (_rbuf-fill231013_))
                        (_rbuf-fill231013_)))))
               (_rbuf-fill231013_
                (lambda ()
                  (let* ((_rbuf231016_ (macro-byte-port-rbuf _in231009_))
                         (_res231018_
                          ((macro-byte-port-rbuf-fill _in231009_)
                           _in231009_
                           (let ()
                             (declare (not safe))
                             (##u8vector-length _rbuf231016_))
                           '#t)))
                    (if (eq? _res231018_ ##err-code-EAGAIN)
                        (macro-port-mutex-unlock! _in231009_)
                        (if (fixnum? _res231018_)
                            (begin
                              (macro-port-mutex-unlock! _in231009_)
                              (let ()
                                (declare (not safe))
                                (##raise-os-io-exception
                                 _in231009_
                                 '#f
                                 _res231018_
                                 std/misc/ports#copy-port
                                 _in231009_
                                 _out231010_)))
                            (if _res231018_
                                (_loop231012_)
                                (macro-port-mutex-unlock! _in231009_))))))))
        (_loop231012_))))
  (define std/misc/ports#copy-character-port/lock
    (lambda (_in230984_ _out230985_)
      (letrec ((_loop230987_
                (lambda ()
                  (let ((_rlo230997_ (macro-character-port-rlo _in230984_))
                        (_rhi230998_ (macro-character-port-rhi _in230984_)))
                    (if (let ()
                          (declare (not safe))
                          (##fx< _rlo230997_ _rhi230998_))
                        (let ((_rbuf231000_
                               (macro-character-port-rbuf _in230984_)))
                          (with-exception-catcher
                           (lambda (_g231001231003_)
                             (if '#t
                                 (let ((_e231006_ _g231001231003_))
                                   (if (eq? _in230984_ _out230985_)
                                       '#!void
                                       (macro-port-mutex-unlock! _in230984_))
                                   (raise _e231006_))
                                 (raise _g231001231003_)))
                           (lambda ()
                             (if (eq? _in230984_ _out230985_)
                                 (macro-port-mutex-unlock! _in230984_)
                                 '#!void)
                             (write-substring
                              _rbuf231000_
                              _rlo230997_
                              _rhi230998_
                              _out230985_)
                             (if (eq? _in230984_ _out230985_)
                                 (macro-port-mutex-lock! _in230984_)
                                 '#!void)))
                          (macro-character-port-rlo-set!
                           _in230984_
                           _rhi230998_)
                          (_rbuf-fill230988_))
                        (if (macro-character-port-peek-eof? _in230984_)
                            (begin
                              (macro-character-port-peek-eof?-set!
                               _in230984_
                               '#f)
                              (macro-port-mutex-unlock! _in230984_))
                            (_rbuf-fill230988_))))))
               (_rbuf-fill230988_
                (lambda ()
                  (let* ((_rbuf230991_ (macro-character-port-rbuf _in230984_))
                         (_res230993_
                          ((macro-character-port-rbuf-fill _in230984_)
                           _in230984_
                           (let ()
                             (declare (not safe))
                             (##string-length _rbuf230991_))
                           '#t)))
                    (if (eq? _res230993_ ##err-code-EAGAIN)
                        (macro-port-mutex-unlock! _in230984_)
                        (if (fixnum? _res230993_)
                            (begin
                              (macro-port-mutex-unlock! _in230984_)
                              (let ()
                                (declare (not safe))
                                (##raise-os-io-exception
                                 _in230984_
                                 '#f
                                 _res230993_
                                 std/misc/ports#copy-port
                                 _in230984_
                                 _out230985_)))
                            (if _res230993_
                                (_loop230987_)
                                (macro-port-mutex-unlock! _in230984_))))))))
        (_loop230987_))))
  (define std/misc/ports#copy-object-port
    (lambda (_in230977_ _out230978_)
      (let _lp230980_ ((_next230982_ (read _in230977_)))
        (if (eof-object? _next230982_)
            '#!void
            (begin
              (write _next230982_ _out230978_)
              (_lp230980_ (read _in230977_)))))))
  (define std/misc/ports#read-all-as-string
    (lambda (_port230973_)
      (let ((_string230975_ (read-line _port230973_ '#f)))
        (if (string? _string230975_) _string230975_ '""))))
  (define std/misc/ports#read-file-string__%
    (lambda (_g303051_ _settings230950230953_ _file230955_)
      (let ((_settings230957_
             (if (eq? _settings230950230953_ absent-value)
                 '()
                 _settings230950230953_)))
        (call-with-input-file
         (cons 'path: (cons _file230955_ _settings230957_))
         std/misc/ports#read-all-as-string))))
  (define std/misc/ports#read-file-string__@
    (lambda (_keys230949230962_ . _args230964_)
      (apply std/misc/ports#read-file-string__%
             _keys230949230962_
             (table-ref _keys230949230962_ 'settings: absent-value)
             _args230964_)))
  (define std/misc/ports#read-file-string
    (lambda _args230951230970_
      (apply keyword-dispatch
             '#(settings:)
             std/misc/ports#read-file-string__@
             _args230951230970_)))
  (define std/misc/ports#read-all-as-lines__%
    (lambda (_g303052_
             _separator230744230748_
             _include-separator?230745230750_
             _port230752_)
      (let* ((_separator230754_
              (if (eq? _separator230744230748_ absent-value)
                  '#\newline
                  _separator230744230748_))
             (_include-separator?230756_
              (if (eq? _include-separator?230745230750_ absent-value)
                  '#f
                  _include-separator?230745230750_))
             (_head230758_ (cons '#f '()))
             (_tail230761_ _head230758_))
        (let _loop230926_ ()
          (let ((_line230929_
                 (read-line
                  _port230752_
                  _separator230754_
                  _include-separator?230756_)))
            (if (string? _line230929_)
                (begin
                  (let ((_new-tail230931_ (cons _line230929_ '())))
                    (let ()
                      (declare (not safe))
                      (##set-cdr! _tail230761_ _new-tail230931_))
                    (set! _tail230761_ _new-tail230931_))
                  (_loop230926_))
                '#!void)))
        (let () (declare (not safe)) (##cdr _head230758_)))))
  (define std/misc/ports#read-all-as-lines__@
    (lambda (_keys230743230937_ . _args230939_)
      (apply std/misc/ports#read-all-as-lines__%
             _keys230743230937_
             (table-ref _keys230743230937_ 'separator: absent-value)
             (table-ref _keys230743230937_ 'include-separator?: absent-value)
             _args230939_)))
  (define std/misc/ports#read-all-as-lines
    (lambda _args230746230945_
      (apply keyword-dispatch
             '#(separator: #f include-separator?: #f)
             std/misc/ports#read-all-as-lines__@
             _args230746230945_)))
  (define std/misc/ports#read-file-lines__%
    (lambda (_g303053_ _settings230719230722_ _file230724_)
      (let ((_settings230726_
             (if (eq? _settings230719230722_ absent-value)
                 '()
                 _settings230719230722_)))
        (call-with-input-file
         (cons 'path: (cons _file230724_ _settings230726_))
         std/misc/ports#read-all-as-lines))))
  (define std/misc/ports#read-file-lines__@
    (lambda (_keys230718230731_ . _args230733_)
      (apply std/misc/ports#read-file-lines__%
             _keys230718230731_
             (table-ref _keys230718230731_ 'settings: absent-value)
             _args230733_)))
  (define std/misc/ports#read-file-lines
    (lambda _args230720230739_
      (apply keyword-dispatch
             '#(settings:)
             std/misc/ports#read-file-lines__@
             _args230720230739_)))
  (define std/misc/ports#read-all-as-u8vector__%
    (lambda (_port230697_ _bufsize230698_)
      (let _lp230700_ ((_buf230702_ (make-u8vector _bufsize230698_))
                       (_u8s230703_ '()))
        (let ((_len230705_
               (read-subu8vector _buf230702_ '0 _bufsize230698_ _port230697_)))
          (if (= _len230705_ _bufsize230698_)
              (_lp230700_
               (make-u8vector _bufsize230698_)
               (cons _buf230702_ _u8s230703_))
              (begin
                (u8vector-shrink! _buf230702_ _len230705_)
                (u8vector-concatenate
                 (reverse (cons _buf230702_ _u8s230703_)))))))))
  (define std/misc/ports#read-all-as-u8vector__0
    (lambda (_port230710_)
      (let ((_bufsize230712_ '8192))
        (std/misc/ports#read-all-as-u8vector__%
         _port230710_
         _bufsize230712_))))
  (define std/misc/ports#read-all-as-u8vector
    (lambda _g303055_
      (let ((_g303054_ (let () (declare (not safe)) (##length _g303055_))))
        (cond ((let () (declare (not safe)) (##fx= _g303054_ 1))
               (apply std/misc/ports#read-all-as-u8vector__0 _g303055_))
              ((let () (declare (not safe)) (##fx= _g303054_ 2))
               (apply std/misc/ports#read-all-as-u8vector__% _g303055_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/ports#read-all-as-u8vector
                _g303055_))))))
  (define std/misc/ports#read-file-u8vector__%
    (lambda (_g303056_
             _settings230664230668_
             _bufsize230665230670_
             _file230672_)
      (let* ((_settings230674_
              (if (eq? _settings230664230668_ absent-value)
                  '()
                  _settings230664230668_))
             (_bufsize230676_
              (if (eq? _bufsize230665230670_ absent-value)
                  '8192
                  _bufsize230665230670_)))
        (call-with-input-file
         (cons 'path: (cons _file230672_ _settings230674_))
         (lambda (_g230677230679_)
           (std/misc/ports#read-all-as-u8vector__%
            _g230677230679_
            _bufsize230676_))))))
  (define std/misc/ports#read-file-u8vector__@
    (lambda (_keys230663230685_ . _args230687_)
      (apply std/misc/ports#read-file-u8vector__%
             _keys230663230685_
             (table-ref _keys230663230685_ 'settings: absent-value)
             (table-ref _keys230663230685_ 'bufsize: absent-value)
             _args230687_)))
  (define std/misc/ports#read-file-u8vector
    (lambda _args230666230693_
      (apply keyword-dispatch
             '#(settings: bufsize:)
             std/misc/ports#read-file-u8vector__@
             _args230666230693_)))
  (define std/misc/ports#write-file-string__%
    (lambda (_g303057_
             _settings230631230635_
             _newline-ending230632230637_
             _file230639_
             _string230640_)
      (let* ((_settings230642_
              (if (eq? _settings230631230635_ absent-value)
                  '()
                  _settings230631230635_))
             (_newline-ending230644_
              (if (eq? _newline-ending230632230637_ absent-value)
                  '#t
                  _newline-ending230632230637_)))
        (call-with-output-file
         (cons 'path: (cons _file230639_ _settings230642_))
         (lambda (_port230646_)
           (display _string230640_ _port230646_)
           (if (and _newline-ending230644_
                    (not (string-empty? _string230640_))
                    (not (std/srfi/13#string-suffix?__0 '"\n" _string230640_)))
               (newline _port230646_)
               '#!void))))))
  (define std/misc/ports#write-file-string__@
    (lambda (_keys230630230651_ . _args230653_)
      (apply std/misc/ports#write-file-string__%
             _keys230630230651_
             (table-ref _keys230630230651_ 'settings: absent-value)
             (table-ref _keys230630230651_ 'newline-ending: absent-value)
             _args230653_)))
  (define std/misc/ports#write-file-string
    (lambda _args230633230659_
      (apply keyword-dispatch
             '#(settings: newline-ending:)
             std/misc/ports#write-file-string__@
             _args230633230659_)))
  (define std/misc/ports#write-file-lines__%
    (lambda (_g303058_
             _settings230598230602_
             _newline-ending230599230604_
             _file230606_
             _list230607_)
      (let* ((_settings230609_
              (if (eq? _settings230598230602_ absent-value)
                  '()
                  _settings230598230602_))
             (_newline-ending230611_
              (if (eq? _newline-ending230599230604_ absent-value)
                  '#t
                  _newline-ending230599230604_)))
        (letrec* ((_string230613_ (string-join _list230607_ '"\n")))
          (std/misc/ports#write-file-string__%
           '#f
           _settings230609_
           _newline-ending230611_
           _file230606_
           _string230613_)))))
  (define std/misc/ports#write-file-lines__@
    (lambda (_keys230597230618_ . _args230620_)
      (apply std/misc/ports#write-file-lines__%
             _keys230597230618_
             (table-ref _keys230597230618_ 'settings: absent-value)
             (table-ref _keys230597230618_ 'newline-ending: absent-value)
             _args230620_)))
  (define std/misc/ports#write-file-lines
    (lambda _args230600230626_
      (apply keyword-dispatch
             '#(settings: newline-ending:)
             std/misc/ports#write-file-lines__@
             _args230600230626_))))
