(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/net/bio/input#input-buffer::t
    (make-struct-type
     'std/net/bio/input#input-buffer::t
     '#f
     '5
     'input-buffer
     '()
     '#f
     '(e rlo rhi fill read)))
  (define std/net/bio/input#input-buffer?
    (make-struct-predicate std/net/bio/input#input-buffer::t))
  (define std/net/bio/input#make-input-buffer
    (lambda _$args178317_
      (apply make-struct-instance
             std/net/bio/input#input-buffer::t
             _$args178317_)))
  (define std/net/bio/input#input-buffer-e
    (make-struct-field-accessor std/net/bio/input#input-buffer::t '0))
  (define std/net/bio/input#input-buffer-rlo
    (make-struct-field-accessor std/net/bio/input#input-buffer::t '1))
  (define std/net/bio/input#input-buffer-rhi
    (make-struct-field-accessor std/net/bio/input#input-buffer::t '2))
  (define std/net/bio/input#input-buffer-fill
    (make-struct-field-accessor std/net/bio/input#input-buffer::t '3))
  (define std/net/bio/input#input-buffer-read
    (make-struct-field-accessor std/net/bio/input#input-buffer::t '4))
  (define std/net/bio/input#input-buffer-e-set!
    (make-struct-field-mutator std/net/bio/input#input-buffer::t '0))
  (define std/net/bio/input#input-buffer-rlo-set!
    (make-struct-field-mutator std/net/bio/input#input-buffer::t '1))
  (define std/net/bio/input#input-buffer-rhi-set!
    (make-struct-field-mutator std/net/bio/input#input-buffer::t '2))
  (define std/net/bio/input#input-buffer-fill-set!
    (make-struct-field-mutator std/net/bio/input#input-buffer::t '3))
  (define std/net/bio/input#input-buffer-read-set!
    (make-struct-field-mutator std/net/bio/input#input-buffer::t '4))
  (define std/net/bio/input#&input-buffer-e
    (make-struct-field-unchecked-accessor
     std/net/bio/input#input-buffer::t
     '0))
  (define std/net/bio/input#&input-buffer-rlo
    (make-struct-field-unchecked-accessor
     std/net/bio/input#input-buffer::t
     '1))
  (define std/net/bio/input#&input-buffer-rhi
    (make-struct-field-unchecked-accessor
     std/net/bio/input#input-buffer::t
     '2))
  (define std/net/bio/input#&input-buffer-fill
    (make-struct-field-unchecked-accessor
     std/net/bio/input#input-buffer::t
     '3))
  (define std/net/bio/input#&input-buffer-read
    (make-struct-field-unchecked-accessor
     std/net/bio/input#input-buffer::t
     '4))
  (define std/net/bio/input#&input-buffer-e-set!
    (make-struct-field-unchecked-mutator std/net/bio/input#input-buffer::t '0))
  (define std/net/bio/input#&input-buffer-rlo-set!
    (make-struct-field-unchecked-mutator std/net/bio/input#input-buffer::t '1))
  (define std/net/bio/input#&input-buffer-rhi-set!
    (make-struct-field-unchecked-mutator std/net/bio/input#input-buffer::t '2))
  (define std/net/bio/input#&input-buffer-fill-set!
    (make-struct-field-unchecked-mutator std/net/bio/input#input-buffer::t '3))
  (define std/net/bio/input#&input-buffer-read-set!
    (make-struct-field-unchecked-mutator std/net/bio/input#input-buffer::t '4))
  (define std/net/bio/input#bio-input-fill!
    (lambda (_buf178314_ _need178315_)
      ((##unchecked-structure-ref
        _buf178314_
        '4
        std/net/bio/input#input-buffer::t
        '#f)
       _buf178314_
       _need178315_)))
  (define std/net/bio/input#bio-input-read
    (lambda (_bytes178309_ _start178310_ _end178311_ _buf178312_)
      ((##unchecked-structure-ref
        _buf178312_
        '5
        std/net/bio/input#input-buffer::t
        '#f)
       _bytes178309_
       _start178310_
       _end178311_
       _buf178312_)))
  (define std/net/bio/input#bio-read-u8
    (lambda (_buf178295_)
      (let ((_rlo178297_
             (##unchecked-structure-ref
              _buf178295_
              '2
              std/net/bio/input#input-buffer::t
              '#f))
            (_rhi178298_
             (##unchecked-structure-ref
              _buf178295_
              '3
              std/net/bio/input#input-buffer::t
              '#f)))
        (if (##fx< _rlo178297_ _rhi178298_)
            (let ((_u8178300_
                   (##u8vector-ref
                    (##unchecked-structure-ref
                     _buf178295_
                     '1
                     std/net/bio/input#input-buffer::t
                     '#f)
                    _rlo178297_)))
              (##unchecked-structure-set!
               _buf178295_
               (##fx+ _rlo178297_ '1)
               '2
               std/net/bio/input#input-buffer::t
               '#f)
              _u8178300_)
            (let ((_rd178302_
                   (std/net/bio/input#bio-input-fill! _buf178295_ '1)))
              (if (##fxzero? _rd178302_)
                  (eof-object)
                  (let* ((_rlo178304_
                          (##unchecked-structure-ref
                           _buf178295_
                           '2
                           std/net/bio/input#input-buffer::t
                           '#f))
                         (_u8178306_
                          (##u8vector-ref
                           (##unchecked-structure-ref
                            _buf178295_
                            '1
                            std/net/bio/input#input-buffer::t
                            '#f)
                           _rlo178304_)))
                    (##unchecked-structure-set!
                     _buf178295_
                     (##fx+ _rlo178304_ '1)
                     '2
                     std/net/bio/input#input-buffer::t
                     '#f)
                    _u8178306_)))))))
  (define std/net/bio/input#bio-peek-u8
    (lambda (_buf178286_)
      (let ((_rlo178288_
             (##unchecked-structure-ref
              _buf178286_
              '2
              std/net/bio/input#input-buffer::t
              '#f))
            (_rhi178289_
             (##unchecked-structure-ref
              _buf178286_
              '3
              std/net/bio/input#input-buffer::t
              '#f)))
        (if (##fx< _rlo178288_ _rhi178289_)
            (##u8vector-ref
             (##unchecked-structure-ref
              _buf178286_
              '1
              std/net/bio/input#input-buffer::t
              '#f)
             _rlo178288_)
            (let ((_rd178291_
                   (std/net/bio/input#bio-input-fill! _buf178286_ '1)))
              (if (##fxzero? _rd178291_)
                  (eof-object)
                  (let ((_rlo178293_
                         (##unchecked-structure-ref
                          _buf178286_
                          '2
                          std/net/bio/input#input-buffer::t
                          '#f)))
                    (##u8vector-ref
                     (##unchecked-structure-ref
                      _buf178286_
                      '1
                      std/net/bio/input#input-buffer::t
                      '#f)
                     _rlo178293_))))))))
  (define std/net/bio/input#bio-read-subu8vector
    (lambda (_bytes178263_ _start178264_ _end178265_ _buf178266_)
      (let* ((_rlo178268_
              (##unchecked-structure-ref
               _buf178266_
               '2
               std/net/bio/input#input-buffer::t
               '#f))
             (_rhi178270_
              (##unchecked-structure-ref
               _buf178266_
               '3
               std/net/bio/input#input-buffer::t
               '#f))
             (_need178272_ (##fx- _end178265_ _start178264_))
             (_rlo+need178274_ (##fx+ _rlo178268_ _need178272_)))
        (if (##fx<= _rlo+need178274_ _rhi178270_)
            (begin
              (##subu8vector-move!
               (##unchecked-structure-ref
                _buf178266_
                '1
                std/net/bio/input#input-buffer::t
                '#f)
               _rlo178268_
               _rlo+need178274_
               _bytes178263_
               _start178264_)
              (##unchecked-structure-set!
               _buf178266_
               _rlo+need178274_
               '2
               std/net/bio/input#input-buffer::t
               '#f)
              _need178272_)
            (if (##fx< _rlo178268_ _rhi178270_)
                (begin
                  (##subu8vector-move!
                   (##unchecked-structure-ref
                    _buf178266_
                    '1
                    std/net/bio/input#input-buffer::t
                    '#f)
                   _rlo178268_
                   _rhi178270_
                   _bytes178263_
                   _start178264_)
                  (##unchecked-structure-set!
                   _buf178266_
                   _rhi178270_
                   '2
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (let* ((_have178277_ (##fx- _rhi178270_ _rlo178268_))
                         (_need178279_ (##fx- _need178272_ _have178277_)))
                    (if (##fx< _need178279_
                               (##u8vector-length
                                (##unchecked-structure-ref
                                 _buf178266_
                                 '1
                                 std/net/bio/input#input-buffer::t
                                 '#f)))
                        (let ((_rd178282_
                               (std/net/bio/input#bio-input-fill!
                                _buf178266_
                                _need178279_)))
                          (if (##fx> _rd178282_ '0)
                              (##fx+ _have178277_
                                     (std/net/bio/input#bio-read-subu8vector
                                      _bytes178263_
                                      (##fx+ _start178264_ _have178277_)
                                      _end178265_
                                      _buf178266_))
                              _have178277_))
                        (##fx+ _have178277_
                               (std/net/bio/input#bio-input-read
                                _bytes178263_
                                (##fx+ _start178264_ _have178277_)
                                _end178265_
                                _buf178266_)))))
                (if (##fx< _need178272_
                           (##u8vector-length
                            (##unchecked-structure-ref
                             _buf178266_
                             '1
                             std/net/bio/input#input-buffer::t
                             '#f)))
                    (let ((_rd178284_
                           (std/net/bio/input#bio-input-fill!
                            _buf178266_
                            _need178272_)))
                      (if (##fx> _rd178284_ '0)
                          (std/net/bio/input#bio-read-subu8vector
                           _bytes178263_
                           _start178264_
                           _end178265_
                           _buf178266_)
                          '0))
                    (std/net/bio/input#bio-input-read
                     _bytes178263_
                     _start178264_
                     _end178265_
                     _buf178266_)))))))
  (define std/net/bio/input#bio-read-subu8vector*__%
    (lambda (_bytes178224_ _start178225_ _end178226_ _buf178227_ _need178228_)
      (let* ((_rlo178230_
              (##unchecked-structure-ref
               _buf178227_
               '2
               std/net/bio/input#input-buffer::t
               '#f))
             (_rhi178232_
              (##unchecked-structure-ref
               _buf178227_
               '3
               std/net/bio/input#input-buffer::t
               '#f))
             (_have178234_ (##fx- _rhi178232_ _rlo178230_))
             (_want178236_ (##fx- _end178226_ _start178225_))
             (_need178238_ (##fxmin _want178236_ _need178228_))
             (_copy178240_ (##fxmin _want178236_ _have178234_)))
        (if (##fx> _copy178240_ '0)
            (let ((_rlo+copy178243_ (##fx+ _rlo178230_ _copy178240_)))
              (##subu8vector-move!
               (##unchecked-structure-ref
                _buf178227_
                '1
                std/net/bio/input#input-buffer::t
                '#f)
               _rlo178230_
               _rlo+copy178243_
               _bytes178224_
               _start178225_)
              (##unchecked-structure-set!
               _buf178227_
               _rlo+copy178243_
               '2
               std/net/bio/input#input-buffer::t
               '#f))
            '#!void)
        (if (##fx>= _copy178240_ _need178238_)
            _copy178240_
            (let ((_rd178245_
                   (std/net/bio/input#bio-input-fill! _buf178227_ '1)))
              (if (##fx> _rd178245_ '0)
                  (std/net/bio/input#bio-read-subu8vector*__%
                   _bytes178224_
                   (##fx+ _start178225_ _copy178240_)
                   _end178226_
                   _buf178227_
                   (##fx- _need178238_ _copy178240_))
                  _copy178240_))))))
  (define std/net/bio/input#bio-read-subu8vector*__0
    (lambda (_bytes178250_ _start178251_ _end178252_ _buf178253_)
      (let ((_need178255_ '0))
        (std/net/bio/input#bio-read-subu8vector*__%
         _bytes178250_
         _start178251_
         _end178252_
         _buf178253_
         _need178255_))))
  (define std/net/bio/input#bio-read-subu8vector*
    (lambda _g290350_
      (let ((_g290349_ (##length _g290350_)))
        (cond ((##fx= _g290349_ 4)
               (apply std/net/bio/input#bio-read-subu8vector*__0 _g290350_))
              ((##fx= _g290349_ 5)
               (apply std/net/bio/input#bio-read-subu8vector*__% _g290350_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/bio/input#bio-read-subu8vector*
                _g290350_))))))
  (define std/net/bio/input#bio-read-subu8vector-unbuffered
    (lambda (_bytes178207_ _start178208_ _end178209_ _buf178210_)
      (let* ((_need178212_ (##fx- _end178209_ _start178208_))
             (_rlo178214_
              (##unchecked-structure-ref
               _buf178210_
               '2
               std/net/bio/input#input-buffer::t
               '#f))
             (_rhi178216_
              (##unchecked-structure-ref
               _buf178210_
               '3
               std/net/bio/input#input-buffer::t
               '#f))
             (_rlo+need178218_ (##fx+ _rlo178214_ _need178212_)))
        (if (##fx<= _rlo+need178218_ _rhi178216_)
            (begin
              (##subu8vector-move!
               (##unchecked-structure-ref
                _buf178210_
                '1
                std/net/bio/input#input-buffer::t
                '#f)
               _rlo178214_
               _rlo+need178218_
               _bytes178207_
               _start178208_)
              (##unchecked-structure-set!
               _buf178210_
               _rlo+need178218_
               '2
               std/net/bio/input#input-buffer::t
               '#f)
              _need178212_)
            (if (##fx< _rlo178214_ _rhi178216_)
                (let ((_have178221_ (##fx- _rhi178216_ _rlo178214_)))
                  (##subu8vector-move!
                   (##unchecked-structure-ref
                    _buf178210_
                    '1
                    std/net/bio/input#input-buffer::t
                    '#f)
                   _rlo178214_
                   _rhi178216_
                   _bytes178207_
                   _start178208_)
                  (##unchecked-structure-set!
                   _buf178210_
                   _rhi178216_
                   '2
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (##fx+ _have178221_
                         (std/net/bio/input#bio-input-read
                          _bytes178207_
                          (##fx+ _start178208_ _have178221_)
                          _end178209_
                          _buf178210_)))
                (std/net/bio/input#bio-input-read
                 _bytes178207_
                 _start178208_
                 _end178209_
                 _buf178210_))))))
  (define std/net/bio/input#bio-read-bytes
    (lambda (_bytes178199_ _buf178200_)
      (let* ((_len178202_ (u8vector-length _bytes178199_))
             (_rd178204_
              (std/net/bio/input#bio-read-subu8vector
               _bytes178199_
               '0
               _len178202_
               _buf178200_)))
        (if (##fx= _rd178204_ _len178202_)
            '#!void
            (std/error#raise-io-error
             'bio-read-bytes
             '"premature end of input"
             _buf178200_
             _rd178204_
             _len178202_)))))
  (define std/net/bio/input#bio-read-bytes-unbuffered
    (lambda (_bytes178191_ _buf178192_)
      (let* ((_len178194_ (u8vector-length _bytes178191_))
             (_rd178196_
              (std/net/bio/input#bio-read-subu8vector-unbuffered
               _bytes178191_
               '0
               _len178194_
               _buf178192_)))
        (if (##fx= _rd178196_ _len178194_)
            '#!void
            (std/error#raise-io-error
             'bio-read-bytes
             '"premature end of input"
             _buf178192_
             _rd178196_
             _len178194_)))))
  (define std/net/bio/input#bio-read-u32
    (lambda (_buf178170_)
      (let* ((_rlo178172_
              (##unchecked-structure-ref
               _buf178170_
               '2
               std/net/bio/input#input-buffer::t
               '#f))
             (_rhi178174_
              (##unchecked-structure-ref
               _buf178170_
               '3
               std/net/bio/input#input-buffer::t
               '#f))
             (_rlo+4178176_ (##fx+ _rlo178172_ '4)))
        (if (##fx<= _rlo+4178176_ _rhi178174_)
            (let ((_u32178179_
                   (std/net/bio/input#bio-get-u32
                    (##unchecked-structure-ref
                     _buf178170_
                     '1
                     std/net/bio/input#input-buffer::t
                     '#f)
                    _rlo178172_)))
              (##unchecked-structure-set!
               _buf178170_
               _rlo+4178176_
               '2
               std/net/bio/input#input-buffer::t
               '#f)
              _u32178179_)
            (let* ((_g290351_
                    (std/net/bio/input#bio-input-fill! _buf178170_ '4))
                   (_rlo178182_
                    (##unchecked-structure-ref
                     _buf178170_
                     '2
                     std/net/bio/input#input-buffer::t
                     '#f))
                   (_rhi178184_
                    (##unchecked-structure-ref
                     _buf178170_
                     '3
                     std/net/bio/input#input-buffer::t
                     '#f))
                   (_rlo+4178186_ (##fx+ _rlo178182_ '4)))
              (if (##fx<= _rlo+4178186_ _rhi178184_)
                  (let ((_u32178189_
                         (std/net/bio/input#bio-get-u32
                          (##unchecked-structure-ref
                           _buf178170_
                           '1
                           std/net/bio/input#input-buffer::t
                           '#f)
                          _rlo178182_)))
                    (##unchecked-structure-set!
                     _buf178170_
                     _rlo+4178186_
                     '2
                     std/net/bio/input#input-buffer::t
                     '#f)
                    _u32178189_)
                  (std/error#raise-io-error
                   'bio-read-u32
                   '"Premature end of input"
                   _buf178170_
                   _rlo178182_
                   _rhi178184_)))))))
  (define std/net/bio/input#bio-get-u32
    (lambda (_u8v178162_ _start178163_)
      (let ((_$e178165_
             (##fxarithmetic-shift-left?
              (##u8vector-ref _u8v178162_ _start178163_)
              '24)))
        (if _$e178165_
            ((lambda (_bits178168_)
               (##fxior _bits178168_
                        (##fxarithmetic-shift-left
                         (##u8vector-ref _u8v178162_ (##fx+ _start178163_ '1))
                         '16)
                        (##fxarithmetic-shift-left
                         (##u8vector-ref _u8v178162_ (##fx+ _start178163_ '2))
                         '8)
                        (##u8vector-ref _u8v178162_ (##fx+ _start178163_ '3))))
             _$e178165_)
            (bitwise-ior
             (arithmetic-shift (##u8vector-ref _u8v178162_ _start178163_) '24)
             (##fxarithmetic-shift-left
              (##u8vector-ref _u8v178162_ (##fx+ _start178163_ '1))
              '16)
             (##fxarithmetic-shift-left
              (##u8vector-ref _u8v178162_ (##fx+ _start178163_ '2))
              '8)
             (##u8vector-ref _u8v178162_ (##fx+ _start178163_ '3)))))))
  (define std/net/bio/input#2^31 (expt '2 '31))
  (define std/net/bio/input#2^32 (expt '2 '32))
  (define std/net/bio/input#bio-read-s32
    (lambda (_buf178158_)
      (let ((_u32178160_ (std/net/bio/input#bio-read-u32 _buf178158_)))
        (if (> _u32178160_ std/net/bio/input#2^31)
            (- _u32178160_ std/net/bio/input#2^32)
            _u32178160_))))
  (define std/net/bio/input#bio-read-u16
    (lambda (_buf178137_)
      (let* ((_rlo178139_
              (##unchecked-structure-ref
               _buf178137_
               '2
               std/net/bio/input#input-buffer::t
               '#f))
             (_rhi178141_
              (##unchecked-structure-ref
               _buf178137_
               '3
               std/net/bio/input#input-buffer::t
               '#f))
             (_rlo+2178143_ (##fx+ _rlo178139_ '2)))
        (if (##fx<= _rlo+2178143_ _rhi178141_)
            (let ((_u16178146_
                   (std/net/bio/input#bio-get-u16
                    (##unchecked-structure-ref
                     _buf178137_
                     '1
                     std/net/bio/input#input-buffer::t
                     '#f)
                    _rlo178139_)))
              (##unchecked-structure-set!
               _buf178137_
               _rlo+2178143_
               '2
               std/net/bio/input#input-buffer::t
               '#f)
              _u16178146_)
            (let* ((_g290352_
                    (std/net/bio/input#bio-input-fill! _buf178137_ '2))
                   (_rlo178149_
                    (##unchecked-structure-ref
                     _buf178137_
                     '2
                     std/net/bio/input#input-buffer::t
                     '#f))
                   (_rhi178151_
                    (##unchecked-structure-ref
                     _buf178137_
                     '3
                     std/net/bio/input#input-buffer::t
                     '#f))
                   (_rlo+2178153_ (##fx+ _rlo178149_ '2)))
              (if (##fx<= _rlo+2178153_ _rhi178151_)
                  (let ((_u16178156_
                         (std/net/bio/input#bio-get-u16
                          (##unchecked-structure-ref
                           _buf178137_
                           '1
                           std/net/bio/input#input-buffer::t
                           '#f)
                          _rlo178149_)))
                    (##unchecked-structure-set!
                     _buf178137_
                     _rlo+2178153_
                     '2
                     std/net/bio/input#input-buffer::t
                     '#f)
                    _u16178156_)
                  (std/error#raise-io-error
                   'bio-read-u16
                   '"Premature end of input"
                   _buf178137_
                   _rlo178149_
                   _rhi178151_)))))))
  (define std/net/bio/input#bio-get-u16
    (lambda (_u8v178134_ _start178135_)
      (##fxior (##fxarithmetic-shift-left
                (##u8vector-ref _u8v178134_ _start178135_)
                '8)
               (##u8vector-ref _u8v178134_ (##fx+ _start178135_ '1)))))
  (define std/net/bio/input#2^15 (expt '2 '15))
  (define std/net/bio/input#2^16 (expt '2 '16))
  (define std/net/bio/input#bio-read-s16
    (lambda (_buf178130_)
      (let ((_u16178132_ (std/net/bio/input#bio-read-u16 _buf178130_)))
        (if (##fx> _u16178132_ std/net/bio/input#2^15)
            (##fx- _u16178132_ std/net/bio/input#2^16)
            _u16178132_))))
  (define std/net/bio/input#bio-read-char
    (lambda (_buf178097_)
      (letrec ((_fill+recur!178099_
                (lambda (_need178126_)
                  (let ((_rd178128_
                         (std/net/bio/input#bio-input-fill!
                          _buf178097_
                          _need178126_)))
                    (if (##fxzero? _rd178128_)
                        (std/error#raise-io-error
                         'bio-read-char
                         '"Incomplete character"
                         _buf178097_)
                        (std/net/bio/input#bio-read-char _buf178097_)))))
               (_get-byte178100_
                (lambda (_i178124_)
                  (##u8vector-ref
                   (##unchecked-structure-ref
                    _buf178097_
                    '1
                    std/net/bio/input#input-buffer::t
                    '#f)
                   _i178124_))))
        (let ((_rlo178102_
               (##unchecked-structure-ref
                _buf178097_
                '2
                std/net/bio/input#input-buffer::t
                '#f))
              (_rhi178103_
               (##unchecked-structure-ref
                _buf178097_
                '3
                std/net/bio/input#input-buffer::t
                '#f)))
          (if (##fx< _rlo178102_ _rhi178103_)
              (let ((_byte178105_ (_get-byte178100_ _rlo178102_)))
                (if (##fx<= _byte178105_ '127)
                    (begin
                      (##unchecked-structure-set!
                       _buf178097_
                       (##fx+ _rlo178102_ '1)
                       '2
                       std/net/bio/input#input-buffer::t
                       '#f)
                      (##integer->char _byte178105_))
                    (if (##fx<= _byte178105_ '223)
                        (let ((_rlo+1178107_ (##fx+ _rlo178102_ '1)))
                          (if (##fx< _rlo+1178107_ _rhi178103_)
                              (let ((_byte2178109_
                                     (_get-byte178100_ _rlo+1178107_)))
                                (##unchecked-structure-set!
                                 _buf178097_
                                 (##fx+ _rlo178102_ '2)
                                 '2
                                 std/net/bio/input#input-buffer::t
                                 '#f)
                                (##integer->char
                                 (##fxior (##fxarithmetic-shift-left
                                           (##fxand _byte178105_ '31)
                                           '6)
                                          (##fxand _byte2178109_ '63))))
                              (_fill+recur!178099_ '2)))
                        (if (##fx<= _byte178105_ '239)
                            (let ((_rlo+2178111_ (##fx+ _rlo178102_ '2)))
                              (if (##fx< _rlo+2178111_ _rhi178103_)
                                  (let ((_byte2178113_
                                         (_get-byte178100_
                                          (##fx+ _rlo178102_ '1)))
                                        (_byte3178114_
                                         (_get-byte178100_ _rlo+2178111_)))
                                    (##unchecked-structure-set!
                                     _buf178097_
                                     (##fx+ _rlo178102_ '3)
                                     '2
                                     std/net/bio/input#input-buffer::t
                                     '#f)
                                    (##integer->char
                                     (##fxior (##fxarithmetic-shift-left
                                               (##fxand _byte178105_ '15)
                                               '12)
                                              (##fxarithmetic-shift-left
                                               (##fxand _byte2178113_ '63)
                                               '6)
                                              (##fxand _byte3178114_ '63))))
                                  (_fill+recur!178099_ '3)))
                            (if (##fx<= _byte178105_ '244)
                                (let ((_rlo+3178116_ (##fx+ _rlo178102_ '3)))
                                  (if (##fx< _rlo+3178116_ _rhi178103_)
                                      (let ((_byte2178118_
                                             (_get-byte178100_
                                              (##fx+ _rlo178102_ '1)))
                                            (_byte3178119_
                                             (_get-byte178100_
                                              (##fx+ _rlo178102_ '2)))
                                            (_byte4178120_
                                             (_get-byte178100_ _rlo+3178116_)))
                                        (##unchecked-structure-set!
                                         _buf178097_
                                         (##integer->char
                                          (##fxior (##fxarithmetic-shift-left
                                                    (##fxand _byte178105_ '7)
                                                    '18)
                                                   (##fxarithmetic-shift-left
                                                    (##fxand _byte2178118_ '63)
                                                    '12)
                                                   (##fxarithmetic-shift-left
                                                    (##fxand _byte3178119_ '63)
                                                    '6)
                                                   (##fxand _byte4178120_
                                                            '63)))
                                         '2
                                         std/net/bio/input#input-buffer::t
                                         '#f))
                                      (_fill+recur!178099_ '4)))
                                (begin
                                  (##unchecked-structure-set!
                                   _buf178097_
                                   (##fx+ _rlo178102_ '1)
                                   '2
                                   std/net/bio/input#input-buffer::t
                                   '#f)
                                  '#\�))))))
              (let ((_rd178122_
                     (std/net/bio/input#bio-input-fill! _buf178097_ '1)))
                (if (##fxzero? _rd178122_)
                    (eof-object)
                    (std/net/bio/input#bio-read-char _buf178097_))))))))
  (define std/net/bio/input#bio-read-substring
    (lambda (_str178085_ _start178086_ _end178087_ _buf178088_)
      (let _lp178090_ ((_i178092_ _start178086_) (_count178093_ '0))
        (if (##fx< _i178092_ _end178087_)
            (let ((_char178095_ (std/net/bio/input#bio-read-char _str178085_)))
              (if (eof-object? _char178095_)
                  _count178093_
                  (begin
                    (##string-set! _str178085_ _i178092_ _char178095_)
                    (_lp178090_
                     (##fx+ _start178086_ '1)
                     (##fx+ _count178093_ '1)))))
            _count178093_))))
  (define std/net/bio/input#bio-read-string
    (lambda (_str178075_ _start178076_ _end178077_ _buf178078_)
      (let* ((_len178080_ (string-length _str178075_))
             (_rd178082_
              (std/net/bio/input#bio-read-substring
               _str178075_
               '0
               _len178080_
               _buf178078_)))
        (if (##fx= _rd178082_ _len178080_)
            '#!void
            (std/error#raise-io-error
             'bio-read-string
             '"premature end of input"
             _buf178078_
             _rd178082_
             _len178080_)))))
  (define std/net/bio/input#bio-read-line__%
    (lambda (_buf178025_ _sep178026_ _include-sep?178027_ _maxchars178028_)
      (let ((_root178030_ (cons '#f '())))
        (let _lp178032_ ((_tl178034_ _root178030_) (_count178035_ '0))
          (if (or (not _maxchars178028_)
                  (##fx< _count178035_ _maxchars178028_))
              (let ((_char178040_
                     (std/net/bio/input#bio-read-char _buf178025_)))
                (if (eof-object? _char178040_)
                    (if (null? (cdr _root178030_))
                        (eof-object)
                        (list->string (cdr _root178030_)))
                    (if (eq? _char178040_ _sep178026_)
                        (list->string
                         (if _include-sep?178027_
                             (let ((_tl*178042_ (cons _char178040_ '())))
                               (set-cdr! _tl178034_ _tl*178042_)
                               (cdr _root178030_))
                             (cdr _root178030_)))
                        (let ((_tl*178044_ (cons _char178040_ '())))
                          (set-cdr! _tl178034_ _tl*178044_)
                          (_lp178032_ _tl*178044_ (##fx+ _count178035_ '1))))))
              (list->string (cdr _root178030_)))))))
  (define std/net/bio/input#bio-read-line__0
    (lambda (_buf178049_)
      (let* ((_sep178051_ '#\newline)
             (_include-sep?178053_ '#f)
             (_maxchars178055_ '#f))
        (std/net/bio/input#bio-read-line__%
         _buf178049_
         _sep178051_
         _include-sep?178053_
         _maxchars178055_))))
  (define std/net/bio/input#bio-read-line__1
    (lambda (_buf178057_ _sep178058_)
      (let* ((_include-sep?178060_ '#f) (_maxchars178062_ '#f))
        (std/net/bio/input#bio-read-line__%
         _buf178057_
         _sep178058_
         _include-sep?178060_
         _maxchars178062_))))
  (define std/net/bio/input#bio-read-line__2
    (lambda (_buf178064_ _sep178065_ _include-sep?178066_)
      (let ((_maxchars178068_ '#f))
        (std/net/bio/input#bio-read-line__%
         _buf178064_
         _sep178065_
         _include-sep?178066_
         _maxchars178068_))))
  (define std/net/bio/input#bio-read-line
    (lambda _g290354_
      (let ((_g290353_ (##length _g290354_)))
        (cond ((##fx= _g290353_ 1)
               (apply std/net/bio/input#bio-read-line__0 _g290354_))
              ((##fx= _g290353_ 2)
               (apply std/net/bio/input#bio-read-line__1 _g290354_))
              ((##fx= _g290353_ 3)
               (apply std/net/bio/input#bio-read-line__2 _g290354_))
              ((##fx= _g290353_ 4)
               (apply std/net/bio/input#bio-read-line__% _g290354_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/bio/input#bio-read-line
                _g290354_))))))
  (define std/net/bio/input#bio-input-utf8-decode
    (lambda (_count178012_ _buf178013_)
      (let* ((_rlo178015_
              (##unchecked-structure-ref
               _buf178013_
               '2
               std/net/bio/input#input-buffer::t
               '#f))
             (_rhi178017_
              (##unchecked-structure-ref
               _buf178013_
               '3
               std/net/bio/input#input-buffer::t
               '#f))
             (_rlo+count178019_ (##fx+ _rlo178015_ _count178012_)))
        (if (##fx<= _rlo+count178019_ _rhi178017_)
            (let ((_str178022_
                   (std/text/utf8#utf8-decode
                    (##unchecked-structure-ref
                     _buf178013_
                     '1
                     std/net/bio/input#input-buffer::t
                     '#f)
                    _rlo178015_
                    _rlo+count178019_)))
              (##unchecked-structure-set!
               _buf178013_
               _rlo+count178019_
               '2
               std/net/bio/input#input-buffer::t
               '#f)
              _str178022_)
            (std/error#raise-io-error
             'bio-input-utf8-decode
             '"not enough bytes"
             _buf178013_
             _count178012_)))))
  (define std/net/bio/input#bio-input-skip
    (lambda (_count177992_ _buf177993_)
      (let _lp177995_ ((_count177997_ _count177992_))
        (let* ((_rlo177999_
                (##unchecked-structure-ref
                 _buf177993_
                 '2
                 std/net/bio/input#input-buffer::t
                 '#f))
               (_rhi178001_
                (##unchecked-structure-ref
                 _buf177993_
                 '3
                 std/net/bio/input#input-buffer::t
                 '#f))
               (_have178003_ (##fx- _rhi178001_ _rlo177999_)))
          (if (##fx< _have178003_ _count177997_)
              (let ((_need178006_ (##fx- _count177997_ _have178003_)))
                (##unchecked-structure-set!
                 _buf177993_
                 _rhi178001_
                 '2
                 std/net/bio/input#input-buffer::t
                 '#f)
                (let ((_rd178008_
                       (std/net/bio/input#bio-input-fill!
                        _buf177993_
                        _need178006_)))
                  (if (##fxzero? _rd178008_)
                      (std/error#raise-io-error
                       'bio-input-skip
                       '"premature end of input"
                       _buf177993_
                       _count177997_)
                      (_lp177995_ _need178006_))))
              (let ((_rlo+count178010_ (##fx+ _rlo177999_ _count177997_)))
                (##unchecked-structure-set!
                 _buf177993_
                 _rlo+count178010_
                 '2
                 std/net/bio/input#input-buffer::t
                 '#f)))))))
  (define std/net/bio/input#bio-input-count
    (lambda (_buf177987_)
      (let ((_rlo177989_
             (##unchecked-structure-ref
              _buf177987_
              '2
              std/net/bio/input#input-buffer::t
              '#f))
            (_rhi177990_
             (##unchecked-structure-ref
              _buf177987_
              '3
              std/net/bio/input#input-buffer::t
              '#f)))
        (##fx- _rhi177990_ _rlo177989_)))))
