(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/net/httpd/handler#errorf
    (lambda (_fmt206439_ . _args206440_)
      (std/logger#log-message 'httpd '0 _fmt206439_ _args206440_)))
  (define std/net/httpd/handler#warnf
    (lambda (_fmt206436_ . _args206437_)
      (std/logger#log-message 'httpd '1 _fmt206436_ _args206437_)))
  (define std/net/httpd/handler#infof
    (lambda (_fmt206433_ . _args206434_)
      (std/logger#log-message 'httpd '2 _fmt206433_ _args206434_)))
  (define std/net/httpd/handler#debugf
    (lambda (_fmt206430_ . _args206431_)
      (std/logger#log-message 'httpd '3 _fmt206430_ _args206431_)))
  (define std/net/httpd/handler#verbosef
    (lambda (_fmt206425_ . _args206427_)
      (std/logger#log-message 'httpd '4 _fmt206425_ _args206427_)))
  (define std/net/httpd/handler#http-request::t
    (make-struct-type
     'std/net/httpd/handler#http-request::t
     '#f
     '9
     'http-request
     '((final: . #t))
     '#f
     '(buf client method url path params proto headers data)))
  (define std/net/httpd/handler#http-request?
    (make-struct-predicate std/net/httpd/handler#http-request::t))
  (define std/net/httpd/handler#make-http-request
    (lambda _$args206422_
      (apply make-struct-instance
             std/net/httpd/handler#http-request::t
             _$args206422_)))
  (define std/net/httpd/handler#http-request-buf
    (make-struct-field-accessor std/net/httpd/handler#http-request::t '0))
  (define std/net/httpd/handler#http-request-client
    (make-struct-field-accessor std/net/httpd/handler#http-request::t '1))
  (define std/net/httpd/handler#http-request-method
    (make-struct-field-accessor std/net/httpd/handler#http-request::t '2))
  (define std/net/httpd/handler#http-request-url
    (make-struct-field-accessor std/net/httpd/handler#http-request::t '3))
  (define std/net/httpd/handler#http-request-path
    (make-struct-field-accessor std/net/httpd/handler#http-request::t '4))
  (define std/net/httpd/handler#http-request-params
    (make-struct-field-accessor std/net/httpd/handler#http-request::t '5))
  (define std/net/httpd/handler#http-request-proto
    (make-struct-field-accessor std/net/httpd/handler#http-request::t '6))
  (define std/net/httpd/handler#http-request-headers
    (make-struct-field-accessor std/net/httpd/handler#http-request::t '7))
  (define std/net/httpd/handler#http-request-data
    (make-struct-field-accessor std/net/httpd/handler#http-request::t '8))
  (define std/net/httpd/handler#http-request-buf-set!
    (make-struct-field-mutator std/net/httpd/handler#http-request::t '0))
  (define std/net/httpd/handler#http-request-client-set!
    (make-struct-field-mutator std/net/httpd/handler#http-request::t '1))
  (define std/net/httpd/handler#http-request-method-set!
    (make-struct-field-mutator std/net/httpd/handler#http-request::t '2))
  (define std/net/httpd/handler#http-request-url-set!
    (make-struct-field-mutator std/net/httpd/handler#http-request::t '3))
  (define std/net/httpd/handler#http-request-path-set!
    (make-struct-field-mutator std/net/httpd/handler#http-request::t '4))
  (define std/net/httpd/handler#http-request-params-set!
    (make-struct-field-mutator std/net/httpd/handler#http-request::t '5))
  (define std/net/httpd/handler#http-request-proto-set!
    (make-struct-field-mutator std/net/httpd/handler#http-request::t '6))
  (define std/net/httpd/handler#http-request-headers-set!
    (make-struct-field-mutator std/net/httpd/handler#http-request::t '7))
  (define std/net/httpd/handler#http-request-data-set!
    (make-struct-field-mutator std/net/httpd/handler#http-request::t '8))
  (define std/net/httpd/handler#&http-request-buf
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-request::t
     '0))
  (define std/net/httpd/handler#&http-request-client
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-request::t
     '1))
  (define std/net/httpd/handler#&http-request-method
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-request::t
     '2))
  (define std/net/httpd/handler#&http-request-url
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-request::t
     '3))
  (define std/net/httpd/handler#&http-request-path
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-request::t
     '4))
  (define std/net/httpd/handler#&http-request-params
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-request::t
     '5))
  (define std/net/httpd/handler#&http-request-proto
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-request::t
     '6))
  (define std/net/httpd/handler#&http-request-headers
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-request::t
     '7))
  (define std/net/httpd/handler#&http-request-data
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-request::t
     '8))
  (define std/net/httpd/handler#&http-request-buf-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-request::t
     '0))
  (define std/net/httpd/handler#&http-request-client-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-request::t
     '1))
  (define std/net/httpd/handler#&http-request-method-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-request::t
     '2))
  (define std/net/httpd/handler#&http-request-url-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-request::t
     '3))
  (define std/net/httpd/handler#&http-request-path-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-request::t
     '4))
  (define std/net/httpd/handler#&http-request-params-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-request::t
     '5))
  (define std/net/httpd/handler#&http-request-proto-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-request::t
     '6))
  (define std/net/httpd/handler#&http-request-headers-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-request::t
     '7))
  (define std/net/httpd/handler#&http-request-data-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-request::t
     '8))
  (define std/net/httpd/handler#http-response::t
    (make-struct-type
     'std/net/httpd/handler#http-response::t
     '#f
     '3
     'http-response
     '((final: . #t))
     '#f
     '(buf output close?)))
  (define std/net/httpd/handler#http-response?
    (make-struct-predicate std/net/httpd/handler#http-response::t))
  (define std/net/httpd/handler#make-http-response
    (lambda _$args206419_
      (apply make-struct-instance
             std/net/httpd/handler#http-response::t
             _$args206419_)))
  (define std/net/httpd/handler#http-response-buf
    (make-struct-field-accessor std/net/httpd/handler#http-response::t '0))
  (define std/net/httpd/handler#http-response-output
    (make-struct-field-accessor std/net/httpd/handler#http-response::t '1))
  (define std/net/httpd/handler#http-response-close?
    (make-struct-field-accessor std/net/httpd/handler#http-response::t '2))
  (define std/net/httpd/handler#http-response-buf-set!
    (make-struct-field-mutator std/net/httpd/handler#http-response::t '0))
  (define std/net/httpd/handler#http-response-output-set!
    (make-struct-field-mutator std/net/httpd/handler#http-response::t '1))
  (define std/net/httpd/handler#http-response-close?-set!
    (make-struct-field-mutator std/net/httpd/handler#http-response::t '2))
  (define std/net/httpd/handler#&http-response-buf
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-response::t
     '0))
  (define std/net/httpd/handler#&http-response-output
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-response::t
     '1))
  (define std/net/httpd/handler#&http-response-close?
    (make-struct-field-unchecked-accessor
     std/net/httpd/handler#http-response::t
     '2))
  (define std/net/httpd/handler#&http-response-buf-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-response::t
     '0))
  (define std/net/httpd/handler#&http-response-output-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-response::t
     '1))
  (define std/net/httpd/handler#&http-response-close?-set!
    (make-struct-field-unchecked-mutator
     std/net/httpd/handler#http-response::t
     '2))
  (define std/net/httpd/handler#http-request-handler
    (lambda (_get-handler206350_ _sock206351_ _addr206352_)
      (letrec* ((_ibuf206354_
                 (std/net/httpd/handler#get-input-buffer _sock206351_))
                (_obuf206355_
                 (std/net/httpd/handler#get-output-buffer _sock206351_))
                (_loop206356_
                 (lambda ()
                   (let ((_req206368_
                          (##structure
                           std/net/httpd/handler#http-request::t
                           _ibuf206354_
                           _addr206352_
                           '#f
                           '#f
                           '#f
                           '#f
                           '#f
                           '#f
                           '#!void))
                         (_res206369_
                          (##structure
                           std/net/httpd/handler#http-response::t
                           _obuf206355_
                           '#f
                           '#f)))
                     (std/net/socket/buffer#ssocket-input-buffer-timeout-set!
                      _ibuf206354_
                      std/net/httpd/handler#request-timeout)
                     (std/net/socket/buffer#ssocket-output-buffer-timeout-set!
                      _obuf206355_
                      std/net/httpd/handler#response-timeout)
                     (with-exception-catcher
                      (lambda (_g206370206372_)
                        (if ((lambda (_$obj206375_)
                               (##structure-instance-of?
                                _$obj206375_
                                'std/error#timeout-error::t))
                             _g206370206372_)
                            (let ((_e206378_ _g206370206372_))
                              (std/net/httpd/handler#errorf
                               '"request error: ~a"
                               _e206378_)
                              (##unchecked-structure-set!
                               _res206369_
                               '#t
                               '3
                               std/net/httpd/handler#http-response::t
                               '#f)
                              (std/net/httpd/handler#http-response-write
                               _res206369_
                               '408
                               '()
                               '#f)
                              (raise 'abort))
                            (if ((lambda (_$obj206380_)
                                   (##structure-instance-of?
                                    _$obj206380_
                                    'std/error#io-error::t))
                                 _g206370206372_)
                                (let ((_e206383_ _g206370206372_))
                                  (std/net/httpd/handler#errorf
                                   '"request error: ~a"
                                   _e206383_)
                                  (##unchecked-structure-set!
                                   _res206369_
                                   '#t
                                   '3
                                   std/net/httpd/handler#http-response::t
                                   '#f)
                                  (std/net/httpd/handler#http-response-write
                                   _res206369_
                                   '400
                                   '()
                                   '#f)
                                  (raise 'abort))
                                (raise _g206370206372_))))
                      (lambda ()
                        (std/net/httpd/handler#read-request! _req206368_)))
                     (let* ((_method206386_
                             (##unchecked-structure-ref
                              _req206368_
                              '3
                              std/net/httpd/handler#http-request::t
                              '#f))
                            (_path206388_
                             (##unchecked-structure-ref
                              _req206368_
                              '5
                              std/net/httpd/handler#http-request::t
                              '#f))
                            (_proto206390_
                             (##unchecked-structure-ref
                              _req206368_
                              '7
                              std/net/httpd/handler#http-request::t
                              '#f))
                            (_headers206392_
                             (##unchecked-structure-ref
                              _req206368_
                              '8
                              std/net/httpd/handler#http-request::t
                              '#f))
                            (_host206394_
                             (std/net/httpd/handler#header-e
                              '"Host"
                              _headers206392_))
                            (_close?206399_
                             (let ((_$e206396_ _proto206390_))
                               (if (equal? '"HTTP/1.1" _$e206396_)
                                   (equal? (std/net/httpd/handler#header-e
                                            '"Connection"
                                            _headers206392_)
                                           '"close")
                                   (if (equal? '"HTTP/1.0" _$e206396_)
                                       (not (equal? (std/net/httpd/handler#header-e
                                                     '"Connection"
                                                     _headers206392_)
                                                    '"Keep-Alive"))
                                       '#t)))))
                       (if _close?206399_
                           (##unchecked-structure-set!
                            _res206369_
                            '#t
                            '3
                            std/net/httpd/handler#http-response::t
                            '#f)
                           '#!void)
                       (if (not (member _proto206390_
                                        '("HTTP/1.1" "HTTP/1.0")))
                           (std/net/httpd/handler#http-response-write
                            _res206369_
                            '505
                            '()
                            '#f)
                           (if (not (symbol? _method206386_))
                               (std/net/httpd/handler#http-response-write
                                _res206369_
                                '501
                                '()
                                '#f)
                               (if (and (eq? _method206386_ 'OPTIONS)
                                        (equal? _path206388_ '"*"))
                                   (std/net/httpd/handler#http-response-write
                                    _res206369_
                                    '200
                                    '()
                                    '#f)
                                   (if (eq? _method206386_ 'TRACE)
                                       (std/net/httpd/handler#http-response-trace
                                        _res206369_
                                        _req206368_)
                                       (let ((_$e206402_
                                              (_get-handler206350_
                                               _host206394_
                                               _path206388_)))
                                         (if _$e206402_
                                             ((lambda (_handler206405_)
                                                (if (procedure?
                                                     _handler206405_)
                                                    (with-exception-catcher
                                                     (lambda (_g206406206408_)
                                                       (if ((lambda (_$obj206411_)
                                                              (##structure-instance-of?
                                                               _$obj206411_
                                                               'std/error#io-error::t))
                                                            _g206406206408_)
                                                           (let ((_e206414_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _g206406206408_))
                     (std/net/httpd/handler#errorf
                      '"request i/o error: ~a"
                      _e206414_)
                     (if (##unchecked-structure-ref
                          _res206369_
                          '2
                          std/net/httpd/handler#http-response::t
                          '#f)
                         '#!void
                         (begin
                           (##unchecked-structure-set!
                            _res206369_
                            '#t
                            '3
                            std/net/httpd/handler#http-response::t
                            '#f)
                           (std/net/httpd/handler#http-response-write
                            _res206369_
                            '500
                            '()
                            '#f)))
                     (raise 'abort))
                   (if '#t
                       (let ((_e206416_ _g206406206408_))
                         (std/net/httpd/handler#errorf
                          '"request handler error: ~a"
                          _e206416_)
                         (if (##unchecked-structure-ref
                              _res206369_
                              '2
                              std/net/httpd/handler#http-response::t
                              '#f)
                             (raise 'abort)
                             (std/net/httpd/handler#http-response-write
                              _res206369_
                              '500
                              '()
                              '#f)))
                       (raise _g206406206408_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (lambda ()
                                                       (_handler206405_
                                                        _req206368_
                                                        _res206369_)))
                                                    (begin
                                                      (std/net/httpd/handler#warnf
                                                       '"request handler is not a procedure: ~a ~a ~a"
                                                       _host206394_
                                                       _path206388_
                                                       _handler206405_)
                                                      (std/net/httpd/handler#http-response-write
                                                       _res206369_
                                                       '500
                                                       '()
                                                       '#f))))
                                              _$e206402_)
                                             (std/net/httpd/handler#http-response-write
                                              _res206369_
                                              '404
                                              '()
                                              '#f)))))))
                       (if _close?206399_
                           '#!void
                           (begin
                             (std/net/httpd/handler#http-request-skip-body
                              _req206368_)
                             (_loop206356_))))))))
        (with-unwind-protect
         (lambda ()
           (with-exception-catcher
            (lambda (_g206357206360_)
              (if '#t
                  (let ((_e206363_ _g206357206360_))
                    (if (memq _e206363_ '(abort eof))
                        '#!void
                        (begin
                          (std/net/httpd/handler#errorf
                           '"unhandled exception: ~a"
                           _e206363_)
                          (raise _e206363_)))
                    _e206363_)
                  (raise _g206357206360_)))
            (lambda () (_loop206356_))))
         (lambda ()
           (std/net/socket/api#ssocket-close _sock206351_)
           (std/net/httpd/handler#put-input-buffer! _ibuf206354_)
           (std/net/httpd/handler#put-output-buffer! _obuf206355_))))))
  (define std/net/httpd/handler#http-request-body
    (lambda (_req206277_)
      (let* ((_req206278206292_ _req206277_)
             (_E206280206296_
              (lambda () (error '"No clause matching" _req206278206292_)))
             (_K206281206312_
              (lambda (_data206299_
                       _headers206300_
                       _method206301_
                       _ibuf206302_)
                (if (eq? _data206299_ '#!void)
                    (let ((_$e206304_ _method206301_))
                      (if (or (eq? 'POST _$e206304_) (eq? 'PUT _$e206304_))
                          (let ((_data206310_
                                 (std/net/httpd/handler#read-request-body
                                  _ibuf206302_
                                  _headers206300_)))
                            (##unchecked-structure-set!
                             _req206277_
                             _data206310_
                             '9
                             std/net/httpd/handler#http-request::t
                             '#f)
                            _data206310_)
                          (begin
                            (std/net/httpd/handler#http-request-skip-body
                             _req206277_)
                            '#f)))
                    _data206299_))))
        (if (##structure-direct-instance-of?
             _req206278206292_
             'std/net/httpd/handler#http-request::t)
            (let* ((_e206282206315_ (##vector-ref _req206278206292_ '1))
                   (_ibuf206318_ _e206282206315_)
                   (_e206283206320_ (##vector-ref _req206278206292_ '2))
                   (_e206284206323_ (##vector-ref _req206278206292_ '3))
                   (_method206326_ _e206284206323_)
                   (_e206285206328_ (##vector-ref _req206278206292_ '4))
                   (_e206286206331_ (##vector-ref _req206278206292_ '5))
                   (_e206287206334_ (##vector-ref _req206278206292_ '6))
                   (_e206288206337_ (##vector-ref _req206278206292_ '7))
                   (_e206289206340_ (##vector-ref _req206278206292_ '8))
                   (_headers206343_ _e206289206340_)
                   (_e206290206345_ (##vector-ref _req206278206292_ '9))
                   (_data206348_ _e206290206345_))
              (_K206281206312_
               _data206348_
               _headers206343_
               _method206326_
               _ibuf206318_))
            (_E206280206296_)))))
  (define std/net/httpd/handler#http-request-timeout-set!
    (lambda (_req206252_ _timeo206253_)
      (let* ((_req206254206260_ _req206252_)
             (_E206256206264_
              (lambda () (error '"No clause matching" _req206254206260_)))
             (_K206257206269_
              (lambda (_ibuf206267_)
                (std/net/socket/buffer#ssocket-input-buffer-timeout-set!
                 _ibuf206267_
                 _timeo206253_))))
        (if (##structure-direct-instance-of?
             _req206254206260_
             'std/net/httpd/handler#http-request::t)
            (let* ((_e206258206272_ (##vector-ref _req206254206260_ '1))
                   (_ibuf206275_ _e206258206272_))
              (_K206257206269_ _ibuf206275_))
            (_E206256206264_)))))
  (define std/net/httpd/handler#http-response-write
    (lambda (_res206202_ _status206203_ _headers206204_ _body206205_)
      (let* ((_res206206206214_ _res206202_)
             (_E206208206218_
              (lambda () (error '"No clause matching" _res206206206214_)))
             (_K206209206234_
              (lambda (_close?206221_ _output206222_ _obuf206223_)
                (if _output206222_
                    (error '"duplicate response" _res206202_)
                    '#!void)
                (##unchecked-structure-set!
                 _res206202_
                 'END
                 '2
                 std/net/httpd/handler#http-response::t
                 '#f)
                (let* ((_len206225_
                        (if (u8vector? _body206205_)
                            (u8vector-length _body206205_)
                            (if (string? _body206205_)
                                (std/text/utf8#string-utf8-length__0
                                 _body206205_)
                                (if (not _body206205_)
                                    '0
                                    (error '"Bad response body; expected string, u8vector, or #f"
                                           _body206205_)))))
                       (_headers206227_
                        (cons (cons '"Content-Length"
                                    (number->string _len206225_))
                              _headers206204_))
                       (_headers206229_
                        (if _close?206221_
                            (cons '("Connection" . "close") _headers206227_)
                            _headers206227_))
                       (_headers206231_
                        (cons (cons '"Date" (std/net/httpd/handler#http-date))
                              _headers206229_)))
                  (std/net/httpd/handler#write-response-line
                   _obuf206223_
                   _status206203_)
                  (std/net/httpd/handler#write-response-headers
                   _obuf206223_
                   _headers206231_)
                  (std/net/httpd/handler#write-crlf _obuf206223_)
                  (if (u8vector? _body206205_)
                      (std/net/bio/output#bio-write-bytes
                       _body206205_
                       _obuf206223_)
                      (if (string? _body206205_)
                          (std/net/bio/output#bio-write-string
                           _body206205_
                           _obuf206223_)
                          '#!void))
                  (std/net/bio/output#bio-force-output _obuf206223_)))))
        (if (##structure-direct-instance-of?
             _res206206206214_
             'std/net/httpd/handler#http-response::t)
            (let* ((_e206210206237_ (##vector-ref _res206206206214_ '1))
                   (_obuf206240_ _e206210206237_)
                   (_e206211206242_ (##vector-ref _res206206206214_ '2))
                   (_output206245_ _e206211206242_)
                   (_e206212206247_ (##vector-ref _res206206206214_ '3))
                   (_close?206250_ _e206212206247_))
              (_K206209206234_ _close?206250_ _output206245_ _obuf206240_))
            (_E206208206218_)))))
  (define std/net/httpd/handler#http-response-begin
    (lambda (_res206155_ _status206156_ _headers206157_)
      (let* ((_res206158206166_ _res206155_)
             (_E206160206170_
              (lambda () (error '"No clause matching" _res206158206166_)))
             (_K206161206184_
              (lambda (_close?206173_ _output206174_ _obuf206175_)
                (if _output206174_
                    (error '"duplicate response" _res206155_)
                    '#!void)
                (##unchecked-structure-set!
                 _res206155_
                 'CHUNK
                 '2
                 std/net/httpd/handler#http-response::t
                 '#f)
                (let* ((_headers206177_
                        (cons '("Transfer-Encoding" . "chunked")
                              _headers206157_))
                       (_headers206179_
                        (if _close?206173_
                            (cons '("Connection" . "close") _headers206177_)
                            _headers206177_))
                       (_headers206181_
                        (cons (cons '"Date" (std/net/httpd/handler#http-date))
                              _headers206179_)))
                  (std/net/httpd/handler#write-response-line
                   _obuf206175_
                   _status206156_)
                  (std/net/httpd/handler#write-response-headers
                   _obuf206175_
                   _headers206181_)
                  (std/net/httpd/handler#write-crlf _obuf206175_)))))
        (if (##structure-direct-instance-of?
             _res206158206166_
             'std/net/httpd/handler#http-response::t)
            (let* ((_e206162206187_ (##vector-ref _res206158206166_ '1))
                   (_obuf206190_ _e206162206187_)
                   (_e206163206192_ (##vector-ref _res206158206166_ '2))
                   (_output206195_ _e206163206192_)
                   (_e206164206197_ (##vector-ref _res206158206166_ '3))
                   (_close?206200_ _e206164206197_))
              (_K206161206184_ _close?206200_ _output206195_ _obuf206190_))
            (_E206160206170_)))))
  (define std/net/httpd/handler#http-response-chunk__%
    (lambda (_res206100_ _chunk206101_ _start206102_ _end206103_)
      (let* ((_res206104206111_ _res206100_)
             (_E206106206115_
              (lambda () (error '"No clause matching" _res206104206111_)))
             (_K206107206121_
              (lambda (_output206118_ _obuf206119_)
                (if (eq? _output206118_ 'CHUNK)
                    '#!void
                    (error '"illegal response; not writing chunks"
                           _res206100_
                           _output206118_))
                (std/net/httpd/handler#write-chunk
                 _obuf206119_
                 _chunk206101_
                 _start206102_
                 _end206103_))))
        (if (##structure-direct-instance-of?
             _res206104206111_
             'std/net/httpd/handler#http-response::t)
            (let* ((_e206108206124_ (##vector-ref _res206104206111_ '1))
                   (_obuf206127_ _e206108206124_)
                   (_e206109206129_ (##vector-ref _res206104206111_ '2))
                   (_output206132_ _e206109206129_))
              (_K206107206121_ _output206132_ _obuf206127_))
            (_E206106206115_)))))
  (define std/net/httpd/handler#http-response-chunk__0
    (lambda (_res206137_ _chunk206138_)
      (let* ((_start206140_ '0) (_end206142_ '#f))
        (std/net/httpd/handler#http-response-chunk__%
         _res206137_
         _chunk206138_
         _start206140_
         _end206142_))))
  (define std/net/httpd/handler#http-response-chunk__1
    (lambda (_res206144_ _chunk206145_ _start206146_)
      (let ((_end206148_ '#f))
        (std/net/httpd/handler#http-response-chunk__%
         _res206144_
         _chunk206145_
         _start206146_
         _end206148_))))
  (define std/net/httpd/handler#http-response-chunk
    (lambda _g309532_
      (let ((_g309531_ (##length _g309532_)))
        (cond ((##fx= _g309531_ 2)
               (apply std/net/httpd/handler#http-response-chunk__0 _g309532_))
              ((##fx= _g309531_ 3)
               (apply std/net/httpd/handler#http-response-chunk__1 _g309532_))
              ((##fx= _g309531_ 4)
               (apply std/net/httpd/handler#http-response-chunk__% _g309532_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/httpd/handler#http-response-chunk
                _g309532_))))))
  (define std/net/httpd/handler#http-response-end
    (lambda (_res206068_)
      (let* ((_res206069206076_ _res206068_)
             (_E206071206080_
              (lambda () (error '"No clause matching" _res206069206076_)))
             (_K206072206086_
              (lambda (_output206083_ _obuf206084_)
                (if (eq? _output206083_ 'CHUNK)
                    '#!void
                    (error '"illegal response; not writing chunks"
                           _res206068_
                           _output206083_))
                (##unchecked-structure-set!
                 _res206068_
                 'END
                 '2
                 std/net/httpd/handler#http-response::t
                 '#f)
                (std/net/httpd/handler#write-last-chunk _obuf206084_)
                (std/net/bio/output#bio-force-output _obuf206084_))))
        (if (##structure-direct-instance-of?
             _res206069206076_
             'std/net/httpd/handler#http-response::t)
            (let* ((_e206073206089_ (##vector-ref _res206069206076_ '1))
                   (_obuf206092_ _e206073206089_)
                   (_e206074206094_ (##vector-ref _res206069206076_ '2))
                   (_output206097_ _e206074206094_))
              (_K206072206086_ _output206097_ _obuf206092_))
            (_E206071206080_)))))
  (define std/net/httpd/handler#http-response-force-output
    (lambda (_res206066_)
      (std/net/bio/output#bio-force-output
       (##direct-structure-ref
        _res206066_
        '1
        std/net/httpd/handler#http-response::t
        '#f))))
  (define std/net/httpd/handler#http-response-timeout-set!
    (lambda (_res206041_ _timeo206042_)
      (let* ((_res206043206049_ _res206041_)
             (_E206045206053_
              (lambda () (error '"No clause matching" _res206043206049_)))
             (_K206046206058_
              (lambda (_obuf206056_)
                (std/net/socket/buffer#ssocket-output-buffer-timeout-set!
                 _obuf206056_
                 _timeo206042_))))
        (if (##structure-direct-instance-of?
             _res206043206049_
             'std/net/httpd/handler#http-response::t)
            (let* ((_e206047206061_ (##vector-ref _res206043206049_ '1))
                   (_obuf206064_ _e206047206061_))
              (_K206046206058_ _obuf206064_))
            (_E206045206053_)))))
  (define std/net/httpd/handler#header-e
    (lambda (_key206001_ _lst206002_)
      (let _lp206004_ ((_rest206006_ _lst206002_))
        (let* ((_rest206007206015_ _rest206006_)
               (_else206009206023_ (lambda () '#f))
               (_K206011206029_
                (lambda (_rest206026_ _hd206027_)
                  (if (##string-equal? _key206001_ (car _hd206027_))
                      (cdr _hd206027_)
                      (_lp206004_ _rest206026_)))))
          (if (##pair? _rest206007206015_)
              (let ((_hd206012206032_ (##car _rest206007206015_))
                    (_tl206013206034_ (##cdr _rest206007206015_)))
                (let* ((_hd206037_ _hd206012206032_)
                       (_rest206039_ _tl206013206034_))
                  (_K206011206029_ _rest206039_ _hd206037_)))
              (_else206009206023_))))))
  (define std/net/httpd/handler#http-request-skip-body
    (lambda (_req205999_)
      (if (eq? (##unchecked-structure-ref
                _req205999_
                '9
                std/net/httpd/handler#http-request::t
                '#f)
               '#!void)
          (begin
            (##unchecked-structure-set!
             _req205999_
             '#f
             '9
             std/net/httpd/handler#http-request::t
             '#f)
            (std/net/httpd/handler#skip-request-body
             (##unchecked-structure-ref
              _req205999_
              '1
              std/net/httpd/handler#http-request::t
              '#f)
             (##unchecked-structure-ref
              _req205999_
              '8
              std/net/httpd/handler#http-request::t
              '#f)))
          '#!void)))
  (define std/net/httpd/handler#http-response-trace
    (lambda (_res205929_ _req205930_)
      (let* ((_req205931205944_ _req205930_)
             (_E205933205948_
              (lambda () (error '"No clause matching" _req205931205944_)))
             (_K205934205964_
              (lambda (_headers205951_
                       _proto205952_
                       _url205953_
                       _method205954_)
                (let ((_xbuf205956_
                       (std/net/bio/buffer#open-chunked-output-buffer__0)))
                  (std/net/bio/output#bio-write-string
                   (symbol->string _method205954_)
                   _xbuf205956_)
                  (std/net/bio/output#bio-write-u8
                   std/net/httpd/handler#SPC
                   _xbuf205956_)
                  (std/net/bio/output#bio-write-string
                   _url205953_
                   _xbuf205956_)
                  (std/net/bio/output#bio-write-u8
                   std/net/httpd/handler#SPC
                   _xbuf205956_)
                  (std/net/bio/output#bio-write-string
                   _proto205952_
                   _xbuf205956_)
                  (std/net/httpd/handler#write-crlf _xbuf205956_)
                  (std/net/httpd/handler#write-response-headers
                   _xbuf205956_
                   _headers205951_)
                  (std/net/httpd/handler#write-crlf _xbuf205956_)
                  (let ((_chunks205958_
                         (std/net/bio/buffer#chunked-output-chunks
                          _xbuf205956_)))
                    (std/net/httpd/handler#http-response-begin
                     _res205929_
                     '200
                     '(("Content-Type" . "message/http")))
                    (for-each
                     (lambda (_g205959205961_)
                       (std/net/httpd/handler#http-response-chunk__0
                        _res205929_
                        _g205959205961_))
                     _chunks205958_)
                    (std/net/httpd/handler#http-response-end _res205929_))))))
        (if (##structure-direct-instance-of?
             _req205931205944_
             'std/net/httpd/handler#http-request::t)
            (let* ((_e205935205967_ (##vector-ref _req205931205944_ '1))
                   (_e205936205970_ (##vector-ref _req205931205944_ '2))
                   (_e205937205973_ (##vector-ref _req205931205944_ '3))
                   (_method205976_ _e205937205973_)
                   (_e205938205978_ (##vector-ref _req205931205944_ '4))
                   (_url205981_ _e205938205978_)
                   (_e205939205983_ (##vector-ref _req205931205944_ '5))
                   (_e205940205986_ (##vector-ref _req205931205944_ '6))
                   (_e205941205989_ (##vector-ref _req205931205944_ '7))
                   (_proto205992_ _e205941205989_)
                   (_e205942205994_ (##vector-ref _req205931205944_ '8))
                   (_headers205997_ _e205942205994_))
              (_K205934205964_
               _headers205997_
               _proto205992_
               _url205981_
               _method205976_))
            (_E205933205948_)))))
  (define-macro (define-guard guard defn)
    (if (eval `(cond-expand (,guard #t) (else #f)))
        '(begin)
        (begin (eval `(define-cond-expand-feature ,guard)) defn)))
  (define-macro (define-c-lambda id args ret #!optional (name #f))
    (let ((name (or name (symbol->string id))))
      `(define ,id (c-lambda ,args ,ret ,name))))
  (define-macro (define-const symbol)
    (let* ((str (symbol->string symbol))
           (ref (string-append "___return (" str ");")))
      `(define ,symbol ((c-lambda () int ,ref)))))
  (define-macro (define-const* symbol #!optional (ccond #f))
    (let* ((str (symbol->string symbol))
           (code (string-append
                  "#if "
                  (or ccond (string-append "defined(" str ")"))
                  "\n"
                  "___return (___FIX ("
                  str
                  "));\n"
                  "#else \n"
                  "___return (___FAL);\n"
                  "#endif")))
      `(define ,symbol ((c-lambda () scheme-object ,code)))))
  (define-macro (define-with-errno symbol ffi-symbol args)
    `(define (,symbol ,@args)
       (declare (not interrupts-enabled))
       (let ((r (,ffi-symbol ,@args)))
         (if (##fx< r 0) (##fx- (##c-code "___RESULT = ___FIX (errno);")) r))))
  (define-macro (define-c-struct
                 struct
                 #!optional
                 (members '())
                 release-function)
    (let* ((struct-str (symbol->string struct))
           (struct-ptr (string->symbol (string-append struct-str "*")))
           (shallow-ptr
            (string->symbol (string-append struct-str "-shallow-ptr*")))
           (borrowed-ptr
            (string->symbol (string-append struct-str "-borrowed-ptr*")))
           (string-types
            '(char-string
              nonull-char-string
              UTF-8-string
              nonnull-UTF-8-string
              UTF-16-string
              nonnull-UTF16-string))
           (string-compat-required?
            (let loop ((m members))
              (cond ((null? m) #f)
                    ((member (cdr (car m)) string-types) #t)
                    (else (loop (cdr m))))))
           (string-setter-body
            (lambda (member-name)
              (let ((m (string-append "___arg1->" member-name)))
                (string-append
                 "if("
                 m
                 " == NULL)"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "else if (strcmp("
                 m
                 ", ___arg2) != 0) {"
                 "\n"
                 "free("
                 m
                 ");"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "}"
                 "\n"
                 "___return;"
                 "\n"))))
           (default-free-body
            (and string-compat-required?
                 (string-append
                  "___SCMOBJ "
                  struct-str
                  "_ffi_free (void *ptr) {"
                  "\n"
                  "struct "
                  struct-str
                  " *obj = (struct "
                  struct-str
                  "*) ptr;"
                  "\n"
                  (apply string-append
                         (map (lambda (m)
                                (cond ((memq (cdr m) string-types)
                                       (let ((mem-name
                                              (symbol->string (car m))))
                                         (string-append
                                          "if(obj->"
                                          mem-name
                                          ") "
                                          "free(obj->"
                                          mem-name
                                          ");"
                                          "\n")))
                                      (else "")))
                              members))
                  "free(obj);"
                  "\n"
                  "return ___FIX (___NO_ERR);"
                  "\n"
                  "}")))
           (release-function
            (or release-function
                (if string-compat-required?
                    (string-append struct-str "_ffi_free")
                    "ffi_free")))
           (string-compat-types
            (if string-compat-required?
                `((c-declare ,default-free-body)
                  (c-define-type
                   ,shallow-ptr
                   (pointer ,struct (,struct-ptr) "ffi_free")))
                '())))
      `(begin
         (c-define-type ,struct (struct ,struct-str))
         (c-define-type
          ,struct-ptr
          (pointer ,struct (,struct-ptr) ,release-function))
         (c-define-type ,borrowed-ptr (pointer ,struct (,struct-ptr)))
         ,@string-compat-types
         (define ,(string->symbol (string-append struct-str "-ptr?"))
           (lambda (obj)
             (and (foreign? obj) (equal? (foreign-tags obj) '(,struct-ptr)))))
         ,@(apply append
                  (map (lambda (m)
                         (let* ((member-name (symbol->string (car m)))
                                (member-type (cdr m))
                                (getter-name
                                 (string-append struct-str "-" member-name))
                                (setter-body
                                 (cond ((member member-type string-types)
                                        (string-setter-body member-name))
                                       (else
                                        (string-append
                                         "___arg1->"
                                         member-name
                                         " = ___arg2;"
                                         "\n"
                                         "___return;"
                                         "\n")))))
                           `((define ,(string->symbol getter-name)
                               (c-lambda
                                (,struct-ptr)
                                ,member-type
                                ,(string-append
                                  "___return(___arg1->"
                                  member-name
                                  ");")))
                             (define ,(string->symbol
                                       (string-append getter-name "-set!"))
                               (c-lambda
                                (,struct-ptr ,member-type)
                                void
                                ,setter-body)))))
                       members))
         (define ,(string->symbol (string-append "malloc-" struct-str))
           (c-lambda
            ()
            ,struct-ptr
            ,(string-append
              "struct "
              struct-str
              "* var = (struct "
              struct-str
              " *) malloc(sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(var, 0, sizeof(struct "
              struct-str
              "));"
              "___return(var);")))
         (define ,(string->symbol (string-append "ptr->" struct-str))
           (c-lambda (,struct-ptr) ,struct "___return(*___arg1);"))
         (define ,(string->symbol
                   (string-append "malloc-" struct-str "-array"))
           (c-lambda
            (unsigned-int32)
            ,(if string-compat-required? shallow-ptr struct-ptr)
            ,(string-append
              "struct "
              struct-str
              " *arr_var=(struct "
              struct-str
              " *) malloc(___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (arr_var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(arr_var, 0, ___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "___return(arr_var);")))
         (define ,(string->symbol (string-append struct-str "-array-ref"))
           (c-lambda
            (,struct-ptr unsigned-int32)
            ,borrowed-ptr
            "___return (___arg1 + ___arg2);"))
         (define ,(string->symbol (string-append struct-str "-array-set!"))
           (c-lambda
            (,struct-ptr unsigned-int32 ,struct-ptr)
            void
            "*(___arg1 + ___arg2) = *___arg3; ___return;")))))
  (c-declare "#include <stdlib.h>")
  (c-declare "#include <string.h>")
  (c-declare "#include <errno.h>")
  (c-declare "static ___SCMOBJ ffi_free (void *ptr);")
  (c-declare
   "#ifndef ___HAVE_FFI_U8VECTOR\n#define ___HAVE_FFI_U8VECTOR\n#define U8_DATA(obj) ___CAST (___U8*, ___BODY_AS (obj, ___tSUBTYPED))\n#define U8_LEN(obj) ___HD_BYTES (___HEADER (obj))\n#endif")
  (namespace ("std/net/httpd/handler#" http-date))
  (c-declare
   "#include <time.h>\n#include <string.h>\n__thread char buf[64];\nstatic char *ffi_httpd_date () {\n struct tm tm;\n time_t t = time(NULL);\n asctime_r (gmtime_r (&t, &tm), buf);\n // clobber newline\n buf[strlen(buf)-1] = 0;\n return buf;\n}")
  (define-c-lambda http-date () char-string "ffi_httpd_date")
  (c-declare
   "#ifndef ___HAVE_FFI_FREE\n#define ___HAVE_FFI_FREE\n___SCMOBJ ffi_free (void *ptr)\n{\n free (ptr);\n return ___FIX (___NO_ERR);\n}\n#endif")
  (define std/net/httpd/handler#request-timeout '60)
  (define std/net/httpd/handler#response-timeout '120)
  (define std/net/httpd/handler#max-request-headers '256)
  (define std/net/httpd/handler#max-token-length '1024)
  (define std/net/httpd/handler#max-request-body-length (expt '2 '20))
  (define std/net/httpd/handler#input-buffer-size '4096)
  (define std/net/httpd/handler#output-buffer-size '4096)
  (define std/net/httpd/handler#set-httpd-request-timeout!
    (lambda (_val205920_)
      (if (or (not _val205920_) (real? _val205920_) (time? _val205920_))
          (set! std/net/httpd/handler#request-timeout _val205920_)
          (error '"Cannot set httpd parameter; Bad argument" _val205920_))))
  (define std/net/httpd/handler#set-httpd-response-timeout!
    (lambda (_val205911_)
      (if (or (not _val205911_) (real? _val205911_) (time? _val205911_))
          (set! std/net/httpd/handler#response-timeout _val205911_)
          (error '"Cannot set httpd parameter; Bad argument" _val205911_))))
  (define std/net/httpd/handler#set-httpd-max-request-headers!
    (lambda (_val205908_)
      (if (and (fixnum? _val205908_) (fxpositive? _val205908_))
          (set! std/net/httpd/handler#max-request-headers _val205908_)
          (error '"Cannot set httpd parameter; Bad argument" _val205908_))))
  (define std/net/httpd/handler#set-httpd-max-token-length!
    (lambda (_val205905_)
      (if (and (fixnum? _val205905_) (fxpositive? _val205905_))
          (set! std/net/httpd/handler#max-token-length _val205905_)
          (error '"Cannot set httpd parameter; Bad argument" _val205905_))))
  (define std/net/httpd/handler#set-httpd-max-request-body-length!
    (lambda (_val205902_)
      (if (and (fixnum? _val205902_) (fxpositive? _val205902_))
          (set! std/net/httpd/handler#max-request-body-length _val205902_)
          (error '"Cannot set httpd parameter; Bad argument" _val205902_))))
  (define std/net/httpd/handler#set-httpd-input-buffer-size!
    (lambda (_val205899_)
      (if (and (fixnum? _val205899_) (fxpositive? _val205899_))
          (set! std/net/httpd/handler#input-buffer-size _val205899_)
          (error '"Cannot set httpd parameter; Bad argument" _val205899_))))
  (define std/net/httpd/handler#set-httpd-output-buffer-size!
    (lambda (_val205896_)
      (if (and (fixnum? _val205896_) (fxpositive? _val205896_))
          (set! std/net/httpd/handler#output-buffer-size _val205896_)
          (error '"Cannot set httpd parameter; Bad argument" _val205896_))))
  (define std/net/httpd/handler#read-request!
    (lambda (_req205882_)
      (let* ((_ibuf205884_
              (##unchecked-structure-ref
               _req205882_
               '1
               std/net/httpd/handler#http-request::t
               '#f))
             (_g309533_
              (std/net/httpd/handler#read-request-line _ibuf205884_)))
        (begin
          (let ((_g309534_
                 (if (##values? _g309533_) (##vector-length _g309533_) 1)))
            (if (not (##fx= _g309534_ 3))
                (error "Context expects 3 values" _g309534_)))
          (let ((_method205886_ (##vector-ref _g309533_ 0))
                (_url205887_ (##vector-ref _g309533_ 1))
                (_proto205888_ (##vector-ref _g309533_ 2)))
            (let ((_g309535_
                   (std/net/httpd/handler#split-request-url _url205887_)))
              (begin
                (let ((_g309536_
                       (if (##values? _g309535_)
                           (##vector-length _g309535_)
                           1)))
                  (if (not (##fx= _g309536_ 2))
                      (error "Context expects 2 values" _g309536_)))
                (let ((_path205890_ (##vector-ref _g309535_ 0))
                      (_params205891_ (##vector-ref _g309535_ 1)))
                  (let ((_headers205893_
                         (std/net/httpd/handler#read-request-headers
                          _ibuf205884_)))
                    (##unchecked-structure-set!
                     _req205882_
                     _method205886_
                     '3
                     std/net/httpd/handler#http-request::t
                     '#f)
                    (##unchecked-structure-set!
                     _req205882_
                     _url205887_
                     '4
                     std/net/httpd/handler#http-request::t
                     '#f)
                    (##unchecked-structure-set!
                     _req205882_
                     _path205890_
                     '5
                     std/net/httpd/handler#http-request::t
                     '#f)
                    (##unchecked-structure-set!
                     _req205882_
                     _params205891_
                     '6
                     std/net/httpd/handler#http-request::t
                     '#f)
                    (##unchecked-structure-set!
                     _req205882_
                     _proto205888_
                     '7
                     std/net/httpd/handler#http-request::t
                     '#f)
                    (##unchecked-structure-set!
                     _req205882_
                     _headers205893_
                     '8
                     std/net/httpd/handler#http-request::t
                     '#f))))))))))
  (define std/net/httpd/handler#split-request-url-rx
    (std/pregexp#pregexp '"^[^/]+://[^/]*(/.*)$"))
  (define std/net/httpd/handler#split-request-url
    (lambda (_url205835_)
      (let ((_$e205837_ (string-index _url205835_ '#\:)))
        (if _$e205837_
            ((lambda (_ix205840_)
               (let* ((_g205841205851_
                       (std/pregexp#pregexp-match
                        std/net/httpd/handler#split-request-url-rx
                        _url205835_))
                      (_else205843205859_
                       (lambda ()
                         (std/error#raise-io-error
                          'http-read-request
                          '"invalid url"
                          _url205835_)))
                      (_K205845205864_
                       (lambda (_base205862_)
                         (std/net/httpd/handler#split-request-url
                          _base205862_))))
                 (if (##pair? _g205841205851_)
                     (let ((_tl205847205867_ (##cdr _g205841205851_)))
                       (if (##pair? _tl205847205867_)
                           (let ((_hd205848205870_ (##car _tl205847205867_))
                                 (_tl205849205872_ (##cdr _tl205847205867_)))
                             (let ((_base205875_ _hd205848205870_))
                               (if (##null? _tl205849205872_)
                                   (std/net/httpd/handler#split-request-url
                                    _base205875_)
                                   (_else205843205859_))))
                           (_else205843205859_)))
                     (_else205843205859_))))
             _$e205837_)
            (let ((_$e205877_ (string-index _url205835_ '#\?)))
              (if _$e205877_
                  ((lambda (_ix205880_)
                     (values (substring _url205835_ '0 _ix205880_)
                             (substring
                              _url205835_
                              (fx+ _ix205880_ '1)
                              (string-length _url205835_))))
                   _$e205877_)
                  (values _url205835_ '#f)))))))
  (define std/net/httpd/handler#read-request-line
    (lambda (_ibuf205819_)
      (let* ((_g309537_
              (std/net/httpd/handler#read-skip*__1
               _ibuf205819_
               std/net/httpd/handler#CR
               std/net/httpd/handler#LF))
             (_method205822_
              (std/net/httpd/handler#read-token
               _ibuf205819_
               std/net/httpd/handler#SPC))
             (_url205824_
              (std/net/httpd/handler#read-token
               _ibuf205819_
               std/net/httpd/handler#SPC))
             (_proto205826_
              (std/net/httpd/handler#read-token
               _ibuf205819_
               std/net/httpd/handler#CR))
             (_g309538_
              (std/net/httpd/handler#read-skip__0
               _ibuf205819_
               std/net/httpd/handler#LF))
             (_method205832_
              (let ((_$e205829_
                     (table-ref
                      std/net/httpd/handler#+http-request-methods+
                      _method205822_
                      '#f)))
                (if _$e205829_ _$e205829_ _method205822_))))
        (values _method205832_ _url205824_ _proto205826_))))
  (define std/net/httpd/handler#read-request-headers
    (lambda (_ibuf205803_)
      (let ((_root205805_ (cons '#f '())))
        (let _lp205807_ ((_tl205809_ _root205805_) (_count205810_ '0))
          (let ((_next205812_ (std/net/bio/input#bio-peek-u8 _ibuf205803_)))
            (if (eof-object? _next205812_)
                (raise 'eof)
                (if (eq? _next205812_ std/net/httpd/handler#CR)
                    (begin
                      (std/net/httpd/handler#read-skip__1
                       _ibuf205803_
                       std/net/httpd/handler#CR
                       std/net/httpd/handler#LF)
                      (cdr _root205805_))
                    (if (fx< _count205810_
                             std/net/httpd/handler#max-request-headers)
                        (let* ((_hdr205814_
                                (std/net/httpd/handler#read-header
                                 _ibuf205803_))
                               (_tl*205816_ (cons _hdr205814_ '())))
                          (set-cdr! _tl205809_ _tl*205816_)
                          (_lp205807_ _tl*205816_ (fx+ _count205810_ '1)))
                        (std/error#raise-io-error
                         'http-read-request
                         '"too many headers"
                         _count205810_)))))))))
  (define std/net/httpd/handler#read-header
    (lambda (_ibuf205793_)
      (let* ((_key205795_
              (std/net/httpd/handler#read-token
               _ibuf205793_
               std/net/httpd/handler#COL))
             (_g309539_ (std/net/httpd/handler#header-titlecase! _key205795_))
             (_g309540_
              (std/net/httpd/handler#read-skip*__0
               _ibuf205793_
               std/net/httpd/handler#SPC))
             (_val205799_
              (std/net/httpd/handler#read-token
               _ibuf205793_
               std/net/httpd/handler#CR))
             (_g309541_
              (std/net/httpd/handler#read-skip__0
               _ibuf205793_
               std/net/httpd/handler#LF)))
        (cons _key205795_ _val205799_))))
  (define std/net/httpd/handler#header-titlecase!
    (lambda (_str205775_)
      (let ((_len205777_ (string-length _str205775_)))
        (let _lp205779_ ((_i205781_ '0) (_upcase?205782_ '#t))
          (if (fx< _i205781_ _len205777_)
              (let* ((_char205784_ (string-ref _str205775_ _i205781_))
                     (_int205786_ (char->integer _char205784_)))
                (if (fx<= '97 _int205786_ '122)
                    (begin
                      (if _upcase?205782_
                          (let ((_char205789_
                                 (integer->char (fx- _int205786_ '32))))
                            (string-set! _str205775_ _i205781_ _char205789_))
                          '#!void)
                      (_lp205779_ (fx+ _i205781_ '1) '#f))
                    (if (fx<= '65 _int205786_ '90)
                        (begin
                          (if _upcase?205782_
                              '#!void
                              (let ((_char205791_
                                     (integer->char (fx+ _int205786_ '32))))
                                (string-set!
                                 _str205775_
                                 _i205781_
                                 _char205791_)))
                          (_lp205779_ (fx+ _i205781_ '1) '#f))
                        (_lp205779_ (fx+ _i205781_ '1) '#t))))
              _str205775_)))))
  (define std/net/httpd/handler#read-token
    (lambda (_ibuf205760_ _sep205761_)
      (letrec* ((_tbuf205763_ (std/net/httpd/handler#get-token-buffer)))
        (let _lp205765_ ((_count205767_ '0))
          (let ((_next205769_ (std/net/bio/input#bio-read-u8 _ibuf205760_)))
            (if (eof-object? _next205769_)
                (begin
                  (std/net/httpd/handler#put-token-buffer! _tbuf205763_)
                  (raise 'eof))
                (if (eq? _next205769_ _sep205761_)
                    (let ((_token205771_
                           (##substring _tbuf205763_ '0 _count205767_)))
                      (std/net/httpd/handler#put-token-buffer! _tbuf205763_)
                      _token205771_)
                    (if (fx< _count205767_
                             std/net/httpd/handler#max-token-length)
                        (let ((_char205773_ (integer->char _next205769_)))
                          (string-set! _tbuf205763_ _count205767_ _char205773_)
                          (_lp205765_ (fx+ _count205767_ '1)))
                        (begin
                          (std/net/httpd/handler#put-token-buffer!
                           _tbuf205763_)
                          (std/error#raise-io-error
                           'http-read-request
                           '"Maximum token length exceeded"
                           _count205767_))))))))))
  (define std/net/httpd/handler#read-skip__0
    (lambda (_ibuf205751_ _c205752_)
      (let ((_next205754_ (std/net/bio/input#bio-read-u8 _ibuf205751_)))
        (if (eq? _c205752_ _next205754_)
            '#!void
            (std/error#raise-io-error
             'http-read-request
             '"Unexpected character"
             _next205754_)))))
  (define std/net/httpd/handler#read-skip__1
    (lambda (_ibuf205756_ _c1205757_ _c2205758_)
      (std/net/httpd/handler#read-skip__0 _ibuf205756_ _c1205757_)
      (std/net/httpd/handler#read-skip__0 _ibuf205756_ _c2205758_)))
  (define std/net/httpd/handler#read-skip
    (lambda _g309543_
      (let ((_g309542_ (##length _g309543_)))
        (cond ((##fx= _g309542_ 2)
               (apply std/net/httpd/handler#read-skip__0 _g309543_))
              ((##fx= _g309542_ 3)
               (apply std/net/httpd/handler#read-skip__1 _g309543_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/httpd/handler#read-skip
                _g309543_))))))
  (define std/net/httpd/handler#read-skip*__0
    (lambda (_ibuf205734_ _c205735_)
      (let _lp205737_ ()
        (let ((_next205740_ (std/net/bio/input#bio-peek-u8 _ibuf205734_)))
          (if (eq? _next205740_ _c205735_)
              (begin (std/net/bio/input#bio-read-u8 _ibuf205734_) (_lp205737_))
              '#!void)))))
  (define std/net/httpd/handler#read-skip*__1
    (lambda (_ibuf205742_ _c1205743_ _c2205744_)
      (let _lp205746_ ()
        (let ((_next205749_ (std/net/bio/input#bio-peek-u8 _ibuf205742_)))
          (if (eq? _next205749_ _c1205743_)
              (begin
                (std/net/bio/input#bio-read-u8 _ibuf205742_)
                (std/net/httpd/handler#read-skip__0 _ibuf205742_ _c2205744_)
                (_lp205746_))
              '#!void)))))
  (define std/net/httpd/handler#read-skip*
    (lambda _g309545_
      (let ((_g309544_ (##length _g309545_)))
        (cond ((##fx= _g309544_ 2)
               (apply std/net/httpd/handler#read-skip*__0 _g309545_))
              ((##fx= _g309544_ 3)
               (apply std/net/httpd/handler#read-skip*__1 _g309545_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/httpd/handler#read-skip*
                _g309545_))))))
  (define std/net/httpd/handler#read-request-body
    (lambda (_ibuf205712_ _headers205713_)
      (letrec ((_read-simple-body205715_
                (lambda ()
                  (let ((_$e205723_
                         (std/net/httpd/handler#header-e
                          '"Content-Length"
                          _headers205713_)))
                    (if _$e205723_
                        ((lambda (_len205726_)
                           (let* ((_len205728_ (string->number _len205726_))
                                  (_g309546_
                                   (if (fx<= _len205728_
                                             std/net/httpd/handler#max-request-body-length)
                                       '#!void
                                       (std/error#raise-io-error
                                        'http-request-body
                                        '"Maximum body length exceeded"
                                        _len205728_)))
                                  (_bytes205731_ (make-u8vector _len205728_)))
                             (std/net/bio/input#bio-read-bytes
                              _bytes205731_
                              _ibuf205712_)
                             _bytes205731_))
                         _$e205723_)
                        '#f)))))
        (let ((_$e205717_
               (std/net/httpd/handler#header-e
                '"Transfer-Encoding"
                _headers205713_)))
          (if _$e205717_
              ((lambda (_tenc205720_)
                 (if (not (equal? '"identity" _tenc205720_))
                     (std/net/httpd/handler#read-request-chunks _ibuf205712_)
                     (_read-simple-body205715_)))
               _$e205717_)
              (_read-simple-body205715_))))))
  (define std/net/httpd/handler#read-request-chunks
    (lambda (_ibuf205691_)
      (let ((_root205693_ (cons '#f '())))
        (let _lp205695_ ((_tl205697_ _root205693_) (_count205698_ '0))
          (let* ((_next205700_
                  (std/net/httpd/handler#read-token
                   _ibuf205691_
                   std/net/httpd/handler#CR))
                 (_g309547_
                  (std/net/httpd/handler#read-skip__0
                   _ibuf205691_
                   std/net/httpd/handler#LF))
                 (_len205703_ (string->number _next205700_ '16)))
            (if (fx> _len205703_ '0)
                (let ((_count205706_ (fx+ _count205698_ _len205703_)))
                  (if (fx<= _count205706_
                            std/net/httpd/handler#max-request-body-length)
                      (let ((_chunk205708_ (make-u8vector _len205703_)))
                        (std/net/bio/input#bio-read-bytes
                         _chunk205708_
                         _ibuf205691_)
                        (std/net/httpd/handler#read-skip__1
                         _ibuf205691_
                         std/net/httpd/handler#CR
                         std/net/httpd/handler#LF)
                        (let ((_tl*205710_ (cons _chunk205708_ '())))
                          (set-cdr! _tl205697_ _tl*205710_)
                          (_lp205695_ _tl*205710_ _count205706_)))
                      (std/error#raise-io-error
                       'http-request-body
                       '"Maximum body length exceeded"
                       _count205706_
                       _len205703_)))
                (u8vector-concatenate (cdr _root205693_))))))))
  (define std/net/httpd/handler#skip-request-body
    (lambda (_ibuf205672_ _headers205673_)
      (letrec ((_skip-simple-body205675_
                (lambda ()
                  (let ((_clen205682205684_
                         (std/net/httpd/handler#header-e
                          '"Content-Length"
                          _headers205673_)))
                    (if _clen205682205684_
                        (let* ((_clen205687_ _clen205682205684_)
                               (_len205689_ (string->number _clen205687_)))
                          (if (fixnum? _len205689_)
                              (std/net/bio/input#bio-input-skip
                               _len205689_
                               _ibuf205672_)
                              (std/error#raise-io-error
                               'http-request-skip-body
                               '"Illegal body length"
                               _clen205687_)))
                        '#f)))))
        (let ((_$e205677_
               (std/net/httpd/handler#header-e
                '"Transfer-Encoding"
                _headers205673_)))
          (if _$e205677_
              ((lambda (_tenc205680_)
                 (if (not (equal? '"identity" _tenc205680_))
                     (std/net/httpd/handler#skip-request-chunks _ibuf205672_)
                     (_skip-simple-body205675_)))
               _$e205677_)
              (_skip-simple-body205675_))))))
  (define std/net/httpd/handler#skip-request-chunks
    (lambda (_ibuf205664_)
      (let* ((_next205666_
              (std/net/httpd/handler#read-token
               _ibuf205664_
               std/net/httpd/handler#CR))
             (_g309548_
              (std/net/httpd/handler#read-skip__0
               _ibuf205664_
               std/net/httpd/handler#LF))
             (_len205669_ (string->number _next205666_ '16)))
        (if (fx> _len205669_ '0)
            (begin
              (std/net/bio/input#bio-input-skip _len205669_ _ibuf205664_)
              (std/net/httpd/handler#read-skip__1
               _ibuf205664_
               std/net/httpd/handler#CR
               std/net/httpd/handler#LF)
              (std/net/httpd/handler#skip-request-chunks _ibuf205664_))
            '#!void))))
  (define std/net/httpd/handler#write-response-line
    (lambda (_obuf205656_ _status205657_)
      (let ((_text205662_
             (let ((_$e205659_
                    (table-ref
                     std/net/httpd/handler#+http-response-codes+
                     _status205657_
                     '#f)))
               (if _$e205659_ (values _$e205659_) '"Gremlins!"))))
        (std/net/bio/output#bio-write-string '"HTTP/1.1" _obuf205656_)
        (std/net/bio/output#bio-write-u8
         std/net/httpd/handler#SPC
         _obuf205656_)
        (std/net/bio/output#bio-write-string
         (number->string _status205657_)
         _obuf205656_)
        (std/net/bio/output#bio-write-u8
         std/net/httpd/handler#SPC
         _obuf205656_)
        (std/net/bio/output#bio-write-string _text205662_ _obuf205656_)
        (std/net/httpd/handler#write-crlf _obuf205656_))))
  (define std/net/httpd/handler#write-response-headers
    (lambda (_obuf205621_ _headers205622_)
      (letrec ((_write-header205624_
                (lambda (_hdr205626_)
                  (let* ((_hdr205627205634_ _hdr205626_)
                         (_E205629205638_
                          (lambda ()
                            (error '"No clause matching" _hdr205627205634_)))
                         (_K205630205644_
                          (lambda (_val205641_ _key205642_)
                            (if (string? _key205642_)
                                (if (string? _val205641_)
                                    (begin
                                      (std/net/bio/output#bio-write-string
                                       _key205642_
                                       _obuf205621_)
                                      (std/net/bio/output#bio-write-u8
                                       std/net/httpd/handler#COL
                                       _obuf205621_)
                                      (std/net/bio/output#bio-write-u8
                                       std/net/httpd/handler#SPC
                                       _obuf205621_)
                                      (std/net/bio/output#bio-write-string
                                       _val205641_
                                       _obuf205621_)
                                      (std/net/httpd/handler#write-crlf
                                       _obuf205621_))
                                    (error '"Bad header value; expected string"
                                           _hdr205626_
                                           _val205641_))
                                (error '"Bad header key; expected string"
                                       _hdr205626_
                                       _key205642_)))))
                    (if (##pair? _hdr205627205634_)
                        (let ((_hd205631205647_ (##car _hdr205627205634_))
                              (_tl205632205649_ (##cdr _hdr205627205634_)))
                          (let* ((_key205652_ _hd205631205647_)
                                 (_val205654_ _tl205632205649_))
                            (_K205630205644_ _val205654_ _key205652_)))
                        (_E205629205638_))))))
        (for-each _write-header205624_ _headers205622_))))
  (define std/net/httpd/handler#write-crlf
    (lambda (_obuf205619_)
      (std/net/bio/output#bio-write-u8 std/net/httpd/handler#CR _obuf205619_)
      (std/net/bio/output#bio-write-u8 std/net/httpd/handler#LF _obuf205619_)))
  (define std/net/httpd/handler#write-chunk
    (lambda (_obuf205609_ _chunk205610_ _start205611_ _end205612_)
      (let* ((_end205614_
              (if _end205612_
                  _end205612_
                  (if (u8vector? _chunk205610_)
                      (u8vector-length _chunk205610_)
                      (if (string? _chunk205610_)
                          (string-length _chunk205610_)
                          (if (not _chunk205610_)
                              '0
                              (error '"Bad chunk; expected u8vector or string"
                                     _chunk205610_))))))
             (_len205616_
              (if (u8vector? _chunk205610_)
                  (fx- _end205614_ _start205611_)
                  (if (string? _chunk205610_)
                      (std/text/utf8#string-utf8-length__%
                       _chunk205610_
                       _start205611_
                       _end205614_)
                      '0))))
        (if (fx> _len205616_ '0)
            (begin
              (std/net/bio/output#bio-write-string
               (number->string _len205616_ '16)
               _obuf205609_)
              (std/net/httpd/handler#write-crlf _obuf205609_)
              (if (u8vector? _chunk205610_)
                  (std/net/bio/output#bio-write-subu8vector
                   _chunk205610_
                   _start205611_
                   _end205614_
                   _obuf205609_)
                  (if (string? _chunk205610_)
                      (std/net/bio/output#bio-write-substring
                       _chunk205610_
                       _start205611_
                       _end205614_
                       _obuf205609_)
                      '#!void))
              (std/net/httpd/handler#write-crlf _obuf205609_))
            '#!void))))
  (define std/net/httpd/handler#write-last-chunk
    (lambda (_obuf205607_)
      (std/net/bio/output#bio-write-u8 std/net/httpd/handler#C0 _obuf205607_)
      (std/net/httpd/handler#write-crlf _obuf205607_)
      (std/net/httpd/handler#write-crlf _obuf205607_)))
  (define std/net/httpd/handler#C0 (char->integer '#\0))
  (define std/net/httpd/handler#CR (char->integer '#\return))
  (define std/net/httpd/handler#LF (char->integer '#\newline))
  (define std/net/httpd/handler#COL (char->integer '#\:))
  (define std/net/httpd/handler#SPC (char->integer '#\space))
  (define std/net/httpd/handler#QMARK (char->integer '#\?))
  (define std/net/httpd/handler#+http-request-methods+
    (let ((_ht205604_ (make-table 'size: '7)))
      (table-set! _ht205604_ '"GET" 'GET)
      (table-set! _ht205604_ '"HEAD" 'HEAD)
      (table-set! _ht205604_ '"POST" 'POST)
      (table-set! _ht205604_ '"PUT" 'PUT)
      (table-set! _ht205604_ '"DELETE" 'DELETE)
      (table-set! _ht205604_ '"TRACE" 'TRACE)
      (table-set! _ht205604_ '"OPTIONS" 'OPTIONS)
      _ht205604_))
  (define std/net/httpd/handler#+http-response-codes+
    (let ((_ht205601_ (make-table 'test: eq? 'size: '40)))
      (table-set! _ht205601_ '100 '"Continue")
      (table-set! _ht205601_ '101 '"Switching Protocols")
      (table-set! _ht205601_ '200 '"OK")
      (table-set! _ht205601_ '201 '"Created")
      (table-set! _ht205601_ '202 '"Accepted")
      (table-set! _ht205601_ '203 '"Non-Authoritative Information")
      (table-set! _ht205601_ '204 '"No Content")
      (table-set! _ht205601_ '205 '"Reset Content")
      (table-set! _ht205601_ '206 '"Partial Content")
      (table-set! _ht205601_ '300 '"Multiple Choices")
      (table-set! _ht205601_ '301 '"Moved Permanently")
      (table-set! _ht205601_ '302 '"Found")
      (table-set! _ht205601_ '303 '"See Other")
      (table-set! _ht205601_ '304 '"Not Modified")
      (table-set! _ht205601_ '305 '"Use Proxy")
      (table-set! _ht205601_ '307 '"Temporary Redirect")
      (table-set! _ht205601_ '400 '"Bad Request")
      (table-set! _ht205601_ '401 '"Unauthorized")
      (table-set! _ht205601_ '402 '"Payment Required")
      (table-set! _ht205601_ '403 '"Forbidden")
      (table-set! _ht205601_ '404 '"Not Found")
      (table-set! _ht205601_ '405 '"Method Not Allowed")
      (table-set! _ht205601_ '406 '"Not Acceptable")
      (table-set! _ht205601_ '407 '"Proxy Authentication Required")
      (table-set! _ht205601_ '408 '"Request Timeout")
      (table-set! _ht205601_ '409 '"Conflict")
      (table-set! _ht205601_ '410 '"Gone")
      (table-set! _ht205601_ '411 '"Length Required")
      (table-set! _ht205601_ '412 '"Precondition Failed")
      (table-set! _ht205601_ '413 '"Request Entity Too Large")
      (table-set! _ht205601_ '414 '"Request-URI Too Long")
      (table-set! _ht205601_ '415 '"Unsupported Media Type")
      (table-set! _ht205601_ '416 '"Requested Range Not Satisfiable")
      (table-set! _ht205601_ '417 '"Expectation Failed")
      (table-set! _ht205601_ '500 '"Internal Server Error")
      (table-set! _ht205601_ '501 '"Not Implemented")
      (table-set! _ht205601_ '502 '"Bad Gateway")
      (table-set! _ht205601_ '503 '"Service Unavailable")
      (table-set! _ht205601_ '504 '"Gateway Timeout")
      (table-set! _ht205601_ '505 '"HTTP Version Not Supported")
      _ht205601_))
  (define std/net/httpd/handler#+input-buffers+ '())
  (define std/net/httpd/handler#+output-buffers+ '())
  (define std/net/httpd/handler#+token-buffers+ '())
  (define std/net/httpd/handler#get-input-buffer
    (lambda (_sock205565_)
      (declare (not interrupts-enabled))
      (let* ((_+input-buffers+205567205575_
              std/net/httpd/handler#+input-buffers+)
             (_else205569205583_
              (lambda ()
                (std/net/socket/buffer#open-ssocket-input-buffer__%
                 _sock205565_
                 std/net/httpd/handler#input-buffer-size)))
             (_K205571205589_
              (lambda (_rest205586_ _buf205587_)
                (set! std/net/httpd/handler#+input-buffers+ _rest205586_)
                (std/net/socket/buffer#ssocket-input-buffer-reset!
                 _buf205587_
                 _sock205565_)
                _buf205587_)))
        (if (##pair? _+input-buffers+205567205575_)
            (let ((_hd205572205592_ (##car _+input-buffers+205567205575_))
                  (_tl205573205594_ (##cdr _+input-buffers+205567205575_)))
              (let* ((_buf205597_ _hd205572205592_)
                     (_rest205599_ _tl205573205594_))
                (_K205571205589_ _rest205599_ _buf205597_)))
            (_else205569205583_)))))
  (define std/net/httpd/handler#put-input-buffer!
    (lambda (_buf205562_)
      (declare (not interrupts-enabled))
      (begin
        (std/net/socket/buffer#ssocket-input-buffer-release! _buf205562_)
        (set! std/net/httpd/handler#+input-buffers+
              (cons _buf205562_ std/net/httpd/handler#+input-buffers+)))))
  (define std/net/httpd/handler#get-output-buffer
    (lambda (_sock205526_)
      (declare (not interrupts-enabled))
      (let* ((_+output-buffers+205528205536_
              std/net/httpd/handler#+output-buffers+)
             (_else205530205544_
              (lambda ()
                (std/net/socket/buffer#open-ssocket-output-buffer__%
                 _sock205526_
                 std/net/httpd/handler#output-buffer-size)))
             (_K205532205550_
              (lambda (_rest205547_ _buf205548_)
                (set! std/net/httpd/handler#+output-buffers+ _rest205547_)
                (std/net/socket/buffer#ssocket-output-buffer-reset!
                 _buf205548_
                 _sock205526_)
                _buf205548_)))
        (if (##pair? _+output-buffers+205528205536_)
            (let ((_hd205533205553_ (##car _+output-buffers+205528205536_))
                  (_tl205534205555_ (##cdr _+output-buffers+205528205536_)))
              (let* ((_buf205558_ _hd205533205553_)
                     (_rest205560_ _tl205534205555_))
                (_K205532205550_ _rest205560_ _buf205558_)))
            (_else205530205544_)))))
  (define std/net/httpd/handler#put-output-buffer!
    (lambda (_buf205523_)
      (declare (not interrupts-enabled))
      (begin
        (std/net/socket/buffer#ssocket-output-buffer-release! _buf205523_)
        (set! std/net/httpd/handler#+output-buffers+
              (cons _buf205523_ std/net/httpd/handler#+output-buffers+)))))
  (define std/net/httpd/handler#get-token-buffer
    (lambda ()
      (declare (not interrupts-enabled))
      (let* ((_+token-buffers+205489205497_
              std/net/httpd/handler#+token-buffers+)
             (_else205491205505_
              (lambda () (make-string std/net/httpd/handler#max-token-length)))
             (_K205493205511_
              (lambda (_rest205508_ _buf205509_)
                (set! std/net/httpd/handler#+token-buffers+ _rest205508_)
                _buf205509_)))
        (if (##pair? _+token-buffers+205489205497_)
            (let ((_hd205494205514_ (##car _+token-buffers+205489205497_))
                  (_tl205495205516_ (##cdr _+token-buffers+205489205497_)))
              (let* ((_buf205519_ _hd205494205514_)
                     (_rest205521_ _tl205495205516_))
                (_K205493205511_ _rest205521_ _buf205519_)))
            (_else205491205505_)))))
  (define std/net/httpd/handler#put-token-buffer!
    (lambda (_buf205485_)
      (declare (not interrupts-enabled))
      (set! std/net/httpd/handler#+token-buffers+
            (cons _buf205485_ std/net/httpd/handler#+token-buffers+)))))
