(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/net/socket/api#ssocket-connect__%
    (lambda (_addr202372_ _timeo202373_)
      (let* ((_sa202375_ (std/os/socket#socket-address _addr202372_))
             (_sock202377_
              (std/os/socket#socket__0
               (std/os/_socket#sockaddr_family _sa202375_)
               std/os/_socket#SOCK_STREAM))
             (_rcon202387_
              (with-exception-catcher
               (lambda (_g202378202380_)
                 (if '#t
                     (let ((_e202383_ _g202378202380_))
                       (close-port _sock202377_)
                       (raise _e202383_))
                     (raise _g202378202380_)))
               (lambda ()
                 (std/os/socket#socket-connect _sock202377_ _sa202375_))))
             (_ssock202389_ (std/net/socket/api#make-ssocket _sock202377_)))
        (let* ((_ssock202391202400_ _ssock202389_)
               (_E202393202404_
                (lambda () (error '"No clause matching" _ssock202391202400_)))
               (_K202394202415_
                (lambda (_close202407_ _wait-out202408_)
                  (if _rcon202387_
                      '#!void
                      (if (_wait-out202408_
                           _ssock202389_
                           (std/net/socket/base#abs-timeout _timeo202373_))
                          '#!void
                          (begin
                            (_close202407_ _ssock202389_ 'inout '#f)
                            (std/error#raise-timeout
                             'ssocket-connect
                             '"connection timeout"
                             _addr202372_))))
                  (let ((_errno202413_
                         (let ((_$e202410_ _rcon202387_))
                           (if _$e202410_
                               _$e202410_
                               (std/os/socket#socket-getsockopt
                                _sock202377_
                                std/os/_socket#SOL_SOCKET
                                std/os/_socket#SO_ERROR)))))
                    (if (##fxzero? _errno202413_)
                        _ssock202389_
                        (begin
                          (_close202407_ _ssock202389_ 'inout '#f)
                          (std/os/error#raise-os-error
                           _errno202413_
                           std/net/socket/api#ssocket-connect
                           _addr202372_
                           _timeo202373_)))))))
          (if (##structure-direct-instance-of?
               _ssock202391202400_
               'std/net/socket/base#!socket::t)
              (let* ((_e202395202418_ (##vector-ref _ssock202391202400_ '1))
                     (_e202396202421_ (##vector-ref _ssock202391202400_ '2))
                     (_e202397202424_ (##vector-ref _ssock202391202400_ '3))
                     (_wait-out202427_ _e202397202424_)
                     (_e202398202429_ (##vector-ref _ssock202391202400_ '4))
                     (_close202432_ _e202398202429_))
                (_K202394202415_ _close202432_ _wait-out202427_))
              (_E202393202404_))))))
  (define std/net/socket/api#ssocket-connect__0
    (lambda (_addr202437_)
      (let ((_timeo202439_ '#f))
        (std/net/socket/api#ssocket-connect__% _addr202437_ _timeo202439_))))
  (define std/net/socket/api#ssocket-connect
    (lambda _g309437_
      (let ((_g309436_ (##length _g309437_)))
        (cond ((##fx= _g309436_ 1)
               (apply std/net/socket/api#ssocket-connect__0 _g309437_))
              ((##fx= _g309436_ 2)
               (apply std/net/socket/api#ssocket-connect__% _g309437_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/api#ssocket-connect
                _g309437_))))))
  (define std/net/socket/api#ssocket-listen__%
    (lambda (_addr202332_ _backlog202333_ _opts202334_)
      (let* ((_sa202336_ (std/os/socket#socket-address _addr202332_))
             (_sock202338_
              (std/os/socket#server-socket__0
               (std/os/_socket#sockaddr_family _sa202336_)
               std/os/_socket#SOCK_STREAM)))
        (with-exception-catcher
         (lambda (_g202340202342_)
           (if '#t
               (let ((_e202345_ _g202340202342_))
                 (close-port _sock202338_)
                 (raise _e202345_))
               (raise _g202340202342_)))
         (lambda ()
           (for-each
            (lambda (_g202348202350_)
              (std/os/socket#socket-setsockopt
               _sock202338_
               std/os/_socket#SOL_SOCKET
               _g202348202350_
               '1))
            _opts202334_)
           (std/os/socket#socket-bind _sock202338_ _sa202336_)
           (std/os/socket#socket-listen__% _sock202338_ _backlog202333_)
           (std/net/socket/api#make-ssocket _sock202338_))))))
  (define std/net/socket/api#ssocket-listen__0
    (lambda (_addr202356_)
      (let* ((_backlog202358_ '10)
             (_opts202360_ std/net/socket/api#default-listen-sockopts))
        (std/net/socket/api#ssocket-listen__%
         _addr202356_
         _backlog202358_
         _opts202360_))))
  (define std/net/socket/api#ssocket-listen__1
    (lambda (_addr202362_ _backlog202363_)
      (let ((_opts202365_ std/net/socket/api#default-listen-sockopts))
        (std/net/socket/api#ssocket-listen__%
         _addr202362_
         _backlog202363_
         _opts202365_))))
  (define std/net/socket/api#ssocket-listen
    (lambda _g309439_
      (let ((_g309438_ (##length _g309439_)))
        (cond ((##fx= _g309438_ 1)
               (apply std/net/socket/api#ssocket-listen__0 _g309439_))
              ((##fx= _g309438_ 2)
               (apply std/net/socket/api#ssocket-listen__1 _g309439_))
              ((##fx= _g309438_ 3)
               (apply std/net/socket/api#ssocket-listen__% _g309439_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/api#ssocket-listen
                _g309439_))))))
  (define std/net/socket/api#ssocket-accept__%
    (lambda (_ssock202278_ _sa202279_ _timeo202280_)
      (let* ((_ssock202281202287_ _ssock202278_)
             (_E202283202291_
              (lambda () (error '"No clause matching" _ssock202281202287_)))
             (_K202284202305_
              (lambda (_sock202294_)
                (let ((_timeo202296_
                       (std/net/socket/base#abs-timeout _timeo202280_)))
                  (let _lp202298_ ()
                    (let ((_wait-in202301_
                           (##direct-structure-ref
                            _ssock202278_
                            '2
                            std/net/socket/base#!socket::t
                            '#f)))
                      (if _wait-in202301_
                          (let ((_cli202303_
                                 (std/os/socket#socket-accept__%
                                  _sock202294_
                                  _sa202279_)))
                            (if _cli202303_
                                (std/net/socket/api#make-ssocket _cli202303_)
                                (if (_wait-in202301_
                                     _ssock202278_
                                     _timeo202296_)
                                    (_lp202298_)
                                    (std/error#raise-timeout
                                     'ssocket-accept
                                     '"accept timeout"
                                     _ssock202278_))))
                          (std/error#raise-io-error
                           'ssocket-accept
                           '"Socket is not open for input"
                           _ssock202278_))))))))
        (if (##structure-direct-instance-of?
             _ssock202281202287_
             'std/net/socket/base#!socket::t)
            (let* ((_e202285202308_ (##vector-ref _ssock202281202287_ '1))
                   (_sock202311_ _e202285202308_))
              (_K202284202305_ _sock202311_))
            (_E202283202291_)))))
  (define std/net/socket/api#ssocket-accept__0
    (lambda (_ssock202316_)
      (let* ((_sa202318_ '#f) (_timeo202320_ '#f))
        (std/net/socket/api#ssocket-accept__%
         _ssock202316_
         _sa202318_
         _timeo202320_))))
  (define std/net/socket/api#ssocket-accept__1
    (lambda (_ssock202322_ _sa202323_)
      (let ((_timeo202325_ '#f))
        (std/net/socket/api#ssocket-accept__%
         _ssock202322_
         _sa202323_
         _timeo202325_))))
  (define std/net/socket/api#ssocket-accept
    (lambda _g309441_
      (let ((_g309440_ (##length _g309441_)))
        (cond ((##fx= _g309440_ 1)
               (apply std/net/socket/api#ssocket-accept__0 _g309441_))
              ((##fx= _g309440_ 2)
               (apply std/net/socket/api#ssocket-accept__1 _g309441_))
              ((##fx= _g309440_ 3)
               (apply std/net/socket/api#ssocket-accept__% _g309441_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/api#ssocket-accept
                _g309441_))))))
  (define std/net/socket/api#ssocket-send__%
    (lambda (_ssock202204_ _buf202205_ _start202206_ _end202207_ _timeo202208_)
      (let* ((_ssock202209202215_ _ssock202204_)
             (_E202211202219_
              (lambda () (error '"No clause matching" _ssock202209202215_)))
             (_K202212202236_
              (lambda (_sock202222_)
                (let ((_timeo202224_
                       (std/net/socket/base#abs-timeout _timeo202208_)))
                  (let _lp202226_ ()
                    (let ((_wait-out202229_
                           (##direct-structure-ref
                            _ssock202204_
                            '3
                            std/net/socket/base#!socket::t
                            '#f)))
                      (if _wait-out202229_
                          (let* ((_r202231_
                                  (std/os/socket#socket-send__2
                                   _sock202222_
                                   _buf202205_
                                   _start202206_
                                   _end202207_))
                                 (_$e202233_ _r202231_))
                            (if _$e202233_
                                _$e202233_
                                (if (_wait-out202229_
                                     _ssock202204_
                                     _timeo202224_)
                                    (_lp202226_)
                                    (std/error#raise-timeout
                                     'ssocket-send
                                     '"send timeout"
                                     _ssock202204_))))
                          (std/error#raise-io-error
                           'ssocket-send
                           '"Socket is not open for output"
                           _ssock202204_))))))))
        (if (##structure-direct-instance-of?
             _ssock202209202215_
             'std/net/socket/base#!socket::t)
            (let* ((_e202213202239_ (##vector-ref _ssock202209202215_ '1))
                   (_sock202242_ _e202213202239_))
              (_K202212202236_ _sock202242_))
            (_E202211202219_)))))
  (define std/net/socket/api#ssocket-send__0
    (lambda (_ssock202247_ _buf202248_)
      (let* ((_start202250_ '0)
             (_end202252_ (u8vector-length _buf202248_))
             (_timeo202254_ '#f))
        (std/net/socket/api#ssocket-send__%
         _ssock202247_
         _buf202248_
         _start202250_
         _end202252_
         _timeo202254_))))
  (define std/net/socket/api#ssocket-send__1
    (lambda (_ssock202256_ _buf202257_ _start202258_)
      (let* ((_end202260_ (u8vector-length _buf202257_)) (_timeo202262_ '#f))
        (std/net/socket/api#ssocket-send__%
         _ssock202256_
         _buf202257_
         _start202258_
         _end202260_
         _timeo202262_))))
  (define std/net/socket/api#ssocket-send__2
    (lambda (_ssock202264_ _buf202265_ _start202266_ _end202267_)
      (let ((_timeo202269_ '#f))
        (std/net/socket/api#ssocket-send__%
         _ssock202264_
         _buf202265_
         _start202266_
         _end202267_
         _timeo202269_))))
  (define std/net/socket/api#ssocket-send
    (lambda _g309443_
      (let ((_g309442_ (##length _g309443_)))
        (cond ((##fx= _g309442_ 2)
               (apply std/net/socket/api#ssocket-send__0 _g309443_))
              ((##fx= _g309442_ 3)
               (apply std/net/socket/api#ssocket-send__1 _g309443_))
              ((##fx= _g309442_ 4)
               (apply std/net/socket/api#ssocket-send__2 _g309443_))
              ((##fx= _g309442_ 5)
               (apply std/net/socket/api#ssocket-send__% _g309443_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/api#ssocket-send
                _g309443_))))))
  (define std/net/socket/api#ssocket-send-all__%
    (lambda (_ssock202131_ _buf202132_ _start202133_ _end202134_ _timeo202135_)
      (let* ((_ssock202136202142_ _ssock202131_)
             (_E202138202146_
              (lambda () (error '"No clause matching" _ssock202136202142_)))
             (_K202139202162_
              (lambda (_sock202149_)
                (let ((_timeo202151_
                       (std/net/socket/base#abs-timeout _timeo202135_)))
                  (let _lp202153_ ((_count202155_ '0)
                                   (_start202156_ _start202133_))
                    (let ((_wait-out202158_
                           (##direct-structure-ref
                            _ssock202131_
                            '3
                            std/net/socket/base#!socket::t
                            '#f)))
                      (if _wait-out202158_
                          (if (##fx< _start202156_ _end202134_)
                              (let ((_r202160_
                                     (std/os/socket#socket-send__2
                                      _sock202149_
                                      _buf202132_
                                      _start202156_
                                      _end202134_)))
                                (if _r202160_
                                    (_lp202153_
                                     (##fx+ _count202155_ _r202160_)
                                     (##fx+ _start202156_ _r202160_))
                                    (if (_wait-out202158_
                                         _ssock202131_
                                         _timeo202151_)
                                        (_lp202153_
                                         _count202155_
                                         _start202156_)
                                        (std/error#raise-timeout
                                         'ssocket-send-all
                                         '"send timeout"
                                         _ssock202131_))))
                              _count202155_)
                          (std/error#raise-io-error
                           'ssocket-send-all
                           '"Socket is not open for output"
                           _ssock202131_))))))))
        (if (##structure-direct-instance-of?
             _ssock202136202142_
             'std/net/socket/base#!socket::t)
            (let* ((_e202140202165_ (##vector-ref _ssock202136202142_ '1))
                   (_sock202168_ _e202140202165_))
              (_K202139202162_ _sock202168_))
            (_E202138202146_)))))
  (define std/net/socket/api#ssocket-send-all__0
    (lambda (_ssock202173_ _buf202174_)
      (let* ((_start202176_ '0)
             (_end202178_ (u8vector-length _buf202174_))
             (_timeo202180_ '#f))
        (std/net/socket/api#ssocket-send-all__%
         _ssock202173_
         _buf202174_
         _start202176_
         _end202178_
         _timeo202180_))))
  (define std/net/socket/api#ssocket-send-all__1
    (lambda (_ssock202182_ _buf202183_ _start202184_)
      (let* ((_end202186_ (u8vector-length _buf202183_)) (_timeo202188_ '#f))
        (std/net/socket/api#ssocket-send-all__%
         _ssock202182_
         _buf202183_
         _start202184_
         _end202186_
         _timeo202188_))))
  (define std/net/socket/api#ssocket-send-all__2
    (lambda (_ssock202190_ _buf202191_ _start202192_ _end202193_)
      (let ((_timeo202195_ '#f))
        (std/net/socket/api#ssocket-send-all__%
         _ssock202190_
         _buf202191_
         _start202192_
         _end202193_
         _timeo202195_))))
  (define std/net/socket/api#ssocket-send-all
    (lambda _g309445_
      (let ((_g309444_ (##length _g309445_)))
        (cond ((##fx= _g309444_ 2)
               (apply std/net/socket/api#ssocket-send-all__0 _g309445_))
              ((##fx= _g309444_ 3)
               (apply std/net/socket/api#ssocket-send-all__1 _g309445_))
              ((##fx= _g309444_ 4)
               (apply std/net/socket/api#ssocket-send-all__2 _g309445_))
              ((##fx= _g309444_ 5)
               (apply std/net/socket/api#ssocket-send-all__% _g309445_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/api#ssocket-send-all
                _g309445_))))))
  (define std/net/socket/api#ssocket-recv__%
    (lambda (_ssock202057_ _buf202058_ _start202059_ _end202060_ _timeo202061_)
      (let* ((_ssock202062202068_ _ssock202057_)
             (_E202064202072_
              (lambda () (error '"No clause matching" _ssock202062202068_)))
             (_K202065202089_
              (lambda (_sock202075_)
                (let ((_timeo202077_
                       (std/net/socket/base#abs-timeout _timeo202061_)))
                  (let _lp202079_ ()
                    (let ((_wait-in202082_
                           (##direct-structure-ref
                            _ssock202057_
                            '2
                            std/net/socket/base#!socket::t
                            '#f)))
                      (if _wait-in202082_
                          (let* ((_r202084_
                                  (std/os/socket#socket-recv__2
                                   _sock202075_
                                   _buf202058_
                                   _start202059_
                                   _end202060_))
                                 (_$e202086_ _r202084_))
                            (if _$e202086_
                                _$e202086_
                                (if (_wait-in202082_
                                     _ssock202057_
                                     _timeo202077_)
                                    (_lp202079_)
                                    (std/error#raise-timeout
                                     'ssocket-recv
                                     '"receive timeout"
                                     _ssock202057_))))
                          (std/error#raise-io-error
                           'ssocket-recv
                           '"Socket is not open for input"
                           _ssock202057_))))))))
        (if (##structure-direct-instance-of?
             _ssock202062202068_
             'std/net/socket/base#!socket::t)
            (let* ((_e202066202092_ (##vector-ref _ssock202062202068_ '1))
                   (_sock202095_ _e202066202092_))
              (_K202065202089_ _sock202095_))
            (_E202064202072_)))))
  (define std/net/socket/api#ssocket-recv__0
    (lambda (_ssock202100_ _buf202101_)
      (let* ((_start202103_ '0)
             (_end202105_ (u8vector-length _buf202101_))
             (_timeo202107_ '#f))
        (std/net/socket/api#ssocket-recv__%
         _ssock202100_
         _buf202101_
         _start202103_
         _end202105_
         _timeo202107_))))
  (define std/net/socket/api#ssocket-recv__1
    (lambda (_ssock202109_ _buf202110_ _start202111_)
      (let* ((_end202113_ (u8vector-length _buf202110_)) (_timeo202115_ '#f))
        (std/net/socket/api#ssocket-recv__%
         _ssock202109_
         _buf202110_
         _start202111_
         _end202113_
         _timeo202115_))))
  (define std/net/socket/api#ssocket-recv__2
    (lambda (_ssock202117_ _buf202118_ _start202119_ _end202120_)
      (let ((_timeo202122_ '#f))
        (std/net/socket/api#ssocket-recv__%
         _ssock202117_
         _buf202118_
         _start202119_
         _end202120_
         _timeo202122_))))
  (define std/net/socket/api#ssocket-recv
    (lambda _g309447_
      (let ((_g309446_ (##length _g309447_)))
        (cond ((##fx= _g309446_ 2)
               (apply std/net/socket/api#ssocket-recv__0 _g309447_))
              ((##fx= _g309446_ 3)
               (apply std/net/socket/api#ssocket-recv__1 _g309447_))
              ((##fx= _g309446_ 4)
               (apply std/net/socket/api#ssocket-recv__2 _g309447_))
              ((##fx= _g309446_ 5)
               (apply std/net/socket/api#ssocket-recv__% _g309447_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/api#ssocket-recv
                _g309447_))))))
  (define std/net/socket/api#ssocket-recv-all__%
    (lambda (_ssock201984_ _buf201985_ _start201986_ _end201987_ _timeo201988_)
      (let* ((_ssock201989201995_ _ssock201984_)
             (_E201991201999_
              (lambda () (error '"No clause matching" _ssock201989201995_)))
             (_K201992202015_
              (lambda (_sock202002_)
                (let ((_timeo202004_
                       (std/net/socket/base#abs-timeout _timeo201988_)))
                  (let _lp202006_ ((_count202008_ '0)
                                   (_start202009_ _start201986_))
                    (let ((_wait-in202011_
                           (##direct-structure-ref
                            _ssock201984_
                            '2
                            std/net/socket/base#!socket::t
                            '#f)))
                      (if _wait-in202011_
                          (if (##fx>= _start202009_ _end201987_)
                              _count202008_
                              (let ((_r202013_
                                     (std/os/socket#socket-recv__2
                                      _sock202002_
                                      _buf201985_
                                      _start202009_
                                      _end201987_)))
                                (if (not _r202013_)
                                    (if (_wait-in202011_
                                         _ssock201984_
                                         _timeo202004_)
                                        (_lp202006_
                                         _count202008_
                                         _start202009_)
                                        (std/error#raise-timeout
                                         'ssocket-recv-all
                                         '"receive timeout"
                                         _ssock201984_))
                                    (if (##fxzero? _r202013_)
                                        _count202008_
                                        (_lp202006_
                                         (##fx+ _count202008_ _r202013_)
                                         (##fx+ _start202009_ _r202013_))))))
                          (std/error#raise-io-error
                           'ssocket-recv-all
                           '"Socket is not open for input"
                           _ssock201984_))))))))
        (if (##structure-direct-instance-of?
             _ssock201989201995_
             'std/net/socket/base#!socket::t)
            (let* ((_e201993202018_ (##vector-ref _ssock201989201995_ '1))
                   (_sock202021_ _e201993202018_))
              (_K201992202015_ _sock202021_))
            (_E201991201999_)))))
  (define std/net/socket/api#ssocket-recv-all__0
    (lambda (_ssock202026_ _buf202027_)
      (let* ((_start202029_ '0)
             (_end202031_ (u8vector-length _buf202027_))
             (_timeo202033_ '#f))
        (std/net/socket/api#ssocket-recv-all__%
         _ssock202026_
         _buf202027_
         _start202029_
         _end202031_
         _timeo202033_))))
  (define std/net/socket/api#ssocket-recv-all__1
    (lambda (_ssock202035_ _buf202036_ _start202037_)
      (let* ((_end202039_ (u8vector-length _buf202036_)) (_timeo202041_ '#f))
        (std/net/socket/api#ssocket-recv-all__%
         _ssock202035_
         _buf202036_
         _start202037_
         _end202039_
         _timeo202041_))))
  (define std/net/socket/api#ssocket-recv-all__2
    (lambda (_ssock202043_ _buf202044_ _start202045_ _end202046_)
      (let ((_timeo202048_ '#f))
        (std/net/socket/api#ssocket-recv-all__%
         _ssock202043_
         _buf202044_
         _start202045_
         _end202046_
         _timeo202048_))))
  (define std/net/socket/api#ssocket-recv-all
    (lambda _g309449_
      (let ((_g309448_ (##length _g309449_)))
        (cond ((##fx= _g309448_ 2)
               (apply std/net/socket/api#ssocket-recv-all__0 _g309449_))
              ((##fx= _g309448_ 3)
               (apply std/net/socket/api#ssocket-recv-all__1 _g309449_))
              ((##fx= _g309448_ 4)
               (apply std/net/socket/api#ssocket-recv-all__2 _g309449_))
              ((##fx= _g309448_ 5)
               (apply std/net/socket/api#ssocket-recv-all__% _g309449_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/api#ssocket-recv-all
                _g309449_))))))
  (define std/net/socket/api#ssocket-socket
    (lambda (_ssock201981_)
      (##direct-structure-ref
       _ssock201981_
       '1
       std/net/socket/base#!socket::t
       '#f)))
  (define std/net/socket/api#ssocket-close
    (lambda (_ssock201979_)
      ((##direct-structure-ref
        _ssock201979_
        '4
        std/net/socket/base#!socket::t
        '#f)
       _ssock201979_
       'inout
       '#f)))
  (define std/net/socket/api#ssocket-close-input__%
    (lambda (_ssock201966_ _shutdown201967_)
      ((##direct-structure-ref
        _ssock201966_
        '4
        std/net/socket/base#!socket::t
        '#f)
       _ssock201966_
       'in
       (if _shutdown201967_ std/os/_socket#SHUT_RD '#f))))
  (define std/net/socket/api#ssocket-close-input__0
    (lambda (_ssock201972_)
      (let ((_shutdown201974_ '#f))
        (std/net/socket/api#ssocket-close-input__%
         _ssock201972_
         _shutdown201974_))))
  (define std/net/socket/api#ssocket-close-input
    (lambda _g309451_
      (let ((_g309450_ (##length _g309451_)))
        (cond ((##fx= _g309450_ 1)
               (apply std/net/socket/api#ssocket-close-input__0 _g309451_))
              ((##fx= _g309450_ 2)
               (apply std/net/socket/api#ssocket-close-input__% _g309451_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/api#ssocket-close-input
                _g309451_))))))
  (define std/net/socket/api#ssocket-close-output__%
    (lambda (_ssock201952_ _shutdown201953_)
      ((##direct-structure-ref
        _ssock201952_
        '4
        std/net/socket/base#!socket::t
        '#f)
       _ssock201952_
       'out
       (if _shutdown201953_ std/os/_socket#SHUT_WR '#f))))
  (define std/net/socket/api#ssocket-close-output__0
    (lambda (_ssock201958_)
      (let ((_shutdown201960_ '#f))
        (std/net/socket/api#ssocket-close-output__%
         _ssock201958_
         _shutdown201960_))))
  (define std/net/socket/api#ssocket-close-output
    (lambda _g309453_
      (let ((_g309452_ (##length _g309453_)))
        (cond ((##fx= _g309452_ 1)
               (apply std/net/socket/api#ssocket-close-output__0 _g309453_))
              ((##fx= _g309452_ 2)
               (apply std/net/socket/api#ssocket-close-output__% _g309453_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/api#ssocket-close-output
                _g309453_))))))
  (define std/net/socket/api#!socket::destroy std/net/socket/api#ssocket-close)
  (bind-method!
   std/net/socket/base#!socket::t
   'destroy
   std/net/socket/api#!socket::destroy
   '#f)
  (define std/net/socket/api#default-listen-sockopts
    (cons std/os/_socket#SO_REUSEADDR '()))
  (define std/net/socket/api#make-ssocket
    (lambda (_sock201817_)
      (let ((_$e201819_ (std/net/socket/base#current-socket-server)))
        (if _$e201819_
            ((lambda (_srv201822_)
               (let ((_token201824_ (##structure std/actor/proto#!token::t))
                     (_dest201826_ _srv201822_))
                 (std/actor/message#send-message__%
                  _dest201826_
                  (##structure
                   std/actor/proto#!call::t
                   (##structure
                    std/net/socket/base#socket-server.add::t
                    _sock201817_)
                   _token201824_)
                  '#f
                  '#t)
                 (std/actor/proto#!!call-recv _token201824_ _dest201826_)))
             _$e201819_)
            (std/net/socket/basic-socket#basic-socket _sock201817_))))))
