(declare (block) (standard-bindings) (extended-bindings))
(define std/net/socket/epoll-server#epoll-socket-server
  (lambda ()
    (letrec* ((_fdtab203042_ (make-table 'test: eq?))
              (_epoll203043_ (std/os/epoll#epoll-create))
              (_maxevts203044_ '8192)
              (_evts203045_ (std/os/epoll#make-epoll-events _maxevts203044_))
              (_poll-in203046_
               (let ()
                 (declare (not safe))
                 (##fxior std/os/epoll#EPOLLIN
                          std/os/epoll#EPOLLHUP
                          std/os/epoll#EPOLLERR)))
              (_poll-out203047_
               (let ()
                 (declare (not safe))
                 (##fxior std/os/epoll#EPOLLOUT
                          std/os/epoll#EPOLLHUP
                          std/os/epoll#EPOLLERR)))
              (_do-epoll203048_
               (lambda ()
                 (let ((_count203274_
                        (std/os/epoll#epoll-wait
                         _epoll203043_
                         _evts203045_
                         _maxevts203044_)))
                   (if (let ()
                         (declare (not safe))
                         (##fxpositive? _count203274_))
                       (let _lp203276_ ((_k203278_ '0))
                         (if (let ()
                               (declare (not safe))
                               (##fx< _k203278_ _count203274_))
                             (let ((_fd203280_
                                    (std/os/epoll#epoll_evt_fd
                                     _evts203045_
                                     _k203278_))
                                   (_ready203281_
                                    (std/os/epoll#epoll_evt_events
                                     _evts203045_
                                     _k203278_)))
                               (let* ((_g203282203290_
                                       (table-ref _fdtab203042_ _fd203280_))
                                      (_E203284203294_
                                       (lambda ()
                                         (error '"No clause matching"
                                                _g203282203290_)))
                                      (_K203285203300_
                                       (lambda (_io-out203297_ _io-in203298_)
                                         (if (let ((__tmp309523
                                                    (let ()
                                                      (declare (not safe))
                                                      (##fxand _ready203281_
                                                               _poll-in203046_))))
                                               (declare (not safe))
                                               (##fxzero? __tmp309523))
                                             '#!void
                                             (if _io-in203298_
                                                 (std/net/socket/basic-server#io-state-signal-ready!
                                                  _io-in203298_
                                                  'ready)
                                                 '#!void))
                                         (if (let ((__tmp309524
                                                    (let ()
                                                      (declare (not safe))
                                                      (##fxand _ready203281_
                                                               _poll-out203047_))))
                                               (declare (not safe))
                                               (##fxzero? __tmp309524))
                                             '#!void
                                             (if _io-out203297_
                                                 (std/net/socket/basic-server#io-state-signal-ready!
                                                  _io-out203297_
                                                  'ready)
                                                 '#!void))
                                         (_lp203276_
                                          (let ()
                                            (declare (not safe))
                                            (##fx+ _k203278_ '1))))))
                                 (if (let ()
                                       (declare (not safe))
                                       (##structure-direct-instance-of?
                                        _g203282203290_
                                        'std/net/socket/base#!socket-state::t))
                                     (let* ((_e203286203303_
                                             (let ()
                                               (declare (not safe))
                                               (##vector-ref
                                                _g203282203290_
                                                '1)))
                                            (_e203287203306_
                                             (let ()
                                               (declare (not safe))
                                               (##vector-ref
                                                _g203282203290_
                                                '2)))
                                            (_io-in203309_ _e203287203306_)
                                            (_e203288203311_
                                             (let ()
                                               (declare (not safe))
                                               (##vector-ref
                                                _g203282203290_
                                                '3)))
                                            (_io-out203314_ _e203288203311_))
                                       (_K203285203300_
                                        _io-out203314_
                                        _io-in203309_))
                                     (_E203284203294_))))
                             '#!void))
                       '#!void))))
              (_add-socket203049_
               (lambda (_sock203232_)
                 (let* ((_self203234_ (current-thread))
                        (_fd203236_ (std/os/fd#fd-e _sock203232_))
                        (_io-in203238_
                         (if (std/os/fd#fd-io-in _sock203232_)
                             (let ((__obj309521
                                    (make-object
                                     std/net/socket/base#!io-state::t
                                     '3)))
                               (std/net/socket/basic-server#!io-state:::init!
                                __obj309521)
                               __obj309521)
                             '#f))
                        (_wait-in203243_
                         (if _io-in203238_
                             (lambda (_ssock203240_ _timeo203241_)
                               (std/net/socket/basic-server#io-state-wait-io!
                                _io-in203238_
                                _timeo203241_
                                'input))
                             '#f))
                        (_io-out203245_
                         (if (std/os/fd#fd-io-out _sock203232_)
                             (let ((__obj309522
                                    (make-object
                                     std/net/socket/base#!io-state::t
                                     '3)))
                               (std/net/socket/basic-server#!io-state:::init!
                                __obj309522)
                               __obj309522)
                             '#f))
                        (_wait-out203250_
                         (if _io-out203245_
                             (lambda (_ssock203247_ _timeo203248_)
                               (std/net/socket/basic-server#io-state-wait-io!
                                _io-out203245_
                                _timeo203248_
                                'output))
                             '#f))
                        (_close203256_
                         (lambda (_ssock203252_ _dir203253_ _shutdown203254_)
                           (std/actor/message#send-message__0
                            _self203234_
                            (let ((__tmp309525
                                   (let ()
                                     (declare (not safe))
                                     (##structure
                                      std/net/socket/base#socket-server.close::t
                                      _ssock203252_
                                      _dir203253_
                                      _shutdown203254_))))
                              (declare (not safe))
                              (##structure
                               std/actor/proto#!event::t
                               __tmp309525)))))
                        (_ssock203258_
                         (let ()
                           (declare (not safe))
                           (##structure
                            std/net/socket/base#!socket::t
                            _sock203232_
                            _wait-in203243_
                            _wait-out203250_
                            _close203256_)))
                        (_state203260_
                         (let ()
                           (declare (not safe))
                           (##structure
                            std/net/socket/base#!socket-state::t
                            _sock203232_
                            _io-in203238_
                            _io-out203245_)))
                        (_events203262_ std/os/epoll#EPOLLET)
                        (_events203264_
                         (if _io-in203238_
                             (let ()
                               (declare (not safe))
                               (##fxior std/os/epoll#EPOLLIN _events203262_))
                             _events203262_))
                        (_events203266_
                         (if _io-out203245_
                             (let ()
                               (declare (not safe))
                               (##fxior std/os/epoll#EPOLLOUT _events203264_))
                             _events203264_)))
                   (make-will
                    _ssock203258_
                    (lambda (_g203268203270_)
                      (_close203256_ _g203268203270_ 'inout '#f)))
                   (std/os/epoll#epoll-ctl-add
                    _epoll203043_
                    _sock203232_
                    _events203266_)
                   (table-set! _fdtab203042_ _fd203236_ _state203260_)
                   _ssock203258_)))
              (_close-socket203050_
               (lambda (_ssock203137_ _dir203138_ _shutdown203139_)
                 (letrec ((_close-io-in!203141_
                           (lambda (_io-in203229_ _sock203230_)
                             (std/net/socket/basic-server#io-state-close-in!
                              _io-in203229_
                              _sock203230_
                              _shutdown203139_)))
                          (_close-io-out!203142_
                           (lambda (_io-out203226_ _sock203227_)
                             (std/net/socket/basic-server#io-state-close-out!
                              _io-out203226_
                              _sock203227_
                              _shutdown203139_))))
                   (let* ((_ssock203143203151_ _ssock203137_)
                          (_E203145203155_
                           (lambda ()
                             (error '"No clause matching"
                                    _ssock203143203151_)))
                          (_K203146203208_
                           (lambda (_wait-out203158_
                                    _wait-in203159_
                                    _sock203160_)
                             (if (or _wait-in203159_ _wait-out203158_)
                                 (let* ((_state203165_
                                         (table-ref
                                          _fdtab203042_
                                          (std/os/fd#fd-e _sock203160_)
                                          '#f))
                                        (_state203166203175_ _state203165_)
                                        (_else203168203183_
                                         (lambda () '#!void))
                                        (_K203170203192_
                                         (lambda (_io-out203186_ _io-in203187_)
                                           (let ((_$e203189_ _dir203138_))
                                             (if (eq? 'in _$e203189_)
                                                 (begin
                                                   (if _io-out203186_
                                                       (std/os/epoll#epoll-ctl-mod
                                                        _epoll203043_
                                                        _sock203160_
                                                        (let ()
                                                          (declare (not safe))
                                                          (##fxior std/os/epoll#EPOLLET
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           std/os/epoll#EPOLLOUT)))
               (begin
                 (std/os/epoll#epoll-ctl-del _epoll203043_ _sock203160_)
                 (table-set! _fdtab203042_ (std/os/fd#fd-e _sock203160_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (##direct-structure-set!
                                                    _ssock203137_
                                                    '#f
                                                    '2
                                                    std/net/socket/base#!socket::t
                                                    '#f)
                                                   (##direct-structure-set!
                                                    _state203165_
                                                    '#f
                                                    '2
                                                    std/net/socket/base#!socket-state::t
                                                    '#f)
                                                   (_close-io-in!203141_
                                                    _io-in203187_
                                                    _sock203160_)
                                                   (if _io-out203186_
                                                       '#!void
                                                       (close-port
                                                        _sock203160_)))
                                                 (if (eq? 'out _$e203189_)
                                                     (begin
                                                       (if _io-in203187_
                                                           (std/os/epoll#epoll-ctl-mod
                                                            _epoll203043_
                                                            _sock203160_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##fxior std/os/epoll#EPOLLET
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                               std/os/epoll#EPOLLIN)))
                   (begin
                     (std/os/epoll#epoll-ctl-del _epoll203043_ _sock203160_)
                     (table-set! _fdtab203042_ (std/os/fd#fd-e _sock203160_))))
               (##direct-structure-set!
                _ssock203137_
                '#f
                '3
                std/net/socket/base#!socket::t
                '#f)
               (##direct-structure-set!
                _state203165_
                '#f
                '3
                std/net/socket/base#!socket-state::t
                '#f)
               (_close-io-out!203142_ _io-out203186_ _sock203160_)
               (if _io-in203187_ '#!void (close-port _sock203160_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (if (eq? 'inout
                                                              _$e203189_)
                                                         (begin
                                                           (std/os/epoll#epoll-ctl-del
                                                            _epoll203043_
                                                            _sock203160_)
                                                           (table-set!
                                                            _fdtab203042_
                                                            (std/os/fd#fd-e
                                                             _sock203160_))
                                                           (if _io-in203187_
                                                               (begin
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (##direct-structure-set!
                          _ssock203137_
                          '#f
                          '2
                          std/net/socket/base#!socket::t
                          '#f)
                         (##direct-structure-set!
                          _state203165_
                          '#f
                          '2
                          std/net/socket/base#!socket-state::t
                          '#f)
                         (_close-io-in!203141_ _io-in203187_ _sock203160_))
                       '#!void)
                   (if _io-out203186_
                       (begin
                         (##direct-structure-set!
                          _ssock203137_
                          '#f
                          '3
                          std/net/socket/base#!socket::t
                          '#f)
                         (##direct-structure-set!
                          _state203165_
                          '#f
                          '3
                          std/net/socket/base#!socket-state::t
                          '#f)
                         (_close-io-out!203142_ _io-out203186_ _sock203160_))
                       '#!void)
                   (close-port _sock203160_))
                 (error '"Bad direction" _dir203138_))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                   (if (let ()
                                         (declare (not safe))
                                         (##structure-direct-instance-of?
                                          _state203166203175_
                                          'std/net/socket/base#!socket-state::t))
                                       (let* ((_e203171203195_
                                               (let ()
                                                 (declare (not safe))
                                                 (##vector-ref
                                                  _state203166203175_
                                                  '1)))
                                              (_e203172203198_
                                               (let ()
                                                 (declare (not safe))
                                                 (##vector-ref
                                                  _state203166203175_
                                                  '2)))
                                              (_io-in203201_ _e203172203198_)
                                              (_e203173203203_
                                               (let ()
                                                 (declare (not safe))
                                                 (##vector-ref
                                                  _state203166203175_
                                                  '3)))
                                              (_io-out203206_ _e203173203203_))
                                         (_K203170203192_
                                          _io-out203206_
                                          _io-in203201_))
                                       '#!void))
                                 '#!void))))
                     (if (let ()
                           (declare (not safe))
                           (##structure-direct-instance-of?
                            _ssock203143203151_
                            'std/net/socket/base#!socket::t))
                         (let* ((_e203147203211_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _ssock203143203151_ '1)))
                                (_sock203214_ _e203147203211_)
                                (_e203148203216_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _ssock203143203151_ '2)))
                                (_wait-in203219_ _e203148203216_)
                                (_e203149203221_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _ssock203143203151_ '3)))
                                (_wait-out203224_ _e203149203221_))
                           (_K203146203208_
                            _wait-out203224_
                            _wait-in203219_
                            _sock203214_))
                         (_E203145203155_))))))
              (_shutdown!203051_
               (lambda ()
                 (close-port _epoll203043_)
                 (let ((_iterable203111_
                        (std/iter#in-hash-values _fdtab203042_))
                       (_iter-do203113_
                        (lambda (_val203054_)
                          (let* ((_val203056203061_ _val203054_)
                                 (_E203058203065_
                                  (lambda ()
                                    (error '"No clause matching"
                                           _val203056203061_)))
                                 (_K203059203106_
                                  (lambda (_state203068_)
                                    (let* ((_state203069203077_ _state203068_)
                                           (_E203071203081_
                                            (lambda ()
                                              (error '"No clause matching"
                                                     _state203069203077_)))
                                           (_K203072203088_
                                            (lambda (_io-out203084_
                                                     _io-in203085_
                                                     _sock203086_)
                                              (if _io-in203085_
                                                  (std/net/socket/basic-server#io-state-close-in!
                                                   _io-in203085_
                                                   _sock203086_
                                                   '#f)
                                                  '#!void)
                                              (if _io-out203084_
                                                  (std/net/socket/basic-server#io-state-close-out!
                                                   _io-out203084_
                                                   _sock203086_
                                                   '#f)
                                                  '#!void)
                                              (close-port _sock203086_))))
                                      (if (let ()
                                            (declare (not safe))
                                            (##structure-direct-instance-of?
                                             _state203069203077_
                                             'std/net/socket/base#!socket-state::t))
                                          (let* ((_e203073203091_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##vector-ref
                                                     _state203069203077_
                                                     '1)))
                                                 (_sock203094_ _e203073203091_)
                                                 (_e203074203096_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##vector-ref
                                                     _state203069203077_
                                                     '2)))
                                                 (_io-in203099_
                                                  _e203074203096_)
                                                 (_e203075203101_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##vector-ref
                                                     _state203069203077_
                                                     '3)))
                                                 (_io-out203104_
                                                  _e203075203101_))
                                            (_K203072203088_
                                             _io-out203104_
                                             _io-in203099_
                                             _sock203094_))
                                          (_E203071203081_)))))
                                 (_state203109_ _val203056203061_))
                            (_K203059203106_ _state203109_)))))
                   (if (pair? _iterable203111_)
                       (for-each _iter-do203113_ _iterable203111_)
                       (if (null? _iterable203111_)
                           '#!void
                           (let* ((_it203116_ (std/iter#iter _iterable203111_))
                                  (_next!203119_
                                   (let ()
                                     (declare (not safe))
                                     (##unchecked-structure-ref
                                      _it203116_
                                      '2
                                      std/iter#iterator::t
                                      '#f))))
                             (declare (not safe))
                             (begin
                               (let _lp203124_ ()
                                 (let ((_val203128_
                                        (_next!203119_ _it203116_)))
                                   (if (eq? std/iter#iter-end _val203128_)
                                       '#!void
                                       (begin
                                         (_iter-do203113_ _val203128_)
                                         (_lp203124_)))))
                               (let ((_$e203130_
                                      (##unchecked-structure-ref
                                       _it203116_
                                       '3
                                       std/iter#iterator::t
                                       '#f)))
                                 (if _$e203130_
                                     ((lambda (_g203132203134_)
                                        (_g203132203134_ _it203116_))
                                      _$e203130_)
                                     '#!void))
                               '#!void)))))
                 (set! _fdtab203042_ '#f)
                 (set! _epoll203043_ '#f))))
      (std/net/socket/basic-server#server-loop
       (std/os/fd#fd-io-in _epoll203043_)
       _do-epoll203048_
       _add-socket203049_
       _close-socket203050_
       _shutdown!203051_))))
