(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/socket/server#start-socket-server!__%
    (lambda (_impl203340_)
      (let ((_$e203342_ (std/net/socket/base#current-socket-server)))
        (if _$e203342_
            (values _$e203342_)
            (begin
              (std/logger#start-logger!__0)
              (let ((_srv203345_
                     (gerbil/gambit/threads#spawn/group
                      'socket-server
                      _impl203340_)))
                (std/net/socket/base#current-socket-server _srv203345_)
                _srv203345_))))))
  (define std/net/socket/server#start-socket-server!__0
    (lambda ()
      (let ((_impl203351_ (std/net/socket/server#default-server-impl)))
        (std/net/socket/server#start-socket-server!__% _impl203351_))))
  (define std/net/socket/server#start-socket-server!
    (lambda _g309527_
      (let ((_g309526_ (let () (declare (not safe)) (##length _g309527_))))
        (cond ((let () (declare (not safe)) (##fx= _g309526_ 0))
               (apply std/net/socket/server#start-socket-server!__0 _g309527_))
              ((let () (declare (not safe)) (##fx= _g309526_ 1))
               (apply std/net/socket/server#start-socket-server!__% _g309527_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/server#start-socket-server!
                _g309527_))))))
  (define std/net/socket/server#stop-socket-server!__%
    (lambda (_srv203329_)
      (std/net/socket/server#server-shutdown! _srv203329_)))
  (define std/net/socket/server#stop-socket-server!__0
    (lambda ()
      (let ((_srv203335_ (std/net/socket/base#current-socket-server)))
        (std/net/socket/server#server-shutdown! _srv203335_))))
  (define std/net/socket/server#stop-socket-server!
    (lambda _g309529_
      (let ((_g309528_ (let () (declare (not safe)) (##length _g309529_))))
        (cond ((let () (declare (not safe)) (##fx= _g309528_ 0))
               (apply std/net/socket/server#stop-socket-server!__0 _g309529_))
              ((let () (declare (not safe)) (##fx= _g309528_ 1))
               (apply std/net/socket/server#server-shutdown! _g309529_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/server#stop-socket-server!
                _g309529_))))))
  (define std/net/socket/server#server-shutdown!
    (lambda (_srv203317_)
      (let ((_tgroup203319_ (thread-thread-group _srv203317_)))
        (with-unwind-protect
         (lambda ()
           (let ((_token203322_
                  (let ()
                    (declare (not safe))
                    (##structure std/actor/proto#!token::t)))
                 (_dest203324_ _srv203317_))
             (std/actor/message#send-message__%
              _dest203324_
              (let ((__tmp309530
                     (let ()
                       (declare (not safe))
                       (##structure
                        std/net/socket/base#socket-server.shutdown!::t))))
                (declare (not safe))
                (##structure
                 std/actor/proto#!call::t
                 __tmp309530
                 _token203322_))
              '#f
              '#t)
             (std/actor/proto#!!call-recv _token203322_ _dest203324_))
           (thread-join! _srv203317_))
         (lambda () (std/misc/threads#thread-group-kill! _tgroup203319_))))))
  (define std/net/socket/server#default-server-impl
    (lambda () std/net/socket/epoll-server#epoll-socket-server)))
