(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/os/fdio#fdread__%
    (lambda (_raw179264_ _bytes179265_ _start179266_ _end179267_)
      (let ((_fd179269_
             (if (std/os/fd#fd? _raw179264_)
                 (std/os/fd#fd-e _raw179264_)
                 _raw179264_)))
        (let _lp179271_ ()
          (let ((_r179275_
                 (std/os/fdio#_read
                  _fd179269_
                  _bytes179265_
                  _start179266_
                  _end179267_)))
            (if (not (let () (declare (not safe)) (##fxnegative? _r179275_)))
                _r179275_
                (let ((_errno179278_
                       (let () (declare (not safe)) (##fx- _r179275_))))
                  (if (or (eq? _errno179278_ std/os/error#EAGAIN)
                          (eq? _errno179278_ std/os/error#EWOULDBLOCK))
                      '#f
                      (if (eq? _errno179278_ std/os/error#EINTR)
                          (_lp179271_)
                          (std/os/error#raise-os-error
                           _errno179278_
                           std/os/fdio#fdread
                           _raw179264_
                           _bytes179265_
                           _start179266_
                           _end179267_))))))))))
  (define std/os/fdio#fdread__0
    (lambda (_raw179287_ _bytes179288_)
      (let* ((_start179290_ '0) (_end179292_ (u8vector-length _bytes179288_)))
        (std/os/fdio#fdread__%
         _raw179287_
         _bytes179288_
         _start179290_
         _end179292_))))
  (define std/os/fdio#fdread__1
    (lambda (_raw179294_ _bytes179295_ _start179296_)
      (let ((_end179298_ (u8vector-length _bytes179295_)))
        (std/os/fdio#fdread__%
         _raw179294_
         _bytes179295_
         _start179296_
         _end179298_))))
  (define std/os/fdio#fdread
    (lambda _g300940_
      (let ((_g300939_ (let () (declare (not safe)) (##length _g300940_))))
        (cond ((let () (declare (not safe)) (##fx= _g300939_ 2))
               (apply std/os/fdio#fdread__0 _g300940_))
              ((let () (declare (not safe)) (##fx= _g300939_ 3))
               (apply std/os/fdio#fdread__1 _g300940_))
              ((let () (declare (not safe)) (##fx= _g300939_ 4))
               (apply std/os/fdio#fdread__% _g300940_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/fdio#fdread
                _g300940_))))))
  (define std/os/fdio#fdwrite__%
    (lambda (_raw179222_ _bytes179223_ _start179224_ _end179225_)
      (let ((_fd179227_
             (if (std/os/fd#fd? _raw179222_)
                 (std/os/fd#fd-e _raw179222_)
                 _raw179222_)))
        (let _lp179229_ ()
          (let ((_r179233_
                 (std/os/fdio#_write
                  _fd179227_
                  _bytes179223_
                  _start179224_
                  _end179225_)))
            (if (not (let () (declare (not safe)) (##fxnegative? _r179233_)))
                _r179233_
                (let ((_errno179236_
                       (let () (declare (not safe)) (##fx- _r179233_))))
                  (if (or (eq? _errno179236_ std/os/error#EAGAIN)
                          (eq? _errno179236_ std/os/error#EWOULDBLOCK))
                      '#f
                      (if (eq? _errno179236_ std/os/error#EINTR)
                          (_lp179229_)
                          (std/os/error#raise-os-error
                           _errno179236_
                           std/os/fdio#fdwrite
                           _raw179222_
                           _bytes179223_
                           _start179224_
                           _end179225_))))))))))
  (define std/os/fdio#fdwrite__0
    (lambda (_raw179245_ _bytes179246_)
      (let* ((_start179248_ '0) (_end179250_ (u8vector-length _bytes179246_)))
        (std/os/fdio#fdwrite__%
         _raw179245_
         _bytes179246_
         _start179248_
         _end179250_))))
  (define std/os/fdio#fdwrite__1
    (lambda (_raw179252_ _bytes179253_ _start179254_)
      (let ((_end179256_ (u8vector-length _bytes179253_)))
        (std/os/fdio#fdwrite__%
         _raw179252_
         _bytes179253_
         _start179254_
         _end179256_))))
  (define std/os/fdio#fdwrite
    (lambda _g300942_
      (let ((_g300941_ (let () (declare (not safe)) (##length _g300942_))))
        (cond ((let () (declare (not safe)) (##fx= _g300941_ 2))
               (apply std/os/fdio#fdwrite__0 _g300942_))
              ((let () (declare (not safe)) (##fx= _g300941_ 3))
               (apply std/os/fdio#fdwrite__1 _g300942_))
              ((let () (declare (not safe)) (##fx= _g300941_ 4))
               (apply std/os/fdio#fdwrite__% _g300942_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/fdio#fdwrite
                _g300942_))))))
  (define std/os/fdio#open__%
    (lambda (_path179195_ _flags179196_ _mode179197_)
      (let* ((_flags179199_
              (fxior _flags179196_
                     std/os/fcntl#O_NONBLOCK
                     std/os/fcntl#O_CLOEXEC))
             (_fd179204_
              (let ((_r179201_
                     (std/os/fdio#_open
                      _path179195_
                      _flags179199_
                      _mode179197_)))
                (if (not (let ()
                           (declare (not safe))
                           (##fxnegative? _r179201_)))
                    _r179201_
                    (std/os/error#raise-os-error
                     (let () (declare (not safe)) (##fx- _r179201_))
                     std/os/fdio#open
                     _path179195_
                     _flags179199_
                     _mode179197_))))
             (_raw179206_
              (std/os/fd#fdopen
               _fd179204_
               (std/os/fdio#file-direction _flags179199_)
               'file)))
        _raw179206_)))
  (define std/os/fdio#open__0
    (lambda (_path179212_ _flags179213_)
      (let ((_mode179215_ '0))
        (std/os/fdio#open__% _path179212_ _flags179213_ _mode179215_))))
  (define std/os/fdio#open
    (lambda _g300944_
      (let ((_g300943_ (let () (declare (not safe)) (##length _g300944_))))
        (cond ((let () (declare (not safe)) (##fx= _g300943_ 2))
               (apply std/os/fdio#open__0 _g300944_))
              ((let () (declare (not safe)) (##fx= _g300943_ 3))
               (apply std/os/fdio#open__% _g300944_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/fdio#open
                _g300944_))))))
  (define std/os/fdio#close
    (lambda (_raw179182_)
      (if (std/os/fd#fd? _raw179182_)
          (close-port _raw179182_)
          (let _lp179184_ ()
            (let ((_r179188_ (std/os/fdio#_close _raw179182_)))
              (if (not (let () (declare (not safe)) (##fxnegative? _r179188_)))
                  _r179188_
                  (let ((_errno179191_
                         (let () (declare (not safe)) (##fx- _r179188_))))
                    (if '#f
                        '#f
                        (if (eq? _errno179191_ std/os/error#EINTR)
                            (_lp179184_)
                            (std/os/error#raise-os-error
                             _errno179191_
                             std/os/fdio#close
                             _raw179182_))))))))))
  (define std/os/fdio#file-direction
    (lambda (_flags179180_)
      (if (let ((__tmp300945
                 (let ()
                   (declare (not safe))
                   (##fxand _flags179180_ std/os/fcntl#O_RDWR))))
            (declare (not safe))
            (##fx= __tmp300945 std/os/fcntl#O_RDWR))
          'inout
          (if (let ((__tmp300946
                     (let ()
                       (declare (not safe))
                       (##fxand _flags179180_ std/os/fcntl#O_RDONLY))))
                (declare (not safe))
                (##fx= __tmp300946 std/os/fcntl#O_RDONLY))
              'in
              (if (let ((__tmp300947
                         (let ()
                           (declare (not safe))
                           (##fxand _flags179180_ std/os/fcntl#O_WRONLY))))
                    (declare (not safe))
                    (##fx= __tmp300947 std/os/fcntl#O_WRONLY))
                  'out
                  (error '"Unspecified file direction" _flags179180_))))))
  (define-macro (define-guard guard defn)
    (if (eval `(cond-expand (,guard #t) (else #f)))
        '(begin)
        (begin (eval `(define-cond-expand-feature ,guard)) defn)))
  (define-macro (define-c-lambda id args ret #!optional (name #f))
    (let ((name (or name (symbol->string id))))
      `(define ,id (c-lambda ,args ,ret ,name))))
  (define-macro (define-const symbol)
    (let* ((str (symbol->string symbol))
           (ref (string-append "___return (" str ");")))
      `(define ,symbol ((c-lambda () int ,ref)))))
  (define-macro (define-const* symbol #!optional (ccond #f))
    (let* ((str (symbol->string symbol))
           (code (string-append
                  "#if "
                  (or ccond (string-append "defined(" str ")"))
                  "\n"
                  "___return (___FIX ("
                  str
                  "));\n"
                  "#else \n"
                  "___return (___FAL);\n"
                  "#endif")))
      `(define ,symbol ((c-lambda () scheme-object ,code)))))
  (define-macro (define-with-errno symbol ffi-symbol args)
    `(define (,symbol ,@args)
       (declare (not interrupts-enabled))
       (let ((r (,ffi-symbol ,@args)))
         (if (##fx< r 0) (##fx- (##c-code "___RESULT = ___FIX (errno);")) r))))
  (define-macro (define-c-struct
                 struct
                 #!optional
                 (members '())
                 release-function)
    (let* ((struct-str (symbol->string struct))
           (struct-ptr (string->symbol (string-append struct-str "*")))
           (shallow-ptr
            (string->symbol (string-append struct-str "-shallow-ptr*")))
           (borrowed-ptr
            (string->symbol (string-append struct-str "-borrowed-ptr*")))
           (string-types
            '(char-string
              nonull-char-string
              UTF-8-string
              nonnull-UTF-8-string
              UTF-16-string
              nonnull-UTF16-string))
           (string-compat-required?
            (let loop ((m members))
              (cond ((null? m) #f)
                    ((member (cdr (car m)) string-types) #t)
                    (else (loop (cdr m))))))
           (string-setter-body
            (lambda (member-name)
              (let ((m (string-append "___arg1->" member-name)))
                (string-append
                 "if("
                 m
                 " == NULL)"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "else if (strcmp("
                 m
                 ", ___arg2) != 0) {"
                 "\n"
                 "free("
                 m
                 ");"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "}"
                 "\n"
                 "___return;"
                 "\n"))))
           (default-free-body
            (and string-compat-required?
                 (string-append
                  "___SCMOBJ "
                  struct-str
                  "_ffi_free (void *ptr) {"
                  "\n"
                  "struct "
                  struct-str
                  " *obj = (struct "
                  struct-str
                  "*) ptr;"
                  "\n"
                  (apply string-append
                         (map (lambda (m)
                                (cond ((memq (cdr m) string-types)
                                       (let ((mem-name
                                              (symbol->string (car m))))
                                         (string-append
                                          "if(obj->"
                                          mem-name
                                          ") "
                                          "free(obj->"
                                          mem-name
                                          ");"
                                          "\n")))
                                      (else "")))
                              members))
                  "free(obj);"
                  "\n"
                  "return ___FIX (___NO_ERR);"
                  "\n"
                  "}")))
           (release-function
            (or release-function
                (if string-compat-required?
                    (string-append struct-str "_ffi_free")
                    "ffi_free")))
           (string-compat-types
            (if string-compat-required?
                `((c-declare ,default-free-body)
                  (c-define-type
                   ,shallow-ptr
                   (pointer ,struct (,struct-ptr) "ffi_free")))
                '())))
      `(begin
         (c-define-type ,struct (struct ,struct-str))
         (c-define-type
          ,struct-ptr
          (pointer ,struct (,struct-ptr) ,release-function))
         (c-define-type ,borrowed-ptr (pointer ,struct (,struct-ptr)))
         ,@string-compat-types
         (define ,(string->symbol (string-append struct-str "-ptr?"))
           (lambda (obj)
             (and (foreign? obj) (equal? (foreign-tags obj) '(,struct-ptr)))))
         ,@(apply append
                  (map (lambda (m)
                         (let* ((member-name (symbol->string (car m)))
                                (member-type (cdr m))
                                (getter-name
                                 (string-append struct-str "-" member-name))
                                (setter-body
                                 (cond ((member member-type string-types)
                                        (string-setter-body member-name))
                                       (else
                                        (string-append
                                         "___arg1->"
                                         member-name
                                         " = ___arg2;"
                                         "\n"
                                         "___return;"
                                         "\n")))))
                           `((define ,(string->symbol getter-name)
                               (c-lambda
                                (,struct-ptr)
                                ,member-type
                                ,(string-append
                                  "___return(___arg1->"
                                  member-name
                                  ");")))
                             (define ,(string->symbol
                                       (string-append getter-name "-set!"))
                               (c-lambda
                                (,struct-ptr ,member-type)
                                void
                                ,setter-body)))))
                       members))
         (define ,(string->symbol (string-append "malloc-" struct-str))
           (c-lambda
            ()
            ,struct-ptr
            ,(string-append
              "struct "
              struct-str
              "* var = (struct "
              struct-str
              " *) malloc(sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(var, 0, sizeof(struct "
              struct-str
              "));"
              "___return(var);")))
         (define ,(string->symbol (string-append "ptr->" struct-str))
           (c-lambda (,struct-ptr) ,struct "___return(*___arg1);"))
         (define ,(string->symbol
                   (string-append "malloc-" struct-str "-array"))
           (c-lambda
            (unsigned-int32)
            ,(if string-compat-required? shallow-ptr struct-ptr)
            ,(string-append
              "struct "
              struct-str
              " *arr_var=(struct "
              struct-str
              " *) malloc(___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (arr_var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(arr_var, 0, ___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "___return(arr_var);")))
         (define ,(string->symbol (string-append struct-str "-array-ref"))
           (c-lambda
            (,struct-ptr unsigned-int32)
            ,borrowed-ptr
            "___return (___arg1 + ___arg2);"))
         (define ,(string->symbol (string-append struct-str "-array-set!"))
           (c-lambda
            (,struct-ptr unsigned-int32 ,struct-ptr)
            void
            "*(___arg1 + ___arg2) = *___arg3; ___return;")))))
  (c-declare "#include <stdlib.h>")
  (c-declare "#include <string.h>")
  (c-declare "#include <errno.h>")
  (c-declare "static ___SCMOBJ ffi_free (void *ptr);")
  (c-declare
   "#ifndef ___HAVE_FFI_U8VECTOR\n#define ___HAVE_FFI_U8VECTOR\n#define U8_DATA(obj) ___CAST (___U8*, ___BODY_AS (obj, ___tSUBTYPED))\n#define U8_LEN(obj) ___HD_BYTES (___HEADER (obj))\n#endif")
  (namespace
   ("std/os/fdio#"
    S_IXOTH
    S_IWOTH
    S_IROTH
    S_IRWXO
    S_IXGRP
    S_IWGRP
    S_IRGRP
    S_IRWXG
    S_IXUSR
    S_IRUSR
    S_IWUSR
    S_IRWXU
    _close
    _open
    _write
    _read))
  (c-declare "#include <unistd.h>")
  (c-declare "#include <sys/types.h>")
  (c-declare "#include <sys/stat.h>")
  (c-declare "#include <fcntl.h>")
  (define-const S_IRWXU)
  (define-const S_IRUSR)
  (define-const S_IWUSR)
  (define-const S_IXUSR)
  (define-const S_IRWXG)
  (define-const S_IRGRP)
  (define-const S_IWGRP)
  (define-const S_IXGRP)
  (define-const S_IRWXO)
  (define-const S_IROTH)
  (define-const S_IWOTH)
  (define-const S_IXOTH)
  (namespace ("std/os/fdio#" __read __write __open __close))
  (c-declare
   "static int ffi_fdio_read (int fd, ___SCMOBJ bytes, int start, int end);")
  (c-declare
   "static int ffi_fdio_write (int fd, ___SCMOBJ bytes, int start, int end);")
  (define-c-lambda __read (int scheme-object int int) int "ffi_fdio_read")
  (define-c-lambda __write (int scheme-object int int) int "ffi_fdio_write")
  (define-c-lambda __open (UTF-8-string int int) int "open")
  (define-c-lambda __close (int) int "close")
  (define-with-errno _read __read (fd bytes start end))
  (define-with-errno _write __write (fd bytes start end))
  (define-with-errno _open __open (path flags mode))
  (define-with-errno _close __close (fd))
  (c-declare
   "int ffi_fdio_read (int fd, ___SCMOBJ bytes, int start, int end)\n{\n return read (fd, U8_DATA (bytes) + start, end - start);\n}\n\nint ffi_fdio_write (int fd, ___SCMOBJ bytes, int start, int end)\n{\n return write (fd, U8_DATA (bytes) + start, end - start);\n}\n")
  (c-declare
   "#ifndef ___HAVE_FFI_FREE\n#define ___HAVE_FFI_FREE\n___SCMOBJ ffi_free (void *ptr)\n{\n free (ptr);\n return ___FIX (___NO_ERR);\n}\n#endif"))
