(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/os/signal-handler#errorf
    (lambda (_fmt199899_ . _args199900_)
      (std/logger#log-message 'signal '0 _fmt199899_ _args199900_)))
  (define std/os/signal-handler#warnf
    (lambda (_fmt199896_ . _args199897_)
      (std/logger#log-message 'signal '1 _fmt199896_ _args199897_)))
  (define std/os/signal-handler#infof
    (lambda (_fmt199893_ . _args199894_)
      (std/logger#log-message 'signal '2 _fmt199893_ _args199894_)))
  (define std/os/signal-handler#debugf
    (lambda (_fmt199890_ . _args199891_)
      (std/logger#log-message 'signal '3 _fmt199890_ _args199891_)))
  (define std/os/signal-handler#verbosef
    (lambda (_fmt199885_ . _args199887_)
      (std/logger#log-message 'signal '4 _fmt199885_ _args199887_)))
  (define std/os/signal-handler#system-signal-handler
    (make-promise
     (lambda ()
       (let ((__obj301093
              (make-object std/os/signal-handler#signal-handler::t '4)))
         (std/os/signal-handler#signal-handler:::init! __obj301093)
         __obj301093))))
  (define std/os/signal-handler#add-signal-handler!
    (lambda (_signo199879_ _thunk199880_)
      (if (and (fx> _signo199879_ '0) (fx< _signo199879_ std/os/signal#SIGMAX))
          '#!void
          (error '"Invalid signal" _signo199879_))
      (let ((_handler199882_
             (force std/os/signal-handler#system-signal-handler)))
        (std/os/signal-handler#signal-handler-add!
         _handler199882_
         _signo199879_
         _thunk199880_))))
  (define std/os/signal-handler#remove-signal-handler!
    (lambda (_signo199875_)
      (if (and (fx> _signo199875_ '0) (fx< _signo199875_ std/os/signal#SIGMAX))
          '#!void
          (error '"Invalid signal" _signo199875_))
      (let ((_handler199877_
             (force std/os/signal-handler#system-signal-handler)))
        (std/os/signal-handler#signal-handler-remove!
         _handler199877_
         _signo199875_))))
  (define std/os/signal-handler#signal-handler::t
    (make-struct-type
     'std/os/signal-handler#signal-handler::t
     '#f
     '4
     'signal-handler
     '((final: . #t))
     ':init!
     '(tab sfd sigset mx)))
  (define std/os/signal-handler#signal-handler?
    (make-struct-predicate std/os/signal-handler#signal-handler::t))
  (define std/os/signal-handler#make-signal-handler
    (lambda _$args199872_
      (apply make-struct-instance
             std/os/signal-handler#signal-handler::t
             _$args199872_)))
  (define std/os/signal-handler#signal-handler-tab
    (make-struct-field-accessor std/os/signal-handler#signal-handler::t '0))
  (define std/os/signal-handler#signal-handler-sfd
    (make-struct-field-accessor std/os/signal-handler#signal-handler::t '1))
  (define std/os/signal-handler#signal-handler-sigset
    (make-struct-field-accessor std/os/signal-handler#signal-handler::t '2))
  (define std/os/signal-handler#signal-handler-mx
    (make-struct-field-accessor std/os/signal-handler#signal-handler::t '3))
  (define std/os/signal-handler#signal-handler-tab-set!
    (make-struct-field-mutator std/os/signal-handler#signal-handler::t '0))
  (define std/os/signal-handler#signal-handler-sfd-set!
    (make-struct-field-mutator std/os/signal-handler#signal-handler::t '1))
  (define std/os/signal-handler#signal-handler-sigset-set!
    (make-struct-field-mutator std/os/signal-handler#signal-handler::t '2))
  (define std/os/signal-handler#signal-handler-mx-set!
    (make-struct-field-mutator std/os/signal-handler#signal-handler::t '3))
  (define std/os/signal-handler#signal-handler:::init!
    (lambda (_self199860_)
      (let* ((_tab199862_ (make-vector std/os/signal#SIGMAX '#f))
             (_sigset199864_ (std/os/signal#make_sigset))
             (_g301094_ (std/os/signal#sigemptyset _sigset199864_))
             (_sfd199867_ (std/os/signalfd#signalfd _sigset199864_))
             (_mx199869_ (make-mutex 'signal-handler)))
        (if (let ((__tmp301095
                   (let ()
                     (declare (not safe))
                     (##vector-length _self199860_))))
              (declare (not safe))
              (##fx< '4 __tmp301095))
            (begin
              (let ()
                (declare (not safe))
                (##vector-set! _self199860_ '1 _tab199862_))
              (let ()
                (declare (not safe))
                (##vector-set! _self199860_ '2 _sfd199867_))
              (let ()
                (declare (not safe))
                (##vector-set! _self199860_ '3 _sigset199864_))
              (let ()
                (declare (not safe))
                (##vector-set! _self199860_ '4 _mx199869_)))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self199860_))
        (std/logger#start-logger!__0)
        (gerbil/gambit/threads#spawn/name
         'signal-handler
         std/os/signal-handler#signal-handler-wait
         _self199860_))))
  (bind-method!
   std/os/signal-handler#signal-handler::t
   ':init!
   std/os/signal-handler#signal-handler:::init!
   '#f)
  (define std/os/signal-handler#signal-handler-wait
    (lambda (_sh199675_)
      (with-exception-catcher
       (lambda (_g199676199678_)
         (if '#t
             (let ((_e199681_ _g199676199678_))
               (std/os/signal-handler#errorf
                '"Error handling signals: ~a"
                _e199681_)
               (raise _e199681_))
             (raise _g199676199678_)))
       (lambda ()
         (letrec* ((_buf199684_ (std/os/signalfd#make-signalfd-siginfo)))
           (let* ((_sh199685199694_ _sh199675_)
                  (_E199687199698_
                   (lambda () (error '"No clause matching" _sh199685199694_)))
                  (_K199688199714_
                   (lambda (_mx199701_ _sigset199702_ _sfd199703_ _tab199704_)
                     (let _loop199706_ ()
                       (std/os/signalfd#signalfd-read__%
                        _sfd199703_
                        _buf199684_)
                       (let* ((_signo199709_
                               (std/os/signalfd#signalfd-siginfo-signo
                                _buf199684_))
                              (_handler199712_
                               (gerbil/gambit/threads#with-lock
                                _mx199701_
                                (lambda ()
                                  (vector-ref _tab199704_ _signo199709_)))))
                         (if _handler199712_
                             (std/os/signal-handler#signal-handler-dispatch
                              _handler199712_)
                             '#!void))
                       (_loop199706_)))))
             (if (let ()
                   (declare (not safe))
                   (##structure-direct-instance-of?
                    _sh199685199694_
                    'std/os/signal-handler#signal-handler::t))
                 (let* ((_e199689199717_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _sh199685199694_ '1)))
                        (_tab199720_ _e199689199717_)
                        (_e199690199722_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _sh199685199694_ '2)))
                        (_sfd199725_ _e199690199722_)
                        (_e199691199727_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _sh199685199694_ '3)))
                        (_sigset199730_ _e199691199727_)
                        (_e199692199732_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _sh199685199694_ '4)))
                        (_mx199735_ _e199692199732_))
                   (_K199688199714_
                    _mx199735_
                    _sigset199730_
                    _sfd199725_
                    _tab199720_))
                 (_E199687199698_))))))))
  (define std/os/signal-handler#signal-handler-add!
    (lambda (_sh199627_ _signo199628_ _thunk199629_)
      (let* ((_sh199630199639_ _sh199627_)
             (_E199632199643_
              (lambda () (error '"No clause matching" _sh199630199639_)))
             (_K199633199652_
              (lambda (_mx199646_ _sigset199647_ _sfd199648_ _tab199649_)
                (gerbil/gambit/threads#with-lock
                 _mx199646_
                 (lambda ()
                   (if (fxzero? (std/os/signal#sigismember
                                 _sigset199647_
                                 _signo199628_))
                       (begin
                         (std/os/signal#sigaddset _sigset199647_ _signo199628_)
                         (std/os/signal-handler#block-signal! _signo199628_)
                         (std/os/signalfd#signalfd-reset!
                          _sfd199648_
                          _sigset199647_))
                       '#!void)
                   (vector-set! _tab199649_ _signo199628_ _thunk199629_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _sh199630199639_
               'std/os/signal-handler#signal-handler::t))
            (let* ((_e199634199655_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _sh199630199639_ '1)))
                   (_tab199658_ _e199634199655_)
                   (_e199635199660_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _sh199630199639_ '2)))
                   (_sfd199663_ _e199635199660_)
                   (_e199636199665_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _sh199630199639_ '3)))
                   (_sigset199668_ _e199636199665_)
                   (_e199637199670_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _sh199630199639_ '4)))
                   (_mx199673_ _e199637199670_))
              (_K199633199652_
               _mx199673_
               _sigset199668_
               _sfd199663_
               _tab199658_))
            (_E199632199643_)))))
  (define std/os/signal-handler#signal-handler-remove!
    (lambda (_sh199580_ _signo199581_)
      (let* ((_sh199582199591_ _sh199580_)
             (_E199584199595_
              (lambda () (error '"No clause matching" _sh199582199591_)))
             (_K199585199604_
              (lambda (_mx199598_ _sigset199599_ _sfd199600_ _tab199601_)
                (gerbil/gambit/threads#with-lock
                 _mx199598_
                 (lambda ()
                   (if (fxzero? (std/os/signal#sigismember
                                 _sigset199599_
                                 _signo199581_))
                       '#!void
                       (begin
                         (std/os/signal#sigdelset _sigset199599_ _signo199581_)
                         (std/os/signalfd#signalfd-reset!
                          _sfd199600_
                          _sigset199599_)
                         (std/os/signal-handler#unblock-signal!
                          _signo199581_)))
                   (vector-set! _tab199601_ _signo199581_ '#f))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _sh199582199591_
               'std/os/signal-handler#signal-handler::t))
            (let* ((_e199586199607_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _sh199582199591_ '1)))
                   (_tab199610_ _e199586199607_)
                   (_e199587199612_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _sh199582199591_ '2)))
                   (_sfd199615_ _e199587199612_)
                   (_e199588199617_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _sh199582199591_ '3)))
                   (_sigset199620_ _e199588199617_)
                   (_e199589199622_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _sh199582199591_ '4)))
                   (_mx199625_ _e199589199622_))
              (_K199585199604_
               _mx199625_
               _sigset199620_
               _sfd199615_
               _tab199610_))
            (_E199584199595_)))))
  (define std/os/signal-handler#block-signal!
    (lambda (_signo199576_)
      (let ((_sigset199578_ (std/os/signal#make_sigset)))
        (std/os/signal#sigemptyset _sigset199578_)
        (std/os/signal#sigaddset _sigset199578_ _signo199576_)
        (std/os/signal#sigprocmask
         std/os/signal#SIG_BLOCK
         _sigset199578_
         '#f))))
  (define std/os/signal-handler#unblock-signal!
    (lambda (_signo199572_)
      (let ((_sigset199574_ (std/os/signal#make_sigset)))
        (std/os/signal#sigemptyset _sigset199574_)
        (std/os/signal#sigaddset _sigset199574_ _signo199572_)
        (std/os/signal#sigprocmask
         std/os/signal#SIG_UNBLOCK
         _sigset199574_
         '#f))))
  (define std/os/signal-handler#signal-handler-dispatch
    (lambda (_handler199563_)
      (with-exception-catcher
       (lambda (_g199564199566_)
         (if '#t
             (let ((_e199569_ _g199564199566_))
               (std/os/signal-handler#errorf
                '"error dispatching signal handler: ~a"
                _e199569_))
             (raise _g199564199566_)))
       (lambda () (_handler199563_))))))
