(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/117#make-list
    (lambda (_n95969_ . _o95970_)
      (let ((_default95972_ (if (pair? _o95970_) (car _o95970_) '#!void)))
        (let _lp95974_ ((_n95976_ _n95969_) (_res95977_ '()))
          (if (<= _n95976_ '0)
              _res95977_
              (_lp95974_ (- _n95976_ '1) (cons _default95972_ _res95977_)))))))
  (define std/srfi/117#list-copy
    (lambda (_ls95962_)
      (let _lp95964_ ((_ls95966_ _ls95962_) (_res95967_ '()))
        (if (pair? _ls95966_)
            (_lp95964_ (cdr _ls95966_) (cons (car _ls95966_) _res95967_))
            (append (reverse _res95967_) _ls95966_)))))
  (define std/srfi/117#list-set!
    (lambda (_ls95958_ _k95959_ _x95960_)
      (if (null? _ls95958_)
          (error '"invalid list index")
          (if (zero? _k95959_)
              (set-car! _ls95958_ _x95960_)
              (std/srfi/117#list-set!
               (cdr _ls95958_)
               (- _k95959_ '1)
               _x95960_)))))
  (define std/srfi/117#last-pair
    (lambda (_ls95956_)
      (if (null? (cdr _ls95956_))
          _ls95956_
          (std/srfi/117#last-pair (cdr _ls95956_)))))
  (define std/srfi/117#map!
    (lambda (_f95949_ _lis95950_)
      (let _lp95952_ ((_lis95954_ _lis95950_))
        (if (pair? _lis95954_)
            (begin
              (set-car! _lis95954_ (_f95949_ (car _lis95954_)))
              (_lp95952_ (cdr _lis95954_)))
            '#!void))))
  (define std/srfi/117#<list-queue>
    (make-struct-type
     'std/srfi/117#<list-queue>
     '#f
     '2
     '<list-queue>
     '((fields: first last))
     '#f))
  (define std/srfi/117#list-queue?
    (make-struct-predicate std/srfi/117#<list-queue>))
  (define std/srfi/117#get-first
    (make-struct-field-accessor std/srfi/117#<list-queue> '0))
  (define std/srfi/117#get-last
    (make-struct-field-accessor std/srfi/117#<list-queue> '1))
  (define std/srfi/117#set-first!
    (make-struct-field-mutator std/srfi/117#<list-queue> '0))
  (define std/srfi/117#set-last!
    (make-struct-field-mutator std/srfi/117#<list-queue> '1))
  (define std/srfi/117#raw-make-list-queue
    (lambda (_first95946_ _last95947_)
      (make-struct-instance
       std/srfi/117#<list-queue>
       _first95946_
       _last95947_)))
  (define std/srfi/117#make-list-queue__0
    (lambda (_list95941_)
      (if (null? _list95941_)
          (let ()
            (declare (not safe))
            (##structure std/srfi/117#<list-queue> '() '()))
          (let ((__tmp294933 (std/srfi/117#last-pair _list95941_)))
            (declare (not safe))
            (##structure std/srfi/117#<list-queue> _list95941_ __tmp294933)))))
  (define std/srfi/117#make-list-queue
    (lambda _g294935_
      (let ((_g294934_ (let () (declare (not safe)) (##length _g294935_))))
        (cond ((let () (declare (not safe)) (##fx= _g294934_ 1))
               (apply std/srfi/117#make-list-queue__0 _g294935_))
              ((let () (declare (not safe)) (##fx= _g294934_ 2))
               (apply (lambda (_list95943_ _last95944_)
                        (let ()
                          (declare (not safe))
                          (##structure
                           std/srfi/117#<list-queue>
                           _list95943_
                           _last95944_)))
                      _g294935_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/117#make-list-queue
                _g294935_))))))
  (define std/srfi/117#list-queue
    (lambda _objs95939_ (std/srfi/117#make-list-queue__0 _objs95939_)))
  (define std/srfi/117#list-queue-copy
    (lambda (_list-queue95937_)
      (std/srfi/117#make-list-queue__0
       (std/srfi/117#list-copy
        (##structure-ref
         _list-queue95937_
         '1
         std/srfi/117#<list-queue>
         '#f)))))
  (define std/srfi/117#list-queue-empty?
    (lambda (_list-queue95935_)
      (null? (##structure-ref
              _list-queue95935_
              '1
              std/srfi/117#<list-queue>
              '#f))))
  (define std/srfi/117#list-queue-front
    (lambda (_list-queue95933_)
      (if (std/srfi/117#list-queue-empty? _list-queue95933_)
          (error '"Empty list-queue")
          (car (##structure-ref
                _list-queue95933_
                '1
                std/srfi/117#<list-queue>
                '#f)))))
  (define std/srfi/117#list-queue-back
    (lambda (_list-queue95931_)
      (if (std/srfi/117#list-queue-empty? _list-queue95931_)
          (error '"Empty list-queue")
          (car (##structure-ref
                _list-queue95931_
                '2
                std/srfi/117#<list-queue>
                '#f)))))
  (define std/srfi/117#list-queue-add-front!
    (lambda (_list-queue95926_ _elem95927_)
      (let ((_new-first95929_
             (cons _elem95927_
                   (##structure-ref
                    _list-queue95926_
                    '1
                    std/srfi/117#<list-queue>
                    '#f))))
        (if (std/srfi/117#list-queue-empty? _list-queue95926_)
            (##structure-set!
             _list-queue95926_
             _new-first95929_
             '2
             std/srfi/117#<list-queue>
             '#f)
            '#!void)
        (##structure-set!
         _list-queue95926_
         _new-first95929_
         '1
         std/srfi/117#<list-queue>
         '#f))))
  (define std/srfi/117#list-queue-add-back!
    (lambda (_list-queue95921_ _elem95922_)
      (let ((_new-last95924_ (list _elem95922_)))
        (if (std/srfi/117#list-queue-empty? _list-queue95921_)
            (##structure-set!
             _list-queue95921_
             _new-last95924_
             '1
             std/srfi/117#<list-queue>
             '#f)
            (set-cdr!
             (##structure-ref
              _list-queue95921_
              '2
              std/srfi/117#<list-queue>
              '#f)
             _new-last95924_))
        (##structure-set!
         _list-queue95921_
         _new-last95924_
         '2
         std/srfi/117#<list-queue>
         '#f))))
  (define std/srfi/117#list-queue-remove-front!
    (lambda (_list-queue95912_)
      (if (std/srfi/117#list-queue-empty? _list-queue95912_)
          (error '"Empty list-queue")
          '#!void)
      (let* ((_old-first95914_
              (##structure-ref
               _list-queue95912_
               '1
               std/srfi/117#<list-queue>
               '#f))
             (_elem95916_ (car _old-first95914_))
             (_new-first95918_ (cdr _old-first95914_)))
        (if (null? _new-first95918_)
            (##structure-set!
             _list-queue95912_
             '()
             '2
             std/srfi/117#<list-queue>
             '#f)
            '#!void)
        (##structure-set!
         _list-queue95912_
         _new-first95918_
         '1
         std/srfi/117#<list-queue>
         '#f)
        _elem95916_)))
  (define std/srfi/117#list-queue-remove-back!
    (lambda (_list-queue95903_)
      (if (std/srfi/117#list-queue-empty? _list-queue95903_)
          (error '"Empty list-queue")
          '#!void)
      (let* ((_old-last95905_
              (##structure-ref
               _list-queue95903_
               '2
               std/srfi/117#<list-queue>
               '#f))
             (_elem95907_ (car _old-last95905_))
             (_new-last95909_
              (std/srfi/117#penult-pair
               (##structure-ref
                _list-queue95903_
                '1
                std/srfi/117#<list-queue>
                '#f))))
        (if (null? _new-last95909_)
            (##structure-set!
             _list-queue95903_
             '()
             '1
             std/srfi/117#<list-queue>
             '#f)
            (set-cdr! _new-last95909_ '()))
        (##structure-set!
         _list-queue95903_
         _new-last95909_
         '2
         std/srfi/117#<list-queue>
         '#f)
        _elem95907_)))
  (define std/srfi/117#list-queue-remove-all!
    (lambda (_list-queue95899_)
      (let ((_result95901_
             (##structure-ref
              _list-queue95899_
              '1
              std/srfi/117#<list-queue>
              '#f)))
        (##structure-set!
         _list-queue95899_
         '()
         '1
         std/srfi/117#<list-queue>
         '#f)
        (##structure-set!
         _list-queue95899_
         '()
         '2
         std/srfi/117#<list-queue>
         '#f)
        _result95901_)))
  (define std/srfi/117#penult-pair
    (lambda (_lis95893_)
      (let _lp95895_ ((_lis95897_ _lis95893_))
        (if (null? (cdr _lis95897_))
            '()
            (if (null? (cddr _lis95897_))
                _lis95897_
                (_lp95895_ (cdr _lis95897_)))))))
  (define std/srfi/117#list-queue-append
    (lambda _list-queues95891_
      (std/srfi/117#list-queue-concatenate _list-queues95891_)))
  (define std/srfi/117#list-queue-concatenate
    (lambda (_list-queues95883_)
      (let ((_result95885_ (std/srfi/117#list-queue)))
        (for-each
         (lambda (_list-queue95887_)
           (for-each
            (lambda (_elem95889_)
              (std/srfi/117#list-queue-add-back! _result95885_ _elem95889_))
            (##structure-ref
             _list-queue95887_
             '1
             std/srfi/117#<list-queue>
             '#f)))
         _list-queues95883_)
        _result95885_)))
  (define std/srfi/117#list-queue-append!__1
    (lambda (_queue95877_) _queue95877_))
  (define std/srfi/117#list-queue-append!__2
    (lambda _queues95879_
      (for-each
       (lambda (_queue95881_)
         (std/srfi/117#list-queue-join! (car _queues95879_) _queue95881_))
       (cdr _queues95879_))
      (car _queues95879_)))
  (define std/srfi/117#list-queue-append!
    (lambda _g294937_
      (let ((_g294936_ (let () (declare (not safe)) (##length _g294937_))))
        (cond ((let () (declare (not safe)) (##fx= _g294936_ 0))
               (apply std/srfi/117#list-queue _g294937_))
              ((let () (declare (not safe)) (##fx= _g294936_ 1))
               (apply std/srfi/117#list-queue-append!__1 _g294937_))
              (#t (apply std/srfi/117#list-queue-append!__2 _g294937_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/117#list-queue-append!
                _g294937_))))))
  (define std/srfi/117#list-queue-join!
    (lambda (_queue195873_ _queue295874_)
      (set-cdr!
       (##structure-ref _queue195873_ '2 std/srfi/117#<list-queue> '#f)
       (##structure-ref _queue295874_ '1 std/srfi/117#<list-queue> '#f))))
  (define std/srfi/117#list-queue-map
    (lambda (_proc95870_ _list-queue95871_)
      (std/srfi/117#make-list-queue__0
       (map _proc95870_
            (##structure-ref
             _list-queue95871_
             '1
             std/srfi/117#<list-queue>
             '#f)))))
  (define std/srfi/117#list-queue-unfold__1
    (lambda (_stop?95865_ _mapper95866_ _successor95867_ _seed95868_)
      (std/srfi/117#list-queue-unfold*
       _stop?95865_
       _mapper95866_
       _successor95867_
       _seed95868_
       (std/srfi/117#list-queue))))
  (define std/srfi/117#list-queue-unfold
    (lambda _g294939_
      (let ((_g294938_ (let () (declare (not safe)) (##length _g294939_))))
        (cond ((let () (declare (not safe)) (##fx= _g294938_ 5))
               (apply std/srfi/117#list-queue-unfold* _g294939_))
              ((let () (declare (not safe)) (##fx= _g294938_ 4))
               (apply std/srfi/117#list-queue-unfold__1 _g294939_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/117#list-queue-unfold
                _g294939_))))))
  (define std/srfi/117#list-queue-unfold*
    (lambda (_stop?95849_
             _mapper95850_
             _successor95851_
             _seed95852_
             _queue95853_)
      (let _loop95855_ ((_seed95857_ _seed95852_))
        (if (not (_stop?95849_ _seed95857_))
            (std/srfi/117#list-queue-add-front!
             (_loop95855_ (_successor95851_ _seed95857_))
             (_mapper95850_ _seed95857_))
            '#!void)
        _queue95853_)))
  (define std/srfi/117#list-queue-unfold-right__1
    (lambda (_stop?95844_ _mapper95845_ _successor95846_ _seed95847_)
      (std/srfi/117#list-queue-unfold-right*
       _stop?95844_
       _mapper95845_
       _successor95846_
       _seed95847_
       (std/srfi/117#list-queue))))
  (define std/srfi/117#list-queue-unfold-right
    (lambda _g294941_
      (let ((_g294940_ (let () (declare (not safe)) (##length _g294941_))))
        (cond ((let () (declare (not safe)) (##fx= _g294940_ 5))
               (apply std/srfi/117#list-queue-unfold-right* _g294941_))
              ((let () (declare (not safe)) (##fx= _g294940_ 4))
               (apply std/srfi/117#list-queue-unfold-right__1 _g294941_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/117#list-queue-unfold-right
                _g294941_))))))
  (define std/srfi/117#list-queue-unfold-right*
    (lambda (_stop?95828_
             _mapper95829_
             _successor95830_
             _seed95831_
             _queue95832_)
      (let _loop95834_ ((_seed95836_ _seed95831_))
        (if (not (_stop?95828_ _seed95836_))
            (std/srfi/117#list-queue-add-back!
             (_loop95834_ (_successor95830_ _seed95836_))
             (_mapper95829_ _seed95836_))
            '#!void)
        _queue95832_)))
  (define std/srfi/117#list-queue-map!
    (lambda (_proc95825_ _list-queue95826_)
      (std/srfi/117#map!
       _proc95825_
       (##structure-ref _list-queue95826_ '1 std/srfi/117#<list-queue> '#f))))
  (define std/srfi/117#list-queue-for-each
    (lambda (_proc95822_ _list-queue95823_)
      (for-each
       _proc95822_
       (##structure-ref _list-queue95823_ '1 std/srfi/117#<list-queue> '#f))))
  (define std/srfi/117#list-queue-list
    (lambda (_list-queue95820_)
      (##structure-ref _list-queue95820_ '1 std/srfi/117#<list-queue> '#f)))
  (define std/srfi/117#list-queue-first-last
    (lambda (_list-queue95818_)
      (values (##structure-ref
               _list-queue95818_
               '1
               std/srfi/117#<list-queue>
               '#f)
              (##structure-ref
               _list-queue95818_
               '2
               std/srfi/117#<list-queue>
               '#f))))
  (define std/srfi/117#list-queue-set-list!__0
    (lambda (_list-queue95811_ _first95812_)
      (##structure-set!
       _list-queue95811_
       _first95812_
       '1
       std/srfi/117#<list-queue>
       '#f)
      (if (null? _first95812_)
          (##structure-set!
           _list-queue95811_
           '()
           '2
           std/srfi/117#<list-queue>
           '#f)
          (##structure-set!
           _list-queue95811_
           (std/srfi/117#last-pair _first95812_)
           '2
           std/srfi/117#<list-queue>
           '#f))))
  (define std/srfi/117#list-queue-set-list!__1
    (lambda (_list-queue95814_ _first95815_ _last95816_)
      (##structure-set!
       _list-queue95814_
       _first95815_
       '1
       std/srfi/117#<list-queue>
       '#f)
      (##structure-set!
       _list-queue95814_
       _last95816_
       '2
       std/srfi/117#<list-queue>
       '#f)))
  (define std/srfi/117#list-queue-set-list!
    (lambda _g294943_
      (let ((_g294942_ (let () (declare (not safe)) (##length _g294943_))))
        (cond ((let () (declare (not safe)) (##fx= _g294942_ 2))
               (apply std/srfi/117#list-queue-set-list!__0 _g294943_))
              ((let () (declare (not safe)) (##fx= _g294942_ 3))
               (apply std/srfi/117#list-queue-set-list!__1 _g294943_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/117#list-queue-set-list!
                _g294943_)))))))
