(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/132#r7rs-vector-copy
    (lambda (_v98744_ _start98745_ _end98746_)
      (subvector _v98744_ _start98745_ _end98746_)))
  (define std/srfi/132#r7rs-vector-copy!__%
    (lambda (_v98714_ _start98715_ _v298716_ _start298717_ _end298718_)
      (subvector-move!
       _v98714_
       _start98715_
       _v298716_
       _start298717_
       _end298718_)))
  (define std/srfi/132#r7rs-vector-copy!__0
    (lambda (_v98723_ _start98724_ _v298725_)
      (let* ((_start298727_ '0) (_end298729_ (vector-length _v298725_)))
        (subvector-move!
         _v98723_
         _start98724_
         _v298725_
         _start298727_
         _end298729_))))
  (define std/srfi/132#r7rs-vector-copy!__1
    (lambda (_v98731_ _start98732_ _v298733_ _start298734_)
      (let ((_end298736_ (vector-length _v298733_)))
        (subvector-move!
         _v98731_
         _start98732_
         _v298733_
         _start298734_
         _end298736_))))
  (define std/srfi/132#r7rs-vector-copy!
    (lambda _g289460_
      (let ((_g289459_ (let () (declare (not safe)) (##length _g289460_))))
        (cond ((let () (declare (not safe)) (##fx= _g289459_ 3))
               (apply std/srfi/132#r7rs-vector-copy!__0 _g289460_))
              ((let () (declare (not safe)) (##fx= _g289459_ 4))
               (apply std/srfi/132#r7rs-vector-copy!__1 _g289460_))
              ((let () (declare (not safe)) (##fx= _g289459_ 5))
               (apply subvector-move! _g289460_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/132#r7rs-vector-copy!
                _g289460_))))))
  (define std/srfi/132#r7rs-vector-fill!
    (lambda (_v98702_ _val98703_ _start98704_ _end98705_)
      (let ((_len98707_ (vector-length _v98702_)))
        (let _lp98709_ ((_i98711_ _start98704_))
          (if (fx< _i98711_ _end98705_)
              (begin
                (vector-set! _v98702_ _i98711_ _val98703_)
                (_lp98709_ (fx+ _i98711_ '1)))
              '#!void)))))
  (define std/srfi/132#list-delete-neighbor-dups
    (lambda (_=98682_ _lis98683_)
      (if (pair? _lis98683_)
          (let* ((_x098685_ (car _lis98683_))
                 (_xs98687_ (cdr _lis98683_))
                 (_ans98699_
                  (let _recur98689_ ((_x098691_ _x098685_)
                                     (_xs98692_ _xs98687_))
                    (if (pair? _xs98692_)
                        (let ((_x198694_ (car _xs98692_))
                              (_x2+98695_ (cdr _xs98692_)))
                          (if (_=98682_ _x098691_ _x198694_)
                              (_recur98689_ _x098691_ _x2+98695_)
                              (let ((_ans-tail98697_
                                     (_recur98689_ _x198694_ _x2+98695_)))
                                (if (eq? _ans-tail98697_ _x2+98695_)
                                    _xs98692_
                                    (cons _x198694_ _ans-tail98697_)))))
                        _xs98692_))))
            (if (eq? _ans98699_ _xs98687_)
                _lis98683_
                (cons _x098685_ _ans98699_)))
          _lis98683_)))
  (define std/srfi/132#list-delete-neighbor-dups!
    (lambda (_=98663_ _lis98664_)
      (if (pair? _lis98664_)
          (let _lp198666_ ((_prev98668_ _lis98664_)
                           (_prev-elt98669_ (car _lis98664_))
                           (_lis98670_ (cdr _lis98664_)))
            (if (pair? _lis98670_)
                (let ((_lis-elt98672_ (car _lis98670_))
                      (_next98673_ (cdr _lis98670_)))
                  (if (_=98663_ _prev-elt98669_ _lis-elt98672_)
                      (let _lp298675_ ((_lis98677_ _next98673_))
                        (if (pair? _lis98677_)
                            (let ((_lis-elt98679_ (car _lis98677_))
                                  (_next98680_ (cdr _lis98677_)))
                              (if (_=98663_ _prev-elt98669_ _lis-elt98679_)
                                  (_lp298675_ _next98680_)
                                  (begin
                                    (set-cdr! _prev98668_ _lis98677_)
                                    (_lp198666_
                                     _lis98677_
                                     _lis-elt98679_
                                     _next98680_))))
                            (set-cdr! _prev98668_ _lis98677_)))
                      (_lp198666_ _lis98670_ _lis-elt98672_ _next98673_)))
                '#!void))
          '#!void)
      _lis98664_))
  (define std/srfi/132#vector-delete-neighbor-dups
    (lambda (_elt=98639_ _v98640_ . _maybe-start+end98641_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v98640_ _maybe-start+end98641_))
       (lambda (_start98644_ _end98645_)
         (if (< _start98644_ _end98645_)
             (let* ((_x98647_ (vector-ref _v98640_ _start98644_))
                    (_ans98660_
                     (let _recur98649_ ((_x98651_ _x98647_)
                                        (_i98652_ _start98644_)
                                        (_j98653_ '1))
                       (if (< _i98652_ _end98645_)
                           (let ((_y98655_ (vector-ref _v98640_ _i98652_))
                                 (_nexti98656_ (+ _i98652_ '1)))
                             (if (_elt=98639_ _x98651_ _y98655_)
                                 (_recur98649_ _x98651_ _nexti98656_ _j98653_)
                                 (let ((_ansvec98658_
                                        (_recur98649_
                                         _y98655_
                                         _nexti98656_
                                         (+ _j98653_ '1))))
                                   (vector-set!
                                    _ansvec98658_
                                    _j98653_
                                    _y98655_)
                                   _ansvec98658_)))
                           (make-vector _j98653_)))))
               (vector-set! _ans98660_ '0 _x98647_)
               _ans98660_)
             '#())))))
  (define std/srfi/132#vector-delete-neighbor-dups!
    (lambda (_elt=98607_ _v98608_ . _maybe-start+end98609_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v98608_ _maybe-start+end98609_))
       (lambda (_start98612_ _end98613_)
         (if (>= _start98612_ _end98613_)
             _end98613_
             (let _skip98615_ ((_j98617_ _start98612_)
                               (_vj98618_ (vector-ref _v98608_ _start98612_)))
               (let ((_j+198620_ (+ _j98617_ '1)))
                 (if (>= _j+198620_ _end98613_)
                     _end98613_
                     (let ((_vj+198622_ (vector-ref _v98608_ _j+198620_)))
                       (if (not (_elt=98607_ _vj98618_ _vj+198622_))
                           (_skip98615_ _j+198620_ _vj+198622_)
                           (let _lp298624_ ((_j98626_ _j98617_)
                                            (_vj98627_ _vj98618_)
                                            (_k98628_ (+ _j98617_ '2)))
                             (let _lp398630_ ((_k98632_ _k98628_))
                               (if (>= _k98632_ _end98613_)
                                   (+ _j98626_ '1)
                                   (let ((_vk98634_
                                          (vector-ref _v98608_ _k98632_))
                                         (_k+198635_ (+ _k98632_ '1)))
                                     (if (_elt=98607_ _vj98627_ _vk98634_)
                                         (_lp398630_ _k+198635_)
                                         (let ((_j+198637_ (+ _j98626_ '1)))
                                           (vector-set!
                                            _v98608_
                                            _j+198637_
                                            _vk98634_)
                                           (_lp298624_
                                            _j+198637_
                                            _vk98634_
                                            _k+198635_)))))))))))))))))
  (define std/srfi/132#list-merge-sort
    (lambda (_elt<98524_ _lis98525_)
      (letrec ((_getrun98527_
                (lambda (_lis98596_)
                  (let _lp98598_ ((_ans98600_ '())
                                  (_i98601_ '1)
                                  (_prev98602_ (car _lis98596_))
                                  (_xs98603_ (cdr _lis98596_)))
                    (if (pair? _xs98603_)
                        (let ((_x98605_ (car _xs98603_)))
                          (if (_elt<98524_ _x98605_ _prev98602_)
                              (values (_append-reverse98528_
                                       _ans98600_
                                       (cons _prev98602_ '()))
                                      _i98601_
                                      _xs98603_)
                              (_lp98598_
                               (cons _prev98602_ _ans98600_)
                               (+ _i98601_ '1)
                               _x98605_
                               (cdr _xs98603_))))
                        (values (_append-reverse98528_
                                 _ans98600_
                                 (cons _prev98602_ '()))
                                _i98601_
                                _xs98603_)))))
               (_append-reverse98528_
                (lambda (_rev-head98588_ _tail98589_)
                  (let _lp98591_ ((_rev-head98593_ _rev-head98588_)
                                  (_tail98594_ _tail98589_))
                    (if (_null-list?98529_ _rev-head98593_)
                        _tail98594_
                        (_lp98591_
                         (cdr _rev-head98593_)
                         (cons (car _rev-head98593_) _tail98594_))))))
               (_null-list?98529_
                (lambda (_l98586_)
                  (if (pair? _l98586_)
                      '#f
                      (if (null? _l98586_)
                          '#t
                          (error '"argument out of domain" _l98586_)))))
               (_merge98530_
                (lambda (_a98572_ _b98573_)
                  (let _recur98575_ ((_x98577_ (car _a98572_))
                                     (_a98578_ _a98572_)
                                     (_y98579_ (car _b98573_))
                                     (_b98580_ _b98573_))
                    (if (_elt<98524_ _y98579_ _x98577_)
                        (cons _y98579_
                              (let ((_b98582_ (cdr _b98580_)))
                                (if (pair? _b98582_)
                                    (_recur98575_
                                     _x98577_
                                     _a98578_
                                     (car _b98582_)
                                     _b98582_)
                                    _a98578_)))
                        (cons _x98577_
                              (let ((_a98584_ (cdr _a98578_)))
                                (if (pair? _a98584_)
                                    (_recur98575_
                                     (car _a98584_)
                                     _a98584_
                                     _y98579_
                                     _b98580_)
                                    _b98580_)))))))
               (_grow98531_
                (lambda (_s98545_ _ls98546_ _ls298547_ _u98548_ _lw98549_)
                  (if (or (<= _lw98549_ _ls98546_) (not (pair? _u98548_)))
                      (values _s98545_ _ls98546_ _u98548_)
                      (let ((_ls298560_
                             (let _lp98554_ ((_ls298556_ _ls298547_))
                               (let ((_ls2*298558_ (+ _ls298556_ _ls298556_)))
                                 (if (<= _ls2*298558_ _ls98546_)
                                     (_lp98554_ _ls2*298558_)
                                     _ls298556_)))))
                        (call-with-values
                         (lambda () (_getrun98527_ _u98548_))
                         (lambda (_r98563_ _lr98564_ _u298565_)
                           (call-with-values
                            (lambda ()
                              (_grow98531_
                               _r98563_
                               _lr98564_
                               '1
                               _u298565_
                               _ls298560_))
                            (lambda (_t98568_ _lt98569_ _u398570_)
                              (_grow98531_
                               (_merge98530_ _s98545_ _t98568_)
                               (+ _ls98546_ _lt98569_)
                               (+ _ls298560_ _ls298560_)
                               _u398570_
                               _lw98549_))))))))))
        (if (pair? _lis98525_)
            (call-with-values
             (lambda () (_getrun98527_ _lis98525_))
             (lambda (_r98534_ _lr98535_ _tail98536_)
               (let ((_infinity98538_ '16777216))
                 (call-with-values
                  (lambda ()
                    (_grow98531_
                     _r98534_
                     _lr98535_
                     '1
                     _tail98536_
                     _infinity98538_))
                  (lambda (_a98541_ _la98542_ _v98543_) _a98541_)))))
            '()))))
  (define std/srfi/132#list-merge-sort!
    (lambda (_elt<98424_ _lis98425_)
      (letrec ((_getrun98427_
                (lambda (_lis98513_)
                  (let _lp98515_ ((_lis98517_ _lis98513_)
                                  (_x98518_ (car _lis98513_))
                                  (_i98519_ '1)
                                  (_next98520_ (cdr _lis98513_)))
                    (if (pair? _next98520_)
                        (let ((_y98522_ (car _next98520_)))
                          (if (_elt<98424_ _y98522_ _x98518_)
                              (values _i98519_ _lis98517_ _next98520_)
                              (_lp98515_
                               _next98520_
                               _y98522_
                               (+ _i98519_ '1)
                               (cdr _next98520_))))
                        (values _i98519_ _lis98517_ _next98520_)))))
               (_merge!98428_
                (lambda (_a98474_ _enda98475_ _b98476_ _endb98477_)
                  (letrec ((_scan-a98479_
                            (lambda (_prev98483_
                                     _x98484_
                                     _a98485_
                                     _y98486_
                                     _b98487_)
                              (if (_elt<98424_ _y98486_ _x98484_)
                                  (begin
                                    (set-cdr! _prev98483_ _b98487_)
                                    (let ((_next-b98489_ (cdr _b98487_)))
                                      (if (eq? _b98487_ _endb98477_)
                                          (begin
                                            (set-cdr! _b98487_ _a98485_)
                                            _enda98475_)
                                          (_scan-b98480_
                                           _b98487_
                                           _x98484_
                                           _a98485_
                                           (car _next-b98489_)
                                           _next-b98489_))))
                                  (if (eq? _a98485_ _enda98475_)
                                      (begin
                                        (_maybe-set-cdr!98481_
                                         _a98485_
                                         _b98487_)
                                        _endb98477_)
                                      (let ((_next-a98491_ (cdr _a98485_)))
                                        (_scan-a98479_
                                         _a98485_
                                         (car _next-a98491_)
                                         _next-a98491_
                                         _y98486_
                                         _b98487_))))))
                           (_scan-b98480_
                            (lambda (_prev98493_
                                     _x98494_
                                     _a98495_
                                     _y98496_
                                     _b98497_)
                              (if (_elt<98424_ _y98496_ _x98494_)
                                  (if (eq? _b98497_ _endb98477_)
                                      (begin
                                        (set-cdr! _b98497_ _a98495_)
                                        _enda98475_)
                                      (let ((_next-b98499_ (cdr _b98497_)))
                                        (_scan-b98480_
                                         _b98497_
                                         _x98494_
                                         _a98495_
                                         (car _next-b98499_)
                                         _next-b98499_)))
                                  (begin
                                    (set-cdr! _prev98493_ _a98495_)
                                    (if (eq? _a98495_ _enda98475_)
                                        (begin
                                          (_maybe-set-cdr!98481_
                                           _a98495_
                                           _b98497_)
                                          _endb98477_)
                                        (let ((_next-a98501_ (cdr _a98495_)))
                                          (_scan-a98479_
                                           _a98495_
                                           (car _next-a98501_)
                                           _next-a98501_
                                           _y98496_
                                           _b98497_)))))))
                           (_maybe-set-cdr!98481_
                            (lambda (_pair98503_ _val98504_)
                              (if (not (eq? (cdr _pair98503_) _val98504_))
                                  (set-cdr! _pair98503_ _val98504_)
                                  '#!void))))
                    (let ((_x98506_ (car _a98474_)) (_y98507_ (car _b98476_)))
                      (if (_elt<98424_ _y98507_ _x98506_)
                          (values _b98476_
                                  (if (eq? _b98476_ _endb98477_)
                                      (begin
                                        (set-cdr! _b98476_ _a98474_)
                                        _enda98475_)
                                      (let ((_next-b98509_ (cdr _b98476_)))
                                        (_scan-b98480_
                                         _b98476_
                                         _x98506_
                                         _a98474_
                                         (car _next-b98509_)
                                         _next-b98509_))))
                          (values _a98474_
                                  (if (eq? _a98474_ _enda98475_)
                                      (begin
                                        (_maybe-set-cdr!98481_
                                         _a98474_
                                         _b98476_)
                                        _endb98477_)
                                      (let ((_next-a98511_ (cdr _a98474_)))
                                        (_scan-a98479_
                                         _a98474_
                                         (car _next-a98511_)
                                         _next-a98511_
                                         _y98507_
                                         _b98476_)))))))))
               (_grow98429_
                (lambda (_s98444_
                         _ends98445_
                         _ls98446_
                         _ls298447_
                         _u98448_
                         _lw98449_)
                  (if (and (pair? _u98448_) (< _ls98446_ _lw98449_))
                      (let ((_ls298457_
                             (let _lp98451_ ((_ls298453_ _ls298447_))
                               (let ((_ls2*298455_ (+ _ls298453_ _ls298453_)))
                                 (if (<= _ls2*298455_ _ls98446_)
                                     (_lp98451_ _ls2*298455_)
                                     _ls298453_)))))
                        (call-with-values
                         (lambda () (_getrun98427_ _u98448_))
                         (lambda (_lr98460_ _endr98461_ _u298462_)
                           (call-with-values
                            (lambda ()
                              (_grow98429_
                               _u98448_
                               _endr98461_
                               _lr98460_
                               '1
                               _u298462_
                               _ls298457_))
                            (lambda (_t98465_ _endt98466_ _lt98467_ _u398468_)
                              (call-with-values
                               (lambda ()
                                 (_merge!98428_
                                  _s98444_
                                  _ends98445_
                                  _t98465_
                                  _endt98466_))
                               (lambda (_st98471_ _end-st98472_)
                                 (_grow98429_
                                  _st98471_
                                  _end-st98472_
                                  (+ _ls98446_ _lt98467_)
                                  (+ _ls298457_ _ls298457_)
                                  _u398468_
                                  _lw98449_))))))))
                      (values _s98444_ _ends98445_ _ls98446_ _u98448_)))))
        (if (pair? _lis98425_)
            (call-with-values
             (lambda () (_getrun98427_ _lis98425_))
             (lambda (_lr98432_ _endr98433_ _rest98434_)
               (let ((_infinity98436_ '16777216))
                 (call-with-values
                  (lambda ()
                    (_grow98429_
                     _lis98425_
                     _endr98433_
                     _lr98432_
                     '1
                     _rest98434_
                     _infinity98436_))
                  (lambda (_a98439_ _enda98440_ _la98441_ _v98442_)
                    (set-cdr! _enda98440_ '())
                    _a98439_)))))
            '()))))
  (define std/srfi/132#list-merge
    (lambda (_<98409_ _a98410_ _b98411_)
      (if (not (pair? _a98410_))
          _b98411_
          (if (not (pair? _b98411_))
              _a98410_
              (let _recur98413_ ((_x98415_ (car _a98410_))
                                 (_a98416_ _a98410_)
                                 (_y98417_ (car _b98411_))
                                 (_b98418_ _b98411_))
                (if (_<98409_ _y98417_ _x98415_)
                    (let ((_b98420_ (cdr _b98418_)))
                      (if (pair? _b98420_)
                          (cons _y98417_
                                (_recur98413_
                                 _x98415_
                                 _a98416_
                                 (car _b98420_)
                                 _b98420_))
                          (cons _y98417_ _a98416_)))
                    (let ((_a98422_ (cdr _a98416_)))
                      (if (pair? _a98422_)
                          (cons _x98415_
                                (_recur98413_
                                 (car _a98422_)
                                 _a98422_
                                 _y98417_
                                 _b98418_))
                          (cons _x98415_ _b98418_)))))))))
  (define std/srfi/132#list-merge!
    (lambda (_<98378_ _a98379_ _b98380_)
      (letrec ((_scan-a98382_
                (lambda (_prev98385_ _a98386_ _x98387_ _b98388_ _y98389_)
                  (if (_<98378_ _y98389_ _x98387_)
                      (let ((_next-b98391_ (cdr _b98388_)))
                        (set-cdr! _prev98385_ _b98388_)
                        (if (pair? _next-b98391_)
                            (_scan-b98383_
                             _b98388_
                             _a98386_
                             _x98387_
                             _next-b98391_
                             (car _next-b98391_))
                            (set-cdr! _b98388_ _a98386_)))
                      (let ((_next-a98393_ (cdr _a98386_)))
                        (if (pair? _next-a98393_)
                            (_scan-a98382_
                             _a98386_
                             _next-a98393_
                             (car _next-a98393_)
                             _b98388_
                             _y98389_)
                            (set-cdr! _a98386_ _b98388_))))))
               (_scan-b98383_
                (lambda (_prev98395_ _a98396_ _x98397_ _b98398_ _y98399_)
                  (if (_<98378_ _y98399_ _x98397_)
                      (let ((_next-b98401_ (cdr _b98398_)))
                        (if (pair? _next-b98401_)
                            (_scan-b98383_
                             _b98398_
                             _a98396_
                             _x98397_
                             _next-b98401_
                             (car _next-b98401_))
                            (set-cdr! _b98398_ _a98396_)))
                      (let ((_next-a98403_ (cdr _a98396_)))
                        (set-cdr! _prev98395_ _a98396_)
                        (if (pair? _next-a98403_)
                            (_scan-a98382_
                             _a98396_
                             _next-a98403_
                             (car _next-a98403_)
                             _b98398_
                             _y98399_)
                            (set-cdr! _a98396_ _b98398_)))))))
        (if (not (pair? _a98379_))
            _b98380_
            (if (not (pair? _b98380_))
                _a98379_
                (if (_<98378_ (car _b98380_) (car _a98379_))
                    (begin
                      (let ((_next-b98405_ (cdr _b98380_)))
                        (if (null? _next-b98405_)
                            (set-cdr! _b98380_ _a98379_)
                            (_scan-b98383_
                             _b98380_
                             _a98379_
                             (car _a98379_)
                             _next-b98405_
                             (car _next-b98405_))))
                      _b98380_)
                    (begin
                      (let ((_next-a98407_ (cdr _a98379_)))
                        (if (null? _next-a98407_)
                            (set-cdr! _a98379_ _b98380_)
                            (_scan-a98382_
                             _a98379_
                             _next-a98407_
                             (car _next-a98407_)
                             _b98380_
                             (car _b98380_))))
                      _a98379_)))))))
  (define std/srfi/132#list-sorted?
    (lambda (_<98362_ _list98363_)
      (let ((_$e98365_ (not (pair? _list98363_))))
        (if _$e98365_
            _$e98365_
            (let _lp98368_ ((_prev98370_ (car _list98363_))
                            (_tail98371_ (cdr _list98363_)))
              (let ((_$e98373_ (not (pair? _tail98371_))))
                (if _$e98373_
                    _$e98373_
                    (let ((_next98376_ (car _tail98371_)))
                      (if (not (_<98362_ _next98376_ _prev98370_))
                          (_lp98368_ _next98376_ (cdr _tail98371_))
                          '#f)))))))))
  (define std/srfi/132#vector-sorted?
    (lambda (_elt<98341_ _v98342_ . _maybe-start+end98343_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v98342_ _maybe-start+end98343_))
       (lambda (_start98346_ _end98347_)
         (let ((_$e98349_ (>= _start98346_ _end98347_)))
           (if _$e98349_
               _$e98349_
               (let _lp98352_ ((_i98354_ (+ _start98346_ '1))
                               (_vi-198355_
                                (vector-ref _v98342_ _start98346_)))
                 (let ((_$e98357_ (>= _i98354_ _end98347_)))
                   (if _$e98357_
                       _$e98357_
                       (let ((_vi98360_ (vector-ref _v98342_ _i98354_)))
                         (if (not (_elt<98341_ _vi98360_ _vi-198355_))
                             (_lp98352_ (+ _i98354_ '1) _vi98360_)
                             '#f)))))))))))
  (define std/srfi/132#vector-portion-copy
    (lambda (_vec98324_ _start98325_ _end98326_)
      (let* ((_len98328_ (vector-length _vec98324_))
             (_new-len98330_ (- _end98326_ _start98325_))
             (_new98332_ (make-vector _new-len98330_)))
        (let _$loop98335_ ((_i98338_ _start98325_) (_j98339_ '0))
          (if (= _i98338_ _end98326_)
              _new98332_
              (begin
                (vector-set!
                 _new98332_
                 _j98339_
                 (vector-ref _vec98324_ _i98338_))
                (_$loop98335_ (+ _i98338_ '1) (+ _j98339_ '1))))))))
  (define std/srfi/132#vector-copy
    (lambda (_vec98322_)
      (std/srfi/132#vector-portion-copy
       _vec98322_
       '0
       (vector-length _vec98322_))))
  (define std/srfi/132#vector-portion-copy!
    (lambda (_target98309_ _src98310_ _start98311_ _end98312_)
      (let ((_len98314_ (- _end98312_ _start98311_)))
        (let _$loop98316_ ((_i98319_ (- _len98314_ '1))
                           (_j98320_ (- _end98312_ '1)))
          (if (< _i98319_ '0)
              '#!void
              (begin
                (vector-set!
                 _target98309_
                 _i98319_
                 (vector-ref _src98310_ _j98320_))
                (_$loop98316_ (- _i98319_ '1) (- _j98320_ '1))))))))
  (define std/srfi/132#has-element
    (lambda (_list98306_ _index98307_)
      (if (zero? _index98307_)
          (if (pair? _list98306_)
              (values '#t (car _list98306_))
              (values '#f '#f))
          (if (null? _list98306_)
              (values '#f '#f)
              (std/srfi/132#has-element
               (cdr _list98306_)
               (- _index98307_ '1))))))
  (define std/srfi/132#list-ref-or-default
    (lambda (_list98298_ _index98299_ _default98300_)
      (call-with-values
       (lambda () (std/srfi/132#has-element _list98298_ _index98299_))
       (lambda (_has?98303_ _maybe98304_)
         (if _has?98303_ _maybe98304_ _default98300_)))))
  (define std/srfi/132#vector-start+end
    (lambda (_vector98292_ _maybe-start+end98293_)
      (let ((_start98295_
             (std/srfi/132#list-ref-or-default _maybe-start+end98293_ '0 '0))
            (_end98296_
             (std/srfi/132#list-ref-or-default
              _maybe-start+end98293_
              '1
              (vector-length _vector98292_))))
        (values _start98295_ _end98296_))))
  (define std/srfi/132#vectors-start+end-2
    (lambda (_vector-198283_ _vector-298284_ _maybe-start+end98285_)
      (let ((_start-198287_
             (std/srfi/132#list-ref-or-default _maybe-start+end98285_ '0 '0))
            (_end-198288_
             (std/srfi/132#list-ref-or-default
              _maybe-start+end98285_
              '1
              (vector-length _vector-198283_)))
            (_start-298289_
             (std/srfi/132#list-ref-or-default _maybe-start+end98285_ '2 '0))
            (_end-298290_
             (std/srfi/132#list-ref-or-default
              _maybe-start+end98285_
              '3
              (vector-length _vector-298284_))))
        (values _start-198287_ _end-198288_ _start-298289_ _end-298290_))))
  (define std/srfi/132#really-vector-heap-sort!
    (lambda (_elt<98233_ _v98234_ _start98235_ _end98236_)
      (letrec ((_restore-heap!98238_
                (lambda (_end98254_ _i98255_)
                  (let* ((_vi98257_ (vector-ref _v98234_ _i98255_))
                         (_first-leaf98259_
                          (quotient (+ _start98235_ _end98254_) '2))
                         (_final-k98280_
                          (let _lp98261_ ((_k98263_ _i98255_))
                            (if (>= _k98263_ _first-leaf98259_)
                                _k98263_
                                (let* ((_k*2-start98265_
                                        (+ _k98263_ (- _k98263_ _start98235_)))
                                       (_child198267_ (+ '1 _k*2-start98265_))
                                       (_child298269_ (+ '2 _k*2-start98265_))
                                       (_child1-val98271_
                                        (vector-ref _v98234_ _child198267_)))
                                  (call-with-values
                                   (lambda ()
                                     (if (< _child298269_ _end98254_)
                                         (let ((_child2-val98275_
                                                (vector-ref
                                                 _v98234_
                                                 _child298269_)))
                                           (if (_elt<98233_
                                                _child2-val98275_
                                                _child1-val98271_)
                                               (values _child198267_
                                                       _child1-val98271_)
                                               (values _child298269_
                                                       _child2-val98275_)))
                                         (values _child198267_
                                                 _child1-val98271_)))
                                   (lambda (_max-child98277_
                                            _max-child-val98278_)
                                     (if (_elt<98233_
                                          _vi98257_
                                          _max-child-val98278_)
                                         (begin
                                           (vector-set!
                                            _v98234_
                                            _k98263_
                                            _max-child-val98278_)
                                           (_lp98261_ _max-child98277_))
                                         _k98263_))))))))
                    (vector-set! _v98234_ _final-k98280_ _vi98257_)))))
        (let ((_first-leaf98240_ (quotient (+ _start98235_ _end98236_) '2)))
          (let _$loop98242_ ((_i98245_ (- _first-leaf98240_ '1)))
            (if (< _i98245_ _start98235_)
                '#!void
                (begin
                  (_restore-heap!98238_ _end98236_ _i98245_)
                  (_$loop98242_ (- _i98245_ '1))))))
        (let _$loop98247_ ((_i98250_ (- _end98236_ '1)))
          (if (<= _i98250_ _start98235_)
              '#!void
              (begin
                (let ((_top98252_ (vector-ref _v98234_ _start98235_)))
                  (vector-set!
                   _v98234_
                   _start98235_
                   (vector-ref _v98234_ _i98250_))
                  (vector-set! _v98234_ _i98250_ _top98252_)
                  (_restore-heap!98238_ _i98250_ _start98235_))
                (_$loop98247_ (- _i98250_ '1))))))))
  (define std/srfi/132#vector-heap-sort!
    (lambda (_elt<98225_ _v98226_ . _maybe-start+end98227_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v98226_ _maybe-start+end98227_))
       (lambda (_start98230_ _end98231_)
         (std/srfi/132#really-vector-heap-sort!
          _elt<98225_
          _v98226_
          _start98230_
          _end98231_)))))
  (define std/srfi/132#vector-heap-sort
    (lambda (_elt<98215_ _v98216_ . _maybe-start+end98217_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v98216_ _maybe-start+end98217_))
       (lambda (_start98220_ _end98221_)
         (let ((_ans98223_
                (std/srfi/132#vector-portion-copy
                 _v98216_
                 _start98220_
                 _end98221_)))
           (std/srfi/132#really-vector-heap-sort!
            _elt<98215_
            _ans98223_
            '0
            (- _end98221_ _start98220_))
           _ans98223_)))))
  (define std/srfi/132#vector-insert-sort
    (lambda (_elt<98205_ _v98206_ . _maybe-start+end98207_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v98206_ _maybe-start+end98207_))
       (lambda (_start98210_ _end98211_)
         (let ((_ans98213_
                (std/srfi/132#vector-portion-copy
                 _v98206_
                 _start98210_
                 _end98211_)))
           (std/srfi/132#%vector-insert-sort!
            _elt<98205_
            _ans98213_
            '0
            (- _end98211_ _start98210_))
           _ans98213_)))))
  (define std/srfi/132#vector-insert-sort!
    (lambda (_<98197_ _v98198_ . _maybe-start+end98199_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v98198_ _maybe-start+end98199_))
       (lambda (_start98202_ _end98203_)
         (std/srfi/132#%vector-insert-sort!
          _<98197_
          _v98198_
          _start98202_
          _end98203_)))))
  (define std/srfi/132#%vector-insert-sort!
    (lambda (_elt<98176_ _v98177_ _start98178_ _end98179_)
      (let _$loop98181_ ((_i98184_ (+ '1 _start98178_)))
        (if (>= _i98184_ _end98179_)
            '#!void
            (begin
              (let ((_val98186_ (vector-ref _v98177_ _i98184_)))
                (vector-set!
                 _v98177_
                 (let _lp98188_ ((_j98190_ _i98184_))
                   (if (<= _j98190_ _start98178_)
                       _start98178_
                       (let* ((_j-198192_ (- _j98190_ '1))
                              (_vj-198194_ (vector-ref _v98177_ _j-198192_)))
                         (if (_elt<98176_ _val98186_ _vj-198194_)
                             (begin
                               (vector-set! _v98177_ _j98190_ _vj-198194_)
                               (_lp98188_ _j-198192_))
                             _j98190_))))
                 _val98186_))
              (_$loop98181_ (+ _i98184_ '1)))))))
  (define std/srfi/132#vector-merge
    (lambda (_<98163_ _v198164_ _v298165_ . _maybe-starts+ends98166_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vectors-start+end-2
          _v198164_
          _v298165_
          _maybe-starts+ends98166_))
       (lambda (_start198169_ _end198170_ _start298171_ _end298172_)
         (let ((_ans98174_
                (make-vector
                 (+ (- _end198170_ _start198169_)
                    (- _end298172_ _start298171_)))))
           (std/srfi/132#%vector-merge!
            _<98163_
            _ans98174_
            _v198164_
            _v298165_
            '0
            _start198169_
            _end198170_
            _start298171_
            _end298172_)
           _ans98174_)))))
  (define std/srfi/132#vector-merge!
    (lambda (_<98147_ _v98148_ _v198149_ _v298150_ . _maybe-starts+ends98151_)
      (call-with-values
       (lambda ()
         (if (pair? _maybe-starts+ends98151_)
             (values (car _maybe-starts+ends98151_)
                     (cdr _maybe-starts+ends98151_))
             (values '0 '())))
       (lambda (_start98154_ _rest98155_)
         (call-with-values
          (lambda ()
            (std/srfi/132#vectors-start+end-2 _v198149_ _v298150_ _rest98155_))
          (lambda (_start198158_ _end198159_ _start298160_ _end298161_)
            (std/srfi/132#%vector-merge!
             _<98147_
             _v98148_
             _v198149_
             _v298150_
             _start98154_
             _start198158_
             _end198159_
             _start298160_
             _end298161_)))))))
  (define std/srfi/132#%vector-merge!
    (lambda (_elt<98109_
             _v98110_
             _v198111_
             _v298112_
             _start98113_
             _start198114_
             _end198115_
             _start298116_
             _end298117_)
      (letrec ((_vblit98119_
                (lambda (_fromv98121_ _j98122_ _i98123_ _end98124_)
                  (let _lp98126_ ((_j98128_ _j98122_) (_i98129_ _i98123_))
                    (vector-set!
                     _v98110_
                     _i98129_
                     (vector-ref _fromv98121_ _j98128_))
                    (let ((_j98131_ (+ _j98128_ '1)))
                      (if (< _j98131_ _end98124_)
                          (_lp98126_ _j98131_ (+ _i98129_ '1))
                          '#!void))))))
        (if (<= _end198115_ _start198114_)
            (if (< _start298116_ _end298117_)
                (_vblit98119_ _v298112_ _start298116_ _start98113_ _end298117_)
                '#!void)
            (if (<= _end298117_ _start298116_)
                (_vblit98119_ _v198111_ _start198114_ _start98113_ _end198115_)
                (let _lp98133_ ((_i98135_ _start98113_)
                                (_j98136_ _start198114_)
                                (_x98137_ (vector-ref _v198111_ _start198114_))
                                (_k98138_ _start298116_)
                                (_y98139_
                                 (vector-ref _v298112_ _start298116_)))
                  (let ((_i198141_ (+ _i98135_ '1)))
                    (if (_elt<98109_ _y98139_ _x98137_)
                        (let ((_k98143_ (+ _k98138_ '1)))
                          (vector-set! _v98110_ _i98135_ _y98139_)
                          (if (< _k98143_ _end298117_)
                              (_lp98133_
                               _i198141_
                               _j98136_
                               _x98137_
                               _k98143_
                               (vector-ref _v298112_ _k98143_))
                              (_vblit98119_
                               _v198111_
                               _j98136_
                               _i198141_
                               _end198115_)))
                        (let ((_j98145_ (+ _j98136_ '1)))
                          (vector-set! _v98110_ _i98135_ _x98137_)
                          (if (< _j98145_ _end198115_)
                              (_lp98133_
                               _i198141_
                               _j98145_
                               (vector-ref _v198111_ _j98145_)
                               _k98138_
                               _y98139_)
                              (_vblit98119_
                               _v298112_
                               _k98138_
                               _i198141_
                               _end298117_)))))))))))
  (define std/srfi/132#vector-merge-sort!
    (lambda (_<98099_ _v98100_ . _maybe-args98101_)
      (call-with-values
       (lambda () (std/srfi/132#vector-start+end _v98100_ _maybe-args98101_))
       (lambda (_start98104_ _end98105_)
         (let ((_temp98107_
                (if (and (pair? _maybe-args98101_)
                         (pair? (cdr _maybe-args98101_))
                         (pair? (cddr _maybe-args98101_)))
                    (caddr _maybe-args98101_)
                    (std/srfi/132#vector-copy _v98100_))))
           (std/srfi/132#%vector-merge-sort!
            _<98099_
            _v98100_
            _start98104_
            _end98105_
            _temp98107_))))))
  (define std/srfi/132#vector-merge-sort
    (lambda (_<98089_ _v98090_ . _maybe-args98091_)
      (call-with-values
       (lambda () (std/srfi/132#vector-start+end _v98090_ _maybe-args98091_))
       (lambda (_start98094_ _end98095_)
         (let ((_ans98097_ (subvector _v98090_ _start98094_ _end98095_)))
           (std/srfi/132#vector-merge-sort! _<98089_ _ans98097_)
           _ans98097_)))))
  (define std/srfi/132#%vector-merge-sort!
    (lambda (_elt<97987_ _v097988_ _l97989_ _r97990_ _temp097991_)
      (letrec ((_xor97993_
                (lambda (_a98086_ _b98087_) (not (eq? _a98086_ _b98087_))))
               (_merge97994_
                (lambda (_target98045_
                         _v198046_
                         _v298047_
                         _l98048_
                         _len198049_
                         _len298050_
                         _v2=target?98051_)
                  (letrec ((_vblit98053_
                            (lambda (_fromv98055_ _j98056_ _i98057_ _end98058_)
                              (let _lp98060_ ((_j98062_ _j98056_)
                                              (_i98063_ _i98057_))
                                (vector-set!
                                 _target98045_
                                 _i98063_
                                 (vector-ref _fromv98055_ _j98062_))
                                (let ((_j98065_ (+ _j98062_ '1)))
                                  (if (< _j98065_ _end98058_)
                                      (_lp98060_ _j98065_ (+ _i98063_ '1))
                                      '#!void))))))
                    (let* ((_r198067_ (+ _l98048_ _len198049_))
                           (_r298069_ (+ _r198067_ _len298050_)))
                      (let _lp98072_ ((_n98074_ _l98048_)
                                      (_j98075_ _l98048_)
                                      (_x98076_
                                       (vector-ref _v198046_ _l98048_))
                                      (_k98077_ _r198067_)
                                      (_y98078_
                                       (vector-ref _v298047_ _r198067_)))
                        (let ((_n+198080_ (+ _n98074_ '1)))
                          (if (_elt<97987_ _y98078_ _x98076_)
                              (let ((_k98082_ (+ _k98077_ '1)))
                                (vector-set! _target98045_ _n98074_ _y98078_)
                                (if (< _k98082_ _r298069_)
                                    (_lp98072_
                                     _n+198080_
                                     _j98075_
                                     _x98076_
                                     _k98082_
                                     (vector-ref _v298047_ _k98082_))
                                    (_vblit98053_
                                     _v198046_
                                     _j98075_
                                     _n+198080_
                                     _r198067_)))
                              (let ((_j98084_ (+ _j98075_ '1)))
                                (vector-set! _target98045_ _n98074_ _x98076_)
                                (if (< _j98084_ _r198067_)
                                    (_lp98072_
                                     _n+198080_
                                     _j98084_
                                     (vector-ref _v198046_ _j98084_)
                                     _k98077_
                                     _y98078_)
                                    (if (not _v2=target?98051_)
                                        (_vblit98053_
                                         _v298047_
                                         _k98077_
                                         _n+198080_
                                         _r298069_)
                                        '#!void))))))))))
               (_getrun97995_
                (lambda (_v98034_ _l98035_ _r98036_)
                  (let _lp98038_ ((_i98040_ (+ _l98035_ '1))
                                  (_x98041_ (vector-ref _v98034_ _l98035_)))
                    (if (>= _i98040_ _r98036_)
                        (- _i98040_ _l98035_)
                        (let ((_y98043_ (vector-ref _v98034_ _i98040_)))
                          (if (_elt<97987_ _y98043_ _x98041_)
                              (- _i98040_ _l98035_)
                              (_lp98038_ (+ _i98040_ '1) _y98043_))))))))
        (if (< _l97989_ _r97990_)
            (call-with-values
             (lambda ()
               (let _recur97998_ ((_l98000_ _l97989_)
                                  (_want98001_ (- _r97990_ _l97989_)))
                 (let ((_len98003_ (- _r97990_ _l98000_)))
                   (let _lp98005_ ((_pfxlen98007_
                                    (_getrun97995_
                                     _v097988_
                                     _l98000_
                                     _r97990_))
                                   (_pfxlen298008_ '1)
                                   (_v98009_ _v097988_)
                                   (_temp98010_ _temp097991_)
                                   (_v=v0?98011_ '#t))
                     (if (or (>= _pfxlen98007_ _want98001_)
                             (= _pfxlen98007_ _len98003_))
                         (values _pfxlen98007_ _v98009_ _v=v0?98011_)
                         (let ((_pfxlen298022_
                                (let _lp98016_ ((_j98018_ _pfxlen298008_))
                                  (let ((_j*298020_ (+ _j98018_ _j98018_)))
                                    (if (<= _j98018_ _pfxlen98007_)
                                        (_lp98016_ _j*298020_)
                                        _j98018_))))
                               (_tail-len98023_ (- _len98003_ _pfxlen98007_)))
                           (call-with-values
                            (lambda ()
                              (_recur97998_
                               (+ _pfxlen98007_ _l98000_)
                               _pfxlen298022_))
                            (lambda (_nr-len98026_
                                     _nr-vec98027_
                                     _nrvec=v0?98028_)
                              (_merge97994_
                               _temp98010_
                               _v98009_
                               _nr-vec98027_
                               _l98000_
                               _pfxlen98007_
                               _nr-len98026_
                               (_xor97993_ _nrvec=v0?98028_ _v=v0?98011_))
                              (_lp98005_
                               (+ _pfxlen98007_ _nr-len98026_)
                               (+ _pfxlen298022_ _pfxlen298022_)
                               _temp98010_
                               _v98009_
                               (not _v=v0?98011_))))))))))
             (lambda (_ignored-len98030_
                      _ignored-ansvec98031_
                      _ansvec=v0?98032_)
               (if (not _ansvec=v0?98032_)
                   (subvector-move!
                    _v097988_
                    _l97989_
                    _temp097991_
                    _l97989_
                    _r97990_)
                   '#!void)))
            '#!void))))
  (define std/srfi/132#vector-quick-sort!
    (lambda (_<97979_ _v97980_ . _maybe-start+end97981_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v97980_ _maybe-start+end97981_))
       (lambda (_start97984_ _end97985_)
         (std/srfi/132#%quick-sort!
          _<97979_
          _v97980_
          _start97984_
          _end97985_)))))
  (define std/srfi/132#vector-quick-sort
    (lambda (_<97969_ _v97970_ . _maybe-start+end97971_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v97970_ _maybe-start+end97971_))
       (lambda (_start97974_ _end97975_)
         (let ((_ans97977_ (make-vector (- _end97975_ _start97974_))))
           (std/srfi/132#vector-portion-copy!
            _ans97977_
            _v97970_
            _start97974_
            _end97975_)
           (std/srfi/132#%quick-sort!
            _<97969_
            _ans97977_
            '0
            (- _end97975_ _start97974_))
           _ans97977_)))))
  (define std/srfi/132#%quick-sort!
    (lambda (_elt<97899_ _v97900_ _start97901_ _end97902_)
      (letrec ((_swap97904_
                (lambda (_l97962_ _r97963_ _n97964_)
                  (if (> _n97964_ '0)
                      (let ((_x97966_ (vector-ref _v97900_ _l97962_))
                            (_r-197967_ (- _r97963_ '1)))
                        (vector-set!
                         _v97900_
                         _l97962_
                         (vector-ref _v97900_ _r-197967_))
                        (vector-set! _v97900_ _r-197967_ _x97966_)
                        (_swap97904_
                         (+ _l97962_ '1)
                         _r-197967_
                         (- _n97964_ '1)))
                      '#!void)))
               (_median97905_
                (lambda (_v197954_ _v297955_ _v397956_)
                  (call-with-values
                   (lambda ()
                     (if (_elt<97899_ _v197954_ _v297955_)
                         (values _v197954_ _v297955_)
                         (values _v297955_ _v197954_)))
                   (lambda (_little97959_ _big97960_)
                     (if (_elt<97899_ _big97960_ _v397956_)
                         _big97960_
                         (if (_elt<97899_ _little97959_ _v397956_)
                             _v397956_
                             _little97959_)))))))
        (let _recur97907_ ((_l97909_ _start97901_) (_r97910_ _end97902_))
          (if (< '10 (- _r97910_ _l97909_))
              (let ((_pivot97912_
                     (_median97905_
                      (vector-ref _v97900_ _l97909_)
                      (vector-ref _v97900_ (quotient (+ _l97909_ _r97910_) '2))
                      (vector-ref _v97900_ (- _r97910_ '1)))))
                (letrec ((_lscan97914_
                          (lambda (_i97918_ _j97919_ _k97920_ _m97921_)
                            (let _lp97923_ ((_i97925_ _i97918_)
                                            (_j97926_ _j97919_))
                              (if (> _j97926_ _k97920_)
                                  (_done97916_ _i97925_ _j97926_ _m97921_)
                                  (let ((_x97928_
                                         (vector-ref _v97900_ _j97926_)))
                                    (if (_elt<97899_ _x97928_ _pivot97912_)
                                        (_lp97923_ _i97925_ (+ _j97926_ '1))
                                        (if (_elt<97899_ _pivot97912_ _x97928_)
                                            (_rscan97915_
                                             _i97925_
                                             _j97926_
                                             _k97920_
                                             _m97921_)
                                            (begin
                                              (if (< _i97925_ _j97926_)
                                                  (begin
                                                    (vector-set!
                                                     _v97900_
                                                     _j97926_
                                                     (vector-ref
                                                      _v97900_
                                                      _i97925_))
                                                    (vector-set!
                                                     _v97900_
                                                     _i97925_
                                                     _x97928_))
                                                  '#!void)
                                              (_lp97923_
                                               (+ _i97925_ '1)
                                               (+ _j97926_ '1))))))))))
                         (_rscan97915_
                          (lambda (_i97930_ _j97931_ _k97932_ _m97933_)
                            (let _lp97935_ ((_k97937_ _k97932_)
                                            (_m97938_ _m97933_))
                              (if (<= _k97937_ _j97931_)
                                  (_done97916_ _i97930_ _j97931_ _m97938_)
                                  (let ((_x97940_
                                         (vector-ref _v97900_ _k97937_)))
                                    (if (_elt<97899_ _pivot97912_ _x97940_)
                                        (_lp97935_ (- _k97937_ '1) _m97938_)
                                        (if (_elt<97899_ _x97940_ _pivot97912_)
                                            (begin
                                              (vector-set!
                                               _v97900_
                                               _k97937_
                                               (vector-ref _v97900_ _j97931_))
                                              (vector-set!
                                               _v97900_
                                               _j97931_
                                               _x97940_)
                                              (_lscan97914_
                                               _i97930_
                                               (+ _j97931_ '1)
                                               (- _k97937_ '1)
                                               _m97938_))
                                            (begin
                                              (if (< _k97937_ _m97938_)
                                                  (begin
                                                    (vector-set!
                                                     _v97900_
                                                     _k97937_
                                                     (vector-ref
                                                      _v97900_
                                                      _m97938_))
                                                    (vector-set!
                                                     _v97900_
                                                     _m97938_
                                                     _x97940_))
                                                  '#!void)
                                              (_lp97935_
                                               (- _k97937_ '1)
                                               (- _m97938_ '1))))))))))
                         (_done97916_
                          (lambda (_i97943_ _j97944_ _m97945_)
                            (let ((_num<97947_ (- _j97944_ _i97943_))
                                  (_num>97948_ (+ '1 (- _m97945_ _j97944_)))
                                  (_num=l97949_ (- _i97943_ _l97909_))
                                  (_num=r97950_ (- (- _r97910_ _m97945_) '1)))
                              (_swap97904_
                               _l97909_
                               _j97944_
                               (min _num<97947_ _num=l97949_))
                              (_swap97904_
                               _j97944_
                               _r97910_
                               (min _num>97948_ _num=r97950_))
                              (if (<= _num<97947_ _num>97948_)
                                  (begin
                                    (_recur97907_
                                     _l97909_
                                     (+ _l97909_ _num<97947_))
                                    (_recur97907_
                                     (- _r97910_ _num>97948_)
                                     _r97910_))
                                  (begin
                                    (_recur97907_
                                     (- _r97910_ _num>97948_)
                                     _r97910_)
                                    (_recur97907_
                                     _l97909_
                                     (+ _l97909_ _num<97947_))))))))
                  (let ((_r-197952_ (- _r97910_ '1)))
                    (_lscan97914_ _l97909_ _l97909_ _r-197952_ _r-197952_))))
              (std/srfi/132#%vector-insert-sort!
               _elt<97899_
               _v97900_
               _l97909_
               _r97910_))))))
  (define std/srfi/132#vector-quick-sort3!
    (lambda (_c97891_ _v97892_ . _maybe-start+end97893_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v97892_ _maybe-start+end97893_))
       (lambda (_start97896_ _end97897_)
         (std/srfi/132#%quick-sort3!
          _c97891_
          _v97892_
          _start97896_
          _end97897_)))))
  (define std/srfi/132#vector-quick-sort3
    (lambda (_c97881_ _v97882_ . _maybe-start+end97883_)
      (call-with-values
       (lambda ()
         (std/srfi/132#vector-start+end _v97882_ _maybe-start+end97883_))
       (lambda (_start97886_ _end97887_)
         (let ((_ans97889_ (make-vector (- _end97887_ _start97886_))))
           (std/srfi/132#vector-portion-copy!
            _ans97889_
            _v97882_
            _start97886_
            _end97887_)
           (std/srfi/132#%quick-sort3!
            _c97881_
            _ans97889_
            '0
            (- _end97887_ _start97886_))
           _ans97889_)))))
  (define std/srfi/132#%quick-sort3!
    (lambda (_c97790_ _v97791_ _start97792_ _end97793_)
      (letrec ((_swap97795_
                (lambda (_l97874_ _r97875_ _n97876_)
                  (if (> _n97876_ '0)
                      (let ((_x97878_ (vector-ref _v97791_ _l97874_))
                            (_r-197879_ (- _r97875_ '1)))
                        (vector-set!
                         _v97791_
                         _l97874_
                         (vector-ref _v97791_ _r-197879_))
                        (vector-set! _v97791_ _r-197879_ _x97878_)
                        (_swap97795_
                         (+ _l97874_ '1)
                         _r-197879_
                         (- _n97876_ '1)))
                      '#!void)))
               (_sort397796_
                (lambda (_v197866_ _v297867_ _v397868_)
                  (call-with-values
                   (lambda ()
                     (if (< (_c97790_ _v197866_ _v297867_) '0)
                         (values _v197866_ _v297867_)
                         (values _v297867_ _v197866_)))
                   (lambda (_little97871_ _big97872_)
                     (if (< (_c97790_ _big97872_ _v397868_) '0)
                         (values _little97871_ _big97872_ _v397868_)
                         (if (< (_c97790_ _little97871_ _v397868_) '0)
                             (values _little97871_ _v397868_ _big97872_)
                             (values _v397868_ _little97871_ _big97872_)))))))
               (_elt<97797_
                (lambda (_v197863_ _v297864_)
                  (negative? (_c97790_ _v197863_ _v297864_)))))
        (let _recur97799_ ((_l97801_ _start97792_) (_r97802_ _end97793_))
          (if (< '10 (- _r97802_ _l97801_))
              (let* ((_r-197804_ (- _r97802_ '1))
                     (_mid97806_ (quotient (+ _l97801_ _r97802_) '2))
                     (_l+197808_ (+ _l97801_ '1))
                     (_pivot97817_
                      (call-with-values
                       (lambda ()
                         (_sort397796_
                          (vector-ref _v97791_ _l97801_)
                          (vector-ref _v97791_ _mid97806_)
                          (vector-ref _v97791_ _r-197804_)))
                       (lambda (_lo97811_ _piv97812_ _hi97813_)
                         (let ((_tmp97815_ (vector-ref _v97791_ _l+197808_)))
                           (vector-set! _v97791_ _l97801_ _piv97812_)
                           (vector-set! _v97791_ _r-197804_ _hi97813_)
                           (vector-set! _v97791_ _l+197808_ _lo97811_)
                           (vector-set! _v97791_ _mid97806_ _tmp97815_)
                           _piv97812_)))))
                (letrec ((_lscan97820_
                          (lambda (_i97824_ _j97825_ _k97826_ _m97827_)
                            (let _lp97829_ ((_i97831_ _i97824_)
                                            (_j97832_ _j97825_))
                              (if (> _j97832_ _k97826_)
                                  (_done97822_ _i97831_ _j97832_ _m97827_)
                                  (let* ((_x97834_
                                          (vector-ref _v97791_ _j97832_))
                                         (_sign97836_
                                          (_c97790_ _x97834_ _pivot97817_)))
                                    (if (< _sign97836_ '0)
                                        (_lp97829_ _i97831_ (+ _j97832_ '1))
                                        (if (= _sign97836_ '0)
                                            (begin
                                              (if (< _i97831_ _j97832_)
                                                  (begin
                                                    (vector-set!
                                                     _v97791_
                                                     _j97832_
                                                     (vector-ref
                                                      _v97791_
                                                      _i97831_))
                                                    (vector-set!
                                                     _v97791_
                                                     _i97831_
                                                     _x97834_))
                                                  '#!void)
                                              (_lp97829_
                                               (+ _i97831_ '1)
                                               (+ _j97832_ '1)))
                                            (if (> _sign97836_ '0)
                                                (_rscan97821_
                                                 _i97831_
                                                 _j97832_
                                                 _k97826_
                                                 _m97827_)
                                                '#!void))))))))
                         (_rscan97821_
                          (lambda (_i97839_ _j97840_ _k97841_ _m97842_)
                            (let _lp97844_ ((_k97846_ _k97841_)
                                            (_m97847_ _m97842_))
                              (if (<= _k97846_ _j97840_)
                                  (_done97822_ _i97839_ _j97840_ _m97847_)
                                  (let* ((_x97849_
                                          (vector-ref _v97791_ _k97846_))
                                         (_sign97851_
                                          (_c97790_ _x97849_ _pivot97817_)))
                                    (if (> _sign97851_ '0)
                                        (_lp97844_ (- _k97846_ '1) _m97847_)
                                        (if (= _sign97851_ '0)
                                            (begin
                                              (if (< _k97846_ _m97847_)
                                                  (begin
                                                    (vector-set!
                                                     _v97791_
                                                     _k97846_
                                                     (vector-ref
                                                      _v97791_
                                                      _m97847_))
                                                    (vector-set!
                                                     _v97791_
                                                     _m97847_
                                                     _x97849_))
                                                  '#!void)
                                              (_lp97844_
                                               (- _k97846_ '1)
                                               (- _m97847_ '1)))
                                            (if (< _sign97851_ '0)
                                                (begin
                                                  (vector-set!
                                                   _v97791_
                                                   _k97846_
                                                   (vector-ref
                                                    _v97791_
                                                    _j97840_))
                                                  (vector-set!
                                                   _v97791_
                                                   _j97840_
                                                   _x97849_)
                                                  (_lscan97820_
                                                   _i97839_
                                                   (+ _j97840_ '1)
                                                   (- _k97846_ '1)
                                                   _m97847_))
                                                '#!void))))))))
                         (_done97822_
                          (lambda (_i97854_ _j97855_ _m97856_)
                            (let ((_num<97858_ (- _j97855_ _i97854_))
                                  (_num>97859_ (+ '1 (- _m97856_ _j97855_)))
                                  (_num=l97860_ (- _i97854_ _l97801_))
                                  (_num=r97861_ (- (- _r97802_ _m97856_) '1)))
                              (_swap97795_
                               _l97801_
                               _j97855_
                               (min _num<97858_ _num=l97860_))
                              (_swap97795_
                               _j97855_
                               _r97802_
                               (min _num>97859_ _num=r97861_))
                              (if (<= _num<97858_ _num>97859_)
                                  (begin
                                    (_recur97799_
                                     _l97801_
                                     (+ _l97801_ _num<97858_))
                                    (_recur97799_
                                     (- _r97802_ _num>97859_)
                                     _r97802_))
                                  (begin
                                    (_recur97799_
                                     (- _r97802_ _num>97859_)
                                     _r97802_)
                                    (_recur97799_
                                     _l97801_
                                     (+ _l97801_ _num<97858_))))))))
                  (_lscan97820_
                   _l+197808_
                   (+ _l97801_ '2)
                   (- _r97802_ '2)
                   _r-197804_)))
              (std/srfi/132#%vector-insert-sort!
               _elt<97797_
               _v97791_
               _l97801_
               _r97802_))))))
  (define std/srfi/132#list-sort
    (lambda (_<97785_ _l97786_)
      (let ((_v97788_ (list->vector _l97786_)))
        (std/srfi/132#vector-heap-sort! _<97785_ _v97788_)
        (vector->list _v97788_))))
  (define std/srfi/132#list-sort! std/srfi/132#list-merge-sort!)
  (define std/srfi/132#list-stable-sort std/srfi/132#list-merge-sort)
  (define std/srfi/132#list-stable-sort! std/srfi/132#list-merge-sort!)
  (define std/srfi/132#vector-sort std/srfi/132#vector-quick-sort)
  (define std/srfi/132#vector-sort! std/srfi/132#vector-quick-sort!)
  (define std/srfi/132#vector-stable-sort std/srfi/132#vector-merge-sort)
  (define std/srfi/132#vector-stable-sort! std/srfi/132#vector-merge-sort!)
  (define std/srfi/132#vector-find-median
    (lambda (_<97768_ _v97769_ _knil97770_ . _rest97771_)
      (let* ((_mean97776_
              (if (null? _rest97771_)
                  (lambda (_a97773_ _b97774_) (/ (+ _a97773_ _b97774_) '2))
                  (car _rest97771_)))
             (_n97778_ (vector-length _v97769_)))
        (if (zero? _n97778_)
            _knil97770_
            (if (odd? _n97778_)
                (std/srfi/132#%vector-select
                 _<97768_
                 _v97769_
                 (quotient _n97778_ '2)
                 '0
                 _n97778_)
                (call-with-values
                 (lambda ()
                   (std/srfi/132#%vector-select2
                    _<97768_
                    _v97769_
                    (- (quotient _n97778_ '2) '1)
                    '0
                    _n97778_))
                 (lambda (_a97782_ _b97783_)
                   (_mean97776_ _a97782_ _b97783_))))))))
  (define std/srfi/132#vector-find-median!
    (lambda (_<97755_ _v97756_ _knil97757_ . _rest97758_)
      (let* ((_mean97763_
              (if (null? _rest97758_)
                  (lambda (_a97760_ _b97761_) (/ (+ _a97760_ _b97761_) '2))
                  (car _rest97758_)))
             (_n97765_ (vector-length _v97756_)))
        (std/srfi/132#vector-sort! _<97755_ _v97756_)
        (if (zero? _n97765_)
            _knil97757_
            (if (odd? _n97765_)
                (vector-ref _v97756_ (quotient _n97765_ '2))
                (_mean97763_
                 (vector-ref _v97756_ (- (quotient _n97765_ '2) '1))
                 (vector-ref _v97756_ (quotient _n97765_ '2))))))))
  (define std/srfi/132#vector-select
    (lambda (_<97745_ _v97746_ _k97747_ . _rest97748_)
      (let* ((_start97750_ (if (null? _rest97748_) '0 (car _rest97748_)))
             (_end97752_
              (if (and (pair? _rest97748_) (pair? (cdr _rest97748_)))
                  (car (cdr _rest97748_))
                  (vector-length _v97746_))))
        (std/srfi/132#%vector-select
         _<97745_
         _v97746_
         _k97747_
         _start97750_
         _end97752_))))
  (define std/srfi/132#vector-select! std/srfi/132#vector-select)
  (define std/srfi/132#vector-separate!
    (lambda (_<97724_ _v97725_ _k97726_ . _rest97727_)
      (let* ((_start97729_ (if (null? _rest97727_) '0 (car _rest97727_)))
             (_end97731_
              (if (and (pair? _rest97727_) (pair? (cdr _rest97727_)))
                  (car (cdr _rest97727_))
                  (vector-length _v97725_))))
        (if (and (> _k97726_ '0) (> _end97731_ _start97729_))
            (let ((_pivot97734_
                   (std/srfi/132#vector-select
                    _<97724_
                    _v97725_
                    (- _k97726_ '1)
                    _start97729_
                    _end97731_)))
              (call-with-values
               (lambda ()
                 (std/srfi/132#count-smaller
                  _<97724_
                  _pivot97734_
                  _v97725_
                  _start97729_
                  _end97731_
                  '0
                  '0))
               (lambda (_count97737_ _count297738_)
                 (let* ((_v297740_ (make-vector _count97737_))
                        (_v397742_
                         (make-vector
                          (- _end97731_
                             _start97729_
                             _count97737_
                             _count297738_))))
                   (std/srfi/132#copy-smaller!
                    _<97724_
                    _pivot97734_
                    _v297740_
                    '0
                    _v97725_
                    _start97729_
                    _end97731_)
                   (std/srfi/132#copy-bigger!
                    _<97724_
                    _pivot97734_
                    _v397742_
                    '0
                    _v97725_
                    _start97729_
                    _end97731_)
                   (std/srfi/132#r7rs-vector-copy!__0
                    _v97725_
                    _start97729_
                    _v297740_)
                   (std/srfi/132#r7rs-vector-fill!
                    _v97725_
                    _pivot97734_
                    (+ _start97729_ _count97737_)
                    (+ _start97729_ _count97737_ _count297738_))
                   (std/srfi/132#r7rs-vector-copy!__0
                    _v97725_
                    (+ _start97729_ _count97737_ _count297738_)
                    _v397742_)))))
            '#!void))))
  (define std/srfi/132#just-sort-it-threshold '50)
  (define std/srfi/132#%vector-select
    (lambda (_<?97718_ _v97719_ _k97720_ _start97721_ _end97722_)
      (if (and 'vector-select
               (procedure? _<?97718_)
               (vector? _v97719_)
               (exact-integer? _k97720_)
               (exact-integer? _start97721_)
               (exact-integer? _end97722_)
               (<= '0 _k97720_ (- _end97722_ _start97721_ '1))
               (<= '0 _start97721_ _end97722_ (vector-length _v97719_)))
          '#!void
          (error '"assertion failure"))
      (std/srfi/132#%%vector-select
       _<?97718_
       _v97719_
       _k97720_
       _start97721_
       _end97722_)))
  (define std/srfi/132#%vector-select2
    (lambda (_<?97712_ _v97713_ _k97714_ _start97715_ _end97716_)
      (if (and 'vector-select
               (procedure? _<?97712_)
               (vector? _v97713_)
               (exact-integer? _k97714_)
               (exact-integer? _start97715_)
               (exact-integer? _end97716_)
               (<= '0 _k97714_ (- _end97716_ _start97715_ '1 '1))
               (<= '0 _start97715_ _end97716_ (vector-length _v97713_)))
          '#!void
          (error '"assertion failure"))
      (std/srfi/132#%%vector-select2
       _<?97712_
       _v97713_
       _k97714_
       _start97715_
       _end97716_)))
  (define std/srfi/132#%%vector-select
    (lambda (_<?97683_ _v97684_ _k97685_ _start97686_ _end97687_)
      (let ((_size97689_ (- _end97687_ _start97686_)))
        (if (= '1 _size97689_)
            (vector-ref _v97684_ (+ _k97685_ _start97686_))
            (if (= '2 _size97689_)
                (if (_<?97683_
                     (vector-ref _v97684_ _start97686_)
                     (vector-ref _v97684_ (+ _start97686_ '1)))
                    (vector-ref _v97684_ (+ _k97685_ _start97686_))
                    (vector-ref _v97684_ (+ (- '1 _k97685_) _start97686_)))
                (if (< _size97689_ std/srfi/132#just-sort-it-threshold)
                    (vector-ref
                     (std/srfi/132#vector-sort
                      _<?97683_
                      (subvector _v97684_ _start97686_ _end97687_))
                     _k97685_)
                    (let* ((_ip97691_ (random-integer _size97689_))
                           (_pivot97693_
                            (vector-ref _v97684_ (+ _start97686_ _ip97691_))))
                      (call-with-values
                       (lambda ()
                         (std/srfi/132#count-smaller
                          _<?97683_
                          _pivot97693_
                          _v97684_
                          _start97686_
                          _end97687_
                          '0
                          '0))
                       (lambda (_count97697_ _count297698_)
                         (if (< _k97685_ _count97697_)
                             (let* ((_n97700_ _count97697_)
                                    (_v297702_ (make-vector _n97700_)))
                               (std/srfi/132#copy-smaller!
                                _<?97683_
                                _pivot97693_
                                _v297702_
                                '0
                                _v97684_
                                _start97686_
                                _end97687_)
                               (std/srfi/132#%%vector-select
                                _<?97683_
                                _v297702_
                                _k97685_
                                '0
                                _n97700_))
                             (if (< _k97685_ (+ _count97697_ _count297698_))
                                 _pivot97693_
                                 (let* ((_n97705_
                                         (- _size97689_
                                            _count97697_
                                            _count297698_))
                                        (_v297707_ (make-vector _n97705_))
                                        (_k297709_
                                         (- _k97685_
                                            _count97697_
                                            _count297698_)))
                                   (std/srfi/132#copy-bigger!
                                    _<?97683_
                                    _pivot97693_
                                    _v297707_
                                    '0
                                    _v97684_
                                    _start97686_
                                    _end97687_)
                                   (std/srfi/132#%%vector-select
                                    _<?97683_
                                    _v297707_
                                    _k297709_
                                    '0
                                    _n97705_)))))))))))))
  (define std/srfi/132#%%vector-select2
    (lambda (_<?97649_ _v97650_ _k97651_ _start97652_ _end97653_)
      (let ((_size97655_ (- _end97653_ _start97652_)))
        (if (= '2 _size97655_)
            (let ((_a97657_ (vector-ref _v97650_ _start97652_))
                  (_b97658_ (vector-ref _v97650_ (+ _start97652_ '1))))
              (if (_<?97649_ _a97657_ _b97658_)
                  (values _a97657_ _b97658_)
                  (values _b97658_ _a97657_)))
            (if (< _size97655_ std/srfi/132#just-sort-it-threshold)
                (let ((_v297660_
                       (std/srfi/132#vector-sort
                        _<?97649_
                        (subvector _v97650_ _start97652_ _end97653_))))
                  (values (vector-ref _v297660_ _k97651_)
                          (vector-ref _v297660_ (+ _k97651_ '1))))
                (let* ((_ip97662_ (random-integer _size97655_))
                       (_pivot97664_
                        (vector-ref _v97650_ (+ _start97652_ _ip97662_))))
                  (call-with-values
                   (lambda ()
                     (std/srfi/132#count-smaller
                      _<?97649_
                      _pivot97664_
                      _v97650_
                      _start97652_
                      _end97653_
                      '0
                      '0))
                   (lambda (_count97668_ _count297669_)
                     (if (= (+ _k97651_ '1) _count97668_)
                         (values (std/srfi/132#%%vector-select
                                  _<?97649_
                                  _v97650_
                                  _k97651_
                                  _start97652_
                                  _end97653_)
                                 _pivot97664_)
                         (if (< _k97651_ _count97668_)
                             (let* ((_n97671_ _count97668_)
                                    (_v297673_ (make-vector _n97671_)))
                               (std/srfi/132#copy-smaller!
                                _<?97649_
                                _pivot97664_
                                _v297673_
                                '0
                                _v97650_
                                _start97652_
                                _end97653_)
                               (std/srfi/132#%%vector-select2
                                _<?97649_
                                _v297673_
                                _k97651_
                                '0
                                _n97671_))
                             (if (< _k97651_ (+ _count97668_ _count297669_))
                                 (values _pivot97664_
                                         (if (< (+ _k97651_ '1)
                                                (+ _count97668_ _count297669_))
                                             _pivot97664_
                                             (std/srfi/132#%%vector-select
                                              _<?97649_
                                              _v97650_
                                              (+ _k97651_ '1)
                                              _start97652_
                                              _end97653_)))
                                 (let* ((_n97676_
                                         (- _size97655_
                                            _count97668_
                                            _count297669_))
                                        (_v297678_ (make-vector _n97676_))
                                        (_k297680_
                                         (- _k97651_
                                            _count97668_
                                            _count297669_)))
                                   (std/srfi/132#copy-bigger!
                                    _<?97649_
                                    _pivot97664_
                                    _v297678_
                                    '0
                                    _v97650_
                                    _start97652_
                                    _end97653_)
                                   (std/srfi/132#%%vector-select2
                                    _<?97649_
                                    _v297678_
                                    _k297680_
                                    '0
                                    _n97676_)))))))))))))
  (define std/srfi/132#count-smaller
    (lambda (_<?97641_
             _pivot97642_
             _v97643_
             _i97644_
             _end97645_
             _count97646_
             _count297647_)
      (if (= _i97644_ _end97645_)
          (values _count97646_ _count297647_)
          (if (_<?97641_ (vector-ref _v97643_ _i97644_) _pivot97642_)
              (std/srfi/132#count-smaller
               _<?97641_
               _pivot97642_
               _v97643_
               (+ _i97644_ '1)
               _end97645_
               (+ _count97646_ '1)
               _count297647_)
              (if (_<?97641_ _pivot97642_ (vector-ref _v97643_ _i97644_))
                  (std/srfi/132#count-smaller
                   _<?97641_
                   _pivot97642_
                   _v97643_
                   (+ _i97644_ '1)
                   _end97645_
                   _count97646_
                   _count297647_)
                  (std/srfi/132#count-smaller
                   _<?97641_
                   _pivot97642_
                   _v97643_
                   (+ _i97644_ '1)
                   _end97645_
                   _count97646_
                   (+ _count297647_ '1)))))))
  (define std/srfi/132#copy-smaller!
    (lambda (_<?97633_
             _pivot97634_
             _dst97635_
             _at97636_
             _src97637_
             _start97638_
             _end97639_)
      (if (= _start97638_ _end97639_)
          _dst97635_
          (if (_<?97633_ (vector-ref _src97637_ _start97638_) _pivot97634_)
              (begin
                (vector-set!
                 _dst97635_
                 _at97636_
                 (vector-ref _src97637_ _start97638_))
                (std/srfi/132#copy-smaller!
                 _<?97633_
                 _pivot97634_
                 _dst97635_
                 (+ _at97636_ '1)
                 _src97637_
                 (+ _start97638_ '1)
                 _end97639_))
              (std/srfi/132#copy-smaller!
               _<?97633_
               _pivot97634_
               _dst97635_
               _at97636_
               _src97637_
               (+ _start97638_ '1)
               _end97639_)))))
  (define std/srfi/132#copy-bigger!
    (lambda (_<?97625_
             _pivot97626_
             _dst97627_
             _at97628_
             _src97629_
             _start97630_
             _end97631_)
      (if (= _start97630_ _end97631_)
          _dst97627_
          (if (_<?97625_ _pivot97626_ (vector-ref _src97629_ _start97630_))
              (begin
                (vector-set!
                 _dst97627_
                 _at97628_
                 (vector-ref _src97629_ _start97630_))
                (std/srfi/132#copy-bigger!
                 _<?97625_
                 _pivot97626_
                 _dst97627_
                 (+ _at97628_ '1)
                 _src97629_
                 (+ _start97630_ '1)
                 _end97631_))
              (std/srfi/132#copy-bigger!
               _<?97625_
               _pivot97626_
               _dst97627_
               _at97628_
               _src97629_
               (+ _start97630_ '1)
               _end97631_))))))
