(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/146#make-tree
    (lambda (_cmp109710_)
      (let ((__obj302737 (make-object std/misc/rbtree#rbtree::t '2)))
        (std/misc/rbtree#rbtree:::init!__0
         __obj302737
         (lambda (_a109712_ _b109713_)
           (let ((_c109715_ _cmp109710_)
                 (_o1109717_ _a109712_)
                 (_o2109719_ _b109713_))
             (if ((std/srfi/128#comparator-ordering-predicate _c109715_)
                  _o1109717_
                  _o2109719_)
                 '-1
                 (if ((##direct-structure-ref
                       _c109715_
                       '2
                       std/srfi/128#comparator::t
                       '#f)
                      _o1109717_
                      _o2109719_)
                     '0
                     '1)))))
        __obj302737)))
  (define std/srfi/146#tree-generator
    (lambda (_rbtree109703_)
      (letrec* ((_it109705_ (std/misc/rbtree#in-rbtree _rbtree109703_)))
        (lambda ()
          (let ((_next109708_ (std/iter#iter-next! _it109705_)))
            (if (eq? _next109708_ std/iter#iter-end)
                (begin (std/iter#iter-fini! _it109705_) '#!eof)
                _next109708_))))))
  (define std/srfi/146#tree-map
    (lambda (_proc109696_ _rbtree109697_)
      (std/misc/rbtree#rbtree-fold
       (lambda (_k109699_ _v109700_ _r109701_)
         (std/misc/rbtree#rbtree-put _r109701_ _k109699_ _v109700_))
       (let ((__obj302738 (make-object std/misc/rbtree#rbtree::t '2)))
         (std/misc/rbtree#rbtree:::init!__0
          __obj302738
          (##direct-structure-ref
           _rbtree109697_
           '2
           std/misc/rbtree#rbtree::t
           '#f))
         __obj302738)
       _rbtree109697_)))
  (define std/srfi/146#tree-fold
    (lambda (_proc109692_ _iv109693_ _rbtree109694_)
      (std/misc/rbtree#rbtree-fold _proc109692_ _iv109693_ _rbtree109694_)))
  (define std/srfi/146#tree-fold/reverse
    (lambda (_proc109688_ _iv109689_ _rbtree109690_)
      (std/misc/rbtree#rbtree-foldr _proc109688_ _iv109689_ _rbtree109690_)))
  (define std/srfi/146#tree-for-each
    (lambda (_proc109685_ _rbtree109686_)
      (std/misc/rbtree#rbtree-for-each _proc109685_ _rbtree109686_)))
  (define std/srfi/146#tree-search
    (lambda (_cmp109654_
             _rbtree109655_
             _key109656_
             _failure109657_
             _success109658_)
      ((call-with-current-continuation
        (lambda (_K109660_)
          (std/misc/rbtree#rbtree-for-each
           (lambda (_k109662_ _v109663_)
             (let ((_c109665_ _cmp109654_)
                   (_o1109667_ _k109662_)
                   (_o2109669_ _key109656_))
               (if ((std/srfi/128#comparator-ordering-predicate _c109665_)
                    _o1109667_
                    _o2109669_)
                   '#!void
                   (if ((##direct-structure-ref
                         _c109665_
                         '2
                         std/srfi/128#comparator::t
                         '#f)
                        _o1109667_
                        _o2109669_)
                       (_K109660_
                        (lambda ()
                          (_success109658_
                           _k109662_
                           _v109663_
                           (lambda (_new-key109673_
                                    _new-value109674_
                                    _obj109675_)
                             (values (std/misc/rbtree#rbtree-put
                                      (std/misc/rbtree#rbtree-remove
                                       _rbtree109655_
                                       _k109662_)
                                      _new-key109673_
                                      _new-value109674_)
                                     _obj109675_))
                           (lambda (_obj109677_)
                             (values (std/misc/rbtree#rbtree-remove
                                      _rbtree109655_
                                      _k109662_)
                                     _obj109677_)))))
                       (_K109660_
                        (lambda ()
                          (_failure109657_
                           _k109662_
                           _v109663_
                           (lambda (_value109680_ _obj109681_)
                             (values (std/misc/rbtree#rbtree-put
                                      _rbtree109655_
                                      _key109656_
                                      _value109680_)
                                     _obj109681_))
                           (lambda (_obj109683_)
                             (values _rbtree109655_ _obj109683_)))))))))
           _rbtree109655_))))))
  (define std/srfi/146#tree-catenate
    (lambda (_rbtree1109645_
             _pivot-key109646_
             _pivot-value109647_
             _rbtree2109648_)
      (std/misc/rbtree#rbtree-fold
       (lambda (_k109650_ _v109651_ _r109652_)
         (std/misc/rbtree#rbtree-put _r109652_ _k109650_ _v109651_))
       (std/misc/rbtree#rbtree-put
        _rbtree1109645_
        _pivot-key109646_
        _pivot-value109647_)
       _rbtree2109648_)))
  (define std/srfi/146#tree-split
    (lambda (_cmp109625_ _rbtree109626_ _obj109627_)
      (letrec* ((_tree<109629_ (std/srfi/146#make-tree _cmp109625_))
                (_tree<=109630_ (std/srfi/146#make-tree _cmp109625_))
                (_tree=109631_ (std/srfi/146#make-tree _cmp109625_))
                (_tree>=109632_ (std/srfi/146#make-tree _cmp109625_))
                (_tree>109633_ (std/srfi/146#make-tree _cmp109625_)))
        (std/misc/rbtree#rbtree-for-each
         (lambda (_k109635_ _v109636_)
           (let ((_c109638_ _cmp109625_)
                 (_o1109640_ _k109635_)
                 (_o2109642_ _obj109627_))
             (if ((std/srfi/128#comparator-ordering-predicate _c109638_)
                  _o1109640_
                  _o2109642_)
                 (begin
                   (std/misc/rbtree#rbtree-put!
                    _tree<109629_
                    _k109635_
                    _v109636_)
                   (std/misc/rbtree#rbtree-put!
                    _tree<=109630_
                    _k109635_
                    _v109636_))
                 (if ((##direct-structure-ref
                       _c109638_
                       '2
                       std/srfi/128#comparator::t
                       '#f)
                      _o1109640_
                      _o2109642_)
                     (begin
                       (std/misc/rbtree#rbtree-put!
                        _tree<=109630_
                        _k109635_
                        _v109636_)
                       (std/misc/rbtree#rbtree-put!
                        _tree=109631_
                        _k109635_
                        _v109636_)
                       (std/misc/rbtree#rbtree-put!
                        _tree>=109632_
                        _k109635_
                        _v109636_))
                     (begin
                       (std/misc/rbtree#rbtree-put!
                        _tree>=109632_
                        _k109635_
                        _v109636_)
                       (std/misc/rbtree#rbtree-put!
                        _tree>109633_
                        _k109635_
                        _v109636_))))))
         _rbtree109626_)
        (values _tree<109629_
                _tree<=109630_
                _tree=109631_
                _tree>=109632_
                _tree>109633_))))
  (define std/srfi/146#tree-key-predecessor
    (lambda (_cmp109605_ _rbtree109606_ _obj109607_ _failure109608_)
      ((call-with-current-continuation
        (lambda (_K109610_)
          (letrec* ((_prev109612_ '#f))
            (std/misc/rbtree#rbtree-for-each
             (lambda (_k109614_ _v109615_)
               (let ((_c109617_ _cmp109605_)
                     (_o1109619_ _k109614_)
                     (_o2109621_ _obj109607_))
                 (if ((std/srfi/128#comparator-ordering-predicate _c109617_)
                      _o1109619_
                      _o2109621_)
                     (set! _prev109612_ _k109614_)
                     (if ((##direct-structure-ref
                           _c109617_
                           '2
                           std/srfi/128#comparator::t
                           '#f)
                          _o1109619_
                          _o2109621_)
                         (_K109610_
                          (if _prev109612_
                              (lambda () _prev109612_)
                              _failure109608_))
                         _failure109608_))))
             _rbtree109606_)
            _failure109608_))))))
  (define std/srfi/146#tree-key-successor
    (lambda (_cmp109585_ _rbtree109586_ _obj109587_ _failure109588_)
      ((call-with-current-continuation
        (lambda (_K109590_)
          (letrec* ((_suc109592_ '#f))
            (std/misc/rbtree#rbtree-for-each
             (lambda (_k109594_ _v109595_)
               (let ((_c109597_ _cmp109585_)
                     (_o1109599_ _k109594_)
                     (_o2109601_ _obj109587_))
                 (if ((std/srfi/128#comparator-ordering-predicate _c109597_)
                      _o1109599_
                      _o2109601_)
                     _failure109588_
                     (if ((##direct-structure-ref
                           _c109597_
                           '2
                           std/srfi/128#comparator::t
                           '#f)
                          _o1109599_
                          _o2109601_)
                         (_K109590_
                          (if _suc109592_
                              (lambda () _suc109592_)
                              _failure109588_))
                         (set! _suc109592_ _k109594_)))))
             _rbtree109586_)
            _failure109588_))))))
  (define std/srfi/146#<mapping>
    (make-struct-type
     'std/srfi/146#<mapping>
     '#f
     '2
     '<mapping>
     '((fields: comparator tree))
     '#f))
  (define std/srfi/146#mapping? (make-struct-predicate std/srfi/146#<mapping>))
  (define std/srfi/146#mapping-key-comparator
    (make-struct-field-accessor std/srfi/146#<mapping> '0))
  (define std/srfi/146#mapping-tree
    (make-struct-field-accessor std/srfi/146#<mapping> '1))
  (define std/srfi/146#%make-mapping
    (lambda (_comparator109582_ _tree109583_)
      (make-struct-instance
       std/srfi/146#<mapping>
       _comparator109582_
       _tree109583_)))
  (define std/srfi/146#make-empty-mapping
    (lambda (_comparator109577_)
      (let ((_val109579_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator109577_
                'std/srfi/128#comparator::t))))
        (if _val109579_ _val109579_ (error)))
      (let ((__tmp302739 (std/srfi/146#make-tree _comparator109577_)))
        (declare (not safe))
        (##structure std/srfi/146#<mapping> _comparator109577_ __tmp302739))))
  (define std/srfi/146#mapping
    (lambda (_comparator109517_ . _args109518_)
      (let ((_val109520_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator109517_
                'std/srfi/128#comparator::t))))
        (if _val109520_ _val109520_ (error)))
      (let ((_rbtree109523_ (std/srfi/146#make-tree _comparator109517_)))
        (let _lp109525_ ((_rest109527_ _args109518_))
          (let* ((_rest109528109539_ _rest109527_)
                 (_E109531109543_
                  (lambda ()
                    (error '"No clause matching" _rest109528109539_))))
            (let ((_K109533109558_
                   (lambda (_rest109554_ _v109555_ _k109556_)
                     (std/misc/rbtree#rbtree-put!
                      _rbtree109523_
                      _k109556_
                      _v109555_)
                     (_lp109525_ _rest109554_)))
                  (_K109532109548_
                   (lambda ()
                     (let ()
                       (declare (not safe))
                       (##structure
                        std/srfi/146#<mapping>
                        _comparator109517_
                        _rbtree109523_)))))
              (let ((_try-match109530109551_
                     (lambda ()
                       (if (let ()
                             (declare (not safe))
                             (##null? _rest109528109539_))
                           (_K109532109548_)
                           (_E109531109543_)))))
                (if (let () (declare (not safe)) (##pair? _rest109528109539_))
                    (let ((_tl109535109563_
                           (let ()
                             (declare (not safe))
                             (##cdr _rest109528109539_)))
                          (_hd109534109561_
                           (let ()
                             (declare (not safe))
                             (##car _rest109528109539_))))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _tl109535109563_))
                          (let ((_tl109537109570_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _tl109535109563_)))
                                (_hd109536109568_
                                 (let ()
                                   (declare (not safe))
                                   (##car _tl109535109563_))))
                            (let ((_k109566_ _hd109534109561_)
                                  (_v109573_ _hd109536109568_)
                                  (_rest109575_ _tl109537109570_))
                              (_K109533109558_
                               _rest109575_
                               _v109573_
                               _k109566_)))
                          (_E109531109543_)))
                    (_try-match109530109551_)))))))))
  (define std/srfi/146#mapping-unfold
    (lambda (_stop?109491_
             _mapper109492_
             _successor109493_
             _seed109494_
             _comparator109495_)
      (let ((_val109497_ (procedure? _stop?109491_)))
        (if _val109497_ _val109497_ (error)))
      (let ((_val109500_ (procedure? _mapper109492_)))
        (if _val109500_ _val109500_ (error)))
      (let ((_val109503_ (procedure? _successor109493_)))
        (if _val109503_ _val109503_ (error)))
      (let ((_val109506_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator109495_
                'std/srfi/128#comparator::t))))
        (if _val109506_ _val109506_ (error)))
      (let _loop109509_ ((_mapping109511_
                          (std/srfi/146#make-empty-mapping _comparator109495_))
                         (_seed109512_ _seed109494_))
        (if (_stop?109491_ _seed109512_)
            _mapping109511_
            (let ((_g302740_ (_mapper109492_ _seed109512_)))
              (begin
                (let ((_g302741_
                       (let ()
                         (declare (not safe))
                         (if (##values? _g302740_)
                             (##vector-length _g302740_)
                             1))))
                  (if (not (let () (declare (not safe)) (##fx= _g302741_ 2)))
                      (error "Context expects 2 values" _g302741_)))
                (let ((_key109514_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g302740_ 0)))
                      (_value109515_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g302740_ 1))))
                  (_loop109509_
                   (std/srfi/146#mapping-adjoin
                    _mapping109511_
                    _key109514_
                    _value109515_)
                   (_successor109493_ _seed109512_)))))))))
  (define std/srfi/146#mapping/ordered std/srfi/146#mapping)
  (define std/srfi/146#mapping-unfold/ordered std/srfi/146#mapping-unfold)
  (define std/srfi/146#mapping-empty?
    (lambda (_mapping109483_)
      (let ((_val109485_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109483_
                'std/srfi/146#<mapping>))))
        (if _val109485_ _val109485_ (error)))
      (not (std/srfi/146#mapping-any?
            (lambda (_key109488_ _value109489_) '#t)
            _mapping109483_))))
  (define std/srfi/146#mapping-contains?
    (lambda (_mapping109475_ _key109476_)
      (let ((_val109478_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109475_
                'std/srfi/146#<mapping>))))
        (if _val109478_ _val109478_ (error)))
      (let ((_val109481_
             (std/misc/rbtree#rbtree-ref__%
              (##structure-ref _mapping109475_ '2 std/srfi/146#<mapping> '#f)
              _key109476_
              absent-value)))
        (not (eq? _val109481_ absent-value)))))
  (define std/srfi/146#mapping-disjoint?
    (lambda (_mapping1109461_ _mapping2109462_)
      (let ((_val109464_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1109461_
                'std/srfi/146#<mapping>))))
        (if _val109464_ _val109464_ (error)))
      (let ((_val109467_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2109462_
                'std/srfi/146#<mapping>))))
        (if _val109467_ _val109467_ (error)))
      (call-with-current-continuation
       (lambda (_return109470_)
         (std/srfi/146#mapping-for-each
          (lambda (_key109472_ _value109473_)
            (if (std/srfi/146#mapping-contains? _mapping2109462_ _key109472_)
                (_return109470_ '#f)
                '#!void))
          _mapping1109461_)
         '#t))))
  (define std/srfi/146#mapping-ref__0
    (lambda (_mapping109426_ _key109427_)
      (let ((_val109429_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109426_
                'std/srfi/146#<mapping>))))
        (if _val109429_ _val109429_ (error)))
      (std/srfi/146#mapping-ref__1
       _mapping109426_
       _key109427_
       (lambda () (error '"mapping-ref: key not in mapping" _key109427_)))))
  (define std/srfi/146#mapping-ref__1
    (lambda (_mapping109433_ _key109434_ _failure109435_)
      (let ((_val109437_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109433_
                'std/srfi/146#<mapping>))))
        (if _val109437_ _val109437_ (error)))
      (let ((_val109440_ (procedure? _failure109435_)))
        (if _val109440_ _val109440_ (error)))
      (std/srfi/146#mapping-ref__2
       _mapping109433_
       _key109434_
       _failure109435_
       (lambda (_value109443_) _value109443_))))
  (define std/srfi/146#mapping-ref__2
    (lambda (_mapping109445_ _key109446_ _failure109447_ _success109448_)
      (let ((_val109450_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109445_
                'std/srfi/146#<mapping>))))
        (if _val109450_ _val109450_ (error)))
      (let ((_val109453_ (procedure? _failure109447_)))
        (if _val109453_ _val109453_ (error)))
      (let ((_val109456_ (procedure? _success109448_)))
        (if _val109456_ _val109456_ (error)))
      (let ((_val109459_
             (std/misc/rbtree#rbtree-ref__%
              (##structure-ref _mapping109445_ '2 std/srfi/146#<mapping> '#f)
              _key109446_
              absent-value)))
        (if (eq? _val109459_ absent-value)
            (_failure109447_)
            (_success109448_ _val109459_)))))
  (define std/srfi/146#mapping-ref
    (lambda _g302743_
      (let ((_g302742_ (let () (declare (not safe)) (##length _g302743_))))
        (cond ((let () (declare (not safe)) (##fx= _g302742_ 2))
               (apply std/srfi/146#mapping-ref__0 _g302743_))
              ((let () (declare (not safe)) (##fx= _g302742_ 3))
               (apply std/srfi/146#mapping-ref__1 _g302743_))
              ((let () (declare (not safe)) (##fx= _g302742_ 4))
               (apply std/srfi/146#mapping-ref__2 _g302743_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping-ref
                _g302743_))))))
  (define std/srfi/146#mapping-ref/default
    (lambda (_mapping109418_ _key109419_ _default109420_)
      (let ((_val109422_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109418_
                'std/srfi/146#<mapping>))))
        (if _val109422_ _val109422_ (error)))
      (std/srfi/146#mapping-ref__1
       _mapping109418_
       _key109419_
       (lambda () _default109420_))))
  (define std/srfi/146#mapping-adjoin
    (lambda (_mapping109359_ . _args109360_)
      (let ((_val109362_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109359_
                'std/srfi/146#<mapping>))))
        (if _val109362_ _val109362_ (error)))
      (let _lp109365_ ((_rest109367_ _args109360_)
                       (_rbtree109368_
                        (##structure-ref
                         _mapping109359_
                         '2
                         std/srfi/146#<mapping>
                         '#f)))
        (let* ((_rest109369109380_ _rest109367_)
               (_E109372109384_
                (lambda () (error '"No clause matching" _rest109369109380_))))
          (let ((_K109374109399_
                 (lambda (_rest109395_ _v109396_ _k109397_)
                   (if (eq? absent-value
                            (std/misc/rbtree#rbtree-ref__%
                             _rbtree109368_
                             _k109397_
                             absent-value))
                       (_lp109365_
                        _rest109395_
                        (std/misc/rbtree#rbtree-put
                         _k109397_
                         _v109396_
                         _rbtree109368_))
                       (_lp109365_ _rest109395_ _rbtree109368_))))
                (_K109373109389_
                 (lambda ()
                   (let ((__tmp302744
                          (std/srfi/146#mapping-comparator _mapping109359_)))
                     (declare (not safe))
                     (##structure
                      std/srfi/146#<mapping>
                      __tmp302744
                      _rbtree109368_)))))
            (let ((_try-match109371109392_
                   (lambda ()
                     (if (let ()
                           (declare (not safe))
                           (##null? _rest109369109380_))
                         (_K109373109389_)
                         (_E109372109384_)))))
              (if (let () (declare (not safe)) (##pair? _rest109369109380_))
                  (let ((_tl109376109404_
                         (let ()
                           (declare (not safe))
                           (##cdr _rest109369109380_)))
                        (_hd109375109402_
                         (let ()
                           (declare (not safe))
                           (##car _rest109369109380_))))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl109376109404_))
                        (let ((_tl109378109411_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl109376109404_)))
                              (_hd109377109409_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl109376109404_))))
                          (let ((_k109407_ _hd109375109402_)
                                (_v109414_ _hd109377109409_)
                                (_rest109416_ _tl109378109411_))
                            (_K109374109399_
                             _rest109416_
                             _v109414_
                             _k109407_)))
                        (_E109372109384_)))
                  (_try-match109371109392_))))))))
  (define std/srfi/146#mapping-adjoin! std/srfi/146#mapping-adjoin)
  (define std/srfi/146#mapping-set
    (lambda (_mapping109300_ . _args109301_)
      (let ((_val109303_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109300_
                'std/srfi/146#<mapping>))))
        (if _val109303_ _val109303_ (error)))
      (let _lp109306_ ((_rest109308_ _args109301_)
                       (_rbtree109309_
                        (##structure-ref
                         _mapping109300_
                         '2
                         std/srfi/146#<mapping>
                         '#f)))
        (let* ((_rest109310109321_ _rest109308_)
               (_E109313109325_
                (lambda () (error '"No clause matching" _rest109310109321_))))
          (let ((_K109315109340_
                 (lambda (_rest109336_ _v109337_ _k109338_)
                   (_lp109306_
                    _rest109336_
                    (std/misc/rbtree#rbtree-put
                     _rbtree109309_
                     _k109338_
                     _v109337_))))
                (_K109314109330_
                 (lambda ()
                   (let ((__tmp302745
                          (std/srfi/146#mapping-comparator _mapping109300_)))
                     (declare (not safe))
                     (##structure
                      std/srfi/146#<mapping>
                      __tmp302745
                      _rbtree109309_)))))
            (let ((_try-match109312109333_
                   (lambda ()
                     (if (let ()
                           (declare (not safe))
                           (##null? _rest109310109321_))
                         (_K109314109330_)
                         (_E109313109325_)))))
              (if (let () (declare (not safe)) (##pair? _rest109310109321_))
                  (let ((_tl109317109345_
                         (let ()
                           (declare (not safe))
                           (##cdr _rest109310109321_)))
                        (_hd109316109343_
                         (let ()
                           (declare (not safe))
                           (##car _rest109310109321_))))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl109317109345_))
                        (let ((_tl109319109352_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl109317109345_)))
                              (_hd109318109350_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl109317109345_))))
                          (let ((_k109348_ _hd109316109343_)
                                (_v109355_ _hd109318109350_)
                                (_rest109357_ _tl109319109352_))
                            (_K109315109340_
                             _rest109357_
                             _v109355_
                             _k109348_)))
                        (_E109313109325_)))
                  (_try-match109312109333_))))))))
  (define std/srfi/146#mapping-set! std/srfi/146#mapping-set)
  (define std/srfi/146#mapping-replace
    (lambda (_mapping109293_ _key109294_ _value109295_)
      (let ((_val109297_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109293_
                'std/srfi/146#<mapping>))))
        (if _val109297_ _val109297_ (error)))
      (let ((__tmp302747 (std/srfi/146#mapping-comparator _mapping109293_))
            (__tmp302746
             (std/misc/rbtree#rbtree-put
              (##structure-ref _mapping109293_ '2 std/srfi/146#<mapping> '#f)
              _key109294_
              _value109295_)))
        (declare (not safe))
        (##structure std/srfi/146#<mapping> __tmp302747 __tmp302746))))
  (define std/srfi/146#mapping-replace! std/srfi/146#mapping-replace)
  (define std/srfi/146#mapping-delete
    (lambda (_mapping109287_ . _keys109288_)
      (let ((_val109290_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109287_
                'std/srfi/146#<mapping>))))
        (if _val109290_ _val109290_ (error)))
      (std/srfi/146#mapping-delete-all _mapping109287_ _keys109288_)))
  (define std/srfi/146#mapping-delete! std/srfi/146#mapping-delete)
  (define std/srfi/146#mapping-delete-all
    (lambda (_mapping109275_ _keys109276_)
      (let ((_val109278_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109275_
                'std/srfi/146#<mapping>))))
        (if _val109278_ _val109278_ (error)))
      (let ((_val109281_ (list? _keys109276_)))
        (if _val109281_ _val109281_ (error)))
      (let ((__tmp302749 (std/srfi/146#mapping-comparator _mapping109275_))
            (__tmp302748
             (foldl1 (lambda (_key109284_ _rbtree109285_)
                       (std/misc/rbtree#rbtree-remove
                        _rbtree109285_
                        _key109284_))
                     (##structure-ref
                      _mapping109275_
                      '2
                      std/srfi/146#<mapping>
                      '#f)
                     _keys109276_)))
        (declare (not safe))
        (##structure std/srfi/146#<mapping> __tmp302749 __tmp302748))))
  (define std/srfi/146#mapping-delete-all! std/srfi/146#mapping-delete-all)
  (define std/srfi/146#mapping-intern
    (lambda (_mapping109261_ _key109262_ _failure109263_)
      (let ((_val109265_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109261_
                'std/srfi/146#<mapping>))))
        (if _val109265_ _val109265_ (error)))
      (let ((_val109268_ (procedure? _failure109263_)))
        (if _val109268_ _val109268_ (error)))
      (let ((_val109271_
             (std/misc/rbtree#rbtree-ref__%
              (##structure-ref _mapping109261_ '2 std/srfi/146#<mapping> '#f)
              _key109262_
              absent-value)))
        (if (eq? _val109271_ absent-value)
            (let ((_val109273_ (_failure109263_)))
              (values (let ((__tmp302751
                             (std/srfi/146#mapping-comparator _mapping109261_))
                            (__tmp302750
                             (std/misc/rbtree#rbtree-put
                              (##structure-ref
                               _mapping109261_
                               '2
                               std/srfi/146#<mapping>
                               '#f)
                              _key109262_
                              _val109273_)))
                        (declare (not safe))
                        (##structure
                         std/srfi/146#<mapping>
                         __tmp302751
                         __tmp302750))
                      _val109273_))
            (values _mapping109261_ _val109271_)))))
  (define std/srfi/146#mapping-intern! std/srfi/146#mapping-intern)
  (define std/srfi/146#mapping-update__0
    (lambda (_mapping109231_ _key109232_ _updater109233_)
      (std/srfi/146#mapping-update__1
       _mapping109231_
       _key109232_
       _updater109233_
       (lambda ()
         (error '"mapping-update: key not found in mapping" _key109232_)))))
  (define std/srfi/146#mapping-update__1
    (lambda (_mapping109236_ _key109237_ _updater109238_ _failure109239_)
      (std/srfi/146#mapping-update__2
       _mapping109236_
       _key109237_
       _updater109238_
       _failure109239_
       (lambda (_value109241_) _value109241_))))
  (define std/srfi/146#mapping-update__2
    (lambda (_mapping109243_
             _key109244_
             _updater109245_
             _failure109246_
             _success109247_)
      (let ((_val109249_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109243_
                'std/srfi/146#<mapping>))))
        (if _val109249_ _val109249_ (error)))
      (let ((_val109252_ (procedure? _updater109245_)))
        (if _val109252_ _val109252_ (error)))
      (let ((_val109255_ (procedure? _failure109246_)))
        (if _val109255_ _val109255_ (error)))
      (let ((_val109258_ (procedure? _success109247_)))
        (if _val109258_ _val109258_ (error)))
      (std/srfi/146#mapping-set
       _mapping109243_
       _key109244_
       (_updater109245_
        (std/srfi/146#mapping-ref__2
         _mapping109243_
         _key109244_
         _failure109246_
         _success109247_)))))
  (define std/srfi/146#mapping-update
    (lambda _g302753_
      (let ((_g302752_ (let () (declare (not safe)) (##length _g302753_))))
        (cond ((let () (declare (not safe)) (##fx= _g302752_ 3))
               (apply std/srfi/146#mapping-update__0 _g302753_))
              ((let () (declare (not safe)) (##fx= _g302752_ 4))
               (apply std/srfi/146#mapping-update__1 _g302753_))
              ((let () (declare (not safe)) (##fx= _g302752_ 5))
               (apply std/srfi/146#mapping-update__2 _g302753_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping-update
                _g302753_))))))
  (define std/srfi/146#mapping-update! std/srfi/146#mapping-update)
  (define std/srfi/146#mapping-update/default
    (lambda (_mapping109225_ _key109226_ _updater109227_ _default109228_)
      (std/srfi/146#mapping-update__1
       _mapping109225_
       _key109226_
       _updater109227_
       (lambda () _default109228_))))
  (define std/srfi/146#mapping-update!/default
    std/srfi/146#mapping-update/default)
  (define std/srfi/146#mapping-pop__0
    (lambda (_mapping109207_)
      (std/srfi/146#mapping-pop__1
       _mapping109207_
       (lambda () (error '"mapping-pop: mapping has no association")))))
  (define std/srfi/146#mapping-pop__1
    (lambda (_mapping109210_ _failure109211_)
      (let ((_val109213_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109210_
                'std/srfi/146#<mapping>))))
        (if _val109213_ _val109213_ (error)))
      (let ((_val109216_ (procedure? _failure109211_)))
        (if _val109216_ _val109216_ (error)))
      ((call-with-current-continuation
        (lambda (_K109219_)
          (std/misc/rbtree#rbtree-for-each
           (##structure-ref _mapping109210_ '2 std/srfi/146#<mapping> '#f)
           (lambda (_k109221_ _v109222_)
             (_K109219_
              (lambda ()
                (values (let ((__tmp302755
                               (std/srfi/146#mapping-comparator
                                _mapping109210_))
                              (__tmp302754
                               (std/misc/rbtree#rbtree-remove
                                (##structure-ref
                                 _mapping109210_
                                 '2
                                 std/srfi/146#<mapping>
                                 '#f)
                                _k109221_)))
                          (declare (not safe))
                          (##structure
                           std/srfi/146#<mapping>
                           __tmp302755
                           __tmp302754))
                        _k109221_
                        _v109222_)))))
          _failure109211_)))))
  (define std/srfi/146#mapping-pop
    (lambda _g302757_
      (let ((_g302756_ (let () (declare (not safe)) (##length _g302757_))))
        (cond ((let () (declare (not safe)) (##fx= _g302756_ 1))
               (apply std/srfi/146#mapping-pop__0 _g302757_))
              ((let () (declare (not safe)) (##fx= _g302756_ 2))
               (apply std/srfi/146#mapping-pop__1 _g302757_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping-pop
                _g302757_))))))
  (define std/srfi/146#mapping-pop! std/srfi/146#mapping-pop)
  (define std/srfi/146#mapping-search
    (lambda (_mapping109177_ _key109178_ _failure109179_ _success109180_)
      (let ((_val109182_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109177_
                'std/srfi/146#<mapping>))))
        (if _val109182_ _val109182_ (error)))
      (let ((_val109185_ (procedure? _failure109179_)))
        (if _val109185_ _val109185_ (error)))
      (let ((_val109188_ (procedure? _success109180_)))
        (if _val109188_ _val109188_ (error)))
      (call-with-current-continuation
       (lambda (_return109191_)
         (let* ((_comparator109193_
                 (##structure-ref
                  _mapping109177_
                  '1
                  std/srfi/146#<mapping>
                  '#f))
                (_g302758_
                 (std/srfi/146#tree-search
                  _comparator109193_
                  (##structure-ref
                   _mapping109177_
                   '2
                   std/srfi/146#<mapping>
                   '#f)
                  _key109178_
                  (lambda (_insert109195_ _ignore109196_)
                    (_failure109179_
                     (lambda (_value109198_ _obj109199_)
                       (_insert109195_ _key109178_ _value109198_ _obj109199_))
                     (lambda (_obj109201_)
                       (_return109191_ _mapping109177_ _obj109201_))))
                  _success109180_)))
           (begin
             (let ((_g302759_
                    (let ()
                      (declare (not safe))
                      (if (##values? _g302758_)
                          (##vector-length _g302758_)
                          1))))
               (if (not (let () (declare (not safe)) (##fx= _g302759_ 2)))
                   (error "Context expects 2 values" _g302759_)))
             (let ((_tree109203_
                    (let () (declare (not safe)) (##vector-ref _g302758_ 0)))
                   (_obj109204_
                    (let () (declare (not safe)) (##vector-ref _g302758_ 1))))
               (let ()
                 (values (let ()
                           (declare (not safe))
                           (##structure
                            std/srfi/146#<mapping>
                            _comparator109193_
                            _tree109203_))
                         _obj109204_)))))))))
  (define std/srfi/146#mapping-search! std/srfi/146#mapping-search)
  (define std/srfi/146#mapping-size
    (lambda (_mapping109169_)
      (let ((_val109171_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109169_
                'std/srfi/146#<mapping>))))
        (if _val109171_ _val109171_ (error)))
      (std/srfi/146#mapping-count
       (lambda (_key109174_ _value109175_) '#t)
       _mapping109169_)))
  (define std/srfi/146#mapping-find
    (lambda (_predicate109151_ _mapping109152_ _failure109153_)
      (let ((_val109155_ (procedure? _predicate109151_)))
        (if _val109155_ _val109155_ (error)))
      (let ((_val109158_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109152_
                'std/srfi/146#<mapping>))))
        (if _val109158_ _val109158_ (error)))
      (let ((_val109161_ (procedure? _failure109153_)))
        (if _val109161_ _val109161_ (error)))
      (call-with-current-continuation
       (lambda (_return109164_)
         (std/srfi/146#mapping-for-each
          (lambda (_key109166_ _value109167_)
            (if (_predicate109151_ _key109166_ _value109167_)
                (_return109164_ _key109166_ _value109167_)
                '#!void))
          _mapping109152_)
         (_failure109153_)))))
  (define std/srfi/146#mapping-count
    (lambda (_predicate109138_ _mapping109139_)
      (let ((_val109141_ (procedure? _predicate109138_)))
        (if _val109141_ _val109141_ (error)))
      (let ((_val109144_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109139_
                'std/srfi/146#<mapping>))))
        (if _val109144_ _val109144_ (error)))
      (std/srfi/146#mapping-fold
       (lambda (_key109147_ _value109148_ _count109149_)
         (if (_predicate109138_ _key109147_ _value109148_)
             (+ '1 _count109149_)
             _count109149_))
       '0
       _mapping109139_)))
  (define std/srfi/146#mapping-any?
    (lambda (_predicate109124_ _mapping109125_)
      (let ((_val109127_ (procedure? _predicate109124_)))
        (if _val109127_ _val109127_ (error)))
      (let ((_val109130_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109125_
                'std/srfi/146#<mapping>))))
        (if _val109130_ _val109130_ (error)))
      (call-with-current-continuation
       (lambda (_return109133_)
         (std/srfi/146#mapping-for-each
          (lambda (_key109135_ _value109136_)
            (if (_predicate109124_ _key109135_ _value109136_)
                (_return109133_ '#t)
                '#!void))
          _mapping109125_)
         '#f))))
  (define std/srfi/146#mapping-every?
    (lambda (_predicate109112_ _mapping109113_)
      (let ((_val109115_ (procedure? _predicate109112_)))
        (if _val109115_ _val109115_ (error)))
      (let ((_val109118_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109113_
                'std/srfi/146#<mapping>))))
        (if _val109118_ _val109118_ (error)))
      (not (std/srfi/146#mapping-any?
            (lambda (_key109121_ _value109122_)
              (not (_predicate109112_ _key109121_ _value109122_)))
            _mapping109113_))))
  (define std/srfi/146#mapping-keys
    (lambda (_mapping109103_)
      (let ((_val109105_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109103_
                'std/srfi/146#<mapping>))))
        (if _val109105_ _val109105_ (error)))
      (std/srfi/146#mapping-fold/reverse
       (lambda (_key109108_ _value109109_ _keys109110_)
         (cons _key109108_ _keys109110_))
       '()
       _mapping109103_)))
  (define std/srfi/146#mapping-values
    (lambda (_mapping109094_)
      (let ((_val109096_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109094_
                'std/srfi/146#<mapping>))))
        (if _val109096_ _val109096_ (error)))
      (std/srfi/146#mapping-fold/reverse
       (lambda (_key109099_ _value109100_ _values109101_)
         (cons _value109100_ _values109101_))
       '()
       _mapping109094_)))
  (define std/srfi/146#mapping-entries
    (lambda (_mapping109089_)
      (let ((_val109091_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109089_
                'std/srfi/146#<mapping>))))
        (if _val109091_ _val109091_ (error)))
      (values (std/srfi/146#mapping-keys _mapping109089_)
              (std/srfi/146#mapping-values _mapping109089_))))
  (define std/srfi/146#mapping-map
    (lambda (_proc109069_ _comparator109070_ _mapping109071_)
      (let ((_val109073_ (procedure? _proc109069_)))
        (if _val109073_ _val109073_ (error)))
      (let ((_val109076_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator109070_
                'std/srfi/128#comparator::t))))
        (if _val109076_ _val109076_ (error)))
      (let ((_val109079_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109071_
                'std/srfi/146#<mapping>))))
        (if _val109079_ _val109079_ (error)))
      (std/srfi/146#mapping-fold
       (lambda (_key109082_ _value109083_ _mapping109084_)
         (let ((_g302760_ (_proc109069_ _key109082_ _value109083_)))
           (begin
             (let ((_g302761_
                    (let ()
                      (declare (not safe))
                      (if (##values? _g302760_)
                          (##vector-length _g302760_)
                          1))))
               (if (not (let () (declare (not safe)) (##fx= _g302761_ 2)))
                   (error "Context expects 2 values" _g302761_)))
             (let ((_key109086_
                    (let () (declare (not safe)) (##vector-ref _g302760_ 0)))
                   (_value109087_
                    (let () (declare (not safe)) (##vector-ref _g302760_ 1))))
               (std/srfi/146#mapping-set
                _mapping109084_
                _key109086_
                _value109087_)))))
       (std/srfi/146#make-empty-mapping _comparator109070_)
       _mapping109071_)))
  (define std/srfi/146#mapping-for-each
    (lambda (_proc109060_ _mapping109061_)
      (let ((_val109063_ (procedure? _proc109060_)))
        (if _val109063_ _val109063_ (error)))
      (let ((_val109066_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109061_
                'std/srfi/146#<mapping>))))
        (if _val109066_ _val109066_ (error)))
      (std/misc/rbtree#rbtree-for-each
       _proc109060_
       (##structure-ref _mapping109061_ '2 std/srfi/146#<mapping> '#f))))
  (define std/srfi/146#mapping-fold
    (lambda (_proc109050_ _acc109051_ _mapping109052_)
      (let ((_val109054_ (procedure? _proc109050_)))
        (if _val109054_ _val109054_ (error)))
      (let ((_val109057_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109052_
                'std/srfi/146#<mapping>))))
        (if _val109057_ _val109057_ (error)))
      (std/misc/rbtree#rbtree-fold
       _proc109050_
       _acc109051_
       (##structure-ref _mapping109052_ '2 std/srfi/146#<mapping> '#f))))
  (define std/srfi/146#mapping-map->list
    (lambda (_proc109037_ _mapping109038_)
      (let ((_val109040_ (procedure? _proc109037_)))
        (if _val109040_ _val109040_ (error)))
      (let ((_val109043_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109038_
                'std/srfi/146#<mapping>))))
        (if _val109043_ _val109043_ (error)))
      (std/srfi/146#mapping-fold/reverse
       (lambda (_key109046_ _value109047_ _lst109048_)
         (cons (_proc109037_ _key109046_ _value109047_) _lst109048_))
       '()
       _mapping109038_)))
  (define std/srfi/146#mapping-filter
    (lambda (_predicate109024_ _mapping109025_)
      (let ((_val109027_ (procedure? _predicate109024_)))
        (if _val109027_ _val109027_ (error)))
      (let ((_val109030_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109025_
                'std/srfi/146#<mapping>))))
        (if _val109030_ _val109030_ (error)))
      (std/srfi/146#mapping-fold
       (lambda (_key109033_ _value109034_ _mapping109035_)
         (if (_predicate109024_ _key109033_ _value109034_)
             (std/srfi/146#mapping-set
              _mapping109035_
              _key109033_
              _value109034_)
             _mapping109035_))
       (std/srfi/146#make-empty-mapping
        (##structure-ref _mapping109025_ '1 std/srfi/146#<mapping> '#f))
       _mapping109025_)))
  (define std/srfi/146#mapping-filter! std/srfi/146#mapping-filter)
  (define std/srfi/146#mapping-remove
    (lambda (_predicate109012_ _mapping109013_)
      (let ((_val109015_ (procedure? _predicate109012_)))
        (if _val109015_ _val109015_ (error)))
      (let ((_val109018_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109013_
                'std/srfi/146#<mapping>))))
        (if _val109018_ _val109018_ (error)))
      (std/srfi/146#mapping-filter
       (lambda (_key109021_ _value109022_)
         (not (_predicate109012_ _key109021_ _value109022_)))
       _mapping109013_)))
  (define std/srfi/146#mapping-remove! std/srfi/146#mapping-remove)
  (define std/srfi/146#mapping-partition
    (lambda (_predicate109003_ _mapping109004_)
      (let ((_val109006_ (procedure? _predicate109003_)))
        (if _val109006_ _val109006_ (error)))
      (let ((_val109009_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping109004_
                'std/srfi/146#<mapping>))))
        (if _val109009_ _val109009_ (error)))
      (values (std/srfi/146#mapping-filter _predicate109003_ _mapping109004_)
              (std/srfi/146#mapping-remove
               _predicate109003_
               _mapping109004_))))
  (define std/srfi/146#mapping-partition! std/srfi/146#mapping-partition)
  (define std/srfi/146#mapping-copy
    (lambda (_mapping108998_)
      (let ((_val109000_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108998_
                'std/srfi/146#<mapping>))))
        (if _val109000_ _val109000_ (error)))
      _mapping108998_))
  (define std/srfi/146#mapping->alist
    (lambda (_mapping108989_)
      (let ((_val108991_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108989_
                'std/srfi/146#<mapping>))))
        (if _val108991_ _val108991_ (error)))
      (reverse (std/srfi/146#mapping-fold
                (lambda (_key108994_ _value108995_ _alist108996_)
                  (cons (cons _key108994_ _value108995_) _alist108996_))
                '()
                _mapping108989_))))
  (define std/srfi/146#alist->mapping
    (lambda (_comparator108975_ _alist108976_)
      (let ((_val108978_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108975_
                'std/srfi/128#comparator::t))))
        (if _val108978_ _val108978_ (error)))
      (let ((_val108981_ (list? _alist108976_)))
        (if _val108981_ _val108981_ (error)))
      (std/srfi/146#mapping-unfold
       null?
       (lambda (_alist108984_)
         (let ((_key108986_ (caar _alist108984_))
               (_value108987_ (cdar _alist108984_)))
           (values _key108986_ _value108987_)))
       cdr
       _alist108976_
       _comparator108975_)))
  (define std/srfi/146#alist->mapping!
    (lambda (_mapping108960_ _alist108961_)
      (let ((_val108963_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108960_
                'std/srfi/146#<mapping>))))
        (if _val108963_ _val108963_ (error)))
      (let ((_val108966_ (list? _alist108961_)))
        (if _val108966_ _val108966_ (error)))
      (foldl1 (lambda (_association108969_ _mapping108970_)
                (let ((_key108972_ (car _association108969_))
                      (_value108973_ (cdr _association108969_)))
                  (std/srfi/146#mapping-set
                   _mapping108970_
                   _key108972_
                   _value108973_)))
              _mapping108960_
              _alist108961_)))
  (define std/srfi/146#alist->mapping/ordered std/srfi/146#alist->mapping)
  (define std/srfi/146#alist->mapping/ordered! std/srfi/146#alist->mapping!)
  (define std/srfi/146#mapping=?__0
    (lambda (_comparator108945_ _mapping108946_)
      (let ((_val108948_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108946_
                'std/srfi/146#<mapping>))))
        (if _val108948_ _val108948_ (error)))
      '#t))
  (define std/srfi/146#mapping=?__2
    (lambda (_comparator108955_
             _mapping1108956_
             _mapping2108957_
             .
             _mappings108958_)
      (if (std/srfi/146#%mapping=?
           _comparator108955_
           _mapping1108956_
           _mapping2108957_)
          (apply std/srfi/146#mapping=?
                 _comparator108955_
                 _mapping2108957_
                 _mappings108958_)
          '#f)))
  (define std/srfi/146#mapping=?
    (lambda _g302763_
      (let ((_g302762_ (let () (declare (not safe)) (##length _g302763_))))
        (cond ((let () (declare (not safe)) (##fx= _g302762_ 2))
               (apply std/srfi/146#mapping=?__0 _g302763_))
              ((let () (declare (not safe)) (##fx= _g302762_ 3))
               (apply std/srfi/146#%mapping=? _g302763_))
              ((let () (declare (not safe)) (##fx>= _g302762_ 3))
               (apply std/srfi/146#mapping=?__2 _g302763_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping=?
                _g302763_))))))
  (define std/srfi/146#%mapping=?
    (lambda (_comparator108941_ _mapping1108942_ _mapping2108943_)
      (if (eq? (##structure-ref _mapping1108942_ '1 std/srfi/146#<mapping> '#f)
               (##structure-ref
                _mapping2108943_
                '1
                std/srfi/146#<mapping>
                '#f))
          (if (std/srfi/146#%mapping<=?
               _comparator108941_
               _mapping1108942_
               _mapping2108943_)
              (std/srfi/146#%mapping<=?
               _comparator108941_
               _mapping2108943_
               _mapping1108942_)
              '#f)
          '#f)))
  (define std/srfi/146#mapping<=?__0
    (lambda (_comparator108908_ _mapping108909_)
      (let ((_val108911_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108909_
                'std/srfi/146#<mapping>))))
        (if _val108911_ _val108911_ (error)))
      '#t))
  (define std/srfi/146#mapping<=?__1
    (lambda (_comparator108914_ _mapping1108915_ _mapping2108916_)
      (let ((_val108918_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108914_
                'std/srfi/128#comparator::t))))
        (if _val108918_ _val108918_ (error)))
      (let ((_val108921_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108915_
                'std/srfi/146#<mapping>))))
        (if _val108921_ _val108921_ (error)))
      (let ((_val108924_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108916_
                'std/srfi/146#<mapping>))))
        (if _val108924_ _val108924_ (error)))
      (std/srfi/146#%mapping<=?
       _comparator108914_
       _mapping1108915_
       _mapping2108916_)))
  (define std/srfi/146#mapping<=?__2
    (lambda (_comparator108927_
             _mapping1108928_
             _mapping2108929_
             .
             _mappings108930_)
      (let ((_val108932_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108927_
                'std/srfi/128#comparator::t))))
        (if _val108932_ _val108932_ (error)))
      (let ((_val108935_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108928_
                'std/srfi/146#<mapping>))))
        (if _val108935_ _val108935_ (error)))
      (let ((_val108938_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108929_
                'std/srfi/146#<mapping>))))
        (if _val108938_ _val108938_ (error)))
      (if (std/srfi/146#%mapping<=?
           _comparator108927_
           _mapping1108928_
           _mapping2108929_)
          (apply std/srfi/146#mapping<=?
                 _comparator108927_
                 _mapping2108929_
                 _mappings108930_)
          '#f)))
  (define std/srfi/146#mapping<=?
    (lambda _g302765_
      (let ((_g302764_ (let () (declare (not safe)) (##length _g302765_))))
        (cond ((let () (declare (not safe)) (##fx= _g302764_ 2))
               (apply std/srfi/146#mapping<=?__0 _g302765_))
              ((let () (declare (not safe)) (##fx= _g302764_ 3))
               (apply std/srfi/146#mapping<=?__1 _g302765_))
              ((let () (declare (not safe)) (##fx>= _g302764_ 3))
               (apply std/srfi/146#mapping<=?__2 _g302765_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping<=?
                _g302765_))))))
  (define std/srfi/146#%mapping<=?
    (lambda (_comparator108880_ _mapping1108881_ _mapping2108882_)
      (let ((_val108884_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108880_
                'std/srfi/128#comparator::t))))
        (if _val108884_ _val108884_ (error)))
      (let ((_val108887_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108881_
                'std/srfi/146#<mapping>))))
        (if _val108887_ _val108887_ (error)))
      (let ((_val108890_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108882_
                'std/srfi/146#<mapping>))))
        (if _val108890_ _val108890_ (error)))
      (let ((_less?108893_
             (std/srfi/128#comparator-ordering-predicate
              (##structure-ref
               _mapping1108881_
               '1
               std/srfi/146#<mapping>
               '#f)))
            (_equality-predicate108894_
             (##direct-structure-ref
              _comparator108880_
              '2
              std/srfi/128#comparator::t
              '#f))
            (_gen1108895_
             (std/srfi/146#tree-generator
              (##structure-ref
               _mapping1108881_
               '2
               std/srfi/146#<mapping>
               '#f)))
            (_gen2108896_
             (std/srfi/146#tree-generator
              (##structure-ref
               _mapping2108882_
               '2
               std/srfi/146#<mapping>
               '#f))))
        (let _loop108898_ ((_item1108900_ (_gen1108895_))
                           (_item2108901_ (_gen2108896_)))
          (if (eof-object? _item1108900_)
              '#t
              (if (eof-object? _item2108901_)
                  '#f
                  (let ((_key1108903_ (car _item1108900_))
                        (_value1108904_ (cadr _item1108900_))
                        (_key2108905_ (car _item2108901_))
                        (_value2108906_ (cadr _item2108901_)))
                    (if (_less?108893_ _key1108903_ _key2108905_)
                        '#f
                        (if (_less?108893_ _key2108905_ _key1108903_)
                            (_loop108898_ _item1108900_ (_gen2108896_))
                            (if (_equality-predicate108894_
                                 _value1108904_
                                 _value2108906_)
                                (_loop108898_ (_gen1108895_) (_gen2108896_))
                                '#f))))))))))
  (define std/srfi/146#mapping>?__0
    (lambda (_comparator108847_ _mapping108848_)
      (let ((_val108850_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108848_
                'std/srfi/146#<mapping>))))
        (if _val108850_ _val108850_ (error)))
      '#t))
  (define std/srfi/146#mapping>?__1
    (lambda (_comparator108853_ _mapping1108854_ _mapping2108855_)
      (let ((_val108857_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108853_
                'std/srfi/128#comparator::t))))
        (if _val108857_ _val108857_ (error)))
      (let ((_val108860_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108854_
                'std/srfi/146#<mapping>))))
        (if _val108860_ _val108860_ (error)))
      (let ((_val108863_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108855_
                'std/srfi/146#<mapping>))))
        (if _val108863_ _val108863_ (error)))
      (std/srfi/146#%mapping>?
       _comparator108853_
       _mapping1108854_
       _mapping2108855_)))
  (define std/srfi/146#mapping>?__2
    (lambda (_comparator108866_
             _mapping1108867_
             _mapping2108868_
             .
             _mappings108869_)
      (let ((_val108871_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108866_
                'std/srfi/128#comparator::t))))
        (if _val108871_ _val108871_ (error)))
      (let ((_val108874_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108867_
                'std/srfi/146#<mapping>))))
        (if _val108874_ _val108874_ (error)))
      (let ((_val108877_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108868_
                'std/srfi/146#<mapping>))))
        (if _val108877_ _val108877_ (error)))
      (if (std/srfi/146#%mapping>?
           _comparator108866_
           _mapping1108867_
           _mapping2108868_)
          (apply std/srfi/146#mapping>?
                 _comparator108866_
                 _mapping2108868_
                 _mappings108869_)
          '#f)))
  (define std/srfi/146#mapping>?
    (lambda _g302767_
      (let ((_g302766_ (let () (declare (not safe)) (##length _g302767_))))
        (cond ((let () (declare (not safe)) (##fx= _g302766_ 2))
               (apply std/srfi/146#mapping>?__0 _g302767_))
              ((let () (declare (not safe)) (##fx= _g302766_ 3))
               (apply std/srfi/146#mapping>?__1 _g302767_))
              ((let () (declare (not safe)) (##fx>= _g302766_ 3))
               (apply std/srfi/146#mapping>?__2 _g302767_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping>?
                _g302767_))))))
  (define std/srfi/146#%mapping>?
    (lambda (_comparator108834_ _mapping1108835_ _mapping2108836_)
      (let ((_val108838_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108834_
                'std/srfi/128#comparator::t))))
        (if _val108838_ _val108838_ (error)))
      (let ((_val108841_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108835_
                'std/srfi/146#<mapping>))))
        (if _val108841_ _val108841_ (error)))
      (let ((_val108844_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108836_
                'std/srfi/146#<mapping>))))
        (if _val108844_ _val108844_ (error)))
      (not (std/srfi/146#%mapping<=?
            _comparator108834_
            _mapping1108835_
            _mapping2108836_))))
  (define std/srfi/146#mapping<?__0
    (lambda (_comparator108801_ _mapping108802_)
      (let ((_val108804_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108802_
                'std/srfi/146#<mapping>))))
        (if _val108804_ _val108804_ (error)))
      '#t))
  (define std/srfi/146#mapping<?__1
    (lambda (_comparator108807_ _mapping1108808_ _mapping2108809_)
      (let ((_val108811_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108807_
                'std/srfi/128#comparator::t))))
        (if _val108811_ _val108811_ (error)))
      (let ((_val108814_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108808_
                'std/srfi/146#<mapping>))))
        (if _val108814_ _val108814_ (error)))
      (let ((_val108817_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108809_
                'std/srfi/146#<mapping>))))
        (if _val108817_ _val108817_ (error)))
      (std/srfi/146#%mapping<?
       _comparator108807_
       _mapping1108808_
       _mapping2108809_)))
  (define std/srfi/146#mapping<?__2
    (lambda (_comparator108820_
             _mapping1108821_
             _mapping2108822_
             .
             _mappings108823_)
      (let ((_val108825_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108820_
                'std/srfi/128#comparator::t))))
        (if _val108825_ _val108825_ (error)))
      (let ((_val108828_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108821_
                'std/srfi/146#<mapping>))))
        (if _val108828_ _val108828_ (error)))
      (let ((_val108831_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108822_
                'std/srfi/146#<mapping>))))
        (if _val108831_ _val108831_ (error)))
      (if (std/srfi/146#%mapping<?
           _comparator108820_
           _mapping1108821_
           _mapping2108822_)
          (apply std/srfi/146#mapping<?
                 _comparator108820_
                 _mapping2108822_
                 _mappings108823_)
          '#f)))
  (define std/srfi/146#mapping<?
    (lambda _g302769_
      (let ((_g302768_ (let () (declare (not safe)) (##length _g302769_))))
        (cond ((let () (declare (not safe)) (##fx= _g302768_ 2))
               (apply std/srfi/146#mapping<?__0 _g302769_))
              ((let () (declare (not safe)) (##fx= _g302768_ 3))
               (apply std/srfi/146#mapping<?__1 _g302769_))
              ((let () (declare (not safe)) (##fx>= _g302768_ 3))
               (apply std/srfi/146#mapping<?__2 _g302769_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping<?
                _g302769_))))))
  (define std/srfi/146#%mapping<?
    (lambda (_comparator108788_ _mapping1108789_ _mapping2108790_)
      (let ((_val108792_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108788_
                'std/srfi/128#comparator::t))))
        (if _val108792_ _val108792_ (error)))
      (let ((_val108795_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108789_
                'std/srfi/146#<mapping>))))
        (if _val108795_ _val108795_ (error)))
      (let ((_val108798_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108790_
                'std/srfi/146#<mapping>))))
        (if _val108798_ _val108798_ (error)))
      (std/srfi/146#%mapping>?
       _comparator108788_
       _mapping2108790_
       _mapping1108789_)))
  (define std/srfi/146#mapping>=?__0
    (lambda (_comparator108755_ _mapping108756_)
      (let ((_val108758_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108756_
                'std/srfi/146#<mapping>))))
        (if _val108758_ _val108758_ (error)))
      '#t))
  (define std/srfi/146#mapping>=?__1
    (lambda (_comparator108761_ _mapping1108762_ _mapping2108763_)
      (let ((_val108765_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108761_
                'std/srfi/128#comparator::t))))
        (if _val108765_ _val108765_ (error)))
      (let ((_val108768_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108762_
                'std/srfi/146#<mapping>))))
        (if _val108768_ _val108768_ (error)))
      (let ((_val108771_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108763_
                'std/srfi/146#<mapping>))))
        (if _val108771_ _val108771_ (error)))
      (std/srfi/146#%mapping>=?
       _comparator108761_
       _mapping1108762_
       _mapping2108763_)))
  (define std/srfi/146#mapping>=?__2
    (lambda (_comparator108774_
             _mapping1108775_
             _mapping2108776_
             .
             _mappings108777_)
      (let ((_val108779_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108774_
                'std/srfi/128#comparator::t))))
        (if _val108779_ _val108779_ (error)))
      (let ((_val108782_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108775_
                'std/srfi/146#<mapping>))))
        (if _val108782_ _val108782_ (error)))
      (let ((_val108785_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108776_
                'std/srfi/146#<mapping>))))
        (if _val108785_ _val108785_ (error)))
      (if (std/srfi/146#%mapping>=?
           _comparator108774_
           _mapping1108775_
           _mapping2108776_)
          (apply std/srfi/146#mapping>=?
                 _comparator108774_
                 _mapping2108776_
                 _mappings108777_)
          '#f)))
  (define std/srfi/146#mapping>=?
    (lambda _g302771_
      (let ((_g302770_ (let () (declare (not safe)) (##length _g302771_))))
        (cond ((let () (declare (not safe)) (##fx= _g302770_ 2))
               (apply std/srfi/146#mapping>=?__0 _g302771_))
              ((let () (declare (not safe)) (##fx= _g302770_ 3))
               (apply std/srfi/146#mapping>=?__1 _g302771_))
              ((let () (declare (not safe)) (##fx>= _g302770_ 3))
               (apply std/srfi/146#mapping>=?__2 _g302771_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping>=?
                _g302771_))))))
  (define std/srfi/146#%mapping>=?
    (lambda (_comparator108742_ _mapping1108743_ _mapping2108744_)
      (let ((_val108746_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108742_
                'std/srfi/128#comparator::t))))
        (if _val108746_ _val108746_ (error)))
      (let ((_val108749_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108743_
                'std/srfi/146#<mapping>))))
        (if _val108749_ _val108749_ (error)))
      (let ((_val108752_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108744_
                'std/srfi/146#<mapping>))))
        (if _val108752_ _val108752_ (error)))
      (not (std/srfi/146#%mapping<?
            _comparator108742_
            _mapping1108743_
            _mapping2108744_))))
  (define std/srfi/146#%mapping-union
    (lambda (_mapping1108724_ _mapping2108725_)
      (std/srfi/146#mapping-fold
       (lambda (_key2108727_ _value2108728_ _mapping108729_)
         (let ((_g302772_
                (std/srfi/146#mapping-search
                 _mapping108729_
                 _key2108727_
                 (lambda (_insert108731_ _ignore108732_)
                   (_insert108731_ _value2108728_ '#f))
                 (lambda (_key1108734_
                          _value1108735_
                          _update108736_
                          _remove108737_)
                   (_update108736_ _key1108734_ _value1108735_ '#f)))))
           (begin
             (let ((_g302773_
                    (let ()
                      (declare (not safe))
                      (if (##values? _g302772_)
                          (##vector-length _g302772_)
                          1))))
               (if (not (let () (declare (not safe)) (##fx= _g302773_ 2)))
                   (error "Context expects 2 values" _g302773_)))
             (let ((_mapping108739_
                    (let () (declare (not safe)) (##vector-ref _g302772_ 0)))
                   (_obj108740_
                    (let () (declare (not safe)) (##vector-ref _g302772_ 1))))
               _mapping108739_))))
       _mapping1108724_
       _mapping2108725_)))
  (define std/srfi/146#%mapping-intersection
    (lambda (_mapping1108718_ _mapping2108719_)
      (std/srfi/146#mapping-filter
       (lambda (_key1108721_ _value1108722_)
         (std/srfi/146#mapping-contains? _mapping2108719_ _key1108721_))
       _mapping1108718_)))
  (define std/srfi/146#%mapping-difference
    (lambda (_mapping1108700_ _mapping2108701_)
      (std/srfi/146#mapping-fold
       (lambda (_key2108703_ _value2108704_ _mapping108705_)
         (let ((_g302774_
                (std/srfi/146#mapping-search
                 _mapping108705_
                 _key2108703_
                 (lambda (_insert108707_ _ignore108708_) (_ignore108708_ '#f))
                 (lambda (_key1108710_
                          _value1108711_
                          _update108712_
                          _remove108713_)
                   (_remove108713_ '#f)))))
           (begin
             (let ((_g302775_
                    (let ()
                      (declare (not safe))
                      (if (##values? _g302774_)
                          (##vector-length _g302774_)
                          1))))
               (if (not (let () (declare (not safe)) (##fx= _g302775_ 2)))
                   (error "Context expects 2 values" _g302775_)))
             (let ((_mapping108715_
                    (let () (declare (not safe)) (##vector-ref _g302774_ 0)))
                   (_obj108716_
                    (let () (declare (not safe)) (##vector-ref _g302774_ 1))))
               _mapping108715_))))
       _mapping1108700_
       _mapping2108701_)))
  (define std/srfi/146#%mapping-xor
    (lambda (_mapping1108682_ _mapping2108683_)
      (std/srfi/146#mapping-fold
       (lambda (_key2108685_ _value2108686_ _mapping108687_)
         (let ((_g302776_
                (std/srfi/146#mapping-search
                 _mapping108687_
                 _key2108685_
                 (lambda (_insert108689_ _ignore108690_)
                   (_insert108689_ _value2108686_ '#f))
                 (lambda (_key1108692_
                          _value1108693_
                          _update108694_
                          _remove108695_)
                   (_remove108695_ '#f)))))
           (begin
             (let ((_g302777_
                    (let ()
                      (declare (not safe))
                      (if (##values? _g302776_)
                          (##vector-length _g302776_)
                          1))))
               (if (not (let () (declare (not safe)) (##fx= _g302777_ 2)))
                   (error "Context expects 2 values" _g302777_)))
             (let ((_mapping108697_
                    (let () (declare (not safe)) (##vector-ref _g302776_ 0)))
                   (_obj108698_
                    (let () (declare (not safe)) (##vector-ref _g302776_ 1))))
               _mapping108697_))))
       _mapping1108682_
       _mapping2108683_)))
  (define std/srfi/146#mapping-union__0
    (lambda (_mapping108658_)
      (let ((_val108660_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108658_
                'std/srfi/146#<mapping>))))
        (if _val108660_ _val108660_ (error)))
      _mapping108658_))
  (define std/srfi/146#mapping-union__1
    (lambda (_mapping1108663_ _mapping2108664_)
      (let ((_val108666_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108663_
                'std/srfi/146#<mapping>))))
        (if _val108666_ _val108666_ (error)))
      (let ((_val108669_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108664_
                'std/srfi/146#<mapping>))))
        (if _val108669_ _val108669_ (error)))
      (std/srfi/146#%mapping-union _mapping1108663_ _mapping2108664_)))
  (define std/srfi/146#mapping-union__2
    (lambda (_mapping1108672_ _mapping2108673_ . _mappings108674_)
      (let ((_val108676_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108672_
                'std/srfi/146#<mapping>))))
        (if _val108676_ _val108676_ (error)))
      (let ((_val108679_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108673_
                'std/srfi/146#<mapping>))))
        (if _val108679_ _val108679_ (error)))
      (apply std/srfi/146#mapping-union
             (std/srfi/146#%mapping-union _mapping1108672_ _mapping2108673_)
             _mappings108674_)))
  (define std/srfi/146#mapping-union
    (lambda _g302779_
      (let ((_g302778_ (let () (declare (not safe)) (##length _g302779_))))
        (cond ((let () (declare (not safe)) (##fx= _g302778_ 1))
               (apply std/srfi/146#mapping-union__0 _g302779_))
              ((let () (declare (not safe)) (##fx= _g302778_ 2))
               (apply std/srfi/146#mapping-union__1 _g302779_))
              ((let () (declare (not safe)) (##fx>= _g302778_ 2))
               (apply std/srfi/146#mapping-union__2 _g302779_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping-union
                _g302779_))))))
  (define std/srfi/146#mapping-union! std/srfi/146#mapping-union)
  (define std/srfi/146#mapping-intersection__0
    (lambda (_mapping108634_)
      (let ((_val108636_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108634_
                'std/srfi/146#<mapping>))))
        (if _val108636_ _val108636_ (error)))
      _mapping108634_))
  (define std/srfi/146#mapping-intersection__1
    (lambda (_mapping1108639_ _mapping2108640_)
      (let ((_val108642_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108639_
                'std/srfi/146#<mapping>))))
        (if _val108642_ _val108642_ (error)))
      (let ((_val108645_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108640_
                'std/srfi/146#<mapping>))))
        (if _val108645_ _val108645_ (error)))
      (std/srfi/146#%mapping-intersection _mapping1108639_ _mapping2108640_)))
  (define std/srfi/146#mapping-intersection__2
    (lambda (_mapping1108648_ _mapping2108649_ . _mappings108650_)
      (let ((_val108652_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108648_
                'std/srfi/146#<mapping>))))
        (if _val108652_ _val108652_ (error)))
      (let ((_val108655_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108649_
                'std/srfi/146#<mapping>))))
        (if _val108655_ _val108655_ (error)))
      (apply std/srfi/146#mapping-intersection
             (std/srfi/146#%mapping-intersection
              _mapping1108648_
              _mapping2108649_)
             _mappings108650_)))
  (define std/srfi/146#mapping-intersection
    (lambda _g302781_
      (let ((_g302780_ (let () (declare (not safe)) (##length _g302781_))))
        (cond ((let () (declare (not safe)) (##fx= _g302780_ 1))
               (apply std/srfi/146#mapping-intersection__0 _g302781_))
              ((let () (declare (not safe)) (##fx= _g302780_ 2))
               (apply std/srfi/146#mapping-intersection__1 _g302781_))
              ((let () (declare (not safe)) (##fx>= _g302780_ 2))
               (apply std/srfi/146#mapping-intersection__2 _g302781_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping-intersection
                _g302781_))))))
  (define std/srfi/146#mapping-intersection! std/srfi/146#mapping-intersection)
  (define std/srfi/146#mapping-difference__0
    (lambda (_mapping108610_)
      (let ((_val108612_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108610_
                'std/srfi/146#<mapping>))))
        (if _val108612_ _val108612_ (error)))
      _mapping108610_))
  (define std/srfi/146#mapping-difference__1
    (lambda (_mapping1108615_ _mapping2108616_)
      (let ((_val108618_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108615_
                'std/srfi/146#<mapping>))))
        (if _val108618_ _val108618_ (error)))
      (let ((_val108621_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108616_
                'std/srfi/146#<mapping>))))
        (if _val108621_ _val108621_ (error)))
      (std/srfi/146#%mapping-difference _mapping1108615_ _mapping2108616_)))
  (define std/srfi/146#mapping-difference__2
    (lambda (_mapping1108624_ _mapping2108625_ . _mappings108626_)
      (let ((_val108628_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108624_
                'std/srfi/146#<mapping>))))
        (if _val108628_ _val108628_ (error)))
      (let ((_val108631_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108625_
                'std/srfi/146#<mapping>))))
        (if _val108631_ _val108631_ (error)))
      (apply std/srfi/146#mapping-difference
             (std/srfi/146#%mapping-difference
              _mapping1108624_
              _mapping2108625_)
             _mappings108626_)))
  (define std/srfi/146#mapping-difference
    (lambda _g302783_
      (let ((_g302782_ (let () (declare (not safe)) (##length _g302783_))))
        (cond ((let () (declare (not safe)) (##fx= _g302782_ 1))
               (apply std/srfi/146#mapping-difference__0 _g302783_))
              ((let () (declare (not safe)) (##fx= _g302782_ 2))
               (apply std/srfi/146#mapping-difference__1 _g302783_))
              ((let () (declare (not safe)) (##fx>= _g302782_ 2))
               (apply std/srfi/146#mapping-difference__2 _g302783_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping-difference
                _g302783_))))))
  (define std/srfi/146#mapping-difference! std/srfi/146#mapping-difference)
  (define std/srfi/146#mapping-xor__0
    (lambda (_mapping108586_)
      (let ((_val108588_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108586_
                'std/srfi/146#<mapping>))))
        (if _val108588_ _val108588_ (error)))
      _mapping108586_))
  (define std/srfi/146#mapping-xor__1
    (lambda (_mapping1108591_ _mapping2108592_)
      (let ((_val108594_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108591_
                'std/srfi/146#<mapping>))))
        (if _val108594_ _val108594_ (error)))
      (let ((_val108597_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108592_
                'std/srfi/146#<mapping>))))
        (if _val108597_ _val108597_ (error)))
      (std/srfi/146#%mapping-xor _mapping1108591_ _mapping2108592_)))
  (define std/srfi/146#mapping-xor__2
    (lambda (_mapping1108600_ _mapping2108601_ . _mappings108602_)
      (let ((_val108604_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108600_
                'std/srfi/146#<mapping>))))
        (if _val108604_ _val108604_ (error)))
      (let ((_val108607_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108601_
                'std/srfi/146#<mapping>))))
        (if _val108607_ _val108607_ (error)))
      (apply std/srfi/146#mapping-xor
             (std/srfi/146#%mapping-xor _mapping1108600_ _mapping2108601_)
             _mappings108602_)))
  (define std/srfi/146#mapping-xor
    (lambda _g302785_
      (let ((_g302784_ (let () (declare (not safe)) (##length _g302785_))))
        (cond ((let () (declare (not safe)) (##fx= _g302784_ 1))
               (apply std/srfi/146#mapping-xor__0 _g302785_))
              ((let () (declare (not safe)) (##fx= _g302784_ 2))
               (apply std/srfi/146#mapping-xor__1 _g302785_))
              ((let () (declare (not safe)) (##fx>= _g302784_ 2))
               (apply std/srfi/146#mapping-xor__2 _g302785_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146#mapping-xor
                _g302785_))))))
  (define std/srfi/146#mapping-xor! std/srfi/146#mapping-xor)
  (define std/srfi/146#mapping-min-key
    (lambda (_mapping108575_)
      (let ((_val108577_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108575_
                'std/srfi/146#<mapping>))))
        (if _val108577_ _val108577_ (error)))
      (call-with-current-continuation
       (lambda (_return108580_)
         (std/srfi/146#mapping-fold
          (lambda (_key108582_ _value108583_ _acc108584_)
            (_return108580_ _key108582_))
          '#f
          _mapping108575_)
         (error '"mapping-min-key: empty map")))))
  (define std/srfi/146#mapping-max-key
    (lambda (_mapping108564_)
      (let ((_val108566_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108564_
                'std/srfi/146#<mapping>))))
        (if _val108566_ _val108566_ (error)))
      (call-with-current-continuation
       (lambda (_return108569_)
         (std/srfi/146#mapping-fold/reverse
          (lambda (_key108571_ _value108572_ _acc108573_)
            (_return108569_ _key108571_))
          '#f
          _mapping108564_)
         (error '"mapping-max-key: empty map")))))
  (define std/srfi/146#mapping-min-value
    (lambda (_mapping108553_)
      (let ((_val108555_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108553_
                'std/srfi/146#<mapping>))))
        (if _val108555_ _val108555_ (error)))
      (call-with-current-continuation
       (lambda (_return108558_)
         (std/srfi/146#mapping-fold
          (lambda (_key108560_ _value108561_ _acc108562_)
            (_return108558_ _value108561_))
          '#f
          _mapping108553_)
         (error '"mapping-min-value: empty map")))))
  (define std/srfi/146#mapping-max-value
    (lambda (_mapping108542_)
      (let ((_val108544_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108542_
                'std/srfi/146#<mapping>))))
        (if _val108544_ _val108544_ (error)))
      (call-with-current-continuation
       (lambda (_return108547_)
         (std/srfi/146#mapping-fold/reverse
          (lambda (_key108549_ _value108550_ _acc108551_)
            (_return108547_ _value108550_))
          '#f
          _mapping108542_)
         (error '"mapping-max-value: empty map")))))
  (define std/srfi/146#mapping-min-entry
    (lambda (_mapping108531_)
      (let ((_val108533_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108531_
                'std/srfi/146#<mapping>))))
        (if _val108533_ _val108533_ (error)))
      (call-with-current-continuation
       (lambda (_return108536_)
         (std/srfi/146#mapping-fold
          (lambda (_key108538_ _value108539_ _acc108540_)
            (_return108536_ _key108538_ _value108539_))
          '#f
          _mapping108531_)
         (error '"mapping-min-key: empty map")))))
  (define std/srfi/146#mapping-max-entry
    (lambda (_mapping108520_)
      (let ((_val108522_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108520_
                'std/srfi/146#<mapping>))))
        (if _val108522_ _val108522_ (error)))
      (call-with-current-continuation
       (lambda (_return108525_)
         (std/srfi/146#mapping-fold/reverse
          (lambda (_key108527_ _value108528_ _acc108529_)
            (_return108525_ _key108527_ _value108528_))
          '#f
          _mapping108520_)
         (error '"mapping-max-key: empty map")))))
  (define std/srfi/146#mapping-key-predecessor
    (lambda (_mapping108510_ _obj108511_ _failure108512_)
      (let ((_val108514_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108510_
                'std/srfi/146#<mapping>))))
        (if _val108514_ _val108514_ (error)))
      (let ((_val108517_ (procedure? _failure108512_)))
        (if _val108517_ _val108517_ (error)))
      (std/srfi/146#tree-key-predecessor
       (##structure-ref _mapping108510_ '1 std/srfi/146#<mapping> '#f)
       (##structure-ref _mapping108510_ '2 std/srfi/146#<mapping> '#f)
       _obj108511_
       _failure108512_)))
  (define std/srfi/146#mapping-key-successor
    (lambda (_mapping108500_ _obj108501_ _failure108502_)
      (let ((_val108504_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108500_
                'std/srfi/146#<mapping>))))
        (if _val108504_ _val108504_ (error)))
      (let ((_val108507_ (procedure? _failure108502_)))
        (if _val108507_ _val108507_ (error)))
      (std/srfi/146#tree-key-successor
       (##structure-ref _mapping108500_ '1 std/srfi/146#<mapping> '#f)
       (##structure-ref _mapping108500_ '2 std/srfi/146#<mapping> '#f)
       _obj108501_
       _failure108502_)))
  (define std/srfi/146#mapping-range=
    (lambda (_mapping108486_ _obj108487_)
      (let ((_val108489_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108486_
                'std/srfi/146#<mapping>))))
        (if _val108489_ _val108489_ (error)))
      (let* ((_comparator108492_
              (##structure-ref _mapping108486_ '1 std/srfi/146#<mapping> '#f))
             (_g302786_
              (std/srfi/146#tree-split
               _comparator108492_
               (##structure-ref _mapping108486_ '2 std/srfi/146#<mapping> '#f)
               _obj108487_)))
        (begin
          (let ((_g302787_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g302786_) (##vector-length _g302786_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g302787_ 5)))
                (error "Context expects 5 values" _g302787_)))
          (let ((_tree<108494_
                 (let () (declare (not safe)) (##vector-ref _g302786_ 0)))
                (_tree<=108495_
                 (let () (declare (not safe)) (##vector-ref _g302786_ 1)))
                (_tree=108496_
                 (let () (declare (not safe)) (##vector-ref _g302786_ 2)))
                (_tree>=108497_
                 (let () (declare (not safe)) (##vector-ref _g302786_ 3)))
                (_tree>108498_
                 (let () (declare (not safe)) (##vector-ref _g302786_ 4))))
            (let ()
              (declare (not safe))
              (##structure
               std/srfi/146#<mapping>
               _comparator108492_
               _tree=108496_)))))))
  (define std/srfi/146#mapping-range<
    (lambda (_mapping108472_ _obj108473_)
      (let ((_val108475_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108472_
                'std/srfi/146#<mapping>))))
        (if _val108475_ _val108475_ (error)))
      (let* ((_comparator108478_
              (##structure-ref _mapping108472_ '1 std/srfi/146#<mapping> '#f))
             (_g302788_
              (std/srfi/146#tree-split
               _comparator108478_
               (##structure-ref _mapping108472_ '2 std/srfi/146#<mapping> '#f)
               _obj108473_)))
        (begin
          (let ((_g302789_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g302788_) (##vector-length _g302788_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g302789_ 5)))
                (error "Context expects 5 values" _g302789_)))
          (let ((_tree<108480_
                 (let () (declare (not safe)) (##vector-ref _g302788_ 0)))
                (_tree<=108481_
                 (let () (declare (not safe)) (##vector-ref _g302788_ 1)))
                (_tree=108482_
                 (let () (declare (not safe)) (##vector-ref _g302788_ 2)))
                (_tree>=108483_
                 (let () (declare (not safe)) (##vector-ref _g302788_ 3)))
                (_tree>108484_
                 (let () (declare (not safe)) (##vector-ref _g302788_ 4))))
            (let ()
              (declare (not safe))
              (##structure
               std/srfi/146#<mapping>
               _comparator108478_
               _tree<108480_)))))))
  (define std/srfi/146#mapping-range<=
    (lambda (_mapping108458_ _obj108459_)
      (let ((_val108461_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108458_
                'std/srfi/146#<mapping>))))
        (if _val108461_ _val108461_ (error)))
      (let* ((_comparator108464_
              (##structure-ref _mapping108458_ '1 std/srfi/146#<mapping> '#f))
             (_g302790_
              (std/srfi/146#tree-split
               _comparator108464_
               (##structure-ref _mapping108458_ '2 std/srfi/146#<mapping> '#f)
               _obj108459_)))
        (begin
          (let ((_g302791_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g302790_) (##vector-length _g302790_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g302791_ 5)))
                (error "Context expects 5 values" _g302791_)))
          (let ((_tree<108466_
                 (let () (declare (not safe)) (##vector-ref _g302790_ 0)))
                (_tree<=108467_
                 (let () (declare (not safe)) (##vector-ref _g302790_ 1)))
                (_tree=108468_
                 (let () (declare (not safe)) (##vector-ref _g302790_ 2)))
                (_tree>=108469_
                 (let () (declare (not safe)) (##vector-ref _g302790_ 3)))
                (_tree>108470_
                 (let () (declare (not safe)) (##vector-ref _g302790_ 4))))
            (let ()
              (declare (not safe))
              (##structure
               std/srfi/146#<mapping>
               _comparator108464_
               _tree<=108467_)))))))
  (define std/srfi/146#mapping-range>
    (lambda (_mapping108444_ _obj108445_)
      (let ((_val108447_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108444_
                'std/srfi/146#<mapping>))))
        (if _val108447_ _val108447_ (error)))
      (let* ((_comparator108450_
              (##structure-ref _mapping108444_ '1 std/srfi/146#<mapping> '#f))
             (_g302792_
              (std/srfi/146#tree-split
               _comparator108450_
               (##structure-ref _mapping108444_ '2 std/srfi/146#<mapping> '#f)
               _obj108445_)))
        (begin
          (let ((_g302793_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g302792_) (##vector-length _g302792_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g302793_ 5)))
                (error "Context expects 5 values" _g302793_)))
          (let ((_tree<108452_
                 (let () (declare (not safe)) (##vector-ref _g302792_ 0)))
                (_tree<=108453_
                 (let () (declare (not safe)) (##vector-ref _g302792_ 1)))
                (_tree=108454_
                 (let () (declare (not safe)) (##vector-ref _g302792_ 2)))
                (_tree>=108455_
                 (let () (declare (not safe)) (##vector-ref _g302792_ 3)))
                (_tree>108456_
                 (let () (declare (not safe)) (##vector-ref _g302792_ 4))))
            (let ()
              (declare (not safe))
              (##structure
               std/srfi/146#<mapping>
               _comparator108450_
               _tree>108456_)))))))
  (define std/srfi/146#mapping-range>=
    (lambda (_mapping108427_ _obj108428_)
      (let ((_val108430_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108427_
                'std/srfi/146#<mapping>))))
        (if _val108430_ _val108430_ (error)))
      (let ((_val108433_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108427_
                'std/srfi/146#<mapping>))))
        (if _val108433_ _val108433_ (error)))
      (let* ((_comparator108436_
              (##structure-ref _mapping108427_ '1 std/srfi/146#<mapping> '#f))
             (_g302794_
              (std/srfi/146#tree-split
               _comparator108436_
               (##structure-ref _mapping108427_ '2 std/srfi/146#<mapping> '#f)
               _obj108428_)))
        (begin
          (let ((_g302795_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g302794_) (##vector-length _g302794_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g302795_ 5)))
                (error "Context expects 5 values" _g302795_)))
          (let ((_tree<108438_
                 (let () (declare (not safe)) (##vector-ref _g302794_ 0)))
                (_tree<=108439_
                 (let () (declare (not safe)) (##vector-ref _g302794_ 1)))
                (_tree=108440_
                 (let () (declare (not safe)) (##vector-ref _g302794_ 2)))
                (_tree>=108441_
                 (let () (declare (not safe)) (##vector-ref _g302794_ 3)))
                (_tree>108442_
                 (let () (declare (not safe)) (##vector-ref _g302794_ 4))))
            (let ()
              (declare (not safe))
              (##structure
               std/srfi/146#<mapping>
               _comparator108436_
               _tree>=108441_)))))))
  (define std/srfi/146#mapping-range=! std/srfi/146#mapping-range=)
  (define std/srfi/146#mapping-range<! std/srfi/146#mapping-range<)
  (define std/srfi/146#mapping-range>! std/srfi/146#mapping-range>)
  (define std/srfi/146#mapping-range<=! std/srfi/146#mapping-range<=)
  (define std/srfi/146#mapping-range>=! std/srfi/146#mapping-range>=)
  (define std/srfi/146#mapping-split
    (lambda (_mapping108413_ _obj108414_)
      (let ((_val108416_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108413_
                'std/srfi/146#<mapping>))))
        (if _val108416_ _val108416_ (error)))
      (let* ((_comparator108419_
              (##structure-ref _mapping108413_ '1 std/srfi/146#<mapping> '#f))
             (_g302796_
              (std/srfi/146#tree-split
               _comparator108419_
               (##structure-ref _mapping108413_ '2 std/srfi/146#<mapping> '#f)
               _obj108414_)))
        (begin
          (let ((_g302797_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g302796_) (##vector-length _g302796_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g302797_ 5)))
                (error "Context expects 5 values" _g302797_)))
          (let ((_tree<108421_
                 (let () (declare (not safe)) (##vector-ref _g302796_ 0)))
                (_tree<=108422_
                 (let () (declare (not safe)) (##vector-ref _g302796_ 1)))
                (_tree=108423_
                 (let () (declare (not safe)) (##vector-ref _g302796_ 2)))
                (_tree>=108424_
                 (let () (declare (not safe)) (##vector-ref _g302796_ 3)))
                (_tree>108425_
                 (let () (declare (not safe)) (##vector-ref _g302796_ 4))))
            (values (let ()
                      (declare (not safe))
                      (##structure
                       std/srfi/146#<mapping>
                       _comparator108419_
                       _tree<108421_))
                    (let ()
                      (declare (not safe))
                      (##structure
                       std/srfi/146#<mapping>
                       _comparator108419_
                       _tree<=108422_))
                    (let ()
                      (declare (not safe))
                      (##structure
                       std/srfi/146#<mapping>
                       _comparator108419_
                       _tree=108423_))
                    (let ()
                      (declare (not safe))
                      (##structure
                       std/srfi/146#<mapping>
                       _comparator108419_
                       _tree>=108424_))
                    (let ()
                      (declare (not safe))
                      (##structure
                       std/srfi/146#<mapping>
                       _comparator108419_
                       _tree>108425_))))))))
  (define std/srfi/146#mapping-split! std/srfi/146#mapping-split)
  (define std/srfi/146#mapping-catenate
    (lambda (_comparator108398_
             _mapping1108399_
             _pivot-key108400_
             _pivot-value108401_
             _mapping2108402_)
      (let ((_val108404_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108398_
                'std/srfi/128#comparator::t))))
        (if _val108404_ _val108404_ (error)))
      (let ((_val108407_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping1108399_
                'std/srfi/146#<mapping>))))
        (if _val108407_ _val108407_ (error)))
      (let ((_val108410_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping2108402_
                'std/srfi/146#<mapping>))))
        (if _val108410_ _val108410_ (error)))
      (let ((__tmp302798
             (std/srfi/146#tree-catenate
              (##structure-ref _mapping1108399_ '2 std/srfi/146#<mapping> '#f)
              _pivot-key108400_
              _pivot-value108401_
              (##structure-ref
               _mapping2108402_
               '2
               std/srfi/146#<mapping>
               '#f))))
        (declare (not safe))
        (##structure std/srfi/146#<mapping> _comparator108398_ __tmp302798))))
  (define std/srfi/146#mapping-catenate! std/srfi/146#mapping-catenate)
  (define std/srfi/146#mapping-map/monotone
    (lambda (_proc108385_ _comparator108386_ _mapping108387_)
      (let ((_val108389_ (procedure? _proc108385_)))
        (if _val108389_ _val108389_ (error)))
      (let ((_val108392_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108386_
                'std/srfi/128#comparator::t))))
        (if _val108392_ _val108392_ (error)))
      (let ((_val108395_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108387_
                'std/srfi/146#<mapping>))))
        (if _val108395_ _val108395_ (error)))
      (let ((__tmp302799
             (std/srfi/146#tree-map
              _proc108385_
              (##structure-ref
               _mapping108387_
               '2
               std/srfi/146#<mapping>
               '#f))))
        (declare (not safe))
        (##structure std/srfi/146#<mapping> _comparator108386_ __tmp302799))))
  (define std/srfi/146#mapping-map/monotone! std/srfi/146#mapping-map/monotone)
  (define std/srfi/146#mapping-fold/reverse
    (lambda (_proc108375_ _acc108376_ _mapping108377_)
      (let ((_val108379_ (procedure? _proc108375_)))
        (if _val108379_ _val108379_ (error)))
      (let ((_val108382_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _mapping108377_
                'std/srfi/146#<mapping>))))
        (if _val108382_ _val108382_ (error)))
      (std/misc/rbtree#rbtree-foldr
       _proc108375_
       _acc108376_
       (##structure-ref _mapping108377_ '2 std/srfi/146#<mapping> '#f))))
  (define std/srfi/146#mapping-equality
    (lambda (_comparator108367_)
      (let ((_val108369_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108367_
                'std/srfi/128#comparator::t))))
        (if _val108369_ _val108369_ (error)))
      (lambda (_mapping1108372_ _mapping2108373_)
        (std/srfi/146#%mapping=?
         _comparator108367_
         _mapping1108372_
         _mapping2108373_))))
  (define std/srfi/146#mapping-ordering
    (lambda (_comparator108334_)
      (let ((_val108336_
             (let ()
               (declare (not safe))
               (##structure-direct-instance-of?
                _comparator108334_
                'std/srfi/128#comparator::t))))
        (if _val108336_ _val108336_ (error)))
      (let ((_value-equality108339_
             (##direct-structure-ref
              _comparator108334_
              '2
              std/srfi/128#comparator::t
              '#f))
            (_value-ordering108340_
             (std/srfi/128#comparator-ordering-predicate _comparator108334_)))
        (lambda (_mapping1108342_ _mapping2108343_)
          (let* ((_key-comparator108345_
                  (##structure-ref
                   _mapping1108342_
                   '1
                   std/srfi/146#<mapping>
                   '#f))
                 (_equality108347_
                  (##direct-structure-ref
                   _key-comparator108345_
                   '2
                   std/srfi/128#comparator::t
                   '#f))
                 (_ordering108349_
                  (std/srfi/128#comparator-ordering-predicate
                   _key-comparator108345_))
                 (_gen1108351_
                  (std/srfi/146#tree-generator
                   (##structure-ref
                    _mapping1108342_
                    '2
                    std/srfi/146#<mapping>
                    '#f)))
                 (_gen2108353_
                  (std/srfi/146#tree-generator
                   (##structure-ref
                    _mapping2108343_
                    '2
                    std/srfi/146#<mapping>
                    '#f))))
            (let _loop108356_ ()
              (let ((_item1108359_ (_gen1108351_))
                    (_item2108360_ (_gen2108353_)))
                (if (eof-object? _item1108359_)
                    (not (eof-object? _item2108360_))
                    (if (eof-object? _item2108360_)
                        '#f
                        (let ((_key1108362_ (car _item1108359_))
                              (_value1108363_ (cadr _item1108359_))
                              (_key2108364_ (car _item2108360_))
                              (_value2108365_ (cadr _item2108360_)))
                          (if (_equality108347_ _key1108362_ _key2108364_)
                              (if (_value-equality108339_
                                   _value1108363_
                                   _value2108365_)
                                  (_loop108356_)
                                  (_value-ordering108340_
                                   _value1108363_
                                   _value2108365_))
                              (_ordering108349_
                               _key1108362_
                               _key2108364_))))))))))))
  (define std/srfi/146#make-mapping-comparator
    (lambda (_comparator108332_)
      (let ((__tmp302801 (std/srfi/146#mapping-equality _comparator108332_))
            (__tmp302800 (std/srfi/146#mapping-ordering _comparator108332_)))
        (declare (not safe))
        (##structure
         std/srfi/128#comparator::t
         std/srfi/146#mapping?
         __tmp302801
         __tmp302800
         '#f))))
  (define std/srfi/146#mapping-comparator
    (std/srfi/146#make-mapping-comparator
     (std/srfi/128#make-default-comparator)))
  (std/srfi/128#comparator-register-default! std/srfi/146#mapping-comparator))
