(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/158#any
    (lambda (_pred114317_ _ls114318_)
      (if (null? (cdr _ls114318_))
          (_pred114317_ (car _ls114318_))
          ((lambda (_x114320_)
             (if _x114320_
                 _x114320_
                 (std/srfi/158#any _pred114317_ (cdr _ls114318_))))
           (_pred114317_ (car _ls114318_))))))
  (define std/srfi/158#list->bytevector
    (lambda (_list114308_)
      (let ((_vec114310_ (make-u8vector (length _list114308_) '0)))
        (let _loop114312_ ((_i114314_ '0) (_list114315_ _list114308_))
          (if (null? _list114315_)
              _vec114310_
              (begin
                (u8vector-set! _vec114310_ _i114314_ (car _list114315_))
                (_loop114312_ (+ _i114314_ '1) (cdr _list114315_))))))))
  (define std/srfi/158#circular-generator
    (lambda _args114301_
      (let ((_base-args114303_ _args114301_))
        (lambda ()
          (if (null? _args114301_)
              (set! _args114301_ _base-args114303_)
              '#!void)
          (let ((_next114306_ (car _args114301_)))
            (set! _args114301_ (cdr _args114301_))
            _next114306_)))))
  (define std/srfi/158#gflatten
    (lambda (_gen114294_)
      (let ((_state114296_ '()))
        (lambda ()
          (if (null? _state114296_) (set! _state114296_ (_gen114294_)) '#!void)
          (if (eof-object? _state114296_)
              _state114296_
              (let ((_obj114299_ (car _state114296_)))
                (set! _state114296_ (cdr _state114296_))
                _obj114299_))))))
  (define std/srfi/158#ggroup__1
    (lambda (_gen114290_ _k114291_ _padding114292_)
      (std/srfi/158#padded-ggroup
       (std/srfi/158#simple-ggroup _gen114290_ _k114291_)
       _k114291_
       _padding114292_)))
  (define std/srfi/158#ggroup
    (lambda _g289984_
      (let ((_g289983_ (let () (declare (not safe)) (##length _g289984_))))
        (cond ((let () (declare (not safe)) (##fx= _g289983_ 2))
               (apply std/srfi/158#simple-ggroup _g289984_))
              ((let () (declare (not safe)) (##fx= _g289983_ 3))
               (apply std/srfi/158#ggroup__1 _g289984_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/158#ggroup
                _g289984_))))))
  (define std/srfi/158#simple-ggroup
    (lambda (_gen114277_ _k114278_)
      (lambda ()
        (let _loop114281_ ((_item114283_ (_gen114277_))
                           (_result114284_ '())
                           (_count114285_ (- _k114278_ '1)))
          (if (eof-object? _item114283_)
              (if (null? _result114284_) _item114283_ (reverse _result114284_))
              (if (= _count114285_ '0)
                  (reverse (cons _item114283_ _result114284_))
                  (_loop114281_
                   (_gen114277_)
                   (cons _item114283_ _result114284_)
                   (- _count114285_ '1))))))))
  (define std/srfi/158#padded-ggroup
    (lambda (_gen114268_ _k114269_ _padding114270_)
      (lambda ()
        (let ((_item114273_ (_gen114268_)))
          (if (eof-object? _item114273_)
              _item114273_
              (let ((_len114275_ (length _item114273_)))
                (if (= _len114275_ _k114269_)
                    _item114273_
                    (append _item114273_
                            (make-list
                             (- _k114269_ _len114275_)
                             _padding114270_)))))))))
  (define std/srfi/158#gmerge__0
    (lambda (_<114239_) (error '"wrong number of arguments for gmerge")))
  (define std/srfi/158#gmerge__1 (lambda (_<114241_ _gen114242_) _gen114242_))
  (define std/srfi/158#gmerge__2
    (lambda (_<114244_ _genleft114245_ _genright114246_)
      (let ((_left114248_ (_genleft114245_))
            (_right114249_ (_genright114246_)))
        (lambda ()
          (if (and (eof-object? _left114248_) (eof-object? _right114249_))
              _left114248_
              (if (eof-object? _left114248_)
                  (let ((_obj114252_ _right114249_))
                    (set! _right114249_ (_genright114246_))
                    _obj114252_)
                  (if (eof-object? _right114249_)
                      (let ((_obj114254_ _left114248_))
                        (set! _left114248_ (_genleft114245_))
                        _obj114254_)
                      (if (_<114244_ _right114249_ _left114248_)
                          (let ((_obj114256_ _right114249_))
                            (set! _right114249_ (_genright114246_))
                            _obj114256_)
                          (let ((_obj114258_ _left114248_))
                            (set! _left114248_ (_genleft114245_))
                            _obj114258_)))))))))
  (define std/srfi/158#gmerge__3
    (lambda (_<114260_ . _gens114261_)
      (apply std/srfi/158#gmerge
             _<114260_
             (let _loop114263_ ((_gens114265_ _gens114261_) (_gs114266_ '()))
               (if (null? _gens114265_)
                   (reverse _gs114266_)
                   (if (null? (cdr _gens114265_))
                       (reverse (cons (car _gens114265_) _gs114266_))
                       (_loop114263_
                        (cddr _gens114265_)
                        (cons (std/srfi/158#gmerge__2
                               _<114260_
                               (car _gens114265_)
                               (cadr _gens114265_))
                              _gs114266_))))))))
  (define std/srfi/158#gmerge
    (lambda _g289986_
      (let ((_g289985_ (let () (declare (not safe)) (##length _g289986_))))
        (cond ((let () (declare (not safe)) (##fx= _g289985_ 1))
               (apply std/srfi/158#gmerge__0 _g289986_))
              ((let () (declare (not safe)) (##fx= _g289985_ 2))
               (apply std/srfi/158#gmerge__1 _g289986_))
              ((let () (declare (not safe)) (##fx= _g289985_ 3))
               (apply std/srfi/158#gmerge__2 _g289986_))
              ((let () (declare (not safe)) (##fx>= _g289985_ 1))
               (apply std/srfi/158#gmerge__3 _g289986_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/158#gmerge
                _g289986_))))))
  (define std/srfi/158#gmap__0
    (lambda (_proc114223_) (error '"wrong number of arguments for gmap")))
  (define std/srfi/158#gmap__1
    (lambda (_proc114225_ _gen114226_)
      (lambda ()
        (let ((_item114229_ (_gen114226_)))
          (if (eof-object? _item114229_)
              _item114229_
              (_proc114225_ _item114229_))))))
  (define std/srfi/158#gmap__2
    (lambda (_proc114231_ . _gens114232_)
      (lambda ()
        (let ((_items114237_
               (map (lambda (_x114235_) (_x114235_)) _gens114232_)))
          (if (std/srfi/158#any eof-object? _items114237_)
              (eof-object)
              (apply _proc114231_ _items114237_))))))
  (define std/srfi/158#gmap
    (lambda _g289988_
      (let ((_g289987_ (let () (declare (not safe)) (##length _g289988_))))
        (cond ((let () (declare (not safe)) (##fx= _g289987_ 1))
               (apply std/srfi/158#gmap__0 _g289988_))
              ((let () (declare (not safe)) (##fx= _g289987_ 2))
               (apply std/srfi/158#gmap__1 _g289988_))
              ((let () (declare (not safe)) (##fx>= _g289987_ 1))
               (apply std/srfi/158#gmap__2 _g289988_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/158#gmap
                _g289988_))))))
  (define std/srfi/158#gstate-filter
    (lambda (_proc114209_ _seed114210_ _gen114211_)
      (let ((_state114213_ _seed114210_))
        (lambda ()
          (let _loop114216_ ((_item114218_ (_gen114211_)))
            (if (eof-object? _item114218_)
                _item114218_
                (let ((_g289989_ (_proc114209_ _item114218_ _state114213_)))
                  (begin
                    (let ((_g289990_
                           (let ()
                             (declare (not safe))
                             (if (##values? _g289989_)
                                 (##vector-length _g289989_)
                                 1))))
                      (if (not (let ()
                                 (declare (not safe))
                                 (##fx= _g289990_ 2)))
                          (error "Context expects 2 values" _g289990_)))
                    (let ((_yes114220_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _g289989_ 0)))
                          (_newstate114221_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _g289989_ 1))))
                      (begin
                        (set! _state114213_ _newstate114221_)
                        (if _yes114220_
                            _item114218_
                            (_loop114216_ (_gen114211_)))))))))))))
  (define std/srfi/158#generator-map->list
    (lambda (_f114198_ . _gs114199_)
      (let _loop114201_ ((_result114203_ '()))
        (let ((_vs114207_ (map (lambda (_g114205_) (_g114205_)) _gs114199_)))
          (if (std/srfi/158#any eof-object? _vs114207_)
              (reverse _result114203_)
              (_loop114201_
               (cons (apply _f114198_ _vs114207_) _result114203_)))))))
  (define std/srfi/158#make-accumulator
    (lambda (_kons114190_ _knil114191_ _finalize114192_)
      (let ((_state114194_ _knil114191_))
        (lambda (_obj114196_)
          (if (eof-object? _obj114196_)
              (_finalize114192_ _state114194_)
              (set! _state114194_
                    (_kons114190_ _obj114196_ _state114194_)))))))
  (define std/srfi/158#count-accumulator
    (lambda ()
      (std/srfi/158#make-accumulator
       (lambda (_obj114185_ _state114186_) (+ '1 _state114186_))
       '0
       (lambda (_x114188_) _x114188_))))
  (define std/srfi/158#list-accumulator
    (lambda () (std/srfi/158#make-accumulator cons '() reverse)))
  (define std/srfi/158#reverse-list-accumulator
    (lambda ()
      (std/srfi/158#make-accumulator cons '() (lambda (_x114181_) _x114181_))))
  (define std/srfi/158#vector-accumulator
    (lambda ()
      (std/srfi/158#make-accumulator
       cons
       '()
       (lambda (_x114178_) (list->vector (reverse _x114178_))))))
  (define std/srfi/158#reverse-vector-accumulator
    (lambda () (std/srfi/158#make-accumulator cons '() list->vector)))
  (define std/srfi/158#vector-accumulator!
    (lambda (_vec114171_ _at114172_)
      (lambda (_obj114174_)
        (if (eof-object? _obj114174_)
            _vec114171_
            (begin
              (vector-set! _vec114171_ _at114172_ _obj114174_)
              (set! _at114172_ (+ _at114172_ '1)))))))
  (define std/srfi/158#bytevector-accumulator
    (lambda ()
      (std/srfi/158#make-accumulator
       cons
       '()
       (lambda (_x114169_)
         (std/srfi/158#list->bytevector (reverse _x114169_))))))
  (define std/srfi/158#bytevector-accumulator!
    (lambda (_bytevec114163_ _at114164_)
      (lambda (_obj114166_)
        (if (eof-object? _obj114166_)
            _bytevec114163_
            (begin
              (u8vector-set! _bytevec114163_ _at114164_ _obj114166_)
              (set! _at114164_ (+ _at114164_ '1)))))))
  (define std/srfi/158#string-accumulator
    (lambda ()
      (std/srfi/158#make-accumulator
       cons
       '()
       (lambda (_lst114161_) (list->string (reverse _lst114161_))))))
  (define std/srfi/158#sum-accumulator
    (lambda ()
      (std/srfi/158#make-accumulator + '0 (lambda (_x114158_) _x114158_))))
  (define std/srfi/158#product-accumulator
    (lambda ()
      (std/srfi/158#make-accumulator * '1 (lambda (_x114155_) _x114155_)))))
