(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/160/c128#c128vector-unfold
    (lambda (_f151642_ _len151644_ _seed151646_)
      (declare (not safe))
      (begin
        (if (procedure? _f151642_)
            '#!void
            (error '"Bad argument; expected procedure" _f151642_))
        (let ((_v151650_
               (make-struct-instance
                std/srfi/160/cvector#c128vector::t
                _len151644_)))
          (let _lp151653_ ((_i151656_ '0) (_state151658_ _seed151646_))
            (if (fx< _i151656_ _len151644_)
                (let ((_g299471_ (_f151642_ _i151656_ _state151658_)))
                  (begin
                    (let ((_g299472_
                           (if (##values? _g299471_)
                               (##vector-length _g299471_)
                               1)))
                      (if (not (##fx= _g299472_ 2))
                          (error "Context expects 2 values" _g299472_)))
                    (let ((_x151661_ (##vector-ref _g299471_ 0))
                          (_state151663_ (##vector-ref _g299471_ 1)))
                      (begin
                        (if (std/srfi/160/base#c128? _x151661_)
                            '#!void
                            (error '"Bad generated value" _x151661_))
                        (std/srfi/160/cvector#c128vector-set!
                         _v151650_
                         _i151656_
                         _x151661_)
                        (_lp151653_ (fx+ _i151656_ '1) _state151663_)))))
                _v151650_))))))
  (define std/srfi/160/c128#c128vector-unfold-right
    (lambda (_f151619_ _len151621_ _seed151623_)
      (declare (not safe))
      (begin
        (if (procedure? _f151619_)
            '#!void
            (error '"Bad argument; expected procedure" _f151619_))
        (let ((_v151627_
               (make-struct-instance
                std/srfi/160/cvector#c128vector::t
                _len151621_)))
          (let _lp151630_ ((_i151633_ (fx- _len151621_ '1))
                           (_state151635_ _seed151623_))
            (if (fx>= _i151633_ '0)
                (let ((_g299473_ (_f151619_ _i151633_ _state151635_)))
                  (begin
                    (let ((_g299474_
                           (if (##values? _g299473_)
                               (##vector-length _g299473_)
                               1)))
                      (if (not (##fx= _g299474_ 2))
                          (error "Context expects 2 values" _g299474_)))
                    (let ((_x151638_ (##vector-ref _g299473_ 0))
                          (_state151640_ (##vector-ref _g299473_ 1)))
                      (begin
                        (if (std/srfi/160/base#c128? _x151638_)
                            '#!void
                            (error '"Bad generated value" _x151638_))
                        (std/srfi/160/cvector#c128vector-set!
                         _v151627_
                         _i151633_
                         _x151638_)
                        (_lp151630_ (fx- _i151633_ '1) _state151640_)))))
                _v151627_))))))
  (define std/srfi/160/c128#c128vector-copy__%
    (lambda (_vec151591_ _start151593_ _end151595_)
      (let ((_v151598_
             (make-struct-instance
              std/srfi/160/cvector#c128vector::t
              (fx- _end151595_ _start151593_))))
        (std/srfi/160/c128#c128vector-copy!
         _v151598_
         '0
         _vec151591_
         _start151593_
         _end151595_)
        _v151598_)))
  (define std/srfi/160/c128#c128vector-copy__0
    (lambda (_vec151604_)
      (let* ((_start151606_ '0)
             (_end151608_
              (std/srfi/160/cvector#c128vector-length _vec151604_)))
        (std/srfi/160/c128#c128vector-copy__%
         _vec151604_
         _start151606_
         _end151608_))))
  (define std/srfi/160/c128#c128vector-copy__1
    (lambda (_vec151610_ _start151611_)
      (let ((_end151613_ (std/srfi/160/cvector#c128vector-length _vec151610_)))
        (std/srfi/160/c128#c128vector-copy__%
         _vec151610_
         _start151611_
         _end151613_))))
  (define std/srfi/160/c128#c128vector-copy
    (lambda _g299476_
      (let ((_g299475_ (let () (declare (not safe)) (##length _g299476_))))
        (cond ((let () (declare (not safe)) (##fx= _g299475_ 1))
               (apply std/srfi/160/c128#c128vector-copy__0 _g299476_))
              ((let () (declare (not safe)) (##fx= _g299475_ 2))
               (apply std/srfi/160/c128#c128vector-copy__1 _g299476_))
              ((let () (declare (not safe)) (##fx= _g299475_ 3))
               (apply std/srfi/160/c128#c128vector-copy__% _g299476_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-copy
                _g299476_))))))
  (define std/srfi/160/c128#c128vector-copy!
    (lambda (_to151570_ _at151572_ _from151574_ _start151576_ _end151578_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _to151570_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _to151570_))
        (if (##structure-direct-instance-of?
             _from151574_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _from151574_))
        (if (and (fixnum? _at151572_)
                 (fx<= '0
                       _at151572_
                       (fx- (std/srfi/160/cvector#c128vector-length _at151572_)
                            '1)))
            '#!void
            (error '"Index out of range" _to151570_ _at151572_))
        (if (and (fixnum? _start151576_)
                 (fx<= '0
                       _start151576_
                       (fx- (std/srfi/160/cvector#c128vector-length
                             _from151574_)
                            '1)))
            '#!void
            (error '"Index out of range" _from151574_ _start151576_))
        (if (and (fixnum? _end151578_)
                 (fx<= _start151576_
                       _end151578_
                       (std/srfi/160/cvector#c128vector-length _from151574_)))
            '#!void
            (error '"Index out of range" _from151574_ _end151578_))
        (if (fx<= (fx- _end151578_ _start151576_)
                  (fx- (std/srfi/160/cvector#c128vector-length _to151570_)
                       _at151572_))
            '#!void
            (error '"Destination area too small"
                   _to151570_
                   _at151572_
                   _from151574_
                   _start151576_
                   _end151578_))
        (let _lp151582_ ((_i151585_ _start151576_) (_j151587_ _at151572_))
          (if (fx< _i151585_ _end151578_)
              (begin
                (std/srfi/160/cvector#c128vector-set!
                 _to151570_
                 _j151587_
                 (std/srfi/160/cvector#c128vector-ref _from151574_ _i151585_))
                (_lp151582_ (fx+ _i151585_ '1) (fx+ _j151587_ '1)))
              '#!void)))))
  (define std/srfi/160/c128#c128vector-reverse-copy__%
    (lambda (_vec151542_ _start151544_ _end151546_)
      (let ((_v151549_
             (make-struct-instance
              std/srfi/160/cvector#c128vector::t
              (fx- _end151546_ _start151544_))))
        (std/srfi/160/c128#c128vector-reverse-copy!
         _v151549_
         '0
         _vec151542_
         _start151544_
         _end151546_)
        _v151549_)))
  (define std/srfi/160/c128#c128vector-reverse-copy__0
    (lambda (_vec151555_)
      (let* ((_start151557_ '0)
             (_end151559_
              (std/srfi/160/cvector#c128vector-length _vec151555_)))
        (std/srfi/160/c128#c128vector-reverse-copy__%
         _vec151555_
         _start151557_
         _end151559_))))
  (define std/srfi/160/c128#c128vector-reverse-copy__1
    (lambda (_vec151561_ _start151562_)
      (let ((_end151564_ (std/srfi/160/cvector#c128vector-length _vec151561_)))
        (std/srfi/160/c128#c128vector-reverse-copy__%
         _vec151561_
         _start151562_
         _end151564_))))
  (define std/srfi/160/c128#c128vector-reverse-copy
    (lambda _g299478_
      (let ((_g299477_ (let () (declare (not safe)) (##length _g299478_))))
        (cond ((let () (declare (not safe)) (##fx= _g299477_ 1))
               (apply std/srfi/160/c128#c128vector-reverse-copy__0 _g299478_))
              ((let () (declare (not safe)) (##fx= _g299477_ 2))
               (apply std/srfi/160/c128#c128vector-reverse-copy__1 _g299478_))
              ((let () (declare (not safe)) (##fx= _g299477_ 3))
               (apply std/srfi/160/c128#c128vector-reverse-copy__% _g299478_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-reverse-copy
                _g299478_))))))
  (define std/srfi/160/c128#c128vector-reverse-copy!
    (lambda (_to151521_ _at151523_ _from151525_ _start151527_ _end151529_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _to151521_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _to151521_))
        (if (##structure-direct-instance-of?
             _from151525_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _from151525_))
        (if (and (fixnum? _at151523_)
                 (fx<= '0
                       _at151523_
                       (fx- (std/srfi/160/cvector#c128vector-length _at151523_)
                            '1)))
            '#!void
            (error '"Index out of range" _to151521_ _at151523_))
        (if (and (fixnum? _start151527_)
                 (fx<= '0
                       _start151527_
                       (fx- (std/srfi/160/cvector#c128vector-length
                             _from151525_)
                            '1)))
            '#!void
            (error '"Index out of range" _from151525_ _start151527_))
        (if (and (fixnum? _end151529_)
                 (fx<= _start151527_
                       _end151529_
                       (std/srfi/160/cvector#c128vector-length _from151525_)))
            '#!void
            (error '"Index out of range" _from151525_ _end151529_))
        (if (fx<= (fx- _end151529_ _start151527_)
                  (fx- (std/srfi/160/cvector#c128vector-length _to151521_)
                       _at151523_))
            '#!void
            (error '"Destination area too small"
                   _to151521_
                   _at151523_
                   _from151525_
                   _start151527_
                   _end151529_))
        (let _lp151533_ ((_i151536_ (fx- _end151529_ '1))
                         (_j151538_ _at151523_))
          (if (fx>= _i151536_ _start151527_)
              (begin
                (std/srfi/160/cvector#c128vector-set!
                 _to151521_
                 _j151538_
                 (std/srfi/160/cvector#c128vector-ref _from151525_ _i151536_))
                (_lp151533_ (fx- _i151536_ '1) (fx+ _j151538_ '1)))
              '#!void)))))
  (define std/srfi/160/c128#c128vector-append
    (lambda _args151518_
      (std/srfi/160/c128#c128vector-concatenate _args151518_)))
  (define std/srfi/160/c128#c128vector-concatenate
    (lambda (_lst151458_)
      (let* ((_len151466_
              (foldl1 (lambda (_v151461_ _r151463_)
                        (fx+ (std/srfi/160/cvector#c128vector-length _v151461_)
                             _r151463_))
                      '0
                      _lst151458_))
             (_v151469_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _len151466_)))
        (declare (not safe))
        (let _lp151473_ ((_rest151476_ _lst151458_) (_at151478_ '0))
          (let* ((_rest151480151488_ _rest151476_)
                 (_else151482151496_ (lambda () _v151469_))
                 (_K151484151506_
                  (lambda (_rest151499_ _u151500_)
                    (let ((_ulen151503_
                           (std/srfi/160/cvector#c128vector-length _u151500_)))
                      (std/srfi/160/c128#c128vector-copy!
                       _v151469_
                       _at151478_
                       _u151500_
                       '0
                       _ulen151503_)
                      (_lp151473_
                       _rest151499_
                       (fx+ _at151478_ _ulen151503_))))))
            (if (##pair? _rest151480151488_)
                (let ((_hd151485151509_ (##car _rest151480151488_))
                      (_tl151486151511_ (##cdr _rest151480151488_)))
                  (let* ((_u151514_ _hd151485151509_)
                         (_rest151516_ _tl151486151511_))
                    (_K151484151506_ _rest151516_ _u151514_)))
                (_else151482151496_)))))))
  (define std/srfi/160/c128#c128vector-append-subvectors
    (lambda _args151330_
      (let* ((_len151391_
              (let _lp151333_ ((_rest151336_ _args151330_) (_r151338_ '0))
                (let* ((_rest151340151352_ _rest151336_)
                       (_else151342151360_ (lambda () _r151338_))
                       (_K151344151369_
                        (lambda (_rest151363_ _end151364_ _start151366_)
                          (_lp151333_
                           _rest151363_
                           (fx+ _r151338_ (fx- _end151364_ _start151366_))))))
                  (if (let ()
                        (declare (not safe))
                        (##pair? _rest151340151352_))
                      (let ((_tl151346151372_
                             (let ()
                               (declare (not safe))
                               (##cdr _rest151340151352_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl151346151372_))
                            (let ((_hd151347151375_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl151346151372_)))
                                  (_tl151348151377_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl151346151372_))))
                              (let ((_start151380_ _hd151347151375_))
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl151348151377_))
                                    (let ((_hd151349151382_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl151348151377_)))
                                          (_tl151350151384_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl151348151377_))))
                                      (let* ((_end151387_ _hd151349151382_)
                                             (_rest151389_ _tl151350151384_))
                                        (_K151344151369_
                                         _rest151389_
                                         _end151387_
                                         _start151380_)))
                                    (_else151342151360_))))
                            (_else151342151360_)))
                      (_else151342151360_)))))
             (_v151394_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _len151391_)))
        (let _lp151398_ ((_rest151400_ _args151330_) (_at151401_ '0))
          (let* ((_rest151403151415_ _rest151400_)
                 (_else151405151423_ (lambda () _v151394_))
                 (_K151407151432_
                  (lambda (_rest151426_ _end151427_ _start151428_ _u151429_)
                    (std/srfi/160/c128#c128vector-copy!
                     _v151394_
                     _at151401_
                     _u151429_
                     _start151428_
                     _end151427_)
                    (_lp151398_
                     _rest151426_
                     (fx+ _at151401_ (fx- _end151427_ _start151428_))))))
            (if (let () (declare (not safe)) (##pair? _rest151403151415_))
                (let ((_hd151408151435_
                       (let ()
                         (declare (not safe))
                         (##car _rest151403151415_)))
                      (_tl151409151437_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest151403151415_))))
                  (let ((_u151440_ _hd151408151435_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl151409151437_))
                        (let ((_hd151410151442_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl151409151437_)))
                              (_tl151411151444_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl151409151437_))))
                          (let ((_start151447_ _hd151410151442_))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl151411151444_))
                                (let ((_hd151412151449_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl151411151444_)))
                                      (_tl151413151451_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _tl151411151444_))))
                                  (let* ((_end151454_ _hd151412151449_)
                                         (_rest151456_ _tl151413151451_))
                                    (_K151407151432_
                                     _rest151456_
                                     _end151454_
                                     _start151447_
                                     _u151440_)))
                                (_else151405151423_))))
                        (_else151405151423_))))
                (_else151405151423_)))))))
  (define std/srfi/160/c128#c128vector-empty?
    (lambda (_v151327_)
      (fxzero? (std/srfi/160/cvector#c128vector-length _v151327_))))
  (define std/srfi/160/c128#c128vector=
    (lambda (_v151269_ . _args151271_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v151269_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _v151269_))
        (let ((_vlen151275_
               (std/srfi/160/cvector#c128vector-length _v151269_)))
          (let _lp151278_ ((_rest151281_ _args151271_))
            (let* ((_rest151283151291_ _rest151281_)
                   (_else151285151299_ (lambda () '#t))
                   (_K151287151315_
                    (lambda (_rest151302_ _u151303_)
                      (if (##structure-direct-instance-of?
                           _u151303_
                           'std/srfi/160/cvector#c128vector::t)
                          '#!void
                          (error '"Bad argument" _u151303_))
                      (let ((_ulen151306_
                             (std/srfi/160/cvector#c128vector-length
                              _u151303_)))
                        (if (fx= _vlen151275_ _ulen151306_)
                            (let _cmp151309_ ((_i151312_ '0))
                              (if (fx< _i151312_ _vlen151275_)
                                  (if (= (std/srfi/160/cvector#c128vector-ref
                                          _v151269_
                                          _i151312_)
                                         (std/srfi/160/cvector#c128vector-ref
                                          _u151303_
                                          _i151312_))
                                      (_cmp151309_ (fx+ _i151312_ '1))
                                      '#f)
                                  (_lp151278_ _rest151302_)))
                            '#f)))))
              (if (##pair? _rest151283151291_)
                  (let ((_hd151288151318_ (##car _rest151283151291_))
                        (_tl151289151320_ (##cdr _rest151283151291_)))
                    (let* ((_u151323_ _hd151288151318_)
                           (_rest151325_ _tl151289151320_))
                      (_K151287151315_ _rest151325_ _u151323_)))
                  (_else151285151299_))))))))
  (define std/srfi/160/c128#c128vector-take
    (lambda (_v151261_ _n151263_)
      (let ((_u151266_
             (make-struct-instance
              std/srfi/160/cvector#c128vector::t
              _n151263_)))
        (std/srfi/160/c128#c128vector-copy!
         _u151266_
         '0
         _v151261_
         '0
         _n151263_)
        _u151266_)))
  (define std/srfi/160/c128#c128vector-take-right
    (lambda (_v151246_ _n151248_)
      (let* ((_vlen151251_ (std/srfi/160/cvector#c128vector-length _v151246_))
             (_ulen151254_ (fx- _vlen151251_ _n151248_))
             (_u151257_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _ulen151254_)))
        (std/srfi/160/c128#c128vector-copy!
         _u151257_
         '0
         _v151246_
         _n151248_
         _vlen151251_)
        _u151257_)))
  (define std/srfi/160/c128#c128vector-drop
    (lambda (_v151231_ _n151233_)
      (let* ((_vlen151236_ (std/srfi/160/cvector#c128vector-length _v151231_))
             (_ulen151239_ (fx- _vlen151236_ _n151233_))
             (_u151242_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _ulen151239_)))
        (std/srfi/160/c128#c128vector-copy!
         _u151242_
         '0
         _v151231_
         _n151233_
         _vlen151236_)
        _u151242_)))
  (define std/srfi/160/c128#c128vector-drop-right
    (lambda (_v151216_ _n151218_)
      (let* ((_vlen151221_ (std/srfi/160/cvector#c128vector-length _v151216_))
             (_ulen151224_ (fx- _vlen151221_ _n151218_))
             (_u151227_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _ulen151224_)))
        (std/srfi/160/c128#c128vector-copy!
         _u151227_
         '0
         _v151216_
         '0
         _ulen151224_)
        _u151227_)))
  (define std/srfi/160/c128#c128vector-segment
    (lambda (_v151198_ _n151200_)
      (let _lp151203_ ((_i151206_ '0)
                       (_rest151208_
                        (std/srfi/160/cvector#c128vector-length _v151198_))
                       (_r151210_ '()))
        (if (fx> _r151210_ '0)
            (let ((_size151213_ (fxmin _n151200_ _rest151208_)))
              (_lp151203_
               (fx+ _i151206_ _size151213_)
               (fx- _rest151208_ _size151213_)
               (cons (std/srfi/160/c128#c128vector-copy__%
                      _v151198_
                      _i151206_
                      (fx+ _i151206_ _size151213_))
                     _r151210_)))
            (reverse _r151210_)))))
  (define std/srfi/160/c128#c128vector-fold__0
    (lambda (_kons151158_ _knil151160_ _v151162_)
      (if (procedure? _kons151158_)
          '#!void
          (error '"Bad argument; expected procedure" _kons151158_))
      (let ((_end151165_ (std/srfi/160/cvector#c128vector-length _v151162_)))
        (declare (not safe))
        (let _lp151169_ ((_i151172_ '0) (_r151174_ _knil151160_))
          (if (fx< _i151172_ _end151165_)
              (_lp151169_
               (fx+ _i151172_ '1)
               (_kons151158_
                _r151174_
                (std/srfi/160/cvector#c128vector-ref _v151162_ _i151172_)))
              _r151174_)))))
  (define std/srfi/160/c128#c128vector-fold__1
    (lambda (_kons151177_ _knil151178_ _v151179_ . _vs151180_)
      (if (procedure? _kons151177_)
          '#!void
          (error '"Bad argument; expected procedure" _kons151177_))
      (let* ((_vs151183_ (cons _v151179_ _vs151180_))
             (_end151185_
              (apply fxmin
                     (map std/srfi/160/cvector#c128vector-length _vs151183_))))
        (declare (not safe))
        (let _lp151189_ ((_i151191_ '0) (_r151192_ _knil151178_))
          (if (fx< _i151191_ _end151185_)
              (_lp151189_
               (fx+ _i151191_ '1)
               (apply _kons151177_
                      _r151192_
                      (map (lambda (_g151193151195_)
                             (std/srfi/160/cvector#c128vector-ref
                              _g151193151195_
                              _i151191_))
                           _vs151183_)))
              _r151192_)))))
  (define std/srfi/160/c128#c128vector-fold
    (lambda _g299480_
      (let ((_g299479_ (let () (declare (not safe)) (##length _g299480_))))
        (cond ((let () (declare (not safe)) (##fx= _g299479_ 3))
               (apply std/srfi/160/c128#c128vector-fold__0 _g299480_))
              ((let () (declare (not safe)) (##fx>= _g299479_ 3))
               (apply std/srfi/160/c128#c128vector-fold__1 _g299480_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-fold
                _g299480_))))))
  (define std/srfi/160/c128#c128vector-fold-right__0
    (lambda (_kons151118_ _knil151120_ _v151122_)
      (if (procedure? _kons151118_)
          '#!void
          (error '"Bad argument; expected procedure" _kons151118_))
      (let ((_last151125_
             (fx- (std/srfi/160/cvector#c128vector-length _v151122_) '1)))
        (declare (not safe))
        (let _lp151129_ ((_i151132_ _last151125_) (_r151134_ _knil151120_))
          (if (fx>= _i151132_ '0)
              (_lp151129_
               (fx- _i151132_ '1)
               (_kons151118_
                _r151134_
                (std/srfi/160/cvector#c128vector-ref _v151122_ _i151132_)))
              _r151134_)))))
  (define std/srfi/160/c128#c128vector-fold-right__1
    (lambda (_kons151137_ _knil151138_ _v151139_ . _vs151140_)
      (if (procedure? _kons151137_)
          '#!void
          (error '"Bad argument; expected procedure" _kons151137_))
      (let* ((_vs151143_ (cons _v151139_ _vs151140_))
             (_last151145_
              (fx- (apply min
                          (map std/srfi/160/cvector#c128vector-length
                               _vs151143_))
                   '1)))
        (declare (not safe))
        (let _lp151149_ ((_i151151_ _last151145_) (_r151152_ _knil151138_))
          (if (fx>= _i151151_ '0)
              (_lp151149_
               (fx- _i151151_ '1)
               (apply _kons151137_
                      _r151152_
                      (map (lambda (_g151153151155_)
                             (std/srfi/160/cvector#c128vector-ref
                              _g151153151155_
                              _i151151_))
                           _vs151143_)))
              _r151152_)))))
  (define std/srfi/160/c128#c128vector-fold-right
    (lambda _g299482_
      (let ((_g299481_ (let () (declare (not safe)) (##length _g299482_))))
        (cond ((let () (declare (not safe)) (##fx= _g299481_ 3))
               (apply std/srfi/160/c128#c128vector-fold-right__0 _g299482_))
              ((let () (declare (not safe)) (##fx>= _g299481_ 3))
               (apply std/srfi/160/c128#c128vector-fold-right__1 _g299482_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-fold-right
                _g299482_))))))
  (define std/srfi/160/c128#c128vector-map__0
    (lambda (_f151078_ _v151080_)
      (if (procedure? _f151078_)
          '#!void
          (error '"Bad argument; expected procedure" _f151078_))
      (let* ((_len151083_ (std/srfi/160/cvector#c128vector-length _v151080_))
             (_u151086_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _len151083_)))
        (declare (not safe))
        (let _lp151091_ ((_i151094_ '0))
          (if (fx< _i151094_ _len151083_)
              (begin
                (std/srfi/160/cvector#c128vector-set!
                 _u151086_
                 _i151094_
                 (std/srfi/160/cvector#c128vector-ref _v151080_ _i151094_))
                (_lp151091_ (fx+ _i151094_ '1)))
              _u151086_)))))
  (define std/srfi/160/c128#c128vector-map__1
    (lambda (_f151097_ _v151098_ . _vs151099_)
      (if (procedure? _f151097_)
          '#!void
          (error '"Bad argument; expected procedure" _f151097_))
      (let* ((_vs151102_ (cons _v151098_ _vs151099_))
             (_len151104_
              (apply fxmin
                     (map std/srfi/160/cvector#c128vector-length _vs151102_)))
             (_u151106_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _len151104_)))
        (declare (not safe))
        (let _lp151110_ ((_i151112_ '0))
          (if (fx< _i151112_ _len151104_)
              (begin
                (std/srfi/160/cvector#c128vector-set!
                 _u151106_
                 _i151112_
                 (apply _f151097_
                        (map (lambda (_g151113151115_)
                               (std/srfi/160/cvector#c128vector-ref
                                _g151113151115_
                                _i151112_))
                             _vs151102_)))
                (_lp151110_ (fx+ _i151112_ '1)))
              _u151106_)))))
  (define std/srfi/160/c128#c128vector-map
    (lambda _g299484_
      (let ((_g299483_ (let () (declare (not safe)) (##length _g299484_))))
        (cond ((let () (declare (not safe)) (##fx= _g299483_ 2))
               (apply std/srfi/160/c128#c128vector-map__0 _g299484_))
              ((let () (declare (not safe)) (##fx>= _g299483_ 2))
               (apply std/srfi/160/c128#c128vector-map__1 _g299484_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-map
                _g299484_))))))
  (define std/srfi/160/c128#c128vector-map!__0
    (lambda (_f151044_ _v151046_)
      (if (procedure? _f151044_)
          '#!void
          (error '"Bad argument; expected procedure" _f151044_))
      (let ((_len151049_ (std/srfi/160/cvector#c128vector-length _v151046_)))
        (declare (not safe))
        (let _lp151053_ ((_i151056_ '0))
          (if (fx< _i151056_ _len151049_)
              (begin
                (std/srfi/160/cvector#c128vector-set!
                 _v151046_
                 _i151056_
                 (_f151044_
                  (std/srfi/160/cvector#c128vector-ref _v151046_ _i151056_)))
                (_lp151053_ (fx+ _i151056_ '1)))
              _v151046_)))))
  (define std/srfi/160/c128#c128vector-map!__1
    (lambda (_f151059_ _v151060_ . _vs151061_)
      (if (procedure? _f151059_)
          '#!void
          (error '"Bad argument; expected procedure" _f151059_))
      (let* ((_vs151064_ (cons _v151060_ _vs151061_))
             (_len151066_
              (apply fxmin
                     (map std/srfi/160/cvector#c128vector-length _vs151064_))))
        (declare (not safe))
        (let _lp151070_ ((_i151072_ '0))
          (if (fx< _i151072_ _len151066_)
              (begin
                (std/srfi/160/cvector#c128vector-set!
                 _v151060_
                 _i151072_
                 (apply _f151059_
                        (map (lambda (_g151073151075_)
                               (std/srfi/160/cvector#c128vector-ref
                                _g151073151075_
                                _i151072_))
                             _vs151064_)))
                (_lp151070_ (fx+ _i151072_ '1)))
              _v151060_)))))
  (define std/srfi/160/c128#c128vector-map!
    (lambda _g299486_
      (let ((_g299485_ (let () (declare (not safe)) (##length _g299486_))))
        (cond ((let () (declare (not safe)) (##fx= _g299485_ 2))
               (apply std/srfi/160/c128#c128vector-map!__0 _g299486_))
              ((let () (declare (not safe)) (##fx>= _g299485_ 2))
               (apply std/srfi/160/c128#c128vector-map!__1 _g299486_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-map!
                _g299486_))))))
  (define std/srfi/160/c128#c128vector-for-each__0
    (lambda (_f151010_ _v151012_)
      (if (procedure? _f151010_)
          '#!void
          (error '"Bad argument; expected procedure" _f151010_))
      (let ((_len151015_ (std/srfi/160/cvector#c128vector-length _v151012_)))
        (declare (not safe))
        (let _lp151019_ ((_i151022_ '0))
          (if (fx< _i151022_ _len151015_)
              (begin
                (_f151010_
                 (std/srfi/160/cvector#c128vector-ref _v151012_ _i151022_))
                (_lp151019_ (fx+ _i151022_ '1)))
              '#!void)))))
  (define std/srfi/160/c128#c128vector-for-each__1
    (lambda (_f151025_ _v151026_ . _vs151027_)
      (let* ((_vs151030_ (cons _v151026_ _vs151027_))
             (_len151032_
              (apply fxmin
                     (map std/srfi/160/cvector#c128vector-length _vs151030_))))
        (declare (not safe))
        (let _lp151036_ ((_i151038_ '0))
          (if (fx< _i151038_ _len151032_)
              (begin
                (apply _f151025_
                       (map (lambda (_g151039151041_)
                              (std/srfi/160/cvector#c128vector-ref
                               _g151039151041_
                               _i151038_))
                            _vs151030_))
                (_lp151036_ (fx+ _i151038_ '1)))
              '#!void)))))
  (define std/srfi/160/c128#c128vector-for-each
    (lambda _g299488_
      (let ((_g299487_ (let () (declare (not safe)) (##length _g299488_))))
        (cond ((let () (declare (not safe)) (##fx= _g299487_ 2))
               (apply std/srfi/160/c128#c128vector-for-each__0 _g299488_))
              ((let () (declare (not safe)) (##fx>= _g299487_ 2))
               (apply std/srfi/160/c128#c128vector-for-each__1 _g299488_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-for-each
                _g299488_))))))
  (define std/srfi/160/c128#c128vector-count__0
    (lambda (_pred150973_ _v150975_)
      (if (procedure? _pred150973_)
          '#!void
          (error '"Bad argument; expected procedure" _pred150973_))
      (let ((_end150978_ (std/srfi/160/cvector#c128vector-length _v150975_)))
        (declare (not safe))
        (let _lp150982_ ((_i150985_ '0) (_r150987_ '0))
          (if (fx< _i150985_ _end150978_)
              (if (_pred150973_
                   (std/srfi/160/cvector#c128vector-ref _v150975_ _i150985_))
                  (_lp150982_ (fx+ _i150985_ '1) (fx+ _r150987_ '1))
                  (_lp150982_ (fx+ _i150985_ '1) _r150987_))
              _r150987_)))))
  (define std/srfi/160/c128#c128vector-count__1
    (lambda (_pred150990_ _v150991_ . _vs150992_)
      (if (procedure? _pred150990_)
          '#!void
          (error '"Bad argument; expected procedure" _pred150990_))
      (let* ((_vs150995_ (cons _v150991_ _vs150992_))
             (_end150997_
              (apply fxmin
                     (map std/srfi/160/cvector#c128vector-length _vs150995_))))
        (declare (not safe))
        (let _lp151001_ ((_i151003_ '0) (_r151004_ '0))
          (if (fx< _i151003_ _end150997_)
              (if (apply _pred150990_
                         (map (lambda (_g151005151007_)
                                (std/srfi/160/cvector#c128vector-ref
                                 _g151005151007_
                                 _i151003_))
                              _vs150995_))
                  (_lp151001_ (fx+ _i151003_ '1) (fx+ _r151004_ '1))
                  (_lp151001_ (fx+ _i151003_ '1) _r151004_))
              _r151004_)))))
  (define std/srfi/160/c128#c128vector-count
    (lambda _g299490_
      (let ((_g299489_ (let () (declare (not safe)) (##length _g299490_))))
        (cond ((let () (declare (not safe)) (##fx= _g299489_ 2))
               (apply std/srfi/160/c128#c128vector-count__0 _g299490_))
              ((let () (declare (not safe)) (##fx>= _g299489_ 2))
               (apply std/srfi/160/c128#c128vector-count__1 _g299490_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-count
                _g299490_))))))
  (define std/srfi/160/c128#c128vector-cumulate
    (lambda (_f150948_ _knil150950_ _v150952_)
      (if (procedure? _f150948_)
          '#!void
          (error '"Bad argument; expected procedure" _f150948_))
      (let* ((_len150955_ (std/srfi/160/cvector#c128vector-length _v150952_))
             (_r150958_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _len150955_)))
        (declare (not safe))
        (let _lp150963_ ((_i150966_ '0) (_r150968_ _knil150950_))
          (if (fx< _i150966_ _len150955_)
              (let ((_next150970_
                     (_f150948_
                      _r150968_
                      (std/srfi/160/cvector#c128vector-ref
                       _v150952_
                       _i150966_))))
                (std/srfi/160/cvector#c128vector-set!
                 _v150952_
                 _i150966_
                 _next150970_)
                (_lp150963_ (fx+ _i150966_ '1) _next150970_))
              _v150952_)))))
  (define std/srfi/160/c128#c128vector-take-while
    (lambda (_pred150931_ _v150933_)
      (let* ((_len150936_ (std/srfi/160/cvector#c128vector-length _v150933_))
             (_idx150939_
              (std/srfi/160/c128#c128vector-skip__0 _pred150931_ _v150933_))
             (_idx150945_
              (let ((_$e150942_ _idx150939_))
                (if _$e150942_ _$e150942_ _len150936_))))
        (std/srfi/160/c128#c128vector-copy__% _v150933_ '0 _idx150945_))))
  (define std/srfi/160/c128#c128vector-take-while-right
    (lambda (_pred150917_ _v150919_)
      (let* ((_len150922_ (std/srfi/160/cvector#c128vector-length _v150919_))
             (_idx150925_
              (std/srfi/160/c128#c128vector-skip-right__0
               _pred150917_
               _v150919_))
             (_idx150928_ (if _idx150925_ (fx+ _idx150925_ '1) '0)))
        (std/srfi/160/c128#c128vector-copy__%
         _v150919_
         _idx150928_
         _len150922_))))
  (define std/srfi/160/c128#c128vector-drop-while
    (lambda (_pred150900_ _v150902_)
      (let* ((_len150905_ (std/srfi/160/cvector#c128vector-length _v150902_))
             (_idx150908_
              (std/srfi/160/c128#c128vector-skip__0 _pred150900_ _v150902_))
             (_idx150914_
              (let ((_$e150911_ _idx150908_))
                (if _$e150911_ _$e150911_ _len150905_))))
        (std/srfi/160/c128#c128vector-copy__%
         _v150902_
         _idx150914_
         _len150905_))))
  (define std/srfi/160/c128#c128vector-drop-while-right
    (lambda (_pred150886_ _v150888_)
      (let* ((_len150891_ (std/srfi/160/cvector#c128vector-length _v150888_))
             (_idx150894_
              (std/srfi/160/c128#c128vector-skip-right__0
               _pred150886_
               _v150888_))
             (_idx150897_ (if _idx150894_ (fx+ _idx150894_ '1) '0)))
        (std/srfi/160/c128#c128vector-copy__% _v150888_ '0 _idx150897_))))
  (define std/srfi/160/c128#c128vector-index__0
    (lambda (_pred150852_ _v150854_)
      (if (procedure? _pred150852_)
          '#!void
          (error '"Bad argument; expected procedure" _pred150852_))
      (let ((_end150857_ (std/srfi/160/cvector#c128vector-length _v150854_)))
        (declare (not safe))
        (let _lp150861_ ((_i150864_ '0))
          (if (fx< _i150864_ _end150857_)
              (if (_pred150852_
                   (std/srfi/160/cvector#c128vector-ref _v150854_ _i150864_))
                  _i150864_
                  (_lp150861_ (fx+ _i150864_ '1)))
              '#f)))))
  (define std/srfi/160/c128#c128vector-index__1
    (lambda (_pred150867_ _v150868_ . _vs150869_)
      (if (procedure? _pred150867_)
          '#!void
          (error '"Bad argument; expected procedure" _pred150867_))
      (let* ((_vs150872_ (cons _v150868_ _vs150869_))
             (_end150874_
              (apply fxmin
                     (map std/srfi/160/cvector#c128vector-length _vs150872_))))
        (declare (not safe))
        (let _lp150878_ ((_i150880_ '0))
          (if (fx< _i150880_ _end150874_)
              (if (apply _pred150867_
                         (map (lambda (_g150881150883_)
                                (std/srfi/160/cvector#c128vector-ref
                                 _g150881150883_
                                 _i150880_))
                              _vs150872_))
                  _i150880_
                  (_lp150878_ (fx+ _i150880_ '1)))
              '#f)))))
  (define std/srfi/160/c128#c128vector-index
    (lambda _g299492_
      (let ((_g299491_ (let () (declare (not safe)) (##length _g299492_))))
        (cond ((let () (declare (not safe)) (##fx= _g299491_ 2))
               (apply std/srfi/160/c128#c128vector-index__0 _g299492_))
              ((let () (declare (not safe)) (##fx>= _g299491_ 2))
               (apply std/srfi/160/c128#c128vector-index__1 _g299492_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-index
                _g299492_))))))
  (define std/srfi/160/c128#c128vector-index-right__0
    (lambda (_pred150818_ _v150820_)
      (if (procedure? _pred150818_)
          '#!void
          (error '"Bad argument; expected procedure" _pred150818_))
      (let ((_start150823_
             (fx- (std/srfi/160/cvector#c128vector-length _v150820_) '1)))
        (declare (not safe))
        (let _lp150827_ ((_i150830_ _start150823_))
          (if (fx>= _i150830_ '0)
              (if (_pred150818_
                   (std/srfi/160/cvector#c128vector-ref _v150820_ _i150830_))
                  _i150830_
                  (_lp150827_ (fx- _i150830_ '1)))
              '#f)))))
  (define std/srfi/160/c128#c128vector-index-right__1
    (lambda (_pred150833_ _v150834_ . _vs150835_)
      (if (procedure? _pred150833_)
          '#!void
          (error '"Bad argument; expected procedure" _pred150833_))
      (let* ((_vs150838_ (cons _v150834_ _vs150835_))
             (_start150840_
              (fx- (apply fxmin
                          (map std/srfi/160/cvector#c128vector-length
                               _vs150838_))
                   '1)))
        (declare (not safe))
        (let _lp150844_ ((_i150846_ _start150840_))
          (if (fx>= _i150846_ '0)
              (if (apply _pred150833_
                         (map (lambda (_g150847150849_)
                                (std/srfi/160/cvector#c128vector-ref
                                 _g150847150849_
                                 _i150846_))
                              _vs150838_))
                  _i150846_
                  (_lp150844_ (fx- _i150846_ '1)))
              '#f)))))
  (define std/srfi/160/c128#c128vector-index-right
    (lambda _g299494_
      (let ((_g299493_ (let () (declare (not safe)) (##length _g299494_))))
        (cond ((let () (declare (not safe)) (##fx= _g299493_ 2))
               (apply std/srfi/160/c128#c128vector-index-right__0 _g299494_))
              ((let () (declare (not safe)) (##fx>= _g299493_ 2))
               (apply std/srfi/160/c128#c128vector-index-right__1 _g299494_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-index-right
                _g299494_))))))
  (define std/srfi/160/c128#c128vector-skip__0
    (lambda (_pred150802_ _v150804_)
      (std/srfi/160/c128#c128vector-index__0
       (lambda (_$obj150807_) (not (_pred150802_ _$obj150807_)))
       _v150804_)))
  (define std/srfi/160/c128#c128vector-skip__1
    (lambda (_pred150810_ _v150811_ . _vs150812_)
      (apply std/srfi/160/c128#c128vector-index
             (lambda (_$obj150815_) (not (_pred150810_ _$obj150815_)))
             _v150811_
             _vs150812_)))
  (define std/srfi/160/c128#c128vector-skip
    (lambda _g299496_
      (let ((_g299495_ (let () (declare (not safe)) (##length _g299496_))))
        (cond ((let () (declare (not safe)) (##fx= _g299495_ 2))
               (apply std/srfi/160/c128#c128vector-skip__0 _g299496_))
              ((let () (declare (not safe)) (##fx>= _g299495_ 2))
               (apply std/srfi/160/c128#c128vector-skip__1 _g299496_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-skip
                _g299496_))))))
  (define std/srfi/160/c128#c128vector-skip-right__0
    (lambda (_pred150786_ _v150788_)
      (std/srfi/160/c128#c128vector-index-right__0
       (lambda (_$obj150791_) (not (_pred150786_ _$obj150791_)))
       _v150788_)))
  (define std/srfi/160/c128#c128vector-skip-right__1
    (lambda (_pred150794_ _v150795_ . _vs150796_)
      (apply std/srfi/160/c128#c128vector-index-right
             (lambda (_$obj150799_) (not (_pred150794_ _$obj150799_)))
             _v150795_
             _vs150796_)))
  (define std/srfi/160/c128#c128vector-skip-right
    (lambda _g299498_
      (let ((_g299497_ (let () (declare (not safe)) (##length _g299498_))))
        (cond ((let () (declare (not safe)) (##fx= _g299497_ 2))
               (apply std/srfi/160/c128#c128vector-skip-right__0 _g299498_))
              ((let () (declare (not safe)) (##fx>= _g299497_ 2))
               (apply std/srfi/160/c128#c128vector-skip-right__1 _g299498_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-skip-right
                _g299498_))))))
  (define std/srfi/160/c128#c128vector-any__0
    (lambda (_pred150746_ _v150748_)
      (if (procedure? _pred150746_)
          '#!void
          (error '"Bad argument; expected procedure" _pred150746_))
      (let ((_end150751_ (std/srfi/160/cvector#c128vector-length _v150748_)))
        (declare (not safe))
        (let _lp150755_ ((_i150758_ '0))
          (if (fx< _i150758_ _end150751_)
              (let ((_$e150761_
                     (_pred150746_
                      (std/srfi/160/cvector#c128vector-ref
                       _v150748_
                       _i150758_))))
                (if _$e150761_
                    (values _$e150761_)
                    (_lp150755_ (fx+ _i150758_ '1))))
              '#f)))))
  (define std/srfi/160/c128#c128vector-any__1
    (lambda (_pred150764_ _v150765_ . _vs150766_)
      (if (procedure? _pred150764_)
          '#!void
          (error '"Bad argument; expected procedure" _pred150764_))
      (let* ((_v150769_ (cons _v150765_ _vs150766_))
             (_end150771_
              (apply fxmin
                     (map std/srfi/160/cvector#c128vector-length _vs150766_))))
        (declare (not safe))
        (let _lp150775_ ((_i150777_ '0))
          (if (fx< _i150777_ _end150771_)
              (let ((_$e150783_
                     (apply _pred150764_
                            (map (lambda (_g150778150780_)
                                   (std/srfi/160/cvector#c128vector-ref
                                    _g150778150780_
                                    _i150777_))
                                 _vs150766_))))
                (if _$e150783_
                    (values _$e150783_)
                    (_lp150775_ (fx+ _i150777_ '1))))
              '#f)))))
  (define std/srfi/160/c128#c128vector-any
    (lambda _g299500_
      (let ((_g299499_ (let () (declare (not safe)) (##length _g299500_))))
        (cond ((let () (declare (not safe)) (##fx= _g299499_ 2))
               (apply std/srfi/160/c128#c128vector-any__0 _g299500_))
              ((let () (declare (not safe)) (##fx>= _g299499_ 2))
               (apply std/srfi/160/c128#c128vector-any__1 _g299500_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-any
                _g299500_))))))
  (define std/srfi/160/c128#c128vector-every__0
    (lambda (_pred150695_ _v150697_)
      (if (procedure? _pred150695_)
          '#!void
          (error '"Bad argument; expected procedure" _pred150695_))
      (let ((_end150700_ (std/srfi/160/cvector#c128vector-length _v150697_)))
        (declare (not safe))
        (let _lp150704_ ((_i150707_ '0) (_r150709_ '#t))
          (if (fx< _i150707_ _end150700_)
              (let ((_$e150712_
                     (_pred150695_
                      (std/srfi/160/cvector#c128vector-ref
                       _v150697_
                       _i150707_))))
                (if _$e150712_
                    ((lambda (_g150714150716_)
                       (_lp150704_ (fx+ _i150707_ '1) _g150714150716_))
                     _$e150712_)
                    '#f))
              _r150709_)))))
  (define std/srfi/160/c128#c128vector-every__1
    (lambda (_pred150719_ _v150720_ . _vs150721_)
      (if (procedure? _pred150719_)
          '#!void
          (error '"Bad argument; expected procedure" _pred150719_))
      (let* ((_v150724_ (cons _v150720_ _vs150721_))
             (_end150726_
              (apply fxmin
                     (map std/srfi/160/cvector#c128vector-length _vs150721_))))
        (declare (not safe))
        (let _lp150730_ ((_i150732_ '0) (_r150733_ '#t))
          (if (fx< _i150732_ _end150726_)
              (let ((_$e150739_
                     (apply _pred150719_
                            (map (lambda (_g150734150736_)
                                   (std/srfi/160/cvector#c128vector-ref
                                    _g150734150736_
                                    _i150732_))
                                 _vs150721_))))
                (if _$e150739_
                    ((lambda (_g150741150743_)
                       (_lp150730_ (fx+ _i150732_ '1) _g150741150743_))
                     _$e150739_)
                    '#f))
              _r150733_)))))
  (define std/srfi/160/c128#c128vector-every
    (lambda _g299502_
      (let ((_g299501_ (let () (declare (not safe)) (##length _g299502_))))
        (cond ((let () (declare (not safe)) (##fx= _g299501_ 2))
               (apply std/srfi/160/c128#c128vector-every__0 _g299502_))
              ((let () (declare (not safe)) (##fx>= _g299501_ 2))
               (apply std/srfi/160/c128#c128vector-every__1 _g299502_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-every
                _g299502_))))))
  (define std/srfi/160/c128#c128vector-partition
    (lambda (_pred150666_ _v150668_)
      (let* ((_count150671_
              (std/srfi/160/c128#c128vector-count__0 _pred150666_ _v150668_))
             (_len150674_ (std/srfi/160/cvector#c128vector-length _v150668_))
             (_u150677_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _len150674_)))
        (declare (not safe))
        (let _lp150682_ ((_i150685_ '0)
                         (_left150687_ '0)
                         (_right150689_ _count150671_))
          (if (fx< _i150685_ _len150674_)
              (let ((_x150692_
                     (std/srfi/160/cvector#c128vector-ref
                      _v150668_
                      _i150685_)))
                (if (_pred150666_ _x150692_)
                    (begin
                      (std/srfi/160/cvector#c128vector-set!
                       _u150677_
                       _left150687_
                       _x150692_)
                      (_lp150682_
                       (fx+ _i150685_ '1)
                       (fx+ _left150687_ '1)
                       _right150689_))
                    (begin
                      (std/srfi/160/cvector#c128vector-set!
                       _u150677_
                       _right150689_
                       _x150692_)
                      (_lp150682_
                       (fx+ _i150685_ '1)
                       _left150687_
                       (fx+ _right150689_ '1)))))
              _u150677_)))))
  (define std/srfi/160/c128#c128vector-filter
    (lambda (_pred150639_ _v150641_)
      (let* ((_count150644_
              (std/srfi/160/c128#c128vector-count__0 _pred150639_ _v150641_))
             (_u150647_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _count150644_))
             (_end150650_ (std/srfi/160/cvector#c128vector-length _v150641_)))
        (declare (not safe))
        (let _lp150655_ ((_i150658_ '0) (_j150660_ '0))
          (if (fx< _i150658_ _end150650_)
              (let ((_x150663_
                     (std/srfi/160/cvector#c128vector-ref
                      _v150641_
                      _i150658_)))
                (if (_pred150639_ _x150663_)
                    (begin
                      (std/srfi/160/cvector#c128vector-set!
                       _u150647_
                       _j150660_
                       _x150663_)
                      (_lp150655_ (fx+ _i150658_ '1) (fx+ _j150660_ '1)))
                    (_lp150655_ (fx+ _i150658_ '1) _j150660_)))
              _u150647_)))))
  (define std/srfi/160/c128#c128vector-remove
    (lambda (_pred150631_ _v150633_)
      (std/srfi/160/c128#c128vector-filter
       (lambda (_$obj150636_) (not (_pred150631_ _$obj150636_)))
       _v150633_)))
  (define std/srfi/160/c128#c128vector-swap
    (lambda (_v150618_ _i150620_ _j150622_)
      (let ((_iv150625_
             (std/srfi/160/cvector#c128vector-ref _v150618_ _i150620_))
            (_jv150627_
             (std/srfi/160/cvector#c128vector-ref _v150618_ _j150622_)))
        (declare (not safe))
        (begin
          (std/srfi/160/cvector#c128vector-set! _v150618_ _i150620_ _jv150627_)
          (std/srfi/160/cvector#c128vector-set!
           _v150618_
           _j150622_
           _iv150625_)))))
  (define std/srfi/160/c128#c128vector-fill!__%
    (lambda (_v150581_ _fill150583_ _start150585_ _end150587_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v150581_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _v150581_))
        (if (std/srfi/160/base#c128? _fill150583_)
            '#!void
            (error '"Bad argument" _fill150583_))
        (if (and (fixnum? _start150585_)
                 (fx<= '0
                       _start150585_
                       (fx- (std/srfi/160/cvector#c128vector-length _v150581_)
                            '1)))
            '#!void
            (error '"Index out of range" _start150585_))
        (if (and (fixnum? _end150587_)
                 (fx<= _start150585_
                       _end150587_
                       (std/srfi/160/cvector#c128vector-length _v150581_)))
            '#!void
            (error '"Index out of range" _end150587_))
        (let _lp150591_ ((_i150594_ _start150585_))
          (if (fx< _i150594_ _end150587_)
              (begin
                (std/srfi/160/cvector#c128vector-set!
                 _v150581_
                 _i150594_
                 _fill150583_)
                (_lp150591_ (fx+ _i150594_ '1)))
              '#!void)))))
  (define std/srfi/160/c128#c128vector-fill!__0
    (lambda (_v150600_ _fill150601_)
      (let* ((_start150603_ '0)
             (_end150605_ (std/srfi/160/cvector#c128vector-length _v150600_)))
        (std/srfi/160/c128#c128vector-fill!__%
         _v150600_
         _fill150601_
         _start150603_
         _end150605_))))
  (define std/srfi/160/c128#c128vector-fill!__1
    (lambda (_v150607_ _fill150608_ _start150609_)
      (let ((_end150611_ (std/srfi/160/cvector#c128vector-length _v150607_)))
        (std/srfi/160/c128#c128vector-fill!__%
         _v150607_
         _fill150608_
         _start150609_
         _end150611_))))
  (define std/srfi/160/c128#c128vector-fill!
    (lambda _g299504_
      (let ((_g299503_ (let () (declare (not safe)) (##length _g299504_))))
        (cond ((let () (declare (not safe)) (##fx= _g299503_ 2))
               (apply std/srfi/160/c128#c128vector-fill!__0 _g299504_))
              ((let () (declare (not safe)) (##fx= _g299503_ 3))
               (apply std/srfi/160/c128#c128vector-fill!__1 _g299504_))
              ((let () (declare (not safe)) (##fx= _g299503_ 4))
               (apply std/srfi/160/c128#c128vector-fill!__% _g299504_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-fill!
                _g299504_))))))
  (define std/srfi/160/c128#c128vector-reverse!__%
    (lambda (_v150541_ _start150543_ _end150545_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v150541_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _v150541_))
        (if (and (fixnum? _start150543_)
                 (fx<= '0
                       _start150543_
                       (fx- (std/srfi/160/cvector#c128vector-length _v150541_)
                            '1)))
            '#!void
            (error '"Index out of range" _start150543_))
        (if (and (fixnum? _end150545_)
                 (fx<= _start150543_
                       _end150545_
                       (std/srfi/160/cvector#c128vector-length _v150541_)))
            '#!void
            (error '"Index out of range" _end150545_))
        (let _lp150549_ ((_i150552_ _start150543_)
                         (_j150554_ (fx- _end150545_ '1)))
          (if (fx< _i150552_ _j150554_)
              (let ((_iv150557_
                     (std/srfi/160/cvector#c128vector-ref _v150541_ _i150552_))
                    (_jv150559_
                     (std/srfi/160/cvector#c128vector-ref
                      _v150541_
                      _j150554_)))
                (std/srfi/160/cvector#c128vector-set!
                 _v150541_
                 _i150552_
                 _jv150559_)
                (std/srfi/160/cvector#c128vector-set!
                 _v150541_
                 _j150554_
                 _iv150557_)
                (_lp150549_ (fx+ _i150552_ '1) (fx- _j150554_ '1)))
              '#!void)))))
  (define std/srfi/160/c128#c128vector-reverse!__0
    (lambda (_v150565_)
      (let* ((_start150567_ '0)
             (_end150569_ (std/srfi/160/cvector#c128vector-length _v150565_)))
        (std/srfi/160/c128#c128vector-reverse!__%
         _v150565_
         _start150567_
         _end150569_))))
  (define std/srfi/160/c128#c128vector-reverse!__1
    (lambda (_v150571_ _start150572_)
      (let ((_end150574_ (std/srfi/160/cvector#c128vector-length _v150571_)))
        (std/srfi/160/c128#c128vector-reverse!__%
         _v150571_
         _start150572_
         _end150574_))))
  (define std/srfi/160/c128#c128vector-reverse!
    (lambda _g299506_
      (let ((_g299505_ (let () (declare (not safe)) (##length _g299506_))))
        (cond ((let () (declare (not safe)) (##fx= _g299505_ 1))
               (apply std/srfi/160/c128#c128vector-reverse!__0 _g299506_))
              ((let () (declare (not safe)) (##fx= _g299505_ 2))
               (apply std/srfi/160/c128#c128vector-reverse!__1 _g299506_))
              ((let () (declare (not safe)) (##fx= _g299505_ 3))
               (apply std/srfi/160/c128#c128vector-reverse!__% _g299506_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector-reverse!
                _g299506_))))))
  (define std/srfi/160/c128#c128vector-unfold!
    (lambda (_f150516_ _v150518_ _start150520_ _end150522_ _seed150524_)
      (declare (not safe))
      (begin
        (if (procedure? _f150516_)
            '#!void
            (error '"Bad argument; expected procedure" _f150516_))
        (if (##structure-direct-instance-of?
             _v150518_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _v150518_))
        (if (and (fixnum? _start150520_)
                 (fx<= '0
                       _start150520_
                       (fx- (std/srfi/160/cvector#c128vector-length _v150518_)
                            '1)))
            '#!void
            (error '"Index out of range" _start150520_))
        (if (and (fixnum? _end150522_)
                 (fx<= _start150520_
                       _end150522_
                       (std/srfi/160/cvector#c128vector-length _v150518_)))
            '#!void
            (error '"Index out of range" _end150522_))
        (let _lp150528_ ((_i150531_ _start150520_)
                         (_state150533_ _seed150524_))
          (if (fx< _i150531_ _end150522_)
              (let ((_g299507_ (_f150516_ _state150533_)))
                (begin
                  (let ((_g299508_
                         (if (##values? _g299507_)
                             (##vector-length _g299507_)
                             1)))
                    (if (not (##fx= _g299508_ 2))
                        (error "Context expects 2 values" _g299508_)))
                  (let ((_x150536_ (##vector-ref _g299507_ 0))
                        (_state150538_ (##vector-ref _g299507_ 1)))
                    (begin
                      (std/srfi/160/cvector#c128vector-set!
                       _v150518_
                       _i150531_
                       _x150536_)
                      (_lp150528_ (fx+ _i150531_ '1) _state150538_)))))
              '#!void)))))
  (define std/srfi/160/c128#c128vector-unfold-right!
    (lambda (_f150492_ _v150494_ _start150496_ _end150498_ _seed150500_)
      (declare (not safe))
      (begin
        (if (procedure? _f150492_)
            '#!void
            (error '"Bad argument; expected procedure" _f150492_))
        (if (##structure-direct-instance-of?
             _v150494_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _v150494_))
        (if (and (fixnum? _start150496_)
                 (fx<= '0
                       _start150496_
                       (fx- (std/srfi/160/cvector#c128vector-length _v150494_)
                            '1)))
            '#!void
            (error '"Index out of range" _start150496_))
        (if (and (fixnum? _end150498_)
                 (fx<= _start150496_
                       _end150498_
                       (std/srfi/160/cvector#c128vector-length _v150494_)))
            '#!void
            (error '"Index out of range" _end150498_))
        (let _lp150504_ ((_i150507_ (fx- _end150498_ '1))
                         (_state150509_ _seed150500_))
          (if (fx>= _i150507_ _start150496_)
              (let ((_g299509_ (_f150492_ _state150509_)))
                (begin
                  (let ((_g299510_
                         (if (##values? _g299509_)
                             (##vector-length _g299509_)
                             1)))
                    (if (not (##fx= _g299510_ 2))
                        (error "Context expects 2 values" _g299510_)))
                  (let ((_x150512_ (##vector-ref _g299509_ 0))
                        (_state150514_ (##vector-ref _g299509_ 1)))
                    (begin
                      (std/srfi/160/cvector#c128vector-set!
                       _v150494_
                       _i150507_
                       _x150512_)
                      (_lp150504_ (fx- _i150507_ '1) _state150514_)))))
              '#!void)))))
  (define std/srfi/160/c128#reverse-c128vector->list__%
    (lambda (_v150458_ _start150460_ _end150462_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v150458_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _v150458_))
        (if (and (fixnum? _start150460_)
                 (fx<= '0
                       _start150460_
                       (fx- (std/srfi/160/cvector#c128vector-length _v150458_)
                            '1)))
            '#!void
            (error '"Index out of range" _start150460_))
        (if (and (fixnum? _end150462_)
                 (fx<= _start150460_
                       _end150462_
                       (std/srfi/160/cvector#c128vector-length _v150458_)))
            '#!void
            (error '"Index out of range" _end150462_))
        (let _lp150466_ ((_i150469_ _start150460_) (_r150471_ '()))
          (if (fx< _i150469_ _end150462_)
              (_lp150466_
               (fx+ _i150469_ '1)
               (cons (std/srfi/160/cvector#c128vector-ref _v150458_ _i150469_)
                     _r150471_))
              _r150471_)))))
  (define std/srfi/160/c128#reverse-c128vector->list__0
    (lambda (_v150477_)
      (let* ((_start150479_ '0)
             (_end150481_ (std/srfi/160/cvector#c128vector-length _v150477_)))
        (std/srfi/160/c128#reverse-c128vector->list__%
         _v150477_
         _start150479_
         _end150481_))))
  (define std/srfi/160/c128#reverse-c128vector->list__1
    (lambda (_v150483_ _start150484_)
      (let ((_end150486_ (std/srfi/160/cvector#c128vector-length _v150483_)))
        (std/srfi/160/c128#reverse-c128vector->list__%
         _v150483_
         _start150484_
         _end150486_))))
  (define std/srfi/160/c128#reverse-c128vector->list
    (lambda _g299512_
      (let ((_g299511_ (let () (declare (not safe)) (##length _g299512_))))
        (cond ((let () (declare (not safe)) (##fx= _g299511_ 1))
               (apply std/srfi/160/c128#reverse-c128vector->list__0 _g299512_))
              ((let () (declare (not safe)) (##fx= _g299511_ 2))
               (apply std/srfi/160/c128#reverse-c128vector->list__1 _g299512_))
              ((let () (declare (not safe)) (##fx= _g299511_ 3))
               (apply std/srfi/160/c128#reverse-c128vector->list__% _g299512_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#reverse-c128vector->list
                _g299512_))))))
  (define std/srfi/160/c128#reverse-list->c128vector
    (lambda (_lst150404_)
      (let* ((_len150407_ (length _lst150404_))
             (_v150410_
              (make-struct-instance
               std/srfi/160/cvector#c128vector::t
               _len150407_)))
        (declare (not safe))
        (let _lp150415_ ((_rest150418_ _lst150404_) (_i150420_ '0))
          (let* ((_rest150422150430_ _rest150418_)
                 (_else150424150438_ (lambda () _v150410_))
                 (_K150426150445_
                  (lambda (_rest150441_ _x150442_)
                    (if (std/srfi/160/base#c128? _x150442_)
                        '#!void
                        (error '"Bad element" _x150442_))
                    (std/srfi/160/cvector#c128vector-set!
                     _v150410_
                     _i150420_
                     _x150442_)
                    (_lp150415_ _rest150441_ (fx+ _i150420_ '1)))))
            (if (##pair? _rest150422150430_)
                (let ((_hd150427150448_ (##car _rest150422150430_))
                      (_tl150428150450_ (##cdr _rest150422150430_)))
                  (let* ((_x150453_ _hd150427150448_)
                         (_rest150455_ _tl150428150450_))
                    (_K150426150445_ _rest150455_ _x150453_)))
                (_else150424150438_)))))))
  (define std/srfi/160/c128#c128vector->vector__%
    (lambda (_v150365_ _start150367_ _end150369_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v150365_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _v150365_))
        (if (and (fixnum? _start150367_)
                 (fx<= '0
                       _start150367_
                       (fx- (std/srfi/160/cvector#c128vector-length _v150365_)
                            '1)))
            '#!void
            (error '"Index out of range" _start150367_))
        (if (and (fixnum? _end150369_)
                 (fx<= _start150367_
                       _end150369_
                       (std/srfi/160/cvector#c128vector-length _v150365_)))
            '#!void
            (error '"Index out of range" _end150369_))
        (let* ((_len150373_ (std/srfi/160/cvector#c128vector-length _v150365_))
               (_u150376_ (make-vector _len150373_)))
          (let _lp150380_ ((_i150383_ '0))
            (if (fx< _i150383_ _len150373_)
                (begin
                  (vector-set!
                   _u150376_
                   _i150383_
                   (std/srfi/160/cvector#c128vector-ref _v150365_ _i150383_))
                  (_lp150380_ (fx+ _i150383_ '1)))
                _u150376_))))))
  (define std/srfi/160/c128#c128vector->vector__0
    (lambda (_v150389_)
      (let* ((_start150391_ '0)
             (_end150393_ (std/srfi/160/cvector#c128vector-length _v150389_)))
        (std/srfi/160/c128#c128vector->vector__%
         _v150389_
         _start150391_
         _end150393_))))
  (define std/srfi/160/c128#c128vector->vector__1
    (lambda (_v150395_ _start150396_)
      (let ((_end150398_ (std/srfi/160/cvector#c128vector-length _v150395_)))
        (std/srfi/160/c128#c128vector->vector__%
         _v150395_
         _start150396_
         _end150398_))))
  (define std/srfi/160/c128#c128vector->vector
    (lambda _g299514_
      (let ((_g299513_ (let () (declare (not safe)) (##length _g299514_))))
        (cond ((let () (declare (not safe)) (##fx= _g299513_ 1))
               (apply std/srfi/160/c128#c128vector->vector__0 _g299514_))
              ((let () (declare (not safe)) (##fx= _g299513_ 2))
               (apply std/srfi/160/c128#c128vector->vector__1 _g299514_))
              ((let () (declare (not safe)) (##fx= _g299513_ 3))
               (apply std/srfi/160/c128#c128vector->vector__% _g299514_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#c128vector->vector
                _g299514_))))))
  (define std/srfi/160/c128#vector->c128vector__%
    (lambda (_v150325_ _start150327_ _end150329_)
      (declare (not safe))
      (begin
        (if (vector? _v150325_)
            '#!void
            (error '"Bad argument; expected vector" _v150325_))
        (if (and (fixnum? _start150327_)
                 (fx<= '0 _start150327_ (fx- (vector-length _v150325_) '1)))
            '#!void
            (error '"Index out of range" _start150327_))
        (if (and (fixnum? _end150329_)
                 (fx<= _start150327_ _end150329_ (vector-length _v150325_)))
            '#!void
            (error '"Index out of range" _end150329_))
        (let* ((_len150333_ (vector-length _v150325_))
               (_u150336_
                (make-struct-instance
                 std/srfi/160/cvector#c128vector::t
                 _len150333_)))
          (let _lp150340_ ((_i150343_ '0))
            (if (fx< _i150343_ _len150333_)
                (begin
                  (std/srfi/160/cvector#c128vector-set!
                   _u150336_
                   _i150343_
                   (vector-ref _v150325_ _i150343_))
                  (_lp150340_ (fx+ _i150343_ '1)))
                _u150336_))))))
  (define std/srfi/160/c128#vector->c128vector__0
    (lambda (_v150349_)
      (let* ((_start150351_ '0) (_end150353_ (vector-length _v150349_)))
        (std/srfi/160/c128#vector->c128vector__%
         _v150349_
         _start150351_
         _end150353_))))
  (define std/srfi/160/c128#vector->c128vector__1
    (lambda (_v150355_ _start150356_)
      (let ((_end150358_ (vector-length _v150355_)))
        (std/srfi/160/c128#vector->c128vector__%
         _v150355_
         _start150356_
         _end150358_))))
  (define std/srfi/160/c128#vector->c128vector
    (lambda _g299516_
      (let ((_g299515_ (let () (declare (not safe)) (##length _g299516_))))
        (cond ((let () (declare (not safe)) (##fx= _g299515_ 1))
               (apply std/srfi/160/c128#vector->c128vector__0 _g299516_))
              ((let () (declare (not safe)) (##fx= _g299515_ 2))
               (apply std/srfi/160/c128#vector->c128vector__1 _g299516_))
              ((let () (declare (not safe)) (##fx= _g299515_ 3))
               (apply std/srfi/160/c128#vector->c128vector__% _g299516_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#vector->c128vector
                _g299516_))))))
  (define std/srfi/160/c128#make-c128vector-generator__%
    (lambda (_v150291_ _start150293_ _end150295_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v150291_
             'std/srfi/160/cvector#c128vector::t)
            '#!void
            (error '"Bad argument" _v150291_))
        (if (and (fixnum? _start150293_)
                 (fx<= '0
                       _start150293_
                       (fx- (std/srfi/160/cvector#c128vector-length _v150291_)
                            '1)))
            '#!void
            (error '"Index out of range" _start150293_))
        (if (and (fixnum? _end150295_)
                 (fx<= _start150293_
                       _end150295_
                       (std/srfi/160/cvector#c128vector-length _v150291_)))
            '#!void
            (error '"Index out of range" _end150295_))
        (let ((_i150299_ _start150293_))
          (lambda ()
            (if (fx< _i150299_ _end150295_)
                (let ((_next150303_
                       (std/srfi/160/cvector#c128vector-ref
                        _v150291_
                        _i150299_)))
                  (set! _i150299_ (fx+ _i150299_ '1))
                  _next150303_)
                '#!eof))))))
  (define std/srfi/160/c128#make-c128vector-generator__0
    (lambda (_v150309_)
      (let* ((_start150311_ '0)
             (_end150313_ (std/srfi/160/cvector#c128vector-length _v150309_)))
        (std/srfi/160/c128#make-c128vector-generator__%
         _v150309_
         _start150311_
         _end150313_))))
  (define std/srfi/160/c128#make-c128vector-generator__1
    (lambda (_v150315_ _start150316_)
      (let ((_end150318_ (std/srfi/160/cvector#c128vector-length _v150315_)))
        (std/srfi/160/c128#make-c128vector-generator__%
         _v150315_
         _start150316_
         _end150318_))))
  (define std/srfi/160/c128#make-c128vector-generator
    (lambda _g299518_
      (let ((_g299517_ (let () (declare (not safe)) (##length _g299518_))))
        (cond ((let () (declare (not safe)) (##fx= _g299517_ 1))
               (apply std/srfi/160/c128#make-c128vector-generator__0
                      _g299518_))
              ((let () (declare (not safe)) (##fx= _g299517_ 2))
               (apply std/srfi/160/c128#make-c128vector-generator__1
                      _g299518_))
              ((let () (declare (not safe)) (##fx= _g299517_ 3))
               (apply std/srfi/160/c128#make-c128vector-generator__%
                      _g299518_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#make-c128vector-generator
                _g299518_))))))
  (define std/srfi/160/c128#c128vector-comparator
    (let ()
      (letrec ((_<?150262_
                (lambda (_a150265_ _b150267_)
                  (let ((_len-a150270_
                         (std/srfi/160/cvector#c128vector-length _a150265_))
                        (_len-b150272_
                         (std/srfi/160/cvector#c128vector-length _b150267_)))
                    (declare (not safe))
                    (if (fx< _len-a150270_ _len-b150272_)
                        '#t
                        (if (fx> _len-a150270_ _len-b150272_)
                            '#f
                            (let ((_end150276_ _len-a150270_))
                              (let _lp150279_ ((_i150282_ '0))
                                (if (fx< _i150282_ _end150276_)
                                    (let ((_x150285_
                                           (std/srfi/160/cvector#c128vector-ref
                                            _a150265_
                                            _i150282_))
                                          (_y150287_
                                           (std/srfi/160/cvector#c128vector-ref
                                            _b150267_
                                            _i150282_)))
                                      (if (< _x150285_ _y150287_)
                                          '#t
                                          (if (> _x150285_ _y150287_)
                                              '#f
                                              (_lp150279_
                                               (fx+ _i150282_ '1)))))
                                    '#f)))))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           std/srfi/160/cvector#c128vector?
           std/srfi/160/c128#c128vector=
           _<?150262_
           equal?-hash)))))
  (define std/srfi/160/c128#write-c128vector__%
    (lambda (_v150239_ _port150241_)
      (let ((_$e150244_ (find-method _v150239_ ':write)))
        (if _$e150244_
            ((lambda (_g150246150248_)
               (_g150246150248_ _v150239_ _port150241_))
             _$e150244_)
            (write _v150239_ (current-output-port))))))
  (define std/srfi/160/c128#write-c128vector__0
    (lambda (_v150254_)
      (let ((_port150256_ (current-output-port)))
        (std/srfi/160/c128#write-c128vector__% _v150254_ _port150256_))))
  (define std/srfi/160/c128#write-c128vector
    (lambda _g299520_
      (let ((_g299519_ (let () (declare (not safe)) (##length _g299520_))))
        (cond ((let () (declare (not safe)) (##fx= _g299519_ 1))
               (apply std/srfi/160/c128#write-c128vector__0 _g299520_))
              ((let () (declare (not safe)) (##fx= _g299519_ 2))
               (apply std/srfi/160/c128#write-c128vector__% _g299520_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c128#write-c128vector
                _g299520_)))))))
