(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/160/s16#s16vector-unfold
    (lambda (_f140226_ _len140228_ _seed140230_)
      (declare (not safe))
      (begin
        (if (procedure? _f140226_)
            '#!void
            (error '"Bad argument; expected procedure" _f140226_))
        (let ((_v140234_ (make-s16vector _len140228_)))
          (let _lp140237_ ((_i140240_ '0) (_state140242_ _seed140230_))
            (if (fx< _i140240_ _len140228_)
                (let ((_g299054_ (_f140226_ _i140240_ _state140242_)))
                  (begin
                    (let ((_g299055_
                           (if (##values? _g299054_)
                               (##vector-length _g299054_)
                               1)))
                      (if (not (##fx= _g299055_ 2))
                          (error "Context expects 2 values" _g299055_)))
                    (let ((_x140245_ (##vector-ref _g299054_ 0))
                          (_state140247_ (##vector-ref _g299054_ 1)))
                      (begin
                        (if (std/srfi/160/base#s16? _x140245_)
                            '#!void
                            (error '"Bad generated value" _x140245_))
                        (s16vector-set! _v140234_ _i140240_ _x140245_)
                        (_lp140237_ (fx+ _i140240_ '1) _state140247_)))))
                _v140234_))))))
  (define std/srfi/160/s16#s16vector-unfold-right
    (lambda (_f140203_ _len140205_ _seed140207_)
      (declare (not safe))
      (begin
        (if (procedure? _f140203_)
            '#!void
            (error '"Bad argument; expected procedure" _f140203_))
        (let ((_v140211_ (make-s16vector _len140205_)))
          (let _lp140214_ ((_i140217_ (fx- _len140205_ '1))
                           (_state140219_ _seed140207_))
            (if (fx>= _i140217_ '0)
                (let ((_g299056_ (_f140203_ _i140217_ _state140219_)))
                  (begin
                    (let ((_g299057_
                           (if (##values? _g299056_)
                               (##vector-length _g299056_)
                               1)))
                      (if (not (##fx= _g299057_ 2))
                          (error "Context expects 2 values" _g299057_)))
                    (let ((_x140222_ (##vector-ref _g299056_ 0))
                          (_state140224_ (##vector-ref _g299056_ 1)))
                      (begin
                        (if (std/srfi/160/base#s16? _x140222_)
                            '#!void
                            (error '"Bad generated value" _x140222_))
                        (s16vector-set! _v140211_ _i140217_ _x140222_)
                        (_lp140214_ (fx- _i140217_ '1) _state140224_)))))
                _v140211_))))))
  (define std/srfi/160/s16#s16vector-copy__%
    (lambda (_vec140175_ _start140177_ _end140179_)
      (let ((_v140182_ (make-s16vector (fx- _end140179_ _start140177_))))
        (std/srfi/160/s16#s16vector-copy!
         _v140182_
         '0
         _vec140175_
         _start140177_
         _end140179_)
        _v140182_)))
  (define std/srfi/160/s16#s16vector-copy__0
    (lambda (_vec140188_)
      (let* ((_start140190_ '0) (_end140192_ (s16vector-length _vec140188_)))
        (std/srfi/160/s16#s16vector-copy__%
         _vec140188_
         _start140190_
         _end140192_))))
  (define std/srfi/160/s16#s16vector-copy__1
    (lambda (_vec140194_ _start140195_)
      (let ((_end140197_ (s16vector-length _vec140194_)))
        (std/srfi/160/s16#s16vector-copy__%
         _vec140194_
         _start140195_
         _end140197_))))
  (define std/srfi/160/s16#s16vector-copy
    (lambda _g299059_
      (let ((_g299058_ (let () (declare (not safe)) (##length _g299059_))))
        (cond ((let () (declare (not safe)) (##fx= _g299058_ 1))
               (apply std/srfi/160/s16#s16vector-copy__0 _g299059_))
              ((let () (declare (not safe)) (##fx= _g299058_ 2))
               (apply std/srfi/160/s16#s16vector-copy__1 _g299059_))
              ((let () (declare (not safe)) (##fx= _g299058_ 3))
               (apply std/srfi/160/s16#s16vector-copy__% _g299059_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-copy
                _g299059_))))))
  (define std/srfi/160/s16#s16vector-copy!
    (lambda (_to140154_ _at140156_ _from140158_ _start140160_ _end140162_)
      (declare (not safe))
      (begin
        (if (s16vector? _to140154_) '#!void (error '"Bad argument" _to140154_))
        (if (s16vector? _from140158_)
            '#!void
            (error '"Bad argument" _from140158_))
        (if (and (fixnum? _at140156_)
                 (fx<= '0 _at140156_ (fx- (s16vector-length _at140156_) '1)))
            '#!void
            (error '"Index out of range" _to140154_ _at140156_))
        (if (and (fixnum? _start140160_)
                 (fx<= '0
                       _start140160_
                       (fx- (s16vector-length _from140158_) '1)))
            '#!void
            (error '"Index out of range" _from140158_ _start140160_))
        (if (and (fixnum? _end140162_)
                 (fx<= _start140160_
                       _end140162_
                       (s16vector-length _from140158_)))
            '#!void
            (error '"Index out of range" _from140158_ _end140162_))
        (if (fx<= (fx- _end140162_ _start140160_)
                  (fx- (s16vector-length _to140154_) _at140156_))
            '#!void
            (error '"Destination area too small"
                   _to140154_
                   _at140156_
                   _from140158_
                   _start140160_
                   _end140162_))
        (let _lp140166_ ((_i140169_ _start140160_) (_j140171_ _at140156_))
          (if (fx< _i140169_ _end140162_)
              (begin
                (s16vector-set!
                 _to140154_
                 _j140171_
                 (s16vector-ref _from140158_ _i140169_))
                (_lp140166_ (fx+ _i140169_ '1) (fx+ _j140171_ '1)))
              '#!void)))))
  (define std/srfi/160/s16#s16vector-reverse-copy__%
    (lambda (_vec140126_ _start140128_ _end140130_)
      (let ((_v140133_ (make-s16vector (fx- _end140130_ _start140128_))))
        (std/srfi/160/s16#s16vector-reverse-copy!
         _v140133_
         '0
         _vec140126_
         _start140128_
         _end140130_)
        _v140133_)))
  (define std/srfi/160/s16#s16vector-reverse-copy__0
    (lambda (_vec140139_)
      (let* ((_start140141_ '0) (_end140143_ (s16vector-length _vec140139_)))
        (std/srfi/160/s16#s16vector-reverse-copy__%
         _vec140139_
         _start140141_
         _end140143_))))
  (define std/srfi/160/s16#s16vector-reverse-copy__1
    (lambda (_vec140145_ _start140146_)
      (let ((_end140148_ (s16vector-length _vec140145_)))
        (std/srfi/160/s16#s16vector-reverse-copy__%
         _vec140145_
         _start140146_
         _end140148_))))
  (define std/srfi/160/s16#s16vector-reverse-copy
    (lambda _g299061_
      (let ((_g299060_ (let () (declare (not safe)) (##length _g299061_))))
        (cond ((let () (declare (not safe)) (##fx= _g299060_ 1))
               (apply std/srfi/160/s16#s16vector-reverse-copy__0 _g299061_))
              ((let () (declare (not safe)) (##fx= _g299060_ 2))
               (apply std/srfi/160/s16#s16vector-reverse-copy__1 _g299061_))
              ((let () (declare (not safe)) (##fx= _g299060_ 3))
               (apply std/srfi/160/s16#s16vector-reverse-copy__% _g299061_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-reverse-copy
                _g299061_))))))
  (define std/srfi/160/s16#s16vector-reverse-copy!
    (lambda (_to140105_ _at140107_ _from140109_ _start140111_ _end140113_)
      (declare (not safe))
      (begin
        (if (s16vector? _to140105_) '#!void (error '"Bad argument" _to140105_))
        (if (s16vector? _from140109_)
            '#!void
            (error '"Bad argument" _from140109_))
        (if (and (fixnum? _at140107_)
                 (fx<= '0 _at140107_ (fx- (s16vector-length _at140107_) '1)))
            '#!void
            (error '"Index out of range" _to140105_ _at140107_))
        (if (and (fixnum? _start140111_)
                 (fx<= '0
                       _start140111_
                       (fx- (s16vector-length _from140109_) '1)))
            '#!void
            (error '"Index out of range" _from140109_ _start140111_))
        (if (and (fixnum? _end140113_)
                 (fx<= _start140111_
                       _end140113_
                       (s16vector-length _from140109_)))
            '#!void
            (error '"Index out of range" _from140109_ _end140113_))
        (if (fx<= (fx- _end140113_ _start140111_)
                  (fx- (s16vector-length _to140105_) _at140107_))
            '#!void
            (error '"Destination area too small"
                   _to140105_
                   _at140107_
                   _from140109_
                   _start140111_
                   _end140113_))
        (let _lp140117_ ((_i140120_ (fx- _end140113_ '1))
                         (_j140122_ _at140107_))
          (if (fx>= _i140120_ _start140111_)
              (begin
                (s16vector-set!
                 _to140105_
                 _j140122_
                 (s16vector-ref _from140109_ _i140120_))
                (_lp140117_ (fx- _i140120_ '1) (fx+ _j140122_ '1)))
              '#!void)))))
  (define std/srfi/160/s16#s16vector-append
    (lambda _args140102_
      (std/srfi/160/s16#s16vector-concatenate _args140102_)))
  (define std/srfi/160/s16#s16vector-concatenate
    (lambda (_lst140042_)
      (let* ((_len140050_
              (foldl1 (lambda (_v140045_ _r140047_)
                        (fx+ (s16vector-length _v140045_) _r140047_))
                      '0
                      _lst140042_))
             (_v140053_ (make-s16vector _len140050_)))
        (declare (not safe))
        (let _lp140057_ ((_rest140060_ _lst140042_) (_at140062_ '0))
          (let* ((_rest140064140072_ _rest140060_)
                 (_else140066140080_ (lambda () _v140053_))
                 (_K140068140090_
                  (lambda (_rest140083_ _u140084_)
                    (let ((_ulen140087_ (s16vector-length _u140084_)))
                      (std/srfi/160/s16#s16vector-copy!
                       _v140053_
                       _at140062_
                       _u140084_
                       '0
                       _ulen140087_)
                      (_lp140057_
                       _rest140083_
                       (fx+ _at140062_ _ulen140087_))))))
            (if (##pair? _rest140064140072_)
                (let ((_hd140069140093_ (##car _rest140064140072_))
                      (_tl140070140095_ (##cdr _rest140064140072_)))
                  (let* ((_u140098_ _hd140069140093_)
                         (_rest140100_ _tl140070140095_))
                    (_K140068140090_ _rest140100_ _u140098_)))
                (_else140066140080_)))))))
  (define std/srfi/160/s16#s16vector-append-subvectors
    (lambda _args139914_
      (let* ((_len139975_
              (let _lp139917_ ((_rest139920_ _args139914_) (_r139922_ '0))
                (let* ((_rest139924139936_ _rest139920_)
                       (_else139926139944_ (lambda () _r139922_))
                       (_K139928139953_
                        (lambda (_rest139947_ _end139948_ _start139950_)
                          (_lp139917_
                           _rest139947_
                           (fx+ _r139922_ (fx- _end139948_ _start139950_))))))
                  (if (let ()
                        (declare (not safe))
                        (##pair? _rest139924139936_))
                      (let ((_tl139930139956_
                             (let ()
                               (declare (not safe))
                               (##cdr _rest139924139936_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl139930139956_))
                            (let ((_hd139931139959_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl139930139956_)))
                                  (_tl139932139961_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl139930139956_))))
                              (let ((_start139964_ _hd139931139959_))
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl139932139961_))
                                    (let ((_hd139933139966_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl139932139961_)))
                                          (_tl139934139968_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl139932139961_))))
                                      (let* ((_end139971_ _hd139933139966_)
                                             (_rest139973_ _tl139934139968_))
                                        (_K139928139953_
                                         _rest139973_
                                         _end139971_
                                         _start139964_)))
                                    (_else139926139944_))))
                            (_else139926139944_)))
                      (_else139926139944_)))))
             (_v139978_ (make-s16vector _len139975_)))
        (let _lp139982_ ((_rest139984_ _args139914_) (_at139985_ '0))
          (let* ((_rest139987139999_ _rest139984_)
                 (_else139989140007_ (lambda () _v139978_))
                 (_K139991140016_
                  (lambda (_rest140010_ _end140011_ _start140012_ _u140013_)
                    (std/srfi/160/s16#s16vector-copy!
                     _v139978_
                     _at139985_
                     _u140013_
                     _start140012_
                     _end140011_)
                    (_lp139982_
                     _rest140010_
                     (fx+ _at139985_ (fx- _end140011_ _start140012_))))))
            (if (let () (declare (not safe)) (##pair? _rest139987139999_))
                (let ((_hd139992140019_
                       (let ()
                         (declare (not safe))
                         (##car _rest139987139999_)))
                      (_tl139993140021_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest139987139999_))))
                  (let ((_u140024_ _hd139992140019_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl139993140021_))
                        (let ((_hd139994140026_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl139993140021_)))
                              (_tl139995140028_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl139993140021_))))
                          (let ((_start140031_ _hd139994140026_))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl139995140028_))
                                (let ((_hd139996140033_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl139995140028_)))
                                      (_tl139997140035_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _tl139995140028_))))
                                  (let* ((_end140038_ _hd139996140033_)
                                         (_rest140040_ _tl139997140035_))
                                    (_K139991140016_
                                     _rest140040_
                                     _end140038_
                                     _start140031_
                                     _u140024_)))
                                (_else139989140007_))))
                        (_else139989140007_))))
                (_else139989140007_)))))))
  (define std/srfi/160/s16#s16vector-empty?
    (lambda (_v139911_) (fxzero? (s16vector-length _v139911_))))
  (define std/srfi/160/s16#s16vector=
    (lambda (_v139853_ . _args139855_)
      (declare (not safe))
      (begin
        (if (s16vector? _v139853_) '#!void (error '"Bad argument" _v139853_))
        (let ((_vlen139859_ (s16vector-length _v139853_)))
          (let _lp139862_ ((_rest139865_ _args139855_))
            (let* ((_rest139867139875_ _rest139865_)
                   (_else139869139883_ (lambda () '#t))
                   (_K139871139899_
                    (lambda (_rest139886_ _u139887_)
                      (if (s16vector? _u139887_)
                          '#!void
                          (error '"Bad argument" _u139887_))
                      (let ((_ulen139890_ (s16vector-length _u139887_)))
                        (if (fx= _vlen139859_ _ulen139890_)
                            (let _cmp139893_ ((_i139896_ '0))
                              (if (fx< _i139896_ _vlen139859_)
                                  (if (= (s16vector-ref _v139853_ _i139896_)
                                         (s16vector-ref _u139887_ _i139896_))
                                      (_cmp139893_ (fx+ _i139896_ '1))
                                      '#f)
                                  (_lp139862_ _rest139886_)))
                            '#f)))))
              (if (##pair? _rest139867139875_)
                  (let ((_hd139872139902_ (##car _rest139867139875_))
                        (_tl139873139904_ (##cdr _rest139867139875_)))
                    (let* ((_u139907_ _hd139872139902_)
                           (_rest139909_ _tl139873139904_))
                      (_K139871139899_ _rest139909_ _u139907_)))
                  (_else139869139883_))))))))
  (define std/srfi/160/s16#s16vector-take
    (lambda (_v139845_ _n139847_)
      (let ((_u139850_ (make-s16vector _n139847_)))
        (std/srfi/160/s16#s16vector-copy! _u139850_ '0 _v139845_ '0 _n139847_)
        _u139850_)))
  (define std/srfi/160/s16#s16vector-take-right
    (lambda (_v139830_ _n139832_)
      (let* ((_vlen139835_ (s16vector-length _v139830_))
             (_ulen139838_ (fx- _vlen139835_ _n139832_))
             (_u139841_ (make-s16vector _ulen139838_)))
        (std/srfi/160/s16#s16vector-copy!
         _u139841_
         '0
         _v139830_
         _n139832_
         _vlen139835_)
        _u139841_)))
  (define std/srfi/160/s16#s16vector-drop
    (lambda (_v139815_ _n139817_)
      (let* ((_vlen139820_ (s16vector-length _v139815_))
             (_ulen139823_ (fx- _vlen139820_ _n139817_))
             (_u139826_ (make-s16vector _ulen139823_)))
        (std/srfi/160/s16#s16vector-copy!
         _u139826_
         '0
         _v139815_
         _n139817_
         _vlen139820_)
        _u139826_)))
  (define std/srfi/160/s16#s16vector-drop-right
    (lambda (_v139800_ _n139802_)
      (let* ((_vlen139805_ (s16vector-length _v139800_))
             (_ulen139808_ (fx- _vlen139805_ _n139802_))
             (_u139811_ (make-s16vector _ulen139808_)))
        (std/srfi/160/s16#s16vector-copy!
         _u139811_
         '0
         _v139800_
         '0
         _ulen139808_)
        _u139811_)))
  (define std/srfi/160/s16#s16vector-segment
    (lambda (_v139782_ _n139784_)
      (let _lp139787_ ((_i139790_ '0)
                       (_rest139792_ (s16vector-length _v139782_))
                       (_r139794_ '()))
        (if (fx> _r139794_ '0)
            (let ((_size139797_ (fxmin _n139784_ _rest139792_)))
              (_lp139787_
               (fx+ _i139790_ _size139797_)
               (fx- _rest139792_ _size139797_)
               (cons (std/srfi/160/s16#s16vector-copy__%
                      _v139782_
                      _i139790_
                      (fx+ _i139790_ _size139797_))
                     _r139794_)))
            (reverse _r139794_)))))
  (define std/srfi/160/s16#s16vector-fold__0
    (lambda (_kons139742_ _knil139744_ _v139746_)
      (if (procedure? _kons139742_)
          '#!void
          (error '"Bad argument; expected procedure" _kons139742_))
      (let ((_end139749_ (s16vector-length _v139746_)))
        (declare (not safe))
        (let _lp139753_ ((_i139756_ '0) (_r139758_ _knil139744_))
          (if (fx< _i139756_ _end139749_)
              (_lp139753_
               (fx+ _i139756_ '1)
               (_kons139742_ _r139758_ (s16vector-ref _v139746_ _i139756_)))
              _r139758_)))))
  (define std/srfi/160/s16#s16vector-fold__1
    (lambda (_kons139761_ _knil139762_ _v139763_ . _vs139764_)
      (if (procedure? _kons139761_)
          '#!void
          (error '"Bad argument; expected procedure" _kons139761_))
      (let* ((_vs139767_ (cons _v139763_ _vs139764_))
             (_end139769_ (apply fxmin (map s16vector-length _vs139767_))))
        (declare (not safe))
        (let _lp139773_ ((_i139775_ '0) (_r139776_ _knil139762_))
          (if (fx< _i139775_ _end139769_)
              (_lp139773_
               (fx+ _i139775_ '1)
               (apply _kons139761_
                      _r139776_
                      (map (lambda (_g139777139779_)
                             (s16vector-ref _g139777139779_ _i139775_))
                           _vs139767_)))
              _r139776_)))))
  (define std/srfi/160/s16#s16vector-fold
    (lambda _g299063_
      (let ((_g299062_ (let () (declare (not safe)) (##length _g299063_))))
        (cond ((let () (declare (not safe)) (##fx= _g299062_ 3))
               (apply std/srfi/160/s16#s16vector-fold__0 _g299063_))
              ((let () (declare (not safe)) (##fx>= _g299062_ 3))
               (apply std/srfi/160/s16#s16vector-fold__1 _g299063_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-fold
                _g299063_))))))
  (define std/srfi/160/s16#s16vector-fold-right__0
    (lambda (_kons139702_ _knil139704_ _v139706_)
      (if (procedure? _kons139702_)
          '#!void
          (error '"Bad argument; expected procedure" _kons139702_))
      (let ((_last139709_ (fx- (s16vector-length _v139706_) '1)))
        (declare (not safe))
        (let _lp139713_ ((_i139716_ _last139709_) (_r139718_ _knil139704_))
          (if (fx>= _i139716_ '0)
              (_lp139713_
               (fx- _i139716_ '1)
               (_kons139702_ _r139718_ (s16vector-ref _v139706_ _i139716_)))
              _r139718_)))))
  (define std/srfi/160/s16#s16vector-fold-right__1
    (lambda (_kons139721_ _knil139722_ _v139723_ . _vs139724_)
      (if (procedure? _kons139721_)
          '#!void
          (error '"Bad argument; expected procedure" _kons139721_))
      (let* ((_vs139727_ (cons _v139723_ _vs139724_))
             (_last139729_
              (fx- (apply min (map s16vector-length _vs139727_)) '1)))
        (declare (not safe))
        (let _lp139733_ ((_i139735_ _last139729_) (_r139736_ _knil139722_))
          (if (fx>= _i139735_ '0)
              (_lp139733_
               (fx- _i139735_ '1)
               (apply _kons139721_
                      _r139736_
                      (map (lambda (_g139737139739_)
                             (s16vector-ref _g139737139739_ _i139735_))
                           _vs139727_)))
              _r139736_)))))
  (define std/srfi/160/s16#s16vector-fold-right
    (lambda _g299065_
      (let ((_g299064_ (let () (declare (not safe)) (##length _g299065_))))
        (cond ((let () (declare (not safe)) (##fx= _g299064_ 3))
               (apply std/srfi/160/s16#s16vector-fold-right__0 _g299065_))
              ((let () (declare (not safe)) (##fx>= _g299064_ 3))
               (apply std/srfi/160/s16#s16vector-fold-right__1 _g299065_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-fold-right
                _g299065_))))))
  (define std/srfi/160/s16#s16vector-map__0
    (lambda (_f139662_ _v139664_)
      (if (procedure? _f139662_)
          '#!void
          (error '"Bad argument; expected procedure" _f139662_))
      (let* ((_len139667_ (s16vector-length _v139664_))
             (_u139670_ (make-s16vector _len139667_)))
        (declare (not safe))
        (let _lp139675_ ((_i139678_ '0))
          (if (fx< _i139678_ _len139667_)
              (begin
                (s16vector-set!
                 _u139670_
                 _i139678_
                 (s16vector-ref _v139664_ _i139678_))
                (_lp139675_ (fx+ _i139678_ '1)))
              _u139670_)))))
  (define std/srfi/160/s16#s16vector-map__1
    (lambda (_f139681_ _v139682_ . _vs139683_)
      (if (procedure? _f139681_)
          '#!void
          (error '"Bad argument; expected procedure" _f139681_))
      (let* ((_vs139686_ (cons _v139682_ _vs139683_))
             (_len139688_ (apply fxmin (map s16vector-length _vs139686_)))
             (_u139690_ (make-s16vector _len139688_)))
        (declare (not safe))
        (let _lp139694_ ((_i139696_ '0))
          (if (fx< _i139696_ _len139688_)
              (begin
                (s16vector-set!
                 _u139690_
                 _i139696_
                 (apply _f139681_
                        (map (lambda (_g139697139699_)
                               (s16vector-ref _g139697139699_ _i139696_))
                             _vs139686_)))
                (_lp139694_ (fx+ _i139696_ '1)))
              _u139690_)))))
  (define std/srfi/160/s16#s16vector-map
    (lambda _g299067_
      (let ((_g299066_ (let () (declare (not safe)) (##length _g299067_))))
        (cond ((let () (declare (not safe)) (##fx= _g299066_ 2))
               (apply std/srfi/160/s16#s16vector-map__0 _g299067_))
              ((let () (declare (not safe)) (##fx>= _g299066_ 2))
               (apply std/srfi/160/s16#s16vector-map__1 _g299067_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-map
                _g299067_))))))
  (define std/srfi/160/s16#s16vector-map!__0
    (lambda (_f139628_ _v139630_)
      (if (procedure? _f139628_)
          '#!void
          (error '"Bad argument; expected procedure" _f139628_))
      (let ((_len139633_ (s16vector-length _v139630_)))
        (declare (not safe))
        (let _lp139637_ ((_i139640_ '0))
          (if (fx< _i139640_ _len139633_)
              (begin
                (s16vector-set!
                 _v139630_
                 _i139640_
                 (_f139628_ (s16vector-ref _v139630_ _i139640_)))
                (_lp139637_ (fx+ _i139640_ '1)))
              _v139630_)))))
  (define std/srfi/160/s16#s16vector-map!__1
    (lambda (_f139643_ _v139644_ . _vs139645_)
      (if (procedure? _f139643_)
          '#!void
          (error '"Bad argument; expected procedure" _f139643_))
      (let* ((_vs139648_ (cons _v139644_ _vs139645_))
             (_len139650_ (apply fxmin (map s16vector-length _vs139648_))))
        (declare (not safe))
        (let _lp139654_ ((_i139656_ '0))
          (if (fx< _i139656_ _len139650_)
              (begin
                (s16vector-set!
                 _v139644_
                 _i139656_
                 (apply _f139643_
                        (map (lambda (_g139657139659_)
                               (s16vector-ref _g139657139659_ _i139656_))
                             _vs139648_)))
                (_lp139654_ (fx+ _i139656_ '1)))
              _v139644_)))))
  (define std/srfi/160/s16#s16vector-map!
    (lambda _g299069_
      (let ((_g299068_ (let () (declare (not safe)) (##length _g299069_))))
        (cond ((let () (declare (not safe)) (##fx= _g299068_ 2))
               (apply std/srfi/160/s16#s16vector-map!__0 _g299069_))
              ((let () (declare (not safe)) (##fx>= _g299068_ 2))
               (apply std/srfi/160/s16#s16vector-map!__1 _g299069_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-map!
                _g299069_))))))
  (define std/srfi/160/s16#s16vector-for-each__0
    (lambda (_f139594_ _v139596_)
      (if (procedure? _f139594_)
          '#!void
          (error '"Bad argument; expected procedure" _f139594_))
      (let ((_len139599_ (s16vector-length _v139596_)))
        (declare (not safe))
        (let _lp139603_ ((_i139606_ '0))
          (if (fx< _i139606_ _len139599_)
              (begin
                (_f139594_ (s16vector-ref _v139596_ _i139606_))
                (_lp139603_ (fx+ _i139606_ '1)))
              '#!void)))))
  (define std/srfi/160/s16#s16vector-for-each__1
    (lambda (_f139609_ _v139610_ . _vs139611_)
      (let* ((_vs139614_ (cons _v139610_ _vs139611_))
             (_len139616_ (apply fxmin (map s16vector-length _vs139614_))))
        (declare (not safe))
        (let _lp139620_ ((_i139622_ '0))
          (if (fx< _i139622_ _len139616_)
              (begin
                (apply _f139609_
                       (map (lambda (_g139623139625_)
                              (s16vector-ref _g139623139625_ _i139622_))
                            _vs139614_))
                (_lp139620_ (fx+ _i139622_ '1)))
              '#!void)))))
  (define std/srfi/160/s16#s16vector-for-each
    (lambda _g299071_
      (let ((_g299070_ (let () (declare (not safe)) (##length _g299071_))))
        (cond ((let () (declare (not safe)) (##fx= _g299070_ 2))
               (apply std/srfi/160/s16#s16vector-for-each__0 _g299071_))
              ((let () (declare (not safe)) (##fx>= _g299070_ 2))
               (apply std/srfi/160/s16#s16vector-for-each__1 _g299071_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-for-each
                _g299071_))))))
  (define std/srfi/160/s16#s16vector-count__0
    (lambda (_pred139557_ _v139559_)
      (if (procedure? _pred139557_)
          '#!void
          (error '"Bad argument; expected procedure" _pred139557_))
      (let ((_end139562_ (s16vector-length _v139559_)))
        (declare (not safe))
        (let _lp139566_ ((_i139569_ '0) (_r139571_ '0))
          (if (fx< _i139569_ _end139562_)
              (if (_pred139557_ (s16vector-ref _v139559_ _i139569_))
                  (_lp139566_ (fx+ _i139569_ '1) (fx+ _r139571_ '1))
                  (_lp139566_ (fx+ _i139569_ '1) _r139571_))
              _r139571_)))))
  (define std/srfi/160/s16#s16vector-count__1
    (lambda (_pred139574_ _v139575_ . _vs139576_)
      (if (procedure? _pred139574_)
          '#!void
          (error '"Bad argument; expected procedure" _pred139574_))
      (let* ((_vs139579_ (cons _v139575_ _vs139576_))
             (_end139581_ (apply fxmin (map s16vector-length _vs139579_))))
        (declare (not safe))
        (let _lp139585_ ((_i139587_ '0) (_r139588_ '0))
          (if (fx< _i139587_ _end139581_)
              (if (apply _pred139574_
                         (map (lambda (_g139589139591_)
                                (s16vector-ref _g139589139591_ _i139587_))
                              _vs139579_))
                  (_lp139585_ (fx+ _i139587_ '1) (fx+ _r139588_ '1))
                  (_lp139585_ (fx+ _i139587_ '1) _r139588_))
              _r139588_)))))
  (define std/srfi/160/s16#s16vector-count
    (lambda _g299073_
      (let ((_g299072_ (let () (declare (not safe)) (##length _g299073_))))
        (cond ((let () (declare (not safe)) (##fx= _g299072_ 2))
               (apply std/srfi/160/s16#s16vector-count__0 _g299073_))
              ((let () (declare (not safe)) (##fx>= _g299072_ 2))
               (apply std/srfi/160/s16#s16vector-count__1 _g299073_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-count
                _g299073_))))))
  (define std/srfi/160/s16#s16vector-cumulate
    (lambda (_f139532_ _knil139534_ _v139536_)
      (if (procedure? _f139532_)
          '#!void
          (error '"Bad argument; expected procedure" _f139532_))
      (let* ((_len139539_ (s16vector-length _v139536_))
             (_r139542_ (make-s16vector _len139539_)))
        (declare (not safe))
        (let _lp139547_ ((_i139550_ '0) (_r139552_ _knil139534_))
          (if (fx< _i139550_ _len139539_)
              (let ((_next139554_
                     (_f139532_
                      _r139552_
                      (s16vector-ref _v139536_ _i139550_))))
                (s16vector-set! _v139536_ _i139550_ _next139554_)
                (_lp139547_ (fx+ _i139550_ '1) _next139554_))
              _v139536_)))))
  (define std/srfi/160/s16#s16vector-take-while
    (lambda (_pred139515_ _v139517_)
      (let* ((_len139520_ (s16vector-length _v139517_))
             (_idx139523_
              (std/srfi/160/s16#s16vector-skip__0 _pred139515_ _v139517_))
             (_idx139529_
              (let ((_$e139526_ _idx139523_))
                (if _$e139526_ _$e139526_ _len139520_))))
        (std/srfi/160/s16#s16vector-copy__% _v139517_ '0 _idx139529_))))
  (define std/srfi/160/s16#s16vector-take-while-right
    (lambda (_pred139501_ _v139503_)
      (let* ((_len139506_ (s16vector-length _v139503_))
             (_idx139509_
              (std/srfi/160/s16#s16vector-skip-right__0
               _pred139501_
               _v139503_))
             (_idx139512_ (if _idx139509_ (fx+ _idx139509_ '1) '0)))
        (std/srfi/160/s16#s16vector-copy__%
         _v139503_
         _idx139512_
         _len139506_))))
  (define std/srfi/160/s16#s16vector-drop-while
    (lambda (_pred139484_ _v139486_)
      (let* ((_len139489_ (s16vector-length _v139486_))
             (_idx139492_
              (std/srfi/160/s16#s16vector-skip__0 _pred139484_ _v139486_))
             (_idx139498_
              (let ((_$e139495_ _idx139492_))
                (if _$e139495_ _$e139495_ _len139489_))))
        (std/srfi/160/s16#s16vector-copy__%
         _v139486_
         _idx139498_
         _len139489_))))
  (define std/srfi/160/s16#s16vector-drop-while-right
    (lambda (_pred139470_ _v139472_)
      (let* ((_len139475_ (s16vector-length _v139472_))
             (_idx139478_
              (std/srfi/160/s16#s16vector-skip-right__0
               _pred139470_
               _v139472_))
             (_idx139481_ (if _idx139478_ (fx+ _idx139478_ '1) '0)))
        (std/srfi/160/s16#s16vector-copy__% _v139472_ '0 _idx139481_))))
  (define std/srfi/160/s16#s16vector-index__0
    (lambda (_pred139436_ _v139438_)
      (if (procedure? _pred139436_)
          '#!void
          (error '"Bad argument; expected procedure" _pred139436_))
      (let ((_end139441_ (s16vector-length _v139438_)))
        (declare (not safe))
        (let _lp139445_ ((_i139448_ '0))
          (if (fx< _i139448_ _end139441_)
              (if (_pred139436_ (s16vector-ref _v139438_ _i139448_))
                  _i139448_
                  (_lp139445_ (fx+ _i139448_ '1)))
              '#f)))))
  (define std/srfi/160/s16#s16vector-index__1
    (lambda (_pred139451_ _v139452_ . _vs139453_)
      (if (procedure? _pred139451_)
          '#!void
          (error '"Bad argument; expected procedure" _pred139451_))
      (let* ((_vs139456_ (cons _v139452_ _vs139453_))
             (_end139458_ (apply fxmin (map s16vector-length _vs139456_))))
        (declare (not safe))
        (let _lp139462_ ((_i139464_ '0))
          (if (fx< _i139464_ _end139458_)
              (if (apply _pred139451_
                         (map (lambda (_g139465139467_)
                                (s16vector-ref _g139465139467_ _i139464_))
                              _vs139456_))
                  _i139464_
                  (_lp139462_ (fx+ _i139464_ '1)))
              '#f)))))
  (define std/srfi/160/s16#s16vector-index
    (lambda _g299075_
      (let ((_g299074_ (let () (declare (not safe)) (##length _g299075_))))
        (cond ((let () (declare (not safe)) (##fx= _g299074_ 2))
               (apply std/srfi/160/s16#s16vector-index__0 _g299075_))
              ((let () (declare (not safe)) (##fx>= _g299074_ 2))
               (apply std/srfi/160/s16#s16vector-index__1 _g299075_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-index
                _g299075_))))))
  (define std/srfi/160/s16#s16vector-index-right__0
    (lambda (_pred139402_ _v139404_)
      (if (procedure? _pred139402_)
          '#!void
          (error '"Bad argument; expected procedure" _pred139402_))
      (let ((_start139407_ (fx- (s16vector-length _v139404_) '1)))
        (declare (not safe))
        (let _lp139411_ ((_i139414_ _start139407_))
          (if (fx>= _i139414_ '0)
              (if (_pred139402_ (s16vector-ref _v139404_ _i139414_))
                  _i139414_
                  (_lp139411_ (fx- _i139414_ '1)))
              '#f)))))
  (define std/srfi/160/s16#s16vector-index-right__1
    (lambda (_pred139417_ _v139418_ . _vs139419_)
      (if (procedure? _pred139417_)
          '#!void
          (error '"Bad argument; expected procedure" _pred139417_))
      (let* ((_vs139422_ (cons _v139418_ _vs139419_))
             (_start139424_
              (fx- (apply fxmin (map s16vector-length _vs139422_)) '1)))
        (declare (not safe))
        (let _lp139428_ ((_i139430_ _start139424_))
          (if (fx>= _i139430_ '0)
              (if (apply _pred139417_
                         (map (lambda (_g139431139433_)
                                (s16vector-ref _g139431139433_ _i139430_))
                              _vs139422_))
                  _i139430_
                  (_lp139428_ (fx- _i139430_ '1)))
              '#f)))))
  (define std/srfi/160/s16#s16vector-index-right
    (lambda _g299077_
      (let ((_g299076_ (let () (declare (not safe)) (##length _g299077_))))
        (cond ((let () (declare (not safe)) (##fx= _g299076_ 2))
               (apply std/srfi/160/s16#s16vector-index-right__0 _g299077_))
              ((let () (declare (not safe)) (##fx>= _g299076_ 2))
               (apply std/srfi/160/s16#s16vector-index-right__1 _g299077_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-index-right
                _g299077_))))))
  (define std/srfi/160/s16#s16vector-skip__0
    (lambda (_pred139386_ _v139388_)
      (std/srfi/160/s16#s16vector-index__0
       (lambda (_$obj139391_) (not (_pred139386_ _$obj139391_)))
       _v139388_)))
  (define std/srfi/160/s16#s16vector-skip__1
    (lambda (_pred139394_ _v139395_ . _vs139396_)
      (apply std/srfi/160/s16#s16vector-index
             (lambda (_$obj139399_) (not (_pred139394_ _$obj139399_)))
             _v139395_
             _vs139396_)))
  (define std/srfi/160/s16#s16vector-skip
    (lambda _g299079_
      (let ((_g299078_ (let () (declare (not safe)) (##length _g299079_))))
        (cond ((let () (declare (not safe)) (##fx= _g299078_ 2))
               (apply std/srfi/160/s16#s16vector-skip__0 _g299079_))
              ((let () (declare (not safe)) (##fx>= _g299078_ 2))
               (apply std/srfi/160/s16#s16vector-skip__1 _g299079_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-skip
                _g299079_))))))
  (define std/srfi/160/s16#s16vector-skip-right__0
    (lambda (_pred139370_ _v139372_)
      (std/srfi/160/s16#s16vector-index-right__0
       (lambda (_$obj139375_) (not (_pred139370_ _$obj139375_)))
       _v139372_)))
  (define std/srfi/160/s16#s16vector-skip-right__1
    (lambda (_pred139378_ _v139379_ . _vs139380_)
      (apply std/srfi/160/s16#s16vector-index-right
             (lambda (_$obj139383_) (not (_pred139378_ _$obj139383_)))
             _v139379_
             _vs139380_)))
  (define std/srfi/160/s16#s16vector-skip-right
    (lambda _g299081_
      (let ((_g299080_ (let () (declare (not safe)) (##length _g299081_))))
        (cond ((let () (declare (not safe)) (##fx= _g299080_ 2))
               (apply std/srfi/160/s16#s16vector-skip-right__0 _g299081_))
              ((let () (declare (not safe)) (##fx>= _g299080_ 2))
               (apply std/srfi/160/s16#s16vector-skip-right__1 _g299081_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-skip-right
                _g299081_))))))
  (define std/srfi/160/s16#s16vector-any__0
    (lambda (_pred139330_ _v139332_)
      (if (procedure? _pred139330_)
          '#!void
          (error '"Bad argument; expected procedure" _pred139330_))
      (let ((_end139335_ (s16vector-length _v139332_)))
        (declare (not safe))
        (let _lp139339_ ((_i139342_ '0))
          (if (fx< _i139342_ _end139335_)
              (let ((_$e139345_
                     (_pred139330_ (s16vector-ref _v139332_ _i139342_))))
                (if _$e139345_
                    (values _$e139345_)
                    (_lp139339_ (fx+ _i139342_ '1))))
              '#f)))))
  (define std/srfi/160/s16#s16vector-any__1
    (lambda (_pred139348_ _v139349_ . _vs139350_)
      (if (procedure? _pred139348_)
          '#!void
          (error '"Bad argument; expected procedure" _pred139348_))
      (let* ((_v139353_ (cons _v139349_ _vs139350_))
             (_end139355_ (apply fxmin (map s16vector-length _vs139350_))))
        (declare (not safe))
        (let _lp139359_ ((_i139361_ '0))
          (if (fx< _i139361_ _end139355_)
              (let ((_$e139367_
                     (apply _pred139348_
                            (map (lambda (_g139362139364_)
                                   (s16vector-ref _g139362139364_ _i139361_))
                                 _vs139350_))))
                (if _$e139367_
                    (values _$e139367_)
                    (_lp139359_ (fx+ _i139361_ '1))))
              '#f)))))
  (define std/srfi/160/s16#s16vector-any
    (lambda _g299083_
      (let ((_g299082_ (let () (declare (not safe)) (##length _g299083_))))
        (cond ((let () (declare (not safe)) (##fx= _g299082_ 2))
               (apply std/srfi/160/s16#s16vector-any__0 _g299083_))
              ((let () (declare (not safe)) (##fx>= _g299082_ 2))
               (apply std/srfi/160/s16#s16vector-any__1 _g299083_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-any
                _g299083_))))))
  (define std/srfi/160/s16#s16vector-every__0
    (lambda (_pred139279_ _v139281_)
      (if (procedure? _pred139279_)
          '#!void
          (error '"Bad argument; expected procedure" _pred139279_))
      (let ((_end139284_ (s16vector-length _v139281_)))
        (declare (not safe))
        (let _lp139288_ ((_i139291_ '0) (_r139293_ '#t))
          (if (fx< _i139291_ _end139284_)
              (let ((_$e139296_
                     (_pred139279_ (s16vector-ref _v139281_ _i139291_))))
                (if _$e139296_
                    ((lambda (_g139298139300_)
                       (_lp139288_ (fx+ _i139291_ '1) _g139298139300_))
                     _$e139296_)
                    '#f))
              _r139293_)))))
  (define std/srfi/160/s16#s16vector-every__1
    (lambda (_pred139303_ _v139304_ . _vs139305_)
      (if (procedure? _pred139303_)
          '#!void
          (error '"Bad argument; expected procedure" _pred139303_))
      (let* ((_v139308_ (cons _v139304_ _vs139305_))
             (_end139310_ (apply fxmin (map s16vector-length _vs139305_))))
        (declare (not safe))
        (let _lp139314_ ((_i139316_ '0) (_r139317_ '#t))
          (if (fx< _i139316_ _end139310_)
              (let ((_$e139323_
                     (apply _pred139303_
                            (map (lambda (_g139318139320_)
                                   (s16vector-ref _g139318139320_ _i139316_))
                                 _vs139305_))))
                (if _$e139323_
                    ((lambda (_g139325139327_)
                       (_lp139314_ (fx+ _i139316_ '1) _g139325139327_))
                     _$e139323_)
                    '#f))
              _r139317_)))))
  (define std/srfi/160/s16#s16vector-every
    (lambda _g299085_
      (let ((_g299084_ (let () (declare (not safe)) (##length _g299085_))))
        (cond ((let () (declare (not safe)) (##fx= _g299084_ 2))
               (apply std/srfi/160/s16#s16vector-every__0 _g299085_))
              ((let () (declare (not safe)) (##fx>= _g299084_ 2))
               (apply std/srfi/160/s16#s16vector-every__1 _g299085_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-every
                _g299085_))))))
  (define std/srfi/160/s16#s16vector-partition
    (lambda (_pred139250_ _v139252_)
      (let* ((_count139255_
              (std/srfi/160/s16#s16vector-count__0 _pred139250_ _v139252_))
             (_len139258_ (s16vector-length _v139252_))
             (_u139261_ (make-s16vector _len139258_)))
        (declare (not safe))
        (let _lp139266_ ((_i139269_ '0)
                         (_left139271_ '0)
                         (_right139273_ _count139255_))
          (if (fx< _i139269_ _len139258_)
              (let ((_x139276_ (s16vector-ref _v139252_ _i139269_)))
                (if (_pred139250_ _x139276_)
                    (begin
                      (s16vector-set! _u139261_ _left139271_ _x139276_)
                      (_lp139266_
                       (fx+ _i139269_ '1)
                       (fx+ _left139271_ '1)
                       _right139273_))
                    (begin
                      (s16vector-set! _u139261_ _right139273_ _x139276_)
                      (_lp139266_
                       (fx+ _i139269_ '1)
                       _left139271_
                       (fx+ _right139273_ '1)))))
              _u139261_)))))
  (define std/srfi/160/s16#s16vector-filter
    (lambda (_pred139223_ _v139225_)
      (let* ((_count139228_
              (std/srfi/160/s16#s16vector-count__0 _pred139223_ _v139225_))
             (_u139231_ (make-s16vector _count139228_))
             (_end139234_ (s16vector-length _v139225_)))
        (declare (not safe))
        (let _lp139239_ ((_i139242_ '0) (_j139244_ '0))
          (if (fx< _i139242_ _end139234_)
              (let ((_x139247_ (s16vector-ref _v139225_ _i139242_)))
                (if (_pred139223_ _x139247_)
                    (begin
                      (s16vector-set! _u139231_ _j139244_ _x139247_)
                      (_lp139239_ (fx+ _i139242_ '1) (fx+ _j139244_ '1)))
                    (_lp139239_ (fx+ _i139242_ '1) _j139244_)))
              _u139231_)))))
  (define std/srfi/160/s16#s16vector-remove
    (lambda (_pred139215_ _v139217_)
      (std/srfi/160/s16#s16vector-filter
       (lambda (_$obj139220_) (not (_pred139215_ _$obj139220_)))
       _v139217_)))
  (define std/srfi/160/s16#s16vector-swap
    (lambda (_v139202_ _i139204_ _j139206_)
      (let ((_iv139209_ (s16vector-ref _v139202_ _i139204_))
            (_jv139211_ (s16vector-ref _v139202_ _j139206_)))
        (declare (not safe))
        (begin
          (s16vector-set! _v139202_ _i139204_ _jv139211_)
          (s16vector-set! _v139202_ _j139206_ _iv139209_)))))
  (define std/srfi/160/s16#s16vector-fill!__%
    (lambda (_v139165_ _fill139167_ _start139169_ _end139171_)
      (declare (not safe))
      (begin
        (if (s16vector? _v139165_) '#!void (error '"Bad argument" _v139165_))
        (if (std/srfi/160/base#s16? _fill139167_)
            '#!void
            (error '"Bad argument" _fill139167_))
        (if (and (fixnum? _start139169_)
                 (fx<= '0 _start139169_ (fx- (s16vector-length _v139165_) '1)))
            '#!void
            (error '"Index out of range" _start139169_))
        (if (and (fixnum? _end139171_)
                 (fx<= _start139169_ _end139171_ (s16vector-length _v139165_)))
            '#!void
            (error '"Index out of range" _end139171_))
        (let _lp139175_ ((_i139178_ _start139169_))
          (if (fx< _i139178_ _end139171_)
              (begin
                (s16vector-set! _v139165_ _i139178_ _fill139167_)
                (_lp139175_ (fx+ _i139178_ '1)))
              '#!void)))))
  (define std/srfi/160/s16#s16vector-fill!__0
    (lambda (_v139184_ _fill139185_)
      (let* ((_start139187_ '0) (_end139189_ (s16vector-length _v139184_)))
        (std/srfi/160/s16#s16vector-fill!__%
         _v139184_
         _fill139185_
         _start139187_
         _end139189_))))
  (define std/srfi/160/s16#s16vector-fill!__1
    (lambda (_v139191_ _fill139192_ _start139193_)
      (let ((_end139195_ (s16vector-length _v139191_)))
        (std/srfi/160/s16#s16vector-fill!__%
         _v139191_
         _fill139192_
         _start139193_
         _end139195_))))
  (define std/srfi/160/s16#s16vector-fill!
    (lambda _g299087_
      (let ((_g299086_ (let () (declare (not safe)) (##length _g299087_))))
        (cond ((let () (declare (not safe)) (##fx= _g299086_ 2))
               (apply std/srfi/160/s16#s16vector-fill!__0 _g299087_))
              ((let () (declare (not safe)) (##fx= _g299086_ 3))
               (apply std/srfi/160/s16#s16vector-fill!__1 _g299087_))
              ((let () (declare (not safe)) (##fx= _g299086_ 4))
               (apply std/srfi/160/s16#s16vector-fill!__% _g299087_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-fill!
                _g299087_))))))
  (define std/srfi/160/s16#s16vector-reverse!__%
    (lambda (_v139125_ _start139127_ _end139129_)
      (declare (not safe))
      (begin
        (if (s16vector? _v139125_) '#!void (error '"Bad argument" _v139125_))
        (if (and (fixnum? _start139127_)
                 (fx<= '0 _start139127_ (fx- (s16vector-length _v139125_) '1)))
            '#!void
            (error '"Index out of range" _start139127_))
        (if (and (fixnum? _end139129_)
                 (fx<= _start139127_ _end139129_ (s16vector-length _v139125_)))
            '#!void
            (error '"Index out of range" _end139129_))
        (let _lp139133_ ((_i139136_ _start139127_)
                         (_j139138_ (fx- _end139129_ '1)))
          (if (fx< _i139136_ _j139138_)
              (let ((_iv139141_ (s16vector-ref _v139125_ _i139136_))
                    (_jv139143_ (s16vector-ref _v139125_ _j139138_)))
                (s16vector-set! _v139125_ _i139136_ _jv139143_)
                (s16vector-set! _v139125_ _j139138_ _iv139141_)
                (_lp139133_ (fx+ _i139136_ '1) (fx- _j139138_ '1)))
              '#!void)))))
  (define std/srfi/160/s16#s16vector-reverse!__0
    (lambda (_v139149_)
      (let* ((_start139151_ '0) (_end139153_ (s16vector-length _v139149_)))
        (std/srfi/160/s16#s16vector-reverse!__%
         _v139149_
         _start139151_
         _end139153_))))
  (define std/srfi/160/s16#s16vector-reverse!__1
    (lambda (_v139155_ _start139156_)
      (let ((_end139158_ (s16vector-length _v139155_)))
        (std/srfi/160/s16#s16vector-reverse!__%
         _v139155_
         _start139156_
         _end139158_))))
  (define std/srfi/160/s16#s16vector-reverse!
    (lambda _g299089_
      (let ((_g299088_ (let () (declare (not safe)) (##length _g299089_))))
        (cond ((let () (declare (not safe)) (##fx= _g299088_ 1))
               (apply std/srfi/160/s16#s16vector-reverse!__0 _g299089_))
              ((let () (declare (not safe)) (##fx= _g299088_ 2))
               (apply std/srfi/160/s16#s16vector-reverse!__1 _g299089_))
              ((let () (declare (not safe)) (##fx= _g299088_ 3))
               (apply std/srfi/160/s16#s16vector-reverse!__% _g299089_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector-reverse!
                _g299089_))))))
  (define std/srfi/160/s16#s16vector-unfold!
    (lambda (_f139100_ _v139102_ _start139104_ _end139106_ _seed139108_)
      (declare (not safe))
      (begin
        (if (procedure? _f139100_)
            '#!void
            (error '"Bad argument; expected procedure" _f139100_))
        (if (s16vector? _v139102_) '#!void (error '"Bad argument" _v139102_))
        (if (and (fixnum? _start139104_)
                 (fx<= '0 _start139104_ (fx- (s16vector-length _v139102_) '1)))
            '#!void
            (error '"Index out of range" _start139104_))
        (if (and (fixnum? _end139106_)
                 (fx<= _start139104_ _end139106_ (s16vector-length _v139102_)))
            '#!void
            (error '"Index out of range" _end139106_))
        (let _lp139112_ ((_i139115_ _start139104_)
                         (_state139117_ _seed139108_))
          (if (fx< _i139115_ _end139106_)
              (let ((_g299090_ (_f139100_ _state139117_)))
                (begin
                  (let ((_g299091_
                         (if (##values? _g299090_)
                             (##vector-length _g299090_)
                             1)))
                    (if (not (##fx= _g299091_ 2))
                        (error "Context expects 2 values" _g299091_)))
                  (let ((_x139120_ (##vector-ref _g299090_ 0))
                        (_state139122_ (##vector-ref _g299090_ 1)))
                    (begin
                      (s16vector-set! _v139102_ _i139115_ _x139120_)
                      (_lp139112_ (fx+ _i139115_ '1) _state139122_)))))
              '#!void)))))
  (define std/srfi/160/s16#s16vector-unfold-right!
    (lambda (_f139076_ _v139078_ _start139080_ _end139082_ _seed139084_)
      (declare (not safe))
      (begin
        (if (procedure? _f139076_)
            '#!void
            (error '"Bad argument; expected procedure" _f139076_))
        (if (s16vector? _v139078_) '#!void (error '"Bad argument" _v139078_))
        (if (and (fixnum? _start139080_)
                 (fx<= '0 _start139080_ (fx- (s16vector-length _v139078_) '1)))
            '#!void
            (error '"Index out of range" _start139080_))
        (if (and (fixnum? _end139082_)
                 (fx<= _start139080_ _end139082_ (s16vector-length _v139078_)))
            '#!void
            (error '"Index out of range" _end139082_))
        (let _lp139088_ ((_i139091_ (fx- _end139082_ '1))
                         (_state139093_ _seed139084_))
          (if (fx>= _i139091_ _start139080_)
              (let ((_g299092_ (_f139076_ _state139093_)))
                (begin
                  (let ((_g299093_
                         (if (##values? _g299092_)
                             (##vector-length _g299092_)
                             1)))
                    (if (not (##fx= _g299093_ 2))
                        (error "Context expects 2 values" _g299093_)))
                  (let ((_x139096_ (##vector-ref _g299092_ 0))
                        (_state139098_ (##vector-ref _g299092_ 1)))
                    (begin
                      (s16vector-set! _v139078_ _i139091_ _x139096_)
                      (_lp139088_ (fx- _i139091_ '1) _state139098_)))))
              '#!void)))))
  (define std/srfi/160/s16#reverse-s16vector->list__%
    (lambda (_v139042_ _start139044_ _end139046_)
      (declare (not safe))
      (begin
        (if (s16vector? _v139042_) '#!void (error '"Bad argument" _v139042_))
        (if (and (fixnum? _start139044_)
                 (fx<= '0 _start139044_ (fx- (s16vector-length _v139042_) '1)))
            '#!void
            (error '"Index out of range" _start139044_))
        (if (and (fixnum? _end139046_)
                 (fx<= _start139044_ _end139046_ (s16vector-length _v139042_)))
            '#!void
            (error '"Index out of range" _end139046_))
        (let _lp139050_ ((_i139053_ _start139044_) (_r139055_ '()))
          (if (fx< _i139053_ _end139046_)
              (_lp139050_
               (fx+ _i139053_ '1)
               (cons (s16vector-ref _v139042_ _i139053_) _r139055_))
              _r139055_)))))
  (define std/srfi/160/s16#reverse-s16vector->list__0
    (lambda (_v139061_)
      (let* ((_start139063_ '0) (_end139065_ (s16vector-length _v139061_)))
        (std/srfi/160/s16#reverse-s16vector->list__%
         _v139061_
         _start139063_
         _end139065_))))
  (define std/srfi/160/s16#reverse-s16vector->list__1
    (lambda (_v139067_ _start139068_)
      (let ((_end139070_ (s16vector-length _v139067_)))
        (std/srfi/160/s16#reverse-s16vector->list__%
         _v139067_
         _start139068_
         _end139070_))))
  (define std/srfi/160/s16#reverse-s16vector->list
    (lambda _g299095_
      (let ((_g299094_ (let () (declare (not safe)) (##length _g299095_))))
        (cond ((let () (declare (not safe)) (##fx= _g299094_ 1))
               (apply std/srfi/160/s16#reverse-s16vector->list__0 _g299095_))
              ((let () (declare (not safe)) (##fx= _g299094_ 2))
               (apply std/srfi/160/s16#reverse-s16vector->list__1 _g299095_))
              ((let () (declare (not safe)) (##fx= _g299094_ 3))
               (apply std/srfi/160/s16#reverse-s16vector->list__% _g299095_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#reverse-s16vector->list
                _g299095_))))))
  (define std/srfi/160/s16#reverse-list->s16vector
    (lambda (_lst138988_)
      (let* ((_len138991_ (length _lst138988_))
             (_v138994_ (make-s16vector _len138991_)))
        (declare (not safe))
        (let _lp138999_ ((_rest139002_ _lst138988_) (_i139004_ '0))
          (let* ((_rest139006139014_ _rest139002_)
                 (_else139008139022_ (lambda () _v138994_))
                 (_K139010139029_
                  (lambda (_rest139025_ _x139026_)
                    (if (std/srfi/160/base#s16? _x139026_)
                        '#!void
                        (error '"Bad element" _x139026_))
                    (s16vector-set! _v138994_ _i139004_ _x139026_)
                    (_lp138999_ _rest139025_ (fx+ _i139004_ '1)))))
            (if (##pair? _rest139006139014_)
                (let ((_hd139011139032_ (##car _rest139006139014_))
                      (_tl139012139034_ (##cdr _rest139006139014_)))
                  (let* ((_x139037_ _hd139011139032_)
                         (_rest139039_ _tl139012139034_))
                    (_K139010139029_ _rest139039_ _x139037_)))
                (_else139008139022_)))))))
  (define std/srfi/160/s16#s16vector->vector__%
    (lambda (_v138949_ _start138951_ _end138953_)
      (declare (not safe))
      (begin
        (if (s16vector? _v138949_) '#!void (error '"Bad argument" _v138949_))
        (if (and (fixnum? _start138951_)
                 (fx<= '0 _start138951_ (fx- (s16vector-length _v138949_) '1)))
            '#!void
            (error '"Index out of range" _start138951_))
        (if (and (fixnum? _end138953_)
                 (fx<= _start138951_ _end138953_ (s16vector-length _v138949_)))
            '#!void
            (error '"Index out of range" _end138953_))
        (let* ((_len138957_ (s16vector-length _v138949_))
               (_u138960_ (make-vector _len138957_)))
          (let _lp138964_ ((_i138967_ '0))
            (if (fx< _i138967_ _len138957_)
                (begin
                  (vector-set!
                   _u138960_
                   _i138967_
                   (s16vector-ref _v138949_ _i138967_))
                  (_lp138964_ (fx+ _i138967_ '1)))
                _u138960_))))))
  (define std/srfi/160/s16#s16vector->vector__0
    (lambda (_v138973_)
      (let* ((_start138975_ '0) (_end138977_ (s16vector-length _v138973_)))
        (std/srfi/160/s16#s16vector->vector__%
         _v138973_
         _start138975_
         _end138977_))))
  (define std/srfi/160/s16#s16vector->vector__1
    (lambda (_v138979_ _start138980_)
      (let ((_end138982_ (s16vector-length _v138979_)))
        (std/srfi/160/s16#s16vector->vector__%
         _v138979_
         _start138980_
         _end138982_))))
  (define std/srfi/160/s16#s16vector->vector
    (lambda _g299097_
      (let ((_g299096_ (let () (declare (not safe)) (##length _g299097_))))
        (cond ((let () (declare (not safe)) (##fx= _g299096_ 1))
               (apply std/srfi/160/s16#s16vector->vector__0 _g299097_))
              ((let () (declare (not safe)) (##fx= _g299096_ 2))
               (apply std/srfi/160/s16#s16vector->vector__1 _g299097_))
              ((let () (declare (not safe)) (##fx= _g299096_ 3))
               (apply std/srfi/160/s16#s16vector->vector__% _g299097_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#s16vector->vector
                _g299097_))))))
  (define std/srfi/160/s16#vector->s16vector__%
    (lambda (_v138909_ _start138911_ _end138913_)
      (declare (not safe))
      (begin
        (if (vector? _v138909_)
            '#!void
            (error '"Bad argument; expected vector" _v138909_))
        (if (and (fixnum? _start138911_)
                 (fx<= '0 _start138911_ (fx- (vector-length _v138909_) '1)))
            '#!void
            (error '"Index out of range" _start138911_))
        (if (and (fixnum? _end138913_)
                 (fx<= _start138911_ _end138913_ (vector-length _v138909_)))
            '#!void
            (error '"Index out of range" _end138913_))
        (let* ((_len138917_ (vector-length _v138909_))
               (_u138920_ (make-s16vector _len138917_)))
          (let _lp138924_ ((_i138927_ '0))
            (if (fx< _i138927_ _len138917_)
                (begin
                  (s16vector-set!
                   _u138920_
                   _i138927_
                   (vector-ref _v138909_ _i138927_))
                  (_lp138924_ (fx+ _i138927_ '1)))
                _u138920_))))))
  (define std/srfi/160/s16#vector->s16vector__0
    (lambda (_v138933_)
      (let* ((_start138935_ '0) (_end138937_ (vector-length _v138933_)))
        (std/srfi/160/s16#vector->s16vector__%
         _v138933_
         _start138935_
         _end138937_))))
  (define std/srfi/160/s16#vector->s16vector__1
    (lambda (_v138939_ _start138940_)
      (let ((_end138942_ (vector-length _v138939_)))
        (std/srfi/160/s16#vector->s16vector__%
         _v138939_
         _start138940_
         _end138942_))))
  (define std/srfi/160/s16#vector->s16vector
    (lambda _g299099_
      (let ((_g299098_ (let () (declare (not safe)) (##length _g299099_))))
        (cond ((let () (declare (not safe)) (##fx= _g299098_ 1))
               (apply std/srfi/160/s16#vector->s16vector__0 _g299099_))
              ((let () (declare (not safe)) (##fx= _g299098_ 2))
               (apply std/srfi/160/s16#vector->s16vector__1 _g299099_))
              ((let () (declare (not safe)) (##fx= _g299098_ 3))
               (apply std/srfi/160/s16#vector->s16vector__% _g299099_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#vector->s16vector
                _g299099_))))))
  (define std/srfi/160/s16#make-s16vector-generator__%
    (lambda (_v138875_ _start138877_ _end138879_)
      (declare (not safe))
      (begin
        (if (s16vector? _v138875_) '#!void (error '"Bad argument" _v138875_))
        (if (and (fixnum? _start138877_)
                 (fx<= '0 _start138877_ (fx- (s16vector-length _v138875_) '1)))
            '#!void
            (error '"Index out of range" _start138877_))
        (if (and (fixnum? _end138879_)
                 (fx<= _start138877_ _end138879_ (s16vector-length _v138875_)))
            '#!void
            (error '"Index out of range" _end138879_))
        (let ((_i138883_ _start138877_))
          (lambda ()
            (if (fx< _i138883_ _end138879_)
                (let ((_next138887_ (s16vector-ref _v138875_ _i138883_)))
                  (set! _i138883_ (fx+ _i138883_ '1))
                  _next138887_)
                '#!eof))))))
  (define std/srfi/160/s16#make-s16vector-generator__0
    (lambda (_v138893_)
      (let* ((_start138895_ '0) (_end138897_ (s16vector-length _v138893_)))
        (std/srfi/160/s16#make-s16vector-generator__%
         _v138893_
         _start138895_
         _end138897_))))
  (define std/srfi/160/s16#make-s16vector-generator__1
    (lambda (_v138899_ _start138900_)
      (let ((_end138902_ (s16vector-length _v138899_)))
        (std/srfi/160/s16#make-s16vector-generator__%
         _v138899_
         _start138900_
         _end138902_))))
  (define std/srfi/160/s16#make-s16vector-generator
    (lambda _g299101_
      (let ((_g299100_ (let () (declare (not safe)) (##length _g299101_))))
        (cond ((let () (declare (not safe)) (##fx= _g299100_ 1))
               (apply std/srfi/160/s16#make-s16vector-generator__0 _g299101_))
              ((let () (declare (not safe)) (##fx= _g299100_ 2))
               (apply std/srfi/160/s16#make-s16vector-generator__1 _g299101_))
              ((let () (declare (not safe)) (##fx= _g299100_ 3))
               (apply std/srfi/160/s16#make-s16vector-generator__% _g299101_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#make-s16vector-generator
                _g299101_))))))
  (define std/srfi/160/s16#s16vector-comparator
    (let ()
      (letrec ((_<?138846_
                (lambda (_a138849_ _b138851_)
                  (let ((_len-a138854_ (s16vector-length _a138849_))
                        (_len-b138856_ (s16vector-length _b138851_)))
                    (declare (not safe))
                    (if (fx< _len-a138854_ _len-b138856_)
                        '#t
                        (if (fx> _len-a138854_ _len-b138856_)
                            '#f
                            (let ((_end138860_ _len-a138854_))
                              (let _lp138863_ ((_i138866_ '0))
                                (if (fx< _i138866_ _end138860_)
                                    (let ((_x138869_
                                           (s16vector-ref _a138849_ _i138866_))
                                          (_y138871_
                                           (s16vector-ref
                                            _b138851_
                                            _i138866_)))
                                      (if (< _x138869_ _y138871_)
                                          '#t
                                          (if (> _x138869_ _y138871_)
                                              '#f
                                              (_lp138863_
                                               (fx+ _i138866_ '1)))))
                                    '#f)))))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           s16vector?
           std/srfi/160/s16#s16vector=
           _<?138846_
           equal?-hash)))))
  (define std/srfi/160/s16#write-s16vector__%
    (lambda (_v138823_ _port138825_)
      (let ((_$e138828_ (find-method _v138823_ ':write)))
        (if _$e138828_
            ((lambda (_g138830138832_)
               (_g138830138832_ _v138823_ _port138825_))
             _$e138828_)
            (write _v138823_ (current-output-port))))))
  (define std/srfi/160/s16#write-s16vector__0
    (lambda (_v138838_)
      (let ((_port138840_ (current-output-port)))
        (std/srfi/160/s16#write-s16vector__% _v138838_ _port138840_))))
  (define std/srfi/160/s16#write-s16vector
    (lambda _g299103_
      (let ((_g299102_ (let () (declare (not safe)) (##length _g299103_))))
        (cond ((let () (declare (not safe)) (##fx= _g299102_ 1))
               (apply std/srfi/160/s16#write-s16vector__0 _g299103_))
              ((let () (declare (not safe)) (##fx= _g299102_ 2))
               (apply std/srfi/160/s16#write-s16vector__% _g299103_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/s16#write-s16vector
                _g299103_)))))))
