(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/160/u32#u32vector-unfold
    (lambda (_f141653_ _len141655_ _seed141657_)
      (declare (not safe))
      (begin
        (if (procedure? _f141653_)
            '#!void
            (error '"Bad argument; expected procedure" _f141653_))
        (let ((_v141661_ (make-u32vector _len141655_)))
          (let _lp141664_ ((_i141667_ '0) (_state141669_ _seed141657_))
            (if (fx< _i141667_ _len141655_)
                (let ((_g299104_ (_f141653_ _i141667_ _state141669_)))
                  (begin
                    (let ((_g299105_
                           (if (##values? _g299104_)
                               (##vector-length _g299104_)
                               1)))
                      (if (not (##fx= _g299105_ 2))
                          (error "Context expects 2 values" _g299105_)))
                    (let ((_x141672_ (##vector-ref _g299104_ 0))
                          (_state141674_ (##vector-ref _g299104_ 1)))
                      (begin
                        (if (std/srfi/160/base#u32? _x141672_)
                            '#!void
                            (error '"Bad generated value" _x141672_))
                        (u32vector-set! _v141661_ _i141667_ _x141672_)
                        (_lp141664_ (fx+ _i141667_ '1) _state141674_)))))
                _v141661_))))))
  (define std/srfi/160/u32#u32vector-unfold-right
    (lambda (_f141630_ _len141632_ _seed141634_)
      (declare (not safe))
      (begin
        (if (procedure? _f141630_)
            '#!void
            (error '"Bad argument; expected procedure" _f141630_))
        (let ((_v141638_ (make-u32vector _len141632_)))
          (let _lp141641_ ((_i141644_ (fx- _len141632_ '1))
                           (_state141646_ _seed141634_))
            (if (fx>= _i141644_ '0)
                (let ((_g299106_ (_f141630_ _i141644_ _state141646_)))
                  (begin
                    (let ((_g299107_
                           (if (##values? _g299106_)
                               (##vector-length _g299106_)
                               1)))
                      (if (not (##fx= _g299107_ 2))
                          (error "Context expects 2 values" _g299107_)))
                    (let ((_x141649_ (##vector-ref _g299106_ 0))
                          (_state141651_ (##vector-ref _g299106_ 1)))
                      (begin
                        (if (std/srfi/160/base#u32? _x141649_)
                            '#!void
                            (error '"Bad generated value" _x141649_))
                        (u32vector-set! _v141638_ _i141644_ _x141649_)
                        (_lp141641_ (fx- _i141644_ '1) _state141651_)))))
                _v141638_))))))
  (define std/srfi/160/u32#u32vector-copy__%
    (lambda (_vec141602_ _start141604_ _end141606_)
      (let ((_v141609_ (make-u32vector (fx- _end141606_ _start141604_))))
        (std/srfi/160/u32#u32vector-copy!
         _v141609_
         '0
         _vec141602_
         _start141604_
         _end141606_)
        _v141609_)))
  (define std/srfi/160/u32#u32vector-copy__0
    (lambda (_vec141615_)
      (let* ((_start141617_ '0) (_end141619_ (u32vector-length _vec141615_)))
        (std/srfi/160/u32#u32vector-copy__%
         _vec141615_
         _start141617_
         _end141619_))))
  (define std/srfi/160/u32#u32vector-copy__1
    (lambda (_vec141621_ _start141622_)
      (let ((_end141624_ (u32vector-length _vec141621_)))
        (std/srfi/160/u32#u32vector-copy__%
         _vec141621_
         _start141622_
         _end141624_))))
  (define std/srfi/160/u32#u32vector-copy
    (lambda _g299109_
      (let ((_g299108_ (let () (declare (not safe)) (##length _g299109_))))
        (cond ((let () (declare (not safe)) (##fx= _g299108_ 1))
               (apply std/srfi/160/u32#u32vector-copy__0 _g299109_))
              ((let () (declare (not safe)) (##fx= _g299108_ 2))
               (apply std/srfi/160/u32#u32vector-copy__1 _g299109_))
              ((let () (declare (not safe)) (##fx= _g299108_ 3))
               (apply std/srfi/160/u32#u32vector-copy__% _g299109_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-copy
                _g299109_))))))
  (define std/srfi/160/u32#u32vector-copy!
    (lambda (_to141581_ _at141583_ _from141585_ _start141587_ _end141589_)
      (declare (not safe))
      (begin
        (if (u32vector? _to141581_) '#!void (error '"Bad argument" _to141581_))
        (if (u32vector? _from141585_)
            '#!void
            (error '"Bad argument" _from141585_))
        (if (and (fixnum? _at141583_)
                 (fx<= '0 _at141583_ (fx- (u32vector-length _at141583_) '1)))
            '#!void
            (error '"Index out of range" _to141581_ _at141583_))
        (if (and (fixnum? _start141587_)
                 (fx<= '0
                       _start141587_
                       (fx- (u32vector-length _from141585_) '1)))
            '#!void
            (error '"Index out of range" _from141585_ _start141587_))
        (if (and (fixnum? _end141589_)
                 (fx<= _start141587_
                       _end141589_
                       (u32vector-length _from141585_)))
            '#!void
            (error '"Index out of range" _from141585_ _end141589_))
        (if (fx<= (fx- _end141589_ _start141587_)
                  (fx- (u32vector-length _to141581_) _at141583_))
            '#!void
            (error '"Destination area too small"
                   _to141581_
                   _at141583_
                   _from141585_
                   _start141587_
                   _end141589_))
        (let _lp141593_ ((_i141596_ _start141587_) (_j141598_ _at141583_))
          (if (fx< _i141596_ _end141589_)
              (begin
                (u32vector-set!
                 _to141581_
                 _j141598_
                 (u32vector-ref _from141585_ _i141596_))
                (_lp141593_ (fx+ _i141596_ '1) (fx+ _j141598_ '1)))
              '#!void)))))
  (define std/srfi/160/u32#u32vector-reverse-copy__%
    (lambda (_vec141553_ _start141555_ _end141557_)
      (let ((_v141560_ (make-u32vector (fx- _end141557_ _start141555_))))
        (std/srfi/160/u32#u32vector-reverse-copy!
         _v141560_
         '0
         _vec141553_
         _start141555_
         _end141557_)
        _v141560_)))
  (define std/srfi/160/u32#u32vector-reverse-copy__0
    (lambda (_vec141566_)
      (let* ((_start141568_ '0) (_end141570_ (u32vector-length _vec141566_)))
        (std/srfi/160/u32#u32vector-reverse-copy__%
         _vec141566_
         _start141568_
         _end141570_))))
  (define std/srfi/160/u32#u32vector-reverse-copy__1
    (lambda (_vec141572_ _start141573_)
      (let ((_end141575_ (u32vector-length _vec141572_)))
        (std/srfi/160/u32#u32vector-reverse-copy__%
         _vec141572_
         _start141573_
         _end141575_))))
  (define std/srfi/160/u32#u32vector-reverse-copy
    (lambda _g299111_
      (let ((_g299110_ (let () (declare (not safe)) (##length _g299111_))))
        (cond ((let () (declare (not safe)) (##fx= _g299110_ 1))
               (apply std/srfi/160/u32#u32vector-reverse-copy__0 _g299111_))
              ((let () (declare (not safe)) (##fx= _g299110_ 2))
               (apply std/srfi/160/u32#u32vector-reverse-copy__1 _g299111_))
              ((let () (declare (not safe)) (##fx= _g299110_ 3))
               (apply std/srfi/160/u32#u32vector-reverse-copy__% _g299111_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-reverse-copy
                _g299111_))))))
  (define std/srfi/160/u32#u32vector-reverse-copy!
    (lambda (_to141532_ _at141534_ _from141536_ _start141538_ _end141540_)
      (declare (not safe))
      (begin
        (if (u32vector? _to141532_) '#!void (error '"Bad argument" _to141532_))
        (if (u32vector? _from141536_)
            '#!void
            (error '"Bad argument" _from141536_))
        (if (and (fixnum? _at141534_)
                 (fx<= '0 _at141534_ (fx- (u32vector-length _at141534_) '1)))
            '#!void
            (error '"Index out of range" _to141532_ _at141534_))
        (if (and (fixnum? _start141538_)
                 (fx<= '0
                       _start141538_
                       (fx- (u32vector-length _from141536_) '1)))
            '#!void
            (error '"Index out of range" _from141536_ _start141538_))
        (if (and (fixnum? _end141540_)
                 (fx<= _start141538_
                       _end141540_
                       (u32vector-length _from141536_)))
            '#!void
            (error '"Index out of range" _from141536_ _end141540_))
        (if (fx<= (fx- _end141540_ _start141538_)
                  (fx- (u32vector-length _to141532_) _at141534_))
            '#!void
            (error '"Destination area too small"
                   _to141532_
                   _at141534_
                   _from141536_
                   _start141538_
                   _end141540_))
        (let _lp141544_ ((_i141547_ (fx- _end141540_ '1))
                         (_j141549_ _at141534_))
          (if (fx>= _i141547_ _start141538_)
              (begin
                (u32vector-set!
                 _to141532_
                 _j141549_
                 (u32vector-ref _from141536_ _i141547_))
                (_lp141544_ (fx- _i141547_ '1) (fx+ _j141549_ '1)))
              '#!void)))))
  (define std/srfi/160/u32#u32vector-append
    (lambda _args141529_
      (std/srfi/160/u32#u32vector-concatenate _args141529_)))
  (define std/srfi/160/u32#u32vector-concatenate
    (lambda (_lst141469_)
      (let* ((_len141477_
              (foldl1 (lambda (_v141472_ _r141474_)
                        (fx+ (u32vector-length _v141472_) _r141474_))
                      '0
                      _lst141469_))
             (_v141480_ (make-u32vector _len141477_)))
        (declare (not safe))
        (let _lp141484_ ((_rest141487_ _lst141469_) (_at141489_ '0))
          (let* ((_rest141491141499_ _rest141487_)
                 (_else141493141507_ (lambda () _v141480_))
                 (_K141495141517_
                  (lambda (_rest141510_ _u141511_)
                    (let ((_ulen141514_ (u32vector-length _u141511_)))
                      (std/srfi/160/u32#u32vector-copy!
                       _v141480_
                       _at141489_
                       _u141511_
                       '0
                       _ulen141514_)
                      (_lp141484_
                       _rest141510_
                       (fx+ _at141489_ _ulen141514_))))))
            (if (##pair? _rest141491141499_)
                (let ((_hd141496141520_ (##car _rest141491141499_))
                      (_tl141497141522_ (##cdr _rest141491141499_)))
                  (let* ((_u141525_ _hd141496141520_)
                         (_rest141527_ _tl141497141522_))
                    (_K141495141517_ _rest141527_ _u141525_)))
                (_else141493141507_)))))))
  (define std/srfi/160/u32#u32vector-append-subvectors
    (lambda _args141341_
      (let* ((_len141402_
              (let _lp141344_ ((_rest141347_ _args141341_) (_r141349_ '0))
                (let* ((_rest141351141363_ _rest141347_)
                       (_else141353141371_ (lambda () _r141349_))
                       (_K141355141380_
                        (lambda (_rest141374_ _end141375_ _start141377_)
                          (_lp141344_
                           _rest141374_
                           (fx+ _r141349_ (fx- _end141375_ _start141377_))))))
                  (if (let ()
                        (declare (not safe))
                        (##pair? _rest141351141363_))
                      (let ((_tl141357141383_
                             (let ()
                               (declare (not safe))
                               (##cdr _rest141351141363_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl141357141383_))
                            (let ((_hd141358141386_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl141357141383_)))
                                  (_tl141359141388_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl141357141383_))))
                              (let ((_start141391_ _hd141358141386_))
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl141359141388_))
                                    (let ((_hd141360141393_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl141359141388_)))
                                          (_tl141361141395_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl141359141388_))))
                                      (let* ((_end141398_ _hd141360141393_)
                                             (_rest141400_ _tl141361141395_))
                                        (_K141355141380_
                                         _rest141400_
                                         _end141398_
                                         _start141391_)))
                                    (_else141353141371_))))
                            (_else141353141371_)))
                      (_else141353141371_)))))
             (_v141405_ (make-u32vector _len141402_)))
        (let _lp141409_ ((_rest141411_ _args141341_) (_at141412_ '0))
          (let* ((_rest141414141426_ _rest141411_)
                 (_else141416141434_ (lambda () _v141405_))
                 (_K141418141443_
                  (lambda (_rest141437_ _end141438_ _start141439_ _u141440_)
                    (std/srfi/160/u32#u32vector-copy!
                     _v141405_
                     _at141412_
                     _u141440_
                     _start141439_
                     _end141438_)
                    (_lp141409_
                     _rest141437_
                     (fx+ _at141412_ (fx- _end141438_ _start141439_))))))
            (if (let () (declare (not safe)) (##pair? _rest141414141426_))
                (let ((_hd141419141446_
                       (let ()
                         (declare (not safe))
                         (##car _rest141414141426_)))
                      (_tl141420141448_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest141414141426_))))
                  (let ((_u141451_ _hd141419141446_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl141420141448_))
                        (let ((_hd141421141453_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl141420141448_)))
                              (_tl141422141455_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl141420141448_))))
                          (let ((_start141458_ _hd141421141453_))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl141422141455_))
                                (let ((_hd141423141460_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl141422141455_)))
                                      (_tl141424141462_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _tl141422141455_))))
                                  (let* ((_end141465_ _hd141423141460_)
                                         (_rest141467_ _tl141424141462_))
                                    (_K141418141443_
                                     _rest141467_
                                     _end141465_
                                     _start141458_
                                     _u141451_)))
                                (_else141416141434_))))
                        (_else141416141434_))))
                (_else141416141434_)))))))
  (define std/srfi/160/u32#u32vector-empty?
    (lambda (_v141338_) (fxzero? (u32vector-length _v141338_))))
  (define std/srfi/160/u32#u32vector=
    (lambda (_v141280_ . _args141282_)
      (declare (not safe))
      (begin
        (if (u32vector? _v141280_) '#!void (error '"Bad argument" _v141280_))
        (let ((_vlen141286_ (u32vector-length _v141280_)))
          (let _lp141289_ ((_rest141292_ _args141282_))
            (let* ((_rest141294141302_ _rest141292_)
                   (_else141296141310_ (lambda () '#t))
                   (_K141298141326_
                    (lambda (_rest141313_ _u141314_)
                      (if (u32vector? _u141314_)
                          '#!void
                          (error '"Bad argument" _u141314_))
                      (let ((_ulen141317_ (u32vector-length _u141314_)))
                        (if (fx= _vlen141286_ _ulen141317_)
                            (let _cmp141320_ ((_i141323_ '0))
                              (if (fx< _i141323_ _vlen141286_)
                                  (if (= (u32vector-ref _v141280_ _i141323_)
                                         (u32vector-ref _u141314_ _i141323_))
                                      (_cmp141320_ (fx+ _i141323_ '1))
                                      '#f)
                                  (_lp141289_ _rest141313_)))
                            '#f)))))
              (if (##pair? _rest141294141302_)
                  (let ((_hd141299141329_ (##car _rest141294141302_))
                        (_tl141300141331_ (##cdr _rest141294141302_)))
                    (let* ((_u141334_ _hd141299141329_)
                           (_rest141336_ _tl141300141331_))
                      (_K141298141326_ _rest141336_ _u141334_)))
                  (_else141296141310_))))))))
  (define std/srfi/160/u32#u32vector-take
    (lambda (_v141272_ _n141274_)
      (let ((_u141277_ (make-u32vector _n141274_)))
        (std/srfi/160/u32#u32vector-copy! _u141277_ '0 _v141272_ '0 _n141274_)
        _u141277_)))
  (define std/srfi/160/u32#u32vector-take-right
    (lambda (_v141257_ _n141259_)
      (let* ((_vlen141262_ (u32vector-length _v141257_))
             (_ulen141265_ (fx- _vlen141262_ _n141259_))
             (_u141268_ (make-u32vector _ulen141265_)))
        (std/srfi/160/u32#u32vector-copy!
         _u141268_
         '0
         _v141257_
         _n141259_
         _vlen141262_)
        _u141268_)))
  (define std/srfi/160/u32#u32vector-drop
    (lambda (_v141242_ _n141244_)
      (let* ((_vlen141247_ (u32vector-length _v141242_))
             (_ulen141250_ (fx- _vlen141247_ _n141244_))
             (_u141253_ (make-u32vector _ulen141250_)))
        (std/srfi/160/u32#u32vector-copy!
         _u141253_
         '0
         _v141242_
         _n141244_
         _vlen141247_)
        _u141253_)))
  (define std/srfi/160/u32#u32vector-drop-right
    (lambda (_v141227_ _n141229_)
      (let* ((_vlen141232_ (u32vector-length _v141227_))
             (_ulen141235_ (fx- _vlen141232_ _n141229_))
             (_u141238_ (make-u32vector _ulen141235_)))
        (std/srfi/160/u32#u32vector-copy!
         _u141238_
         '0
         _v141227_
         '0
         _ulen141235_)
        _u141238_)))
  (define std/srfi/160/u32#u32vector-segment
    (lambda (_v141209_ _n141211_)
      (let _lp141214_ ((_i141217_ '0)
                       (_rest141219_ (u32vector-length _v141209_))
                       (_r141221_ '()))
        (if (fx> _r141221_ '0)
            (let ((_size141224_ (fxmin _n141211_ _rest141219_)))
              (_lp141214_
               (fx+ _i141217_ _size141224_)
               (fx- _rest141219_ _size141224_)
               (cons (std/srfi/160/u32#u32vector-copy__%
                      _v141209_
                      _i141217_
                      (fx+ _i141217_ _size141224_))
                     _r141221_)))
            (reverse _r141221_)))))
  (define std/srfi/160/u32#u32vector-fold__0
    (lambda (_kons141169_ _knil141171_ _v141173_)
      (if (procedure? _kons141169_)
          '#!void
          (error '"Bad argument; expected procedure" _kons141169_))
      (let ((_end141176_ (u32vector-length _v141173_)))
        (declare (not safe))
        (let _lp141180_ ((_i141183_ '0) (_r141185_ _knil141171_))
          (if (fx< _i141183_ _end141176_)
              (_lp141180_
               (fx+ _i141183_ '1)
               (_kons141169_ _r141185_ (u32vector-ref _v141173_ _i141183_)))
              _r141185_)))))
  (define std/srfi/160/u32#u32vector-fold__1
    (lambda (_kons141188_ _knil141189_ _v141190_ . _vs141191_)
      (if (procedure? _kons141188_)
          '#!void
          (error '"Bad argument; expected procedure" _kons141188_))
      (let* ((_vs141194_ (cons _v141190_ _vs141191_))
             (_end141196_ (apply fxmin (map u32vector-length _vs141194_))))
        (declare (not safe))
        (let _lp141200_ ((_i141202_ '0) (_r141203_ _knil141189_))
          (if (fx< _i141202_ _end141196_)
              (_lp141200_
               (fx+ _i141202_ '1)
               (apply _kons141188_
                      _r141203_
                      (map (lambda (_g141204141206_)
                             (u32vector-ref _g141204141206_ _i141202_))
                           _vs141194_)))
              _r141203_)))))
  (define std/srfi/160/u32#u32vector-fold
    (lambda _g299113_
      (let ((_g299112_ (let () (declare (not safe)) (##length _g299113_))))
        (cond ((let () (declare (not safe)) (##fx= _g299112_ 3))
               (apply std/srfi/160/u32#u32vector-fold__0 _g299113_))
              ((let () (declare (not safe)) (##fx>= _g299112_ 3))
               (apply std/srfi/160/u32#u32vector-fold__1 _g299113_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-fold
                _g299113_))))))
  (define std/srfi/160/u32#u32vector-fold-right__0
    (lambda (_kons141129_ _knil141131_ _v141133_)
      (if (procedure? _kons141129_)
          '#!void
          (error '"Bad argument; expected procedure" _kons141129_))
      (let ((_last141136_ (fx- (u32vector-length _v141133_) '1)))
        (declare (not safe))
        (let _lp141140_ ((_i141143_ _last141136_) (_r141145_ _knil141131_))
          (if (fx>= _i141143_ '0)
              (_lp141140_
               (fx- _i141143_ '1)
               (_kons141129_ _r141145_ (u32vector-ref _v141133_ _i141143_)))
              _r141145_)))))
  (define std/srfi/160/u32#u32vector-fold-right__1
    (lambda (_kons141148_ _knil141149_ _v141150_ . _vs141151_)
      (if (procedure? _kons141148_)
          '#!void
          (error '"Bad argument; expected procedure" _kons141148_))
      (let* ((_vs141154_ (cons _v141150_ _vs141151_))
             (_last141156_
              (fx- (apply min (map u32vector-length _vs141154_)) '1)))
        (declare (not safe))
        (let _lp141160_ ((_i141162_ _last141156_) (_r141163_ _knil141149_))
          (if (fx>= _i141162_ '0)
              (_lp141160_
               (fx- _i141162_ '1)
               (apply _kons141148_
                      _r141163_
                      (map (lambda (_g141164141166_)
                             (u32vector-ref _g141164141166_ _i141162_))
                           _vs141154_)))
              _r141163_)))))
  (define std/srfi/160/u32#u32vector-fold-right
    (lambda _g299115_
      (let ((_g299114_ (let () (declare (not safe)) (##length _g299115_))))
        (cond ((let () (declare (not safe)) (##fx= _g299114_ 3))
               (apply std/srfi/160/u32#u32vector-fold-right__0 _g299115_))
              ((let () (declare (not safe)) (##fx>= _g299114_ 3))
               (apply std/srfi/160/u32#u32vector-fold-right__1 _g299115_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-fold-right
                _g299115_))))))
  (define std/srfi/160/u32#u32vector-map__0
    (lambda (_f141089_ _v141091_)
      (if (procedure? _f141089_)
          '#!void
          (error '"Bad argument; expected procedure" _f141089_))
      (let* ((_len141094_ (u32vector-length _v141091_))
             (_u141097_ (make-u32vector _len141094_)))
        (declare (not safe))
        (let _lp141102_ ((_i141105_ '0))
          (if (fx< _i141105_ _len141094_)
              (begin
                (u32vector-set!
                 _u141097_
                 _i141105_
                 (u32vector-ref _v141091_ _i141105_))
                (_lp141102_ (fx+ _i141105_ '1)))
              _u141097_)))))
  (define std/srfi/160/u32#u32vector-map__1
    (lambda (_f141108_ _v141109_ . _vs141110_)
      (if (procedure? _f141108_)
          '#!void
          (error '"Bad argument; expected procedure" _f141108_))
      (let* ((_vs141113_ (cons _v141109_ _vs141110_))
             (_len141115_ (apply fxmin (map u32vector-length _vs141113_)))
             (_u141117_ (make-u32vector _len141115_)))
        (declare (not safe))
        (let _lp141121_ ((_i141123_ '0))
          (if (fx< _i141123_ _len141115_)
              (begin
                (u32vector-set!
                 _u141117_
                 _i141123_
                 (apply _f141108_
                        (map (lambda (_g141124141126_)
                               (u32vector-ref _g141124141126_ _i141123_))
                             _vs141113_)))
                (_lp141121_ (fx+ _i141123_ '1)))
              _u141117_)))))
  (define std/srfi/160/u32#u32vector-map
    (lambda _g299117_
      (let ((_g299116_ (let () (declare (not safe)) (##length _g299117_))))
        (cond ((let () (declare (not safe)) (##fx= _g299116_ 2))
               (apply std/srfi/160/u32#u32vector-map__0 _g299117_))
              ((let () (declare (not safe)) (##fx>= _g299116_ 2))
               (apply std/srfi/160/u32#u32vector-map__1 _g299117_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-map
                _g299117_))))))
  (define std/srfi/160/u32#u32vector-map!__0
    (lambda (_f141055_ _v141057_)
      (if (procedure? _f141055_)
          '#!void
          (error '"Bad argument; expected procedure" _f141055_))
      (let ((_len141060_ (u32vector-length _v141057_)))
        (declare (not safe))
        (let _lp141064_ ((_i141067_ '0))
          (if (fx< _i141067_ _len141060_)
              (begin
                (u32vector-set!
                 _v141057_
                 _i141067_
                 (_f141055_ (u32vector-ref _v141057_ _i141067_)))
                (_lp141064_ (fx+ _i141067_ '1)))
              _v141057_)))))
  (define std/srfi/160/u32#u32vector-map!__1
    (lambda (_f141070_ _v141071_ . _vs141072_)
      (if (procedure? _f141070_)
          '#!void
          (error '"Bad argument; expected procedure" _f141070_))
      (let* ((_vs141075_ (cons _v141071_ _vs141072_))
             (_len141077_ (apply fxmin (map u32vector-length _vs141075_))))
        (declare (not safe))
        (let _lp141081_ ((_i141083_ '0))
          (if (fx< _i141083_ _len141077_)
              (begin
                (u32vector-set!
                 _v141071_
                 _i141083_
                 (apply _f141070_
                        (map (lambda (_g141084141086_)
                               (u32vector-ref _g141084141086_ _i141083_))
                             _vs141075_)))
                (_lp141081_ (fx+ _i141083_ '1)))
              _v141071_)))))
  (define std/srfi/160/u32#u32vector-map!
    (lambda _g299119_
      (let ((_g299118_ (let () (declare (not safe)) (##length _g299119_))))
        (cond ((let () (declare (not safe)) (##fx= _g299118_ 2))
               (apply std/srfi/160/u32#u32vector-map!__0 _g299119_))
              ((let () (declare (not safe)) (##fx>= _g299118_ 2))
               (apply std/srfi/160/u32#u32vector-map!__1 _g299119_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-map!
                _g299119_))))))
  (define std/srfi/160/u32#u32vector-for-each__0
    (lambda (_f141021_ _v141023_)
      (if (procedure? _f141021_)
          '#!void
          (error '"Bad argument; expected procedure" _f141021_))
      (let ((_len141026_ (u32vector-length _v141023_)))
        (declare (not safe))
        (let _lp141030_ ((_i141033_ '0))
          (if (fx< _i141033_ _len141026_)
              (begin
                (_f141021_ (u32vector-ref _v141023_ _i141033_))
                (_lp141030_ (fx+ _i141033_ '1)))
              '#!void)))))
  (define std/srfi/160/u32#u32vector-for-each__1
    (lambda (_f141036_ _v141037_ . _vs141038_)
      (let* ((_vs141041_ (cons _v141037_ _vs141038_))
             (_len141043_ (apply fxmin (map u32vector-length _vs141041_))))
        (declare (not safe))
        (let _lp141047_ ((_i141049_ '0))
          (if (fx< _i141049_ _len141043_)
              (begin
                (apply _f141036_
                       (map (lambda (_g141050141052_)
                              (u32vector-ref _g141050141052_ _i141049_))
                            _vs141041_))
                (_lp141047_ (fx+ _i141049_ '1)))
              '#!void)))))
  (define std/srfi/160/u32#u32vector-for-each
    (lambda _g299121_
      (let ((_g299120_ (let () (declare (not safe)) (##length _g299121_))))
        (cond ((let () (declare (not safe)) (##fx= _g299120_ 2))
               (apply std/srfi/160/u32#u32vector-for-each__0 _g299121_))
              ((let () (declare (not safe)) (##fx>= _g299120_ 2))
               (apply std/srfi/160/u32#u32vector-for-each__1 _g299121_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-for-each
                _g299121_))))))
  (define std/srfi/160/u32#u32vector-count__0
    (lambda (_pred140984_ _v140986_)
      (if (procedure? _pred140984_)
          '#!void
          (error '"Bad argument; expected procedure" _pred140984_))
      (let ((_end140989_ (u32vector-length _v140986_)))
        (declare (not safe))
        (let _lp140993_ ((_i140996_ '0) (_r140998_ '0))
          (if (fx< _i140996_ _end140989_)
              (if (_pred140984_ (u32vector-ref _v140986_ _i140996_))
                  (_lp140993_ (fx+ _i140996_ '1) (fx+ _r140998_ '1))
                  (_lp140993_ (fx+ _i140996_ '1) _r140998_))
              _r140998_)))))
  (define std/srfi/160/u32#u32vector-count__1
    (lambda (_pred141001_ _v141002_ . _vs141003_)
      (if (procedure? _pred141001_)
          '#!void
          (error '"Bad argument; expected procedure" _pred141001_))
      (let* ((_vs141006_ (cons _v141002_ _vs141003_))
             (_end141008_ (apply fxmin (map u32vector-length _vs141006_))))
        (declare (not safe))
        (let _lp141012_ ((_i141014_ '0) (_r141015_ '0))
          (if (fx< _i141014_ _end141008_)
              (if (apply _pred141001_
                         (map (lambda (_g141016141018_)
                                (u32vector-ref _g141016141018_ _i141014_))
                              _vs141006_))
                  (_lp141012_ (fx+ _i141014_ '1) (fx+ _r141015_ '1))
                  (_lp141012_ (fx+ _i141014_ '1) _r141015_))
              _r141015_)))))
  (define std/srfi/160/u32#u32vector-count
    (lambda _g299123_
      (let ((_g299122_ (let () (declare (not safe)) (##length _g299123_))))
        (cond ((let () (declare (not safe)) (##fx= _g299122_ 2))
               (apply std/srfi/160/u32#u32vector-count__0 _g299123_))
              ((let () (declare (not safe)) (##fx>= _g299122_ 2))
               (apply std/srfi/160/u32#u32vector-count__1 _g299123_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-count
                _g299123_))))))
  (define std/srfi/160/u32#u32vector-cumulate
    (lambda (_f140959_ _knil140961_ _v140963_)
      (if (procedure? _f140959_)
          '#!void
          (error '"Bad argument; expected procedure" _f140959_))
      (let* ((_len140966_ (u32vector-length _v140963_))
             (_r140969_ (make-u32vector _len140966_)))
        (declare (not safe))
        (let _lp140974_ ((_i140977_ '0) (_r140979_ _knil140961_))
          (if (fx< _i140977_ _len140966_)
              (let ((_next140981_
                     (_f140959_
                      _r140979_
                      (u32vector-ref _v140963_ _i140977_))))
                (u32vector-set! _v140963_ _i140977_ _next140981_)
                (_lp140974_ (fx+ _i140977_ '1) _next140981_))
              _v140963_)))))
  (define std/srfi/160/u32#u32vector-take-while
    (lambda (_pred140942_ _v140944_)
      (let* ((_len140947_ (u32vector-length _v140944_))
             (_idx140950_
              (std/srfi/160/u32#u32vector-skip__0 _pred140942_ _v140944_))
             (_idx140956_
              (let ((_$e140953_ _idx140950_))
                (if _$e140953_ _$e140953_ _len140947_))))
        (std/srfi/160/u32#u32vector-copy__% _v140944_ '0 _idx140956_))))
  (define std/srfi/160/u32#u32vector-take-while-right
    (lambda (_pred140928_ _v140930_)
      (let* ((_len140933_ (u32vector-length _v140930_))
             (_idx140936_
              (std/srfi/160/u32#u32vector-skip-right__0
               _pred140928_
               _v140930_))
             (_idx140939_ (if _idx140936_ (fx+ _idx140936_ '1) '0)))
        (std/srfi/160/u32#u32vector-copy__%
         _v140930_
         _idx140939_
         _len140933_))))
  (define std/srfi/160/u32#u32vector-drop-while
    (lambda (_pred140911_ _v140913_)
      (let* ((_len140916_ (u32vector-length _v140913_))
             (_idx140919_
              (std/srfi/160/u32#u32vector-skip__0 _pred140911_ _v140913_))
             (_idx140925_
              (let ((_$e140922_ _idx140919_))
                (if _$e140922_ _$e140922_ _len140916_))))
        (std/srfi/160/u32#u32vector-copy__%
         _v140913_
         _idx140925_
         _len140916_))))
  (define std/srfi/160/u32#u32vector-drop-while-right
    (lambda (_pred140897_ _v140899_)
      (let* ((_len140902_ (u32vector-length _v140899_))
             (_idx140905_
              (std/srfi/160/u32#u32vector-skip-right__0
               _pred140897_
               _v140899_))
             (_idx140908_ (if _idx140905_ (fx+ _idx140905_ '1) '0)))
        (std/srfi/160/u32#u32vector-copy__% _v140899_ '0 _idx140908_))))
  (define std/srfi/160/u32#u32vector-index__0
    (lambda (_pred140863_ _v140865_)
      (if (procedure? _pred140863_)
          '#!void
          (error '"Bad argument; expected procedure" _pred140863_))
      (let ((_end140868_ (u32vector-length _v140865_)))
        (declare (not safe))
        (let _lp140872_ ((_i140875_ '0))
          (if (fx< _i140875_ _end140868_)
              (if (_pred140863_ (u32vector-ref _v140865_ _i140875_))
                  _i140875_
                  (_lp140872_ (fx+ _i140875_ '1)))
              '#f)))))
  (define std/srfi/160/u32#u32vector-index__1
    (lambda (_pred140878_ _v140879_ . _vs140880_)
      (if (procedure? _pred140878_)
          '#!void
          (error '"Bad argument; expected procedure" _pred140878_))
      (let* ((_vs140883_ (cons _v140879_ _vs140880_))
             (_end140885_ (apply fxmin (map u32vector-length _vs140883_))))
        (declare (not safe))
        (let _lp140889_ ((_i140891_ '0))
          (if (fx< _i140891_ _end140885_)
              (if (apply _pred140878_
                         (map (lambda (_g140892140894_)
                                (u32vector-ref _g140892140894_ _i140891_))
                              _vs140883_))
                  _i140891_
                  (_lp140889_ (fx+ _i140891_ '1)))
              '#f)))))
  (define std/srfi/160/u32#u32vector-index
    (lambda _g299125_
      (let ((_g299124_ (let () (declare (not safe)) (##length _g299125_))))
        (cond ((let () (declare (not safe)) (##fx= _g299124_ 2))
               (apply std/srfi/160/u32#u32vector-index__0 _g299125_))
              ((let () (declare (not safe)) (##fx>= _g299124_ 2))
               (apply std/srfi/160/u32#u32vector-index__1 _g299125_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-index
                _g299125_))))))
  (define std/srfi/160/u32#u32vector-index-right__0
    (lambda (_pred140829_ _v140831_)
      (if (procedure? _pred140829_)
          '#!void
          (error '"Bad argument; expected procedure" _pred140829_))
      (let ((_start140834_ (fx- (u32vector-length _v140831_) '1)))
        (declare (not safe))
        (let _lp140838_ ((_i140841_ _start140834_))
          (if (fx>= _i140841_ '0)
              (if (_pred140829_ (u32vector-ref _v140831_ _i140841_))
                  _i140841_
                  (_lp140838_ (fx- _i140841_ '1)))
              '#f)))))
  (define std/srfi/160/u32#u32vector-index-right__1
    (lambda (_pred140844_ _v140845_ . _vs140846_)
      (if (procedure? _pred140844_)
          '#!void
          (error '"Bad argument; expected procedure" _pred140844_))
      (let* ((_vs140849_ (cons _v140845_ _vs140846_))
             (_start140851_
              (fx- (apply fxmin (map u32vector-length _vs140849_)) '1)))
        (declare (not safe))
        (let _lp140855_ ((_i140857_ _start140851_))
          (if (fx>= _i140857_ '0)
              (if (apply _pred140844_
                         (map (lambda (_g140858140860_)
                                (u32vector-ref _g140858140860_ _i140857_))
                              _vs140849_))
                  _i140857_
                  (_lp140855_ (fx- _i140857_ '1)))
              '#f)))))
  (define std/srfi/160/u32#u32vector-index-right
    (lambda _g299127_
      (let ((_g299126_ (let () (declare (not safe)) (##length _g299127_))))
        (cond ((let () (declare (not safe)) (##fx= _g299126_ 2))
               (apply std/srfi/160/u32#u32vector-index-right__0 _g299127_))
              ((let () (declare (not safe)) (##fx>= _g299126_ 2))
               (apply std/srfi/160/u32#u32vector-index-right__1 _g299127_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-index-right
                _g299127_))))))
  (define std/srfi/160/u32#u32vector-skip__0
    (lambda (_pred140813_ _v140815_)
      (std/srfi/160/u32#u32vector-index__0
       (lambda (_$obj140818_) (not (_pred140813_ _$obj140818_)))
       _v140815_)))
  (define std/srfi/160/u32#u32vector-skip__1
    (lambda (_pred140821_ _v140822_ . _vs140823_)
      (apply std/srfi/160/u32#u32vector-index
             (lambda (_$obj140826_) (not (_pred140821_ _$obj140826_)))
             _v140822_
             _vs140823_)))
  (define std/srfi/160/u32#u32vector-skip
    (lambda _g299129_
      (let ((_g299128_ (let () (declare (not safe)) (##length _g299129_))))
        (cond ((let () (declare (not safe)) (##fx= _g299128_ 2))
               (apply std/srfi/160/u32#u32vector-skip__0 _g299129_))
              ((let () (declare (not safe)) (##fx>= _g299128_ 2))
               (apply std/srfi/160/u32#u32vector-skip__1 _g299129_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-skip
                _g299129_))))))
  (define std/srfi/160/u32#u32vector-skip-right__0
    (lambda (_pred140797_ _v140799_)
      (std/srfi/160/u32#u32vector-index-right__0
       (lambda (_$obj140802_) (not (_pred140797_ _$obj140802_)))
       _v140799_)))
  (define std/srfi/160/u32#u32vector-skip-right__1
    (lambda (_pred140805_ _v140806_ . _vs140807_)
      (apply std/srfi/160/u32#u32vector-index-right
             (lambda (_$obj140810_) (not (_pred140805_ _$obj140810_)))
             _v140806_
             _vs140807_)))
  (define std/srfi/160/u32#u32vector-skip-right
    (lambda _g299131_
      (let ((_g299130_ (let () (declare (not safe)) (##length _g299131_))))
        (cond ((let () (declare (not safe)) (##fx= _g299130_ 2))
               (apply std/srfi/160/u32#u32vector-skip-right__0 _g299131_))
              ((let () (declare (not safe)) (##fx>= _g299130_ 2))
               (apply std/srfi/160/u32#u32vector-skip-right__1 _g299131_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-skip-right
                _g299131_))))))
  (define std/srfi/160/u32#u32vector-any__0
    (lambda (_pred140757_ _v140759_)
      (if (procedure? _pred140757_)
          '#!void
          (error '"Bad argument; expected procedure" _pred140757_))
      (let ((_end140762_ (u32vector-length _v140759_)))
        (declare (not safe))
        (let _lp140766_ ((_i140769_ '0))
          (if (fx< _i140769_ _end140762_)
              (let ((_$e140772_
                     (_pred140757_ (u32vector-ref _v140759_ _i140769_))))
                (if _$e140772_
                    (values _$e140772_)
                    (_lp140766_ (fx+ _i140769_ '1))))
              '#f)))))
  (define std/srfi/160/u32#u32vector-any__1
    (lambda (_pred140775_ _v140776_ . _vs140777_)
      (if (procedure? _pred140775_)
          '#!void
          (error '"Bad argument; expected procedure" _pred140775_))
      (let* ((_v140780_ (cons _v140776_ _vs140777_))
             (_end140782_ (apply fxmin (map u32vector-length _vs140777_))))
        (declare (not safe))
        (let _lp140786_ ((_i140788_ '0))
          (if (fx< _i140788_ _end140782_)
              (let ((_$e140794_
                     (apply _pred140775_
                            (map (lambda (_g140789140791_)
                                   (u32vector-ref _g140789140791_ _i140788_))
                                 _vs140777_))))
                (if _$e140794_
                    (values _$e140794_)
                    (_lp140786_ (fx+ _i140788_ '1))))
              '#f)))))
  (define std/srfi/160/u32#u32vector-any
    (lambda _g299133_
      (let ((_g299132_ (let () (declare (not safe)) (##length _g299133_))))
        (cond ((let () (declare (not safe)) (##fx= _g299132_ 2))
               (apply std/srfi/160/u32#u32vector-any__0 _g299133_))
              ((let () (declare (not safe)) (##fx>= _g299132_ 2))
               (apply std/srfi/160/u32#u32vector-any__1 _g299133_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-any
                _g299133_))))))
  (define std/srfi/160/u32#u32vector-every__0
    (lambda (_pred140706_ _v140708_)
      (if (procedure? _pred140706_)
          '#!void
          (error '"Bad argument; expected procedure" _pred140706_))
      (let ((_end140711_ (u32vector-length _v140708_)))
        (declare (not safe))
        (let _lp140715_ ((_i140718_ '0) (_r140720_ '#t))
          (if (fx< _i140718_ _end140711_)
              (let ((_$e140723_
                     (_pred140706_ (u32vector-ref _v140708_ _i140718_))))
                (if _$e140723_
                    ((lambda (_g140725140727_)
                       (_lp140715_ (fx+ _i140718_ '1) _g140725140727_))
                     _$e140723_)
                    '#f))
              _r140720_)))))
  (define std/srfi/160/u32#u32vector-every__1
    (lambda (_pred140730_ _v140731_ . _vs140732_)
      (if (procedure? _pred140730_)
          '#!void
          (error '"Bad argument; expected procedure" _pred140730_))
      (let* ((_v140735_ (cons _v140731_ _vs140732_))
             (_end140737_ (apply fxmin (map u32vector-length _vs140732_))))
        (declare (not safe))
        (let _lp140741_ ((_i140743_ '0) (_r140744_ '#t))
          (if (fx< _i140743_ _end140737_)
              (let ((_$e140750_
                     (apply _pred140730_
                            (map (lambda (_g140745140747_)
                                   (u32vector-ref _g140745140747_ _i140743_))
                                 _vs140732_))))
                (if _$e140750_
                    ((lambda (_g140752140754_)
                       (_lp140741_ (fx+ _i140743_ '1) _g140752140754_))
                     _$e140750_)
                    '#f))
              _r140744_)))))
  (define std/srfi/160/u32#u32vector-every
    (lambda _g299135_
      (let ((_g299134_ (let () (declare (not safe)) (##length _g299135_))))
        (cond ((let () (declare (not safe)) (##fx= _g299134_ 2))
               (apply std/srfi/160/u32#u32vector-every__0 _g299135_))
              ((let () (declare (not safe)) (##fx>= _g299134_ 2))
               (apply std/srfi/160/u32#u32vector-every__1 _g299135_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-every
                _g299135_))))))
  (define std/srfi/160/u32#u32vector-partition
    (lambda (_pred140677_ _v140679_)
      (let* ((_count140682_
              (std/srfi/160/u32#u32vector-count__0 _pred140677_ _v140679_))
             (_len140685_ (u32vector-length _v140679_))
             (_u140688_ (make-u32vector _len140685_)))
        (declare (not safe))
        (let _lp140693_ ((_i140696_ '0)
                         (_left140698_ '0)
                         (_right140700_ _count140682_))
          (if (fx< _i140696_ _len140685_)
              (let ((_x140703_ (u32vector-ref _v140679_ _i140696_)))
                (if (_pred140677_ _x140703_)
                    (begin
                      (u32vector-set! _u140688_ _left140698_ _x140703_)
                      (_lp140693_
                       (fx+ _i140696_ '1)
                       (fx+ _left140698_ '1)
                       _right140700_))
                    (begin
                      (u32vector-set! _u140688_ _right140700_ _x140703_)
                      (_lp140693_
                       (fx+ _i140696_ '1)
                       _left140698_
                       (fx+ _right140700_ '1)))))
              _u140688_)))))
  (define std/srfi/160/u32#u32vector-filter
    (lambda (_pred140650_ _v140652_)
      (let* ((_count140655_
              (std/srfi/160/u32#u32vector-count__0 _pred140650_ _v140652_))
             (_u140658_ (make-u32vector _count140655_))
             (_end140661_ (u32vector-length _v140652_)))
        (declare (not safe))
        (let _lp140666_ ((_i140669_ '0) (_j140671_ '0))
          (if (fx< _i140669_ _end140661_)
              (let ((_x140674_ (u32vector-ref _v140652_ _i140669_)))
                (if (_pred140650_ _x140674_)
                    (begin
                      (u32vector-set! _u140658_ _j140671_ _x140674_)
                      (_lp140666_ (fx+ _i140669_ '1) (fx+ _j140671_ '1)))
                    (_lp140666_ (fx+ _i140669_ '1) _j140671_)))
              _u140658_)))))
  (define std/srfi/160/u32#u32vector-remove
    (lambda (_pred140642_ _v140644_)
      (std/srfi/160/u32#u32vector-filter
       (lambda (_$obj140647_) (not (_pred140642_ _$obj140647_)))
       _v140644_)))
  (define std/srfi/160/u32#u32vector-swap
    (lambda (_v140629_ _i140631_ _j140633_)
      (let ((_iv140636_ (u32vector-ref _v140629_ _i140631_))
            (_jv140638_ (u32vector-ref _v140629_ _j140633_)))
        (declare (not safe))
        (begin
          (u32vector-set! _v140629_ _i140631_ _jv140638_)
          (u32vector-set! _v140629_ _j140633_ _iv140636_)))))
  (define std/srfi/160/u32#u32vector-fill!__%
    (lambda (_v140592_ _fill140594_ _start140596_ _end140598_)
      (declare (not safe))
      (begin
        (if (u32vector? _v140592_) '#!void (error '"Bad argument" _v140592_))
        (if (std/srfi/160/base#u32? _fill140594_)
            '#!void
            (error '"Bad argument" _fill140594_))
        (if (and (fixnum? _start140596_)
                 (fx<= '0 _start140596_ (fx- (u32vector-length _v140592_) '1)))
            '#!void
            (error '"Index out of range" _start140596_))
        (if (and (fixnum? _end140598_)
                 (fx<= _start140596_ _end140598_ (u32vector-length _v140592_)))
            '#!void
            (error '"Index out of range" _end140598_))
        (let _lp140602_ ((_i140605_ _start140596_))
          (if (fx< _i140605_ _end140598_)
              (begin
                (u32vector-set! _v140592_ _i140605_ _fill140594_)
                (_lp140602_ (fx+ _i140605_ '1)))
              '#!void)))))
  (define std/srfi/160/u32#u32vector-fill!__0
    (lambda (_v140611_ _fill140612_)
      (let* ((_start140614_ '0) (_end140616_ (u32vector-length _v140611_)))
        (std/srfi/160/u32#u32vector-fill!__%
         _v140611_
         _fill140612_
         _start140614_
         _end140616_))))
  (define std/srfi/160/u32#u32vector-fill!__1
    (lambda (_v140618_ _fill140619_ _start140620_)
      (let ((_end140622_ (u32vector-length _v140618_)))
        (std/srfi/160/u32#u32vector-fill!__%
         _v140618_
         _fill140619_
         _start140620_
         _end140622_))))
  (define std/srfi/160/u32#u32vector-fill!
    (lambda _g299137_
      (let ((_g299136_ (let () (declare (not safe)) (##length _g299137_))))
        (cond ((let () (declare (not safe)) (##fx= _g299136_ 2))
               (apply std/srfi/160/u32#u32vector-fill!__0 _g299137_))
              ((let () (declare (not safe)) (##fx= _g299136_ 3))
               (apply std/srfi/160/u32#u32vector-fill!__1 _g299137_))
              ((let () (declare (not safe)) (##fx= _g299136_ 4))
               (apply std/srfi/160/u32#u32vector-fill!__% _g299137_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-fill!
                _g299137_))))))
  (define std/srfi/160/u32#u32vector-reverse!__%
    (lambda (_v140552_ _start140554_ _end140556_)
      (declare (not safe))
      (begin
        (if (u32vector? _v140552_) '#!void (error '"Bad argument" _v140552_))
        (if (and (fixnum? _start140554_)
                 (fx<= '0 _start140554_ (fx- (u32vector-length _v140552_) '1)))
            '#!void
            (error '"Index out of range" _start140554_))
        (if (and (fixnum? _end140556_)
                 (fx<= _start140554_ _end140556_ (u32vector-length _v140552_)))
            '#!void
            (error '"Index out of range" _end140556_))
        (let _lp140560_ ((_i140563_ _start140554_)
                         (_j140565_ (fx- _end140556_ '1)))
          (if (fx< _i140563_ _j140565_)
              (let ((_iv140568_ (u32vector-ref _v140552_ _i140563_))
                    (_jv140570_ (u32vector-ref _v140552_ _j140565_)))
                (u32vector-set! _v140552_ _i140563_ _jv140570_)
                (u32vector-set! _v140552_ _j140565_ _iv140568_)
                (_lp140560_ (fx+ _i140563_ '1) (fx- _j140565_ '1)))
              '#!void)))))
  (define std/srfi/160/u32#u32vector-reverse!__0
    (lambda (_v140576_)
      (let* ((_start140578_ '0) (_end140580_ (u32vector-length _v140576_)))
        (std/srfi/160/u32#u32vector-reverse!__%
         _v140576_
         _start140578_
         _end140580_))))
  (define std/srfi/160/u32#u32vector-reverse!__1
    (lambda (_v140582_ _start140583_)
      (let ((_end140585_ (u32vector-length _v140582_)))
        (std/srfi/160/u32#u32vector-reverse!__%
         _v140582_
         _start140583_
         _end140585_))))
  (define std/srfi/160/u32#u32vector-reverse!
    (lambda _g299139_
      (let ((_g299138_ (let () (declare (not safe)) (##length _g299139_))))
        (cond ((let () (declare (not safe)) (##fx= _g299138_ 1))
               (apply std/srfi/160/u32#u32vector-reverse!__0 _g299139_))
              ((let () (declare (not safe)) (##fx= _g299138_ 2))
               (apply std/srfi/160/u32#u32vector-reverse!__1 _g299139_))
              ((let () (declare (not safe)) (##fx= _g299138_ 3))
               (apply std/srfi/160/u32#u32vector-reverse!__% _g299139_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector-reverse!
                _g299139_))))))
  (define std/srfi/160/u32#u32vector-unfold!
    (lambda (_f140527_ _v140529_ _start140531_ _end140533_ _seed140535_)
      (declare (not safe))
      (begin
        (if (procedure? _f140527_)
            '#!void
            (error '"Bad argument; expected procedure" _f140527_))
        (if (u32vector? _v140529_) '#!void (error '"Bad argument" _v140529_))
        (if (and (fixnum? _start140531_)
                 (fx<= '0 _start140531_ (fx- (u32vector-length _v140529_) '1)))
            '#!void
            (error '"Index out of range" _start140531_))
        (if (and (fixnum? _end140533_)
                 (fx<= _start140531_ _end140533_ (u32vector-length _v140529_)))
            '#!void
            (error '"Index out of range" _end140533_))
        (let _lp140539_ ((_i140542_ _start140531_)
                         (_state140544_ _seed140535_))
          (if (fx< _i140542_ _end140533_)
              (let ((_g299140_ (_f140527_ _state140544_)))
                (begin
                  (let ((_g299141_
                         (if (##values? _g299140_)
                             (##vector-length _g299140_)
                             1)))
                    (if (not (##fx= _g299141_ 2))
                        (error "Context expects 2 values" _g299141_)))
                  (let ((_x140547_ (##vector-ref _g299140_ 0))
                        (_state140549_ (##vector-ref _g299140_ 1)))
                    (begin
                      (u32vector-set! _v140529_ _i140542_ _x140547_)
                      (_lp140539_ (fx+ _i140542_ '1) _state140549_)))))
              '#!void)))))
  (define std/srfi/160/u32#u32vector-unfold-right!
    (lambda (_f140503_ _v140505_ _start140507_ _end140509_ _seed140511_)
      (declare (not safe))
      (begin
        (if (procedure? _f140503_)
            '#!void
            (error '"Bad argument; expected procedure" _f140503_))
        (if (u32vector? _v140505_) '#!void (error '"Bad argument" _v140505_))
        (if (and (fixnum? _start140507_)
                 (fx<= '0 _start140507_ (fx- (u32vector-length _v140505_) '1)))
            '#!void
            (error '"Index out of range" _start140507_))
        (if (and (fixnum? _end140509_)
                 (fx<= _start140507_ _end140509_ (u32vector-length _v140505_)))
            '#!void
            (error '"Index out of range" _end140509_))
        (let _lp140515_ ((_i140518_ (fx- _end140509_ '1))
                         (_state140520_ _seed140511_))
          (if (fx>= _i140518_ _start140507_)
              (let ((_g299142_ (_f140503_ _state140520_)))
                (begin
                  (let ((_g299143_
                         (if (##values? _g299142_)
                             (##vector-length _g299142_)
                             1)))
                    (if (not (##fx= _g299143_ 2))
                        (error "Context expects 2 values" _g299143_)))
                  (let ((_x140523_ (##vector-ref _g299142_ 0))
                        (_state140525_ (##vector-ref _g299142_ 1)))
                    (begin
                      (u32vector-set! _v140505_ _i140518_ _x140523_)
                      (_lp140515_ (fx- _i140518_ '1) _state140525_)))))
              '#!void)))))
  (define std/srfi/160/u32#reverse-u32vector->list__%
    (lambda (_v140469_ _start140471_ _end140473_)
      (declare (not safe))
      (begin
        (if (u32vector? _v140469_) '#!void (error '"Bad argument" _v140469_))
        (if (and (fixnum? _start140471_)
                 (fx<= '0 _start140471_ (fx- (u32vector-length _v140469_) '1)))
            '#!void
            (error '"Index out of range" _start140471_))
        (if (and (fixnum? _end140473_)
                 (fx<= _start140471_ _end140473_ (u32vector-length _v140469_)))
            '#!void
            (error '"Index out of range" _end140473_))
        (let _lp140477_ ((_i140480_ _start140471_) (_r140482_ '()))
          (if (fx< _i140480_ _end140473_)
              (_lp140477_
               (fx+ _i140480_ '1)
               (cons (u32vector-ref _v140469_ _i140480_) _r140482_))
              _r140482_)))))
  (define std/srfi/160/u32#reverse-u32vector->list__0
    (lambda (_v140488_)
      (let* ((_start140490_ '0) (_end140492_ (u32vector-length _v140488_)))
        (std/srfi/160/u32#reverse-u32vector->list__%
         _v140488_
         _start140490_
         _end140492_))))
  (define std/srfi/160/u32#reverse-u32vector->list__1
    (lambda (_v140494_ _start140495_)
      (let ((_end140497_ (u32vector-length _v140494_)))
        (std/srfi/160/u32#reverse-u32vector->list__%
         _v140494_
         _start140495_
         _end140497_))))
  (define std/srfi/160/u32#reverse-u32vector->list
    (lambda _g299145_
      (let ((_g299144_ (let () (declare (not safe)) (##length _g299145_))))
        (cond ((let () (declare (not safe)) (##fx= _g299144_ 1))
               (apply std/srfi/160/u32#reverse-u32vector->list__0 _g299145_))
              ((let () (declare (not safe)) (##fx= _g299144_ 2))
               (apply std/srfi/160/u32#reverse-u32vector->list__1 _g299145_))
              ((let () (declare (not safe)) (##fx= _g299144_ 3))
               (apply std/srfi/160/u32#reverse-u32vector->list__% _g299145_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#reverse-u32vector->list
                _g299145_))))))
  (define std/srfi/160/u32#reverse-list->u32vector
    (lambda (_lst140415_)
      (let* ((_len140418_ (length _lst140415_))
             (_v140421_ (make-u32vector _len140418_)))
        (declare (not safe))
        (let _lp140426_ ((_rest140429_ _lst140415_) (_i140431_ '0))
          (let* ((_rest140433140441_ _rest140429_)
                 (_else140435140449_ (lambda () _v140421_))
                 (_K140437140456_
                  (lambda (_rest140452_ _x140453_)
                    (if (std/srfi/160/base#u32? _x140453_)
                        '#!void
                        (error '"Bad element" _x140453_))
                    (u32vector-set! _v140421_ _i140431_ _x140453_)
                    (_lp140426_ _rest140452_ (fx+ _i140431_ '1)))))
            (if (##pair? _rest140433140441_)
                (let ((_hd140438140459_ (##car _rest140433140441_))
                      (_tl140439140461_ (##cdr _rest140433140441_)))
                  (let* ((_x140464_ _hd140438140459_)
                         (_rest140466_ _tl140439140461_))
                    (_K140437140456_ _rest140466_ _x140464_)))
                (_else140435140449_)))))))
  (define std/srfi/160/u32#u32vector->vector__%
    (lambda (_v140376_ _start140378_ _end140380_)
      (declare (not safe))
      (begin
        (if (u32vector? _v140376_) '#!void (error '"Bad argument" _v140376_))
        (if (and (fixnum? _start140378_)
                 (fx<= '0 _start140378_ (fx- (u32vector-length _v140376_) '1)))
            '#!void
            (error '"Index out of range" _start140378_))
        (if (and (fixnum? _end140380_)
                 (fx<= _start140378_ _end140380_ (u32vector-length _v140376_)))
            '#!void
            (error '"Index out of range" _end140380_))
        (let* ((_len140384_ (u32vector-length _v140376_))
               (_u140387_ (make-vector _len140384_)))
          (let _lp140391_ ((_i140394_ '0))
            (if (fx< _i140394_ _len140384_)
                (begin
                  (vector-set!
                   _u140387_
                   _i140394_
                   (u32vector-ref _v140376_ _i140394_))
                  (_lp140391_ (fx+ _i140394_ '1)))
                _u140387_))))))
  (define std/srfi/160/u32#u32vector->vector__0
    (lambda (_v140400_)
      (let* ((_start140402_ '0) (_end140404_ (u32vector-length _v140400_)))
        (std/srfi/160/u32#u32vector->vector__%
         _v140400_
         _start140402_
         _end140404_))))
  (define std/srfi/160/u32#u32vector->vector__1
    (lambda (_v140406_ _start140407_)
      (let ((_end140409_ (u32vector-length _v140406_)))
        (std/srfi/160/u32#u32vector->vector__%
         _v140406_
         _start140407_
         _end140409_))))
  (define std/srfi/160/u32#u32vector->vector
    (lambda _g299147_
      (let ((_g299146_ (let () (declare (not safe)) (##length _g299147_))))
        (cond ((let () (declare (not safe)) (##fx= _g299146_ 1))
               (apply std/srfi/160/u32#u32vector->vector__0 _g299147_))
              ((let () (declare (not safe)) (##fx= _g299146_ 2))
               (apply std/srfi/160/u32#u32vector->vector__1 _g299147_))
              ((let () (declare (not safe)) (##fx= _g299146_ 3))
               (apply std/srfi/160/u32#u32vector->vector__% _g299147_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#u32vector->vector
                _g299147_))))))
  (define std/srfi/160/u32#vector->u32vector__%
    (lambda (_v140336_ _start140338_ _end140340_)
      (declare (not safe))
      (begin
        (if (vector? _v140336_)
            '#!void
            (error '"Bad argument; expected vector" _v140336_))
        (if (and (fixnum? _start140338_)
                 (fx<= '0 _start140338_ (fx- (vector-length _v140336_) '1)))
            '#!void
            (error '"Index out of range" _start140338_))
        (if (and (fixnum? _end140340_)
                 (fx<= _start140338_ _end140340_ (vector-length _v140336_)))
            '#!void
            (error '"Index out of range" _end140340_))
        (let* ((_len140344_ (vector-length _v140336_))
               (_u140347_ (make-u32vector _len140344_)))
          (let _lp140351_ ((_i140354_ '0))
            (if (fx< _i140354_ _len140344_)
                (begin
                  (u32vector-set!
                   _u140347_
                   _i140354_
                   (vector-ref _v140336_ _i140354_))
                  (_lp140351_ (fx+ _i140354_ '1)))
                _u140347_))))))
  (define std/srfi/160/u32#vector->u32vector__0
    (lambda (_v140360_)
      (let* ((_start140362_ '0) (_end140364_ (vector-length _v140360_)))
        (std/srfi/160/u32#vector->u32vector__%
         _v140360_
         _start140362_
         _end140364_))))
  (define std/srfi/160/u32#vector->u32vector__1
    (lambda (_v140366_ _start140367_)
      (let ((_end140369_ (vector-length _v140366_)))
        (std/srfi/160/u32#vector->u32vector__%
         _v140366_
         _start140367_
         _end140369_))))
  (define std/srfi/160/u32#vector->u32vector
    (lambda _g299149_
      (let ((_g299148_ (let () (declare (not safe)) (##length _g299149_))))
        (cond ((let () (declare (not safe)) (##fx= _g299148_ 1))
               (apply std/srfi/160/u32#vector->u32vector__0 _g299149_))
              ((let () (declare (not safe)) (##fx= _g299148_ 2))
               (apply std/srfi/160/u32#vector->u32vector__1 _g299149_))
              ((let () (declare (not safe)) (##fx= _g299148_ 3))
               (apply std/srfi/160/u32#vector->u32vector__% _g299149_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#vector->u32vector
                _g299149_))))))
  (define std/srfi/160/u32#make-u32vector-generator__%
    (lambda (_v140302_ _start140304_ _end140306_)
      (declare (not safe))
      (begin
        (if (u32vector? _v140302_) '#!void (error '"Bad argument" _v140302_))
        (if (and (fixnum? _start140304_)
                 (fx<= '0 _start140304_ (fx- (u32vector-length _v140302_) '1)))
            '#!void
            (error '"Index out of range" _start140304_))
        (if (and (fixnum? _end140306_)
                 (fx<= _start140304_ _end140306_ (u32vector-length _v140302_)))
            '#!void
            (error '"Index out of range" _end140306_))
        (let ((_i140310_ _start140304_))
          (lambda ()
            (if (fx< _i140310_ _end140306_)
                (let ((_next140314_ (u32vector-ref _v140302_ _i140310_)))
                  (set! _i140310_ (fx+ _i140310_ '1))
                  _next140314_)
                '#!eof))))))
  (define std/srfi/160/u32#make-u32vector-generator__0
    (lambda (_v140320_)
      (let* ((_start140322_ '0) (_end140324_ (u32vector-length _v140320_)))
        (std/srfi/160/u32#make-u32vector-generator__%
         _v140320_
         _start140322_
         _end140324_))))
  (define std/srfi/160/u32#make-u32vector-generator__1
    (lambda (_v140326_ _start140327_)
      (let ((_end140329_ (u32vector-length _v140326_)))
        (std/srfi/160/u32#make-u32vector-generator__%
         _v140326_
         _start140327_
         _end140329_))))
  (define std/srfi/160/u32#make-u32vector-generator
    (lambda _g299151_
      (let ((_g299150_ (let () (declare (not safe)) (##length _g299151_))))
        (cond ((let () (declare (not safe)) (##fx= _g299150_ 1))
               (apply std/srfi/160/u32#make-u32vector-generator__0 _g299151_))
              ((let () (declare (not safe)) (##fx= _g299150_ 2))
               (apply std/srfi/160/u32#make-u32vector-generator__1 _g299151_))
              ((let () (declare (not safe)) (##fx= _g299150_ 3))
               (apply std/srfi/160/u32#make-u32vector-generator__% _g299151_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#make-u32vector-generator
                _g299151_))))))
  (define std/srfi/160/u32#u32vector-comparator
    (let ()
      (letrec ((_<?140273_
                (lambda (_a140276_ _b140278_)
                  (let ((_len-a140281_ (u32vector-length _a140276_))
                        (_len-b140283_ (u32vector-length _b140278_)))
                    (declare (not safe))
                    (if (fx< _len-a140281_ _len-b140283_)
                        '#t
                        (if (fx> _len-a140281_ _len-b140283_)
                            '#f
                            (let ((_end140287_ _len-a140281_))
                              (let _lp140290_ ((_i140293_ '0))
                                (if (fx< _i140293_ _end140287_)
                                    (let ((_x140296_
                                           (u32vector-ref _a140276_ _i140293_))
                                          (_y140298_
                                           (u32vector-ref
                                            _b140278_
                                            _i140293_)))
                                      (if (< _x140296_ _y140298_)
                                          '#t
                                          (if (> _x140296_ _y140298_)
                                              '#f
                                              (_lp140290_
                                               (fx+ _i140293_ '1)))))
                                    '#f)))))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           u32vector?
           std/srfi/160/u32#u32vector=
           _<?140273_
           equal?-hash)))))
  (define std/srfi/160/u32#write-u32vector__%
    (lambda (_v140250_ _port140252_)
      (let ((_$e140255_ (find-method _v140250_ ':write)))
        (if _$e140255_
            ((lambda (_g140257140259_)
               (_g140257140259_ _v140250_ _port140252_))
             _$e140255_)
            (write _v140250_ (current-output-port))))))
  (define std/srfi/160/u32#write-u32vector__0
    (lambda (_v140265_)
      (let ((_port140267_ (current-output-port)))
        (std/srfi/160/u32#write-u32vector__% _v140265_ _port140267_))))
  (define std/srfi/160/u32#write-u32vector
    (lambda _g299153_
      (let ((_g299152_ (let () (declare (not safe)) (##length _g299153_))))
        (cond ((let () (declare (not safe)) (##fx= _g299152_ 1))
               (apply std/srfi/160/u32#write-u32vector__0 _g299153_))
              ((let () (declare (not safe)) (##fx= _g299152_ 2))
               (apply std/srfi/160/u32#write-u32vector__% _g299153_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/u32#write-u32vector
                _g299153_)))))))
