(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/41#stream-type
    (make-struct-type
     'std/srfi/41#stream-type
     '#f
     '1
     'stream-type
     '((fields: box))
     '#f))
  (define std/srfi/41#stream? (make-struct-predicate std/srfi/41#stream-type))
  (define std/srfi/41#stream-promise
    (make-struct-field-accessor std/srfi/41#stream-type '0))
  (define std/srfi/41#stream-promise!
    (make-struct-field-mutator std/srfi/41#stream-type '0))
  (define std/srfi/41#make-stream
    (lambda (_box65732_)
      (make-struct-instance std/srfi/41#stream-type _box65732_)))
  (define std/srfi/41#stream-eager
    (lambda (_expr65730_)
      (let ((__tmp294758 (cons 'eager _expr65730_)))
        (declare (not safe))
        (##structure std/srfi/41#stream-type __tmp294758))))
  (define std/srfi/41#stream-force
    (lambda (_promise65718_)
      (let* ((_content65720_
              (##structure-ref _promise65718_ '1 std/srfi/41#stream-type '#f))
             (_$e65722_ (car _content65720_)))
        (if (eq? 'eager _$e65722_)
            (cdr _content65720_)
            (if (eq? 'lazy _$e65722_)
                (let* ((_promise*65725_ ((cdr _content65720_)))
                       (_content65727_
                        (##structure-ref
                         _promise65718_
                         '1
                         std/srfi/41#stream-type
                         '#f)))
                  (if (not (eqv? (car _content65727_) 'eager))
                      (begin
                        (set-car!
                         _content65727_
                         (car (##structure-ref
                               _promise*65725_
                               '1
                               std/srfi/41#stream-type
                               '#f)))
                        (set-cdr!
                         _content65727_
                         (cdr (##structure-ref
                               _promise*65725_
                               '1
                               std/srfi/41#stream-type
                               '#f)))
                        (##structure-set!
                         _promise*65725_
                         _content65727_
                         '1
                         std/srfi/41#stream-type
                         '#f))
                      '#!void)
                  (std/srfi/41#stream-force _promise65718_))
                '#!void)))))
  (define std/srfi/41#stream-null
    (let ((__tmp294759
           (cons 'lazy
                 (lambda () (std/srfi/41#stream-eager (cons 'stream 'null))))))
      (declare (not safe))
      (##structure std/srfi/41#stream-type __tmp294759)))
  (define std/srfi/41#stream-pare-type
    (make-struct-type
     'std/srfi/41#stream-pare-type
     '#f
     '2
     'stream-pare-type
     '((fields: kar kdr))
     '#f))
  (define std/srfi/41#stream-pare?
    (make-struct-predicate std/srfi/41#stream-pare-type))
  (define std/srfi/41#stream-kar
    (make-struct-field-accessor std/srfi/41#stream-pare-type '0))
  (define std/srfi/41#stream-kdr
    (make-struct-field-accessor std/srfi/41#stream-pare-type '1))
  (define std/srfi/41#make-stream-pare
    (lambda (_kar65714_ _kdr65715_)
      (make-struct-instance
       std/srfi/41#stream-pare-type
       _kar65714_
       _kdr65715_)))
  (define std/srfi/41#stream-pair?
    (lambda (_obj65712_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj65712_ 'std/srfi/41#stream-type))
          (let ((__tmp294760 (std/srfi/41#stream-force _obj65712_)))
            (declare (not safe))
            (##structure-instance-of?
             __tmp294760
             'std/srfi/41#stream-pare-type))
          '#f)))
  (define std/srfi/41#stream-null?
    (lambda (_obj65710_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj65710_ 'std/srfi/41#stream-type))
          (eqv? (std/srfi/41#stream-force _obj65710_)
                (std/srfi/41#stream-force std/srfi/41#stream-null))
          '#f)))
  (define std/srfi/41#stream-car
    (lambda (_strm65708_)
      (if (not (let ()
                 (declare (not safe))
                 (##structure-instance-of?
                  _strm65708_
                  'std/srfi/41#stream-type)))
          (error 'stream-car '"non-stream")
          (if (std/srfi/41#stream-null? _strm65708_)
              (error 'stream-car '"null stream")
              (std/srfi/41#stream-force
               (##structure-ref
                (std/srfi/41#stream-force _strm65708_)
                '1
                std/srfi/41#stream-pare-type
                '#f))))))
  (define std/srfi/41#stream-cdr
    (lambda (_strm65706_)
      (if (not (let ()
                 (declare (not safe))
                 (##structure-instance-of?
                  _strm65706_
                  'std/srfi/41#stream-type)))
          (error 'stream-cdr '"non-stream")
          (if (std/srfi/41#stream-null? _strm65706_)
              (error 'stream-cdr '"null stream")
              (##structure-ref
               (std/srfi/41#stream-force _strm65706_)
               '2
               std/srfi/41#stream-pare-type
               '#f)))))
  (define std/srfi/41#exists
    (lambda (_pred?65700_ . _lists65701_)
      (if (not (null? (car _lists65701_)))
          (let ((_$e65703_ (apply _pred?65700_ (map car _lists65701_))))
            (if _$e65703_
                _$e65703_
                (apply std/srfi/41#exists
                       _pred?65700_
                       (map cdr _lists65701_))))
          '#f)))
  (define std/srfi/41#list->stream
    (lambda (_objs65690_)
      (letrec ((_list->stream65692_
                (lambda (_objs65694_)
                  (let ((__tmp294761
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (null? _objs65694_)
                                       std/srfi/41#stream-null
                                       (std/srfi/41#stream-eager
                                        (let ((__tmp294764
                                               (let ((__tmp294765
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (std/srfi/41#stream-eager
                                                               (car _objs65694_))))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294765)))
                                              (__tmp294762
                                               (let ((__tmp294763
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (_list->stream65692_
                                                               (cdr _objs65694_))))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294763))))
                                          (declare (not safe))
                                          (##structure
                                           std/srfi/41#stream-pare-type
                                           __tmp294764
                                           __tmp294762)))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294761)))))
        (if (not (list? _objs65690_))
            (error 'list->stream '"non-list argument")
            (_list->stream65692_ _objs65690_)))))
  (define std/srfi/41#port->stream
    (lambda _port65676_
      (letrec ((_port->stream65678_
                (lambda (_p65682_)
                  (let ((__tmp294766
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (let ((_c65686_ (read-char _p65682_)))
                                     (if (eof-object? _c65686_)
                                         std/srfi/41#stream-null
                                         (std/srfi/41#stream-eager
                                          (let ((__tmp294769
                                                 (let ((__tmp294770
                                                        (cons 'lazy
                                                              (lambda ()
                                                                (std/srfi/41#stream-eager
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _c65686_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (declare (not safe))
                                                   (##structure
                                                    std/srfi/41#stream-type
                                                    __tmp294770)))
                                                (__tmp294767
                                                 (let ((__tmp294768
                                                        (cons 'lazy
                                                              (lambda ()
                                                                (_port->stream65678_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _p65682_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (declare (not safe))
                                                   (##structure
                                                    std/srfi/41#stream-type
                                                    __tmp294768))))
                                            (declare (not safe))
                                            (##structure
                                             std/srfi/41#stream-pare-type
                                             __tmp294769
                                             __tmp294767))))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294766)))))
        (let ((_p65680_
               (if (null? _port65676_)
                   (current-input-port)
                   (car _port65676_))))
          (if (not (input-port? _p65680_))
              (error 'port->stream '"non-input-port argument")
              (_port->stream65678_ _p65680_))))))
  (define std/srfi/41#stream->list
    (lambda _args65663_
      (let ((_n65665_ (if (= '1 (length _args65663_)) '#f (car _args65663_)))
            (_strm65666_
             (if (= '1 (length _args65663_))
                 (car _args65663_)
                 (cadr _args65663_))))
        (if (not (let ()
                   (declare (not safe))
                   (##structure-instance-of?
                    _strm65666_
                    'std/srfi/41#stream-type)))
            (error 'stream->list '"non-stream argument")
            (if (and _n65665_ (not (integer? _n65665_)))
                (error 'stream->list '"non-integer count")
                (if (and _n65665_ (negative? _n65665_))
                    (error 'stream->list '"negative count")
                    (let _loop65668_ ((_n65670_ (if _n65665_ _n65665_ '-1))
                                      (_strm65671_ _strm65666_))
                      (if (or (zero? _n65670_)
                              (std/srfi/41#stream-null? _strm65671_))
                          '()
                          (cons (std/srfi/41#stream-car _strm65671_)
                                (_loop65668_
                                 (- _n65670_ '1)
                                 (std/srfi/41#stream-cdr _strm65671_)))))))))))
  (define std/srfi/41#stream-append
    (lambda _strms65651_
      (letrec ((_stream-append65653_
                (lambda (_strms65657_)
                  (let ((__tmp294771
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (null? (cdr _strms65657_))
                                       (car _strms65657_)
                                       (if (std/srfi/41#stream-null?
                                            (car _strms65657_))
                                           (_stream-append65653_
                                            (cdr _strms65657_))
                                           (std/srfi/41#stream-eager
                                            (let ((__tmp294774
                                                   (let ((__tmp294775
                                                          (cons 'lazy
                                                                (lambda ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (std/srfi/41#stream-eager
                           (std/srfi/41#stream-car (car _strms65657_)))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (declare (not safe))
                                                     (##structure
                                                      std/srfi/41#stream-type
                                                      __tmp294775)))
                                                  (__tmp294772
                                                   (let ((__tmp294773
                                                          (cons 'lazy
                                                                (lambda ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (_stream-append65653_
                           (cons (std/srfi/41#stream-cdr (car _strms65657_))
                                 (cdr _strms65657_)))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (declare (not safe))
                                                     (##structure
                                                      std/srfi/41#stream-type
                                                      __tmp294773))))
                                              (declare (not safe))
                                              (##structure
                                               std/srfi/41#stream-pare-type
                                               __tmp294774
                                               __tmp294772))))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294771)))))
        (if (null? _strms65651_)
            std/srfi/41#stream-null
            (if (std/srfi/41#exists
                 (lambda (_x65655_)
                   (not (let ()
                          (declare (not safe))
                          (##structure-instance-of?
                           _x65655_
                           'std/srfi/41#stream-type))))
                 _strms65651_)
                (error 'stream-append '"non-stream argument")
                (_stream-append65653_ _strms65651_))))))
  (define std/srfi/41#stream-concat
    (lambda (_strms65639_)
      (letrec ((_stream-concat65641_
                (lambda (_strms65643_)
                  (let ((__tmp294776
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (std/srfi/41#stream-null? _strms65643_)
                                       std/srfi/41#stream-null
                                       (if (not (let ((__tmp294777
                                                       (std/srfi/41#stream-car
                                                        _strms65643_)))
                                                  (declare (not safe))
                                                  (##structure-instance-of?
                                                   __tmp294777
                                                   'std/srfi/41#stream-type)))
                                           (error 'stream-concat
                                                  '"non-stream object in input stream")
                                           (if (std/srfi/41#stream-null?
                                                (std/srfi/41#stream-car
                                                 _strms65643_))
                                               (_stream-concat65641_
                                                (std/srfi/41#stream-cdr
                                                 _strms65643_))
                                               (std/srfi/41#stream-eager
                                                (let ((__tmp294784
                                                       (let ((__tmp294785
                                                              (cons 'lazy
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            (lambda ()
                              (std/srfi/41#stream-eager
                               (std/srfi/41#stream-car
                                (std/srfi/41#stream-car _strms65643_)))))))
                 (declare (not safe))
                 (##structure std/srfi/41#stream-type __tmp294785)))
              (__tmp294778
               (let ((__tmp294779
                      (cons 'lazy
                            (lambda ()
                              (_stream-concat65641_
                               (std/srfi/41#stream-eager
                                (let ((__tmp294782
                                       (let ((__tmp294783
                                              (cons 'lazy
                                                    (lambda ()
                                                      (std/srfi/41#stream-eager
                                                       (std/srfi/41#stream-cdr
                                                        (std/srfi/41#stream-car
                                                         _strms65643_)))))))
                                         (declare (not safe))
                                         (##structure
                                          std/srfi/41#stream-type
                                          __tmp294783)))
                                      (__tmp294780
                                       (let ((__tmp294781
                                              (cons 'lazy
                                                    (lambda ()
                                                      (std/srfi/41#stream-cdr
                                                       _strms65643_)))))
                                         (declare (not safe))
                                         (##structure
                                          std/srfi/41#stream-type
                                          __tmp294781))))
                                  (declare (not safe))
                                  (##structure
                                   std/srfi/41#stream-pare-type
                                   __tmp294782
                                   __tmp294780))))))))
                 (declare (not safe))
                 (##structure std/srfi/41#stream-type __tmp294779))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                  (declare (not safe))
                                                  (##structure
                                                   std/srfi/41#stream-pare-type
                                                   __tmp294784
                                                   __tmp294778)))))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294776)))))
        (if (not (let ()
                   (declare (not safe))
                   (##structure-instance-of?
                    _strms65639_
                    'std/srfi/41#stream-type)))
            (error 'stream-concat '"non-stream argument")
            (_stream-concat65641_ _strms65639_)))))
  (define std/srfi/41#stream-constant
    (lambda _objs65631_
      (let ((__tmp294786
             (cons 'lazy
                   (lambda ()
                     (let ()
                       (if (null? _objs65631_)
                           std/srfi/41#stream-null
                           (if (null? (cdr _objs65631_))
                               (std/srfi/41#stream-eager
                                (let ((__tmp294789
                                       (let ((__tmp294790
                                              (cons 'lazy
                                                    (lambda ()
                                                      (std/srfi/41#stream-eager
                                                       (car _objs65631_))))))
                                         (declare (not safe))
                                         (##structure
                                          std/srfi/41#stream-type
                                          __tmp294790)))
                                      (__tmp294787
                                       (let ((__tmp294788
                                              (cons 'lazy
                                                    (lambda ()
                                                      (std/srfi/41#stream-constant
                                                       (car _objs65631_))))))
                                         (declare (not safe))
                                         (##structure
                                          std/srfi/41#stream-type
                                          __tmp294788))))
                                  (declare (not safe))
                                  (##structure
                                   std/srfi/41#stream-pare-type
                                   __tmp294789
                                   __tmp294787)))
                               (std/srfi/41#stream-eager
                                (let ((__tmp294793
                                       (let ((__tmp294794
                                              (cons 'lazy
                                                    (lambda ()
                                                      (std/srfi/41#stream-eager
                                                       (car _objs65631_))))))
                                         (declare (not safe))
                                         (##structure
                                          std/srfi/41#stream-type
                                          __tmp294794)))
                                      (__tmp294791
                                       (let ((__tmp294792
                                              (cons 'lazy
                                                    (lambda ()
                                                      (apply std/srfi/41#stream-constant
                                                             (append (cdr _objs65631_)
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                             (list (car _objs65631_))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                         (declare (not safe))
                                         (##structure
                                          std/srfi/41#stream-type
                                          __tmp294792))))
                                  (declare (not safe))
                                  (##structure
                                   std/srfi/41#stream-pare-type
                                   __tmp294793
                                   __tmp294791))))))))))
        (declare (not safe))
        (##structure std/srfi/41#stream-type __tmp294786))))
  (define std/srfi/41#stream-drop
    (lambda (_n65618_ _strm65619_)
      (letrec ((_stream-drop65621_
                (lambda (_n65623_ _strm65624_)
                  (let ((__tmp294795
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (or (zero? _n65623_)
                                           (std/srfi/41#stream-null?
                                            _strm65624_))
                                       _strm65624_
                                       (_stream-drop65621_
                                        (- _n65623_ '1)
                                        (std/srfi/41#stream-cdr
                                         _strm65624_))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294795)))))
        (if (not (integer? _n65618_))
            (error 'stream-drop '"non-integer argument")
            (if (negative? _n65618_)
                (error 'stream-drop '"negative argument")
                (if (not (let ()
                           (declare (not safe))
                           (##structure-instance-of?
                            _strm65619_
                            'std/srfi/41#stream-type)))
                    (error 'stream-drop '"non-stream argument")
                    (_stream-drop65621_ _n65618_ _strm65619_)))))))
  (define std/srfi/41#stream-drop-while
    (lambda (_pred?65609_ _strm65610_)
      (letrec ((_stream-drop-while65612_
                (lambda (_strm65614_)
                  (let ((__tmp294796
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (and (std/srfi/41#stream-pair?
                                             _strm65614_)
                                            (_pred?65609_
                                             (std/srfi/41#stream-car
                                              _strm65614_)))
                                       (_stream-drop-while65612_
                                        (std/srfi/41#stream-cdr _strm65614_))
                                       _strm65614_))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294796)))))
        (if (not (procedure? _pred?65609_))
            (error 'stream-drop-while '"non-procedural argument")
            (if (not (let ()
                       (declare (not safe))
                       (##structure-instance-of?
                        _strm65610_
                        'std/srfi/41#stream-type)))
                (error 'stream-drop-while '"non-stream argument")
                (_stream-drop-while65612_ _strm65610_))))))
  (define std/srfi/41#stream-filter
    (lambda (_pred?65598_ _strm65599_)
      (letrec ((_stream-filter65601_
                (lambda (_strm65603_)
                  (let ((__tmp294797
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (std/srfi/41#stream-null? _strm65603_)
                                       std/srfi/41#stream-null
                                       (if (_pred?65598_
                                            (std/srfi/41#stream-car
                                             _strm65603_))
                                           (std/srfi/41#stream-eager
                                            (let ((__tmp294800
                                                   (let ((__tmp294801
                                                          (cons 'lazy
                                                                (lambda ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (std/srfi/41#stream-eager
                           (std/srfi/41#stream-car _strm65603_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (declare (not safe))
                                                     (##structure
                                                      std/srfi/41#stream-type
                                                      __tmp294801)))
                                                  (__tmp294798
                                                   (let ((__tmp294799
                                                          (cons 'lazy
                                                                (lambda ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (_stream-filter65601_
                           (std/srfi/41#stream-cdr _strm65603_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (declare (not safe))
                                                     (##structure
                                                      std/srfi/41#stream-type
                                                      __tmp294799))))
                                              (declare (not safe))
                                              (##structure
                                               std/srfi/41#stream-pare-type
                                               __tmp294800
                                               __tmp294798)))
                                           (_stream-filter65601_
                                            (std/srfi/41#stream-cdr
                                             _strm65603_)))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294797)))))
        (if (not (procedure? _pred?65598_))
            (error 'stream-filter '"non-procedural argument")
            (if (not (let ()
                       (declare (not safe))
                       (##structure-instance-of?
                        _strm65599_
                        'std/srfi/41#stream-type)))
                (error 'stream-filter '"non-stream argument")
                (_stream-filter65601_ _strm65599_))))))
  (define std/srfi/41#stream-fold
    (lambda (_proc65589_ _base65590_ _strm65591_)
      (if (not (procedure? _proc65589_))
          (error 'stream-fold '"non-procedural argument")
          (if (not (let ()
                     (declare (not safe))
                     (##structure-instance-of?
                      _strm65591_
                      'std/srfi/41#stream-type)))
              (error 'stream-fold '"non-stream argument")
              (let _loop65593_ ((_base65595_ _base65590_)
                                (_strm65596_ _strm65591_))
                (if (std/srfi/41#stream-null? _strm65596_)
                    _base65595_
                    (_loop65593_
                     (_proc65589_
                      _base65595_
                      (std/srfi/41#stream-car _strm65596_))
                     (std/srfi/41#stream-cdr _strm65596_))))))))
  (define std/srfi/41#stream-for-each
    (lambda (_proc65580_ . _strms65581_)
      (letrec ((_stream-for-each65583_
                (lambda (_strms65587_)
                  (if (not (std/srfi/41#exists
                            std/srfi/41#stream-null?
                            _strms65587_))
                      (begin
                        (apply _proc65580_
                               (map std/srfi/41#stream-car _strms65587_))
                        (_stream-for-each65583_
                         (map std/srfi/41#stream-cdr _strms65587_)))
                      '#!void))))
        (if (not (procedure? _proc65580_))
            (error 'stream-for-each '"non-procedural argument")
            (if (null? _strms65581_)
                (error 'stream-for-each '"no stream arguments")
                (if (std/srfi/41#exists
                     (lambda (_x65585_)
                       (not (let ()
                              (declare (not safe))
                              (##structure-instance-of?
                               _x65585_
                               'std/srfi/41#stream-type))))
                     _strms65581_)
                    (error 'stream-for-each '"non-stream argument")
                    (_stream-for-each65583_ _strms65581_)))))))
  (define std/srfi/41#stream-from
    (lambda (_first65566_ . _step65567_)
      (letrec ((_stream-from65569_
                (lambda (_first65573_ _delta65574_)
                  (let ((__tmp294802
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (std/srfi/41#stream-eager
                                    (let ((__tmp294805
                                           (let ((__tmp294806
                                                  (cons 'lazy
                                                        (lambda ()
                                                          (std/srfi/41#stream-eager
                                                           _first65573_)))))
                                             (declare (not safe))
                                             (##structure
                                              std/srfi/41#stream-type
                                              __tmp294806)))
                                          (__tmp294803
                                           (let ((__tmp294804
                                                  (cons 'lazy
                                                        (lambda ()
                                                          (_stream-from65569_
                                                           (+ _first65573_
                                                              _delta65574_)
                                                           _delta65574_)))))
                                             (declare (not safe))
                                             (##structure
                                              std/srfi/41#stream-type
                                              __tmp294804))))
                                      (declare (not safe))
                                      (##structure
                                       std/srfi/41#stream-pare-type
                                       __tmp294805
                                       __tmp294803))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294802)))))
        (let ((_delta65571_ (if (null? _step65567_) '1 (car _step65567_))))
          (if (not (number? _first65566_))
              (error 'stream-from '"non-numeric starting number")
              (if (not (number? _delta65571_))
                  (error 'stream-from '"non-numeric step size")
                  (_stream-from65569_ _first65566_ _delta65571_)))))))
  (define std/srfi/41#stream-iterate
    (lambda (_proc65555_ _base65556_)
      (letrec ((_stream-iterate65558_
                (lambda (_base65560_)
                  (let ((__tmp294807
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (std/srfi/41#stream-eager
                                    (let ((__tmp294810
                                           (let ((__tmp294811
                                                  (cons 'lazy
                                                        (lambda ()
                                                          (std/srfi/41#stream-eager
                                                           _base65560_)))))
                                             (declare (not safe))
                                             (##structure
                                              std/srfi/41#stream-type
                                              __tmp294811)))
                                          (__tmp294808
                                           (let ((__tmp294809
                                                  (cons 'lazy
                                                        (lambda ()
                                                          (_stream-iterate65558_
                                                           (_proc65555_
                                                            _base65560_))))))
                                             (declare (not safe))
                                             (##structure
                                              std/srfi/41#stream-type
                                              __tmp294809))))
                                      (declare (not safe))
                                      (##structure
                                       std/srfi/41#stream-pare-type
                                       __tmp294810
                                       __tmp294808))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294807)))))
        (if (not (procedure? _proc65555_))
            (error 'stream-iterate '"non-procedural argument")
            (_stream-iterate65558_ _base65556_)))))
  (define std/srfi/41#stream-length
    (lambda (_strm65548_)
      (if (not (let ()
                 (declare (not safe))
                 (##structure-instance-of?
                  _strm65548_
                  'std/srfi/41#stream-type)))
          (error 'stream-length '"non-stream argument")
          (let _loop65550_ ((_len65552_ '0) (_strm65553_ _strm65548_))
            (if (std/srfi/41#stream-null? _strm65553_)
                _len65552_
                (_loop65550_
                 (+ _len65552_ '1)
                 (std/srfi/41#stream-cdr _strm65553_)))))))
  (define std/srfi/41#stream-map
    (lambda (_proc65535_ . _strms65536_)
      (letrec ((_stream-map65538_
                (lambda (_strms65542_)
                  (let ((__tmp294812
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (std/srfi/41#exists
                                        std/srfi/41#stream-null?
                                        _strms65542_)
                                       std/srfi/41#stream-null
                                       (std/srfi/41#stream-eager
                                        (let ((__tmp294815
                                               (let ((__tmp294816
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (std/srfi/41#stream-eager
                                                               (apply _proc65535_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              (map std/srfi/41#stream-car _strms65542_)))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294816)))
                                              (__tmp294813
                                               (let ((__tmp294814
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (_stream-map65538_
                                                               (map std/srfi/41#stream-cdr
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _strms65542_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294814))))
                                          (declare (not safe))
                                          (##structure
                                           std/srfi/41#stream-pare-type
                                           __tmp294815
                                           __tmp294813)))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294812)))))
        (if (not (procedure? _proc65535_))
            (error 'stream-map '"non-procedural argument")
            (if (null? _strms65536_)
                (error 'stream-map '"no stream arguments")
                (if (std/srfi/41#exists
                     (lambda (_x65540_)
                       (not (let ()
                              (declare (not safe))
                              (##structure-instance-of?
                               _x65540_
                               'std/srfi/41#stream-type))))
                     _strms65536_)
                    (error 'stream-map '"non-stream argument")
                    (_stream-map65538_ _strms65536_)))))))
  (define std/srfi/41#stream-range
    (lambda (_first65516_ _past65517_ . _step65518_)
      (letrec ((_stream-range65520_
                (lambda (_first65526_ _past65527_ _delta65528_ _lt?65529_)
                  (let ((__tmp294817
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (_lt?65529_ _first65526_ _past65527_)
                                       (std/srfi/41#stream-eager
                                        (let ((__tmp294820
                                               (let ((__tmp294821
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (std/srfi/41#stream-eager
                                                               _first65526_)))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294821)))
                                              (__tmp294818
                                               (let ((__tmp294819
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (_stream-range65520_
                                                               (+ _first65526_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _delta65528_)
                       _past65527_
                       _delta65528_
                       _lt?65529_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294819))))
                                          (declare (not safe))
                                          (##structure
                                           std/srfi/41#stream-pare-type
                                           __tmp294820
                                           __tmp294818)))
                                       std/srfi/41#stream-null))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294817)))))
        (if (not (number? _first65516_))
            (error 'stream-range '"non-numeric starting number")
            (if (not (number? _past65517_))
                (error 'stream-range '"non-numeric ending number")
                (let ((_delta65522_
                       (if (pair? _step65518_)
                           (car _step65518_)
                           (if (< _first65516_ _past65517_) '1 '-1))))
                  (if (not (number? _delta65522_))
                      (error 'stream-range '"non-numeric step size")
                      (let ((_lt?65524_ (if (< '0 _delta65522_) < >)))
                        (_stream-range65520_
                         _first65516_
                         _past65517_
                         _delta65522_
                         _lt?65524_)))))))))
  (define std/srfi/41#stream-ref
    (lambda (_strm65508_ _n65509_)
      (if (not (let ()
                 (declare (not safe))
                 (##structure-instance-of?
                  _strm65508_
                  'std/srfi/41#stream-type)))
          (error 'stream-ref '"non-stream argument")
          (if (not (integer? _n65509_))
              (error 'stream-ref '"non-integer argument")
              (if (negative? _n65509_)
                  (error 'stream-ref '"negative argument")
                  (let _loop65511_ ((_strm65513_ _strm65508_)
                                    (_n65514_ _n65509_))
                    (if (std/srfi/41#stream-null? _strm65513_)
                        (error 'stream-ref '"beyond end of stream")
                        (if (zero? _n65514_)
                            (std/srfi/41#stream-car _strm65513_)
                            (_loop65511_
                             (std/srfi/41#stream-cdr _strm65513_)
                             (- _n65514_ '1))))))))))
  (define std/srfi/41#stream-reverse
    (lambda (_strm65497_)
      (letrec ((_stream-reverse65499_
                (lambda (_strm65501_ _rev65502_)
                  (let ((__tmp294822
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (std/srfi/41#stream-null? _strm65501_)
                                       _rev65502_
                                       (_stream-reverse65499_
                                        (std/srfi/41#stream-cdr _strm65501_)
                                        (std/srfi/41#stream-eager
                                         (let ((__tmp294825
                                                (let ((__tmp294826
                                                       (cons 'lazy
                                                             (lambda ()
                                                               (std/srfi/41#stream-eager
                                                                (std/srfi/41#stream-car
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _strm65501_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                  (declare (not safe))
                                                  (##structure
                                                   std/srfi/41#stream-type
                                                   __tmp294826)))
                                               (__tmp294823
                                                (let ((__tmp294824
                                                       (cons 'lazy
                                                             (lambda ()
                                                               _rev65502_))))
                                                  (declare (not safe))
                                                  (##structure
                                                   std/srfi/41#stream-type
                                                   __tmp294824))))
                                           (declare (not safe))
                                           (##structure
                                            std/srfi/41#stream-pare-type
                                            __tmp294825
                                            __tmp294823))))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294822)))))
        (if (not (let ()
                   (declare (not safe))
                   (##structure-instance-of?
                    _strm65497_
                    'std/srfi/41#stream-type)))
            (error 'stream-reverse '"non-stream argument")
            (_stream-reverse65499_ _strm65497_ std/srfi/41#stream-null)))))
  (define std/srfi/41#stream-scan
    (lambda (_proc65482_ _base65483_ _strm65484_)
      (letrec ((_stream-scan65486_
                (lambda (_base65488_ _strm65489_)
                  (let ((__tmp294827
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (std/srfi/41#stream-null? _strm65489_)
                                       (std/srfi/41#stream-eager
                                        (let ((__tmp294830
                                               (let ((__tmp294831
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (std/srfi/41#stream-eager
                                                               _base65488_)))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294831)))
                                              (__tmp294828
                                               (let ((__tmp294829
                                                      (cons 'lazy
                                                            (lambda ()
                                                              std/srfi/41#stream-null))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294829))))
                                          (declare (not safe))
                                          (##structure
                                           std/srfi/41#stream-pare-type
                                           __tmp294830
                                           __tmp294828)))
                                       (std/srfi/41#stream-eager
                                        (let ((__tmp294834
                                               (let ((__tmp294835
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (std/srfi/41#stream-eager
                                                               _base65488_)))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294835)))
                                              (__tmp294832
                                               (let ((__tmp294833
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (_stream-scan65486_
                                                               (_proc65482_
                                                                _base65488_
                                                                (std/srfi/41#stream-car
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _strm65489_))
                       (std/srfi/41#stream-cdr _strm65489_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294833))))
                                          (declare (not safe))
                                          (##structure
                                           std/srfi/41#stream-pare-type
                                           __tmp294834
                                           __tmp294832)))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294827)))))
        (if (not (procedure? _proc65482_))
            (error 'stream-scan '"non-procedural argument")
            (if (not (let ()
                       (declare (not safe))
                       (##structure-instance-of?
                        _strm65484_
                        'std/srfi/41#stream-type)))
                (error 'stream-scan '"non-stream argument")
                (_stream-scan65486_ _base65483_ _strm65484_))))))
  (define std/srfi/41#stream-take
    (lambda (_n65467_ _strm65468_)
      (letrec ((_stream-take65470_
                (lambda (_n65472_ _strm65473_)
                  (let ((__tmp294836
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (or (std/srfi/41#stream-null?
                                            _strm65473_)
                                           (zero? _n65472_))
                                       std/srfi/41#stream-null
                                       (std/srfi/41#stream-eager
                                        (let ((__tmp294839
                                               (let ((__tmp294840
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (std/srfi/41#stream-eager
                                                               (std/srfi/41#stream-car
                                                                _strm65473_))))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294840)))
                                              (__tmp294837
                                               (let ((__tmp294838
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (_stream-take65470_
                                                               (- _n65472_ '1)
                                                               (std/srfi/41#stream-cdr
                                                                _strm65473_))))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294838))))
                                          (declare (not safe))
                                          (##structure
                                           std/srfi/41#stream-pare-type
                                           __tmp294839
                                           __tmp294837)))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294836)))))
        (if (not (let ()
                   (declare (not safe))
                   (##structure-instance-of?
                    _strm65468_
                    'std/srfi/41#stream-type)))
            (error 'stream-take '"non-stream argument")
            (if (not (integer? _n65467_))
                (error 'stream-take '"non-integer argument")
                (if (negative? _n65467_)
                    (error 'stream-take '"negative argument")
                    (_stream-take65470_ _n65467_ _strm65468_)))))))
  (define std/srfi/41#stream-take-while
    (lambda (_pred?65456_ _strm65457_)
      (letrec ((_stream-take-while65459_
                (lambda (_strm65461_)
                  (let ((__tmp294841
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (std/srfi/41#stream-null? _strm65461_)
                                       std/srfi/41#stream-null
                                       (if (_pred?65456_
                                            (std/srfi/41#stream-car
                                             _strm65461_))
                                           (std/srfi/41#stream-eager
                                            (let ((__tmp294844
                                                   (let ((__tmp294845
                                                          (cons 'lazy
                                                                (lambda ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (std/srfi/41#stream-eager
                           (std/srfi/41#stream-car _strm65461_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (declare (not safe))
                                                     (##structure
                                                      std/srfi/41#stream-type
                                                      __tmp294845)))
                                                  (__tmp294842
                                                   (let ((__tmp294843
                                                          (cons 'lazy
                                                                (lambda ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (_stream-take-while65459_
                           (std/srfi/41#stream-cdr _strm65461_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (declare (not safe))
                                                     (##structure
                                                      std/srfi/41#stream-type
                                                      __tmp294843))))
                                              (declare (not safe))
                                              (##structure
                                               std/srfi/41#stream-pare-type
                                               __tmp294844
                                               __tmp294842)))
                                           std/srfi/41#stream-null)))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294841)))))
        (if (not (let ()
                   (declare (not safe))
                   (##structure-instance-of?
                    _strm65457_
                    'std/srfi/41#stream-type)))
            (error 'stream-take-while '"non-stream argument")
            (if (not (procedure? _pred?65456_))
                (error 'stream-take-while '"non-procedural argument")
                (_stream-take-while65459_ _strm65457_))))))
  (define std/srfi/41#stream-unfold
    (lambda (_mapper65443_ _pred?65444_ _generator65445_ _base65446_)
      (letrec ((_stream-unfold65448_
                (lambda (_base65450_)
                  (let ((__tmp294846
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (_pred?65444_ _base65450_)
                                       (std/srfi/41#stream-eager
                                        (let ((__tmp294849
                                               (let ((__tmp294850
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (std/srfi/41#stream-eager
                                                               (_mapper65443_
                                                                _base65450_))))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294850)))
                                              (__tmp294847
                                               (let ((__tmp294848
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (_stream-unfold65448_
                                                               (_generator65445_
                                                                _base65450_))))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294848))))
                                          (declare (not safe))
                                          (##structure
                                           std/srfi/41#stream-pare-type
                                           __tmp294849
                                           __tmp294847)))
                                       std/srfi/41#stream-null))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294846)))))
        (if (not (procedure? _mapper65443_))
            (error 'stream-unfold '"non-procedural mapper")
            (if (not (procedure? _pred?65444_))
                (error 'stream-unfold '"non-procedural pred?")
                (if (not (procedure? _generator65445_))
                    (error 'stream-unfold '"non-procedural generator")
                    (_stream-unfold65448_ _base65446_)))))))
  (define std/srfi/41#stream-unfolds
    (lambda (_gen65402_ _seed65403_)
      (letrec ((_len-values65405_
                (lambda (_gen65437_ _seed65438_)
                  (call-with-values
                   (lambda () (_gen65437_ _seed65438_))
                   (lambda _vs65441_ (- (length _vs65441_) '1)))))
               (_unfold-result-stream65406_
                (lambda (_gen65426_ _seed65427_)
                  (let ((__tmp294851
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (call-with-values
                                    (lambda () (_gen65426_ _seed65427_))
                                    (lambda (_next65432_ . _results65433_)
                                      (std/srfi/41#stream-eager
                                       (let ((__tmp294854
                                              (let ((__tmp294855
                                                     (cons 'lazy
                                                           (lambda ()
                                                             (std/srfi/41#stream-eager
                                                              _results65433_)))))
                                                (declare (not safe))
                                                (##structure
                                                 std/srfi/41#stream-type
                                                 __tmp294855)))
                                             (__tmp294852
                                              (let ((__tmp294853
                                                     (cons 'lazy
                                                           (lambda ()
                                                             (_unfold-result-stream65406_
                                                              _gen65426_
                                                              _next65432_)))))
                                                (declare (not safe))
                                                (##structure
                                                 std/srfi/41#stream-type
                                                 __tmp294853))))
                                         (declare (not safe))
                                         (##structure
                                          std/srfi/41#stream-pare-type
                                          __tmp294854
                                          __tmp294852))))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294851))))
               (_result-stream->output-stream65407_
                (lambda (_result-stream65417_ _i65418_)
                  (let ((__tmp294856
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (let ((_result65422_
                                          (list-ref
                                           (std/srfi/41#stream-car
                                            _result-stream65417_)
                                           (- _i65418_ '1))))
                                     (if (pair? _result65422_)
                                         (std/srfi/41#stream-eager
                                          (let ((__tmp294859
                                                 (let ((__tmp294860
                                                        (cons 'lazy
                                                              (lambda ()
                                                                (std/srfi/41#stream-eager
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (car _result65422_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (declare (not safe))
                                                   (##structure
                                                    std/srfi/41#stream-type
                                                    __tmp294860)))
                                                (__tmp294857
                                                 (let ((__tmp294858
                                                        (cons 'lazy
                                                              (lambda ()
                                                                (_result-stream->output-stream65407_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (std/srfi/41#stream-cdr _result-stream65417_)
                         _i65418_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (declare (not safe))
                                                   (##structure
                                                    std/srfi/41#stream-type
                                                    __tmp294858))))
                                            (declare (not safe))
                                            (##structure
                                             std/srfi/41#stream-pare-type
                                             __tmp294859
                                             __tmp294857)))
                                         (if (not _result65422_)
                                             (_result-stream->output-stream65407_
                                              (std/srfi/41#stream-cdr
                                               _result-stream65417_)
                                              _i65418_)
                                             (if (null? _result65422_)
                                                 std/srfi/41#stream-null
                                                 (error 'stream-unfolds
                                                        '"can't happen"))))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294856))))
               (_result-stream->output-streams65408_
                (lambda (_result-stream65410_)
                  (let _loop65412_ ((_i65414_
                                     (_len-values65405_
                                      _gen65402_
                                      _seed65403_))
                                    (_outputs65415_ '()))
                    (if (zero? _i65414_)
                        (apply values _outputs65415_)
                        (_loop65412_
                         (- _i65414_ '1)
                         (cons (_result-stream->output-stream65407_
                                _result-stream65410_
                                _i65414_)
                               _outputs65415_)))))))
        (if (not (procedure? _gen65402_))
            (error 'stream-unfolds '"non-procedural argument")
            (_result-stream->output-streams65408_
             (_unfold-result-stream65406_ _gen65402_ _seed65403_))))))
  (define std/srfi/41#stream-zip
    (lambda _strms65390_
      (letrec ((_stream-zip65392_
                (lambda (_strms65396_)
                  (let ((__tmp294861
                         (cons 'lazy
                               (lambda ()
                                 (let ()
                                   (if (std/srfi/41#exists
                                        std/srfi/41#stream-null?
                                        _strms65396_)
                                       std/srfi/41#stream-null
                                       (std/srfi/41#stream-eager
                                        (let ((__tmp294864
                                               (let ((__tmp294865
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (std/srfi/41#stream-eager
                                                               (map std/srfi/41#stream-car
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _strms65396_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294865)))
                                              (__tmp294862
                                               (let ((__tmp294863
                                                      (cons 'lazy
                                                            (lambda ()
                                                              (_stream-zip65392_
                                                               (map std/srfi/41#stream-cdr
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _strms65396_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (declare (not safe))
                                                 (##structure
                                                  std/srfi/41#stream-type
                                                  __tmp294863))))
                                          (declare (not safe))
                                          (##structure
                                           std/srfi/41#stream-pare-type
                                           __tmp294864
                                           __tmp294862)))))))))
                    (declare (not safe))
                    (##structure std/srfi/41#stream-type __tmp294861)))))
        (if (null? _strms65390_)
            (error 'stream-zip '"no stream arguments")
            (if (std/srfi/41#exists
                 (lambda (_x65394_)
                   (not (let ()
                          (declare (not safe))
                          (##structure-instance-of?
                           _x65394_
                           'std/srfi/41#stream-type))))
                 _strms65390_)
                (error 'stream-zip '"non-stream argument")
                (_stream-zip65392_ _strms65390_)))))))
