(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/text/base58#alphabet::t
    (make-struct-type
     'std/text/base58#alphabet::t
     '#f
     '2
     'alphabet
     '((final: . #t))
     ':init!
     '(enc dec)))
  (define std/text/base58#alphabet?
    (make-struct-predicate std/text/base58#alphabet::t))
  (define std/text/base58#make-alphabet
    (lambda _$args167488_
      (apply make-struct-instance std/text/base58#alphabet::t _$args167488_)))
  (define std/text/base58#alphabet-enc
    (make-struct-field-accessor std/text/base58#alphabet::t '0))
  (define std/text/base58#alphabet-dec
    (make-struct-field-accessor std/text/base58#alphabet::t '1))
  (define std/text/base58#alphabet-enc-set!
    (make-struct-field-mutator std/text/base58#alphabet::t '0))
  (define std/text/base58#alphabet-dec-set!
    (make-struct-field-mutator std/text/base58#alphabet::t '1))
  (define std/text/base58#&alphabet-enc
    (make-struct-field-unchecked-accessor std/text/base58#alphabet::t '0))
  (define std/text/base58#&alphabet-dec
    (make-struct-field-unchecked-accessor std/text/base58#alphabet::t '1))
  (define std/text/base58#&alphabet-enc-set!
    (make-struct-field-unchecked-mutator std/text/base58#alphabet::t '0))
  (define std/text/base58#&alphabet-dec-set!
    (make-struct-field-unchecked-mutator std/text/base58#alphabet::t '1))
  (define std/text/base58#alphabet:::init!
    (lambda (_self167475_ _str167476_)
      (let* ((_alpha167478_ (string->list _str167476_))
             (_enc167480_ (list->vector _alpha167478_))
             (_dec167482_ (make-vector '128 '#f)))
        (for-each
         (lambda (_i167485_ _a167486_)
           (vector-set! _dec167482_ (char->integer _a167486_) _i167485_))
         (iota (string-length _str167476_))
         _alpha167478_)
        (if (##fx< '2 (##vector-length _self167475_))
            (begin
              (##vector-set! _self167475_ '1 _enc167480_)
              (##vector-set! _self167475_ '2 _dec167482_))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self167475_)))))
  (bind-method!
   std/text/base58#alphabet::t
   ':init!
   std/text/base58#alphabet:::init!
   '#f)
  (define std/text/base58#alphabet-encode
    (lambda (_ab167349_ _i167350_)
      (vector-ref
       (##unchecked-structure-ref
        _ab167349_
        '1
        std/text/base58#alphabet::t
        '#f)
       _i167350_)))
  (define std/text/base58#alphabet-decode
    (lambda (_ab167344_ _char167345_)
      (let ((_i167347_ (char->integer _char167345_)))
        (if (fx< _i167347_ '128)
            (vector-ref
             (##unchecked-structure-ref
              _ab167344_
              '2
              std/text/base58#alphabet::t
              '#f)
             _i167347_)
            '#f))))
  (define std/text/base58#base58-btc-alphabet
    (let ((__obj290244 (make-object std/text/base58#alphabet::t '2)))
      (std/text/base58#alphabet:::init!
       __obj290244
       '"123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz")
      __obj290244))
  (define std/text/base58#base58-flickr-alphabet
    (let ((__obj290245 (make-object std/text/base58#alphabet::t '2)))
      (std/text/base58#alphabet:::init!
       __obj290245
       '"123456789abcdefghijkmnopqrstuvwxyzABCDEFGHJKLMNPQRSTUVWXYZ")
      __obj290245))
  (define std/text/base58#base58-encode__%
    (lambda (_bytes167308_ _ab167309_)
      (let* ((_idx167311_
              (fx+ (fxquotient (fx* (u8vector-length _bytes167308_) '138) '100)
                   '1))
             (_str167313_ (make-string _idx167311_)))
        (let _lp167316_ ((_bn167318_
                          (std/text/base58#bytes->integer _bytes167308_))
                         (_idx167319_ _idx167311_))
          (if (zero? _bn167318_)
              (let ((_zero167321_
                     (std/text/base58#alphabet-encode _ab167309_ '0)))
                (let _pad167323_ ((_i167325_ '0) (_idx167326_ _idx167319_))
                  (if (and (fx< _i167325_ (u8vector-length _bytes167308_))
                           (fxzero? (u8vector-ref _bytes167308_ _i167325_)))
                      (let ((_idx167328_ (fx- _idx167326_ '1)))
                        (string-set! _str167313_ _idx167328_ _zero167321_)
                        (_pad167323_ (fx+ _i167325_ '1) _idx167328_))
                      (substring
                       _str167313_
                       _idx167326_
                       (string-length _str167313_)))))
              (let ((_bn167330_ (quotient _bn167318_ '58))
                    (_mo167331_ (modulo _bn167318_ '58))
                    (_idx167332_ (fx- _idx167319_ '1)))
                (string-set!
                 _str167313_
                 _idx167332_
                 (std/text/base58#alphabet-encode _ab167309_ _mo167331_))
                (_lp167316_ _bn167330_ _idx167332_)))))))
  (define std/text/base58#base58-encode__0
    (lambda (_bytes167337_)
      (let ((_ab167339_ std/text/base58#base58-btc-alphabet))
        (std/text/base58#base58-encode__% _bytes167337_ _ab167339_))))
  (define std/text/base58#base58-encode
    (lambda _g290247_
      (let ((_g290246_ (##length _g290247_)))
        (cond ((##fx= _g290246_ 1)
               (apply std/text/base58#base58-encode__0 _g290247_))
              ((##fx= _g290246_ 2)
               (apply std/text/base58#base58-encode__% _g290247_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/base58#base58-encode
                _g290247_))))))
  (define std/text/base58#base58-decode__%
    (lambda (_str167273_ _ab167274_)
      (letrec* ((_leading-zeros167276_
                 (let ((_zero167291_
                        (std/text/base58#alphabet-encode _ab167274_ '0)))
                   (let _lp167293_ ((_i167295_ '0))
                     (if (and (fx< _i167295_ (string-length _str167273_))
                              (eq? _zero167291_
                                   (string-ref _str167273_ _i167295_)))
                         (_lp167293_ (fx+ _i167295_ '1))
                         (make-u8vector _i167295_ '0))))))
        (let _lp167278_ ((_i167280_ '0) (_bn167281_ '0))
          (if (fx< _i167280_ (string-length _str167273_))
              (let ((_char167283_ (string-ref _str167273_ _i167280_)))
                (let ((_$e167286_
                       (std/text/base58#alphabet-decode
                        _ab167274_
                        _char167283_)))
                  (if _$e167286_
                      ((lambda (_c167289_)
                         (_lp167278_
                          (fx+ _i167280_ '1)
                          (+ (* _bn167281_ '58) _c167289_)))
                       _$e167286_)
                      (std/error#raise-io-error
                       'base58-decode
                       '"Invalid character"
                       _str167273_
                       _char167283_))))
              (u8vector-append
               _leading-zeros167276_
               (std/text/base58#integer->bytes _bn167281_)))))))
  (define std/text/base58#base58-decode__0
    (lambda (_str167300_)
      (let ((_ab167302_ std/text/base58#base58-btc-alphabet))
        (std/text/base58#base58-decode__% _str167300_ _ab167302_))))
  (define std/text/base58#base58-decode
    (lambda _g290249_
      (let ((_g290248_ (##length _g290249_)))
        (cond ((##fx= _g290248_ 1)
               (apply std/text/base58#base58-decode__0 _g290249_))
              ((##fx= _g290248_ 2)
               (apply std/text/base58#base58-decode__% _g290249_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/base58#base58-decode
                _g290249_))))))
  (define std/text/base58#bytes->integer
    (lambda (_bytes167263_)
      (let _lp167265_ ((_i167267_ '0) (_r167268_ '0))
        (if (fx< _i167267_ (u8vector-length _bytes167263_))
            (let ((_b167270_ (u8vector-ref _bytes167263_ _i167267_)))
              (_lp167265_
               (fx+ _i167267_ '1)
               (bitwise-ior (arithmetic-shift _r167268_ '8) _b167270_)))
            _r167268_))))
  (define std/text/base58#integer->bytes
    (lambda (_x167256_)
      (let _lp167258_ ((_x167260_ _x167256_) (_r167261_ '()))
        (if (positive? _x167260_)
            (_lp167258_
             (arithmetic-shift _x167260_ '-8)
             (cons (bitwise-and _x167260_ '255) _r167261_))
            (list->u8vector _r167261_))))))
