(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/text/hex#hexes '"0123456789abcdef")
  (define std/text/hex#hex-encode__%
    (lambda (_bytes164604_ _start164605_ _end164606_)
      (let* ((_end164611_
              (let ((_$e164608_ _end164606_))
                (if _$e164608_ _$e164608_ (u8vector-length _bytes164604_))))
             (_len164613_ (fx- _end164611_ _start164605_))
             (_str164615_
              (make-string
               (let () (declare (not safe)) (##fx* '2 _len164613_)))))
        (let _lp164618_ ((_n164620_ '0))
          (if (let () (declare (not safe)) (##fx< _n164620_ _len164613_))
              (let* ((_ix164622_
                      (let ()
                        (declare (not safe))
                        (##fx+ _n164620_ _start164605_)))
                     (_b164624_
                      (let ()
                        (declare (not safe))
                        (##u8vector-ref _bytes164604_ _ix164622_)))
                     (_off164626_
                      (let ()
                        (declare (not safe))
                        (##fxarithmetic-shift _n164620_ '1))))
                (let ((__tmp290226
                       (let ((__tmp290227
                              (let ()
                                (declare (not safe))
                                (##fxarithmetic-shift _b164624_ '-4))))
                         (declare (not safe))
                         (##string-ref std/text/hex#hexes __tmp290227))))
                  (declare (not safe))
                  (##string-set! _str164615_ _off164626_ __tmp290226))
                (let ((__tmp290230
                       (let () (declare (not safe)) (##fx+ _off164626_ '1)))
                      (__tmp290228
                       (let ((__tmp290229
                              (let ()
                                (declare (not safe))
                                (##fxand _b164624_ '15))))
                         (declare (not safe))
                         (##string-ref std/text/hex#hexes __tmp290229))))
                  (declare (not safe))
                  (##string-set! _str164615_ __tmp290230 __tmp290228))
                (_lp164618_
                 (let () (declare (not safe)) (##fx+ _n164620_ '1))))
              _str164615_)))))
  (define std/text/hex#hex-encode__0
    (lambda (_bytes164632_)
      (let* ((_start164634_ '0) (_end164636_ '#f))
        (std/text/hex#hex-encode__% _bytes164632_ _start164634_ _end164636_))))
  (define std/text/hex#hex-encode__1
    (lambda (_bytes164638_ _start164639_)
      (let ((_end164641_ '#f))
        (std/text/hex#hex-encode__% _bytes164638_ _start164639_ _end164641_))))
  (define std/text/hex#hex-encode
    (lambda _g290232_
      (let ((_g290231_ (let () (declare (not safe)) (##length _g290232_))))
        (cond ((let () (declare (not safe)) (##fx= _g290231_ 1))
               (apply std/text/hex#hex-encode__0 _g290232_))
              ((let () (declare (not safe)) (##fx= _g290231_ 2))
               (apply std/text/hex#hex-encode__1 _g290232_))
              ((let () (declare (not safe)) (##fx= _g290231_ 3))
               (apply std/text/hex#hex-encode__% _g290232_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/hex#hex-encode
                _g290232_))))))
  (define std/text/hex#hex
    (lambda (_u4164601_)
      (let ()
        (declare (not safe))
        (##string-ref std/text/hex#hexes _u4164601_))))
  (define std/text/hex#unhexes-len (char->integer '#\g))
  (define std/text/hex#unhexes (make-u8vector std/text/hex#unhexes-len '255))
  (let _loop164595_ ((_i164597_ '0))
    (if (<= _i164597_ '15)
        (begin
          (let ((_c164599_ (std/text/hex#hex _i164597_)))
            (let ((__tmp290233 (char->integer _c164599_)))
              (declare (not safe))
              (##u8vector-set! std/text/hex#unhexes __tmp290233 _i164597_))
            (let ((__tmp290234 (char->integer (char-upcase _c164599_))))
              (declare (not safe))
              (##u8vector-set! std/text/hex#unhexes __tmp290234 _i164597_)))
          (_loop164595_ (+ _i164597_ '1)))
        '#!void))
  (define std/text/hex#unhex*
    (lambda (_char164589_)
      (letrec* ((_i164591_ (char->integer _char164589_)))
        (if (let ()
              (declare (not safe))
              (##fx< '-1 _i164591_ std/text/hex#unhexes-len))
            (let ((_d164593_
                   (let ()
                     (declare (not safe))
                     (##u8vector-ref std/text/hex#unhexes _i164591_))))
              (if (let () (declare (not safe)) (##fx< _d164593_ '16))
                  _d164593_
                  '#f))
            '#f))))
  (define std/text/hex#unhex
    (lambda (_char164584_)
      (let ((_$e164586_ (std/text/hex#unhex* _char164584_)))
        (if _$e164586_ _$e164586_ (error '"invalid hex char" _char164584_)))))
  (define std/text/hex#hex-decode-nibble
    (lambda (_string164581_ _pos164582_)
      (std/text/hex#unhex
       (let ()
         (declare (not safe))
         (##string-ref _string164581_ _pos164582_)))))
  (define std/text/hex#hex-decode-byte
    (lambda (_string164578_ _pos164579_)
      (let ((__tmp290236
             (let ((__tmp290237
                    (std/text/hex#hex-decode-nibble
                     _string164578_
                     _pos164579_)))
               (declare (not safe))
               (##fxarithmetic-shift __tmp290237 '4)))
            (__tmp290235
             (std/text/hex#hex-decode-nibble
              _string164578_
              (let () (declare (not safe)) (##fx+ _pos164579_ '1)))))
        (declare (not safe))
        (##fx+ __tmp290236 __tmp290235))))
  (define std/text/hex#hex-decode__%
    (lambda (_str164542_ _start164543_ _end164544_)
      (letrec* ((_len164546_
                 (- (let ((_$e164557_ _end164544_))
                      (if _$e164557_ _$e164557_ (string-length _str164542_)))
                    _start164543_))
                (_blen164547_
                 (let ((__tmp290238
                        (let () (declare (not safe)) (##fx+ _len164546_ '1))))
                   (declare (not safe))
                   (##fxquotient __tmp290238 '2)))
                (_bytes164548_ (make-u8vector _blen164547_))
                (_hexes-start164549_
                 (let ((__tmp290239
                        (let ()
                          (declare (not safe))
                          (##fxand _len164546_ '1))))
                   (declare (not safe))
                   (##fx- _start164543_ __tmp290239))))
        (let _lp164551_ ((_n164553_ '0))
          (if (let () (declare (not safe)) (##fx< _n164553_ _blen164547_))
              (let ((_off164555_
                     (let ((__tmp290240
                            (let ()
                              (declare (not safe))
                              (##fxarithmetic-shift _n164553_ '1))))
                       (declare (not safe))
                       (##fx+ _hexes-start164549_ __tmp290240))))
                (let ((__tmp290241
                       (if (let ()
                             (declare (not safe))
                             (##fx< _off164555_ _start164543_))
                           (std/text/hex#hex-decode-nibble
                            _str164542_
                            (let ()
                              (declare (not safe))
                              (##fx+ _off164555_ '1)))
                           (std/text/hex#hex-decode-byte
                            _str164542_
                            _off164555_))))
                  (declare (not safe))
                  (##u8vector-set! _bytes164548_ _n164553_ __tmp290241))
                (_lp164551_
                 (let () (declare (not safe)) (##fx+ _n164553_ '1))))
              '#!void))
        _bytes164548_)))
  (define std/text/hex#hex-decode__0
    (lambda (_str164563_)
      (let* ((_start164565_ '0) (_end164567_ '#f))
        (std/text/hex#hex-decode__% _str164563_ _start164565_ _end164567_))))
  (define std/text/hex#hex-decode__1
    (lambda (_str164569_ _start164570_)
      (let ((_end164572_ '#f))
        (std/text/hex#hex-decode__% _str164569_ _start164570_ _end164572_))))
  (define std/text/hex#hex-decode
    (lambda _g290243_
      (let ((_g290242_ (let () (declare (not safe)) (##length _g290243_))))
        (cond ((let () (declare (not safe)) (##fx= _g290242_ 1))
               (apply std/text/hex#hex-decode__0 _g290243_))
              ((let () (declare (not safe)) (##fx= _g290242_ 2))
               (apply std/text/hex#hex-decode__1 _g290243_))
              ((let () (declare (not safe)) (##fx= _g290242_ 3))
               (apply std/text/hex#hex-decode__% _g290243_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/hex#hex-decode
                _g290243_)))))))
