(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/text/json#read-json__%
    (lambda (_port169870_)
      (std/text/json#read-json-object__% _port169870_ '#f)))
  (define std/text/json#read-json__0
    (lambda ()
      (let ((_port169876_ (current-input-port)))
        (std/text/json#read-json__% _port169876_))))
  (define std/text/json#read-json
    (lambda _g290283_
      (let ((_g290282_ (##length _g290283_)))
        (cond ((##fx= _g290282_ 0)
               (apply std/text/json#read-json__0 _g290283_))
              ((##fx= _g290282_ 1)
               (apply std/text/json#read-json__% _g290283_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/json#read-json
                _g290283_))))))
  (define std/text/json#string->json-object
    (lambda (_str169867_)
      (std/text/json#read-json-object__% (open-input-string _str169867_) '#f)))
  (define std/text/json#write-json__%
    (lambda (_obj169854_ _port169855_)
      (std/text/json#write-json-object _obj169854_ _port169855_)))
  (define std/text/json#write-json__0
    (lambda (_obj169860_)
      (let ((_port169862_ (current-output-port)))
        (std/text/json#write-json-object _obj169860_ _port169862_))))
  (define std/text/json#write-json
    (lambda _g290285_
      (let ((_g290284_ (##length _g290285_)))
        (cond ((##fx= _g290284_ 1)
               (apply std/text/json#write-json__0 _g290285_))
              ((##fx= _g290284_ 2)
               (apply std/text/json#write-json-object _g290285_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/json#write-json
                _g290285_))))))
  (define std/text/json#json-object->string
    (lambda (_obj169849_)
      (let ((_port169851_ (open-output-string)))
        (std/text/json#write-json-object _obj169849_ _port169851_)
        (get-output-string _port169851_))))
  (define std/text/json#json-symbolic-keys (make-parameter '#t))
  (define std/text/json#json-list-wrapper (make-parameter identity))
  (define std/text/json#json-sort-keys (make-parameter '#t))
  (define std/text/json#raise-invalid-token
    (lambda (_port169846_ _char169847_)
      (if (eof-object? _char169847_)
          (std/error#raise-io-error
           'read-json
           '"Incomplete JSON object; EOF reached"
           _port169846_)
          (std/error#raise-io-error
           'read-json
           '"Invalid JSON token"
           _port169846_
           _char169847_))))
  (define std/text/json#read-json-object__%
    (lambda (_port169814_ _raise-eof?169815_)
      (std/text/json#skip-whitespace _port169814_)
      (let ((_char169817_ (peek-char _port169814_)))
        (if (eof-object? _char169817_)
            (if _raise-eof?169815_
                (std/error#raise-io-error
                 'read-json
                 '"EOF reached"
                 _port169814_)
                '#!eof)
            (let ((_$e169819_ _char169817_))
              (let ((_default169821169825_
                     (lambda ()
                       (std/text/json#raise-invalid-token
                        _port169814_
                        _char169817_)))
                    (_table169822169827_
                     '#(#f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        2
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        6
                        #f
                        #f
                        6
                        6
                        6
                        6
                        6
                        6
                        6
                        6
                        6
                        6
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        1
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        4
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        5
                        #f
                        #f
                        #f
                        #f
                        #f
                        3
                        #f
                        #f
                        #f
                        #f
                        #f
                        #f
                        0)))
                (if (char? _$e169819_)
                    (let ((_ix169830_ (##char->integer _$e169819_)))
                      (if (##fx< _ix169830_ '124)
                          (let ((_x169833_
                                 (##vector-ref
                                  _table169822169827_
                                  _ix169830_)))
                            (if _x169833_
                                (if (##fx< _x169833_ '3)
                                    (if (##fx= _x169833_ '0)
                                        (std/text/json#read-json-hash
                                         _port169814_)
                                        (if (##fx= _x169833_ '1)
                                            (std/text/json#read-json-list
                                             _port169814_)
                                            (std/text/json#read-json-string
                                             _port169814_)))
                                    (if (##fx< _x169833_ '5)
                                        (if (##fx= _x169833_ '3)
                                            (std/text/json#read-json-true
                                             _port169814_)
                                            (std/text/json#read-json-false
                                             _port169814_))
                                        (if (##fx= _x169833_ '5)
                                            (std/text/json#read-json-null
                                             _port169814_)
                                            (std/text/json#read-json-number
                                             _port169814_))))
                                (_default169821169825_)))
                          (_default169821169825_)))
                    (_default169821169825_))))))))
  (define std/text/json#read-json-object__0
    (lambda (_port169839_)
      (let ((_raise-eof?169841_ '#t))
        (std/text/json#read-json-object__% _port169839_ _raise-eof?169841_))))
  (define std/text/json#read-json-object
    (lambda _g290287_
      (let ((_g290286_ (##length _g290287_)))
        (cond ((##fx= _g290286_ 1)
               (apply std/text/json#read-json-object__0 _g290287_))
              ((##fx= _g290286_ 2)
               (apply std/text/json#read-json-object__% _g290287_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/json#read-json-object
                _g290287_))))))
  (define std/text/json#skip-whitespace
    (lambda (_port169809_)
      (let ((_char169811_ (peek-char _port169809_)))
        (if (eof-object? _char169811_)
            '#!void
            (if (char-whitespace? _char169811_)
                (begin
                  (read-char _port169809_)
                  (std/text/json#skip-whitespace _port169809_))
                '#!void)))))
  (define std/text/json#skip-chars
    (lambda (_chars169767_ _port169768_)
      (let _lp169770_ ((_rest169772_ _chars169767_))
        (let* ((_rest169773169781_ _rest169772_)
               (_else169775169789_ (lambda () '#!void))
               (_K169777169797_
                (lambda (_rest169792_ _char169793_)
                  (let ((_next169795_ (read-char _port169768_)))
                    (if (eq? _next169795_ _char169793_)
                        (_lp169770_ _rest169792_)
                        (std/text/json#raise-invalid-token
                         _port169768_
                         _next169795_))))))
          (if (##pair? _rest169773169781_)
              (let ((_hd169778169800_ (##car _rest169773169781_))
                    (_tl169779169802_ (##cdr _rest169773169781_)))
                (let* ((_char169805_ _hd169778169800_)
                       (_rest169807_ _tl169779169802_))
                  (_K169777169797_ _rest169807_ _char169805_)))
              '#!void)))))
  (define std/text/json#read-json-hash
    (lambda (_port169751_)
      (read-char _port169751_)
      (let ((_obj169753_
             (if (std/text/json#json-symbolic-keys)
                 (make-table 'test: eq?)
                 (make-table))))
        (let _lp169755_ ()
          (let ((_key169758_ (std/text/json#read-json-hash-key _port169751_)))
            (if _key169758_
                (if (hash-key? _obj169753_ _key169758_)
                    (error '"Duplicate hash key in JSON input" _key169758_)
                    (let ((_val169760_
                           (std/text/json#read-json-object__0 _port169751_)))
                      (table-set! _obj169753_ _key169758_ _val169760_)
                      (std/text/json#skip-whitespace _port169751_)
                      (let* ((_char169762_ (peek-char _port169751_))
                             (_$e169764_ _char169762_))
                        (if (eq? '#\, _$e169764_)
                            (begin (read-char _port169751_) (_lp169755_))
                            (if (eq? '#\} _$e169764_)
                                (begin (read-char _port169751_) _obj169753_)
                                (std/text/json#raise-invalid-token
                                 _port169751_
                                 _char169762_))))))
                _obj169753_))))))
  (define std/text/json#read-json-hash-key
    (lambda (_port169737_)
      (std/text/json#skip-whitespace _port169737_)
      (let* ((_char169739_ (peek-char _port169737_)) (_$e169741_ _char169739_))
        (if (eq? '#\" _$e169741_)
            (let ((_key169744_ (std/text/json#read-json-string _port169737_)))
              (std/text/json#skip-whitespace _port169737_)
              (let* ((_char169746_ (peek-char _port169737_))
                     (_$e169748_ _char169746_))
                (if (eq? '#\: _$e169748_)
                    (begin
                      (read-char _port169737_)
                      (if (std/text/json#json-symbolic-keys)
                          (string->symbol _key169744_)
                          _key169744_))
                    (std/text/json#raise-invalid-token
                     _port169737_
                     _char169746_))))
            (if (eq? '#\} _$e169741_)
                (begin (read-char _port169737_) '#f)
                (std/text/json#raise-invalid-token
                 _port169737_
                 _char169739_))))))
  (define std/text/json#read-json-list
    (lambda (_port169725_)
      (read-char _port169725_)
      (let ((_root169727_ (cons '#f '())))
        (let _lp169729_ ((_tl169731_ _root169727_))
          (let ((_next169733_
                 (std/text/json#read-json-list-next _port169725_)))
            (if (eof-object? _next169733_)
                ((std/text/json#json-list-wrapper) (cdr _root169727_))
                (let ((_tl*169735_ (cons _next169733_ '())))
                  (set-cdr! _tl169731_ _tl*169735_)
                  (_lp169729_ _tl*169735_))))))))
  (define std/text/json#read-json-list-next
    (lambda (_port169711_)
      (std/text/json#skip-whitespace _port169711_)
      (let* ((_char169713_ (peek-char _port169711_)) (_$e169715_ _char169713_))
        (if (eq? '#\] _$e169715_)
            (begin (read-char _port169711_) '#!eof)
            (let ((_obj169718_
                   (std/text/json#read-json-object__0 _port169711_)))
              (std/text/json#skip-whitespace _port169711_)
              (let* ((_char169720_ (peek-char _port169711_))
                     (_$e169722_ _char169720_))
                (if (eq? '#\, _$e169722_)
                    (begin (read-char _port169711_) _obj169718_)
                    (if (eq? '#\] _$e169722_)
                        _obj169718_
                        (std/text/json#raise-invalid-token
                         _port169711_
                         _char169720_)))))))))
  (define std/text/json#read-json-string
    (lambda (_port169610_)
      (letrec ((_read-escape-char169612_
                (lambda (_port169690_)
                  (let* ((_char169692_ (read-char _port169690_))
                         (_$e169694_ _char169692_))
                    (let ((_default169696169700_
                           (lambda ()
                             (std/text/json#raise-invalid-token
                              _port169690_
                              _char169692_)))
                          (_table169697169702_
                           '#(#f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              0
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              0
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              0
                              #f
                              #f
                              #f
                              #f
                              #f
                              1
                              #f
                              #f
                              #f
                              3
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              #f
                              2
                              #f
                              #f
                              #f
                              4
                              #f
                              5
                              6)))
                      (if (char? _$e169694_)
                          (let ((_ix169705_ (##char->integer _$e169694_)))
                            (if (##fx< _ix169705_ '118)
                                (let ((_x169708_
                                       (##vector-ref
                                        _table169697169702_
                                        _ix169705_)))
                                  (if _x169708_
                                      (if (##fx< _x169708_ '3)
                                          (if (##fx= _x169708_ '0)
                                              _char169692_
                                              (if (##fx= _x169708_ '1)
                                                  '#\backspace
                                                  '#\newline))
                                          (if (##fx< _x169708_ '5)
                                              (if (##fx= _x169708_ '3)
                                                  '#\page
                                                  '#\return)
                                              (if (##fx= _x169708_ '5)
                                                  '#\tab
                                                  (_read-escape-unicode169613_
                                                   _port169690_))))
                                      (_default169696169700_)))
                                (_default169696169700_)))
                          (_default169696169700_))))))
               (_read-escape-unicode169613_
                (lambda (_port169639_)
                  (let _lp169641_ ((_n169643_ '0) (_chars169644_ '()))
                    (if (##fx< _n169643_ '4)
                        (_lp169641_
                         (##fx+ _n169643_ '1)
                         (cons (read-char _port169639_) _chars169644_))
                        (let _lp169646_ ((_rest169648_ _chars169644_)
                                         (_val169649_ '0)
                                         (_shift169650_ '0))
                          (let* ((_rest169651169659_ _rest169648_)
                                 (_else169653169670_
                                  (lambda ()
                                    (if (and (##fx< _val169649_ ##max-char)
                                             (or (##fx< _val169649_ '55296)
                                                 (##fx< '57343 _val169649_)))
                                        (##integer->char _val169649_)
                                        '#\�)))
                                 (_K169655169678_
                                  (lambda (_rest169673_ _char169674_)
                                    (let ((_n169676_
                                           (##fxarithmetic-shift
                                            (_hex-value169614_ _char169674_)
                                            _shift169650_)))
                                      (_lp169646_
                                       _rest169673_
                                       (bitwise-ior _n169676_ _val169649_)
                                       (##fx+ _shift169650_ '4))))))
                            (if (##pair? _rest169651169659_)
                                (let ((_hd169656169681_
                                       (##car _rest169651169659_))
                                      (_tl169657169683_
                                       (##cdr _rest169651169659_)))
                                  (let* ((_char169686_ _hd169656169681_)
                                         (_rest169688_ _tl169657169683_))
                                    (_K169655169678_
                                     _rest169688_
                                     _char169686_)))
                                (_else169653169670_))))))))
               (_hex-value169614_
                (lambda (_char169634_)
                  (let ((_$e169636_ (std/text/hex#unhex* _char169634_)))
                    (if _$e169636_
                        _$e169636_
                        (std/text/json#raise-invalid-token
                         _port169610_
                         _char169634_))))))
        (read-char _port169610_)
        (let ((_root169616_ (cons '#f '())))
          (let _lp169618_ ((_tl169620_ _root169616_))
            (let* ((_char169622_ (read-char _port169610_))
                   (_$e169624_ _char169622_))
              (if (eq? '#\" _$e169624_)
                  (list->string (cdr _root169616_))
                  (if (eq? '#\\ _$e169624_)
                      (let* ((_char169627_
                              (_read-escape-char169612_ _port169610_))
                             (_tl*169629_ (cons _char169627_ '())))
                        (set-cdr! _tl169620_ _tl*169629_)
                        (_lp169618_ _tl*169629_))
                      (if (eof-object? _char169622_)
                          (std/text/json#raise-invalid-token
                           _port169610_
                           _char169622_)
                          (let ((_tl*169632_ (cons _char169622_ '())))
                            (set-cdr! _tl169620_ _tl*169632_)
                            (_lp169618_ _tl*169632_)))))))))))
  (define std/text/json#read-json-number
    (lambda (_port169583_)
      (letrec ((_parse169585_
                (lambda (_chars169603_)
                  (let* ((_str169605_ (list->string _chars169603_))
                         (_$e169607_ (string->number _str169605_)))
                    (if _$e169607_
                        _$e169607_
                        (std/text/json#raise-invalid-token
                         _port169583_
                         _str169605_))))))
        (let ((_chars169587_ (cons (read-char _port169583_) '())))
          (let _lp169589_ ((_tl169591_ _chars169587_))
            (let ((_char169593_ (peek-char _port169583_)))
              (if (or (eof-object? _char169593_)
                      (memq _char169593_ '(#\] #\} #\,))
                      (char-whitespace? _char169593_))
                  (_parse169585_ _chars169587_)
                  (let ((_tl*169601_ (cons (read-char _port169583_) '())))
                    (set-cdr! _tl169591_ _tl*169601_)
                    (_lp169589_ _tl*169601_)))))))))
  (define std/text/json#read-json-true
    (lambda (_port169581_)
      (std/text/json#skip-chars '(#\t #\r #\u #\e) _port169581_)
      '#t))
  (define std/text/json#read-json-false
    (lambda (_port169579_)
      (std/text/json#skip-chars '(#\f #\a #\l #\s #\e) _port169579_)
      '#f))
  (define std/text/json#read-json-null
    (lambda (_port169577_)
      (std/text/json#skip-chars '(#\n #\u #\l #\l) _port169577_)
      '#!void))
  (define std/text/json#write-json-object
    (lambda (_obj169567_ _port169568_)
      (if (number? _obj169567_)
          (if (exact-integer? _obj169567_)
              (gerbil/gambit/ports#write-string__%
               (number->string _obj169567_)
               _port169568_)
              (if (inexact? _obj169567_)
                  (std/text/json#write-json-inexact _obj169567_ _port169568_)
                  (if (rational? _obj169567_)
                      (std/text/json#write-json-inexact
                       (exact->inexact _obj169567_)
                       _port169568_)
                      (error '"Bad JSON object" _obj169567_))))
          (if (string? _obj169567_)
              (std/text/json#write-json-string _obj169567_ _port169568_)
              (if (symbol? _obj169567_)
                  (std/text/json#write-json-string
                   (symbol->string _obj169567_)
                   _port169568_)
                  (if (keyword? _obj169567_)
                      (std/text/json#write-json-string
                       (keyword->string _obj169567_)
                       _port169568_)
                      (if (list? _obj169567_)
                          (std/text/json#write-json-list
                           _obj169567_
                           _port169568_)
                          (if (vector? _obj169567_)
                              (std/text/json#write-json-vector
                               _obj169567_
                               _port169568_)
                              (if (table? _obj169567_)
                                  (std/text/json#write-json-hash
                                   _obj169567_
                                   _port169568_)
                                  (if (eq? '#t _obj169567_)
                                      (gerbil/gambit/ports#write-string__%
                                       '"true"
                                       _port169568_)
                                      (if (eq? '#f _obj169567_)
                                          (gerbil/gambit/ports#write-string__%
                                           '"false"
                                           _port169568_)
                                          (if (eq? _obj169567_ '#!void)
                                              (gerbil/gambit/ports#write-string__%
                                               '"null"
                                               _port169568_)
                                              (let ((_$e169570_
                                                     (method-ref
                                                      _obj169567_
                                                      ':write-json)))
                                                (if _$e169570_
                                                    ((lambda (_g169572169574_)
                                                       (_g169572169574_
                                                        _obj169567_
                                                        _port169568_))
                                                     _$e169570_)
                                                    (std/text/json#write-json-object
                                                     (let ((__method290281
                                                            (method-ref
                                                             _obj169567_
                                                             ':json)))
                                                       (if __method290281
                                                           (__method290281
                                                            _obj169567_)
                                                           (error '"Missing method"
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _obj169567_
                          ':json)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     _port169568_)))))))))))))))
  (define std/text/json#write-json-inexact
    (lambda (_obj169559_ _port169560_)
      (let* ((_mag169562_ (abs _obj169559_))
             (_str169564_ (number->string _mag169562_)))
        (if (flnegative? _obj169559_) (write-char '#\- _port169560_) '#!void)
        (if (eq? (string-ref _str169564_ '0) '#\.)
            (write-char '#\0 _port169560_)
            '#!void)
        (gerbil/gambit/ports#write-string__% _str169564_ _port169560_)
        (if (eq? (string-ref
                  _str169564_
                  (##fx- (string-length _str169564_) '1))
                 '#\.)
            (write-char '#\0 _port169560_)
            '#!void))))
  (define std/text/json#write-json-list
    (lambda (_obj169494_ _port169495_)
      (write-char '#\[ _port169495_)
      (let _lp169497_ ((_rest169499_ _obj169494_))
        (let* ((_rest169500169513_ _rest169499_)
               (_E169504169517_
                (lambda () (error '"No clause matching" _rest169500169513_))))
          (let ((_K169509169549_
                 (lambda (_val169547_)
                   (std/text/json#write-json-object _val169547_ _port169495_)
                   (write-char '#\] _port169495_)))
                (_K169506169532_
                 (lambda (_rest169529_ _val169530_)
                   (std/text/json#write-json-object _val169530_ _port169495_)
                   (write-char '#\, _port169495_)
                   (_lp169497_ _rest169529_)))
                (_K169505169522_ (lambda () (write-char '#\] _port169495_))))
            (let ((_try-match169503169525_
                   (lambda ()
                     (if (##null? _rest169500169513_)
                         (_K169505169522_)
                         (_E169504169517_)))))
              (if (##pair? _rest169500169513_)
                  (let ((_tl169511169554_ (##cdr _rest169500169513_))
                        (_hd169510169552_ (##car _rest169500169513_)))
                    (if (##null? _tl169511169554_)
                        (let ((_val169557_ _hd169510169552_))
                          (_K169509169549_ _val169557_))
                        (let ((_val169540_ _hd169510169552_)
                              (_rest169542_ _tl169511169554_))
                          (_K169506169532_ _rest169542_ _val169540_))))
                  (_try-match169503169525_))))))))
  (define std/text/json#write-json-vector
    (lambda (_obj169483_ _port169484_)
      (let ((_len169486_ (vector-length _obj169483_)))
        (if (##fxpositive? _len169486_)
            (let ((_last169488_ (##fx- _len169486_ '1)))
              (write-char '#\[ _port169484_)
              (let _lp169490_ ((_n169492_ '0))
                (if (##fx= _n169492_ _last169488_)
                    (begin
                      (std/text/json#write-json-object
                       (##vector-ref _obj169483_ _n169492_)
                       _port169484_)
                      (write-char '#\] _port169484_))
                    (begin
                      (std/text/json#write-json-object
                       (##vector-ref _obj169483_ _n169492_)
                       _port169484_)
                      (write-char '#\, _port169484_)
                      (_lp169490_ (##fx+ _n169492_ '1))))))
            (gerbil/gambit/ports#write-string__% '"[]" _port169484_)))))
  (define std/text/json#json-key-string__%
    (lambda (_key169470_ _obj169471_)
      (if (string? _key169470_)
          _key169470_
          (if (symbol? _key169470_)
              (symbol->string _key169470_)
              (if (keyword? _key169470_)
                  (keyword->string _key169470_)
                  (error '"Illegal hash key; must be symbol, keyword or string"
                         _obj169471_
                         _key169470_))))))
  (define std/text/json#json-key-string__0
    (lambda (_key169476_)
      (let ((_obj169478_ '#f))
        (std/text/json#json-key-string__% _key169476_ _obj169478_))))
  (define std/text/json#json-key-string
    (lambda _g290289_
      (let ((_g290288_ (##length _g290289_)))
        (cond ((##fx= _g290288_ 1)
               (apply std/text/json#json-key-string__0 _g290289_))
              ((##fx= _g290288_ 2)
               (apply std/text/json#json-key-string__% _g290289_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/json#json-key-string
                _g290289_))))))
  (define std/text/json#write-json-alist__%
    (lambda (_alist169398_ _port169399_ _obj169400_)
      (write-char '#\{ _port169399_)
      (let _lp169402_ ((_previous-key169404_ '#f) (_rest169405_ _alist169398_))
        (let* ((_rest169406169417_ _rest169405_)
               (_E169409169421_
                (lambda () (error '"No clause matching" _rest169406169417_))))
          (let ((_K169411169438_
                 (lambda (_rest169432_ _val169433_ _key-obj169434_)
                   (let ((_key169436_
                          (std/text/json#json-key-string__%
                           _key-obj169434_
                           _obj169400_)))
                     (if (equal? _key169436_ _previous-key169404_)
                         (error '"Duplicate key in JSON object" _key169436_)
                         '#!void)
                     (write _key169436_ _port169399_)
                     (write-char '#\: _port169399_)
                     (std/text/json#write-json-object _val169433_ _port169399_)
                     (if (null? _rest169432_)
                         '#!void
                         (write-char '#\, _port169399_))
                     (_lp169402_ _key169436_ _rest169432_))))
                (_K169410169426_ (lambda () (write-char '#\} _port169399_))))
            (let ((_try-match169408169429_
                   (lambda ()
                     (if (##null? _rest169406169417_)
                         (_K169410169426_)
                         (_E169409169421_)))))
              (if (##pair? _rest169406169417_)
                  (let ((_tl169413169443_ (##cdr _rest169406169417_))
                        (_hd169412169441_ (##car _rest169406169417_)))
                    (if (##pair? _hd169412169441_)
                        (let ((_tl169415169448_ (##cdr _hd169412169441_))
                              (_hd169414169446_ (##car _hd169412169441_)))
                          (let ((_key-obj169451_ _hd169414169446_)
                                (_val169453_ _tl169415169448_)
                                (_rest169455_ _tl169413169443_))
                            (_K169411169438_
                             _rest169455_
                             _val169453_
                             _key-obj169451_)))
                        (_E169409169421_)))
                  (_try-match169408169429_))))))))
  (define std/text/json#write-json-alist__0
    (lambda (_alist169460_ _port169461_)
      (let ((_obj169463_ _alist169460_))
        (std/text/json#write-json-alist__%
         _alist169460_
         _port169461_
         _obj169463_))))
  (define std/text/json#write-json-alist
    (lambda _g290291_
      (let ((_g290290_ (##length _g290291_)))
        (cond ((##fx= _g290290_ 2)
               (apply std/text/json#write-json-alist__0 _g290291_))
              ((##fx= _g290290_ 3)
               (apply std/text/json#write-json-alist__% _g290291_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/json#write-json-alist
                _g290291_))))))
  (define std/text/json#json-sort-alist__%
    (lambda (_alist169381_ _obj169382_)
      (std/sort#sort
       _alist169381_
       (lambda (_kv1169384_ _kv2169385_)
         (string<?
          (std/text/json#json-key-string__% (car _kv1169384_) _obj169382_)
          (std/text/json#json-key-string__% (car _kv2169385_) _obj169382_))))))
  (define std/text/json#json-sort-alist__0
    (lambda (_alist169390_)
      (let ((_obj169392_ _alist169390_))
        (std/text/json#json-sort-alist__% _alist169390_ _obj169392_))))
  (define std/text/json#json-sort-alist
    (lambda _g290293_
      (let ((_g290292_ (##length _g290293_)))
        (cond ((##fx= _g290292_ 1)
               (apply std/text/json#json-sort-alist__0 _g290293_))
              ((##fx= _g290292_ 2)
               (apply std/text/json#json-sort-alist__% _g290293_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/json#json-sort-alist
                _g290293_))))))
  (define std/text/json#write-json-alist/sort__%
    (lambda (_alist169364_ _port169365_ _obj169366_)
      (std/text/json#write-json-alist__%
       (std/text/json#json-sort-alist__% _alist169364_ _obj169366_)
       _port169365_
       _obj169366_)))
  (define std/text/json#write-json-alist/sort__0
    (lambda (_alist169371_ _port169372_)
      (let ((_obj169374_ _alist169371_))
        (std/text/json#write-json-alist/sort__%
         _alist169371_
         _port169372_
         _obj169374_))))
  (define std/text/json#write-json-alist/sort
    (lambda _g290295_
      (let ((_g290294_ (##length _g290295_)))
        (cond ((##fx= _g290294_ 2)
               (apply std/text/json#write-json-alist/sort__0 _g290295_))
              ((##fx= _g290294_ 3)
               (apply std/text/json#write-json-alist/sort__% _g290295_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/json#write-json-alist/sort
                _g290295_))))))
  (define std/text/json#write-json-hash
    (lambda (_obj169358_ _port169359_)
      (letrec* ((_lst169361_ (table->list _obj169358_)))
        (if (std/text/json#json-sort-keys)
            (std/text/json#write-json-alist/sort__%
             _lst169361_
             _port169359_
             _obj169358_)
            (std/text/json#write-json-alist__%
             _lst169361_
             _port169359_
             _obj169358_)))))
  (define std/text/json#write-json-string
    (lambda (_obj169317_ _port169318_)
      (letrec* ((_escape169320_
                 '((#\" . #\")
                   (#\\ . #\\)
                   (#\backspace . #\b)
                   (#\newline . #\n)
                   (#\page . #\f)
                   (#\return . #\r)
                   (#\tab . #\t)))
                (_printable-char?169321_
                 (lambda (_char169354_)
                   (let ((_n169356_ (char->integer _char169354_)))
                     (if (##fx< _n169356_ '32)
                         '#f
                         (if (##fx= _n169356_ '127) '#f '#t)))))
                (_write-uchar169322_
                 (lambda (_char169341_ _port169342_)
                   (let ((_int169344_ (char->integer _char169341_)))
                     (gerbil/gambit/ports#write-string__% '"\\u" _port169342_)
                     (let _lp169346_ ((_n169348_ '0)
                                      (_mask169349_ '61440)
                                      (_shift169350_ '-12))
                       (if (##fx< _n169348_ '4)
                           (let ((_char169352_
                                  (std/text/hex#hex
                                   (arithmetic-shift
                                    (bitwise-and _int169344_ _mask169349_)
                                    _shift169350_))))
                             (write-char _char169352_ _port169342_)
                             (_lp169346_
                              (##fx+ _n169348_ '1)
                              (arithmetic-shift _mask169349_ '-4)
                              (##fx+ _shift169350_ '4)))
                           '#!void)))))
                (_write-str169323_
                 (lambda (_obj169325_ _port169326_)
                   (let ((_len169328_ (string-length _obj169325_)))
                     (let _lp169330_ ((_n169332_ '0))
                       (if (##fx< _n169332_ _len169328_)
                           (let ((_char169334_
                                  (string-ref _obj169325_ _n169332_)))
                             (let ((_$e169336_
                                    (assq _char169334_ _escape169320_)))
                               (if _$e169336_
                                   ((lambda (_esc169339_)
                                      (write-char '#\\ _port169326_)
                                      (write-char
                                       (cdr _esc169339_)
                                       _port169326_))
                                    _$e169336_)
                                   (if (_printable-char?169321_ _char169334_)
                                       (write-char _char169334_ _port169326_)
                                       (_write-uchar169322_
                                        _char169334_
                                        _port169326_))))
                             (_lp169330_ (##fx+ _n169332_ '1)))
                           '#!void))))))
        (write-char '#\" _port169318_)
        (_write-str169323_ _obj169317_ _port169318_)
        (write-char '#\" _port169318_)))))
