(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/xml/libxml#parser-e
    (lambda (_source210875_
             _parse-string210876_
             _parse-u8vector210877_
             _parse-port210878_)
      (if (string? _source210875_)
          _parse-string210876_
          (if (u8vector? _source210875_)
              (lambda (_src210880_ _url210881_ _enc210882_ _opt210883_)
                (_parse-u8vector210877_
                 _src210880_
                 '0
                 (u8vector-length _src210880_)
                 _url210881_
                 _enc210882_
                 _opt210883_))
              (if (input-port? _source210875_)
                  _parse-port210878_
                  (error '"Illegal source; Expected string, u8vector, or input-port"
                         _source210875_))))))
  (define std/xml/libxml#parse-xml__%
    (lambda (_g290403_
             _url210830210836_
             _encoding210831210838_
             _options210832210840_
             _ns210833210842_
             _source210844_)
      (let* ((_url210846_
              (if (eq? _url210830210836_ absent-value)
                  '"none.xml"
                  _url210830210836_))
             (_encoding210848_
              (if (eq? _encoding210831210838_ absent-value)
                  '"UTF-8"
                  _encoding210831210838_))
             (_options210850_
              (if (eq? _options210832210840_ absent-value)
                  std/xml/libxml#parse-xml-default-options
                  _options210832210840_))
             (_ns210852_
              (if (eq? _ns210833210842_ absent-value) '() _ns210833210842_))
             (_parse210854_
              (std/xml/libxml#parser-e
               _source210844_
               std/xml/libxml#xmlRead-string
               std/xml/libxml#xmlRead-u8vector
               std/xml/libxml#xmlRead-port))
             (_xtree210856_
              (_parse210854_
               _source210844_
               _url210846_
               _encoding210848_
               _options210850_)))
        (if _xtree210856_
            (with-unwind-protect
             (lambda ()
               (std/xml/libxml#xml-doc->sxml _xtree210856_ _ns210852_))
             (lambda () (std/xml/libxml#xmlFreeDoc _xtree210856_)))
            (error '"Error parsing xml; no parse tree" _source210844_)))))
  (define std/xml/libxml#parse-xml__@
    (lambda (_keys210829210864_ . _args210866_)
      (apply std/xml/libxml#parse-xml__%
             _keys210829210864_
             (table-ref _keys210829210864_ 'url: absent-value)
             (table-ref _keys210829210864_ 'encoding: absent-value)
             (table-ref _keys210829210864_ 'options: absent-value)
             (table-ref _keys210829210864_ 'namespaces: absent-value)
             _args210866_)))
  (define std/xml/libxml#parse-xml
    (lambda _args210834210872_
      (apply keyword-dispatch
             '#(url: options: #f #f encoding: namespaces:)
             std/xml/libxml#parse-xml__@
             _args210834210872_)))
  (define std/xml/libxml#parse-html__%
    (lambda (_g290404_
             _url210783210789_
             _encoding210784210791_
             _options210785210793_
             _filter-els210786210795_
             _source210797_)
      (let* ((_url210799_
              (if (eq? _url210783210789_ absent-value)
                  '"none.html"
                  _url210783210789_))
             (_encoding210801_
              (if (eq? _encoding210784210791_ absent-value)
                  '"UTF-8"
                  _encoding210784210791_))
             (_options210803_
              (if (eq? _options210785210793_ absent-value)
                  std/xml/libxml#parse-html-default-options
                  _options210785210793_))
             (_filter-els210805_
              (if (eq? _filter-els210786210795_ absent-value)
                  '()
                  _filter-els210786210795_))
             (_parse210807_
              (std/xml/libxml#parser-e
               _source210797_
               std/xml/libxml#htmlRead-string
               std/xml/libxml#htmlRead-u8vector
               std/xml/libxml#htmlRead-port))
             (_xtree210809_
              (_parse210807_
               _source210797_
               _url210799_
               _encoding210801_
               _options210803_)))
        (if _xtree210809_
            (with-unwind-protect
             (lambda ()
               (std/xml/libxml#html-doc->sxml
                _xtree210809_
                (std/xml/libxml#node-filter-e _filter-els210805_)))
             (lambda () (std/xml/libxml#xmlFreeDoc _xtree210809_)))
            (error '"Error parsing html; no parse tree" _source210797_)))))
  (define std/xml/libxml#parse-html__@
    (lambda (_keys210782210817_ . _args210819_)
      (apply std/xml/libxml#parse-html__%
             _keys210782210817_
             (table-ref _keys210782210817_ 'url: absent-value)
             (table-ref _keys210782210817_ 'encoding: absent-value)
             (table-ref _keys210782210817_ 'options: absent-value)
             (table-ref _keys210782210817_ 'filter: absent-value)
             _args210819_)))
  (define std/xml/libxml#parse-html
    (lambda _args210787210825_
      (apply keyword-dispatch
             '#(encoding: options: url: filter:)
             std/xml/libxml#parse-html__@
             _args210787210825_)))
  (define std/xml/libxml#xml-doc->sxml
    (lambda (_xtree210748_ _ns210749_)
      (letrec* ((_nsmap210751_
                 (if (table? _ns210749_)
                     _ns210749_
                     (if (pair? _ns210749_) (list->table _ns210749_) '#f)))
                (_ns-name-e210752_
                 (lambda (_node210766_ _node-name210767_ _node-ns210768_)
                   (let ((_name210770_ (_node-name210767_ _node210766_))
                         (_ns210771_ (_node-ns210768_ _node210766_)))
                     (if _ns210771_
                         (let* ((_href210773_
                                 (std/xml/libxml#xmlNs-href _ns210771_))
                                (_pre210778_
                                 (let ((_$e210775_
                                        (if _nsmap210751_
                                            (table-ref
                                             _nsmap210751_
                                             _href210773_
                                             '#f)
                                            '#f)))
                                   (if _$e210775_ _$e210775_ _href210773_))))
                           (string->symbol
                            (string-append _pre210778_ '":" _name210770_)))
                         (string->symbol _name210770_)))))
                (_element-e210753_
                 (lambda (_node210764_)
                   (_ns-name-e210752_
                    _node210764_
                    std/xml/libxml#xmlNode-name
                    std/xml/libxml#xmlNode-ns)))
                (_attribute-e210754_
                 (lambda (_node210762_)
                   (_ns-name-e210752_
                    _node210762_
                    std/xml/libxml#xmlAttr-name
                    std/xml/libxml#xmlAttr-ns))))
        (let ((_body210759_
               (std/xml/libxml#xmlNode->sxml
                (std/xml/libxml#xmlDocGetRootElement _xtree210748_)
                false
                _element-e210753_
                _attribute-e210754_))
              (_nsassoc210760_
               (if _nsmap210751_
                   (hash-map
                    (lambda (_href210756_ _pre210757_)
                      (cons (string->symbol _pre210757_)
                            (cons _href210756_ '())))
                    _nsmap210751_)
                   '#f)))
          (if _nsassoc210760_
              (cons '*TOP*
                    (cons (cons '@
                                (cons (cons '*NAMESPACES* _nsassoc210760_)
                                      '()))
                          _body210759_))
              (cons '*TOP* _body210759_))))))
  (define std/xml/libxml#html-doc->sxml
    (lambda (_xtree210745_ _filter-e210746_)
      (cons '*TOP*
            (std/xml/libxml#xmlNode->sxml
             (std/xml/libxml#xmlDocGetRootElement _xtree210745_)
             _filter-e210746_
             std/xml/libxml#xmlNode-name-e
             std/xml/libxml#xmlAttr-name-e))))
  (define std/xml/libxml#xmlNode->sxml
    (lambda (_node210729_
             _filter-e210730_
             _element-e210731_
             _attribute-e210732_)
      (let _recur210734_ ((_node210736_ _node210729_))
        (if _node210736_
            (if (_filter-e210730_ _node210736_)
                (_recur210734_ (std/xml/libxml#xmlNode-next _node210736_))
                (let ((_type210738_ (std/xml/libxml#xmlNode-type _node210736_))
                      (_rest210739_
                       (_recur210734_
                        (std/xml/libxml#xmlNode-next _node210736_))))
                  (if (eq? _type210738_ std/xml/libxml#XML_ELEMENT_NODE)
                      (let ((_el210741_ (_element-e210731_ _node210736_))
                            (_attr210742_
                             (std/xml/libxml#xmlNode-properties _node210736_))
                            (_children210743_
                             (_recur210734_
                              (std/xml/libxml#xmlNode-children _node210736_))))
                        (if _attr210742_
                            (cons (cons _el210741_
                                        (cons (cons '@
                                                    (std/xml/libxml#xmlAttr->list
                                                     _attr210742_
                                                     _attribute-e210732_))
                                              _children210743_))
                                  _rest210739_)
                            (cons (cons _el210741_ _children210743_)
                                  _rest210739_)))
                      (if (eq? _type210738_ std/xml/libxml#XML_TEXT_NODE)
                          (cons (std/xml/libxml#xmlNode-content _node210736_)
                                _rest210739_)
                          (if (eq? _type210738_
                                   std/xml/libxml#XML_CDATA_SECTION_NODE)
                              (cons (cons '*CDATA*
                                          (cons (std/xml/libxml#xmlNode-content
                                                 _node210736_)
                                                '()))
                                    _rest210739_)
                              (if (eq? _type210738_
                                       std/xml/libxml#XML_COMMENT_NODE)
                                  _rest210739_
                                  (error '"Unexpected node"
                                         (std/xml/libxml#xmlNode-name
                                          _node210736_)
                                         _type210738_)))))))
            '()))))
  (define std/xml/libxml#xmlAttr->list
    (lambda (_attr210717_ _attribute-e210718_)
      (let _recur210720_ ((_attr210722_ _attr210717_))
        (if _attr210722_
            (let* ((_value210724_
                    (std/xml/libxml#xmlAttr-children _attr210722_))
                   (_value210726_
                    (if _value210724_
                        (cons (std/xml/libxml#xmlNode-content _value210724_)
                              '())
                        '())))
              (cons (cons (_attribute-e210718_ _attr210722_) _value210726_)
                    (_recur210720_
                     (std/xml/libxml#xmlAttr-next _attr210722_))))
            '()))))
  (define std/xml/libxml#xmlNode-name-e
    (lambda (_node210715_)
      (string->symbol (std/xml/libxml#xmlNode-name _node210715_))))
  (define std/xml/libxml#xmlAttr-name-e
    (lambda (_node210713_)
      (string->symbol (std/xml/libxml#xmlAttr-name _node210713_))))
  (define std/xml/libxml#parse-xml-default-options
    (fxior std/xml/libxml#XML_PARSE_NOENT
           std/xml/libxml#XML_PARSE_NONET
           std/xml/libxml#XML_PARSE_NOBLANKS))
  (define std/xml/libxml#parse-html-default-options
    (fxior std/xml/libxml#HTML_PARSE_RECOVER
           std/xml/libxml#HTML_PARSE_NOERROR
           std/xml/libxml#HTML_PARSE_NOWARNING
           std/xml/libxml#HTML_PARSE_NONET
           std/xml/libxml#HTML_PARSE_NOBLANKS))
  (define std/xml/libxml#node-filter-e
    (lambda (_elems210703_)
      (if (null? _elems210703_)
          false
          (lambda (_node210705_)
            (let ((_name210706210708_
                   (std/xml/libxml#xmlNode-name _node210705_)))
              (if _name210706210708_
                  (let ((_name210711_ _name210706210708_))
                    (member _name210711_ _elems210703_))
                  '#f)))))))
