(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/xml/ssax#read-xml__%
    (lambda (_g301315_ _ns223317223320_ _source223322_)
      (let* ((_ns223324_
              (if (eq? _ns223317223320_ absent-value) '() _ns223317223320_))
             (_ns223326_
              (if (table? _ns223324_) (table->list _ns223324_) _ns223324_))
             (_ns223360_
              (map (lambda (_e223327223329_)
                     (let* ((_g223331223338_ _e223327223329_)
                            (_E223333223342_
                             (lambda ()
                               (error '"No clause matching" _g223331223338_)))
                            (_K223334223348_
                             (lambda (_id223345_ _uri223346_)
                               (cons (string->symbol _id223345_)
                                     _uri223346_))))
                       (if (let ()
                             (declare (not safe))
                             (##pair? _g223331223338_))
                           (let ((_hd223335223351_
                                  (let ()
                                    (declare (not safe))
                                    (##car _g223331223338_)))
                                 (_tl223336223353_
                                  (let ()
                                    (declare (not safe))
                                    (##cdr _g223331223338_))))
                             (let* ((_uri223356_ _hd223335223351_)
                                    (_id223358_ _tl223336223353_))
                               (_K223334223348_ _id223358_ _uri223356_)))
                           (_E223333223342_))))
                   _ns223326_)))
        (if (input-port? _source223322_)
            (std/xml/ssax#ssax:xml->sxml _source223322_ _ns223360_)
            (if (string? _source223322_)
                (call-with-input-string
                 _source223322_
                 (lambda (_g223362223364_)
                   (std/xml/ssax#ssax:xml->sxml _g223362223364_ _ns223360_)))
                (if (u8vector? _source223322_)
                    (call-with-input-u8vector
                     _source223322_
                     (lambda (_g223366223368_)
                       (std/xml/ssax#ssax:xml->sxml
                        _g223366223368_
                        _ns223360_)))
                    (error '"Bad input source; expected port, string, or u8vector"
                           _source223322_)))))))
  (define std/xml/ssax#read-xml__@
    (lambda (_keys223316223374_ . _args223376_)
      (apply std/xml/ssax#read-xml__%
             _keys223316223374_
             (table-ref _keys223316223374_ 'namespaces: absent-value)
             _args223376_)))
  (define std/xml/ssax#read-xml
    (lambda _args223318223382_
      (apply keyword-dispatch
             '#(namespaces:)
             std/xml/ssax#read-xml__@
             _args223318223382_)))
  (define std/xml/ssax#ssax:warn void)
  (define std/xml/ssax#string-null? string-empty?)
  (define std/xml/ssax#nl (string '#\newline))
  (define std/xml/ssax#cout
    (lambda _args223311_
      (for-each
       (lambda (_x223313_)
         (if (procedure? _x223313_) (_x223313_) (display _x223313_)))
       _args223311_)))
  (define std/xml/ssax#cerr
    (lambda _args223307_
      (for-each
       (lambda (_x223309_)
         (if (procedure? _x223309_)
             (_x223309_ (current-error-port))
             (display _x223309_ (current-error-port))))
       _args223307_)))
  (define std/xml/ssax#ascii->char integer->char)
  (define std/xml/ssax#ucscode->char
    (lambda (_code223305_) (integer->char _code223305_)))
  (define std/xml/ssax#char-return (std/xml/ssax#ascii->char '13))
  (define std/xml/ssax#char-tab (std/xml/ssax#ascii->char '9))
  (define std/xml/ssax#char-newline (std/xml/ssax#ascii->char '10))
  (define std/xml/ssax#parser-error
    (lambda (_port223301_ _message223302_ . _rest223303_)
      (apply error _message223302_ _rest223303_)))
  (define std/xml/ssax#peek-next-char__%
    (lambda (_port223291_) (read-char _port223291_) (peek-char _port223291_)))
  (define std/xml/ssax#peek-next-char__0
    (lambda ()
      (let ((_port223297_ (current-input-port)))
        (std/xml/ssax#peek-next-char__% _port223297_))))
  (define std/xml/ssax#peek-next-char
    (lambda _g301317_
      (let ((_g301316_ (let () (declare (not safe)) (##length _g301317_))))
        (cond ((let () (declare (not safe)) (##fx= _g301316_ 0))
               (apply std/xml/ssax#peek-next-char__0 _g301317_))
              ((let () (declare (not safe)) (##fx= _g301316_ 1))
               (apply std/xml/ssax#peek-next-char__% _g301317_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/xml/ssax#peek-next-char
                _g301317_))))))
  (define std/xml/ssax#assert-curr-char__%
    (lambda (_expected-chars223272_ _comment223273_ _port223274_)
      (let ((_c223276_ (read-char _port223274_)))
        (if (memv _c223276_ _expected-chars223272_)
            _c223276_
            (std/xml/ssax#parser-error
             _port223274_
             '"Wrong character "
             _c223276_
             '" (0x"
             (if (eof-object? _c223276_)
                 '"*eof*"
                 (number->string (char->integer _c223276_) '16))
             '") "
             _comment223273_
             '". "
             _expected-chars223272_
             '" expected")))))
  (define std/xml/ssax#assert-curr-char__0
    (lambda (_expected-chars223281_ _comment223282_)
      (let ((_port223284_ (current-input-port)))
        (std/xml/ssax#assert-curr-char__%
         _expected-chars223281_
         _comment223282_
         _port223284_))))
  (define std/xml/ssax#assert-curr-char
    (lambda _g301319_
      (let ((_g301318_ (let () (declare (not safe)) (##length _g301319_))))
        (cond ((let () (declare (not safe)) (##fx= _g301318_ 2))
               (apply std/xml/ssax#assert-curr-char__0 _g301319_))
              ((let () (declare (not safe)) (##fx= _g301318_ 3))
               (apply std/xml/ssax#assert-curr-char__% _g301319_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/xml/ssax#assert-curr-char
                _g301319_))))))
  (define std/xml/ssax#skip-until__%
    (lambda (_arg223249_ _port223250_)
      (if (number? _arg223249_)
          (let _$loop223252_ ((_i223255_ _arg223249_))
            (if (not (positive? _i223255_))
                '#f
                (begin
                  (if (eof-object? (read-char _port223250_))
                      (std/xml/ssax#parser-error
                       _port223250_
                       '"Unexpected EOF while skipping "
                       _arg223249_
                       '" characters")
                      '#!void)
                  (_$loop223252_ (- _i223255_ '1)))))
          (let _loop223257_ ((_c223259_ (read-char _port223250_)))
            (if (memv _c223259_ _arg223249_)
                _c223259_
                (if (eof-object? _c223259_)
                    (if (memq '*eof* _arg223249_)
                        _c223259_
                        (std/xml/ssax#parser-error
                         _port223250_
                         '"Unexpected EOF while skipping until "
                         _arg223249_))
                    (_loop223257_ (read-char _port223250_))))))))
  (define std/xml/ssax#skip-until__0
    (lambda (_arg223264_)
      (let ((_port223266_ (current-input-port)))
        (std/xml/ssax#skip-until__% _arg223264_ _port223266_))))
  (define std/xml/ssax#skip-until
    (lambda _g301321_
      (let ((_g301320_ (let () (declare (not safe)) (##length _g301321_))))
        (cond ((let () (declare (not safe)) (##fx= _g301320_ 1))
               (apply std/xml/ssax#skip-until__0 _g301321_))
              ((let () (declare (not safe)) (##fx= _g301320_ 2))
               (apply std/xml/ssax#skip-until__% _g301321_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/xml/ssax#skip-until
                _g301321_))))))
  (define std/xml/ssax#skip-while__%
    (lambda (_skip-chars223230_ _port223231_)
      (let _$loop223233_ ((_c223236_ (peek-char _port223231_)))
        (if (not (memv _c223236_ _skip-chars223230_))
            _c223236_
            (begin
              (read-char _port223231_)
              (_$loop223233_ (peek-char _port223231_)))))))
  (define std/xml/ssax#skip-while__0
    (lambda (_skip-chars223241_)
      (let ((_port223243_ (current-input-port)))
        (std/xml/ssax#skip-while__% _skip-chars223241_ _port223243_))))
  (define std/xml/ssax#skip-while
    (lambda _g301323_
      (let ((_g301322_ (let () (declare (not safe)) (##length _g301323_))))
        (cond ((let () (declare (not safe)) (##fx= _g301322_ 1))
               (apply std/xml/ssax#skip-while__0 _g301323_))
              ((let () (declare (not safe)) (##fx= _g301322_ 2))
               (apply std/xml/ssax#skip-while__% _g301323_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/xml/ssax#skip-while
                _g301323_))))))
  (define std/xml/ssax#input-parse:init-buffer
    (let ((_buffer223226_ (make-string '512))) (lambda () _buffer223226_)))
  (define std/xml/ssax#next-token-old__%
    (lambda (_prefix-skipped-chars223188_
             _break-chars223189_
             _comment223190_
             _port223191_)
      (let* ((_buffer223193_ (std/xml/ssax#input-parse:init-buffer))
             (_curr-buf-len223195_ (string-length _buffer223193_))
             (_quantum223197_ _curr-buf-len223195_))
        (let _loop223200_ ((_i223202_ '0)
                           (_c223203_
                            (std/xml/ssax#skip-while__%
                             _prefix-skipped-chars223188_
                             _port223191_)))
          (if (memv _c223203_ _break-chars223189_)
              (substring _buffer223193_ '0 _i223202_)
              (if (eof-object? _c223203_)
                  (if (memq '*eof* _break-chars223189_)
                      (substring _buffer223193_ '0 _i223202_)
                      (std/xml/ssax#parser-error
                       _port223191_
                       '"EOF while reading a token "
                       _comment223190_))
                  (begin
                    (if (>= _i223202_ _curr-buf-len223195_)
                        (begin
                          (set! _buffer223193_
                                (string-append
                                 _buffer223193_
                                 (make-string _quantum223197_)))
                          (set! _quantum223197_ _curr-buf-len223195_)
                          (set! _curr-buf-len223195_
                                (string-length _buffer223193_)))
                        '#!void)
                    (string-set! _buffer223193_ _i223202_ _c223203_)
                    (read-char _port223191_)
                    (_loop223200_
                     (+ '1 _i223202_)
                     (peek-char _port223191_)))))))))
  (define std/xml/ssax#next-token-old__0
    (lambda (_prefix-skipped-chars223208_ _break-chars223209_)
      (let* ((_comment223211_ '"") (_port223213_ (current-input-port)))
        (std/xml/ssax#next-token-old__%
         _prefix-skipped-chars223208_
         _break-chars223209_
         _comment223211_
         _port223213_))))
  (define std/xml/ssax#next-token-old__1
    (lambda (_prefix-skipped-chars223215_ _break-chars223216_ _comment223217_)
      (let ((_port223219_ (current-input-port)))
        (std/xml/ssax#next-token-old__%
         _prefix-skipped-chars223215_
         _break-chars223216_
         _comment223217_
         _port223219_))))
  (define std/xml/ssax#next-token-old
    (lambda _g301325_
      (let ((_g301324_ (let () (declare (not safe)) (##length _g301325_))))
        (cond ((let () (declare (not safe)) (##fx= _g301324_ 2))
               (apply std/xml/ssax#next-token-old__0 _g301325_))
              ((let () (declare (not safe)) (##fx= _g301324_ 3))
               (apply std/xml/ssax#next-token-old__1 _g301325_))
              ((let () (declare (not safe)) (##fx= _g301324_ 4))
               (apply std/xml/ssax#next-token-old__% _g301325_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/xml/ssax#next-token-old
                _g301325_))))))
  (define std/xml/ssax#next-token__%
    (lambda (_prefix-skipped-chars223148_
             _break-chars223149_
             _comment223150_
             _port223151_)
      (let _outer223153_ ((_buffer223155_
                           (std/xml/ssax#input-parse:init-buffer))
                          (_filled-buffer-l223156_ '())
                          (_c223157_
                           (std/xml/ssax#skip-while__%
                            _prefix-skipped-chars223148_
                            _port223151_)))
        (let ((_curr-buf-len223159_ (string-length _buffer223155_)))
          (let _loop223161_ ((_i223163_ '0) (_c223164_ _c223157_))
            (if (memv _c223164_ _break-chars223149_)
                (if (null? _filled-buffer-l223156_)
                    (substring _buffer223155_ '0 _i223163_)
                    (std/srfi/13#string-concatenate-reverse__%
                     _filled-buffer-l223156_
                     _buffer223155_
                     _i223163_))
                (if (eof-object? _c223164_)
                    (if (memq '*eof* _break-chars223149_)
                        (if (null? _filled-buffer-l223156_)
                            (substring _buffer223155_ '0 _i223163_)
                            (std/srfi/13#string-concatenate-reverse__%
                             _filled-buffer-l223156_
                             _buffer223155_
                             _i223163_))
                        (std/xml/ssax#parser-error
                         _port223151_
                         '"EOF while reading a token "
                         _comment223150_))
                    (if (>= _i223163_ _curr-buf-len223159_)
                        (_outer223153_
                         (make-string _curr-buf-len223159_)
                         (cons _buffer223155_ _filled-buffer-l223156_)
                         _c223164_)
                        (begin
                          (string-set! _buffer223155_ _i223163_ _c223164_)
                          (read-char _port223151_)
                          (_loop223161_
                           (+ '1 _i223163_)
                           (peek-char _port223151_)))))))))))
  (define std/xml/ssax#next-token__0
    (lambda (_prefix-skipped-chars223169_ _break-chars223170_)
      (let* ((_comment223172_ '"") (_port223174_ (current-input-port)))
        (std/xml/ssax#next-token__%
         _prefix-skipped-chars223169_
         _break-chars223170_
         _comment223172_
         _port223174_))))
  (define std/xml/ssax#next-token__1
    (lambda (_prefix-skipped-chars223176_ _break-chars223177_ _comment223178_)
      (let ((_port223180_ (current-input-port)))
        (std/xml/ssax#next-token__%
         _prefix-skipped-chars223176_
         _break-chars223177_
         _comment223178_
         _port223180_))))
  (define std/xml/ssax#next-token
    (lambda _g301327_
      (let ((_g301326_ (let () (declare (not safe)) (##length _g301327_))))
        (cond ((let () (declare (not safe)) (##fx= _g301326_ 2))
               (apply std/xml/ssax#next-token__0 _g301327_))
              ((let () (declare (not safe)) (##fx= _g301326_ 3))
               (apply std/xml/ssax#next-token__1 _g301327_))
              ((let () (declare (not safe)) (##fx= _g301326_ 4))
               (apply std/xml/ssax#next-token__% _g301327_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/xml/ssax#next-token
                _g301327_))))))
  (define std/xml/ssax#next-token-of__%
    (lambda (_incl-list/pred223107_ _port223108_)
      (let* ((_buffer223110_ (std/xml/ssax#input-parse:init-buffer))
             (_curr-buf-len223112_ (string-length _buffer223110_)))
        (if (procedure? _incl-list/pred223107_)
            (let _outer223115_ ((_buffer223117_ _buffer223110_)
                                (_filled-buffer-l223118_ '()))
              (let _loop223120_ ((_i223122_ '0))
                (if (>= _i223122_ _curr-buf-len223112_)
                    (_outer223115_
                     (make-string _curr-buf-len223112_)
                     (cons _buffer223117_ _filled-buffer-l223118_))
                    (let ((_c223124_
                           (_incl-list/pred223107_ (peek-char _port223108_))))
                      (if _c223124_
                          (begin
                            (string-set! _buffer223117_ _i223122_ _c223124_)
                            (read-char _port223108_)
                            (_loop223120_ (+ '1 _i223122_)))
                          (if (null? _filled-buffer-l223118_)
                              (substring _buffer223117_ '0 _i223122_)
                              (std/srfi/13#string-concatenate-reverse__%
                               _filled-buffer-l223118_
                               _buffer223117_
                               _i223122_)))))))
            (let _outer223126_ ((_buffer223128_ _buffer223110_)
                                (_filled-buffer-l223129_ '()))
              (let _loop223131_ ((_i223133_ '0))
                (if (>= _i223133_ _curr-buf-len223112_)
                    (_outer223126_
                     (make-string _curr-buf-len223112_)
                     (cons _buffer223128_ _filled-buffer-l223129_))
                    (let ((_c223135_ (peek-char _port223108_)))
                      (if (not (memv _c223135_ _incl-list/pred223107_))
                          (if (null? _filled-buffer-l223129_)
                              (substring _buffer223128_ '0 _i223133_)
                              (std/srfi/13#string-concatenate-reverse__%
                               _filled-buffer-l223129_
                               _buffer223128_
                               _i223133_))
                          (begin
                            (string-set! _buffer223128_ _i223133_ _c223135_)
                            (read-char _port223108_)
                            (_loop223131_ (+ '1 _i223133_))))))))))))
  (define std/xml/ssax#next-token-of__0
    (lambda (_incl-list/pred223140_)
      (let ((_port223142_ (current-input-port)))
        (std/xml/ssax#next-token-of__% _incl-list/pred223140_ _port223142_))))
  (define std/xml/ssax#next-token-of
    (lambda _g301329_
      (let ((_g301328_ (let () (declare (not safe)) (##length _g301329_))))
        (cond ((let () (declare (not safe)) (##fx= _g301328_ 1))
               (apply std/xml/ssax#next-token-of__0 _g301329_))
              ((let () (declare (not safe)) (##fx= _g301328_ 2))
               (apply std/xml/ssax#next-token-of__% _g301329_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/xml/ssax#next-token-of
                _g301329_))))))
  (define std/xml/ssax#*read-line-breaks*
    (list std/xml/ssax#char-newline std/xml/ssax#char-return '*eof*))
  (define std/xml/ssax#read-text-line__%
    (lambda (_port223091_)
      (if (eof-object? (peek-char _port223091_))
          (peek-char _port223091_)
          (let* ((_line223093_
                  (std/xml/ssax#next-token__%
                   '()
                   std/xml/ssax#*read-line-breaks*
                   '"reading a line"
                   _port223091_))
                 (_c223095_ (read-char _port223091_)))
            (if (eqv? _c223095_ std/xml/ssax#char-return)
                (if (eqv? (peek-char _port223091_) '#\newline)
                    (read-char _port223091_)
                    '#f)
                '#f)
            _line223093_))))
  (define std/xml/ssax#read-text-line__0
    (lambda ()
      (let ((_port223102_ (current-input-port)))
        (std/xml/ssax#read-text-line__% _port223102_))))
  (define std/xml/ssax#read-text-line
    (lambda _g301331_
      (let ((_g301330_ (let () (declare (not safe)) (##length _g301331_))))
        (cond ((let () (declare (not safe)) (##fx= _g301330_ 0))
               (apply std/xml/ssax#read-text-line__0 _g301331_))
              ((let () (declare (not safe)) (##fx= _g301330_ 1))
               (apply std/xml/ssax#read-text-line__% _g301331_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/xml/ssax#read-text-line
                _g301331_))))))
  (define std/xml/ssax#read-string__%
    (lambda (_n223068_ _port223069_)
      (if (not (positive? _n223068_))
          '""
          (let ((_buffer223071_ (make-string _n223068_)))
            (let _loop223073_ ((_i223075_ '0)
                               (_c223076_ (read-char _port223069_)))
              (if (eof-object? _c223076_)
                  (substring _buffer223071_ '0 _i223075_)
                  (let ((_i1223078_ (+ '1 _i223075_)))
                    (string-set! _buffer223071_ _i223075_ _c223076_)
                    (if (= _i1223078_ _n223068_)
                        _buffer223071_
                        (_loop223073_
                         _i1223078_
                         (read-char _port223069_))))))))))
  (define std/xml/ssax#read-string__0
    (lambda (_n223083_)
      (let ((_port223085_ (current-input-port)))
        (std/xml/ssax#read-string__% _n223083_ _port223085_))))
  (define std/xml/ssax#read-string
    (lambda _g301333_
      (let ((_g301332_ (let () (declare (not safe)) (##length _g301333_))))
        (cond ((let () (declare (not safe)) (##fx= _g301332_ 1))
               (apply std/xml/ssax#read-string__0 _g301333_))
              ((let () (declare (not safe)) (##fx= _g301332_ 2))
               (apply std/xml/ssax#read-string__% _g301333_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/xml/ssax#read-string
                _g301333_))))))
  (define std/xml/ssax#MISCIO:find-string-from-port?
    (lambda (_str223033_ _<input-port>223034_ . _max-no-char223035_)
      (set! _max-no-char223035_
            (if (null? _max-no-char223035_) '#f (car _max-no-char223035_)))
      (letrec ((_no-chars-read223037_ '0)
               (_my-peek-char223038_
                (lambda ()
                  (if (or (not _max-no-char223035_)
                          (< _no-chars-read223037_ _max-no-char223035_))
                      (let ((_c223048_ (peek-char _<input-port>223034_)))
                        (if (eof-object? _c223048_) '#f _c223048_))
                      '#f)))
               (_next-char223039_
                (lambda ()
                  (read-char _<input-port>223034_)
                  (set! _no-chars-read223037_ (+ '1 _no-chars-read223037_))))
               (_match-1st-char223040_
                (lambda ()
                  (let ((_c223052_ (_my-peek-char223038_)))
                    (if (not _c223052_)
                        '#f
                        (begin
                          (_next-char223039_)
                          (if (char=? _c223052_ (string-ref _str223033_ '0))
                              (_match-other-chars223041_ '1)
                              (_match-1st-char223040_)))))))
               (_match-other-chars223041_
                (lambda (_pos-to-match223054_)
                  (if (>= _pos-to-match223054_ (string-length _str223033_))
                      _no-chars-read223037_
                      (let ((_c223056_ (_my-peek-char223038_)))
                        (if _c223056_
                            (if (not (char=? _c223056_
                                             (string-ref
                                              _str223033_
                                              _pos-to-match223054_)))
                                (_backtrack223042_ '1 _pos-to-match223054_)
                                (begin
                                  (_next-char223039_)
                                  (_match-other-chars223041_
                                   (+ '1 _pos-to-match223054_))))
                            '#f)))))
               (_backtrack223042_
                (lambda (_i223058_ _matched-substr-len223059_)
                  (let ((_j223061_ (- _matched-substr-len223059_ _i223058_)))
                    (if (<= _j223061_ '0)
                        (_match-1st-char223040_)
                        (let _loop223063_ ((_k223065_ '0))
                          (if (>= _k223065_ _j223061_)
                              (_match-other-chars223041_ _j223061_)
                              (if (char=? (string-ref _str223033_ _k223065_)
                                          (string-ref
                                           _str223033_
                                           (+ _i223058_ _k223065_)))
                                  (_loop223063_ (+ '1 _k223065_))
                                  (_backtrack223042_
                                   (+ '1 _i223058_)
                                   _matched-substr-len223059_)))))))))
        (_match-1st-char223040_))))
  (define std/xml/ssax#find-string-from-port?
    std/xml/ssax#MISCIO:find-string-from-port?)
  (define std/xml/ssax#make-xml-token
    (lambda (_kind223030_ _head223031_) (cons _kind223030_ _head223031_)))
  (define std/xml/ssax#xml-token? pair?)
  (define std/xml/ssax#string-whitespace?
    (lambda (_str223019_)
      (let ((_len223021_ (string-length _str223019_)))
        (if (zero? _len223021_)
            '#t
            (if (= '1 _len223021_)
                (char-whitespace? (string-ref _str223019_ '0))
                (if (= '2 _len223021_)
                    (if (char-whitespace? (string-ref _str223019_ '0))
                        (char-whitespace? (string-ref _str223019_ '1))
                        '#f)
                    (let _loop223023_ ((_i223025_ '0))
                      (let ((_$e223027_ (>= _i223025_ _len223021_)))
                        (if _$e223027_
                            _$e223027_
                            (if (char-whitespace?
                                 (string-ref _str223019_ _i223025_))
                                (_loop223023_ (+ '1 _i223025_))
                                '#f))))))))))
  (define std/xml/ssax#assq-values
    (lambda (_val223011_ _alist223012_)
      (let _loop223014_ ((_alist223016_ _alist223012_) (_scanned223017_ '()))
        (if (null? _alist223016_)
            (values '#f _scanned223017_)
            (if (equal? _val223011_ (caar _alist223016_))
                (values (car _alist223016_)
                        (append _scanned223017_ (cdr _alist223016_)))
                (_loop223014_
                 (cdr _alist223016_)
                 (cons (car _alist223016_) _scanned223017_)))))))
  (define std/xml/ssax#fold-right
    (lambda (_kons223001_ _knil223002_ _lis1223003_)
      (let _recur223005_ ((_lis223007_ _lis1223003_))
        (if (null? _lis223007_)
            _knil223002_
            (let ((_head223009_ (car _lis223007_)))
              (_kons223001_
               _head223009_
               (_recur223005_ (cdr _lis223007_))))))))
  (define std/xml/ssax#fold
    (lambda (_kons222992_ _knil222993_ _lis1222994_)
      (let _lp222996_ ((_lis222998_ _lis1222994_) (_ans222999_ _knil222993_))
        (if (null? _lis222998_)
            _ans222999_
            (_lp222996_
             (cdr _lis222998_)
             (_kons222992_ (car _lis222998_) _ans222999_))))))
  (define std/xml/ssax#ssax:S-chars
    (map std/xml/ssax#ascii->char '(32 10 9 13)))
  (define std/xml/ssax#ssax:skip-S
    (lambda (_port222990_)
      (std/xml/ssax#skip-while__% std/xml/ssax#ssax:S-chars _port222990_)))
  (define std/xml/ssax#ssax:ncname-starting-char?
    (lambda (_a-char222985_)
      (if (char? _a-char222985_)
          (let ((_$e222987_ (char-alphabetic? _a-char222985_)))
            (if _$e222987_ _$e222987_ (char=? '#\_ _a-char222985_)))
          '#f)))
  (define std/xml/ssax#ssax:read-NCName
    (lambda (_port222976_)
      (let* ((_first-char222978_ (peek-char _port222976_))
             (_$e222980_
              (std/xml/ssax#ssax:ncname-starting-char? _first-char222978_)))
        (if _$e222980_
            _$e222980_
            (std/xml/ssax#parser-error
             _port222976_
             '"XMLNS [4] for '"
             _first-char222978_
             '"'")))
      (string->symbol
       (std/xml/ssax#next-token-of__%
        (lambda (_c222983_)
          (if (eof-object? _c222983_)
              '#f
              (if (char-alphabetic? _c222983_)
                  _c222983_
                  (if (std/srfi/13#string-index__0 '"0123456789.-_" _c222983_)
                      _c222983_
                      '#f))))
        _port222976_))))
  (define std/xml/ssax#ssax:read-QName
    (lambda (_port222969_)
      (let* ((_prefix-or-localpart222971_
              (std/xml/ssax#ssax:read-NCName _port222969_))
             (_$e222973_ (peek-char _port222969_)))
        (if (eq? '#\: _$e222973_)
            (begin
              (read-char _port222969_)
              (cons _prefix-or-localpart222971_
                    (std/xml/ssax#ssax:read-NCName _port222969_)))
            _prefix-or-localpart222971_))))
  (define std/xml/ssax#ssax:Prefix-XML (string->symbol '"xml"))
  (define std/xml/ssax#name-compare
    (letrec ((_symbol-compare222961_
              (lambda (_symb1222963_ _symb2222964_)
                (if (eq? _symb1222963_ _symb2222964_)
                    '=
                    (if (string<?
                         (symbol->string _symb1222963_)
                         (symbol->string _symb2222964_))
                        '<
                        '>)))))
      (lambda (_name1222966_ _name2222967_)
        (if (symbol? _name1222966_)
            (if (symbol? _name2222967_)
                (_symbol-compare222961_ _name1222966_ _name2222967_)
                '<)
            (if (symbol? _name2222967_)
                '>
                (if (eq? _name2222967_ std/xml/ssax#ssax:largest-unres-name)
                    '<
                    (if (eq? _name1222966_
                             std/xml/ssax#ssax:largest-unres-name)
                        '>
                        (if (eq? (car _name1222966_) (car _name2222967_))
                            (_symbol-compare222961_
                             (cdr _name1222966_)
                             (cdr _name2222967_))
                            (_symbol-compare222961_
                             (car _name1222966_)
                             (car _name2222967_))))))))))
  (define std/xml/ssax#ssax:largest-unres-name
    (cons (string->symbol '"#LARGEST-SYMBOL")
          (string->symbol '"#LARGEST-SYMBOL")))
  (define std/xml/ssax#ssax:read-markup-token
    (let ()
      (letrec ((_skip-comment218432_
                (lambda (_port222959_)
                  (std/xml/ssax#assert-curr-char__%
                   '(#\-)
                   '"XML [15], second dash"
                   _port222959_)
                  (if (not (std/xml/ssax#find-string-from-port?
                            '"-->"
                            _port222959_))
                      (std/xml/ssax#parser-error
                       _port222959_
                       '"XML [15], no -->")
                      '#!void)
                  (cons 'COMMENT '#f)))
               (_read-cdata218433_
                (lambda (_port218446_)
                  (let ((_$e219816_
                         (string=?
                          '"CDATA["
                          (std/xml/ssax#read-string__% '6 _port218446_))))
                    (if _$e219816_
                        _$e219816_
                        (begin
                          (std/xml/ssax#cerr
                           '"failed assertion: "
                           '(string=? "CDATA[" (read-string 6 port))
                           std/xml/ssax#nl
                           '"bindings"
                           '#\newline
                           'port
                           '": "
                           _port218446_
                           std/xml/ssax#nl)
                          (error '"assertion failure"))))
                  (cons 'CDSECT '#f))))
        (lambda (_port218435_)
          (std/xml/ssax#assert-curr-char__%
           '(#\<)
           '"start of the token"
           _port218435_)
          (let ((_$e218437_ (peek-char _port218435_)))
            (if (eq? '#\/ _$e218437_)
                (begin
                  (read-char _port218435_)
                  (let ((_$r218440_
                         (cons 'END
                               (std/xml/ssax#ssax:read-QName _port218435_))))
                    (std/xml/ssax#ssax:skip-S _port218435_)
                    (std/xml/ssax#assert-curr-char__%
                     '(#\>)
                     '"XML [42]"
                     _port218435_)
                    _$r218440_))
                (if (eq? '#\? _$e218437_)
                    (begin
                      (read-char _port218435_)
                      (cons 'PI (std/xml/ssax#ssax:read-NCName _port218435_)))
                    (if (eq? '#\! _$e218437_)
                        (let ((_$e218443_
                               (std/xml/ssax#peek-next-char__% _port218435_)))
                          (if (eq? '#\- _$e218443_)
                              (begin
                                (read-char _port218435_)
                                (_skip-comment218432_ _port218435_))
                              (if (eq? '#\[ _$e218443_)
                                  (begin
                                    (read-char _port218435_)
                                    (_read-cdata218433_ _port218435_))
                                  (cons 'DECL
                                        (std/xml/ssax#ssax:read-NCName
                                         _port218435_)))))
                        (cons 'START
                              (std/xml/ssax#ssax:read-QName
                               _port218435_))))))))))
  (define std/xml/ssax#ssax:skip-pi
    (lambda (_port218429_)
      (if (not (std/xml/ssax#find-string-from-port? '"?>" _port218429_))
          (std/xml/ssax#parser-error
           _port218429_
           '"Failed to find ?> terminating the PI")
          '#!void)))
  (define std/xml/ssax#ssax:read-pi-body-as-string
    (lambda (_port218422_)
      (std/xml/ssax#ssax:skip-S _port218422_)
      (std/srfi/13#string-concatenate/shared
       (let _loop218424_ ()
         (let ((_pi-fragment218427_
                (std/xml/ssax#next-token__%
                 '()
                 '(#\?)
                 '"reading PI content"
                 _port218422_)))
           (if (eqv? '#\> (std/xml/ssax#peek-next-char__% _port218422_))
               (begin (read-char _port218422_) (cons _pi-fragment218427_ '()))
               (cons _pi-fragment218427_ (cons '"?" (_loop218424_)))))))))
  (define std/xml/ssax#ssax:skip-internal-dtd
    (lambda (_port218420_)
      (if (not (std/xml/ssax#find-string-from-port? '"]>" _port218420_))
          (std/xml/ssax#parser-error
           _port218420_
           '"Failed to find ]> terminating the internal DTD subset")
          '#!void)))
  (define std/xml/ssax#ssax:read-cdata-body
    (let ((_cdata-delimiters218394_
           (list std/xml/ssax#char-return '#\newline '#\] '#\&)))
      (lambda (_port218396_ _str-handler218397_ _seed218398_)
        (let _loop218400_ ((_seed218402_ _seed218398_))
          (let* ((_fragment218404_
                  (std/xml/ssax#next-token__%
                   '()
                   _cdata-delimiters218394_
                   '"reading CDATA"
                   _port218396_))
                 (_$e218406_ (read-char _port218396_)))
            (if (eq? '#\newline _$e218406_)
                (_loop218400_
                 (_str-handler218397_
                  _fragment218404_
                  std/xml/ssax#nl
                  _seed218402_))
                (if (eq? '#\] _$e218406_)
                    (if (not (eqv? (peek-char _port218396_) '#\]))
                        (_loop218400_
                         (_str-handler218397_
                          _fragment218404_
                          '"]"
                          _seed218402_))
                        (let _check-after-second-braket218409_ ((_seed218411_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (if (std/xml/ssax#string-null? _fragment218404_)
                             _seed218402_
                             (_str-handler218397_
                              _fragment218404_
                              '""
                              _seed218402_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                          (let ((_$e218413_
                                 (std/xml/ssax#peek-next-char__%
                                  _port218396_)))
                            (if (eq? '#\> _$e218413_)
                                (begin (read-char _port218396_) _seed218411_)
                                (if (eq? '#\] _$e218413_)
                                    (_check-after-second-braket218409_
                                     (_str-handler218397_
                                      '"]"
                                      '""
                                      _seed218411_))
                                    (_loop218400_
                                     (_str-handler218397_
                                      '"]]"
                                      '""
                                      _seed218411_)))))))
                    (if (eq? '#\& _$e218406_)
                        (let ((_ent-ref218418_
                               (std/xml/ssax#next-token-of__%
                                (lambda (_c218416_)
                                  (if (not (eof-object? _c218416_))
                                      (if (char-alphabetic? _c218416_)
                                          _c218416_
                                          '#f)
                                      '#f))
                                _port218396_)))
                          (if (and (string=? '"gt" _ent-ref218418_)
                                   (eqv? (peek-char _port218396_) '#\;))
                              (begin
                                (read-char _port218396_)
                                (_loop218400_
                                 (_str-handler218397_
                                  _fragment218404_
                                  '">"
                                  _seed218402_)))
                              (_loop218400_
                               (_str-handler218397_
                                _ent-ref218418_
                                '""
                                (_str-handler218397_
                                 _fragment218404_
                                 '"&"
                                 _seed218402_)))))
                        (begin
                          (if (eqv? (peek-char _port218396_) '#\newline)
                              (read-char _port218396_)
                              '#!void)
                          (_loop218400_
                           (_str-handler218397_
                            _fragment218404_
                            std/xml/ssax#nl
                            _seed218402_)))))))))))
  (define std/xml/ssax#ssax:read-char-ref
    (lambda (_port218385_)
      (let* ((_base218387_
              (if (eqv? (peek-char _port218385_) '#\x)
                  (begin (read-char _port218385_) '16)
                  '10))
             (_name218389_
              (std/xml/ssax#next-token__% '() '(#\;) '"XML [66]" _port218385_))
             (_char-code218391_ (string->number _name218389_ _base218387_)))
        (read-char _port218385_)
        (if (integer? _char-code218391_)
            (integer->char _char-code218391_)
            (std/xml/ssax#parser-error
             _port218385_
             '"[wf-Legalchar] broken for '"
             _name218389_
             '"'")))))
  (define std/xml/ssax#ssax:predefined-parsed-entities
    (cons (cons (string->symbol '"amp") '"&")
          (cons (cons (string->symbol '"lt") '"<")
                (cons (cons (string->symbol '"gt") '">")
                      (cons (cons (string->symbol '"apos") '"'")
                            (cons (cons (string->symbol '"quot") '"\"")
                                  '()))))))
  (define std/xml/ssax#ssax:handle-parsed-entity
    (lambda (_port218358_
             _name218359_
             _entities218360_
             _content-handler218361_
             _str-handler218362_
             _seed218363_)
      (let ((_$e218365_ (assq _name218359_ _entities218360_)))
        (if _$e218365_
            ((lambda (_decl-entity218368_)
               (let ((_ent-body218370_ (cdr _decl-entity218368_))
                     (_new-entities218371_
                      (cons (cons _name218359_ '#f) _entities218360_)))
                 (if (string? _ent-body218370_)
                     (call-with-input-string
                      _ent-body218370_
                      (lambda (_port218373_)
                        (_content-handler218361_
                         _port218373_
                         _new-entities218371_
                         _seed218363_)))
                     (if (procedure? _ent-body218370_)
                         (let* ((_port218375_ (_ent-body218370_))
                                (_$r218377_
                                 (_content-handler218361_
                                  _port218375_
                                  _new-entities218371_
                                  _seed218363_)))
                           (close-input-port _port218375_)
                           _$r218377_)
                         (std/xml/ssax#parser-error
                          _port218358_
                          '"[norecursion] broken for "
                          _name218359_)))))
             _$e218365_)
            (let ((_$e218380_
                   (assq _name218359_
                         std/xml/ssax#ssax:predefined-parsed-entities)))
              (if _$e218380_
                  ((lambda (_decl-entity218383_)
                     (_str-handler218362_
                      (cdr _decl-entity218383_)
                      '""
                      _seed218363_))
                   _$e218380_)
                  (std/xml/ssax#parser-error
                   _port218358_
                   '"[wf-entdeclared] broken for "
                   _name218359_)))))))
  (define std/xml/ssax#make-empty-attlist (lambda () '()))
  (define std/xml/ssax#attlist-add
    (lambda (_attlist218351_ _name-value218352_)
      (if (null? _attlist218351_)
          (cons _name-value218352_ _attlist218351_)
          (let ((_$e218354_
                 (std/xml/ssax#name-compare
                  (car _name-value218352_)
                  (caar _attlist218351_))))
            (if (eq? '= _$e218354_)
                '#f
                (if (eq? '< _$e218354_)
                    (cons _name-value218352_ _attlist218351_)
                    (cons (car _attlist218351_)
                          (std/xml/ssax#attlist-add
                           (cdr _attlist218351_)
                           _name-value218352_))))))))
  (define std/xml/ssax#attlist-null? null?)
  (define std/xml/ssax#attlist-remove-top
    (lambda (_attlist218349_)
      (values (car _attlist218349_) (cdr _attlist218349_))))
  (define std/xml/ssax#attlist->alist
    (lambda (_attlist218347_) _attlist218347_))
  (define std/xml/ssax#attlist-fold std/xml/ssax#fold)
  (define std/xml/ssax#ssax:read-attributes
    (let ((_value-delimeters218301_
           (append std/xml/ssax#ssax:S-chars '(#\< #\&))))
      (letrec ((_read-attrib-value218303_
                (lambda (_delimiter218334_
                         _port218335_
                         _entities218336_
                         _prev-fragments218337_)
                  (let* ((_new-fragments218339_
                          (cons (std/xml/ssax#next-token__%
                                 '()
                                 (cons _delimiter218334_
                                       _value-delimeters218301_)
                                 '"XML [10]"
                                 _port218335_)
                                _prev-fragments218337_))
                         (_cterm218341_ (read-char _port218335_)))
                    (if (or (eof-object? _cterm218341_)
                            (eqv? _cterm218341_ _delimiter218334_))
                        _new-fragments218339_
                        (if (eqv? _cterm218341_ std/xml/ssax#char-return)
                            (begin
                              (if (eqv? (peek-char _port218335_) '#\newline)
                                  (read-char _port218335_)
                                  '#!void)
                              (_read-attrib-value218303_
                               _delimiter218334_
                               _port218335_
                               _entities218336_
                               (cons '" " _new-fragments218339_)))
                            (if (memv _cterm218341_ std/xml/ssax#ssax:S-chars)
                                (_read-attrib-value218303_
                                 _delimiter218334_
                                 _port218335_
                                 _entities218336_
                                 (cons '" " _new-fragments218339_))
                                (if (eqv? _cterm218341_ '#\&)
                                    (if (eqv? (peek-char _port218335_) '#\#)
                                        (begin
                                          (read-char _port218335_)
                                          (_read-attrib-value218303_
                                           _delimiter218334_
                                           _port218335_
                                           _entities218336_
                                           (cons (string (std/xml/ssax#ssax:read-char-ref
                                                          _port218335_))
                                                 _new-fragments218339_)))
                                        (_read-attrib-value218303_
                                         _delimiter218334_
                                         _port218335_
                                         _entities218336_
                                         (_read-named-entity218304_
                                          _port218335_
                                          _entities218336_
                                          _new-fragments218339_)))
                                    (std/xml/ssax#parser-error
                                     _port218335_
                                     '"[CleanAttrVals] broken"))))))))
               (_read-named-entity218304_
                (lambda (_port218320_ _entities218321_ _fragments218322_)
                  (let ((_name218324_
                         (std/xml/ssax#ssax:read-NCName _port218320_)))
                    (std/xml/ssax#assert-curr-char__%
                     '(#\;)
                     '"XML [68]"
                     _port218320_)
                    (std/xml/ssax#ssax:handle-parsed-entity
                     _port218320_
                     _name218324_
                     _entities218321_
                     (lambda (_port218326_ _entities218327_ _fragments218328_)
                       (_read-attrib-value218303_
                        '*eof*
                        _port218326_
                        _entities218327_
                        _fragments218328_))
                     (lambda (_str1218330_ _str2218331_ _fragments218332_)
                       (if (equal? '"" _str2218331_)
                           (cons _str1218330_ _fragments218332_)
                           (cons _str2218331_
                                 (cons _str1218330_ _fragments218332_))))
                     _fragments218322_)))))
        (lambda (_port218306_ _entities218307_)
          (let _loop218309_ ((_attr-list218311_
                              (std/xml/ssax#make-empty-attlist)))
            (if (not (std/xml/ssax#ssax:ncname-starting-char?
                      (std/xml/ssax#ssax:skip-S _port218306_)))
                _attr-list218311_
                (let ((_name218313_
                       (std/xml/ssax#ssax:read-QName _port218306_)))
                  (std/xml/ssax#ssax:skip-S _port218306_)
                  (std/xml/ssax#assert-curr-char__%
                   '(#\=)
                   '"XML [25]"
                   _port218306_)
                  (std/xml/ssax#ssax:skip-S _port218306_)
                  (let ((_delimiter218315_
                         (std/xml/ssax#assert-curr-char__%
                          '(#\' #\")
                          '"XML [10]"
                          _port218306_)))
                    (_loop218309_
                     (let ((_$e218317_
                            (std/xml/ssax#attlist-add
                             _attr-list218311_
                             (cons _name218313_
                                   (std/srfi/13#string-concatenate-reverse/shared__0
                                    (_read-attrib-value218303_
                                     _delimiter218315_
                                     _port218306_
                                     _entities218307_
                                     '()))))))
                       (if _$e218317_
                           _$e218317_
                           (std/xml/ssax#parser-error
                            _port218306_
                            '"[uniqattspec] broken for "
                            _name218313_))))))))))))
  (define std/xml/ssax#ssax:resolve-name
    (lambda (_port218291_
             _unres-name218292_
             _namespaces218293_
             _apply-default-ns?218294_)
      (if (pair? _unres-name218292_)
          (cons (let ((_$e218296_
                       (assq (car _unres-name218292_) _namespaces218293_)))
                  (if _$e218296_
                      (cadr _$e218296_)
                      (if (eq? (car _unres-name218292_)
                               std/xml/ssax#ssax:Prefix-XML)
                          std/xml/ssax#ssax:Prefix-XML
                          (std/xml/ssax#parser-error
                           _port218291_
                           '"[nsc-NSDeclared] broken; prefix "
                           (car _unres-name218292_)))))
                (cdr _unres-name218292_))
          (if _apply-default-ns?218294_
              (let ((_default-ns218299_ (assq '*DEFAULT* _namespaces218293_)))
                (if (and _default-ns218299_ (cadr _default-ns218299_))
                    (cons (cadr _default-ns218299_) _unres-name218292_)
                    _unres-name218292_))
              _unres-name218292_))))
  (define std/xml/ssax#ssax:uri-string->symbol
    (lambda (_uri-str218289_) (string->symbol _uri-str218289_)))
  (define std/xml/ssax#ssax:complete-start-tag
    (let ((_xmlns218185_ (string->symbol '"xmlns"))
          (_largest-dummy-decl-attr218186_
           (list std/xml/ssax#ssax:largest-unres-name '#f '#f '#f)))
      (letrec ((_validate-attrs218188_
                (lambda (_port218243_ _attlist218244_ _decl-attrs218245_)
                  (letrec ((_add-default-decl218247_
                            (lambda (_decl-attr218280_ _result218281_)
                              (let ((_g301334_
                                     (apply values _decl-attr218280_)))
                                (begin
                                  (let ((_g301335_
                                         (let ()
                                           (declare (not safe))
                                           (if (##values? _g301334_)
                                               (##vector-length _g301334_)
                                               1))))
                                    (if (not (let ()
                                               (declare (not safe))
                                               (##fx= _g301335_ 4)))
                                        (error "Context expects 4 values"
                                               _g301335_)))
                                  (let ((_attr-name218283_
                                         (let ()
                                           (declare (not safe))
                                           (##vector-ref _g301334_ 0)))
                                        (_content-type218284_
                                         (let ()
                                           (declare (not safe))
                                           (##vector-ref _g301334_ 1)))
                                        (_use-type218285_
                                         (let ()
                                           (declare (not safe))
                                           (##vector-ref _g301334_ 2)))
                                        (_default-value218286_
                                         (let ()
                                           (declare (not safe))
                                           (##vector-ref _g301334_ 3))))
                                    (let ()
                                      (if (eq? _use-type218285_ 'REQUIRED)
                                          (std/xml/ssax#parser-error
                                           _port218243_
                                           '"[RequiredAttr] broken for"
                                           _attr-name218283_)
                                          '#f)
                                      (if _default-value218286_
                                          (cons (cons _attr-name218283_
                                                      _default-value218286_)
                                                _result218281_)
                                          _result218281_))))))))
                    (let _loop218249_ ((_attlist218251_ _attlist218244_)
                                       (_decl-attrs218252_ _decl-attrs218245_)
                                       (_result218253_ '()))
                      (if (std/xml/ssax#attlist-null? _attlist218251_)
                          (std/xml/ssax#attlist-fold
                           _add-default-decl218247_
                           _result218253_
                           _decl-attrs218252_)
                          (let ((_g301336_
                                 (std/xml/ssax#attlist-remove-top
                                  _attlist218251_)))
                            (begin
                              (let ((_g301337_
                                     (let ()
                                       (declare (not safe))
                                       (if (##values? _g301336_)
                                           (##vector-length _g301336_)
                                           1))))
                                (if (not (let ()
                                           (declare (not safe))
                                           (##fx= _g301337_ 2)))
                                    (error "Context expects 2 values"
                                           _g301337_)))
                              (let ((_attr218255_
                                     (let ()
                                       (declare (not safe))
                                       (##vector-ref _g301336_ 0)))
                                    (_attr-others218256_
                                     (let ()
                                       (declare (not safe))
                                       (##vector-ref _g301336_ 1))))
                                (let ((_g301338_
                                       (if (std/xml/ssax#attlist-null?
                                            _decl-attrs218252_)
                                           (values _largest-dummy-decl-attr218186_
                                                   _decl-attrs218252_)
                                           (std/xml/ssax#attlist-remove-top
                                            _decl-attrs218252_))))
                                  (begin
                                    (let ((_g301339_
                                           (let ()
                                             (declare (not safe))
                                             (if (##values? _g301338_)
                                                 (##vector-length _g301338_)
                                                 1))))
                                      (if (not (let ()
                                                 (declare (not safe))
                                                 (##fx= _g301339_ 2)))
                                          (error "Context expects 2 values"
                                                 _g301339_)))
                                    (let ((_decl-attr218258_
                                           (let ()
                                             (declare (not safe))
                                             (##vector-ref _g301338_ 0)))
                                          (_other-decls218259_
                                           (let ()
                                             (declare (not safe))
                                             (##vector-ref _g301338_ 1))))
                                      (let ()
                                        (let ((_$e218262_
                                               (std/xml/ssax#name-compare
                                                (car _attr218255_)
                                                (car _decl-attr218258_))))
                                          (if (eq? '< _$e218262_)
                                              (if (or (eq? _xmlns218185_
                                                           (car _attr218255_))
                                                      (and (pair? (car _attr218255_))
                                                           (eq? _xmlns218185_
                                                                (caar _attr218255_))))
                                                  (_loop218249_
                                                   _attr-others218256_
                                                   _decl-attrs218252_
                                                   (cons _attr218255_
                                                         _result218253_))
                                                  (std/xml/ssax#parser-error
                                                   _port218243_
                                                   '"[ValueType] broken for "
                                                   _attr218255_))
                                              (if (eq? '> _$e218262_)
                                                  (_loop218249_
                                                   _attlist218251_
                                                   _other-decls218259_
                                                   (_add-default-decl218247_
                                                    _decl-attr218258_
                                                    _result218253_))
                                                  (let ((_g301340_
                                                         (apply values
                                                                _decl-attr218258_)))
                                                    (begin
                                                      (let ((_g301341_
                                                             (let ()
                                                               (declare
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (not safe))
                       (if (##values? _g301340_)
                           (##vector-length _g301340_)
                           1))))
                (if (not (let () (declare (not safe)) (##fx= _g301341_ 4)))
                    (error "Context expects 4 values" _g301341_)))
              (let ((_attr-name218268_
                     (let () (declare (not safe)) (##vector-ref _g301340_ 0)))
                    (_content-type218269_
                     (let () (declare (not safe)) (##vector-ref _g301340_ 1)))
                    (_use-type218270_
                     (let () (declare (not safe)) (##vector-ref _g301340_ 2)))
                    (_default-value218271_
                     (let () (declare (not safe)) (##vector-ref _g301340_ 3))))
                (let ()
                  (if (eq? _use-type218270_ 'FIXED)
                      (let ((_$e218274_
                             (equal? (cdr _attr218255_)
                                     _default-value218271_)))
                        (if _$e218274_
                            _$e218274_
                            (std/xml/ssax#parser-error
                             _port218243_
                             '"[FixedAttr] broken for "
                             _attr-name218268_)))
                      (if (eq? _content-type218269_ 'CDATA)
                          '#t
                          (if (pair? _content-type218269_)
                              (let ((_$e218277_
                                     (member (cdr _attr218255_)
                                             _content-type218269_)))
                                (if _$e218277_
                                    _$e218277_
                                    (std/xml/ssax#parser-error
                                     _port218243_
                                     '"[enum] broken for "
                                     _attr-name218268_
                                     '"="
                                     (cdr _attr218255_))))
                              '#!void)))
                  (_loop218249_
                   _attr-others218256_
                   _other-decls218259_
                   (cons _attr218255_ _result218253_)))))))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
               (_add-ns218189_
                (lambda (_port218232_
                         _prefix218233_
                         _uri-str218234_
                         _namespaces218235_)
                  (if (equal? '"" _uri-str218234_)
                      (std/xml/ssax#parser-error
                       _port218232_
                       '"[dt-NSName] broken for "
                       _prefix218233_)
                      '#f)
                  (let ((_uri-symbol218237_ (string->symbol _uri-str218234_)))
                    (let _loop218239_ ((_nss218241_ _namespaces218235_))
                      (if (null? _nss218241_)
                          (cons (cons _prefix218233_
                                      (cons _uri-symbol218237_
                                            _uri-symbol218237_))
                                _namespaces218235_)
                          (if (eq? _uri-symbol218237_ (cddar _nss218241_))
                              (cons (cons _prefix218233_
                                          (cons (cadar _nss218241_)
                                                _uri-symbol218237_))
                                    _namespaces218235_)
                              (_loop218239_ (cdr _nss218241_))))))))
               (_adjust-namespace-decl218190_
                (lambda (_port218222_ _attrs218223_ _namespaces218224_)
                  (let _loop218226_ ((_attrs218228_ _attrs218223_)
                                     (_proper-attrs218229_ '())
                                     (_namespaces218230_ _namespaces218224_))
                    (if (null? _attrs218228_)
                        (values _proper-attrs218229_ _namespaces218230_)
                        (if (eq? _xmlns218185_ (caar _attrs218228_))
                            (_loop218226_
                             (cdr _attrs218228_)
                             _proper-attrs218229_
                             (if (equal? '"" (cdar _attrs218228_))
                                 (cons (cons '*DEFAULT* (cons '#f '#f))
                                       _namespaces218230_)
                                 (_add-ns218189_
                                  _port218222_
                                  '*DEFAULT*
                                  (cdar _attrs218228_)
                                  _namespaces218230_)))
                            (if (and (pair? (caar _attrs218228_))
                                     (eq? _xmlns218185_ (caaar _attrs218228_)))
                                (_loop218226_
                                 (cdr _attrs218228_)
                                 _proper-attrs218229_
                                 (_add-ns218189_
                                  _port218222_
                                  (cdaar _attrs218228_)
                                  (cdar _attrs218228_)
                                  _namespaces218230_))
                                (_loop218226_
                                 (cdr _attrs218228_)
                                 (cons (car _attrs218228_)
                                       _proper-attrs218229_)
                                 _namespaces218230_))))))))
        (lambda (_tag-head218192_
                 _port218193_
                 _elems218194_
                 _entities218195_
                 _namespaces218196_)
          (let* ((_attlist218198_
                  (std/xml/ssax#ssax:read-attributes
                   _port218193_
                   _entities218195_))
                 (_empty-el-tag?218200_
                  (begin
                    (std/xml/ssax#ssax:skip-S _port218193_)
                    (if (eqv? '#\/
                              (std/xml/ssax#assert-curr-char__%
                               '(#\> #\/)
                               '"XML [40], XML [44], no '>'"
                               _port218193_))
                        (std/xml/ssax#assert-curr-char__%
                         '(#\>)
                         '"XML [44], no '>'"
                         _port218193_)
                        '#f)))
                 (_g301342_
                  (if _elems218194_
                      (let ((_$e218202_
                             (assoc _tag-head218192_ _elems218194_)))
                        (if _$e218202_
                            ((lambda (_decl-elem218205_)
                               (values (if _empty-el-tag?218200_
                                           'EMPTY-TAG
                                           (cadr _decl-elem218205_))
                                       (caddr _decl-elem218205_)))
                             _$e218202_)
                            (std/xml/ssax#parser-error
                             _port218193_
                             '"[elementvalid] broken, no decl for "
                             _tag-head218192_)))
                      (values (if _empty-el-tag?218200_ 'EMPTY-TAG 'ANY)
                              '#f))))
            (begin
              (let ((_g301343_
                     (let ()
                       (declare (not safe))
                       (if (##values? _g301342_)
                           (##vector-length _g301342_)
                           1))))
                (if (not (let () (declare (not safe)) (##fx= _g301343_ 2)))
                    (error "Context expects 2 values" _g301343_)))
              (let ((_elem-content218207_
                     (let () (declare (not safe)) (##vector-ref _g301342_ 0)))
                    (_decl-attrs218208_
                     (let () (declare (not safe)) (##vector-ref _g301342_ 1))))
                (let* ((_merged-attrs218210_
                        (if _decl-attrs218208_
                            (_validate-attrs218188_
                             _port218193_
                             _attlist218198_
                             _decl-attrs218208_)
                            (std/xml/ssax#attlist->alist _attlist218198_)))
                       (_g301344_
                        (_adjust-namespace-decl218190_
                         _port218193_
                         _merged-attrs218210_
                         _namespaces218196_)))
                  (begin
                    (let ((_g301345_
                           (let ()
                             (declare (not safe))
                             (if (##values? _g301344_)
                                 (##vector-length _g301344_)
                                 1))))
                      (if (not (let ()
                                 (declare (not safe))
                                 (##fx= _g301345_ 2)))
                          (error "Context expects 2 values" _g301345_)))
                    (let ((_proper-attrs218212_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _g301344_ 0)))
                          (_namespaces218213_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _g301344_ 1))))
                      (let ()
                        (values (std/xml/ssax#ssax:resolve-name
                                 _port218193_
                                 _tag-head218192_
                                 _namespaces218213_
                                 '#t)
                                (std/xml/ssax#fold-right
                                 (lambda (_name-value218216_ _attlist218217_)
                                   (let ((_$e218219_
                                          (std/xml/ssax#attlist-add
                                           _attlist218217_
                                           (cons (std/xml/ssax#ssax:resolve-name
                                                  _port218193_
                                                  (car _name-value218216_)
                                                  _namespaces218213_
                                                  '#f)
                                                 (cdr _name-value218216_)))))
                                     (if _$e218219_
                                         _$e218219_
                                         (std/xml/ssax#parser-error
                                          _port218193_
                                          '"[uniqattspec] after NS expansion broken for "
                                          _name-value218216_))))
                                 (std/xml/ssax#make-empty-attlist)
                                 _proper-attrs218212_)
                                _namespaces218213_
                                _elem-content218207_))))))))))))
  (define std/xml/ssax#ssax:read-external-id
    (lambda (_port218171_)
      (let ((_discriminator218173_
             (std/xml/ssax#ssax:read-NCName _port218171_)))
        (std/xml/ssax#assert-curr-char__%
         std/xml/ssax#ssax:S-chars
         '"space after SYSTEM or PUBLIC"
         _port218171_)
        (std/xml/ssax#ssax:skip-S _port218171_)
        (let ((_delimiter218175_
               (std/xml/ssax#assert-curr-char__%
                '(#\' #\")
                '"XML [11], XML [12]"
                _port218171_)))
          (if (eq? _discriminator218173_ (string->symbol '"SYSTEM"))
              (let ((_$r218177_
                     (std/xml/ssax#next-token__%
                      '()
                      (list _delimiter218175_)
                      '"XML [11]"
                      _port218171_)))
                (read-char _port218171_)
                _$r218177_)
              (if (eq? _discriminator218173_ (string->symbol '"PUBLIC"))
                  (begin
                    (std/xml/ssax#skip-until__%
                     (list _delimiter218175_)
                     _port218171_)
                    (std/xml/ssax#assert-curr-char__%
                     std/xml/ssax#ssax:S-chars
                     '"space after PubidLiteral"
                     _port218171_)
                    (std/xml/ssax#ssax:skip-S _port218171_)
                    (let* ((_delimiter218180_
                            (std/xml/ssax#assert-curr-char__%
                             '(#\' #\")
                             '"XML [11]"
                             _port218171_))
                           (_systemid218182_
                            (std/xml/ssax#next-token__%
                             '()
                             (list _delimiter218180_)
                             '"XML [11]"
                             _port218171_)))
                      (read-char _port218171_)
                      _systemid218182_))
                  (std/xml/ssax#parser-error
                   _port218171_
                   '"XML [75], "
                   _discriminator218173_
                   '" rather than SYSTEM or PUBLIC")))))))
  (define std/xml/ssax#ssax:scan-Misc
    (lambda (_port218154_)
      (let _loop218156_ ((_c218158_ (std/xml/ssax#ssax:skip-S _port218154_)))
        (if (eof-object? _c218158_)
            _c218158_
            (if (not (char=? _c218158_ '#\<))
                (std/xml/ssax#parser-error
                 _port218154_
                 '"XML [22], char '"
                 _c218158_
                 '"' unexpected")
                (let* ((_token218160_
                        (std/xml/ssax#ssax:read-markup-token _port218154_))
                       (_$e218162_ (car _token218160_)))
                  (if (eq? 'COMMENT _$e218162_)
                      (_loop218156_ (std/xml/ssax#ssax:skip-S _port218154_))
                      (if (or (eq? 'PI _$e218162_)
                              (eq? 'DECL _$e218162_)
                              (eq? 'START _$e218162_))
                          _token218160_
                          (std/xml/ssax#parser-error
                           _port218154_
                           '"XML [22], unexpected token of kind "
                           (car _token218160_))))))))))
  (define std/xml/ssax#ssax:read-char-data
    (let ((_terminators-usual218111_ (list '#\< '#\& std/xml/ssax#char-return))
          (_terminators-usual-eof218112_
           (list '#\< '*eof* '#\& std/xml/ssax#char-return))
          (_handle-fragment218113_
           (lambda (_fragment218107_ _str-handler218108_ _seed218109_)
             (if (std/xml/ssax#string-null? _fragment218107_)
                 _seed218109_
                 (_str-handler218108_ _fragment218107_ '"" _seed218109_)))))
      (lambda (_port218115_
               _expect-eof?218116_
               _str-handler218117_
               _seed218118_)
        (if (eqv? '#\< (peek-char _port218115_))
            (let* ((_token218120_
                    (std/xml/ssax#ssax:read-markup-token _port218115_))
                   (_$e218122_ (car _token218120_)))
              (if (or (eq? 'START _$e218122_) (eq? 'END _$e218122_))
                  (values _seed218118_ _token218120_)
                  (if (eq? 'CDSECT _$e218122_)
                      (let ((_seed218128_
                             (std/xml/ssax#ssax:read-cdata-body
                              _port218115_
                              _str-handler218117_
                              _seed218118_)))
                        (std/xml/ssax#ssax:read-char-data
                         _port218115_
                         _expect-eof?218116_
                         _str-handler218117_
                         _seed218128_))
                      (if (eq? 'COMMENT _$e218122_)
                          (std/xml/ssax#ssax:read-char-data
                           _port218115_
                           _expect-eof?218116_
                           _str-handler218117_
                           _seed218118_)
                          (values _seed218118_ _token218120_)))))
            (let ((_char-data-terminators218130_
                   (if _expect-eof?218116_
                       _terminators-usual-eof218112_
                       _terminators-usual218111_)))
              (let _loop218132_ ((_seed218134_ _seed218118_))
                (let* ((_fragment218136_
                        (std/xml/ssax#next-token__%
                         '()
                         _char-data-terminators218130_
                         '"reading char data"
                         _port218115_))
                       (_term-char218138_ (peek-char _port218115_)))
                  (if (eof-object? _term-char218138_)
                      (values (_handle-fragment218113_
                               _fragment218136_
                               _str-handler218117_
                               _seed218134_)
                              _term-char218138_)
                      (let ((_$e218141_ _term-char218138_))
                        (if (eq? '#\< _$e218141_)
                            (let* ((_token218144_
                                    (std/xml/ssax#ssax:read-markup-token
                                     _port218115_))
                                   (_$e218146_ (car _token218144_)))
                              (if (eq? 'CDSECT _$e218146_)
                                  (_loop218132_
                                   (std/xml/ssax#ssax:read-cdata-body
                                    _port218115_
                                    _str-handler218117_
                                    (_handle-fragment218113_
                                     _fragment218136_
                                     _str-handler218117_
                                     _seed218134_)))
                                  (if (eq? 'COMMENT _$e218146_)
                                      (_loop218132_
                                       (_handle-fragment218113_
                                        _fragment218136_
                                        _str-handler218117_
                                        _seed218134_))
                                      (values (_handle-fragment218113_
                                               _fragment218136_
                                               _str-handler218117_
                                               _seed218134_)
                                              _token218144_))))
                            (if (eq? '#\& _$e218141_)
                                (let ((_$e218149_
                                       (std/xml/ssax#peek-next-char__%
                                        _port218115_)))
                                  (if (eq? '#\# _$e218149_)
                                      (begin
                                        (read-char _port218115_)
                                        (_loop218132_
                                         (_str-handler218117_
                                          _fragment218136_
                                          (string (std/xml/ssax#ssax:read-char-ref
                                                   _port218115_))
                                          _seed218134_)))
                                      (let ((_name218152_
                                             (std/xml/ssax#ssax:read-NCName
                                              _port218115_)))
                                        (std/xml/ssax#assert-curr-char__%
                                         '(#\;)
                                         '"XML [68]"
                                         _port218115_)
                                        (values (_handle-fragment218113_
                                                 _fragment218136_
                                                 _str-handler218117_
                                                 _seed218134_)
                                                (cons 'ENTITY-REF
                                                      _name218152_)))))
                                (begin
                                  (if (eqv? (std/xml/ssax#peek-next-char__%
                                             _port218115_)
                                            '#\newline)
                                      (read-char _port218115_)
                                      '#!void)
                                  (_loop218132_
                                   (_str-handler218117_
                                    _fragment218136_
                                    (string '#\newline)
                                    _seed218134_))))))))))))))
  (define std/xml/ssax#ssax:assert-token
    (lambda (_token218099_ _kind218100_ _gi218101_ _error-cont218102_)
      (let ((_$e218104_
             (if (std/xml/ssax#xml-token? _token218099_)
                 (if (eq? _kind218100_ (car _token218099_))
                     (equal? _gi218101_ (cdr _token218099_))
                     '#f)
                 '#f)))
        (if _$e218104_
            _$e218104_
            (_error-cont218102_ _token218099_ _kind218100_ _gi218101_)))))
  (define std/xml/ssax#ssax:reverse-collect-str
    (lambda (_fragments218091_)
      (if (null? _fragments218091_)
          '()
          (if (null? (cdr _fragments218091_))
              _fragments218091_
              (let _loop218093_ ((_fragments218095_ _fragments218091_)
                                 (_result218096_ '())
                                 (_strs218097_ '()))
                (if (null? _fragments218095_)
                    (if (null? _strs218097_)
                        _result218096_
                        (cons (std/srfi/13#string-concatenate/shared
                               _strs218097_)
                              _result218096_))
                    (if (string? (car _fragments218095_))
                        (_loop218093_
                         (cdr _fragments218095_)
                         _result218096_
                         (cons (car _fragments218095_) _strs218097_))
                        (_loop218093_
                         (cdr _fragments218095_)
                         (cons (car _fragments218095_)
                               (if (null? _strs218097_)
                                   _result218096_
                                   (cons (std/srfi/13#string-concatenate/shared
                                          _strs218097_)
                                         _result218096_)))
                         '()))))))))
  (define std/xml/ssax#ssax:reverse-collect-str-drop-ws
    (lambda (_fragments218082_)
      (if (null? _fragments218082_)
          '()
          (if (null? (cdr _fragments218082_))
              (if (and (string? (car _fragments218082_))
                       (std/xml/ssax#string-whitespace?
                        (car _fragments218082_)))
                  '()
                  _fragments218082_)
              (let _loop218084_ ((_fragments218086_ _fragments218082_)
                                 (_result218087_ '())
                                 (_strs218088_ '())
                                 (_all-whitespace?218089_ '#t))
                (if (null? _fragments218086_)
                    (if _all-whitespace?218089_
                        _result218087_
                        (cons (std/srfi/13#string-concatenate/shared
                               _strs218088_)
                              _result218087_))
                    (if (string? (car _fragments218086_))
                        (_loop218084_
                         (cdr _fragments218086_)
                         _result218087_
                         (cons (car _fragments218086_) _strs218088_)
                         (if _all-whitespace?218089_
                             (std/xml/ssax#string-whitespace?
                              (car _fragments218086_))
                             '#f))
                        (_loop218084_
                         (cdr _fragments218086_)
                         (cons (car _fragments218086_)
                               (if _all-whitespace?218089_
                                   _result218087_
                                   (cons (std/srfi/13#string-concatenate/shared
                                          _strs218088_)
                                         _result218087_)))
                         '()
                         '#t))))))))
  (define std/xml/ssax#ssax:xml->sxml
    (lambda (_port213110_ _namespace-prefix-assig213111_)
      (letrec ((_namespaces213113_
                (map (lambda (_el213116_)
                       (cons '#f
                             (cons (car _el213116_)
                                   (string->symbol (cdr _el213116_)))))
                     _namespace-prefix-assig213111_))
               (_RES-NAME->SXML213114_
                (lambda (_res-name213118_)
                  (string->symbol
                   (string-append
                    (symbol->string (car _res-name213118_))
                    '":"
                    (symbol->string (cdr _res-name213118_)))))))
        (let ((_result218078_
               (reverse ((lambda (_port215145_ _seed215147_)
                           (letrec ((_handle-decl215150_
                                     (lambda (_port218044_
                                              _token-head218045_
                                              _seed218047_)
                                       (let ((_$e218049_
                                              (eq? (string->symbol '"DOCTYPE")
                                                   _token-head218045_)))
                                         (if _$e218049_
                                             _$e218049_
                                             (std/xml/ssax#parser-error
                                              _port218044_
                                              '"XML [22], expected DOCTYPE declaration, found "
                                              _token-head218045_)))
                                       (std/xml/ssax#assert-curr-char__%
                                        std/xml/ssax#ssax:S-chars
                                        '"XML [28], space after DOCTYPE"
                                        _port218044_)
                                       (std/xml/ssax#ssax:skip-S _port218044_)
                                       (let* ((_docname218052_
                                               (std/xml/ssax#ssax:read-QName
                                                _port218044_))
                                              (_systemid218055_
                                               (if (std/xml/ssax#ssax:ncname-starting-char?
                                                    (std/xml/ssax#ssax:skip-S
                                                     _port218044_))
                                                   (std/xml/ssax#ssax:read-external-id
                                                    _port218044_)
                                                   '#f))
                                              (_internal-subset?218058_
                                               (begin
                                                 (std/xml/ssax#ssax:skip-S
                                                  _port218044_)
                                                 (eqv? '#\[
                                                       (std/xml/ssax#assert-curr-char__%
                                                        '(#\> #\[)
                                                        '"XML [28], end-of-DOCTYPE"
                                                        _port218044_))))
                                              (_g301346_
                                               ((lambda (_port218061_
                                                         _docname218063_
                                                         _systemid218065_
                                                         _internal-subset?218067_
                                                         _seed218069_)
                                                  (if _internal-subset?218067_
                                                      (std/xml/ssax#ssax:skip-internal-dtd
                                                       _port218061_)
                                                      '#!void)
                                                  (values '#f
                                                          '()
                                                          _namespaces213113_
                                                          _seed218069_))
                                                _port218044_
                                                _docname218052_
                                                _systemid218055_
                                                _internal-subset?218058_
                                                _seed218047_)))
                                         (begin
                                           (let ((_g301347_
                                                  (let ()
                                                    (declare (not safe))
                                                    (if (##values? _g301346_)
                                                        (##vector-length
                                                         _g301346_)
                                                        1))))
                                             (if (not (let ()
                                                        (declare (not safe))
                                                        (##fx= _g301347_ 4)))
                                                 (error "Context expects 4 values"
                                                        _g301347_)))
                                           (let ((_elems218072_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##vector-ref
                                                     _g301346_
                                                     0)))
                                                 (_entities218073_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##vector-ref
                                                     _g301346_
                                                     1)))
                                                 (_namespaces218074_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##vector-ref
                                                     _g301346_
                                                     2)))
                                                 (_seed218075_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##vector-ref
                                                     _g301346_
                                                     3))))
                                             (let ()
                                               (_scan-for-significant-prolog-token-2215154_
                                                _port218044_
                                                _elems218072_
                                                _entities218073_
                                                _namespaces218074_
                                                _seed218075_)))))))
                                    (_scan-for-significant-prolog-token-1215152_
                                     (lambda (_port217137_ _seed217138_)
                                       (let ((_token217140_
                                              (std/xml/ssax#ssax:scan-Misc
                                               _port217137_)))
                                         (if (eof-object? _token217140_)
                                             (std/xml/ssax#parser-error
                                              _port217137_
                                              '"XML [22], unexpected EOF")
                                             (let ((_$e217142_
                                                    (car _token217140_)))
                                               (if (eq? 'PI _$e217142_)
                                                   (let ((_seed218031_
                                                          ((lambda (_port218020_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _target218021_
                            _seed218022_)
                     (let ((_$e218024_ _target218021_))
                       ((lambda (_port218027_ _pi-tag218028_ _seed218029_)
                          (cons (list '*PI*
                                      _pi-tag218028_
                                      (std/xml/ssax#ssax:read-pi-body-as-string
                                       _port218027_))
                                _seed218029_))
                        _port218020_
                        _target218021_
                        _seed218022_)))
                   _port217137_
                   (cdr _token217140_)
                   _seed217138_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_scan-for-significant-prolog-token-1215152_
                                                      _port217137_
                                                      _seed218031_))
                                                   (if (eq? 'DECL _$e217142_)
                                                       (_handle-decl215150_
                                                        _port217137_
                                                        (cdr _token217140_)
                                                        _seed217138_)
                                                       (if (eq? 'START
                                                                _$e217142_)
                                                           (let ((_g301348_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          ((lambda (_elem-gi218033_ _seed218035_)
                             (values '#f '() _namespaces213113_ _seed218035_))
                           (cdr _token217140_)
                           _seed217138_)))
                     (begin
                       (let ((_g301349_
                              (let ()
                                (declare (not safe))
                                (if (##values? _g301348_)
                                    (##vector-length _g301348_)
                                    1))))
                         (if (not (let ()
                                    (declare (not safe))
                                    (##fx= _g301349_ 4)))
                             (error "Context expects 4 values" _g301349_)))
                       (let ((_elems218038_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _g301348_ 0)))
                             (_entities218039_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _g301348_ 1)))
                             (_namespaces218040_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _g301348_ 2)))
                             (_seed218041_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _g301348_ 3))))
                         (let ()
                           (_element-parser215156_
                            (cdr _token217140_)
                            _port217137_
                            _elems218038_
                            _entities218039_
                            _namespaces218040_
                            '#f
                            _seed218041_)))))
                   (std/xml/ssax#parser-error
                    _port217137_
                    '"XML [22], unexpected markup "
                    _token217140_)))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                    (_scan-for-significant-prolog-token-2215154_
                                     (lambda (_port216229_
                                              _elems216230_
                                              _entities216232_
                                              _namespaces216234_
                                              _seed216236_)
                                       (let ((_token216238_
                                              (std/xml/ssax#ssax:scan-Misc
                                               _port216229_)))
                                         (if (eof-object? _token216238_)
                                             (std/xml/ssax#parser-error
                                              _port216229_
                                              '"XML [22], unexpected EOF")
                                             (let ((_$e216241_
                                                    (car _token216238_)))
                                               (if (eq? 'PI _$e216241_)
                                                   (let ((_seed217130_
                                                          ((lambda (_port217119_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _target217120_
                            _seed217121_)
                     (let ((_$e217123_ _target217120_))
                       ((lambda (_port217126_ _pi-tag217127_ _seed217128_)
                          (cons (list '*PI*
                                      _pi-tag217127_
                                      (std/xml/ssax#ssax:read-pi-body-as-string
                                       _port217126_))
                                _seed217128_))
                        _port217119_
                        _target217120_
                        _seed217121_)))
                   _port216229_
                   (cdr _token216238_)
                   _seed216236_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_scan-for-significant-prolog-token-2215154_
                                                      _port216229_
                                                      _elems216230_
                                                      _entities216232_
                                                      _namespaces216234_
                                                      _seed217130_))
                                                   (if (eq? 'START _$e216241_)
                                                       (_element-parser215156_
                                                        (cdr _token216238_)
                                                        _port216229_
                                                        _elems216230_
                                                        _entities216232_
                                                        _namespaces216234_
                                                        '#f
                                                        ((lambda (_elem-gi217132_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _seed217134_)
                   _seed217134_)
                 (cdr _token216238_)
                 _seed216236_))
               (std/xml/ssax#parser-error
                _port216229_
                '"XML [22], unexpected markup "
                _token216238_))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                    (_element-parser215156_
                                     (lambda (_start-tag-head215159_
                                              _port215161_
                                              _elems215163_
                                              _entities215165_
                                              _namespaces215167_
                                              _preserve-ws?215169_
                                              _seed215171_)
                                       (letrec* ((_xml-space-gi215174_
                                                  (cons std/xml/ssax#ssax:Prefix-XML
                                                        (string->symbol
                                                         '"space"))))
                                         (let _handle-start-tag215177_ ((_start-tag-head215180_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                                 _start-tag-head215159_)
                                (_port215181_ _port215161_)
                                (_entities215182_ _entities215165_)
                                (_namespaces215183_ _namespaces215167_)
                                (_preserve-ws?215184_ _preserve-ws?215169_)
                                (_parent-seed215185_ _seed215171_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                           (let ((_g301350_
                                                  (std/xml/ssax#ssax:complete-start-tag
                                                   _start-tag-head215180_
                                                   _port215181_
                                                   _elems215163_
                                                   _entities215182_
                                                   _namespaces215183_)))
                                             (begin
                                               (let ((_g301351_
                                                      (let ()
                                                        (declare (not safe))
                                                        (if (##values?
                                                             _g301350_)
                                                            (##vector-length
                                                             _g301350_)
                                                            1))))
                                                 (if (not (let ()
                                                            (declare
                                                              (not safe))
                                                            (##fx= _g301351_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           4)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (error "Context expects 4 values"
                                                            _g301351_)))
                                               (let ((_elem-gi215188_
                                                      (let ()
                                                        (declare (not safe))
                                                        (##vector-ref
                                                         _g301350_
                                                         0)))
                                                     (_attributes215190_
                                                      (let ()
                                                        (declare (not safe))
                                                        (##vector-ref
                                                         _g301350_
                                                         1)))
                                                     (_namespaces215192_
                                                      (let ()
                                                        (declare (not safe))
                                                        (##vector-ref
                                                         _g301350_
                                                         2)))
                                                     (_expected-content215193_
                                                      (let ()
                                                        (declare (not safe))
                                                        (##vector-ref
                                                         _g301350_
                                                         3))))
                                                 (let ((_seed215207_
                                                        ((lambda (_elem-gi215196_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _attributes215198_
                          _namespaces215200_
                          _expected-content215202_
                          _seed215204_)
                   '())
                 _elem-gi215188_
                 _attributes215190_
                 _namespaces215192_
                 _expected-content215193_
                 _parent-seed215185_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (let ((_$e215210_
                                                          _expected-content215193_))
                                                     (if (eq? 'EMPTY-TAG
                                                              _$e215210_)
                                                         ((lambda (_elem-gi215213_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           _attributes215215_
                           _namespaces215217_
                           _parent-seed215219_
                           _seed215221_)
                    (let ((_seed215229_
                           (std/xml/ssax#ssax:reverse-collect-str-drop-ws
                            _seed215221_))
                          (_attrs215230_
                           (std/xml/ssax#attlist-fold
                            (lambda (_attr215224_ _accum215226_)
                              (cons (list (if (symbol? (car _attr215224_))
                                              (car _attr215224_)
                                              (_RES-NAME->SXML213114_
                                               (car _attr215224_)))
                                          (cdr _attr215224_))
                                    _accum215226_))
                            '()
                            _attributes215215_)))
                      (cons (cons (if (symbol? _elem-gi215213_)
                                      _elem-gi215213_
                                      (_RES-NAME->SXML213114_ _elem-gi215213_))
                                  (if (null? _attrs215230_)
                                      _seed215229_
                                      (cons (cons '@ _attrs215230_)
                                            _seed215229_)))
                            _parent-seed215219_)))
                  _elem-gi215188_
                  _attributes215190_
                  _namespaces215192_
                  _parent-seed215185_
                  _seed215207_)
                 (if (eq? 'EMPTY _$e215210_)
                     (begin
                       (std/xml/ssax#ssax:assert-token
                        (if (eqv? '#\< (std/xml/ssax#ssax:skip-S _port215181_))
                            (std/xml/ssax#ssax:read-markup-token _port215181_)
                            '#f)
                        'END
                        _start-tag-head215180_
                        (lambda (_token215233_
                                 _exp-kind215235_
                                 _exp-head215237_)
                          (std/xml/ssax#parser-error
                           _port215181_
                           '"[elementvalid] broken for "
                           _token215233_
                           '" while expecting "
                           _exp-kind215235_
                           _exp-head215237_)))
                       ((lambda (_elem-gi215240_
                                 _attributes215241_
                                 _namespaces215242_
                                 _parent-seed215243_
                                 _seed215244_)
                          (let ((_seed215249_
                                 (std/xml/ssax#ssax:reverse-collect-str-drop-ws
                                  _seed215244_))
                                (_attrs215250_
                                 (std/xml/ssax#attlist-fold
                                  (lambda (_attr215246_ _accum215247_)
                                    (cons (list (if (symbol? (car _attr215246_))
                                                    (car _attr215246_)
                                                    (_RES-NAME->SXML213114_
                                                     (car _attr215246_)))
                                                (cdr _attr215246_))
                                          _accum215247_))
                                  '()
                                  _attributes215241_)))
                            (cons (cons (if (symbol? _elem-gi215240_)
                                            _elem-gi215240_
                                            (_RES-NAME->SXML213114_
                                             _elem-gi215240_))
                                        (if (null? _attrs215250_)
                                            _seed215249_
                                            (cons (cons '@ _attrs215250_)
                                                  _seed215249_)))
                                  _parent-seed215243_)))
                        _elem-gi215188_
                        _attributes215190_
                        _namespaces215192_
                        _parent-seed215185_
                        _seed215207_))
                     (let ((_preserve-ws?215258_
                            (let ((_$e215252_
                                   (assoc _xml-space-gi215174_
                                          _attributes215190_)))
                              (if _$e215252_
                                  ((lambda (_name-value215255_)
                                     (equal? '"preserve"
                                             (cdr _name-value215255_)))
                                   _$e215252_)
                                  _preserve-ws?215184_))))
                       (let _loop215260_ ((_port215263_ _port215181_)
                                          (_entities215264_ _entities215182_)
                                          (_expect-eof?215265_ '#f)
                                          (_seed215267_ _seed215207_))
                         (let ((_g301352_
                                (std/xml/ssax#ssax:read-char-data
                                 _port215263_
                                 _expect-eof?215265_
                                 (lambda (_string1215269_
                                          _string2215271_
                                          _seed215273_)
                                   (if (std/xml/ssax#string-null?
                                        _string2215271_)
                                       (cons _string1215269_ _seed215273_)
                                       (cons _string2215271_
                                             (cons _string1215269_
                                                   _seed215273_))))
                                 _seed215267_)))
                           (begin
                             (let ((_g301353_
                                    (let ()
                                      (declare (not safe))
                                      (if (##values? _g301352_)
                                          (##vector-length _g301352_)
                                          1))))
                               (if (not (let ()
                                          (declare (not safe))
                                          (##fx= _g301353_ 2)))
                                   (error "Context expects 2 values"
                                          _g301353_)))
                             (let ((_seed215276_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _g301352_ 0)))
                                   (_term-token215277_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _g301352_ 1))))
                               (let ()
                                 (if (eof-object? _term-token215277_)
                                     _seed215276_
                                     (let ((_$e215281_
                                            (car _term-token215277_)))
                                       (if (eq? 'END _$e215281_)
                                           (begin
                                             (std/xml/ssax#ssax:assert-token
                                              _term-token215277_
                                              'END
                                              _start-tag-head215180_
                                              (lambda (_token215284_
                                                       _exp-kind215285_
                                                       _exp-head215286_)
                                                (std/xml/ssax#parser-error
                                                 _port215263_
                                                 '"[GIMatch] broken for "
                                                 _term-token215277_
                                                 '" while expecting "
                                                 _exp-kind215285_
                                                 _exp-head215286_)))
                                             ((lambda (_elem-gi215288_
                                                       _attributes215289_
                                                       _namespaces215290_
                                                       _parent-seed215291_
                                                       _seed215292_)
                                                (let ((_seed215297_
                                                       (std/xml/ssax#ssax:reverse-collect-str-drop-ws
                                                        _seed215292_))
                                                      (_attrs215298_
                                                       (std/xml/ssax#attlist-fold
                                                        (lambda (_attr215294_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _accum215295_)
                  (cons (list (if (symbol? (car _attr215294_))
                                  (car _attr215294_)
                                  (_RES-NAME->SXML213114_ (car _attr215294_)))
                              (cdr _attr215294_))
                        _accum215295_))
                '()
                _attributes215289_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                  (cons (cons (if (symbol? _elem-gi215288_)
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _elem-gi215288_
                          (_RES-NAME->SXML213114_ _elem-gi215288_))
                      (if (null? _attrs215298_)
                          _seed215297_
                          (cons (cons '@ _attrs215298_) _seed215297_)))
                _parent-seed215291_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              _elem-gi215188_
                                              _attributes215190_
                                              _namespaces215192_
                                              _parent-seed215185_
                                              _seed215276_))
                                           (if (eq? 'PI _$e215281_)
                                               (let ((_seed216215_
                                                      ((lambda (_port216201_
                                                                _target216202_
                                                                _seed216203_)
                                                         (let ((_$e216205_
                                                                _target216202_))
                                                           ((lambda (_port216208_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                             _pi-tag216210_
                             _seed216212_)
                      (cons (list '*PI*
                                  _pi-tag216210_
                                  (std/xml/ssax#ssax:read-pi-body-as-string
                                   _port216208_))
                            _seed216212_))
                    _port216201_
                    _target216202_
                    _seed216203_)))
               _port215263_
               (cdr _term-token215277_)
               _seed215276_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (_loop215260_
                                                  _port215263_
                                                  _entities215264_
                                                  _expect-eof?215265_
                                                  _seed216215_))
                                               (if (eq? 'ENTITY-REF _$e215281_)
                                                   (let ((_seed216225_
                                                          (std/xml/ssax#ssax:handle-parsed-entity
                                                           _port215263_
                                                           (cdr _term-token215277_)
                                                           _entities215264_
                                                           (lambda (_port216217_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _entities216218_
                            _seed216219_)
                     (_loop215260_
                      _port216217_
                      _entities216218_
                      '#t
                      _seed216219_))
                   (lambda (_string1216221_ _string2216222_ _seed216223_)
                     (if (std/xml/ssax#string-null? _string2216222_)
                         (cons _string1216221_ _seed216223_)
                         (cons _string2216222_
                               (cons _string1216221_ _seed216223_))))
                   _seed215276_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_loop215260_
                                                      _port215263_
                                                      _entities215264_
                                                      _expect-eof?215265_
                                                      _seed216225_))
                                                   (if (eq? 'START _$e215281_)
                                                       (begin
                                                         (if (eq? _expected-content215193_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          'PCDATA)
                     (std/xml/ssax#parser-error
                      _port215263_
                      '"[elementvalid] broken for "
                      _elem-gi215188_
                      '" with char content only; unexpected token "
                      _term-token215277_)
                     '#!void)
                 (let ((_seed216227_
                        (_handle-start-tag215177_
                         (cdr _term-token215277_)
                         _port215263_
                         _entities215264_
                         _namespaces215192_
                         _preserve-ws?215258_
                         _seed215276_)))
                   (_loop215260_
                    _port215263_
                    _entities215264_
                    _expect-eof?215265_
                    _seed216227_)))
               (std/xml/ssax#parser-error
                _port215263_
                '"XML [43] broken for "
                _term-token215277_)))))))))))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                             (_scan-for-significant-prolog-token-1215152_
                              _port215145_
                              _seed215147_)))
                         _port213110_
                         '()))))
          (cons '*TOP*
                (if (null? _namespace-prefix-assig213111_)
                    _result218078_
                    (cons (list '@
                                (cons '*NAMESPACES*
                                      (map (lambda (_ns218080_)
                                             (list (car _ns218080_)
                                                   (cdr _ns218080_)))
                                           _namespace-prefix-assig213111_)))
                          _result218078_)))))))
  (define std/xml/ssax#SSAX:XML->SXML std/xml/ssax#ssax:xml->sxml))
