(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/xml/sxpath#string-null? string-empty?)
  (define std/xml/sxpath#nl (string '#\newline))
  (define std/xml/sxpath#cout
    (lambda _args227671_
      (for-each
       (lambda (_x227673_)
         (if (procedure? _x227673_) (_x227673_) (display _x227673_)))
       _args227671_)))
  (define std/xml/sxpath#cerr
    (lambda _args227667_
      (for-each
       (lambda (_x227669_)
         (if (procedure? _x227669_)
             (_x227669_ (current-error-port))
             (display _x227669_ (current-error-port))))
       _args227667_)))
  (define std/xml/sxpath#nodeset?
    (lambda (_x227662_)
      (let ((_$e227664_
             (if (pair? _x227662_) (not (symbol? (car _x227662_))) '#f)))
        (if _$e227664_ _$e227664_ (null? _x227662_)))))
  (define std/xml/sxpath#node-typeof?
    (lambda (_crit227655_)
      (lambda (_node227657_)
        (let ((_$e227659_ _crit227655_))
          (if (eq? '* _$e227659_)
              (if (pair? _node227657_)
                  (not (memq (car _node227657_) '(@ *PI*)))
                  '#f)
              (if (eq? '*any* _$e227659_)
                  '#t
                  (if (eq? '*text* _$e227659_)
                      (string? _node227657_)
                      (if (pair? _node227657_)
                          (eq? _crit227655_ (car _node227657_))
                          '#f))))))))
  (define std/xml/sxpath#node-eq?
    (lambda (_other227651_)
      (lambda (_node227653_) (eq? _other227651_ _node227653_))))
  (define std/xml/sxpath#node-equal?
    (lambda (_other227647_)
      (lambda (_node227649_) (equal? _other227647_ _node227649_))))
  (define std/xml/sxpath#node-pos
    (lambda (_n224652_)
      (lambda (_nodeset224654_)
        (if (not (std/xml/sxpath#nodeset? _nodeset224654_))
            '()
            (if (null? _nodeset224654_)
                _nodeset224654_
                (if (eqv? _n224652_ '1)
                    (list (car _nodeset224654_))
                    (if (negative? _n224652_)
                        ((std/xml/sxpath#node-pos
                          (+ _n224652_ '1 (length _nodeset224654_)))
                         _nodeset224654_)
                        (begin
                          (let ((_$e226022_ (positive? _n224652_)))
                            (if _$e226022_
                                _$e226022_
                                (begin
                                  (std/xml/sxpath#cerr
                                   '"failed assertion: "
                                   '(positive? n)
                                   std/xml/sxpath#nl
                                   '"bindings"
                                   '#\newline
                                   'n
                                   '": "
                                   _n224652_
                                   std/xml/sxpath#nl)
                                  (error '"assertion failure"))))
                          ((std/xml/sxpath#node-pos (- _n224652_ '1))
                           (cdr _nodeset224654_))))))))))
  (define std/xml/sxpath#filter
    (lambda (_pred?224641_)
      (lambda (_lst224643_)
        (let _loop224645_ ((_lst224647_
                            (if (std/xml/sxpath#nodeset? _lst224643_)
                                _lst224643_
                                (list _lst224643_)))
                           (_res224648_ '()))
          (if (null? _lst224647_)
              (reverse _res224648_)
              (let ((_pred-result224650_ (_pred?224641_ (car _lst224647_))))
                (_loop224645_
                 (cdr _lst224647_)
                 (if (and _pred-result224650_
                          (not (null? _pred-result224650_)))
                     (cons (car _lst224647_) _res224648_)
                     _res224648_))))))))
  (define std/xml/sxpath#take-until
    (lambda (_pred?224631_)
      (lambda (_lst224633_)
        (let _loop224635_ ((_lst224637_
                            (if (std/xml/sxpath#nodeset? _lst224633_)
                                _lst224633_
                                (list _lst224633_))))
          (if (null? _lst224637_)
              _lst224637_
              (let ((_pred-result224639_ (_pred?224631_ (car _lst224637_))))
                (if (and _pred-result224639_ (not (null? _pred-result224639_)))
                    '()
                    (cons (car _lst224637_)
                          (_loop224635_ (cdr _lst224637_))))))))))
  (define std/xml/sxpath#take-after
    (lambda (_pred?224621_)
      (lambda (_lst224623_)
        (let _loop224625_ ((_lst224627_
                            (if (std/xml/sxpath#nodeset? _lst224623_)
                                _lst224623_
                                (list _lst224623_))))
          (if (null? _lst224627_)
              _lst224627_
              (let ((_pred-result224629_ (_pred?224621_ (car _lst224627_))))
                (if (and _pred-result224629_ (not (null? _pred-result224629_)))
                    (cdr _lst224627_)
                    (_loop224625_ (cdr _lst224627_)))))))))
  (define std/xml/sxpath#map-union
    (lambda (_proc224616_ _lst224617_)
      (if (null? _lst224617_)
          _lst224617_
          (let ((_proc-res224619_ (_proc224616_ (car _lst224617_))))
            ((if (std/xml/sxpath#nodeset? _proc-res224619_) append cons)
             _proc-res224619_
             (std/xml/sxpath#map-union _proc224616_ (cdr _lst224617_)))))))
  (define std/xml/sxpath#node-reverse
    (lambda (_node-or-nodeset224614_)
      (if (not (std/xml/sxpath#nodeset? _node-or-nodeset224614_))
          (list _node-or-nodeset224614_)
          (reverse _node-or-nodeset224614_))))
  (define std/xml/sxpath#node-trace
    (lambda (_title224610_)
      (lambda (_node-or-nodeset224612_)
        (std/xml/sxpath#cout std/xml/sxpath#nl '"-->")
        (display _title224610_)
        (display '" :")
        (pretty-print _node-or-nodeset224612_)
        _node-or-nodeset224612_)))
  (define std/xml/sxpath#select-kids
    (lambda (_test-pred?224606_)
      (lambda (_node224608_)
        (if (null? _node224608_)
            _node224608_
            (if (not (pair? _node224608_))
                '()
                (if (symbol? (car _node224608_))
                    ((std/xml/sxpath#filter _test-pred?224606_)
                     (cdr _node224608_))
                    (std/xml/sxpath#map-union
                     (std/xml/sxpath#select-kids _test-pred?224606_)
                     _node224608_)))))))
  (define std/xml/sxpath#node-self std/xml/sxpath#filter)
  (define std/xml/sxpath#node-join
    (lambda _selectors224597_
      (lambda (_nodeset224599_)
        (let _loop224601_ ((_nodeset224603_ _nodeset224599_)
                           (_selectors224604_ _selectors224597_))
          (if (null? _selectors224604_)
              _nodeset224603_
              (_loop224601_
               (if (std/xml/sxpath#nodeset? _nodeset224603_)
                   (std/xml/sxpath#map-union
                    (car _selectors224604_)
                    _nodeset224603_)
                   ((car _selectors224604_) _nodeset224603_))
               (cdr _selectors224604_)))))))
  (define std/xml/sxpath#node-reduce
    (lambda _converters224588_
      (lambda (_nodeset224590_)
        (let _loop224592_ ((_nodeset224594_ _nodeset224590_)
                           (_converters224595_ _converters224588_))
          (if (null? _converters224595_)
              _nodeset224594_
              (_loop224592_
               ((car _converters224595_) _nodeset224594_)
               (cdr _converters224595_)))))))
  (define std/xml/sxpath#node-or
    (lambda _converters224576_
      (lambda (_node-or-nodeset224578_)
        (let _loop224580_ ((_result224582_ '())
                           (_converters224583_ _converters224576_))
          (if (null? _converters224583_)
              _result224582_
              (_loop224580_
               (append _result224582_
                       (let ((_$e224585_
                              ((car _converters224583_)
                               _node-or-nodeset224578_)))
                         (if _$e224585_ _$e224585_ '())))
               (cdr _converters224583_)))))))
  (define std/xml/sxpath#node-closure
    (lambda (_test-pred?224567_)
      (lambda (_node224569_)
        (let _loop224571_ ((_parent224573_ _node224569_) (_result224574_ '()))
          (if (null? _parent224573_)
              _result224574_
              (_loop224571_
               ((std/xml/sxpath#select-kids (std/xml/sxpath#node-typeof? '*))
                _parent224573_)
               (append _result224574_
                       ((std/xml/sxpath#select-kids _test-pred?224567_)
                        _parent224573_))))))))
  (define std/xml/sxpath#node-parent
    (lambda (_rootnode224561_)
      (lambda (_node224563_)
        (if (std/xml/sxpath#nodeset? _node224563_)
            (std/xml/sxpath#map-union
             (std/xml/sxpath#node-parent _rootnode224561_)
             _node224563_)
            (let ((_pred224565_
                   (std/xml/sxpath#node-or
                    (std/xml/sxpath#node-reduce
                     (std/xml/sxpath#node-self
                      (std/xml/sxpath#node-typeof? '*))
                     (std/xml/sxpath#select-kids
                      (std/xml/sxpath#node-eq? _node224563_)))
                    (std/xml/sxpath#node-join
                     (std/xml/sxpath#select-kids
                      (std/xml/sxpath#node-typeof? '@))
                     (std/xml/sxpath#select-kids
                      (std/xml/sxpath#node-eq? _node224563_))))))
              ((std/xml/sxpath#node-or
                (std/xml/sxpath#node-self _pred224565_)
                (std/xml/sxpath#node-closure _pred224565_))
               _rootnode224561_))))))
  (define std/xml/sxpath#sxpath
    (lambda (_path224547_)
      (lambda (_nodeset224549_)
        (let _loop224551_ ((_nodeset224553_ _nodeset224549_)
                           (_path224554_ _path224547_))
          (if (null? _path224554_)
              _nodeset224553_
              (if (std/xml/sxpath#nodeset? _nodeset224553_)
                  (std/xml/sxpath#map-union
                   (std/xml/sxpath#sxpath _path224554_)
                   _nodeset224553_)
                  (if (procedure? (car _path224554_))
                      (_loop224551_
                       ((car _path224554_) _nodeset224553_)
                       (cdr _path224554_))
                      (if (eq? '// (car _path224554_))
                          (_loop224551_
                           ((if (std/xml/sxpath#nodeset? _nodeset224553_)
                                append
                                cons)
                            _nodeset224553_
                            ((std/xml/sxpath#node-closure
                              (std/xml/sxpath#node-typeof? '*any*))
                             _nodeset224553_))
                           (cdr _path224554_))
                          (if (symbol? (car _path224554_))
                              (_loop224551_
                               ((std/xml/sxpath#select-kids
                                 (std/xml/sxpath#node-typeof?
                                  (car _path224554_)))
                                _nodeset224553_)
                               (cdr _path224554_))
                              (if (and (pair? (car _path224554_))
                                       (eq? 'equal? (caar _path224554_)))
                                  (_loop224551_
                                   ((std/xml/sxpath#select-kids
                                     (apply std/xml/sxpath#node-equal?
                                            (cdar _path224554_)))
                                    _nodeset224553_)
                                   (cdr _path224554_))
                                  (if (and (pair? (car _path224554_))
                                           (eq? 'eq? (caar _path224554_)))
                                      (_loop224551_
                                       ((std/xml/sxpath#select-kids
                                         (apply std/xml/sxpath#node-eq?
                                                (cdar _path224554_)))
                                        _nodeset224553_)
                                       (cdr _path224554_))
                                      (if (pair? (car _path224554_))
                                          (let _reducer224556_ ((_nodeset224558_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (if (symbol? (caar _path224554_))
                             ((std/xml/sxpath#select-kids
                               (std/xml/sxpath#node-typeof?
                                (caar _path224554_)))
                              _nodeset224553_)
                             (_loop224551_
                              _nodeset224553_
                              (caar _path224554_))))
                        (_reducing-path224559_ (cdar _path224554_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                            (if (null? _reducing-path224559_)
                                                (_loop224551_
                                                 _nodeset224558_
                                                 (cdr _path224554_))
                                                (if (number? (car _reducing-path224559_))
                                                    (_reducer224556_
                                                     ((std/xml/sxpath#node-pos
                                                       (car _reducing-path224559_))
                                                      _nodeset224558_)
                                                     (cdr _reducing-path224559_))
                                                    (_reducer224556_
                                                     ((std/xml/sxpath#filter
                                                       (std/xml/sxpath#sxpath
                                                        (car _reducing-path224559_)))
                                                      _nodeset224558_)
                                                     (cdr _reducing-path224559_)))))
                                          (error '"Invalid path step: "
                                                 (car _path224554_)))))))))))))))
