(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/actor/message#actor-error::t
    (make-struct-type
     'std/actor/message#actor-error::t
     error::t
     '0
     'actor-error
     '()
     ':init!
     '()))
  (define std/actor/message#actor-error?
    (make-struct-predicate std/actor/message#actor-error::t))
  (define std/actor/message#make-actor-error
    (lambda _$args177859_
      (apply make-struct-instance
             std/actor/message#actor-error::t
             _$args177859_)))
  (define std/actor/message#actor-error:::init!
    (lambda (_self177854_ _where177855_ _what177856_ . _irritants177857_)
      (if (let ((__tmp306350
                 (let () (declare (not safe)) (##vector-length _self177854_))))
            (declare (not safe))
            (##fx< '3 __tmp306350))
          (begin
            (let ()
              (declare (not safe))
              (##vector-set! _self177854_ '1 _what177856_))
            (let ()
              (declare (not safe))
              (##vector-set! _self177854_ '2 _irritants177857_))
            (let ()
              (declare (not safe))
              (##vector-set! _self177854_ '3 _where177855_)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self177854_))))
  (bind-method!
   std/actor/message#actor-error::t
   ':init!
   std/actor/message#actor-error:::init!
   '#f)
  (define std/actor/message#message::t
    (make-struct-type
     'std/actor/message#message::t
     '#f
     '4
     'message
     '((final: . #t))
     '#f
     '(e source dest options)))
  (define std/actor/message#message?
    (make-struct-predicate std/actor/message#message::t))
  (define std/actor/message#make-message
    (lambda _$args177729_
      (apply make-struct-instance std/actor/message#message::t _$args177729_)))
  (define std/actor/message#message-e
    (make-struct-field-accessor std/actor/message#message::t '0))
  (define std/actor/message#message-source
    (make-struct-field-accessor std/actor/message#message::t '1))
  (define std/actor/message#message-dest
    (make-struct-field-accessor std/actor/message#message::t '2))
  (define std/actor/message#message-options
    (make-struct-field-accessor std/actor/message#message::t '3))
  (define std/actor/message#message-e-set!
    (make-struct-field-mutator std/actor/message#message::t '0))
  (define std/actor/message#message-source-set!
    (make-struct-field-mutator std/actor/message#message::t '1))
  (define std/actor/message#message-dest-set!
    (make-struct-field-mutator std/actor/message#message::t '2))
  (define std/actor/message#message-options-set!
    (make-struct-field-mutator std/actor/message#message::t '3))
  (define std/actor/message#proxy::t
    (make-struct-type
     'std/actor/message#proxy::t
     '#f
     '1
     'proxy
     '()
     '#f
     '(handler)))
  (define std/actor/message#proxy?
    (make-struct-predicate std/actor/message#proxy::t))
  (define std/actor/message#make-proxy
    (lambda _$args177726_
      (apply make-struct-instance std/actor/message#proxy::t _$args177726_)))
  (define std/actor/message#proxy-handler
    (make-struct-field-accessor std/actor/message#proxy::t '0))
  (define std/actor/message#proxy-handler-set!
    (make-struct-field-mutator std/actor/message#proxy::t '0))
  (define std/actor/message#send__%
    (lambda (_dest177703_ _msg177704_ _raise-dead?177705_)
      (let _lp177707_ ((_dest177709_ _dest177703_))
        (if (thread? _dest177709_)
            (let ((_$e177711_
                   (std/actor/message#thread-send/check
                    _dest177709_
                    _msg177704_)))
              (if _$e177711_
                  _$e177711_
                  (if (not _raise-dead?177705_)
                      '#f
                      (raise (make-struct-instance
                              std/actor/message#actor-error::t
                              'send
                              '"Cannot send message; dead thread"
                              _dest177709_
                              _msg177704_)))))
            (if (let ()
                  (declare (not safe))
                  (##structure-instance-of?
                   _dest177709_
                   'std/actor/message#proxy::t))
                (_lp177707_
                 (##structure-ref
                  _dest177709_
                  '1
                  std/actor/message#proxy::t
                  '#f))
                (_lp177707_
                 (let* ((__self306348 ':actor)
                        (__method306349
                         (method-ref __self306348 _dest177709_)))
                   (if __method306349
                       (__method306349 __self306348)
                       (error '"Missing method"
                              __self306348
                              _dest177709_)))))))))
  (define std/actor/message#send__0
    (lambda (_dest177717_ _msg177718_)
      (let ((_raise-dead?177720_ '#f))
        (std/actor/message#send__%
         _dest177717_
         _msg177718_
         _raise-dead?177720_))))
  (define std/actor/message#send
    (lambda _g306352_
      (let ((_g306351_ (let () (declare (not safe)) (##length _g306352_))))
        (cond ((let () (declare (not safe)) (##fx= _g306351_ 2))
               (apply std/actor/message#send__0 _g306352_))
              ((let () (declare (not safe)) (##fx= _g306351_ 3))
               (apply std/actor/message#send__% _g306352_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/message#send
                _g306352_))))))
  (define std/actor/message#send-message__%
    (lambda (_dest177676_ _value177677_ _options177678_ _check-dead?177679_)
      (std/actor/message#send__%
       _dest177676_
       (let ((__tmp306353 (current-thread)))
         (declare (not safe))
         (##structure
          std/actor/message#message::t
          _value177677_
          __tmp306353
          _dest177676_
          _options177678_))
       _check-dead?177679_)))
  (define std/actor/message#send-message__0
    (lambda (_dest177684_ _value177685_)
      (let* ((_options177687_ '#f)
             (_check-dead?177689_
              (let ()
                (declare (not safe))
                (##structure-instance-of?
                 _dest177684_
                 'std/actor/message#proxy::t))))
        (std/actor/message#send-message__%
         _dest177684_
         _value177685_
         _options177687_
         _check-dead?177689_))))
  (define std/actor/message#send-message__1
    (lambda (_dest177691_ _value177692_ _options177693_)
      (let ((_check-dead?177695_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _dest177691_
                'std/actor/message#proxy::t))))
        (std/actor/message#send-message__%
         _dest177691_
         _value177692_
         _options177693_
         _check-dead?177695_))))
  (define std/actor/message#send-message
    (lambda _g306355_
      (let ((_g306354_ (let () (declare (not safe)) (##length _g306355_))))
        (cond ((let () (declare (not safe)) (##fx= _g306354_ 2))
               (apply std/actor/message#send-message__0 _g306355_))
              ((let () (declare (not safe)) (##fx= _g306354_ 3))
               (apply std/actor/message#send-message__1 _g306355_))
              ((let () (declare (not safe)) (##fx= _g306354_ 4))
               (apply std/actor/message#send-message__% _g306355_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/message#send-message
                _g306355_))))))
  (define std/actor/message#send-message/timeout__%
    (lambda (_dest177656_ _value177657_ _timeo177658_ _check-dead?177659_)
      (std/actor/message#send__%
       _dest177656_
       (let ((__tmp306357 (current-thread))
             (__tmp306356 (cons 'timeout: (cons _timeo177658_ '()))))
         (declare (not safe))
         (##structure
          std/actor/message#message::t
          _value177657_
          __tmp306357
          _dest177656_
          __tmp306356))
       _check-dead?177659_)))
  (define std/actor/message#send-message/timeout__0
    (lambda (_dest177664_ _value177665_ _timeo177666_)
      (let ((_check-dead?177668_
             (let ()
               (declare (not safe))
               (##structure-instance-of?
                _dest177664_
                'std/actor/message#proxy::t))))
        (std/actor/message#send-message/timeout__%
         _dest177664_
         _value177665_
         _timeo177666_
         _check-dead?177668_))))
  (define std/actor/message#send-message/timeout
    (lambda _g306359_
      (let ((_g306358_ (let () (declare (not safe)) (##length _g306359_))))
        (cond ((let () (declare (not safe)) (##fx= _g306358_ 3))
               (apply std/actor/message#send-message/timeout__0 _g306359_))
              ((let () (declare (not safe)) (##fx= _g306358_ 4))
               (apply std/actor/message#send-message/timeout__% _g306359_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/message#send-message/timeout
                _g306359_))))))
  (namespace ("std/actor/message#" send thread-send/check))
  (define (thread-send/check thread msg)
    (declare (not interrupts-enabled))
    (macro-check-initialized-thread
     thread
     (send thread msg)
     (if (macro-thread-end-condvar thread) (##thread-send thread msg) #f)))
  (define std/actor/message#receive-timeout
    (lambda _args177591_
      (letrec* ((_now177593_ '#f))
        (let _lp177595_ ((_rest177597_ _args177591_)
                         (_timeo177598_ absent-obj)
                         (_deadline177599_ '#f)
                         (_K177600_ void))
          (let* ((_rest177601177611_ _rest177597_)
                 (_else177603177619_
                  (lambda () (values _timeo177598_ _K177600_)))
                 (_K177605177636_
                  (lambda (_rest177622_ _k177623_ _evt177624_)
                    (if (not _evt177624_)
                        (_lp177595_
                         _rest177622_
                         _timeo177598_
                         _deadline177599_
                         _K177600_)
                        (if (time? _evt177624_)
                            (let ((_evt-deadline177626_
                                   (time->seconds _evt177624_)))
                              (if (or (not _deadline177599_)
                                      (< _evt-deadline177626_
                                         _deadline177599_))
                                  (_lp177595_
                                   _rest177622_
                                   _evt177624_
                                   _evt-deadline177626_
                                   _k177623_)
                                  (_lp177595_
                                   _rest177622_
                                   _timeo177598_
                                   _deadline177599_
                                   _K177600_)))
                            (if (real? _evt177624_)
                                (begin
                                  (if _now177593_
                                      '#!void
                                      (set! _now177593_
                                            (let ()
                                              (declare (not safe))
                                              (##current-time-point))))
                                  (let ((_evt-deadline177631_
                                         (+ _now177593_ _evt177624_)))
                                    (if (or (not _deadline177599_)
                                            (< _evt-deadline177631_
                                               _deadline177599_))
                                        (_lp177595_
                                         _rest177622_
                                         (seconds->time _evt-deadline177631_)
                                         _evt-deadline177631_
                                         _k177623_)
                                        (_lp177595_
                                         _rest177622_
                                         _timeo177598_
                                         _deadline177599_
                                         _K177600_))))
                                (error '"Illegal event; expected time, real, or #f"
                                       _evt177624_)))))))
            (if (let () (declare (not safe)) (##pair? _rest177601177611_))
                (let ((_hd177606177639_
                       (let ()
                         (declare (not safe))
                         (##car _rest177601177611_)))
                      (_tl177607177641_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest177601177611_))))
                  (let ((_evt177644_ _hd177606177639_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl177607177641_))
                        (let ((_hd177608177646_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl177607177641_)))
                              (_tl177609177648_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl177607177641_))))
                          (let* ((_k177651_ _hd177608177646_)
                                 (_rest177653_ _tl177609177648_))
                            (_K177605177636_
                             _rest177653_
                             _k177651_
                             _evt177644_)))
                        (_else177603177619_))))
                (_else177603177619_)))))))
  (define std/actor/message#mailbox-timeout '#(timeout))
  (namespace ("std/actor/message#" mailbox-empty mailbox-next))
  (define mailbox-empty '#(empty))
  (define (mailbox-next)
    (declare (not interrupts-enabled))
    (let* ((mb (##thread-mailbox-get! (macro-current-thread)))
           (cursor (macro-mailbox-cursor mb))
           (next (if cursor (macro-fifo-next cursor) (macro-mailbox-fifo mb)))
           (next2 (macro-fifo-next next)))
      (if (##pair? next2)
          (let ((result (macro-fifo-elem next2)))
            (macro-mailbox-cursor-set! mb next)
            result)
          mailbox-empty))))
