(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/actor/rpc/proto/cookie#challenge-digest
    std/crypto/digest#digest::sha256)
  (define std/actor/rpc/proto/cookie#challenge-length
    (std/crypto/digest#digest-size
     std/actor/rpc/proto/cookie#challenge-digest))
  (define std/actor/rpc/proto/cookie#rpc-cookie-proto-accept
    (lambda (_ibuf254396_ _obuf254397_ _cookie254398_)
      (std/actor/rpc/proto/null#rpc-proto-accept-e
       _ibuf254396_
       _obuf254397_
       std/actor/rpc/proto/message#rpc-proto-cookie
       (lambda (_ibuf254400_ _obuf254401_)
         (std/actor/rpc/proto/cookie#rpc-cookie-proto-challenge
          _ibuf254400_
          _obuf254401_
          _cookie254398_)
         (values std/actor/rpc/proto/null#rpc-null-proto-read
                 std/actor/rpc/proto/null#rpc-null-proto-write)))))
  (define std/actor/rpc/proto/cookie#rpc-cookie-proto-connect
    (lambda (_ibuf254387_ _obuf254388_ _cookie254389_)
      (std/actor/rpc/proto/null#rpc-proto-connect-e
       _ibuf254387_
       _obuf254388_
       std/actor/rpc/proto/message#rpc-proto-cookie
       (lambda (_ibuf254391_ _obuf254392_)
         (let ((_e254394_ (std/net/bio/input#bio-read-u8 _ibuf254391_)))
           (if (eq? _e254394_ std/actor/rpc/proto/message#rpc-proto-challenge)
               (begin
                 (std/actor/rpc/proto/cookie#rpc-cookie-proto-challenge-respond
                  _ibuf254391_
                  _obuf254392_
                  _cookie254389_)
                 (values std/actor/rpc/proto/null#rpc-null-proto-read
                         std/actor/rpc/proto/null#rpc-null-proto-write))
               (if (eof-object? _e254394_)
                   (std/actor/proto#raise-rpc-io-error
                    'rpc-proto-connect
                    '"connection closed")
                   (std/actor/proto#raise-rpc-io-error
                    'rpc-proto-connect
                    '"bad hello"
                    _e254394_))))))))
  (define std/actor/rpc/proto/cookie#rpc-cookie-proto-challenge
    (lambda (_ibuf254370_ _obuf254371_ _cookie254372_)
      (std/net/bio/output#bio-write-u8
       std/actor/rpc/proto/message#rpc-proto-challenge
       _obuf254371_)
      (let ((_challenge254374_
             (std/crypto/etc#random-bytes
              std/actor/rpc/proto/cookie#challenge-length)))
        (std/net/bio/output#bio-write-u32
         std/actor/rpc/proto/cookie#challenge-length
         _obuf254371_)
        (std/net/bio/output#bio-write-bytes _challenge254374_ _obuf254371_)
        (std/net/bio/output#bio-force-output _obuf254371_)
        (let* ((_sz254376_ (std/net/bio/input#bio-read-u32 _ibuf254370_))
               (_g310663_
                (if (fx= _sz254376_
                         std/actor/rpc/proto/cookie#challenge-length)
                    '#!void
                    (std/actor/proto#raise-rpc-io-error
                     'rpc-proto-authen
                     '"challenge response size mismatch"
                     _sz254376_)))
               (_response254379_ (make-u8vector _sz254376_))
               (_g310664_
                (std/net/bio/input#bio-read-bytes
                 _response254379_
                 _ibuf254370_))
               (_secret254384_
                (let ((_digest254382_
                       (let ((__obj310661
                              (make-object std/crypto/digest#digest::t '2)))
                         (std/crypto/digest#digest:::init!
                          __obj310661
                          std/actor/rpc/proto/cookie#challenge-digest)
                         __obj310661)))
                  (std/crypto/digest#digest-update!__0
                   _digest254382_
                   _cookie254372_)
                  (std/crypto/digest#digest-update!__0
                   _digest254382_
                   _challenge254374_)
                  (std/crypto/digest#digest-final!__0 _digest254382_))))
          (if (equal? _response254379_ _secret254384_)
              (begin
                (std/net/bio/output#bio-write-u8
                 std/actor/rpc/proto/message#rpc-proto-connect-accept
                 _obuf254371_)
                (std/net/bio/output#bio-force-output _obuf254371_))
              (begin
                (std/net/bio/output#bio-write-u8
                 std/actor/rpc/proto/message#rpc-proto-connect-reject
                 _obuf254371_)
                (std/net/bio/output#bio-force-output _obuf254371_)
                (std/actor/proto#raise-rpc-io-error
                 'rpc-proto-authen
                 '"authentication failure"
                 _challenge254374_
                 _response254379_)))))))
  (define std/actor/rpc/proto/cookie#rpc-cookie-proto-challenge-respond
    (lambda (_ibuf254353_ _obuf254354_ _cookie254355_)
      (let* ((_sz254357_ (std/net/bio/input#bio-read-u32 _ibuf254353_))
             (_g310665_
              (if (fx> _sz254357_ '1024)
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-authen
                   '"inordinately sized challenge"
                   _sz254357_)
                  '#!void))
             (_challenge254360_ (make-u8vector _sz254357_))
             (_g310666_
              (std/net/bio/input#bio-read-bytes
               _challenge254360_
               _ibuf254353_))
             (_digest254363_
              (let ((__obj310662 (make-object std/crypto/digest#digest::t '2)))
                (std/crypto/digest#digest:::init!
                 __obj310662
                 std/actor/rpc/proto/cookie#challenge-digest)
                __obj310662)))
        (std/crypto/digest#digest-update!__0 _digest254363_ _cookie254355_)
        (std/crypto/digest#digest-update!__0 _digest254363_ _challenge254360_)
        (let ((_response254366_
               (std/crypto/digest#digest-final!__0 _digest254363_)))
          (std/net/bio/output#bio-write-u32
           std/actor/rpc/proto/cookie#challenge-length
           _obuf254354_)
          (std/net/bio/output#bio-write-bytes _response254366_ _obuf254354_)
          (std/net/bio/output#bio-force-output _obuf254354_))
        (let ((_e254368_ (std/net/bio/input#bio-read-u8 _ibuf254353_)))
          (if (eq? _e254368_
                   std/actor/rpc/proto/message#rpc-proto-connect-accept)
              '#!void
              (if (eof-object? _e254368_)
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-authen
                   '"connection closed")
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-authen
                   '"authentication failure"
                   _e254368_)))))))
  (define std/actor/rpc/proto/cookie#rpc-cookie-proto__%
    (lambda (_cookie-file254327_)
      (let ((_cookie254329_ (call-with-input-file _cookie-file254327_ read)))
        (if (u8vector? _cookie254329_)
            (##structure
             std/actor/rpc/base#!rpc-protocol::t
             (lambda (_g254330254333_ _g254331254335_)
               (std/actor/rpc/proto/cookie#rpc-cookie-proto-connect
                _g254330254333_
                _g254331254335_
                _cookie254329_))
             (lambda (_g254337254340_ _g254338254342_)
               (std/actor/rpc/proto/cookie#rpc-cookie-proto-accept
                _g254337254340_
                _g254338254342_
                _cookie254329_)))
            (error '"Invalid cookie; expected u8vector"
                   _cookie-file254327_
                   _cookie254329_)))))
  (define std/actor/rpc/proto/cookie#rpc-cookie-proto__0
    (lambda ()
      (let ((_cookie-file254349_ '"~/.gerbil/cookie"))
        (std/actor/rpc/proto/cookie#rpc-cookie-proto__% _cookie-file254349_))))
  (define std/actor/rpc/proto/cookie#rpc-cookie-proto
    (lambda _g310668_
      (let ((_g310667_ (##length _g310668_)))
        (cond ((##fx= _g310667_ 0)
               (apply std/actor/rpc/proto/cookie#rpc-cookie-proto__0
                      _g310668_))
              ((##fx= _g310667_ 1)
               (apply std/actor/rpc/proto/cookie#rpc-cookie-proto__%
                      _g310668_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/rpc/proto/cookie#rpc-cookie-proto
                _g310668_))))))
  (define std/actor/rpc/proto/cookie#rpc-generate-cookie!__%
    (lambda (_cookie-file254310_)
      (let ((_cookie254312_
             (std/crypto/etc#random-bytes
              std/actor/rpc/proto/cookie#challenge-length)))
        (call-with-output-file
         _cookie-file254310_
         (lambda (_g254313254315_) (write _cookie254312_ _g254313254315_))))))
  (define std/actor/rpc/proto/cookie#rpc-generate-cookie!__0
    (lambda ()
      (let ((_cookie-file254322_ '"~/.gerbil/cookie"))
        (std/actor/rpc/proto/cookie#rpc-generate-cookie!__%
         _cookie-file254322_))))
  (define std/actor/rpc/proto/cookie#rpc-generate-cookie!
    (lambda _g310670_
      (let ((_g310669_ (##length _g310670_)))
        (cond ((##fx= _g310669_ 0)
               (apply std/actor/rpc/proto/cookie#rpc-generate-cookie!__0
                      _g310670_))
              ((##fx= _g310669_ 1)
               (apply std/actor/rpc/proto/cookie#rpc-generate-cookie!__%
                      _g310670_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/rpc/proto/cookie#rpc-generate-cookie!
                _g310670_)))))))
