(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/actor/rpc/proto/null#rpc-proto-accept-e
    (lambda (_ibuf254293_ _obuf254294_ _proto-t254295_ _K254296_)
      (letrec ((_connection-closed254298_
                (lambda ()
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-accept
                   '"connection closed")))
               (_bad-hello254299_
                (lambda (_e254305_)
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-accept
                   '"bad hello"
                   _e254305_))))
        (let ((_e254301_ (std/net/bio/input#bio-read-u8 _ibuf254293_)))
          (if (eof-object? _e254301_)
              (_connection-closed254298_)
              (if (eq? _e254301_
                       std/actor/rpc/proto/message#rpc-proto-connect-hello)
                  (let ((_e254303_
                         (std/net/bio/input#bio-read-u8 _ibuf254293_)))
                    (if (eof-object? _e254303_)
                        (_connection-closed254298_)
                        (if (eq? _e254303_ _proto-t254295_)
                            (begin
                              (std/net/bio/output#bio-write-u8
                               std/actor/rpc/proto/message#rpc-proto-connect-accept
                               _obuf254294_)
                              (_K254296_ _ibuf254293_ _obuf254294_))
                            (begin
                              (std/net/bio/output#bio-write-u8
                               std/actor/rpc/proto/message#rpc-proto-connect-reject
                               _obuf254294_)
                              (std/net/bio/output#bio-force-output
                               _obuf254294_)
                              (_bad-hello254299_ _e254303_)))))
                  (_bad-hello254299_ _e254301_)))))))
  (define std/actor/rpc/proto/null#rpc-proto-connect-e
    (lambda (_ibuf254279_ _obuf254280_ _proto-t254281_ _K254282_)
      (letrec ((_connection-rejected254284_
                (lambda ()
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-connect
                   '"Connection hello rejected by peer")))
               (_connection-closed254285_
                (lambda ()
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-connect
                   '"connection closed")))
               (_bad-hello254286_
                (lambda ()
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-connect
                   '"bad hello"))))
        (std/net/bio/output#bio-write-u8
         std/actor/rpc/proto/message#rpc-proto-connect-hello
         _obuf254280_)
        (std/net/bio/output#bio-write-u8 _proto-t254281_ _obuf254280_)
        (std/net/bio/output#bio-force-output _obuf254280_)
        (let ((_e254288_ (std/net/bio/input#bio-read-u8 _ibuf254279_)))
          (if (eof-object? _e254288_)
              (_connection-closed254285_)
              (if (eq? _e254288_
                       std/actor/rpc/proto/message#rpc-proto-connect-accept)
                  (_K254282_ _ibuf254279_ _obuf254280_)
                  (if (eq? _e254288_
                           std/actor/rpc/proto/message#rpc-proto-connect-reject)
                      (_connection-rejected254284_)
                      (_bad-hello254286_))))))))
  (define std/actor/rpc/proto/null#rpc-null-proto-accept
    (lambda (_ibuf254273_ _obuf254274_)
      (std/actor/rpc/proto/null#rpc-proto-accept-e
       _ibuf254273_
       _obuf254274_
       std/actor/rpc/proto/message#rpc-proto-null
       (lambda (_ibuf254276_ _obuf254277_)
         (std/net/bio/output#bio-force-output _obuf254277_)
         (values std/actor/rpc/proto/null#rpc-null-proto-read
                 std/actor/rpc/proto/null#rpc-null-proto-write)))))
  (define std/actor/rpc/proto/null#rpc-null-proto-connect
    (lambda (_ibuf254267_ _obuf254268_)
      (std/actor/rpc/proto/null#rpc-proto-connect-e
       _ibuf254267_
       _obuf254268_
       std/actor/rpc/proto/message#rpc-proto-null
       (lambda (_ibuf254270_ _obuf254271_)
         (values std/actor/rpc/proto/null#rpc-null-proto-read
                 std/actor/rpc/proto/null#rpc-null-proto-write)))))
  (define std/actor/rpc/proto/null#rpc-null-proto-read
    (lambda (_ibuf254258_ _bytes254259_)
      (let ((_e254261_ (std/net/bio/input#bio-read-u8 _ibuf254258_)))
        (if (eq? _e254261_ std/actor/rpc/proto/message#rpc-proto-keep-alive)
            '#!void
            (if (eq? _e254261_ std/actor/rpc/proto/message#rpc-proto-message)
                (let ((_len254263_
                       (std/net/bio/input#bio-read-u32 _ibuf254258_)))
                  (if (fx<= _len254263_
                            std/actor/rpc/proto/message#rpc-proto-message-max-length)
                      (let ((_bytes254265_
                             (if (fx< (u8vector-length _bytes254259_)
                                      _len254263_)
                                 (make-u8vector _len254263_)
                                 _bytes254259_)))
                        (std/net/bio/input#bio-read-subu8vector-unbuffered
                         _bytes254265_
                         '0
                         _len254263_
                         _ibuf254258_)
                        (values _bytes254265_ _len254263_))
                      (std/actor/proto#raise-rpc-io-error
                       'rpc-proto-read
                       '"message too long"
                       _len254263_)))
                (if (eof-object? _e254261_)
                    _e254261_
                    (std/actor/proto#raise-rpc-io-error
                     'rpc-proto-read
                     '"bad message"
                     _e254261_)))))))
  (define std/actor/rpc/proto/null#rpc-null-proto-write
    (lambda (_obuf254246_ _obj254247_)
      (if (eq? _obj254247_ '#!void)
          (begin
            (std/net/bio/output#bio-write-u8
             std/actor/rpc/proto/message#rpc-proto-keep-alive
             _obuf254246_)
            (std/net/bio/output#bio-force-output _obuf254246_))
          (if (u8vector? _obj254247_)
              (begin
                (std/net/bio/output#bio-write-u8
                 std/actor/rpc/proto/message#rpc-proto-message
                 _obuf254246_)
                (std/net/bio/output#bio-write-u32
                 (u8vector-length _obj254247_)
                 _obuf254246_)
                (std/net/bio/output#bio-write-bytes _obj254247_ _obuf254246_)
                (std/net/bio/output#bio-force-output _obuf254246_))
              (if (##structure-instance-of?
                   _obj254247_
                   'std/net/bio/buffer#chunked-output-buffer::t)
                  (let* ((_len254249_
                          (std/net/bio/buffer#chunked-output-length
                           _obj254247_))
                         (_chunks254251_
                          (std/net/bio/buffer#chunked-output-chunks
                           _obj254247_)))
                    (std/net/bio/output#bio-write-u8
                     std/actor/rpc/proto/message#rpc-proto-message
                     _obuf254246_)
                    (std/net/bio/output#bio-write-u32 _len254249_ _obuf254246_)
                    (for-each
                     (lambda (_g254253254255_)
                       (std/net/bio/output#bio-write-bytes
                        _g254253254255_
                        _obuf254246_))
                     _chunks254251_)
                    (std/net/bio/output#bio-force-output _obuf254246_))
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-write
                   '"unexpected object"
                   _obj254247_))))))
  (define std/actor/rpc/proto/null#rpc-null-proto
    (lambda ()
      (##structure
       std/actor/rpc/base#!rpc-protocol::t
       std/actor/rpc/proto/null#rpc-null-proto-connect
       std/actor/rpc/proto/null#rpc-null-proto-accept))))
