(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/actor/rpc/server#errorf
    (lambda (_fmt257997_ . _args257998_)
      (std/logger#log-message 'rpc '0 _fmt257997_ _args257998_)))
  (define std/actor/rpc/server#warnf
    (lambda (_fmt257994_ . _args257995_)
      (std/logger#log-message 'rpc '1 _fmt257994_ _args257995_)))
  (define std/actor/rpc/server#infof
    (lambda (_fmt257991_ . _args257992_)
      (std/logger#log-message 'rpc '2 _fmt257991_ _args257992_)))
  (define std/actor/rpc/server#debugf
    (lambda (_fmt257988_ . _args257989_)
      (std/logger#log-message 'rpc '3 _fmt257988_ _args257989_)))
  (define std/actor/rpc/server#verbosef
    (lambda (_fmt257983_ . _args257985_)
      (std/logger#log-message 'rpc '4 _fmt257983_ _args257985_)))
  (define std/actor/rpc/server#current-rpc-server (make-parameter '#f))
  (define std/actor/rpc/server#start-rpc-server!__%
    (lambda (_g311040_ _proto257960257963_ . _addresses257965_)
      (let ((_proto257967_
             (if (eq? _proto257960257963_ absent-value)
                 (std/actor/rpc/proto/null#rpc-null-proto)
                 _proto257960257963_)))
        (std/logger#start-logger!__0)
        (gerbil/gambit/threads#spawn/group
         'rpc-server
         std/actor/rpc/server#rpc-server
         _proto257967_
         _addresses257965_))))
  (define std/actor/rpc/server#start-rpc-server!__@
    (lambda (_keys257959257972_ . _args257974_)
      (apply std/actor/rpc/server#start-rpc-server!__%
             _keys257959257972_
             (table-ref _keys257959257972_ 'proto: absent-value)
             _args257974_)))
  (define std/actor/rpc/server#start-rpc-server!
    (lambda _args257961257980_
      (apply keyword-dispatch
             '#(proto:)
             std/actor/rpc/server#start-rpc-server!__@
             _args257961257980_)))
  (define std/actor/rpc/server#stop-rpc-server!
    (lambda (_rpcd257952_)
      (let ((_tgroup257954_ (thread-thread-group _rpcd257952_)))
        (with-unwind-protect
         (lambda ()
           (std/actor/message#send-message__0
            _rpcd257952_
            (let ((__tmp311041
                   (let ()
                     (declare (not safe))
                     (##structure std/actor/rpc/base#rpc.shutdown::t))))
              (declare (not safe))
              (##structure std/actor/proto#!event::t __tmp311041)))
           (thread-join! _rpcd257952_))
         (lambda () (std/misc/threads#thread-group-kill! _tgroup257954_))))))
  (define std/actor/rpc/server#rpc-connect__%
    (lambda (_rpcd257923_ _id257924_ _address257925_ _proto257926_)
      (let ((_$e257928_
             (std/actor/rpc/server#rpc-canonical-address _address257925_)))
        (if _$e257928_
            ((lambda (_address257931_)
               (let ((_token257933_
                      (let ()
                        (declare (not safe))
                        (##structure std/actor/proto#!token::t)))
                     (_dest257935_ _rpcd257923_))
                 (std/actor/message#send-message__%
                  _dest257935_
                  (let ((__tmp311042
                         (let ()
                           (declare (not safe))
                           (##structure
                            std/actor/rpc/base#rpc.connect::t
                            _id257924_
                            _address257931_
                            _proto257926_))))
                    (declare (not safe))
                    (##structure
                     std/actor/proto#!call::t
                     __tmp311042
                     _token257933_))
                  '#f
                  '#t)
                 (std/actor/proto#!!call-recv _token257933_ _dest257935_)))
             _$e257928_)
            (error '"Bad rpc address" _address257925_)))))
  (define std/actor/rpc/server#rpc-connect__0
    (lambda (_rpcd257941_ _id257942_ _address257943_)
      (let ((_proto257945_ '#f))
        (std/actor/rpc/server#rpc-connect__%
         _rpcd257941_
         _id257942_
         _address257943_
         _proto257945_))))
  (define std/actor/rpc/server#rpc-connect
    (lambda _g311044_
      (let ((_g311043_ (let () (declare (not safe)) (##length _g311044_))))
        (cond ((let () (declare (not safe)) (##fx= _g311043_ 3))
               (apply std/actor/rpc/server#rpc-connect__0 _g311044_))
              ((let () (declare (not safe)) (##fx= _g311043_ 4))
               (apply std/actor/rpc/server#rpc-connect__% _g311044_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/rpc/server#rpc-connect
                _g311044_))))))
  (define std/actor/rpc/server#rpc-register__%
    (lambda (_rpcd257901_ _id257902_ _proto257903_)
      (let ((_token257905_
             (let ()
               (declare (not safe))
               (##structure std/actor/proto#!token::t)))
            (_dest257907_ _rpcd257901_))
        (std/actor/message#send-message__%
         _dest257907_
         (let ((__tmp311045
                (let ()
                  (declare (not safe))
                  (##structure
                   std/actor/rpc/base#rpc.register::t
                   _id257902_
                   _proto257903_))))
           (declare (not safe))
           (##structure std/actor/proto#!call::t __tmp311045 _token257905_))
         '#f
         '#t)
        (std/actor/proto#!!call-recv _token257905_ _dest257907_))))
  (define std/actor/rpc/server#rpc-register__0
    (lambda (_rpcd257913_ _id257914_)
      (let ((_proto257916_ '#f))
        (std/actor/rpc/server#rpc-register__%
         _rpcd257913_
         _id257914_
         _proto257916_))))
  (define std/actor/rpc/server#rpc-register
    (lambda _g311047_
      (let ((_g311046_ (let () (declare (not safe)) (##length _g311047_))))
        (cond ((let () (declare (not safe)) (##fx= _g311046_ 2))
               (apply std/actor/rpc/server#rpc-register__0 _g311047_))
              ((let () (declare (not safe)) (##fx= _g311046_ 3))
               (apply std/actor/rpc/server#rpc-register__% _g311047_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/rpc/server#rpc-register
                _g311047_))))))
  (define std/actor/rpc/server#rpc-unregister
    (lambda (_rpcd257892_ _id257893_)
      (let ((_token257895_
             (let ()
               (declare (not safe))
               (##structure std/actor/proto#!token::t)))
            (_dest257897_ _rpcd257892_))
        (std/actor/message#send-message__%
         _dest257897_
         (let ((__tmp311048
                (let ()
                  (declare (not safe))
                  (##structure
                   std/actor/rpc/base#rpc.unregister::t
                   _id257893_))))
           (declare (not safe))
           (##structure std/actor/proto#!call::t __tmp311048 _token257895_))
         '#f
         '#t)
        (std/actor/proto#!!call-recv _token257895_ _dest257897_))))
  (define std/actor/rpc/server#rpc-canonical-address
    (lambda (_address257887_)
      (if (std/net/address#resolved-address? _address257887_)
          _address257887_
          (if (or (std/net/address#inet-address? _address257887_)
                  (std/net/address#inet-address-string? _address257887_))
              (std/net/address#resolve-address _address257887_)
              (if (string? _address257887_) _address257887_ '#f)))))
  (define std/actor/rpc/server#rpc-server
    (lambda (_proto257870_ _addresses257871_)
      (let* ((_sas257873_ (map std/os/socket#socket-address _addresses257871_))
             (_g311049_
              (for-each
               std/actor/rpc/server#rpc-unlink-unix-socket
               _sas257873_))
             (_socks257876_
              (map std/net/socket/api#ssocket-listen _sas257873_)))
        (call-with-parameters
         (lambda ()
           (with-exception-catcher
            (lambda (_g257879257881_)
              (if '#t
                  (let ((_e257884_ _g257879257881_))
                    (if (eq? _e257884_ 'shutdown)
                        '#!void
                        (begin
                          (std/actor/rpc/server#errorf
                           '"unhandled exception: ~a"
                           _e257884_)
                          (raise _e257884_))))
                  (raise _g257879257881_)))
            (lambda ()
              (std/actor/rpc/server#rpc-server-loop
               _socks257876_
               _sas257873_
               _proto257870_))))
         std/actor/rpc/server#current-rpc-server
         (current-thread)))))
  (define std/actor/rpc/server#rpc-unlink-unix-socket
    (lambda (_sa257867_)
      (if (eq? (std/os/_socket#sockaddr_family _sa257867_)
               std/os/_socket#AF_UNIX)
          (with-exception-catcher
           void
           (lambda ()
             (delete-file (std/os/socket#socket-address->string _sa257867_))))
          '#!void)))
  (define std/actor/rpc/server#rpc-server-loop
    (lambda (_socks257164_ _sas257165_ _proto257166_)
      (letrec* ((_connect-e257168_
                 (##structure-ref
                  _proto257166_
                  '1
                  std/actor/rpc/base#!rpc-protocol::t
                  '#f))
                (_accept-e257169_
                 (##structure-ref
                  _proto257166_
                  '2
                  std/actor/rpc/base#!rpc-protocol::t
                  '#f))
                (_actors257170_ (std/actor/rpc/base#make-actor-table))
                (_actor-threads257171_ (make-table 'test: eq?))
                (_conns257172_ (make-table))
                (_threads257173_ (make-table 'test: eq?))
                (_monitors257174_ (make-table 'test: eq?))
                (_acceptors257175_
                 (map (lambda (_sock257864_ _sa257865_)
                        (gerbil/gambit/threads#spawn/name
                         'rpc-server-accept
                         std/actor/rpc/server#rpc-server-accept
                         (current-thread)
                         _sock257864_
                         (std/os/_socket#sockaddr_family _sa257865_)))
                      _socks257164_
                      _sas257165_))
                (_server-connection257176_ '0)
                (_accept-connection257177_
                 (lambda (_cli257854_ _clisa257855_)
                   (let* ((_cliaddr257857_
                           (std/os/socket#socket-address->address
                            _clisa257855_))
                          (_address257859_
                           (list _cliaddr257857_ _server-connection257176_))
                          (_thr257861_
                           (gerbil/gambit/threads#spawn/name
                            'rpc-connection
                            std/actor/rpc/connection#rpc-server-connection
                            (current-thread)
                            _actors257170_
                            _cli257854_
                            _clisa257855_
                            _address257859_
                            _accept-e257169_)))
                     (set! _server-connection257176_
                           (+ _server-connection257176_ '1))
                     (table-set! _conns257172_ _address257859_ _thr257861_)
                     (table-set! _threads257173_ _thr257861_ _address257859_)
                     (std/actor/rpc/base#rpc-monitor__0 _thr257861_))))
                (_open-connection257178_
                 (lambda (_address257842_)
                   (let ((_$e257844_
                          (table-ref _conns257172_ _address257842_ '#f)))
                     (if _$e257844_
                         (values _$e257844_)
                         (if (list? _address257842_)
                             '#f
                             (let ((_address257847_
                                    (std/actor/rpc/server#rpc-canonical-address
                                     _address257842_)))
                               (if (not _address257847_)
                                   '#f
                                   (let ((_$e257849_
                                          (table-ref
                                           _conns257172_
                                           _address257847_
                                           '#f)))
                                     (if _$e257849_
                                         (values _$e257849_)
                                         (let ((_thr257852_
                                                (gerbil/gambit/threads#spawn/name
                                                 'rpc-connection
                                                 std/actor/rpc/connection#rpc-client-connection
                                                 (current-thread)
                                                 _actors257170_
                                                 _address257847_
                                                 _connect-e257168_)))
                                           (table-set!
                                            _conns257172_
                                            _address257847_
                                            _thr257852_)
                                           (table-set!
                                            _threads257173_
                                            _thr257852_
                                            _address257847_)
                                           (std/actor/rpc/base#rpc-monitor__0
                                            _thr257852_)
                                           _thr257852_))))))))))
                (_handle-protocol-action257179_
                 (lambda (_msg257433_)
                   (let* ((_msg257434257443_ _msg257433_)
                          (_E257436257447_
                           (lambda ()
                             (error '"No clause matching" _msg257434257443_)))
                          (_K257437257819_
                           (lambda (_opt257450_
                                    _dest257451_
                                    _src257452_
                                    _content257453_)
                             (let* ((_content257454257504_ _content257453_)
                                    (_else257465257512_
                                     (lambda ()
                                       (std/actor/rpc/server#warnf
                                        '"Unexpected message ~a"
                                        _msg257433_))))
                               (let ((_K257499257803_
                                      (lambda (_cliaddr257800_ _cli257801_)
                                        (_accept-connection257177_
                                         _cli257801_
                                         _cliaddr257800_)))
                                     (_K257497257791_
                                      (lambda ()
                                        (let ((_$e257786_
                                               (table-ref
                                                _threads257173_
                                                _src257452_
                                                '#f)))
                                          (if _$e257786_
                                              ((lambda (_address257789_)
                                                 (std/actor/message#send-message__0
                                                  _src257452_
                                                  (let ((__tmp311050
                                                         (let ()
                                                           (declare (not safe))
                                                           (##structure
                                                            std/actor/rpc/base#rpc.connection-close::t))))
                                                    (declare (not safe))
                                                    (##structure
                                                     std/actor/proto#!event::t
                                                     __tmp311050)))
                                                 (_remove-thread!257181_
                                                  _src257452_))
                                               _$e257786_)
                                              (std/actor/rpc/server#warnf
                                               '"Unexpected protocol mesage ~a"
                                               _msg257433_)))))
                                     (_K257491257755_
                                      (lambda (_k257740_
                                               _proto257741_
                                               _address257742_
                                               _id257743_)
                                        (let* ((_uuid257745_
                                                (std/misc/uuid#UUID
                                                 _id257743_))
                                               (_proto257750_
                                                (let ((_$e257747_
                                                       _proto257741_))
                                                  (if _$e257747_
                                                      _$e257747_
                                                      (std/actor/rpc/base#lookup-protocol
                                                       _uuid257745_)))))
                                          (if (let ()
                                                (declare (not safe))
                                                (##structure-direct-instance-of?
                                                 _proto257750_
                                                 'std/actor/proto#!protocol::t))
                                              (let ((_handler257753_
                                                     (_open-connection257178_
                                                      _address257742_)))
                                                (if _handler257753_
                                                    (std/actor/message#send-message__%
                                                     _src257452_
                                                     (let ((__tmp311051
                                                            (let ((__obj311039
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           (make-object std/actor/proto#remote::t '4)))
                      (std/actor/proto#remote:::init!
                       __obj311039
                       _handler257753_
                       _id257743_
                       _address257742_
                       _proto257750_)
                      __obj311039)))
               (declare (not safe))
               (##structure std/actor/proto#!value::t __tmp311051 _k257740_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     '#f
                                                     '#f)
                                                    (std/actor/message#send-message__%
                                                     _src257452_
                                                     (let ((__tmp311052
                                                            (make-struct-instance
                                                             std/actor/proto#rpc-error::t
                                                             'rpc-server
                                                             '"invalid address")))
                                                       (declare (not safe))
                                                       (##structure
                                                        std/actor/proto#!error::t
                                                        __tmp311052
                                                        _k257740_))
                                                     '#f
                                                     '#f)))
                                              (std/actor/message#send-message__%
                                               _src257452_
                                               (let ()
                                                 (declare (not safe))
                                                 (##structure
                                                  std/actor/proto#!error::t
                                                  '"bad protocol"
                                                  _k257740_))
                                               '#f
                                               '#f)))))
                                     (_K257486257715_
                                      (lambda (_k257698_
                                               _proto257699_
                                               _id257700_)
                                        (let ((_uuid257702_
                                               (std/misc/uuid#UUID
                                                _id257700_)))
                                          (if (std/misc/sync#sync-hash-key?
                                               _actors257170_
                                               _uuid257702_)
                                              (std/actor/message#send-message__%
                                               _src257452_
                                               (let ()
                                                 (declare (not safe))
                                                 (##structure
                                                  std/actor/proto#!error::t
                                                  '"duplicate registration"
                                                  _k257698_))
                                               '#f
                                               '#f)
                                              (let ((_proto257707_
                                                     (let ((_$e257704_
                                                            _proto257699_))
                                                       (if _$e257704_
                                                           _$e257704_
                                                           (std/actor/rpc/base#lookup-protocol
                                                            _uuid257702_)))))
                                                (if (let ()
                                                      (declare (not safe))
                                                      (##structure-direct-instance-of?
                                                       _proto257707_
                                                       'std/actor/proto#!protocol::t))
                                                    (let ((_thread257709_
                                                           (_actor-thread-e257180_
                                                            _src257452_)))
                                                      (std/actor/rpc/base#actor-table-put!
                                                       _actors257170_
                                                       _uuid257702_
                                                       _src257452_
                                                       _proto257707_)
                                                      (hash-update!
                                                       _actor-threads257171_
                                                       _thread257709_
                                                       (lambda (_g257710257712_)
                                                         (cons _uuid257702_
                                                               _g257710257712_))
                                                       '())
                                                      (std/actor/rpc/base#rpc-monitor__0
                                                       _thread257709_)
                                                      (std/actor/message#send-message__%
                                                       _src257452_
                                                       (let ()
                                                         (declare (not safe))
                                                         (##structure
                                                          std/actor/proto#!value::t
                                                          _uuid257702_
                                                          _k257698_))
                                                       '#f
                                                       '#f))
                                                    (std/actor/message#send-message__%
                                                     _src257452_
                                                     (let ()
                                                       (declare (not safe))
                                                       (##structure
                                                        std/actor/proto#!error::t
                                                        '"bad protocol"
                                                        _k257698_))
                                                     '#f
                                                     '#f)))))))
                                     (_K257482257678_
                                      (lambda (_k257664_ _id257665_)
                                        (let* ((_uuid257667_
                                                (std/misc/uuid#UUID
                                                 _id257665_))
                                               (_thread257669_
                                                (_actor-thread-e257180_
                                                 _src257452_)))
                                          (std/misc/sync#sync-hash-remove!
                                           _actors257170_
                                           _uuid257667_)
                                          (let ((_actor-rest257676_
                                                 (remf (lambda (_g257671257673_)
                                                         (std/misc/uuid#uuid=?
                                                          _g257671257673_
                                                          _uuid257667_))
                                                       (table-ref
                                                        _actor-threads257171_
                                                        _thread257669_
                                                        '()))))
                                            (if (null? _actor-rest257676_)
                                                (table-set!
                                                 _actor-threads257171_
                                                 _thread257669_)
                                                (table-set!
                                                 _actor-threads257171_
                                                 _thread257669_
                                                 _actor-rest257676_)))
                                          (std/actor/message#send-message__%
                                           _src257452_
                                           (let ()
                                             (declare (not safe))
                                             (##structure
                                              std/actor/proto#!value::t
                                              '#!void
                                              _k257664_))
                                           '#f
                                           '#f))))
                                     (_K257478257644_
                                      (lambda (_k257603_ _id257604_)
                                        (let* ((_uuid257606_
                                                (std/misc/uuid#UUID
                                                 _id257604_))
                                               (_actor257641_
                                                (let ((_$e257608_
                                                       (std/misc/sync#sync-hash-get
                                                        _actors257170_
                                                        _uuid257606_)))
                                                  (if _$e257608_
                                                      ((lambda (_e257610257612_)
                                                         (let* ((_g257614257621_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _e257610257612_)
                        (_E257616257625_
                         (lambda ()
                           (error '"No clause matching" _g257614257621_)))
                        (_K257617257630_
                         (lambda (_actor257628_) _actor257628_)))
                   (if (let ((__tmp311053
                              (if (let ()
                                    (declare (not safe))
                                    (##values? _g257614257621_))
                                  (let ()
                                    (declare (not safe))
                                    (##vector-length _g257614257621_))
                                  '1)))
                         (declare (not safe))
                         (##fx= __tmp311053 '2))
                       (let* ((_e257618257633_
                               (let ()
                                 (declare (not safe))
                                 (##vector-ref _g257614257621_ '0)))
                              (_actor257636_ _e257618257633_)
                              (_e257619257638_
                               (let ()
                                 (declare (not safe))
                                 (##vector-ref _g257614257621_ '1))))
                         (_K257617257630_ _actor257636_))
                       (_E257616257625_))))
               _$e257608_)
              '#f))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                          (std/actor/message#send-message__%
                                           _src257452_
                                           (let ()
                                             (declare (not safe))
                                             (##structure
                                              std/actor/proto#!value::t
                                              _actor257641_
                                              _k257603_))
                                           '#f
                                           '#f))))
                                     (_K257475257588_
                                      (lambda (_k257584_)
                                        (let ((_addresses257586_
                                               (map std/os/socket#socket-address->address
                                                    _sas257165_)))
                                          (std/actor/message#send-message__%
                                           _src257452_
                                           (let ()
                                             (declare (not safe))
                                             (##structure
                                              std/actor/proto#!value::t
                                              _addresses257586_
                                              _k257584_))
                                           '#f
                                           '#f))))
                                     (_K257472257569_
                                      (lambda (_remote257556_)
                                        (let* ((_address257558_
                                                (##direct-structure-ref
                                                 _remote257556_
                                                 '3
                                                 std/actor/proto#remote::t
                                                 '#f))
                                               (_$e257560_
                                                (table-ref
                                                 _conns257172_
                                                 _address257558_
                                                 '#f)))
                                          (if _$e257560_
                                              ((lambda (_thread257563_)
                                                 (hash-update!
                                                  _monitors257174_
                                                  _thread257563_
                                                  (lambda (_g257564257566_)
                                                    (cons (cons _src257452_
                                                                _remote257556_)
                                                          _g257564257566_))
                                                  '()))
                                               _$e257560_)
                                              (std/actor/message#send-message__0
                                               _src257452_
                                               (let ((__tmp311054
                                                      (let ()
                                                        (declare (not safe))
                                                        (##structure
                                                         std/actor/rpc/base#rpc.disconnect::t
                                                         _remote257556_))))
                                                 (declare (not safe))
                                                 (##structure
                                                  std/actor/proto#!event::t
                                                  __tmp311054)))))))
                                     (_K257469257541_
                                      (lambda (_remote257527_)
                                        (let* ((_address257529_
                                                (##direct-structure-ref
                                                 _remote257527_
                                                 '3
                                                 std/actor/proto#remote::t
                                                 '#f))
                                               (_thread257530257532_
                                                (table-ref
                                                 _conns257172_
                                                 _address257529_
                                                 '#f)))
                                          (if _thread257530257532_
                                              (let ((_thread257535_
                                                     _thread257530257532_))
                                                (hash-update!
                                                 _monitors257174_
                                                 _thread257535_
                                                 (lambda (_g257536257538_)
                                                   (remove1 (cons _src257452_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _remote257527_)
                    _g257536257538_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 '()))
                                              '#f))))
                                     (_K257467257517_
                                      (lambda () (raise 'shutdown))))
                                 (let ((_try-match257457257781_
                                        (lambda ()
                                          (if (let ()
                                                (declare (not safe))
                                                (##structure-direct-instance-of?
                                                 _content257454257504_
                                                 'std/actor/proto#!call::t))
                                              (let ((_e257492257758_
                                                     (let ()
                                                       (declare (not safe))
                                                       (##vector-ref
                                                        _content257454257504_
                                                        '1))))
                                                (if (let ()
                                                      (declare (not safe))
                                                      (##structure-direct-instance-of?
                                                       _e257492257758_
                                                       'std/actor#rpc.connect::t))
                                                    (let* ((_e257494257761_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##vector-ref
                                                               _e257492257758_
                                                               '1)))
                                                           (_e257495257766_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##vector-ref
                                                               _e257492257758_
                                                               '2)))
                                                           (_e257496257771_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##vector-ref
                                                               _e257492257758_
                                                               '3)))
                                                           (_e257493257776_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##vector-ref
                                                               _content257454257504_
                                                               '2))))
                                                      (let ((_id257764_
                                                             _e257494257761_)
                                                            (_address257769_
                                                             _e257495257766_)
                                                            (_proto257774_
                                                             _e257496257771_)
                                                            (_k257779_
                                                             _e257493257776_))
                                                        (_K257491257755_
                                                         _k257779_
                                                         _proto257774_
                                                         _address257769_
                                                         _id257764_)))
                                                    (if (let ()
                                                          (declare (not safe))
                                                          (##structure-direct-instance-of?
                                                           _e257492257758_
                                                           'std/actor#rpc.register::t))
                                                        (let* ((_e257489257721_
                                                                (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (declare (not safe))
                          (##vector-ref _e257492257758_ '1)))
                       (_e257490257726_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _e257492257758_ '2)))
                       (_e257488257731_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _content257454257504_ '2))))
                  (let ((_id257724_ _e257489257721_)
                        (_proto257729_ _e257490257726_)
                        (_k257734_ _e257488257731_))
                    (_K257486257715_ _k257734_ _proto257729_ _id257724_)))
                (if (let ()
                      (declare (not safe))
                      (##structure-direct-instance-of?
                       _e257492257758_
                       'std/actor#rpc.unregister::t))
                    (let* ((_e257485257684_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _e257492257758_ '1)))
                           (_e257484257689_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _content257454257504_ '2))))
                      (let ((_id257687_ _e257485257684_)
                            (_k257692_ _e257484257689_))
                        (_K257482257678_ _k257692_ _id257687_)))
                    (if (let ()
                          (declare (not safe))
                          (##structure-direct-instance-of?
                           _e257492257758_
                           'std/actor#rpc.resolve::t))
                        (let* ((_e257481257650_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref _e257492257758_ '1)))
                               (_e257480257655_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref _content257454257504_ '2))))
                          (let ((_id257653_ _e257481257650_)
                                (_k257658_ _e257480257655_))
                            (_K257478257644_ _k257658_ _id257653_)))
                        (if (let ()
                              (declare (not safe))
                              (##structure-direct-instance-of?
                               _e257492257758_
                               'std/actor#rpc.server-address::t))
                            (let* ((_e257477257594_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _content257454257504_ '2)))
                                   (_k257597_ _e257477257594_))
                              (_K257475257588_ _k257597_))
                            (_else257465257512_)))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (_else257465257512_)))))
                                   (if (let ()
                                         (declare (not safe))
                                         (##structure-direct-instance-of?
                                          _content257454257504_
                                          'std/actor/proto#!event::t))
                                       (let ((_e257500257806_
                                              (let ()
                                                (declare (not safe))
                                                (##vector-ref
                                                 _content257454257504_
                                                 '1))))
                                         (if (let ()
                                               (declare (not safe))
                                               (##structure-direct-instance-of?
                                                _e257500257806_
                                                'std/actor#rpc.connection-accept::t))
                                             (let* ((_e257501257809_
                                                     (let ()
                                                       (declare (not safe))
                                                       (##vector-ref
                                                        _e257500257806_
                                                        '1)))
                                                    (_e257502257814_
                                                     (let ()
                                                       (declare (not safe))
                                                       (##vector-ref
                                                        _e257500257806_
                                                        '2))))
                                               (let ((_cli257812_
                                                      _e257501257809_)
                                                     (_cliaddr257817_
                                                      _e257502257814_))
                                                 (_K257499257803_
                                                  _cliaddr257817_
                                                  _cli257812_)))
                                             (if (let ()
                                                   (declare (not safe))
                                                   (##structure-direct-instance-of?
                                                    _e257500257806_
                                                    'std/actor#rpc.connection-shutdown::t))
                                                 (_K257497257791_)
                                                 (if (let ()
                                                       (declare (not safe))
                                                       (##structure-direct-instance-of?
                                                        _e257500257806_
                                                        'std/actor#rpc.monitor::t))
                                                     (let* ((_e257474257575_
                                                             (let ()
                                                               (declare
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (not safe))
                       (##vector-ref _e257500257806_ '1)))
                    (_remote257578_ _e257474257575_))
               (_K257472257569_ _remote257578_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (if (let ()
                                                           (declare (not safe))
                                                           (##structure-direct-instance-of?
                                                            _e257500257806_
                                                            'std/actor#rpc.unmonitor::t))
                                                         (let* ((_e257471257547_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (let ()
                           (declare (not safe))
                           (##vector-ref _e257500257806_ '1)))
                        (_remote257550_ _e257471257547_))
                   (_K257469257541_ _remote257550_))
                 (if (let ()
                       (declare (not safe))
                       (##structure-direct-instance-of?
                        _e257500257806_
                        'std/actor#rpc.shutdown::t))
                     (_K257467257517_)
                     (_else257465257512_)))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                       (_try-match257457257781_))))))))
                     (if (let ()
                           (declare (not safe))
                           (##structure-direct-instance-of?
                            _msg257434257443_
                            'std/actor/message#message::t))
                         (let* ((_e257438257822_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _msg257434257443_ '1)))
                                (_content257825_ _e257438257822_)
                                (_e257439257827_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _msg257434257443_ '2)))
                                (_src257830_ _e257439257827_)
                                (_e257440257832_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _msg257434257443_ '3)))
                                (_dest257835_ _e257440257832_)
                                (_e257441257837_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _msg257434257443_ '4)))
                                (_opt257840_ _e257441257837_))
                           (_K257437257819_
                            _opt257840_
                            _dest257835_
                            _src257830_
                            _content257825_))
                         (_E257436257447_)))))
                (_actor-thread-e257180_
                 (lambda (_actor257431_)
                   (if (thread? _actor257431_)
                       _actor257431_
                       (if (let ()
                             (declare (not safe))
                             (##structure-instance-of?
                              _actor257431_
                              'std/actor/message#proxy::t))
                           (##structure-ref
                            _actor257431_
                            '1
                            std/actor/message#proxy::t
                            '#f)
                           (error '"Bad actor" _actor257431_)))))
                (_remove-thread!257181_
                 (lambda (_thread257383_)
                   (let ((_$e257385_
                          (table-ref _threads257173_ _thread257383_ '#f)))
                     (if _$e257385_
                         ((lambda (_address257388_)
                            (for-each
                             (lambda (_e257389257391_)
                               (let* ((_g257393257400_ _e257389257391_)
                                      (_E257395257404_
                                       (lambda ()
                                         (error '"No clause matching"
                                                _g257393257400_)))
                                      (_K257396257410_
                                       (lambda (_remote257407_ _actor257408_)
                                         (std/actor/message#send-message__0
                                          _actor257408_
                                          (let ((__tmp311055
                                                 (let ()
                                                   (declare (not safe))
                                                   (##structure
                                                    std/actor/rpc/base#rpc.disconnect::t
                                                    _remote257407_))))
                                            (declare (not safe))
                                            (##structure
                                             std/actor/proto#!event::t
                                             __tmp311055))))))
                                 (if (let ()
                                       (declare (not safe))
                                       (##pair? _g257393257400_))
                                     (let ((_hd257397257413_
                                            (let ()
                                              (declare (not safe))
                                              (##car _g257393257400_)))
                                           (_tl257398257415_
                                            (let ()
                                              (declare (not safe))
                                              (##cdr _g257393257400_))))
                                       (let* ((_actor257418_ _hd257397257413_)
                                              (_remote257420_
                                               _tl257398257415_))
                                         (_K257396257410_
                                          _remote257420_
                                          _actor257418_)))
                                     (_E257395257404_))))
                             (table-ref _monitors257174_ _thread257383_ '()))
                            (table-set! _conns257172_ _address257388_)
                            (table-set! _threads257173_ _thread257383_)
                            (table-set! _monitors257174_ _thread257383_))
                          _$e257385_)
                         '#!void))
                   (let ((_$e257422_
                          (table-ref
                           _actor-threads257171_
                           _thread257383_
                           '#f)))
                     (if _$e257422_
                         ((lambda (_uuids257425_)
                            (for-each
                             (lambda (_g257426257428_)
                               (std/misc/sync#sync-hash-remove!
                                _actors257170_
                                _g257426257428_))
                             _uuids257425_)
                            (table-set! _actor-threads257171_ _thread257383_))
                          _$e257422_)
                         '#!void))))
                (_loop257182_
                 (lambda ()
                   (let _loop257244257246_ ()
                     (let ((_next257250_ (thread-mailbox-next)))
                       ((lambda (_msg257253_)
                          (let* ((_msg257255257273_ _msg257253_)
                                 (_else257261257281_
                                  (lambda () (_loop257244257246_))))
                            (let ((_K257271257378_
                                   (lambda (_msg257335_)
                                     (thread-mailbox-extract-and-rewind)
                                     (let ((_dest257337_
                                            (##direct-structure-ref
                                             _msg257335_
                                             '3
                                             std/actor/message#message::t
                                             '#f)))
                                       (if (eq? (current-thread) _dest257337_)
                                           (_handle-protocol-action257179_
                                            _msg257335_)
                                           (if (let ()
                                                 (declare (not safe))
                                                 (##structure-direct-instance-of?
                                                  _dest257337_
                                                  'std/actor/proto#remote::t))
                                               (let* ((_address257339_
                                                       (##direct-structure-ref
                                                        _dest257337_
                                                        '3
                                                        std/actor/proto#remote::t
                                                        '#f))
                                                      (_handler257341_
                                                       (_open-connection257178_
                                                        _address257339_)))
                                                 (if _handler257341_
                                                     (thread-send
                                                      _handler257341_
                                                      _msg257335_)
                                                     (std/actor/rpc/connection#rpc-send-error-response
                                                      _msg257335_
                                                      '"ivalid address")))
                                               (if (let ()
                                                     (declare (not safe))
                                                     (##structure-instance-of?
                                                      _dest257337_
                                                      'std/actor/proto#handle::t))
                                                   (let* ((_uuid257343_
                                                           (##structure-ref
                                                            _dest257337_
                                                            '2
                                                            std/actor/proto#handle::t
                                                            '#f))
                                                          (_$e257345_
                                                           (std/misc/sync#sync-hash-get
                                                            _actors257170_
                                                            _uuid257343_)))
                                                     (if _$e257345_
                                                         ((lambda (_e257347257349_)
                                                            (let* ((_g257351257358_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _e257347257349_)
                           (_E257353257362_
                            (lambda ()
                              (error '"No clause matching" _g257351257358_)))
                           (_K257354257367_
                            (lambda (_actor257365_)
                              (std/actor/message#send__0
                               _actor257365_
                               _msg257335_))))
                      (if (let ((__tmp311056
                                 (if (let ()
                                       (declare (not safe))
                                       (##values? _g257351257358_))
                                     (let ()
                                       (declare (not safe))
                                       (##vector-length _g257351257358_))
                                     '1)))
                            (declare (not safe))
                            (##fx= __tmp311056 '2))
                          (let* ((_e257355257370_
                                  (let ()
                                    (declare (not safe))
                                    (##vector-ref _g257351257358_ '0)))
                                 (_actor257373_ _e257355257370_)
                                 (_e257356257375_
                                  (let ()
                                    (declare (not safe))
                                    (##vector-ref _g257351257358_ '1))))
                            (_K257354257367_ _actor257373_))
                          (_E257353257362_))))
                  _$e257345_)
                 (std/actor/rpc/connection#rpc-send-error-response
                  _msg257335_
                  '"unknown actor")))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (begin
                                                     (std/actor/rpc/server#warnf
                                                      '"bad destination ~a"
                                                      _dest257337_)
                                                     (std/actor/rpc/connection#rpc-send-error-response
                                                      _msg257335_
                                                      '"bad destination"))))))))
                                  (_K257270257327_
                                   (lambda (_thread257325_)
                                     (thread-mailbox-extract-and-rewind)
                                     (if (memq _thread257325_
                                               _acceptors257175_)
                                         (std/actor/rpc/server#warnf
                                          '"acceptor thread has exited abnormally ~a"
                                          _thread257325_)
                                         (_remove-thread!257181_
                                          _thread257325_))))
                                  (_K257269257318_
                                   (lambda ()
                                     (thread-mailbox-extract-and-rewind)
                                     (_dump!257183_ (current-error-port))))
                                  (_K257264257298_
                                   (lambda (_port257296_)
                                     (thread-mailbox-extract-and-rewind)
                                     (_dump!257183_ _port257296_)))
                                  (_K257263257287_
                                   (lambda (_value257285_)
                                     (thread-mailbox-extract-and-rewind)
                                     (std/actor/rpc/server#warnf
                                      '"unexepected message ~a"
                                      _value257285_))))
                              (let* ((_try-match257259257313_
                                      (lambda ()
                                        (if (let ()
                                              (declare (not safe))
                                              (##pair? _msg257255257273_))
                                            (let ((_tl257266257303_
                                                   (let ()
                                                     (declare (not safe))
                                                     (##cdr _msg257255257273_)))
                                                  (_hd257265257301_
                                                   (let ()
                                                     (declare (not safe))
                                                     (##car _msg257255257273_))))
                                              (if (let ()
                                                    (declare (not safe))
                                                    (##eq? _hd257265257301_
                                                           'dump))
                                                  (if (let ()
                                                        (declare (not safe))
                                                        (##pair? _tl257266257303_))
                                                      (let ((_tl257268257308_
                                                             (let ()
                                                               (declare
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (not safe))
                       (##cdr _tl257266257303_)))
                    (_hd257267257306_
                     (let () (declare (not safe)) (##car _tl257266257303_))))
                (if (let () (declare (not safe)) (##null? _tl257268257308_))
                    (let ((_port257311_ _hd257267257306_))
                      (_K257264257298_ _port257311_))
                    (let ((_value257290_ _msg257255257273_))
                      (_K257263257287_ _value257290_))))
              (let ((_value257290_ _msg257255257273_))
                (_K257263257287_ _value257290_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                  (let ((_value257290_
                                                         _msg257255257273_))
                                                    (_K257263257287_
                                                     _value257290_))))
                                            (let ((_value257290_
                                                   _msg257255257273_))
                                              (_K257263257287_
                                               _value257290_)))))
                                     (_try-match257258257321_
                                      (lambda ()
                                        (if (let ()
                                              (declare (not safe))
                                              (##eq? _msg257255257273_ 'dump))
                                            (_K257269257318_)
                                            (_try-match257259257313_))))
                                     (_try-match257257257332_
                                      (lambda ()
                                        (if (thread? _msg257255257273_)
                                            (let ((_thread257330_
                                                   _msg257255257273_))
                                              (_K257270257327_ _thread257330_))
                                            (_try-match257258257321_)))))
                                (if (let ()
                                      (declare (not safe))
                                      (##structure-direct-instance-of?
                                       _msg257255257273_
                                       'std/actor/message#message::t))
                                    (let ((_msg257381_ _msg257255257273_))
                                      (_K257271257378_ _msg257381_))
                                    (_try-match257257257332_))))))
                        _next257250_)))
                   (_loop257182_)))
                (_dump!257183_
                 (lambda (_port257198_)
                   (call-with-parameters
                    (lambda ()
                      (displayln '"=== rpc-server ===")
                      (std/misc/sync#sync-hash-do
                       _actors257170_
                       (lambda (_ht257201_)
                         (displayln '"actors: " (table-length _ht257201_))
                         (table-for-each
                          (lambda (_uuid257203_ _actor-state257204_)
                            (let* ((_actor-state257205257212_
                                    _actor-state257204_)
                                   (_E257207257216_
                                    (lambda ()
                                      (error '"No clause matching"
                                             _actor-state257205257212_)))
                                   (_K257208257222_
                                    (lambda (_proto257219_ _actor257220_)
                                      (displayln
                                       (std/misc/uuid#uuid->string
                                        _uuid257203_)
                                       '" -> "
                                       (cons _actor257220_
                                             (cons _proto257219_ '()))))))
                              (if (let ((__tmp311057
                                         (if (let ()
                                               (declare (not safe))
                                               (##values?
                                                _actor-state257205257212_))
                                             (let ()
                                               (declare (not safe))
                                               (##vector-length
                                                _actor-state257205257212_))
                                             '1)))
                                    (declare (not safe))
                                    (##fx= __tmp311057 '2))
                                  (let* ((_e257209257225_
                                          (let ()
                                            (declare (not safe))
                                            (##vector-ref
                                             _actor-state257205257212_
                                             '0)))
                                         (_actor257228_ _e257209257225_)
                                         (_e257210257230_
                                          (let ()
                                            (declare (not safe))
                                            (##vector-ref
                                             _actor-state257205257212_
                                             '1)))
                                         (_proto257233_ _e257210257230_))
                                    (_K257208257222_
                                     _proto257233_
                                     _actor257228_))
                                  (_E257207257216_))))
                          _ht257201_)))
                      (displayln
                       '"actor-threads: "
                       (table-length _actor-threads257171_))
                      (table-for-each
                       (lambda (_thread257235_ _uuids257236_)
                         (displayln
                          _thread257235_
                          '" -> "
                          (map std/misc/uuid#uuid->string _uuids257236_)))
                       _actor-threads257171_)
                      (displayln '"connections: " (table-length _conns257172_))
                      (table-for-each
                       (lambda (_address257238_ _conn257239_)
                         (displayln _address257238_ '" -> " _conn257239_))
                       _conns257172_)
                      (displayln '"monitors: " (table-length _monitors257174_))
                      (table-for-each
                       (lambda (_conn257241_ _mons257242_)
                         (displayln _conn257241_ '" -> " _mons257242_))
                       _monitors257174_))
                    current-output-port
                    _port257198_))))
        (for-each std/actor/rpc/base#rpc-monitor _acceptors257175_)
        (with-exception-catcher
         (lambda (_g257184257186_)
           (if '#t
               (let ((_e257189_ _g257184257186_))
                 (for-each
                  (lambda (_g257190257192_)
                    (std/actor/message#send-message__0
                     _g257190257192_
                     (let ((__tmp311058
                            (let ()
                              (declare (not safe))
                              (##structure
                               std/actor/rpc/base#rpc.shutdown::t))))
                       (declare (not safe))
                       (##structure std/actor/proto#!event::t __tmp311058))))
                  (hash-keys _actor-threads257171_))
                 (for-each std/net/socket/api#ssocket-close _socks257164_)
                 (for-each
                  (lambda (_thread257195_)
                    (thread-send _thread257195_ 'shutdown)
                    (std/actor/message#send-message__0
                     _thread257195_
                     (let ((__tmp311059
                            (let ()
                              (declare (not safe))
                              (##structure
                               std/actor/rpc/base#rpc.connection-close::t))))
                       (declare (not safe))
                       (##structure std/actor/proto#!event::t __tmp311059))))
                  (hash-keys _threads257173_))
                 (for-each thread-join! (hash-keys _threads257173_))
                 (std/actor/rpc/connection#rpc-send-error-responses
                  '"server shutdown")
                 (raise _e257189_))
               (raise _g257184257186_)))
         (lambda () (_loop257182_))))))
  (define std/actor/rpc/server#rpc-server-accept
    (lambda (_rpc-server257137_ _sock257138_ _safamily257139_)
      (letrec ((_loop257141_
                (lambda ()
                  (let* ((_cliaddr257157_
                          (std/os/socket#make-socket-address _safamily257139_))
                         (_clisock257159_
                          (std/net/socket/api#ssocket-accept__1
                           _sock257138_
                           _cliaddr257157_)))
                    (std/actor/rpc/server#debugf
                     '"accepted connection from ~a"
                     (let ((_clistr257162_
                            (std/os/socket#socket-address->string
                             _cliaddr257157_)))
                       (if (string-empty? _clistr257162_)
                           '"?"
                           _clistr257162_)))
                    (std/actor/message#send-message__0
                     _rpc-server257137_
                     (let ((__tmp311060
                            (let ()
                              (declare (not safe))
                              (##structure
                               std/actor/rpc/base#rpc.connection-accept::t
                               _clisock257159_
                               _cliaddr257157_))))
                       (declare (not safe))
                       (##structure std/actor/proto#!event::t __tmp311060)))
                    (_loop257141_)))))
        (let _again257143_ ()
          (with-exception-catcher
           (lambda (_g257145257147_)
             (if ((lambda (_$obj257150_) (os-exception? _$obj257150_))
                  _g257145257147_)
                 (let ((_e257153_ _g257145257147_))
                   (std/actor/rpc/server#errorf
                    '"error accepting connection: ~a"
                    _e257153_)
                   (_again257143_))
                 (raise _g257145257147_)))
           (lambda () (_loop257141_))))))))
