(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/db/dbi#connection::t
    (make-struct-type
     'std/db/dbi#connection::t
     '#f
     '4
     'connection
     '()
     ':init!
     '(e txn-begin txn-commit txn-abort)))
  (define std/db/dbi#connection?
    (make-struct-predicate std/db/dbi#connection::t))
  (define std/db/dbi#make-connection
    (lambda _$args259525_
      (apply make-struct-instance std/db/dbi#connection::t _$args259525_)))
  (define std/db/dbi#connection-e
    (make-struct-field-accessor std/db/dbi#connection::t '0))
  (define std/db/dbi#connection-txn-begin
    (make-struct-field-accessor std/db/dbi#connection::t '1))
  (define std/db/dbi#connection-txn-commit
    (make-struct-field-accessor std/db/dbi#connection::t '2))
  (define std/db/dbi#connection-txn-abort
    (make-struct-field-accessor std/db/dbi#connection::t '3))
  (define std/db/dbi#connection-e-set!
    (make-struct-field-mutator std/db/dbi#connection::t '0))
  (define std/db/dbi#connection-txn-begin-set!
    (make-struct-field-mutator std/db/dbi#connection::t '1))
  (define std/db/dbi#connection-txn-commit-set!
    (make-struct-field-mutator std/db/dbi#connection::t '2))
  (define std/db/dbi#connection-txn-abort-set!
    (make-struct-field-mutator std/db/dbi#connection::t '3))
  (define std/db/dbi#statement::t
    (make-struct-type 'std/db/dbi#statement::t '#f '1 'statement '() '#f '(e)))
  (define std/db/dbi#statement?
    (make-struct-predicate std/db/dbi#statement::t))
  (define std/db/dbi#make-statement
    (lambda _$args259522_
      (apply make-struct-instance std/db/dbi#statement::t _$args259522_)))
  (define std/db/dbi#statement-e
    (make-struct-field-accessor std/db/dbi#statement::t '0))
  (define std/db/dbi#statement-e-set!
    (make-struct-field-mutator std/db/dbi#statement::t '0))
  (define std/db/dbi#connection:::init!
    (lambda (_self259519_ _e259520_)
      (if (let ((__tmp311147
                 (let () (declare (not safe)) (##vector-length _self259519_))))
            (declare (not safe))
            (##fx< '1 __tmp311147))
          (let ()
            (declare (not safe))
            (##vector-set! _self259519_ '1 _e259520_))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self259519_))))
  (bind-method!
   std/db/dbi#connection::t
   ':init!
   std/db/dbi#connection:::init!
   '#f)
  (define std/db/dbi#sql-error::t
    (make-struct-type
     'std/db/dbi#sql-error::t
     error::t
     '0
     'sql-error
     '()
     '#f
     '()))
  (define std/db/dbi#sql-error?
    (make-struct-predicate std/db/dbi#sql-error::t))
  (define std/db/dbi#make-sql-error
    (lambda _$args259394_
      (apply make-struct-instance std/db/dbi#sql-error::t _$args259394_)))
  (define std/db/dbi#raise-sql-error
    (lambda (_where259390_ _what259391_ . _irritants259392_)
      (raise (make-struct-instance
              std/db/dbi#sql-error::t
              _what259391_
              _irritants259392_
              _where259390_))))
  (define std/db/dbi#sql-connect
    (lambda (_connect259385_ . _args259386_)
      (let ((_conn259388_ (apply _connect259385_ _args259386_)))
        (make-will _conn259388_ std/db/dbi#sql-close)
        _conn259388_)))
  (define std/db/dbi#sql-close
    (lambda (_conn259335_)
      (let* ((_conn259336259345_ _conn259335_)
             (_E259338259349_
              (lambda () (error '"No clause matching" _conn259336259345_)))
             (_K259339259362_
              (lambda (_txn-abort259352_
                       _txn-commit259353_
                       _txn-begin259354_
                       _e259355_)
                (if _e259355_
                    (with-unwind-protect
                     (lambda ()
                       (if _txn-begin259354_
                           (with-exception-catcher
                            void
                            (lambda ()
                              (let ((__method311128
                                     (method-ref _txn-begin259354_ 'finalize)))
                                (if __method311128
                                    (__method311128 _txn-begin259354_)
                                    (error '"Missing method"
                                           _txn-begin259354_
                                           'finalize)))))
                           '#!void)
                       (if _txn-commit259353_
                           (with-exception-catcher
                            void
                            (lambda ()
                              (let ((__method311129
                                     (method-ref
                                      _txn-commit259353_
                                      'finalize)))
                                (if __method311129
                                    (__method311129 _txn-commit259353_)
                                    (error '"Missing method"
                                           _txn-commit259353_
                                           'finalize)))))
                           '#!void)
                       (if _txn-abort259352_
                           (with-exception-catcher
                            void
                            (lambda ()
                              (let ((__method311130
                                     (method-ref _txn-abort259352_ 'finalize)))
                                (if __method311130
                                    (__method311130 _txn-abort259352_)
                                    (error '"Missing method"
                                           _txn-abort259352_
                                           'finalize)))))
                           '#!void)
                       (let ((__method311131 (method-ref _conn259335_ 'close)))
                         (if __method311131
                             (__method311131 _conn259335_)
                             (error '"Missing method" _conn259335_ 'close))))
                     (lambda ()
                       (##structure-set!
                        _conn259335_
                        '#f
                        '1
                        std/db/dbi#connection::t
                        '#f)
                       (##structure-set!
                        _conn259335_
                        '#f
                        '2
                        std/db/dbi#connection::t
                        '#f)
                       (##structure-set!
                        _conn259335_
                        '#f
                        '3
                        std/db/dbi#connection::t
                        '#f)
                       (##structure-set!
                        _conn259335_
                        '#f
                        '4
                        std/db/dbi#connection::t
                        '#f)))
                    '#!void))))
        (if (let ()
              (declare (not safe))
              (##structure-instance-of?
               _conn259336259345_
               'std/db/dbi#connection::t))
            (let* ((_e259340259365_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _conn259336259345_ '1)))
                   (_e259368_ _e259340259365_)
                   (_e259341259370_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _conn259336259345_ '2)))
                   (_txn-begin259373_ _e259341259370_)
                   (_e259342259375_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _conn259336259345_ '3)))
                   (_txn-commit259378_ _e259342259375_)
                   (_e259343259380_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _conn259336259345_ '4)))
                   (_txn-abort259383_ _e259343259380_))
              (_K259339259362_
               _txn-abort259383_
               _txn-commit259378_
               _txn-begin259373_
               _e259368_))
            (_E259338259349_)))))
  (define std/db/dbi#connection::destroy std/db/dbi#sql-close)
  (bind-method!
   std/db/dbi#connection::t
   'destroy
   std/db/dbi#connection::destroy
   '#f)
  (define std/db/dbi#sql-txn-do
    (lambda (_conn259181_ _sql259182_ _getf259183_ _setf259184_)
      (let* ((_conn259185259191_ _conn259181_)
             (_E259187259195_
              (lambda () (error '"No clause matching" _conn259185259191_)))
             (_K259188259205_
              (lambda (_e259198_)
                (if (not _e259198_)
                    (error '"Invalid operation; connection closed"
                           _conn259181_)
                    (let ((_$e259200_ (_getf259183_ _conn259181_)))
                      (if _$e259200_
                          (std/db/dbi#sql-exec _$e259200_)
                          (let ((_stmt259203_
                                 (let ((__method311132
                                        (method-ref _conn259181_ 'prepare)))
                                   (if __method311132
                                       (__method311132
                                        _conn259181_
                                        _sql259182_)
                                       (error '"Missing method"
                                              _conn259181_
                                              'prepare)))))
                            (_setf259184_ _conn259181_ _stmt259203_)
                            (std/db/dbi#sql-exec _stmt259203_))))))))
        (if (let ()
              (declare (not safe))
              (##structure-instance-of?
               _conn259185259191_
               'std/db/dbi#connection::t))
            (let* ((_e259189259208_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _conn259185259191_ '1)))
                   (_e259211_ _e259189259208_))
              (_K259188259205_ _e259211_))
            (_E259187259195_)))))
  (define std/db/dbi#sql-txn-begin
    (lambda (_conn259179_)
      (std/db/dbi#sql-txn-do
       _conn259179_
       '"BEGIN TRANSACTION"
       std/db/dbi#connection-txn-begin
       std/db/dbi#connection-txn-begin-set!)))
  (define std/db/dbi#sql-txn-commit
    (lambda (_conn259177_)
      (std/db/dbi#sql-txn-do
       _conn259177_
       '"COMMIT"
       std/db/dbi#connection-txn-commit
       std/db/dbi#connection-txn-commit-set!)))
  (define std/db/dbi#sql-txn-abort
    (lambda (_conn259175_)
      (std/db/dbi#sql-txn-do
       _conn259175_
       '"ROLLBACK"
       std/db/dbi#connection-txn-abort
       std/db/dbi#connection-txn-abort-set!)))
  (define std/db/dbi#sql-prepare
    (lambda (_conn259170_ _text259171_)
      (if (##structure-ref _conn259170_ '1 std/db/dbi#connection::t '#f)
          (let ((_stmt259173_
                 (let ((__method311133 (method-ref _conn259170_ 'prepare)))
                   (if __method311133
                       (__method311133 _conn259170_ _text259171_)
                       (error '"Missing method" _conn259170_ 'prepare)))))
            (make-will _stmt259173_ std/db/dbi#sql-finalize)
            _stmt259173_)
          (error '"Invalid operation; connection closed" _conn259170_))))
  (define std/db/dbi#sql-finalize
    (lambda (_stmt259166_)
      (if (##structure-ref _stmt259166_ '1 std/db/dbi#statement::t '#f)
          (with-unwind-protect
           (lambda ()
             (let ((__method311134 (method-ref _stmt259166_ 'finalize)))
               (if __method311134
                   (__method311134 _stmt259166_)
                   (error '"Missing method" _stmt259166_ 'finalize))))
           (lambda ()
             (##structure-set!
              _stmt259166_
              '#f
              '1
              std/db/dbi#statement::t
              '#f)))
          '#!void)))
  (define std/db/dbi#statement::destroy std/db/dbi#sql-finalize)
  (bind-method!
   std/db/dbi#statement::t
   'destroy
   std/db/dbi#statement::destroy
   '#f)
  (define std/db/dbi#sql-bind
    (lambda (_stmt259041_ . _args259042_)
      (if (##structure-ref _stmt259041_ '1 std/db/dbi#statement::t '#f)
          (apply call-method _stmt259041_ 'bind _args259042_)
          (error '"Invalid operation; statement finalized" _stmt259041_))))
  (define std/db/dbi#sql-clear
    (lambda (_stmt259039_)
      (if (##structure-ref _stmt259039_ '1 std/db/dbi#statement::t '#f)
          (let ((__method311135 (method-ref _stmt259039_ 'clear)))
            (if __method311135
                (__method311135 _stmt259039_)
                (error '"Missing method" _stmt259039_ 'clear)))
          (error '"Invalid operation; statement finalized" _stmt259039_))))
  (define std/db/dbi#sql-reset
    (lambda (_stmt259037_)
      (if (##structure-ref _stmt259037_ '1 std/db/dbi#statement::t '#f)
          (let ((__method311136 (method-ref _stmt259037_ 'reset)))
            (if __method311136
                (__method311136 _stmt259037_)
                (error '"Missing method" _stmt259037_ 'reset)))
          (error '"Invalid operation; statement finalized" _stmt259037_))))
  (define std/db/dbi#sql-reset/clear
    (lambda (_stmt259035_)
      (if (##structure-ref _stmt259035_ '1 std/db/dbi#statement::t '#f)
          (begin
            (let ((__method311137 (method-ref _stmt259035_ 'reset)))
              (if __method311137
                  (__method311137 _stmt259035_)
                  (error '"Missing method" _stmt259035_ 'reset)))
            (let ((__method311138 (method-ref _stmt259035_ 'clear)))
              (if __method311138
                  (__method311138 _stmt259035_)
                  (error '"Missing method" _stmt259035_ 'clear))))
          (error '"Invalid operation; statement finalized" _stmt259035_))))
  (define std/db/dbi#sql-eval-e
    (lambda (_eval-e259026_ _conn259027_ _sql259028_ _args259029_)
      (let ((_stmt259031_ (std/db/dbi#sql-prepare _conn259027_ _sql259028_)))
        (with-unwind-protect
         (lambda ()
           (if (null? _args259029_)
               '#!void
               (apply std/db/dbi#sql-bind _stmt259031_ _args259029_))
           (_eval-e259026_ _stmt259031_))
         (lambda () (std/db/dbi#sql-finalize _stmt259031_))))))
  (define std/db/dbi#sql-eval
    (lambda (_conn259022_ _sql259023_ . _args259024_)
      (std/db/dbi#sql-eval-e
       std/db/dbi#sql-exec
       _conn259022_
       _sql259023_
       _args259024_)))
  (define std/db/dbi#sql-eval-query
    (lambda (_conn259018_ _sql259019_ . _args259020_)
      (std/db/dbi#sql-eval-e
       std/db/dbi#sql-query
       _conn259018_
       _sql259019_
       _args259020_)))
  (define std/db/dbi#sql-exec
    (lambda (_stmt259016_)
      (if (##structure-ref _stmt259016_ '1 std/db/dbi#statement::t '#f)
          (begin
            (let ((__method311139 (method-ref _stmt259016_ 'exec)))
              (if __method311139
                  (__method311139 _stmt259016_)
                  (error '"Missing method" _stmt259016_ 'exec)))
            (let ((__method311140 (method-ref _stmt259016_ 'reset)))
              (if __method311140
                  (__method311140 _stmt259016_)
                  (error '"Missing method" _stmt259016_ 'reset)))
            '#!void)
          (error '"Invalid operation; statement finalized" _stmt259016_))))
  (define std/db/dbi#sql-query
    (lambda (_stmt258955_)
      (let ((_iterable258978_ (std/db/dbi#in-sql-query _stmt258955_))
            (_iter-do258980_
             (lambda (_val258957_)
               (let* ((_val258959258964_ _val258957_)
                      (_E258961258968_
                       (lambda ()
                         (error '"No clause matching" _val258959258964_)))
                      (_K258962258973_ (lambda (_row258971_) _row258971_))
                      (_row258976_ _val258959258964_))
                 (_K258962258973_ _row258976_)))))
        (if (pair? _iterable258978_)
            (map _iter-do258980_ _iterable258978_)
            (if (null? _iterable258978_)
                '()
                (let* ((_it258983_ (std/iter#iter _iterable258978_))
                       (_next!258986_
                        (let ()
                          (declare (not safe))
                          (##unchecked-structure-ref
                           _it258983_
                           '2
                           std/iter#iterator::t
                           '#f))))
                  (declare (not safe))
                  (let ((_root258991_ (cons '#f '())))
                    (let _lp258994_ ((_tl258997_ _root258991_))
                      (let ((_val259000_ (_next!258986_ _it258983_)))
                        (if (eq? std/iter#iter-end _val259000_)
                            (begin
                              (let ((_$e259002_
                                     (##unchecked-structure-ref
                                      _it258983_
                                      '3
                                      std/iter#iterator::t
                                      '#f)))
                                (if _$e259002_
                                    ((lambda (_g259004259006_)
                                       (_g259004259006_ _it258983_))
                                     _$e259002_)
                                    '#!void))
                              (cdr _root258991_))
                            (let* ((_xval259009_ (_iter-do258980_ _val259000_))
                                   (_tl*259012_ (cons _xval259009_ '())))
                              (set-cdr! _tl258997_ _tl*259012_)
                              (_lp258994_ _tl*259012_))))))))))))
  (define std/db/dbi#:iter::statement
    (lambda (_stmt258953_) (std/db/dbi#in-sql-query _stmt258953_)))
  (std/generic/dispatch#generic-bind!
   std/iter#:iter::t
   (cons (std/generic/dispatch#type-linearize-class std/db/dbi#statement::t)
         '())
   std/db/dbi#:iter::statement)
  (define std/db/dbi#in-sql-query
    (lambda (_stmt258830_)
      (letrec ((_next258832_
                (lambda (_it258861_)
                  (let* ((_it258862258868_ _it258861_)
                         (_E258864258872_
                          (lambda ()
                            (error '"No clause matching" _it258862258868_)))
                         (_K258865258879_
                          (lambda (_stmt258875_)
                            (let ((_r258877_
                                   (let ((__method311141
                                          (method-ref
                                           _stmt258875_
                                           'query-fetch)))
                                     (if __method311141
                                         (__method311141 _stmt258875_)
                                         (error '"Missing method"
                                                _stmt258875_
                                                'query-fetch)))))
                              (if (std/iter#iter-end? _r258877_)
                                  std/iter#iter-end
                                  (let ((__method311142
                                         (method-ref _stmt258875_ 'query-row)))
                                    (if __method311142
                                        (__method311142 _stmt258875_)
                                        (error '"Missing method"
                                               _stmt258875_
                                               'query-row))))))))
                    (if (let ()
                          (declare (not safe))
                          (##structure-direct-instance-of?
                           _it258862258868_
                           'std/iter#iterator::t))
                        (let* ((_e258866258882_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref _it258862258868_ '1)))
                               (_stmt258885_ _e258866258882_))
                          (_K258865258879_ _stmt258885_))
                        (_E258864258872_)))))
               (_fini258833_
                (lambda (_it258837_)
                  (let* ((_it258838258844_ _it258837_)
                         (_E258840258848_
                          (lambda ()
                            (error '"No clause matching" _it258838258844_)))
                         (_K258841258853_
                          (lambda (_stmt258851_)
                            (if _stmt258851_
                                (begin
                                  (let ((__method311143
                                         (method-ref
                                          _stmt258851_
                                          'query-fini)))
                                    (if __method311143
                                        (__method311143 _stmt258851_)
                                        (error '"Missing method"
                                               _stmt258851_
                                               'query-fini)))
                                  (##direct-structure-set!
                                   _it258837_
                                   '#f
                                   '1
                                   std/iter#iterator::t
                                   '#f))
                                '#!void))))
                    (if (let ()
                          (declare (not safe))
                          (##structure-direct-instance-of?
                           _it258838258844_
                           'std/iter#iterator::t))
                        (let* ((_e258842258856_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref _it258838258844_ '1)))
                               (_stmt258859_ _e258842258856_))
                          (_K258841258853_ _stmt258859_))
                        (_E258840258848_))))))
        (if (##structure-ref _stmt258830_ '1 std/db/dbi#statement::t '#f)
            (let ((_it258835_
                   (let ((__obj311144 (make-object std/iter#iterator::t '3)))
                     (if (let ((__tmp311148
                                (let ()
                                  (declare (not safe))
                                  (##vector-length __obj311144))))
                           (declare (not safe))
                           (##fx< '3 __tmp311148))
                         (begin
                           (let ()
                             (declare (not safe))
                             (##vector-set! __obj311144 '1 _stmt258830_))
                           (let ()
                             (declare (not safe))
                             (##vector-set! __obj311144 '2 _next258832_))
                           (let ()
                             (declare (not safe))
                             (##vector-set! __obj311144 '3 _fini258833_)))
                         (error '"struct-instance-init!: too many arguments for struct"
                                __obj311144))
                     __obj311144)))
              (make-will _it258835_ _fini258833_)
              (let ((__method311145 (method-ref _stmt258830_ 'query-start)))
                (if __method311145
                    (__method311145 _stmt258830_)
                    (error '"Missing method" _stmt258830_ 'query-start)))
              _it258835_)
            (error '"Invalid operation; statement finalized" _stmt258830_)))))
  (define std/db/dbi#sql-columns
    (lambda (_stmt258828_)
      (if (##structure-ref _stmt258828_ '1 std/db/dbi#statement::t '#f)
          (let ((__method311146 (method-ref _stmt258828_ 'columns)))
            (if __method311146
                (__method311146 _stmt258828_)
                (error '"Missing method" _stmt258828_ 'columns)))
          (error '"Invalid operation; statement finalized" _stmt258828_)))))
