(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/db/lmdb#lmdb-error::t
    (make-struct-type
     'std/db/lmdb#lmdb-error::t
     error::t
     '0
     'lmdb-error
     '()
     '#f
     '()))
  (define std/db/lmdb#lmdb-error?
    (make-struct-predicate std/db/lmdb#lmdb-error::t))
  (define std/db/lmdb#make-lmdb-error
    (lambda _$args275951_
      (apply make-struct-instance std/db/lmdb#lmdb-error::t _$args275951_)))
  (define std/db/lmdb#raise-lmdb-error
    (lambda (_where275948_ _errno275949_)
      (raise (make-struct-instance
              std/db/lmdb#lmdb-error::t
              (std/db/_lmdb#mdb_strerror _errno275949_)
              (cons _errno275949_ '())
              _where275948_))))
  (define std/db/lmdb#lmdb-env::t
    (make-struct-type
     'std/db/lmdb#lmdb-env::t
     '#f
     '3
     'lmdb-env
     '((final: . #t))
     '#f
     '(ptr dbs mx)))
  (define std/db/lmdb#lmdb-env?
    (make-struct-predicate std/db/lmdb#lmdb-env::t))
  (define std/db/lmdb#make-lmdb-env
    (lambda _$args275945_
      (apply make-struct-instance std/db/lmdb#lmdb-env::t _$args275945_)))
  (define std/db/lmdb#lmdb-env-ptr
    (make-struct-field-accessor std/db/lmdb#lmdb-env::t '0))
  (define std/db/lmdb#lmdb-env-dbs
    (make-struct-field-accessor std/db/lmdb#lmdb-env::t '1))
  (define std/db/lmdb#lmdb-env-mx
    (make-struct-field-accessor std/db/lmdb#lmdb-env::t '2))
  (define std/db/lmdb#lmdb-env-ptr-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-env::t '0))
  (define std/db/lmdb#lmdb-env-dbs-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-env::t '1))
  (define std/db/lmdb#lmdb-env-mx-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-env::t '2))
  (define std/db/lmdb#lmdb-db::t
    (make-struct-type
     'std/db/lmdb#lmdb-db::t
     '#f
     '3
     'lmdb-db
     '((final: . #t))
     '#f
     '(env dbi name)))
  (define std/db/lmdb#lmdb-db? (make-struct-predicate std/db/lmdb#lmdb-db::t))
  (define std/db/lmdb#make-lmdb-db
    (lambda _$args275942_
      (apply make-struct-instance std/db/lmdb#lmdb-db::t _$args275942_)))
  (define std/db/lmdb#lmdb-db-env
    (make-struct-field-accessor std/db/lmdb#lmdb-db::t '0))
  (define std/db/lmdb#lmdb-db-dbi
    (make-struct-field-accessor std/db/lmdb#lmdb-db::t '1))
  (define std/db/lmdb#lmdb-db-name
    (make-struct-field-accessor std/db/lmdb#lmdb-db::t '2))
  (define std/db/lmdb#lmdb-db-env-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-db::t '0))
  (define std/db/lmdb#lmdb-db-dbi-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-db::t '1))
  (define std/db/lmdb#lmdb-db-name-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-db::t '2))
  (define std/db/lmdb#lmdb-txn::t
    (make-struct-type
     'std/db/lmdb#lmdb-txn::t
     '#f
     '3
     'lmdb-txn
     '((final: . #t))
     '#f
     '(env ptr val)))
  (define std/db/lmdb#lmdb-txn?
    (make-struct-predicate std/db/lmdb#lmdb-txn::t))
  (define std/db/lmdb#make-lmdb-txn
    (lambda _$args275939_
      (apply make-struct-instance std/db/lmdb#lmdb-txn::t _$args275939_)))
  (define std/db/lmdb#lmdb-txn-env
    (make-struct-field-accessor std/db/lmdb#lmdb-txn::t '0))
  (define std/db/lmdb#lmdb-txn-ptr
    (make-struct-field-accessor std/db/lmdb#lmdb-txn::t '1))
  (define std/db/lmdb#lmdb-txn-val
    (make-struct-field-accessor std/db/lmdb#lmdb-txn::t '2))
  (define std/db/lmdb#lmdb-txn-env-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-txn::t '0))
  (define std/db/lmdb#lmdb-txn-ptr-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-txn::t '1))
  (define std/db/lmdb#lmdb-txn-val-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-txn::t '2))
  (define std/db/lmdb#lmdb-cursor::t
    (make-struct-type
     'std/db/lmdb#lmdb-cursor::t
     '#f
     '5
     'lmdb-cursor
     '((final: . #t))
     '#f
     '(txn db ptr val1 val2)))
  (define std/db/lmdb#lmdb-cursor?
    (make-struct-predicate std/db/lmdb#lmdb-cursor::t))
  (define std/db/lmdb#make-lmdb-cursor
    (lambda _$args275936_
      (apply make-struct-instance std/db/lmdb#lmdb-cursor::t _$args275936_)))
  (define std/db/lmdb#lmdb-cursor-txn
    (make-struct-field-accessor std/db/lmdb#lmdb-cursor::t '0))
  (define std/db/lmdb#lmdb-cursor-db
    (make-struct-field-accessor std/db/lmdb#lmdb-cursor::t '1))
  (define std/db/lmdb#lmdb-cursor-ptr
    (make-struct-field-accessor std/db/lmdb#lmdb-cursor::t '2))
  (define std/db/lmdb#lmdb-cursor-val1
    (make-struct-field-accessor std/db/lmdb#lmdb-cursor::t '3))
  (define std/db/lmdb#lmdb-cursor-val2
    (make-struct-field-accessor std/db/lmdb#lmdb-cursor::t '4))
  (define std/db/lmdb#lmdb-cursor-txn-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-cursor::t '0))
  (define std/db/lmdb#lmdb-cursor-db-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-cursor::t '1))
  (define std/db/lmdb#lmdb-cursor-ptr-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-cursor::t '2))
  (define std/db/lmdb#lmdb-cursor-val1-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-cursor::t '3))
  (define std/db/lmdb#lmdb-cursor-val2-set!
    (make-struct-field-mutator std/db/lmdb#lmdb-cursor::t '4))
  (define std/db/lmdb#lmdb-open__%
    (lambda (_g312668_
             _maxdbs275874275881_
             _mapsize275875275883_
             _maxreaders275876275885_
             _flags275877275887_
             _mode275878275889_
             _path275891_)
      (let* ((_maxdbs275893_
              (if (eq? _maxdbs275874275881_ absent-value)
                  '1
                  _maxdbs275874275881_))
             (_mapsize275895_
              (if (eq? _mapsize275875275883_ absent-value)
                  '#f
                  _mapsize275875275883_))
             (_maxreaders275897_
              (if (eq? _maxreaders275876275885_ absent-value)
                  '#f
                  _maxreaders275876275885_))
             (_flags275899_
              (if (eq? _flags275877275887_ absent-value)
                  '0
                  _flags275877275887_))
             (_mode275901_
              (if (eq? _mode275878275889_ absent-value)
                  '432
                  _mode275878275889_)))
        (create-directory* _path275891_)
        (let ((_env**275903_ (std/db/_lmdb#ffi_make_mdb_env_ptr_ptr)))
          (if _env**275903_
              '#!void
              (error '"lmdb-open: memory allocation failure"))
          (let ((_res275905_ (std/db/_lmdb#mdb_env_create _env**275903_)))
            (if (let () (declare (not safe)) (##fxzero? _res275905_))
                '#!void
                (std/db/lmdb#raise-lmdb-error 'mdb_env_create _res275905_)))
          (let ((_env*275908_ (std/db/_lmdb#ffi_mdb_env_ptr _env**275903_)))
            (if _maxdbs275893_
                (let ((_res275910_
                       (std/db/_lmdb#mdb_env_set_maxdbs
                        _env*275908_
                        _maxdbs275893_)))
                  (if (let () (declare (not safe)) (##fxzero? _res275910_))
                      '#!void
                      (begin
                        (std/db/_lmdb#mdb_env_close _env*275908_)
                        (std/db/lmdb#raise-lmdb-error
                         'mdb_env_set_maxdbs
                         _res275910_))))
                '#!void)
            (if _mapsize275895_
                (let ((_res275913_
                       (std/db/_lmdb#mdb_env_set_mapsize
                        _env*275908_
                        _mapsize275895_)))
                  (if (let () (declare (not safe)) (##fxzero? _res275913_))
                      '#!void
                      (begin
                        (std/db/_lmdb#mdb_env_close _env*275908_)
                        (std/db/lmdb#raise-lmdb-error
                         'mdb_env_set_mapsize
                         _res275913_))))
                '#!void)
            (if _maxreaders275897_
                (let ((_res275916_
                       (std/db/_lmdb#mdb_env_set_maxreaders
                        _env*275908_
                        _maxreaders275897_)))
                  (if (let () (declare (not safe)) (##fxzero? _res275916_))
                      '#!void
                      (begin
                        (std/db/_lmdb#mdb_env_close _env*275908_)
                        (std/db/lmdb#raise-lmdb-error
                         'mdb_env_set_maxreaders
                         _res275916_))))
                '#!void)
            (let ((_res275919_
                   (std/db/_lmdb#mdb_env_open
                    _env*275908_
                    _path275891_
                    _flags275899_
                    _mode275901_)))
              (if (let () (declare (not safe)) (##fxzero? _res275919_))
                  '#!void
                  (begin
                    (std/db/_lmdb#mdb_env_close _env*275908_)
                    (std/db/lmdb#raise-lmdb-error 'mdb_env_open _res275919_))))
            (let ((__tmp312670 (make-table)) (__tmp312669 (make-mutex)))
              (declare (not safe))
              (##structure
               std/db/lmdb#lmdb-env::t
               _env*275908_
               __tmp312670
               __tmp312669)))))))
  (define std/db/lmdb#lmdb-open__@
    (lambda (_keys275873275925_ . _args275927_)
      (apply std/db/lmdb#lmdb-open__%
             _keys275873275925_
             (table-ref _keys275873275925_ 'max-dbs: absent-value)
             (table-ref _keys275873275925_ 'mapsize: absent-value)
             (table-ref _keys275873275925_ 'max-readers: absent-value)
             (table-ref _keys275873275925_ 'flags: absent-value)
             (table-ref _keys275873275925_ 'mode: absent-value)
             _args275927_)))
  (define std/db/lmdb#lmdb-open
    (lambda _args275879275933_
      (apply keyword-dispatch
             '#(mapsize: #f flags: #f mode: max-dbs: max-readers: #f #f #f)
             std/db/lmdb#lmdb-open__@
             _args275879275933_)))
  (define std/db/lmdb#lmdb-sync__%
    (lambda (_env275834_ _force?275835_)
      (let* ((_env275836275842_ _env275834_)
             (_E275838275846_
              (lambda () (error '"No clause matching" _env275836275842_)))
             (_K275839275854_
              (lambda (_env*275849_)
                (if _env*275849_ '#!void (error '"lmdb-open-db: invalid env"))
                (let ((_res275851_
                       (std/db/_lmdb#mdb_env_sync
                        _env*275849_
                        (if _force?275835_ '1 '0))))
                  (if (let () (declare (not safe)) (##fxzero? _res275851_))
                      '#!void
                      (std/db/lmdb#raise-lmdb-error
                       'mdb_env_sync
                       _res275851_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _env275836275842_
               'std/db/lmdb#lmdb-env::t))
            (let* ((_e275840275857_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _env275836275842_ '1)))
                   (_env*275860_ _e275840275857_))
              (_K275839275854_ _env*275860_))
            (_E275838275846_)))))
  (define std/db/lmdb#lmdb-sync__0
    (lambda (_env275865_)
      (let ((_force?275867_ '#f))
        (std/db/lmdb#lmdb-sync__% _env275865_ _force?275867_))))
  (define std/db/lmdb#lmdb-sync
    (lambda _g312672_
      (let ((_g312671_ (let () (declare (not safe)) (##length _g312672_))))
        (cond ((let () (declare (not safe)) (##fx= _g312671_ 1))
               (apply std/db/lmdb#lmdb-sync__0 _g312672_))
              ((let () (declare (not safe)) (##fx= _g312671_ 2))
               (apply std/db/lmdb#lmdb-sync__% _g312672_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/lmdb#lmdb-sync
                _g312672_))))))
  (define std/db/lmdb#lmdb-close
    (lambda (_env275809_)
      (let* ((_env275810275816_ _env275809_)
             (_E275812275820_
              (lambda () (error '"No clause matching" _env275810275816_)))
             (_K275813275825_
              (lambda (_env*275823_)
                (if _env*275823_
                    '#!void
                    (begin
                      (std/db/_lmdb#mdb_env_close _env*275823_)
                      (##direct-structure-set!
                       _env275809_
                       '#f
                       '1
                       std/db/lmdb#lmdb-env::t
                       '#f))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _env275810275816_
               'std/db/lmdb#lmdb-env::t))
            (let* ((_e275814275828_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _env275810275816_ '1)))
                   (_env*275831_ _e275814275828_))
              (_K275813275825_ _env*275831_))
            (_E275812275820_)))))
  (define std/db/lmdb#lmdb-env::destroy std/db/lmdb#lmdb-close)
  (bind-method!
   std/db/lmdb#lmdb-env::t
   'destroy
   std/db/lmdb#lmdb-env::destroy
   '#f)
  (define std/db/lmdb#lmdb-stat
    (lambda (_env275657_)
      (let* ((_env275658275664_ _env275657_)
             (_E275660275668_
              (lambda () (error '"No clause matching" _env275658275664_)))
             (_K275661275679_
              (lambda (_env*275671_)
                (if _env*275671_ '#!void (error '"lmdb-open-db: invalid env"))
                (let ((_stat*275673_ (std/db/_lmdb#ffi_make_mdb_stat_ptr)))
                  (if _stat*275673_
                      '#!void
                      (error '"lmdb-stat: memory allocation failure"))
                  (let ((_res275676_
                         (std/db/_lmdb#mdb_env_stat
                          _env*275671_
                          _stat*275673_)))
                    (if (let () (declare (not safe)) (##fxzero? _res275676_))
                        '#!void
                        (std/db/lmdb#raise-lmdb-error
                         'mdb_env_stat
                         _res275676_)))
                  (cons 'psize:
                        (cons (std/db/_lmdb#ffi_mdb_stat_psize)
                              (cons 'depth:
                                    (cons (std/db/_lmdb#ffi_mdb_stat_depth)
                                          (cons 'branch-pages:
                                                (cons (std/db/_lmdb#ffi_mdb_stat_branch_pages)
                                                      (cons 'leaf-pages:
                                                            (cons (std/db/_lmdb#ffi_mdb_stat_leaf_pages)
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (cons 'overflow-pages:
                                (cons (std/db/_lmdb#ffi_mdb_stat_overflow_pages)
                                      (cons 'entries:
                                            (cons (std/db/_lmdb#ffi_mdb_stat_entries)
                                                  '()))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _env275658275664_
               'std/db/lmdb#lmdb-env::t))
            (let* ((_e275662275682_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _env275658275664_ '1)))
                   (_env*275685_ _e275662275682_))
              (_K275661275679_ _env*275685_))
            (_E275660275668_)))))
  (define std/db/lmdb#lmdb-open-db__%
    (lambda (_env275582_ _name275583_ _flags275584_)
      (let* ((_env275585275593_ _env275582_)
             (_E275587275597_
              (lambda () (error '"No clause matching" _env275585275593_)))
             (_K275588275627_
              (lambda (_mx275600_ _dbs275601_ _env*275602_)
                (if _env*275602_ '#!void (error '"lmdb-open-db: invalid env"))
                (gerbil/gambit/threads#with-lock
                 _mx275600_
                 (lambda ()
                   (let ((_$e275605_ (table-ref _dbs275601_ _name275583_ '#f)))
                     (if _$e275605_
                         (values _$e275605_)
                         (let ((_txn**275608_
                                (std/db/_lmdb#ffi_make_mdb_txn_ptr_ptr))
                               (_dbi*275609_
                                (std/db/_lmdb#ffi_make_mdb_dbi_ptr)))
                           (if (and _txn**275608_ _dbi*275609_)
                               '#!void
                               (error '"lmdb-open-db: memory allocation failure"))
                           (let ((_res275611_
                                  (std/db/_lmdb#mdb_txn_begin
                                   _env*275602_
                                   '#f
                                   '0
                                   _txn**275608_)))
                             (if (let ()
                                   (declare (not safe))
                                   (##fxzero? _res275611_))
                                 '#!void
                                 (std/db/lmdb#raise-lmdb-error
                                  'mdb_txn_begin
                                  _res275611_)))
                           (let ((_txn*275614_
                                  (std/db/_lmdb#ffi_mdb_txn_ptr
                                   _txn**275608_)))
                             (let ((_res275616_
                                    (std/db/_lmdb#mdb_dbi_open
                                     _txn*275614_
                                     _name275583_
                                     _flags275584_
                                     _dbi*275609_)))
                               (if (let ()
                                     (declare (not safe))
                                     (##fxzero? _res275616_))
                                   '#!void
                                   (begin
                                     (std/db/_lmdb#mdb_txn_abort _txn*275614_)
                                     (std/db/lmdb#raise-lmdb-error
                                      'mdb_dbi_open
                                      _res275616_))))
                             (let ((_res275619_
                                    (std/db/_lmdb#mdb_txn_commit
                                     _txn*275614_)))
                               (if (let ()
                                     (declare (not safe))
                                     (##fxzero? _res275619_))
                                   '#!void
                                   (std/db/lmdb#raise-lmdb-error
                                    'mdb_txn_commit
                                    _res275619_))))
                           (let* ((_dbi275622_
                                   (std/db/_lmdb#ffi_mdb_dbi_ptr_value
                                    _dbi*275609_))
                                  (_db275624_
                                   (let ()
                                     (declare (not safe))
                                     (##structure
                                      std/db/lmdb#lmdb-db::t
                                      _env275582_
                                      _dbi275622_
                                      _name275583_))))
                             (table-set! _dbs275601_ _name275583_ _db275624_)
                             _db275624_)))))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _env275585275593_
               'std/db/lmdb#lmdb-env::t))
            (let* ((_e275589275630_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _env275585275593_ '1)))
                   (_env*275633_ _e275589275630_)
                   (_e275590275635_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _env275585275593_ '2)))
                   (_dbs275638_ _e275590275635_)
                   (_e275591275640_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _env275585275593_ '3)))
                   (_mx275643_ _e275591275640_))
              (_K275588275627_ _mx275643_ _dbs275638_ _env*275633_))
            (_E275587275597_)))))
  (define std/db/lmdb#lmdb-open-db__0
    (lambda (_env275648_ _name275649_)
      (let ((_flags275651_ std/db/_lmdb#MDB_CREATE))
        (std/db/lmdb#lmdb-open-db__% _env275648_ _name275649_ _flags275651_))))
  (define std/db/lmdb#lmdb-open-db
    (lambda _g312674_
      (let ((_g312673_ (let () (declare (not safe)) (##length _g312674_))))
        (cond ((let () (declare (not safe)) (##fx= _g312673_ 2))
               (apply std/db/lmdb#lmdb-open-db__0 _g312674_))
              ((let () (declare (not safe)) (##fx= _g312673_ 3))
               (apply std/db/lmdb#lmdb-open-db__% _g312674_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/lmdb#lmdb-open-db
                _g312674_))))))
  (define std/db/lmdb#lmdb-close-db
    (lambda (_db275506_)
      (let* ((_db275507275515_ _db275506_)
             (_E275509275519_
              (lambda () (error '"No clause matching" _db275507275515_)))
             (_K275510275563_
              (lambda (_name275522_ _dbi275523_ _env275524_)
                (if _dbi275523_
                    (let* ((_env275525275533_ _env275524_)
                           (_E275527275537_
                            (lambda ()
                              (error '"No clause matching" _env275525275533_)))
                           (_K275528275545_
                            (lambda (_mx275540_ _dbs275541_ _env*275542_)
                              (gerbil/gambit/threads#with-lock
                               _mx275540_
                               (lambda ()
                                 (std/db/_lmdb#mdb_dbi_close
                                  _env*275542_
                                  _dbi275523_)
                                 (##direct-structure-set!
                                  _db275506_
                                  '#f
                                  '2
                                  std/db/lmdb#lmdb-db::t
                                  '#f)
                                 (table-set! _dbs275541_ _name275522_))))))
                      (if (let ()
                            (declare (not safe))
                            (##structure-direct-instance-of?
                             _env275525275533_
                             'std/db/lmdb#lmdb-env::t))
                          (let* ((_e275529275548_
                                  (let ()
                                    (declare (not safe))
                                    (##vector-ref _env275525275533_ '1)))
                                 (_env*275551_ _e275529275548_)
                                 (_e275530275553_
                                  (let ()
                                    (declare (not safe))
                                    (##vector-ref _env275525275533_ '2)))
                                 (_dbs275556_ _e275530275553_)
                                 (_e275531275558_
                                  (let ()
                                    (declare (not safe))
                                    (##vector-ref _env275525275533_ '3)))
                                 (_mx275561_ _e275531275558_))
                            (_K275528275545_
                             _mx275561_
                             _dbs275556_
                             _env*275551_))
                          (_E275527275537_)))
                    '#!void))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _db275507275515_
               'std/db/lmdb#lmdb-db::t))
            (let* ((_e275511275566_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _db275507275515_ '1)))
                   (_env275569_ _e275511275566_)
                   (_e275512275571_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _db275507275515_ '2)))
                   (_dbi275574_ _e275512275571_)
                   (_e275513275576_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _db275507275515_ '3)))
                   (_name275579_ _e275513275576_))
              (_K275510275563_ _name275579_ _dbi275574_ _env275569_))
            (_E275509275519_)))))
  (define std/db/lmdb#lmdb-db::destroy std/db/lmdb#lmdb-close-db)
  (bind-method!
   std/db/lmdb#lmdb-db::t
   'destroy
   std/db/lmdb#lmdb-db::destroy
   '#f)
  (define std/db/lmdb#lmdb-txn-begin__%
    (lambda (_env275305_ _parent275306_ _flags275307_)
      (let* ((_env275308275314_ _env275305_)
             (_E275310275318_
              (lambda () (error '"No clause matching" _env275308275314_)))
             (_K275311275358_
              (lambda (_env*275321_)
                (if _env*275321_ '#!void (error '"lmdb-open-db: invalid env"))
                (let ((_txn**275349_ (std/db/_lmdb#ffi_make_mdb_txn_ptr_ptr))
                      (_partxn*275350_
                       (if _parent275306_
                           (let* ((_parent275322275329_ _parent275306_)
                                  (_E275324275333_
                                   (lambda ()
                                     (error '"No clause matching"
                                            _parent275322275329_)))
                                  (_K275325275338_
                                   (lambda (_txn*275336_) _txn*275336_)))
                             (if (let ()
                                   (declare (not safe))
                                   (##structure-direct-instance-of?
                                    _parent275322275329_
                                    'std/db/lmdb#lmdb-txn::t))
                                 (let* ((_e275326275341_
                                         (let ()
                                           (declare (not safe))
                                           (##vector-ref
                                            _parent275322275329_
                                            '1)))
                                        (_e275327275344_
                                         (let ()
                                           (declare (not safe))
                                           (##vector-ref
                                            _parent275322275329_
                                            '2)))
                                        (_txn*275347_ _e275327275344_))
                                   (_K275325275338_ _txn*275347_))
                                 (_E275324275333_)))
                           '#f)))
                  (if _txn**275349_
                      '#!void
                      (error '"lmdb-txn-begin: memory allocation failure"))
                  (let ((_res275352_
                         (std/db/_lmdb#mdb_txn_begin
                          _env*275321_
                          _parent275306_
                          _flags275307_
                          _txn**275349_)))
                    (if (let () (declare (not safe)) (##fxzero? _res275352_))
                        '#!void
                        (std/db/lmdb#raise-lmdb-error
                         'mdb_txn_begin
                         _res275352_)))
                  (let ((_txn*275355_
                         (std/db/_lmdb#ffi_mdb_txn_ptr _txn**275349_))
                        (_val*275356_ (std/db/_lmdb#ffi_make_mdb_val_ptr)))
                    (if (and _txn*275355_ _val*275356_)
                        '#!void
                        (error '"lmdb-stat: memory allocation failure"))
                    (let ()
                      (declare (not safe))
                      (##structure
                       std/db/lmdb#lmdb-txn::t
                       _env275305_
                       _txn*275355_
                       _val*275356_)))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _env275308275314_
               'std/db/lmdb#lmdb-env::t))
            (let* ((_e275312275361_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _env275308275314_ '1)))
                   (_env*275364_ _e275312275361_))
              (_K275311275358_ _env*275364_))
            (_E275310275318_)))))
  (define std/db/lmdb#lmdb-txn-begin__0
    (lambda (_env275369_)
      (let* ((_parent275371_ '#f) (_flags275373_ '0))
        (std/db/lmdb#lmdb-txn-begin__%
         _env275369_
         _parent275371_
         _flags275373_))))
  (define std/db/lmdb#lmdb-txn-begin__1
    (lambda (_env275375_ _parent275376_)
      (let ((_flags275378_ '0))
        (std/db/lmdb#lmdb-txn-begin__%
         _env275375_
         _parent275376_
         _flags275378_))))
  (define std/db/lmdb#lmdb-txn-begin
    (lambda _g312676_
      (let ((_g312675_ (let () (declare (not safe)) (##length _g312676_))))
        (cond ((let () (declare (not safe)) (##fx= _g312675_ 1))
               (apply std/db/lmdb#lmdb-txn-begin__0 _g312676_))
              ((let () (declare (not safe)) (##fx= _g312675_ 2))
               (apply std/db/lmdb#lmdb-txn-begin__1 _g312676_))
              ((let () (declare (not safe)) (##fx= _g312675_ 3))
               (apply std/db/lmdb#lmdb-txn-begin__% _g312676_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/lmdb#lmdb-txn-begin
                _g312676_))))))
  (define std/db/lmdb#lmdb-txn-id
    (lambda (_txn275276_)
      (let* ((_txn275277275284_ _txn275276_)
             (_E275279275288_
              (lambda () (error '"No clause matching" _txn275277275284_)))
             (_K275280275293_
              (lambda (_txn*275291_) (std/db/_lmdb#mdb_txn_id _txn*275291_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _txn275277275284_
               'std/db/lmdb#lmdb-txn::t))
            (let* ((_e275281275296_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _txn275277275284_ '1)))
                   (_e275282275299_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _txn275277275284_ '2)))
                   (_txn*275302_ _e275282275299_))
              (std/db/_lmdb#mdb_txn_id _txn*275302_))
            (_E275279275288_)))))
  (define std/db/lmdb#lmdb-txn-commit
    (lambda (_txn275245_)
      (let* ((_txn275246275253_ _txn275245_)
             (_E275248275257_
              (lambda () (error '"No clause matching" _txn275246275253_)))
             (_K275249275265_
              (lambda (_txn*275260_)
                (let ((_res275262_ (std/db/_lmdb#mdb_txn_commit _txn*275260_)))
                  (if (let () (declare (not safe)) (##fxzero? _res275262_))
                      '#!void
                      (std/db/lmdb#raise-lmdb-error
                       'mdb_txn_commit
                       _res275262_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _txn275246275253_
               'std/db/lmdb#lmdb-txn::t))
            (let* ((_e275250275268_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _txn275246275253_ '1)))
                   (_e275251275271_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _txn275246275253_ '2)))
                   (_txn*275274_ _e275251275271_))
              (_K275249275265_ _txn*275274_))
            (_E275248275257_)))))
  (define std/db/lmdb#lmdb-txn-abort
    (lambda (_txn275217_)
      (let* ((_txn275218275225_ _txn275217_)
             (_E275220275229_
              (lambda () (error '"No clause matching" _txn275218275225_)))
             (_K275221275234_
              (lambda (_txn*275232_)
                (std/db/_lmdb#mdb_txn_abort _txn*275232_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _txn275218275225_
               'std/db/lmdb#lmdb-txn::t))
            (let* ((_e275222275237_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _txn275218275225_ '1)))
                   (_e275223275240_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _txn275218275225_ '2)))
                   (_txn*275243_ _e275223275240_))
              (std/db/_lmdb#mdb_txn_abort _txn*275243_))
            (_E275220275229_)))))
  (define std/db/lmdb#lmdb-txn-reset
    (lambda (_txn275189_)
      (let* ((_txn275190275197_ _txn275189_)
             (_E275192275201_
              (lambda () (error '"No clause matching" _txn275190275197_)))
             (_K275193275206_
              (lambda (_txn*275204_)
                (std/db/_lmdb#mdb_txn_reset _txn*275204_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _txn275190275197_
               'std/db/lmdb#lmdb-txn::t))
            (let* ((_e275194275209_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _txn275190275197_ '1)))
                   (_e275195275212_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _txn275190275197_ '2)))
                   (_txn*275215_ _e275195275212_))
              (std/db/_lmdb#mdb_txn_reset _txn*275215_))
            (_E275192275201_)))))
  (define std/db/lmdb#lmdb-txn-renew
    (lambda (_txn275158_)
      (let* ((_txn275159275166_ _txn275158_)
             (_E275161275170_
              (lambda () (error '"No clause matching" _txn275159275166_)))
             (_K275162275178_
              (lambda (_txn*275173_)
                (let ((_res275175_ (std/db/_lmdb#mdb_txn_renew _txn*275173_)))
                  (if (let () (declare (not safe)) (##fxzero? _res275175_))
                      '#!void
                      (std/db/lmdb#raise-lmdb-error
                       'mdb_txn_renew
                       _res275175_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _txn275159275166_
               'std/db/lmdb#lmdb-txn::t))
            (let* ((_e275163275181_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _txn275159275166_ '1)))
                   (_e275164275184_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _txn275159275166_ '2)))
                   (_txn*275187_ _e275164275184_))
              (_K275162275178_ _txn*275187_))
            (_E275161275170_)))))
  (define std/db/lmdb#lmdb-db-stat
    (lambda (_txn275109_ _db275110_)
      (let ((_txn275111275121_ _txn275109_) (_db275112275123_ _db275110_))
        (let* ((_E275114275127_
                (lambda ()
                  (error '"No clause matching"
                         _txn275111275121_
                         _db275112275123_)))
               (_K275115275139_
                (lambda (_txn*275130_ _dbi275131_)
                  (let ((_stat*275133_ (std/db/_lmdb#ffi_make_mdb_stat_ptr)))
                    (if _stat*275133_
                        '#!void
                        (error '"lmdb-stat: memory allocation failure"))
                    (let ((_res275136_
                           (_txn*275130_ _dbi275131_ _stat*275133_)))
                      (if (let () (declare (not safe)) (##fxzero? _res275136_))
                          '#!void
                          (std/db/lmdb#raise-lmdb-error 'txn* _res275136_)))
                    (cons 'psize:
                          (cons (std/db/_lmdb#ffi_mdb_stat_psize)
                                (cons 'depth:
                                      (cons (std/db/_lmdb#ffi_mdb_stat_depth)
                                            (cons 'branch-pages:
                                                  (cons (std/db/_lmdb#ffi_mdb_stat_branch_pages)
                                                        (cons 'leaf-pages:
                                                              (cons (std/db/_lmdb#ffi_mdb_stat_leaf_pages)
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            (cons 'overflow-pages:
                                  (cons (std/db/_lmdb#ffi_mdb_stat_overflow_pages)
                                        (cons 'entries:
                                              (cons (std/db/_lmdb#ffi_mdb_stat_entries)
                                                    '()))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _txn275111275121_
                 'std/db/lmdb#lmdb-txn::t))
              (let* ((_e275118275142_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _txn275111275121_ '1)))
                     (_e275119275145_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _txn275111275121_ '2)))
                     (_txn*275148_ _e275119275145_))
                (if (let ()
                      (declare (not safe))
                      (##structure-direct-instance-of?
                       _db275112275123_
                       'std/db/lmdb#lmdb-db::t))
                    (let* ((_e275116275150_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _db275112275123_ '1)))
                           (_e275117275153_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _db275112275123_ '2)))
                           (_dbi275156_ _e275117275153_))
                      (_K275115275139_ _txn*275148_ _dbi275156_))
                    (_E275114275127_)))
              (_E275114275127_))))))
  (define std/db/lmdb#lmdb-db-drop__%
    (lambda (_txn275050_ _db275051_ _del?275052_)
      (let ((_txn275053275063_ _txn275050_) (_db275054275065_ _db275051_))
        (let* ((_E275056275069_
                (lambda ()
                  (error '"No clause matching"
                         _txn275053275063_
                         _db275054275065_)))
               (_K275057275078_
                (lambda (_txn*275072_ _dbi275073_)
                  (let ((_res275075_
                         (std/db/_lmdb#mdb_drop
                          _txn*275072_
                          _dbi275073_
                          (if _del?275052_ '1 '0))))
                    (if (let () (declare (not safe)) (##fxzero? _res275075_))
                        '#!void
                        (std/db/lmdb#raise-lmdb-error
                         'mdb_drop
                         _res275075_))))))
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _txn275053275063_
                 'std/db/lmdb#lmdb-txn::t))
              (let* ((_e275060275081_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _txn275053275063_ '1)))
                     (_e275061275084_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _txn275053275063_ '2)))
                     (_txn*275087_ _e275061275084_))
                (if (let ()
                      (declare (not safe))
                      (##structure-direct-instance-of?
                       _db275054275065_
                       'std/db/lmdb#lmdb-db::t))
                    (let* ((_e275058275089_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _db275054275065_ '1)))
                           (_e275059275092_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _db275054275065_ '2)))
                           (_dbi275095_ _e275059275092_))
                      (_K275057275078_ _txn*275087_ _dbi275095_))
                    (_E275056275069_)))
              (_E275056275069_))))))
  (define std/db/lmdb#lmdb-db-drop__0
    (lambda (_txn275100_ _db275101_)
      (let ((_del?275103_ '#f))
        (std/db/lmdb#lmdb-db-drop__% _txn275100_ _db275101_ _del?275103_))))
  (define std/db/lmdb#lmdb-db-drop
    (lambda _g312678_
      (let ((_g312677_ (let () (declare (not safe)) (##length _g312678_))))
        (cond ((let () (declare (not safe)) (##fx= _g312677_ 2))
               (apply std/db/lmdb#lmdb-db-drop__0 _g312678_))
              ((let () (declare (not safe)) (##fx= _g312677_ 3))
               (apply std/db/lmdb#lmdb-db-drop__% _g312678_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/lmdb#lmdb-db-drop
                _g312678_))))))
  (define std/db/lmdb#value-bytes
    (lambda (_key275047_)
      (if (u8vector? _key275047_)
          _key275047_
          (if (string? _key275047_)
              (std/text/utf8#string->utf8__0 _key275047_)
              (error '"Bad argument: expected u8vector or string"
                     _key275047_)))))
  (define std/db/lmdb#value-data
    (lambda (_val*275040_)
      (let* ((_size275042_ (std/db/_lmdb#ffi_mdb_val_size _val*275040_))
             (_bytes275044_ (make-u8vector _size275042_)))
        (std/db/_lmdb#ffi_mdb_val_data _val*275040_ _bytes275044_)
        _bytes275044_)))
  (define std/db/lmdb#value-data*
    (lambda (_val*275034_)
      (let ((_size275036_ (std/db/_lmdb#ffi_mdb_val_size _val*275034_)))
        (if _size275036_
            (let ((_bytes275038_ (make-u8vector _size275036_)))
              (std/db/_lmdb#ffi_mdb_val_data _val*275034_ _bytes275038_)
              _bytes275038_)
            '#f))))
  (define std/db/lmdb#lmdb-get
    (lambda (_txn274979_ _db274980_ _key274981_)
      (let ((_keyb274983_ (std/db/lmdb#value-bytes _key274981_)))
        (let ((_txn274984274995_ _txn274979_) (_db274985274997_ _db274980_))
          (let* ((_E274987275001_
                  (lambda ()
                    (error '"No clause matching"
                           _txn274984274995_
                           _db274985274997_)))
                 (_K274988275010_
                  (lambda (_val*275004_ _txn*275005_ _dbi275006_)
                    (let ((_res275008_
                           (std/db/_lmdb#mdb_get
                            _txn*275005_
                            _dbi275006_
                            _keyb274983_
                            _val*275004_)))
                      (if (let () (declare (not safe)) (##fxzero? _res275008_))
                          (std/db/lmdb#value-data _val*275004_)
                          (if (eq? _res275008_ std/db/_lmdb#MDB_NOTFOUND)
                              '#f
                              (std/db/lmdb#raise-lmdb-error
                               'mdb_get
                               _res275008_)))))))
            (if (let ()
                  (declare (not safe))
                  (##structure-direct-instance-of?
                   _txn274984274995_
                   'std/db/lmdb#lmdb-txn::t))
                (let* ((_e274991275013_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _txn274984274995_ '1)))
                       (_e274992275016_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _txn274984274995_ '2)))
                       (_txn*275019_ _e274992275016_)
                       (_e274993275021_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _txn274984274995_ '3)))
                       (_val*275024_ _e274993275021_))
                  (if (let ()
                        (declare (not safe))
                        (##structure-direct-instance-of?
                         _db274985274997_
                         'std/db/lmdb#lmdb-db::t))
                      (let* ((_e274989275026_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _db274985274997_ '1)))
                             (_e274990275029_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _db274985274997_ '2)))
                             (_dbi275032_ _e274990275029_))
                        (_K274988275010_
                         _val*275024_
                         _txn*275019_
                         _dbi275032_))
                      (_E274987275001_)))
                (_E274987275001_)))))))
  (define std/db/lmdb#lmdb-put__%
    (lambda (_txn274911_ _db274912_ _key274913_ _val274914_ _flags274915_)
      (let ((_keyx274917_ (std/db/lmdb#value-bytes _key274913_))
            (_valx274918_ (std/db/lmdb#value-bytes _val274914_)))
        (let ((_txn274919274929_ _txn274911_) (_db274920274931_ _db274912_))
          (let* ((_E274922274935_
                  (lambda ()
                    (error '"No clause matching"
                           _txn274919274929_
                           _db274920274931_)))
                 (_K274923274944_
                  (lambda (_txn*274938_ _dbi274939_)
                    (let ((_res274941_
                           (std/db/_lmdb#mdb_put
                            _txn*274938_
                            _dbi274939_
                            _keyx274917_
                            _valx274918_
                            _flags274915_)))
                      (if (let () (declare (not safe)) (##fxzero? _res274941_))
                          '#!void
                          (std/db/lmdb#raise-lmdb-error
                           'mdb_put
                           _res274941_))))))
            (if (let ()
                  (declare (not safe))
                  (##structure-direct-instance-of?
                   _txn274919274929_
                   'std/db/lmdb#lmdb-txn::t))
                (let* ((_e274926274947_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _txn274919274929_ '1)))
                       (_e274927274950_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _txn274919274929_ '2)))
                       (_txn*274953_ _e274927274950_))
                  (if (let ()
                        (declare (not safe))
                        (##structure-direct-instance-of?
                         _db274920274931_
                         'std/db/lmdb#lmdb-db::t))
                      (let* ((_e274924274955_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _db274920274931_ '1)))
                             (_e274925274958_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _db274920274931_ '2)))
                             (_dbi274961_ _e274925274958_))
                        (_K274923274944_ _txn*274953_ _dbi274961_))
                      (_E274922274935_)))
                (_E274922274935_)))))))
  (define std/db/lmdb#lmdb-put__0
    (lambda (_txn274966_ _db274967_ _key274968_ _val274969_)
      (let ((_flags274971_ '0))
        (std/db/lmdb#lmdb-put__%
         _txn274966_
         _db274967_
         _key274968_
         _val274969_
         _flags274971_))))
  (define std/db/lmdb#lmdb-put
    (lambda _g312680_
      (let ((_g312679_ (let () (declare (not safe)) (##length _g312680_))))
        (cond ((let () (declare (not safe)) (##fx= _g312679_ 4))
               (apply std/db/lmdb#lmdb-put__0 _g312680_))
              ((let () (declare (not safe)) (##fx= _g312679_ 5))
               (apply std/db/lmdb#lmdb-put__% _g312680_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/lmdb#lmdb-put
                _g312680_))))))
  (define std/db/lmdb#lmdb-del__%
    (lambda (_txn274845_ _db274846_ _key274847_ _val274848_)
      (let ((_keyx274850_ (std/db/lmdb#value-bytes _key274847_))
            (_valx274851_
             (if _val274848_ (std/db/lmdb#value-bytes _val274848_) '#f)))
        (let ((_txn274852274862_ _txn274845_) (_db274853274864_ _db274846_))
          (let* ((_E274855274868_
                  (lambda ()
                    (error '"No clause matching"
                           _txn274852274862_
                           _db274853274864_)))
                 (_K274856274877_
                  (lambda (_txn*274871_ _dbi274872_)
                    (let ((_res274874_
                           (std/db/_lmdb#mdb_del
                            _txn*274871_
                            _dbi274872_
                            _keyx274850_
                            _valx274851_)))
                      (if (let () (declare (not safe)) (##fxzero? _res274874_))
                          '#!void
                          (std/db/lmdb#raise-lmdb-error
                           'mdb_del
                           _res274874_))))))
            (if (let ()
                  (declare (not safe))
                  (##structure-direct-instance-of?
                   _txn274852274862_
                   'std/db/lmdb#lmdb-txn::t))
                (let* ((_e274859274880_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _txn274852274862_ '1)))
                       (_e274860274883_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _txn274852274862_ '2)))
                       (_txn*274886_ _e274860274883_))
                  (if (let ()
                        (declare (not safe))
                        (##structure-direct-instance-of?
                         _db274853274864_
                         'std/db/lmdb#lmdb-db::t))
                      (let* ((_e274857274888_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _db274853274864_ '1)))
                             (_e274858274891_
                              (let ()
                                (declare (not safe))
                                (##vector-ref _db274853274864_ '2)))
                             (_dbi274894_ _e274858274891_))
                        (_K274856274877_ _txn*274886_ _dbi274894_))
                      (_E274855274868_)))
                (_E274855274868_)))))))
  (define std/db/lmdb#lmdb-del__0
    (lambda (_txn274899_ _db274900_ _key274901_)
      (let ((_val274903_ '#f))
        (std/db/lmdb#lmdb-del__%
         _txn274899_
         _db274900_
         _key274901_
         _val274903_))))
  (define std/db/lmdb#lmdb-del
    (lambda _g312682_
      (let ((_g312681_ (let () (declare (not safe)) (##length _g312682_))))
        (cond ((let () (declare (not safe)) (##fx= _g312681_ 3))
               (apply std/db/lmdb#lmdb-del__0 _g312682_))
              ((let () (declare (not safe)) (##fx= _g312681_ 4))
               (apply std/db/lmdb#lmdb-del__% _g312682_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/lmdb#lmdb-del
                _g312682_))))))
  (define std/db/lmdb#lmdb-cursor-open
    (lambda (_txn274785_ _db274786_)
      (let ((_txn274787274798_ _txn274785_) (_db274788274800_ _db274786_))
        (let* ((_E274790274804_
                (lambda ()
                  (error '"No clause matching"
                         _txn274787274798_
                         _db274788274800_)))
               (_K274791274820_
                (lambda (_val*274807_ _txn*274808_ _dbi274809_)
                  (let ((_cursor**274811_
                         (std/db/_lmdb#ffi_make_mdb_cursor_ptr_ptr)))
                    (if _cursor**274811_
                        '#!void
                        (error '"lmdb-cursor-open: memory allocation failure"))
                    (let ((_res274813_
                           (std/db/_lmdb#mdb_cursor_open
                            _txn*274808_
                            _dbi274809_
                            _cursor**274811_)))
                      (if (let () (declare (not safe)) (##fxzero? _res274813_))
                          '#!void
                          (std/db/lmdb#raise-lmdb-error
                           'mdb_cursor_open
                           _res274813_)))
                    (let ((_val1*274816_ (std/db/_lmdb#ffi_make_mdb_val_ptr))
                          (_val2*274817_ (std/db/_lmdb#ffi_make_mdb_val_ptr))
                          (_cursor*274818_
                           (std/db/_lmdb#ffi_mdb_cursor_ptr _cursor**274811_)))
                      (if (and _val1*274816_ _val2*274817_)
                          '#!void
                          (error '"lmdb-cursor-open: memory allocation failure"))
                      (let ()
                        (declare (not safe))
                        (##structure
                         std/db/lmdb#lmdb-cursor::t
                         _txn274785_
                         _db274786_
                         _cursor*274818_
                         _val1*274816_
                         _val2*274817_)))))))
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _txn274787274798_
                 'std/db/lmdb#lmdb-txn::t))
              (let* ((_e274794274823_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _txn274787274798_ '1)))
                     (_e274795274826_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _txn274787274798_ '2)))
                     (_txn*274829_ _e274795274826_)
                     (_e274796274831_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _txn274787274798_ '3)))
                     (_val*274834_ _e274796274831_))
                (if (let ()
                      (declare (not safe))
                      (##structure-direct-instance-of?
                       _db274788274800_
                       'std/db/lmdb#lmdb-db::t))
                    (let* ((_e274792274836_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _db274788274800_ '1)))
                           (_e274793274839_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _db274788274800_ '2)))
                           (_dbi274842_ _e274793274839_))
                      (_K274791274820_ _val*274834_ _txn*274829_ _dbi274842_))
                    (_E274790274804_)))
              (_E274790274804_))))))
  (define std/db/lmdb#lmdb-cursor-close
    (lambda (_cursor274753_)
      (let* ((_cursor274754274762_ _cursor274753_)
             (_E274756274766_
              (lambda () (error '"No clause matching" _cursor274754274762_)))
             (_K274757274771_
              (lambda (_cursor*274769_)
                (if _cursor*274769_
                    (begin
                      (std/db/_lmdb#mdb_cursor_close _cursor*274769_)
                      (##direct-structure-set!
                       _cursor274753_
                       '#f
                       '3
                       std/db/lmdb#lmdb-cursor::t
                       '#f)
                      (##direct-structure-set!
                       _cursor274753_
                       '#f
                       '4
                       std/db/lmdb#lmdb-cursor::t
                       '#f)
                      (##direct-structure-set!
                       _cursor274753_
                       '#f
                       '5
                       std/db/lmdb#lmdb-cursor::t
                       '#f))
                    '#!void))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _cursor274754274762_
               'std/db/lmdb#lmdb-cursor::t))
            (let* ((_e274758274774_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cursor274754274762_ '1)))
                   (_e274759274777_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cursor274754274762_ '2)))
                   (_e274760274780_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cursor274754274762_ '3)))
                   (_cursor*274783_ _e274760274780_))
              (_K274757274771_ _cursor*274783_))
            (_E274756274766_)))))
  (define std/db/lmdb#lmdb-cursor-renew
    (lambda (_cursor274703_ _txn274704_)
      (let ((_cursor274705274716_ _cursor274703_)
            (_txn274706274718_ _txn274704_))
        (let* ((_E274708274722_
                (lambda ()
                  (error '"No clause matching"
                         _cursor274705274716_
                         _txn274706274718_)))
               (_K274709274731_
                (lambda (_cursor*274725_ _txn*274726_)
                  (if _cursor*274725_
                      '#!void
                      (error '"lmdb-cursor-renew: invalid cursor"))
                  (let ((_res274728_
                         (std/db/_lmdb#mdb_cursor_renew
                          _txn*274726_
                          _cursor*274725_)))
                    (if (let () (declare (not safe)) (##fxzero? _res274728_))
                        '#!void
                        (std/db/lmdb#raise-lmdb-error
                         'mdb_cursor_renew
                         _res274728_)))
                  (##direct-structure-set!
                   _cursor274703_
                   _txn274704_
                   '1
                   std/db/lmdb#lmdb-cursor::t
                   '#f))))
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _cursor274705274716_
                 'std/db/lmdb#lmdb-cursor::t))
              (let* ((_e274712274734_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274705274716_ '1)))
                     (_e274713274737_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274705274716_ '2)))
                     (_e274714274740_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274705274716_ '3)))
                     (_cursor*274743_ _e274714274740_))
                (if (let ()
                      (declare (not safe))
                      (##structure-direct-instance-of?
                       _txn274706274718_
                       'std/db/lmdb#lmdb-txn::t))
                    (let* ((_e274710274745_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _txn274706274718_ '1)))
                           (_e274711274748_
                            (let ()
                              (declare (not safe))
                              (##vector-ref _txn274706274718_ '2)))
                           (_txn*274751_ _e274711274748_))
                      (_K274709274731_ _cursor*274743_ _txn*274751_))
                    (_E274708274722_)))
              (_E274708274722_))))))
  (define std/db/lmdb#lmdb-cursor-get__%
    (lambda (_cursor274628_ _op274629_ _key274630_ _val274631_)
      (let ((_keyx274633_
             (if _key274630_ (std/db/lmdb#value-bytes _key274630_) '#f))
            (_valx274634_
             (if _val274631_ (std/db/lmdb#value-bytes _val274631_) '#f)))
        (let* ((_cursor274635274645_ _cursor274628_)
               (_E274637274649_
                (lambda () (error '"No clause matching" _cursor274635274645_)))
               (_K274638274658_
                (lambda (_val2*274652_ _val1*274653_ _cursor*274654_)
                  (if _cursor*274654_
                      '#!void
                      (error '"lmdb-cursor-get: invalid cursor"))
                  (let ((_res274656_
                         (std/db/_lmdb#mdb_cursor_get
                          _cursor*274654_
                          _keyx274633_
                          _val1*274653_
                          _valx274634_
                          _val2*274652_
                          _op274629_)))
                    (if (let () (declare (not safe)) (##fxzero? _res274656_))
                        (values (std/db/lmdb#value-data* _val1*274653_)
                                (std/db/lmdb#value-data* _val2*274652_))
                        (if (eq? _res274656_ std/db/_lmdb#MDB_NOTFOUND)
                            '#f
                            (std/db/lmdb#raise-lmdb-error
                             'mdb_cursor_get
                             _res274656_)))))))
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _cursor274635274645_
                 'std/db/lmdb#lmdb-cursor::t))
              (let* ((_e274639274661_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274635274645_ '1)))
                     (_e274640274664_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274635274645_ '2)))
                     (_e274641274667_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274635274645_ '3)))
                     (_cursor*274670_ _e274641274667_)
                     (_e274642274672_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274635274645_ '4)))
                     (_val1*274675_ _e274642274672_)
                     (_e274643274677_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274635274645_ '5)))
                     (_val2*274680_ _e274643274677_))
                (_K274638274658_ _val2*274680_ _val1*274675_ _cursor*274670_))
              (_E274637274649_))))))
  (define std/db/lmdb#lmdb-cursor-get__0
    (lambda (_cursor274685_ _op274686_)
      (let* ((_key274688_ '#f) (_val274690_ '#f))
        (std/db/lmdb#lmdb-cursor-get__%
         _cursor274685_
         _op274686_
         _key274688_
         _val274690_))))
  (define std/db/lmdb#lmdb-cursor-get__1
    (lambda (_cursor274692_ _op274693_ _key274694_)
      (let ((_val274696_ '#f))
        (std/db/lmdb#lmdb-cursor-get__%
         _cursor274692_
         _op274693_
         _key274694_
         _val274696_))))
  (define std/db/lmdb#lmdb-cursor-get
    (lambda _g312684_
      (let ((_g312683_ (let () (declare (not safe)) (##length _g312684_))))
        (cond ((let () (declare (not safe)) (##fx= _g312683_ 2))
               (apply std/db/lmdb#lmdb-cursor-get__0 _g312684_))
              ((let () (declare (not safe)) (##fx= _g312683_ 3))
               (apply std/db/lmdb#lmdb-cursor-get__1 _g312684_))
              ((let () (declare (not safe)) (##fx= _g312683_ 4))
               (apply std/db/lmdb#lmdb-cursor-get__% _g312684_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/lmdb#lmdb-cursor-get
                _g312684_))))))
  (define std/db/lmdb#lmdb-cursor-put__%
    (lambda (_cursor274572_ _key274573_ _val274574_ _flags274575_)
      (let ((_keyx274577_ (std/db/lmdb#value-bytes _key274573_))
            (_valx274578_ (std/db/lmdb#value-bytes _val274574_)))
        (let* ((_cursor274579274587_ _cursor274572_)
               (_E274581274591_
                (lambda () (error '"No clause matching" _cursor274579274587_)))
               (_K274582274599_
                (lambda (_cursor*274594_)
                  (if _cursor*274594_
                      '#!void
                      (error '"lmdb-cursor-put: invalid cursor"))
                  (let ((_res274596_
                         (std/db/_lmdb#mdb_cursor_put
                          _cursor*274594_
                          _keyx274577_
                          _valx274578_
                          _flags274575_)))
                    (if (let () (declare (not safe)) (##fxzero? _res274596_))
                        '#!void
                        (std/db/lmdb#raise-lmdb-error
                         'mdb_cursor_put
                         _res274596_))))))
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _cursor274579274587_
                 'std/db/lmdb#lmdb-cursor::t))
              (let* ((_e274583274602_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274579274587_ '1)))
                     (_e274584274605_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274579274587_ '2)))
                     (_e274585274608_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _cursor274579274587_ '3)))
                     (_cursor*274611_ _e274585274608_))
                (_K274582274599_ _cursor*274611_))
              (_E274581274591_))))))
  (define std/db/lmdb#lmdb-cursor-put__0
    (lambda (_cursor274616_ _key274617_ _val274618_)
      (let ((_flags274620_ '0))
        (std/db/lmdb#lmdb-cursor-put__%
         _cursor274616_
         _key274617_
         _val274618_
         _flags274620_))))
  (define std/db/lmdb#lmdb-cursor-put
    (lambda _g312686_
      (let ((_g312685_ (let () (declare (not safe)) (##length _g312686_))))
        (cond ((let () (declare (not safe)) (##fx= _g312685_ 3))
               (apply std/db/lmdb#lmdb-cursor-put__0 _g312686_))
              ((let () (declare (not safe)) (##fx= _g312685_ 4))
               (apply std/db/lmdb#lmdb-cursor-put__% _g312686_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/lmdb#lmdb-cursor-put
                _g312686_))))))
  (define std/db/lmdb#lmdb-cursor-del__%
    (lambda (_cursor274525_ _flags274526_)
      (let* ((_cursor274527274535_ _cursor274525_)
             (_E274529274539_
              (lambda () (error '"No clause matching" _cursor274527274535_)))
             (_K274530274547_
              (lambda (_cursor*274542_)
                (if _cursor*274542_
                    '#!void
                    (error '"lmdb-cursor-del: invalid cursor"))
                (let ((_res274544_
                       (std/db/_lmdb#mdb_cursor_del
                        _cursor*274542_
                        _flags274526_)))
                  (if (let () (declare (not safe)) (##fxzero? _res274544_))
                      '#!void
                      (std/db/lmdb#raise-lmdb-error
                       'mdb_cursor_del
                       _res274544_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _cursor274527274535_
               'std/db/lmdb#lmdb-cursor::t))
            (let* ((_e274531274550_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cursor274527274535_ '1)))
                   (_e274532274553_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cursor274527274535_ '2)))
                   (_e274533274556_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cursor274527274535_ '3)))
                   (_cursor*274559_ _e274533274556_))
              (_K274530274547_ _cursor*274559_))
            (_E274529274539_)))))
  (define std/db/lmdb#lmdb-cursor-del__0
    (lambda (_cursor274564_)
      (let ((_flags274566_ '0))
        (std/db/lmdb#lmdb-cursor-del__% _cursor274564_ _flags274566_))))
  (define std/db/lmdb#lmdb-cursor-del
    (lambda _g312688_
      (let ((_g312687_ (let () (declare (not safe)) (##length _g312688_))))
        (cond ((let () (declare (not safe)) (##fx= _g312687_ 1))
               (apply std/db/lmdb#lmdb-cursor-del__0 _g312688_))
              ((let () (declare (not safe)) (##fx= _g312687_ 2))
               (apply std/db/lmdb#lmdb-cursor-del__% _g312688_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/db/lmdb#lmdb-cursor-del
                _g312688_))))))
  (define std/db/lmdb#lmdb-cursor-count
    (lambda (_cursor274490_)
      (let* ((_cursor274491274499_ _cursor274490_)
             (_E274493274503_
              (lambda () (error '"No clause matching" _cursor274491274499_)))
             (_K274494274510_
              (lambda (_cursor*274506_)
                (if _cursor*274506_
                    '#!void
                    (error '"lmdb-cursor-count: invalid cursor"))
                (let ((_size_t*274508_ (std/db/_lmdb#ffi_make_size_t_ptr)))
                  (if _size_t*274508_
                      '#!void
                      (error '"lmdb-cursor-open: memory allocation failure"))
                  (std/db/_lmdb#ffi_size_t_ptr_value _size_t*274508_)))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _cursor274491274499_
               'std/db/lmdb#lmdb-cursor::t))
            (let* ((_e274495274513_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cursor274491274499_ '1)))
                   (_e274496274516_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cursor274491274499_ '2)))
                   (_e274497274519_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cursor274491274499_ '3)))
                   (_cursor*274522_ _e274497274519_))
              (_K274494274510_ _cursor*274522_))
            (_E274493274503_))))))
