(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/generic/dispatch#type-of
    (lambda (_obj5362_)
      (declare (not interrupts-enabled))
      (let ((_t5365_ (##type _obj5362_)))
        (if (##fx= _t5365_ (macro-type-mem1))
            (let ((_st5367_ (##subtype _obj5362_)))
              (if (##fx= _st5367_ (macro-subtype-structure))
                  (##type-id (##structure-type _obj5362_))
                  (if (##fx= _st5367_ (macro-subtype-boxvalues))
                      (if (##fx= (##vector-length _obj5362_) '1) 'box 'values)
                      (##vector-ref
                       std/generic/dispatch#+subtype-id+
                       _st5367_))))
            (if (##fx= _t5365_ (macro-type-mem2))
                'pair
                (if (##fx= _t5365_ (macro-type-fixnum))
                    'fixnum
                    (if (##char? _obj5362_)
                        'char
                        (if (##eq? _obj5362_ '())
                            'null
                            (if (##eq? _obj5362_ '#f)
                                'boolean
                                (if (##eq? _obj5362_ '#t)
                                    'boolean
                                    (if (##eq? _obj5362_ '#!void)
                                        'void
                                        (if (##eq? _obj5362_ '#!eof)
                                            'eof
                                            'unknown))))))))))))
  (define std/generic/dispatch#linear-type-of
    (lambda (_obj5354_)
      (let ((_t5356_ (##type _obj5354_)))
        (if (##fx= _t5356_ (macro-type-mem1))
            (let ((_st5358_ (##subtype _obj5354_)))
              (if (##fx= _st5358_ (macro-subtype-structure))
                  (let ((_klass5360_ (##structure-type _obj5354_)))
                    (std/generic/dispatch#type-linearize-class _klass5360_))
                  (if (##fx= _st5358_ (macro-subtype-boxvalues))
                      (if (##fx= (##vector-length _obj5354_) '1)
                          '(box t)
                          '(values t))
                      (##vector-ref
                       std/generic/dispatch#+subtype-linear+
                       _st5358_))))
            (if (##fx= _t5356_ (macro-type-mem2))
                '(pair t)
                (if (##fx= _t5356_ (macro-type-fixnum))
                    '(fixnum integer real number t)
                    (if (##char? _obj5354_)
                        '(char t)
                        (if (##eq? _obj5354_ '())
                            '(null t)
                            (if (##eq? _obj5354_ '#f)
                                '(boolean t)
                                (if (##eq? _obj5354_ '#t)
                                    '(boolean t)
                                    (if (##eq? _obj5354_ '#!void)
                                        '(void t)
                                        (if (##eq? _obj5354_ '#!eof)
                                            '(eof t)
                                            '(unknown)))))))))))))
  (define std/generic/dispatch#type-linearize-class
    (lambda (_klass5352_)
      (if (type-descriptor? _klass5352_)
          (if (type-descriptor-mixin _klass5352_)
              (std/generic/dispatch#type-linearize-class-type _klass5352_)
              (std/generic/dispatch#type-linearize-struct-type _klass5352_))
          (std/generic/dispatch#type-linearize-record-type__0 _klass5352_))))
  (define std/generic/dispatch#type-linearize-class-type
    (lambda (_klass5312_)
      (let _lp5314_ ((_rest5316_ (type-descriptor-mixin _klass5312_))
                     (_r5317_ (cons (##type-id _klass5312_) '())))
        (let* ((_rest53185326_ _rest5316_)
               (_else53205334_ (lambda () (foldl1 cons '(object t) _r5317_)))
               (_K53225340_
                (lambda (_rest5337_ _klass5338_)
                  (_lp5314_
                   _rest5337_
                   (cons (##type-id _klass5338_) _r5317_)))))
          (if (##pair? _rest53185326_)
              (let ((_hd53235343_ (##car _rest53185326_))
                    (_tl53245345_ (##cdr _rest53185326_)))
                (let* ((_klass5348_ _hd53235343_) (_rest5350_ _tl53245345_))
                  (_K53225340_ _rest5350_ _klass5348_)))
              (_else53205334_))))))
  (define std/generic/dispatch#type-linearize-struct-type
    (lambda (_klass5310_)
      (std/generic/dispatch#type-linearize-record-type__%
       _klass5310_
       '(object t))))
  (define std/generic/dispatch#type-linearize-record-type__%
    (lambda (_klass5292_ _base5293_)
      (let _lp5295_ ((_klass5297_ _klass5292_) (_r5298_ '()))
        (if (##type? _klass5297_)
            (_lp5295_
             (##type-super _klass5297_)
             (cons (##type-id _klass5297_) _r5298_))
            (foldl1 cons _base5293_ _r5298_)))))
  (define std/generic/dispatch#type-linearize-record-type__0
    (lambda (_klass5303_)
      (let ((_base5305_ '(t)))
        (std/generic/dispatch#type-linearize-record-type__%
         _klass5303_
         _base5305_))))
  (define std/generic/dispatch#type-linearize-record-type
    (lambda _g283091_
      (let ((_g283090_ (##length _g283091_)))
        (cond ((##fx= _g283090_ 1)
               (apply std/generic/dispatch#type-linearize-record-type__0
                      _g283091_))
              ((##fx= _g283090_ 2)
               (apply std/generic/dispatch#type-linearize-record-type__%
                      _g283091_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/generic/dispatch#type-linearize-record-type
                _g283091_))))))
  (define std/generic/dispatch#+subtype-id+ (make-vector '32 'unknown))
  (define std/generic/dispatch#+subtype-linear+ (make-vector '32 '(unknown)))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-vector)
   'vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-vector)
   '(vector t))
  (vector-set! std/generic/dispatch#+subtype-id+ (macro-subtype-pair) 'pair)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-pair)
   '(pair t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-ratnum)
   'ratnum)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-ratnum)
   '(ratnum real number t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-cpxnum)
   'cpxnum)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-cpxnum)
   '(cpxnum number t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-symbol)
   'symbol)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-symbol)
   '(symbol t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-keyword)
   'keyword)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-keyword)
   '(keyword t))
  (vector-set! std/generic/dispatch#+subtype-id+ (macro-subtype-frame) 'frame)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-frame)
   '(frame t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-continuation)
   'continuation)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-continuation)
   '(continuation t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-promise)
   'promise)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-promise)
   '(promise t))
  (vector-set! std/generic/dispatch#+subtype-id+ (macro-subtype-weak) 'weak)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-weak)
   '(weak t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-procedure)
   'procedure)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-procedure)
   '(procedure t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-foreign)
   'foreign)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-foreign)
   '(foreign t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-string)
   'string)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-string)
   '(string t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-s8vector)
   's8vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-s8vector)
   '(s8vector t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-u8vector)
   'u8vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-u8vector)
   '(u8vector t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-s16vector)
   's16vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-s16vector)
   '(s16vector t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-u16vector)
   'u16vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-u16vector)
   '(u16vector t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-s32vector)
   's32vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-s32vector)
   '(s32vector t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-u32vector)
   'u32vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-u32vector)
   '(u32vector t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-f32vector)
   'f32vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-f32vector)
   '(f32vector t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-s64vector)
   's64vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-s64vector)
   '(s64vector t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-u64vector)
   'u64vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-u64vector)
   '(u64vector t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-f64vector)
   'f64vector)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-f64vector)
   '(f64vector t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-flonum)
   'flonum)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-flonum)
   '(flonum real number t))
  (vector-set!
   std/generic/dispatch#+subtype-id+
   (macro-subtype-bignum)
   'bignum)
  (vector-set!
   std/generic/dispatch#+subtype-linear+
   (macro-subtype-bignum)
   '(bignum integer real number t))
  (define std/generic/dispatch#generic::t
    (make-struct-type
     'std/generic/dispatch#generic::t
     '#f
     '4
     'generic
     '((final: . #t))
     ':init!
     '(id tabs default mx)))
  (define std/generic/dispatch#generic?
    (make-struct-predicate std/generic/dispatch#generic::t))
  (define std/generic/dispatch#make-generic
    (lambda _$args5288_
      (apply make-struct-instance
             std/generic/dispatch#generic::t
             _$args5288_)))
  (define std/generic/dispatch#generic-id
    (make-struct-field-accessor std/generic/dispatch#generic::t '0))
  (define std/generic/dispatch#generic-tabs
    (make-struct-field-accessor std/generic/dispatch#generic::t '1))
  (define std/generic/dispatch#generic-default
    (make-struct-field-accessor std/generic/dispatch#generic::t '2))
  (define std/generic/dispatch#generic-mx
    (make-struct-field-accessor std/generic/dispatch#generic::t '3))
  (define std/generic/dispatch#generic-id-set!
    (make-struct-field-mutator std/generic/dispatch#generic::t '0))
  (define std/generic/dispatch#generic-tabs-set!
    (make-struct-field-mutator std/generic/dispatch#generic::t '1))
  (define std/generic/dispatch#generic-default-set!
    (make-struct-field-mutator std/generic/dispatch#generic::t '2))
  (define std/generic/dispatch#generic-mx-set!
    (make-struct-field-mutator std/generic/dispatch#generic::t '3))
  (define std/generic/dispatch#&generic-id
    (make-struct-field-unchecked-accessor std/generic/dispatch#generic::t '0))
  (define std/generic/dispatch#&generic-tabs
    (make-struct-field-unchecked-accessor std/generic/dispatch#generic::t '1))
  (define std/generic/dispatch#&generic-default
    (make-struct-field-unchecked-accessor std/generic/dispatch#generic::t '2))
  (define std/generic/dispatch#&generic-mx
    (make-struct-field-unchecked-accessor std/generic/dispatch#generic::t '3))
  (define std/generic/dispatch#&generic-id-set!
    (make-struct-field-unchecked-mutator std/generic/dispatch#generic::t '0))
  (define std/generic/dispatch#&generic-tabs-set!
    (make-struct-field-unchecked-mutator std/generic/dispatch#generic::t '1))
  (define std/generic/dispatch#&generic-default-set!
    (make-struct-field-unchecked-mutator std/generic/dispatch#generic::t '2))
  (define std/generic/dispatch#&generic-mx-set!
    (make-struct-field-unchecked-mutator std/generic/dispatch#generic::t '3))
  (define std/generic/dispatch#generic:::init!__%
    (lambda (_self5269_ _id5270_ _default5271_)
      (if (or (not _default5271_) (procedure? _default5271_))
          '#!void
          (error '"Bad default method; expected procedure or #f"
                 _id5270_
                 _default5271_))
      (if (##fx< '4 (##vector-length _self5269_))
          (begin
            (##vector-set! _self5269_ '1 _id5270_)
            (##vector-set! _self5269_ '2 (vector))
            (##vector-set! _self5269_ '3 _default5271_)
            (##vector-set! _self5269_ '4 (make-mutex 'generic)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self5269_))))
  (define std/generic/dispatch#generic:::init!__0
    (lambda (_self5279_ _id5280_)
      (let ((_default5282_ '#f))
        (std/generic/dispatch#generic:::init!__%
         _self5279_
         _id5280_
         _default5282_))))
  (define std/generic/dispatch#generic:::init!
    (lambda _g283093_
      (let ((_g283092_ (##length _g283093_)))
        (cond ((##fx= _g283092_ 2)
               (apply std/generic/dispatch#generic:::init!__0 _g283093_))
              ((##fx= _g283092_ 3)
               (apply std/generic/dispatch#generic:::init!__% _g283093_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/generic/dispatch#generic:::init!
                _g283093_))))))
  (bind-method!
   std/generic/dispatch#generic::t
   ':init!
   std/generic/dispatch#generic:::init!
   '#f)
  (define std/generic/dispatch#generic-table::t
    (make-struct-type
     'std/generic/dispatch#generic-table::t
     '#f
     '3
     'generic-table
     '((final: . #t))
     ':init!
     '(methods cache mx)))
  (define std/generic/dispatch#generic-table?
    (make-struct-predicate std/generic/dispatch#generic-table::t))
  (define std/generic/dispatch#make-generic-table
    (lambda _$args5143_
      (apply make-struct-instance
             std/generic/dispatch#generic-table::t
             _$args5143_)))
  (define std/generic/dispatch#generic-table-methods
    (make-struct-field-accessor std/generic/dispatch#generic-table::t '0))
  (define std/generic/dispatch#generic-table-cache
    (make-struct-field-accessor std/generic/dispatch#generic-table::t '1))
  (define std/generic/dispatch#generic-table-mx
    (make-struct-field-accessor std/generic/dispatch#generic-table::t '2))
  (define std/generic/dispatch#generic-table-methods-set!
    (make-struct-field-mutator std/generic/dispatch#generic-table::t '0))
  (define std/generic/dispatch#generic-table-cache-set!
    (make-struct-field-mutator std/generic/dispatch#generic-table::t '1))
  (define std/generic/dispatch#generic-table-mx-set!
    (make-struct-field-mutator std/generic/dispatch#generic-table::t '2))
  (define std/generic/dispatch#&generic-table-methods
    (make-struct-field-unchecked-accessor
     std/generic/dispatch#generic-table::t
     '0))
  (define std/generic/dispatch#&generic-table-cache
    (make-struct-field-unchecked-accessor
     std/generic/dispatch#generic-table::t
     '1))
  (define std/generic/dispatch#&generic-table-mx
    (make-struct-field-unchecked-accessor
     std/generic/dispatch#generic-table::t
     '2))
  (define std/generic/dispatch#&generic-table-methods-set!
    (make-struct-field-unchecked-mutator
     std/generic/dispatch#generic-table::t
     '0))
  (define std/generic/dispatch#&generic-table-cache-set!
    (make-struct-field-unchecked-mutator
     std/generic/dispatch#generic-table::t
     '1))
  (define std/generic/dispatch#&generic-table-mx-set!
    (make-struct-field-unchecked-mutator
     std/generic/dispatch#generic-table::t
     '2))
  (define std/generic/dispatch#generic-table:::init!
    (lambda (_self5141_)
      (if (##fx< '3 (##vector-length _self5141_))
          (begin
            (##vector-set! _self5141_ '1 '())
            (##vector-set! _self5141_ '2 (make-vector '10 '#f))
            (##vector-set! _self5141_ '3 (make-mutex 'generic-table)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self5141_))))
  (bind-method!
   std/generic/dispatch#generic-table::t
   ':init!
   std/generic/dispatch#generic-table:::init!
   '#f)
  (define std/generic/dispatch#generic-bind!
    (lambda (_gen5000_ _signature5001_ _method5002_)
      (if (procedure? _method5002_)
          '#!void
          (error '"Bad method; expected procedure" _method5002_))
      (let ((_arity5004_ (length _signature5001_))
            (_mx5005_
             (##unchecked-structure-ref
              _gen5000_
              '4
              std/generic/dispatch#generic::t
              '#f)))
        (mutex-lock! _mx5005_)
        (let ((_tabs5007_
               (##unchecked-structure-ref
                _gen5000_
                '2
                std/generic/dispatch#generic::t
                '#f)))
          (if (##fx< _arity5004_ (##vector-length _tabs5007_))
              (let ((_$e5009_ (##vector-ref _tabs5007_ _arity5004_)))
                (if _$e5009_
                    ((lambda (_gtab5012_)
                       (std/generic/dispatch#generic-bind-method!
                        _gtab5012_
                        _signature5001_
                        _method5002_))
                     _$e5009_)
                    (let ((_gtab5014_
                           (let ((__obj283088
                                  (make-object
                                   std/generic/dispatch#generic-table::t
                                   '3)))
                             (std/generic/dispatch#generic-table:::init!
                              __obj283088)
                             __obj283088)))
                      (##vector-set! _tabs5007_ _arity5004_ _gtab5014_)
                      (std/generic/dispatch#generic-bind-method!
                       _gtab5014_
                       _signature5001_
                       _method5002_))))
              (let ((_new-tabs5016_ (make-vector (##fx+ _arity5004_ '1) '#f))
                    (_gtab5017_
                     (let ((__obj283089
                            (make-object
                             std/generic/dispatch#generic-table::t
                             '3)))
                       (std/generic/dispatch#generic-table:::init! __obj283089)
                       __obj283089)))
                (##subvector-move!
                 _tabs5007_
                 '0
                 (##vector-length _tabs5007_)
                 _new-tabs5016_
                 '0)
                (##vector-set! _new-tabs5016_ _arity5004_ _gtab5017_)
                (##unchecked-structure-set!
                 _gen5000_
                 _new-tabs5016_
                 '2
                 std/generic/dispatch#generic::t
                 '#f)
                (std/generic/dispatch#generic-bind-method!
                 _gtab5017_
                 _signature5001_
                 _method5002_))))
        (mutex-unlock! _mx5005_))))
  (define std/generic/dispatch#generic-bind-method!
    (lambda (_gtab4973_ _signature4974_ _method4975_)
      (letrec ((_invalidate?4977_
                (lambda (_cache4989_)
                  (let ((_cache-len4991_ (##vector-length _cache4989_)))
                    (let _lp4993_ ((_i4995_ '0))
                      (if (##fx< _i4995_ _cache-len4991_)
                          (let ((_$e4997_ (##vector-ref _cache4989_ _i4995_)))
                            (if _$e4997_
                                _$e4997_
                                (_lp4993_ (##fx+ _i4995_ '1))))
                          '#f))))))
        (let _again4979_ ()
          (let* ((_old-methods4982_
                  (##unchecked-structure-ref
                   _gtab4973_
                   '1
                   std/generic/dispatch#generic-table::t
                   '#f))
                 (_new-methods4984_
                  (std/generic/dispatch#generic-add-method
                   _old-methods4982_
                   _signature4974_
                   _method4975_)))
            (let ((_mx4987_
                   (##unchecked-structure-ref
                    _gtab4973_
                    '3
                    std/generic/dispatch#generic-table::t
                    '#f)))
              (mutex-lock! _mx4987_)
              (if (eq? _old-methods4982_
                       (##unchecked-structure-ref
                        _gtab4973_
                        '1
                        std/generic/dispatch#generic-table::t
                        '#f))
                  (begin
                    (##unchecked-structure-set!
                     _gtab4973_
                     _new-methods4984_
                     '1
                     std/generic/dispatch#generic-table::t
                     '#f)
                    (if (_invalidate?4977_
                         (##unchecked-structure-ref
                          _gtab4973_
                          '2
                          std/generic/dispatch#generic-table::t
                          '#f))
                        (##unchecked-structure-set!
                         _gtab4973_
                         (make-vector
                          (##vector-length
                           (##unchecked-structure-ref
                            _gtab4973_
                            '2
                            std/generic/dispatch#generic-table::t
                            '#f))
                          '#f)
                         '2
                         std/generic/dispatch#generic-table::t
                         '#f)
                        '#!void)
                    (mutex-unlock! _mx4987_))
                  (begin (mutex-unlock! _mx4987_) (_again4979_)))))))))
  (define std/generic/dispatch#generic-add-method
    (lambda (_methods4904_ _signature4905_ _method4906_)
      (let _recur4908_ ((_rest4910_ _methods4904_))
        (let* ((_rest49114919_ _rest4910_)
               (_else49134927_
                (lambda () (cons (cons _signature4905_ _method4906_) '())))
               (_K49154961_
                (lambda (_rest4930_ _hd4931_)
                  (let* ((_hd49324939_ _hd4931_)
                         (_E49344943_
                          (lambda ()
                            (error '"No clause matching" _hd49324939_)))
                         (_K49354949_
                          (lambda (_hd-method4946_ _hd-signature4947_)
                            (if (std/generic/dispatch#generic-dispatch-before?
                                 _signature4905_
                                 _hd-signature4947_)
                                (cons (cons _signature4905_ _method4906_)
                                      (cons _hd4931_ _rest4930_))
                                (if (equal? _signature4905_ _hd-signature4947_)
                                    (cons (cons _signature4905_ _method4906_)
                                          _rest4930_)
                                    (cons _hd4931_
                                          (_recur4908_ _rest4930_)))))))
                    (if (##pair? _hd49324939_)
                        (let ((_hd49364952_ (##car _hd49324939_))
                              (_tl49374954_ (##cdr _hd49324939_)))
                          (let* ((_hd-signature4957_ _hd49364952_)
                                 (_hd-method4959_ _tl49374954_))
                            (_K49354949_ _hd-method4959_ _hd-signature4957_)))
                        (_E49344943_))))))
          (if (##pair? _rest49114919_)
              (let ((_hd49164964_ (##car _rest49114919_))
                    (_tl49174966_ (##cdr _rest49114919_)))
                (let* ((_hd4969_ _hd49164964_) (_rest4971_ _tl49174966_))
                  (_K49154961_ _rest4971_ _hd4969_)))
              (_else49134927_))))))
  (define std/generic/dispatch#generic-dispatch-before?
    (lambda (_sig-a4832_ _sig-b4833_)
      (let _lp4835_ ((_rest-a4837_ _sig-a4832_) (_rest-b4838_ _sig-b4833_))
        (let* ((_rest-a48394847_ _rest-a4837_)
               (_else48414855_ (lambda () '#f))
               (_K48434892_
                (lambda (_rest-a4858_ _type-a4859_)
                  (let* ((_rest-b48604867_ _rest-b4838_)
                         (_E48624871_
                          (lambda ()
                            (error '"No clause matching" _rest-b48604867_)))
                         (_K48634880_
                          (lambda (_rest-b4874_ _type-b4875_)
                            (if (not (std/generic/dispatch#generic-dispatch-type<?
                                      _type-b4875_
                                      _type-a4859_))
                                (let ((_$e4877_
                                       (std/generic/dispatch#generic-dispatch-type<?
                                        _type-a4859_
                                        _type-b4875_)))
                                  (if _$e4877_
                                      _$e4877_
                                      (_lp4835_ _rest-a4858_ _rest-b4874_)))
                                '#f))))
                    (if (##pair? _rest-b48604867_)
                        (let ((_hd48644883_ (##car _rest-b48604867_))
                              (_tl48654885_ (##cdr _rest-b48604867_)))
                          (let* ((_type-b4888_ _hd48644883_)
                                 (_rest-b4890_ _tl48654885_))
                            (_K48634880_ _rest-b4890_ _type-b4888_)))
                        (_E48624871_))))))
          (if (##pair? _rest-a48394847_)
              (let ((_hd48444895_ (##car _rest-a48394847_))
                    (_tl48454897_ (##cdr _rest-a48394847_)))
                (let* ((_type-a4900_ _hd48444895_) (_rest-a4902_ _tl48454897_))
                  (_K48434892_ _rest-a4902_ _type-a4900_)))
              (_else48414855_))))))
  (define std/generic/dispatch#generic-dispatch-type<?
    (lambda (_type-a4829_ _type-b4830_)
      (memq (car _type-b4830_) _type-a4829_)))
  (define std/generic/dispatch#generic-dispatch
    (lambda (_gen4808_ . _args4809_)
      (let ((_arity4811_ (##length _args4809_))
            (_tabs4812_
             (##unchecked-structure-ref
              _gen4808_
              '2
              std/generic/dispatch#generic::t
              '#f)))
        (let ((_$e4814_
               (if (##fx< _arity4811_ (##vector-length _tabs4812_))
                   (##vector-ref _tabs4812_ _arity4811_)
                   '#f)))
          (if _$e4814_
              ((lambda (_gtab4817_)
                 (let ((_$e4819_
                        (std/generic/dispatch#generic-dispatch-method
                         _gtab4817_
                         _args4809_
                         (##unchecked-structure-ref
                          _gen4808_
                          '3
                          std/generic/dispatch#generic::t
                          '#f))))
                   (if _$e4819_
                       ((lambda (_method4822_) (apply _method4822_ _args4809_))
                        _$e4819_)
                       (error '"No method matching arguments"
                              (##direct-structure-ref
                               _gen4808_
                               '1
                               std/generic/dispatch#generic::t
                               '#f)
                              _args4809_))))
               _$e4814_)
              (let ((_$e4824_
                     (##unchecked-structure-ref
                      _gen4808_
                      '3
                      std/generic/dispatch#generic::t
                      '#f)))
                (if _$e4824_
                    ((lambda (_method4827_) (apply _method4827_ _args4809_))
                     _$e4824_)
                    (error '"No method matching arguments"
                           (##direct-structure-ref
                            _gen4808_
                            '1
                            std/generic/dispatch#generic::t
                            '#f)
                           _args4809_))))))))
  (define std/generic/dispatch#generic-dispatch-method
    (lambda (_gtab4801_ _args4802_ _default4803_)
      (let ((_$e4805_
             (std/generic/dispatch#generic-dispatch-cache-lookup
              (##unchecked-structure-ref
               _gtab4801_
               '2
               std/generic/dispatch#generic-table::t
               '#f)
              _args4802_)))
        (if _$e4805_
            _$e4805_
            (std/generic/dispatch#generic-dispatch-method-ref
             _gtab4801_
             _args4802_
             _default4803_)))))
  (define std/generic/dispatch#generic-dispatch-method-ref
    (lambda (_gtab4787_ _args4788_ _default4789_)
      (let* ((_methods4791_
              (##unchecked-structure-ref
               _gtab4787_
               '1
               std/generic/dispatch#generic-table::t
               '#f))
             (_method4796_
              (let ((_$e4793_
                     (std/generic/dispatch#generic-dispatch-find-method
                      _methods4791_
                      _args4788_)))
                (if _$e4793_ _$e4793_ _default4789_))))
        (if _method4796_
            (let ((_mx4799_
                   (##unchecked-structure-ref
                    _gtab4787_
                    '3
                    std/generic/dispatch#generic-table::t
                    '#f)))
              (mutex-lock! _mx4799_)
              (if (eq? _methods4791_
                       (##unchecked-structure-ref
                        _gtab4787_
                        '1
                        std/generic/dispatch#generic-table::t
                        '#f))
                  (if (std/generic/dispatch#generic-dispatch-cache-lookup
                       (##unchecked-structure-ref
                        _gtab4787_
                        '2
                        std/generic/dispatch#generic-table::t
                        '#f)
                       _args4788_)
                      '#!void
                      (std/generic/dispatch#generic-dispatch-cache!
                       _gtab4787_
                       _args4788_
                       _method4796_))
                  '#!void)
              (mutex-unlock! _mx4799_))
            '#!void)
        _method4796_)))
  (define std/generic/dispatch#generic-dispatch1
    (lambda (_gen4764_ _arg14766_)
      (let* ((_tabs4768_
              (##unchecked-structure-ref
               _gen4764_
               '2
               std/generic/dispatch#generic::t
               '#f))
             (_$e4771_
              (if (##fx< '1 (##vector-length _tabs4768_))
                  (##vector-ref _tabs4768_ '1)
                  '#f)))
        (if _$e4771_
            ((lambda (_gtab4774_)
               (let ((_$e4776_
                      (std/generic/dispatch#generic-dispatch-method1
                       _gtab4774_
                       (##unchecked-structure-ref
                        _gen4764_
                        '3
                        std/generic/dispatch#generic::t
                        '#f)
                       _arg14766_)))
                 (if _$e4776_
                     ((lambda (_method4779_) (_method4779_ _arg14766_))
                      _$e4776_)
                     (error '"No method matching arguments"
                            (##direct-structure-ref
                             _gen4764_
                             '1
                             std/generic/dispatch#generic::t
                             '#f)
                            (cons _arg14766_ '())))))
             _$e4771_)
            (let ((_$e4782_
                   (##unchecked-structure-ref
                    _gen4764_
                    '3
                    std/generic/dispatch#generic::t
                    '#f)))
              (if _$e4782_
                  ((lambda (_method4785_) (_method4785_ _arg14766_)) _$e4782_)
                  (error '"No method matching arguments"
                         (##direct-structure-ref
                          _gen4764_
                          '1
                          std/generic/dispatch#generic::t
                          '#f)
                         (cons _arg14766_ '()))))))))
  (define std/generic/dispatch#generic-dispatch-method1
    (lambda (_gtab4755_ _default4757_ _arg14759_)
      (let ((_$e4761_
             (std/generic/dispatch#generic-dispatch-cache-lookup1
              (##unchecked-structure-ref
               _gtab4755_
               '2
               std/generic/dispatch#generic-table::t
               '#f)
              _arg14759_)))
        (if _$e4761_
            _$e4761_
            (std/generic/dispatch#generic-dispatch-method-ref
             _gtab4755_
             (cons _arg14759_ '())
             _default4757_)))))
  (define std/generic/dispatch#generic-dispatch2
    (lambda (_gen4731_ _arg14733_ _arg24734_)
      (let* ((_tabs4736_
              (##unchecked-structure-ref
               _gen4731_
               '2
               std/generic/dispatch#generic::t
               '#f))
             (_$e4739_
              (if (##fx< '2 (##vector-length _tabs4736_))
                  (##vector-ref _tabs4736_ '2)
                  '#f)))
        (if _$e4739_
            ((lambda (_gtab4742_)
               (let ((_$e4744_
                      (std/generic/dispatch#generic-dispatch-method2
                       _gtab4742_
                       (##unchecked-structure-ref
                        _gen4731_
                        '3
                        std/generic/dispatch#generic::t
                        '#f)
                       _arg14733_
                       _arg24734_)))
                 (if _$e4744_
                     ((lambda (_method4747_)
                        (_method4747_ _arg14733_ _arg24734_))
                      _$e4744_)
                     (error '"No method matching arguments"
                            (##direct-structure-ref
                             _gen4731_
                             '1
                             std/generic/dispatch#generic::t
                             '#f)
                            (cons _arg14733_ (cons _arg24734_ '()))))))
             _$e4739_)
            (let ((_$e4750_
                   (##unchecked-structure-ref
                    _gen4731_
                    '3
                    std/generic/dispatch#generic::t
                    '#f)))
              (if _$e4750_
                  ((lambda (_method4753_) (_method4753_ _arg14733_ _arg24734_))
                   _$e4750_)
                  (error '"No method matching arguments"
                         (##direct-structure-ref
                          _gen4731_
                          '1
                          std/generic/dispatch#generic::t
                          '#f)
                         (cons _arg14733_ (cons _arg24734_ '())))))))))
  (define std/generic/dispatch#generic-dispatch-method2
    (lambda (_gtab4721_ _default4723_ _arg14725_ _arg24726_)
      (let ((_$e4728_
             (std/generic/dispatch#generic-dispatch-cache-lookup2
              (##unchecked-structure-ref
               _gtab4721_
               '2
               std/generic/dispatch#generic-table::t
               '#f)
              _arg14725_
              _arg24726_)))
        (if _$e4728_
            _$e4728_
            (std/generic/dispatch#generic-dispatch-method-ref
             _gtab4721_
             (cons _arg14725_ (cons _arg24726_ '()))
             _default4723_)))))
  (define std/generic/dispatch#generic-dispatch3
    (lambda (_gen4696_ _arg14698_ _arg24699_ _arg34700_)
      (let* ((_tabs4702_
              (##unchecked-structure-ref
               _gen4696_
               '2
               std/generic/dispatch#generic::t
               '#f))
             (_$e4705_
              (if (##fx< '3 (##vector-length _tabs4702_))
                  (##vector-ref _tabs4702_ '3)
                  '#f)))
        (if _$e4705_
            ((lambda (_gtab4708_)
               (let ((_$e4710_
                      (std/generic/dispatch#generic-dispatch-method3
                       _gtab4708_
                       (##unchecked-structure-ref
                        _gen4696_
                        '3
                        std/generic/dispatch#generic::t
                        '#f)
                       _arg14698_
                       _arg24699_
                       _arg34700_)))
                 (if _$e4710_
                     ((lambda (_method4713_)
                        (_method4713_ _arg14698_ _arg24699_ _arg34700_))
                      _$e4710_)
                     (error '"No method matching arguments"
                            (##direct-structure-ref
                             _gen4696_
                             '1
                             std/generic/dispatch#generic::t
                             '#f)
                            (cons _arg14698_
                                  (cons _arg24699_ (cons _arg34700_ '())))))))
             _$e4705_)
            (let ((_$e4716_
                   (##unchecked-structure-ref
                    _gen4696_
                    '3
                    std/generic/dispatch#generic::t
                    '#f)))
              (if _$e4716_
                  ((lambda (_method4719_)
                     (_method4719_ _arg14698_ _arg24699_ _arg34700_))
                   _$e4716_)
                  (error '"No method matching arguments"
                         (##direct-structure-ref
                          _gen4696_
                          '1
                          std/generic/dispatch#generic::t
                          '#f)
                         (cons _arg14698_
                               (cons _arg24699_ (cons _arg34700_ '()))))))))))
  (define std/generic/dispatch#generic-dispatch-method3
    (lambda (_gtab4685_ _default4687_ _arg14689_ _arg24690_ _arg34691_)
      (let ((_$e4693_
             (std/generic/dispatch#generic-dispatch-cache-lookup3
              (##unchecked-structure-ref
               _gtab4685_
               '2
               std/generic/dispatch#generic-table::t
               '#f)
              _arg14689_
              _arg24690_
              _arg34691_)))
        (if _$e4693_
            _$e4693_
            (std/generic/dispatch#generic-dispatch-method-ref
             _gtab4685_
             (cons _arg14689_ (cons _arg24690_ (cons _arg34691_ '())))
             _default4687_)))))
  (define std/generic/dispatch#generic-dispatch4
    (lambda (_gen4659_ _arg14661_ _arg24662_ _arg34663_ _arg44664_)
      (let* ((_tabs4666_
              (##unchecked-structure-ref
               _gen4659_
               '2
               std/generic/dispatch#generic::t
               '#f))
             (_$e4669_
              (if (##fx< '4 (##vector-length _tabs4666_))
                  (##vector-ref _tabs4666_ '4)
                  '#f)))
        (if _$e4669_
            ((lambda (_gtab4672_)
               (let ((_$e4674_
                      (std/generic/dispatch#generic-dispatch-method4
                       _gtab4672_
                       (##unchecked-structure-ref
                        _gen4659_
                        '3
                        std/generic/dispatch#generic::t
                        '#f)
                       _arg14661_
                       _arg24662_
                       _arg34663_
                       _arg44664_)))
                 (if _$e4674_
                     ((lambda (_method4677_)
                        (_method4677_
                         _arg14661_
                         _arg24662_
                         _arg34663_
                         _arg44664_))
                      _$e4674_)
                     (error '"No method matching arguments"
                            (##direct-structure-ref
                             _gen4659_
                             '1
                             std/generic/dispatch#generic::t
                             '#f)
                            (cons _arg14661_
                                  (cons _arg24662_
                                        (cons _arg34663_
                                              (cons _arg44664_ '()))))))))
             _$e4669_)
            (let ((_$e4680_
                   (##unchecked-structure-ref
                    _gen4659_
                    '3
                    std/generic/dispatch#generic::t
                    '#f)))
              (if _$e4680_
                  ((lambda (_method4683_)
                     (_method4683_
                      _arg14661_
                      _arg24662_
                      _arg34663_
                      _arg44664_))
                   _$e4680_)
                  (error '"No method matching arguments"
                         (##direct-structure-ref
                          _gen4659_
                          '1
                          std/generic/dispatch#generic::t
                          '#f)
                         (cons _arg14661_
                               (cons _arg24662_
                                     (cons _arg34663_
                                           (cons _arg44664_ '())))))))))))
  (define std/generic/dispatch#generic-dispatch-method4
    (lambda (_gtab4647_
             _default4649_
             _arg14651_
             _arg24652_
             _arg34653_
             _arg44654_)
      (let ((_$e4656_
             (std/generic/dispatch#generic-dispatch-cache-lookup4
              (##unchecked-structure-ref
               _gtab4647_
               '2
               std/generic/dispatch#generic-table::t
               '#f)
              _arg14651_
              _arg24652_
              _arg34653_
              _arg44654_)))
        (if _$e4656_
            _$e4656_
            (std/generic/dispatch#generic-dispatch-method-ref
             _gtab4647_
             (cons _arg14651_
                   (cons _arg24652_ (cons _arg34653_ (cons _arg44654_ '()))))
             _default4649_)))))
  (define std/generic/dispatch#generic-dispatch-find-method
    (lambda (_methods4577_ _args4578_)
      (let ((_arg-types4580_
             (map std/generic/dispatch#linear-type-of _args4578_)))
        (let _lp4582_ ((_rest4584_ _methods4577_))
          (let* ((_rest45854593_ _rest4584_)
                 (_else45874601_ (lambda () '#f))
                 (_K45894635_
                  (lambda (_rest4604_ _hd4605_)
                    (let* ((_hd46064613_ _hd4605_)
                           (_E46084617_
                            (lambda ()
                              (error '"No clause matching" _hd46064613_)))
                           (_K46094623_
                            (lambda (_method4620_ _signature4621_)
                              (if (std/generic/dispatch#generic-dispatch-match?
                                   _arg-types4580_
                                   _signature4621_)
                                  _method4620_
                                  (_lp4582_ _rest4604_)))))
                      (if (##pair? _hd46064613_)
                          (let ((_hd46104626_ (##car _hd46064613_))
                                (_tl46114628_ (##cdr _hd46064613_)))
                            (let* ((_signature4631_ _hd46104626_)
                                   (_method4633_ _tl46114628_))
                              (_K46094623_ _method4633_ _signature4631_)))
                          (_E46084617_))))))
            (if (##pair? _rest45854593_)
                (let ((_hd45904638_ (##car _rest45854593_))
                      (_tl45914640_ (##cdr _rest45854593_)))
                  (let* ((_hd4643_ _hd45904638_) (_rest4645_ _tl45914640_))
                    (_K45894635_ _rest4645_ _hd4643_)))
                (_else45874601_)))))))
  (define std/generic/dispatch#generic-dispatch-match?
    (lambda (_arg-types4508_ _signature4509_)
      (let _lp4511_ ((_rest-args4513_ _arg-types4508_)
                     (_rest-sign4514_ _signature4509_))
        (let* ((_rest-args45154523_ _rest-args4513_)
               (_else45174531_ (lambda () '#t))
               (_K45194565_
                (lambda (_rest-args4534_ _arg-tids4535_)
                  (let* ((_rest-sign45364543_ _rest-sign4514_)
                         (_E45384547_
                          (lambda ()
                            (error '"No clause matching" _rest-sign45364543_)))
                         (_K45394553_
                          (lambda (_rest-sign4550_ _sign-tids4551_)
                            (if (memq (car _sign-tids4551_) _arg-tids4535_)
                                (_lp4511_ _rest-args4534_ _rest-sign4550_)
                                '#f))))
                    (if (##pair? _rest-sign45364543_)
                        (let ((_hd45404556_ (##car _rest-sign45364543_))
                              (_tl45414558_ (##cdr _rest-sign45364543_)))
                          (let* ((_sign-tids4561_ _hd45404556_)
                                 (_rest-sign4563_ _tl45414558_))
                            (_K45394553_ _rest-sign4563_ _sign-tids4561_)))
                        (_E45384547_))))))
          (if (##pair? _rest-args45154523_)
              (let ((_hd45204568_ (##car _rest-args45154523_))
                    (_tl45214570_ (##cdr _rest-args45154523_)))
                (let* ((_arg-tids4573_ _hd45204568_)
                       (_rest-args4575_ _tl45214570_))
                  (_K45194565_ _rest-args4575_ _arg-tids4573_)))
              (_else45174531_))))))
  (define std/generic/dispatch#generic-dispatch-next
    (lambda (_gen4432_ _method4433_ . _args4434_)
      (letrec ((_drop4436_
                (lambda (_method4458_ _methods4459_)
                  (let _lp4461_ ((_rest4463_ _methods4459_))
                    (let* ((_rest44644474_ _rest4463_)
                           (_else44664482_ (lambda () '()))
                           (_K44684489_
                            (lambda (_rest4485_ _proc4486_ _signature4487_)
                              (if (eq? _method4458_ _proc4486_)
                                  _rest4485_
                                  (_lp4461_ _rest4485_)))))
                      (if (##pair? _rest44644474_)
                          (let ((_hd44694492_ (##car _rest44644474_))
                                (_tl44704494_ (##cdr _rest44644474_)))
                            (if (##pair? _hd44694492_)
                                (let ((_hd44714497_ (##car _hd44694492_))
                                      (_tl44724499_ (##cdr _hd44694492_)))
                                  (let* ((_signature4502_ _hd44714497_)
                                         (_proc4504_ _tl44724499_)
                                         (_rest4506_ _tl44704494_))
                                    (_K44684489_
                                     _rest4506_
                                     _proc4504_
                                     _signature4502_)))
                                (_else44664482_)))
                          (_else44664482_)))))))
        (let ((_arity4438_ (##length _args4434_))
              (_tabs4439_
               (##unchecked-structure-ref
                _gen4432_
                '2
                std/generic/dispatch#generic::t
                '#f)))
          (let ((_$e4441_
                 (if (##fx< _arity4438_ (##vector-length _tabs4439_))
                     (##vector-ref _tabs4439_ _arity4438_)
                     '#f)))
            (if _$e4441_
                ((lambda (_gtab4444_)
                   (let* ((_methods4446_
                           (_drop4436_
                            _method4433_
                            (##unchecked-structure-ref
                             _gtab4444_
                             '1
                             std/generic/dispatch#generic-table::t
                             '#f)))
                          (_$e4448_
                           (std/generic/dispatch#generic-dispatch-find-method
                            _methods4446_
                            _args4434_)))
                     (if _$e4448_
                         ((lambda (_method4451_)
                            (apply _method4451_ _args4434_))
                          _$e4448_)
                         (let ((_$e4453_
                                (##unchecked-structure-ref
                                 _gen4432_
                                 '3
                                 std/generic/dispatch#generic::t
                                 '#f)))
                           (if _$e4453_
                               ((lambda (_method4456_)
                                  (apply _method4456_ _args4434_))
                                _$e4453_)
                               (error '"No next method matching arguments"
                                      (##direct-structure-ref
                                       _gen4432_
                                       '1
                                       std/generic/dispatch#generic::t
                                       '#f)
                                      _args4434_))))))
                 _$e4441_)
                (error '"Cannot dispatch next method; no dispatch table"
                       (##direct-structure-ref
                        _gen4432_
                        '1
                        std/generic/dispatch#generic::t
                        '#f)
                       _args4434_)))))))
  (define std/generic/dispatch#generic-dispatch-cache-lookup
    (lambda (_cache4345_ _args4346_)
      (declare (not interrupts-enabled))
      (letrec ((_lookup4348_
                (lambda (_hash4352_ _shift4353_ _rest4354_)
                  (let* ((_rest43554363_ _rest4354_)
                         (_else43574376_
                          (lambda ()
                            (let* ((_len4371_ (##vector-length _cache4345_))
                                   (_ix4373_
                                    (##fxmodulo _hash4352_ _len4371_)))
                              (##vector-ref _cache4345_ _ix4373_))))
                         (_K43594420_
                          (lambda (_rest4379_ _arg4380_)
                            (let* ((_tid4382_
                                    (std/generic/dispatch#type-of _arg4380_))
                                   (_hash4384_
                                    (##fxxor _hash4352_
                                             (##fxarithmetic-shift
                                              (##symbol-hash _tid4382_)
                                              _shift4353_))))
                              (let* ((_g43864394_
                                      (_lookup4348_
                                       _hash4384_
                                       (##fx+ _shift4353_ '1)
                                       _rest4379_))
                                     (_else43884402_ (lambda () '#f))
                                     (_K43904408_
                                      (lambda (_xrest4405_ _xtid4406_)
                                        (if (##eq? _tid4382_ _xtid4406_)
                                            _xrest4405_
                                            '#f))))
                                (if (##pair? _g43864394_)
                                    (let ((_hd43914411_ (##car _g43864394_))
                                          (_tl43924413_ (##cdr _g43864394_)))
                                      (let* ((_xtid4416_ _hd43914411_)
                                             (_xrest4418_ _tl43924413_))
                                        (_K43904408_ _xrest4418_ _xtid4416_)))
                                    (_else43884402_)))))))
                    (if (##pair? _rest43554363_)
                        (let ((_hd43604423_ (##car _rest43554363_))
                              (_tl43614425_ (##cdr _rest43554363_)))
                          (let* ((_arg4428_ _hd43604423_)
                                 (_rest4430_ _tl43614425_))
                            (_K43594420_ _rest4430_ _arg4428_)))
                        (_else43574376_))))))
        (let ((_proc4350_ (_lookup4348_ '0 '0 _args4346_)))
          (if (##procedure? _proc4350_) _proc4350_ '#f)))))
  (define std/generic/dispatch#cache-hash1
    (lambda (_cache4293_ _mix4294_ _shift4295_ _arg4296_)
      (declare (not interrupts-enabled))
      (let* ((_tid4299_ (std/generic/dispatch#type-of _arg4296_))
             (_hash4301_
              (##fxxor _mix4294_
                       (##fxarithmetic-shift
                        (##symbol-hash _tid4299_)
                        _shift4295_)))
             (_len4303_ (##vector-length _cache4293_))
             (_ix4305_ (##fxmodulo _hash4301_ _len4303_))
             (_obj4307_ (##vector-ref _cache4293_ _ix4305_)))
        (let* ((_obj43094317_ _obj4307_)
               (_else43114325_ (lambda () '#f))
               (_K43134333_
                (lambda (_rest4328_ _xtid4330_)
                  (if (eq? _tid4299_ _xtid4330_) _rest4328_ '#f))))
          (if (##pair? _obj43094317_)
              (let ((_hd43144336_ (##car _obj43094317_))
                    (_tl43154338_ (##cdr _obj43094317_)))
                (let* ((_xtid4341_ _hd43144336_) (_rest4343_ _tl43154338_))
                  (_K43134333_ _rest4343_ _xtid4341_)))
              (_else43114325_))))))
  (define std/generic/dispatch#cache-hash2
    (lambda (_cache4238_ _mix4240_ _shift4242_ _arg14244_ _arg24245_)
      (declare (not interrupts-enabled))
      (let* ((_tid4248_ (std/generic/dispatch#type-of _arg14244_))
             (_hash4251_
              (##fxxor _mix4240_
                       (##fxarithmetic-shift
                        (##symbol-hash _tid4248_)
                        _shift4242_)))
             (_obj4254_
              (std/generic/dispatch#cache-hash1
               _cache4238_
               _hash4251_
               (fx+ _shift4242_ '1)
               _arg24245_)))
        (let* ((_obj42574265_ _obj4254_)
               (_else42594273_ (lambda () '#f))
               (_K42614281_
                (lambda (_rest4276_ _xtid4278_)
                  (if (eq? _tid4248_ _xtid4278_) _rest4276_ '#f))))
          (if (##pair? _obj42574265_)
              (let ((_hd42624284_ (##car _obj42574265_))
                    (_tl42634286_ (##cdr _obj42574265_)))
                (let* ((_xtid4289_ _hd42624284_) (_rest4291_ _tl42634286_))
                  (_K42614281_ _rest4291_ _xtid4289_)))
              (_else42594273_))))))
  (define std/generic/dispatch#cache-hash3
    (lambda (_cache4182_
             _mix4184_
             _shift4186_
             _arg14188_
             _arg24189_
             _arg34190_)
      (declare (not interrupts-enabled))
      (let* ((_tid4193_ (std/generic/dispatch#type-of _arg14188_))
             (_hash4196_
              (##fxxor _mix4184_
                       (##fxarithmetic-shift
                        (##symbol-hash _tid4193_)
                        _shift4186_)))
             (_obj4199_
              (std/generic/dispatch#cache-hash2
               _cache4182_
               _hash4196_
               (fx+ _shift4186_ '1)
               _arg24189_
               _arg34190_)))
        (let* ((_obj42024210_ _obj4199_)
               (_else42044218_ (lambda () '#f))
               (_K42064226_
                (lambda (_rest4221_ _xtid4223_)
                  (if (eq? _tid4193_ _xtid4223_) _rest4221_ '#f))))
          (if (##pair? _obj42024210_)
              (let ((_hd42074229_ (##car _obj42024210_))
                    (_tl42084231_ (##cdr _obj42024210_)))
                (let* ((_xtid4234_ _hd42074229_) (_rest4236_ _tl42084231_))
                  (_K42064226_ _rest4236_ _xtid4234_)))
              (_else42044218_))))))
  (define std/generic/dispatch#cache-hash4
    (lambda (_cache4125_
             _mix4127_
             _shift4129_
             _arg14131_
             _arg24132_
             _arg34133_
             _arg44134_)
      (declare (not interrupts-enabled))
      (let* ((_tid4137_ (std/generic/dispatch#type-of _arg14131_))
             (_hash4140_
              (##fxxor _mix4127_
                       (##fxarithmetic-shift
                        (##symbol-hash _tid4137_)
                        _shift4129_)))
             (_obj4143_
              (std/generic/dispatch#cache-hash3
               _cache4125_
               _hash4140_
               (fx+ _shift4129_ '1)
               _arg24132_
               _arg34133_
               _arg44134_)))
        (let* ((_obj41464154_ _obj4143_)
               (_else41484162_ (lambda () '#f))
               (_K41504170_
                (lambda (_rest4165_ _xtid4167_)
                  (if (eq? _tid4137_ _xtid4167_) _rest4165_ '#f))))
          (if (##pair? _obj41464154_)
              (let ((_hd41514173_ (##car _obj41464154_))
                    (_tl41524175_ (##cdr _obj41464154_)))
                (let* ((_xtid4178_ _hd41514173_) (_rest4180_ _tl41524175_))
                  (_K41504170_ _rest4180_ _xtid4178_)))
              (_else41484162_))))))
  (define std/generic/dispatch#generic-dispatch-cache-lookup1
    (lambda (_cache4117_ _arg14119_)
      (declare (not interrupts-enabled))
      (let ((_method4122_
             (std/generic/dispatch#cache-hash1 _cache4117_ '0 '0 _arg14119_)))
        (if (##procedure? _method4122_) _method4122_ '#f))))
  (define std/generic/dispatch#generic-dispatch-cache-lookup2
    (lambda (_cache4108_ _arg14110_ _arg24111_)
      (declare (not interrupts-enabled))
      (let ((_method4114_
             (std/generic/dispatch#cache-hash2
              _cache4108_
              '0
              '0
              _arg14110_
              _arg24111_)))
        (if (##procedure? _method4114_) _method4114_ '#f))))
  (define std/generic/dispatch#generic-dispatch-cache-lookup3
    (lambda (_cache4098_ _arg14100_ _arg24101_ _arg34102_)
      (declare (not interrupts-enabled))
      (let ((_method4105_
             (std/generic/dispatch#cache-hash3
              _cache4098_
              '0
              '0
              _arg14100_
              _arg24101_
              _arg34102_)))
        (if (##procedure? _method4105_) _method4105_ '#f))))
  (define std/generic/dispatch#generic-dispatch-cache-lookup4
    (lambda (_cache4087_ _arg14089_ _arg24090_ _arg34091_ _arg44092_)
      (declare (not interrupts-enabled))
      (let ((_method4095_
             (std/generic/dispatch#cache-hash4
              _cache4087_
              '0
              '0
              _arg14089_
              _arg24090_
              _arg34091_
              _arg44092_)))
        (if (##procedure? _method4095_) _method4095_ '#f))))
  (define std/generic/dispatch#generic-dispatch-cache!
    (lambda (_gtab4060_ _args4061_ _method4062_)
      (let* ((_arg-types4064_ (map std/generic/dispatch#type-of _args4061_))
             (_entry4066_ (foldl1 cons _method4062_ _arg-types4064_))
             (_hash4072_
              (foldl2 (lambda (_tid4068_ _shift4069_ _r4070_)
                        (##fxxor _r4070_
                                 (##fxarithmetic-shift
                                  (##symbol-hash _tid4068_)
                                  _shift4069_)))
                      '0
                      _arg-types4064_
                      (iota (length _args4061_)))))
        (let _lp4075_ ((_cache4077_
                        (##unchecked-structure-ref
                         _gtab4060_
                         '2
                         std/generic/dispatch#generic-table::t
                         '#f)))
          (let* ((_len4079_ (##vector-length _cache4077_))
                 (_ix4081_ (##fxmodulo _hash4072_ _len4079_)))
            (if (##vector-ref _cache4077_ _ix4081_)
                (let ((_$e4084_
                       (std/generic/dispatch#generic-dispatch-cache-rehash
                        _cache4077_)))
                  (if _$e4084_ (_lp4075_ _$e4084_) '#!void))
                (begin
                  (##vector-set! _cache4077_ _ix4081_ _entry4066_)
                  (##unchecked-structure-set!
                   _gtab4060_
                   _cache4077_
                   '2
                   std/generic/dispatch#generic-table::t
                   '#f))))))))
  (define std/generic/dispatch#generic-dispatch-cache-rehash
    (lambda (_cache3988_)
      (letrec* ((_cache-len3990_ (##vector-length _cache3988_))
                (_hash-entry3991_
                 (lambda (_entry4015_)
                   (let _lp4017_ ((_rest4019_ _entry4015_)
                                  (_count4020_ '0)
                                  (_r4021_ '()))
                     (let* ((_rest40224030_ _rest4019_)
                            (_else40244042_
                             (lambda ()
                               (foldl2 (lambda (_tid4038_ _shift4039_ _r4040_)
                                         (##fxxor _r4040_
                                                  (##fxarithmetic-shift
                                                   (##symbol-hash _tid4038_)
                                                   _shift4039_)))
                                       '0
                                       _r4021_
                                       (iota _count4020_))))
                            (_K40264048_
                             (lambda (_rest4045_ _tid4046_)
                               (_lp4017_
                                _rest4045_
                                (##fx+ _count4020_ '1)
                                (cons _tid4046_ _r4021_)))))
                       (if (##pair? _rest40224030_)
                           (let ((_hd40274051_ (##car _rest40224030_))
                                 (_tl40284053_ (##cdr _rest40224030_)))
                             (let* ((_tid4056_ _hd40274051_)
                                    (_rest4058_ _tl40284053_))
                               (_K40264048_ _rest4058_ _tid4056_)))
                           (_else40244042_))))))
                (_rehash!3992_
                 (lambda (_new-cache4000_)
                   (letrec* ((_new-cache-len4002_
                              (##vector-length _new-cache4000_)))
                     (let _lp4004_ ((_i4006_ '0))
                       (if (##fx< _i4006_ _cache-len3990_)
                           (let ((_entry4008_
                                  (##vector-ref _cache3988_ _i4006_)))
                             (if _entry4008_
                                 (let* ((_hash4010_
                                         (_hash-entry3991_ _entry4008_))
                                        (_ix4012_
                                         (##fxmodulo
                                          _hash4010_
                                          _new-cache-len4002_)))
                                   (if (##vector-ref _new-cache4000_ _ix4012_)
                                       '#f
                                       (begin
                                         (##vector-set!
                                          _new-cache4000_
                                          _ix4012_
                                          _entry4008_)
                                         (_lp4004_ (##fx+ _i4006_ '1)))))
                                 (_lp4004_ (##fx+ _i4006_ '1))))
                           '#t))))))
        (let _retry3994_ ((_new-cache-len3996_
                           (##fxquotient (##fx* '3 _cache-len3990_) '2)))
          (if (##fx< _new-cache-len3996_ std/generic/dispatch#+max-cache-size+)
              (let ((_new-cache3998_ (make-vector _new-cache-len3996_ '#f)))
                (if (_rehash!3992_ _new-cache3998_)
                    _new-cache3998_
                    (_retry3994_
                     (##fxquotient (##fx* '3 _new-cache-len3996_) '2))))
              (begin
                (display '"*** Warning: cannot rehash generic cache; maximum cache size exceeded\n"
                         ##stderr-port)
                '#f))))))
  (define std/generic/dispatch#+max-cache-size+ (expt '2 '16)))
