(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/misc/concurrent-plan#max-actual-workers (make-parameter '0))
  (define std/misc/concurrent-plan#perform-plan/threads__%
    (lambda (_g302081_
             _perform3852238530_
             _announce3852338532_
             _on-success3852438534_
             _on-failure3852538536_
             _deterministic-order3852638538_
             _max-workers3852738540_
             _fg-queue38542_
             _bg-queue38543_)
      (let* ((_perform38545_
              (if (eq? _perform3852238530_ absent-value)
                  (error '"Missing required keyword argument" 'perform:)
                  _perform3852238530_))
             (_announce38547_
              (if (eq? _announce3852338532_ absent-value)
                  (error '"Missing required keyword argument" 'announce:)
                  _announce3852338532_))
             (_on-success38549_
              (if (eq? _on-success3852438534_ absent-value)
                  (error '"Missing required keyword argument" 'on-success:)
                  _on-success3852438534_))
             (_on-failure38551_
              (if (eq? _on-failure3852538536_ absent-value)
                  (error '"Missing required keyword argument" 'on-failure:)
                  _on-failure3852538536_))
             (_deterministic-order38553_
              (if (eq? _deterministic-order3852638538_ absent-value)
                  (error '"Missing required keyword argument"
                         'deterministic-order:)
                  _deterministic-order3852638538_))
             (_max-workers38555_
              (if (eq? _max-workers3852738540_ absent-value)
                  (max (let () (declare (not safe)) (##cpu-count)) '1)
                  _max-workers3852738540_)))
        (letrec* ((_foreground-thread38658_ (current-thread))
                  (_fg-perform38659_
                   (lambda (_item38751_)
                     (_announce38547_ _item38751_)
                     (with-exception-catcher
                      (lambda (_g3875238754_)
                        (_on-failure38551_ _item38751_ _g3875238754_))
                      (lambda ()
                        (_on-success38549_
                         _item38751_
                         (_perform38545_ _item38751_))))))
                  (_serial?38660_ (< _max-workers38555_ '2))
                  (_parallel?38661_ (not _serial?38660_))
                  (_workers38662_ '0))
          (let _loop38664_ ()
            (letrec* ((_no-fg-item?38667_
                       (std/misc/pqueue#pqueue-empty? _fg-queue38542_))
                      (_fg-item?38668_ (not _no-fg-item?38667_))
                      (_no-bg-item?38669_
                       (std/misc/pqueue#pqueue-empty? _bg-queue38543_))
                      (_bg-item?38670_ (not _no-bg-item?38669_))
                      (_no-workers?38671_ (zero? _workers38662_))
                      (_workers?38672_ (not _no-workers?38671_))
                      (_no-worker-slots?38673_
                       (>= _workers38662_ _max-workers38555_))
                      (_worker-slots?38674_ (not _no-worker-slots?38673_))
                      (_ready-to-spawn?38675_
                       (if _bg-item?38670_ _worker-slots?38674_ '#f))
                      (_wait?38676_
                       (if (not _ready-to-spawn?38675_)
                           (let ((_$e38748_ _no-fg-item?38667_))
                             (if _$e38748_
                                 _$e38748_
                                 _deterministic-order38553_))
                           '#f)))
              (let ((_$e38678_
                     (if _parallel?38661_
                         (if _workers?38672_
                             (thread-receive (if _wait?38676_ '#f '0) '#f)
                             '#f)
                         '#f)))
                (if _$e38678_
                    ((lambda (_e3868038682_)
                       (let* ((_g3868438695_ _e3868038682_)
                              (_E3868738699_
                               (lambda ()
                                 (error '"No clause matching" _g3868438695_))))
                         (let ((_K3868938721_
                                (lambda (_item38713_ _worker38714_)
                                  (set! _workers38662_ (- _workers38662_ '1))
                                  (with-exception-catcher
                                   (lambda (_g3871538717_)
                                     (_on-failure38551_
                                      _item38713_
                                      _g3871538717_))
                                   (lambda ()
                                     (_on-success38549_
                                      _item38713_
                                      (std/misc/concurrent-plan#worker-join!
                                       _worker38714_))))
                                  (_loop38664_)))
                               (_K3868838705_
                                (lambda (_m38703_)
                                  (error '"unexpected message" _m38703_))))
                           (if (let ()
                                 (declare (not safe))
                                 (##pair? _g3868438695_))
                               (let ((_tl3869138726_
                                      (let ()
                                        (declare (not safe))
                                        (##cdr _g3868438695_)))
                                     (_hd3869038724_
                                      (let ()
                                        (declare (not safe))
                                        (##car _g3868438695_))))
                                 (if (let ()
                                       (declare (not safe))
                                       (##pair? _tl3869138726_))
                                     (let ((_tl3869338733_
                                            (let ()
                                              (declare (not safe))
                                              (##cdr _tl3869138726_)))
                                           (_hd3869238731_
                                            (let ()
                                              (declare (not safe))
                                              (##car _tl3869138726_))))
                                       (if (let ()
                                             (declare (not safe))
                                             (##null? _tl3869338733_))
                                           (let ((_worker38729_ _hd3869038724_)
                                                 (_item38736_ _hd3869238731_))
                                             (_K3868938721_
                                              _item38736_
                                              _worker38729_))
                                           (let ((_m38708_ _g3868438695_))
                                             (_K3868838705_ _m38708_))))
                                     (let ((_m38708_ _g3868438695_))
                                       (_K3868838705_ _m38708_))))
                               (let ((_m38708_ _g3868438695_))
                                 (_K3868838705_ _m38708_))))))
                     _$e38678_)
                    (if (and _parallel?38661_ _ready-to-spawn?38675_)
                        (begin
                          (let ((_item38738_
                                 (std/misc/pqueue#pqueue-pop!__%
                                  _bg-queue38543_
                                  '#f)))
                            (_announce38547_ _item38738_)
                            (set! _workers38662_ (+ _workers38662_ '1))
                            (gerbil/gambit/threads#spawn/name
                             (cons 'worker: (cons _item38738_ '()))
                             (lambda ()
                               (with-unwind-protect
                                (lambda () (_perform38545_ _item38738_))
                                (lambda ()
                                  (thread-send
                                   _foreground-thread38658_
                                   (cons (current-thread)
                                         (cons _item38738_ '())))))))
                            (if (< (std/misc/concurrent-plan#max-actual-workers)
                                   _workers38662_)
                                (std/misc/concurrent-plan#max-actual-workers
                                 _workers38662_)
                                '#!void))
                          (_loop38664_))
                        (if (and _serial?38660_ _bg-item?38670_)
                            (begin
                              (_fg-perform38659_
                               (std/misc/pqueue#pqueue-pop!__%
                                _bg-queue38543_
                                '#f))
                              (_loop38664_))
                            (if (and _fg-item?38668_
                                     (not _deterministic-order38553_))
                                (begin
                                  (_fg-perform38659_
                                   (std/misc/pqueue#pqueue-pop!__%
                                    _fg-queue38542_
                                    '#f))
                                  (_loop38664_))
                                (if (and _fg-item?38668_
                                         _deterministic-order38553_
                                         _no-workers?38671_
                                         _no-bg-item?38669_)
                                    (begin
                                      (let _lp38743_ ()
                                        (if (std/misc/pqueue#pqueue-empty?
                                             _fg-queue38542_)
                                            '#!void
                                            (begin
                                              (_fg-perform38659_
                                               (std/misc/pqueue#pqueue-pop!__%
                                                _fg-queue38542_
                                                '#f))
                                              (_lp38743_))))
                                      (_loop38664_))
                                    (begin
                                      (let ()
                                        (if (and _no-fg-item?38667_
                                                 _no-bg-item?38669_
                                                 _no-workers?38671_)
                                            '#!void
                                            (std/assert#assert!/fail
                                             '"\"misc/concurrent-plan.ss\"@103.16"
                                             '(and no-fg-item?
                                                   no-bg-item?
                                                   no-workers?)
                                             '())))
                                      '#!void)))))))))))))
  (define std/misc/concurrent-plan#perform-plan/threads__@
    (lambda (_keys3852138761_ . _args38763_)
      (apply std/misc/concurrent-plan#perform-plan/threads__%
             _keys3852138761_
             (table-ref _keys3852138761_ 'perform: absent-value)
             (table-ref _keys3852138761_ 'announce: absent-value)
             (table-ref _keys3852138761_ 'on-success: absent-value)
             (table-ref _keys3852138761_ 'on-failure: absent-value)
             (table-ref _keys3852138761_ 'deterministic-order: absent-value)
             (table-ref _keys3852138761_ 'max-workers: absent-value)
             _args38763_)))
  (define std/misc/concurrent-plan#perform-plan/threads
    (lambda _args3852838769_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                announce:
                #f
                #f
                on-success:
                perform:
                max-workers:
                deterministic-order:
                on-failure:
                #f)
             std/misc/concurrent-plan#perform-plan/threads__@
             _args3852838769_)))
  (define std/misc/concurrent-plan#worker-join!
    (lambda (_thread38508_)
      (with-exception-catcher
       (lambda (_g3850938511_)
         (if ((lambda (_$obj38514_) (uncaught-exception? _$obj38514_))
              _g3850938511_)
             (let ((_exn38517_ _g3850938511_))
               (raise (make-struct-instance
                       std/misc/concurrent-plan#worker-error::t
                       _exn38517_)))
             (raise _g3850938511_)))
       (lambda () (thread-join! _thread38508_)))))
  (define std/misc/concurrent-plan#worker-error::t
    (make-struct-type
     'std/misc/concurrent-plan#worker-error::t
     exception::t
     '1
     'worker-error
     '()
     '#f
     '(e)))
  (define std/misc/concurrent-plan#worker-error?
    (make-struct-predicate std/misc/concurrent-plan#worker-error::t))
  (define std/misc/concurrent-plan#make-worker-error
    (lambda _$args38505_
      (apply make-struct-instance
             std/misc/concurrent-plan#worker-error::t
             _$args38505_)))
  (define std/misc/concurrent-plan#worker-error-e
    (make-struct-field-accessor std/misc/concurrent-plan#worker-error::t '0))
  (define std/misc/concurrent-plan#worker-error-e-set!
    (make-struct-field-mutator std/misc/concurrent-plan#worker-error::t '0))
  (define std/misc/concurrent-plan#worker-error::display-exception
    (lambda (_self38500_ _port38501_)
      (let ((_e38503_ (std/misc/concurrent-plan#worker-error-e _self38500_)))
        (display '"Uncaught exception: " _port38501_)
        (display-exception (uncaught-exception-reason _e38503_) _port38501_))))
  (bind-method!
   std/misc/concurrent-plan#worker-error::t
   'display-exception
   std/misc/concurrent-plan#worker-error::display-exception
   '#f))
