(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/misc/func#repeat
    (lambda (_v-or-fn234060_ _n-times234061_ . _args234062_)
      (declare (fixnum) (not safe))
      (begin
        (if (fixnum? _n-times234061_)
            '#!void
            (error '"Bad argument; expected fixnum" _n-times234061_))
        (if (procedure? _v-or-fn234060_)
            (let ((_fn234066_
                   (if (null? _args234062_)
                       _v-or-fn234060_
                       (lambda () (apply _v-or-fn234060_ _args234062_)))))
              (let _lp234068_ ((_i234070_ '0) (_acc234071_ '()))
                (if (< _i234070_ _n-times234061_)
                    (_lp234068_
                     (+ _i234070_ '1)
                     (cons (_fn234066_) _acc234071_))
                    (reverse _acc234071_))))
            (let _lp234073_ ((_i234075_ '0) (_acc234076_ '()))
              (if (< _i234075_ _n-times234061_)
                  (_lp234073_
                   (+ _i234075_ '1)
                   (cons _v-or-fn234060_ _acc234076_))
                  _acc234076_))))))
  (define std/misc/func#always
    (lambda (_v-or-fn234055_ . _args234056_)
      (if (procedure? _v-or-fn234055_)
          (lambda () (apply _v-or-fn234055_ _args234056_))
          (lambda () _v-or-fn234055_))))
  (define std/misc/func#compose1__0 (lambda () identity))
  (define std/misc/func#compose1__1 (lambda (_f234044_) _f234044_))
  (define std/misc/func#compose1__2
    (lambda (_f1234046_ _f2234047_)
      (lambda (_x234049_) (_f1234046_ (_f2234047_ _x234049_)))))
  (define std/misc/func#compose1__3
    (lambda (_f1234051_ _f2234052_ . _rest234053_)
      (apply std/misc/func#rcompose1
             (reverse (cons _f1234051_ (cons _f2234052_ _rest234053_))))))
  (define std/misc/func#compose1
    (lambda _g303790_
      (let ((_g303789_ (let () (declare (not safe)) (##length _g303790_))))
        (cond ((let () (declare (not safe)) (##fx= _g303789_ 0))
               (apply std/misc/func#compose1__0 _g303790_))
              ((let () (declare (not safe)) (##fx= _g303789_ 1))
               (apply std/misc/func#compose1__1 _g303790_))
              ((let () (declare (not safe)) (##fx= _g303789_ 2))
               (apply std/misc/func#compose1__2 _g303790_))
              ((let () (declare (not safe)) (##fx>= _g303789_ 2))
               (apply std/misc/func#compose1__3 _g303790_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/func#compose1
                _g303790_))))))
  (define std/misc/func#rcompose1__0 (lambda () identity))
  (define std/misc/func#rcompose1__1 (lambda (_f234032_) _f234032_))
  (define std/misc/func#rcompose1__2
    (lambda (_f1234034_ _f2234035_)
      (lambda (_x234037_) (_f2234035_ (_f1234034_ _x234037_)))))
  (define std/misc/func#rcompose1__3
    (lambda (_f1234039_ _f2234040_ . _rest234041_)
      (std/misc/func#rcompose1__2
       _f1234039_
       (apply std/misc/func#rcompose1 _f2234040_ _rest234041_))))
  (define std/misc/func#rcompose1
    (lambda _g303792_
      (let ((_g303791_ (let () (declare (not safe)) (##length _g303792_))))
        (cond ((let () (declare (not safe)) (##fx= _g303791_ 0))
               (apply std/misc/func#rcompose1__0 _g303792_))
              ((let () (declare (not safe)) (##fx= _g303791_ 1))
               (apply std/misc/func#rcompose1__1 _g303792_))
              ((let () (declare (not safe)) (##fx= _g303791_ 2))
               (apply std/misc/func#rcompose1__2 _g303792_))
              ((let () (declare (not safe)) (##fx>= _g303791_ 2))
               (apply std/misc/func#rcompose1__3 _g303792_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/func#rcompose1
                _g303792_))))))
  (define std/misc/func#compose__0 (lambda () identity))
  (define std/misc/func#compose__1 (lambda (_f234020_) _f234020_))
  (define std/misc/func#compose__2
    (lambda (_f1234022_ _f2234023_)
      (lambda _args234025_ (_f1234022_ (apply _f2234023_ _args234025_)))))
  (define std/misc/func#compose__3
    (lambda (_f1234027_ _f2234028_ . _rest234029_)
      (apply std/misc/func#rcompose
             (reverse (cons _f1234027_ (cons _f2234028_ _rest234029_))))))
  (define std/misc/func#compose
    (lambda _g303794_
      (let ((_g303793_ (let () (declare (not safe)) (##length _g303794_))))
        (cond ((let () (declare (not safe)) (##fx= _g303793_ 0))
               (apply std/misc/func#compose__0 _g303794_))
              ((let () (declare (not safe)) (##fx= _g303793_ 1))
               (apply std/misc/func#compose__1 _g303794_))
              ((let () (declare (not safe)) (##fx= _g303793_ 2))
               (apply std/misc/func#compose__2 _g303794_))
              ((let () (declare (not safe)) (##fx>= _g303793_ 2))
               (apply std/misc/func#compose__3 _g303794_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/func#compose
                _g303794_))))))
  (define std/misc/func#rcompose__0 (lambda () identity))
  (define std/misc/func#rcompose__1 (lambda (_f234008_) _f234008_))
  (define std/misc/func#rcompose__2
    (lambda (_f1234010_ _f2234011_)
      (lambda _args234013_ (_f2234011_ (apply _f1234010_ _args234013_)))))
  (define std/misc/func#rcompose__3
    (lambda (_f1234015_ _f2234016_ . _rest234017_)
      (std/misc/func#rcompose__2
       _f1234015_
       (apply std/misc/func#rcompose _f2234016_ _rest234017_))))
  (define std/misc/func#rcompose
    (lambda _g303796_
      (let ((_g303795_ (let () (declare (not safe)) (##length _g303796_))))
        (cond ((let () (declare (not safe)) (##fx= _g303795_ 0))
               (apply std/misc/func#rcompose__0 _g303796_))
              ((let () (declare (not safe)) (##fx= _g303795_ 1))
               (apply std/misc/func#rcompose__1 _g303796_))
              ((let () (declare (not safe)) (##fx= _g303795_ 2))
               (apply std/misc/func#rcompose__2 _g303796_))
              ((let () (declare (not safe)) (##fx>= _g303795_ 2))
               (apply std/misc/func#rcompose__3 _g303796_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/func#rcompose
                _g303796_))))))
  (define std/misc/func#compose/values__0 (lambda () values))
  (define std/misc/func#compose/values__1 (lambda (_f233995_) _f233995_))
  (define std/misc/func#compose/values__2
    (lambda (_f1233997_ _f2233998_)
      (lambda _args234000_
        (call-with-values
         (lambda () (apply _f2233998_ _args234000_))
         _f1233997_))))
  (define std/misc/func#compose/values__3
    (lambda (_f1234003_ _f2234004_ . _rest234005_)
      (apply std/misc/func#rcompose/values
             (reverse (cons _f1234003_ (cons _f2234004_ _rest234005_))))))
  (define std/misc/func#compose/values
    (lambda _g303798_
      (let ((_g303797_ (let () (declare (not safe)) (##length _g303798_))))
        (cond ((let () (declare (not safe)) (##fx= _g303797_ 0))
               (apply std/misc/func#compose/values__0 _g303798_))
              ((let () (declare (not safe)) (##fx= _g303797_ 1))
               (apply std/misc/func#compose/values__1 _g303798_))
              ((let () (declare (not safe)) (##fx= _g303797_ 2))
               (apply std/misc/func#compose/values__2 _g303798_))
              ((let () (declare (not safe)) (##fx>= _g303797_ 2))
               (apply std/misc/func#compose/values__3 _g303798_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/func#compose/values
                _g303798_))))))
  (define std/misc/func#rcompose/values__0 (lambda () values))
  (define std/misc/func#rcompose/values__1 (lambda (_f233982_) _f233982_))
  (define std/misc/func#rcompose/values__2
    (lambda (_f1233984_ _f2233985_)
      (lambda _args233987_
        (call-with-values
         (lambda () (apply _f1233984_ _args233987_))
         _f2233985_))))
  (define std/misc/func#rcompose/values__3
    (lambda (_f1233990_ _f2233991_ . _rest233992_)
      (std/misc/func#rcompose/values__2
       _f1233990_
       (apply std/misc/func#rcompose/values _f2233991_ _rest233992_))))
  (define std/misc/func#rcompose/values
    (lambda _g303800_
      (let ((_g303799_ (let () (declare (not safe)) (##length _g303800_))))
        (cond ((let () (declare (not safe)) (##fx= _g303799_ 0))
               (apply std/misc/func#rcompose/values__0 _g303800_))
              ((let () (declare (not safe)) (##fx= _g303799_ 1))
               (apply std/misc/func#rcompose/values__1 _g303800_))
              ((let () (declare (not safe)) (##fx= _g303799_ 2))
               (apply std/misc/func#rcompose/values__2 _g303800_))
              ((let () (declare (not safe)) (##fx>= _g303799_ 2))
               (apply std/misc/func#rcompose/values__3 _g303800_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/func#rcompose/values
                _g303800_))))))
  (define std/misc/func#every-of__%
    (lambda (_g303801_ _test233951233954_ _preds233956_ _v233957_)
      (let ((_test233959_
             (if (eq? _test233951233954_ absent-value)
                 equal?
                 _test233951233954_)))
        (andmap1 (lambda (_p233961_)
                   ((if (procedure? _p233961_)
                        _p233961_
                        (lambda (_g233962233964_)
                          (_test233959_ _p233961_ _g233962233964_)))
                    _v233957_))
                 _preds233956_))))
  (define std/misc/func#every-of__@
    (lambda (_keys233950233970_ . _args233972_)
      (apply std/misc/func#every-of__%
             _keys233950233970_
             (table-ref _keys233950233970_ 'test: absent-value)
             _args233972_)))
  (define std/misc/func#every-of
    (lambda _args233952233978_
      (apply keyword-dispatch
             '#(test:)
             std/misc/func#every-of__@
             _args233952233978_)))
  (define std/misc/func#any-of__%
    (lambda (_g303802_ _test233919233922_ _preds233924_ _v233925_)
      (let ((_test233927_
             (if (eq? _test233919233922_ absent-value)
                 equal?
                 _test233919233922_)))
        (ormap1 (lambda (_p233929_)
                  ((if (procedure? _p233929_)
                       _p233929_
                       (lambda (_g233930233932_)
                         (_test233927_ _p233929_ _g233930233932_)))
                   _v233925_))
                _preds233924_))))
  (define std/misc/func#any-of__@
    (lambda (_keys233918233938_ . _args233940_)
      (apply std/misc/func#any-of__%
             _keys233918233938_
             (table-ref _keys233918233938_ 'test: absent-value)
             _args233940_)))
  (define std/misc/func#any-of
    (lambda _args233920233946_
      (apply keyword-dispatch
             '#(test:)
             std/misc/func#any-of__@
             _args233920233946_)))
  (define std/misc/func#pred-limit
    (lambda (_pred233906_ _limit233907_)
      (letrec ((_test233909_
                (lambda (_v233912_)
                  (declare (fixnum))
                  (if (> _limit233907_ '0)
                      (let ((_v233915_ (_pred233906_ _v233912_)))
                        (if _v233915_
                            (set! _limit233907_ (- _limit233907_ '1))
                            '#!void)
                        _v233915_)
                      '#f))))
        (if _limit233907_
            (if (> _limit233907_ '0) _test233909_ (lambda (_g303803_) '#f))
            _pred233906_))))
  (define std/misc/func#pred-sequence__%
    (lambda (_list233880_ _limit233881_)
      (declare (not safe) (fixnum))
      (letrec* ((_g303804_
                 (let ((_g303805_
                        (if (fixnum? _limit233881_)
                            '#!void
                            (set! _limit233881_ '-1))))
                   #!void
                   _g303805_))
                (_seq233883_ _list233880_)
                (_check233884_
                 (lambda (_v233889_)
                   (letrec* ((_is-match233891_
                              (if (or (equal? (car _seq233883_) _v233889_)
                                      (begin
                                        (set! _seq233883_ _list233880_)
                                        '#f))
                                  (if (set! _seq233883_ (cdr _seq233883_))
                                      (null? _seq233883_)
                                      '#f)
                                  '#f)))
                     (if _is-match233891_
                         (begin
                           (set! _seq233883_ _list233880_)
                           (if (> _limit233881_ '0)
                               (set! _limit233881_ (- _limit233881_ '1))
                               '#!void))
                         '#!void)
                     _is-match233891_))))
        (if (pair? _list233880_)
            (lambda (_v233886_)
              (if (zero? _limit233881_) '#f (_check233884_ _v233886_)))
            (lambda (_g303807_) '#f)))))
  (define std/misc/func#pred-sequence__0
    (lambda (_list233899_)
      (let ((_limit233901_ '#f))
        (std/misc/func#pred-sequence__% _list233899_ _limit233901_))))
  (define std/misc/func#pred-sequence
    (lambda _g303809_
      (let ((_g303808_ (let () (declare (not safe)) (##length _g303809_))))
        (cond ((let () (declare (not safe)) (##fx= _g303808_ 1))
               (apply std/misc/func#pred-sequence__0 _g303809_))
              ((let () (declare (not safe)) (##fx= _g303808_ 2))
               (apply std/misc/func#pred-sequence__% _g303809_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/func#pred-sequence
                _g303809_))))))
  (define std/misc/func#pred-and
    (lambda (_pred233873_)
      (letrec* ((_res233875_ '#t))
        (lambda (_v233877_)
          (if _res233875_
              (begin (set! _res233875_ (_pred233873_ _v233877_)) _res233875_)
              '#f)))))
  (define std/misc/func#pred-or
    (lambda (_pred233867_)
      (letrec* ((_res233869_ '#f))
        (lambda (_v233871_)
          (if _res233869_
              '#t
              (begin
                (set! _res233869_ (_pred233867_ _v233871_))
                _res233869_))))))
  (define std/misc/func#pred-every-of__%
    (lambda (_g303810_ _test233830233833_ _preds233835_)
      (let ((_test233837_
             (if (eq? _test233830233833_ absent-value)
                 equal?
                 _test233830233833_)))
        (if (pair? _preds233835_)
            (let ((_preds233845_
                   (map (lambda (_p233839_)
                          (if (procedure? _p233839_)
                              _p233839_
                              (lambda (_g233840233842_)
                                (_test233837_ _p233839_ _g233840233842_))))
                        _preds233835_)))
              (lambda (_v233847_)
                (andmap1 (lambda (_g233848233850_) (_g233848233850_ _v233847_))
                         _preds233845_)))
            true))))
  (define std/misc/func#pred-every-of__@
    (lambda (_keys233829233856_ . _args233858_)
      (apply std/misc/func#pred-every-of__%
             _keys233829233856_
             (table-ref _keys233829233856_ 'test: absent-value)
             _args233858_)))
  (define std/misc/func#pred-every-of
    (lambda _args233831233864_
      (apply keyword-dispatch
             '#(test:)
             std/misc/func#pred-every-of__@
             _args233831233864_)))
  (define std/misc/func#pred-any-of__%
    (lambda (_g303811_ _test233791233794_ _preds233796_)
      (let ((_test233798_
             (if (eq? _test233791233794_ absent-value)
                 equal?
                 _test233791233794_)))
        (if (pair? _preds233796_)
            (let ((_preds233806_
                   (map (lambda (_p233800_)
                          (if (procedure? _p233800_)
                              _p233800_
                              (lambda (_g233801233803_)
                                (_test233798_ _p233800_ _g233801233803_))))
                        _preds233796_)))
              (lambda (_v233808_)
                (ormap1 (lambda (_g233809233811_) (_g233809233811_ _v233808_))
                        _preds233806_)))
            false))))
  (define std/misc/func#pred-any-of__@
    (lambda (_keys233790233817_ . _args233819_)
      (apply std/misc/func#pred-any-of__%
             _keys233790233817_
             (table-ref _keys233790233817_ 'test: absent-value)
             _args233819_)))
  (define std/misc/func#pred-any-of
    (lambda _args233792233825_
      (apply keyword-dispatch
             '#(test:)
             std/misc/func#pred-any-of__@
             _args233792233825_))))
