(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/misc/hash#hash-empty?
    (lambda (_h30740_) (zero? (table-length _h30740_))))
  (define std/misc/hash#%none '#(none))
  (define std/misc/hash#hash-ref/default
    (lambda (_table30734_ _key30735_ _default30736_)
      (let ((_val30738_
             (table-ref _table30734_ _key30735_ std/misc/hash#%none)))
        (if (eq? _val30738_ std/misc/hash#%none)
            (_default30736_)
            _val30738_))))
  (define std/misc/hash#hash-ensure-ref
    (lambda (_table30727_ _key30728_ _default30729_)
      (std/misc/hash#hash-ref/default
       _table30727_
       _key30728_
       (lambda ()
         (let ((_value30732_ (_default30729_)))
           (table-set! _table30727_ _key30728_ _value30732_)
           _value30732_)))))
  (define std/misc/hash#invert-hash__%
    (lambda (_g304167_ _to3070130704_ _from30706_)
      (let ((_to30708_
             (if (eq? _to3070130704_ absent-value)
                 (make-table)
                 _to3070130704_)))
        (table-for-each
         (lambda (_k30710_ _v30711_) (table-set! _to30708_ _v30711_ _k30710_))
         _from30706_)
        _to30708_)))
  (define std/misc/hash#invert-hash__@
    (lambda (_keys3070030716_ . _args30718_)
      (apply std/misc/hash#invert-hash__%
             _keys3070030716_
             (table-ref _keys3070030716_ 'to: absent-value)
             _args30718_)))
  (define std/misc/hash#invert-hash
    (lambda _args3070230724_
      (apply keyword-dispatch
             '#(to:)
             std/misc/hash#invert-hash__@
             _args3070230724_)))
  (define std/misc/hash#invert-hash/fold__%
    (lambda (_g304168_
             _to3066330668_
             _nil3066430670_
             _cons3066530672_
             _from30674_)
      (let* ((_to30676_
              (if (eq? _to3066330668_ absent-value)
                  (make-table)
                  _to3066330668_))
             (_nil30678_
              (if (eq? _nil3066430670_ absent-value) '() _nil3066430670_))
             (_cons30680_
              (if (eq? _cons3066530672_ absent-value) cons _cons3066530672_)))
        (table-for-each
         (lambda (_k30682_ _v30683_)
           (table-set!
            _to30676_
            _v30683_
            (_cons30680_ _k30682_ (table-ref _to30676_ _v30683_ _nil30678_))))
         _from30674_)
        _to30676_)))
  (define std/misc/hash#invert-hash/fold__@
    (lambda (_keys3066230688_ . _args30690_)
      (apply std/misc/hash#invert-hash/fold__%
             _keys3066230688_
             (table-ref _keys3066230688_ 'to: absent-value)
             (table-ref _keys3066230688_ 'nil: absent-value)
             (table-ref _keys3066230688_ 'cons: absent-value)
             _args30690_)))
  (define std/misc/hash#invert-hash/fold
    (lambda _args3066630696_
      (apply keyword-dispatch
             '#(nil: cons: to:)
             std/misc/hash#invert-hash/fold__@
             _args3066630696_)))
  (define std/misc/hash#invert-hash<-vector__%
    (lambda (_g304169_
             _start3059530601_
             _end3059630603_
             _to3059730605_
             _key3059830607_
             _from30609_)
      (let* ((_start30611_
              (if (eq? _start3059530601_ absent-value) '0 _start3059530601_))
             (_end30613_
              (if (eq? _end3059630603_ absent-value)
                  (vector-length _from30609_)
                  _end3059630603_))
             (_to30615_
              (if (eq? _to3059730605_ absent-value)
                  (make-table)
                  _to3059730605_))
             (_key30617_
              (if (eq? _key3059830607_ absent-value)
                  identity
                  _key3059830607_)))
        (let* ((_iter-do30624_
                (lambda (_n30619_)
                  (let ((_i30622_ _n30619_))
                    (table-set!
                     _to30615_
                     (_key30617_ (vector-ref _from30609_ _i30622_))
                     _i30622_))))
               (_$start30627_ _start30611_)
               (_$end30630_ _end30613_)
               (_$step30633_ (if (> _$start30627_ _$end30630_) '-1 '1)))
          (if (negative? _$step30633_)
              (let _lp30637_ ((_val30640_ _$start30627_))
                (if (> _val30640_ _$end30630_)
                    (begin
                      (_iter-do30624_ _val30640_)
                      (_lp30637_ (+ _val30640_ _$step30633_)))
                    '#!void))
              (let _lp30643_ ((_val30645_ _$start30627_))
                (if (< _val30645_ _$end30630_)
                    (begin
                      (_iter-do30624_ _val30645_)
                      (_lp30643_ (+ _val30645_ _$step30633_)))
                    '#!void))))
        _to30615_)))
  (define std/misc/hash#invert-hash<-vector__@
    (lambda (_keys3059430650_ . _args30652_)
      (apply std/misc/hash#invert-hash<-vector__%
             _keys3059430650_
             (table-ref _keys3059430650_ 'start: absent-value)
             (table-ref _keys3059430650_ 'end: absent-value)
             (table-ref _keys3059430650_ 'to: absent-value)
             (table-ref _keys3059430650_ 'key: absent-value)
             _args30652_)))
  (define std/misc/hash#invert-hash<-vector
    (lambda _args3059930658_
      (apply keyword-dispatch
             '#(#f key: #f #f end: start: #f #f to:)
             std/misc/hash#invert-hash<-vector__@
             _args3059930658_)))
  (define std/misc/hash#invert-hash<-vector/fold__%
    (lambda (_g304170_
             _start3051530523_
             _end3051630525_
             _to3051730527_
             _nil3051830529_
             _cons3051930531_
             _key3052030533_
             _from30535_)
      (let* ((_start30537_
              (if (eq? _start3051530523_ absent-value) '0 _start3051530523_))
             (_end30539_
              (if (eq? _end3051630525_ absent-value)
                  (vector-length _from30535_)
                  _end3051630525_))
             (_to30541_
              (if (eq? _to3051730527_ absent-value)
                  (make-table)
                  _to3051730527_))
             (_nil30543_
              (if (eq? _nil3051830529_ absent-value) '() _nil3051830529_))
             (_cons30545_
              (if (eq? _cons3051930531_ absent-value) cons _cons3051930531_))
             (_key30547_
              (if (eq? _key3052030533_ absent-value)
                  identity
                  _key3052030533_)))
        (let* ((_iter-do30556_
                (lambda (_n30549_)
                  (let ((_i30552_ _n30549_))
                    (letrec* ((_val30554_ (vector-ref _from30535_ _i30552_)))
                      (table-set!
                       _to30541_
                       (_key30547_ _val30554_)
                       (_cons30545_
                        _i30552_
                        (table-ref _to30541_ _val30554_ _nil30543_)))))))
               (_$start30559_ _start30537_)
               (_$end30562_ _end30539_)
               (_$step30565_ (if (> _$start30559_ _$end30562_) '-1 '1)))
          (if (negative? _$step30565_)
              (let _lp30569_ ((_val30572_ _$start30559_))
                (if (> _val30572_ _$end30562_)
                    (begin
                      (_iter-do30556_ _val30572_)
                      (_lp30569_ (+ _val30572_ _$step30565_)))
                    '#!void))
              (let _lp30575_ ((_val30577_ _$start30559_))
                (if (< _val30577_ _$end30562_)
                    (begin
                      (_iter-do30556_ _val30577_)
                      (_lp30575_ (+ _val30577_ _$step30565_)))
                    '#!void))))
        _to30541_)))
  (define std/misc/hash#invert-hash<-vector/fold__@
    (lambda (_keys3051430582_ . _args30584_)
      (apply std/misc/hash#invert-hash<-vector/fold__%
             _keys3051430582_
             (table-ref _keys3051430582_ 'start: absent-value)
             (table-ref _keys3051430582_ 'end: absent-value)
             (table-ref _keys3051430582_ 'to: absent-value)
             (table-ref _keys3051430582_ 'nil: absent-value)
             (table-ref _keys3051430582_ 'cons: absent-value)
             (table-ref _keys3051430582_ 'key: absent-value)
             _args30584_)))
  (define std/misc/hash#invert-hash<-vector/fold
    (lambda _args3052130590_
      (apply keyword-dispatch
             '#(#f
                #f
                to:
                #f
                #f
                #f
                nil:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                end:
                #f
                #f
                #f
                #f
                #f
                cons:
                start:
                #f
                #f
                #f
                #f
                key:
                #f
                #f
                #f
                #f
                #f
                #f
                #f)
             std/misc/hash#invert-hash<-vector/fold__@
             _args3052130590_)))
  (define std/misc/hash#hash-restrict-keys
    (let ((_marker30502_ '#(fresh)))
      (lambda (_h30504_ _keys30505_)
        (let ((_table30507_ (make-table)))
          (for-each
           (lambda (_k30509_)
             (let ((_v30511_ (table-ref _h30504_ _k30509_ _marker30502_)))
               (if (eq? _v30511_ _marker30502_)
                   '#!void
                   (table-set! _table30507_ _k30509_ _v30511_))))
           _keys30505_)
          _table30507_))))
  (define std/misc/hash#hash-value-map
    (lambda (_h30467_ _f30468_)
      (list->table
       (map (lambda (_e3046930471_)
              (let* ((_g3047330480_ _e3046930471_)
                     (_E3047530484_
                      (lambda () (error '"No clause matching" _g3047330480_)))
                     (_K3047630490_
                      (lambda (_v30487_ _k30488_)
                        (cons _k30488_ (_f30468_ _v30487_)))))
                (if (let () (declare (not safe)) (##pair? _g3047330480_))
                    (let ((_hd3047730493_
                           (let () (declare (not safe)) (##car _g3047330480_)))
                          (_tl3047830495_
                           (let ()
                             (declare (not safe))
                             (##cdr _g3047330480_))))
                      (let* ((_k30498_ _hd3047730493_)
                             (_v30500_ _tl3047830495_))
                        (_K3047630490_ _v30500_ _k30498_)))
                    (_E3047530484_))))
            (table->list _h30467_)))))
  (define std/misc/hash#hash-key-value-map__%
    (lambda (_f30410_ _from30411_ _to30412_)
      (table-for-each
       (lambda (_k30414_ _v30415_)
         (let* ((_g3041630425_ (_f30410_ _k30414_ _v30415_))
                (_E3041930429_
                 (lambda () (error '"No clause matching" _g3041630425_))))
           (let ((_K3042130443_
                  (lambda (_v130440_ _k130441_)
                    (table-set! _to30412_ _k130441_ _v130440_)))
                 (_K3042030434_ (lambda () '#!void)))
             (let ((_try-match3041830437_
                    (lambda ()
                      (if (let ()
                            (declare (not safe))
                            (##eq? _g3041630425_ '#f))
                          '#!void
                          (_E3041930429_)))))
               (if (let () (declare (not safe)) (##pair? _g3041630425_))
                   (let ((_tl3042330448_
                          (let () (declare (not safe)) (##cdr _g3041630425_)))
                         (_hd3042230446_
                          (let () (declare (not safe)) (##car _g3041630425_))))
                     (let ((_k130451_ _hd3042230446_)
                           (_v130453_ _tl3042330448_))
                       (_K3042130443_ _v130453_ _k130451_)))
                   (_try-match3041830437_))))))
       _from30411_)
      _to30412_))
  (define std/misc/hash#hash-key-value-map__0
    (lambda (_f30458_ _from30459_)
      (let ((_to30461_ (make-table)))
        (std/misc/hash#hash-key-value-map__% _f30458_ _from30459_ _to30461_))))
  (define std/misc/hash#hash-key-value-map
    (lambda _g304172_
      (let ((_g304171_ (let () (declare (not safe)) (##length _g304172_))))
        (cond ((let () (declare (not safe)) (##fx= _g304171_ 2))
               (apply std/misc/hash#hash-key-value-map__0 _g304172_))
              ((let () (declare (not safe)) (##fx= _g304171_ 3))
               (apply std/misc/hash#hash-key-value-map__% _g304172_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/hash#hash-key-value-map
                _g304172_))))))
  (define std/misc/hash#hash-filter__%
    (lambda (_from30390_ _pred30391_ _to30392_)
      (table-for-each
       (lambda (_k30394_ _v30395_)
         (if (_pred30391_ _k30394_ _v30395_)
             (table-set! _to30392_ _k30394_ _v30395_)
             '#!void))
       _from30390_)
      _to30392_))
  (define std/misc/hash#hash-filter__0
    (lambda (_from30400_ _pred30401_)
      (let ((_to30403_ (make-table)))
        (std/misc/hash#hash-filter__% _from30400_ _pred30401_ _to30403_))))
  (define std/misc/hash#hash-filter
    (lambda _g304174_
      (let ((_g304173_ (let () (declare (not safe)) (##length _g304174_))))
        (cond ((let () (declare (not safe)) (##fx= _g304173_ 2))
               (apply std/misc/hash#hash-filter__0 _g304174_))
              ((let () (declare (not safe)) (##fx= _g304173_ 3))
               (apply std/misc/hash#hash-filter__% _g304174_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/hash#hash-filter
                _g304174_))))))
  (define std/misc/hash#hash-remove__%
    (lambda (_from30370_ _pred30371_ _to30372_)
      (table-for-each
       (lambda (_k30374_ _v30375_)
         (if (_pred30371_ _k30374_ _v30375_)
             '#!void
             (table-set! _to30372_ _k30374_ _v30375_)))
       _from30370_)
      _to30372_))
  (define std/misc/hash#hash-remove__0
    (lambda (_from30380_ _pred30381_)
      (let ((_to30383_ (make-table)))
        (std/misc/hash#hash-remove__% _from30380_ _pred30381_ _to30383_))))
  (define std/misc/hash#hash-remove
    (lambda _g304176_
      (let ((_g304175_ (let () (declare (not safe)) (##length _g304176_))))
        (cond ((let () (declare (not safe)) (##fx= _g304175_ 2))
               (apply std/misc/hash#hash-remove__0 _g304176_))
              ((let () (declare (not safe)) (##fx= _g304175_ 3))
               (apply std/misc/hash#hash-remove__% _g304176_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/hash#hash-remove
                _g304176_))))))
  (define std/misc/hash#hash-remove-value__%
    (lambda (_from30345_ _value30346_ _to30347_)
      (std/misc/hash#hash-remove__%
       _from30345_
       (lambda (_g304177_ _v30349_) (equal? _v30349_ _value30346_))
       _to30347_)))
  (define std/misc/hash#hash-remove-value__0
    (lambda (_from30354_)
      (let* ((_value30356_ '#f) (_to30358_ (make-table)))
        (std/misc/hash#hash-remove-value__%
         _from30354_
         _value30356_
         _to30358_))))
  (define std/misc/hash#hash-remove-value__1
    (lambda (_from30360_ _value30361_)
      (let ((_to30363_ (make-table)))
        (std/misc/hash#hash-remove-value__%
         _from30360_
         _value30361_
         _to30363_))))
  (define std/misc/hash#hash-remove-value
    (lambda _g304179_
      (let ((_g304178_ (let () (declare (not safe)) (##length _g304179_))))
        (cond ((let () (declare (not safe)) (##fx= _g304178_ 1))
               (apply std/misc/hash#hash-remove-value__0 _g304179_))
              ((let () (declare (not safe)) (##fx= _g304178_ 2))
               (apply std/misc/hash#hash-remove-value__1 _g304179_))
              ((let () (declare (not safe)) (##fx= _g304178_ 3))
               (apply std/misc/hash#hash-remove-value__% _g304179_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/hash#hash-remove-value
                _g304179_))))))
  (define std/misc/hash#hash-ensure-removed!
    (lambda (_table30339_ _key30340_)
      (let ((_val30342_
             (table-ref _table30339_ _key30340_ std/misc/hash#%none)))
        (if (eq? _val30342_ std/misc/hash#%none)
            (values '#f '#f)
            (begin
              (table-set! _table30339_ _key30340_)
              (values _val30342_ '#t))))))
  (define std/misc/hash#hash-ensure-modify!
    (lambda (_table30329_ _key30330_ _default30331_ _function30332_)
      (let* ((_val30334_
              (std/misc/hash#hash-ensure-ref
               _table30329_
               _key30330_
               _default30331_))
             (_new-val30336_ (_function30332_ _val30334_)))
        (table-set! _table30329_ _key30330_ _new-val30336_)
        _new-val30336_)))
  (define std/misc/hash#hash-merge/override
    (lambda (_base-table30323_ . _rest30324_)
      (foldl1 (lambda (_tab30326_ _r30327_)
                (table-merge _r30327_ _tab30326_ '#t))
              _base-table30323_
              _rest30324_)))
  (define std/misc/hash#hash-merge/override!
    (lambda (_base-table30317_ . _rest30318_)
      (foldl1 (lambda (_tab30320_ _r30321_)
                (table-merge! _r30321_ _tab30320_ '#t))
              _base-table30317_
              _rest30318_)))
  (define std/misc/hash#hash->list/sort
    (lambda (_hash30311_ _pred30312_)
      (std/sort#sort
       (table->list _hash30311_)
       (lambda (_x30314_ _y30315_)
         (_pred30312_ (car _x30314_) (car _y30315_))))))
  (define std/misc/hash#hash-get-set! hash-put!)
  (define std/misc/hash#hash-ref-set!__1
    (lambda (_h30306_ _k30307_ __d30308_ _v30309_)
      (table-set! _h30306_ _k30307_ _v30309_)))
  (define std/misc/hash#hash-ref-set!
    (lambda _g304181_
      (let ((_g304180_ (let () (declare (not safe)) (##length _g304181_))))
        (cond ((let () (declare (not safe)) (##fx= _g304180_ 3))
               (apply table-set! _g304181_))
              ((let () (declare (not safe)) (##fx= _g304180_ 4))
               (apply std/misc/hash#hash-ref-set!__1 _g304181_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/hash#hash-ref-set!
                _g304181_)))))))
