(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/misc/process#check-process-success
    (lambda (_exit-status231161_ _settings231162_)
      (if (zero? _exit-status231161_)
          '#!void
          (error '"Process exited with non-zero status"
                 _exit-status231161_
                 _settings231162_))))
  (define std/misc/process#run-process__%
    (lambda (_g303097_
             _coprocess231088231099_
             _check-status231089231101_
             _environment231090231103_
             _directory231091231105_
             _stdin-redirection231092231107_
             _stdout-redirection231093231109_
             _stderr-redirection231094231111_
             _pseudo-terminal231095231113_
             _show-console231096231115_
             _command231117_)
      (let* ((_coprocess231119_
              (if (eq? _coprocess231088231099_ absent-value)
                  std/misc/ports#read-all-as-string
                  _coprocess231088231099_))
             (_check-status231121_
              (if (eq? _check-status231089231101_ absent-value)
                  '#t
                  _check-status231089231101_))
             (_environment231123_
              (if (eq? _environment231090231103_ absent-value)
                  '#f
                  _environment231090231103_))
             (_directory231125_
              (if (eq? _directory231091231105_ absent-value)
                  '#f
                  _directory231091231105_))
             (_stdin-redirection231127_
              (if (eq? _stdin-redirection231092231107_ absent-value)
                  '#t
                  _stdin-redirection231092231107_))
             (_stdout-redirection231129_
              (if (eq? _stdout-redirection231093231109_ absent-value)
                  '#t
                  _stdout-redirection231093231109_))
             (_stderr-redirection231131_
              (if (eq? _stderr-redirection231094231111_ absent-value)
                  '#f
                  _stderr-redirection231094231111_))
             (_pseudo-terminal231133_
              (if (eq? _pseudo-terminal231095231113_ absent-value)
                  '#f
                  _pseudo-terminal231095231113_))
             (_show-console231135_
              (if (eq? _show-console231096231115_ absent-value)
                  '#f
                  _show-console231096231115_))
             (_settings231137_
              (cons 'path:
                    (cons (car _command231117_)
                          (cons 'arguments:
                                (cons (cdr _command231117_)
                                      (cons 'environment:
                                            (cons _environment231123_
                                                  (cons 'directory:
                                                        (cons _directory231125_
                                                              (cons 'stdin-redirection:
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            (cons _stdin-redirection231127_
                                  (cons 'stdout-redirection:
                                        (cons _stdout-redirection231129_
                                              (cons 'stderr-redirection:
                                                    (cons _stderr-redirection231131_
                                                          (cons 'pseudo-terminal:
                                                                (cons _pseudo-terminal231133_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              (cons 'show-console:
                                    (cons _show-console231135_
                                          '())))))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
             (_process231139_ (open-process _settings231137_)))
        (with-unwind-protect
         (lambda ()
           (letrec* ((_result231143_ (_coprocess231119_ _process231139_))
                     (_status231144_ (process-status _process231139_)))
             (if _check-status231121_
                 ((if (procedure? _check-status231121_)
                      _check-status231121_
                      std/misc/process#check-process-success)
                  _status231144_
                  _settings231137_)
                 '#!void)
             _result231143_))
         (lambda ()
           (close-port _process231139_)
           (process-status _process231139_))))))
  (define std/misc/process#run-process__@
    (lambda (_keys231087231150_ . _args231152_)
      (apply std/misc/process#run-process__%
             _keys231087231150_
             (table-ref _keys231087231150_ 'coprocess: absent-value)
             (table-ref _keys231087231150_ 'check-status: absent-value)
             (table-ref _keys231087231150_ 'environment: absent-value)
             (table-ref _keys231087231150_ 'directory: absent-value)
             (table-ref _keys231087231150_ 'stdin-redirection: absent-value)
             (table-ref _keys231087231150_ 'stdout-redirection: absent-value)
             (table-ref _keys231087231150_ 'stderr-redirection: absent-value)
             (table-ref _keys231087231150_ 'pseudo-terminal: absent-value)
             (table-ref _keys231087231150_ 'show-console: absent-value)
             _args231152_)))
  (define std/misc/process#run-process
    (lambda _args231097231158_
      (apply keyword-dispatch
             '#(stdout-redirection:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                stdin-redirection:
                #f
                #f
                #f
                #f
                #f
                stderr-redirection:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                directory:
                environment:
                pseudo-terminal:
                #f
                #f
                #f
                #f
                #f
                show-console:
                #f
                #f
                #f
                #f
                #f
                #f
                coprocess:
                #f
                #f
                #f
                #f
                #f
                check-status:
                #f
                #f)
             std/misc/process#run-process__@
             _args231097231158_)))
  (define std/misc/process#run-process/batch__%
    (lambda (_g303098_
             _check-status231048231054_
             _environment231049231056_
             _directory231050231058_
             _show-console231051231060_
             _command231062_)
      (let* ((_check-status231064_
              (if (eq? _check-status231048231054_ absent-value)
                  '#t
                  _check-status231048231054_))
             (_environment231066_
              (if (eq? _environment231049231056_ absent-value)
                  '#f
                  _environment231049231056_))
             (_directory231068_
              (if (eq? _directory231050231058_ absent-value)
                  '#f
                  _directory231050231058_))
             (_show-console231070_
              (if (eq? _show-console231051231060_ absent-value)
                  '#f
                  _show-console231051231060_)))
        (std/misc/process#run-process__%
         '#f
         close-output-port
         _check-status231064_
         _environment231066_
         _directory231068_
         absent-value
         '#f
         absent-value
         absent-value
         _show-console231070_
         _command231062_)
        '#!void)))
  (define std/misc/process#run-process/batch__@
    (lambda (_keys231047231075_ . _args231077_)
      (apply std/misc/process#run-process/batch__%
             _keys231047231075_
             (table-ref _keys231047231075_ 'check-status: absent-value)
             (table-ref _keys231047231075_ 'environment: absent-value)
             (table-ref _keys231047231075_ 'directory: absent-value)
             (table-ref _keys231047231075_ 'show-console: absent-value)
             _args231077_)))
  (define std/misc/process#run-process/batch
    (lambda _args231052231083_
      (apply keyword-dispatch
             '#(#f
                #f
                show-console:
                directory:
                environment:
                #f
                check-status:
                #f
                #f)
             std/misc/process#run-process/batch__@
             _args231052231083_))))
