(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/net/bio/file#file-input-buffer::t
    (make-struct-type
     'std/net/bio/file#file-input-buffer::t
     std/net/bio/input#input-buffer::t
     '1
     'file-input-buffer
     '((final: . #t))
     '#f
     '(fd)))
  (define std/net/bio/file#file-input-buffer?
    (make-struct-predicate std/net/bio/file#file-input-buffer::t))
  (define std/net/bio/file#make-file-input-buffer
    (lambda _$args179470_
      (apply make-struct-instance
             std/net/bio/file#file-input-buffer::t
             _$args179470_)))
  (define std/net/bio/file#file-input-buffer-fd
    (make-struct-field-accessor std/net/bio/file#file-input-buffer::t '0))
  (define std/net/bio/file#file-input-buffer-fd-set!
    (make-struct-field-mutator std/net/bio/file#file-input-buffer::t '0))
  (define std/net/bio/file#&file-input-buffer-fd
    (make-struct-field-unchecked-accessor
     std/net/bio/file#file-input-buffer::t
     '0))
  (define std/net/bio/file#&file-input-buffer-fd-set!
    (make-struct-field-unchecked-mutator
     std/net/bio/file#file-input-buffer::t
     '0))
  (define std/net/bio/file#open-file-input-buffer__%
    (lambda (_path179457_ _bufsz179458_)
      (std/net/bio/file#open-fd-input-buffer__%
       (std/os/fdio#open__0 _path179457_ std/os/fcntl#O_RDONLY)
       _bufsz179458_)))
  (define std/net/bio/file#open-file-input-buffer__0
    (lambda (_path179463_)
      (let ((_bufsz179465_ '4096))
        (std/net/bio/file#open-file-input-buffer__%
         _path179463_
         _bufsz179465_))))
  (define std/net/bio/file#open-file-input-buffer
    (lambda _g301108_
      (let ((_g301107_ (##length _g301108_)))
        (cond ((##fx= _g301107_ 1)
               (apply std/net/bio/file#open-file-input-buffer__0 _g301108_))
              ((##fx= _g301107_ 2)
               (apply std/net/bio/file#open-file-input-buffer__% _g301108_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/bio/file#open-file-input-buffer
                _g301108_))))))
  (define std/net/bio/file#open-fd-input-buffer__%
    (lambda (_fd179443_ _bufsz179444_)
      (##structure
       std/net/bio/file#file-input-buffer::t
       (make-u8vector _bufsz179444_)
       '0
       '0
       std/net/bio/file#file-input-fill!
       std/net/bio/file#file-input-read
       _fd179443_)))
  (define std/net/bio/file#open-fd-input-buffer__0
    (lambda (_fd179449_)
      (let ((_bufsz179451_ '4096))
        (std/net/bio/file#open-fd-input-buffer__% _fd179449_ _bufsz179451_))))
  (define std/net/bio/file#open-fd-input-buffer
    (lambda _g301110_
      (let ((_g301109_ (##length _g301110_)))
        (cond ((##fx= _g301109_ 1)
               (apply std/net/bio/file#open-fd-input-buffer__0 _g301110_))
              ((##fx= _g301109_ 2)
               (apply std/net/bio/file#open-fd-input-buffer__% _g301110_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/bio/file#open-fd-input-buffer
                _g301110_))))))
  (define std/net/bio/file#close-file-input-buffer
    (lambda (_buf179433_)
      (let ((_$e179435_
             (##unchecked-structure-ref
              _buf179433_
              '6
              std/net/bio/file#file-input-buffer::t
              '#f)))
        (if _$e179435_
            ((lambda (_fd179438_)
               (std/os/fdio#close _fd179438_)
               (##unchecked-structure-set!
                _buf179433_
                '#f
                '6
                std/net/bio/file#file-input-buffer::t
                '#f)
               (##unchecked-structure-set!
                _buf179433_
                (lambda _g301111_ '0)
                '4
                std/net/bio/input#input-buffer::t
                '#f)
               (##unchecked-structure-set!
                _buf179433_
                (lambda _g301112_ '0)
                '5
                std/net/bio/input#input-buffer::t
                '#f))
             _$e179435_)
            '#!void))))
  (define std/net/bio/file#file-input-fill!
    (lambda (_buf179414_ _need179415_)
      (let ((_bytes179417_
             (##unchecked-structure-ref
              _buf179414_
              '1
              std/net/bio/input#input-buffer::t
              '#f))
            (_rlo179418_
             (##unchecked-structure-ref
              _buf179414_
              '2
              std/net/bio/input#input-buffer::t
              '#f))
            (_rhi179419_
             (##unchecked-structure-ref
              _buf179414_
              '3
              std/net/bio/input#input-buffer::t
              '#f)))
        (if (##fx> _rlo179418_ '0)
            (if (##fx= _rlo179418_ _rhi179419_)
                (begin
                  (##unchecked-structure-set!
                   _buf179414_
                   '0
                   '2
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (##unchecked-structure-set!
                   _buf179414_
                   '0
                   '3
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (std/net/bio/file#file-input-fill! _buf179414_ _need179415_))
                (begin
                  (##subu8vector-move!
                   _bytes179417_
                   _rlo179418_
                   _rhi179419_
                   _bytes179417_
                   '0)
                  (##unchecked-structure-set!
                   _buf179414_
                   '0
                   '2
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (##unchecked-structure-set!
                   _buf179414_
                   (##fx- _rhi179419_ _rlo179418_)
                   '3
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (std/net/bio/file#file-input-fill!
                   _buf179414_
                   _need179415_)))
            (let ((_fd179421_
                   (##unchecked-structure-ref
                    _buf179414_
                    '6
                    std/net/bio/file#file-input-buffer::t
                    '#f)))
              (let _lp179423_ ((_rhi179425_ _rhi179419_)
                               (_want179426_ (##fx- _need179415_ _rhi179419_))
                               (_count179427_ '0))
                (let ((_rd179429_
                       (std/os/fdio#fdread__%
                        _fd179421_
                        _bytes179417_
                        _rhi179425_
                        (##u8vector-length _bytes179417_))))
                  (if _rd179429_
                      (let ((_rhi+rd179431_ (##fx+ _rhi179425_ _rd179429_)))
                        (##unchecked-structure-set!
                         _buf179414_
                         _rhi+rd179431_
                         '3
                         std/net/bio/input#input-buffer::t
                         '#f)
                        (if (##fx< _rd179429_ _want179426_)
                            (if (##fx> _rd179429_ '0)
                                (_lp179423_
                                 _rhi+rd179431_
                                 (##fx- _want179426_ _rd179429_)
                                 (##fx+ _count179427_ _rd179429_))
                                _count179427_)
                            (##fx+ _count179427_ _rd179429_)))
                      (begin
                        (if (std/os/fd#fd? _fd179421_)
                            (##wait-for-io!
                             (std/os/fd#fd-io-in _fd179421_)
                             '#t)
                            '#!void)
                        (_lp179423_
                         _rhi179425_
                         _want179426_
                         _count179427_))))))))))
  (define std/net/bio/file#file-input-read
    (lambda (_bytes179400_ _start179401_ _end179402_ _buf179403_)
      (let ((_fd179405_
             (##unchecked-structure-ref
              _buf179403_
              '6
              std/net/bio/file#file-input-buffer::t
              '#f)))
        (let _lp179407_ ((_count179409_ '0) (_start179410_ _start179401_))
          (if (##fx>= _start179410_ _end179402_)
              _count179409_
              (let ((_r179412_
                     (std/os/fdio#fdread__%
                      _fd179405_
                      _bytes179400_
                      _start179410_
                      _end179402_)))
                (if (not _r179412_)
                    (begin
                      (if (std/os/fd#fd? _fd179405_)
                          (##wait-for-io! (std/os/fd#fd-io-in _fd179405_) '#t)
                          '#!void)
                      (_lp179407_ _count179409_ _start179410_))
                    (if (##fxzero? _r179412_)
                        _count179409_
                        (_lp179407_
                         (##fx+ _count179409_ _r179412_)
                         (##fx+ _start179410_ _r179412_))))))))))
  (define std/net/bio/file#file-output-buffer::t
    (make-struct-type
     'std/net/bio/file#file-output-buffer::t
     std/net/bio/output#output-buffer::t
     '1
     'file-output-buffer
     '((final: . #t))
     '#f
     '(fd)))
  (define std/net/bio/file#file-output-buffer?
    (make-struct-predicate std/net/bio/file#file-output-buffer::t))
  (define std/net/bio/file#make-file-output-buffer
    (lambda _$args179397_
      (apply make-struct-instance
             std/net/bio/file#file-output-buffer::t
             _$args179397_)))
  (define std/net/bio/file#file-output-buffer-fd
    (make-struct-field-accessor std/net/bio/file#file-output-buffer::t '0))
  (define std/net/bio/file#file-output-buffer-fd-set!
    (make-struct-field-mutator std/net/bio/file#file-output-buffer::t '0))
  (define std/net/bio/file#&file-output-buffer-fd
    (make-struct-field-unchecked-accessor
     std/net/bio/file#file-output-buffer::t
     '0))
  (define std/net/bio/file#&file-output-buffer-fd-set!
    (make-struct-field-unchecked-mutator
     std/net/bio/file#file-output-buffer::t
     '0))
  (define std/net/bio/file#open-file-output-buffer__%__%
    (lambda (__179351179354_
             _flags179348179356_
             _mode179349179358_
             _path179360_
             _bufsz179361_)
      (let* ((_flags179363_
              (if (eq? _flags179348179356_ absent-value)
                  (fxior std/os/fcntl#O_WRONLY
                         std/os/fcntl#O_CREAT
                         std/os/fcntl#O_EXCL)
                  _flags179348179356_))
             (_mode179365_
              (if (eq? _mode179349179358_ absent-value)
                  '384
                  _mode179349179358_)))
        (std/net/bio/file#open-fd-output-buffer__%
         (std/os/fdio#open__% _path179360_ _flags179363_ _mode179365_)
         _bufsz179361_))))
  (define std/net/bio/file#open-file-output-buffer__%__0
    (lambda (__179351179370_
             _flags179348179371_
             _mode179349179372_
             _path179373_)
      (let ((_bufsz179375_ '4096))
        (std/net/bio/file#open-file-output-buffer__%__%
         __179351179370_
         _flags179348179371_
         _mode179349179372_
         _path179373_
         _bufsz179375_))))
  (define std/net/bio/file#open-file-output-buffer__%
    (lambda _g301114_
      (let ((_g301113_ (##length _g301114_)))
        (cond ((##fx= _g301113_ 4)
               (apply std/net/bio/file#open-file-output-buffer__%__0
                      _g301114_))
              ((##fx= _g301113_ 5)
               (apply std/net/bio/file#open-file-output-buffer__%__%
                      _g301114_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/bio/file#open-file-output-buffer__%
                _g301114_))))))
  (define std/net/bio/file#open-file-output-buffer__@
    (lambda (_keys179347179386_ . _args179388_)
      (apply std/net/bio/file#open-file-output-buffer__%
             _keys179347179386_
             (table-ref _keys179347179386_ 'flags: absent-value)
             (table-ref _keys179347179386_ 'mode: absent-value)
             _args179388_)))
  (define std/net/bio/file#open-file-output-buffer
    (lambda _args179350179394_
      (apply keyword-dispatch
             '#(flags: mode: #f)
             std/net/bio/file#open-file-output-buffer__@
             _args179350179394_)))
  (define std/net/bio/file#open-fd-output-buffer__%
    (lambda (_fd179333_ _bufsz179334_)
      (##structure
       std/net/bio/file#file-output-buffer::t
       (make-u8vector _bufsz179334_)
       '0
       _bufsz179334_
       std/net/bio/file#file-output-drain!
       std/net/bio/file#file-output-write
       _fd179333_)))
  (define std/net/bio/file#open-fd-output-buffer__0
    (lambda (_fd179339_)
      (let ((_bufsz179341_ '4096))
        (std/net/bio/file#open-fd-output-buffer__% _fd179339_ _bufsz179341_))))
  (define std/net/bio/file#open-fd-output-buffer
    (lambda _g301116_
      (let ((_g301115_ (##length _g301116_)))
        (cond ((##fx= _g301115_ 1)
               (apply std/net/bio/file#open-fd-output-buffer__0 _g301116_))
              ((##fx= _g301115_ 2)
               (apply std/net/bio/file#open-fd-output-buffer__% _g301116_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/bio/file#open-fd-output-buffer
                _g301116_))))))
  (define std/net/bio/file#close-file-output-buffer
    (lambda (_buf179323_)
      (let ((_$e179325_
             (##unchecked-structure-ref
              _buf179323_
              '6
              std/net/bio/file#file-output-buffer::t
              '#f)))
        (if _$e179325_
            ((lambda (_fd179328_)
               (std/os/fdio#close _fd179328_)
               (##unchecked-structure-set!
                _buf179323_
                '#f
                '6
                std/net/bio/file#file-output-buffer::t
                '#f)
               (##unchecked-structure-set!
                _buf179323_
                (lambda _g301117_ (error '"device is closed" _fd179328_))
                '4
                std/net/bio/output#output-buffer::t
                '#f)
               (##unchecked-structure-set!
                _buf179323_
                (lambda _g301118_ (error '"device is closed" _fd179328_))
                '5
                std/net/bio/output#output-buffer::t
                '#f))
             _$e179325_)
            '#!void))))
  (define std/net/bio/file#file-output-drain!
    (lambda (_buf179320_ _need179321_)
      (std/net/bio/file#file-output-write
       (##unchecked-structure-ref
        _buf179320_
        '1
        std/net/bio/output#output-buffer::t
        '#f)
       '0
       (##unchecked-structure-ref
        _buf179320_
        '2
        std/net/bio/output#output-buffer::t
        '#f)
       _buf179320_)
      (##unchecked-structure-set!
       _buf179320_
       '0
       '2
       std/net/bio/output#output-buffer::t
       '#f)))
  (define std/net/bio/file#file-output-write
    (lambda (_bytes179306_ _start179307_ _end179308_ _buf179309_)
      (let ((_fd179311_
             (##unchecked-structure-ref
              _buf179309_
              '6
              std/net/bio/file#file-output-buffer::t
              '#f)))
        (let _lp179313_ ((_count179315_ '0) (_start179316_ _start179307_))
          (if (##fx< _start179316_ _end179308_)
              (let ((_r179318_
                     (std/os/fdio#fdwrite__%
                      _fd179311_
                      _bytes179306_
                      _start179316_
                      _end179308_)))
                (if _r179318_
                    (_lp179313_
                     (##fx+ _count179315_ _r179318_)
                     (##fx+ _start179316_ _r179318_))
                    (begin
                      (if (std/os/fd#fd? _fd179311_)
                          (##wait-for-io! (std/os/fd#fd-io-out _fd179311_) '#t)
                          '#!void)
                      (_lp179313_ _count179315_ _start179316_))))
              _count179315_))))))
