(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/net/httpd/file#open-flags
    (if std/os/fcntl#O_NOATIME
        (fxior std/os/fcntl#O_RDONLY std/os/fcntl#O_NOATIME)
        std/os/fcntl#O_RDONLY))
  (define std/net/httpd/file#http-response-file
    (lambda (_res208020_ _headers208021_ _path208022_)
      (let ((_file208024_
             (std/os/fdio#open__0 _path208022_ std/net/httpd/file#open-flags)))
        (with-unwind-protect
         (lambda ()
           (std/net/httpd/file#http-response-write-file
            _res208020_
            _headers208021_
            _file208024_))
         (lambda () (close-port _file208024_))))))
  (define std/net/httpd/file#http-response-write-file
    (lambda (_res208009_ _headers208010_ _file208011_)
      (let ((_buf208013_ (std/net/httpd/file#get-file-buffer)))
        (std/net/httpd/handler#http-response-begin
         _res208009_
         '200
         _headers208010_)
        (let _lp208015_ ()
          (let ((_rd208018_ (std/os/fdio#fdread__0 _file208011_ _buf208013_)))
            (if (not _rd208018_)
                (begin
                  (std/event#wait__0 (std/os/fd#fd-io-in _file208011_))
                  (_lp208015_))
                (if (fx= _rd208018_ '0)
                    (begin
                      (std/net/httpd/file#put-file-buffer _buf208013_)
                      (std/net/httpd/handler#http-response-end _res208009_))
                    (begin
                      (std/net/httpd/handler#http-response-chunk__%
                       _res208009_
                       _buf208013_
                       '0
                       _rd208018_)
                      (_lp208015_)))))))))
  (define std/net/httpd/file#buffer-cache '())
  (define std/net/httpd/file#get-file-buffer
    (lambda ()
      (declare (not interrupts-enabled))
      (if (##pair? std/net/httpd/file#buffer-cache)
          (let ((_buf208007_ (##car std/net/httpd/file#buffer-cache)))
            (set! std/net/httpd/file#buffer-cache
                  (##cdr std/net/httpd/file#buffer-cache))
            _buf208007_)
          (make-u8vector '8192))))
  (define std/net/httpd/file#put-file-buffer
    (lambda (_buf208002_)
      (declare (not interrupts-enabled))
      (set! std/net/httpd/file#buffer-cache
            (##cons _buf208002_ std/net/httpd/file#buffer-cache)))))
