(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/socket/basic-server#errorf
    (lambda (_fmt203038_ . _args203039_)
      (std/logger#log-message 'socket '0 _fmt203038_ _args203039_)))
  (define std/net/socket/basic-server#warnf
    (lambda (_fmt203035_ . _args203036_)
      (std/logger#log-message 'socket '1 _fmt203035_ _args203036_)))
  (define std/net/socket/basic-server#infof
    (lambda (_fmt203032_ . _args203033_)
      (std/logger#log-message 'socket '2 _fmt203032_ _args203033_)))
  (define std/net/socket/basic-server#debugf
    (lambda (_fmt203029_ . _args203030_)
      (std/logger#log-message 'socket '3 _fmt203029_ _args203030_)))
  (define std/net/socket/basic-server#verbosef
    (lambda (_fmt203024_ . _args203026_)
      (std/logger#log-message 'socket '4 _fmt203024_ _args203026_)))
  (define std/net/socket/basic-server#!io-state:::init!
    (lambda (_self203022_)
      (if (let ((__tmp309517
                 (let () (declare (not safe)) (##vector-length _self203022_))))
            (declare (not safe))
            (##fx< '3 __tmp309517))
          (begin
            (let ()
              (declare (not safe))
              (##vector-set! _self203022_ '1 'blocked))
            (let ((__tmp309518 (make-mutex)))
              (declare (not safe))
              (##vector-set! _self203022_ '2 __tmp309518))
            (let ((__tmp309519 (make-condition-variable)))
              (declare (not safe))
              (##vector-set! _self203022_ '3 __tmp309519)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self203022_))))
  (bind-method!
   std/net/socket/base#!io-state::t
   ':init!
   std/net/socket/basic-server#!io-state:::init!
   '#f)
  (define std/net/socket/basic-server#server-poll
    (lambda (_server202888_ _io202889_)
      (let _lp202891_ ()
        (let () (declare (not safe)) (##wait-for-io! _io202889_ '#t))
        (let ((_token202894_
               (let ()
                 (declare (not safe))
                 (##structure std/actor/proto#!token::t)))
              (_dest202896_ _server202888_))
          (std/actor/message#send-message__%
           _dest202896_
           (let ((__tmp309520
                  (let ()
                    (declare (not safe))
                    (##structure std/net/socket/base#socket-server.poll::t))))
             (declare (not safe))
             (##structure std/actor/proto#!call::t __tmp309520 _token202894_))
           '#f
           '#t)
          (std/actor/proto#!!call-recv _token202894_ _dest202896_))
        (_lp202891_))))
  (define std/net/socket/basic-server#server-loop
    (lambda (_poll-io202634_
             _do-poll202635_
             _add-socket202636_
             _close-socket202637_
             _shutdown!202638_)
      (letrec* ((_poll-thread202640_
                 (if _poll-io202634_
                     (gerbil/gambit/threads#spawn/name
                      'server-poll
                      std/net/socket/basic-server#server-poll
                      (current-thread)
                      _poll-io202634_)
                     '#f)))
        (with-unwind-protect
         (lambda ()
           (with-exception-catcher
            (lambda (_g202641202644_)
              (if '#t
                  (let ((_e202647_ _g202641202644_))
                    (std/net/socket/basic-server#errorf
                     '"socket-server error: ~a"
                     _e202647_)
                    (_shutdown!202638_)
                    (raise _e202647_))
                  (raise _g202641202644_)))
            (lambda ()
              (let _loop202650_ ()
                (let _loop202652202654_ ()
                  (let ((_next202658_ (thread-mailbox-next)))
                    ((lambda (_$message202661_)
                       (let* ((_$message202663202673_ _$message202661_)
                              (_else202665202681_
                               (lambda () (_loop202652202654_)))
                              (_K202667202864_
                               (lambda (_$options202684_
                                        _$dest202686_
                                        _$source202688_
                                        _$value202690_)
                                 (let* ((_$value202712202737_ _$value202690_)
                                        (_else202718202745_
                                         (lambda () (_loop202652202654_))))
                                   (let ((_K202733202853_
                                          (lambda (_k202851_)
                                            (thread-mailbox-extract-and-rewind)
                                            (_do-poll202635_)
                                            (std/actor/message#send-message__%
                                             _$source202688_
                                             (let ()
                                               (declare (not safe))
                                               (##structure
                                                std/actor/proto#!value::t
                                                '#!void
                                                _k202851_))
                                             '#f
                                             '#f)
                                            (_loop202650_)))
                                         (_K202729202832_
                                          (lambda (_k202820_ _sock202821_)
                                            (thread-mailbox-extract-and-rewind)
                                            (with-exception-catcher
                                             (lambda (_g202822202824_)
                                               (if '#t
                                                   (let ((_e202827_
                                                          _g202822202824_))
                                                     (std/net/socket/basic-server#errorf
                                                      '"socket-server.add: ~a"
                                                      _e202827_)
                                                     (std/actor/message#send-message__%
                                                      _$source202688_
                                                      (let ()
                                                        (declare (not safe))
                                                        (##structure
                                                         std/actor/proto#!error::t
                                                         _e202827_
                                                         _k202820_))
                                                      '#f
                                                      '#f))
                                                   (raise _g202822202824_)))
                                             (lambda ()
                                               (let ((_ssock202830_
                                                      (_add-socket202636_
                                                       _sock202821_)))
                                                 (std/actor/message#send-message__%
                                                  _$source202688_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##structure
                                                     std/actor/proto#!value::t
                                                     _ssock202830_
                                                     _k202820_))
                                                  '#f
                                                  '#f))))
                                            (_loop202650_)))
                                         (_K202724202795_
                                          (lambda (_shutdown202784_
                                                   _dir202785_
                                                   _ssock202786_)
                                            (thread-mailbox-extract-and-rewind)
                                            (with-exception-catcher
                                             (lambda (_g202787202789_)
                                               (if '#t
                                                   (let ((_e202792_
                                                          _g202787202789_))
                                                     (std/net/socket/basic-server#errorf
                                                      '"socket-server.close: ~a"
                                                      _e202792_))
                                                   (raise _g202787202789_)))
                                             (lambda ()
                                               (_close-socket202637_
                                                _ssock202786_
                                                _dir202785_
                                                _shutdown202784_)))
                                            (_loop202650_)))
                                         (_K202721202769_
                                          (lambda (_k202760_)
                                            (thread-mailbox-extract-and-rewind)
                                            (with-exception-catcher
                                             (lambda (_g202761202763_)
                                               (if '#t
                                                   (let ((_e202766_
                                                          _g202761202763_))
                                                     (std/net/socket/basic-server#errorf
                                                      '"socket-server.shutdown!: ~a"
                                                      _e202766_)
                                                     (std/actor/message#send-message__%
                                                      _$source202688_
                                                      (let ()
                                                        (declare (not safe))
                                                        (##structure
                                                         std/actor/proto#!error::t
                                                         _e202766_
                                                         _k202760_))
                                                      '#f
                                                      '#f))
                                                   (raise _g202761202763_)))
                                             (lambda ()
                                               (_shutdown!202638_)
                                               (std/actor/message#send-message__%
                                                _$source202688_
                                                (let ()
                                                  (declare (not safe))
                                                  (##structure
                                                   std/actor/proto#!value::t
                                                   '#!void
                                                   _k202760_))
                                                '#f
                                                '#f)))))
                                         (_K202720202751_
                                          (lambda (_msg202749_)
                                            (thread-mailbox-extract-and-rewind)
                                            (std/net/socket/basic-server#warnf
                                             '"Unexpected message: ~a"
                                             _msg202749_)
                                            (_loop202650_))))
                                     (let ((_try-match202715202816_
                                            (lambda ()
                                              (if (let ()
                                                    (declare (not safe))
                                                    (##structure-direct-instance-of?
                                                     _$value202712202737_
                                                     'std/actor/proto#!event::t))
                                                  (let ((_e202725202798_
                                                         (let ()
                                                           (declare (not safe))
                                                           (##vector-ref
                                                            _$value202712202737_
                                                            '1))))
                                                    (if (let ()
                                                          (declare (not safe))
                                                          (##structure-direct-instance-of?
                                                           _e202725202798_
                                                           'std/net/socket/base#socket-server.close::t))
                                                        (let* ((_e202726202801_
                                                                (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (declare (not safe))
                          (##vector-ref _e202725202798_ '1)))
                       (_e202727202806_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _e202725202798_ '2)))
                       (_e202728202811_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _e202725202798_ '3))))
                  (let ((_ssock202804_ _e202726202801_)
                        (_dir202809_ _e202727202806_)
                        (_shutdown202814_ _e202728202811_))
                    (_K202724202795_
                     _shutdown202814_
                     _dir202809_
                     _ssock202804_)))
                (let ((_msg202754_ _$value202712202737_))
                  (_K202720202751_ _msg202754_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                  (let ((_msg202754_
                                                         _$value202712202737_))
                                                    (_K202720202751_
                                                     _msg202754_))))))
                                       (if (let ()
                                             (declare (not safe))
                                             (##structure-direct-instance-of?
                                              _$value202712202737_
                                              'std/actor/proto#!call::t))
                                           (let ((_e202734202856_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##vector-ref
                                                     _$value202712202737_
                                                     '1))))
                                             (if (let ()
                                                   (declare (not safe))
                                                   (##structure-direct-instance-of?
                                                    _e202734202856_
                                                    'std/net/socket/base#socket-server.poll::t))
                                                 (let* ((_e202735202859_
                                                         (let ()
                                                           (declare (not safe))
                                                           (##vector-ref
                                                            _$value202712202737_
                                                            '2)))
                                                        (_k202862_
                                                         _e202735202859_))
                                                   (_K202733202853_ _k202862_))
                                                 (if (let ()
                                                       (declare (not safe))
                                                       (##structure-direct-instance-of?
                                                        _e202734202856_
                                                        'std/net/socket/base#socket-server.add::t))
                                                     (let* ((_e202732202838_
                                                             (let ()
                                                               (declare
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (not safe))
                       (##vector-ref _e202734202856_ '1)))
                    (_e202731202843_
                     (let ()
                       (declare (not safe))
                       (##vector-ref _$value202712202737_ '2))))
               (let ((_sock202841_ _e202732202838_)
                     (_k202846_ _e202731202843_))
                 (_K202729202832_ _k202846_ _sock202841_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (if (let ()
                                                           (declare (not safe))
                                                           (##structure-direct-instance-of?
                                                            _e202734202856_
                                                            'std/net/socket/base#socket-server.shutdown!::t))
                                                         (let* ((_e202723202775_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (let ()
                           (declare (not safe))
                           (##vector-ref _$value202712202737_ '2)))
                        (_k202778_ _e202723202775_))
                   (_K202721202769_ _k202778_))
                 (let ((_msg202754_ _$value202712202737_))
                   (_K202720202751_ _msg202754_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                           (_try-match202715202816_))))))))
                         (if (let ()
                               (declare (not safe))
                               (##structure-direct-instance-of?
                                _$message202663202673_
                                'std/actor/message#message::t))
                             (let* ((_e202668202867_
                                     (let ()
                                       (declare (not safe))
                                       (##vector-ref
                                        _$message202663202673_
                                        '1)))
                                    (_$value202870_ _e202668202867_)
                                    (_e202669202872_
                                     (let ()
                                       (declare (not safe))
                                       (##vector-ref
                                        _$message202663202673_
                                        '2)))
                                    (_$source202875_ _e202669202872_)
                                    (_e202670202877_
                                     (let ()
                                       (declare (not safe))
                                       (##vector-ref
                                        _$message202663202673_
                                        '3)))
                                    (_$dest202880_ _e202670202877_)
                                    (_e202671202882_
                                     (let ()
                                       (declare (not safe))
                                       (##vector-ref
                                        _$message202663202673_
                                        '4)))
                                    (_$options202885_ _e202671202882_))
                               (_K202667202864_
                                _$options202885_
                                _$dest202880_
                                _$source202875_
                                _$value202870_))
                             (_loop202652202654_))))
                     _next202658_)))))))
         (lambda ()
           (if _poll-thread202640_
               (thread-terminate! _poll-thread202640_)
               '#!void))))))
  (define std/net/socket/basic-server#io-state-signal-ready!
    (lambda (_iostate202598_ _how202599_)
      (let* ((_iostate202600202608_ _iostate202598_)
             (_E202602202612_
              (lambda () (error '"No clause matching" _iostate202600202608_)))
             (_K202603202618_
              (lambda (_cv202615_ _mx202616_)
                (mutex-lock! _mx202616_)
                (##direct-structure-set!
                 _iostate202598_
                 _how202599_
                 '1
                 std/net/socket/base#!io-state::t
                 '#f)
                (condition-variable-broadcast! _cv202615_)
                (mutex-unlock! _mx202616_))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _iostate202600202608_
               'std/net/socket/base#!io-state::t))
            (let* ((_e202604202621_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _iostate202600202608_ '1)))
                   (_e202605202624_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _iostate202600202608_ '2)))
                   (_mx202627_ _e202605202624_)
                   (_e202606202629_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _iostate202600202608_ '3)))
                   (_cv202632_ _e202606202629_))
              (_K202603202618_ _cv202632_ _mx202627_))
            (_E202602202612_)))))
  (define std/net/socket/basic-server#io-state-wait-io!
    (lambda (_iostate202552_ _timeo202553_ _how202554_)
      (let* ((_iostate202555202563_ _iostate202552_)
             (_E202557202567_
              (lambda () (error '"No clause matching" _iostate202555202563_)))
             (_K202558202582_
              (lambda (_cv202570_ _mx202571_)
                (let _lp202573_ ()
                  (mutex-lock! _mx202571_)
                  (let ((_$e202576_
                         (##direct-structure-ref
                          _iostate202552_
                          '1
                          std/net/socket/base#!io-state::t
                          '#f)))
                    (if (eq? 'closed _$e202576_)
                        (begin
                          (mutex-unlock! _mx202571_)
                          (error '"Socket direction has been closed"
                                 _how202554_))
                        (if (eq? 'ready _$e202576_)
                            (begin
                              (##direct-structure-set!
                               _iostate202552_
                               _how202554_
                               '1
                               std/net/socket/base#!io-state::t
                               '#f)
                              (mutex-unlock! _mx202571_)
                              '#!void)
                            (begin
                              (##direct-structure-set!
                               _iostate202552_
                               'blocked
                               '1
                               std/net/socket/base#!io-state::t
                               '#f)
                              (if (mutex-unlock!
                                   _mx202571_
                                   _cv202570_
                                   (or _timeo202553_ absent-obj))
                                  (_lp202573_)
                                  '#f)))))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _iostate202555202563_
               'std/net/socket/base#!io-state::t))
            (let* ((_e202559202585_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _iostate202555202563_ '1)))
                   (_e202560202588_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _iostate202555202563_ '2)))
                   (_mx202591_ _e202560202588_)
                   (_e202561202593_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _iostate202555202563_ '3)))
                   (_cv202596_ _e202561202593_))
              (_K202558202582_ _cv202596_ _mx202591_))
            (_E202557202567_)))))
  (define std/net/socket/basic-server#io-state-close-in!
    (lambda (_iostate202548_ _sock202549_ _shutdown202550_)
      (if _shutdown202550_
          (std/net/socket/basic-server#shutdown-socket!
           _sock202549_
           _shutdown202550_)
          (close-input-port _sock202549_))
      (std/net/socket/basic-server#io-state-signal-ready!
       _iostate202548_
       'closed)))
  (define std/net/socket/basic-server#io-state-close-out!
    (lambda (_iostate202544_ _sock202545_ _shutdown202546_)
      (if _shutdown202546_
          (std/net/socket/basic-server#shutdown-socket!
           _sock202545_
           _shutdown202546_)
          (close-output-port _sock202545_))
      (std/net/socket/basic-server#io-state-signal-ready!
       _iostate202544_
       'closed)))
  (define std/net/socket/basic-server#shutdown-socket!
    (lambda (_sock202534_ _how202535_)
      (with-exception-catcher
       (lambda (_g202536202538_)
         (if '#t
             (let ((_e202541_ _g202536202538_))
               (std/net/socket/basic-server#errorf
                '"socket-server.shutdown-socket!: ~a"
                _e202541_))
             (raise _g202536202538_)))
       (lambda () (std/os/socket#socket-shutdown _sock202534_ _how202535_))))))
