(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/net/socket/buffer#default-buffer-size '4096)
  (define std/net/socket/buffer#ssocket-input-buffer::t
    (make-struct-type
     'std/net/socket/buffer#ssocket-input-buffer::t
     std/net/bio/input#input-buffer::t
     '2
     'ssocket-input-buffer
     '((final: . #t))
     '#f
     '(sock timeo)))
  (define std/net/socket/buffer#ssocket-input-buffer?
    (make-struct-predicate std/net/socket/buffer#ssocket-input-buffer::t))
  (define std/net/socket/buffer#make-ssocket-input-buffer
    (lambda _$args202530_
      (apply make-struct-instance
             std/net/socket/buffer#ssocket-input-buffer::t
             _$args202530_)))
  (define std/net/socket/buffer#ssocket-input-buffer-sock
    (make-struct-field-accessor
     std/net/socket/buffer#ssocket-input-buffer::t
     '0))
  (define std/net/socket/buffer#ssocket-input-buffer-timeo
    (make-struct-field-accessor
     std/net/socket/buffer#ssocket-input-buffer::t
     '1))
  (define std/net/socket/buffer#ssocket-input-buffer-sock-set!
    (make-struct-field-mutator
     std/net/socket/buffer#ssocket-input-buffer::t
     '0))
  (define std/net/socket/buffer#ssocket-input-buffer-timeo-set!
    (make-struct-field-mutator
     std/net/socket/buffer#ssocket-input-buffer::t
     '1))
  (define std/net/socket/buffer#&ssocket-input-buffer-sock
    (make-struct-field-unchecked-accessor
     std/net/socket/buffer#ssocket-input-buffer::t
     '0))
  (define std/net/socket/buffer#&ssocket-input-buffer-timeo
    (make-struct-field-unchecked-accessor
     std/net/socket/buffer#ssocket-input-buffer::t
     '1))
  (define std/net/socket/buffer#&ssocket-input-buffer-sock-set!
    (make-struct-field-unchecked-mutator
     std/net/socket/buffer#ssocket-input-buffer::t
     '0))
  (define std/net/socket/buffer#&ssocket-input-buffer-timeo-set!
    (make-struct-field-unchecked-mutator
     std/net/socket/buffer#ssocket-input-buffer::t
     '1))
  (define std/net/socket/buffer#open-ssocket-input-buffer__%
    (lambda (_ssock202517_ _size202518_)
      (##structure
       std/net/socket/buffer#ssocket-input-buffer::t
       (make-u8vector _size202518_)
       '0
       '0
       std/net/socket/buffer#ssocket-input-fill!
       std/net/socket/buffer#ssocket-input-read
       _ssock202517_
       '#f)))
  (define std/net/socket/buffer#open-ssocket-input-buffer__0
    (lambda (_ssock202523_)
      (let ((_size202525_ std/net/socket/buffer#default-buffer-size))
        (std/net/socket/buffer#open-ssocket-input-buffer__%
         _ssock202523_
         _size202525_))))
  (define std/net/socket/buffer#open-ssocket-input-buffer
    (lambda _g309457_
      (let ((_g309456_ (##length _g309457_)))
        (cond ((##fx= _g309456_ 1)
               (apply std/net/socket/buffer#open-ssocket-input-buffer__0
                      _g309457_))
              ((##fx= _g309456_ 2)
               (apply std/net/socket/buffer#open-ssocket-input-buffer__%
                      _g309457_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/buffer#open-ssocket-input-buffer
                _g309457_))))))
  (define std/net/socket/buffer#ssocket-input-fill!
    (lambda (_buf202495_ _need202496_)
      (let ((_bytes202498_
             (##unchecked-structure-ref
              _buf202495_
              '1
              std/net/bio/input#input-buffer::t
              '#f))
            (_rlo202499_
             (##unchecked-structure-ref
              _buf202495_
              '2
              std/net/bio/input#input-buffer::t
              '#f))
            (_rhi202500_
             (##unchecked-structure-ref
              _buf202495_
              '3
              std/net/bio/input#input-buffer::t
              '#f)))
        (if (##fx> _rlo202499_ '0)
            (if (##fx= _rlo202499_ _rhi202500_)
                (begin
                  (##unchecked-structure-set!
                   _buf202495_
                   '0
                   '2
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (##unchecked-structure-set!
                   _buf202495_
                   '0
                   '3
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (std/net/socket/buffer#ssocket-input-fill!
                   _buf202495_
                   _need202496_))
                (begin
                  (##subu8vector-move!
                   _bytes202498_
                   _rlo202499_
                   _rhi202500_
                   _bytes202498_
                   '0)
                  (##unchecked-structure-set!
                   _buf202495_
                   '0
                   '2
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (##unchecked-structure-set!
                   _buf202495_
                   (##fx- _rhi202500_ _rlo202499_)
                   '3
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (std/net/socket/buffer#ssocket-input-fill!
                   _buf202495_
                   _need202496_)))
            (let ((_sock202502_
                   (##unchecked-structure-ref
                    _buf202495_
                    '6
                    std/net/socket/buffer#ssocket-input-buffer::t
                    '#f))
                  (_timeo202503_
                   (##unchecked-structure-ref
                    _buf202495_
                    '7
                    std/net/socket/buffer#ssocket-input-buffer::t
                    '#f)))
              (let _lp202505_ ((_rhi202507_ _rhi202500_)
                               (_want202508_ (##fx- _need202496_ _rhi202500_))
                               (_count202509_ '0))
                (let* ((_rd202511_
                        (std/net/socket/api#ssocket-recv__%
                         _sock202502_
                         _bytes202498_
                         _rhi202507_
                         (##u8vector-length _bytes202498_)
                         _timeo202503_))
                       (_rhi+rd202513_ (##fx+ _rhi202507_ _rd202511_)))
                  (##unchecked-structure-set!
                   _buf202495_
                   _rhi+rd202513_
                   '3
                   std/net/bio/input#input-buffer::t
                   '#f)
                  (if (##fx< _rd202511_ _want202508_)
                      (if (##fx> _rd202511_ '0)
                          (_lp202505_
                           _rhi+rd202513_
                           (##fx- _want202508_ _rd202511_)
                           (##fx+ _count202509_ _rd202511_))
                          _count202509_)
                      (##fx+ _count202509_ _rd202511_)))))))))
  (define std/net/socket/buffer#ssocket-input-read
    (lambda (_bytes202490_ _start202491_ _end202492_ _buf202493_)
      (std/net/socket/api#ssocket-recv-all__%
       (##unchecked-structure-ref
        _buf202493_
        '6
        std/net/socket/buffer#ssocket-input-buffer::t
        '#f)
       _bytes202490_
       _start202491_
       _end202492_
       (##unchecked-structure-ref
        _buf202493_
        '7
        std/net/socket/buffer#ssocket-input-buffer::t
        '#f))))
  (define std/net/socket/buffer#ssocket-input-buffer-timeout-set!
    (lambda (_buf202485_ _timeo202486_)
      (let ((_timeo202488_ (std/net/socket/base#abs-timeout _timeo202486_)))
        (##direct-structure-set!
         _buf202485_
         _timeo202488_
         '7
         std/net/socket/buffer#ssocket-input-buffer::t
         '#f))))
  (define std/net/socket/buffer#ssocket-output-buffer::t
    (make-struct-type
     'std/net/socket/buffer#ssocket-output-buffer::t
     std/net/bio/output#output-buffer::t
     '2
     'ssocket-output-buffer
     '((final: . #t))
     '#f
     '(sock timeo)))
  (define std/net/socket/buffer#ssocket-output-buffer?
    (make-struct-predicate std/net/socket/buffer#ssocket-output-buffer::t))
  (define std/net/socket/buffer#make-ssocket-output-buffer
    (lambda _$args202482_
      (apply make-struct-instance
             std/net/socket/buffer#ssocket-output-buffer::t
             _$args202482_)))
  (define std/net/socket/buffer#ssocket-output-buffer-sock
    (make-struct-field-accessor
     std/net/socket/buffer#ssocket-output-buffer::t
     '0))
  (define std/net/socket/buffer#ssocket-output-buffer-timeo
    (make-struct-field-accessor
     std/net/socket/buffer#ssocket-output-buffer::t
     '1))
  (define std/net/socket/buffer#ssocket-output-buffer-sock-set!
    (make-struct-field-mutator
     std/net/socket/buffer#ssocket-output-buffer::t
     '0))
  (define std/net/socket/buffer#ssocket-output-buffer-timeo-set!
    (make-struct-field-mutator
     std/net/socket/buffer#ssocket-output-buffer::t
     '1))
  (define std/net/socket/buffer#&ssocket-output-buffer-sock
    (make-struct-field-unchecked-accessor
     std/net/socket/buffer#ssocket-output-buffer::t
     '0))
  (define std/net/socket/buffer#&ssocket-output-buffer-timeo
    (make-struct-field-unchecked-accessor
     std/net/socket/buffer#ssocket-output-buffer::t
     '1))
  (define std/net/socket/buffer#&ssocket-output-buffer-sock-set!
    (make-struct-field-unchecked-mutator
     std/net/socket/buffer#ssocket-output-buffer::t
     '0))
  (define std/net/socket/buffer#&ssocket-output-buffer-timeo-set!
    (make-struct-field-unchecked-mutator
     std/net/socket/buffer#ssocket-output-buffer::t
     '1))
  (define std/net/socket/buffer#open-ssocket-output-buffer__%
    (lambda (_ssock202469_ _size202470_)
      (##structure
       std/net/socket/buffer#ssocket-output-buffer::t
       (make-u8vector _size202470_)
       '0
       _size202470_
       std/net/socket/buffer#ssocket-output-drain!
       std/net/socket/buffer#ssocket-output-write
       _ssock202469_
       '#f)))
  (define std/net/socket/buffer#open-ssocket-output-buffer__0
    (lambda (_ssock202475_)
      (let ((_size202477_ std/net/socket/buffer#default-buffer-size))
        (std/net/socket/buffer#open-ssocket-output-buffer__%
         _ssock202475_
         _size202477_))))
  (define std/net/socket/buffer#open-ssocket-output-buffer
    (lambda _g309459_
      (let ((_g309458_ (##length _g309459_)))
        (cond ((##fx= _g309458_ 1)
               (apply std/net/socket/buffer#open-ssocket-output-buffer__0
                      _g309459_))
              ((##fx= _g309458_ 2)
               (apply std/net/socket/buffer#open-ssocket-output-buffer__%
                      _g309459_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socket/buffer#open-ssocket-output-buffer
                _g309459_))))))
  (define std/net/socket/buffer#ssocket-output-drain!
    (lambda (_buf202465_ _need202466_)
      (std/net/socket/api#ssocket-send-all__%
       (##unchecked-structure-ref
        _buf202465_
        '6
        std/net/socket/buffer#ssocket-output-buffer::t
        '#f)
       (##unchecked-structure-ref
        _buf202465_
        '1
        std/net/bio/output#output-buffer::t
        '#f)
       '0
       (##unchecked-structure-ref
        _buf202465_
        '2
        std/net/bio/output#output-buffer::t
        '#f)
       (##unchecked-structure-ref
        _buf202465_
        '7
        std/net/socket/buffer#ssocket-output-buffer::t
        '#f))
      (##unchecked-structure-set!
       _buf202465_
       '0
       '2
       std/net/bio/output#output-buffer::t
       '#f)))
  (define std/net/socket/buffer#ssocket-output-write
    (lambda (_bytes202460_ _start202461_ _end202462_ _buf202463_)
      (std/net/socket/api#ssocket-send-all__%
       (##unchecked-structure-ref
        _buf202463_
        '6
        std/net/socket/buffer#ssocket-output-buffer::t
        '#f)
       _bytes202460_
       _start202461_
       _end202462_
       (##unchecked-structure-ref
        _buf202463_
        '7
        std/net/socket/buffer#ssocket-output-buffer::t
        '#f))))
  (define std/net/socket/buffer#ssocket-output-buffer-timeout-set!
    (lambda (_buf202455_ _timeo202456_)
      (let ((_timeo202458_ (std/net/socket/base#abs-timeout _timeo202456_)))
        (##direct-structure-set!
         _buf202455_
         _timeo202458_
         '7
         std/net/socket/buffer#ssocket-output-buffer::t
         '#f))))
  (define std/net/socket/buffer#ssocket-input-buffer-reset!
    (lambda (_buf202452_ _sock202453_)
      (##unchecked-structure-set!
       _buf202452_
       '0
       '2
       std/net/bio/input#input-buffer::t
       '#f)
      (##unchecked-structure-set!
       _buf202452_
       '0
       '3
       std/net/bio/input#input-buffer::t
       '#f)
      (##unchecked-structure-set!
       _buf202452_
       _sock202453_
       '6
       std/net/socket/buffer#ssocket-input-buffer::t
       '#f)
      (##unchecked-structure-set!
       _buf202452_
       '#f
       '7
       std/net/socket/buffer#ssocket-input-buffer::t
       '#f)))
  (define std/net/socket/buffer#ssocket-input-buffer-release!
    (lambda (_buf202450_)
      (##unchecked-structure-set!
       _buf202450_
       '#f
       '6
       std/net/socket/buffer#ssocket-input-buffer::t
       '#f)))
  (define std/net/socket/buffer#ssocket-output-buffer-reset!
    (lambda (_buf202447_ _sock202448_)
      (##unchecked-structure-set!
       _buf202447_
       '0
       '2
       std/net/bio/output#output-buffer::t
       '#f)
      (##unchecked-structure-set!
       _buf202447_
       (u8vector-length
        (##unchecked-structure-ref
         _buf202447_
         '1
         std/net/bio/output#output-buffer::t
         '#f))
       '3
       std/net/bio/output#output-buffer::t
       '#f)
      (##unchecked-structure-set!
       _buf202447_
       _sock202448_
       '6
       std/net/socket/buffer#ssocket-output-buffer::t
       '#f)
      (##unchecked-structure-set!
       _buf202447_
       '#f
       '7
       std/net/socket/buffer#ssocket-output-buffer::t
       '#f)))
  (define std/net/socket/buffer#ssocket-output-buffer-release!
    (lambda (_buf202445_)
      (##unchecked-structure-set!
       _buf202445_
       '#f
       '6
       std/net/socket/buffer#ssocket-output-buffer::t
       '#f))))
