(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/uri#uri-unreserved-chars
    '"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-._~")
  (define std/net/uri#uri-gendelim-chars '":/?#[]@")
  (define std/net/uri#uri-subdelim-chars '"!$&'()*+,;=")
  (define std/net/uri#make-uri-encoding-table__%
    (lambda (_self-chars171775_ _sub-chars171776_)
      (let ((_vt171778_ (make-vector '256 '#f))
            (_len171779_ (string-length _self-chars171775_)))
        (let _lp171781_ ((_n171783_ '0))
          (if (let () (declare (not safe)) (##fx< _n171783_ _len171779_))
              (let ((_char171785_
                     (let ()
                       (declare (not safe))
                       (##string-ref _self-chars171775_ _n171783_))))
                (vector-set!
                 _vt171778_
                 (char->integer _char171785_)
                 _char171785_)
                (_lp171781_
                 (let () (declare (not safe)) (##fx+ _n171783_ '1))))
              '#!void))
        (for-each
         (lambda (_e171786171788_)
           (let* ((_g171790171797_ _e171786171788_)
                  (_E171792171801_
                   (lambda () (error '"No clause matching" _g171790171797_)))
                  (_K171793171807_
                   (lambda (_sub171804_ _char171805_)
                     (vector-set!
                      _vt171778_
                      (char->integer _char171805_)
                      _sub171804_))))
             (if (let () (declare (not safe)) (##pair? _g171790171797_))
                 (let ((_hd171794171810_
                        (let () (declare (not safe)) (##car _g171790171797_)))
                       (_tl171795171812_
                        (let () (declare (not safe)) (##cdr _g171790171797_))))
                   (let* ((_char171815_ _hd171794171810_)
                          (_sub171817_ _tl171795171812_))
                     (_K171793171807_ _sub171817_ _char171815_)))
                 (_E171792171801_))))
         _sub-chars171776_)
        _vt171778_)))
  (define std/net/uri#make-uri-encoding-table__0
    (lambda (_self-chars171822_)
      (let ((_sub-chars171824_ '()))
        (std/net/uri#make-uri-encoding-table__%
         _self-chars171822_
         _sub-chars171824_))))
  (define std/net/uri#make-uri-encoding-table
    (lambda _g290331_
      (let ((_g290330_ (let () (declare (not safe)) (##length _g290331_))))
        (cond ((let () (declare (not safe)) (##fx= _g290330_ 1))
               (apply std/net/uri#make-uri-encoding-table__0 _g290331_))
              ((let () (declare (not safe)) (##fx= _g290330_ 2))
               (apply std/net/uri#make-uri-encoding-table__% _g290331_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/uri#make-uri-encoding-table
                _g290331_))))))
  (define std/net/uri#uri-encoding
    (std/net/uri#make-uri-encoding-table__0 std/net/uri#uri-unreserved-chars))
  (define std/net/uri#uri-space-encoding
    (std/net/uri#make-uri-encoding-table__%
     std/net/uri#uri-unreserved-chars
     '((#\space . #\+))))
  (define std/net/uri#uri-encode__%
    (lambda (_str171760_ _vt171761_)
      (if (and (vector? _vt171761_)
               (let ((__tmp290332 (vector-length _vt171761_)))
                 (declare (not safe))
                 (##fx= __tmp290332 '256)))
          '#!void
          (error '"Bad encoding table" _vt171761_))
      (with-output-to-string
       '()
       (lambda () (std/net/uri#write-uri-encoded _str171760_ _vt171761_)))))
  (define std/net/uri#uri-encode__0
    (lambda (_str171767_)
      (let ((_vt171769_ std/net/uri#uri-encoding))
        (std/net/uri#uri-encode__% _str171767_ _vt171769_))))
  (define std/net/uri#uri-encode
    (lambda _g290334_
      (let ((_g290333_ (let () (declare (not safe)) (##length _g290334_))))
        (cond ((let () (declare (not safe)) (##fx= _g290333_ 1))
               (apply std/net/uri#uri-encode__0 _g290334_))
              ((let () (declare (not safe)) (##fx= _g290333_ 2))
               (apply std/net/uri#uri-encode__% _g290334_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/uri#uri-encode
                _g290334_))))))
  (define std/net/uri#form-url-encode__%
    (lambda (_fields171672_ _+space?171673_)
      (letrec* ((_encoding171675_
                 (if _+space?171673_
                     std/net/uri#uri-space-encoding
                     std/net/uri#uri-encoding))
                (_encode-field171676_
                 (lambda (_field171719_)
                   (let* ((_field171720171727_ _field171719_)
                          (_E171722171731_
                           (lambda ()
                             (error '"No clause matching"
                                    _field171720171727_)))
                          (_K171723171737_
                           (lambda (_val171734_ _key171735_)
                             (std/net/uri#write-uri-encoded
                              _key171735_
                              _encoding171675_)
                             (if _val171734_
                                 (begin
                                   (write-char '#\=)
                                   (std/net/uri#write-uri-encoded
                                    _val171734_
                                    _encoding171675_))
                                 '#!void))))
                     (if (let ()
                           (declare (not safe))
                           (##pair? _field171720171727_))
                         (let ((_hd171724171740_
                                (let ()
                                  (declare (not safe))
                                  (##car _field171720171727_)))
                               (_tl171725171742_
                                (let ()
                                  (declare (not safe))
                                  (##cdr _field171720171727_))))
                           (let* ((_key171745_ _hd171724171740_)
                                  (_val171747_ _tl171725171742_))
                             (_K171723171737_ _val171747_ _key171745_)))
                         (_E171722171731_))))))
        (let* ((_fields171677171686_ _fields171672_)
               (_E171680171690_
                (lambda ()
                  (error '"No clause matching" _fields171677171686_))))
          (let ((_K171682171707_
                 (lambda (_rest171701_ _first171702_)
                   (with-output-to-string
                    '()
                    (lambda ()
                      (_encode-field171676_ _first171702_)
                      (for-each
                       (lambda (_field171705_)
                         (write-char '#\&)
                         (_encode-field171676_ _field171705_))
                       _rest171701_)))))
                (_K171681171695_ (lambda () '"")))
            (let ((_try-match171679171698_
                   (lambda ()
                     (if (let ()
                           (declare (not safe))
                           (##null? _fields171677171686_))
                         (_K171681171695_)
                         (_E171680171690_)))))
              (if (let () (declare (not safe)) (##pair? _fields171677171686_))
                  (let ((_tl171684171712_
                         (let ()
                           (declare (not safe))
                           (##cdr _fields171677171686_)))
                        (_hd171683171710_
                         (let ()
                           (declare (not safe))
                           (##car _fields171677171686_))))
                    (let ((_first171715_ _hd171683171710_)
                          (_rest171717_ _tl171684171712_))
                      (_K171682171707_ _rest171717_ _first171715_)))
                  (_try-match171679171698_))))))))
  (define std/net/uri#form-url-encode__0
    (lambda (_fields171752_)
      (let ((_+space?171754_ '#t))
        (std/net/uri#form-url-encode__% _fields171752_ _+space?171754_))))
  (define std/net/uri#form-url-encode
    (lambda _g290336_
      (let ((_g290335_ (let () (declare (not safe)) (##length _g290336_))))
        (cond ((let () (declare (not safe)) (##fx= _g290335_ 1))
               (apply std/net/uri#form-url-encode__0 _g290336_))
              ((let () (declare (not safe)) (##fx= _g290335_ 2))
               (apply std/net/uri#form-url-encode__% _g290336_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/uri#form-url-encode
                _g290336_))))))
  (define std/net/uri#write-uri-encoded
    (lambda (_str171650_ _encoding171651_)
      (letrec ((_write-hex171653_
                (lambda (_n171669_)
                  (write-char
                   (let ()
                     (declare (not safe))
                     (##string-ref '"0123456789ABCDEF" _n171669_))))))
        (let* ((_utf8171655_ (std/text/utf8#string->utf8__0 _str171650_))
               (_len171657_ (u8vector-length _utf8171655_)))
          (let _lp171660_ ((_n171662_ '0))
            (if (let () (declare (not safe)) (##fx< _n171662_ _len171657_))
                (let ((_byte171664_
                       (let ()
                         (declare (not safe))
                         (##u8vector-ref _utf8171655_ _n171662_))))
                  (let ((_$e171666_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _encoding171651_ _byte171664_))))
                    (if _$e171666_
                        (write-char _$e171666_)
                        (begin
                          (write-char '#\%)
                          (_write-hex171653_
                           (let ((__tmp290337
                                  (let ()
                                    (declare (not safe))
                                    (##fxarithmetic-shift _byte171664_ '-4))))
                             (declare (not safe))
                             (##fxand __tmp290337 '15)))
                          (_write-hex171653_
                           (let ()
                             (declare (not safe))
                             (##fxand _byte171664_ '15))))))
                  (_lp171660_
                   (let () (declare (not safe)) (##fx+ _n171662_ '1))))
                '#!void))))))
  (define std/net/uri#hex-bytes
    (let ((_ht171644_ (make-table 'test: eq?)))
      (for-each
       (lambda (_n171646_)
         (let ((_char171648_
                (let ()
                  (declare (not safe))
                  (##string-ref '"0123456789ABCDEF" _n171646_))))
           (table-set! _ht171644_ _char171648_ _n171646_)
           (table-set! _ht171644_ (char-downcase _char171648_) _n171646_)))
       (iota '16))
      _ht171644_))
  (define std/net/uri#uri-decode__%
    (lambda (_str171598_ _encoding171599_)
      (letrec ((_hex-byte171601_
                (lambda (_byte171627_)
                  (let* ((_char171629_ (integer->char _byte171627_))
                         (_$e171631_
                          (table-ref std/net/uri#hex-bytes _char171629_ '#f)))
                    (if _$e171631_
                        (values _$e171631_)
                        (error '"Malformed uri encoding" _char171629_))))))
        (if _encoding171599_
            (if (and (vector? _encoding171599_)
                     (let ((__tmp290338 (vector-length _encoding171599_)))
                       (declare (not safe))
                       (##fx= __tmp290338 '256)))
                '#!void
                (error '"Bad encoding table" _encoding171599_))
            '#!void)
        (let* ((_utf8171603_ (std/text/utf8#string->utf8__0 _str171598_))
               (_len171605_ (u8vector-length _utf8171603_))
               (_pct171607_ (char->integer '#\%)))
          (std/text/utf8#utf8->string__0
           (with-output-to-u8vector
            '()
            (lambda ()
              (let _lp171611_ ((_n171613_ '0))
                (if (let () (declare (not safe)) (##fx< _n171613_ _len171605_))
                    (let* ((_next171615_
                            (let ()
                              (declare (not safe))
                              (##u8vector-ref _utf8171603_ _n171613_)))
                           (_$e171617_
                            (if _encoding171599_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref _encoding171599_ _next171615_))
                                '#f)))
                      (if _$e171617_
                          ((lambda (_char171620_)
                             (write-char _char171620_)
                             (_lp171611_
                              (let ()
                                (declare (not safe))
                                (##fx+ _n171613_ '1))))
                           _$e171617_)
                          (if (eq? _next171615_ _pct171607_)
                              (let ((_n171622_
                                     (let ()
                                       (declare (not safe))
                                       (##fx+ _n171613_ '1))))
                                (if (let ((__tmp290339
                                           (let ()
                                             (declare (not safe))
                                             (##fx+ _n171622_ '1))))
                                      (declare (not safe))
                                      (##fx< __tmp290339 _len171605_))
                                    (let ((_hi171624_
                                           (let ()
                                             (declare (not safe))
                                             (##u8vector-ref
                                              _utf8171603_
                                              _n171622_)))
                                          (_lo171625_
                                           (let ((__tmp290340
                                                  (let ()
                                                    (declare (not safe))
                                                    (##fx+ _n171622_ '1))))
                                             (declare (not safe))
                                             (##u8vector-ref
                                              _utf8171603_
                                              __tmp290340))))
                                      (write-u8
                                       (let ((__tmp290342
                                              (let ((__tmp290343
                                                     (_hex-byte171601_
                                                      _hi171624_)))
                                                (declare (not safe))
                                                (##fxarithmetic-shift
                                                 __tmp290343
                                                 '4)))
                                             (__tmp290341
                                              (_hex-byte171601_ _lo171625_)))
                                         (declare (not safe))
                                         (##fxior __tmp290342 __tmp290341)))
                                      (_lp171611_
                                       (let ()
                                         (declare (not safe))
                                         (##fx+ _n171622_ '2))))
                                    (error '"Malformed uri component")))
                              (begin
                                (write-u8 _next171615_)
                                (_lp171611_
                                 (let ()
                                   (declare (not safe))
                                   (##fx+ _n171613_ '1)))))))
                    '#!void)))))))))
  (define std/net/uri#uri-decode__0
    (lambda (_str171637_)
      (let ((_encoding171639_ '#f))
        (std/net/uri#uri-decode__% _str171637_ _encoding171639_))))
  (define std/net/uri#uri-decode
    (lambda _g290345_
      (let ((_g290344_ (let () (declare (not safe)) (##length _g290345_))))
        (cond ((let () (declare (not safe)) (##fx= _g290344_ 1))
               (apply std/net/uri#uri-decode__0 _g290345_))
              ((let () (declare (not safe)) (##fx= _g290344_ 2))
               (apply std/net/uri#uri-decode__% _g290345_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/uri#uri-decode
                _g290345_))))))
  (define std/net/uri#uri-space-decoding
    (std/net/uri#make-uri-encoding-table__% '"" '((#\+ . #\space))))
  (define std/net/uri#form-url-decode
    (lambda (_str171533_)
      (filter-map1
       (lambda (_part171535_)
         (if (not (string-empty? _part171535_))
             (let* ((_g171536171550_ (string-split _part171535_ '#\=))
                    (_else171539171558_
                     (lambda ()
                       (error '"Malformed form component" _part171535_))))
               (let ((_K171544171580_
                      (lambda (_val171577_ _key171578_)
                        (cons (std/net/uri#uri-decode__%
                               _key171578_
                               std/net/uri#uri-space-decoding)
                              (std/net/uri#uri-decode__%
                               _val171577_
                               std/net/uri#uri-space-decoding))))
                     (_K171541171564_
                      (lambda (_key171562_)
                        (cons (std/net/uri#uri-decode__%
                               _key171562_
                               std/net/uri#uri-space-decoding)
                              '#f))))
                 (if (let () (declare (not safe)) (##pair? _g171536171550_))
                     (let ((_tl171546171585_
                            (let ()
                              (declare (not safe))
                              (##cdr _g171536171550_)))
                           (_hd171545171583_
                            (let ()
                              (declare (not safe))
                              (##car _g171536171550_))))
                       (if (let ()
                             (declare (not safe))
                             (##pair? _tl171546171585_))
                           (let ((_tl171548171592_
                                  (let ()
                                    (declare (not safe))
                                    (##cdr _tl171546171585_)))
                                 (_hd171547171590_
                                  (let ()
                                    (declare (not safe))
                                    (##car _tl171546171585_))))
                             (if (let ()
                                   (declare (not safe))
                                   (##null? _tl171548171592_))
                                 (let ((_key171588_ _hd171545171583_)
                                       (_val171595_ _hd171547171590_))
                                   (_K171544171580_ _val171595_ _key171588_))
                                 (_else171539171558_)))
                           (if (let ()
                                 (declare (not safe))
                                 (##null? _tl171546171585_))
                               (let ((_key171572_ _hd171545171583_))
                                 (_K171541171564_ _key171572_))
                               (_else171539171558_))))
                     (_else171539171558_))))
             '#f))
       (string-split _str171533_ '#\&)))))
