(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/os/fd#open-raw-device
    (lambda (_direction178624_ _id178625_ _fd178626_)
      (letrec ((_fail178628_
                (lambda ()
                  (let ()
                    (declare (not safe))
                    (##fail-check-settings
                     '1
                     std/os/fd#open-raw-device
                     _direction178624_
                     _id178625_
                     _fd178626_)))))
        (let ((__tmp290346
               (lambda (_psettings178630_)
                 (let ((_device178632_
                        (let ((__tmp290347
                               (let ()
                                 (declare (not safe))
                                 (##psettings->device-flags
                                  _psettings178630_))))
                          (declare (not safe))
                          (##os-device-open-raw-from-fd
                           _fd178626_
                           __tmp290347))))
                   (if (let () (declare (not safe)) (##fixnum? _device178632_))
                       (let ()
                         (declare (not safe))
                         (##raise-os-exception
                          '#f
                          _device178632_
                          std/os/fd#open-raw-device
                          _direction178624_
                          _id178625_
                          _fd178626_))
                       (let ((__tmp290348
                              (cons _id178625_ (cons _fd178626_ '()))))
                         (declare (not safe))
                         (##make-raw-device-port
                          _direction178624_
                          _device178632_
                          _id178625_
                          __tmp290348
                          _fd178626_)))))))
          (declare (not safe))
          (##make-psettings
           _direction178624_
           '()
           '()
           _fail178628_
           __tmp290346)))))
  (define std/os/fd#direction
    (lambda (_dir178619_)
      (let ((_$e178621_ _dir178619_))
        (if (eq? 'in _$e178621_)
            (macro-direction-in)
            (if (eq? 'out _$e178621_)
                (macro-direction-out)
                (if (eq? 'inout _$e178621_)
                    (macro-direction-inout)
                    (error '"Bad direction; must be in, out, or inout"
                           _dir178619_)))))))
  (define std/os/fd#fdopen
    (lambda (_fd178613_ _dir178614_ _t178615_)
      (let ((_dirx178617_ (std/os/fd#direction _dir178614_)))
        (std/os/fd#open-raw-device _dirx178617_ _t178615_ _fd178613_))))
  (define std/os/fd#fdopen-port
    (lambda (_fd178607_ _dir178608_ _name178609_)
      (let ((_dirx178611_ (std/os/fd#direction _dir178608_)))
        (declare (not safe))
        (##open-predefined _dirx178611_ _name178609_ _fd178607_))))
  (define std/os/fd#fd-e
    (lambda (_raw178605_)
      (values (macro-raw-device-port-specific _raw178605_))))
  (define std/os/fd#fd-io-in
    (lambda (_raw178603_)
      (values (macro-raw-device-port-rdevice-condvar _raw178603_))))
  (define std/os/fd#fd-io-out
    (lambda (_raw178601_)
      (values (macro-raw-device-port-wdevice-condvar _raw178601_))))
  (define std/os/fd#fd-type
    (lambda (_raw178599_) (values (macro-raw-device-port-type _raw178599_))))
  (define std/os/fd#fd?
    (lambda (_obj178597_) (values (macro-raw-device-port? _obj178597_))))
  (define std/os/fd#fd-type?
    (lambda (_obj178594_ _t178595_)
      (if (macro-raw-device-port? _obj178594_)
          (eq? (std/os/fd#fd-type _obj178594_) _t178595_)
          '#f))))
