(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/os/inotify#inotify-event::t
    (make-struct-type
     'std/os/inotify#inotify-event::t
     '#f
     '4
     'inotify-event
     '((final: . #t))
     '#f
     '(wd mask cookie name)))
  (define std/os/inotify#inotify-event?
    (make-struct-predicate std/os/inotify#inotify-event::t))
  (define std/os/inotify#make-inotify-event
    (lambda _$args199511_
      (apply make-struct-instance
             std/os/inotify#inotify-event::t
             _$args199511_)))
  (define std/os/inotify#inotify-event-wd
    (make-struct-field-accessor std/os/inotify#inotify-event::t '0))
  (define std/os/inotify#inotify-event-mask
    (make-struct-field-accessor std/os/inotify#inotify-event::t '1))
  (define std/os/inotify#inotify-event-cookie
    (make-struct-field-accessor std/os/inotify#inotify-event::t '2))
  (define std/os/inotify#inotify-event-name
    (make-struct-field-accessor std/os/inotify#inotify-event::t '3))
  (define std/os/inotify#inotify-event-wd-set!
    (make-struct-field-mutator std/os/inotify#inotify-event::t '0))
  (define std/os/inotify#inotify-event-mask-set!
    (make-struct-field-mutator std/os/inotify#inotify-event::t '1))
  (define std/os/inotify#inotify-event-cookie-set!
    (make-struct-field-mutator std/os/inotify#inotify-event::t '2))
  (define std/os/inotify#inotify-event-name-set!
    (make-struct-field-mutator std/os/inotify#inotify-event::t '3))
  (define std/os/inotify#inotify-init
    (lambda ()
      (let ((_fd199509_
             (let ((_r199506_ (std/os/inotify#_inotify_init)))
               (if (not (let ()
                          (declare (not safe))
                          (##fxnegative? _r199506_)))
                   _r199506_
                   (std/os/error#raise-os-error
                    (let () (declare (not safe)) (##fx- _r199506_))
                    std/os/inotify#inotify-init)))))
        (std/os/fd#fdopen _fd199509_ 'in 'inotify))))
  (define std/os/inotify#inotify?
    (lambda (_obj199503_) (std/os/fd#fd-type? _obj199503_ 'inotify)))
  (define std/os/inotify#inotify-close
    (lambda (_in199501_) (close-port _in199501_)))
  (define std/os/inotify#inotify-add-watch
    (lambda (_in199494_ _path199495_ _mask199496_)
      (let ((_r199498_
             (std/os/inotify#_inotify_add_watch
              (std/os/fd#fd-e _in199494_)
              _path199495_
              _mask199496_)))
        (if (not (let () (declare (not safe)) (##fxnegative? _r199498_)))
            _r199498_
            (std/os/error#raise-os-error
             (let () (declare (not safe)) (##fx- _r199498_))
             std/os/inotify#inotify-add-watch
             _in199494_
             _path199495_
             _mask199496_)))))
  (define std/os/inotify#inotify-rm-watch
    (lambda (_in199488_ _wd199489_)
      (let ((_r199491_
             (std/os/inotify#_inotify_rm_watch
              (std/os/fd#fd-e _in199488_)
              _wd199489_)))
        (if (not (let () (declare (not safe)) (##fxnegative? _r199491_)))
            _r199491_
            (std/os/error#raise-os-error
             (let () (declare (not safe)) (##fx- _r199491_))
             std/os/inotify#inotify-rm-watch
             _in199488_
             _wd199489_)))))
  (define std/os/inotify#inotify__%
    (lambda (_in199465_ _timeo199466_)
      (let* ((_timeo199468_
              (std/misc/timeout#make-timeout__% _timeo199466_ '#t))
             (_buf199470_ (std/os/inotify#get-buffer)))
        (let _lp199473_ ()
          (let ((_rd199476_ (std/os/fdio#fdread__0 _in199465_ _buf199470_)))
            (if _rd199476_
                (if (let () (declare (not safe)) (##fxzero? _rd199476_))
                    (error '"empty inotify read")
                    (std/os/inotify#inotify-events _buf199470_ _rd199476_))
                (if (let ((__tmp301076 (std/os/fd#fd-io-in _in199465_)))
                      (declare (not safe))
                      (##wait-for-io! __tmp301076 _timeo199468_))
                    (_lp199473_)
                    '#f)))))))
  (define std/os/inotify#inotify__0
    (lambda (_in199481_)
      (let ((_timeo199483_ '#f))
        (std/os/inotify#inotify__% _in199481_ _timeo199483_))))
  (define std/os/inotify#inotify
    (lambda _g301078_
      (let ((_g301077_ (let () (declare (not safe)) (##length _g301078_))))
        (cond ((let () (declare (not safe)) (##fx= _g301077_ 1))
               (apply std/os/inotify#inotify__0 _g301078_))
              ((let () (declare (not safe)) (##fx= _g301077_ 2))
               (apply std/os/inotify#inotify__% _g301078_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/inotify#inotify
                _g301078_))))))
  (define std/os/inotify#inotify-events
    (lambda (_buf199450_ _rd199451_)
      (let _lp199453_ ((_off199455_ '0) (_evts199456_ '()))
        (if (let () (declare (not safe)) (##fx< _off199455_ _rd199451_))
            (let ((_wd199458_
                   (std/os/inotify#inotify_event_wd _buf199450_ _off199455_))
                  (_mask199459_
                   (std/os/inotify#inotify_event_mask _buf199450_ _off199455_))
                  (_cookie199460_
                   (std/os/inotify#inotify_event_cookie
                    _buf199450_
                    _off199455_))
                  (_name199461_
                   (std/os/inotify#inotify_event_name _buf199450_ _off199455_))
                  (_sz199462_
                   (std/os/inotify#inotify_event_size
                    _buf199450_
                    _off199455_)))
              (_lp199453_
               (let () (declare (not safe)) (##fx+ _off199455_ _sz199462_))
               (cons (let ()
                       (declare (not safe))
                       (##structure
                        std/os/inotify#inotify-event::t
                        _wd199458_
                        _mask199459_
                        _cookie199460_
                        _name199461_))
                     _evts199456_)))
            (reverse _evts199456_)))))
  (define std/os/inotify#buffer-key 'std/os/inotify#buffer)
  (define std/os/inotify#get-buffer
    (lambda ()
      (let ((_$e199445_
             (gerbil/gambit/threads#thread-local-get
              std/os/inotify#buffer-key)))
        (if _$e199445_
            (values _$e199445_)
            (let ((_buf199448_ (make-u8vector '4096)))
              (gerbil/gambit/threads#thread-local-set!
               std/os/inotify#buffer-key
               _buf199448_)
              _buf199448_)))))
  (define-macro (define-guard guard defn)
    (if (eval `(cond-expand (,guard #t) (else #f)))
        '(begin)
        (begin (eval `(define-cond-expand-feature ,guard)) defn)))
  (define-macro (define-c-lambda id args ret #!optional (name #f))
    (let ((name (or name (symbol->string id))))
      `(define ,id (c-lambda ,args ,ret ,name))))
  (define-macro (define-const symbol)
    (let* ((str (symbol->string symbol))
           (ref (string-append "___return (" str ");")))
      `(define ,symbol ((c-lambda () int ,ref)))))
  (define-macro (define-const* symbol #!optional (ccond #f))
    (let* ((str (symbol->string symbol))
           (code (string-append
                  "#if "
                  (or ccond (string-append "defined(" str ")"))
                  "\n"
                  "___return (___FIX ("
                  str
                  "));\n"
                  "#else \n"
                  "___return (___FAL);\n"
                  "#endif")))
      `(define ,symbol ((c-lambda () scheme-object ,code)))))
  (define-macro (define-with-errno symbol ffi-symbol args)
    `(define (,symbol ,@args)
       (declare (not interrupts-enabled))
       (let ((r (,ffi-symbol ,@args)))
         (if (##fx< r 0) (##fx- (##c-code "___RESULT = ___FIX (errno);")) r))))
  (define-macro (define-c-struct
                 struct
                 #!optional
                 (members '())
                 release-function)
    (let* ((struct-str (symbol->string struct))
           (struct-ptr (string->symbol (string-append struct-str "*")))
           (shallow-ptr
            (string->symbol (string-append struct-str "-shallow-ptr*")))
           (borrowed-ptr
            (string->symbol (string-append struct-str "-borrowed-ptr*")))
           (string-types
            '(char-string
              nonull-char-string
              UTF-8-string
              nonnull-UTF-8-string
              UTF-16-string
              nonnull-UTF16-string))
           (string-compat-required?
            (let loop ((m members))
              (cond ((null? m) #f)
                    ((member (cdr (car m)) string-types) #t)
                    (else (loop (cdr m))))))
           (string-setter-body
            (lambda (member-name)
              (let ((m (string-append "___arg1->" member-name)))
                (string-append
                 "if("
                 m
                 " == NULL)"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "else if (strcmp("
                 m
                 ", ___arg2) != 0) {"
                 "\n"
                 "free("
                 m
                 ");"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "}"
                 "\n"
                 "___return;"
                 "\n"))))
           (default-free-body
            (and string-compat-required?
                 (string-append
                  "___SCMOBJ "
                  struct-str
                  "_ffi_free (void *ptr) {"
                  "\n"
                  "struct "
                  struct-str
                  " *obj = (struct "
                  struct-str
                  "*) ptr;"
                  "\n"
                  (apply string-append
                         (map (lambda (m)
                                (cond ((memq (cdr m) string-types)
                                       (let ((mem-name
                                              (symbol->string (car m))))
                                         (string-append
                                          "if(obj->"
                                          mem-name
                                          ") "
                                          "free(obj->"
                                          mem-name
                                          ");"
                                          "\n")))
                                      (else "")))
                              members))
                  "free(obj);"
                  "\n"
                  "return ___FIX (___NO_ERR);"
                  "\n"
                  "}")))
           (release-function
            (or release-function
                (if string-compat-required?
                    (string-append struct-str "_ffi_free")
                    "ffi_free")))
           (string-compat-types
            (if string-compat-required?
                `((c-declare ,default-free-body)
                  (c-define-type
                   ,shallow-ptr
                   (pointer ,struct (,struct-ptr) "ffi_free")))
                '())))
      `(begin
         (c-define-type ,struct (struct ,struct-str))
         (c-define-type
          ,struct-ptr
          (pointer ,struct (,struct-ptr) ,release-function))
         (c-define-type ,borrowed-ptr (pointer ,struct (,struct-ptr)))
         ,@string-compat-types
         (define ,(string->symbol (string-append struct-str "-ptr?"))
           (lambda (obj)
             (and (foreign? obj) (equal? (foreign-tags obj) '(,struct-ptr)))))
         ,@(apply append
                  (map (lambda (m)
                         (let* ((member-name (symbol->string (car m)))
                                (member-type (cdr m))
                                (getter-name
                                 (string-append struct-str "-" member-name))
                                (setter-body
                                 (cond ((member member-type string-types)
                                        (string-setter-body member-name))
                                       (else
                                        (string-append
                                         "___arg1->"
                                         member-name
                                         " = ___arg2;"
                                         "\n"
                                         "___return;"
                                         "\n")))))
                           `((define ,(string->symbol getter-name)
                               (c-lambda
                                (,struct-ptr)
                                ,member-type
                                ,(string-append
                                  "___return(___arg1->"
                                  member-name
                                  ");")))
                             (define ,(string->symbol
                                       (string-append getter-name "-set!"))
                               (c-lambda
                                (,struct-ptr ,member-type)
                                void
                                ,setter-body)))))
                       members))
         (define ,(string->symbol (string-append "malloc-" struct-str))
           (c-lambda
            ()
            ,struct-ptr
            ,(string-append
              "struct "
              struct-str
              "* var = (struct "
              struct-str
              " *) malloc(sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(var, 0, sizeof(struct "
              struct-str
              "));"
              "___return(var);")))
         (define ,(string->symbol (string-append "ptr->" struct-str))
           (c-lambda (,struct-ptr) ,struct "___return(*___arg1);"))
         (define ,(string->symbol
                   (string-append "malloc-" struct-str "-array"))
           (c-lambda
            (unsigned-int32)
            ,(if string-compat-required? shallow-ptr struct-ptr)
            ,(string-append
              "struct "
              struct-str
              " *arr_var=(struct "
              struct-str
              " *) malloc(___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (arr_var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(arr_var, 0, ___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "___return(arr_var);")))
         (define ,(string->symbol (string-append struct-str "-array-ref"))
           (c-lambda
            (,struct-ptr unsigned-int32)
            ,borrowed-ptr
            "___return (___arg1 + ___arg2);"))
         (define ,(string->symbol (string-append struct-str "-array-set!"))
           (c-lambda
            (,struct-ptr unsigned-int32 ,struct-ptr)
            void
            "*(___arg1 + ___arg2) = *___arg3; ___return;")))))
  (c-declare "#include <stdlib.h>")
  (c-declare "#include <string.h>")
  (c-declare "#include <errno.h>")
  (c-declare "static ___SCMOBJ ffi_free (void *ptr);")
  (c-declare
   "#ifndef ___HAVE_FFI_U8VECTOR\n#define ___HAVE_FFI_U8VECTOR\n#define U8_DATA(obj) ___CAST (___U8*, ___BODY_AS (obj, ___tSUBTYPED))\n#define U8_LEN(obj) ___HD_BYTES (___HEADER (obj))\n#endif")
  (namespace
   ("std/os/inotify#"
    IN_UNMOUNT
    IN_Q_OVERFLOW
    IN_ISDIR
    IN_IGNORED
    IN_ONLYDIR
    IN_ONESHOT
    IN_MASK_ADD
    IN_EXCL_UNLINK
    IN_DONT_FOLLOW
    IN_CLOSE
    IN_MOVE
    IN_ALL_EVENTS
    IN_OPEN
    IN_MOVED_TO
    IN_MOVED_FROM
    IN_MOVE_SELF
    IN_MODIFY
    IN_DELETE_SELF
    IN_DELETE
    IN_CREATE
    IN_CLOSE_NOWRITE
    IN_CLOSE_WRITE
    IN_ATTRIB
    IN_ACCESS
    inotify_event_size
    inotify_event_name
    inotify_event_cookie
    inotify_event_mask
    inotify_event_wd
    _inotify_rm_watch
    _inotify_add_watch
    _inotify_init))
  (c-declare "#include <sys/inotify.h>")
  (define-macro (define-const-uint32 symbol)
    (let* ((str (symbol->string symbol))
           (ref (string-append "___return (" str ");")))
      `(define ,symbol ((c-lambda () unsigned-int32 ,ref)))))
  (namespace
   ("std/os/inotify#" __inotify_init __inotify_add_watch __inotify_rm_watch))
  (define-const-uint32 IN_ACCESS)
  (define-const-uint32 IN_ATTRIB)
  (define-const-uint32 IN_CLOSE_WRITE)
  (define-const-uint32 IN_CLOSE_NOWRITE)
  (define-const-uint32 IN_CREATE)
  (define-const-uint32 IN_DELETE)
  (define-const-uint32 IN_DELETE_SELF)
  (define-const-uint32 IN_MODIFY)
  (define-const-uint32 IN_MOVE_SELF)
  (define-const-uint32 IN_MOVED_FROM)
  (define-const-uint32 IN_MOVED_TO)
  (define-const-uint32 IN_OPEN)
  (define-const-uint32 IN_ALL_EVENTS)
  (define-const-uint32 IN_MOVE)
  (define-const-uint32 IN_CLOSE)
  (define-const-uint32 IN_DONT_FOLLOW)
  (define-const-uint32 IN_EXCL_UNLINK)
  (define-const-uint32 IN_MASK_ADD)
  (define-const-uint32 IN_ONESHOT)
  (define-const-uint32 IN_ONLYDIR)
  (define-const-uint32 IN_IGNORED)
  (define-const-uint32 IN_ISDIR)
  (define-const-uint32 IN_Q_OVERFLOW)
  (define-const-uint32 IN_UNMOUNT)
  (define-c-lambda
   __inotify_init
   ()
   int
   "___return (inotify_init1 (IN_NONBLOCK|IN_CLOEXEC));")
  (define-c-lambda
   __inotify_add_watch
   (int UTF-8-string int)
   int
   "inotify_add_watch")
  (define-c-lambda __inotify_rm_watch (int int) int "inotify_rm_watch")
  (define-with-errno _inotify_init __inotify_init ())
  (define-with-errno _inotify_add_watch __inotify_add_watch (fd path mask))
  (define-with-errno _inotify_rm_watch __inotify_rm_watch (fd wd))
  (c-declare "static int ffi_inotify_event_wd (___SCMOBJ buf, int off);")
  (c-declare
   "static uint32_t ffi_inotify_event_mask (___SCMOBJ buf, int off);")
  (c-declare
   "static uint32_t ffi_inotify_event_cookie (___SCMOBJ buf, int off);")
  (c-declare "static char *ffi_inotify_event_name (___SCMOBJ buf, int off);")
  (c-declare "static int ffi_inotify_event_size (___SCMOBJ buf, int off);")
  (define-c-lambda
   inotify_event_wd
   (scheme-object int)
   int
   "ffi_inotify_event_wd")
  (define-c-lambda
   inotify_event_mask
   (scheme-object int)
   unsigned-int32
   "ffi_inotify_event_mask")
  (define-c-lambda
   inotify_event_cookie
   (scheme-object int)
   unsigned-int32
   "ffi_inotify_event_cookie")
  (define-c-lambda
   inotify_event_name
   (scheme-object int)
   UTF-8-string
   "ffi_inotify_event_name")
  (define-c-lambda
   inotify_event_size
   (scheme-object int)
   int
   "ffi_inotify_event_size")
  (c-declare
   "int ffi_inotify_event_wd (___SCMOBJ buf, int off)\n{\n return ((struct inotify_event*)(U8_DATA (buf) + off))->wd;\n}\n\nuint32_t ffi_inotify_event_mask (___SCMOBJ buf, int off)\n{\n return ((struct inotify_event*)(U8_DATA (buf) + off))->mask;\n}\n\nuint32_t ffi_inotify_event_cookie (___SCMOBJ buf, int off)\n{\n return ((struct inotify_event*)(U8_DATA (buf) + off))->cookie;\n}\n\nchar *ffi_inotify_event_name (___SCMOBJ buf, int off)\n{\n struct inotify_event *ptr = (struct inotify_event*)(U8_DATA (buf) + off);\n if (ptr->len)\n  return ptr->name;\n return NULL;\n}\n\nint ffi_inotify_event_size (___SCMOBJ buf, int off)\n{\n return sizeof (struct inotify_event) + ((struct inotify_event*)(U8_DATA (buf) + off))->len;\n}")
  (c-declare
   "#ifndef ___HAVE_FFI_FREE\n#define ___HAVE_FFI_FREE\n___SCMOBJ ffi_free (void *ptr)\n{\n free (ptr);\n return ___FIX (___NO_ERR);\n}\n#endif"))
