(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/os/signalfd#signalfd
    (lambda (_sigset199555_)
      (let ((_fd199560_
             (let ((_r199557_
                    (std/os/signalfd#_signalfd
                     '-1
                     _sigset199555_
                     (let ()
                       (declare (not safe))
                       (##fxior std/os/signalfd#SFD_NONBLOCK
                                std/os/signalfd#SFD_CLOEXEC)))))
               (if (not (let ()
                          (declare (not safe))
                          (##fxnegative? _r199557_)))
                   _r199557_
                   (std/os/error#raise-os-error
                    (let () (declare (not safe)) (##fx- _r199557_))
                    std/os/signalfd#signalfd
                    _sigset199555_)))))
        (std/os/fd#fdopen _fd199560_ 'in 'signalfd))))
  (define std/os/signalfd#signalfd?
    (lambda (_obj199553_) (std/os/fd#fd-type? _obj199553_ 'signalfd)))
  (define std/os/signalfd#signalfd-reset!
    (lambda (_sfd199547_ _sigset199548_)
      (let ((_r199550_
             (std/os/signalfd#_signalfd
              (std/os/fd#fd-e _sfd199547_)
              _sigset199548_
              '0)))
        (if (not (let () (declare (not safe)) (##fxnegative? _r199550_)))
            _r199550_
            (std/os/error#raise-os-error
             (let () (declare (not safe)) (##fx- _r199550_))
             std/os/signalfd#signalfd-reset!
             _sfd199547_
             _sigset199548_)))))
  (define std/os/signalfd#signalfd-read__%
    (lambda (_sfd199529_ _buf199530_)
      (let _lp199532_ ()
        (let ((_rd199535_ (std/os/fdio#fdread__0 _sfd199529_ _buf199530_)))
          (if _rd199535_
              _buf199530_
              (begin
                (let ((__tmp301090 (std/os/fd#fd-io-in _sfd199529_)))
                  (declare (not safe))
                  (##wait-for-io! __tmp301090 '#t))
                (_lp199532_)))))))
  (define std/os/signalfd#signalfd-read__0
    (lambda (_sfd199540_)
      (let ((_buf199542_ (std/os/signalfd#make-signalfd-siginfo)))
        (std/os/signalfd#signalfd-read__% _sfd199540_ _buf199542_))))
  (define std/os/signalfd#signalfd-read
    (lambda _g301092_
      (let ((_g301091_ (let () (declare (not safe)) (##length _g301092_))))
        (cond ((let () (declare (not safe)) (##fx= _g301091_ 1))
               (apply std/os/signalfd#signalfd-read__0 _g301092_))
              ((let () (declare (not safe)) (##fx= _g301091_ 2))
               (apply std/os/signalfd#signalfd-read__% _g301092_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/signalfd#signalfd-read
                _g301092_))))))
  (define std/os/signalfd#make-signalfd-siginfo
    (lambda () (make-u8vector (std/os/signalfd#size-of-signalfd-siginfo))))
  (define-macro (define-guard guard defn)
    (if (eval `(cond-expand (,guard #t) (else #f)))
        '(begin)
        (begin (eval `(define-cond-expand-feature ,guard)) defn)))
  (define-macro (define-c-lambda id args ret #!optional (name #f))
    (let ((name (or name (symbol->string id))))
      `(define ,id (c-lambda ,args ,ret ,name))))
  (define-macro (define-const symbol)
    (let* ((str (symbol->string symbol))
           (ref (string-append "___return (" str ");")))
      `(define ,symbol ((c-lambda () int ,ref)))))
  (define-macro (define-const* symbol #!optional (ccond #f))
    (let* ((str (symbol->string symbol))
           (code (string-append
                  "#if "
                  (or ccond (string-append "defined(" str ")"))
                  "\n"
                  "___return (___FIX ("
                  str
                  "));\n"
                  "#else \n"
                  "___return (___FAL);\n"
                  "#endif")))
      `(define ,symbol ((c-lambda () scheme-object ,code)))))
  (define-macro (define-with-errno symbol ffi-symbol args)
    `(define (,symbol ,@args)
       (declare (not interrupts-enabled))
       (let ((r (,ffi-symbol ,@args)))
         (if (##fx< r 0) (##fx- (##c-code "___RESULT = ___FIX (errno);")) r))))
  (define-macro (define-c-struct
                 struct
                 #!optional
                 (members '())
                 release-function)
    (let* ((struct-str (symbol->string struct))
           (struct-ptr (string->symbol (string-append struct-str "*")))
           (shallow-ptr
            (string->symbol (string-append struct-str "-shallow-ptr*")))
           (borrowed-ptr
            (string->symbol (string-append struct-str "-borrowed-ptr*")))
           (string-types
            '(char-string
              nonull-char-string
              UTF-8-string
              nonnull-UTF-8-string
              UTF-16-string
              nonnull-UTF16-string))
           (string-compat-required?
            (let loop ((m members))
              (cond ((null? m) #f)
                    ((member (cdr (car m)) string-types) #t)
                    (else (loop (cdr m))))))
           (string-setter-body
            (lambda (member-name)
              (let ((m (string-append "___arg1->" member-name)))
                (string-append
                 "if("
                 m
                 " == NULL)"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "else if (strcmp("
                 m
                 ", ___arg2) != 0) {"
                 "\n"
                 "free("
                 m
                 ");"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "}"
                 "\n"
                 "___return;"
                 "\n"))))
           (default-free-body
            (and string-compat-required?
                 (string-append
                  "___SCMOBJ "
                  struct-str
                  "_ffi_free (void *ptr) {"
                  "\n"
                  "struct "
                  struct-str
                  " *obj = (struct "
                  struct-str
                  "*) ptr;"
                  "\n"
                  (apply string-append
                         (map (lambda (m)
                                (cond ((memq (cdr m) string-types)
                                       (let ((mem-name
                                              (symbol->string (car m))))
                                         (string-append
                                          "if(obj->"
                                          mem-name
                                          ") "
                                          "free(obj->"
                                          mem-name
                                          ");"
                                          "\n")))
                                      (else "")))
                              members))
                  "free(obj);"
                  "\n"
                  "return ___FIX (___NO_ERR);"
                  "\n"
                  "}")))
           (release-function
            (or release-function
                (if string-compat-required?
                    (string-append struct-str "_ffi_free")
                    "ffi_free")))
           (string-compat-types
            (if string-compat-required?
                `((c-declare ,default-free-body)
                  (c-define-type
                   ,shallow-ptr
                   (pointer ,struct (,struct-ptr) "ffi_free")))
                '())))
      `(begin
         (c-define-type ,struct (struct ,struct-str))
         (c-define-type
          ,struct-ptr
          (pointer ,struct (,struct-ptr) ,release-function))
         (c-define-type ,borrowed-ptr (pointer ,struct (,struct-ptr)))
         ,@string-compat-types
         (define ,(string->symbol (string-append struct-str "-ptr?"))
           (lambda (obj)
             (and (foreign? obj) (equal? (foreign-tags obj) '(,struct-ptr)))))
         ,@(apply append
                  (map (lambda (m)
                         (let* ((member-name (symbol->string (car m)))
                                (member-type (cdr m))
                                (getter-name
                                 (string-append struct-str "-" member-name))
                                (setter-body
                                 (cond ((member member-type string-types)
                                        (string-setter-body member-name))
                                       (else
                                        (string-append
                                         "___arg1->"
                                         member-name
                                         " = ___arg2;"
                                         "\n"
                                         "___return;"
                                         "\n")))))
                           `((define ,(string->symbol getter-name)
                               (c-lambda
                                (,struct-ptr)
                                ,member-type
                                ,(string-append
                                  "___return(___arg1->"
                                  member-name
                                  ");")))
                             (define ,(string->symbol
                                       (string-append getter-name "-set!"))
                               (c-lambda
                                (,struct-ptr ,member-type)
                                void
                                ,setter-body)))))
                       members))
         (define ,(string->symbol (string-append "malloc-" struct-str))
           (c-lambda
            ()
            ,struct-ptr
            ,(string-append
              "struct "
              struct-str
              "* var = (struct "
              struct-str
              " *) malloc(sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(var, 0, sizeof(struct "
              struct-str
              "));"
              "___return(var);")))
         (define ,(string->symbol (string-append "ptr->" struct-str))
           (c-lambda (,struct-ptr) ,struct "___return(*___arg1);"))
         (define ,(string->symbol
                   (string-append "malloc-" struct-str "-array"))
           (c-lambda
            (unsigned-int32)
            ,(if string-compat-required? shallow-ptr struct-ptr)
            ,(string-append
              "struct "
              struct-str
              " *arr_var=(struct "
              struct-str
              " *) malloc(___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (arr_var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(arr_var, 0, ___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "___return(arr_var);")))
         (define ,(string->symbol (string-append struct-str "-array-ref"))
           (c-lambda
            (,struct-ptr unsigned-int32)
            ,borrowed-ptr
            "___return (___arg1 + ___arg2);"))
         (define ,(string->symbol (string-append struct-str "-array-set!"))
           (c-lambda
            (,struct-ptr unsigned-int32 ,struct-ptr)
            void
            "*(___arg1 + ___arg2) = *___arg3; ___return;")))))
  (c-declare "#include <stdlib.h>")
  (c-declare "#include <string.h>")
  (c-declare "#include <errno.h>")
  (c-declare "static ___SCMOBJ ffi_free (void *ptr);")
  (c-declare
   "#ifndef ___HAVE_FFI_U8VECTOR\n#define ___HAVE_FFI_U8VECTOR\n#define U8_DATA(obj) ___CAST (___U8*, ___BODY_AS (obj, ___tSUBTYPED))\n#define U8_LEN(obj) ___HD_BYTES (___HEADER (obj))\n#endif")
  (namespace
   ("std/os/signalfd#"
    _signalfd
    signalfd-siginfo-addr
    signalfd-siginfo-stime
    signalfd-siginfo-utime
    signalfd-siginfo-ptr
    signalfd-siginfo-int
    signalfd-siginfo-status
    signalfd-siginfo-trapno
    signalfd-siginfo-overrun
    signalfd-siginfo-band
    signalfd-siginfo-tid
    signalfd-siginfo-fd
    signalfd-siginfo-uid
    signalfd-siginfo-pid
    signalfd-siginfo-code
    signalfd-siginfo-errno
    signalfd-siginfo-signo
    size-of-signalfd-siginfo
    SFD_CLOEXEC
    SFD_NONBLOCK))
  (c-declare "#include <signal.h>")
  (c-declare "#include <sys/signalfd.h>")
  (namespace ("std/os/signalfd#" __signalfd))
  (define-const SFD_NONBLOCK)
  (define-const SFD_CLOEXEC)
  (define-guard ffi-have-sigset (c-define-type sigset_t "sigset_t"))
  (define-guard
   ffi-have-sigset*
   (c-define-type sigset_t* (pointer "sigset_t" (sigset_t*) "ffi_free")))
  (define-c-lambda __signalfd (int sigset_t* int) int "signalfd")
  (define-with-errno _signalfd __signalfd (fd mask flags))
  (define-c-lambda
   size-of-signalfd-siginfo
   ()
   int
   "___return (sizeof (struct signalfd_siginfo));")
  (define-c-lambda
   signalfd-siginfo-signo
   (scheme-object)
   unsigned-int32
   "___return (((struct signalfd_siginfo*)U8_DATA (___arg1))->ssi_signo);")
  (define-c-lambda
   signalfd-siginfo-errno
   (scheme-object)
   int32
   "___return (((struct signalfd_siginfo*)U8_DATA (___arg1))->ssi_errno);")
  (define-c-lambda
   signalfd-siginfo-code
   (scheme-object)
   int32
   "___return (((struct signalfd_siginfo*)U8_DATA (___arg1))->ssi_code);")
  (define-c-lambda
   signalfd-siginfo-pid
   (scheme-object)
   unsigned-int32
   "___return (((struct signalfd_siginfo*)U8_DATA (___arg1))->ssi_pid);")
  (define-c-lambda
   signalfd-siginfo-uid
   (scheme-object)
   unsigned-int32
   "___return (((struct signalfd_siginfo*)U8_DATA (___arg1))->ssi_uid);")
  (define-c-lambda
   signalfd-siginfo-fd
   (scheme-object)
   int32
   "___return (((struct signalfd_siginfo*)U8_DATA (___arg1))->ssi_fd);")
  (define-c-lambda
   signalfd-siginfo-tid
   (scheme-object)
   unsigned-int32
   "___return (((struct signalfd_siginfo*)U8_DATA (___arg1))->ssi_tid);")
  (define-c-lambda
   signalfd-siginfo-band
   (scheme-object)
   unsigned-int32
   "___return (((struct signalfd_siginfo*)U8_DATA (___arg1))->ssi_band);")
  (define-c-lambda
   signalfd-siginfo-overrun
   (scheme-object)
   unsigned-int32
   "___return (((struct signalfd_siginfo*)U8_DATA (___arg1))->ssi_overrun);")
  (define-c-lambda
   signalfd-siginfo-trapno
   (scheme-object)
   unsigned-int32
   "___return (((struct signalfd_siginfo*)U8_DATA (___arg1))->ssi_trapno);")
  (define-c-lambda
   signalfd-siginfo-status
   (scheme-object)
   int32
   "___return (((struct signalfd_siginfo*)U8_DATA (___arg1))->ssi_status);")
  (define-c-lambda
   signalfd-siginfo-int
   (scheme-object)
   int32
   "___return (((struct signalfd_siginfo*)U8_DATA (___arg1))->ssi_int);")
  (define-c-lambda
   signalfd-siginfo-ptr
   (scheme-object)
   unsigned-int64
   "___return (((struct signalfd_siginfo*)U8_DATA (___arg1))->ssi_ptr);")
  (define-c-lambda
   signalfd-siginfo-utime
   (scheme-object)
   unsigned-int64
   "___return (((struct signalfd_siginfo*)U8_DATA (___arg1))->ssi_utime);")
  (define-c-lambda
   signalfd-siginfo-stime
   (scheme-object)
   unsigned-int64
   "___return (((struct signalfd_siginfo*)U8_DATA (___arg1))->ssi_stime);")
  (define-c-lambda
   signalfd-siginfo-addr
   (scheme-object)
   unsigned-int64
   "___return (((struct signalfd_siginfo*)U8_DATA (___arg1))->ssi_addr);")
  (c-declare
   "#ifndef ___HAVE_FFI_FREE\n#define ___HAVE_FFI_FREE\n___SCMOBJ ffi_free (void *ptr)\n{\n free (ptr);\n return ___FIX (___NO_ERR);\n}\n#endif"))
