(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/os/socket#open-socket
    (lambda (_domain199364_ _type199365_ _proto199366_ _dir199367_)
      (let* ((_fd199372_
              (let ((_r199369_
                     (std/os/_socket#_socket
                      _domain199364_
                      _type199365_
                      _proto199366_)))
                (if (not (let ()
                           (declare (not safe))
                           (##fxnegative? _r199369_)))
                    _r199369_
                    (std/os/error#raise-os-error
                     (let () (declare (not safe)) (##fx- _r199369_))
                     std/os/socket#socket
                     _domain199364_
                     _type199365_
                     _proto199366_))))
             (_raw199374_ (std/os/fd#fdopen _fd199372_ _dir199367_ 'socket)))
        (std/os/fcntl#fd-set-nonblock/closeonexec _raw199374_)
        _raw199374_)))
  (define std/os/socket#socket__%
    (lambda (_domain199348_ _type199349_ _proto199350_)
      (std/os/socket#open-socket
       _domain199348_
       _type199349_
       _proto199350_
       'inout)))
  (define std/os/socket#socket__0
    (lambda (_domain199355_ _type199356_)
      (let ((_proto199358_ '0))
        (std/os/socket#socket__% _domain199355_ _type199356_ _proto199358_))))
  (define std/os/socket#socket
    (lambda _g301050_
      (let ((_g301049_ (let () (declare (not safe)) (##length _g301050_))))
        (cond ((let () (declare (not safe)) (##fx= _g301049_ 2))
               (apply std/os/socket#socket__0 _g301050_))
              ((let () (declare (not safe)) (##fx= _g301049_ 3))
               (apply std/os/socket#socket__% _g301050_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/socket#socket
                _g301050_))))))
  (define std/os/socket#server-socket__%
    (lambda (_domain199331_ _type199332_ _proto199333_)
      (std/os/socket#open-socket
       _domain199331_
       _type199332_
       _proto199333_
       'in)))
  (define std/os/socket#server-socket__0
    (lambda (_domain199338_ _type199339_)
      (let ((_proto199341_ '0))
        (std/os/socket#server-socket__%
         _domain199338_
         _type199339_
         _proto199341_))))
  (define std/os/socket#server-socket
    (lambda _g301052_
      (let ((_g301051_ (let () (declare (not safe)) (##length _g301052_))))
        (cond ((let () (declare (not safe)) (##fx= _g301051_ 2))
               (apply std/os/socket#server-socket__0 _g301052_))
              ((let () (declare (not safe)) (##fx= _g301051_ 3))
               (apply std/os/socket#server-socket__% _g301052_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/socket#server-socket
                _g301052_))))))
  (define std/os/socket#socket?
    (lambda (_obj199328_) (std/os/fd#fd-type? _obj199328_ 'socket)))
  (define std/os/socket#socket-bind
    (lambda (_sock199322_ _addr199323_)
      (let ((_r199325_
             (std/os/_socket#_bind
              (std/os/fd#fd-e _sock199322_)
              (std/os/socket#socket-address _addr199323_))))
        (if (not (let () (declare (not safe)) (##fxnegative? _r199325_)))
            _r199325_
            (std/os/error#raise-os-error
             (let () (declare (not safe)) (##fx- _r199325_))
             std/os/socket#socket-bind
             _sock199322_
             _addr199323_)))))
  (define std/os/socket#socket-listen__%
    (lambda (_sock199306_ _backlog199307_)
      (let ((_r199309_
             (std/os/_socket#_listen
              (std/os/fd#fd-e _sock199306_)
              _backlog199307_)))
        (if (not (let () (declare (not safe)) (##fxnegative? _r199309_)))
            _r199309_
            (std/os/error#raise-os-error
             (let () (declare (not safe)) (##fx- _r199309_))
             std/os/socket#socket-listen
             _sock199306_
             _backlog199307_)))))
  (define std/os/socket#socket-listen__0
    (lambda (_sock199315_)
      (let ((_backlog199317_ '10))
        (std/os/socket#socket-listen__% _sock199315_ _backlog199317_))))
  (define std/os/socket#socket-listen
    (lambda _g301054_
      (let ((_g301053_ (let () (declare (not safe)) (##length _g301054_))))
        (cond ((let () (declare (not safe)) (##fx= _g301053_ 1))
               (apply std/os/socket#socket-listen__0 _g301054_))
              ((let () (declare (not safe)) (##fx= _g301053_ 2))
               (apply std/os/socket#socket-listen__% _g301054_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/socket#socket-listen
                _g301054_))))))
  (define std/os/socket#socket-accept__%
    (lambda (_sock199273_ _sa199274_)
      (let ((_fd199275199290_
             (let _lp199277_ ()
               (let ((_r199281_
                      (std/os/_socket#_accept4
                       (std/os/fd#fd-e _sock199273_)
                       _sa199274_)))
                 (if (not (let ()
                            (declare (not safe))
                            (##fxnegative? _r199281_)))
                     _r199281_
                     (let ((_errno199284_
                            (let () (declare (not safe)) (##fx- _r199281_))))
                       (if (or (eq? _errno199284_ std/os/error#EAGAIN)
                               (eq? _errno199284_ std/os/error#EWOULDBLOCK))
                           '#f
                           (if (eq? _errno199284_ std/os/error#EINTR)
                               (_lp199277_)
                               (std/os/error#raise-os-error
                                _errno199284_
                                std/os/socket#socket-accept
                                _sock199273_
                                _sa199274_)))))))))
        (if _fd199275199290_
            (let ((_fd199293_ _fd199275199290_))
              (std/os/fd#fdopen _fd199293_ 'inout 'socket))
            '#f))))
  (define std/os/socket#socket-accept__0
    (lambda (_sock199298_)
      (let ((_sa199300_ '#f))
        (std/os/socket#socket-accept__% _sock199298_ _sa199300_))))
  (define std/os/socket#socket-accept
    (lambda _g301056_
      (let ((_g301055_ (let () (declare (not safe)) (##length _g301056_))))
        (cond ((let () (declare (not safe)) (##fx= _g301055_ 1))
               (apply std/os/socket#socket-accept__0 _g301056_))
              ((let () (declare (not safe)) (##fx= _g301055_ 2))
               (apply std/os/socket#socket-accept__% _g301056_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/socket#socket-accept
                _g301056_))))))
  (define std/os/socket#socket-connect
    (lambda (_sock199257_ _sa199258_)
      (let ((_sa199260_ (std/os/socket#socket-address _sa199258_)))
        (let _lp199262_ ()
          (let ((_r199266_
                 (std/os/_socket#_connect
                  (std/os/fd#fd-e _sock199257_)
                  _sa199260_)))
            (if (not (let () (declare (not safe)) (##fxnegative? _r199266_)))
                _r199266_
                (let ((_errno199269_
                       (let () (declare (not safe)) (##fx- _r199266_))))
                  (if (eq? _errno199269_ std/os/error#EINPROGRESS)
                      '#f
                      (if (eq? _errno199269_ std/os/error#EINTR)
                          (_lp199262_)
                          (std/os/error#raise-os-error
                           _errno199269_
                           std/os/socket#socket-connect
                           _sock199257_
                           _sa199260_))))))))))
  (define std/os/socket#socket-shutdown
    (lambda (_sock199251_ _how199252_)
      (let ((_r199254_
             (std/os/_socket#_shutdown
              (std/os/fd#fd-e _sock199251_)
              _how199252_)))
        (if (not (let () (declare (not safe)) (##fxnegative? _r199254_)))
            _r199254_
            (std/os/error#raise-os-error
             (let () (declare (not safe)) (##fx- _r199254_))
             std/os/socket#socket-shutdown
             _sock199251_
             _how199252_)))
      (if (eq? _how199252_ std/os/_socket#SHUT_RD)
          (close-input-port _sock199251_)
          (if (eq? _how199252_ std/os/_socket#SHUT_WR)
              (close-output-port _sock199251_)
              (if (eq? _how199252_ std/os/_socket#SHUT_RDWR)
                  (close-port _sock199251_)
                  '#!void)))))
  (define std/os/socket#socket-close
    (lambda (_sock199249_) (close-port _sock199249_)))
  (define std/os/socket#socket-send__%
    (lambda (_sock199197_
             _bytes199198_
             _start199199_
             _end199200_
             _flags199201_)
      (let _lp199203_ ()
        (let ((_r199207_
               (std/os/_socket#_send
                (std/os/fd#fd-e _sock199197_)
                _bytes199198_
                _start199199_
                _end199200_
                _flags199201_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r199207_)))
              _r199207_
              (let ((_errno199210_
                     (let () (declare (not safe)) (##fx- _r199207_))))
                (if (or (eq? _errno199210_ std/os/error#EAGAIN)
                        (eq? _errno199210_ std/os/error#EWOULDBLOCK))
                    '#f
                    (if (eq? _errno199210_ std/os/error#EINTR)
                        (_lp199203_)
                        (std/os/error#raise-os-error
                         _errno199210_
                         std/os/socket#socket-send
                         _sock199197_
                         _bytes199198_
                         _start199199_
                         _end199200_
                         _flags199201_)))))))))
  (define std/os/socket#socket-send__0
    (lambda (_sock199219_ _bytes199220_)
      (let* ((_start199222_ '0)
             (_end199224_ (u8vector-length _bytes199220_))
             (_flags199226_ '0))
        (std/os/socket#socket-send__%
         _sock199219_
         _bytes199220_
         _start199222_
         _end199224_
         _flags199226_))))
  (define std/os/socket#socket-send__1
    (lambda (_sock199228_ _bytes199229_ _start199230_)
      (let* ((_end199232_ (u8vector-length _bytes199229_)) (_flags199234_ '0))
        (std/os/socket#socket-send__%
         _sock199228_
         _bytes199229_
         _start199230_
         _end199232_
         _flags199234_))))
  (define std/os/socket#socket-send__2
    (lambda (_sock199236_ _bytes199237_ _start199238_ _end199239_)
      (let ((_flags199241_ '0))
        (std/os/socket#socket-send__%
         _sock199236_
         _bytes199237_
         _start199238_
         _end199239_
         _flags199241_))))
  (define std/os/socket#socket-send
    (lambda _g301058_
      (let ((_g301057_ (let () (declare (not safe)) (##length _g301058_))))
        (cond ((let () (declare (not safe)) (##fx= _g301057_ 2))
               (apply std/os/socket#socket-send__0 _g301058_))
              ((let () (declare (not safe)) (##fx= _g301057_ 3))
               (apply std/os/socket#socket-send__1 _g301058_))
              ((let () (declare (not safe)) (##fx= _g301057_ 4))
               (apply std/os/socket#socket-send__2 _g301058_))
              ((let () (declare (not safe)) (##fx= _g301057_ 5))
               (apply std/os/socket#socket-send__% _g301058_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/socket#socket-send
                _g301058_))))))
  (define std/os/socket#socket-sendto__%
    (lambda (_sock199137_
             _bytes199138_
             _sa199139_
             _start199140_
             _end199141_
             _flags199142_)
      (let ((_sa199144_ (std/os/socket#socket-address _sa199139_)))
        (let _lp199146_ ()
          (let ((_r199150_
                 (std/os/_socket#_sendto
                  (std/os/fd#fd-e _sock199137_)
                  _bytes199138_
                  _start199140_
                  _end199141_
                  _flags199142_
                  _sa199144_)))
            (if (not (let () (declare (not safe)) (##fxnegative? _r199150_)))
                _r199150_
                (let ((_errno199153_
                       (let () (declare (not safe)) (##fx- _r199150_))))
                  (if (or (eq? _errno199153_ std/os/error#EAGAIN)
                          (eq? _errno199153_ std/os/error#EWOULDBLOCK))
                      '#f
                      (if (eq? _errno199153_ std/os/error#EINTR)
                          (_lp199146_)
                          (std/os/error#raise-os-error
                           _errno199153_
                           std/os/socket#socket-sendto
                           _sock199137_
                           _bytes199138_
                           _sa199144_
                           _start199140_
                           _end199141_
                           _flags199142_))))))))))
  (define std/os/socket#socket-sendto__0
    (lambda (_sock199162_ _bytes199163_ _sa199164_)
      (let* ((_start199166_ '0)
             (_end199168_ (u8vector-length _bytes199163_))
             (_flags199170_ '0))
        (std/os/socket#socket-sendto__%
         _sock199162_
         _bytes199163_
         _sa199164_
         _start199166_
         _end199168_
         _flags199170_))))
  (define std/os/socket#socket-sendto__1
    (lambda (_sock199172_ _bytes199173_ _sa199174_ _start199175_)
      (let* ((_end199177_ (u8vector-length _bytes199173_)) (_flags199179_ '0))
        (std/os/socket#socket-sendto__%
         _sock199172_
         _bytes199173_
         _sa199174_
         _start199175_
         _end199177_
         _flags199179_))))
  (define std/os/socket#socket-sendto__2
    (lambda (_sock199181_ _bytes199182_ _sa199183_ _start199184_ _end199185_)
      (let ((_flags199187_ '0))
        (std/os/socket#socket-sendto__%
         _sock199181_
         _bytes199182_
         _sa199183_
         _start199184_
         _end199185_
         _flags199187_))))
  (define std/os/socket#socket-sendto
    (lambda _g301060_
      (let ((_g301059_ (let () (declare (not safe)) (##length _g301060_))))
        (cond ((let () (declare (not safe)) (##fx= _g301059_ 3))
               (apply std/os/socket#socket-sendto__0 _g301060_))
              ((let () (declare (not safe)) (##fx= _g301059_ 4))
               (apply std/os/socket#socket-sendto__1 _g301060_))
              ((let () (declare (not safe)) (##fx= _g301059_ 5))
               (apply std/os/socket#socket-sendto__2 _g301060_))
              ((let () (declare (not safe)) (##fx= _g301059_ 6))
               (apply std/os/socket#socket-sendto__% _g301060_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/socket#socket-sendto
                _g301060_))))))
  (define std/os/socket#socket-sendmsg
    (lambda (_sock199117_
             _name-bytes199118_
             _io-bytes199119_
             _ctl-bytes199120_
             _flags199121_)
      (let _lp199123_ ()
        (let ((_r199127_
               (std/os/_socket#_sendmsg
                (std/os/fd#fd-e _sock199117_)
                _name-bytes199118_
                _io-bytes199119_
                _ctl-bytes199120_
                _flags199121_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r199127_)))
              _r199127_
              (let ((_errno199130_
                     (let () (declare (not safe)) (##fx- _r199127_))))
                (if (or (eq? _errno199130_ std/os/error#EAGAIN)
                        (eq? _errno199130_ std/os/error#EWOULDBLOCK))
                    '#f
                    (if (eq? _errno199130_ std/os/error#EINTR)
                        (_lp199123_)
                        (std/os/error#raise-os-error
                         _errno199130_
                         std/os/socket#socket-sendmsg
                         _sock199117_
                         _name-bytes199118_
                         _io-bytes199119_
                         _ctl-bytes199120_
                         _flags199121_)))))))))
  (define std/os/socket#socket-recv__%
    (lambda (_sock199065_
             _bytes199066_
             _start199067_
             _end199068_
             _flags199069_)
      (let _lp199071_ ()
        (let ((_r199075_
               (std/os/_socket#_recv
                (std/os/fd#fd-e _sock199065_)
                _bytes199066_
                _start199067_
                _end199068_
                _flags199069_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r199075_)))
              _r199075_
              (let ((_errno199078_
                     (let () (declare (not safe)) (##fx- _r199075_))))
                (if (or (eq? _errno199078_ std/os/error#EAGAIN)
                        (eq? _errno199078_ std/os/error#EWOULDBLOCK))
                    '#f
                    (if (eq? _errno199078_ std/os/error#EINTR)
                        (_lp199071_)
                        (std/os/error#raise-os-error
                         _errno199078_
                         std/os/socket#socket-recv
                         _sock199065_
                         _bytes199066_
                         _start199067_
                         _end199068_
                         _flags199069_)))))))))
  (define std/os/socket#socket-recv__0
    (lambda (_sock199087_ _bytes199088_)
      (let* ((_start199090_ '0)
             (_end199092_ (u8vector-length _bytes199088_))
             (_flags199094_ '0))
        (std/os/socket#socket-recv__%
         _sock199087_
         _bytes199088_
         _start199090_
         _end199092_
         _flags199094_))))
  (define std/os/socket#socket-recv__1
    (lambda (_sock199096_ _bytes199097_ _start199098_)
      (let* ((_end199100_ (u8vector-length _bytes199097_)) (_flags199102_ '0))
        (std/os/socket#socket-recv__%
         _sock199096_
         _bytes199097_
         _start199098_
         _end199100_
         _flags199102_))))
  (define std/os/socket#socket-recv__2
    (lambda (_sock199104_ _bytes199105_ _start199106_ _end199107_)
      (let ((_flags199109_ '0))
        (std/os/socket#socket-recv__%
         _sock199104_
         _bytes199105_
         _start199106_
         _end199107_
         _flags199109_))))
  (define std/os/socket#socket-recv
    (lambda _g301062_
      (let ((_g301061_ (let () (declare (not safe)) (##length _g301062_))))
        (cond ((let () (declare (not safe)) (##fx= _g301061_ 2))
               (apply std/os/socket#socket-recv__0 _g301062_))
              ((let () (declare (not safe)) (##fx= _g301061_ 3))
               (apply std/os/socket#socket-recv__1 _g301062_))
              ((let () (declare (not safe)) (##fx= _g301061_ 4))
               (apply std/os/socket#socket-recv__2 _g301062_))
              ((let () (declare (not safe)) (##fx= _g301061_ 5))
               (apply std/os/socket#socket-recv__% _g301062_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/socket#socket-recv
                _g301062_))))))
  (define std/os/socket#socket-recvfrom__%
    (lambda (_sock199007_
             _bytes199008_
             _sa199009_
             _start199010_
             _end199011_
             _flags199012_)
      (let _lp199014_ ()
        (let ((_r199018_
               (std/os/_socket#_recvfrom
                (std/os/fd#fd-e _sock199007_)
                _bytes199008_
                _start199010_
                _end199011_
                _flags199012_
                _sa199009_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r199018_)))
              _r199018_
              (let ((_errno199021_
                     (let () (declare (not safe)) (##fx- _r199018_))))
                (if (or (eq? _errno199021_ std/os/error#EAGAIN)
                        (eq? _errno199021_ std/os/error#EWOULDBLOCK))
                    '#f
                    (if (eq? _errno199021_ std/os/error#EINTR)
                        (_lp199014_)
                        (std/os/error#raise-os-error
                         _errno199021_
                         std/os/socket#socket-recvfrom
                         _sock199007_
                         _bytes199008_
                         _sa199009_
                         _start199010_
                         _end199011_
                         _flags199012_)))))))))
  (define std/os/socket#socket-recvfrom__0
    (lambda (_sock199030_ _bytes199031_ _sa199032_)
      (let* ((_start199034_ '0)
             (_end199036_ (u8vector-length _bytes199031_))
             (_flags199038_ '0))
        (std/os/socket#socket-recvfrom__%
         _sock199030_
         _bytes199031_
         _sa199032_
         _start199034_
         _end199036_
         _flags199038_))))
  (define std/os/socket#socket-recvfrom__1
    (lambda (_sock199040_ _bytes199041_ _sa199042_ _start199043_)
      (let* ((_end199045_ (u8vector-length _bytes199041_)) (_flags199047_ '0))
        (std/os/socket#socket-recvfrom__%
         _sock199040_
         _bytes199041_
         _sa199042_
         _start199043_
         _end199045_
         _flags199047_))))
  (define std/os/socket#socket-recvfrom__2
    (lambda (_sock199049_ _bytes199050_ _sa199051_ _start199052_ _end199053_)
      (let ((_flags199055_ '0))
        (std/os/socket#socket-recvfrom__%
         _sock199049_
         _bytes199050_
         _sa199051_
         _start199052_
         _end199053_
         _flags199055_))))
  (define std/os/socket#socket-recvfrom
    (lambda _g301064_
      (let ((_g301063_ (let () (declare (not safe)) (##length _g301064_))))
        (cond ((let () (declare (not safe)) (##fx= _g301063_ 3))
               (apply std/os/socket#socket-recvfrom__0 _g301064_))
              ((let () (declare (not safe)) (##fx= _g301063_ 4))
               (apply std/os/socket#socket-recvfrom__1 _g301064_))
              ((let () (declare (not safe)) (##fx= _g301063_ 5))
               (apply std/os/socket#socket-recvfrom__2 _g301064_))
              ((let () (declare (not safe)) (##fx= _g301063_ 6))
               (apply std/os/socket#socket-recvfrom__% _g301064_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/socket#socket-recvfrom
                _g301064_))))))
  (define std/os/socket#socket-recvmsg*
    (lambda (_sock198984_
             _name-bytes198985_
             _rname198986_
             _io-bytes198987_
             _ctl-bytes198988_
             _rctl198989_
             _flags198990_
             _rflags198991_)
      (let _lp198993_ ()
        (let ((_r198997_
               (std/os/_socket#_recvmsg
                (std/os/fd#fd-e _sock198984_)
                _name-bytes198985_
                _rname198986_
                _io-bytes198987_
                _ctl-bytes198988_
                _rctl198989_
                _flags198990_
                _rflags198991_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r198997_)))
              _r198997_
              (let ((_errno199000_
                     (let () (declare (not safe)) (##fx- _r198997_))))
                (if (or (eq? _errno199000_ std/os/error#EAGAIN)
                        (eq? _errno199000_ std/os/error#EWOULDBLOCK))
                    '#f
                    (if (eq? _errno199000_ std/os/error#EINTR)
                        (_lp198993_)
                        (std/os/error#raise-os-error
                         _errno199000_
                         std/os/socket#socket-recvmsg
                         _sock198984_
                         _name-bytes198985_
                         _io-bytes198987_
                         _ctl-bytes198988_
                         _flags198990_)))))))))
  (define std/os/socket#socket-recvmsg
    (lambda (_sock198963_ _name198964_ _io198965_ _ctl198966_ _flags198967_)
      (let* ((_rname198972_
              (if _name198964_
                  (let ((_r198969_ (std/os/_socket#make_int_ptr)))
                    (if _r198969_
                        _r198969_
                        (error '"Error allocating memory" 'make_int_ptr)))
                  '#f))
             (_rctl198977_
              (if _ctl198966_
                  (let ((_r198974_ (std/os/_socket#make_int_ptr)))
                    (if _r198974_
                        _r198974_
                        (error '"Error allocating memory" 'make_int_ptr)))
                  '#f))
             (_rflags198979_ (std/os/_socket#make_int_ptr))
             (_r198981_
              (std/os/socket#socket-recvmsg*
               _sock198963_
               _name198964_
               _rname198972_
               _io198965_
               _ctl198966_
               _rctl198977_
               _flags198967_
               _rflags198979_)))
        (if _r198981_
            (values _r198981_
                    (if _rname198972_
                        (std/os/_socket#int_ptr_value _rname198972_)
                        '#f)
                    (if _rctl198977_
                        (std/os/_socket#int_ptr_value _rctl198977_)
                        '#f)
                    (std/os/_socket#int_ptr_value _rflags198979_))
            '#f))))
  (define std/os/socket#socket-getpeername__%
    (lambda (_sock198942_ _sa198943_)
      (let ((_sa198948_
             (let ((_$e198945_ _sa198943_))
               (if _$e198945_
                   _$e198945_
                   (std/os/socket#make-socket-address
                    (std/os/socket#socket-domain _sock198942_))))))
        (let ((_r198950_
               (std/os/_socket#_getpeername
                (std/os/fd#fd-e _sock198942_)
                _sa198948_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r198950_)))
              _r198950_
              (std/os/error#raise-os-error
               (let () (declare (not safe)) (##fx- _r198950_))
               std/os/socket#socket-getpeername
               _sock198942_)))
        _sa198948_)))
  (define std/os/socket#socket-getpeername__0
    (lambda (_sock198956_)
      (let ((_sa198958_ '#f))
        (std/os/socket#socket-getpeername__% _sock198956_ _sa198958_))))
  (define std/os/socket#socket-getpeername
    (lambda _g301066_
      (let ((_g301065_ (let () (declare (not safe)) (##length _g301066_))))
        (cond ((let () (declare (not safe)) (##fx= _g301065_ 1))
               (apply std/os/socket#socket-getpeername__0 _g301066_))
              ((let () (declare (not safe)) (##fx= _g301065_ 2))
               (apply std/os/socket#socket-getpeername__% _g301066_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/socket#socket-getpeername
                _g301066_))))))
  (define std/os/socket#socket-getsockname__%
    (lambda (_sock198920_ _sa198921_)
      (let ((_sa198926_
             (let ((_$e198923_ _sa198921_))
               (if _$e198923_
                   _$e198923_
                   (std/os/socket#make-socket-address
                    (std/os/socket#socket-domain _sock198920_))))))
        (let ((_r198928_
               (std/os/_socket#_getsockname
                (std/os/fd#fd-e _sock198920_)
                _sa198926_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r198928_)))
              _r198928_
              (std/os/error#raise-os-error
               (let () (declare (not safe)) (##fx- _r198928_))
               std/os/socket#socket-getsockname
               _sock198920_)))
        _sa198926_)))
  (define std/os/socket#socket-getsockname__0
    (lambda (_sock198934_)
      (let ((_sa198936_ '#f))
        (std/os/socket#socket-getsockname__% _sock198934_ _sa198936_))))
  (define std/os/socket#socket-getsockname
    (lambda _g301068_
      (let ((_g301067_ (let () (declare (not safe)) (##length _g301068_))))
        (cond ((let () (declare (not safe)) (##fx= _g301067_ 1))
               (apply std/os/socket#socket-getsockname__0 _g301068_))
              ((let () (declare (not safe)) (##fx= _g301067_ 2))
               (apply std/os/socket#socket-getsockname__% _g301068_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/socket#socket-getsockname
                _g301068_))))))
  (define std/os/socket#socket-domain
    (lambda (_sock198917_)
      (std/os/socket#socket-getsockopt
       _sock198917_
       std/os/_socket#SOL_SOCKET
       std/os/_socket#SO_DOMAIN)))
  (define std/os/socket#socket-address?
    (lambda (_obj198915_) (std/os/_socket#sockaddr? _obj198915_)))
  (define std/os/socket#make-socket-address
    (lambda (_af198910_)
      (let ((_r198912_ (std/os/_socket#make_sockaddr _af198910_)))
        (if _r198912_
            _r198912_
            (error '"Error allocating memory" 'make_sockaddr)))))
  (define std/os/socket#make-socket-address-in
    (lambda () (std/os/socket#make-socket-address std/os/_socket#AF_INET)))
  (define std/os/socket#make-socket-address-in6
    (lambda () (std/os/socket#make-socket-address std/os/_socket#AF_INET6)))
  (define std/os/socket#make-socket-address-un
    (lambda () (std/os/socket#make-socket-address std/os/_socket#AF_UNIX)))
  (define std/os/socket#socket-address-in
    (lambda (_host198899_ _port198900_)
      (let* ((_ip4198902_ (std/net/address#ip4-address _host198899_))
             (_sa198904_ (std/os/socket#make-socket-address-in)))
        (std/os/_socket#sockaddr_in_addr_set _sa198904_ _ip4198902_)
        (std/os/_socket#sockaddr_in_port_set _sa198904_ _port198900_)
        _sa198904_)))
  (define std/os/socket#socket-address-in6
    (lambda (_host198891_ _port198892_)
      (let* ((_ip6198894_ (std/net/address#ip6-address _host198891_))
             (_sa198896_ (std/os/socket#make-socket-address-in6)))
        (std/os/_socket#sockaddr_in6_addr_set _sa198896_ _ip6198894_)
        (std/os/_socket#sockaddr_in6_port_set _sa198896_ _port198892_)
        _sa198896_)))
  (define std/os/socket#socket-address-un
    (lambda (_path198885_)
      (let ((_pathlen198887_
             (std/text/utf8#string-utf8-length__0 _path198885_)))
        (if (let ()
              (declare (not safe))
              (##fx< _pathlen198887_ std/os/_socket#UNIX_MAX_PATH))
            (let ((_sa198889_ (std/os/socket#make-socket-address-un)))
              (std/os/_socket#sockaddr_un_path_set _sa198889_ _path198885_)
              _sa198889_)
            (error '"Malformed address; path is too long")))))
  (define std/os/socket#socket-address-family
    (lambda (_sa198883_) (std/os/_socket#sockaddr_family _sa198883_)))
  (define std/os/socket#socket-address
    (lambda (_addr198878_)
      (if (std/os/_socket#sockaddr? _addr198878_)
          _addr198878_
          (if (or (std/net/address#inet-address? _addr198878_)
                  (std/net/address#inet-address-string? _addr198878_))
              (std/os/socket#inet-address->socket-address _addr198878_)
              (std/os/socket#socket-address-un _addr198878_)))))
  (define std/os/socket#inet-address->socket-address
    (lambda (_addr198848_)
      (let* ((_g198849198856_ (std/net/address#resolve-address _addr198848_))
             (_E198851198860_
              (lambda () (error '"No clause matching" _g198849198856_)))
             (_K198852198866_
              (lambda (_port198863_ _ip198864_)
                (if (std/net/address#ip4-address? _ip198864_)
                    (std/os/socket#socket-address-in _ip198864_ _port198863_)
                    (if (std/net/address#ip6-address? _ip198864_)
                        (std/os/socket#socket-address-in6
                         _ip198864_
                         _port198863_)
                        (error '"Bad address; expected ip4 or ip6 inet-address"
                               _addr198848_))))))
        (if (let () (declare (not safe)) (##pair? _g198849198856_))
            (let ((_hd198853198869_
                   (let () (declare (not safe)) (##car _g198849198856_)))
                  (_tl198854198871_
                   (let () (declare (not safe)) (##cdr _g198849198856_))))
              (let* ((_ip198874_ _hd198853198869_)
                     (_port198876_ _tl198854198871_))
                (_K198852198866_ _port198876_ _ip198874_)))
            (_E198851198860_)))))
  (define std/os/socket#socket-address->address
    (lambda (_sa198832_)
      (let ((_saf198834_ (std/os/_socket#sockaddr_family _sa198832_)))
        (if (eq? _saf198834_ std/os/_socket#AF_INET)
            (let* ((_ip4198836_ (make-u8vector '4))
                   (_g301069_
                    (std/os/_socket#sockaddr_in_addr _sa198832_ _ip4198836_))
                   (_port198839_ (std/os/_socket#sockaddr_in_port _sa198832_)))
              (cons _ip4198836_ _port198839_))
            (if (eq? _saf198834_ std/os/_socket#AF_INET6)
                (let* ((_ip6198842_ (make-u8vector '16))
                       (_g301070_
                        (std/os/_socket#sockaddr_in6_addr
                         _sa198832_
                         _ip6198842_))
                       (_port198845_
                        (std/os/_socket#sockaddr_in6_port _sa198832_)))
                  (cons _ip6198842_ _port198845_))
                (if (eq? _saf198834_ std/os/_socket#AF_UNIX)
                    (std/os/_socket#sockaddr_un_path _sa198832_)
                    (error '"Unknown address family"
                           _sa198832_
                           _saf198834_)))))))
  (define std/os/socket#socket-address->string
    (lambda (_sa198816_)
      (let ((_saf198818_ (std/os/_socket#sockaddr_family _sa198816_)))
        (if (eq? _saf198818_ std/os/_socket#AF_INET)
            (let* ((_ip4198820_ (make-u8vector '4))
                   (_g301071_
                    (std/os/_socket#sockaddr_in_addr _sa198816_ _ip4198820_))
                   (_port198823_ (std/os/_socket#sockaddr_in_port _sa198816_)))
              (string-append
               (std/net/address#ip4-address->string _ip4198820_)
               '":"
               (number->string _port198823_)))
            (if (eq? _saf198818_ std/os/_socket#AF_INET6)
                (let* ((_ip6198826_ (make-u8vector '16))
                       (_g301072_
                        (std/os/_socket#sockaddr_in6_addr
                         _sa198816_
                         _ip6198826_))
                       (_port198829_
                        (std/os/_socket#sockaddr_in6_port _sa198816_)))
                  (string-append
                   (std/net/address#ip6-address->string _ip6198826_)
                   '":"
                   (number->string _port198829_)))
                (if (eq? _saf198818_ std/os/_socket#AF_UNIX)
                    (std/os/_socket#sockaddr_un_path _sa198816_)
                    (error '"Unknown address family"
                           _sa198816_
                           _saf198818_)))))))
  (define std/os/socket#socket-getsockopt
    (lambda (_sock198770_ _level198771_ _opt198772_ . _args198773_)
      (let ((_$e198775_
             (table-ref std/os/socket#socket-sockopts _level198771_ '#f)))
        (if _$e198775_
            ((lambda (_ht198778_)
               (let ((_$e198780_ (table-ref _ht198778_ _opt198772_ '#f)))
                 (if _$e198780_
                     ((lambda (_e198782198784_)
                        (let* ((_g198786198793_ _e198782198784_)
                               (_E198788198797_
                                (lambda ()
                                  (error '"No clause matching"
                                         _g198786198793_)))
                               (_K198789198803_
                                (lambda (_setf198800_ _getf198801_)
                                  (if _getf198801_
                                      (apply _getf198801_
                                             _sock198770_
                                             _level198771_
                                             _opt198772_
                                             _args198773_)
                                      (error '"No getsockopt operation defined for option"
                                             _level198771_
                                             _opt198772_)))))
                          (if (let ((__tmp301073
                                     (if (let ()
                                           (declare (not safe))
                                           (##values? _g198786198793_))
                                         (let ()
                                           (declare (not safe))
                                           (##vector-length _g198786198793_))
                                         '1)))
                                (declare (not safe))
                                (##fx= __tmp301073 '2))
                              (let* ((_e198790198806_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _g198786198793_ '0)))
                                     (_getf198809_ _e198790198806_)
                                     (_e198791198811_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _g198786198793_ '1)))
                                     (_setf198814_ _e198791198811_))
                                (_K198789198803_ _setf198814_ _getf198809_))
                              (_E198788198797_))))
                      _$e198780_)
                     (error '"Unknown socket option"
                            _level198771_
                            _opt198772_))))
             _$e198775_)
            (error '"Unknown socket level" _level198771_ _opt198772_)))))
  (define std/os/socket#socket-setsockopt
    (lambda (_sock198723_ _level198724_ _opt198725_ _val198726_ . _args198727_)
      (let ((_$e198729_
             (table-ref std/os/socket#socket-sockopts _level198724_ '#f)))
        (if _$e198729_
            ((lambda (_ht198732_)
               (let ((_$e198734_ (table-ref _ht198732_ _opt198725_ '#f)))
                 (if _$e198734_
                     ((lambda (_e198736198738_)
                        (let* ((_g198740198747_ _e198736198738_)
                               (_E198742198751_
                                (lambda ()
                                  (error '"No clause matching"
                                         _g198740198747_)))
                               (_K198743198757_
                                (lambda (_setf198754_ _getf198755_)
                                  (if _setf198754_
                                      (apply _setf198754_
                                             _sock198723_
                                             _level198724_
                                             _opt198725_
                                             _val198726_
                                             _args198727_)
                                      (error '"No setsockopt operation defined for option"
                                             _level198724_
                                             _opt198725_)))))
                          (if (let ((__tmp301074
                                     (if (let ()
                                           (declare (not safe))
                                           (##values? _g198740198747_))
                                         (let ()
                                           (declare (not safe))
                                           (##vector-length _g198740198747_))
                                         '1)))
                                (declare (not safe))
                                (##fx= __tmp301074 '2))
                              (let* ((_e198744198760_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _g198740198747_ '0)))
                                     (_getf198763_ _e198744198760_)
                                     (_e198745198765_
                                      (let ()
                                        (declare (not safe))
                                        (##vector-ref _g198740198747_ '1)))
                                     (_setf198768_ _e198745198765_))
                                (_K198743198757_ _setf198768_ _getf198763_))
                              (_E198742198751_))))
                      _$e198734_)
                     (error '"Unknown socket option"
                            _level198724_
                            _opt198725_))))
             _$e198729_)
            (error '"Unknown socket level" _level198724_ _opt198725_)))))
  (define std/os/socket#socket-getsockopt-int
    (lambda (_sock198716_ _level198717_ _opt198718_)
      (let ((_r198720_
             (std/os/_socket#_getsockopt_int
              (std/os/fd#fd-e _sock198716_)
              _level198717_
              _opt198718_)))
        (if (not (let () (declare (not safe)) (##fxnegative? _r198720_)))
            _r198720_
            (std/os/error#raise-os-error
             (let () (declare (not safe)) (##fx- _r198720_))
             std/os/socket#socket-getsockopt
             _sock198716_
             _level198717_
             _opt198718_)))))
  (define std/os/socket#socket-setsockopt-int
    (lambda (_sock198708_ _level198709_ _opt198710_ _val198711_)
      (if (fixnum? _val198711_)
          (let ((_r198713_
                 (std/os/_socket#_setsockopt_int
                  (std/os/fd#fd-e _sock198708_)
                  _level198709_
                  _opt198710_
                  _val198711_)))
            (if (not (let () (declare (not safe)) (##fxnegative? _r198713_)))
                _r198713_
                (std/os/error#raise-os-error
                 (let () (declare (not safe)) (##fx- _r198713_))
                 std/os/socket#socket-setsockopt
                 _sock198708_
                 _level198709_
                 _opt198710_
                 _val198711_)))
          (error '"Bad argument; expected fixnum" _val198711_))))
  (define std/os/socket#socket-getsockopt-tv
    (lambda (_sock198696_ _level198697_ _opt198698_)
      (let ((_tv198703_
             (let ((_r198700_ (std/os/_socket#make_tv)))
               (if _r198700_
                   _r198700_
                   (error '"Error allocating memory" 'make_tv)))))
        (let ((_r198705_
               (std/os/_socket#_getsockopt_tv
                (std/os/fd#fd-e _sock198696_)
                _level198697_
                _opt198698_
                _tv198703_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r198705_)))
              _r198705_
              (std/os/error#raise-os-error
               (let () (declare (not safe)) (##fx- _r198705_))
               std/os/socket#socket-getsockopt
               _sock198696_
               _level198697_
               _opt198698_)))
        (+ (std/os/_socket#tv_sec _tv198703_)
           (/ (std/os/_socket#tv_usec _tv198703_) '1000000.)))))
  (define std/os/socket#socket-setsockopt-tv
    (lambda (_sock198676_ _level198677_ _opt198678_ _tm198679_)
      (if (real? _tm198679_)
          (let* ((_tm-sec198681_ (floor _tm198679_))
                 (_tm-frac198683_ (- _tm198679_ _tm-sec198681_))
                 (_tm-usec198685_ (floor (* _tm-frac198683_ '1000000.)))
                 (_tv198690_
                  (let ((_r198687_ (std/os/_socket#make_tv)))
                    (if _r198687_
                        _r198687_
                        (error '"Error allocating memory" 'make_tv)))))
            (std/os/_socket#tv_sec_set
             _tv198690_
             (inexact->exact _tm-sec198681_))
            (std/os/_socket#tv_usec_set
             _tv198690_
             (inexact->exact _tm-usec198685_))
            (let ((_r198693_
                   (std/os/_socket#_setsockopt_tv
                    (std/os/fd#fd-e _sock198676_)
                    _level198677_
                    _opt198678_
                    _tv198690_)))
              (if (not (let () (declare (not safe)) (##fxnegative? _r198693_)))
                  _r198693_
                  (std/os/error#raise-os-error
                   (let () (declare (not safe)) (##fx- _r198693_))
                   std/os/socket#socket-setsockopt
                   _sock198676_
                   _level198677_
                   _opt198678_
                   _tm198679_))))
          (error '"Bad argument; expected real" _tm198679_))))
  (define std/os/socket#socket-getsockopt-addr-in
    (lambda (_sock198667_ _level198668_ _opt198669_)
      (let ((_sa198671_ (std/os/socket#make-socket-address-in)))
        (let ((_r198673_
               (std/os/_socket#_getsockopt_sa
                (std/os/fd#fd-e _sock198667_)
                _level198668_
                _opt198669_
                _sa198671_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r198673_)))
              _r198673_
              (std/os/error#raise-os-error
               (let () (declare (not safe)) (##fx- _r198673_))
               std/os/socket#socket-getsockopt
               _sock198667_
               _level198668_
               _opt198669_)))
        _sa198671_)))
  (define std/os/socket#socket-getsockopt-addr-in6
    (lambda (_sock198658_ _level198659_ _opt198660_)
      (let ((_sa198662_ (std/os/socket#make-socket-address-in6)))
        (let ((_r198664_
               (std/os/_socket#_getsockopt_sa
                (std/os/fd#fd-e _sock198658_)
                _level198659_
                _opt198660_
                _sa198662_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r198664_)))
              _r198664_
              (std/os/error#raise-os-error
               (let () (declare (not safe)) (##fx- _r198664_))
               std/os/socket#socket-getsockopt
               _sock198658_
               _level198659_
               _opt198660_)))
        _sa198662_)))
  (define std/os/socket#socket-setsockopt-addr
    (lambda (_sock198648_ _level198649_ _opt198650_ _addr198651_)
      (let* ((_sa198653_ (std/os/socket#socket-address _addr198651_))
             (_r198655_
              (std/os/_socket#_setsockopt_sa
               (std/os/fd#fd-e _sock198648_)
               _level198649_
               _opt198650_
               _sa198653_)))
        (if (not (let () (declare (not safe)) (##fxnegative? _r198655_)))
            _r198655_
            (std/os/error#raise-os-error
             (let () (declare (not safe)) (##fx- _r198655_))
             std/os/socket#socket-setsockopt
             _sock198648_
             _level198649_
             _opt198650_
             _addr198651_)))))
  (define std/os/socket#socket-getsockopt-bytes
    (lambda (_sock198640_ _level198641_ _opt198642_ _bytes198643_)
      (if (u8vector? _bytes198643_)
          (let ((_r198645_
                 (std/os/_socket#_getsockopt_bytes
                  (std/os/fd#fd-e _sock198640_)
                  _level198641_
                  _opt198642_
                  _bytes198643_)))
            (if (not (let () (declare (not safe)) (##fxnegative? _r198645_)))
                _r198645_
                (std/os/error#raise-os-error
                 (let () (declare (not safe)) (##fx- _r198645_))
                 std/os/socket#socket-getsockopt
                 _sock198640_
                 _level198641_
                 _opt198642_
                 _bytes198643_)))
          (error '"Bad argument; expected bytes" _bytes198643_))))
  (define std/os/socket#socket-setsockopt-bytes
    (lambda (_sock198632_ _level198633_ _opt198634_ _bytes198635_)
      (if (u8vector? _bytes198635_)
          (let ((_r198637_
                 (std/os/_socket#_setsockopt_bytes
                  (std/os/fd#fd-e _sock198632_)
                  _level198633_
                  _opt198634_
                  _bytes198635_)))
            (if (not (let () (declare (not safe)) (##fxnegative? _r198637_)))
                _r198637_
                (std/os/error#raise-os-error
                 (let () (declare (not safe)) (##fx- _r198637_))
                 std/os/socket#socket-setsockopt
                 _sock198632_
                 _level198633_
                 _opt198634_
                 _bytes198635_)))
          (error '"Bad argument; expected bytes" _bytes198635_))))
  (define std/os/socket#socket-setsockopt-mreq
    (lambda (_sock198588_ _level198589_ _opt198590_ _ips198591_)
      (let* ((_ips198592198600_ _ips198591_)
             (_else198594198608_
              (lambda ()
                (error '"Bad argument; expected pair of ip4 addresses"
                       _ips198591_)))
             (_K198596198620_
              (lambda (_laddr198611_ _maddr198612_)
                (let ((_maddr198614_
                       (std/net/address#ip4-address _maddr198612_))
                      (_laddr198615_
                       (std/net/address#ip4-address _laddr198611_)))
                  (let ((_r198617_
                         (std/os/_socket#_setsockopt_mreq
                          (std/os/fd#fd-e _sock198588_)
                          _level198589_
                          _opt198590_
                          _maddr198614_
                          _laddr198615_)))
                    (if (not (let ()
                               (declare (not safe))
                               (##fxnegative? _r198617_)))
                        _r198617_
                        (std/os/error#raise-os-error
                         (let () (declare (not safe)) (##fx- _r198617_))
                         std/os/socket#socket-setsockopt
                         _sock198588_
                         _level198589_
                         _opt198590_
                         _ips198591_)))))))
        (if (let () (declare (not safe)) (##pair? _ips198592198600_))
            (let ((_hd198597198623_
                   (let () (declare (not safe)) (##car _ips198592198600_)))
                  (_tl198598198625_
                   (let () (declare (not safe)) (##cdr _ips198592198600_))))
              (let* ((_maddr198628_ _hd198597198623_)
                     (_laddr198630_ _tl198598198625_))
                (_K198596198620_ _laddr198630_ _maddr198628_)))
            (_else198594198608_)))))
  (define std/os/socket#socket-setsockopt-mreq-src
    (lambda (_sock198526_ _level198527_ _opt198528_ _ips198529_)
      (let* ((_ips198530198542_ _ips198529_)
             (_else198532198550_
              (lambda ()
                (error '"Bad argument; expected list with 3 ip4 addresses"
                       _ips198529_)))
             (_K198534198564_
              (lambda (_saddr198553_ _iaddr198554_ _maddr198555_)
                (let ((_maddr198557_
                       (std/net/address#ip4-address _maddr198555_))
                      (_iaddr198558_
                       (std/net/address#ip4-address _iaddr198554_))
                      (_saddr198559_
                       (std/net/address#ip4-address _saddr198553_)))
                  (let ((_r198561_
                         (std/os/_socket#_setsockopt_mreq_src
                          (std/os/fd#fd-e _sock198526_)
                          _level198527_
                          _opt198528_
                          _maddr198557_
                          _iaddr198558_
                          _saddr198559_)))
                    (if (not (let ()
                               (declare (not safe))
                               (##fxnegative? _r198561_)))
                        _r198561_
                        (std/os/error#raise-os-error
                         (let () (declare (not safe)) (##fx- _r198561_))
                         std/os/socket#socket-setsockopt
                         _sock198526_
                         _level198527_
                         _opt198528_
                         _ips198529_)))))))
        (if (let () (declare (not safe)) (##pair? _ips198530198542_))
            (let ((_hd198535198567_
                   (let () (declare (not safe)) (##car _ips198530198542_)))
                  (_tl198536198569_
                   (let () (declare (not safe)) (##cdr _ips198530198542_))))
              (let ((_maddr198572_ _hd198535198567_))
                (if (let () (declare (not safe)) (##pair? _tl198536198569_))
                    (let ((_hd198537198574_
                           (let ()
                             (declare (not safe))
                             (##car _tl198536198569_)))
                          (_tl198538198576_
                           (let ()
                             (declare (not safe))
                             (##cdr _tl198536198569_))))
                      (let ((_iaddr198579_ _hd198537198574_))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl198538198576_))
                            (let ((_hd198539198581_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl198538198576_)))
                                  (_tl198540198583_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl198538198576_))))
                              (let ((_saddr198586_ _hd198539198581_))
                                (if (let ()
                                      (declare (not safe))
                                      (##null? _tl198540198583_))
                                    (_K198534198564_
                                     _saddr198586_
                                     _iaddr198579_
                                     _maddr198572_)
                                    (_else198532198550_))))
                            (_else198532198550_))))
                    (_else198532198550_))))
            (_else198532198550_)))))
  (define std/os/socket#socket-setsockopt-mreq6
    (lambda (_sock198483_ _level198484_ _opt198485_ _ips198486_)
      (let* ((_ips198487198495_ _ips198486_)
             (_else198489198503_
              (lambda ()
                (error '"Bad argument; expected pair of ip6 addresses"
                       _ips198486_)))
             (_K198491198514_
              (lambda (_ifindex198506_ _maddr198507_)
                (let* ((_maddr198509_
                        (std/net/address#ip6-address _maddr198507_))
                       (_r198511_
                        (std/os/_socket#_setsockopt_mreq6
                         (std/os/fd#fd-e _sock198483_)
                         _level198484_
                         _opt198485_
                         _maddr198509_
                         _ifindex198506_)))
                  (if (not (let ()
                             (declare (not safe))
                             (##fxnegative? _r198511_)))
                      _r198511_
                      (std/os/error#raise-os-error
                       (let () (declare (not safe)) (##fx- _r198511_))
                       std/os/socket#socket-setsockopt
                       _sock198483_
                       _level198484_
                       _opt198485_
                       _ips198486_))))))
        (if (let () (declare (not safe)) (##pair? _ips198487198495_))
            (let ((_hd198492198517_
                   (let () (declare (not safe)) (##car _ips198487198495_)))
                  (_tl198493198519_
                   (let () (declare (not safe)) (##cdr _ips198487198495_))))
              (let* ((_maddr198522_ _hd198492198517_)
                     (_ifindex198524_ _tl198493198519_))
                (_K198491198514_ _ifindex198524_ _maddr198522_)))
            (_else198489198503_)))))
  (define std/os/socket#socket-getsockopt-linger
    (lambda (_sock198471_ _level198472_ _opt198473_)
      (let ((_linger198478_
             (let ((_r198475_ (std/os/_socket#make_linger)))
               (if _r198475_
                   _r198475_
                   (error '"Error allocating memory" 'make_linger)))))
        (let ((_r198480_
               (std/os/_socket#_getsockopt_linger
                _sock198471_
                _level198472_
                _opt198473_
                _linger198478_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r198480_)))
              _r198480_
              (std/os/error#raise-os-error
               (let () (declare (not safe)) (##fx- _r198480_))
               std/os/socket#socket-getsockopt
               _sock198471_
               _level198472_
               _opt198473_)))
        (if (let ((__tmp301075 (std/os/_socket#linger_onoff _linger198478_)))
              (declare (not safe))
              (##fxzero? __tmp301075))
            '#f
            (std/os/_socket#linger_linger _linger198478_)))))
  (define std/os/socket#socket-setsockopt-linger
    (lambda (_sock198458_ _level198459_ _opt198460_ _val198461_)
      (let ((_linger198466_
             (let ((_r198463_ (std/os/_socket#make_linger)))
               (if _r198463_
                   _r198463_
                   (error '"Error allocating memory" 'make_linger)))))
        (if (fixnum? _val198461_)
            (begin
              (std/os/_socket#linger_onoff_set _linger198466_ '1)
              (std/os/_socket#linger_linger_set _linger198466_ _val198461_))
            (if (not _val198461_)
                (begin
                  (std/os/_socket#linger_onoff_set _linger198466_ '0)
                  (std/os/_socket#linger_linger_set _linger198466_ '0))
                (error '"Bad argument; expected fixnum or #f" _val198461_)))
        (let ((_r198468_
               (std/os/_socket#_setsockopt_linger
                _sock198458_
                _level198459_
                _opt198460_
                _linger198466_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r198468_)))
              _r198468_
              (std/os/error#raise-os-error
               (let () (declare (not safe)) (##fx- _r198468_))
               std/os/socket#socket-setsockopt
               _sock198458_
               _level198459_
               _opt198460_
               _val198461_))))))
  (define std/os/socket#socket-sockopts
    (let ((_ht198455_ (make-table 'test: eq? 'size: '4)))
      (table-set! _ht198455_ std/os/_socket#SOL_SOCKET (make-table 'test: eq?))
      (table-set! _ht198455_ std/os/_socket#IPPROTO_IP (make-table 'test: eq?))
      (table-set!
       _ht198455_
       std/os/_socket#IPPROTO_IPV6
       (make-table 'test: eq?))
      (table-set!
       _ht198455_
       std/os/_socket#IPPROTO_TCP
       (make-table 'test: eq?))
      _ht198455_))
  (if std/os/_socket#SO_ACCEPTCONN
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_ACCEPTCONN
       (values std/os/socket#socket-getsockopt-int '#f))
      '#!void)
  (if std/os/_socket#SO_BINDTODEVICE
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_BINDTODEVICE
       (values std/os/socket#socket-getsockopt-bytes
               std/os/socket#socket-setsockopt-bytes))
      '#!void)
  (if std/os/_socket#SO_BROADCAST
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_BROADCAST
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_DEBUG
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_DEBUG
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_DOMAIN
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_DOMAIN
       (values std/os/socket#socket-getsockopt-int '#f))
      '#!void)
  (if std/os/_socket#SO_DONTROUTE
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_DONTROUTE
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_ERROR
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_ERROR
       (values std/os/socket#socket-getsockopt-int '#f))
      '#!void)
  (if std/os/_socket#SO_KEEPALIVE
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_KEEPALIVE
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_LINGER
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_LINGER
       (values std/os/socket#socket-getsockopt-linger
               std/os/socket#socket-setsockopt-linger))
      '#!void)
  (if std/os/_socket#SO_OOBLINE
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_OOBLINE
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_PASSCRED
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_PASSCRED
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_PEERCRED
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_PEERCRED
       (values std/os/socket#socket-getsockopt-bytes
               std/os/socket#socket-setsockopt-bytes))
      '#!void)
  (if std/os/_socket#SO_PEEK_OFF
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_PEEK_OFF
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_PROTOCOL
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_PROTOCOL
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_RCVBUF
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_RCVBUF
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_SNDBUF
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_SNDBUF
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_RCVLOWAT
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_RCVLOWAT
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_SNDLOWAT
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_SNDLOWAT
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_RCVTIMEO
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_RCVTIMEO
       (values std/os/socket#socket-getsockopt-tv
               std/os/socket#socket-setsockopt-tv))
      '#!void)
  (if std/os/_socket#SO_SNDTIMEO
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_SNDTIMEO
       (values std/os/socket#socket-getsockopt-tv
               std/os/socket#socket-setsockopt-tv))
      '#!void)
  (if std/os/_socket#SO_REUSEADDR
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_REUSEADDR
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_REUSEPORT
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_REUSEPORT
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_TYPE
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_TYPE
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_TIMESTAMP
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_TIMESTAMP
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#SO_USELOOPBACK
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#SOL_SOCKET)
       std/os/_socket#SO_USELOOPBACK
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_ADD_MEMBERSHIP
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_ADD_MEMBERSHIP
       (values '#f std/os/socket#socket-setsockopt-mreq))
      '#!void)
  (if std/os/_socket#IP_DROP_MEMBERSHIP
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_DROP_MEMBERSHIP
       (values '#f std/os/socket#socket-setsockopt-mreq))
      '#!void)
  (if std/os/_socket#IP_ADD_SOURCE_MEMBERSHIP
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_ADD_SOURCE_MEMBERSHIP
       (values '#f std/os/socket#socket-setsockopt-mreq-src))
      '#!void)
  (if std/os/_socket#IP_DROP_SOURCE_MEMBERSHIP
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_DROP_SOURCE_MEMBERSHIP
       (values '#f std/os/socket#socket-setsockopt-mreq-src))
      '#!void)
  (if std/os/_socket#IP_BLOCK_SOURCE
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_BLOCK_SOURCE
       (values '#f std/os/socket#socket-setsockopt-mreq-src))
      '#!void)
  (if std/os/_socket#IP_UNBLOCK_SOURCE
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_UNBLOCK_SOURCE
       (values '#f std/os/socket#socket-setsockopt-mreq-src))
      '#!void)
  (if std/os/_socket#IP_FREEBIND
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_FREEBIND
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_HDRINCL
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_HDRINCL
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_MTU
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_MTU
       (values std/os/socket#socket-getsockopt-int '#f))
      '#!void)
  (if std/os/_socket#IP_MTU_DISCOVER
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_MTU_DISCOVER
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_MULTICAST_ALL
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_MULTICAST_ALL
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_MULTICAST_IF
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_MULTICAST_IF
       (values '#f std/os/socket#socket-setsockopt-mreq))
      '#!void)
  (if std/os/_socket#IP_MULTICAST_LOOP
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_MULTICAST_LOOP
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_MULTICAST_TTL
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_MULTICAST_TTL
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_NODEFRAG
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_NODEFRAG
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_OPTIONS
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_OPTIONS
       (values std/os/socket#socket-getsockopt-bytes
               std/os/socket#socket-setsockopt-bytes))
      '#!void)
  (if std/os/_socket#IP_PKTINFO
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_PKTINFO
       (values std/os/socket#socket-getsockopt-bytes
               std/os/socket#socket-setsockopt-bytes))
      '#!void)
  (if std/os/_socket#IP_RECVERR
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_RECVERR
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_RECVORIGDSTADDR
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_RECVORIGDSTADDR
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_RECVOPTS
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_RECVOPTS
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_RECVTOS
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_RECVTOS
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_RECVTTL
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_RECVTTL
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_RETOPTS
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_RETOPTS
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_ROUTER_ALERT
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_ROUTER_ALERT
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_TOS
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_TOS
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IP_TTL
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IP)
       std/os/_socket#IP_TTL
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_ADDRFORM
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_ADDRFORM
       (values '#f std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_ADD_MEMBERSHIP
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_ADD_MEMBERSHIP
       (values '#f std/os/socket#socket-setsockopt-mreq6))
      '#!void)
  (if std/os/_socket#IPV6_DROP_MEMBERSHIP
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_DROP_MEMBERSHIP
       (values '#f std/os/socket#socket-setsockopt-mreq6))
      '#!void)
  (if std/os/_socket#IPV6_MTU
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_MTU
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_MTU_DISCOVER
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_MTU_DISCOVER
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_MULTICAST_HOPS
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_MULTICAST_HOPS
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_MULTICAST_IF
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_MULTICAST_IF
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_MULTICAST_LOOP
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_MULTICAST_LOOP
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_RECVPKTINFO
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_RECVPKTINFO
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_RTHDR
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_RTHDR
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_AUTHHDR
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_AUTHHDR
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_DSTOPTS
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_DSTOPTS
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_HOPOPTS
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_HOPOPTS
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_FLOWINFO
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_FLOWINFO
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_HOPLIMIT
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_HOPLIMIT
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_ROUTER_ALERT
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_ROUTER_ALERT
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_UNICAST_HOPS
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_UNICAST_HOPS
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#IPV6_V6ONLY
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_IPV6)
       std/os/_socket#IPV6_V6ONLY
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#TCP_CONGESTION
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_TCP)
       std/os/_socket#TCP_CONGESTION
       (values '#f std/os/socket#socket-setsockopt-bytes))
      '#!void)
  (if std/os/_socket#TCP_CORK
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_TCP)
       std/os/_socket#TCP_CORK
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#TCP_DEFER_ACCEPT
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_TCP)
       std/os/_socket#TCP_DEFER_ACCEPT
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#TCP_KEEPCNT
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_TCP)
       std/os/_socket#TCP_KEEPCNT
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#TCP_KEEPIDLE
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_TCP)
       std/os/_socket#TCP_KEEPIDLE
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#TCP_KEEPINTVL
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_TCP)
       std/os/_socket#TCP_KEEPINTVL
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#TCP_MAXSEG
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_TCP)
       std/os/_socket#TCP_MAXSEG
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#TCP_NODELAY
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_TCP)
       std/os/_socket#TCP_NODELAY
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void)
  (if std/os/_socket#TCP_SYNCNT
      (table-set!
       (table-ref std/os/socket#socket-sockopts std/os/_socket#IPPROTO_TCP)
       std/os/_socket#TCP_SYNCNT
       (values std/os/socket#socket-getsockopt-int
               std/os/socket#socket-setsockopt-int))
      '#!void))
