(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/parser/grammar-reader#read-module-body
    (lambda (_port164037_)
      (let _lp164039_ ((_body164041_ '()))
        (let ((_next164043_ (read-syntax _port164037_)))
          (if (eof-object? _next164043_)
              (gx#raise-syntax-error
               '#f
               '"Bad syntax; no parser or lexer definitions"
               (std/parser/grammar-reader#read-error-token _port164037_))
              (if (or (eq? (gx#stx-e _next164043_) '%%parser)
                      (eq? (gx#stx-e _next164043_) '%%lexer))
                  (std/parser/grammar-reader#read-module-section
                   _port164037_
                   _body164041_
                   (let ((__tmp300660 (gx#stx-e _next164043_)))
                     (declare (not safe))
                     (##structure
                      std/parser/base#token::t
                      '$$
                      __tmp300660
                      '#f)))
                  (_lp164039_ (cons _next164043_ _body164041_))))))))
  (define std/parser/grammar-reader#read-error-token
    (lambda (_port164032_)
      (let ((_name164034_
             (let () (declare (not safe)) (##port-name _port164032_)))
            (_loc164035_ (std/parser/stream#port-location _port164032_)))
        (let ((__tmp300662 (cons 'read-module-body (cons _name164034_ '())))
              (__tmp300661
               (std/parser/base#location->source-location _loc164035_)))
          (declare (not safe))
          (##structure AST::t __tmp300662 __tmp300661)))))
  (define std/parser/grammar-reader#read-module-section
    (lambda (_port164026_ _body164027_ _tok164028_)
      (let ((_e164030_
             (##direct-structure-ref
              _tok164028_
              '2
              std/parser/base#token::t
              '#f)))
        (if (eof-object? _e164030_)
            (reverse _body164027_)
            (if (eq? _e164030_ '%%parser)
                (std/parser/grammar-reader#read-parser-section
                 _port164026_
                 _body164027_)
                (if (eq? _e164030_ '%%lexer)
                    (std/parser/grammar-reader#read-lexer-section
                     _port164026_
                     _body164027_)
                    (gx#raise-syntax-error
                     '#f
                     '"Bad syntax; unexpected token"
                     (std/parser/base#token->syntax _tok164028_))))))))
  (define std/parser/grammar-reader#read-parser-section
    (lambda (_port164023_ _body164024_)
      (std/parser/grammar-reader#read-%%-section
       _port164023_
       _body164024_
       'defparser
       std/parser/grammar-reader#read-parser-body)))
  (define std/parser/grammar-reader#read-lexer-section
    (lambda (_port164020_ _body164021_)
      (std/parser/grammar-reader#read-%%-section
       _port164020_
       _body164021_
       'deflexer
       std/parser/grammar-reader#read-lexer-body)))
  (define std/parser/grammar-reader#read-%%-section
    (lambda (_port163806_ _body163807_ _defmacro163808_ _read-body-e163809_)
      (letrec ((_raise-e163811_
                (lambda (_exn164013_)
                  (if (let ()
                        (declare (not safe))
                        (##structure-instance-of?
                         _exn164013_
                         'std/parser/base#parse-error::t))
                      (apply gx#raise-syntax-error
                             '#f
                             (string-append
                              '"Bad syntax; parse error: "
                              (let ((_$e164015_ (error-trace _exn164013_)))
                                (if _$e164015_
                                    ((lambda (_where164018_)
                                       (string-append
                                        (symbol->string _where164018_)
                                        '" :"))
                                     _$e164015_)
                                    '""))
                              (error-message _exn164013_))
                             (map std/parser/base#token->syntax
                                  (error-irritants _exn164013_)))
                      (raise _exn164013_)))))
        (let ((_g300663_
               (std/parser/grammar-reader#read-section-head _port163806_)))
          (begin
            (let ((_g300664_
                   (let ()
                     (declare (not safe))
                     (if (##values? _g300663_)
                         (##vector-length _g300663_)
                         1))))
              (if (not (let () (declare (not safe)) (##fx= _g300664_ 2)))
                  (error "Context expects 2 values" _g300664_)))
            (let ((_macro-id163813_
                   (let () (declare (not safe)) (##vector-ref _g300663_ 0)))
                  (_opts163814_
                   (let () (declare (not safe)) (##vector-ref _g300663_ 1))))
              (let ((_g300665_
                     (with-exception-catcher
                      _raise-e163811_
                      (lambda () (_read-body-e163809_ _port163806_)))))
                (begin
                  (let ((_g300666_
                         (let ()
                           (declare (not safe))
                           (if (##values? _g300665_)
                               (##vector-length _g300665_)
                               1))))
                    (if (not (let () (declare (not safe)) (##fx= _g300666_ 2)))
                        (error "Context expects 2 values" _g300666_)))
                  (let ((_rules163817_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _g300665_ 0)))
                        (_end163818_
                         (let ()
                           (declare (not safe))
                           (##vector-ref _g300665_ 1))))
                    (let* ((_g163820163827_
                            (lambda (_g163821163824_)
                              (gx#raise-syntax-error
                               '#f
                               '"Bad syntax"
                               _g163821163824_)))
                           (_g163819164010_
                            (lambda (_g163821163830_)
                              ((lambda (_L163832_)
                                 (let ()
                                   (let* ((_g163844163851_
                                           (lambda (_g163845163848_)
                                             (gx#raise-syntax-error
                                              '#f
                                              '"Bad syntax"
                                              _g163845163848_)))
                                          (_g163843164007_
                                           (lambda (_g163845163854_)
                                             ((lambda (_L163856_)
                                                (let ()
                                                  (let* ((_g163866163882_
                                                          (lambda (_g163867163879_)
                                                            (gx#raise-syntax-error
                                                             '#f
                                                             '"Bad syntax"
                                                             _g163867163879_)))
                                                         (_g163865164004_
                                                          (lambda (_g163867163885_)
                                                            (if (gx#stx-pair/null?
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _g163867163885_)
                        (let ((_g300667_
                               (gx#syntax-split-splice _g163867163885_ '0)))
                          (begin
                            (let ((_g300668_
                                   (let ()
                                     (declare (not safe))
                                     (if (##values? _g300667_)
                                         (##vector-length _g300667_)
                                         1))))
                              (if (not (let ()
                                         (declare (not safe))
                                         (##fx= _g300668_ 2)))
                                  (error "Context expects 2 values"
                                         _g300668_)))
                            (let ((_target163869163887_
                                   (let ()
                                     (declare (not safe))
                                     (##vector-ref _g300667_ 0)))
                                  (_tl163871163889_
                                   (let ()
                                     (declare (not safe))
                                     (##vector-ref _g300667_ 1))))
                              (if (gx#stx-null? _tl163871163889_)
                                  (letrec ((_loop163872163892_
                                            (lambda (_hd163870163895_
                                                     _macro-opt163876163897_)
                                              (if (gx#stx-pair?
                                                   _hd163870163895_)
                                                  (let ((_e163873163900_
                                                         (gx#syntax-e
                                                          _hd163870163895_)))
                                                    (let ((_lp-hd163874163903_
                                                           (let ()
                                                             (declare
                                                               (not safe))
                                                             (##car _e163873163900_)))
                                                          (_lp-tl163875163905_
                                                           (let ()
                                                             (declare
                                                               (not safe))
                                                             (##cdr _e163873163900_))))
                                                      (_loop163872163892_
                                                       _lp-tl163875163905_
                                                       (cons _lp-hd163874163903_
                                                             _macro-opt163876163897_))))
                                                  (let ((_macro-opt163877163908_
                                                         (reverse _macro-opt163876163897_)))
                                                    ((lambda (_L163911_)
                                                       (let ()
                                                         (let* ((_g163925163941_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (lambda (_g163926163938_)
                           (gx#raise-syntax-error
                            '#f
                            '"Bad syntax"
                            _g163926163938_)))
                        (_g163924164001_
                         (lambda (_g163926163944_)
                           (if (gx#stx-pair/null? _g163926163944_)
                               (let ((_g300669_
                                      (gx#syntax-split-splice
                                       _g163926163944_
                                       '0)))
                                 (begin
                                   (let ((_g300670_
                                          (let ()
                                            (declare (not safe))
                                            (if (##values? _g300669_)
                                                (##vector-length _g300669_)
                                                1))))
                                     (if (not (let ()
                                                (declare (not safe))
                                                (##fx= _g300670_ 2)))
                                         (error "Context expects 2 values"
                                                _g300670_)))
                                   (let ((_target163928163946_
                                          (let ()
                                            (declare (not safe))
                                            (##vector-ref _g300669_ 0)))
                                         (_tl163930163948_
                                          (let ()
                                            (declare (not safe))
                                            (##vector-ref _g300669_ 1))))
                                     (if (gx#stx-null? _tl163930163948_)
                                         (letrec ((_loop163931163951_
                                                   (lambda (_hd163929163954_
                                                            _rule163935163956_)
                                                     (if (gx#stx-pair?
                                                          _hd163929163954_)
                                                         (let ((_e163932163959_
                                                                (gx#syntax-e
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _hd163929163954_)))
                   (let ((_lp-hd163933163962_
                          (let ()
                            (declare (not safe))
                            (##car _e163932163959_)))
                         (_lp-tl163934163964_
                          (let ()
                            (declare (not safe))
                            (##cdr _e163932163959_))))
                     (_loop163931163951_
                      _lp-tl163934163964_
                      (cons _lp-hd163933163962_ _rule163935163956_))))
                 (let ((_rule163936163967_ (reverse _rule163935163956_)))
                   ((lambda (_L163970_)
                      (let ()
                        (let ()
                          (let ((_defn163999_
                                 (gx#stx-wrap-source
                                  (cons _L163832_
                                        (cons _L163856_
                                              (foldr1 (lambda (_g163984163989_
                                                               _g163985163991_)
                                                        (cons _g163984163989_
                                                              _g163985163991_))
                                                      (foldr1 (lambda (_g163986163994_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                               _g163987163996_)
                        (cons _g163986163994_ _g163987163996_))
                      '()
                      _L163970_)
              _L163911_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                  (gx#stx-source _L163856_))))
                            (std/parser/grammar-reader#read-module-section
                             _port163806_
                             (cons _defn163999_ _body163807_)
                             _end163818_)))))
                    _rule163936163967_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                           (_loop163931163951_
                                            _target163928163946_
                                            '()))
                                         (_g163925163941_ _g163926163944_)))))
                               (_g163925163941_ _g163926163944_)))))
                   (_g163924164001_ _rules163817_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     _macro-opt163877163908_))))))
                                    (_loop163872163892_
                                     _target163869163887_
                                     '()))
                                  (_g163866163882_ _g163867163885_)))))
                        (_g163866163882_ _g163867163885_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                    (_g163865164004_
                                                     _opts163814_))))
                                              _g163845163854_))))
                                     (_g163843164007_ _macro-id163813_))))
                               _g163821163830_))))
                      (_g163819164010_ _defmacro163808_)))))))))))
  (define std/parser/grammar-reader#read-section-head
    (lambda (_port163786_)
      (letrec ((_read-id163788_
                (lambda ()
                  (let ((_next163799_ (peek-char _port163786_)))
                    (if (or (eof-object? _next163799_)
                            (memq _next163799_ '(#\newline #\# #\;)))
                        (gx#raise-syntax-error
                         '#f
                         '"Bad syntax; missing section id"
                         (std/parser/grammar-reader#read-error-token
                          _port163786_)
                         _next163799_)
                        (if (char-whitespace? _next163799_)
                            (begin (read-char _port163786_) (_read-id163788_))
                            (let ((_id163804_ (read-syntax _port163786_)))
                              (if (gx#identifier? _id163804_)
                                  '#!void
                                  (gx#raise-syntax-error
                                   '#f
                                   '"Bad syntax; expected identifier"
                                   _id163804_))
                              (_read-opts163789_ _id163804_ '())))))))
               (_read-opts163789_
                (lambda (_id163791_ _opts163792_)
                  (let ((_next163794_ (peek-char _port163786_)))
                    (if (eof-object? _next163794_)
                        (gx#raise-syntax-error
                         '#f
                         '"Bad syntax; premature end of input"
                         (std/parser/grammar-reader#read-error-token
                          _port163786_))
                        (if (eq? '#\newline _next163794_)
                            (begin
                              (read-char _port163786_)
                              (values _id163791_ (reverse _opts163792_)))
                            (if (eq? _next163794_ '#\;)
                                (begin
                                  (read-line _port163786_)
                                  (values _id163791_ (reverse _opts163792_)))
                                (if (eq? _next163794_ '#\#)
                                    (gx#raise-syntax-error
                                     '#f
                                     '"Bad syntax; unexpected character"
                                     (std/parser/grammar-reader#read-error-token
                                      _port163786_)
                                     _next163794_)
                                    (if (char-whitespace? _next163794_)
                                        (begin
                                          (read-char _port163786_)
                                          (_read-opts163789_
                                           _id163791_
                                           _opts163792_))
                                        (let ((_opt163796_
                                               (read-syntax _port163786_)))
                                          (_read-opts163789_
                                           _id163791_
                                           (cons _opt163796_
                                                 _opts163792_))))))))))))
        (_read-id163788_))))
  (define std/parser/grammar-reader#raise-unexpected-token
    (lambda (_tok163784_)
      (gx#raise-syntax-error
       '#f
       '"Bad syntax; unexpected token"
       (std/parser/base#token->syntax _tok163784_))))
  (define std/parser/grammar-reader#read-parser-body
    (lambda (_port163626_)
      (letrec ((_locat-delta*163628_
                (lambda (_start163781_ _end163782_)
                  (std/parser/base#location->source-location
                   (std/parser/base#location-delta*
                    (##direct-structure-ref
                     _start163781_
                     '3
                     std/parser/base#token::t
                     '#f)
                    (##direct-structure-ref
                     _end163782_
                     '3
                     std/parser/base#token::t
                     '#f)))))
               (_make-rule163629_
                (lambda (_rule-id163776_
                         _prods163777_
                         _start163778_
                         _end163779_)
                  (let ((__tmp300672
                         (cons _rule-id163776_ (reverse _prods163777_)))
                        (__tmp300671
                         (_locat-delta*163628_ _start163778_ _end163779_)))
                    (declare (not safe))
                    (##structure AST::t __tmp300672 __tmp300671))))
               (_parse-rule163630_
                (lambda (_ts163709_ _K163710_ _E163711_)
                  (let* ((_rule163713_
                          (std/parser/grammar-reader#parse-rule-head__0
                           _ts163709_))
                         (_$e163715_
                          (##direct-structure-ref
                           _rule163713_
                           '1
                           std/parser/base#token::t
                           '#f)))
                    (if (eq? 'Rule _$e163715_)
                        (let* ((_g163718163732_
                                (lambda (_g163719163729_)
                                  (gx#raise-syntax-error
                                   '#f
                                   '"Bad syntax"
                                   _g163719163729_)))
                               (_g163717163773_
                                (lambda (_g163719163735_)
                                  (if (gx#stx-pair? _g163719163735_)
                                      (let ((_e163722163737_
                                             (gx#syntax-e _g163719163735_)))
                                        (let ((_hd163723163740_
                                               (let ()
                                                 (declare (not safe))
                                                 (##car _e163722163737_)))
                                              (_tl163724163742_
                                               (let ()
                                                 (declare (not safe))
                                                 (##cdr _e163722163737_))))
                                          (if (gx#stx-pair? _tl163724163742_)
                                              (let ((_e163725163745_
                                                     (gx#syntax-e
                                                      _tl163724163742_)))
                                                (let ((_hd163726163748_
                                                       (let ()
                                                         (declare (not safe))
                                                         (##car _e163725163745_)))
                                                      (_tl163727163750_
                                                       (let ()
                                                         (declare (not safe))
                                                         (##cdr _e163725163745_))))
                                                  (if (gx#stx-null?
                                                       _tl163727163750_)
                                                      ((lambda (_L163753_
                                                                _L163754_)
                                                         (let ()
                                                           (_parse-rule-k163631_
                                                            _ts163709_
                                                            _rule163713_
                                                            _L163754_
                                                            _L163753_
                                                            '()
                                                            _K163710_
                                                            _E163711_)))
                                                       _hd163726163748_
                                                       _hd163723163740_)
                                                      (_g163718163732_
                                                       _g163719163735_))))
                                              (_g163718163732_
                                               _g163719163735_))))
                                      (_g163718163732_ _g163719163735_)))))
                          (_g163717163773_
                           (##direct-structure-ref
                            _rule163713_
                            '2
                            std/parser/base#token::t
                            '#f)))
                        (_E163711_ _ts163709_ _rule163713_ '#f)))))
               (_parse-rule-k163631_
                (lambda (_ts163693_
                         _start163694_
                         _rule-id163695_
                         _head163696_
                         _prods163697_
                         _K163698_
                         _E163699_)
                  (let* ((_next163701_
                          (std/parser/lexer#token-stream-next _ts163693_))
                         (_$e163703_
                          (##direct-structure-ref
                           _next163701_
                           '1
                           std/parser/base#token::t
                           '#f)))
                    (if (eq? '$$ _$e163703_)
                        (let ((_$e163706_
                               (##direct-structure-ref
                                _next163701_
                                '2
                                std/parser/base#token::t
                                '#f)))
                          (if (eq? 'ACTION _$e163706_)
                              (_parse-rule-action163632_
                               _ts163693_
                               _start163694_
                               _rule-id163695_
                               _head163696_
                               _prods163697_
                               _K163698_
                               _E163699_)
                              (if (eq? 'ALTRULE _$e163706_)
                                  (_parse-rule-altrule163633_
                                   _ts163693_
                                   _start163694_
                                   _rule-id163695_
                                   (cons _head163696_ _prods163697_)
                                   _K163698_
                                   _E163699_)
                                  (if (eq? 'ENDRULE _$e163706_)
                                      (_K163698_
                                       _ts163693_
                                       (_make-rule163629_
                                        _rule-id163695_
                                        (cons _head163696_ _prods163697_)
                                        _start163694_
                                        _next163701_))
                                      (_E163699_
                                       _ts163693_
                                       _next163701_
                                       (_make-rule163629_
                                        _rule-id163695_
                                        (cons _head163696_ _prods163697_)
                                        _start163694_
                                        _next163701_))))))
                        (std/parser/grammar-reader#raise-unexpected-token
                         _next163701_)))))
               (_parse-rule-action163632_
                (lambda (_ts163672_
                         _start163673_
                         _rule-id163674_
                         _head163675_
                         _prods163676_
                         _K163677_
                         _E163678_)
                  (let ((_action163680_ (read-syntax _port163626_)))
                    (if (eof-object? _action163680_)
                        (gx#raise-syntax-error
                         '#f
                         '"Bad syntax; unexpected end of input"
                         _rule-id163674_)
                        (let* ((_ts163682_
                                (std/parser/grammar-reader#lex-parser
                                 _port163626_))
                               (_next163684_
                                (std/parser/lexer#token-stream-next
                                 _ts163682_)))
                          (let ((_$e163687_
                                 (##direct-structure-ref
                                  _next163684_
                                  '1
                                  std/parser/base#token::t
                                  '#f)))
                            (if (eq? '$$ _$e163687_)
                                (let ((_$e163690_
                                       (##direct-structure-ref
                                        _next163684_
                                        '2
                                        std/parser/base#token::t
                                        '#f)))
                                  (if (eq? 'ACTION _$e163690_)
                                      (std/parser/grammar-reader#raise-unexpected-token
                                       _next163684_)
                                      (if (eq? 'ALTRULE _$e163690_)
                                          (_parse-rule-altrule163633_
                                           _ts163682_
                                           _start163673_
                                           _rule-id163674_
                                           (cons _action163680_
                                                 (cons '=>
                                                       (cons _head163675_
                                                             _prods163676_)))
                                           _K163677_
                                           _E163678_)
                                          (if (eq? 'ENDRULE _$e163690_)
                                              (_K163677_
                                               _ts163682_
                                               (_make-rule163629_
                                                _rule-id163674_
                                                (cons _action163680_
                                                      (cons '=>
                                                            (cons _head163675_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _prods163676_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                _start163673_
                                                _next163684_))
                                              (_E163678_
                                               _ts163682_
                                               _next163684_
                                               (_make-rule163629_
                                                _rule-id163674_
                                                (cons _action163680_
                                                      (cons '=>
                                                            (cons _head163675_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _prods163676_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                _start163673_
                                                _next163684_))))))
                                (std/parser/grammar-reader#raise-unexpected-token
                                 _next163684_))))))))
               (_parse-rule-altrule163633_
                (lambda (_ts163649_
                         _start163650_
                         _rule-id163651_
                         _prods163652_
                         _K163653_
                         _E163654_)
                  (let* ((_prod163656_
                          (std/parser/grammar-reader#parse-rule-prod__0
                           _ts163649_))
                         (_$e163658_
                          (##direct-structure-ref
                           _prod163656_
                           '1
                           std/parser/base#token::t
                           '#f)))
                    (if (eq? 'Prod _$e163658_)
                        (let* ((_prod163661_
                                (##direct-structure-ref
                                 _prod163656_
                                 '2
                                 std/parser/base#token::t
                                 '#f))
                               (_next163663_
                                (std/parser/lexer#token-stream-next
                                 _ts163649_)))
                          (let ((_$e163666_
                                 (##direct-structure-ref
                                  _next163663_
                                  '1
                                  std/parser/base#token::t
                                  '#f)))
                            (if (eq? '$$ _$e163666_)
                                (let ((_$e163669_
                                       (##direct-structure-ref
                                        _next163663_
                                        '2
                                        std/parser/base#token::t
                                        '#f)))
                                  (if (eq? 'ACTION _$e163669_)
                                      (_parse-rule-action163632_
                                       _ts163649_
                                       _start163650_
                                       _rule-id163651_
                                       _prod163661_
                                       _prods163652_
                                       _K163653_
                                       _E163654_)
                                      (if (eq? 'ALTRULE _$e163669_)
                                          (_parse-rule-altrule163633_
                                           _ts163649_
                                           _start163650_
                                           _rule-id163651_
                                           (cons _prod163661_ _prods163652_)
                                           _K163653_
                                           _E163654_)
                                          (if (eq? 'ENDRULE _$e163669_)
                                              (_K163653_
                                               _ts163649_
                                               (_make-rule163629_
                                                _rule-id163651_
                                                (cons _prod163661_
                                                      _prods163652_)
                                                _start163650_
                                                _next163663_))
                                              (_E163654_
                                               _ts163649_
                                               _next163663_
                                               (_make-rule163629_
                                                _rule-id163651_
                                                (cons _prod163661_
                                                      _prods163652_)
                                                _start163650_
                                                _next163663_))))))
                                (std/parser/grammar-reader#raise-unexpected-token
                                 _next163663_))))
                        (std/parser/grammar-reader#raise-unexpected-token
                         _prod163656_))))))
        (let _lp163635_ ((_ts163637_
                          (std/parser/grammar-reader#lex-parser _port163626_))
                         (_rules163638_ '()))
          (_parse-rule163630_
           _ts163637_
           (lambda (_ts163640_ _rule163641_)
             (_lp163635_ _ts163640_ (cons _rule163641_ _rules163638_)))
           (lambda (_ts163643_ _tok163644_ _rule163645_)
             (let ((_rules163647_
                    (if _rule163645_
                        (cons _rule163645_ _rules163638_)
                        _rules163638_)))
               (if (eq? (##direct-structure-ref
                         _tok163644_
                         '2
                         std/parser/base#token::t
                         '#f)
                        'ENDRULE)
                   (_lp163635_ _ts163643_ _rules163647_)
                   (values (reverse _rules163647_) _tok163644_)))))))))
  (define std/parser/grammar-reader#read-lexer-body
    (lambda (_port163574_)
      (letrec ((_make-rule163576_
                (lambda (_rx163622_ _action163623_ _end163624_)
                  (let ((__tmp300674
                         (cons (##direct-structure-ref
                                _rx163622_
                                '2
                                std/parser/base#token::t
                                '#f)
                               (cons _action163623_ '())))
                        (__tmp300673
                         (std/parser/base#location->source-location
                          (std/parser/base#location-delta
                           (##direct-structure-ref
                            _rx163622_
                            '3
                            std/parser/base#token::t
                            '#f)
                           _end163624_))))
                    (declare (not safe))
                    (##structure AST::t __tmp300674 __tmp300673))))
               (_parse-rule163577_
                (lambda (_ts163613_ _K163614_ _E163615_)
                  (let* ((_next163617_
                          (std/parser/lexer#token-stream-next _ts163613_))
                         (_$e163619_
                          (##direct-structure-ref
                           _next163617_
                           '1
                           std/parser/base#token::t
                           '#f)))
                    (if (eq? 'RX _$e163619_)
                        (_parse-rule-k163578_
                         _ts163613_
                         _next163617_
                         _K163614_
                         _E163615_)
                        (_E163615_ _ts163613_ _next163617_)))))
               (_parse-rule-k163578_
                (lambda (_ts163591_ _rx163592_ _K163593_ _E163594_)
                  (let* ((_next163596_
                          (std/parser/lexer#token-stream-next _ts163591_))
                         (_$e163598_
                          (##direct-structure-ref
                           _next163596_
                           '1
                           std/parser/base#token::t
                           '#f)))
                    (if (eq? '$$ _$e163598_)
                        (let ((_$e163601_
                               (##direct-structure-ref
                                _next163596_
                                '2
                                std/parser/base#token::t
                                '#f)))
                          (if (eq? 'ACTION _$e163601_)
                              (let ((_action163604_
                                     (read-syntax _port163574_)))
                                (if (eof-object? _action163604_)
                                    (gx#raise-syntax-error
                                     '#f
                                     '"Bad syntax; unexpected end of input"
                                     (std/parser/base#token->syntax
                                      _next163596_))
                                    (let* ((_ts163606_
                                            (std/parser/grammar-reader#lex-lexer
                                             _port163574_))
                                           (_end163608_
                                            (std/parser/lexer#token-stream-loc
                                             _ts163606_))
                                           (_rule163610_
                                            (_make-rule163576_
                                             _rx163592_
                                             _action163604_
                                             _end163608_)))
                                      (_K163593_ _ts163606_ _rule163610_))))
                              (std/parser/grammar-reader#raise-unexpected-token
                               _next163596_)))
                        (std/parser/grammar-reader#raise-unexpected-token
                         _next163596_))))))
        (let _lp163580_ ((_ts163582_
                          (std/parser/grammar-reader#lex-lexer _port163574_))
                         (_rules163583_ '()))
          (_parse-rule163577_
           _ts163582_
           (lambda (_ts163585_ _rule163586_)
             (_lp163580_ _ts163585_ (cons _rule163586_ _rules163583_)))
           (lambda (_ts163588_ _tok163589_)
             (if (eq? (##direct-structure-ref
                       _tok163589_
                       '2
                       std/parser/base#token::t
                       '#f)
                      'ENDRULE)
                 (_lp163580_ _ts163588_ _rules163583_)
                 (values (reverse _rules163583_) _tok163589_))))))))
  (define std/parser/grammar-reader#WS
    (std/parser/rlang#@charset '(#\space #\tab)))
  (define std/parser/grammar-reader#lex-parser::L
    (cons (std/parser/rlang#@cat__2
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\%))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\%))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\p))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\a))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\r))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\s))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\e))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\r)))
          (cons (std/parser/rlang#@cat__2
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\%))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\%))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\l))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\e))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\x))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\e))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\r)))
                (cons (std/parser/rlang#@cat__1
                       (let ()
                         (declare (not safe))
                         (##structure std/parser/rlang#char::t '#\=))
                       (let ()
                         (declare (not safe))
                         (##structure std/parser/rlang#char::t '#\>)))
                      (cons (let ()
                              (declare (not safe))
                              (##structure std/parser/rlang#char::t '#\|))
                            (cons (std/parser/rlang#@cat__1
                                   (std/parser/rlang#@rep+
                                    (let ()
                                      (declare (not safe))
                                      (##structure
                                       std/parser/rlang#char::t
                                       '#\newline)))
                                   (std/parser/rlang#@rep+
                                    std/parser/grammar-reader#WS))
                                  (cons (std/parser/rlang#@rep+
                                         (let ()
                                           (declare (not safe))
                                           (##structure
                                            std/parser/rlang#char::t
                                            '#\newline)))
                                        (cons (std/parser/rlang#@rep+
                                               std/parser/grammar-reader#WS)
                                              (cons (std/parser/rlang#@cat__1
                                                     (let ()
                                                       (declare (not safe))
                                                       (##structure
                                                        std/parser/rlang#char::t
                                                        '#\;))
                                                     (std/parser/rlang#@rep+
                                                      (std/parser/rlang#@negset
                                                       '(#\newline))))
                                                    (cons (std/parser/rlang#@cat__1
                                                           (let ()
                                                             (declare
                                                               (not safe))
                                                             (##structure
                                                              std/parser/rlang#char::t
                                                              '#\<))
                                                           (let ()
                                                             (declare
                                                               (not safe))
                                                             (##structure
                                                              std/parser/rlang#char::t
                                                              '#\-)))
                                                          (cons (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (declare (not safe))
                          (##structure std/parser/rlang#char::t '#\())
                        (cons (let ()
                                (declare (not safe))
                                (##structure std/parser/rlang#char::t '#\)))
                              (cons (std/parser/rlang#@cat__2
                                     (let ()
                                       (declare (not safe))
                                       (##structure
                                        std/parser/rlang#char::t
                                        '#\'))
                                     (std/parser/rlang#@rep*
                                      (std/parser/rlang#@negset '(#\')))
                                     (let ()
                                       (declare (not safe))
                                       (##structure
                                        std/parser/rlang#char::t
                                        '#\')))
                                    (cons (std/parser/rlang#@cat__2
                                           (let ()
                                             (declare (not safe))
                                             (##structure
                                              std/parser/rlang#char::t
                                              '#\"))
                                           (std/parser/rlang#@rep*
                                            (std/parser/rlang#@alt__1
                                             (let ()
                                               (declare (not safe))
                                               (##structure
                                                std/parser/rlang#char::t
                                                '#\"))
                                             (std/parser/rlang#@negset
                                              '(#\"))))
                                           (let ()
                                             (declare (not safe))
                                             (##structure
                                              std/parser/rlang#char::t
                                              '#\")))
                                          (cons (let ()
                                                  (declare (not safe))
                                                  (##structure
                                                   std/parser/rlang#char::t
                                                   '#\*))
                                                (cons (let ()
                                                        (declare (not safe))
                                                        (##structure
                                                         std/parser/rlang#char::t
                                                         '#\+))
                                                      (cons (let ()
                                                              (declare
                                                                (not safe))
                                                              (##structure
                                                               std/parser/rlang#char::t
                                                               '#\?))
                                                            (cons (std/parser/rlang#@rep+
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           (std/parser/rlang#@charset
                            '(#\-
                              #\+
                              #\*
                              #\/
                              #\=
                              #\?
                              #\<
                              #\>
                              #\~
                              #\!
                              #\@
                              #\$
                              #\%
                              #\^
                              #\&
                              #\:
                              #\_
                              #\a
                              #\b
                              #\c
                              #\d
                              #\e
                              #\f
                              #\g
                              #\h
                              #\i
                              #\j
                              #\k
                              #\l
                              #\m
                              #\n
                              #\o
                              #\p
                              #\q
                              #\r
                              #\s
                              #\t
                              #\u
                              #\v
                              #\w
                              #\x
                              #\y
                              #\z
                              #\A
                              #\B
                              #\C
                              #\D
                              #\E
                              #\F
                              #\G
                              #\H
                              #\I
                              #\J
                              #\K
                              #\L
                              #\M
                              #\N
                              #\O
                              #\P
                              #\Q
                              #\R
                              #\S
                              #\T
                              #\U
                              #\V
                              #\W
                              #\X
                              #\Y
                              #\Z
                              #\0
                              #\1
                              #\2
                              #\3
                              #\4
                              #\5
                              #\6
                              #\7
                              #\8
                              #\9)))
                          '()))))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
  (define std/parser/grammar-reader#lex-parser::R
    (cons (lambda (_@@163521_ _@loc163522_)
            (let ()
              (declare (not safe))
              (##structure
               std/parser/base#token::t
               '$$
               '%%parser
               _@loc163522_)))
          (cons (lambda (_@@163524_ _@loc163525_)
                  (let ()
                    (declare (not safe))
                    (##structure
                     std/parser/base#token::t
                     '$$
                     '%%lexer
                     _@loc163525_)))
                (cons (lambda (_@@163527_ _@loc163528_)
                        (let ()
                          (declare (not safe))
                          (##structure
                           std/parser/base#token::t
                           '$$
                           'ACTION
                           _@loc163528_)))
                      (cons (lambda (_@@163530_ _@loc163531_)
                              (let ()
                                (declare (not safe))
                                (##structure
                                 std/parser/base#token::t
                                 '$$
                                 'ALTRULE
                                 _@loc163531_)))
                            (cons (lambda (_@@163533_ _@loc163535_)
                                    std/parser/lexer#$)
                                  (cons (lambda (_@@163538_ _@loc163539_)
                                          (let ()
                                            (declare (not safe))
                                            (##structure
                                             std/parser/base#token::t
                                             '$$
                                             'ENDRULE
                                             _@loc163539_)))
                                        (cons (lambda (_@@163541_ _@loc163542_)
                                                std/parser/lexer#$)
                                              (cons (lambda (_@@163544_
                                                             _@loc163545_)
                                                      std/parser/lexer#$)
                                                    (cons (lambda (_@@163547_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           _@loc163548_)
                    (let ()
                      (declare (not safe))
                      (##structure
                       std/parser/base#token::t
                       'PROD
                       '<-
                       _@loc163548_)))
                  (cons (lambda (_@@163550_ _@loc163551_)
                          (let ()
                            (declare (not safe))
                            (##structure
                             std/parser/base#token::t
                             'LPAREN
                             '|(|
                             _@loc163551_)))
                        (cons (lambda (_@@163553_ _@loc163554_)
                                (let ()
                                  (declare (not safe))
                                  (##structure
                                   std/parser/base#token::t
                                   'RPAREN
                                   '|)|
                                   _@loc163554_)))
                              (cons (lambda (_@@163556_ _@loc163557_)
                                      (let ((__tmp300675
                                             (std/parser/grammar-reader#string->token-symbol
                                              _@@163556_)))
                                        (declare (not safe))
                                        (##structure
                                         std/parser/base#token::t
                                         'EQ
                                         __tmp300675
                                         _@loc163557_)))
                                    (cons (lambda (_@@163559_ _@loc163560_)
                                            (let ((__tmp300676
                                                   (std/parser/grammar-reader#string->token-string
                                                    _@@163559_)))
                                              (declare (not safe))
                                              (##structure
                                               std/parser/base#token::t
                                               'EQUAL
                                               __tmp300676
                                               _@loc163560_)))
                                          (cons (lambda (_@@163562_
                                                         _@loc163563_)
                                                  (let ()
                                                    (declare (not safe))
                                                    (##structure
                                                     std/parser/base#token::t
                                                     'STAR
                                                     '*
                                                     _@loc163563_)))
                                                (cons (lambda (_@@163565_
                                                               _@loc163566_)
                                                        (let ()
                                                          (declare (not safe))
                                                          (##structure
                                                           std/parser/base#token::t
                                                           'PLUS
                                                           '+
                                                           _@loc163566_)))
                                                      (cons (lambda (_@@163568_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                             _@loc163569_)
                      (let ()
                        (declare (not safe))
                        (##structure
                         std/parser/base#token::t
                         'MAYBE
                         '?
                         _@loc163569_)))
                    (cons (lambda (_@@163571_ _@loc163572_)
                            (let ((__tmp300677 (string->symbol _@@163571_)))
                              (declare (not safe))
                              (##structure
                               std/parser/base#token::t
                               'Ident
                               __tmp300677
                               _@loc163572_)))
                          '()))))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
  (define std/parser/grammar-reader#lex-parser
    (lambda (_input163518_)
      (std/parser/lexer#lex
       _input163518_
       std/parser/grammar-reader#lex-parser::L
       std/parser/grammar-reader#lex-parser::R)))
  (define std/parser/grammar-reader#parse-rule-head__%
    (lambda (_input163494_ _$lexer163496_ _wrap-e163498_)
      (std/parser/defparser#parser-parse
       'parse-rule-head
       (std/parser/defparser#parser-input-stream _input163494_ _$lexer163496_)
       std/parser/grammar-reader#Rule
       _wrap-e163498_)))
  (define std/parser/grammar-reader#parse-rule-head__0
    (lambda (_input163503_)
      (let* ((_$lexer163505_ std/parser/grammar-reader#lex-parser)
             (_wrap-e163507_ std/parser/base#wrap-ast))
        (std/parser/grammar-reader#parse-rule-head__%
         _input163503_
         _$lexer163505_
         _wrap-e163507_))))
  (define std/parser/grammar-reader#parse-rule-head__1
    (lambda (_input163509_ _$lexer163510_)
      (let ((_wrap-e163512_ std/parser/base#wrap-ast))
        (std/parser/grammar-reader#parse-rule-head__%
         _input163509_
         _$lexer163510_
         _wrap-e163512_))))
  (define std/parser/grammar-reader#parse-rule-head
    (lambda _g300679_
      (let ((_g300678_ (let () (declare (not safe)) (##length _g300679_))))
        (cond ((let () (declare (not safe)) (##fx= _g300678_ 1))
               (apply std/parser/grammar-reader#parse-rule-head__0 _g300679_))
              ((let () (declare (not safe)) (##fx= _g300678_ 2))
               (apply std/parser/grammar-reader#parse-rule-head__1 _g300679_))
              ((let () (declare (not safe)) (##fx= _g300678_ 3))
               (apply std/parser/grammar-reader#parse-rule-head__% _g300679_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/parser/grammar-reader#parse-rule-head
                _g300679_))))))
  (define std/parser/grammar-reader#Rule::1::app::cat::1
    (lambda (_ts163487_ _toks163488_ _wrap-e163489_ _K163490_ _E163491_)
      (std/parser/grammar-reader#Ident
       _ts163487_
       _toks163488_
       _wrap-e163489_
       _K163490_
       _E163491_)))
  (define std/parser/grammar-reader#Rule::1::app::cat::2
    (lambda (_ts163476_ _toks163477_ _wrap-e163478_ _K163479_ _E163480_)
      (let* ((_next163482_ (std/parser/lexer#token-stream-next _ts163476_))
             (_toks163484_ (cons _next163482_ _toks163477_)))
        (if (eq? (##direct-structure-ref
                  _next163482_
                  '2
                  std/parser/base#token::t
                  '#f)
                 '<-)
            (_K163479_ _toks163484_ _next163482_)
            (_E163480_ _toks163484_)))))
  (define std/parser/grammar-reader#Rule::1::app::cat::3
    (lambda (_ts163470_ _toks163471_ _wrap-e163472_ _K163473_ _E163474_)
      (std/parser/grammar-reader#Prod
       _ts163470_
       _toks163471_
       _wrap-e163472_
       _K163473_
       _E163474_)))
  (define std/parser/grammar-reader#Rule::1::app
    (lambda (_ts163454_ _toks163455_ _wrap-e163456_ _K163457_ _E163458_)
      (std/parser/grammar-reader#Ident
       _ts163454_
       _toks163455_
       _wrap-e163456_
       (lambda (_toks163460_ _$1162811163461_)
         (std/parser/grammar-reader#Rule::1::app::cat::2
          _ts163454_
          _toks163460_
          _wrap-e163456_
          (lambda (_toks163464_ _g300680_)
            (std/parser/grammar-reader#Prod
             _ts163454_
             _toks163464_
             _wrap-e163456_
             (lambda (_toks163466_ _$2162812163467_)
               (_K163457_ _toks163466_ _$1162811163461_ _$2162812163467_))
             _E163458_))
          _E163458_))
       _E163458_)))
  (define std/parser/grammar-reader#Rule::1
    (lambda (_ts163430_ _toks163431_ _wrap-e163432_ _K163433_ _E163434_)
      (let ((_start163436_ (std/parser/lexer#token-stream-loc _ts163430_)))
        (std/parser/grammar-reader#Rule::1::app
         _ts163430_
         _toks163431_
         _wrap-e163432_
         (lambda (_toks163439_ _$1162813163440_ _$2162814163442_)
           (let* ((_end163445_ (std/parser/lexer#token-stream-loc _ts163430_))
                  (_@loc163448_
                   (std/parser/base#location-delta*
                    _start163436_
                    _end163445_)))
             (_K163433_
              _toks163439_
              (let ((__tmp300681
                     (_wrap-e163432_
                      ((lambda (_$1163451_ _$2163452_)
                         (cons _$1163451_ (cons _$2163452_ '())))
                       (##direct-structure-ref
                        _$1162813163440_
                        '2
                        std/parser/base#token::t
                        '#f)
                       (##direct-structure-ref
                        _$2162814163442_
                        '2
                        std/parser/base#token::t
                        '#f))
                      _@loc163448_)))
                (declare (not safe))
                (##structure
                 std/parser/base#token::t
                 'Rule
                 __tmp300681
                 _@loc163448_)))))
         _E163434_))))
  (define std/parser/grammar-reader#Rule::2
    (lambda (_ts163418_ _toks163419_ _wrap-e163420_ _K163421_ _E163422_)
      (let* ((_next163424_ (std/parser/lexer#token-stream-next _ts163418_))
             (_toks163427_ (cons _next163424_ _toks163419_)))
        (if (std/parser/lexer#$$? _next163424_)
            (_K163421_ _toks163427_ _next163424_)
            (_E163422_ _toks163427_)))))
  (define std/parser/grammar-reader#Rule
    (lambda (_ts163404_ _toks163406_ _wrap-e163408_ _K163410_ _E163412_)
      (std/parser/grammar-reader#Rule::1
       _ts163404_
       _toks163406_
       _wrap-e163408_
       _K163410_
       (lambda (_xtoks163415_)
         (std/parser/defparser#parser-rewind
          _ts163404_
          _xtoks163415_
          _toks163406_)
         (std/parser/grammar-reader#Rule::2
          _ts163404_
          _toks163406_
          _wrap-e163408_
          _K163410_
          _E163412_)))))
  (define std/parser/grammar-reader#parse-rule-prod__%
    (lambda (_input163380_ _$lexer163382_ _wrap-e163384_)
      (std/parser/defparser#parser-parse
       'parse-rule-prod
       (std/parser/defparser#parser-input-stream _input163380_ _$lexer163382_)
       std/parser/grammar-reader#Prod
       _wrap-e163384_)))
  (define std/parser/grammar-reader#parse-rule-prod__0
    (lambda (_input163389_)
      (let* ((_$lexer163391_ std/parser/grammar-reader#lex-parser)
             (_wrap-e163393_ std/parser/base#wrap-ast))
        (std/parser/grammar-reader#parse-rule-prod__%
         _input163389_
         _$lexer163391_
         _wrap-e163393_))))
  (define std/parser/grammar-reader#parse-rule-prod__1
    (lambda (_input163395_ _$lexer163396_)
      (let ((_wrap-e163398_ std/parser/base#wrap-ast))
        (std/parser/grammar-reader#parse-rule-prod__%
         _input163395_
         _$lexer163396_
         _wrap-e163398_))))
  (define std/parser/grammar-reader#parse-rule-prod
    (lambda _g300683_
      (let ((_g300682_ (let () (declare (not safe)) (##length _g300683_))))
        (cond ((let () (declare (not safe)) (##fx= _g300682_ 1))
               (apply std/parser/grammar-reader#parse-rule-prod__0 _g300683_))
              ((let () (declare (not safe)) (##fx= _g300682_ 2))
               (apply std/parser/grammar-reader#parse-rule-prod__1 _g300683_))
              ((let () (declare (not safe)) (##fx= _g300682_ 3))
               (apply std/parser/grammar-reader#parse-rule-prod__% _g300683_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/parser/grammar-reader#parse-rule-prod
                _g300683_))))))
  (define std/parser/grammar-reader#Prod::app::rep*
    (lambda (_ts163373_ _toks163374_ _wrap-e163375_ _K163376_ _E163377_)
      (std/parser/grammar-reader#Pattern
       _ts163373_
       _toks163374_
       _wrap-e163375_
       _K163376_
       _E163377_)))
  (define std/parser/grammar-reader#Prod::app
    (lambda (_ts163351_ _toks163352_ _wrap-e163353_ _K163354_ _E163355_)
      (std/parser/grammar-reader#Pattern
       _ts163351_
       _toks163352_
       _wrap-e163353_
       (lambda (_toks163357_ _g162816163358_)
         (let _lp163361_ ((_toks163364_ _toks163357_)
                          (_$1162815163365_ (cons _g162816163358_ '())))
           (std/parser/grammar-reader#Pattern
            _ts163351_
            _toks163364_
            _wrap-e163353_
            (lambda (_toks163368_ _g162816163369_)
              (_lp163361_
               _toks163368_
               (cons _g162816163369_ _$1162815163365_)))
            (lambda (_xtoks163371_)
              (std/parser/defparser#parser-rewind
               _ts163351_
               _xtoks163371_
               _toks163364_)
              (_K163354_ _toks163364_ (reverse _$1162815163365_))))))
       _E163355_)))
  (define std/parser/grammar-reader#Prod
    (lambda (_ts163329_ _toks163330_ _wrap-e163331_ _K163332_ _E163333_)
      (let ((_start163335_ (std/parser/lexer#token-stream-loc _ts163329_)))
        (std/parser/grammar-reader#Prod::app
         _ts163329_
         _toks163330_
         _wrap-e163331_
         (lambda (_toks163337_ _$1162817163338_)
           (let* ((_end163341_ (std/parser/lexer#token-stream-loc _ts163329_))
                  (_@loc163343_
                   (std/parser/base#location-delta*
                    _start163335_
                    _end163341_)))
             (_K163332_
              _toks163337_
              (let ((__tmp300684
                     (_wrap-e163331_
                      ((lambda (_$1163346_)
                         (std/parser/grammar-reader#simplify
                          (cons '@cat _$1163346_)))
                       ((lambda (_$x163348_)
                          (map std/parser/base#token-e _$x163348_))
                        _$1162817163338_))
                      _@loc163343_)))
                (declare (not safe))
                (##structure
                 std/parser/base#token::t
                 'Prod
                 __tmp300684
                 _@loc163343_)))))
         _E163333_))))
  (define std/parser/grammar-reader#Pattern::1::app::cat::1
    (lambda (_ts163323_ _toks163324_ _wrap-e163325_ _K163326_ _E163327_)
      (std/parser/grammar-reader#SimplePattern
       _ts163323_
       _toks163324_
       _wrap-e163325_
       _K163326_
       _E163327_)))
  (define std/parser/grammar-reader#Pattern::1::app::cat::2
    (lambda (_ts163312_ _toks163313_ _wrap-e163314_ _K163315_ _E163316_)
      (let* ((_next163318_ (std/parser/lexer#token-stream-next _ts163312_))
             (_toks163320_ (cons _next163318_ _toks163313_)))
        (if (eq? (##direct-structure-ref
                  _next163318_
                  '2
                  std/parser/base#token::t
                  '#f)
                 '+)
            (_K163315_ _toks163320_ _next163318_)
            (_E163316_ _toks163320_)))))
  (define std/parser/grammar-reader#Pattern::1::app
    (lambda (_ts163300_ _toks163301_ _wrap-e163302_ _K163303_ _E163304_)
      (std/parser/grammar-reader#SimplePattern
       _ts163300_
       _toks163301_
       _wrap-e163302_
       (lambda (_toks163306_ _$1162818163307_)
         (std/parser/grammar-reader#Pattern::1::app::cat::2
          _ts163300_
          _toks163306_
          _wrap-e163302_
          (lambda (_toks163310_ _g300685_)
            (_K163303_ _toks163310_ _$1162818163307_))
          _E163304_))
       _E163304_)))
  (define std/parser/grammar-reader#Pattern::1
    (lambda (_ts163281_ _toks163282_ _wrap-e163283_ _K163284_ _E163285_)
      (let ((_start163287_ (std/parser/lexer#token-stream-loc _ts163281_)))
        (std/parser/grammar-reader#Pattern::1::app
         _ts163281_
         _toks163282_
         _wrap-e163283_
         (lambda (_toks163289_ _$1162819163290_)
           (let* ((_end163293_ (std/parser/lexer#token-stream-loc _ts163281_))
                  (_@loc163295_
                   (std/parser/base#location-delta*
                    _start163287_
                    _end163293_)))
             (_K163284_
              _toks163289_
              (let ((__tmp300686
                     (_wrap-e163283_
                      ((lambda (_$1163298_)
                         (cons '@rep+ (cons _$1163298_ '())))
                       (##direct-structure-ref
                        _$1162819163290_
                        '2
                        std/parser/base#token::t
                        '#f))
                      _@loc163295_)))
                (declare (not safe))
                (##structure
                 std/parser/base#token::t
                 'Pattern
                 __tmp300686
                 _@loc163295_)))))
         _E163285_))))
  (define std/parser/grammar-reader#Pattern::2::app::cat::1
    (lambda (_ts163275_ _toks163276_ _wrap-e163277_ _K163278_ _E163279_)
      (std/parser/grammar-reader#SimplePattern
       _ts163275_
       _toks163276_
       _wrap-e163277_
       _K163278_
       _E163279_)))
  (define std/parser/grammar-reader#Pattern::2::app::cat::2
    (lambda (_ts163264_ _toks163265_ _wrap-e163266_ _K163267_ _E163268_)
      (let* ((_next163270_ (std/parser/lexer#token-stream-next _ts163264_))
             (_toks163272_ (cons _next163270_ _toks163265_)))
        (if (eq? (##direct-structure-ref
                  _next163270_
                  '2
                  std/parser/base#token::t
                  '#f)
                 '*)
            (_K163267_ _toks163272_ _next163270_)
            (_E163268_ _toks163272_)))))
  (define std/parser/grammar-reader#Pattern::2::app
    (lambda (_ts163252_ _toks163253_ _wrap-e163254_ _K163255_ _E163256_)
      (std/parser/grammar-reader#SimplePattern
       _ts163252_
       _toks163253_
       _wrap-e163254_
       (lambda (_toks163258_ _$1162820163259_)
         (std/parser/grammar-reader#Pattern::2::app::cat::2
          _ts163252_
          _toks163258_
          _wrap-e163254_
          (lambda (_toks163262_ _g300687_)
            (_K163255_ _toks163262_ _$1162820163259_))
          _E163256_))
       _E163256_)))
  (define std/parser/grammar-reader#Pattern::2
    (lambda (_ts163233_ _toks163234_ _wrap-e163235_ _K163236_ _E163237_)
      (let ((_start163239_ (std/parser/lexer#token-stream-loc _ts163233_)))
        (std/parser/grammar-reader#Pattern::2::app
         _ts163233_
         _toks163234_
         _wrap-e163235_
         (lambda (_toks163241_ _$1162821163242_)
           (let* ((_end163245_ (std/parser/lexer#token-stream-loc _ts163233_))
                  (_@loc163247_
                   (std/parser/base#location-delta*
                    _start163239_
                    _end163245_)))
             (_K163236_
              _toks163241_
              (let ((__tmp300688
                     (_wrap-e163235_
                      ((lambda (_$1163250_)
                         (cons '@rep* (cons _$1163250_ '())))
                       (##direct-structure-ref
                        _$1162821163242_
                        '2
                        std/parser/base#token::t
                        '#f))
                      _@loc163247_)))
                (declare (not safe))
                (##structure
                 std/parser/base#token::t
                 'Pattern
                 __tmp300688
                 _@loc163247_)))))
         _E163237_))))
  (define std/parser/grammar-reader#Pattern::3::app::cat::1
    (lambda (_ts163227_ _toks163228_ _wrap-e163229_ _K163230_ _E163231_)
      (std/parser/grammar-reader#SimplePattern
       _ts163227_
       _toks163228_
       _wrap-e163229_
       _K163230_
       _E163231_)))
  (define std/parser/grammar-reader#Pattern::3::app::cat::2
    (lambda (_ts163216_ _toks163217_ _wrap-e163218_ _K163219_ _E163220_)
      (let* ((_next163222_ (std/parser/lexer#token-stream-next _ts163216_))
             (_toks163224_ (cons _next163222_ _toks163217_)))
        (if (eq? (##direct-structure-ref
                  _next163222_
                  '2
                  std/parser/base#token::t
                  '#f)
                 '?)
            (_K163219_ _toks163224_ _next163222_)
            (_E163220_ _toks163224_)))))
  (define std/parser/grammar-reader#Pattern::3::app
    (lambda (_ts163204_ _toks163205_ _wrap-e163206_ _K163207_ _E163208_)
      (std/parser/grammar-reader#SimplePattern
       _ts163204_
       _toks163205_
       _wrap-e163206_
       (lambda (_toks163210_ _$1162822163211_)
         (std/parser/grammar-reader#Pattern::3::app::cat::2
          _ts163204_
          _toks163210_
          _wrap-e163206_
          (lambda (_toks163214_ _g300689_)
            (_K163207_ _toks163214_ _$1162822163211_))
          _E163208_))
       _E163208_)))
  (define std/parser/grammar-reader#Pattern::3
    (lambda (_ts163185_ _toks163186_ _wrap-e163187_ _K163188_ _E163189_)
      (let ((_start163191_ (std/parser/lexer#token-stream-loc _ts163185_)))
        (std/parser/grammar-reader#Pattern::3::app
         _ts163185_
         _toks163186_
         _wrap-e163187_
         (lambda (_toks163193_ _$1162823163194_)
           (let* ((_end163197_ (std/parser/lexer#token-stream-loc _ts163185_))
                  (_@loc163199_
                   (std/parser/base#location-delta*
                    _start163191_
                    _end163197_)))
             (_K163188_
              _toks163193_
              (let ((__tmp300690
                     (_wrap-e163187_
                      ((lambda (_$1163202_)
                         (cons '@maybe (cons _$1163202_ '())))
                       (##direct-structure-ref
                        _$1162823163194_
                        '2
                        std/parser/base#token::t
                        '#f))
                      _@loc163199_)))
                (declare (not safe))
                (##structure
                 std/parser/base#token::t
                 'Pattern
                 __tmp300690
                 _@loc163199_)))))
         _E163189_))))
  (define std/parser/grammar-reader#Pattern::4::app
    (lambda (_ts163179_ _toks163180_ _wrap-e163181_ _K163182_ _E163183_)
      (std/parser/grammar-reader#SimplePattern
       _ts163179_
       _toks163180_
       _wrap-e163181_
       _K163182_
       _E163183_)))
  (define std/parser/grammar-reader#Pattern::4
    (lambda (_ts163160_ _toks163161_ _wrap-e163162_ _K163163_ _E163164_)
      (let ((_start163166_ (std/parser/lexer#token-stream-loc _ts163160_)))
        (std/parser/grammar-reader#SimplePattern
         _ts163160_
         _toks163161_
         _wrap-e163162_
         (lambda (_toks163168_ _$1162824163169_)
           (let* ((_end163172_ (std/parser/lexer#token-stream-loc _ts163160_))
                  (_@loc163174_
                   (std/parser/base#location-delta*
                    _start163166_
                    _end163172_)))
             (_K163163_
              _toks163168_
              (let ((__tmp300691
                     (_wrap-e163162_
                      ((lambda (_$1163177_) _$1163177_)
                       (##direct-structure-ref
                        _$1162824163169_
                        '2
                        std/parser/base#token::t
                        '#f))
                      _@loc163174_)))
                (declare (not safe))
                (##structure
                 std/parser/base#token::t
                 'Pattern
                 __tmp300691
                 _@loc163174_)))))
         _E163164_))))
  (define std/parser/grammar-reader#Pattern
    (lambda (_ts163148_ _toks163149_ _wrap-e163150_ _K163151_ _E163152_)
      (std/parser/grammar-reader#Pattern::1
       _ts163148_
       _toks163149_
       _wrap-e163150_
       _K163151_
       (lambda (_xtoks163154_)
         (std/parser/defparser#parser-rewind
          _ts163148_
          _xtoks163154_
          _toks163149_)
         (std/parser/grammar-reader#Pattern::2
          _ts163148_
          _toks163149_
          _wrap-e163150_
          _K163151_
          (lambda (_xtoks163156_)
            (std/parser/defparser#parser-rewind
             _ts163148_
             _xtoks163156_
             _toks163149_)
            (std/parser/grammar-reader#Pattern::3
             _ts163148_
             _toks163149_
             _wrap-e163150_
             _K163151_
             (lambda (_xtoks163158_)
               (std/parser/defparser#parser-rewind
                _ts163148_
                _xtoks163158_
                _toks163149_)
               (std/parser/grammar-reader#Pattern::4
                _ts163148_
                _toks163149_
                _wrap-e163150_
                _K163151_
                _E163152_)))))))))
  (define std/parser/grammar-reader#SimplePattern::1::app::cat::1
    (lambda (_ts163137_ _toks163138_ _wrap-e163139_ _K163140_ _E163141_)
      (let* ((_next163143_ (std/parser/lexer#token-stream-next _ts163137_))
             (_toks163145_ (cons _next163143_ _toks163138_)))
        (if (eq? (##direct-structure-ref
                  _next163143_
                  '2
                  std/parser/base#token::t
                  '#f)
                 '|(|)
            (_K163140_ _toks163145_ _next163143_)
            (_E163141_ _toks163145_)))))
  (define std/parser/grammar-reader#SimplePattern::1::app::cat::2
    (lambda (_ts163131_ _toks163132_ _wrap-e163133_ _K163134_ _E163135_)
      (std/parser/grammar-reader#Ident
       _ts163131_
       _toks163132_
       _wrap-e163133_
       _K163134_
       _E163135_)))
  (define std/parser/grammar-reader#SimplePattern::1::app::cat::3
    (lambda (_ts163125_ _toks163126_ _wrap-e163127_ _K163128_ _E163129_)
      (std/parser/grammar-reader#Ident
       _ts163125_
       _toks163126_
       _wrap-e163127_
       _K163128_
       _E163129_)))
  (define std/parser/grammar-reader#SimplePattern::1::app::cat::4
    (lambda (_ts163114_ _toks163115_ _wrap-e163116_ _K163117_ _E163118_)
      (let* ((_next163120_ (std/parser/lexer#token-stream-next _ts163114_))
             (_toks163122_ (cons _next163120_ _toks163115_)))
        (if (eq? (##direct-structure-ref
                  _next163120_
                  '2
                  std/parser/base#token::t
                  '#f)
                 '|)|)
            (_K163117_ _toks163122_ _next163120_)
            (_E163118_ _toks163122_)))))
  (define std/parser/grammar-reader#SimplePattern::1::app
    (lambda (_ts163096_ _toks163097_ _wrap-e163098_ _K163099_ _E163100_)
      (std/parser/grammar-reader#SimplePattern::1::app::cat::1
       _ts163096_
       _toks163097_
       _wrap-e163098_
       (lambda (_toks163102_ _g300692_)
         (std/parser/grammar-reader#Ident
          _ts163096_
          _toks163102_
          _wrap-e163098_
          (lambda (_toks163104_ _$1162825163105_)
            (std/parser/grammar-reader#Ident
             _ts163096_
             _toks163104_
             _wrap-e163098_
             (lambda (_toks163108_ _$2162826163109_)
               (std/parser/grammar-reader#SimplePattern::1::app::cat::4
                _ts163096_
                _toks163108_
                _wrap-e163098_
                (lambda (_toks163112_ _g300693_)
                  (_K163099_ _toks163112_ _$1162825163105_ _$2162826163109_))
                _E163100_))
             _E163100_))
          _E163100_))
       _E163100_)))
  (define std/parser/grammar-reader#SimplePattern::1
    (lambda (_ts163074_ _toks163075_ _wrap-e163076_ _K163077_ _E163078_)
      (let ((_start163080_ (std/parser/lexer#token-stream-loc _ts163074_)))
        (std/parser/grammar-reader#SimplePattern::1::app
         _ts163074_
         _toks163075_
         _wrap-e163076_
         (lambda (_toks163082_ _$1162827163083_ _$2162828163085_)
           (let* ((_end163088_ (std/parser/lexer#token-stream-loc _ts163074_))
                  (_@loc163090_
                   (std/parser/base#location-delta*
                    _start163080_
                    _end163088_)))
             (_K163077_
              _toks163082_
              (let ((__tmp300694
                     (_wrap-e163076_
                      ((lambda (_$1163093_ _$2163094_)
                         (cons _$1163093_ (cons _$2163094_ '())))
                       (##direct-structure-ref
                        _$1162827163083_
                        '2
                        std/parser/base#token::t
                        '#f)
                       (##direct-structure-ref
                        _$2162828163085_
                        '2
                        std/parser/base#token::t
                        '#f))
                      _@loc163090_)))
                (declare (not safe))
                (##structure
                 std/parser/base#token::t
                 'SimplePattern
                 __tmp300694
                 _@loc163090_)))))
         _E163078_))))
  (define std/parser/grammar-reader#SimplePattern::2::app
    (lambda (_ts163068_ _toks163069_ _wrap-e163070_ _K163071_ _E163072_)
      (std/parser/grammar-reader#Ident
       _ts163068_
       _toks163069_
       _wrap-e163070_
       _K163071_
       _E163072_)))
  (define std/parser/grammar-reader#SimplePattern::2
    (lambda (_ts163049_ _toks163050_ _wrap-e163051_ _K163052_ _E163053_)
      (let ((_start163055_ (std/parser/lexer#token-stream-loc _ts163049_)))
        (std/parser/grammar-reader#Ident
         _ts163049_
         _toks163050_
         _wrap-e163051_
         (lambda (_toks163057_ _$1162829163058_)
           (let* ((_end163061_ (std/parser/lexer#token-stream-loc _ts163049_))
                  (_@loc163063_
                   (std/parser/base#location-delta*
                    _start163055_
                    _end163061_)))
             (_K163052_
              _toks163057_
              (let ((__tmp300695
                     (_wrap-e163051_
                      ((lambda (_$1163066_) _$1163066_)
                       (##direct-structure-ref
                        _$1162829163058_
                        '2
                        std/parser/base#token::t
                        '#f))
                      _@loc163063_)))
                (declare (not safe))
                (##structure
                 std/parser/base#token::t
                 'SimplePattern
                 __tmp300695
                 _@loc163063_)))))
         _E163053_))))
  (define std/parser/grammar-reader#SimplePattern::3::app
    (lambda (_ts163043_ _toks163044_ _wrap-e163045_ _K163046_ _E163047_)
      (std/parser/grammar-reader#EQ
       _ts163043_
       _toks163044_
       _wrap-e163045_
       _K163046_
       _E163047_)))
  (define std/parser/grammar-reader#SimplePattern::3
    (lambda (_ts163024_ _toks163025_ _wrap-e163026_ _K163027_ _E163028_)
      (let ((_start163030_ (std/parser/lexer#token-stream-loc _ts163024_)))
        (std/parser/grammar-reader#EQ
         _ts163024_
         _toks163025_
         _wrap-e163026_
         (lambda (_toks163032_ _$1162830163033_)
           (let* ((_end163036_ (std/parser/lexer#token-stream-loc _ts163024_))
                  (_@loc163038_
                   (std/parser/base#location-delta*
                    _start163030_
                    _end163036_)))
             (_K163027_
              _toks163032_
              (let ((__tmp300696
                     (_wrap-e163026_
                      ((lambda (_$1163041_)
                         (cons '@eq
                               (cons (cons 'quote (cons _$1163041_ '())) '())))
                       (##direct-structure-ref
                        _$1162830163033_
                        '2
                        std/parser/base#token::t
                        '#f))
                      _@loc163038_)))
                (declare (not safe))
                (##structure
                 std/parser/base#token::t
                 'SimplePattern
                 __tmp300696
                 _@loc163038_)))))
         _E163028_))))
  (define std/parser/grammar-reader#SimplePattern::4::app
    (lambda (_ts163018_ _toks163019_ _wrap-e163020_ _K163021_ _E163022_)
      (std/parser/grammar-reader#EQUAL
       _ts163018_
       _toks163019_
       _wrap-e163020_
       _K163021_
       _E163022_)))
  (define std/parser/grammar-reader#SimplePattern::4
    (lambda (_ts162997_ _toks162998_ _wrap-e162999_ _K163000_ _E163001_)
      (let ((_start163003_ (std/parser/lexer#token-stream-loc _ts162997_)))
        (std/parser/grammar-reader#EQUAL
         _ts162997_
         _toks162998_
         _wrap-e162999_
         (lambda (_toks163006_ _$1162831163007_)
           (let* ((_end163010_ (std/parser/lexer#token-stream-loc _ts162997_))
                  (_@loc163013_
                   (std/parser/base#location-delta*
                    _start163003_
                    _end163010_)))
             (_K163000_
              _toks163006_
              (let ((__tmp300697
                     (_wrap-e162999_
                      ((lambda (_$1163016_)
                         (cons '@eq
                               (cons (cons 'quote (cons _$1163016_ '()))
                                     (cons equal? '()))))
                       (##direct-structure-ref
                        _$1162831163007_
                        '2
                        std/parser/base#token::t
                        '#f))
                      _@loc163013_)))
                (declare (not safe))
                (##structure
                 std/parser/base#token::t
                 'SimplePattern
                 __tmp300697
                 _@loc163013_)))))
         _E163001_))))
  (define std/parser/grammar-reader#SimplePattern
    (lambda (_ts162984_ _toks162985_ _wrap-e162986_ _K162987_ _E162988_)
      (std/parser/grammar-reader#SimplePattern::1
       _ts162984_
       _toks162985_
       _wrap-e162986_
       _K162987_
       (lambda (_xtoks162990_)
         (std/parser/defparser#parser-rewind
          _ts162984_
          _xtoks162990_
          _toks162985_)
         (std/parser/grammar-reader#SimplePattern::2
          _ts162984_
          _toks162985_
          _wrap-e162986_
          _K162987_
          (lambda (_xtoks162993_)
            (std/parser/defparser#parser-rewind
             _ts162984_
             _xtoks162993_
             _toks162985_)
            (std/parser/grammar-reader#SimplePattern::3
             _ts162984_
             _toks162985_
             _wrap-e162986_
             _K162987_
             (lambda (_xtoks162995_)
               (std/parser/defparser#parser-rewind
                _ts162984_
                _xtoks162995_
                _toks162985_)
               (std/parser/grammar-reader#SimplePattern::4
                _ts162984_
                _toks162985_
                _wrap-e162986_
                _K162987_
                _E162988_)))))))))
  (define std/parser/grammar-reader#Ident
    (lambda (_ts162973_ _toks162974_ _wrap-e162975_ _K162976_ _E162977_)
      (let* ((_next162979_ (std/parser/lexer#token-stream-next _ts162973_))
             (_toks162981_ (cons _next162979_ _toks162974_)))
        (if (eq? (##direct-structure-ref
                  _next162979_
                  '1
                  std/parser/base#token::t
                  '#f)
                 'Ident)
            (_K162976_ _toks162981_ _next162979_)
            (_E162977_ _toks162981_)))))
  (define std/parser/grammar-reader#EQ
    (lambda (_ts162962_ _toks162963_ _wrap-e162964_ _K162965_ _E162966_)
      (let* ((_next162968_ (std/parser/lexer#token-stream-next _ts162962_))
             (_toks162970_ (cons _next162968_ _toks162963_)))
        (if (eq? (##direct-structure-ref
                  _next162968_
                  '1
                  std/parser/base#token::t
                  '#f)
                 'EQ)
            (_K162965_ _toks162970_ _next162968_)
            (_E162966_ _toks162970_)))))
  (define std/parser/grammar-reader#EQUAL
    (lambda (_ts162945_ _toks162947_ _wrap-e162949_ _K162951_ _E162953_)
      (let* ((_next162956_ (std/parser/lexer#token-stream-next _ts162945_))
             (_toks162959_ (cons _next162956_ _toks162947_)))
        (if (eq? (##direct-structure-ref
                  _next162956_
                  '1
                  std/parser/base#token::t
                  '#f)
                 'EQUAL)
            (_K162951_ _toks162959_ _next162956_)
            (_E162953_ _toks162959_)))))
  (define std/parser/grammar-reader#lex-lexer::L
    (cons (std/parser/rlang#@cat__2
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\%))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\%))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\p))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\a))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\r))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\s))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\e))
           (let ()
             (declare (not safe))
             (##structure std/parser/rlang#char::t '#\r)))
          (cons (std/parser/rlang#@cat__2
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\%))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\%))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\l))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\e))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\x))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\e))
                 (let ()
                   (declare (not safe))
                   (##structure std/parser/rlang#char::t '#\r)))
                (cons (std/parser/rlang#@cat__1
                       (std/parser/rlang#@rep+ std/parser/grammar-reader#WS)
                       (std/parser/rlang#@cat__1
                        (let ()
                          (declare (not safe))
                          (##structure std/parser/rlang#char::t '#\-))
                        (let ()
                          (declare (not safe))
                          (##structure std/parser/rlang#char::t '#\>))))
                      (cons (std/parser/rlang#@rep+
                             (let ()
                               (declare (not safe))
                               (##structure
                                std/parser/rlang#char::t
                                '#\newline)))
                            (cons (std/parser/rlang#@rep+
                                   std/parser/grammar-reader#WS)
                                  (cons (std/parser/rlang#@cat__1
                                         (let ()
                                           (declare (not safe))
                                           (##structure
                                            std/parser/rlang#char::t
                                            '#\;))
                                         (std/parser/rlang#@rep+
                                          (std/parser/rlang#@negset
                                           '(#\newline))))
                                        (cons (std/parser/rlang#@rep+
                                               (std/parser/rlang#@alt__2
                                                (std/parser/rlang#@cat__1
                                                 (let ()
                                                   (declare (not safe))
                                                   (##structure
                                                    std/parser/rlang#char::t
                                                    '#\\))
                                                 (let ()
                                                   (declare (not safe))
                                                   (##structure
                                                    std/parser/rlang#char::t
                                                    '#\;)))
                                                (std/parser/rlang#@cat__1
                                                 (let ()
                                                   (declare (not safe))
                                                   (##structure
                                                    std/parser/rlang#char::t
                                                    '#\\))
                                                 (let ()
                                                   (declare (not safe))
                                                   (##structure
                                                    std/parser/rlang#char::t
                                                    '#\space)))
                                                (std/parser/rlang#@negset
                                                 '(#\space
                                                   #\newline
                                                   #\tab
                                                   #\;))))
                                              '()))))))))
  (define std/parser/grammar-reader#lex-lexer::R
    (cons (lambda (_@@162922_ _@loc162923_)
            (let ()
              (declare (not safe))
              (##structure
               std/parser/base#token::t
               '$$
               '%%parser
               _@loc162923_)))
          (cons (lambda (_@@162925_ _@loc162926_)
                  (let ()
                    (declare (not safe))
                    (##structure
                     std/parser/base#token::t
                     '$$
                     '%%lexer
                     _@loc162926_)))
                (cons (lambda (_@@162928_ _@loc162929_)
                        (let ()
                          (declare (not safe))
                          (##structure
                           std/parser/base#token::t
                           '$$
                           'ACTION
                           _@loc162929_)))
                      (cons (lambda (_@@162931_ _@loc162932_)
                              (let ()
                                (declare (not safe))
                                (##structure
                                 std/parser/base#token::t
                                 '$$
                                 'ENDRULE
                                 _@loc162932_)))
                            (cons (lambda (_@@162934_ _@loc162936_)
                                    std/parser/lexer#$)
                                  (cons (lambda (_@@162939_ _@loc162940_)
                                          std/parser/lexer#$)
                                        (cons (lambda (_@@162942_ _@loc162943_)
                                                (let ((__tmp300698
                                                       (std/parser/grammar-reader#escape-chars
                                                        _@@162942_)))
                                                  (declare (not safe))
                                                  (##structure
                                                   std/parser/base#token::t
                                                   'RX
                                                   __tmp300698
                                                   _@loc162943_)))
                                              '()))))))))
  (define std/parser/grammar-reader#lex-lexer
    (lambda (_input162919_)
      (std/parser/lexer#lex
       _input162919_
       std/parser/grammar-reader#lex-lexer::L
       std/parser/grammar-reader#lex-lexer::R)))
  (define std/parser/grammar-reader#simplify
    (lambda (_cat162880_)
      (let* ((_cat162881162891_ _cat162880_)
             (_else162883162899_ (lambda () _cat162880_))
             (_K162885162904_ (lambda (_e162902_) _e162902_)))
        (if (let () (declare (not safe)) (##pair? _cat162881162891_))
            (let ((_hd162886162907_
                   (let () (declare (not safe)) (##car _cat162881162891_)))
                  (_tl162887162909_
                   (let () (declare (not safe)) (##cdr _cat162881162891_))))
              (if (let () (declare (not safe)) (##eq? _hd162886162907_ '@cat))
                  (if (let () (declare (not safe)) (##pair? _tl162887162909_))
                      (let ((_hd162888162912_
                             (let ()
                               (declare (not safe))
                               (##car _tl162887162909_)))
                            (_tl162889162914_
                             (let ()
                               (declare (not safe))
                               (##cdr _tl162887162909_))))
                        (let ((_e162917_ _hd162888162912_))
                          (if (let ()
                                (declare (not safe))
                                (##null? _tl162889162914_))
                              (_K162885162904_ _e162917_)
                              (_else162883162899_))))
                      (_else162883162899_))
                  (_else162883162899_)))
            (_else162883162899_)))))
  (define std/parser/grammar-reader#string->token-symbol
    (lambda (_str162878_)
      (string->symbol
       (std/parser/grammar-reader#string->token-string _str162878_))))
  (define std/parser/grammar-reader#string->token-string
    (lambda (_str162876_)
      (std/parser/grammar-reader#escape-chars
       (substring _str162876_ '1 (fx- (string-length _str162876_) '1)))))
  (define std/parser/grammar-reader#escape-chars
    (lambda (_str162833_)
      (let _lp162835_ ((_rest162837_ (string->list _str162833_))
                       (_chars162838_ '()))
        (let* ((_rest162839162847_ _rest162837_)
               (_else162841162855_
                (lambda () (list->string (reverse _chars162838_))))
               (_K162843162864_
                (lambda (_rest162858_ _char162859_)
                  (if (eq? _char162859_ '#\\)
                      (let ((_$e162861_ _char162859_))
                        (if (eq? '#\n _$e162861_)
                            (_lp162835_
                             _rest162858_
                             (cons '#\newline _chars162838_))
                            (if (eq? '#\r _$e162861_)
                                (_lp162835_
                                 _rest162858_
                                 (cons '#\return _chars162838_))
                                (if (eq? '#\t _$e162861_)
                                    (_lp162835_
                                     _rest162858_
                                     (cons '#\tab _chars162838_))
                                    (_lp162835_
                                     _rest162858_
                                     (cons _char162859_ _chars162838_))))))
                      (_lp162835_
                       _rest162858_
                       (cons _char162859_ _chars162838_))))))
          (if (let () (declare (not safe)) (##pair? _rest162839162847_))
              (let ((_hd162844162867_
                     (let () (declare (not safe)) (##car _rest162839162847_)))
                    (_tl162845162869_
                     (let () (declare (not safe)) (##cdr _rest162839162847_))))
                (let* ((_char162872_ _hd162844162867_)
                       (_rest162874_ _tl162845162869_))
                  (_K162843162864_ _rest162874_ _char162872_)))
              (_else162841162855_)))))))
