(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/parser/stream#char-stream::t
    (make-struct-type
     'std/parser/stream#char-stream::t
     '#f
     '4
     'char-stream
     '((final: . #t))
     ':init!
     '(port buf loc lines)))
  (define std/parser/stream#char-stream?
    (make-struct-predicate std/parser/stream#char-stream::t))
  (define std/parser/stream#make-char-stream
    (lambda _$args153047_
      (apply make-struct-instance
             std/parser/stream#char-stream::t
             _$args153047_)))
  (define std/parser/stream#char-stream-port
    (make-struct-field-accessor std/parser/stream#char-stream::t '0))
  (define std/parser/stream#char-stream-buf
    (make-struct-field-accessor std/parser/stream#char-stream::t '1))
  (define std/parser/stream#char-stream-loc
    (make-struct-field-accessor std/parser/stream#char-stream::t '2))
  (define std/parser/stream#char-stream-lines
    (make-struct-field-accessor std/parser/stream#char-stream::t '3))
  (define std/parser/stream#char-stream-port-set!
    (make-struct-field-mutator std/parser/stream#char-stream::t '0))
  (define std/parser/stream#char-stream-buf-set!
    (make-struct-field-mutator std/parser/stream#char-stream::t '1))
  (define std/parser/stream#char-stream-loc-set!
    (make-struct-field-mutator std/parser/stream#char-stream::t '2))
  (define std/parser/stream#char-stream-lines-set!
    (make-struct-field-mutator std/parser/stream#char-stream::t '3))
  (define std/parser/stream#char-stream:::init!
    (lambda (_self153044_ _port153045_)
      (if (macro-character-input-port? _port153045_)
          '#!void
          (error '"Bad input source; not a character-input-port" _port153045_))
      (if (let ((__tmp290165
                 (let () (declare (not safe)) (##vector-length _self153044_))))
            (declare (not safe))
            (##fx< '4 __tmp290165))
          (begin
            (let ()
              (declare (not safe))
              (##vector-set! _self153044_ '1 _port153045_))
            (let () (declare (not safe)) (##vector-set! _self153044_ '2 '()))
            (let ((__tmp290166
                   (let ()
                     (declare (not safe))
                     (##structure
                      std/parser/base#location::t
                      _port153045_
                      '0
                      '0
                      '0
                      '0))))
              (declare (not safe))
              (##vector-set! _self153044_ '3 __tmp290166))
            (let () (declare (not safe)) (##vector-set! _self153044_ '4 '())))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self153044_))))
  (bind-method!
   std/parser/stream#char-stream::t
   ':init!
   std/parser/stream#char-stream:::init!
   '#f)
  (define std/parser/stream#char-stream-close
    (lambda (_cs152919_)
      (close-input-port
       (##direct-structure-ref
        _cs152919_
        '1
        std/parser/stream#char-stream::t
        '#f))))
  (define std/parser/stream#char-stream-getc
    (lambda (_cs152836_)
      (let* ((_cs152837152846_ _cs152836_)
             (_E152839152850_
              (lambda () (error '"No clause matching" _cs152837152846_)))
             (_K152840152896_
              (lambda (_lines152853_ _loc152854_ _buf152855_ _port152856_)
                (let* ((_buf152857152865_ _buf152855_)
                       (_else152859152878_
                        (lambda ()
                          (let* ((_loc152873_
                                  (std/parser/stream#port-location
                                   _port152856_))
                                 (_char152875_ (read-char _port152856_)))
                            (if (eof-object? _char152875_)
                                '#!void
                                (begin
                                  (##direct-structure-set!
                                   _cs152836_
                                   _loc152873_
                                   '3
                                   std/parser/stream#char-stream::t
                                   '#f)
                                  (if (eq? '#\newline _char152875_)
                                      (##direct-structure-set!
                                       _cs152836_
                                       (cons (##direct-structure-ref
                                              _loc152873_
                                              '5
                                              std/parser/base#location::t
                                              '#f)
                                             _lines152853_)
                                       '4
                                       std/parser/stream#char-stream::t
                                       '#f)
                                      '#!void)))
                            _char152875_)))
                       (_K152861152884_
                        (lambda (_rest152881_ _char152882_)
                          (##direct-structure-set!
                           _cs152836_
                           _rest152881_
                           '2
                           std/parser/stream#char-stream::t
                           '#f)
                          (##direct-structure-set!
                           _cs152836_
                           (std/parser/stream#location-getc
                            _loc152854_
                            _char152882_
                            _lines152853_)
                           '3
                           std/parser/stream#char-stream::t
                           '#f)
                          _char152882_)))
                  (if (let () (declare (not safe)) (##pair? _buf152857152865_))
                      (let ((_hd152862152887_
                             (let ()
                               (declare (not safe))
                               (##car _buf152857152865_)))
                            (_tl152863152889_
                             (let ()
                               (declare (not safe))
                               (##cdr _buf152857152865_))))
                        (let* ((_char152892_ _hd152862152887_)
                               (_rest152894_ _tl152863152889_))
                          (_K152861152884_ _rest152894_ _char152892_)))
                      (_else152859152878_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _cs152837152846_
               'std/parser/stream#char-stream::t))
            (let* ((_e152841152899_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cs152837152846_ '1)))
                   (_port152902_ _e152841152899_)
                   (_e152842152904_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cs152837152846_ '2)))
                   (_buf152907_ _e152842152904_)
                   (_e152843152909_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cs152837152846_ '3)))
                   (_loc152912_ _e152843152909_)
                   (_e152844152914_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cs152837152846_ '4)))
                   (_lines152917_ _e152844152914_))
              (_K152840152896_
               _lines152917_
               _loc152912_
               _buf152907_
               _port152902_))
            (_E152839152850_)))))
  (define std/parser/stream#char-stream-ungetc
    (lambda (_cs152790_ _char152791_)
      (if (eof-object? _char152791_)
          '#!void
          (let* ((_cs152792152801_ _cs152790_)
                 (_E152794152805_
                  (lambda () (error '"No clause matching" _cs152792152801_)))
                 (_K152795152813_
                  (lambda (_lines152808_ _loc152809_ _buf152810_ _port152811_)
                    (##direct-structure-set!
                     _cs152790_
                     (cons _char152791_ _buf152810_)
                     '2
                     std/parser/stream#char-stream::t
                     '#f)
                    (##direct-structure-set!
                     _cs152790_
                     (std/parser/stream#location-ungetc
                      _loc152809_
                      _char152791_
                      _lines152808_)
                     '3
                     std/parser/stream#char-stream::t
                     '#f))))
            (if (let ()
                  (declare (not safe))
                  (##structure-direct-instance-of?
                   _cs152792152801_
                   'std/parser/stream#char-stream::t))
                (let* ((_e152796152816_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _cs152792152801_ '1)))
                       (_port152819_ _e152796152816_)
                       (_e152797152821_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _cs152792152801_ '2)))
                       (_buf152824_ _e152797152821_)
                       (_e152798152826_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _cs152792152801_ '3)))
                       (_loc152829_ _e152798152826_)
                       (_e152799152831_
                        (let ()
                          (declare (not safe))
                          (##vector-ref _cs152792152801_ '4)))
                       (_lines152834_ _e152799152831_))
                  (_K152795152813_
                   _lines152834_
                   _loc152829_
                   _buf152824_
                   _port152819_))
                (_E152794152805_))))))
  (define std/parser/stream#char-stream-peek
    (lambda (_cs152726_)
      (let* ((_cs152727152734_ _cs152726_)
             (_E152729152738_
              (lambda () (error '"No clause matching" _cs152727152734_)))
             (_K152730152777_
              (lambda (_buf152741_ _port152742_)
                (let* ((_buf152743152751_ _buf152741_)
                       (_else152745152759_
                        (lambda () (peek-char _port152742_)))
                       (_K152747152765_
                        (lambda (_rest152762_ _char152763_) _char152763_)))
                  (if (let () (declare (not safe)) (##pair? _buf152743152751_))
                      (let ((_hd152748152768_
                             (let ()
                               (declare (not safe))
                               (##car _buf152743152751_)))
                            (_tl152749152770_
                             (let ()
                               (declare (not safe))
                               (##cdr _buf152743152751_))))
                        (let* ((_char152773_ _hd152748152768_)
                               (_rest152775_ _tl152749152770_))
                          (_K152747152765_ _rest152775_ _char152773_)))
                      (_else152745152759_))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _cs152727152734_
               'std/parser/stream#char-stream::t))
            (let* ((_e152731152780_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cs152727152734_ '1)))
                   (_port152783_ _e152731152780_)
                   (_e152732152785_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _cs152727152734_ '2)))
                   (_buf152788_ _e152732152785_))
              (_K152730152777_ _buf152788_ _port152783_))
            (_E152729152738_)))))
  (define std/parser/stream#location-getc
    (lambda (_loc152675_ _char152676_ _lines152677_)
      (let* ((_loc152678152688_ _loc152675_)
             (_E152680152692_
              (lambda () (error '"No clause matching" _loc152678152688_)))
             (_K152681152700_
              (lambda (_xoff152695_ _col152696_ _line152697_ _port152698_)
                (if (let () (declare (not safe)) (##fx< _xoff152695_ '0))
                    (let ()
                      (declare (not safe))
                      (##structure
                       std/parser/base#location::t
                       _port152698_
                       '0
                       '0
                       '1
                       '0))
                    (if (memq _xoff152695_ _lines152677_)
                        (let ((__tmp290168
                               (let ()
                                 (declare (not safe))
                                 (##fx+ _line152697_ '1)))
                              (__tmp290167
                               (let ()
                                 (declare (not safe))
                                 (##fx+ _xoff152695_ '1))))
                          (declare (not safe))
                          (##structure
                           std/parser/base#location::t
                           _port152698_
                           __tmp290168
                           '0
                           '1
                           __tmp290167))
                        (let ((__tmp290170
                               (let ()
                                 (declare (not safe))
                                 (##fx+ _col152696_ '1)))
                              (__tmp290169
                               (let ()
                                 (declare (not safe))
                                 (##fx+ _xoff152695_ '1))))
                          (declare (not safe))
                          (##structure
                           std/parser/base#location::t
                           _port152698_
                           _line152697_
                           __tmp290170
                           '1
                           __tmp290169)))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _loc152678152688_
               'std/parser/base#location::t))
            (let* ((_e152682152703_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152678152688_ '1)))
                   (_port152706_ _e152682152703_)
                   (_e152683152708_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152678152688_ '2)))
                   (_line152711_ _e152683152708_)
                   (_e152684152713_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152678152688_ '3)))
                   (_col152716_ _e152684152713_)
                   (_e152685152718_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152678152688_ '4)))
                   (_e152686152721_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152678152688_ '5)))
                   (_xoff152724_ _e152686152721_))
              (_K152681152700_
               _xoff152724_
               _col152716_
               _line152711_
               _port152706_))
            (_E152680152692_)))))
  (define std/parser/stream#location-ungetc
    (lambda (_loc152610_ _char152611_ _lines152612_)
      (let* ((_loc152613152623_ _loc152610_)
             (_E152615152627_
              (lambda () (error '"No clause matching" _loc152613152623_)))
             (_K152616152649_
              (lambda (_xoff152630_ _col152631_ _line152632_ _port152633_)
                (if (let () (declare (not safe)) (##fx> _col152631_ '0))
                    (let ((__tmp290172
                           (let ()
                             (declare (not safe))
                             (##fx- _col152631_ '1)))
                          (__tmp290171
                           (let ()
                             (declare (not safe))
                             (##fx- _xoff152630_ '1))))
                      (declare (not safe))
                      (##structure
                       std/parser/base#location::t
                       _port152633_
                       _line152632_
                       __tmp290172
                       '1
                       __tmp290171))
                    (let* ((_xoff152635_
                            (let ()
                              (declare (not safe))
                              (##fx- _xoff152630_ '1)))
                           (_base152644_
                            (let ((_$e152641_
                                   (find (lambda (_g152636152638_)
                                           (< _g152636152638_ _xoff152635_))
                                         _lines152612_)))
                              (if _$e152641_ _$e152641_ '-1)))
                           (_col152646_
                            (let ()
                              (declare (not safe))
                              (##fx- _xoff152635_ _base152644_ '1))))
                      (let ((__tmp290173
                             (let ()
                               (declare (not safe))
                               (##fx- _line152632_ '1))))
                        (declare (not safe))
                        (##structure
                         std/parser/base#location::t
                         _port152633_
                         __tmp290173
                         _col152646_
                         '1
                         _xoff152635_)))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _loc152613152623_
               'std/parser/base#location::t))
            (let* ((_e152617152652_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152613152623_ '1)))
                   (_port152655_ _e152617152652_)
                   (_e152618152657_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152613152623_ '2)))
                   (_line152660_ _e152618152657_)
                   (_e152619152662_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152613152623_ '3)))
                   (_col152665_ _e152619152662_)
                   (_e152620152667_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152613152623_ '4)))
                   (_e152621152670_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _loc152613152623_ '5)))
                   (_xoff152673_ _e152621152670_))
              (_K152616152649_
               _xoff152673_
               _col152665_
               _line152660_
               _port152655_))
            (_E152615152627_)))))
  (define std/parser/stream#port-location
    (lambda (_port152601_)
      (let* ((_line152603_ (macro-character-port-rlines _port152601_))
             (_xoff152605_
              (let ((__tmp290175 (macro-character-port-rchars _port152601_))
                    (__tmp290174 (macro-character-port-rlo _port152601_)))
                (declare (not safe))
                (##fx+ __tmp290175 __tmp290174)))
             (_col152607_
              (let ((__tmp290176 (macro-character-port-rcurline _port152601_)))
                (declare (not safe))
                (##fx- _xoff152605_ __tmp290176))))
        (let ()
          (declare (not safe))
          (##structure
           std/parser/base#location::t
           _port152601_
           _line152603_
           _col152607_
           '1
           _xoff152605_))))))
