(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (fixnum))
  (define std/pregexp#*pregexp-version* '20050502)
  (define std/pregexp#*pregexp-comment-char* '#\;)
  (define std/pregexp#*pregexp-nul-char-int* (- (char->integer '#\a) '97))
  (define std/pregexp#*pregexp-return-char*
    (integer->char (+ '13 std/pregexp#*pregexp-nul-char-int*)))
  (define std/pregexp#*pregexp-tab-char*
    (integer->char (+ '9 std/pregexp#*pregexp-nul-char-int*)))
  (define std/pregexp#pregexp-space-sensitive? (make-parameter '#t))
  (define std/pregexp#pregexp-reverse!
    (lambda (_s46001_)
      (let _loop46003_ ((_s46005_ _s46001_) (_r46006_ '()))
        (if (null? _s46005_)
            _r46006_
            (let ((_d46008_ (cdr _s46005_)))
              (set-cdr! _s46005_ _r46006_)
              (_loop46003_ _d46008_ _s46005_))))))
  (define std/pregexp#pregexp-error
    (lambda _args45999_ (apply error '"Regular expression error" _args45999_)))
  (define std/pregexp#pregexp-read-pattern
    (lambda (_s45985_ _i45986_ _n45987_)
      (if (>= _i45986_ _n45987_)
          (list (list ':or (list ':seq)) _i45986_)
          (let _loop45989_ ((_branches45991_ '()) (_i45992_ _i45986_))
            (if (or (>= _i45992_ _n45987_)
                    (char=? (let ()
                              (declare (not safe))
                              (##string-ref _s45985_ _i45992_))
                            '#\)))
                (list (cons ':or
                            (std/pregexp#pregexp-reverse! _branches45991_))
                      _i45992_)
                (let ((_vv45997_
                       (std/pregexp#pregexp-read-branch
                        _s45985_
                        (if (char=? (let ()
                                      (declare (not safe))
                                      (##string-ref _s45985_ _i45992_))
                                    '#\|)
                            (+ _i45992_ '1)
                            _i45992_)
                        _n45987_)))
                  (_loop45989_
                   (cons (car _vv45997_) _branches45991_)
                   (cadr _vv45997_))))))))
  (define std/pregexp#pregexp-read-branch
    (lambda (_s45969_ _i45970_ _n45971_)
      (let _loop45973_ ((_pieces45975_ '()) (_i45976_ _i45970_))
        (if (>= _i45976_ _n45971_)
            (list (cons ':seq (std/pregexp#pregexp-reverse! _pieces45975_))
                  _i45976_)
            (if (let ((_c45978_
                       (let ()
                         (declare (not safe))
                         (##string-ref _s45969_ _i45976_))))
                  (or (char=? _c45978_ '#\|) (char=? _c45978_ '#\))))
                (list (cons ':seq (std/pregexp#pregexp-reverse! _pieces45975_))
                      _i45976_)
                (let ((_vv45983_
                       (std/pregexp#pregexp-read-piece
                        _s45969_
                        _i45976_
                        _n45971_)))
                  (_loop45973_
                   (cons (car _vv45983_) _pieces45975_)
                   (cadr _vv45983_))))))))
  (define std/pregexp#pregexp-read-piece
    (lambda (_s45919_ _i45920_ _n45921_)
      (let* ((_c45923_
              (let () (declare (not safe)) (##string-ref _s45919_ _i45920_)))
             (_$e45925_ _c45923_))
        (let ((_default4592745941_
               (lambda ()
                 (if (or (std/pregexp#pregexp-space-sensitive?)
                         (and (not (char-whitespace? _c45923_))
                              (not (char=? _c45923_
                                           std/pregexp#*pregexp-comment-char*))))
                     (std/pregexp#pregexp-wrap-quantifier-if-any
                      (list _c45923_ (+ _i45920_ '1))
                      _s45919_
                      _n45921_)
                     (let _loop45934_ ((_i45936_ _i45920_)
                                       (_in-comment?45937_ '#f))
                       (if (>= _i45936_ _n45921_)
                           (list ':empty _i45936_)
                           (let ((_c45939_
                                  (let ()
                                    (declare (not safe))
                                    (##string-ref _s45919_ _i45936_))))
                             (if _in-comment?45937_
                                 (_loop45934_
                                  (+ _i45936_ '1)
                                  (not (char=? _c45939_ '#\newline)))
                                 (if (char-whitespace? _c45939_)
                                     (_loop45934_ (+ _i45936_ '1) '#f)
                                     (if (char=? _c45939_
                                                 std/pregexp#*pregexp-comment-char*)
                                         (_loop45934_ (+ _i45936_ '1) '#t)
                                         (list ':empty _i45936_))))))))))
              (_table4592845943_
               '#(#f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  1
                  #f
                  #f
                  #f
                  4
                  #f
                  #f
                  #f
                  #f
                  #f
                  2
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  3
                  5
                  #f
                  0)))
          (if (char? _$e45925_)
              (let ((_ix45946_
                     (let ()
                       (declare (not safe))
                       (##char->integer _$e45925_))))
                (if (let () (declare (not safe)) (##fx< _ix45946_ '95))
                    (let ((_x45949_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _table4592845943_ _ix45946_))))
                      (if _x45949_
                          (if (let () (declare (not safe)) (##fx< _x45949_ '3))
                              (if (let ()
                                    (declare (not safe))
                                    (##fx= _x45949_ '0))
                                  (list ':bos (+ _i45920_ '1))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx= _x45949_ '1))
                                      (list ':eos (+ _i45920_ '1))
                                      (std/pregexp#pregexp-wrap-quantifier-if-any
                                       (list ':any (+ _i45920_ '1))
                                       _s45919_
                                       _n45921_)))
                              (if (let ()
                                    (declare (not safe))
                                    (##fx= _x45949_ '3))
                                  (let ((_i+145952_ (+ _i45920_ '1)))
                                    (std/pregexp#pregexp-wrap-quantifier-if-any
                                     (let ((_$e45954_
                                            (if (< _i+145952_ _n45921_)
                                                (let ()
                                                  (declare (not safe))
                                                  (##string-ref
                                                   _s45919_
                                                   _i+145952_))
                                                '#f)))
                                       (if (eq? '#\^ _$e45954_)
                                           (let ((_vv45957_
                                                  (std/pregexp#pregexp-read-char-list
                                                   _s45919_
                                                   (+ _i45920_ '2)
                                                   _n45921_)))
                                             (list (list ':neg-char
                                                         (car _vv45957_))
                                                   (cadr _vv45957_)))
                                           (std/pregexp#pregexp-read-char-list
                                            _s45919_
                                            _i+145952_
                                            _n45921_)))
                                     _s45919_
                                     _n45921_))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx= _x45949_ '4))
                                      (std/pregexp#pregexp-wrap-quantifier-if-any
                                       (std/pregexp#pregexp-read-subpattern
                                        _s45919_
                                        (+ _i45920_ '1)
                                        _n45921_)
                                       _s45919_
                                       _n45921_)
                                      (std/pregexp#pregexp-wrap-quantifier-if-any
                                       (let ((_$e45959_
                                              (std/pregexp#pregexp-read-escaped-number
                                               _s45919_
                                               _i45920_
                                               _n45921_)))
                                         (if _$e45959_
                                             ((lambda (_num-i45962_)
                                                (list (list ':backref
                                                            (car _num-i45962_))
                                                      (cadr _num-i45962_)))
                                              _$e45959_)
                                             (let ((_$e45964_
                                                    (std/pregexp#pregexp-read-escaped-char
                                                     _s45919_
                                                     _i45920_
                                                     _n45921_)))
                                               (if _$e45964_
                                                   ((lambda (_char-i45967_)
                                                      (list (car _char-i45967_)
                                                            (cadr _char-i45967_)))
                                                    _$e45964_)
                                                   (std/pregexp#pregexp-error
                                                    'pregexp-read-piece
                                                    'backslash)))))
                                       _s45919_
                                       _n45921_))))
                          (_default4592745941_)))
                    (_default4592745941_)))
              (_default4592745941_))))))
  (define std/pregexp#pregexp-read-escaped-number
    (lambda (_s45906_ _i45907_ _n45908_)
      (if (< (+ _i45907_ '1) _n45908_)
          (let ((_c45910_
                 (let ((__tmp281174 (+ _i45907_ '1)))
                   (declare (not safe))
                   (##string-ref _s45906_ __tmp281174))))
            (if (char-numeric? _c45910_)
                (let _loop45912_ ((_i45914_ (+ _i45907_ '2))
                                  (_r45915_ (list _c45910_)))
                  (if (>= _i45914_ _n45908_)
                      (list (string->number
                             (list->string
                              (std/pregexp#pregexp-reverse! _r45915_)))
                            _i45914_)
                      (let ((_c45917_
                             (let ()
                               (declare (not safe))
                               (##string-ref _s45906_ _i45914_))))
                        (if (char-numeric? _c45917_)
                            (_loop45912_
                             (+ _i45914_ '1)
                             (cons _c45917_ _r45915_))
                            (list (string->number
                                   (list->string
                                    (std/pregexp#pregexp-reverse! _r45915_)))
                                  _i45914_)))))
                '#f))
          '#f)))
  (define std/pregexp#pregexp-read-escaped-char
    (lambda (_s45883_ _i45884_ _n45885_)
      (if (< (+ _i45884_ '1) _n45885_)
          (let* ((_c45887_
                  (let ((__tmp281175 (+ _i45884_ '1)))
                    (declare (not safe))
                    (##string-ref _s45883_ __tmp281175)))
                 (_$e45889_ _c45887_))
            (let ((_default4589145895_
                   (lambda () (list _c45887_ (+ _i45884_ '2))))
                  (_table4589245897_
                   '#(#f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      1
                      #f
                      3
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      7
                      #f
                      #f
                      #f
                      10
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      0
                      #f
                      2
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      #f
                      4
                      #f
                      #f
                      #f
                      5
                      6
                      8
                      #f
                      #f
                      9)))
              (if (char? _$e45889_)
                  (let ((_ix45900_
                         (let ()
                           (declare (not safe))
                           (##char->integer _$e45889_))))
                    (if (let () (declare (not safe)) (##fx< _ix45900_ '120))
                        (let ((_x45903_
                               (let ()
                                 (declare (not safe))
                                 (##vector-ref _table4589245897_ _ix45900_))))
                          (if _x45903_
                              (if (let ()
                                    (declare (not safe))
                                    (##fx< _x45903_ '5))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx< _x45903_ '2))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45903_ '0))
                                          (list ':wbdry (+ _i45884_ '2))
                                          (list ':not-wbdry (+ _i45884_ '2)))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45903_ '2))
                                          (list ':digit (+ _i45884_ '2))
                                          (if (let ()
                                                (declare (not safe))
                                                (##fx= _x45903_ '3))
                                              (list '(:neg-char :digit)
                                                    (+ _i45884_ '2))
                                              (list '#\newline
                                                    (+ _i45884_ '2)))))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx< _x45903_ '8))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45903_ '5))
                                          (list std/pregexp#*pregexp-return-char*
                                                (+ _i45884_ '2))
                                          (if (let ()
                                                (declare (not safe))
                                                (##fx= _x45903_ '6))
                                              (list ':space (+ _i45884_ '2))
                                              (list '(:neg-char :space)
                                                    (+ _i45884_ '2))))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45903_ '8))
                                          (list std/pregexp#*pregexp-tab-char*
                                                (+ _i45884_ '2))
                                          (if (let ()
                                                (declare (not safe))
                                                (##fx= _x45903_ '9))
                                              (list ':word (+ _i45884_ '2))
                                              (list '(:neg-char :word)
                                                    (+ _i45884_ '2))))))
                              (_default4589145895_)))
                        (_default4589145895_)))
                  (_default4589145895_))))
          '#f)))
  (define std/pregexp#pregexp-read-posix-char-class
    (lambda (_s45865_ _i45866_ _n45867_)
      (let ((_neg?45869_ '#f))
        (let _loop45871_ ((_i45873_ _i45866_) (_r45874_ (list '#\:)))
          (if (>= _i45873_ _n45867_)
              (std/pregexp#pregexp-error 'pregexp-read-posix-char-class)
              (let ((_c45876_
                     (let ()
                       (declare (not safe))
                       (##string-ref _s45865_ _i45873_))))
                (if (char=? _c45876_ '#\^)
                    (begin
                      (set! _neg?45869_ '#t)
                      (_loop45871_ (+ _i45873_ '1) _r45874_))
                    (if (char-alphabetic? _c45876_)
                        (_loop45871_ (+ _i45873_ '1) (cons _c45876_ _r45874_))
                        (if (char=? _c45876_ '#\:)
                            (if (or (>= (+ _i45873_ '1) _n45867_)
                                    (not (char=? (let ((__tmp281176
                                                        (+ _i45873_ '1)))
                                                   (declare (not safe))
                                                   (##string-ref
                                                    _s45865_
                                                    __tmp281176))
                                                 '#\])))
                                (std/pregexp#pregexp-error
                                 'pregexp-read-posix-char-class)
                                (let ((_posix-class45881_
                                       (string->symbol
                                        (list->string
                                         (std/pregexp#pregexp-reverse!
                                          _r45874_)))))
                                  (list (if _neg?45869_
                                            (list ':neg-char
                                                  _posix-class45881_)
                                            _posix-class45881_)
                                        (+ _i45873_ '2))))
                            (std/pregexp#pregexp-error
                             'pregexp-read-posix-char-class))))))))))
  (define std/pregexp#pregexp-read-cluster-type
    (lambda (_s45837_ _i45838_ _n45839_)
      (let* ((_c45841_
              (let () (declare (not safe)) (##string-ref _s45837_ _i45838_)))
             (_$e45843_ _c45841_))
        (if (eq? '#\? _$e45843_)
            (let* ((_i45846_ (+ _i45838_ '1))
                   (_$e45848_
                    (let ()
                      (declare (not safe))
                      (##string-ref _s45837_ _i45846_))))
              (if (eq? '#\: _$e45848_)
                  (list '() (+ _i45846_ '1))
                  (if (eq? '#\= _$e45848_)
                      (list '(:lookahead) (+ _i45846_ '1))
                      (if (eq? '#\! _$e45848_)
                          (list '(:neg-lookahead) (+ _i45846_ '1))
                          (if (eq? '#\> _$e45848_)
                              (list '(:no-backtrack) (+ _i45846_ '1))
                              (if (eq? '#\< _$e45848_)
                                  (list (let ((_$e45851_
                                               (let ((__tmp281177
                                                      (+ _i45846_ '1)))
                                                 (declare (not safe))
                                                 (##string-ref
                                                  _s45837_
                                                  __tmp281177))))
                                          (if (eq? '#\= _$e45851_)
                                              '(:lookbehind)
                                              (if (eq? '#\! _$e45851_)
                                                  '(:neg-lookbehind)
                                                  (std/pregexp#pregexp-error
                                                   'pregexp-read-cluster-type))))
                                        (+ _i45846_ '2))
                                  (let _loop45854_ ((_i45856_ _i45846_)
                                                    (_r45857_ '())
                                                    (_inv?45858_ '#f))
                                    (let* ((_c45860_
                                            (let ()
                                              (declare (not safe))
                                              (##string-ref
                                               _s45837_
                                               _i45856_)))
                                           (_$e45862_ _c45860_))
                                      (if (eq? '#\- _$e45862_)
                                          (_loop45854_
                                           (+ _i45856_ '1)
                                           _r45857_
                                           '#t)
                                          (if (eq? '#\i _$e45862_)
                                              (_loop45854_
                                               (+ _i45856_ '1)
                                               (cons (if _inv?45858_
                                                         ':case-sensitive
                                                         ':case-insensitive)
                                                     _r45857_)
                                               '#f)
                                              (if (eq? '#\x _$e45862_)
                                                  (begin
                                                    (std/pregexp#pregexp-space-sensitive?
                                                     _inv?45858_)
                                                    (_loop45854_
                                                     (+ _i45856_ '1)
                                                     _r45857_
                                                     '#f))
                                                  (if (eq? '#\: _$e45862_)
                                                      (list _r45857_
                                                            (+ _i45856_ '1))
                                                      (std/pregexp#pregexp-error
                                                       'pregexp-read-cluster-type)))))))))))))
            (list '(:sub) _i45838_)))))
  (define std/pregexp#pregexp-read-subpattern
    (lambda (_s45814_ _i45815_ _n45816_)
      (let* ((_remember-space-sensitive?45818_
              (std/pregexp#pregexp-space-sensitive?))
             (_ctyp-i45820_
              (std/pregexp#pregexp-read-cluster-type
               _s45814_
               _i45815_
               _n45816_))
             (_ctyp45822_ (car _ctyp-i45820_))
             (_i45824_ (cadr _ctyp-i45820_))
             (_vv45826_
              (std/pregexp#pregexp-read-pattern _s45814_ _i45824_ _n45816_)))
        (std/pregexp#pregexp-space-sensitive? _remember-space-sensitive?45818_)
        (let ((_vv-re45829_ (car _vv45826_)) (_vv-i45830_ (cadr _vv45826_)))
          (if (and (< _vv-i45830_ _n45816_)
                   (char=? (let ()
                             (declare (not safe))
                             (##string-ref _s45814_ _vv-i45830_))
                           '#\)))
              (list (let _loop45832_ ((_ctyp45834_ _ctyp45822_)
                                      (_re45835_ _vv-re45829_))
                      (if (null? _ctyp45834_)
                          _re45835_
                          (_loop45832_
                           (cdr _ctyp45834_)
                           (list (car _ctyp45834_) _re45835_))))
                    (+ _vv-i45830_ '1))
              (std/pregexp#pregexp-error 'pregexp-read-subpattern))))))
  (define std/pregexp#pregexp-wrap-quantifier-if-any
    (lambda (_vv45774_ _s45775_ _n45776_)
      (let ((_re45778_ (car _vv45774_)))
        (let _loop45780_ ((_i45782_ (cadr _vv45774_)))
          (if (>= _i45782_ _n45776_)
              _vv45774_
              (let ((_c45784_
                     (let ()
                       (declare (not safe))
                       (##string-ref _s45775_ _i45782_))))
                (if (and (char-whitespace? _c45784_)
                         (not (std/pregexp#pregexp-space-sensitive?)))
                    (_loop45780_ (+ _i45782_ '1))
                    (let ((_$e45786_ _c45784_))
                      (if (or (eq? '#\* _$e45786_)
                              (eq? '#\+ _$e45786_)
                              (eq? '#\? _$e45786_)
                              (eq? '#\{ _$e45786_))
                          (let* ((_new-re45798_
                                  (list ':between
                                        'minimal?
                                        'at-least
                                        'at-most
                                        _re45778_))
                                 (_new-vv45800_ (list _new-re45798_ 'next-i)))
                            (let ((_$e45803_ _c45784_))
                              (if (eq? '#\* _$e45803_)
                                  (begin
                                    (set-car! (cddr _new-re45798_) '0)
                                    (set-car! (cdddr _new-re45798_) '#f))
                                  (if (eq? '#\+ _$e45803_)
                                      (begin
                                        (set-car! (cddr _new-re45798_) '1)
                                        (set-car! (cdddr _new-re45798_) '#f))
                                      (if (eq? '#\? _$e45803_)
                                          (begin
                                            (set-car! (cddr _new-re45798_) '0)
                                            (set-car!
                                             (cdddr _new-re45798_)
                                             '1))
                                          (if (eq? '#\{ _$e45803_)
                                              (let ((_pq45806_
                                                     (std/pregexp#pregexp-read-nums
                                                      _s45775_
                                                      (+ _i45782_ '1)
                                                      _n45776_)))
                                                (if (not _pq45806_)
                                                    (std/pregexp#pregexp-error
                                                     'pregexp-wrap-quantifier-if-any
                                                     'left-brace-must-be-followed-by-number)
                                                    '#!void)
                                                (set-car!
                                                 (cddr _new-re45798_)
                                                 (car _pq45806_))
                                                (set-car!
                                                 (cdddr _new-re45798_)
                                                 (cadr _pq45806_))
                                                (set! _i45782_
                                                      (caddr _pq45806_)))
                                              '#!void)))))
                            (let _loop45808_ ((_i45810_ (+ _i45782_ '1)))
                              (if (>= _i45810_ _n45776_)
                                  (begin
                                    (set-car! (cdr _new-re45798_) '#f)
                                    (set-car! (cdr _new-vv45800_) _i45810_))
                                  (let ((_c45812_
                                         (let ()
                                           (declare (not safe))
                                           (##string-ref _s45775_ _i45810_))))
                                    (if (and (char-whitespace? _c45812_)
                                             (not (std/pregexp#pregexp-space-sensitive?)))
                                        (_loop45808_ (+ _i45810_ '1))
                                        (if (char=? _c45812_ '#\?)
                                            (begin
                                              (set-car!
                                               (cdr _new-re45798_)
                                               '#t)
                                              (set-car!
                                               (cdr _new-vv45800_)
                                               (+ _i45810_ '1)))
                                            (begin
                                              (set-car!
                                               (cdr _new-re45798_)
                                               '#f)
                                              (set-car!
                                               (cdr _new-vv45800_)
                                               _i45810_)))))))
                            _new-vv45800_)
                          _vv45774_)))))))))
  (define std/pregexp#pregexp-read-nums
    (lambda (_s45758_ _i45759_ _n45760_)
      (let _loop45762_ ((_p45764_ '())
                        (_q45765_ '())
                        (_k45766_ _i45759_)
                        (_reading45767_ '1))
        (if (>= _k45766_ _n45760_)
            (std/pregexp#pregexp-error 'pregexp-read-nums)
            '#!void)
        (let ((_c45769_
               (let () (declare (not safe)) (##string-ref _s45758_ _k45766_))))
          (if (char-numeric? _c45769_)
              (if (= _reading45767_ '1)
                  (_loop45762_
                   (cons _c45769_ _p45764_)
                   _q45765_
                   (+ _k45766_ '1)
                   '1)
                  (_loop45762_
                   _p45764_
                   (cons _c45769_ _q45765_)
                   (+ _k45766_ '1)
                   '2))
              (if (and (char-whitespace? _c45769_)
                       (not (std/pregexp#pregexp-space-sensitive?)))
                  (_loop45762_
                   _p45764_
                   _q45765_
                   (+ _k45766_ '1)
                   _reading45767_)
                  (if (and (char=? _c45769_ '#\,) (= _reading45767_ '1))
                      (_loop45762_ _p45764_ _q45765_ (+ _k45766_ '1) '2)
                      (if (char=? _c45769_ '#\})
                          (let ((_p45771_
                                 (string->number
                                  (list->string
                                   (std/pregexp#pregexp-reverse! _p45764_))))
                                (_q45772_
                                 (string->number
                                  (list->string
                                   (std/pregexp#pregexp-reverse! _q45765_)))))
                            (if (and (not _p45771_) (= _reading45767_ '1))
                                (list '0 '#f _k45766_)
                                (if (= _reading45767_ '1)
                                    (list _p45771_ _p45771_ _k45766_)
                                    (list _p45771_ _q45772_ _k45766_))))
                          '#f))))))))
  (define std/pregexp#pregexp-invert-char-list
    (lambda (_vv45756_) (set-car! (car _vv45756_) ':none-of-chars) _vv45756_))
  (define std/pregexp#pregexp-read-char-list
    (lambda (_s45731_ _i45732_ _n45733_)
      (let _loop45735_ ((_r45737_ '()) (_i45738_ _i45732_))
        (if (>= _i45738_ _n45733_)
            (std/pregexp#pregexp-error
             'pregexp-read-char-list
             'character-class-ended-too-soon)
            (let* ((_c45740_
                    (let ()
                      (declare (not safe))
                      (##string-ref _s45731_ _i45738_)))
                   (_$e45742_ _c45740_))
              (if (eq? '#\] _$e45742_)
                  (if (null? _r45737_)
                      (_loop45735_ (cons _c45740_ _r45737_) (+ _i45738_ '1))
                      (list (cons ':one-of-chars
                                  (std/pregexp#pregexp-reverse! _r45737_))
                            (+ _i45738_ '1)))
                  (if (eq? '#\\ _$e45742_)
                      (let ((_char-i45745_
                             (std/pregexp#pregexp-read-escaped-char
                              _s45731_
                              _i45738_
                              _n45733_)))
                        (if _char-i45745_
                            (_loop45735_
                             (cons (car _char-i45745_) _r45737_)
                             (cadr _char-i45745_))
                            (std/pregexp#pregexp-error
                             'pregexp-read-char-list
                             'backslash)))
                      (if (eq? '#\- _$e45742_)
                          (if (or (null? _r45737_)
                                  (let ((_i+145750_ (+ _i45738_ '1)))
                                    (and (< _i+145750_ _n45733_)
                                         (char=? (let ()
                                                   (declare (not safe))
                                                   (##string-ref
                                                    _s45731_
                                                    _i+145750_))
                                                 '#\]))))
                              (_loop45735_
                               (cons _c45740_ _r45737_)
                               (+ _i45738_ '1))
                              (let ((_c-prev45752_ (car _r45737_)))
                                (if (char? _c-prev45752_)
                                    (_loop45735_
                                     (cons (list ':char-range
                                                 _c-prev45752_
                                                 (let ((__tmp281178
                                                        (+ _i45738_ '1)))
                                                   (declare (not safe))
                                                   (##string-ref
                                                    _s45731_
                                                    __tmp281178)))
                                           (cdr _r45737_))
                                     (+ _i45738_ '2))
                                    (_loop45735_
                                     (cons _c45740_ _r45737_)
                                     (+ _i45738_ '1)))))
                          (if (eq? '#\[ _$e45742_)
                              (if (char=? (let ((__tmp281179 (+ _i45738_ '1)))
                                            (declare (not safe))
                                            (##string-ref
                                             _s45731_
                                             __tmp281179))
                                          '#\:)
                                  (let ((_posix-char-class-i45754_
                                         (std/pregexp#pregexp-read-posix-char-class
                                          _s45731_
                                          (+ _i45738_ '2)
                                          _n45733_)))
                                    (_loop45735_
                                     (cons (car _posix-char-class-i45754_)
                                           _r45737_)
                                     (cadr _posix-char-class-i45754_)))
                                  (_loop45735_
                                   (cons _c45740_ _r45737_)
                                   (+ _i45738_ '1)))
                              (_loop45735_
                               (cons _c45740_ _r45737_)
                               (+ _i45738_ '1)))))))))))
  (define std/pregexp#pregexp-string-match
    (lambda (_s145717_ _s45718_ _i45719_ _n45720_ _sk45721_ _fk45722_)
      (let ((_n145724_ (string-length _s145717_)))
        (if (> _n145724_ _n45720_)
            (_fk45722_)
            (let _loop45726_ ((_j45728_ '0) (_k45729_ _i45719_))
              (if (>= _j45728_ _n145724_)
                  (_sk45721_ _k45729_)
                  (if (>= _k45729_ _n45720_)
                      (_fk45722_)
                      (if (char=? (let ()
                                    (declare (not safe))
                                    (##string-ref _s145717_ _j45728_))
                                  (let ()
                                    (declare (not safe))
                                    (##string-ref _s45718_ _k45729_)))
                          (_loop45726_ (+ _j45728_ '1) (+ _k45729_ '1))
                          (_fk45722_)))))))))
  (define std/pregexp#pregexp-char-word?
    (lambda (_c45709_)
      (let ((_$e45711_ (char-alphabetic? _c45709_)))
        (if _$e45711_
            _$e45711_
            (let ((_$e45714_ (char-numeric? _c45709_)))
              (if _$e45714_ _$e45714_ (char=? _c45709_ '#\_)))))))
  (define std/pregexp#pregexp-at-word-boundary?
    (lambda (_s45690_ _i45691_ _n45692_)
      (let ((_$e45694_ (= _i45691_ '0)))
        (if _$e45694_
            _$e45694_
            (let ((_$e45697_ (>= _i45691_ _n45692_)))
              (if _$e45697_
                  _$e45697_
                  (let ((_c/i45700_
                         (let ()
                           (declare (not safe))
                           (##string-ref _s45690_ _i45691_)))
                        (_c/i-145701_
                         (let ((__tmp281180 (- _i45691_ '1)))
                           (declare (not safe))
                           (##string-ref _s45690_ __tmp281180))))
                    (let ((_c/i/w?45703_
                           (std/pregexp#pregexp-check-if-in-char-class?
                            _c/i45700_
                            ':word))
                          (_c/i-1/w?45704_
                           (std/pregexp#pregexp-check-if-in-char-class?
                            _c/i-145701_
                            ':word)))
                      (let ((_$e45706_
                             (if _c/i/w?45703_ (not _c/i-1/w?45704_) '#f)))
                        (if _$e45706_
                            _$e45706_
                            (if (not _c/i/w?45703_)
                                _c/i-1/w?45704_
                                '#f)))))))))))
  (define std/pregexp#pregexp-check-if-in-char-class?
    (lambda (_c45633_ _char-class45634_)
      (let ((_$e45636_ _char-class45634_))
        (let ((_default4563845642_
               (lambda ()
                 (std/pregexp#pregexp-error 'pregexp-check-if-in-char-class?)))
              (_table4563945644_
               '#(#f
                  #f
                  #f
                  #f
                  #f
                  #f
                  (:digit . 6)
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  (:alnum . 1)
                  (:word . 13)
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  (:cntrl . 5)
                  #f
                  #f
                  #f
                  #f
                  (:alpha . 2)
                  #f
                  #f
                  (:lower . 8)
                  #f
                  #f
                  #f
                  #f
                  #f
                  (:xdigit . 14)
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  (:space . 11)
                  #f
                  (:upper . 12)
                  #f
                  #f
                  #f
                  (:punct . 10)
                  #f
                  (:any . 0)
                  #f
                  #f
                  (:print . 9)
                  (:blank . 4)
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  (:ascii . 3)
                  #f
                  #f
                  #f
                  #f
                  #f
                  #f
                  (:graph . 7))))
          (if (symbol? _$e45636_)
              (let* ((_h45647_
                      (let () (declare (not safe)) (##symbol-hash _$e45636_)))
                     (_ix45650_
                      (let () (declare (not safe)) (##fxmodulo _h45647_ '100)))
                     (_q45653_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _table4563945644_ _ix45650_))))
                (if _q45653_
                    (if (eq? (let () (declare (not safe)) (##car _q45653_))
                             _$e45636_)
                        (let ((_x45657_
                               (let () (declare (not safe)) (##cdr _q45653_))))
                          (if (let () (declare (not safe)) (##fx< _x45657_ '7))
                              (if (let ()
                                    (declare (not safe))
                                    (##fx< _x45657_ '3))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx= _x45657_ '0))
                                      (not (char=? _c45633_ '#\newline))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45657_ '1))
                                          (let ((_$e45660_
                                                 (char-alphabetic? _c45633_)))
                                            (if _$e45660_
                                                _$e45660_
                                                (char-numeric? _c45633_)))
                                          (char-alphabetic? _c45633_)))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx< _x45657_ '5))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45657_ '3))
                                          (< (char->integer _c45633_) '128)
                                          (let ((_$e45663_
                                                 (char=? _c45633_ '#\space)))
                                            (if _$e45663_
                                                _$e45663_
                                                (char=? _c45633_
                                                        std/pregexp#*pregexp-tab-char*))))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45657_ '5))
                                          (< (char->integer _c45633_) '32)
                                          (char-numeric? _c45633_))))
                              (if (let ()
                                    (declare (not safe))
                                    (##fx< _x45657_ '11))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx< _x45657_ '9))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45657_ '7))
                                          (if (>= (char->integer _c45633_) '32)
                                              (not (char-whitespace? _c45633_))
                                              '#f)
                                          (char-lower-case? _c45633_))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45657_ '9))
                                          (>= (char->integer _c45633_) '32)
                                          (if (>= (char->integer _c45633_) '32)
                                              (if (not (char-whitespace?
                                                        _c45633_))
                                                  (if (not (char-alphabetic?
                                                            _c45633_))
                                                      (not (char-numeric?
                                                            _c45633_))
                                                      '#f)
                                                  '#f)
                                              '#f)))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx< _x45657_ '13))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45657_ '11))
                                          (char-whitespace? _c45633_)
                                          (char-upper-case? _c45633_))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45657_ '13))
                                          (let ((_$e45666_
                                                 (char-alphabetic? _c45633_)))
                                            (if _$e45666_
                                                _$e45666_
                                                (let ((_$e45669_
                                                       (char-numeric?
                                                        _c45633_)))
                                                  (if _$e45669_
                                                      _$e45669_
                                                      (char=? _c45633_
                                                              '#\_)))))
                                          (let ((_$e45672_
                                                 (char-numeric? _c45633_)))
                                            (if _$e45672_
                                                _$e45672_
                                                (let ((_$e45675_
                                                       (char-ci=?
                                                        _c45633_
                                                        '#\a)))
                                                  (if _$e45675_
                                                      _$e45675_
                                                      (let ((_$e45678_
                                                             (char-ci=?
                                                              _c45633_
                                                              '#\b)))
                                                        (if _$e45678_
                                                            _$e45678_
                                                            (let ((_$e45681_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           (char-ci=? _c45633_ '#\c)))
                      (if _$e45681_
                          _$e45681_
                          (let ((_$e45684_ (char-ci=? _c45633_ '#\d)))
                            (if _$e45684_
                                _$e45684_
                                (let ((_$e45687_ (char-ci=? _c45633_ '#\e)))
                                  (if _$e45687_
                                      _$e45687_
                                      (char-ci=?
                                       _c45633_
                                       '#\f))))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                        (_default4563845642_))
                    (_default4563845642_)))
              (_default4563845642_))))))
  (define std/pregexp#pregexp-list-ref
    (lambda (_s45625_ _i45626_)
      (let _loop45628_ ((_s45630_ _s45625_) (_k45631_ '0))
        (if (null? _s45630_)
            '#f
            (if (= _k45631_ _i45626_)
                (car _s45630_)
                (_loop45628_ (cdr _s45630_) (+ _k45631_ '1)))))))
  (define std/pregexp#pregexp-make-backref-list
    (lambda (_re45616_)
      (let _sub45618_ ((_re45620_ _re45616_))
        (if (pair? _re45620_)
            (let ((_car-re45622_ (car _re45620_))
                  (_sub-cdr-re45623_ (_sub45618_ (cdr _re45620_))))
              (if (eqv? _car-re45622_ ':sub)
                  (cons (cons _re45620_ '#f) _sub-cdr-re45623_)
                  (append (_sub45618_ _car-re45622_) _sub-cdr-re45623_)))
            '()))))
  (define std/pregexp#pregexp-match-positions-aux
    (lambda (_re45464_ _s45465_ _sn45466_ _start45467_ _n45468_ _i45469_)
      (let ((_identity45473_ (lambda (_x45471_) _x45471_))
            (_backrefs45474_ (std/pregexp#pregexp-make-backref-list _re45464_))
            (_case-sensitive?45475_ '#t))
        (let _sub45477_ ((_re45479_ _re45464_)
                         (_i45480_ _i45469_)
                         (_sk45481_ _identity45473_)
                         (_fk45482_ (lambda () '#f)))
          (if (eqv? _re45479_ ':bos)
              (if (= _i45480_ _start45467_) (_sk45481_ _i45480_) (_fk45482_))
              (if (eqv? _re45479_ ':eos)
                  (if (>= _i45480_ _n45468_) (_sk45481_ _i45480_) (_fk45482_))
                  (if (eqv? _re45479_ ':empty)
                      (_sk45481_ _i45480_)
                      (if (eqv? _re45479_ ':wbdry)
                          (if (std/pregexp#pregexp-at-word-boundary?
                               _s45465_
                               _i45480_
                               _n45468_)
                              (_sk45481_ _i45480_)
                              (_fk45482_))
                          (if (eqv? _re45479_ ':not-wbdry)
                              (if (std/pregexp#pregexp-at-word-boundary?
                                   _s45465_
                                   _i45480_
                                   _n45468_)
                                  (_fk45482_)
                                  (_sk45481_ _i45480_))
                              (if (and (char? _re45479_) (< _i45480_ _n45468_))
                                  (if ((if _case-sensitive?45475_
                                           char=?
                                           char-ci=?)
                                       (let ()
                                         (declare (not safe))
                                         (##string-ref _s45465_ _i45480_))
                                       _re45479_)
                                      (_sk45481_ (+ _i45480_ '1))
                                      (_fk45482_))
                                  (if (and (not (pair? _re45479_))
                                           (< _i45480_ _n45468_))
                                      (if (std/pregexp#pregexp-check-if-in-char-class?
                                           (let ()
                                             (declare (not safe))
                                             (##string-ref _s45465_ _i45480_))
                                           _re45479_)
                                          (_sk45481_ (+ _i45480_ '1))
                                          (_fk45482_))
                                      (if (and (pair? _re45479_)
                                               (eqv? (car _re45479_)
                                                     ':char-range)
                                               (< _i45480_ _n45468_))
                                          (let ((_c45484_
                                                 (let ()
                                                   (declare (not safe))
                                                   (##string-ref
                                                    _s45465_
                                                    _i45480_))))
                                            (if (let ((_c<45486_
                                                       (if _case-sensitive?45475_
                                                           char<=?
                                                           char-ci<=?)))
                                                  (and (_c<45486_
                                                        (cadr _re45479_)
                                                        _c45484_)
                                                       (_c<45486_
                                                        _c45484_
                                                        (caddr _re45479_))))
                                                (_sk45481_ (+ _i45480_ '1))
                                                (_fk45482_)))
                                          (if (pair? _re45479_)
                                              (let ((_$e45488_
                                                     (car _re45479_)))
                                                (let ((_default4549045494_
                                                       (lambda ()
                                                         (std/pregexp#pregexp-error
                                                          'pregexp-match-positions-aux)))
                                                      (_table4549145496_
                                                       '#(#f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          (:neg-char . 2)
                                                          #f
                                                          #f
                                                          #f
                                                          (:neg-lookahead . 8)
                                                          (:sub . 6)
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          (:or . 4)
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          (:char-range . 0)
                                                          #f
                                                          #f
                                                          #f
                                                          (:case-insensitive
                                                           .
                                                           12)
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          (:lookahead . 7)
                                                          #f
                                                          #f
                                                          #f
                                                          (:between . 13)
                                                          #f
                                                          #f
                                                          #f
                                                          (:one-of-chars . 1)
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          (:backref . 5)
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          (:lookbehind . 9)
                                                          (:neg-lookbehind
                                                           .
                                                           10)
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          (:case-sensitive
                                                           .
                                                           12)
                                                          #f
                                                          #f
                                                          #f
                                                          (:seq . 3)
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          #f
                                                          (:no-backtrack . 11)
                                                          #f
                                                          #f)))
                                                  (if (symbol? _$e45488_)
                                                      (let* ((_h45499_
                                                              (let ()
                                                                (declare
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (not safe))
                        (##symbol-hash _$e45488_)))
                     (_ix45502_
                      (let () (declare (not safe)) (##fxmodulo _h45499_ '100)))
                     (_q45505_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _table4549145496_ _ix45502_))))
                (if _q45505_
                    (if (eq? (let () (declare (not safe)) (##car _q45505_))
                             _$e45488_)
                        (let ((_x45509_
                               (let () (declare (not safe)) (##cdr _q45505_))))
                          (if (let () (declare (not safe)) (##fx< _x45509_ '7))
                              (if (let ()
                                    (declare (not safe))
                                    (##fx< _x45509_ '3))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx= _x45509_ '0))
                                      (if (>= _i45480_ _n45468_)
                                          (_fk45482_)
                                          (std/pregexp#pregexp-error
                                           'pregexp-match-positions-aux))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45509_ '1))
                                          (if (>= _i45480_ _n45468_)
                                              (_fk45482_)
                                              (let _loup-one-of-chars45512_ ((_chars45514_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                                      (cdr _re45479_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                (if (null? _chars45514_)
                                                    (_fk45482_)
                                                    (_sub45477_
                                                     (car _chars45514_)
                                                     _i45480_
                                                     _sk45481_
                                                     (lambda ()
                                                       (_loup-one-of-chars45512_
                                                        (cdr _chars45514_)))))))
                                          (if (>= _i45480_ _n45468_)
                                              (_fk45482_)
                                              (_sub45477_
                                               (cadr _re45479_)
                                               _i45480_
                                               (lambda (_i145517_) (_fk45482_))
                                               (lambda ()
                                                 (_sk45481_
                                                  (+ _i45480_ '1)))))))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx< _x45509_ '5))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45509_ '3))
                                          (let _loup-seq45520_ ((_res45522_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (cdr _re45479_))
                        (_i45523_ _i45480_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                            (if (null? _res45522_)
                                                (_sk45481_ _i45523_)
                                                (_sub45477_
                                                 (car _res45522_)
                                                 _i45523_
                                                 (lambda (_i145525_)
                                                   (_loup-seq45520_
                                                    (cdr _res45522_)
                                                    _i145525_))
                                                 _fk45482_)))
                                          (let _loup-or45527_ ((_res45529_
                                                                (cdr _re45479_)))
                                            (if (null? _res45529_)
                                                (_fk45482_)
                                                (_sub45477_
                                                 (car _res45529_)
                                                 _i45480_
                                                 (lambda (_i145531_)
                                                   (let ((_$e45533_
                                                          (_sk45481_
                                                           _i145531_)))
                                                     (if _$e45533_
                                                         _$e45533_
                                                         (_loup-or45527_
                                                          (cdr _res45529_)))))
                                                 (lambda ()
                                                   (_loup-or45527_
                                                    (cdr _res45529_)))))))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45509_ '5))
                                          (let* ((_c45537_
                                                  (std/pregexp#pregexp-list-ref
                                                   _backrefs45474_
                                                   (cadr _re45479_)))
                                                 (_backref45542_
                                                  (let ((_$e45539_ _c45537_))
                                                    (if _$e45539_
                                                        (cdr _$e45539_)
                                                        (begin
                                                          (std/pregexp#pregexp-error
                                                           'pregexp-match-positions-aux
                                                           'non-existent-backref
                                                           _re45479_)
                                                          '#f)))))
                                            (if _backref45542_
                                                (std/pregexp#pregexp-string-match
                                                 (substring
                                                  _s45465_
                                                  (car _backref45542_)
                                                  (cdr _backref45542_))
                                                 _s45465_
                                                 _i45480_
                                                 _n45468_
                                                 (lambda (_i45545_)
                                                   (_sk45481_ _i45545_))
                                                 _fk45482_)
                                                (_sk45481_ _i45480_)))
                                          (_sub45477_
                                           (cadr _re45479_)
                                           _i45480_
                                           (lambda (_i145547_)
                                             (set-cdr!
                                              (assv _re45479_ _backrefs45474_)
                                              (cons _i45480_ _i145547_))
                                             (_sk45481_ _i145547_))
                                           _fk45482_))))
                              (if (let ()
                                    (declare (not safe))
                                    (##fx< _x45509_ '10))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx= _x45509_ '7))
                                      (let ((_found-it?45550_
                                             (_sub45477_
                                              (cadr _re45479_)
                                              _i45480_
                                              _identity45473_
                                              (lambda () '#f))))
                                        (if _found-it?45550_
                                            (_sk45481_ _i45480_)
                                            (_fk45482_)))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45509_ '8))
                                          (let ((_found-it?45553_
                                                 (_sub45477_
                                                  (cadr _re45479_)
                                                  _i45480_
                                                  _identity45473_
                                                  (lambda () '#f))))
                                            (if _found-it?45553_
                                                (_fk45482_)
                                                (_sk45481_ _i45480_)))
                                          (let ((_n-actual45555_ _n45468_)
                                                (_sn-actual45556_ _sn45466_))
                                            (set! _n45468_ _i45480_)
                                            (set! _sn45466_ _i45480_)
                                            (let ((_found-it?45559_
                                                   (_sub45477_
                                                    (list ':seq
                                                          '(:between
                                                            #f
                                                            0
                                                            #f
                                                            :any)
                                                          (cadr _re45479_)
                                                          ':eos)
                                                    '0
                                                    _identity45473_
                                                    (lambda () '#f))))
                                              (set! _n45468_ _n-actual45555_)
                                              (set! _sn45466_ _sn-actual45556_)
                                              (if _found-it?45559_
                                                  (_sk45481_ _i45480_)
                                                  (_fk45482_))))))
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx< _x45509_ '12))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45509_ '10))
                                          (let ((_n-actual45561_ _n45468_)
                                                (_sn-actual45562_ _sn45466_))
                                            (set! _n45468_ _i45480_)
                                            (set! _sn45466_ _i45480_)
                                            (let ((_found-it?45565_
                                                   (_sub45477_
                                                    (list ':seq
                                                          '(:between
                                                            #f
                                                            0
                                                            #f
                                                            :any)
                                                          (cadr _re45479_)
                                                          ':eos)
                                                    '0
                                                    _identity45473_
                                                    (lambda () '#f))))
                                              (set! _n45468_ _n-actual45561_)
                                              (set! _sn45466_ _sn-actual45562_)
                                              (if _found-it?45565_
                                                  (_fk45482_)
                                                  (_sk45481_ _i45480_))))
                                          (let ((_found-it?45568_
                                                 (_sub45477_
                                                  (cadr _re45479_)
                                                  _i45480_
                                                  _identity45473_
                                                  (lambda () '#f))))
                                            (if _found-it?45568_
                                                (_sk45481_ _found-it?45568_)
                                                (_fk45482_))))
                                      (if (let ()
                                            (declare (not safe))
                                            (##fx= _x45509_ '12))
                                          (let ((_old45570_
                                                 _case-sensitive?45475_))
                                            (set! _case-sensitive?45475_
                                                  (eqv? (car _re45479_)
                                                        ':case-sensitive))
                                            (_sub45477_
                                             (cadr _re45479_)
                                             _i45480_
                                             (lambda (_i145572_)
                                               (set! _case-sensitive?45475_
                                                     _old45570_)
                                               (_sk45481_ _i145572_))
                                             (lambda ()
                                               (set! _case-sensitive?45475_
                                                     _old45570_)
                                               (_fk45482_))))
                                          (let* ((_maximal?45575_
                                                  (not (cadr _re45479_)))
                                                 (_p45577_ (caddr _re45479_))
                                                 (_q45579_ (cadddr _re45479_))
                                                 (_could-loop-infinitely?45581_
                                                  (if _maximal?45575_
                                                      (not _q45579_)
                                                      '#f))
                                                 (_re45583_
                                                  (car (cddddr _re45479_))))
                                            (let _loup-p45586_ ((_k45588_ '0)
                                                                (_i45589_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _i45480_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (if (< _k45588_ _p45577_)
                                                  (_sub45477_
                                                   _re45583_
                                                   _i45589_
                                                   (lambda (_i145591_)
                                                     (if (and _could-loop-infinitely?45581_
                                                              (= _i145591_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _i45589_))
                 (std/pregexp#pregexp-error
                  'pregexp-match-positions-aux
                  'greedy-quantifier-operand-could-be-empty)
                 '#!void)
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_loup-p45586_
                                                      (+ _k45588_ '1)
                                                      _i145591_))
                                                   _fk45482_)
                                                  (let ((_q45593_
                                                         (if _q45579_
                                                             (- _q45579_
                                                                _p45577_)
                                                             '#f)))
                                                    (let _loup-q45595_ ((_k45597_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                                 '0)
                                (_i45598_ _i45589_))
              (let ((_fk45601_ (lambda () (_sk45481_ _i45598_))))
                (if (and _q45593_ (>= _k45597_ _q45593_))
                    (_fk45601_)
                    (if _maximal?45575_
                        (_sub45477_
                         _re45583_
                         _i45598_
                         (lambda (_i145603_)
                           (if (and _could-loop-infinitely?45581_
                                    (= _i145603_ _i45598_))
                               (std/pregexp#pregexp-error
                                'pregexp-match-positions-aux
                                'greedy-quantifier-operand-could-be-empty)
                               '#!void)
                           (let ((_$e45605_
                                  (_loup-q45595_ (+ _k45597_ '1) _i145603_)))
                             (if _$e45605_ _$e45605_ (_fk45601_))))
                         _fk45601_)
                        (let ((_$e45608_ (_fk45601_)))
                          (if _$e45608_
                              _$e45608_
                              (_sub45477_
                               _re45583_
                               _i45598_
                               (lambda (_i145611_)
                                 (_loup-q45595_ (+ _k45597_ '1) _i145611_))
                               _fk45601_))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                        (_default4549045494_))
                    (_default4549045494_)))
              (_default4549045494_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (if (>= _i45480_ _n45468_)
                                                  (_fk45482_)
                                                  (std/pregexp#pregexp-error
                                                   'pregexp-match-positions-aux))))))))))))
        (let ((_backrefs45614_ (map cdr _backrefs45474_)))
          (if (car _backrefs45614_) _backrefs45614_ '#f)))))
  (define std/pregexp#pregexp-replace-aux
    (lambda (_str45441_ _ins45442_ _n45443_ _backrefs45444_)
      (let _loop45446_ ((_i45448_ '0) (_r45449_ '""))
        (if (>= _i45448_ _n45443_)
            _r45449_
            (let ((_c45451_
                   (let ()
                     (declare (not safe))
                     (##string-ref _ins45442_ _i45448_))))
              (if (char=? _c45451_ '#\\)
                  (let* ((_br-i45453_
                          (std/pregexp#pregexp-read-escaped-number
                           _ins45442_
                           _i45448_
                           _n45443_))
                         (_br45455_
                          (if _br-i45453_
                              (car _br-i45453_)
                              (if (char=? (let ((__tmp281181 (+ _i45448_ '1)))
                                            (declare (not safe))
                                            (##string-ref
                                             _ins45442_
                                             __tmp281181))
                                          '#\&)
                                  '0
                                  '#f)))
                         (_i45457_
                          (if _br-i45453_
                              (cadr _br-i45453_)
                              (if _br45455_ (+ _i45448_ '2) (+ _i45448_ '1)))))
                    (if (not _br45455_)
                        (let ((_c245460_
                               (let ()
                                 (declare (not safe))
                                 (##string-ref _ins45442_ _i45457_))))
                          (_loop45446_
                           (+ _i45457_ '1)
                           (if (char=? _c245460_ '#\$)
                               _r45449_
                               (string-append _r45449_ (string _c245460_)))))
                        (_loop45446_
                         _i45457_
                         (let ((_backref45462_
                                (std/pregexp#pregexp-list-ref
                                 _backrefs45444_
                                 _br45455_)))
                           (if _backref45462_
                               (string-append
                                _r45449_
                                (substring
                                 _str45441_
                                 (car _backref45462_)
                                 (cdr _backref45462_)))
                               _r45449_)))))
                  (_loop45446_
                   (+ _i45448_ '1)
                   (string-append _r45449_ (string _c45451_)))))))))
  (define std/pregexp#pregexp
    (lambda (_s45438_)
      (call-with-parameters
       (lambda ()
         (list ':sub
               (car (std/pregexp#pregexp-read-pattern
                     _s45438_
                     '0
                     (string-length _s45438_)))))
       std/pregexp#pregexp-space-sensitive?
       '#t)))
  (define std/pregexp#pregexp-match-positions__%
    (lambda (_pat45398_ _str45399_ _start45400_ _end45401_)
      (if (string? _pat45398_)
          (set! _pat45398_ (std/pregexp#pregexp _pat45398_))
          (if (pair? _pat45398_)
              '#t
              (std/pregexp#pregexp-error
               'pregexp-match-positions
               'pattern-must-be-compiled-or-string-regexp
               _pat45398_)))
      (let* ((_str-len45403_ (string-length _str45399_))
             (_start45405_
              (if _start45400_
                  (if (fixnum? _start45400_)
                      (if (and (>= _start45400_ '0)
                               (< _start45400_ _str-len45403_))
                          _start45400_
                          (error '"Start index out of range" _start45400_))
                      (error '"Expected nonnegative fixnum" _start45400_))
                  '0))
             (_end45407_
              (if _end45401_
                  (if (fixnum? _end45401_)
                      (if (<= _end45401_ _str-len45403_)
                          _end45401_
                          (error '"End index out of range" _end45401_))
                      (error '"Expected fixnum" _end45401_))
                  _str-len45403_)))
        (let _loop45410_ ((_i45412_ _start45405_))
          (if (<= _i45412_ _end45407_)
              (let ((_$e45414_
                     (std/pregexp#pregexp-match-positions-aux
                      _pat45398_
                      _str45399_
                      _str-len45403_
                      _start45405_
                      _end45407_
                      _i45412_)))
                (if _$e45414_ _$e45414_ (_loop45410_ (+ _i45412_ '1))))
              '#f)))))
  (define std/pregexp#pregexp-match-positions__0
    (lambda (_pat45420_ _str45421_)
      (let* ((_start45423_ '#f) (_end45425_ '#f))
        (std/pregexp#pregexp-match-positions__%
         _pat45420_
         _str45421_
         _start45423_
         _end45425_))))
  (define std/pregexp#pregexp-match-positions__1
    (lambda (_pat45427_ _str45428_ _start45429_)
      (let ((_end45431_ '#f))
        (std/pregexp#pregexp-match-positions__%
         _pat45427_
         _str45428_
         _start45429_
         _end45431_))))
  (define std/pregexp#pregexp-match-positions
    (lambda _g281183_
      (let ((_g281182_ (let () (declare (not safe)) (##length _g281183_))))
        (cond ((let () (declare (not safe)) (##fx= _g281182_ 2))
               (apply std/pregexp#pregexp-match-positions__0 _g281183_))
              ((let () (declare (not safe)) (##fx= _g281182_ 3))
               (apply std/pregexp#pregexp-match-positions__1 _g281183_))
              ((let () (declare (not safe)) (##fx= _g281182_ 4))
               (apply std/pregexp#pregexp-match-positions__% _g281183_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/pregexp#pregexp-match-positions
                _g281183_))))))
  (define std/pregexp#pregexp-match
    (lambda (_pat45389_ _str45390_ . _opt-args45391_)
      (let ((_ix-prs45393_
             (apply std/pregexp#pregexp-match-positions
                    _pat45389_
                    _str45390_
                    _opt-args45391_)))
        (if _ix-prs45393_
            (map (lambda (_ix-pr45395_)
                   (if _ix-pr45395_
                       (substring
                        _str45390_
                        (car _ix-pr45395_)
                        (cdr _ix-pr45395_))
                       '#f))
                 _ix-prs45393_)
            '#f))))
  (define std/pregexp#pregexp-split
    (lambda (_pat45368_ _str45369_)
      (let ((_n45371_ (string-length _str45369_)))
        (let _loop45373_ ((_i45375_ '0)
                          (_r45376_ '())
                          (_picked-up-one-undelimited-char?45377_ '#f))
          (if (>= _i45375_ _n45371_)
              (std/pregexp#pregexp-reverse! _r45376_)
              (let ((_$e45379_
                     (std/pregexp#pregexp-match-positions__%
                      _pat45368_
                      _str45369_
                      _i45375_
                      _n45371_)))
                (if _$e45379_
                    ((lambda (_y45382_)
                       (let ((_jk45384_ (car _y45382_)))
                         (let ((_j45386_ (car _jk45384_))
                               (_k45387_ (cdr _jk45384_)))
                           (if (= _j45386_ _k45387_)
                               (_loop45373_
                                (+ _k45387_ '1)
                                (cons (substring
                                       _str45369_
                                       _i45375_
                                       (+ _j45386_ '1))
                                      _r45376_)
                                '#t)
                               (if (and (= _j45386_ _i45375_)
                                        _picked-up-one-undelimited-char?45377_)
                                   (_loop45373_ _k45387_ _r45376_ '#f)
                                   (_loop45373_
                                    _k45387_
                                    (cons (substring
                                           _str45369_
                                           _i45375_
                                           _j45386_)
                                          _r45376_)
                                    '#f))))))
                     _$e45379_)
                    (_loop45373_
                     _n45371_
                     (cons (substring _str45369_ _i45375_ _n45371_) _r45376_)
                     '#f))))))))
  (define std/pregexp#pregexp-replace
    (lambda (_pat45355_ _str45356_ _ins45357_)
      (let* ((_n45359_ (string-length _str45356_))
             (_pp45361_
              (std/pregexp#pregexp-match-positions__%
               _pat45355_
               _str45356_
               '0
               _n45359_)))
        (if (not _pp45361_)
            _str45356_
            (let ((_ins-len45364_ (string-length _ins45357_))
                  (_m-i45365_ (caar _pp45361_))
                  (_m-n45366_ (cdar _pp45361_)))
              (string-append
               (substring _str45356_ '0 _m-i45365_)
               (std/pregexp#pregexp-replace-aux
                _str45356_
                _ins45357_
                _ins-len45364_
                _pp45361_)
               (substring _str45356_ _m-n45366_ _n45359_)))))))
  (define std/pregexp#pregexp-replace*
    (lambda (_pat45340_ _str45341_ _ins45342_)
      (let ((_pat45344_
             (if (string? _pat45340_)
                 (std/pregexp#pregexp _pat45340_)
                 _pat45340_))
            (_n45345_ (string-length _str45341_))
            (_ins-len45346_ (string-length _ins45342_)))
        (let _loop45348_ ((_i45350_ '0) (_r45351_ '""))
          (if (>= _i45350_ _n45345_)
              _r45351_
              (let ((_pp45353_
                     (std/pregexp#pregexp-match-positions__%
                      _pat45344_
                      _str45341_
                      _i45350_
                      _n45345_)))
                (if (not _pp45353_)
                    (if (= _i45350_ '0)
                        _str45341_
                        (string-append
                         _r45351_
                         (substring _str45341_ _i45350_ _n45345_)))
                    (_loop45348_
                     (cdar _pp45353_)
                     (string-append
                      _r45351_
                      (substring _str45341_ _i45350_ (caar _pp45353_))
                      (std/pregexp#pregexp-replace-aux
                       _str45341_
                       _ins45342_
                       _ins-len45346_
                       _pp45353_))))))))))
  (define std/pregexp#pregexp-quote
    (lambda (_s45331_)
      (let _loop45333_ ((_i45335_ (- (string-length _s45331_) '1))
                        (_r45336_ '()))
        (if (< _i45335_ '0)
            (list->string _r45336_)
            (_loop45333_
             (- _i45335_ '1)
             (let ((_c45338_
                    (let ()
                      (declare (not safe))
                      (##string-ref _s45331_ _i45335_))))
               (if (memv _c45338_
                         '(#\\
                           #\.
                           #\?
                           #\*
                           #\+
                           #\|
                           #\^
                           #\$
                           #\[
                           #\]
                           #\{
                           #\}
                           #\(
                           #\)))
                   (cons '#\\ (cons _c45338_ _r45336_))
                   (cons _c45338_ _r45336_)))))))))
