(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/14#%latin1->char integer->char)
  (define std/srfi/14#%char->latin1 char->integer)
  (define std/srfi/14#:char-set
    (make-struct-type
     'std/srfi/14#:char-set
     '#f
     '1
     ':char-set
     '((fields: s))
     '#f))
  (define std/srfi/14#char-set? (make-struct-predicate std/srfi/14#:char-set))
  (define std/srfi/14#char-set:s
    (make-struct-field-accessor std/srfi/14#:char-set '0))
  (define std/srfi/14#make-char-set
    (lambda (_s58843_) (make-struct-instance std/srfi/14#:char-set _s58843_)))
  (define std/srfi/14#%string-copy
    (lambda (_s58841_) (substring _s58841_ '0 (string-length _s58841_))))
  (define std/srfi/14#%default-base
    (lambda (_maybe-base58835_ _proc58836_)
      (if (pair? _maybe-base58835_)
          (let ((_bcs58838_ (car _maybe-base58835_))
                (_tail58839_ (cdr _maybe-base58835_)))
            (if (null? _tail58839_)
                (if (let ()
                      (declare (not safe))
                      (##structure-instance-of?
                       _bcs58838_
                       'std/srfi/14#:char-set))
                    (std/srfi/14#%string-copy
                     (##structure-ref _bcs58838_ '1 std/srfi/14#:char-set '#f))
                    (error '"BASE-CS parameter not a char-set"
                           _proc58836_
                           _bcs58838_))
                (error '"Expected final base char set -- too many parameters"
                       _proc58836_
                       _maybe-base58835_)))
          (make-string '256 (std/srfi/14#%latin1->char '0)))))
  (define std/srfi/14#%char-set:s/check
    (lambda (_cs58828_ _proc58829_)
      (let _lp58831_ ((_cs58833_ _cs58828_))
        (if (let ()
              (declare (not safe))
              (##structure-instance-of? _cs58833_ 'std/srfi/14#:char-set))
            (##structure-ref _cs58833_ '1 std/srfi/14#:char-set '#f)
            (_lp58831_ (error '"Not a char-set" _cs58833_ _proc58829_))))))
  (define std/srfi/14#si=0?
    (lambda (_s58825_ _i58826_)
      (zero? (std/srfi/14#%char->latin1 (string-ref _s58825_ _i58826_)))))
  (define std/srfi/14#si=1?
    (lambda (_s58822_ _i58823_) (not (std/srfi/14#si=0? _s58822_ _i58823_))))
  (define std/srfi/14#c0 (std/srfi/14#%latin1->char '0))
  (define std/srfi/14#c1 (std/srfi/14#%latin1->char '1))
  (define std/srfi/14#si
    (lambda (_s58819_ _i58820_)
      (std/srfi/14#%char->latin1 (string-ref _s58819_ _i58820_))))
  (define std/srfi/14#%set0!
    (lambda (_s58816_ _i58817_)
      (string-set! _s58816_ _i58817_ std/srfi/14#c0)))
  (define std/srfi/14#%set1!
    (lambda (_s58813_ _i58814_)
      (string-set! _s58813_ _i58814_ std/srfi/14#c1)))
  (define std/srfi/14#setv!
    (lambda (_s58809_ _i58810_ _v58811_)
      (string-set! _s58809_ _i58810_ (std/srfi/14#%latin1->char _v58811_))))
  (define std/srfi/14#%not!
    (lambda (_s58805_ _i58806_ _v58807_)
      (std/srfi/14#setv! _s58805_ _i58806_ (- '1 _v58807_))))
  (define std/srfi/14#%and!
    (lambda (_s58801_ _i58802_ _v58803_)
      (if (zero? _v58803_) (std/srfi/14#%set0! _s58801_ _i58802_) '#!void)))
  (define std/srfi/14#%or!
    (lambda (_s58797_ _i58798_ _v58799_)
      (if (not (zero? _v58799_))
          (std/srfi/14#%set1! _s58797_ _i58798_)
          '#!void)))
  (define std/srfi/14#%minus!
    (lambda (_s58793_ _i58794_ _v58795_)
      (if (not (zero? _v58795_))
          (std/srfi/14#%set0! _s58793_ _i58794_)
          '#!void)))
  (define std/srfi/14#%xor!
    (lambda (_s58789_ _i58790_ _v58791_)
      (if (not (zero? _v58791_))
          (std/srfi/14#setv!
           _s58789_
           _i58790_
           (- '1 (std/srfi/14#si _s58789_ _i58790_)))
          '#!void)))
  (define std/srfi/14#char-set-copy
    (lambda (_cs58787_)
      (let ((__tmp294109
             (std/srfi/14#%string-copy
              (std/srfi/14#%char-set:s/check
               _cs58787_
               std/srfi/14#char-set-copy))))
        (declare (not safe))
        (##structure std/srfi/14#:char-set __tmp294109))))
  (define std/srfi/14#char-set=
    (lambda _rest58768_
      (let ((_$e58770_ (null? _rest58768_)))
        (if _$e58770_
            _$e58770_
            (let* ((_cs158773_ (car _rest58768_))
                   (_rest58775_ (cdr _rest58768_))
                   (_s158777_
                    (std/srfi/14#%char-set:s/check
                     _cs158773_
                     std/srfi/14#char-set=)))
              (let _lp58780_ ((_rest58782_ _rest58775_))
                (let ((_$e58784_ (not (pair? _rest58782_))))
                  (if _$e58784_
                      _$e58784_
                      (if (string=?
                           _s158777_
                           (std/srfi/14#%char-set:s/check
                            (car _rest58782_)
                            std/srfi/14#char-set=))
                          (_lp58780_ (cdr _rest58782_))
                          '#f)))))))))
  (define std/srfi/14#char-set<=
    (lambda _rest58745_
      (let ((_$e58747_ (null? _rest58745_)))
        (if _$e58747_
            _$e58747_
            (let ((_cs158750_ (car _rest58745_))
                  (_rest58751_ (cdr _rest58745_)))
              (let _lp58753_ ((_s158755_
                               (std/srfi/14#%char-set:s/check
                                _cs158750_
                                std/srfi/14#char-set<=))
                              (_rest58756_ _rest58751_))
                (let ((_$e58758_ (not (pair? _rest58756_))))
                  (if _$e58758_
                      _$e58758_
                      (let ((_s258761_
                             (std/srfi/14#%char-set:s/check
                              (car _rest58756_)
                              std/srfi/14#char-set<=))
                            (_rest58762_ (cdr _rest58756_)))
                        (if (eq? _s158755_ _s258761_)
                            (_lp58753_ _s258761_ _rest58762_)
                            (let _lp258764_ ((_i58766_ '255))
                              (if (< _i58766_ '0)
                                  (_lp58753_ _s258761_ _rest58762_)
                                  (if (<= (std/srfi/14#si _s158755_ _i58766_)
                                          (std/srfi/14#si _s258761_ _i58766_))
                                      (_lp258764_ (- _i58766_ '1))
                                      '#f)))))))))))))
  (define std/srfi/14#char-set-hash
    (lambda (_cs58716_ . _maybe-bound58717_)
      (let* ((_bound58727_
              (let ((_maybe-arg58719_ _maybe-bound58717_))
                (if (null? _maybe-arg58719_)
                    '4194304
                    (if (null? (cdr _maybe-arg58719_))
                        (let ((_val58722_ (car _maybe-arg58719_)))
                          (if ((lambda (_n58725_)
                                 (and (integer? _n58725_)
                                      (exact? _n58725_)
                                      (<= '0 _n58725_)))
                               _val58722_)
                              _val58722_
                              (error '"argument out of domain" _val58722_)))
                        (error '"too many optional arguments"
                               _maybe-arg58719_)))))
             (_bound58729_ (if (zero? _bound58727_) '4194304 _bound58727_))
             (_s58731_
              (std/srfi/14#%char-set:s/check
               _cs58716_
               std/srfi/14#char-set-hash))
             (_mask58737_
              (let _lp58733_ ((_i58735_ '65536))
                (if (>= _i58735_ _bound58729_)
                    (- _i58735_ '1)
                    (_lp58733_ (+ _i58735_ _i58735_))))))
        (let _lp58740_ ((_i58742_ '255) (_ans58743_ '0))
          (if (< _i58742_ '0)
              (modulo _ans58743_ _bound58729_)
              (_lp58740_
               (- _i58742_ '1)
               (if (std/srfi/14#si=0? _s58731_ _i58742_)
                   _ans58743_
                   (bitwise-and
                    _mask58737_
                    (+ (* '37 _ans58743_) _i58742_)))))))))
  (define std/srfi/14#char-set-contains?
    (lambda (_cs58713_ _char58714_)
      (std/srfi/14#si=1?
       (std/srfi/14#%char-set:s/check _cs58713_ std/srfi/14#char-set-contains?)
       (std/srfi/14#%char->latin1
        (if (char? _char58714_)
            _char58714_
            (error '"Bad argument" _char58714_ 'char? 'char-set-contains?))))))
  (define std/srfi/14#char-set-size
    (lambda (_cs58704_)
      (let ((_s58706_
             (std/srfi/14#%char-set:s/check
              _cs58704_
              std/srfi/14#char-set-size)))
        (let _lp58708_ ((_i58710_ '255) (_size58711_ '0))
          (if (< _i58710_ '0)
              _size58711_
              (_lp58708_
               (- _i58710_ '1)
               (+ _size58711_ (std/srfi/14#si _s58706_ _i58710_))))))))
  (define std/srfi/14#char-set-count
    (lambda (_pred58694_ _cset58695_)
      (if (procedure? _pred58694_)
          _pred58694_
          (error '"Bad argument" _pred58694_ 'procedure? 'char-set-count))
      (let ((_s58697_
             (std/srfi/14#%char-set:s/check
              _cset58695_
              std/srfi/14#char-set-count)))
        (let _lp58699_ ((_i58701_ '255) (_count58702_ '0))
          (if (< _i58701_ '0)
              _count58702_
              (_lp58699_
               (- _i58701_ '1)
               (if (and (std/srfi/14#si=1? _s58697_ _i58701_)
                        (_pred58694_ (std/srfi/14#%latin1->char _i58701_)))
                   (+ _count58702_ '1)
                   _count58702_)))))))
  (define std/srfi/14#%set-char-set
    (lambda (_set58685_ _proc58686_ _cs58687_ _chars58688_)
      (let ((_s58690_
             (std/srfi/14#%string-copy
              (std/srfi/14#%char-set:s/check _cs58687_ _proc58686_))))
        (for-each
         (lambda (_c58692_)
           (_set58685_ _s58690_ (std/srfi/14#%char->latin1 _c58692_)))
         _chars58688_)
        (let ()
          (declare (not safe))
          (##structure std/srfi/14#:char-set _s58690_)))))
  (define std/srfi/14#%set-char-set!
    (lambda (_set58676_ _proc58677_ _cs58678_ _chars58679_)
      (let ((_s58681_ (std/srfi/14#%char-set:s/check _cs58678_ _proc58677_)))
        (for-each
         (lambda (_c58683_)
           (_set58676_ _s58681_ (std/srfi/14#%char->latin1 _c58683_)))
         _chars58679_))
      _cs58678_))
  (define std/srfi/14#char-set-adjoin
    (lambda (_cs58673_ . _chars58674_)
      (std/srfi/14#%set-char-set
       std/srfi/14#%set1!
       std/srfi/14#char-set-adjoin
       _cs58673_
       _chars58674_)))
  (define std/srfi/14#char-set-adjoin!
    (lambda (_cs58670_ . _chars58671_)
      (std/srfi/14#%set-char-set!
       std/srfi/14#%set1!
       std/srfi/14#char-set-adjoin!
       _cs58670_
       _chars58671_)))
  (define std/srfi/14#char-set-delete
    (lambda (_cs58667_ . _chars58668_)
      (std/srfi/14#%set-char-set
       std/srfi/14#%set0!
       std/srfi/14#char-set-delete
       _cs58667_
       _chars58668_)))
  (define std/srfi/14#char-set-delete!
    (lambda (_cs58664_ . _chars58665_)
      (std/srfi/14#%set-char-set!
       std/srfi/14#%set0!
       std/srfi/14#char-set-delete!
       _cs58664_
       _chars58665_)))
  (define std/srfi/14#char-set-cursor
    (lambda (_cset58662_)
      (std/srfi/14#%char-set-cursor-next
       _cset58662_
       '256
       std/srfi/14#char-set-cursor)))
  (define std/srfi/14#end-of-char-set?
    (lambda (_cursor58660_) (< _cursor58660_ '0)))
  (define std/srfi/14#char-set-ref
    (lambda (_cset58657_ _cursor58658_)
      (std/srfi/14#%latin1->char _cursor58658_)))
  (define std/srfi/14#char-set-cursor-next
    (lambda (_cset58652_ _cursor58653_)
      (if ((lambda (_i58655_)
             (and (integer? _i58655_) (exact? _i58655_) (<= '0 _i58655_ '255)))
           _cursor58653_)
          _cursor58653_
          (error '"Bad argument"
                 _cursor58653_
                 '(lambda (i) (and (integer? i) (exact? i) (<= 0 i 255)))
                 'char-set-cursor-next))
      (std/srfi/14#%char-set-cursor-next
       _cset58652_
       _cursor58653_
       std/srfi/14#char-set-cursor-next)))
  (define std/srfi/14#%char-set-cursor-next
    (lambda (_cset58637_ _cursor58638_ _proc58639_)
      (let ((_s58641_ (std/srfi/14#%char-set:s/check _cset58637_ _proc58639_)))
        (let _lp58643_ ((_cur58645_ _cursor58638_))
          (let ((_cur58647_ (- _cur58645_ '1)))
            (if (or (< _cur58647_ '0) (std/srfi/14#si=1? _s58641_ _cur58647_))
                _cur58647_
                (_lp58643_ _cur58647_)))))))
  (define std/srfi/14#char-set-for-each
    (lambda (_proc58628_ _cs58629_)
      (if (procedure? _proc58628_)
          _proc58628_
          (error '"Bad argument" _proc58628_ 'procedure? 'char-set-for-each))
      (let ((_s58631_
             (std/srfi/14#%char-set:s/check
              _cs58629_
              std/srfi/14#char-set-for-each)))
        (let _lp58633_ ((_i58635_ '255))
          (if (>= _i58635_ '0)
              (begin
                (if (std/srfi/14#si=1? _s58631_ _i58635_)
                    (_proc58628_ (std/srfi/14#%latin1->char _i58635_))
                    '#!void)
                (_lp58633_ (- _i58635_ '1)))
              '#!void)))))
  (define std/srfi/14#char-set-map
    (lambda (_proc58618_ _cs58619_)
      (if (procedure? _proc58618_)
          _proc58618_
          (error '"Bad argument" _proc58618_ 'procedure? 'char-set-map))
      (let ((_s58621_
             (std/srfi/14#%char-set:s/check
              _cs58619_
              std/srfi/14#char-set-map))
            (_ans58622_ (make-string '256 std/srfi/14#c0)))
        (let _lp58624_ ((_i58626_ '255))
          (if (>= _i58626_ '0)
              (begin
                (if (std/srfi/14#si=1? _s58621_ _i58626_)
                    (std/srfi/14#%set1!
                     _ans58622_
                     (std/srfi/14#%char->latin1
                      (_proc58618_ (std/srfi/14#%latin1->char _i58626_))))
                    '#!void)
                (_lp58624_ (- _i58626_ '1)))
              '#!void))
        (let ()
          (declare (not safe))
          (##structure std/srfi/14#:char-set _ans58622_)))))
  (define std/srfi/14#char-set-fold
    (lambda (_kons58607_ _knil58608_ _cs58609_)
      (if (procedure? _kons58607_)
          _kons58607_
          (error '"Bad argument" _kons58607_ 'procedure? 'char-set-fold))
      (let ((_s58611_
             (std/srfi/14#%char-set:s/check
              _cs58609_
              std/srfi/14#char-set-fold)))
        (let _lp58613_ ((_i58615_ '255) (_ans58616_ _knil58608_))
          (if (< _i58615_ '0)
              _ans58616_
              (_lp58613_
               (- _i58615_ '1)
               (if (std/srfi/14#si=0? _s58611_ _i58615_)
                   _ans58616_
                   (_kons58607_
                    (std/srfi/14#%latin1->char _i58615_)
                    _ans58616_))))))))
  (define std/srfi/14#char-set-every
    (lambda (_pred58592_ _cs58593_)
      (if (procedure? _pred58592_)
          _pred58592_
          (error '"Bad argument" _pred58592_ 'procedure? 'char-set-every))
      (let ((_s58595_
             (std/srfi/14#%char-set:s/check
              _cs58593_
              std/srfi/14#char-set-every)))
        (let _lp58597_ ((_i58599_ '255))
          (let ((_$e58601_ (< _i58599_ '0)))
            (if _$e58601_
                _$e58601_
                (if (or (std/srfi/14#si=0? _s58595_ _i58599_)
                        (_pred58592_ (std/srfi/14#%latin1->char _i58599_)))
                    (_lp58597_ (- _i58599_ '1))
                    '#f)))))))
  (define std/srfi/14#char-set-any
    (lambda (_pred58580_ _cs58581_)
      (if (procedure? _pred58580_)
          _pred58580_
          (error '"Bad argument" _pred58580_ 'procedure? 'char-set-any))
      (let ((_s58583_
             (std/srfi/14#%char-set:s/check
              _cs58581_
              std/srfi/14#char-set-any)))
        (let _lp58585_ ((_i58587_ '255))
          (if (>= _i58587_ '0)
              (let ((_$e58589_
                     (if (std/srfi/14#si=1? _s58583_ _i58587_)
                         (_pred58580_ (std/srfi/14#%latin1->char _i58587_))
                         '#f)))
                (if _$e58589_ _$e58589_ (_lp58585_ (- _i58587_ '1))))
              '#f)))))
  (define std/srfi/14#%char-set-unfold!
    (lambda (_proc58569_ _p58570_ _f58571_ _g58572_ _s58573_ _seed58574_)
      (if (procedure? _p58570_)
          _p58570_
          (error '"Bad argument" _p58570_ 'procedure? 'proc))
      (if (procedure? _f58571_)
          _f58571_
          (error '"Bad argument" _f58571_ 'procedure? 'proc))
      (if (procedure? _g58572_)
          _g58572_
          (error '"Bad argument" _g58572_ 'procedure? 'proc))
      (let _lp58576_ ((_seed58578_ _seed58574_))
        (if (not (_p58570_ _seed58578_))
            (begin
              (std/srfi/14#%set1!
               _s58573_
               (std/srfi/14#%char->latin1 (_f58571_ _seed58578_)))
              (_lp58576_ (_g58572_ _seed58578_)))
            '#!void))))
  (define std/srfi/14#char-set-unfold
    (lambda (_p58561_ _f58562_ _g58563_ _seed58564_ . _maybe-base58565_)
      (let ((_bs58567_
             (std/srfi/14#%default-base
              _maybe-base58565_
              std/srfi/14#char-set-unfold)))
        (std/srfi/14#%char-set-unfold!
         std/srfi/14#char-set-unfold
         _p58561_
         _f58562_
         _g58563_
         _bs58567_
         _seed58564_)
        (let ()
          (declare (not safe))
          (##structure std/srfi/14#:char-set _bs58567_)))))
  (define std/srfi/14#char-set-unfold!
    (lambda (_p58555_ _f58556_ _g58557_ _seed58558_ _base-cset58559_)
      (std/srfi/14#%char-set-unfold!
       std/srfi/14#char-set-unfold!
       _p58555_
       _f58556_
       _g58557_
       (std/srfi/14#%char-set:s/check
        _base-cset58559_
        std/srfi/14#char-set-unfold!)
       _seed58558_)
      _base-cset58559_))
  (define std/srfi/14#%list->char-set!
    (lambda (_chars58550_ _s58551_)
      (for-each
       (lambda (_char58553_)
         (std/srfi/14#%set1! _s58551_ (std/srfi/14#%char->latin1 _char58553_)))
       _chars58550_)))
  (define std/srfi/14#char-set
    (lambda _chars58546_
      (let ((_s58548_ (make-string '256 std/srfi/14#c0)))
        (std/srfi/14#%list->char-set! _chars58546_ _s58548_)
        (let ()
          (declare (not safe))
          (##structure std/srfi/14#:char-set _s58548_)))))
  (define std/srfi/14#list->char-set
    (lambda (_chars58541_ . _maybe-base58542_)
      (let ((_bs58544_
             (std/srfi/14#%default-base
              _maybe-base58542_
              std/srfi/14#list->char-set)))
        (std/srfi/14#%list->char-set! _chars58541_ _bs58544_)
        (let ()
          (declare (not safe))
          (##structure std/srfi/14#:char-set _bs58544_)))))
  (define std/srfi/14#list->char-set!
    (lambda (_chars58538_ _base-cs58539_)
      (std/srfi/14#%list->char-set!
       _chars58538_
       (std/srfi/14#%char-set:s/check
        _base-cs58539_
        std/srfi/14#list->char-set!))
      _base-cs58539_))
  (define std/srfi/14#char-set->list
    (lambda (_cs58529_)
      (let ((_s58531_
             (std/srfi/14#%char-set:s/check
              _cs58529_
              std/srfi/14#char-set->list)))
        (let _lp58533_ ((_i58535_ '255) (_ans58536_ '()))
          (if (< _i58535_ '0)
              _ans58536_
              (_lp58533_
               (- _i58535_ '1)
               (if (std/srfi/14#si=0? _s58531_ _i58535_)
                   _ans58536_
                   (cons (std/srfi/14#%latin1->char _i58535_)
                         _ans58536_))))))))
  (define std/srfi/14#%string->char-set!
    (lambda (_str58520_ _bs58521_ _proc58522_)
      (if (string? _str58520_)
          _str58520_
          (error '"Bad argument" _str58520_ 'string? 'proc))
      (let _$loop58524_ ((_i58527_ (- (string-length _str58520_) '1)))
        (if (< _i58527_ '0)
            '#!void
            (begin
              (std/srfi/14#%set1!
               _bs58521_
               (std/srfi/14#%char->latin1 (string-ref _str58520_ _i58527_)))
              (_$loop58524_ (- _i58527_ '1)))))))
  (define std/srfi/14#string->char-set
    (lambda (_str58515_ . _maybe-base58516_)
      (let ((_bs58518_
             (std/srfi/14#%default-base
              _maybe-base58516_
              std/srfi/14#string->char-set)))
        (std/srfi/14#%string->char-set!
         _str58515_
         _bs58518_
         std/srfi/14#string->char-set)
        (let ()
          (declare (not safe))
          (##structure std/srfi/14#:char-set _bs58518_)))))
  (define std/srfi/14#string->char-set!
    (lambda (_str58512_ _base-cs58513_)
      (std/srfi/14#%string->char-set!
       _str58512_
       (std/srfi/14#%char-set:s/check
        _base-cs58513_
        std/srfi/14#string->char-set!)
       std/srfi/14#string->char-set!)
      _base-cs58513_))
  (define std/srfi/14#char-set->string
    (lambda (_cs58498_)
      (let* ((_s58500_
              (std/srfi/14#%char-set:s/check
               _cs58498_
               std/srfi/14#char-set->string))
             (_ans58502_ (make-string (std/srfi/14#char-set-size _cs58498_))))
        (let _lp58505_ ((_i58507_ '255) (_j58508_ '0))
          (if (< _i58507_ '0)
              _ans58502_
              (let ((_j58510_
                     (if (std/srfi/14#si=0? _s58500_ _i58507_)
                         _j58508_
                         (begin
                           (string-set!
                            _ans58502_
                            _j58508_
                            (std/srfi/14#%latin1->char _i58507_))
                           (+ _j58508_ '1)))))
                (_lp58505_ (- _i58507_ '1) _j58510_)))))))
  (define std/srfi/14#%ucs-range->char-set!
    (lambda (_lower58484_ _upper58485_ _error?58486_ _bs58487_ _proc58488_)
      (if ((lambda (_x58490_)
             (and (integer? _x58490_) (exact? _x58490_) (<= '0 _x58490_)))
           _lower58484_)
          _lower58484_
          (error '"Bad argument"
                 _lower58484_
                 '(lambda (x) (and (integer? x) (exact? x) (<= 0 x)))
                 'proc))
      (if ((lambda (_x58492_)
             (and (integer? _x58492_)
                  (exact? _x58492_)
                  (<= _lower58484_ _x58492_)))
           _upper58485_)
          _upper58485_
          (error '"Bad argument"
                 _upper58485_
                 '(lambda (x) (and (integer? x) (exact? x) (<= lower x)))
                 'proc))
      (if (and (< _lower58484_ _upper58485_)
               (< '256 _upper58485_)
               _error?58486_)
          (error '"Requested UCS range contains unavailable characters -- this implementation only supports Latin-1"
                 _proc58488_
                 _lower58484_
                 _upper58485_)
          '#!void)
      (let _lp58494_ ((_i58496_ (- (min _upper58485_ '256) '1)))
        (if (<= _lower58484_ _i58496_)
            (begin
              (std/srfi/14#%set1! _bs58487_ _i58496_)
              (_lp58494_ (- _i58496_ '1)))
            '#!void))))
  (define std/srfi/14#ucs-range->char-set
    (lambda (_lower58468_ _upper58469_ . _rest58470_)
      (let ((_rest58472_ _rest58470_))
        (call-with-values
         (lambda ()
           (if (null? _rest58472_)
               (values '#f '())
               (values (car _rest58472_) (cdr _rest58472_))))
         (lambda (_error?58476_ _rest58477_)
           (if '#t
               (let* ((_rest58480_ _rest58477_)
                      (_bs58482_
                       (std/srfi/14#%default-base
                        _rest58480_
                        std/srfi/14#ucs-range->char-set)))
                 (std/srfi/14#%ucs-range->char-set!
                  _lower58468_
                  _upper58469_
                  _error?58476_
                  _bs58482_
                  std/srfi/14#ucs-range->char-set)
                 (let ()
                   (declare (not safe))
                   (##structure std/srfi/14#:char-set _bs58482_)))
               (error '"argument out of domain" _error?58476_)))))))
  (define std/srfi/14#ucs-range->char-set!
    (lambda (_lower58463_ _upper58464_ _error?58465_ _base-cs58466_)
      (std/srfi/14#%ucs-range->char-set!
       _lower58463_
       _upper58464_
       _error?58465_
       (std/srfi/14#%char-set:s/check
        _base-cs58466_
        std/srfi/14#ucs-range->char-set!)
       std/srfi/14#ucs-range->char-set)
      _base-cs58466_))
  (define std/srfi/14#%char-set-filter!
    (lambda (_pred58454_ _ds58455_ _bs58456_ _proc58457_)
      (if (procedure? _pred58454_)
          _pred58454_
          (error '"Bad argument" _pred58454_ 'procedure? 'proc))
      (let _lp58459_ ((_i58461_ '255))
        (if (>= _i58461_ '0)
            (begin
              (if (and (std/srfi/14#si=1? _ds58455_ _i58461_)
                       (_pred58454_ (std/srfi/14#%latin1->char _i58461_)))
                  (std/srfi/14#%set1! _bs58456_ _i58461_)
                  '#!void)
              (_lp58459_ (- _i58461_ '1)))
            '#!void))))
  (define std/srfi/14#char-set-filter
    (lambda (_predicate58448_ _domain58449_ . _maybe-base58450_)
      (let ((_bs58452_
             (std/srfi/14#%default-base
              _maybe-base58450_
              std/srfi/14#char-set-filter)))
        (std/srfi/14#%char-set-filter!
         _predicate58448_
         (std/srfi/14#%char-set:s/check
          _domain58449_
          std/srfi/14#char-set-filter!)
         _bs58452_
         std/srfi/14#char-set-filter)
        (let ()
          (declare (not safe))
          (##structure std/srfi/14#:char-set _bs58452_)))))
  (define std/srfi/14#char-set-filter!
    (lambda (_predicate58444_ _domain58445_ _base-cs58446_)
      (std/srfi/14#%char-set-filter!
       _predicate58444_
       (std/srfi/14#%char-set:s/check
        _domain58445_
        std/srfi/14#char-set-filter!)
       (std/srfi/14#%char-set:s/check
        _base-cs58446_
        std/srfi/14#char-set-filter!)
       std/srfi/14#char-set-filter!)
      _base-cs58446_))
  (define std/srfi/14#->char-set
    (lambda (_x58442_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _x58442_ 'std/srfi/14#:char-set))
          _x58442_
          (if (string? _x58442_)
              (std/srfi/14#string->char-set _x58442_)
              (if (char? _x58442_)
                  (std/srfi/14#char-set _x58442_)
                  (error '"->char-set: Not a charset, string or char."
                         _x58442_))))))
  (define std/srfi/14#%string-iter
    (lambda (_p58435_ _s58436_)
      (let _lp58438_ ((_i58440_ (- (string-length _s58436_) '1)))
        (if (>= _i58440_ '0)
            (begin
              (_p58435_
               _i58440_
               (std/srfi/14#%char->latin1 (string-ref _s58436_ _i58440_)))
              (_lp58438_ (- _i58440_ '1)))
            '#!void))))
  (define std/srfi/14#%char-set-algebra
    (lambda (_s58422_ _csets58423_ _op58424_ _proc58425_)
      (for-each
       (lambda (_cset58427_)
         (let ((_s258429_
                (std/srfi/14#%char-set:s/check _cset58427_ _proc58425_)))
           (let _lp58431_ ((_i58433_ '255))
             (if (>= _i58433_ '0)
                 (begin
                   (_op58424_
                    _s58422_
                    _i58433_
                    (std/srfi/14#si _s258429_ _i58433_))
                   (_lp58431_ (- _i58433_ '1)))
                 '#!void))))
       _csets58423_)))
  (define std/srfi/14#char-set-complement
    (lambda (_cs58414_)
      (let ((_s58416_
             (std/srfi/14#%char-set:s/check
              _cs58414_
              std/srfi/14#char-set-complement))
            (_ans58417_ (make-string '256)))
        (std/srfi/14#%string-iter
         (lambda (_i58419_ _v58420_)
           (std/srfi/14#%not! _ans58417_ _i58419_ _v58420_))
         _s58416_)
        (let ()
          (declare (not safe))
          (##structure std/srfi/14#:char-set _ans58417_)))))
  (define std/srfi/14#char-set-complement!
    (lambda (_cset58407_)
      (let ((_s58409_
             (std/srfi/14#%char-set:s/check
              _cset58407_
              std/srfi/14#char-set-complement!)))
        (std/srfi/14#%string-iter
         (lambda (_i58411_ _v58412_)
           (std/srfi/14#%not! _s58409_ _i58411_ _v58412_))
         _s58409_))
      _cset58407_))
  (define std/srfi/14#char-set-union!
    (lambda (_cset158404_ . _csets58405_)
      (std/srfi/14#%char-set-algebra
       (std/srfi/14#%char-set:s/check _cset158404_ std/srfi/14#char-set-union!)
       _csets58405_
       std/srfi/14#%or!
       std/srfi/14#char-set-union!)
      _cset158404_))
  (define std/srfi/14#char-set-union
    (lambda _csets58400_
      (if (pair? _csets58400_)
          (let ((_s58402_
                 (std/srfi/14#%string-copy
                  (std/srfi/14#%char-set:s/check
                   (car _csets58400_)
                   std/srfi/14#char-set-union))))
            (std/srfi/14#%char-set-algebra
             _s58402_
             (cdr _csets58400_)
             std/srfi/14#%or!
             std/srfi/14#char-set-union)
            (let ()
              (declare (not safe))
              (##structure std/srfi/14#:char-set _s58402_)))
          (std/srfi/14#char-set-copy std/srfi/14#char-set:empty))))
  (define std/srfi/14#char-set-intersection!
    (lambda (_cset158397_ . _csets58398_)
      (std/srfi/14#%char-set-algebra
       (std/srfi/14#%char-set:s/check
        _cset158397_
        std/srfi/14#char-set-intersection!)
       _csets58398_
       std/srfi/14#%and!
       std/srfi/14#char-set-intersection!)
      _cset158397_))
  (define std/srfi/14#char-set-intersection
    (lambda _csets58393_
      (if (pair? _csets58393_)
          (let ((_s58395_
                 (std/srfi/14#%string-copy
                  (std/srfi/14#%char-set:s/check
                   (car _csets58393_)
                   std/srfi/14#char-set-intersection))))
            (std/srfi/14#%char-set-algebra
             _s58395_
             (cdr _csets58393_)
             std/srfi/14#%and!
             std/srfi/14#char-set-intersection)
            (let ()
              (declare (not safe))
              (##structure std/srfi/14#:char-set _s58395_)))
          (std/srfi/14#char-set-copy std/srfi/14#char-set:full))))
  (define std/srfi/14#char-set-difference!
    (lambda (_cset158390_ . _csets58391_)
      (std/srfi/14#%char-set-algebra
       (std/srfi/14#%char-set:s/check
        _cset158390_
        std/srfi/14#char-set-difference!)
       _csets58391_
       std/srfi/14#%minus!
       std/srfi/14#char-set-difference!)
      _cset158390_))
  (define std/srfi/14#char-set-difference
    (lambda (_cs158385_ . _csets58386_)
      (if (pair? _csets58386_)
          (let ((_s58388_
                 (std/srfi/14#%string-copy
                  (std/srfi/14#%char-set:s/check
                   _cs158385_
                   std/srfi/14#char-set-difference))))
            (std/srfi/14#%char-set-algebra
             _s58388_
             _csets58386_
             std/srfi/14#%minus!
             std/srfi/14#char-set-difference)
            (let ()
              (declare (not safe))
              (##structure std/srfi/14#:char-set _s58388_)))
          (std/srfi/14#char-set-copy _cs158385_))))
  (define std/srfi/14#char-set-xor!
    (lambda (_cset158382_ . _csets58383_)
      (std/srfi/14#%char-set-algebra
       (std/srfi/14#%char-set:s/check _cset158382_ std/srfi/14#char-set-xor!)
       _csets58383_
       std/srfi/14#%xor!
       std/srfi/14#char-set-xor!)
      _cset158382_))
  (define std/srfi/14#char-set-xor
    (lambda _csets58378_
      (if (pair? _csets58378_)
          (let ((_s58380_
                 (std/srfi/14#%string-copy
                  (std/srfi/14#%char-set:s/check
                   (car _csets58378_)
                   std/srfi/14#char-set-xor))))
            (std/srfi/14#%char-set-algebra
             _s58380_
             (cdr _csets58378_)
             std/srfi/14#%xor!
             std/srfi/14#char-set-xor)
            (let ()
              (declare (not safe))
              (##structure std/srfi/14#:char-set _s58380_)))
          (std/srfi/14#char-set-copy std/srfi/14#char-set:empty))))
  (define std/srfi/14#%char-set-diff+intersection!
    (lambda (_diff58368_ _int58369_ _csets58370_ _proc58371_)
      (for-each
       (lambda (_cs58373_)
         (std/srfi/14#%string-iter
          (lambda (_i58375_ _v58376_)
            (if (not (zero? _v58376_))
                (if (std/srfi/14#si=1? _diff58368_ _i58375_)
                    (begin
                      (std/srfi/14#%set0! _diff58368_ _i58375_)
                      (std/srfi/14#%set1! _int58369_ _i58375_))
                    '#!void)
                '#!void))
          (std/srfi/14#%char-set:s/check _cs58373_ _proc58371_)))
       _csets58370_)))
  (define std/srfi/14#char-set-diff+intersection!
    (lambda (_cs158358_ _cs258359_ . _csets58360_)
      (let ((_s158362_
             (std/srfi/14#%char-set:s/check
              _cs158358_
              std/srfi/14#char-set-diff+intersection!))
            (_s258363_
             (std/srfi/14#%char-set:s/check
              _cs258359_
              std/srfi/14#char-set-diff+intersection!)))
        (std/srfi/14#%string-iter
         (lambda (_i58365_ _v58366_)
           (if (zero? _v58366_)
               (std/srfi/14#%set0! _s258363_ _i58365_)
               (if (std/srfi/14#si=1? _s258363_ _i58365_)
                   (std/srfi/14#%set0! _s158362_ _i58365_)
                   '#!void)))
         _s158362_)
        (std/srfi/14#%char-set-diff+intersection!
         _s158362_
         _s258363_
         _csets58360_
         std/srfi/14#char-set-diff+intersection!))
      (values _cs158358_ _cs258359_)))
  (define std/srfi/14#char-set-diff+intersection
    (lambda (_cs158352_ . _csets58353_)
      (let ((_diff58355_
             (string-copy
              (std/srfi/14#%char-set:s/check
               _cs158352_
               std/srfi/14#char-set-diff+intersection)))
            (_int58356_ (make-string '256 std/srfi/14#c0)))
        (std/srfi/14#%char-set-diff+intersection!
         _diff58355_
         _int58356_
         _csets58353_
         std/srfi/14#char-set-diff+intersection)
        (values (let ()
                  (declare (not safe))
                  (##structure std/srfi/14#:char-set _diff58355_))
                (let ()
                  (declare (not safe))
                  (##structure std/srfi/14#:char-set _int58356_))))))
  (define std/srfi/14#char-set:empty (std/srfi/14#char-set))
  (define std/srfi/14#char-set:full
    (std/srfi/14#char-set-complement std/srfi/14#char-set:empty))
  (define std/srfi/14#char-set:lower-case
    (let* ((_a-z58345_ (std/srfi/14#ucs-range->char-set '97 '123))
           (_latin158347_
            (std/srfi/14#ucs-range->char-set! '223 '247 '#t _a-z58345_))
           (_latin258349_
            (std/srfi/14#ucs-range->char-set! '248 '256 '#t _latin158347_)))
      (std/srfi/14#char-set-adjoin!
       _latin258349_
       (std/srfi/14#%latin1->char '181))))
  (define std/srfi/14#char-set:upper-case
    (let ((_A-Z58343_ (std/srfi/14#ucs-range->char-set '65 '91)))
      (std/srfi/14#ucs-range->char-set!
       '216
       '223
       '#t
       (std/srfi/14#ucs-range->char-set! '192 '215 '#t _A-Z58343_))))
  (define std/srfi/14#char-set:title-case std/srfi/14#char-set:empty)
  (define std/srfi/14#char-set:letter
    (let ((_u/l58341_
           (std/srfi/14#char-set-union
            std/srfi/14#char-set:upper-case
            std/srfi/14#char-set:lower-case)))
      (std/srfi/14#char-set-adjoin!
       _u/l58341_
       (std/srfi/14#%latin1->char '170)
       (std/srfi/14#%latin1->char '186))))
  (define std/srfi/14#char-set:digit
    (std/srfi/14#string->char-set '"0123456789"))
  (define std/srfi/14#char-set:hex-digit
    (std/srfi/14#string->char-set '"0123456789abcdefABCDEF"))
  (define std/srfi/14#char-set:letter+digit
    (std/srfi/14#char-set-union
     std/srfi/14#char-set:letter
     std/srfi/14#char-set:digit))
  (define std/srfi/14#char-set:punctuation
    (let ((_ascii58338_
           (std/srfi/14#string->char-set '"!\"#%&'()*,-./:;?@[\\]_{}"))
          (_latin-1-chars58339_
           (map std/srfi/14#%latin1->char '(161 171 173 183 187 191))))
      (std/srfi/14#list->char-set! _latin-1-chars58339_ _ascii58338_)))
  (define std/srfi/14#char-set:symbol
    (let ((_ascii58335_ (std/srfi/14#string->char-set '"$+<=>^`|~"))
          (_latin-1-chars58336_
           (map std/srfi/14#%latin1->char
                '(162
                  163
                  164
                  165
                  166
                  167
                  168
                  169
                  172
                  174
                  175
                  176
                  177
                  180
                  182
                  184
                  215
                  247))))
      (std/srfi/14#list->char-set! _latin-1-chars58336_ _ascii58335_)))
  (define std/srfi/14#char-set:graphic
    (std/srfi/14#char-set-union
     std/srfi/14#char-set:letter+digit
     std/srfi/14#char-set:punctuation
     std/srfi/14#char-set:symbol))
  (define std/srfi/14#char-set:whitespace
    (std/srfi/14#list->char-set
     (map std/srfi/14#%latin1->char '(9 10 11 12 13 32 160))))
  (define std/srfi/14#char-set:printing
    (std/srfi/14#char-set-union
     std/srfi/14#char-set:whitespace
     std/srfi/14#char-set:graphic))
  (define std/srfi/14#char-set:blank
    (std/srfi/14#list->char-set (map std/srfi/14#%latin1->char '(9 32 160))))
  (define std/srfi/14#char-set:iso-control
    (std/srfi/14#ucs-range->char-set!
     '127
     '160
     '#t
     (std/srfi/14#ucs-range->char-set '0 '32)))
  (define std/srfi/14#char-set:ascii
    (std/srfi/14#ucs-range->char-set '0 '128)))
