(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/146/hamt#hamt-hash-slice-size '5)
  (define std/srfi/146/hamt#hamt-hash-size
    (let ((_word-size111981_ std/srfi/143#fx-width))
      (- _word-size111981_
         (remainder
          _word-size111981_
          std/srfi/146/hamt#hamt-hash-slice-size))))
  (define std/srfi/146/hamt#hamt-hash-modulus
    (expt '2 std/srfi/146/hamt#hamt-hash-size))
  (define std/srfi/146/hamt#hamt-bucket-size
    (expt '2 std/srfi/146/hamt#hamt-hash-slice-size))
  (define std/srfi/146/hamt#hamt-null (cons 'hamt 'null))
  (define std/srfi/146/hamt#hash-array-mapped-trie
    (make-struct-type
     'std/srfi/146/hamt#hash-array-mapped-trie
     '#f
     '6
     'hash-array-mapped-trie
     '((fields: = count hash mutable? payload? root))
     '#f))
  (define std/srfi/146/hamt#hash-array-mapped-trie?
    (make-struct-predicate std/srfi/146/hamt#hash-array-mapped-trie))
  (define std/srfi/146/hamt#hamt/=
    (make-struct-field-accessor std/srfi/146/hamt#hash-array-mapped-trie '0))
  (define std/srfi/146/hamt#hamt/count
    (make-struct-field-accessor std/srfi/146/hamt#hash-array-mapped-trie '1))
  (define std/srfi/146/hamt#hamt/hash
    (make-struct-field-accessor std/srfi/146/hamt#hash-array-mapped-trie '2))
  (define std/srfi/146/hamt#hamt/mutable?
    (make-struct-field-accessor std/srfi/146/hamt#hash-array-mapped-trie '3))
  (define std/srfi/146/hamt#hamt/payload?
    (make-struct-field-accessor std/srfi/146/hamt#hash-array-mapped-trie '4))
  (define std/srfi/146/hamt#hamt/root
    (make-struct-field-accessor std/srfi/146/hamt#hash-array-mapped-trie '5))
  (define std/srfi/146/hamt#set-hamt/count!
    (make-struct-field-mutator std/srfi/146/hamt#hash-array-mapped-trie '1))
  (define std/srfi/146/hamt#set-hamt/root!
    (make-struct-field-mutator std/srfi/146/hamt#hash-array-mapped-trie '5))
  (define std/srfi/146/hamt#%make-hamt
    (lambda (_=111974_
             _count111975_
             _hash111976_
             _mutable?111977_
             _payload?111978_
             _root111979_)
      (make-struct-instance
       std/srfi/146/hamt#hash-array-mapped-trie
       _=111974_
       _count111975_
       _hash111976_
       _mutable?111977_
       _payload?111978_
       _root111979_)))
  (define std/srfi/146/hamt#make-hamt
    (lambda (_=111970_ _hash111971_ _payload?111972_)
      (let ((__tmp295455 (std/srfi/146/hamt#make-empty-narrow)))
        (declare (not safe))
        (##structure
         std/srfi/146/hamt#hash-array-mapped-trie
         _=111970_
         '0
         _hash111971_
         '#f
         _payload?111972_
         __tmp295455))))
  (define std/srfi/146/hamt#collision
    (make-struct-type
     'std/srfi/146/hamt#collision
     '#f
     '2
     'collision
     '((fields: entries hash))
     '#f))
  (define std/srfi/146/hamt#collision?
    (make-struct-predicate std/srfi/146/hamt#collision))
  (define std/srfi/146/hamt#collision/entries
    (make-struct-field-accessor std/srfi/146/hamt#collision '0))
  (define std/srfi/146/hamt#collision/hash
    (make-struct-field-accessor std/srfi/146/hamt#collision '1))
  (define std/srfi/146/hamt#make-collision
    (lambda (_entries111967_ _hash111968_)
      (make-struct-instance
       std/srfi/146/hamt#collision
       _entries111967_
       _hash111968_)))
  (define std/srfi/146/hamt#narrow
    (make-struct-type
     'std/srfi/146/hamt#narrow
     '#f
     '3
     'narrow
     '((fields: array children leaves))
     '#f))
  (define std/srfi/146/hamt#narrow?
    (make-struct-predicate std/srfi/146/hamt#narrow))
  (define std/srfi/146/hamt#narrow/array
    (make-struct-field-accessor std/srfi/146/hamt#narrow '0))
  (define std/srfi/146/hamt#narrow/children
    (make-struct-field-accessor std/srfi/146/hamt#narrow '1))
  (define std/srfi/146/hamt#narrow/leaves
    (make-struct-field-accessor std/srfi/146/hamt#narrow '2))
  (define std/srfi/146/hamt#make-narrow
    (lambda (_array111963_ _children111964_ _leaves111965_)
      (make-struct-instance
       std/srfi/146/hamt#narrow
       _array111963_
       _children111964_
       _leaves111965_)))
  (define std/srfi/146/hamt#wide
    (make-struct-type
     'std/srfi/146/hamt#wide
     '#f
     '3
     'wide
     '((fields: array children leaves))
     '#f))
  (define std/srfi/146/hamt#wide?
    (make-struct-predicate std/srfi/146/hamt#wide))
  (define std/srfi/146/hamt#wide/array
    (make-struct-field-accessor std/srfi/146/hamt#wide '0))
  (define std/srfi/146/hamt#wide/children
    (make-struct-field-accessor std/srfi/146/hamt#wide '1))
  (define std/srfi/146/hamt#wide/leaves
    (make-struct-field-accessor std/srfi/146/hamt#wide '2))
  (define std/srfi/146/hamt#set-wide/children!
    (make-struct-field-mutator std/srfi/146/hamt#wide '1))
  (define std/srfi/146/hamt#set-wide/leaves!
    (make-struct-field-mutator std/srfi/146/hamt#wide '2))
  (define std/srfi/146/hamt#make-wide
    (lambda (_array111959_ _children111960_ _leaves111961_)
      (make-struct-instance
       std/srfi/146/hamt#wide
       _array111959_
       _children111960_
       _leaves111961_)))
  (define std/srfi/146/hamt#hamt/empty?
    (lambda (_hamt111957_)
      (zero? (##structure-ref
              _hamt111957_
              '2
              std/srfi/146/hamt#hash-array-mapped-trie
              '#f))))
  (define std/srfi/146/hamt#hamt/immutable-inner
    (lambda (_hamt111952_ _replace111953_)
      (if (##structure-ref
           _hamt111952_
           '4
           std/srfi/146/hamt#hash-array-mapped-trie
           '#f)
          (let ((_payload?111955_
                 (##structure-ref
                  _hamt111952_
                  '5
                  std/srfi/146/hamt#hash-array-mapped-trie
                  '#f)))
            (let ((__tmp295459
                   (##structure-ref
                    _hamt111952_
                    '1
                    std/srfi/146/hamt#hash-array-mapped-trie
                    '#f))
                  (__tmp295458
                   (##structure-ref
                    _hamt111952_
                    '2
                    std/srfi/146/hamt#hash-array-mapped-trie
                    '#f))
                  (__tmp295457
                   (##structure-ref
                    _hamt111952_
                    '3
                    std/srfi/146/hamt#hash-array-mapped-trie
                    '#f))
                  (__tmp295456
                   (std/srfi/146/hamt#->immutable
                    (##structure-ref
                     _hamt111952_
                     '6
                     std/srfi/146/hamt#hash-array-mapped-trie
                     '#f)
                    _payload?111955_
                    _replace111953_)))
              (declare (not safe))
              (##structure
               std/srfi/146/hamt#hash-array-mapped-trie
               __tmp295459
               __tmp295458
               __tmp295457
               '#f
               _payload?111955_
               __tmp295456)))
          _hamt111952_)))
  (define std/srfi/146/hamt#hamt/immutable__0
    (lambda (_hamt111944_)
      (std/srfi/146/hamt#hamt/immutable-inner
       _hamt111944_
       (lambda (_k111946_ _d111947_) _d111947_))))
  (define std/srfi/146/hamt#hamt/immutable
    (lambda _g295461_
      (let ((_g295460_ (let () (declare (not safe)) (##length _g295461_))))
        (cond ((let () (declare (not safe)) (##fx= _g295460_ 1))
               (apply std/srfi/146/hamt#hamt/immutable__0 _g295461_))
              ((let () (declare (not safe)) (##fx= _g295460_ 2))
               (apply std/srfi/146/hamt#hamt/immutable-inner _g295461_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/146/hamt#hamt/immutable
                _g295461_))))))
  (define std/srfi/146/hamt#hamt/mutable
    (lambda (_hamt111942_)
      (if (##structure-ref
           _hamt111942_
           '4
           std/srfi/146/hamt#hash-array-mapped-trie
           '#f)
          _hamt111942_
          (let ((__tmp295466
                 (##structure-ref
                  _hamt111942_
                  '1
                  std/srfi/146/hamt#hash-array-mapped-trie
                  '#f))
                (__tmp295465
                 (##structure-ref
                  _hamt111942_
                  '2
                  std/srfi/146/hamt#hash-array-mapped-trie
                  '#f))
                (__tmp295464
                 (##structure-ref
                  _hamt111942_
                  '3
                  std/srfi/146/hamt#hash-array-mapped-trie
                  '#f))
                (__tmp295463
                 (##structure-ref
                  _hamt111942_
                  '5
                  std/srfi/146/hamt#hash-array-mapped-trie
                  '#f))
                (__tmp295462
                 (##structure-ref
                  _hamt111942_
                  '6
                  std/srfi/146/hamt#hash-array-mapped-trie
                  '#f)))
            (declare (not safe))
            (##structure
             std/srfi/146/hamt#hash-array-mapped-trie
             __tmp295466
             __tmp295465
             __tmp295464
             '#t
             __tmp295463
             __tmp295462)))))
  (define std/srfi/146/hamt#hamt/replace
    (lambda (_hamt111922_ _key111923_ _dp111924_)
      (if (not (##structure-ref
                _hamt111922_
                '4
                std/srfi/146/hamt#hash-array-mapped-trie
                '#f))
          '#!void
          (error '"Assertion failed:"
                 '(not (hamt/mutable? hamt))
                 (list 'not
                       (##structure-ref
                        _hamt111922_
                        '4
                        std/srfi/146/hamt#hash-array-mapped-trie
                        '#f))))
      (let* ((_payload?111926_
              (##structure-ref
               _hamt111922_
               '5
               std/srfi/146/hamt#hash-array-mapped-trie
               '#f))
             (_root111928_
              (##structure-ref
               _hamt111922_
               '6
               std/srfi/146/hamt#hash-array-mapped-trie
               '#f))
             (_==111930_
              (##structure-ref
               _hamt111922_
               '1
               std/srfi/146/hamt#hash-array-mapped-trie
               '#f))
             (_hp111932_
              (##structure-ref
               _hamt111922_
               '3
               std/srfi/146/hamt#hash-array-mapped-trie
               '#f))
             (_hash111934_
              (std/srfi/146/hamt#hash-bits _hp111932_ _key111923_))
             (_g295467_
              (std/srfi/146/hamt#modify-pure
               _hamt111922_
               _root111928_
               '0
               _dp111924_
               _hash111934_
               _key111923_)))
        (begin
          (let ((_g295468_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g295467_) (##vector-length _g295467_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g295468_ 2)))
                (error "Context expects 2 values" _g295468_)))
          (let ((_change111936_
                 (let () (declare (not safe)) (##vector-ref _g295467_ 0)))
                (_node111937_
                 (let () (declare (not safe)) (##vector-ref _g295467_ 1))))
            (let ()
              (if (eq? _node111937_ _root111928_)
                  _hamt111922_
                  (let ((_count111940_
                         (+ (##structure-ref
                             _hamt111922_
                             '2
                             std/srfi/146/hamt#hash-array-mapped-trie
                             '#f)
                            _change111936_)))
                    (declare (not safe))
                    (##structure
                     std/srfi/146/hamt#hash-array-mapped-trie
                     _==111930_
                     _count111940_
                     _hp111932_
                     '#f
                     _payload?111926_
                     _node111937_)))))))))
  (define std/srfi/146/hamt#hamt/put
    (lambda (_hamt111916_ _key111917_ _datum111918_)
      (std/srfi/146/hamt#hamt/replace
       _hamt111916_
       _key111917_
       (lambda (_x111920_) _datum111918_))))
  (define std/srfi/146/hamt#hamt/replace!
    (lambda (_hamt111902_ _key111903_ _dp111904_)
      (if (##structure-ref
           _hamt111902_
           '4
           std/srfi/146/hamt#hash-array-mapped-trie
           '#f)
          '#!void
          (error '"Assertion failed:"
                 '(hamt/mutable? hamt)
                 (list 'hamt/mutable? _hamt111902_)))
      (let* ((_root111906_
              (##structure-ref
               _hamt111902_
               '6
               std/srfi/146/hamt#hash-array-mapped-trie
               '#f))
             (_hp111908_
              (##structure-ref
               _hamt111902_
               '3
               std/srfi/146/hamt#hash-array-mapped-trie
               '#f))
             (_hash111910_
              (std/srfi/146/hamt#hash-bits _hp111908_ _key111903_))
             (_g295469_
              (std/srfi/146/hamt#mutate
               _hamt111902_
               _root111906_
               '0
               _dp111904_
               _hash111910_
               _key111903_)))
        (begin
          (let ((_g295470_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g295469_) (##vector-length _g295469_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g295470_ 2)))
                (error "Context expects 2 values" _g295470_)))
          (let ((_change111912_
                 (let () (declare (not safe)) (##vector-ref _g295469_ 0)))
                (_node111913_
                 (let () (declare (not safe)) (##vector-ref _g295469_ 1))))
            (let ()
              (if (zero? _change111912_)
                  '#!void
                  (##structure-set!
                   _hamt111902_
                   (+ (##structure-ref
                       _hamt111902_
                       '2
                       std/srfi/146/hamt#hash-array-mapped-trie
                       '#f)
                      _change111912_)
                   '2
                   std/srfi/146/hamt#hash-array-mapped-trie
                   '#f))
              (if (eq? _node111913_ _root111906_)
                  '#!void
                  (##structure-set!
                   _hamt111902_
                   _node111913_
                   '6
                   std/srfi/146/hamt#hash-array-mapped-trie
                   '#f))
              _hamt111902_))))))
  (define std/srfi/146/hamt#hamt/put!
    (lambda (_hamt111896_ _key111897_ _datum111898_)
      (std/srfi/146/hamt#hamt/replace!
       _hamt111896_
       _key111897_
       (lambda (_x111900_) _datum111898_))))
  (define std/srfi/146/hamt#make-empty-narrow
    (lambda ()
      (let ((__tmp295471 (vector)))
        (declare (not safe))
        (##structure std/srfi/146/hamt#narrow __tmp295471 '0 '0))))
  (define std/srfi/146/hamt#hamt-null?
    (lambda (_n111893_) (eq? _n111893_ std/srfi/146/hamt#hamt-null)))
  (define std/srfi/146/hamt#collision-single-leaf?
    (lambda (_n111889_)
      (let ((_elements111891_
             (##structure-ref _n111889_ '1 std/srfi/146/hamt#collision '#f)))
        (if (not (null? _elements111891_))
            (null? (cdr _elements111891_))
            '#f))))
  (define std/srfi/146/hamt#narrow-single-leaf?
    (lambda (_n111887_)
      (if (zero? (##structure-ref _n111887_ '2 std/srfi/146/hamt#narrow '#f))
          (= '1
             (bit-count
              (##structure-ref _n111887_ '3 std/srfi/146/hamt#narrow '#f)))
          '#f)))
  (define std/srfi/146/hamt#wide-single-leaf?
    (lambda (_n111885_)
      (if (zero? (##structure-ref _n111885_ '2 std/srfi/146/hamt#wide '#f))
          (= '1
             (bit-count
              (##structure-ref _n111885_ '3 std/srfi/146/hamt#wide '#f)))
          '#f)))
  (define std/srfi/146/hamt#hash-bits
    (lambda (_hp111882_ _key111883_)
      (remainder
       (_hp111882_ _key111883_)
       std/srfi/146/hamt#hamt-hash-modulus)))
  (define std/srfi/146/hamt#next-set-bit
    (lambda (_i111876_ _start111877_ _end111878_)
      (let ((_index111880_
             (first-set-bit
              (std/srfi/151#bit-field _i111876_ _start111877_ _end111878_))))
        (if (not (= _index111880_ '-1)) (+ _index111880_ _start111877_) '#f))))
  (define std/srfi/146/hamt#narrow->wide
    (lambda (_n111846_ _payload?111847_)
      (let* ((_c111849_
              (##structure-ref _n111846_ '2 std/srfi/146/hamt#narrow '#f))
             (_l111851_
              (##structure-ref _n111846_ '3 std/srfi/146/hamt#narrow '#f))
             (_stride111853_ (std/srfi/146/hamt#leaf-stride _payload?111847_))
             (_a-in111855_
              (##structure-ref _n111846_ '1 std/srfi/146/hamt#narrow '#f))
             (_a-out111857_
              (make-vector
               (* _stride111853_ std/srfi/146/hamt#hamt-bucket-size))))
        (let _next-leaf111860_ ((_start111862_ '0) (_count111863_ '0))
          (let ((_i111865_
                 (std/srfi/146/hamt#next-set-bit
                  _l111851_
                  _start111862_
                  std/srfi/146/hamt#hamt-bucket-size)))
            (if _i111865_
                (begin
                  (let ((_j111867_ (* _stride111853_ _i111865_)))
                    (vector-set!
                     _a-out111857_
                     _j111867_
                     (vector-ref _a-in111855_ _count111863_))
                    (if _payload?111847_
                        (vector-set!
                         _a-out111857_
                         (+ _j111867_ '1)
                         (vector-ref _a-in111855_ (+ _count111863_ '1)))
                        '#!void))
                  (_next-leaf111860_
                   (+ _i111865_ '1)
                   (+ _stride111853_ _count111863_)))
                '#!void)))
        (let _next-child111869_ ((_start111871_ '0)
                                 (_offset111872_
                                  (* _stride111853_ (bit-count _l111851_))))
          (let ((_i111874_
                 (std/srfi/146/hamt#next-set-bit
                  _c111849_
                  _start111871_
                  std/srfi/146/hamt#hamt-bucket-size)))
            (if _i111874_
                (begin
                  (vector-set!
                   _a-out111857_
                   (* _stride111853_ _i111874_)
                   (vector-ref _a-in111855_ _offset111872_))
                  (_next-child111869_ (+ _i111874_ '1) (+ _offset111872_ '1)))
                '#!void)))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/146/hamt#wide
           _a-out111857_
           _c111849_
           _l111851_)))))
  (define std/srfi/146/hamt#->immutable
    (lambda (_n111810_ _payload?111811_ _replace111812_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _n111810_ 'std/srfi/146/hamt#collision))
          _n111810_
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _n111810_ 'std/srfi/146/hamt#narrow))
              _n111810_
              (if (let ()
                    (declare (not safe))
                    (##structure-instance-of?
                     _n111810_
                     'std/srfi/146/hamt#wide))
                  (let* ((_c111814_
                          (##structure-ref
                           _n111810_
                           '2
                           std/srfi/146/hamt#wide
                           '#f))
                         (_l111816_
                          (##structure-ref
                           _n111810_
                           '3
                           std/srfi/146/hamt#wide
                           '#f))
                         (_stride111818_
                          (std/srfi/146/hamt#leaf-stride _payload?111811_))
                         (_l-count111820_ (bit-count _l111816_))
                         (_a-in111822_
                          (##structure-ref
                           _n111810_
                           '1
                           std/srfi/146/hamt#wide
                           '#f))
                         (_a-out111824_
                          (make-vector
                           (+ (* _stride111818_ _l-count111820_)
                              (bit-count _c111814_)))))
                    (let _next-leaf111827_ ((_start111829_ '0)
                                            (_count111830_ '0))
                      (let ((_i111832_
                             (std/srfi/146/hamt#next-set-bit
                              _l111816_
                              _start111829_
                              std/srfi/146/hamt#hamt-bucket-size)))
                        (if _i111832_
                            (begin
                              (let* ((_j111834_ (* _stride111818_ _i111832_))
                                     (_key111836_
                                      (vector-ref _a-in111822_ _j111834_)))
                                (vector-set!
                                 _a-out111824_
                                 _count111830_
                                 _key111836_)
                                (if _payload?111811_
                                    (vector-set!
                                     _a-out111824_
                                     (+ _count111830_ '1)
                                     (_replace111812_
                                      _key111836_
                                      (vector-ref
                                       _a-in111822_
                                       (+ _j111834_ '1))))
                                    '#!void))
                              (_next-leaf111827_
                               (+ _i111832_ '1)
                               (+ _stride111818_ _count111830_)))
                            '#!void)))
                    (let _next-child111839_ ((_start111841_ '0)
                                             (_offset111842_
                                              (* _stride111818_
                                                 _l-count111820_)))
                      (let ((_i111844_
                             (std/srfi/146/hamt#next-set-bit
                              _c111814_
                              _start111841_
                              std/srfi/146/hamt#hamt-bucket-size)))
                        (if _i111844_
                            (begin
                              (vector-set!
                               _a-out111824_
                               _offset111842_
                               (std/srfi/146/hamt#->immutable
                                (vector-ref
                                 _a-in111822_
                                 (* _stride111818_ _i111844_))
                                _payload?111811_
                                _replace111812_))
                              (_next-child111839_
                               (+ _i111844_ '1)
                               (+ _offset111842_ '1)))
                            '#!void)))
                    (let ()
                      (declare (not safe))
                      (##structure
                       std/srfi/146/hamt#narrow
                       _a-out111824_
                       _c111814_
                       _l111816_)))
                  (error '"Unexpected type of node."))))))
  (define std/srfi/146/hamt#hash-fragment
    (lambda (_shift111807_ _hash111808_)
      (std/srfi/151#bit-field
       _hash111808_
       _shift111807_
       (+ _shift111807_ std/srfi/146/hamt#hamt-hash-slice-size))))
  (define std/srfi/146/hamt#fragment->mask
    (lambda (_fragment111805_) (- (expt '2 _fragment111805_) '1)))
  (define std/srfi/146/hamt#mutate
    (lambda (_hamt111798_
             _n111799_
             _shift111800_
             _dp111801_
             _h111802_
             _k111803_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _n111799_ 'std/srfi/146/hamt#collision))
          (std/srfi/146/hamt#modify-collision
           _hamt111798_
           _n111799_
           _shift111800_
           _dp111801_
           _h111802_
           _k111803_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _n111799_ 'std/srfi/146/hamt#narrow))
              (std/srfi/146/hamt#modify-wide
               _hamt111798_
               (std/srfi/146/hamt#narrow->wide
                _n111799_
                (##structure-ref
                 _hamt111798_
                 '5
                 std/srfi/146/hamt#hash-array-mapped-trie
                 '#f))
               _shift111800_
               _dp111801_
               _h111802_
               _k111803_)
              (if (let ()
                    (declare (not safe))
                    (##structure-instance-of?
                     _n111799_
                     'std/srfi/146/hamt#wide))
                  (std/srfi/146/hamt#modify-wide
                   _hamt111798_
                   _n111799_
                   _shift111800_
                   _dp111801_
                   _h111802_
                   _k111803_)
                  (error '"Unknown HAMT node type." _n111799_))))))
  (define std/srfi/146/hamt#modify-wide
    (lambda (_hamt111787_
             _n111788_
             _shift111789_
             _dp111790_
             _h111791_
             _k111792_)
      (let ((_fragment111794_
             (std/srfi/146/hamt#hash-fragment _shift111789_ _h111791_)))
        (if (bit-set?
             _fragment111794_
             (##structure-ref _n111788_ '2 std/srfi/146/hamt#wide '#f))
            (std/srfi/146/hamt#modify-wide-child
             _hamt111787_
             _n111788_
             _shift111789_
             _dp111790_
             _h111791_
             _k111792_)
            (if (bit-set?
                 _fragment111794_
                 (##structure-ref _n111788_ '3 std/srfi/146/hamt#wide '#f))
                (std/srfi/146/hamt#modify-wide-leaf
                 _hamt111787_
                 _n111788_
                 _shift111789_
                 _dp111790_
                 _h111791_
                 _k111792_)
                (let ((_d111796_ (_dp111790_ std/srfi/146/hamt#hamt-null)))
                  (if (std/srfi/146/hamt#hamt-null? _d111796_)
                      (values '0 _n111788_)
                      (std/srfi/146/hamt#modify-wide-new
                       _hamt111787_
                       _n111788_
                       _shift111789_
                       _d111796_
                       _h111791_
                       _k111792_))))))))
  (define std/srfi/146/hamt#modify-wide-child
    (lambda (_hamt111752_
             _n111753_
             _shift111754_
             _dp111755_
             _h111756_
             _k111757_)
      (let* ((_fragment111759_
              (std/srfi/146/hamt#hash-fragment _shift111754_ _h111756_))
             (_array111761_
              (##structure-ref _n111753_ '1 std/srfi/146/hamt#wide '#f))
             (_payload?111763_
              (##structure-ref
               _hamt111752_
               '5
               std/srfi/146/hamt#hash-array-mapped-trie
               '#f))
             (_stride111765_ (std/srfi/146/hamt#leaf-stride _payload?111763_))
             (_i111767_ (* _stride111765_ _fragment111759_))
             (_child111769_ (vector-ref _array111761_ _i111767_))
             (_g295472_
              (std/srfi/146/hamt#mutate
               _hamt111752_
               _child111769_
               (+ _shift111754_ std/srfi/146/hamt#hamt-hash-slice-size)
               _dp111755_
               _h111756_
               _k111757_)))
        (begin
          (let ((_g295473_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g295472_) (##vector-length _g295472_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g295473_ 2)))
                (error "Context expects 2 values" _g295473_)))
          (let ((_change111771_
                 (let () (declare (not safe)) (##vector-ref _g295472_ 0)))
                (_new-child111772_
                 (let () (declare (not safe)) (##vector-ref _g295472_ 1))))
            (let ()
              (letrec ((_coalesce111775_
                        (lambda (_key111784_ _datum111785_)
                          (vector-set! _array111761_ _i111767_ _key111784_)
                          (if _payload?111763_
                              (vector-set!
                               _array111761_
                               (+ _i111767_ '1)
                               _datum111785_)
                              '#!void)
                          (##structure-set!
                           _n111753_
                           (std/srfi/151#copy-bit
                            _fragment111759_
                            (##structure-ref
                             _n111753_
                             '2
                             std/srfi/146/hamt#wide
                             '#f)
                            '#f)
                           '2
                           std/srfi/146/hamt#wide
                           '#f)
                          (##structure-set!
                           _n111753_
                           (std/srfi/151#copy-bit
                            _fragment111759_
                            (##structure-ref
                             _n111753_
                             '3
                             std/srfi/146/hamt#wide
                             '#f)
                            '#t)
                           '3
                           std/srfi/146/hamt#wide
                           '#f)
                          (values _change111771_ _n111753_)))
                       (_replace111776_
                        (lambda ()
                          (vector-set!
                           _array111761_
                           _i111767_
                           _new-child111772_)
                          (values _change111771_ _n111753_))))
                (if (eq? _new-child111772_ _child111769_)
                    (values _change111771_ _n111753_)
                    (if (std/srfi/146/hamt#hamt-null? _new-child111772_)
                        (error '"Child cannot become null." _n111753_)
                        (if (let ()
                              (declare (not safe))
                              (##structure-instance-of?
                               _new-child111772_
                               'std/srfi/146/hamt#collision))
                            (if (std/srfi/146/hamt#collision-single-leaf?
                                 _new-child111772_)
                                (let ((_a111778_
                                       (car (##structure-ref
                                             _new-child111772_
                                             '1
                                             std/srfi/146/hamt#collision
                                             '#f))))
                                  (if _payload?111763_
                                      (_coalesce111775_
                                       (car _a111778_)
                                       (cdr _a111778_))
                                      (_coalesce111775_ _a111778_ '#f)))
                                (_replace111776_))
                            (if (let ()
                                  (declare (not safe))
                                  (##structure-instance-of?
                                   _new-child111772_
                                   'std/srfi/146/hamt#wide))
                                (if (std/srfi/146/hamt#wide-single-leaf?
                                     _new-child111772_)
                                    (let ((_a111780_
                                           (##structure-ref
                                            _new-child111772_
                                            '1
                                            std/srfi/146/hamt#wide
                                            '#f))
                                          (_j111781_
                                           (* _stride111765_
                                              (std/srfi/146/hamt#next-set-bit
                                               (##structure-ref
                                                _new-child111772_
                                                '3
                                                std/srfi/146/hamt#wide
                                                '#f)
                                               '0
                                               std/srfi/146/hamt#hamt-bucket-size))))
                                      (_coalesce111775_
                                       (vector-ref _a111780_ _j111781_)
                                       (if _payload?111763_
                                           (vector-ref
                                            _a111780_
                                            (+ _j111781_ '1))
                                           '#f)))
                                    (_replace111776_))
                                (if (let ()
                                      (declare (not safe))
                                      (##structure-instance-of?
                                       _new-child111772_
                                       'std/srfi/146/hamt#narrow))
                                    (_replace111776_)
                                    (error '"Unexpected type of child node.")))))))))))))
  (define std/srfi/146/hamt#modify-wide-leaf
    (lambda (_hamt111725_
             _n111726_
             _shift111727_
             _dp111728_
             _h111729_
             _k111730_)
      (let* ((_fragment111732_
              (std/srfi/146/hamt#hash-fragment _shift111727_ _h111729_))
             (_array111734_
              (##structure-ref _n111726_ '1 std/srfi/146/hamt#wide '#f))
             (_payload?111736_
              (##structure-ref
               _hamt111725_
               '5
               std/srfi/146/hamt#hash-array-mapped-trie
               '#f))
             (_stride111738_ (std/srfi/146/hamt#leaf-stride _payload?111736_))
             (_i111740_ (* _stride111738_ _fragment111732_))
             (_key111742_ (vector-ref _array111734_ _i111740_)))
        (if ((##structure-ref
              _hamt111725_
              '1
              std/srfi/146/hamt#hash-array-mapped-trie
              '#f)
             _k111730_
             _key111742_)
            (let* ((_existing111745_
                    (if _payload?111736_
                        (vector-ref _array111734_ (+ _i111740_ '1))
                        std/srfi/146/hamt#hamt-null))
                   (_d111747_ (_dp111728_ _existing111745_)))
              (if (std/srfi/146/hamt#hamt-null? _d111747_)
                  (begin
                    (vector-set! _array111734_ _i111740_ '#f)
                    (if _payload?111736_
                        (vector-set! _array111734_ (+ _i111740_ '1) '#f)
                        '#!void)
                    (##structure-set!
                     _n111726_
                     (std/srfi/151#copy-bit
                      _fragment111732_
                      (##structure-ref _n111726_ '3 std/srfi/146/hamt#wide '#f)
                      '#f)
                     '3
                     std/srfi/146/hamt#wide
                     '#f)
                    (values '-1 _n111726_))
                  (begin
                    (if _payload?111736_
                        (vector-set! _array111734_ (+ _i111740_ '1) _d111747_)
                        '#!void)
                    (values '0 _n111726_))))
            (let ((_d111750_ (_dp111728_ std/srfi/146/hamt#hamt-null)))
              (if (std/srfi/146/hamt#hamt-null? _d111750_)
                  (values '0 _n111726_)
                  (std/srfi/146/hamt#add-wide-leaf-key
                   _hamt111725_
                   _n111726_
                   _shift111727_
                   _d111750_
                   _h111729_
                   _k111730_)))))))
  (define std/srfi/146/hamt#add-wide-leaf-key
    (lambda (_hamt111697_
             _n111698_
             _shift111699_
             _d111700_
             _h111701_
             _k111702_)
      (letrec* ((_payload?111704_
                 (##structure-ref
                  _hamt111697_
                  '5
                  std/srfi/146/hamt#hash-array-mapped-trie
                  '#f))
                (_make-entry111705_
                 (if _payload?111704_
                     cons
                     (lambda (_k111722_ _d111723_) _k111722_))))
        (let* ((_fragment111707_
                (std/srfi/146/hamt#hash-fragment _shift111699_ _h111701_))
               (_array111709_
                (##structure-ref _n111698_ '1 std/srfi/146/hamt#wide '#f))
               (_stride111711_
                (std/srfi/146/hamt#leaf-stride _payload?111704_))
               (_i111713_ (* _stride111711_ _fragment111707_))
               (_key111715_ (vector-ref _array111709_ _i111713_))
               (_hash111717_
                (std/srfi/146/hamt#hash-bits
                 (##structure-ref
                  _hamt111697_
                  '3
                  std/srfi/146/hamt#hash-array-mapped-trie
                  '#f)
                 _key111715_))
               (_datum111719_
                (if _payload?111704_
                    (vector-ref _array111709_ (+ _i111713_ '1))
                    '#f)))
          (vector-set!
           _array111709_
           _i111713_
           (if (= _h111701_ _hash111717_)
               (let ((__tmp295474
                      (list (_make-entry111705_ _k111702_ _d111700_)
                            (_make-entry111705_ _key111715_ _datum111719_))))
                 (declare (not safe))
                 (##structure
                  std/srfi/146/hamt#collision
                  __tmp295474
                  _h111701_))
               (std/srfi/146/hamt#make-narrow-with-two-keys
                _payload?111704_
                (+ _shift111699_ std/srfi/146/hamt#hamt-hash-slice-size)
                _h111701_
                _k111702_
                _d111700_
                _hash111717_
                _key111715_
                _datum111719_)))
          (if _payload?111704_
              (vector-set! _array111709_ (+ _i111713_ '1) '#f)
              '#!void)
          (##structure-set!
           _n111698_
           (std/srfi/151#copy-bit
            _fragment111707_
            (##structure-ref _n111698_ '2 std/srfi/146/hamt#wide '#f)
            '#t)
           '2
           std/srfi/146/hamt#wide
           '#f)
          (##structure-set!
           _n111698_
           (std/srfi/151#copy-bit
            _fragment111707_
            (##structure-ref _n111698_ '3 std/srfi/146/hamt#wide '#f)
            '#f)
           '3
           std/srfi/146/hamt#wide
           '#f)
          (values '1 _n111698_)))))
  (define std/srfi/146/hamt#modify-wide-new
    (lambda (_hamt111679_
             _n111680_
             _shift111681_
             _d111682_
             _h111683_
             _k111684_)
      (let* ((_fragment111686_
              (std/srfi/146/hamt#hash-fragment _shift111681_ _h111683_))
             (_array111688_
              (##structure-ref _n111680_ '1 std/srfi/146/hamt#wide '#f))
             (_payload?111690_
              (##structure-ref
               _hamt111679_
               '5
               std/srfi/146/hamt#hash-array-mapped-trie
               '#f))
             (_stride111692_ (std/srfi/146/hamt#leaf-stride _payload?111690_))
             (_i111694_ (* _stride111692_ _fragment111686_)))
        (vector-set! _array111688_ _i111694_ _k111684_)
        (if _payload?111690_
            (vector-set! _array111688_ (+ _i111694_ '1) _d111682_)
            '#!void)
        (##structure-set!
         _n111680_
         (std/srfi/151#copy-bit
          _fragment111686_
          (##structure-ref _n111680_ '3 std/srfi/146/hamt#wide '#f)
          '#t)
         '3
         std/srfi/146/hamt#wide
         '#f)
        (values '1 _n111680_))))
  (define std/srfi/146/hamt#make-narrow-with-two-keys
    (lambda (_payload?111658_
             _shift111659_
             _h1111660_
             _k1111661_
             _d1111662_
             _h2111663_
             _k2111664_
             _d2111665_)
      (letrec ((_two-leaves111667_
                (lambda (_f1111672_
                         _k1111673_
                         _d1111674_
                         _f2111675_
                         _k2111676_
                         _d2111677_)
                  (let ((__tmp295476
                         (if _payload?111658_
                             (vector _k1111673_
                                     _d1111674_
                                     _k2111676_
                                     _d2111677_)
                             (vector _k1111673_ _k2111676_)))
                        (__tmp295475
                         (std/srfi/151#copy-bit
                          _f2111675_
                          (std/srfi/151#copy-bit _f1111672_ '0 '#t)
                          '#t)))
                    (declare (not safe))
                    (##structure
                     std/srfi/146/hamt#narrow
                     __tmp295476
                     '0
                     __tmp295475)))))
        (if (not (= _h1111660_ _h2111663_))
            '#!void
            (error '"Assertion failed:"
                   '(not (= h1 h2))
                   (list 'not (= _h1111660_ _h2111663_))))
        (let ((_f1111669_
               (std/srfi/146/hamt#hash-fragment _shift111659_ _h1111660_))
              (_f2111670_
               (std/srfi/146/hamt#hash-fragment _shift111659_ _h2111663_)))
          (if (= _f1111669_ _f2111670_)
              (let ((__tmp295478
                     (vector (std/srfi/146/hamt#make-narrow-with-two-keys
                              _payload?111658_
                              (+ _shift111659_
                                 std/srfi/146/hamt#hamt-hash-slice-size)
                              _h1111660_
                              _k1111661_
                              _d1111662_
                              _h2111663_
                              _k2111664_
                              _d2111665_)))
                    (__tmp295477 (std/srfi/151#copy-bit _f1111669_ '0 '#t)))
                (declare (not safe))
                (##structure
                 std/srfi/146/hamt#narrow
                 __tmp295478
                 __tmp295477
                 '0))
              (if (< _f1111669_ _f2111670_)
                  (_two-leaves111667_
                   _f1111669_
                   _k1111661_
                   _d1111662_
                   _f2111670_
                   _k2111664_
                   _d2111665_)
                  (_two-leaves111667_
                   _f2111670_
                   _k2111664_
                   _d2111665_
                   _f1111669_
                   _k1111661_
                   _d1111662_)))))))
  (define std/srfi/146/hamt#modify-pure
    (lambda (_hamt111651_
             _n111652_
             _shift111653_
             _dp111654_
             _h111655_
             _k111656_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _n111652_ 'std/srfi/146/hamt#collision))
          (std/srfi/146/hamt#modify-collision
           _hamt111651_
           _n111652_
           _shift111653_
           _dp111654_
           _h111655_
           _k111656_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _n111652_ 'std/srfi/146/hamt#narrow))
              (std/srfi/146/hamt#modify-narrow
               _hamt111651_
               _n111652_
               _shift111653_
               _dp111654_
               _h111655_
               _k111656_)
              (if (let ()
                    (declare (not safe))
                    (##structure-instance-of?
                     _n111652_
                     'std/srfi/146/hamt#wide))
                  (error '"Should have been converted to narrow before here.")
                  (error '"Unknown HAMT node type." _n111652_))))))
  (define std/srfi/146/hamt#lower-collision
    (lambda (_hamt111632_
             _n111633_
             _shift111634_
             _dp111635_
             _h111636_
             _k111637_)
      (let ((_collision-hash111639_
             (##structure-ref _n111633_ '2 std/srfi/146/hamt#collision '#f))
            (_d111640_ (_dp111635_ std/srfi/146/hamt#hamt-null)))
        (if (std/srfi/146/hamt#hamt-null? _d111640_)
            (values '0 _n111633_)
            (values '1
                    (let _descend111642_ ((_shift111644_ _shift111634_))
                      (let ((_collision-fragment111646_
                             (std/srfi/146/hamt#hash-fragment
                              _shift111644_
                              _collision-hash111639_))
                            (_leaf-fragment111647_
                             (std/srfi/146/hamt#hash-fragment
                              _shift111644_
                              _h111636_)))
                        (if (= _collision-fragment111646_
                               _leaf-fragment111647_)
                            (let ((_child111649_
                                   (_descend111642_
                                    (+ _shift111644_
                                       std/srfi/146/hamt#hamt-hash-slice-size))))
                              (let ((__tmp295480 (vector _child111649_))
                                    (__tmp295479
                                     (std/srfi/151#copy-bit
                                      _collision-fragment111646_
                                      '0
                                      '#t)))
                                (declare (not safe))
                                (##structure
                                 std/srfi/146/hamt#narrow
                                 __tmp295480
                                 __tmp295479
                                 '0)))
                            (let ((__tmp295483
                                   (if (##structure-ref
                                        _hamt111632_
                                        '5
                                        std/srfi/146/hamt#hash-array-mapped-trie
                                        '#f)
                                       (vector _k111637_ _d111640_ _n111633_)
                                       (vector _k111637_ _n111633_)))
                                  (__tmp295482
                                   (std/srfi/151#copy-bit
                                    _collision-fragment111646_
                                    '0
                                    '#t))
                                  (__tmp295481
                                   (std/srfi/151#copy-bit
                                    _leaf-fragment111647_
                                    '0
                                    '#t)))
                              (declare (not safe))
                              (##structure
                               std/srfi/146/hamt#narrow
                               __tmp295483
                               __tmp295482
                               __tmp295481))))))))))
  (define std/srfi/146/hamt#modify-collision
    (lambda (_hamt111602_
             _n111603_
             _shift111604_
             _dp111605_
             _h111606_
             _k111607_)
      (if (= _h111606_
             (##structure-ref _n111603_ '2 std/srfi/146/hamt#collision '#f))
          (let ((_payload?111609_
                 (##structure-ref
                  _hamt111602_
                  '5
                  std/srfi/146/hamt#hash-array-mapped-trie
                  '#f)))
            (let _next111611_ ((_entries111613_
                                (##structure-ref
                                 _n111603_
                                 '1
                                 std/srfi/146/hamt#collision
                                 '#f))
                               (_checked111614_ '()))
              (if (null? _entries111613_)
                  (let ((_d111616_ (_dp111605_ std/srfi/146/hamt#hamt-null)))
                    (if (std/srfi/146/hamt#hamt-null? _d111616_)
                        (values '0 _n111603_)
                        (values '1
                                (let ((__tmp295484
                                       (if _payload?111609_
                                           (cons (cons _k111607_ _d111616_)
                                                 _checked111614_)
                                           (cons _k111607_ _checked111614_))))
                                  (declare (not safe))
                                  (##structure
                                   std/srfi/146/hamt#collision
                                   __tmp295484
                                   _h111606_)))))
                  (let* ((_entry111618_ (car _entries111613_))
                         (_key111620_
                          (if _payload?111609_
                              (car _entry111618_)
                              _entry111618_)))
                    (if ((##structure-ref
                          _hamt111602_
                          '1
                          std/srfi/146/hamt#hash-array-mapped-trie
                          '#f)
                         _k111607_
                         _key111620_)
                        (let* ((_existing111623_
                                (if _payload?111609_
                                    (cdr _entry111618_)
                                    std/srfi/146/hamt#hamt-null))
                               (_d111625_ (_dp111605_ _existing111623_))
                               (_delete?111627_
                                (std/srfi/146/hamt#hamt-null? _d111625_))
                               (_others111629_
                                (append _checked111614_
                                        (cdr _entries111613_))))
                          (values (if _delete?111627_ '-1 '0)
                                  (let ((__tmp295485
                                         (if _delete?111627_
                                             _others111629_
                                             (if _payload?111609_
                                                 (cons (cons _k111607_
                                                             _d111625_)
                                                       _others111629_)
                                                 (cons _k111607_
                                                       _others111629_)))))
                                    (declare (not safe))
                                    (##structure
                                     std/srfi/146/hamt#collision
                                     __tmp295485
                                     _h111606_))))
                        (_next111611_
                         (cdr _entries111613_)
                         (cons (car _entries111613_) _checked111614_)))))))
          (std/srfi/146/hamt#lower-collision
           _hamt111602_
           _n111603_
           _shift111604_
           _dp111605_
           _h111606_
           _k111607_))))
  (define std/srfi/146/hamt#leaf-stride
    (lambda (_payload?111600_) (if _payload?111600_ '2 '1)))
  (define std/srfi/146/hamt#narrow-child-index
    (lambda (_l111595_ _c111596_ _mask111597_ _payload?111598_)
      (+ (* (std/srfi/146/hamt#leaf-stride _payload?111598_)
            (bit-count _l111595_))
         (bit-count (bitwise-and _c111596_ _mask111597_)))))
  (define std/srfi/146/hamt#narrow-leaf-index
    (lambda (_l111591_ _mask111592_ _payload?111593_)
      (* (std/srfi/146/hamt#leaf-stride _payload?111593_)
         (bit-count (bitwise-and _l111591_ _mask111592_)))))
  (define std/srfi/146/hamt#modify-narrow
    (lambda (_hamt111580_
             _n111581_
             _shift111582_
             _dp111583_
             _h111584_
             _k111585_)
      (let ((_fragment111587_
             (std/srfi/146/hamt#hash-fragment _shift111582_ _h111584_)))
        (if (bit-set?
             _fragment111587_
             (##structure-ref _n111581_ '2 std/srfi/146/hamt#narrow '#f))
            (std/srfi/146/hamt#modify-narrow-child
             _hamt111580_
             _n111581_
             _shift111582_
             _dp111583_
             _h111584_
             _k111585_)
            (if (bit-set?
                 _fragment111587_
                 (##structure-ref _n111581_ '3 std/srfi/146/hamt#narrow '#f))
                (std/srfi/146/hamt#modify-narrow-leaf
                 _hamt111580_
                 _n111581_
                 _shift111582_
                 _dp111583_
                 _h111584_
                 _k111585_)
                (let ((_d111589_ (_dp111583_ std/srfi/146/hamt#hamt-null)))
                  (if (std/srfi/146/hamt#hamt-null? _d111589_)
                      (values '0 _n111581_)
                      (std/srfi/146/hamt#modify-narrow-new
                       _hamt111580_
                       _n111581_
                       _shift111582_
                       _d111589_
                       _h111584_
                       _k111585_))))))))
  (define std/srfi/146/hamt#modify-narrow-child
    (lambda (_hamt111484_
             _n111485_
             _shift111486_
             _dp111487_
             _h111488_
             _k111489_)
      (let* ((_fragment111491_
              (std/srfi/146/hamt#hash-fragment _shift111486_ _h111488_))
             (_mask111493_ (std/srfi/146/hamt#fragment->mask _fragment111491_))
             (_c111495_
              (##structure-ref _n111485_ '2 std/srfi/146/hamt#narrow '#f))
             (_l111497_
              (##structure-ref _n111485_ '3 std/srfi/146/hamt#narrow '#f))
             (_array111499_
              (##structure-ref _n111485_ '1 std/srfi/146/hamt#narrow '#f))
             (_payload?111501_
              (##structure-ref
               _hamt111484_
               '5
               std/srfi/146/hamt#hash-array-mapped-trie
               '#f))
             (_child-index111503_
              (std/srfi/146/hamt#narrow-child-index
               _l111497_
               _c111495_
               _mask111493_
               _payload?111501_))
             (_child111505_ (vector-ref _array111499_ _child-index111503_))
             (_g295486_
              (std/srfi/146/hamt#modify-pure
               _hamt111484_
               _child111505_
               (+ _shift111486_ std/srfi/146/hamt#hamt-hash-slice-size)
               _dp111487_
               _h111488_
               _k111489_)))
        (begin
          (let ((_g295487_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g295486_) (##vector-length _g295486_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g295487_ 2)))
                (error "Context expects 2 values" _g295487_)))
          (let ((_change111507_
                 (let () (declare (not safe)) (##vector-ref _g295486_ 0)))
                (_new-child111508_
                 (let () (declare (not safe)) (##vector-ref _g295486_ 1))))
            (let ()
              (letrec ((_coalesce111511_
                        (lambda (_key111519_ _datum111520_)
                          (let ((_leaf-index111522_
                                 (std/srfi/146/hamt#narrow-leaf-index
                                  _l111497_
                                  _mask111493_
                                  _payload?111501_)))
                            (values _change111507_
                                    (let ((__tmp295490
                                           (if _payload?111501_
                                               (let* ((_result111524_
                                                       (make-vector
                                                        (+ (vector-length
                                                            _array111499_)
                                                           (- (+ (+ '0 '1) '1)
                                                              '1))))
                                                      (_index111527_
                                                       _leaf-index111522_))
                                                 (vector-copy!
                                                  _result111524_
                                                  (+ '0 '0)
                                                  _array111499_
                                                  '0
                                                  _index111527_)
                                                 (vector-set!
                                                  _result111524_
                                                  (+ '0 _index111527_)
                                                  _key111519_)
                                                 (let* ((_skew111530_
                                                         (+ '0 '1))
                                                        (_index111533_
                                                         _leaf-index111522_))
                                                   (vector-copy!
                                                    _result111524_
                                                    (+ _index111527_
                                                       _skew111530_)
                                                    _array111499_
                                                    _index111527_
                                                    _index111533_)
                                                   (vector-set!
                                                    _result111524_
                                                    (+ _skew111530_
                                                       _index111533_)
                                                    _datum111520_)
                                                   (let* ((_skew111536_
                                                           (+ _skew111530_ '1))
                                                          (_index111539_
                                                           _child-index111503_))
                                                     (vector-copy!
                                                      _result111524_
                                                      (+ _index111533_
                                                         _skew111536_)
                                                      _array111499_
                                                      _index111533_
                                                      _index111539_)
                                                     (let* ((_dropped111542_
                                                             '1)
                                                            (_offset111545_
                                                             (+ _index111539_
                                                                _dropped111542_))
                                                            (_skew111548_
                                                             (- _skew111536_
                                                                _dropped111542_)))
                                                       (let ((_index111552_
                                                              (vector-length
                                                               _array111499_)))
                                                         (vector-copy!
                                                          _result111524_
                                                          (+ _offset111545_
                                                             _skew111548_)
                                                          _array111499_
                                                          _offset111545_
                                                          _index111552_)
                                                         _result111524_)))))
                                               (let* ((_result111555_
                                                       (make-vector
                                                        (+ (vector-length
                                                            _array111499_)
                                                           (- (+ '0 '1) '1))))
                                                      (_index111558_
                                                       _leaf-index111522_))
                                                 (vector-copy!
                                                  _result111555_
                                                  (+ '0 '0)
                                                  _array111499_
                                                  '0
                                                  _index111558_)
                                                 (vector-set!
                                                  _result111555_
                                                  (+ '0 _index111558_)
                                                  _key111519_)
                                                 (let* ((_skew111561_
                                                         (+ '0 '1))
                                                        (_index111564_
                                                         _child-index111503_))
                                                   (vector-copy!
                                                    _result111555_
                                                    (+ _index111558_
                                                       _skew111561_)
                                                    _array111499_
                                                    _index111558_
                                                    _index111564_)
                                                   (let* ((_dropped111567_ '1)
                                                          (_offset111570_
                                                           (+ _index111564_
                                                              _dropped111567_))
                                                          (_skew111573_
                                                           (- _skew111561_
                                                              _dropped111567_)))
                                                     (let ((_index111577_
                                                            (vector-length
                                                             _array111499_)))
                                                       (vector-copy!
                                                        _result111555_
                                                        (+ _offset111570_
                                                           _skew111573_)
                                                        _array111499_
                                                        _offset111570_
                                                        _index111577_)
                                                       _result111555_))))))
                                          (__tmp295489
                                           (std/srfi/151#copy-bit
                                            _fragment111491_
                                            _c111495_
                                            '#f))
                                          (__tmp295488
                                           (std/srfi/151#copy-bit
                                            _fragment111491_
                                            _l111497_
                                            '#t)))
                                      (declare (not safe))
                                      (##structure
                                       std/srfi/146/hamt#narrow
                                       __tmp295490
                                       __tmp295489
                                       __tmp295488))))))
                       (_replace111512_
                        (lambda ()
                          (values _change111507_
                                  (let ((__tmp295491
                                         (std/srfi/146/vector-edit#vector-replace-one
                                          _array111499_
                                          _child-index111503_
                                          _new-child111508_)))
                                    (declare (not safe))
                                    (##structure
                                     std/srfi/146/hamt#narrow
                                     __tmp295491
                                     _c111495_
                                     _l111497_))))))
                (if (eq? _new-child111508_ _child111505_)
                    (values '0 _n111485_)
                    (if (std/srfi/146/hamt#hamt-null? _new-child111508_)
                        (error '"Child cannot become null." _n111485_)
                        (if (let ()
                              (declare (not safe))
                              (##structure-instance-of?
                               _new-child111508_
                               'std/srfi/146/hamt#collision))
                            (if (std/srfi/146/hamt#collision-single-leaf?
                                 _new-child111508_)
                                (let ((_a111514_
                                       (car (##structure-ref
                                             _new-child111508_
                                             '1
                                             std/srfi/146/hamt#collision
                                             '#f))))
                                  (if _payload?111501_
                                      (_coalesce111511_
                                       (car _a111514_)
                                       (cdr _a111514_))
                                      (_coalesce111511_ _a111514_ '#f)))
                                (_replace111512_))
                            (if (let ()
                                  (declare (not safe))
                                  (##structure-instance-of?
                                   _new-child111508_
                                   'std/srfi/146/hamt#narrow))
                                (if (std/srfi/146/hamt#narrow-single-leaf?
                                     _new-child111508_)
                                    (let ((_a111516_
                                           (##structure-ref
                                            _new-child111508_
                                            '1
                                            std/srfi/146/hamt#narrow
                                            '#f)))
                                      (_coalesce111511_
                                       (vector-ref _a111516_ '0)
                                       (if _payload?111501_
                                           (vector-ref _a111516_ '1)
                                           '#f)))
                                    (_replace111512_))
                                (if (let ()
                                      (declare (not safe))
                                      (##structure-instance-of?
                                       _new-child111508_
                                       'std/srfi/146/hamt#wide))
                                    (error '"New child should be collision or narrow.")
                                    (error '"Unexpected type of child node.")))))))))))))
  (define std/srfi/146/hamt#modify-narrow-leaf
    (lambda (_hamt111451_
             _n111452_
             _shift111453_
             _dp111454_
             _h111455_
             _k111456_)
      (let* ((_fragment111458_
              (std/srfi/146/hamt#hash-fragment _shift111453_ _h111455_))
             (_mask111460_ (std/srfi/146/hamt#fragment->mask _fragment111458_))
             (_c111462_
              (##structure-ref _n111452_ '2 std/srfi/146/hamt#narrow '#f))
             (_l111464_
              (##structure-ref _n111452_ '3 std/srfi/146/hamt#narrow '#f))
             (_array111466_
              (##structure-ref _n111452_ '1 std/srfi/146/hamt#narrow '#f))
             (_payload?111468_
              (##structure-ref
               _hamt111451_
               '5
               std/srfi/146/hamt#hash-array-mapped-trie
               '#f))
             (_stride111470_ (std/srfi/146/hamt#leaf-stride _payload?111468_))
             (_leaf-index111472_
              (std/srfi/146/hamt#narrow-leaf-index
               _l111464_
               _mask111460_
               _payload?111468_))
             (_key111474_ (vector-ref _array111466_ _leaf-index111472_)))
        (if ((##structure-ref
              _hamt111451_
              '1
              std/srfi/146/hamt#hash-array-mapped-trie
              '#f)
             _k111456_
             _key111474_)
            (let* ((_existing111477_
                    (if _payload?111468_
                        (vector-ref _array111466_ (+ _leaf-index111472_ '1))
                        std/srfi/146/hamt#hamt-null))
                   (_d111479_ (_dp111454_ _existing111477_)))
              (if (std/srfi/146/hamt#hamt-null? _d111479_)
                  (values '-1
                          (let ((__tmp295493
                                 (std/srfi/146/vector-edit#vector-without
                                  _array111466_
                                  _leaf-index111472_
                                  (+ _leaf-index111472_ _stride111470_)))
                                (__tmp295492
                                 (std/srfi/151#copy-bit
                                  _fragment111458_
                                  _l111464_
                                  '#f)))
                            (declare (not safe))
                            (##structure
                             std/srfi/146/hamt#narrow
                             __tmp295493
                             _c111462_
                             __tmp295492)))
                  (if _payload?111468_
                      (values '0
                              (let ((__tmp295494
                                     (std/srfi/146/vector-edit#vector-replace-one
                                      _array111466_
                                      (+ _leaf-index111472_ '1)
                                      _d111479_)))
                                (declare (not safe))
                                (##structure
                                 std/srfi/146/hamt#narrow
                                 __tmp295494
                                 _c111462_
                                 _l111464_)))
                      (values '0 _n111452_))))
            (let ((_d111482_ (_dp111454_ std/srfi/146/hamt#hamt-null)))
              (if (std/srfi/146/hamt#hamt-null? _d111482_)
                  (values '0 _n111452_)
                  (std/srfi/146/hamt#add-narrow-leaf-key
                   _hamt111451_
                   _n111452_
                   _shift111453_
                   _d111482_
                   _h111455_
                   _k111456_)))))))
  (define std/srfi/146/hamt#add-narrow-leaf-key
    (lambda (_hamt111363_
             _n111364_
             _shift111365_
             _d111366_
             _h111367_
             _k111368_)
      (letrec* ((_payload?111370_
                 (##structure-ref
                  _hamt111363_
                  '5
                  std/srfi/146/hamt#hash-array-mapped-trie
                  '#f))
                (_make-entry111371_
                 (if _payload?111370_
                     cons
                     (lambda (_k111448_ _d111449_) _k111448_))))
        (let* ((_fragment111373_
                (std/srfi/146/hamt#hash-fragment _shift111365_ _h111367_))
               (_mask111375_
                (std/srfi/146/hamt#fragment->mask _fragment111373_))
               (_c111377_
                (##structure-ref _n111364_ '2 std/srfi/146/hamt#narrow '#f))
               (_l111379_
                (##structure-ref _n111364_ '3 std/srfi/146/hamt#narrow '#f))
               (_array111381_
                (##structure-ref _n111364_ '1 std/srfi/146/hamt#narrow '#f))
               (_payload?111383_
                (##structure-ref
                 _hamt111363_
                 '5
                 std/srfi/146/hamt#hash-array-mapped-trie
                 '#f))
               (_stride111385_
                (std/srfi/146/hamt#leaf-stride _payload?111383_))
               (_leaf-index111387_
                (std/srfi/146/hamt#narrow-leaf-index
                 _l111379_
                 _mask111375_
                 _payload?111383_))
               (_key111389_ (vector-ref _array111381_ _leaf-index111387_))
               (_child-index111391_
                (std/srfi/146/hamt#narrow-child-index
                 _l111379_
                 _c111377_
                 _mask111375_
                 _payload?111383_))
               (_hash111393_
                (std/srfi/146/hamt#hash-bits
                 (##structure-ref
                  _hamt111363_
                  '3
                  std/srfi/146/hamt#hash-array-mapped-trie
                  '#f)
                 _key111389_))
               (_datum111395_
                (if _payload?111383_
                    (vector-ref _array111381_ (+ _leaf-index111387_ '1))
                    '#f)))
          (values '1
                  (let ((__tmp295497
                         (if (= _h111367_ _hash111393_)
                             (let* ((_result111398_
                                     (make-vector
                                      (+ (vector-length _array111381_)
                                         (+ (- '0 _stride111385_) '1))))
                                    (_index111401_ _leaf-index111387_))
                               (vector-copy!
                                _result111398_
                                (+ '0 '0)
                                _array111381_
                                '0
                                _index111401_)
                               (let* ((_dropped111404_ _stride111385_)
                                      (_offset111407_
                                       (+ _index111401_ _dropped111404_))
                                      (_skew111410_ (- '0 _dropped111404_)))
                                 (let ((_index111414_ _child-index111391_))
                                   (vector-copy!
                                    _result111398_
                                    (+ _offset111407_ _skew111410_)
                                    _array111381_
                                    _offset111407_
                                    _index111414_)
                                   (vector-set!
                                    _result111398_
                                    (+ _skew111410_ _index111414_)
                                    (let ((__tmp295498
                                           (list (_make-entry111371_
                                                  _k111368_
                                                  _d111366_)
                                                 (_make-entry111371_
                                                  _key111389_
                                                  _datum111395_))))
                                      (declare (not safe))
                                      (##structure
                                       std/srfi/146/hamt#collision
                                       __tmp295498
                                       _h111367_)))
                                   (let* ((_skew111417_ (+ _skew111410_ '1))
                                          (_index111420_
                                           (vector-length _array111381_)))
                                     (vector-copy!
                                      _result111398_
                                      (+ _index111414_ _skew111417_)
                                      _array111381_
                                      _index111414_
                                      _index111420_)
                                     _result111398_))))
                             (let* ((_result111423_
                                     (make-vector
                                      (+ (vector-length _array111381_)
                                         (+ (- '0 _stride111385_) '1))))
                                    (_index111426_ _leaf-index111387_))
                               (vector-copy!
                                _result111423_
                                (+ '0 '0)
                                _array111381_
                                '0
                                _index111426_)
                               (let* ((_dropped111429_ _stride111385_)
                                      (_offset111432_
                                       (+ _index111426_ _dropped111429_))
                                      (_skew111435_ (- '0 _dropped111429_)))
                                 (let ((_index111439_ _child-index111391_))
                                   (vector-copy!
                                    _result111423_
                                    (+ _offset111432_ _skew111435_)
                                    _array111381_
                                    _offset111432_
                                    _index111439_)
                                   (vector-set!
                                    _result111423_
                                    (+ _skew111435_ _index111439_)
                                    (std/srfi/146/hamt#make-narrow-with-two-keys
                                     _payload?111383_
                                     (+ _shift111365_
                                        std/srfi/146/hamt#hamt-hash-slice-size)
                                     _h111367_
                                     _k111368_
                                     _d111366_
                                     _hash111393_
                                     _key111389_
                                     _datum111395_))
                                   (let* ((_skew111442_ (+ _skew111435_ '1))
                                          (_index111445_
                                           (vector-length _array111381_)))
                                     (vector-copy!
                                      _result111423_
                                      (+ _index111439_ _skew111442_)
                                      _array111381_
                                      _index111439_
                                      _index111445_)
                                     _result111423_))))))
                        (__tmp295496
                         (std/srfi/151#copy-bit
                          _fragment111373_
                          _c111377_
                          '#t))
                        (__tmp295495
                         (std/srfi/151#copy-bit
                          _fragment111373_
                          _l111379_
                          '#f)))
                    (declare (not safe))
                    (##structure
                     std/srfi/146/hamt#narrow
                     __tmp295497
                     __tmp295496
                     __tmp295495)))))))
  (define std/srfi/146/hamt#modify-narrow-new
    (lambda (_hamt111309_
             _n111310_
             _shift111311_
             _d111312_
             _h111313_
             _k111314_)
      (let* ((_fragment111316_
              (std/srfi/146/hamt#hash-fragment _shift111311_ _h111313_))
             (_mask111318_ (std/srfi/146/hamt#fragment->mask _fragment111316_))
             (_c111320_
              (##structure-ref _n111310_ '2 std/srfi/146/hamt#narrow '#f))
             (_l111322_
              (##structure-ref _n111310_ '3 std/srfi/146/hamt#narrow '#f))
             (_array111324_
              (##structure-ref _n111310_ '1 std/srfi/146/hamt#narrow '#f))
             (_payload?111326_
              (##structure-ref
               _hamt111309_
               '5
               std/srfi/146/hamt#hash-array-mapped-trie
               '#f))
             (_leaf-index111328_
              (std/srfi/146/hamt#narrow-leaf-index
               _l111322_
               _mask111318_
               _payload?111326_))
             (_delete?111330_ (std/srfi/146/hamt#hamt-null? _d111312_)))
        (values '1
                (let ((__tmp295500
                       (if _payload?111326_
                           (let* ((_result111333_
                                   (make-vector
                                    (+ (vector-length _array111324_)
                                       (+ (+ '0 '1) '1))))
                                  (_index111336_ _leaf-index111328_))
                             (vector-copy!
                              _result111333_
                              (+ '0 '0)
                              _array111324_
                              '0
                              _index111336_)
                             (vector-set!
                              _result111333_
                              (+ '0 _index111336_)
                              _k111314_)
                             (let* ((_skew111339_ (+ '0 '1))
                                    (_index111342_ _leaf-index111328_))
                               (vector-copy!
                                _result111333_
                                (+ _index111336_ _skew111339_)
                                _array111324_
                                _index111336_
                                _index111342_)
                               (vector-set!
                                _result111333_
                                (+ _skew111339_ _index111342_)
                                _d111312_)
                               (let* ((_skew111345_ (+ _skew111339_ '1))
                                      (_index111348_
                                       (vector-length _array111324_)))
                                 (vector-copy!
                                  _result111333_
                                  (+ _index111342_ _skew111345_)
                                  _array111324_
                                  _index111342_
                                  _index111348_)
                                 _result111333_)))
                           (let* ((_result111351_
                                   (make-vector
                                    (+ (vector-length _array111324_)
                                       (+ '0 '1))))
                                  (_index111354_ _leaf-index111328_))
                             (vector-copy!
                              _result111351_
                              (+ '0 '0)
                              _array111324_
                              '0
                              _index111354_)
                             (vector-set!
                              _result111351_
                              (+ '0 _index111354_)
                              _k111314_)
                             (let* ((_skew111357_ (+ '0 '1))
                                    (_index111360_
                                     (vector-length _array111324_)))
                               (vector-copy!
                                _result111351_
                                (+ _index111354_ _skew111357_)
                                _array111324_
                                _index111354_
                                _index111360_)
                               _result111351_))))
                      (__tmp295499
                       (std/srfi/151#copy-bit _fragment111316_ _l111322_ '#t)))
                  (declare (not safe))
                  (##structure
                   std/srfi/146/hamt#narrow
                   __tmp295500
                   _c111320_
                   __tmp295499))))))
  (define std/srfi/146/hamt#hamt-fetch
    (lambda (_hamt111262_ _key111263_)
      (let ((_h111265_
             (std/srfi/146/hamt#hash-bits
              (##structure-ref
               _hamt111262_
               '3
               std/srfi/146/hamt#hash-array-mapped-trie
               '#f)
              _key111263_))
            (_payload?111266_
             (##structure-ref
              _hamt111262_
              '5
              std/srfi/146/hamt#hash-array-mapped-trie
              '#f)))
        (let _descend111268_ ((_n111270_
                               (##structure-ref
                                _hamt111262_
                                '6
                                std/srfi/146/hamt#hash-array-mapped-trie
                                '#f))
                              (_shift111271_ '0))
          (if (let ()
                (declare (not safe))
                (##structure-instance-of?
                 _n111270_
                 'std/srfi/146/hamt#collision))
              (let ((_entries111273_
                     (##structure-ref
                      _n111270_
                      '1
                      std/srfi/146/hamt#collision
                      '#f))
                    (_key=111274_
                     (##structure-ref
                      _hamt111262_
                      '1
                      std/srfi/146/hamt#hash-array-mapped-trie
                      '#f)))
                (if _payload?111266_
                    (let ((_$e111276_
                           (assoc _key111263_ _entries111273_ _key=111274_)))
                      (if _$e111276_
                          (cdr _$e111276_)
                          std/srfi/146/hamt#hamt-null))
                    (if (std/srfi/1#find-tail
                         (lambda (_e111279_)
                           (_key=111274_ _key111263_ _e111279_))
                         _entries111273_)
                        'present
                        std/srfi/146/hamt#hamt-null)))
              (if (let ()
                    (declare (not safe))
                    (##structure-instance-of?
                     _n111270_
                     'std/srfi/146/hamt#narrow))
                  (let ((_array111281_
                         (##structure-ref
                          _n111270_
                          '1
                          std/srfi/146/hamt#narrow
                          '#f))
                        (_c111282_
                         (##structure-ref
                          _n111270_
                          '2
                          std/srfi/146/hamt#narrow
                          '#f))
                        (_l111283_
                         (##structure-ref
                          _n111270_
                          '3
                          std/srfi/146/hamt#narrow
                          '#f))
                        (_fragment111284_
                         (std/srfi/146/hamt#hash-fragment
                          _shift111271_
                          _h111265_)))
                    (if (bit-set? _fragment111284_ _c111282_)
                        (let* ((_mask111286_
                                (std/srfi/146/hamt#fragment->mask
                                 _fragment111284_))
                               (_child-index111288_
                                (std/srfi/146/hamt#narrow-child-index
                                 _l111283_
                                 _c111282_
                                 _mask111286_
                                 (##structure-ref
                                  _hamt111262_
                                  '5
                                  std/srfi/146/hamt#hash-array-mapped-trie
                                  '#f))))
                          (_descend111268_
                           (vector-ref _array111281_ _child-index111288_)
                           (+ _shift111271_
                              std/srfi/146/hamt#hamt-hash-slice-size)))
                        (if (bit-set? _fragment111284_ _l111283_)
                            (let* ((_mask111291_
                                    (std/srfi/146/hamt#fragment->mask
                                     _fragment111284_))
                                   (_leaf-index111293_
                                    (std/srfi/146/hamt#narrow-leaf-index
                                     _l111283_
                                     _mask111291_
                                     (##structure-ref
                                      _hamt111262_
                                      '5
                                      std/srfi/146/hamt#hash-array-mapped-trie
                                      '#f)))
                                   (_k111295_
                                    (vector-ref
                                     _array111281_
                                     _leaf-index111293_)))
                              (if ((##structure-ref
                                    _hamt111262_
                                    '1
                                    std/srfi/146/hamt#hash-array-mapped-trie
                                    '#f)
                                   _k111295_
                                   _key111263_)
                                  (if _payload?111266_
                                      (vector-ref
                                       _array111281_
                                       (+ _leaf-index111293_ '1))
                                      'present)
                                  std/srfi/146/hamt#hamt-null))
                            std/srfi/146/hamt#hamt-null)))
                  (if (let ()
                        (declare (not safe))
                        (##structure-instance-of?
                         _n111270_
                         'std/srfi/146/hamt#wide))
                      (let ((_array111298_
                             (##structure-ref
                              _n111270_
                              '1
                              std/srfi/146/hamt#wide
                              '#f))
                            (_stride111299_
                             (std/srfi/146/hamt#leaf-stride
                              (##structure-ref
                               _hamt111262_
                               '5
                               std/srfi/146/hamt#hash-array-mapped-trie
                               '#f)))
                            (_c111300_
                             (##structure-ref
                              _n111270_
                              '2
                              std/srfi/146/hamt#wide
                              '#f))
                            (_l111301_
                             (##structure-ref
                              _n111270_
                              '3
                              std/srfi/146/hamt#wide
                              '#f))
                            (_i111302_
                             (std/srfi/146/hamt#hash-fragment
                              _shift111271_
                              _h111265_)))
                        (if (bit-set? _i111302_ _c111300_)
                            (_descend111268_
                             (vector-ref
                              _array111298_
                              (* _stride111299_ _i111302_))
                             (+ _shift111271_
                                std/srfi/146/hamt#hamt-hash-slice-size))
                            (if (bit-set? _i111302_ _l111301_)
                                (let* ((_j111304_ (* _stride111299_ _i111302_))
                                       (_k111306_
                                        (vector-ref _array111298_ _j111304_)))
                                  (if ((##structure-ref
                                        _hamt111262_
                                        '1
                                        std/srfi/146/hamt#hash-array-mapped-trie
                                        '#f)
                                       _k111306_
                                       _key111263_)
                                      (if _payload?111266_
                                          (vector-ref
                                           _array111298_
                                           (+ _j111304_ '1))
                                          'present)
                                      std/srfi/146/hamt#hamt-null))
                                std/srfi/146/hamt#hamt-null)))
                      (error '"Unexpected type of child node."))))))))
  (define std/srfi/146/hamt#collision/for-each
    (lambda (_procedure111242_ _node111243_ _payload?111244_)
      (if _payload?111244_
          (let _$loop111246_ ((_remaining111249_
                               (##structure-ref
                                _node111243_
                                '1
                                std/srfi/146/hamt#collision
                                '#f)))
            (if (null? _remaining111249_)
                '#!void
                (begin
                  (let ((_e111252_ (car _remaining111249_)))
                    (_procedure111242_ (car _e111252_) (cdr _e111252_)))
                  (_$loop111246_ (cdr _remaining111249_)))))
          (let _$loop111254_ ((_remaining111257_
                               (##structure-ref
                                _node111243_
                                '1
                                std/srfi/146/hamt#collision
                                '#f)))
            (if (null? _remaining111257_)
                '#!void
                (begin
                  (let ((_e111260_ (car _remaining111257_)))
                    (_procedure111242_ _e111260_ '#f))
                  (_$loop111254_ (cdr _remaining111257_))))))))
  (define std/srfi/146/hamt#narrow/for-each
    (lambda (_procedure111210_ _node111211_ _payload?111212_)
      (let ((_array111214_
             (##structure-ref _node111211_ '1 std/srfi/146/hamt#narrow '#f))
            (_stride111215_ (std/srfi/146/hamt#leaf-stride _payload?111212_))
            (_c111216_
             (##structure-ref _node111211_ '2 std/srfi/146/hamt#narrow '#f))
            (_l111217_
             (##structure-ref _node111211_ '3 std/srfi/146/hamt#narrow '#f)))
        (let _next-leaf111219_ ((_count111221_ '0) (_start111222_ '0))
          (let ((_i111224_
                 (std/srfi/146/hamt#next-set-bit
                  _l111217_
                  _start111222_
                  std/srfi/146/hamt#hamt-bucket-size)))
            (if _i111224_
                (let* ((_j111226_ (* _stride111215_ _count111221_))
                       (_k111228_ (vector-ref _array111214_ _j111226_))
                       (_d111230_
                        (if _payload?111212_
                            (vector-ref _array111214_ (+ _j111226_ '1))
                            '#f)))
                  (_procedure111210_ _k111228_ _d111230_)
                  (_next-leaf111219_ (+ _count111221_ '1) (+ _i111224_ '1)))
                (let _next-child111233_ ((_start111235_ '0)
                                         (_offset111236_
                                          (* _stride111215_ _count111221_)))
                  (let ((_i111238_
                         (std/srfi/146/hamt#next-set-bit
                          _c111216_
                          _start111235_
                          std/srfi/146/hamt#hamt-bucket-size)))
                    (if _i111238_
                        (let ((_child111240_
                               (vector-ref _array111214_ _offset111236_)))
                          (std/srfi/146/hamt#hamt-node/for-each
                           _child111240_
                           _payload?111212_
                           _procedure111210_)
                          (_next-child111233_
                           (+ _i111238_ '1)
                           (+ _offset111236_ '1)))
                        '#!void)))))))))
  (define std/srfi/146/hamt#wide/for-each
    (lambda (_procedure111189_ _node111190_ _payload?111191_)
      (let ((_array111193_
             (##structure-ref _node111190_ '1 std/srfi/146/hamt#wide '#f))
            (_stride111194_ (std/srfi/146/hamt#leaf-stride _payload?111191_))
            (_c111195_
             (##structure-ref _node111190_ '2 std/srfi/146/hamt#wide '#f))
            (_l111196_
             (##structure-ref _node111190_ '3 std/srfi/146/hamt#wide '#f)))
        (let _$loop111198_ ((_i111201_ '0))
          (if (= _i111201_ std/srfi/146/hamt#hamt-bucket-size)
              '#!void
              (begin
                (let ((_j111203_ (* _stride111194_ _i111201_)))
                  (if (bit-set? _i111201_ _l111196_)
                      (let ((_k111205_ (vector-ref _array111193_ _j111203_))
                            (_d111206_
                             (if _payload?111191_
                                 (vector-ref _array111193_ (+ _j111203_ '1))
                                 '#f)))
                        (_procedure111189_ _k111205_ _d111206_))
                      (if (bit-set? _i111201_ _c111195_)
                          (let ((_child111208_
                                 (vector-ref _array111193_ _j111203_)))
                            (std/srfi/146/hamt#hamt-node/for-each
                             _child111208_
                             _payload?111191_
                             _procedure111189_))
                          '#!void)))
                (_$loop111198_ (+ _i111201_ '1))))))))
  (define std/srfi/146/hamt#hamt-node/for-each
    (lambda (_node111185_ _payload?111186_ _procedure111187_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of?
             _node111185_
             'std/srfi/146/hamt#collision))
          (std/srfi/146/hamt#collision/for-each
           _procedure111187_
           _node111185_
           _payload?111186_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of?
                 _node111185_
                 'std/srfi/146/hamt#narrow))
              (std/srfi/146/hamt#narrow/for-each
               _procedure111187_
               _node111185_
               _payload?111186_)
              (if (let ()
                    (declare (not safe))
                    (##structure-instance-of?
                     _node111185_
                     'std/srfi/146/hamt#wide))
                  (std/srfi/146/hamt#wide/for-each
                   _procedure111187_
                   _node111185_
                   _payload?111186_)
                  (error '"Invalid type of node." _node111185_))))))
  (define std/srfi/146/hamt#hamt/for-each
    (lambda (_procedure111182_ _hamt111183_)
      (std/srfi/146/hamt#hamt-node/for-each
       (##structure-ref
        _hamt111183_
        '6
        std/srfi/146/hamt#hash-array-mapped-trie
        '#f)
       (##structure-ref
        _hamt111183_
        '5
        std/srfi/146/hamt#hash-array-mapped-trie
        '#f)
       _procedure111182_)))
  (define std/srfi/146/hamt#hamt->list
    (lambda (_hamt111174_ _procedure111175_)
      (let ((_accumulator111177_ '()))
        (std/srfi/146/hamt#hamt/for-each
         (lambda (_k111179_ _v111180_)
           (set! _accumulator111177_
                 (cons (_procedure111175_ _k111179_ _v111180_)
                       _accumulator111177_)))
         _hamt111174_)
        _accumulator111177_)))
  (define std/srfi/146/hamt#assert-collision-valid
    (lambda (_node111156_ _hp111157_ _payload?111158_)
      (let ((_entries111162_
             (##structure-ref _node111156_ '1 std/srfi/146/hamt#collision '#f))
            (_hash111163_
             (##structure-ref _node111156_ '2 std/srfi/146/hamt#collision '#f))
            (_extract111164_
             (if _payload?111158_ car (lambda (_x111160_) _x111160_))))
        (let _$loop111166_ ((_remaining111169_ _entries111162_))
          (if (null? _remaining111169_)
              '#!void
              (begin
                (let ((_a111172_ (car _remaining111169_)))
                  (if (= _hash111163_
                         (std/srfi/146/hamt#hash-bits
                          _hp111157_
                          (_extract111164_ _a111172_)))
                      '#!void
                      (error '"Assertion failed:"
                             '(= hash (hash-bits hp (extract a)))
                             (list '=
                                   _hash111163_
                                   (std/srfi/146/hamt#hash-bits
                                    _hp111157_
                                    (_extract111164_ _a111172_))))))
                (_$loop111166_ (cdr _remaining111169_)))))
        (if _payload?111158_ (map car _entries111162_) _entries111162_))))
  (define std/srfi/146/hamt#assert-narrow-valid
    (lambda (_node111119_ _hp111120_ _payload?111121_ _shift111122_)
      (let ((_array111124_
             (##structure-ref _node111119_ '1 std/srfi/146/hamt#narrow '#f))
            (_stride111125_ (std/srfi/146/hamt#leaf-stride _payload?111121_))
            (_c111126_
             (##structure-ref _node111119_ '2 std/srfi/146/hamt#narrow '#f))
            (_l111127_
             (##structure-ref _node111119_ '3 std/srfi/146/hamt#narrow '#f)))
        (if (zero? (bitwise-and _c111126_ _l111127_))
            '#!void
            (error '"Assertion failed:"
                   '(zero? (bitwise-and c l))
                   (list 'zero? (bitwise-and _c111126_ _l111127_))))
        (let _next-leaf111129_ ((_count111131_ '0)
                                (_i111132_ '0)
                                (_keys111133_ '()))
          (if (< _i111132_ std/srfi/146/hamt#hamt-bucket-size)
              (if (bit-set? _i111132_ _l111127_)
                  (let ((_k111135_
                         (vector-ref
                          _array111124_
                          (* _stride111125_ _count111131_))))
                    (if (= _i111132_
                           (std/srfi/146/hamt#hash-fragment
                            _shift111122_
                            (std/srfi/146/hamt#hash-bits
                             _hp111120_
                             _k111135_)))
                        '#!void
                        (error '"Assertion failed:"
                               '(= i (hash-fragment shift (hash-bits hp k)))
                               (list '=
                                     _i111132_
                                     (std/srfi/146/hamt#hash-fragment
                                      _shift111122_
                                      (std/srfi/146/hamt#hash-bits
                                       _hp111120_
                                       _k111135_)))))
                    (_next-leaf111129_
                     (+ _count111131_ '1)
                     (+ _i111132_ '1)
                     (cons _k111135_ _keys111133_)))
                  (_next-leaf111129_
                   _count111131_
                   (+ _i111132_ '1)
                   _keys111133_))
              (let _next-child111137_ ((_i111139_ '0)
                                       (_key-groups111140_ (list _keys111133_))
                                       (_offset111141_
                                        (* _stride111125_ _count111131_)))
                (if (= _i111139_ std/srfi/146/hamt#hamt-bucket-size)
                    (apply append _key-groups111140_)
                    (if (bit-set? _i111139_ _c111126_)
                        (let* ((_child111143_
                                (vector-ref _array111124_ _offset111141_))
                               (_child-keys111145_
                                (std/srfi/146/hamt#assert-hamt-node-valid
                                 _child111143_
                                 _hp111120_
                                 _payload?111121_
                                 (+ _shift111122_
                                    std/srfi/146/hamt#hamt-hash-slice-size))))
                          (let _$loop111148_ ((_remaining111151_
                                               _child-keys111145_))
                            (if (null? _remaining111151_)
                                '#!void
                                (begin
                                  (let ((_k111154_ (car _remaining111151_)))
                                    (if (= _i111139_
                                           (std/srfi/146/hamt#hash-fragment
                                            _shift111122_
                                            (std/srfi/146/hamt#hash-bits
                                             _hp111120_
                                             _k111154_)))
                                        '#!void
                                        (error '"Assertion failed:"
                                               '(= i
                                                   (hash-fragment
                                                    shift
                                                    (hash-bits hp k)))
                                               (list '=
                                                     _i111139_
                                                     (std/srfi/146/hamt#hash-fragment
                                                      _shift111122_
                                                      (std/srfi/146/hamt#hash-bits
                                                       _hp111120_
                                                       _k111154_))))))
                                  (_$loop111148_ (cdr _remaining111151_)))))
                          (_next-child111137_
                           (+ _i111139_ '1)
                           (cons _child-keys111145_ _key-groups111140_)
                           (+ _offset111141_ '1)))
                        (_next-child111137_
                         (+ _i111139_ '1)
                         _key-groups111140_
                         _offset111141_)))))))))
  (define std/srfi/146/hamt#assert-wide-valid
    (lambda (_node111087_ _hp111088_ _payload?111089_ _shift111090_)
      (let ((_array111092_
             (##structure-ref _node111087_ '1 std/srfi/146/hamt#wide '#f))
            (_stride111093_ (std/srfi/146/hamt#leaf-stride _payload?111089_))
            (_c111094_
             (##structure-ref _node111087_ '2 std/srfi/146/hamt#wide '#f))
            (_l111095_
             (##structure-ref _node111087_ '3 std/srfi/146/hamt#wide '#f)))
        (if (zero? (bitwise-and _c111094_ _l111095_))
            '#!void
            (error '"Assertion failed:"
                   '(zero? (bitwise-and c l))
                   (list 'zero? (bitwise-and _c111094_ _l111095_))))
        (let _next-fragment111097_ ((_i111099_ '0) (_key-groups111100_ '()))
          (if (= _i111099_ std/srfi/146/hamt#hamt-bucket-size)
              (apply append _key-groups111100_)
              (let ((_j111102_ (* _stride111093_ _i111099_)))
                (if (bit-set? _i111099_ _l111095_)
                    (let ((_k111104_ (vector-ref _array111092_ _j111102_)))
                      (if (= _i111099_
                             (std/srfi/146/hamt#hash-fragment
                              _shift111090_
                              (std/srfi/146/hamt#hash-bits
                               _hp111088_
                               _k111104_)))
                          '#!void
                          (error '"Assertion failed:"
                                 '(= i (hash-fragment shift (hash-bits hp k)))
                                 (list '=
                                       _i111099_
                                       (std/srfi/146/hamt#hash-fragment
                                        _shift111090_
                                        (std/srfi/146/hamt#hash-bits
                                         _hp111088_
                                         _k111104_)))))
                      (_next-fragment111097_
                       (+ _i111099_ '1)
                       (cons (list _k111104_) _key-groups111100_)))
                    (if (bit-set? _i111099_ _c111094_)
                        (let* ((_child111106_
                                (vector-ref _array111092_ _j111102_))
                               (_child-keys111108_
                                (std/srfi/146/hamt#assert-hamt-node-valid
                                 _child111106_
                                 _hp111088_
                                 _payload?111089_
                                 (+ _shift111090_
                                    std/srfi/146/hamt#hamt-hash-slice-size))))
                          (let _$loop111111_ ((_remaining111114_
                                               _child-keys111108_))
                            (if (null? _remaining111114_)
                                '#!void
                                (begin
                                  (let ((_k111117_ (car _remaining111114_)))
                                    (if (= _i111099_
                                           (std/srfi/146/hamt#hash-fragment
                                            _shift111090_
                                            (std/srfi/146/hamt#hash-bits
                                             _hp111088_
                                             _k111117_)))
                                        '#!void
                                        (error '"Assertion failed:"
                                               '(= i
                                                   (hash-fragment
                                                    shift
                                                    (hash-bits hp k)))
                                               (list '=
                                                     _i111099_
                                                     (std/srfi/146/hamt#hash-fragment
                                                      _shift111090_
                                                      (std/srfi/146/hamt#hash-bits
                                                       _hp111088_
                                                       _k111117_))))))
                                  (_$loop111111_ (cdr _remaining111114_)))))
                          (_next-fragment111097_
                           (+ _i111099_ '1)
                           (cons _child-keys111108_ _key-groups111100_)))
                        (begin
                          (if (not (vector-ref _array111092_ _j111102_))
                              '#!void
                              (error '"Assertion failed:"
                                     '(not (vector-ref array j))
                                     (list 'not
                                           (vector-ref
                                            _array111092_
                                            _j111102_))))
                          (if _payload?111089_
                              (if (not (vector-ref
                                        _array111092_
                                        (+ _j111102_ '1)))
                                  '#!void
                                  (error '"Assertion failed:"
                                         '(not (vector-ref array (+ j 1)))
                                         (list 'not
                                               (vector-ref
                                                _array111092_
                                                (+ _j111102_ '1)))))
                              '#!void)
                          (_next-fragment111097_
                           (+ _i111099_ '1)
                           _key-groups111100_))))))))))
  (define std/srfi/146/hamt#assert-hamt-node-valid
    (lambda (_node111082_ _hp111083_ _payload?111084_ _shift111085_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of?
             _node111082_
             'std/srfi/146/hamt#collision))
          (std/srfi/146/hamt#assert-collision-valid
           _node111082_
           _hp111083_
           _payload?111084_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of?
                 _node111082_
                 'std/srfi/146/hamt#narrow))
              (std/srfi/146/hamt#assert-narrow-valid
               _node111082_
               _hp111083_
               _payload?111084_
               _shift111085_)
              (if (let ()
                    (declare (not safe))
                    (##structure-instance-of?
                     _node111082_
                     'std/srfi/146/hamt#wide))
                  (std/srfi/146/hamt#assert-wide-valid
                   _node111082_
                   _hp111083_
                   _payload?111084_
                   _shift111085_)
                  (error '"Invalid type of node." _node111082_))))))
  (define std/srfi/146/hamt#assert-hamt-valid
    (lambda (_hamt111073_)
      (let ((_hp111075_
             (##structure-ref
              _hamt111073_
              '3
              std/srfi/146/hamt#hash-array-mapped-trie
              '#f)))
        (if (procedure?
             (##structure-ref
              _hamt111073_
              '1
              std/srfi/146/hamt#hash-array-mapped-trie
              '#f))
            '#!void
            (error '"Assertion failed:"
                   '(procedure? (hamt/= hamt))
                   (list 'procedure?
                         (##structure-ref
                          _hamt111073_
                          '1
                          std/srfi/146/hamt#hash-array-mapped-trie
                          '#f))))
        (if (procedure? _hp111075_)
            '#!void
            (error '"Assertion failed:"
                   '(procedure? hp)
                   (list 'procedure? _hp111075_)))
        (if (memq (##structure-ref
                   _hamt111073_
                   '4
                   std/srfi/146/hamt#hash-array-mapped-trie
                   '#f)
                  '(#t #f))
            '#!void
            (error '"Assertion failed:"
                   '(memq (hamt/mutable? hamt) '(#t #f))
                   (list 'memq
                         (##structure-ref
                          _hamt111073_
                          '4
                          std/srfi/146/hamt#hash-array-mapped-trie
                          '#f)
                         '(#t #f))))
        (let* ((_payload?111077_
                (##structure-ref
                 _hamt111073_
                 '5
                 std/srfi/146/hamt#hash-array-mapped-trie
                 '#f))
               (_keys111079_
                (std/srfi/146/hamt#assert-hamt-node-valid
                 (##structure-ref
                  _hamt111073_
                  '6
                  std/srfi/146/hamt#hash-array-mapped-trie
                  '#f)
                 _hp111075_
                 _payload?111077_
                 '0)))
          (if (= (##structure-ref
                  _hamt111073_
                  '2
                  std/srfi/146/hamt#hash-array-mapped-trie
                  '#f)
                 (length _keys111079_))
              '#!void
              (error '"Assertion failed:"
                     '(= (hamt/count hamt) (length keys))
                     (list '=
                           (##structure-ref
                            _hamt111073_
                            '2
                            std/srfi/146/hamt#hash-array-mapped-trie
                            '#f)
                           (length _keys111079_)))))))))
