(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/151#bitwise-nand
    (lambda (_i105651_ _j105652_)
      (bitwise-not (bitwise-and _i105651_ _j105652_))))
  (define std/srfi/151#bitwise-nor
    (lambda (_i105648_ _j105649_)
      (bitwise-not (bitwise-ior _i105648_ _j105649_))))
  (define std/srfi/151#bitwise-andc1
    (lambda (_i105645_ _j105646_)
      (bitwise-and (bitwise-not _i105645_) _j105646_)))
  (define std/srfi/151#bitwise-andc2
    (lambda (_i105642_ _j105643_)
      (bitwise-and _i105642_ (bitwise-not _j105643_))))
  (define std/srfi/151#bitwise-orc1
    (lambda (_i105639_ _j105640_)
      (bitwise-ior (bitwise-not _i105639_) _j105640_)))
  (define std/srfi/151#bitwise-orc2
    (lambda (_i105636_ _j105637_)
      (bitwise-ior _i105636_ (bitwise-not _j105637_))))
  (define std/srfi/151#bitwise-eqv
    (lambda _args105629_
      (let _lp105631_ ((_args105633_ _args105629_) (_ans105634_ '-1))
        (if (pair? _args105633_)
            (_lp105631_
             (cdr _args105633_)
             (bitwise-not (bitwise-xor _ans105634_ (car _args105633_))))
            _ans105634_))))
  (define std/srfi/151#mask
    (lambda (_start105626_ _end105627_)
      (bitwise-not (arithmetic-shift '-1 (- _end105627_ _start105626_)))))
  (define std/srfi/151#any-bit-set?
    (lambda (_test-bits105623_ _n105624_)
      (not (zero? (bitwise-and _test-bits105623_ _n105624_)))))
  (define std/srfi/151#every-bit-set?
    (lambda (_test-bits105620_ _n105621_)
      (= _test-bits105620_ (bitwise-and _test-bits105620_ _n105621_))))
  (define std/srfi/151#bit-field
    (lambda (_n105616_ _start105617_ _end105618_)
      (bitwise-and
       (std/srfi/151#mask _start105617_ _end105618_)
       (arithmetic-shift _n105616_ (- _start105617_)))))
  (define std/srfi/151#bit-field-any?
    (lambda (_n105612_ _start105613_ _end105614_)
      (not (zero? (bitwise-and
                   (arithmetic-shift _n105612_ (- _start105613_))
                   (std/srfi/151#mask _start105613_ _end105614_))))))
  (define std/srfi/151#bit-field-every?
    (lambda (_n105606_ _start105607_ _end105608_)
      (let ((_m105610_ (std/srfi/151#mask _start105607_ _end105608_)))
        (eqv? _m105610_
              (bitwise-and
               (arithmetic-shift _n105606_ (- _start105607_))
               _m105610_)))))
  (define std/srfi/151#bit-field-clear
    (lambda (_n105602_ _start105603_ _end105604_)
      (std/srfi/151#bit-field-replace _n105602_ '0 _start105603_ _end105604_)))
  (define std/srfi/151#bit-field-set
    (lambda (_n105598_ _start105599_ _end105600_)
      (std/srfi/151#bit-field-replace
       _n105598_
       '-1
       _start105599_
       _end105600_)))
  (define std/srfi/151#bit-field-replace
    (lambda (_n105591_ _newfield105592_ _start105593_ _end105594_)
      (let ((_m105596_ (std/srfi/151#mask _start105593_ _end105594_)))
        (bitwise-ior
         (bitwise-and
          _n105591_
          (bitwise-not (arithmetic-shift _m105596_ _start105593_)))
         (arithmetic-shift
          (bitwise-and _newfield105592_ _m105596_)
          _start105593_)))))
  (define std/srfi/151#bit-field-replace-same
    (lambda (_to105586_ _from105587_ _start105588_ _end105589_)
      (std/srfi/151#bitwise-if
       (arithmetic-shift
        (std/srfi/151#mask _start105588_ _end105589_)
        _start105588_)
       _from105587_
       _to105586_)))
  (define std/srfi/151#bit-field-rotate
    (lambda (_n105575_ _count105576_ _start105577_ _end105578_)
      (letrec* ((_width105580_ (- _end105578_ _start105577_)))
        (set! _count105576_ (modulo _count105576_ _width105580_))
        (let ((_mask105582_
               (bitwise-not (arithmetic-shift '-1 _width105580_))))
          (letrec* ((_zn105584_
                     (bitwise-and
                      _mask105582_
                      (arithmetic-shift _n105575_ (- _start105577_)))))
            (bitwise-ior
             (arithmetic-shift
              (bitwise-ior
               (bitwise-and
                _mask105582_
                (arithmetic-shift _zn105584_ _count105576_))
               (arithmetic-shift _zn105584_ (- _count105576_ _width105580_)))
              _start105577_)
             (bitwise-and
              (bitwise-not (arithmetic-shift _mask105582_ _start105577_))
              _n105575_)))))))
  (define std/srfi/151#bit-reverse
    (lambda (_k105565_ _n105566_)
      (let _$loop105568_ ((_m105571_
                           (if (negative? _n105566_)
                               (bitwise-not _n105566_)
                               _n105566_))
                          (_k105572_ (+ '-1 _k105565_))
                          (_rvs105573_ '0))
        (if (negative? _k105572_)
            (if (negative? _n105566_) (bitwise-not _rvs105573_) _rvs105573_)
            (_$loop105568_
             (arithmetic-shift _m105571_ '-1)
             (+ '-1 _k105572_)
             (bitwise-ior
              (arithmetic-shift _rvs105573_ '1)
              (bitwise-and '1 _m105571_)))))))
  (define std/srfi/151#bit-field-reverse
    (lambda (_n105555_ _start105556_ _end105557_)
      (letrec* ((_width105559_ (- _end105557_ _start105556_)))
        (let ((_mask105561_
               (bitwise-not (arithmetic-shift '-1 _width105559_))))
          (letrec* ((_zn105563_
                     (bitwise-and
                      _mask105561_
                      (arithmetic-shift _n105555_ (- _start105556_)))))
            (bitwise-ior
             (arithmetic-shift
              (std/srfi/151#bit-reverse _width105559_ _zn105563_)
              _start105556_)
             (bitwise-and
              (bitwise-not (arithmetic-shift _mask105561_ _start105556_))
              _n105555_)))))))
  (define std/srfi/151#copy-bit
    (lambda (_index105551_ _to105552_ _bool105553_)
      (if _bool105553_
          (bitwise-ior _to105552_ (arithmetic-shift '1 _index105551_))
          (bitwise-and
           _to105552_
           (bitwise-not (arithmetic-shift '1 _index105551_))))))
  (define std/srfi/151#bits->list
    (lambda (_k105535_ . _len105536_)
      (if (null? _len105536_)
          (let _$loop105538_ ((_k105541_ _k105535_) (_lst105542_ '()))
            (if (<= _k105541_ '0)
                (reverse _lst105542_)
                (_$loop105538_
                 (arithmetic-shift _k105541_ '-1)
                 (cons (odd? _k105541_) _lst105542_))))
          (let _$loop105544_ ((_idx105547_ (+ '-1 (car _len105536_)))
                              (_k105548_ _k105535_)
                              (_lst105549_ '()))
            (if (negative? _idx105547_)
                (reverse _lst105549_)
                (_$loop105544_
                 (+ '-1 _idx105547_)
                 (arithmetic-shift _k105548_ '-1)
                 (cons (odd? _k105548_) _lst105549_)))))))
  (define std/srfi/151#list->bits
    (lambda (_bools105527_)
      (let _$loop105529_ ((_bs105532_ (reverse _bools105527_))
                          (_acc105533_ '0))
        (if (null? _bs105532_)
            _acc105533_
            (_$loop105529_
             (cdr _bs105532_)
             (+ _acc105533_ _acc105533_ (if (car _bs105532_) '1 '0)))))))
  (define std/srfi/151#bits
    (lambda _bools105525_ (std/srfi/151#list->bits _bools105525_)))
  (define std/srfi/151#bitwise-if
    (lambda (_mask105521_ _n0105522_ _n1105523_)
      (bitwise-ior
       (bitwise-and _mask105521_ _n0105522_)
       (bitwise-and (bitwise-not _mask105521_) _n1105523_))))
  (define std/srfi/151#bits->vector__0
    (lambda (_i105516_) (list->vector (std/srfi/151#bits->list _i105516_))))
  (define std/srfi/151#bits->vector__1
    (lambda (_i105518_ _len105519_)
      (list->vector (std/srfi/151#bits->list _i105518_ _len105519_))))
  (define std/srfi/151#bits->vector
    (lambda _g289704_
      (let ((_g289703_ (let () (declare (not safe)) (##length _g289704_))))
        (cond ((let () (declare (not safe)) (##fx= _g289703_ 1))
               (apply std/srfi/151#bits->vector__0 _g289704_))
              ((let () (declare (not safe)) (##fx= _g289703_ 2))
               (apply std/srfi/151#bits->vector__1 _g289704_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/151#bits->vector
                _g289704_))))))
  (define std/srfi/151#vector->bits
    (lambda (_vector105514_)
      (std/srfi/151#list->bits (vector->list _vector105514_))))
  (define std/srfi/151#bit-swap
    (lambda (_n1105507_ _n2105508_ _i105509_)
      (let ((_n1-bit105511_ (bit-set? _n1105507_ _i105509_))
            (_n2-bit105512_ (bit-set? _n2105508_ _i105509_)))
        (std/srfi/151#copy-bit
         _n2105508_
         (std/srfi/151#copy-bit _n1105507_ _i105509_ _n2-bit105512_)
         _n1-bit105511_))))
  (define std/srfi/151#bitwise-fold
    (lambda (_proc105496_ _seed105497_ _i105498_)
      (let ((_len105500_ (integer-length _i105498_)))
        (let _loop105502_ ((_n105504_ '0) (_r105505_ _seed105497_))
          (if (= _n105504_ _len105500_)
              _r105505_
              (_loop105502_
               (+ _n105504_ '1)
               (_proc105496_ (bit-set? _n105504_ _i105498_) _r105505_)))))))
  (define std/srfi/151#bitwise-for-each
    (lambda (_proc105487_ _i105488_)
      (let ((_len105490_ (integer-length _i105488_)))
        (let _loop105492_ ((_n105494_ '0))
          (if (< _n105494_ _len105490_)
              (begin
                (_proc105487_ (bit-set? _n105494_ _i105488_))
                (_loop105492_ (+ _n105494_ '1)))
              '#!void)))))
  (define std/srfi/151#bitwise-unfold
    (lambda (_stop?105476_ _mapper105477_ _successor105478_ _seed105479_)
      (let _loop105481_ ((_n105483_ '0)
                         (_result105484_ '0)
                         (_state105485_ _seed105479_))
        (if (_stop?105476_ _state105485_)
            _result105484_
            (_loop105481_
             (+ _n105483_ '1)
             (std/srfi/151#copy-bit
              _n105483_
              _result105484_
              (_mapper105477_ _state105485_))
             (_successor105478_ _state105485_))))))
  (define std/srfi/151#make-bitwise-generator
    (lambda (_i105471_)
      (lambda ()
        (let ((_bit105474_ (bit-set? '0 _i105471_)))
          (set! _i105471_ (arithmetic-shift _i105471_ '-1))
          _bit105474_)))))
