(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/160/c64#c64vector-unfold
    (lambda (_f150215_ _len150217_ _seed150219_)
      (declare (not safe))
      (begin
        (if (procedure? _f150215_)
            '#!void
            (error '"Bad argument; expected procedure" _f150215_))
        (let ((_v150223_
               (let ((__obj299404
                      (make-object std/srfi/160/cvector#c64vector::t '1)))
                 (std/srfi/160/cvector#c64vector:::init!__0
                  __obj299404
                  _len150217_)
                 __obj299404)))
          (let _lp150226_ ((_i150229_ '0) (_state150231_ _seed150219_))
            (if (fx< _i150229_ _len150217_)
                (let ((_g299421_ (_f150215_ _i150229_ _state150231_)))
                  (begin
                    (let ((_g299422_
                           (if (##values? _g299421_)
                               (##vector-length _g299421_)
                               1)))
                      (if (not (##fx= _g299422_ 2))
                          (error "Context expects 2 values" _g299422_)))
                    (let ((_x150234_ (##vector-ref _g299421_ 0))
                          (_state150236_ (##vector-ref _g299421_ 1)))
                      (begin
                        (if (std/srfi/160/base#c64? _x150234_)
                            '#!void
                            (error '"Bad generated value" _x150234_))
                        (std/srfi/160/cvector#c64vector-set!
                         _v150223_
                         _i150229_
                         _x150234_)
                        (_lp150226_ (fx+ _i150229_ '1) _state150236_)))))
                _v150223_))))))
  (define std/srfi/160/c64#c64vector-unfold-right
    (lambda (_f150192_ _len150194_ _seed150196_)
      (declare (not safe))
      (begin
        (if (procedure? _f150192_)
            '#!void
            (error '"Bad argument; expected procedure" _f150192_))
        (let ((_v150200_
               (let ((__obj299405
                      (make-object std/srfi/160/cvector#c64vector::t '1)))
                 (std/srfi/160/cvector#c64vector:::init!__0
                  __obj299405
                  _len150194_)
                 __obj299405)))
          (let _lp150203_ ((_i150206_ (fx- _len150194_ '1))
                           (_state150208_ _seed150196_))
            (if (fx>= _i150206_ '0)
                (let ((_g299423_ (_f150192_ _i150206_ _state150208_)))
                  (begin
                    (let ((_g299424_
                           (if (##values? _g299423_)
                               (##vector-length _g299423_)
                               1)))
                      (if (not (##fx= _g299424_ 2))
                          (error "Context expects 2 values" _g299424_)))
                    (let ((_x150211_ (##vector-ref _g299423_ 0))
                          (_state150213_ (##vector-ref _g299423_ 1)))
                      (begin
                        (if (std/srfi/160/base#c64? _x150211_)
                            '#!void
                            (error '"Bad generated value" _x150211_))
                        (std/srfi/160/cvector#c64vector-set!
                         _v150200_
                         _i150206_
                         _x150211_)
                        (_lp150203_ (fx- _i150206_ '1) _state150213_)))))
                _v150200_))))))
  (define std/srfi/160/c64#c64vector-copy__%
    (lambda (_vec150164_ _start150166_ _end150168_)
      (let ((_v150171_
             (let ((__obj299406
                    (make-object std/srfi/160/cvector#c64vector::t '1)))
               (std/srfi/160/cvector#c64vector:::init!__0
                __obj299406
                (fx- _end150168_ _start150166_))
               __obj299406)))
        (std/srfi/160/c64#c64vector-copy!
         _v150171_
         '0
         _vec150164_
         _start150166_
         _end150168_)
        _v150171_)))
  (define std/srfi/160/c64#c64vector-copy__0
    (lambda (_vec150177_)
      (let* ((_start150179_ '0)
             (_end150181_ (std/srfi/160/cvector#c64vector-length _vec150177_)))
        (std/srfi/160/c64#c64vector-copy__%
         _vec150177_
         _start150179_
         _end150181_))))
  (define std/srfi/160/c64#c64vector-copy__1
    (lambda (_vec150183_ _start150184_)
      (let ((_end150186_ (std/srfi/160/cvector#c64vector-length _vec150183_)))
        (std/srfi/160/c64#c64vector-copy__%
         _vec150183_
         _start150184_
         _end150186_))))
  (define std/srfi/160/c64#c64vector-copy
    (lambda _g299426_
      (let ((_g299425_ (let () (declare (not safe)) (##length _g299426_))))
        (cond ((let () (declare (not safe)) (##fx= _g299425_ 1))
               (apply std/srfi/160/c64#c64vector-copy__0 _g299426_))
              ((let () (declare (not safe)) (##fx= _g299425_ 2))
               (apply std/srfi/160/c64#c64vector-copy__1 _g299426_))
              ((let () (declare (not safe)) (##fx= _g299425_ 3))
               (apply std/srfi/160/c64#c64vector-copy__% _g299426_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-copy
                _g299426_))))))
  (define std/srfi/160/c64#c64vector-copy!
    (lambda (_to150143_ _at150145_ _from150147_ _start150149_ _end150151_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _to150143_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _to150143_))
        (if (##structure-direct-instance-of?
             _from150147_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _from150147_))
        (if (and (fixnum? _at150145_)
                 (fx<= '0
                       _at150145_
                       (fx- (std/srfi/160/cvector#c64vector-length _at150145_)
                            '1)))
            '#!void
            (error '"Index out of range" _to150143_ _at150145_))
        (if (and (fixnum? _start150149_)
                 (fx<= '0
                       _start150149_
                       (fx- (std/srfi/160/cvector#c64vector-length
                             _from150147_)
                            '1)))
            '#!void
            (error '"Index out of range" _from150147_ _start150149_))
        (if (and (fixnum? _end150151_)
                 (fx<= _start150149_
                       _end150151_
                       (std/srfi/160/cvector#c64vector-length _from150147_)))
            '#!void
            (error '"Index out of range" _from150147_ _end150151_))
        (if (fx<= (fx- _end150151_ _start150149_)
                  (fx- (std/srfi/160/cvector#c64vector-length _to150143_)
                       _at150145_))
            '#!void
            (error '"Destination area too small"
                   _to150143_
                   _at150145_
                   _from150147_
                   _start150149_
                   _end150151_))
        (let _lp150155_ ((_i150158_ _start150149_) (_j150160_ _at150145_))
          (if (fx< _i150158_ _end150151_)
              (begin
                (std/srfi/160/cvector#c64vector-set!
                 _to150143_
                 _j150160_
                 (std/srfi/160/cvector#c64vector-ref _from150147_ _i150158_))
                (_lp150155_ (fx+ _i150158_ '1) (fx+ _j150160_ '1)))
              '#!void)))))
  (define std/srfi/160/c64#c64vector-reverse-copy__%
    (lambda (_vec150115_ _start150117_ _end150119_)
      (let ((_v150122_
             (let ((__obj299407
                    (make-object std/srfi/160/cvector#c64vector::t '1)))
               (std/srfi/160/cvector#c64vector:::init!__0
                __obj299407
                (fx- _end150119_ _start150117_))
               __obj299407)))
        (std/srfi/160/c64#c64vector-reverse-copy!
         _v150122_
         '0
         _vec150115_
         _start150117_
         _end150119_)
        _v150122_)))
  (define std/srfi/160/c64#c64vector-reverse-copy__0
    (lambda (_vec150128_)
      (let* ((_start150130_ '0)
             (_end150132_ (std/srfi/160/cvector#c64vector-length _vec150128_)))
        (std/srfi/160/c64#c64vector-reverse-copy__%
         _vec150128_
         _start150130_
         _end150132_))))
  (define std/srfi/160/c64#c64vector-reverse-copy__1
    (lambda (_vec150134_ _start150135_)
      (let ((_end150137_ (std/srfi/160/cvector#c64vector-length _vec150134_)))
        (std/srfi/160/c64#c64vector-reverse-copy__%
         _vec150134_
         _start150135_
         _end150137_))))
  (define std/srfi/160/c64#c64vector-reverse-copy
    (lambda _g299428_
      (let ((_g299427_ (let () (declare (not safe)) (##length _g299428_))))
        (cond ((let () (declare (not safe)) (##fx= _g299427_ 1))
               (apply std/srfi/160/c64#c64vector-reverse-copy__0 _g299428_))
              ((let () (declare (not safe)) (##fx= _g299427_ 2))
               (apply std/srfi/160/c64#c64vector-reverse-copy__1 _g299428_))
              ((let () (declare (not safe)) (##fx= _g299427_ 3))
               (apply std/srfi/160/c64#c64vector-reverse-copy__% _g299428_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-reverse-copy
                _g299428_))))))
  (define std/srfi/160/c64#c64vector-reverse-copy!
    (lambda (_to150094_ _at150096_ _from150098_ _start150100_ _end150102_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _to150094_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _to150094_))
        (if (##structure-direct-instance-of?
             _from150098_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _from150098_))
        (if (and (fixnum? _at150096_)
                 (fx<= '0
                       _at150096_
                       (fx- (std/srfi/160/cvector#c64vector-length _at150096_)
                            '1)))
            '#!void
            (error '"Index out of range" _to150094_ _at150096_))
        (if (and (fixnum? _start150100_)
                 (fx<= '0
                       _start150100_
                       (fx- (std/srfi/160/cvector#c64vector-length
                             _from150098_)
                            '1)))
            '#!void
            (error '"Index out of range" _from150098_ _start150100_))
        (if (and (fixnum? _end150102_)
                 (fx<= _start150100_
                       _end150102_
                       (std/srfi/160/cvector#c64vector-length _from150098_)))
            '#!void
            (error '"Index out of range" _from150098_ _end150102_))
        (if (fx<= (fx- _end150102_ _start150100_)
                  (fx- (std/srfi/160/cvector#c64vector-length _to150094_)
                       _at150096_))
            '#!void
            (error '"Destination area too small"
                   _to150094_
                   _at150096_
                   _from150098_
                   _start150100_
                   _end150102_))
        (let _lp150106_ ((_i150109_ (fx- _end150102_ '1))
                         (_j150111_ _at150096_))
          (if (fx>= _i150109_ _start150100_)
              (begin
                (std/srfi/160/cvector#c64vector-set!
                 _to150094_
                 _j150111_
                 (std/srfi/160/cvector#c64vector-ref _from150098_ _i150109_))
                (_lp150106_ (fx- _i150109_ '1) (fx+ _j150111_ '1)))
              '#!void)))))
  (define std/srfi/160/c64#c64vector-append
    (lambda _args150091_
      (std/srfi/160/c64#c64vector-concatenate _args150091_)))
  (define std/srfi/160/c64#c64vector-concatenate
    (lambda (_lst150031_)
      (let* ((_len150039_
              (foldl1 (lambda (_v150034_ _r150036_)
                        (fx+ (std/srfi/160/cvector#c64vector-length _v150034_)
                             _r150036_))
                      '0
                      _lst150031_))
             (_v150042_
              (let ((__obj299408
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299408
                 _len150039_)
                __obj299408)))
        (declare (not safe))
        (let _lp150046_ ((_rest150049_ _lst150031_) (_at150051_ '0))
          (let* ((_rest150053150061_ _rest150049_)
                 (_else150055150069_ (lambda () _v150042_))
                 (_K150057150079_
                  (lambda (_rest150072_ _u150073_)
                    (let ((_ulen150076_
                           (std/srfi/160/cvector#c64vector-length _u150073_)))
                      (std/srfi/160/c64#c64vector-copy!
                       _v150042_
                       _at150051_
                       _u150073_
                       '0
                       _ulen150076_)
                      (_lp150046_
                       _rest150072_
                       (fx+ _at150051_ _ulen150076_))))))
            (if (##pair? _rest150053150061_)
                (let ((_hd150058150082_ (##car _rest150053150061_))
                      (_tl150059150084_ (##cdr _rest150053150061_)))
                  (let* ((_u150087_ _hd150058150082_)
                         (_rest150089_ _tl150059150084_))
                    (_K150057150079_ _rest150089_ _u150087_)))
                (_else150055150069_)))))))
  (define std/srfi/160/c64#c64vector-append-subvectors
    (lambda _args149903_
      (let* ((_len149964_
              (let _lp149906_ ((_rest149909_ _args149903_) (_r149911_ '0))
                (let* ((_rest149913149925_ _rest149909_)
                       (_else149915149933_ (lambda () _r149911_))
                       (_K149917149942_
                        (lambda (_rest149936_ _end149937_ _start149939_)
                          (_lp149906_
                           _rest149936_
                           (fx+ _r149911_ (fx- _end149937_ _start149939_))))))
                  (if (let ()
                        (declare (not safe))
                        (##pair? _rest149913149925_))
                      (let ((_tl149919149945_
                             (let ()
                               (declare (not safe))
                               (##cdr _rest149913149925_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl149919149945_))
                            (let ((_hd149920149948_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl149919149945_)))
                                  (_tl149921149950_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl149919149945_))))
                              (let ((_start149953_ _hd149920149948_))
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl149921149950_))
                                    (let ((_hd149922149955_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl149921149950_)))
                                          (_tl149923149957_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl149921149950_))))
                                      (let* ((_end149960_ _hd149922149955_)
                                             (_rest149962_ _tl149923149957_))
                                        (_K149917149942_
                                         _rest149962_
                                         _end149960_
                                         _start149953_)))
                                    (_else149915149933_))))
                            (_else149915149933_)))
                      (_else149915149933_)))))
             (_v149967_
              (let ((__obj299409
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299409
                 _len149964_)
                __obj299409)))
        (let _lp149971_ ((_rest149973_ _args149903_) (_at149974_ '0))
          (let* ((_rest149976149988_ _rest149973_)
                 (_else149978149996_ (lambda () _v149967_))
                 (_K149980150005_
                  (lambda (_rest149999_ _end150000_ _start150001_ _u150002_)
                    (std/srfi/160/c64#c64vector-copy!
                     _v149967_
                     _at149974_
                     _u150002_
                     _start150001_
                     _end150000_)
                    (_lp149971_
                     _rest149999_
                     (fx+ _at149974_ (fx- _end150000_ _start150001_))))))
            (if (let () (declare (not safe)) (##pair? _rest149976149988_))
                (let ((_hd149981150008_
                       (let ()
                         (declare (not safe))
                         (##car _rest149976149988_)))
                      (_tl149982150010_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest149976149988_))))
                  (let ((_u150013_ _hd149981150008_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl149982150010_))
                        (let ((_hd149983150015_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl149982150010_)))
                              (_tl149984150017_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl149982150010_))))
                          (let ((_start150020_ _hd149983150015_))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl149984150017_))
                                (let ((_hd149985150022_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl149984150017_)))
                                      (_tl149986150024_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _tl149984150017_))))
                                  (let* ((_end150027_ _hd149985150022_)
                                         (_rest150029_ _tl149986150024_))
                                    (_K149980150005_
                                     _rest150029_
                                     _end150027_
                                     _start150020_
                                     _u150013_)))
                                (_else149978149996_))))
                        (_else149978149996_))))
                (_else149978149996_)))))))
  (define std/srfi/160/c64#c64vector-empty?
    (lambda (_v149900_)
      (fxzero? (std/srfi/160/cvector#c64vector-length _v149900_))))
  (define std/srfi/160/c64#c64vector=
    (lambda (_v149842_ . _args149844_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v149842_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _v149842_))
        (let ((_vlen149848_ (std/srfi/160/cvector#c64vector-length _v149842_)))
          (let _lp149851_ ((_rest149854_ _args149844_))
            (let* ((_rest149856149864_ _rest149854_)
                   (_else149858149872_ (lambda () '#t))
                   (_K149860149888_
                    (lambda (_rest149875_ _u149876_)
                      (if (##structure-direct-instance-of?
                           _u149876_
                           'std/srfi/160/cvector#c64vector::t)
                          '#!void
                          (error '"Bad argument" _u149876_))
                      (let ((_ulen149879_
                             (std/srfi/160/cvector#c64vector-length
                              _u149876_)))
                        (if (fx= _vlen149848_ _ulen149879_)
                            (let _cmp149882_ ((_i149885_ '0))
                              (if (fx< _i149885_ _vlen149848_)
                                  (if (= (std/srfi/160/cvector#c64vector-ref
                                          _v149842_
                                          _i149885_)
                                         (std/srfi/160/cvector#c64vector-ref
                                          _u149876_
                                          _i149885_))
                                      (_cmp149882_ (fx+ _i149885_ '1))
                                      '#f)
                                  (_lp149851_ _rest149875_)))
                            '#f)))))
              (if (##pair? _rest149856149864_)
                  (let ((_hd149861149891_ (##car _rest149856149864_))
                        (_tl149862149893_ (##cdr _rest149856149864_)))
                    (let* ((_u149896_ _hd149861149891_)
                           (_rest149898_ _tl149862149893_))
                      (_K149860149888_ _rest149898_ _u149896_)))
                  (_else149858149872_))))))))
  (define std/srfi/160/c64#c64vector-take
    (lambda (_v149834_ _n149836_)
      (let ((_u149839_
             (let ((__obj299410
                    (make-object std/srfi/160/cvector#c64vector::t '1)))
               (std/srfi/160/cvector#c64vector:::init!__0
                __obj299410
                _n149836_)
               __obj299410)))
        (std/srfi/160/c64#c64vector-copy! _u149839_ '0 _v149834_ '0 _n149836_)
        _u149839_)))
  (define std/srfi/160/c64#c64vector-take-right
    (lambda (_v149819_ _n149821_)
      (let* ((_vlen149824_ (std/srfi/160/cvector#c64vector-length _v149819_))
             (_ulen149827_ (fx- _vlen149824_ _n149821_))
             (_u149830_
              (let ((__obj299411
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299411
                 _ulen149827_)
                __obj299411)))
        (std/srfi/160/c64#c64vector-copy!
         _u149830_
         '0
         _v149819_
         _n149821_
         _vlen149824_)
        _u149830_)))
  (define std/srfi/160/c64#c64vector-drop
    (lambda (_v149804_ _n149806_)
      (let* ((_vlen149809_ (std/srfi/160/cvector#c64vector-length _v149804_))
             (_ulen149812_ (fx- _vlen149809_ _n149806_))
             (_u149815_
              (let ((__obj299412
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299412
                 _ulen149812_)
                __obj299412)))
        (std/srfi/160/c64#c64vector-copy!
         _u149815_
         '0
         _v149804_
         _n149806_
         _vlen149809_)
        _u149815_)))
  (define std/srfi/160/c64#c64vector-drop-right
    (lambda (_v149789_ _n149791_)
      (let* ((_vlen149794_ (std/srfi/160/cvector#c64vector-length _v149789_))
             (_ulen149797_ (fx- _vlen149794_ _n149791_))
             (_u149800_
              (let ((__obj299413
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299413
                 _ulen149797_)
                __obj299413)))
        (std/srfi/160/c64#c64vector-copy!
         _u149800_
         '0
         _v149789_
         '0
         _ulen149797_)
        _u149800_)))
  (define std/srfi/160/c64#c64vector-segment
    (lambda (_v149771_ _n149773_)
      (let _lp149776_ ((_i149779_ '0)
                       (_rest149781_
                        (std/srfi/160/cvector#c64vector-length _v149771_))
                       (_r149783_ '()))
        (if (fx> _r149783_ '0)
            (let ((_size149786_ (fxmin _n149773_ _rest149781_)))
              (_lp149776_
               (fx+ _i149779_ _size149786_)
               (fx- _rest149781_ _size149786_)
               (cons (std/srfi/160/c64#c64vector-copy__%
                      _v149771_
                      _i149779_
                      (fx+ _i149779_ _size149786_))
                     _r149783_)))
            (reverse _r149783_)))))
  (define std/srfi/160/c64#c64vector-fold__0
    (lambda (_kons149731_ _knil149733_ _v149735_)
      (if (procedure? _kons149731_)
          '#!void
          (error '"Bad argument; expected procedure" _kons149731_))
      (let ((_end149738_ (std/srfi/160/cvector#c64vector-length _v149735_)))
        (declare (not safe))
        (let _lp149742_ ((_i149745_ '0) (_r149747_ _knil149733_))
          (if (fx< _i149745_ _end149738_)
              (_lp149742_
               (fx+ _i149745_ '1)
               (_kons149731_
                _r149747_
                (std/srfi/160/cvector#c64vector-ref _v149735_ _i149745_)))
              _r149747_)))))
  (define std/srfi/160/c64#c64vector-fold__1
    (lambda (_kons149750_ _knil149751_ _v149752_ . _vs149753_)
      (if (procedure? _kons149750_)
          '#!void
          (error '"Bad argument; expected procedure" _kons149750_))
      (let* ((_vs149756_ (cons _v149752_ _vs149753_))
             (_end149758_
              (apply fxmin
                     (map std/srfi/160/cvector#c64vector-length _vs149756_))))
        (declare (not safe))
        (let _lp149762_ ((_i149764_ '0) (_r149765_ _knil149751_))
          (if (fx< _i149764_ _end149758_)
              (_lp149762_
               (fx+ _i149764_ '1)
               (apply _kons149750_
                      _r149765_
                      (map (lambda (_g149766149768_)
                             (std/srfi/160/cvector#c64vector-ref
                              _g149766149768_
                              _i149764_))
                           _vs149756_)))
              _r149765_)))))
  (define std/srfi/160/c64#c64vector-fold
    (lambda _g299430_
      (let ((_g299429_ (let () (declare (not safe)) (##length _g299430_))))
        (cond ((let () (declare (not safe)) (##fx= _g299429_ 3))
               (apply std/srfi/160/c64#c64vector-fold__0 _g299430_))
              ((let () (declare (not safe)) (##fx>= _g299429_ 3))
               (apply std/srfi/160/c64#c64vector-fold__1 _g299430_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-fold
                _g299430_))))))
  (define std/srfi/160/c64#c64vector-fold-right__0
    (lambda (_kons149691_ _knil149693_ _v149695_)
      (if (procedure? _kons149691_)
          '#!void
          (error '"Bad argument; expected procedure" _kons149691_))
      (let ((_last149698_
             (fx- (std/srfi/160/cvector#c64vector-length _v149695_) '1)))
        (declare (not safe))
        (let _lp149702_ ((_i149705_ _last149698_) (_r149707_ _knil149693_))
          (if (fx>= _i149705_ '0)
              (_lp149702_
               (fx- _i149705_ '1)
               (_kons149691_
                _r149707_
                (std/srfi/160/cvector#c64vector-ref _v149695_ _i149705_)))
              _r149707_)))))
  (define std/srfi/160/c64#c64vector-fold-right__1
    (lambda (_kons149710_ _knil149711_ _v149712_ . _vs149713_)
      (if (procedure? _kons149710_)
          '#!void
          (error '"Bad argument; expected procedure" _kons149710_))
      (let* ((_vs149716_ (cons _v149712_ _vs149713_))
             (_last149718_
              (fx- (apply min
                          (map std/srfi/160/cvector#c64vector-length
                               _vs149716_))
                   '1)))
        (declare (not safe))
        (let _lp149722_ ((_i149724_ _last149718_) (_r149725_ _knil149711_))
          (if (fx>= _i149724_ '0)
              (_lp149722_
               (fx- _i149724_ '1)
               (apply _kons149710_
                      _r149725_
                      (map (lambda (_g149726149728_)
                             (std/srfi/160/cvector#c64vector-ref
                              _g149726149728_
                              _i149724_))
                           _vs149716_)))
              _r149725_)))))
  (define std/srfi/160/c64#c64vector-fold-right
    (lambda _g299432_
      (let ((_g299431_ (let () (declare (not safe)) (##length _g299432_))))
        (cond ((let () (declare (not safe)) (##fx= _g299431_ 3))
               (apply std/srfi/160/c64#c64vector-fold-right__0 _g299432_))
              ((let () (declare (not safe)) (##fx>= _g299431_ 3))
               (apply std/srfi/160/c64#c64vector-fold-right__1 _g299432_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-fold-right
                _g299432_))))))
  (define std/srfi/160/c64#c64vector-map__0
    (lambda (_f149651_ _v149653_)
      (if (procedure? _f149651_)
          '#!void
          (error '"Bad argument; expected procedure" _f149651_))
      (let* ((_len149656_ (std/srfi/160/cvector#c64vector-length _v149653_))
             (_u149659_
              (let ((__obj299414
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299414
                 _len149656_)
                __obj299414)))
        (declare (not safe))
        (let _lp149664_ ((_i149667_ '0))
          (if (fx< _i149667_ _len149656_)
              (begin
                (std/srfi/160/cvector#c64vector-set!
                 _u149659_
                 _i149667_
                 (std/srfi/160/cvector#c64vector-ref _v149653_ _i149667_))
                (_lp149664_ (fx+ _i149667_ '1)))
              _u149659_)))))
  (define std/srfi/160/c64#c64vector-map__1
    (lambda (_f149670_ _v149671_ . _vs149672_)
      (if (procedure? _f149670_)
          '#!void
          (error '"Bad argument; expected procedure" _f149670_))
      (let* ((_vs149675_ (cons _v149671_ _vs149672_))
             (_len149677_
              (apply fxmin
                     (map std/srfi/160/cvector#c64vector-length _vs149675_)))
             (_u149679_
              (let ((__obj299415
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299415
                 _len149677_)
                __obj299415)))
        (declare (not safe))
        (let _lp149683_ ((_i149685_ '0))
          (if (fx< _i149685_ _len149677_)
              (begin
                (std/srfi/160/cvector#c64vector-set!
                 _u149679_
                 _i149685_
                 (apply _f149670_
                        (map (lambda (_g149686149688_)
                               (std/srfi/160/cvector#c64vector-ref
                                _g149686149688_
                                _i149685_))
                             _vs149675_)))
                (_lp149683_ (fx+ _i149685_ '1)))
              _u149679_)))))
  (define std/srfi/160/c64#c64vector-map
    (lambda _g299434_
      (let ((_g299433_ (let () (declare (not safe)) (##length _g299434_))))
        (cond ((let () (declare (not safe)) (##fx= _g299433_ 2))
               (apply std/srfi/160/c64#c64vector-map__0 _g299434_))
              ((let () (declare (not safe)) (##fx>= _g299433_ 2))
               (apply std/srfi/160/c64#c64vector-map__1 _g299434_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-map
                _g299434_))))))
  (define std/srfi/160/c64#c64vector-map!__0
    (lambda (_f149617_ _v149619_)
      (if (procedure? _f149617_)
          '#!void
          (error '"Bad argument; expected procedure" _f149617_))
      (let ((_len149622_ (std/srfi/160/cvector#c64vector-length _v149619_)))
        (declare (not safe))
        (let _lp149626_ ((_i149629_ '0))
          (if (fx< _i149629_ _len149622_)
              (begin
                (std/srfi/160/cvector#c64vector-set!
                 _v149619_
                 _i149629_
                 (_f149617_
                  (std/srfi/160/cvector#c64vector-ref _v149619_ _i149629_)))
                (_lp149626_ (fx+ _i149629_ '1)))
              _v149619_)))))
  (define std/srfi/160/c64#c64vector-map!__1
    (lambda (_f149632_ _v149633_ . _vs149634_)
      (if (procedure? _f149632_)
          '#!void
          (error '"Bad argument; expected procedure" _f149632_))
      (let* ((_vs149637_ (cons _v149633_ _vs149634_))
             (_len149639_
              (apply fxmin
                     (map std/srfi/160/cvector#c64vector-length _vs149637_))))
        (declare (not safe))
        (let _lp149643_ ((_i149645_ '0))
          (if (fx< _i149645_ _len149639_)
              (begin
                (std/srfi/160/cvector#c64vector-set!
                 _v149633_
                 _i149645_
                 (apply _f149632_
                        (map (lambda (_g149646149648_)
                               (std/srfi/160/cvector#c64vector-ref
                                _g149646149648_
                                _i149645_))
                             _vs149637_)))
                (_lp149643_ (fx+ _i149645_ '1)))
              _v149633_)))))
  (define std/srfi/160/c64#c64vector-map!
    (lambda _g299436_
      (let ((_g299435_ (let () (declare (not safe)) (##length _g299436_))))
        (cond ((let () (declare (not safe)) (##fx= _g299435_ 2))
               (apply std/srfi/160/c64#c64vector-map!__0 _g299436_))
              ((let () (declare (not safe)) (##fx>= _g299435_ 2))
               (apply std/srfi/160/c64#c64vector-map!__1 _g299436_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-map!
                _g299436_))))))
  (define std/srfi/160/c64#c64vector-for-each__0
    (lambda (_f149583_ _v149585_)
      (if (procedure? _f149583_)
          '#!void
          (error '"Bad argument; expected procedure" _f149583_))
      (let ((_len149588_ (std/srfi/160/cvector#c64vector-length _v149585_)))
        (declare (not safe))
        (let _lp149592_ ((_i149595_ '0))
          (if (fx< _i149595_ _len149588_)
              (begin
                (_f149583_
                 (std/srfi/160/cvector#c64vector-ref _v149585_ _i149595_))
                (_lp149592_ (fx+ _i149595_ '1)))
              '#!void)))))
  (define std/srfi/160/c64#c64vector-for-each__1
    (lambda (_f149598_ _v149599_ . _vs149600_)
      (let* ((_vs149603_ (cons _v149599_ _vs149600_))
             (_len149605_
              (apply fxmin
                     (map std/srfi/160/cvector#c64vector-length _vs149603_))))
        (declare (not safe))
        (let _lp149609_ ((_i149611_ '0))
          (if (fx< _i149611_ _len149605_)
              (begin
                (apply _f149598_
                       (map (lambda (_g149612149614_)
                              (std/srfi/160/cvector#c64vector-ref
                               _g149612149614_
                               _i149611_))
                            _vs149603_))
                (_lp149609_ (fx+ _i149611_ '1)))
              '#!void)))))
  (define std/srfi/160/c64#c64vector-for-each
    (lambda _g299438_
      (let ((_g299437_ (let () (declare (not safe)) (##length _g299438_))))
        (cond ((let () (declare (not safe)) (##fx= _g299437_ 2))
               (apply std/srfi/160/c64#c64vector-for-each__0 _g299438_))
              ((let () (declare (not safe)) (##fx>= _g299437_ 2))
               (apply std/srfi/160/c64#c64vector-for-each__1 _g299438_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-for-each
                _g299438_))))))
  (define std/srfi/160/c64#c64vector-count__0
    (lambda (_pred149546_ _v149548_)
      (if (procedure? _pred149546_)
          '#!void
          (error '"Bad argument; expected procedure" _pred149546_))
      (let ((_end149551_ (std/srfi/160/cvector#c64vector-length _v149548_)))
        (declare (not safe))
        (let _lp149555_ ((_i149558_ '0) (_r149560_ '0))
          (if (fx< _i149558_ _end149551_)
              (if (_pred149546_
                   (std/srfi/160/cvector#c64vector-ref _v149548_ _i149558_))
                  (_lp149555_ (fx+ _i149558_ '1) (fx+ _r149560_ '1))
                  (_lp149555_ (fx+ _i149558_ '1) _r149560_))
              _r149560_)))))
  (define std/srfi/160/c64#c64vector-count__1
    (lambda (_pred149563_ _v149564_ . _vs149565_)
      (if (procedure? _pred149563_)
          '#!void
          (error '"Bad argument; expected procedure" _pred149563_))
      (let* ((_vs149568_ (cons _v149564_ _vs149565_))
             (_end149570_
              (apply fxmin
                     (map std/srfi/160/cvector#c64vector-length _vs149568_))))
        (declare (not safe))
        (let _lp149574_ ((_i149576_ '0) (_r149577_ '0))
          (if (fx< _i149576_ _end149570_)
              (if (apply _pred149563_
                         (map (lambda (_g149578149580_)
                                (std/srfi/160/cvector#c64vector-ref
                                 _g149578149580_
                                 _i149576_))
                              _vs149568_))
                  (_lp149574_ (fx+ _i149576_ '1) (fx+ _r149577_ '1))
                  (_lp149574_ (fx+ _i149576_ '1) _r149577_))
              _r149577_)))))
  (define std/srfi/160/c64#c64vector-count
    (lambda _g299440_
      (let ((_g299439_ (let () (declare (not safe)) (##length _g299440_))))
        (cond ((let () (declare (not safe)) (##fx= _g299439_ 2))
               (apply std/srfi/160/c64#c64vector-count__0 _g299440_))
              ((let () (declare (not safe)) (##fx>= _g299439_ 2))
               (apply std/srfi/160/c64#c64vector-count__1 _g299440_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-count
                _g299440_))))))
  (define std/srfi/160/c64#c64vector-cumulate
    (lambda (_f149521_ _knil149523_ _v149525_)
      (if (procedure? _f149521_)
          '#!void
          (error '"Bad argument; expected procedure" _f149521_))
      (let* ((_len149528_ (std/srfi/160/cvector#c64vector-length _v149525_))
             (_r149531_
              (let ((__obj299416
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299416
                 _len149528_)
                __obj299416)))
        (declare (not safe))
        (let _lp149536_ ((_i149539_ '0) (_r149541_ _knil149523_))
          (if (fx< _i149539_ _len149528_)
              (let ((_next149543_
                     (_f149521_
                      _r149541_
                      (std/srfi/160/cvector#c64vector-ref
                       _v149525_
                       _i149539_))))
                (std/srfi/160/cvector#c64vector-set!
                 _v149525_
                 _i149539_
                 _next149543_)
                (_lp149536_ (fx+ _i149539_ '1) _next149543_))
              _v149525_)))))
  (define std/srfi/160/c64#c64vector-take-while
    (lambda (_pred149504_ _v149506_)
      (let* ((_len149509_ (std/srfi/160/cvector#c64vector-length _v149506_))
             (_idx149512_
              (std/srfi/160/c64#c64vector-skip__0 _pred149504_ _v149506_))
             (_idx149518_
              (let ((_$e149515_ _idx149512_))
                (if _$e149515_ _$e149515_ _len149509_))))
        (std/srfi/160/c64#c64vector-copy__% _v149506_ '0 _idx149518_))))
  (define std/srfi/160/c64#c64vector-take-while-right
    (lambda (_pred149490_ _v149492_)
      (let* ((_len149495_ (std/srfi/160/cvector#c64vector-length _v149492_))
             (_idx149498_
              (std/srfi/160/c64#c64vector-skip-right__0
               _pred149490_
               _v149492_))
             (_idx149501_ (if _idx149498_ (fx+ _idx149498_ '1) '0)))
        (std/srfi/160/c64#c64vector-copy__%
         _v149492_
         _idx149501_
         _len149495_))))
  (define std/srfi/160/c64#c64vector-drop-while
    (lambda (_pred149473_ _v149475_)
      (let* ((_len149478_ (std/srfi/160/cvector#c64vector-length _v149475_))
             (_idx149481_
              (std/srfi/160/c64#c64vector-skip__0 _pred149473_ _v149475_))
             (_idx149487_
              (let ((_$e149484_ _idx149481_))
                (if _$e149484_ _$e149484_ _len149478_))))
        (std/srfi/160/c64#c64vector-copy__%
         _v149475_
         _idx149487_
         _len149478_))))
  (define std/srfi/160/c64#c64vector-drop-while-right
    (lambda (_pred149459_ _v149461_)
      (let* ((_len149464_ (std/srfi/160/cvector#c64vector-length _v149461_))
             (_idx149467_
              (std/srfi/160/c64#c64vector-skip-right__0
               _pred149459_
               _v149461_))
             (_idx149470_ (if _idx149467_ (fx+ _idx149467_ '1) '0)))
        (std/srfi/160/c64#c64vector-copy__% _v149461_ '0 _idx149470_))))
  (define std/srfi/160/c64#c64vector-index__0
    (lambda (_pred149425_ _v149427_)
      (if (procedure? _pred149425_)
          '#!void
          (error '"Bad argument; expected procedure" _pred149425_))
      (let ((_end149430_ (std/srfi/160/cvector#c64vector-length _v149427_)))
        (declare (not safe))
        (let _lp149434_ ((_i149437_ '0))
          (if (fx< _i149437_ _end149430_)
              (if (_pred149425_
                   (std/srfi/160/cvector#c64vector-ref _v149427_ _i149437_))
                  _i149437_
                  (_lp149434_ (fx+ _i149437_ '1)))
              '#f)))))
  (define std/srfi/160/c64#c64vector-index__1
    (lambda (_pred149440_ _v149441_ . _vs149442_)
      (if (procedure? _pred149440_)
          '#!void
          (error '"Bad argument; expected procedure" _pred149440_))
      (let* ((_vs149445_ (cons _v149441_ _vs149442_))
             (_end149447_
              (apply fxmin
                     (map std/srfi/160/cvector#c64vector-length _vs149445_))))
        (declare (not safe))
        (let _lp149451_ ((_i149453_ '0))
          (if (fx< _i149453_ _end149447_)
              (if (apply _pred149440_
                         (map (lambda (_g149454149456_)
                                (std/srfi/160/cvector#c64vector-ref
                                 _g149454149456_
                                 _i149453_))
                              _vs149445_))
                  _i149453_
                  (_lp149451_ (fx+ _i149453_ '1)))
              '#f)))))
  (define std/srfi/160/c64#c64vector-index
    (lambda _g299442_
      (let ((_g299441_ (let () (declare (not safe)) (##length _g299442_))))
        (cond ((let () (declare (not safe)) (##fx= _g299441_ 2))
               (apply std/srfi/160/c64#c64vector-index__0 _g299442_))
              ((let () (declare (not safe)) (##fx>= _g299441_ 2))
               (apply std/srfi/160/c64#c64vector-index__1 _g299442_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-index
                _g299442_))))))
  (define std/srfi/160/c64#c64vector-index-right__0
    (lambda (_pred149391_ _v149393_)
      (if (procedure? _pred149391_)
          '#!void
          (error '"Bad argument; expected procedure" _pred149391_))
      (let ((_start149396_
             (fx- (std/srfi/160/cvector#c64vector-length _v149393_) '1)))
        (declare (not safe))
        (let _lp149400_ ((_i149403_ _start149396_))
          (if (fx>= _i149403_ '0)
              (if (_pred149391_
                   (std/srfi/160/cvector#c64vector-ref _v149393_ _i149403_))
                  _i149403_
                  (_lp149400_ (fx- _i149403_ '1)))
              '#f)))))
  (define std/srfi/160/c64#c64vector-index-right__1
    (lambda (_pred149406_ _v149407_ . _vs149408_)
      (if (procedure? _pred149406_)
          '#!void
          (error '"Bad argument; expected procedure" _pred149406_))
      (let* ((_vs149411_ (cons _v149407_ _vs149408_))
             (_start149413_
              (fx- (apply fxmin
                          (map std/srfi/160/cvector#c64vector-length
                               _vs149411_))
                   '1)))
        (declare (not safe))
        (let _lp149417_ ((_i149419_ _start149413_))
          (if (fx>= _i149419_ '0)
              (if (apply _pred149406_
                         (map (lambda (_g149420149422_)
                                (std/srfi/160/cvector#c64vector-ref
                                 _g149420149422_
                                 _i149419_))
                              _vs149411_))
                  _i149419_
                  (_lp149417_ (fx- _i149419_ '1)))
              '#f)))))
  (define std/srfi/160/c64#c64vector-index-right
    (lambda _g299444_
      (let ((_g299443_ (let () (declare (not safe)) (##length _g299444_))))
        (cond ((let () (declare (not safe)) (##fx= _g299443_ 2))
               (apply std/srfi/160/c64#c64vector-index-right__0 _g299444_))
              ((let () (declare (not safe)) (##fx>= _g299443_ 2))
               (apply std/srfi/160/c64#c64vector-index-right__1 _g299444_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-index-right
                _g299444_))))))
  (define std/srfi/160/c64#c64vector-skip__0
    (lambda (_pred149375_ _v149377_)
      (std/srfi/160/c64#c64vector-index__0
       (lambda (_$obj149380_) (not (_pred149375_ _$obj149380_)))
       _v149377_)))
  (define std/srfi/160/c64#c64vector-skip__1
    (lambda (_pred149383_ _v149384_ . _vs149385_)
      (apply std/srfi/160/c64#c64vector-index
             (lambda (_$obj149388_) (not (_pred149383_ _$obj149388_)))
             _v149384_
             _vs149385_)))
  (define std/srfi/160/c64#c64vector-skip
    (lambda _g299446_
      (let ((_g299445_ (let () (declare (not safe)) (##length _g299446_))))
        (cond ((let () (declare (not safe)) (##fx= _g299445_ 2))
               (apply std/srfi/160/c64#c64vector-skip__0 _g299446_))
              ((let () (declare (not safe)) (##fx>= _g299445_ 2))
               (apply std/srfi/160/c64#c64vector-skip__1 _g299446_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-skip
                _g299446_))))))
  (define std/srfi/160/c64#c64vector-skip-right__0
    (lambda (_pred149359_ _v149361_)
      (std/srfi/160/c64#c64vector-index-right__0
       (lambda (_$obj149364_) (not (_pred149359_ _$obj149364_)))
       _v149361_)))
  (define std/srfi/160/c64#c64vector-skip-right__1
    (lambda (_pred149367_ _v149368_ . _vs149369_)
      (apply std/srfi/160/c64#c64vector-index-right
             (lambda (_$obj149372_) (not (_pred149367_ _$obj149372_)))
             _v149368_
             _vs149369_)))
  (define std/srfi/160/c64#c64vector-skip-right
    (lambda _g299448_
      (let ((_g299447_ (let () (declare (not safe)) (##length _g299448_))))
        (cond ((let () (declare (not safe)) (##fx= _g299447_ 2))
               (apply std/srfi/160/c64#c64vector-skip-right__0 _g299448_))
              ((let () (declare (not safe)) (##fx>= _g299447_ 2))
               (apply std/srfi/160/c64#c64vector-skip-right__1 _g299448_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-skip-right
                _g299448_))))))
  (define std/srfi/160/c64#c64vector-any__0
    (lambda (_pred149319_ _v149321_)
      (if (procedure? _pred149319_)
          '#!void
          (error '"Bad argument; expected procedure" _pred149319_))
      (let ((_end149324_ (std/srfi/160/cvector#c64vector-length _v149321_)))
        (declare (not safe))
        (let _lp149328_ ((_i149331_ '0))
          (if (fx< _i149331_ _end149324_)
              (let ((_$e149334_
                     (_pred149319_
                      (std/srfi/160/cvector#c64vector-ref
                       _v149321_
                       _i149331_))))
                (if _$e149334_
                    (values _$e149334_)
                    (_lp149328_ (fx+ _i149331_ '1))))
              '#f)))))
  (define std/srfi/160/c64#c64vector-any__1
    (lambda (_pred149337_ _v149338_ . _vs149339_)
      (if (procedure? _pred149337_)
          '#!void
          (error '"Bad argument; expected procedure" _pred149337_))
      (let* ((_v149342_ (cons _v149338_ _vs149339_))
             (_end149344_
              (apply fxmin
                     (map std/srfi/160/cvector#c64vector-length _vs149339_))))
        (declare (not safe))
        (let _lp149348_ ((_i149350_ '0))
          (if (fx< _i149350_ _end149344_)
              (let ((_$e149356_
                     (apply _pred149337_
                            (map (lambda (_g149351149353_)
                                   (std/srfi/160/cvector#c64vector-ref
                                    _g149351149353_
                                    _i149350_))
                                 _vs149339_))))
                (if _$e149356_
                    (values _$e149356_)
                    (_lp149348_ (fx+ _i149350_ '1))))
              '#f)))))
  (define std/srfi/160/c64#c64vector-any
    (lambda _g299450_
      (let ((_g299449_ (let () (declare (not safe)) (##length _g299450_))))
        (cond ((let () (declare (not safe)) (##fx= _g299449_ 2))
               (apply std/srfi/160/c64#c64vector-any__0 _g299450_))
              ((let () (declare (not safe)) (##fx>= _g299449_ 2))
               (apply std/srfi/160/c64#c64vector-any__1 _g299450_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-any
                _g299450_))))))
  (define std/srfi/160/c64#c64vector-every__0
    (lambda (_pred149268_ _v149270_)
      (if (procedure? _pred149268_)
          '#!void
          (error '"Bad argument; expected procedure" _pred149268_))
      (let ((_end149273_ (std/srfi/160/cvector#c64vector-length _v149270_)))
        (declare (not safe))
        (let _lp149277_ ((_i149280_ '0) (_r149282_ '#t))
          (if (fx< _i149280_ _end149273_)
              (let ((_$e149285_
                     (_pred149268_
                      (std/srfi/160/cvector#c64vector-ref
                       _v149270_
                       _i149280_))))
                (if _$e149285_
                    ((lambda (_g149287149289_)
                       (_lp149277_ (fx+ _i149280_ '1) _g149287149289_))
                     _$e149285_)
                    '#f))
              _r149282_)))))
  (define std/srfi/160/c64#c64vector-every__1
    (lambda (_pred149292_ _v149293_ . _vs149294_)
      (if (procedure? _pred149292_)
          '#!void
          (error '"Bad argument; expected procedure" _pred149292_))
      (let* ((_v149297_ (cons _v149293_ _vs149294_))
             (_end149299_
              (apply fxmin
                     (map std/srfi/160/cvector#c64vector-length _vs149294_))))
        (declare (not safe))
        (let _lp149303_ ((_i149305_ '0) (_r149306_ '#t))
          (if (fx< _i149305_ _end149299_)
              (let ((_$e149312_
                     (apply _pred149292_
                            (map (lambda (_g149307149309_)
                                   (std/srfi/160/cvector#c64vector-ref
                                    _g149307149309_
                                    _i149305_))
                                 _vs149294_))))
                (if _$e149312_
                    ((lambda (_g149314149316_)
                       (_lp149303_ (fx+ _i149305_ '1) _g149314149316_))
                     _$e149312_)
                    '#f))
              _r149306_)))))
  (define std/srfi/160/c64#c64vector-every
    (lambda _g299452_
      (let ((_g299451_ (let () (declare (not safe)) (##length _g299452_))))
        (cond ((let () (declare (not safe)) (##fx= _g299451_ 2))
               (apply std/srfi/160/c64#c64vector-every__0 _g299452_))
              ((let () (declare (not safe)) (##fx>= _g299451_ 2))
               (apply std/srfi/160/c64#c64vector-every__1 _g299452_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-every
                _g299452_))))))
  (define std/srfi/160/c64#c64vector-partition
    (lambda (_pred149239_ _v149241_)
      (let* ((_count149244_
              (std/srfi/160/c64#c64vector-count__0 _pred149239_ _v149241_))
             (_len149247_ (std/srfi/160/cvector#c64vector-length _v149241_))
             (_u149250_
              (let ((__obj299417
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299417
                 _len149247_)
                __obj299417)))
        (declare (not safe))
        (let _lp149255_ ((_i149258_ '0)
                         (_left149260_ '0)
                         (_right149262_ _count149244_))
          (if (fx< _i149258_ _len149247_)
              (let ((_x149265_
                     (std/srfi/160/cvector#c64vector-ref _v149241_ _i149258_)))
                (if (_pred149239_ _x149265_)
                    (begin
                      (std/srfi/160/cvector#c64vector-set!
                       _u149250_
                       _left149260_
                       _x149265_)
                      (_lp149255_
                       (fx+ _i149258_ '1)
                       (fx+ _left149260_ '1)
                       _right149262_))
                    (begin
                      (std/srfi/160/cvector#c64vector-set!
                       _u149250_
                       _right149262_
                       _x149265_)
                      (_lp149255_
                       (fx+ _i149258_ '1)
                       _left149260_
                       (fx+ _right149262_ '1)))))
              _u149250_)))))
  (define std/srfi/160/c64#c64vector-filter
    (lambda (_pred149212_ _v149214_)
      (let* ((_count149217_
              (std/srfi/160/c64#c64vector-count__0 _pred149212_ _v149214_))
             (_u149220_
              (let ((__obj299418
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299418
                 _count149217_)
                __obj299418))
             (_end149223_ (std/srfi/160/cvector#c64vector-length _v149214_)))
        (declare (not safe))
        (let _lp149228_ ((_i149231_ '0) (_j149233_ '0))
          (if (fx< _i149231_ _end149223_)
              (let ((_x149236_
                     (std/srfi/160/cvector#c64vector-ref _v149214_ _i149231_)))
                (if (_pred149212_ _x149236_)
                    (begin
                      (std/srfi/160/cvector#c64vector-set!
                       _u149220_
                       _j149233_
                       _x149236_)
                      (_lp149228_ (fx+ _i149231_ '1) (fx+ _j149233_ '1)))
                    (_lp149228_ (fx+ _i149231_ '1) _j149233_)))
              _u149220_)))))
  (define std/srfi/160/c64#c64vector-remove
    (lambda (_pred149204_ _v149206_)
      (std/srfi/160/c64#c64vector-filter
       (lambda (_$obj149209_) (not (_pred149204_ _$obj149209_)))
       _v149206_)))
  (define std/srfi/160/c64#c64vector-swap
    (lambda (_v149191_ _i149193_ _j149195_)
      (let ((_iv149198_
             (std/srfi/160/cvector#c64vector-ref _v149191_ _i149193_))
            (_jv149200_
             (std/srfi/160/cvector#c64vector-ref _v149191_ _j149195_)))
        (declare (not safe))
        (begin
          (std/srfi/160/cvector#c64vector-set! _v149191_ _i149193_ _jv149200_)
          (std/srfi/160/cvector#c64vector-set!
           _v149191_
           _j149195_
           _iv149198_)))))
  (define std/srfi/160/c64#c64vector-fill!__%
    (lambda (_v149154_ _fill149156_ _start149158_ _end149160_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v149154_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _v149154_))
        (if (std/srfi/160/base#c64? _fill149156_)
            '#!void
            (error '"Bad argument" _fill149156_))
        (if (and (fixnum? _start149158_)
                 (fx<= '0
                       _start149158_
                       (fx- (std/srfi/160/cvector#c64vector-length _v149154_)
                            '1)))
            '#!void
            (error '"Index out of range" _start149158_))
        (if (and (fixnum? _end149160_)
                 (fx<= _start149158_
                       _end149160_
                       (std/srfi/160/cvector#c64vector-length _v149154_)))
            '#!void
            (error '"Index out of range" _end149160_))
        (let _lp149164_ ((_i149167_ _start149158_))
          (if (fx< _i149167_ _end149160_)
              (begin
                (std/srfi/160/cvector#c64vector-set!
                 _v149154_
                 _i149167_
                 _fill149156_)
                (_lp149164_ (fx+ _i149167_ '1)))
              '#!void)))))
  (define std/srfi/160/c64#c64vector-fill!__0
    (lambda (_v149173_ _fill149174_)
      (let* ((_start149176_ '0)
             (_end149178_ (std/srfi/160/cvector#c64vector-length _v149173_)))
        (std/srfi/160/c64#c64vector-fill!__%
         _v149173_
         _fill149174_
         _start149176_
         _end149178_))))
  (define std/srfi/160/c64#c64vector-fill!__1
    (lambda (_v149180_ _fill149181_ _start149182_)
      (let ((_end149184_ (std/srfi/160/cvector#c64vector-length _v149180_)))
        (std/srfi/160/c64#c64vector-fill!__%
         _v149180_
         _fill149181_
         _start149182_
         _end149184_))))
  (define std/srfi/160/c64#c64vector-fill!
    (lambda _g299454_
      (let ((_g299453_ (let () (declare (not safe)) (##length _g299454_))))
        (cond ((let () (declare (not safe)) (##fx= _g299453_ 2))
               (apply std/srfi/160/c64#c64vector-fill!__0 _g299454_))
              ((let () (declare (not safe)) (##fx= _g299453_ 3))
               (apply std/srfi/160/c64#c64vector-fill!__1 _g299454_))
              ((let () (declare (not safe)) (##fx= _g299453_ 4))
               (apply std/srfi/160/c64#c64vector-fill!__% _g299454_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-fill!
                _g299454_))))))
  (define std/srfi/160/c64#c64vector-reverse!__%
    (lambda (_v149114_ _start149116_ _end149118_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v149114_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _v149114_))
        (if (and (fixnum? _start149116_)
                 (fx<= '0
                       _start149116_
                       (fx- (std/srfi/160/cvector#c64vector-length _v149114_)
                            '1)))
            '#!void
            (error '"Index out of range" _start149116_))
        (if (and (fixnum? _end149118_)
                 (fx<= _start149116_
                       _end149118_
                       (std/srfi/160/cvector#c64vector-length _v149114_)))
            '#!void
            (error '"Index out of range" _end149118_))
        (let _lp149122_ ((_i149125_ _start149116_)
                         (_j149127_ (fx- _end149118_ '1)))
          (if (fx< _i149125_ _j149127_)
              (let ((_iv149130_
                     (std/srfi/160/cvector#c64vector-ref _v149114_ _i149125_))
                    (_jv149132_
                     (std/srfi/160/cvector#c64vector-ref _v149114_ _j149127_)))
                (std/srfi/160/cvector#c64vector-set!
                 _v149114_
                 _i149125_
                 _jv149132_)
                (std/srfi/160/cvector#c64vector-set!
                 _v149114_
                 _j149127_
                 _iv149130_)
                (_lp149122_ (fx+ _i149125_ '1) (fx- _j149127_ '1)))
              '#!void)))))
  (define std/srfi/160/c64#c64vector-reverse!__0
    (lambda (_v149138_)
      (let* ((_start149140_ '0)
             (_end149142_ (std/srfi/160/cvector#c64vector-length _v149138_)))
        (std/srfi/160/c64#c64vector-reverse!__%
         _v149138_
         _start149140_
         _end149142_))))
  (define std/srfi/160/c64#c64vector-reverse!__1
    (lambda (_v149144_ _start149145_)
      (let ((_end149147_ (std/srfi/160/cvector#c64vector-length _v149144_)))
        (std/srfi/160/c64#c64vector-reverse!__%
         _v149144_
         _start149145_
         _end149147_))))
  (define std/srfi/160/c64#c64vector-reverse!
    (lambda _g299456_
      (let ((_g299455_ (let () (declare (not safe)) (##length _g299456_))))
        (cond ((let () (declare (not safe)) (##fx= _g299455_ 1))
               (apply std/srfi/160/c64#c64vector-reverse!__0 _g299456_))
              ((let () (declare (not safe)) (##fx= _g299455_ 2))
               (apply std/srfi/160/c64#c64vector-reverse!__1 _g299456_))
              ((let () (declare (not safe)) (##fx= _g299455_ 3))
               (apply std/srfi/160/c64#c64vector-reverse!__% _g299456_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector-reverse!
                _g299456_))))))
  (define std/srfi/160/c64#c64vector-unfold!
    (lambda (_f149089_ _v149091_ _start149093_ _end149095_ _seed149097_)
      (declare (not safe))
      (begin
        (if (procedure? _f149089_)
            '#!void
            (error '"Bad argument; expected procedure" _f149089_))
        (if (##structure-direct-instance-of?
             _v149091_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _v149091_))
        (if (and (fixnum? _start149093_)
                 (fx<= '0
                       _start149093_
                       (fx- (std/srfi/160/cvector#c64vector-length _v149091_)
                            '1)))
            '#!void
            (error '"Index out of range" _start149093_))
        (if (and (fixnum? _end149095_)
                 (fx<= _start149093_
                       _end149095_
                       (std/srfi/160/cvector#c64vector-length _v149091_)))
            '#!void
            (error '"Index out of range" _end149095_))
        (let _lp149101_ ((_i149104_ _start149093_)
                         (_state149106_ _seed149097_))
          (if (fx< _i149104_ _end149095_)
              (let ((_g299457_ (_f149089_ _state149106_)))
                (begin
                  (let ((_g299458_
                         (if (##values? _g299457_)
                             (##vector-length _g299457_)
                             1)))
                    (if (not (##fx= _g299458_ 2))
                        (error "Context expects 2 values" _g299458_)))
                  (let ((_x149109_ (##vector-ref _g299457_ 0))
                        (_state149111_ (##vector-ref _g299457_ 1)))
                    (begin
                      (std/srfi/160/cvector#c64vector-set!
                       _v149091_
                       _i149104_
                       _x149109_)
                      (_lp149101_ (fx+ _i149104_ '1) _state149111_)))))
              '#!void)))))
  (define std/srfi/160/c64#c64vector-unfold-right!
    (lambda (_f149065_ _v149067_ _start149069_ _end149071_ _seed149073_)
      (declare (not safe))
      (begin
        (if (procedure? _f149065_)
            '#!void
            (error '"Bad argument; expected procedure" _f149065_))
        (if (##structure-direct-instance-of?
             _v149067_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _v149067_))
        (if (and (fixnum? _start149069_)
                 (fx<= '0
                       _start149069_
                       (fx- (std/srfi/160/cvector#c64vector-length _v149067_)
                            '1)))
            '#!void
            (error '"Index out of range" _start149069_))
        (if (and (fixnum? _end149071_)
                 (fx<= _start149069_
                       _end149071_
                       (std/srfi/160/cvector#c64vector-length _v149067_)))
            '#!void
            (error '"Index out of range" _end149071_))
        (let _lp149077_ ((_i149080_ (fx- _end149071_ '1))
                         (_state149082_ _seed149073_))
          (if (fx>= _i149080_ _start149069_)
              (let ((_g299459_ (_f149065_ _state149082_)))
                (begin
                  (let ((_g299460_
                         (if (##values? _g299459_)
                             (##vector-length _g299459_)
                             1)))
                    (if (not (##fx= _g299460_ 2))
                        (error "Context expects 2 values" _g299460_)))
                  (let ((_x149085_ (##vector-ref _g299459_ 0))
                        (_state149087_ (##vector-ref _g299459_ 1)))
                    (begin
                      (std/srfi/160/cvector#c64vector-set!
                       _v149067_
                       _i149080_
                       _x149085_)
                      (_lp149077_ (fx- _i149080_ '1) _state149087_)))))
              '#!void)))))
  (define std/srfi/160/c64#reverse-c64vector->list__%
    (lambda (_v149031_ _start149033_ _end149035_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v149031_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _v149031_))
        (if (and (fixnum? _start149033_)
                 (fx<= '0
                       _start149033_
                       (fx- (std/srfi/160/cvector#c64vector-length _v149031_)
                            '1)))
            '#!void
            (error '"Index out of range" _start149033_))
        (if (and (fixnum? _end149035_)
                 (fx<= _start149033_
                       _end149035_
                       (std/srfi/160/cvector#c64vector-length _v149031_)))
            '#!void
            (error '"Index out of range" _end149035_))
        (let _lp149039_ ((_i149042_ _start149033_) (_r149044_ '()))
          (if (fx< _i149042_ _end149035_)
              (_lp149039_
               (fx+ _i149042_ '1)
               (cons (std/srfi/160/cvector#c64vector-ref _v149031_ _i149042_)
                     _r149044_))
              _r149044_)))))
  (define std/srfi/160/c64#reverse-c64vector->list__0
    (lambda (_v149050_)
      (let* ((_start149052_ '0)
             (_end149054_ (std/srfi/160/cvector#c64vector-length _v149050_)))
        (std/srfi/160/c64#reverse-c64vector->list__%
         _v149050_
         _start149052_
         _end149054_))))
  (define std/srfi/160/c64#reverse-c64vector->list__1
    (lambda (_v149056_ _start149057_)
      (let ((_end149059_ (std/srfi/160/cvector#c64vector-length _v149056_)))
        (std/srfi/160/c64#reverse-c64vector->list__%
         _v149056_
         _start149057_
         _end149059_))))
  (define std/srfi/160/c64#reverse-c64vector->list
    (lambda _g299462_
      (let ((_g299461_ (let () (declare (not safe)) (##length _g299462_))))
        (cond ((let () (declare (not safe)) (##fx= _g299461_ 1))
               (apply std/srfi/160/c64#reverse-c64vector->list__0 _g299462_))
              ((let () (declare (not safe)) (##fx= _g299461_ 2))
               (apply std/srfi/160/c64#reverse-c64vector->list__1 _g299462_))
              ((let () (declare (not safe)) (##fx= _g299461_ 3))
               (apply std/srfi/160/c64#reverse-c64vector->list__% _g299462_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#reverse-c64vector->list
                _g299462_))))))
  (define std/srfi/160/c64#reverse-list->c64vector
    (lambda (_lst148977_)
      (let* ((_len148980_ (length _lst148977_))
             (_v148983_
              (let ((__obj299419
                     (make-object std/srfi/160/cvector#c64vector::t '1)))
                (std/srfi/160/cvector#c64vector:::init!__0
                 __obj299419
                 _len148980_)
                __obj299419)))
        (declare (not safe))
        (let _lp148988_ ((_rest148991_ _lst148977_) (_i148993_ '0))
          (let* ((_rest148995149003_ _rest148991_)
                 (_else148997149011_ (lambda () _v148983_))
                 (_K148999149018_
                  (lambda (_rest149014_ _x149015_)
                    (if (std/srfi/160/base#c64? _x149015_)
                        '#!void
                        (error '"Bad element" _x149015_))
                    (std/srfi/160/cvector#c64vector-set!
                     _v148983_
                     _i148993_
                     _x149015_)
                    (_lp148988_ _rest149014_ (fx+ _i148993_ '1)))))
            (if (##pair? _rest148995149003_)
                (let ((_hd149000149021_ (##car _rest148995149003_))
                      (_tl149001149023_ (##cdr _rest148995149003_)))
                  (let* ((_x149026_ _hd149000149021_)
                         (_rest149028_ _tl149001149023_))
                    (_K148999149018_ _rest149028_ _x149026_)))
                (_else148997149011_)))))))
  (define std/srfi/160/c64#c64vector->vector__%
    (lambda (_v148938_ _start148940_ _end148942_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v148938_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _v148938_))
        (if (and (fixnum? _start148940_)
                 (fx<= '0
                       _start148940_
                       (fx- (std/srfi/160/cvector#c64vector-length _v148938_)
                            '1)))
            '#!void
            (error '"Index out of range" _start148940_))
        (if (and (fixnum? _end148942_)
                 (fx<= _start148940_
                       _end148942_
                       (std/srfi/160/cvector#c64vector-length _v148938_)))
            '#!void
            (error '"Index out of range" _end148942_))
        (let* ((_len148946_ (std/srfi/160/cvector#c64vector-length _v148938_))
               (_u148949_ (make-vector _len148946_)))
          (let _lp148953_ ((_i148956_ '0))
            (if (fx< _i148956_ _len148946_)
                (begin
                  (vector-set!
                   _u148949_
                   _i148956_
                   (std/srfi/160/cvector#c64vector-ref _v148938_ _i148956_))
                  (_lp148953_ (fx+ _i148956_ '1)))
                _u148949_))))))
  (define std/srfi/160/c64#c64vector->vector__0
    (lambda (_v148962_)
      (let* ((_start148964_ '0)
             (_end148966_ (std/srfi/160/cvector#c64vector-length _v148962_)))
        (std/srfi/160/c64#c64vector->vector__%
         _v148962_
         _start148964_
         _end148966_))))
  (define std/srfi/160/c64#c64vector->vector__1
    (lambda (_v148968_ _start148969_)
      (let ((_end148971_ (std/srfi/160/cvector#c64vector-length _v148968_)))
        (std/srfi/160/c64#c64vector->vector__%
         _v148968_
         _start148969_
         _end148971_))))
  (define std/srfi/160/c64#c64vector->vector
    (lambda _g299464_
      (let ((_g299463_ (let () (declare (not safe)) (##length _g299464_))))
        (cond ((let () (declare (not safe)) (##fx= _g299463_ 1))
               (apply std/srfi/160/c64#c64vector->vector__0 _g299464_))
              ((let () (declare (not safe)) (##fx= _g299463_ 2))
               (apply std/srfi/160/c64#c64vector->vector__1 _g299464_))
              ((let () (declare (not safe)) (##fx= _g299463_ 3))
               (apply std/srfi/160/c64#c64vector->vector__% _g299464_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#c64vector->vector
                _g299464_))))))
  (define std/srfi/160/c64#vector->c64vector__%
    (lambda (_v148898_ _start148900_ _end148902_)
      (declare (not safe))
      (begin
        (if (vector? _v148898_)
            '#!void
            (error '"Bad argument; expected vector" _v148898_))
        (if (and (fixnum? _start148900_)
                 (fx<= '0 _start148900_ (fx- (vector-length _v148898_) '1)))
            '#!void
            (error '"Index out of range" _start148900_))
        (if (and (fixnum? _end148902_)
                 (fx<= _start148900_ _end148902_ (vector-length _v148898_)))
            '#!void
            (error '"Index out of range" _end148902_))
        (let* ((_len148906_ (vector-length _v148898_))
               (_u148909_
                (let ((__obj299420
                       (make-object std/srfi/160/cvector#c64vector::t '1)))
                  (std/srfi/160/cvector#c64vector:::init!__0
                   __obj299420
                   _len148906_)
                  __obj299420)))
          (let _lp148913_ ((_i148916_ '0))
            (if (fx< _i148916_ _len148906_)
                (begin
                  (std/srfi/160/cvector#c64vector-set!
                   _u148909_
                   _i148916_
                   (vector-ref _v148898_ _i148916_))
                  (_lp148913_ (fx+ _i148916_ '1)))
                _u148909_))))))
  (define std/srfi/160/c64#vector->c64vector__0
    (lambda (_v148922_)
      (let* ((_start148924_ '0) (_end148926_ (vector-length _v148922_)))
        (std/srfi/160/c64#vector->c64vector__%
         _v148922_
         _start148924_
         _end148926_))))
  (define std/srfi/160/c64#vector->c64vector__1
    (lambda (_v148928_ _start148929_)
      (let ((_end148931_ (vector-length _v148928_)))
        (std/srfi/160/c64#vector->c64vector__%
         _v148928_
         _start148929_
         _end148931_))))
  (define std/srfi/160/c64#vector->c64vector
    (lambda _g299466_
      (let ((_g299465_ (let () (declare (not safe)) (##length _g299466_))))
        (cond ((let () (declare (not safe)) (##fx= _g299465_ 1))
               (apply std/srfi/160/c64#vector->c64vector__0 _g299466_))
              ((let () (declare (not safe)) (##fx= _g299465_ 2))
               (apply std/srfi/160/c64#vector->c64vector__1 _g299466_))
              ((let () (declare (not safe)) (##fx= _g299465_ 3))
               (apply std/srfi/160/c64#vector->c64vector__% _g299466_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#vector->c64vector
                _g299466_))))))
  (define std/srfi/160/c64#make-c64vector-generator__%
    (lambda (_v148864_ _start148866_ _end148868_)
      (declare (not safe))
      (begin
        (if (##structure-direct-instance-of?
             _v148864_
             'std/srfi/160/cvector#c64vector::t)
            '#!void
            (error '"Bad argument" _v148864_))
        (if (and (fixnum? _start148866_)
                 (fx<= '0
                       _start148866_
                       (fx- (std/srfi/160/cvector#c64vector-length _v148864_)
                            '1)))
            '#!void
            (error '"Index out of range" _start148866_))
        (if (and (fixnum? _end148868_)
                 (fx<= _start148866_
                       _end148868_
                       (std/srfi/160/cvector#c64vector-length _v148864_)))
            '#!void
            (error '"Index out of range" _end148868_))
        (let ((_i148872_ _start148866_))
          (lambda ()
            (if (fx< _i148872_ _end148868_)
                (let ((_next148876_
                       (std/srfi/160/cvector#c64vector-ref
                        _v148864_
                        _i148872_)))
                  (set! _i148872_ (fx+ _i148872_ '1))
                  _next148876_)
                '#!eof))))))
  (define std/srfi/160/c64#make-c64vector-generator__0
    (lambda (_v148882_)
      (let* ((_start148884_ '0)
             (_end148886_ (std/srfi/160/cvector#c64vector-length _v148882_)))
        (std/srfi/160/c64#make-c64vector-generator__%
         _v148882_
         _start148884_
         _end148886_))))
  (define std/srfi/160/c64#make-c64vector-generator__1
    (lambda (_v148888_ _start148889_)
      (let ((_end148891_ (std/srfi/160/cvector#c64vector-length _v148888_)))
        (std/srfi/160/c64#make-c64vector-generator__%
         _v148888_
         _start148889_
         _end148891_))))
  (define std/srfi/160/c64#make-c64vector-generator
    (lambda _g299468_
      (let ((_g299467_ (let () (declare (not safe)) (##length _g299468_))))
        (cond ((let () (declare (not safe)) (##fx= _g299467_ 1))
               (apply std/srfi/160/c64#make-c64vector-generator__0 _g299468_))
              ((let () (declare (not safe)) (##fx= _g299467_ 2))
               (apply std/srfi/160/c64#make-c64vector-generator__1 _g299468_))
              ((let () (declare (not safe)) (##fx= _g299467_ 3))
               (apply std/srfi/160/c64#make-c64vector-generator__% _g299468_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#make-c64vector-generator
                _g299468_))))))
  (define std/srfi/160/c64#c64vector-comparator
    (let ()
      (letrec ((_<?148835_
                (lambda (_a148838_ _b148840_)
                  (let ((_len-a148843_
                         (std/srfi/160/cvector#c64vector-length _a148838_))
                        (_len-b148845_
                         (std/srfi/160/cvector#c64vector-length _b148840_)))
                    (declare (not safe))
                    (if (fx< _len-a148843_ _len-b148845_)
                        '#t
                        (if (fx> _len-a148843_ _len-b148845_)
                            '#f
                            (let ((_end148849_ _len-a148843_))
                              (let _lp148852_ ((_i148855_ '0))
                                (if (fx< _i148855_ _end148849_)
                                    (let ((_x148858_
                                           (std/srfi/160/cvector#c64vector-ref
                                            _a148838_
                                            _i148855_))
                                          (_y148860_
                                           (std/srfi/160/cvector#c64vector-ref
                                            _b148840_
                                            _i148855_)))
                                      (if (< _x148858_ _y148860_)
                                          '#t
                                          (if (> _x148858_ _y148860_)
                                              '#f
                                              (_lp148852_
                                               (fx+ _i148855_ '1)))))
                                    '#f)))))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           std/srfi/160/cvector#c64vector?
           std/srfi/160/c64#c64vector=
           _<?148835_
           equal?-hash)))))
  (define std/srfi/160/c64#write-c64vector__%
    (lambda (_v148812_ _port148814_)
      (let ((_$e148817_ (find-method _v148812_ ':write)))
        (if _$e148817_
            ((lambda (_g148819148821_)
               (_g148819148821_ _v148812_ _port148814_))
             _$e148817_)
            (write _v148812_ (current-output-port))))))
  (define std/srfi/160/c64#write-c64vector__0
    (lambda (_v148827_)
      (let ((_port148829_ (current-output-port)))
        (std/srfi/160/c64#write-c64vector__% _v148827_ _port148829_))))
  (define std/srfi/160/c64#write-c64vector
    (lambda _g299470_
      (let ((_g299469_ (let () (declare (not safe)) (##length _g299470_))))
        (cond ((let () (declare (not safe)) (##fx= _g299469_ 1))
               (apply std/srfi/160/c64#write-c64vector__0 _g299470_))
              ((let () (declare (not safe)) (##fx= _g299469_ 2))
               (apply std/srfi/160/c64#write-c64vector__% _g299470_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/c64#write-c64vector
                _g299470_)))))))
