(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/160/f32#f32vector-unfold
    (lambda (_f147361_ _len147363_ _seed147365_)
      (declare (not safe))
      (begin
        (if (procedure? _f147361_)
            '#!void
            (error '"Bad argument; expected procedure" _f147361_))
        (let ((_v147369_ (make-f32vector _len147363_)))
          (let _lp147372_ ((_i147375_ '0) (_state147377_ _seed147365_))
            (if (fx< _i147375_ _len147363_)
                (let ((_g299304_ (_f147361_ _i147375_ _state147377_)))
                  (begin
                    (let ((_g299305_
                           (if (##values? _g299304_)
                               (##vector-length _g299304_)
                               1)))
                      (if (not (##fx= _g299305_ 2))
                          (error "Context expects 2 values" _g299305_)))
                    (let ((_x147380_ (##vector-ref _g299304_ 0))
                          (_state147382_ (##vector-ref _g299304_ 1)))
                      (begin
                        (if (flonum? _x147380_)
                            '#!void
                            (error '"Bad generated value" _x147380_))
                        (f32vector-set! _v147369_ _i147375_ _x147380_)
                        (_lp147372_ (fx+ _i147375_ '1) _state147382_)))))
                _v147369_))))))
  (define std/srfi/160/f32#f32vector-unfold-right
    (lambda (_f147338_ _len147340_ _seed147342_)
      (declare (not safe))
      (begin
        (if (procedure? _f147338_)
            '#!void
            (error '"Bad argument; expected procedure" _f147338_))
        (let ((_v147346_ (make-f32vector _len147340_)))
          (let _lp147349_ ((_i147352_ (fx- _len147340_ '1))
                           (_state147354_ _seed147342_))
            (if (fx>= _i147352_ '0)
                (let ((_g299306_ (_f147338_ _i147352_ _state147354_)))
                  (begin
                    (let ((_g299307_
                           (if (##values? _g299306_)
                               (##vector-length _g299306_)
                               1)))
                      (if (not (##fx= _g299307_ 2))
                          (error "Context expects 2 values" _g299307_)))
                    (let ((_x147357_ (##vector-ref _g299306_ 0))
                          (_state147359_ (##vector-ref _g299306_ 1)))
                      (begin
                        (if (flonum? _x147357_)
                            '#!void
                            (error '"Bad generated value" _x147357_))
                        (f32vector-set! _v147346_ _i147352_ _x147357_)
                        (_lp147349_ (fx- _i147352_ '1) _state147359_)))))
                _v147346_))))))
  (define std/srfi/160/f32#f32vector-copy__%
    (lambda (_vec147310_ _start147312_ _end147314_)
      (let ((_v147317_ (make-f32vector (fx- _end147314_ _start147312_))))
        (std/srfi/160/f32#f32vector-copy!
         _v147317_
         '0
         _vec147310_
         _start147312_
         _end147314_)
        _v147317_)))
  (define std/srfi/160/f32#f32vector-copy__0
    (lambda (_vec147323_)
      (let* ((_start147325_ '0) (_end147327_ (f32vector-length _vec147323_)))
        (std/srfi/160/f32#f32vector-copy__%
         _vec147323_
         _start147325_
         _end147327_))))
  (define std/srfi/160/f32#f32vector-copy__1
    (lambda (_vec147329_ _start147330_)
      (let ((_end147332_ (f32vector-length _vec147329_)))
        (std/srfi/160/f32#f32vector-copy__%
         _vec147329_
         _start147330_
         _end147332_))))
  (define std/srfi/160/f32#f32vector-copy
    (lambda _g299309_
      (let ((_g299308_ (let () (declare (not safe)) (##length _g299309_))))
        (cond ((let () (declare (not safe)) (##fx= _g299308_ 1))
               (apply std/srfi/160/f32#f32vector-copy__0 _g299309_))
              ((let () (declare (not safe)) (##fx= _g299308_ 2))
               (apply std/srfi/160/f32#f32vector-copy__1 _g299309_))
              ((let () (declare (not safe)) (##fx= _g299308_ 3))
               (apply std/srfi/160/f32#f32vector-copy__% _g299309_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-copy
                _g299309_))))))
  (define std/srfi/160/f32#f32vector-copy!
    (lambda (_to147289_ _at147291_ _from147293_ _start147295_ _end147297_)
      (declare (not safe))
      (begin
        (if (f32vector? _to147289_) '#!void (error '"Bad argument" _to147289_))
        (if (f32vector? _from147293_)
            '#!void
            (error '"Bad argument" _from147293_))
        (if (and (fixnum? _at147291_)
                 (fx<= '0 _at147291_ (fx- (f32vector-length _at147291_) '1)))
            '#!void
            (error '"Index out of range" _to147289_ _at147291_))
        (if (and (fixnum? _start147295_)
                 (fx<= '0
                       _start147295_
                       (fx- (f32vector-length _from147293_) '1)))
            '#!void
            (error '"Index out of range" _from147293_ _start147295_))
        (if (and (fixnum? _end147297_)
                 (fx<= _start147295_
                       _end147297_
                       (f32vector-length _from147293_)))
            '#!void
            (error '"Index out of range" _from147293_ _end147297_))
        (if (fx<= (fx- _end147297_ _start147295_)
                  (fx- (f32vector-length _to147289_) _at147291_))
            '#!void
            (error '"Destination area too small"
                   _to147289_
                   _at147291_
                   _from147293_
                   _start147295_
                   _end147297_))
        (let _lp147301_ ((_i147304_ _start147295_) (_j147306_ _at147291_))
          (if (fx< _i147304_ _end147297_)
              (begin
                (f32vector-set!
                 _to147289_
                 _j147306_
                 (f32vector-ref _from147293_ _i147304_))
                (_lp147301_ (fx+ _i147304_ '1) (fx+ _j147306_ '1)))
              '#!void)))))
  (define std/srfi/160/f32#f32vector-reverse-copy__%
    (lambda (_vec147261_ _start147263_ _end147265_)
      (let ((_v147268_ (make-f32vector (fx- _end147265_ _start147263_))))
        (std/srfi/160/f32#f32vector-reverse-copy!
         _v147268_
         '0
         _vec147261_
         _start147263_
         _end147265_)
        _v147268_)))
  (define std/srfi/160/f32#f32vector-reverse-copy__0
    (lambda (_vec147274_)
      (let* ((_start147276_ '0) (_end147278_ (f32vector-length _vec147274_)))
        (std/srfi/160/f32#f32vector-reverse-copy__%
         _vec147274_
         _start147276_
         _end147278_))))
  (define std/srfi/160/f32#f32vector-reverse-copy__1
    (lambda (_vec147280_ _start147281_)
      (let ((_end147283_ (f32vector-length _vec147280_)))
        (std/srfi/160/f32#f32vector-reverse-copy__%
         _vec147280_
         _start147281_
         _end147283_))))
  (define std/srfi/160/f32#f32vector-reverse-copy
    (lambda _g299311_
      (let ((_g299310_ (let () (declare (not safe)) (##length _g299311_))))
        (cond ((let () (declare (not safe)) (##fx= _g299310_ 1))
               (apply std/srfi/160/f32#f32vector-reverse-copy__0 _g299311_))
              ((let () (declare (not safe)) (##fx= _g299310_ 2))
               (apply std/srfi/160/f32#f32vector-reverse-copy__1 _g299311_))
              ((let () (declare (not safe)) (##fx= _g299310_ 3))
               (apply std/srfi/160/f32#f32vector-reverse-copy__% _g299311_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-reverse-copy
                _g299311_))))))
  (define std/srfi/160/f32#f32vector-reverse-copy!
    (lambda (_to147240_ _at147242_ _from147244_ _start147246_ _end147248_)
      (declare (not safe))
      (begin
        (if (f32vector? _to147240_) '#!void (error '"Bad argument" _to147240_))
        (if (f32vector? _from147244_)
            '#!void
            (error '"Bad argument" _from147244_))
        (if (and (fixnum? _at147242_)
                 (fx<= '0 _at147242_ (fx- (f32vector-length _at147242_) '1)))
            '#!void
            (error '"Index out of range" _to147240_ _at147242_))
        (if (and (fixnum? _start147246_)
                 (fx<= '0
                       _start147246_
                       (fx- (f32vector-length _from147244_) '1)))
            '#!void
            (error '"Index out of range" _from147244_ _start147246_))
        (if (and (fixnum? _end147248_)
                 (fx<= _start147246_
                       _end147248_
                       (f32vector-length _from147244_)))
            '#!void
            (error '"Index out of range" _from147244_ _end147248_))
        (if (fx<= (fx- _end147248_ _start147246_)
                  (fx- (f32vector-length _to147240_) _at147242_))
            '#!void
            (error '"Destination area too small"
                   _to147240_
                   _at147242_
                   _from147244_
                   _start147246_
                   _end147248_))
        (let _lp147252_ ((_i147255_ (fx- _end147248_ '1))
                         (_j147257_ _at147242_))
          (if (fx>= _i147255_ _start147246_)
              (begin
                (f32vector-set!
                 _to147240_
                 _j147257_
                 (f32vector-ref _from147244_ _i147255_))
                (_lp147252_ (fx- _i147255_ '1) (fx+ _j147257_ '1)))
              '#!void)))))
  (define std/srfi/160/f32#f32vector-append
    (lambda _args147237_
      (std/srfi/160/f32#f32vector-concatenate _args147237_)))
  (define std/srfi/160/f32#f32vector-concatenate
    (lambda (_lst147177_)
      (let* ((_len147185_
              (foldl1 (lambda (_v147180_ _r147182_)
                        (fx+ (f32vector-length _v147180_) _r147182_))
                      '0
                      _lst147177_))
             (_v147188_ (make-f32vector _len147185_)))
        (declare (not safe))
        (let _lp147192_ ((_rest147195_ _lst147177_) (_at147197_ '0))
          (let* ((_rest147199147207_ _rest147195_)
                 (_else147201147215_ (lambda () _v147188_))
                 (_K147203147225_
                  (lambda (_rest147218_ _u147219_)
                    (let ((_ulen147222_ (f32vector-length _u147219_)))
                      (std/srfi/160/f32#f32vector-copy!
                       _v147188_
                       _at147197_
                       _u147219_
                       '0
                       _ulen147222_)
                      (_lp147192_
                       _rest147218_
                       (fx+ _at147197_ _ulen147222_))))))
            (if (##pair? _rest147199147207_)
                (let ((_hd147204147228_ (##car _rest147199147207_))
                      (_tl147205147230_ (##cdr _rest147199147207_)))
                  (let* ((_u147233_ _hd147204147228_)
                         (_rest147235_ _tl147205147230_))
                    (_K147203147225_ _rest147235_ _u147233_)))
                (_else147201147215_)))))))
  (define std/srfi/160/f32#f32vector-append-subvectors
    (lambda _args147049_
      (let* ((_len147110_
              (let _lp147052_ ((_rest147055_ _args147049_) (_r147057_ '0))
                (let* ((_rest147059147071_ _rest147055_)
                       (_else147061147079_ (lambda () _r147057_))
                       (_K147063147088_
                        (lambda (_rest147082_ _end147083_ _start147085_)
                          (_lp147052_
                           _rest147082_
                           (fx+ _r147057_ (fx- _end147083_ _start147085_))))))
                  (if (let ()
                        (declare (not safe))
                        (##pair? _rest147059147071_))
                      (let ((_tl147065147091_
                             (let ()
                               (declare (not safe))
                               (##cdr _rest147059147071_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl147065147091_))
                            (let ((_hd147066147094_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl147065147091_)))
                                  (_tl147067147096_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl147065147091_))))
                              (let ((_start147099_ _hd147066147094_))
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl147067147096_))
                                    (let ((_hd147068147101_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl147067147096_)))
                                          (_tl147069147103_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl147067147096_))))
                                      (let* ((_end147106_ _hd147068147101_)
                                             (_rest147108_ _tl147069147103_))
                                        (_K147063147088_
                                         _rest147108_
                                         _end147106_
                                         _start147099_)))
                                    (_else147061147079_))))
                            (_else147061147079_)))
                      (_else147061147079_)))))
             (_v147113_ (make-f32vector _len147110_)))
        (let _lp147117_ ((_rest147119_ _args147049_) (_at147120_ '0))
          (let* ((_rest147122147134_ _rest147119_)
                 (_else147124147142_ (lambda () _v147113_))
                 (_K147126147151_
                  (lambda (_rest147145_ _end147146_ _start147147_ _u147148_)
                    (std/srfi/160/f32#f32vector-copy!
                     _v147113_
                     _at147120_
                     _u147148_
                     _start147147_
                     _end147146_)
                    (_lp147117_
                     _rest147145_
                     (fx+ _at147120_ (fx- _end147146_ _start147147_))))))
            (if (let () (declare (not safe)) (##pair? _rest147122147134_))
                (let ((_hd147127147154_
                       (let ()
                         (declare (not safe))
                         (##car _rest147122147134_)))
                      (_tl147128147156_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest147122147134_))))
                  (let ((_u147159_ _hd147127147154_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl147128147156_))
                        (let ((_hd147129147161_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl147128147156_)))
                              (_tl147130147163_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl147128147156_))))
                          (let ((_start147166_ _hd147129147161_))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl147130147163_))
                                (let ((_hd147131147168_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl147130147163_)))
                                      (_tl147132147170_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _tl147130147163_))))
                                  (let* ((_end147173_ _hd147131147168_)
                                         (_rest147175_ _tl147132147170_))
                                    (_K147126147151_
                                     _rest147175_
                                     _end147173_
                                     _start147166_
                                     _u147159_)))
                                (_else147124147142_))))
                        (_else147124147142_))))
                (_else147124147142_)))))))
  (define std/srfi/160/f32#f32vector-empty?
    (lambda (_v147046_) (fxzero? (f32vector-length _v147046_))))
  (define std/srfi/160/f32#f32vector=
    (lambda (_v146988_ . _args146990_)
      (declare (not safe))
      (begin
        (if (f32vector? _v146988_) '#!void (error '"Bad argument" _v146988_))
        (let ((_vlen146994_ (f32vector-length _v146988_)))
          (let _lp146997_ ((_rest147000_ _args146990_))
            (let* ((_rest147002147010_ _rest147000_)
                   (_else147004147018_ (lambda () '#t))
                   (_K147006147034_
                    (lambda (_rest147021_ _u147022_)
                      (if (f32vector? _u147022_)
                          '#!void
                          (error '"Bad argument" _u147022_))
                      (let ((_ulen147025_ (f32vector-length _u147022_)))
                        (if (fx= _vlen146994_ _ulen147025_)
                            (let _cmp147028_ ((_i147031_ '0))
                              (if (fx< _i147031_ _vlen146994_)
                                  (if (= (f32vector-ref _v146988_ _i147031_)
                                         (f32vector-ref _u147022_ _i147031_))
                                      (_cmp147028_ (fx+ _i147031_ '1))
                                      '#f)
                                  (_lp146997_ _rest147021_)))
                            '#f)))))
              (if (##pair? _rest147002147010_)
                  (let ((_hd147007147037_ (##car _rest147002147010_))
                        (_tl147008147039_ (##cdr _rest147002147010_)))
                    (let* ((_u147042_ _hd147007147037_)
                           (_rest147044_ _tl147008147039_))
                      (_K147006147034_ _rest147044_ _u147042_)))
                  (_else147004147018_))))))))
  (define std/srfi/160/f32#f32vector-take
    (lambda (_v146980_ _n146982_)
      (let ((_u146985_ (make-f32vector _n146982_)))
        (std/srfi/160/f32#f32vector-copy! _u146985_ '0 _v146980_ '0 _n146982_)
        _u146985_)))
  (define std/srfi/160/f32#f32vector-take-right
    (lambda (_v146965_ _n146967_)
      (let* ((_vlen146970_ (f32vector-length _v146965_))
             (_ulen146973_ (fx- _vlen146970_ _n146967_))
             (_u146976_ (make-f32vector _ulen146973_)))
        (std/srfi/160/f32#f32vector-copy!
         _u146976_
         '0
         _v146965_
         _n146967_
         _vlen146970_)
        _u146976_)))
  (define std/srfi/160/f32#f32vector-drop
    (lambda (_v146950_ _n146952_)
      (let* ((_vlen146955_ (f32vector-length _v146950_))
             (_ulen146958_ (fx- _vlen146955_ _n146952_))
             (_u146961_ (make-f32vector _ulen146958_)))
        (std/srfi/160/f32#f32vector-copy!
         _u146961_
         '0
         _v146950_
         _n146952_
         _vlen146955_)
        _u146961_)))
  (define std/srfi/160/f32#f32vector-drop-right
    (lambda (_v146935_ _n146937_)
      (let* ((_vlen146940_ (f32vector-length _v146935_))
             (_ulen146943_ (fx- _vlen146940_ _n146937_))
             (_u146946_ (make-f32vector _ulen146943_)))
        (std/srfi/160/f32#f32vector-copy!
         _u146946_
         '0
         _v146935_
         '0
         _ulen146943_)
        _u146946_)))
  (define std/srfi/160/f32#f32vector-segment
    (lambda (_v146917_ _n146919_)
      (let _lp146922_ ((_i146925_ '0)
                       (_rest146927_ (f32vector-length _v146917_))
                       (_r146929_ '()))
        (if (fx> _r146929_ '0)
            (let ((_size146932_ (fxmin _n146919_ _rest146927_)))
              (_lp146922_
               (fx+ _i146925_ _size146932_)
               (fx- _rest146927_ _size146932_)
               (cons (std/srfi/160/f32#f32vector-copy__%
                      _v146917_
                      _i146925_
                      (fx+ _i146925_ _size146932_))
                     _r146929_)))
            (reverse _r146929_)))))
  (define std/srfi/160/f32#f32vector-fold__0
    (lambda (_kons146877_ _knil146879_ _v146881_)
      (if (procedure? _kons146877_)
          '#!void
          (error '"Bad argument; expected procedure" _kons146877_))
      (let ((_end146884_ (f32vector-length _v146881_)))
        (declare (not safe))
        (let _lp146888_ ((_i146891_ '0) (_r146893_ _knil146879_))
          (if (fx< _i146891_ _end146884_)
              (_lp146888_
               (fx+ _i146891_ '1)
               (_kons146877_ _r146893_ (f32vector-ref _v146881_ _i146891_)))
              _r146893_)))))
  (define std/srfi/160/f32#f32vector-fold__1
    (lambda (_kons146896_ _knil146897_ _v146898_ . _vs146899_)
      (if (procedure? _kons146896_)
          '#!void
          (error '"Bad argument; expected procedure" _kons146896_))
      (let* ((_vs146902_ (cons _v146898_ _vs146899_))
             (_end146904_ (apply fxmin (map f32vector-length _vs146902_))))
        (declare (not safe))
        (let _lp146908_ ((_i146910_ '0) (_r146911_ _knil146897_))
          (if (fx< _i146910_ _end146904_)
              (_lp146908_
               (fx+ _i146910_ '1)
               (apply _kons146896_
                      _r146911_
                      (map (lambda (_g146912146914_)
                             (f32vector-ref _g146912146914_ _i146910_))
                           _vs146902_)))
              _r146911_)))))
  (define std/srfi/160/f32#f32vector-fold
    (lambda _g299313_
      (let ((_g299312_ (let () (declare (not safe)) (##length _g299313_))))
        (cond ((let () (declare (not safe)) (##fx= _g299312_ 3))
               (apply std/srfi/160/f32#f32vector-fold__0 _g299313_))
              ((let () (declare (not safe)) (##fx>= _g299312_ 3))
               (apply std/srfi/160/f32#f32vector-fold__1 _g299313_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-fold
                _g299313_))))))
  (define std/srfi/160/f32#f32vector-fold-right__0
    (lambda (_kons146837_ _knil146839_ _v146841_)
      (if (procedure? _kons146837_)
          '#!void
          (error '"Bad argument; expected procedure" _kons146837_))
      (let ((_last146844_ (fx- (f32vector-length _v146841_) '1)))
        (declare (not safe))
        (let _lp146848_ ((_i146851_ _last146844_) (_r146853_ _knil146839_))
          (if (fx>= _i146851_ '0)
              (_lp146848_
               (fx- _i146851_ '1)
               (_kons146837_ _r146853_ (f32vector-ref _v146841_ _i146851_)))
              _r146853_)))))
  (define std/srfi/160/f32#f32vector-fold-right__1
    (lambda (_kons146856_ _knil146857_ _v146858_ . _vs146859_)
      (if (procedure? _kons146856_)
          '#!void
          (error '"Bad argument; expected procedure" _kons146856_))
      (let* ((_vs146862_ (cons _v146858_ _vs146859_))
             (_last146864_
              (fx- (apply min (map f32vector-length _vs146862_)) '1)))
        (declare (not safe))
        (let _lp146868_ ((_i146870_ _last146864_) (_r146871_ _knil146857_))
          (if (fx>= _i146870_ '0)
              (_lp146868_
               (fx- _i146870_ '1)
               (apply _kons146856_
                      _r146871_
                      (map (lambda (_g146872146874_)
                             (f32vector-ref _g146872146874_ _i146870_))
                           _vs146862_)))
              _r146871_)))))
  (define std/srfi/160/f32#f32vector-fold-right
    (lambda _g299315_
      (let ((_g299314_ (let () (declare (not safe)) (##length _g299315_))))
        (cond ((let () (declare (not safe)) (##fx= _g299314_ 3))
               (apply std/srfi/160/f32#f32vector-fold-right__0 _g299315_))
              ((let () (declare (not safe)) (##fx>= _g299314_ 3))
               (apply std/srfi/160/f32#f32vector-fold-right__1 _g299315_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-fold-right
                _g299315_))))))
  (define std/srfi/160/f32#f32vector-map__0
    (lambda (_f146797_ _v146799_)
      (if (procedure? _f146797_)
          '#!void
          (error '"Bad argument; expected procedure" _f146797_))
      (let* ((_len146802_ (f32vector-length _v146799_))
             (_u146805_ (make-f32vector _len146802_)))
        (declare (not safe))
        (let _lp146810_ ((_i146813_ '0))
          (if (fx< _i146813_ _len146802_)
              (begin
                (f32vector-set!
                 _u146805_
                 _i146813_
                 (f32vector-ref _v146799_ _i146813_))
                (_lp146810_ (fx+ _i146813_ '1)))
              _u146805_)))))
  (define std/srfi/160/f32#f32vector-map__1
    (lambda (_f146816_ _v146817_ . _vs146818_)
      (if (procedure? _f146816_)
          '#!void
          (error '"Bad argument; expected procedure" _f146816_))
      (let* ((_vs146821_ (cons _v146817_ _vs146818_))
             (_len146823_ (apply fxmin (map f32vector-length _vs146821_)))
             (_u146825_ (make-f32vector _len146823_)))
        (declare (not safe))
        (let _lp146829_ ((_i146831_ '0))
          (if (fx< _i146831_ _len146823_)
              (begin
                (f32vector-set!
                 _u146825_
                 _i146831_
                 (apply _f146816_
                        (map (lambda (_g146832146834_)
                               (f32vector-ref _g146832146834_ _i146831_))
                             _vs146821_)))
                (_lp146829_ (fx+ _i146831_ '1)))
              _u146825_)))))
  (define std/srfi/160/f32#f32vector-map
    (lambda _g299317_
      (let ((_g299316_ (let () (declare (not safe)) (##length _g299317_))))
        (cond ((let () (declare (not safe)) (##fx= _g299316_ 2))
               (apply std/srfi/160/f32#f32vector-map__0 _g299317_))
              ((let () (declare (not safe)) (##fx>= _g299316_ 2))
               (apply std/srfi/160/f32#f32vector-map__1 _g299317_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-map
                _g299317_))))))
  (define std/srfi/160/f32#f32vector-map!__0
    (lambda (_f146763_ _v146765_)
      (if (procedure? _f146763_)
          '#!void
          (error '"Bad argument; expected procedure" _f146763_))
      (let ((_len146768_ (f32vector-length _v146765_)))
        (declare (not safe))
        (let _lp146772_ ((_i146775_ '0))
          (if (fx< _i146775_ _len146768_)
              (begin
                (f32vector-set!
                 _v146765_
                 _i146775_
                 (_f146763_ (f32vector-ref _v146765_ _i146775_)))
                (_lp146772_ (fx+ _i146775_ '1)))
              _v146765_)))))
  (define std/srfi/160/f32#f32vector-map!__1
    (lambda (_f146778_ _v146779_ . _vs146780_)
      (if (procedure? _f146778_)
          '#!void
          (error '"Bad argument; expected procedure" _f146778_))
      (let* ((_vs146783_ (cons _v146779_ _vs146780_))
             (_len146785_ (apply fxmin (map f32vector-length _vs146783_))))
        (declare (not safe))
        (let _lp146789_ ((_i146791_ '0))
          (if (fx< _i146791_ _len146785_)
              (begin
                (f32vector-set!
                 _v146779_
                 _i146791_
                 (apply _f146778_
                        (map (lambda (_g146792146794_)
                               (f32vector-ref _g146792146794_ _i146791_))
                             _vs146783_)))
                (_lp146789_ (fx+ _i146791_ '1)))
              _v146779_)))))
  (define std/srfi/160/f32#f32vector-map!
    (lambda _g299319_
      (let ((_g299318_ (let () (declare (not safe)) (##length _g299319_))))
        (cond ((let () (declare (not safe)) (##fx= _g299318_ 2))
               (apply std/srfi/160/f32#f32vector-map!__0 _g299319_))
              ((let () (declare (not safe)) (##fx>= _g299318_ 2))
               (apply std/srfi/160/f32#f32vector-map!__1 _g299319_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-map!
                _g299319_))))))
  (define std/srfi/160/f32#f32vector-for-each__0
    (lambda (_f146729_ _v146731_)
      (if (procedure? _f146729_)
          '#!void
          (error '"Bad argument; expected procedure" _f146729_))
      (let ((_len146734_ (f32vector-length _v146731_)))
        (declare (not safe))
        (let _lp146738_ ((_i146741_ '0))
          (if (fx< _i146741_ _len146734_)
              (begin
                (_f146729_ (f32vector-ref _v146731_ _i146741_))
                (_lp146738_ (fx+ _i146741_ '1)))
              '#!void)))))
  (define std/srfi/160/f32#f32vector-for-each__1
    (lambda (_f146744_ _v146745_ . _vs146746_)
      (let* ((_vs146749_ (cons _v146745_ _vs146746_))
             (_len146751_ (apply fxmin (map f32vector-length _vs146749_))))
        (declare (not safe))
        (let _lp146755_ ((_i146757_ '0))
          (if (fx< _i146757_ _len146751_)
              (begin
                (apply _f146744_
                       (map (lambda (_g146758146760_)
                              (f32vector-ref _g146758146760_ _i146757_))
                            _vs146749_))
                (_lp146755_ (fx+ _i146757_ '1)))
              '#!void)))))
  (define std/srfi/160/f32#f32vector-for-each
    (lambda _g299321_
      (let ((_g299320_ (let () (declare (not safe)) (##length _g299321_))))
        (cond ((let () (declare (not safe)) (##fx= _g299320_ 2))
               (apply std/srfi/160/f32#f32vector-for-each__0 _g299321_))
              ((let () (declare (not safe)) (##fx>= _g299320_ 2))
               (apply std/srfi/160/f32#f32vector-for-each__1 _g299321_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-for-each
                _g299321_))))))
  (define std/srfi/160/f32#f32vector-count__0
    (lambda (_pred146692_ _v146694_)
      (if (procedure? _pred146692_)
          '#!void
          (error '"Bad argument; expected procedure" _pred146692_))
      (let ((_end146697_ (f32vector-length _v146694_)))
        (declare (not safe))
        (let _lp146701_ ((_i146704_ '0) (_r146706_ '0))
          (if (fx< _i146704_ _end146697_)
              (if (_pred146692_ (f32vector-ref _v146694_ _i146704_))
                  (_lp146701_ (fx+ _i146704_ '1) (fx+ _r146706_ '1))
                  (_lp146701_ (fx+ _i146704_ '1) _r146706_))
              _r146706_)))))
  (define std/srfi/160/f32#f32vector-count__1
    (lambda (_pred146709_ _v146710_ . _vs146711_)
      (if (procedure? _pred146709_)
          '#!void
          (error '"Bad argument; expected procedure" _pred146709_))
      (let* ((_vs146714_ (cons _v146710_ _vs146711_))
             (_end146716_ (apply fxmin (map f32vector-length _vs146714_))))
        (declare (not safe))
        (let _lp146720_ ((_i146722_ '0) (_r146723_ '0))
          (if (fx< _i146722_ _end146716_)
              (if (apply _pred146709_
                         (map (lambda (_g146724146726_)
                                (f32vector-ref _g146724146726_ _i146722_))
                              _vs146714_))
                  (_lp146720_ (fx+ _i146722_ '1) (fx+ _r146723_ '1))
                  (_lp146720_ (fx+ _i146722_ '1) _r146723_))
              _r146723_)))))
  (define std/srfi/160/f32#f32vector-count
    (lambda _g299323_
      (let ((_g299322_ (let () (declare (not safe)) (##length _g299323_))))
        (cond ((let () (declare (not safe)) (##fx= _g299322_ 2))
               (apply std/srfi/160/f32#f32vector-count__0 _g299323_))
              ((let () (declare (not safe)) (##fx>= _g299322_ 2))
               (apply std/srfi/160/f32#f32vector-count__1 _g299323_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-count
                _g299323_))))))
  (define std/srfi/160/f32#f32vector-cumulate
    (lambda (_f146667_ _knil146669_ _v146671_)
      (if (procedure? _f146667_)
          '#!void
          (error '"Bad argument; expected procedure" _f146667_))
      (let* ((_len146674_ (f32vector-length _v146671_))
             (_r146677_ (make-f32vector _len146674_)))
        (declare (not safe))
        (let _lp146682_ ((_i146685_ '0) (_r146687_ _knil146669_))
          (if (fx< _i146685_ _len146674_)
              (let ((_next146689_
                     (_f146667_
                      _r146687_
                      (f32vector-ref _v146671_ _i146685_))))
                (f32vector-set! _v146671_ _i146685_ _next146689_)
                (_lp146682_ (fx+ _i146685_ '1) _next146689_))
              _v146671_)))))
  (define std/srfi/160/f32#f32vector-take-while
    (lambda (_pred146650_ _v146652_)
      (let* ((_len146655_ (f32vector-length _v146652_))
             (_idx146658_
              (std/srfi/160/f32#f32vector-skip__0 _pred146650_ _v146652_))
             (_idx146664_
              (let ((_$e146661_ _idx146658_))
                (if _$e146661_ _$e146661_ _len146655_))))
        (std/srfi/160/f32#f32vector-copy__% _v146652_ '0 _idx146664_))))
  (define std/srfi/160/f32#f32vector-take-while-right
    (lambda (_pred146636_ _v146638_)
      (let* ((_len146641_ (f32vector-length _v146638_))
             (_idx146644_
              (std/srfi/160/f32#f32vector-skip-right__0
               _pred146636_
               _v146638_))
             (_idx146647_ (if _idx146644_ (fx+ _idx146644_ '1) '0)))
        (std/srfi/160/f32#f32vector-copy__%
         _v146638_
         _idx146647_
         _len146641_))))
  (define std/srfi/160/f32#f32vector-drop-while
    (lambda (_pred146619_ _v146621_)
      (let* ((_len146624_ (f32vector-length _v146621_))
             (_idx146627_
              (std/srfi/160/f32#f32vector-skip__0 _pred146619_ _v146621_))
             (_idx146633_
              (let ((_$e146630_ _idx146627_))
                (if _$e146630_ _$e146630_ _len146624_))))
        (std/srfi/160/f32#f32vector-copy__%
         _v146621_
         _idx146633_
         _len146624_))))
  (define std/srfi/160/f32#f32vector-drop-while-right
    (lambda (_pred146605_ _v146607_)
      (let* ((_len146610_ (f32vector-length _v146607_))
             (_idx146613_
              (std/srfi/160/f32#f32vector-skip-right__0
               _pred146605_
               _v146607_))
             (_idx146616_ (if _idx146613_ (fx+ _idx146613_ '1) '0)))
        (std/srfi/160/f32#f32vector-copy__% _v146607_ '0 _idx146616_))))
  (define std/srfi/160/f32#f32vector-index__0
    (lambda (_pred146571_ _v146573_)
      (if (procedure? _pred146571_)
          '#!void
          (error '"Bad argument; expected procedure" _pred146571_))
      (let ((_end146576_ (f32vector-length _v146573_)))
        (declare (not safe))
        (let _lp146580_ ((_i146583_ '0))
          (if (fx< _i146583_ _end146576_)
              (if (_pred146571_ (f32vector-ref _v146573_ _i146583_))
                  _i146583_
                  (_lp146580_ (fx+ _i146583_ '1)))
              '#f)))))
  (define std/srfi/160/f32#f32vector-index__1
    (lambda (_pred146586_ _v146587_ . _vs146588_)
      (if (procedure? _pred146586_)
          '#!void
          (error '"Bad argument; expected procedure" _pred146586_))
      (let* ((_vs146591_ (cons _v146587_ _vs146588_))
             (_end146593_ (apply fxmin (map f32vector-length _vs146591_))))
        (declare (not safe))
        (let _lp146597_ ((_i146599_ '0))
          (if (fx< _i146599_ _end146593_)
              (if (apply _pred146586_
                         (map (lambda (_g146600146602_)
                                (f32vector-ref _g146600146602_ _i146599_))
                              _vs146591_))
                  _i146599_
                  (_lp146597_ (fx+ _i146599_ '1)))
              '#f)))))
  (define std/srfi/160/f32#f32vector-index
    (lambda _g299325_
      (let ((_g299324_ (let () (declare (not safe)) (##length _g299325_))))
        (cond ((let () (declare (not safe)) (##fx= _g299324_ 2))
               (apply std/srfi/160/f32#f32vector-index__0 _g299325_))
              ((let () (declare (not safe)) (##fx>= _g299324_ 2))
               (apply std/srfi/160/f32#f32vector-index__1 _g299325_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-index
                _g299325_))))))
  (define std/srfi/160/f32#f32vector-index-right__0
    (lambda (_pred146537_ _v146539_)
      (if (procedure? _pred146537_)
          '#!void
          (error '"Bad argument; expected procedure" _pred146537_))
      (let ((_start146542_ (fx- (f32vector-length _v146539_) '1)))
        (declare (not safe))
        (let _lp146546_ ((_i146549_ _start146542_))
          (if (fx>= _i146549_ '0)
              (if (_pred146537_ (f32vector-ref _v146539_ _i146549_))
                  _i146549_
                  (_lp146546_ (fx- _i146549_ '1)))
              '#f)))))
  (define std/srfi/160/f32#f32vector-index-right__1
    (lambda (_pred146552_ _v146553_ . _vs146554_)
      (if (procedure? _pred146552_)
          '#!void
          (error '"Bad argument; expected procedure" _pred146552_))
      (let* ((_vs146557_ (cons _v146553_ _vs146554_))
             (_start146559_
              (fx- (apply fxmin (map f32vector-length _vs146557_)) '1)))
        (declare (not safe))
        (let _lp146563_ ((_i146565_ _start146559_))
          (if (fx>= _i146565_ '0)
              (if (apply _pred146552_
                         (map (lambda (_g146566146568_)
                                (f32vector-ref _g146566146568_ _i146565_))
                              _vs146557_))
                  _i146565_
                  (_lp146563_ (fx- _i146565_ '1)))
              '#f)))))
  (define std/srfi/160/f32#f32vector-index-right
    (lambda _g299327_
      (let ((_g299326_ (let () (declare (not safe)) (##length _g299327_))))
        (cond ((let () (declare (not safe)) (##fx= _g299326_ 2))
               (apply std/srfi/160/f32#f32vector-index-right__0 _g299327_))
              ((let () (declare (not safe)) (##fx>= _g299326_ 2))
               (apply std/srfi/160/f32#f32vector-index-right__1 _g299327_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-index-right
                _g299327_))))))
  (define std/srfi/160/f32#f32vector-skip__0
    (lambda (_pred146521_ _v146523_)
      (std/srfi/160/f32#f32vector-index__0
       (lambda (_$obj146526_) (not (_pred146521_ _$obj146526_)))
       _v146523_)))
  (define std/srfi/160/f32#f32vector-skip__1
    (lambda (_pred146529_ _v146530_ . _vs146531_)
      (apply std/srfi/160/f32#f32vector-index
             (lambda (_$obj146534_) (not (_pred146529_ _$obj146534_)))
             _v146530_
             _vs146531_)))
  (define std/srfi/160/f32#f32vector-skip
    (lambda _g299329_
      (let ((_g299328_ (let () (declare (not safe)) (##length _g299329_))))
        (cond ((let () (declare (not safe)) (##fx= _g299328_ 2))
               (apply std/srfi/160/f32#f32vector-skip__0 _g299329_))
              ((let () (declare (not safe)) (##fx>= _g299328_ 2))
               (apply std/srfi/160/f32#f32vector-skip__1 _g299329_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-skip
                _g299329_))))))
  (define std/srfi/160/f32#f32vector-skip-right__0
    (lambda (_pred146505_ _v146507_)
      (std/srfi/160/f32#f32vector-index-right__0
       (lambda (_$obj146510_) (not (_pred146505_ _$obj146510_)))
       _v146507_)))
  (define std/srfi/160/f32#f32vector-skip-right__1
    (lambda (_pred146513_ _v146514_ . _vs146515_)
      (apply std/srfi/160/f32#f32vector-index-right
             (lambda (_$obj146518_) (not (_pred146513_ _$obj146518_)))
             _v146514_
             _vs146515_)))
  (define std/srfi/160/f32#f32vector-skip-right
    (lambda _g299331_
      (let ((_g299330_ (let () (declare (not safe)) (##length _g299331_))))
        (cond ((let () (declare (not safe)) (##fx= _g299330_ 2))
               (apply std/srfi/160/f32#f32vector-skip-right__0 _g299331_))
              ((let () (declare (not safe)) (##fx>= _g299330_ 2))
               (apply std/srfi/160/f32#f32vector-skip-right__1 _g299331_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-skip-right
                _g299331_))))))
  (define std/srfi/160/f32#f32vector-any__0
    (lambda (_pred146465_ _v146467_)
      (if (procedure? _pred146465_)
          '#!void
          (error '"Bad argument; expected procedure" _pred146465_))
      (let ((_end146470_ (f32vector-length _v146467_)))
        (declare (not safe))
        (let _lp146474_ ((_i146477_ '0))
          (if (fx< _i146477_ _end146470_)
              (let ((_$e146480_
                     (_pred146465_ (f32vector-ref _v146467_ _i146477_))))
                (if _$e146480_
                    (values _$e146480_)
                    (_lp146474_ (fx+ _i146477_ '1))))
              '#f)))))
  (define std/srfi/160/f32#f32vector-any__1
    (lambda (_pred146483_ _v146484_ . _vs146485_)
      (if (procedure? _pred146483_)
          '#!void
          (error '"Bad argument; expected procedure" _pred146483_))
      (let* ((_v146488_ (cons _v146484_ _vs146485_))
             (_end146490_ (apply fxmin (map f32vector-length _vs146485_))))
        (declare (not safe))
        (let _lp146494_ ((_i146496_ '0))
          (if (fx< _i146496_ _end146490_)
              (let ((_$e146502_
                     (apply _pred146483_
                            (map (lambda (_g146497146499_)
                                   (f32vector-ref _g146497146499_ _i146496_))
                                 _vs146485_))))
                (if _$e146502_
                    (values _$e146502_)
                    (_lp146494_ (fx+ _i146496_ '1))))
              '#f)))))
  (define std/srfi/160/f32#f32vector-any
    (lambda _g299333_
      (let ((_g299332_ (let () (declare (not safe)) (##length _g299333_))))
        (cond ((let () (declare (not safe)) (##fx= _g299332_ 2))
               (apply std/srfi/160/f32#f32vector-any__0 _g299333_))
              ((let () (declare (not safe)) (##fx>= _g299332_ 2))
               (apply std/srfi/160/f32#f32vector-any__1 _g299333_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-any
                _g299333_))))))
  (define std/srfi/160/f32#f32vector-every__0
    (lambda (_pred146414_ _v146416_)
      (if (procedure? _pred146414_)
          '#!void
          (error '"Bad argument; expected procedure" _pred146414_))
      (let ((_end146419_ (f32vector-length _v146416_)))
        (declare (not safe))
        (let _lp146423_ ((_i146426_ '0) (_r146428_ '#t))
          (if (fx< _i146426_ _end146419_)
              (let ((_$e146431_
                     (_pred146414_ (f32vector-ref _v146416_ _i146426_))))
                (if _$e146431_
                    ((lambda (_g146433146435_)
                       (_lp146423_ (fx+ _i146426_ '1) _g146433146435_))
                     _$e146431_)
                    '#f))
              _r146428_)))))
  (define std/srfi/160/f32#f32vector-every__1
    (lambda (_pred146438_ _v146439_ . _vs146440_)
      (if (procedure? _pred146438_)
          '#!void
          (error '"Bad argument; expected procedure" _pred146438_))
      (let* ((_v146443_ (cons _v146439_ _vs146440_))
             (_end146445_ (apply fxmin (map f32vector-length _vs146440_))))
        (declare (not safe))
        (let _lp146449_ ((_i146451_ '0) (_r146452_ '#t))
          (if (fx< _i146451_ _end146445_)
              (let ((_$e146458_
                     (apply _pred146438_
                            (map (lambda (_g146453146455_)
                                   (f32vector-ref _g146453146455_ _i146451_))
                                 _vs146440_))))
                (if _$e146458_
                    ((lambda (_g146460146462_)
                       (_lp146449_ (fx+ _i146451_ '1) _g146460146462_))
                     _$e146458_)
                    '#f))
              _r146452_)))))
  (define std/srfi/160/f32#f32vector-every
    (lambda _g299335_
      (let ((_g299334_ (let () (declare (not safe)) (##length _g299335_))))
        (cond ((let () (declare (not safe)) (##fx= _g299334_ 2))
               (apply std/srfi/160/f32#f32vector-every__0 _g299335_))
              ((let () (declare (not safe)) (##fx>= _g299334_ 2))
               (apply std/srfi/160/f32#f32vector-every__1 _g299335_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-every
                _g299335_))))))
  (define std/srfi/160/f32#f32vector-partition
    (lambda (_pred146385_ _v146387_)
      (let* ((_count146390_
              (std/srfi/160/f32#f32vector-count__0 _pred146385_ _v146387_))
             (_len146393_ (f32vector-length _v146387_))
             (_u146396_ (make-f32vector _len146393_)))
        (declare (not safe))
        (let _lp146401_ ((_i146404_ '0)
                         (_left146406_ '0)
                         (_right146408_ _count146390_))
          (if (fx< _i146404_ _len146393_)
              (let ((_x146411_ (f32vector-ref _v146387_ _i146404_)))
                (if (_pred146385_ _x146411_)
                    (begin
                      (f32vector-set! _u146396_ _left146406_ _x146411_)
                      (_lp146401_
                       (fx+ _i146404_ '1)
                       (fx+ _left146406_ '1)
                       _right146408_))
                    (begin
                      (f32vector-set! _u146396_ _right146408_ _x146411_)
                      (_lp146401_
                       (fx+ _i146404_ '1)
                       _left146406_
                       (fx+ _right146408_ '1)))))
              _u146396_)))))
  (define std/srfi/160/f32#f32vector-filter
    (lambda (_pred146358_ _v146360_)
      (let* ((_count146363_
              (std/srfi/160/f32#f32vector-count__0 _pred146358_ _v146360_))
             (_u146366_ (make-f32vector _count146363_))
             (_end146369_ (f32vector-length _v146360_)))
        (declare (not safe))
        (let _lp146374_ ((_i146377_ '0) (_j146379_ '0))
          (if (fx< _i146377_ _end146369_)
              (let ((_x146382_ (f32vector-ref _v146360_ _i146377_)))
                (if (_pred146358_ _x146382_)
                    (begin
                      (f32vector-set! _u146366_ _j146379_ _x146382_)
                      (_lp146374_ (fx+ _i146377_ '1) (fx+ _j146379_ '1)))
                    (_lp146374_ (fx+ _i146377_ '1) _j146379_)))
              _u146366_)))))
  (define std/srfi/160/f32#f32vector-remove
    (lambda (_pred146350_ _v146352_)
      (std/srfi/160/f32#f32vector-filter
       (lambda (_$obj146355_) (not (_pred146350_ _$obj146355_)))
       _v146352_)))
  (define std/srfi/160/f32#f32vector-swap
    (lambda (_v146337_ _i146339_ _j146341_)
      (let ((_iv146344_ (f32vector-ref _v146337_ _i146339_))
            (_jv146346_ (f32vector-ref _v146337_ _j146341_)))
        (declare (not safe))
        (begin
          (f32vector-set! _v146337_ _i146339_ _jv146346_)
          (f32vector-set! _v146337_ _j146341_ _iv146344_)))))
  (define std/srfi/160/f32#f32vector-fill!__%
    (lambda (_v146300_ _fill146302_ _start146304_ _end146306_)
      (declare (not safe))
      (begin
        (if (f32vector? _v146300_) '#!void (error '"Bad argument" _v146300_))
        (if (flonum? _fill146302_)
            '#!void
            (error '"Bad argument" _fill146302_))
        (if (and (fixnum? _start146304_)
                 (fx<= '0 _start146304_ (fx- (f32vector-length _v146300_) '1)))
            '#!void
            (error '"Index out of range" _start146304_))
        (if (and (fixnum? _end146306_)
                 (fx<= _start146304_ _end146306_ (f32vector-length _v146300_)))
            '#!void
            (error '"Index out of range" _end146306_))
        (let _lp146310_ ((_i146313_ _start146304_))
          (if (fx< _i146313_ _end146306_)
              (begin
                (f32vector-set! _v146300_ _i146313_ _fill146302_)
                (_lp146310_ (fx+ _i146313_ '1)))
              '#!void)))))
  (define std/srfi/160/f32#f32vector-fill!__0
    (lambda (_v146319_ _fill146320_)
      (let* ((_start146322_ '0) (_end146324_ (f32vector-length _v146319_)))
        (std/srfi/160/f32#f32vector-fill!__%
         _v146319_
         _fill146320_
         _start146322_
         _end146324_))))
  (define std/srfi/160/f32#f32vector-fill!__1
    (lambda (_v146326_ _fill146327_ _start146328_)
      (let ((_end146330_ (f32vector-length _v146326_)))
        (std/srfi/160/f32#f32vector-fill!__%
         _v146326_
         _fill146327_
         _start146328_
         _end146330_))))
  (define std/srfi/160/f32#f32vector-fill!
    (lambda _g299337_
      (let ((_g299336_ (let () (declare (not safe)) (##length _g299337_))))
        (cond ((let () (declare (not safe)) (##fx= _g299336_ 2))
               (apply std/srfi/160/f32#f32vector-fill!__0 _g299337_))
              ((let () (declare (not safe)) (##fx= _g299336_ 3))
               (apply std/srfi/160/f32#f32vector-fill!__1 _g299337_))
              ((let () (declare (not safe)) (##fx= _g299336_ 4))
               (apply std/srfi/160/f32#f32vector-fill!__% _g299337_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-fill!
                _g299337_))))))
  (define std/srfi/160/f32#f32vector-reverse!__%
    (lambda (_v146260_ _start146262_ _end146264_)
      (declare (not safe))
      (begin
        (if (f32vector? _v146260_) '#!void (error '"Bad argument" _v146260_))
        (if (and (fixnum? _start146262_)
                 (fx<= '0 _start146262_ (fx- (f32vector-length _v146260_) '1)))
            '#!void
            (error '"Index out of range" _start146262_))
        (if (and (fixnum? _end146264_)
                 (fx<= _start146262_ _end146264_ (f32vector-length _v146260_)))
            '#!void
            (error '"Index out of range" _end146264_))
        (let _lp146268_ ((_i146271_ _start146262_)
                         (_j146273_ (fx- _end146264_ '1)))
          (if (fx< _i146271_ _j146273_)
              (let ((_iv146276_ (f32vector-ref _v146260_ _i146271_))
                    (_jv146278_ (f32vector-ref _v146260_ _j146273_)))
                (f32vector-set! _v146260_ _i146271_ _jv146278_)
                (f32vector-set! _v146260_ _j146273_ _iv146276_)
                (_lp146268_ (fx+ _i146271_ '1) (fx- _j146273_ '1)))
              '#!void)))))
  (define std/srfi/160/f32#f32vector-reverse!__0
    (lambda (_v146284_)
      (let* ((_start146286_ '0) (_end146288_ (f32vector-length _v146284_)))
        (std/srfi/160/f32#f32vector-reverse!__%
         _v146284_
         _start146286_
         _end146288_))))
  (define std/srfi/160/f32#f32vector-reverse!__1
    (lambda (_v146290_ _start146291_)
      (let ((_end146293_ (f32vector-length _v146290_)))
        (std/srfi/160/f32#f32vector-reverse!__%
         _v146290_
         _start146291_
         _end146293_))))
  (define std/srfi/160/f32#f32vector-reverse!
    (lambda _g299339_
      (let ((_g299338_ (let () (declare (not safe)) (##length _g299339_))))
        (cond ((let () (declare (not safe)) (##fx= _g299338_ 1))
               (apply std/srfi/160/f32#f32vector-reverse!__0 _g299339_))
              ((let () (declare (not safe)) (##fx= _g299338_ 2))
               (apply std/srfi/160/f32#f32vector-reverse!__1 _g299339_))
              ((let () (declare (not safe)) (##fx= _g299338_ 3))
               (apply std/srfi/160/f32#f32vector-reverse!__% _g299339_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector-reverse!
                _g299339_))))))
  (define std/srfi/160/f32#f32vector-unfold!
    (lambda (_f146235_ _v146237_ _start146239_ _end146241_ _seed146243_)
      (declare (not safe))
      (begin
        (if (procedure? _f146235_)
            '#!void
            (error '"Bad argument; expected procedure" _f146235_))
        (if (f32vector? _v146237_) '#!void (error '"Bad argument" _v146237_))
        (if (and (fixnum? _start146239_)
                 (fx<= '0 _start146239_ (fx- (f32vector-length _v146237_) '1)))
            '#!void
            (error '"Index out of range" _start146239_))
        (if (and (fixnum? _end146241_)
                 (fx<= _start146239_ _end146241_ (f32vector-length _v146237_)))
            '#!void
            (error '"Index out of range" _end146241_))
        (let _lp146247_ ((_i146250_ _start146239_)
                         (_state146252_ _seed146243_))
          (if (fx< _i146250_ _end146241_)
              (let ((_g299340_ (_f146235_ _state146252_)))
                (begin
                  (let ((_g299341_
                         (if (##values? _g299340_)
                             (##vector-length _g299340_)
                             1)))
                    (if (not (##fx= _g299341_ 2))
                        (error "Context expects 2 values" _g299341_)))
                  (let ((_x146255_ (##vector-ref _g299340_ 0))
                        (_state146257_ (##vector-ref _g299340_ 1)))
                    (begin
                      (f32vector-set! _v146237_ _i146250_ _x146255_)
                      (_lp146247_ (fx+ _i146250_ '1) _state146257_)))))
              '#!void)))))
  (define std/srfi/160/f32#f32vector-unfold-right!
    (lambda (_f146211_ _v146213_ _start146215_ _end146217_ _seed146219_)
      (declare (not safe))
      (begin
        (if (procedure? _f146211_)
            '#!void
            (error '"Bad argument; expected procedure" _f146211_))
        (if (f32vector? _v146213_) '#!void (error '"Bad argument" _v146213_))
        (if (and (fixnum? _start146215_)
                 (fx<= '0 _start146215_ (fx- (f32vector-length _v146213_) '1)))
            '#!void
            (error '"Index out of range" _start146215_))
        (if (and (fixnum? _end146217_)
                 (fx<= _start146215_ _end146217_ (f32vector-length _v146213_)))
            '#!void
            (error '"Index out of range" _end146217_))
        (let _lp146223_ ((_i146226_ (fx- _end146217_ '1))
                         (_state146228_ _seed146219_))
          (if (fx>= _i146226_ _start146215_)
              (let ((_g299342_ (_f146211_ _state146228_)))
                (begin
                  (let ((_g299343_
                         (if (##values? _g299342_)
                             (##vector-length _g299342_)
                             1)))
                    (if (not (##fx= _g299343_ 2))
                        (error "Context expects 2 values" _g299343_)))
                  (let ((_x146231_ (##vector-ref _g299342_ 0))
                        (_state146233_ (##vector-ref _g299342_ 1)))
                    (begin
                      (f32vector-set! _v146213_ _i146226_ _x146231_)
                      (_lp146223_ (fx- _i146226_ '1) _state146233_)))))
              '#!void)))))
  (define std/srfi/160/f32#reverse-f32vector->list__%
    (lambda (_v146177_ _start146179_ _end146181_)
      (declare (not safe))
      (begin
        (if (f32vector? _v146177_) '#!void (error '"Bad argument" _v146177_))
        (if (and (fixnum? _start146179_)
                 (fx<= '0 _start146179_ (fx- (f32vector-length _v146177_) '1)))
            '#!void
            (error '"Index out of range" _start146179_))
        (if (and (fixnum? _end146181_)
                 (fx<= _start146179_ _end146181_ (f32vector-length _v146177_)))
            '#!void
            (error '"Index out of range" _end146181_))
        (let _lp146185_ ((_i146188_ _start146179_) (_r146190_ '()))
          (if (fx< _i146188_ _end146181_)
              (_lp146185_
               (fx+ _i146188_ '1)
               (cons (f32vector-ref _v146177_ _i146188_) _r146190_))
              _r146190_)))))
  (define std/srfi/160/f32#reverse-f32vector->list__0
    (lambda (_v146196_)
      (let* ((_start146198_ '0) (_end146200_ (f32vector-length _v146196_)))
        (std/srfi/160/f32#reverse-f32vector->list__%
         _v146196_
         _start146198_
         _end146200_))))
  (define std/srfi/160/f32#reverse-f32vector->list__1
    (lambda (_v146202_ _start146203_)
      (let ((_end146205_ (f32vector-length _v146202_)))
        (std/srfi/160/f32#reverse-f32vector->list__%
         _v146202_
         _start146203_
         _end146205_))))
  (define std/srfi/160/f32#reverse-f32vector->list
    (lambda _g299345_
      (let ((_g299344_ (let () (declare (not safe)) (##length _g299345_))))
        (cond ((let () (declare (not safe)) (##fx= _g299344_ 1))
               (apply std/srfi/160/f32#reverse-f32vector->list__0 _g299345_))
              ((let () (declare (not safe)) (##fx= _g299344_ 2))
               (apply std/srfi/160/f32#reverse-f32vector->list__1 _g299345_))
              ((let () (declare (not safe)) (##fx= _g299344_ 3))
               (apply std/srfi/160/f32#reverse-f32vector->list__% _g299345_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#reverse-f32vector->list
                _g299345_))))))
  (define std/srfi/160/f32#reverse-list->f32vector
    (lambda (_lst146123_)
      (let* ((_len146126_ (length _lst146123_))
             (_v146129_ (make-f32vector _len146126_)))
        (declare (not safe))
        (let _lp146134_ ((_rest146137_ _lst146123_) (_i146139_ '0))
          (let* ((_rest146141146149_ _rest146137_)
                 (_else146143146157_ (lambda () _v146129_))
                 (_K146145146164_
                  (lambda (_rest146160_ _x146161_)
                    (if (flonum? _x146161_)
                        '#!void
                        (error '"Bad element" _x146161_))
                    (f32vector-set! _v146129_ _i146139_ _x146161_)
                    (_lp146134_ _rest146160_ (fx+ _i146139_ '1)))))
            (if (##pair? _rest146141146149_)
                (let ((_hd146146146167_ (##car _rest146141146149_))
                      (_tl146147146169_ (##cdr _rest146141146149_)))
                  (let* ((_x146172_ _hd146146146167_)
                         (_rest146174_ _tl146147146169_))
                    (_K146145146164_ _rest146174_ _x146172_)))
                (_else146143146157_)))))))
  (define std/srfi/160/f32#f32vector->vector__%
    (lambda (_v146084_ _start146086_ _end146088_)
      (declare (not safe))
      (begin
        (if (f32vector? _v146084_) '#!void (error '"Bad argument" _v146084_))
        (if (and (fixnum? _start146086_)
                 (fx<= '0 _start146086_ (fx- (f32vector-length _v146084_) '1)))
            '#!void
            (error '"Index out of range" _start146086_))
        (if (and (fixnum? _end146088_)
                 (fx<= _start146086_ _end146088_ (f32vector-length _v146084_)))
            '#!void
            (error '"Index out of range" _end146088_))
        (let* ((_len146092_ (f32vector-length _v146084_))
               (_u146095_ (make-vector _len146092_)))
          (let _lp146099_ ((_i146102_ '0))
            (if (fx< _i146102_ _len146092_)
                (begin
                  (vector-set!
                   _u146095_
                   _i146102_
                   (f32vector-ref _v146084_ _i146102_))
                  (_lp146099_ (fx+ _i146102_ '1)))
                _u146095_))))))
  (define std/srfi/160/f32#f32vector->vector__0
    (lambda (_v146108_)
      (let* ((_start146110_ '0) (_end146112_ (f32vector-length _v146108_)))
        (std/srfi/160/f32#f32vector->vector__%
         _v146108_
         _start146110_
         _end146112_))))
  (define std/srfi/160/f32#f32vector->vector__1
    (lambda (_v146114_ _start146115_)
      (let ((_end146117_ (f32vector-length _v146114_)))
        (std/srfi/160/f32#f32vector->vector__%
         _v146114_
         _start146115_
         _end146117_))))
  (define std/srfi/160/f32#f32vector->vector
    (lambda _g299347_
      (let ((_g299346_ (let () (declare (not safe)) (##length _g299347_))))
        (cond ((let () (declare (not safe)) (##fx= _g299346_ 1))
               (apply std/srfi/160/f32#f32vector->vector__0 _g299347_))
              ((let () (declare (not safe)) (##fx= _g299346_ 2))
               (apply std/srfi/160/f32#f32vector->vector__1 _g299347_))
              ((let () (declare (not safe)) (##fx= _g299346_ 3))
               (apply std/srfi/160/f32#f32vector->vector__% _g299347_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#f32vector->vector
                _g299347_))))))
  (define std/srfi/160/f32#vector->f32vector__%
    (lambda (_v146044_ _start146046_ _end146048_)
      (declare (not safe))
      (begin
        (if (vector? _v146044_)
            '#!void
            (error '"Bad argument; expected vector" _v146044_))
        (if (and (fixnum? _start146046_)
                 (fx<= '0 _start146046_ (fx- (vector-length _v146044_) '1)))
            '#!void
            (error '"Index out of range" _start146046_))
        (if (and (fixnum? _end146048_)
                 (fx<= _start146046_ _end146048_ (vector-length _v146044_)))
            '#!void
            (error '"Index out of range" _end146048_))
        (let* ((_len146052_ (vector-length _v146044_))
               (_u146055_ (make-f32vector _len146052_)))
          (let _lp146059_ ((_i146062_ '0))
            (if (fx< _i146062_ _len146052_)
                (begin
                  (f32vector-set!
                   _u146055_
                   _i146062_
                   (vector-ref _v146044_ _i146062_))
                  (_lp146059_ (fx+ _i146062_ '1)))
                _u146055_))))))
  (define std/srfi/160/f32#vector->f32vector__0
    (lambda (_v146068_)
      (let* ((_start146070_ '0) (_end146072_ (vector-length _v146068_)))
        (std/srfi/160/f32#vector->f32vector__%
         _v146068_
         _start146070_
         _end146072_))))
  (define std/srfi/160/f32#vector->f32vector__1
    (lambda (_v146074_ _start146075_)
      (let ((_end146077_ (vector-length _v146074_)))
        (std/srfi/160/f32#vector->f32vector__%
         _v146074_
         _start146075_
         _end146077_))))
  (define std/srfi/160/f32#vector->f32vector
    (lambda _g299349_
      (let ((_g299348_ (let () (declare (not safe)) (##length _g299349_))))
        (cond ((let () (declare (not safe)) (##fx= _g299348_ 1))
               (apply std/srfi/160/f32#vector->f32vector__0 _g299349_))
              ((let () (declare (not safe)) (##fx= _g299348_ 2))
               (apply std/srfi/160/f32#vector->f32vector__1 _g299349_))
              ((let () (declare (not safe)) (##fx= _g299348_ 3))
               (apply std/srfi/160/f32#vector->f32vector__% _g299349_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#vector->f32vector
                _g299349_))))))
  (define std/srfi/160/f32#make-f32vector-generator__%
    (lambda (_v146010_ _start146012_ _end146014_)
      (declare (not safe))
      (begin
        (if (f32vector? _v146010_) '#!void (error '"Bad argument" _v146010_))
        (if (and (fixnum? _start146012_)
                 (fx<= '0 _start146012_ (fx- (f32vector-length _v146010_) '1)))
            '#!void
            (error '"Index out of range" _start146012_))
        (if (and (fixnum? _end146014_)
                 (fx<= _start146012_ _end146014_ (f32vector-length _v146010_)))
            '#!void
            (error '"Index out of range" _end146014_))
        (let ((_i146018_ _start146012_))
          (lambda ()
            (if (fx< _i146018_ _end146014_)
                (let ((_next146022_ (f32vector-ref _v146010_ _i146018_)))
                  (set! _i146018_ (fx+ _i146018_ '1))
                  _next146022_)
                '#!eof))))))
  (define std/srfi/160/f32#make-f32vector-generator__0
    (lambda (_v146028_)
      (let* ((_start146030_ '0) (_end146032_ (f32vector-length _v146028_)))
        (std/srfi/160/f32#make-f32vector-generator__%
         _v146028_
         _start146030_
         _end146032_))))
  (define std/srfi/160/f32#make-f32vector-generator__1
    (lambda (_v146034_ _start146035_)
      (let ((_end146037_ (f32vector-length _v146034_)))
        (std/srfi/160/f32#make-f32vector-generator__%
         _v146034_
         _start146035_
         _end146037_))))
  (define std/srfi/160/f32#make-f32vector-generator
    (lambda _g299351_
      (let ((_g299350_ (let () (declare (not safe)) (##length _g299351_))))
        (cond ((let () (declare (not safe)) (##fx= _g299350_ 1))
               (apply std/srfi/160/f32#make-f32vector-generator__0 _g299351_))
              ((let () (declare (not safe)) (##fx= _g299350_ 2))
               (apply std/srfi/160/f32#make-f32vector-generator__1 _g299351_))
              ((let () (declare (not safe)) (##fx= _g299350_ 3))
               (apply std/srfi/160/f32#make-f32vector-generator__% _g299351_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#make-f32vector-generator
                _g299351_))))))
  (define std/srfi/160/f32#f32vector-comparator
    (let ()
      (letrec ((_<?145981_
                (lambda (_a145984_ _b145986_)
                  (let ((_len-a145989_ (f32vector-length _a145984_))
                        (_len-b145991_ (f32vector-length _b145986_)))
                    (declare (not safe))
                    (if (fx< _len-a145989_ _len-b145991_)
                        '#t
                        (if (fx> _len-a145989_ _len-b145991_)
                            '#f
                            (let ((_end145995_ _len-a145989_))
                              (let _lp145998_ ((_i146001_ '0))
                                (if (fx< _i146001_ _end145995_)
                                    (let ((_x146004_
                                           (f32vector-ref _a145984_ _i146001_))
                                          (_y146006_
                                           (f32vector-ref
                                            _b145986_
                                            _i146001_)))
                                      (if (< _x146004_ _y146006_)
                                          '#t
                                          (if (> _x146004_ _y146006_)
                                              '#f
                                              (_lp145998_
                                               (fx+ _i146001_ '1)))))
                                    '#f)))))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           f32vector?
           std/srfi/160/f32#f32vector=
           _<?145981_
           equal?-hash)))))
  (define std/srfi/160/f32#write-f32vector__%
    (lambda (_v145958_ _port145960_)
      (let ((_$e145963_ (find-method _v145958_ ':write)))
        (if _$e145963_
            ((lambda (_g145965145967_)
               (_g145965145967_ _v145958_ _port145960_))
             _$e145963_)
            (write _v145958_ (current-output-port))))))
  (define std/srfi/160/f32#write-f32vector__0
    (lambda (_v145973_)
      (let ((_port145975_ (current-output-port)))
        (std/srfi/160/f32#write-f32vector__% _v145973_ _port145975_))))
  (define std/srfi/160/f32#write-f32vector
    (lambda _g299353_
      (let ((_g299352_ (let () (declare (not safe)) (##length _g299353_))))
        (cond ((let () (declare (not safe)) (##fx= _g299352_ 1))
               (apply std/srfi/160/f32#write-f32vector__0 _g299353_))
              ((let () (declare (not safe)) (##fx= _g299352_ 2))
               (apply std/srfi/160/f32#write-f32vector__% _g299353_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f32#write-f32vector
                _g299353_)))))))
