(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/160/f64#f64vector-unfold
    (lambda (_f148788_ _len148790_ _seed148792_)
      (declare (not safe))
      (begin
        (if (procedure? _f148788_)
            '#!void
            (error '"Bad argument; expected procedure" _f148788_))
        (let ((_v148796_ (make-f64vector _len148790_)))
          (let _lp148799_ ((_i148802_ '0) (_state148804_ _seed148792_))
            (if (fx< _i148802_ _len148790_)
                (let ((_g299354_ (_f148788_ _i148802_ _state148804_)))
                  (begin
                    (let ((_g299355_
                           (if (##values? _g299354_)
                               (##vector-length _g299354_)
                               1)))
                      (if (not (##fx= _g299355_ 2))
                          (error "Context expects 2 values" _g299355_)))
                    (let ((_x148807_ (##vector-ref _g299354_ 0))
                          (_state148809_ (##vector-ref _g299354_ 1)))
                      (begin
                        (if (flonum? _x148807_)
                            '#!void
                            (error '"Bad generated value" _x148807_))
                        (f64vector-set! _v148796_ _i148802_ _x148807_)
                        (_lp148799_ (fx+ _i148802_ '1) _state148809_)))))
                _v148796_))))))
  (define std/srfi/160/f64#f64vector-unfold-right
    (lambda (_f148765_ _len148767_ _seed148769_)
      (declare (not safe))
      (begin
        (if (procedure? _f148765_)
            '#!void
            (error '"Bad argument; expected procedure" _f148765_))
        (let ((_v148773_ (make-f64vector _len148767_)))
          (let _lp148776_ ((_i148779_ (fx- _len148767_ '1))
                           (_state148781_ _seed148769_))
            (if (fx>= _i148779_ '0)
                (let ((_g299356_ (_f148765_ _i148779_ _state148781_)))
                  (begin
                    (let ((_g299357_
                           (if (##values? _g299356_)
                               (##vector-length _g299356_)
                               1)))
                      (if (not (##fx= _g299357_ 2))
                          (error "Context expects 2 values" _g299357_)))
                    (let ((_x148784_ (##vector-ref _g299356_ 0))
                          (_state148786_ (##vector-ref _g299356_ 1)))
                      (begin
                        (if (flonum? _x148784_)
                            '#!void
                            (error '"Bad generated value" _x148784_))
                        (f64vector-set! _v148773_ _i148779_ _x148784_)
                        (_lp148776_ (fx- _i148779_ '1) _state148786_)))))
                _v148773_))))))
  (define std/srfi/160/f64#f64vector-copy__%
    (lambda (_vec148737_ _start148739_ _end148741_)
      (let ((_v148744_ (make-f64vector (fx- _end148741_ _start148739_))))
        (std/srfi/160/f64#f64vector-copy!
         _v148744_
         '0
         _vec148737_
         _start148739_
         _end148741_)
        _v148744_)))
  (define std/srfi/160/f64#f64vector-copy__0
    (lambda (_vec148750_)
      (let* ((_start148752_ '0) (_end148754_ (f64vector-length _vec148750_)))
        (std/srfi/160/f64#f64vector-copy__%
         _vec148750_
         _start148752_
         _end148754_))))
  (define std/srfi/160/f64#f64vector-copy__1
    (lambda (_vec148756_ _start148757_)
      (let ((_end148759_ (f64vector-length _vec148756_)))
        (std/srfi/160/f64#f64vector-copy__%
         _vec148756_
         _start148757_
         _end148759_))))
  (define std/srfi/160/f64#f64vector-copy
    (lambda _g299359_
      (let ((_g299358_ (let () (declare (not safe)) (##length _g299359_))))
        (cond ((let () (declare (not safe)) (##fx= _g299358_ 1))
               (apply std/srfi/160/f64#f64vector-copy__0 _g299359_))
              ((let () (declare (not safe)) (##fx= _g299358_ 2))
               (apply std/srfi/160/f64#f64vector-copy__1 _g299359_))
              ((let () (declare (not safe)) (##fx= _g299358_ 3))
               (apply std/srfi/160/f64#f64vector-copy__% _g299359_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-copy
                _g299359_))))))
  (define std/srfi/160/f64#f64vector-copy!
    (lambda (_to148716_ _at148718_ _from148720_ _start148722_ _end148724_)
      (declare (not safe))
      (begin
        (if (f64vector? _to148716_) '#!void (error '"Bad argument" _to148716_))
        (if (f64vector? _from148720_)
            '#!void
            (error '"Bad argument" _from148720_))
        (if (and (fixnum? _at148718_)
                 (fx<= '0 _at148718_ (fx- (f64vector-length _at148718_) '1)))
            '#!void
            (error '"Index out of range" _to148716_ _at148718_))
        (if (and (fixnum? _start148722_)
                 (fx<= '0
                       _start148722_
                       (fx- (f64vector-length _from148720_) '1)))
            '#!void
            (error '"Index out of range" _from148720_ _start148722_))
        (if (and (fixnum? _end148724_)
                 (fx<= _start148722_
                       _end148724_
                       (f64vector-length _from148720_)))
            '#!void
            (error '"Index out of range" _from148720_ _end148724_))
        (if (fx<= (fx- _end148724_ _start148722_)
                  (fx- (f64vector-length _to148716_) _at148718_))
            '#!void
            (error '"Destination area too small"
                   _to148716_
                   _at148718_
                   _from148720_
                   _start148722_
                   _end148724_))
        (let _lp148728_ ((_i148731_ _start148722_) (_j148733_ _at148718_))
          (if (fx< _i148731_ _end148724_)
              (begin
                (f64vector-set!
                 _to148716_
                 _j148733_
                 (f64vector-ref _from148720_ _i148731_))
                (_lp148728_ (fx+ _i148731_ '1) (fx+ _j148733_ '1)))
              '#!void)))))
  (define std/srfi/160/f64#f64vector-reverse-copy__%
    (lambda (_vec148688_ _start148690_ _end148692_)
      (let ((_v148695_ (make-f64vector (fx- _end148692_ _start148690_))))
        (std/srfi/160/f64#f64vector-reverse-copy!
         _v148695_
         '0
         _vec148688_
         _start148690_
         _end148692_)
        _v148695_)))
  (define std/srfi/160/f64#f64vector-reverse-copy__0
    (lambda (_vec148701_)
      (let* ((_start148703_ '0) (_end148705_ (f64vector-length _vec148701_)))
        (std/srfi/160/f64#f64vector-reverse-copy__%
         _vec148701_
         _start148703_
         _end148705_))))
  (define std/srfi/160/f64#f64vector-reverse-copy__1
    (lambda (_vec148707_ _start148708_)
      (let ((_end148710_ (f64vector-length _vec148707_)))
        (std/srfi/160/f64#f64vector-reverse-copy__%
         _vec148707_
         _start148708_
         _end148710_))))
  (define std/srfi/160/f64#f64vector-reverse-copy
    (lambda _g299361_
      (let ((_g299360_ (let () (declare (not safe)) (##length _g299361_))))
        (cond ((let () (declare (not safe)) (##fx= _g299360_ 1))
               (apply std/srfi/160/f64#f64vector-reverse-copy__0 _g299361_))
              ((let () (declare (not safe)) (##fx= _g299360_ 2))
               (apply std/srfi/160/f64#f64vector-reverse-copy__1 _g299361_))
              ((let () (declare (not safe)) (##fx= _g299360_ 3))
               (apply std/srfi/160/f64#f64vector-reverse-copy__% _g299361_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-reverse-copy
                _g299361_))))))
  (define std/srfi/160/f64#f64vector-reverse-copy!
    (lambda (_to148667_ _at148669_ _from148671_ _start148673_ _end148675_)
      (declare (not safe))
      (begin
        (if (f64vector? _to148667_) '#!void (error '"Bad argument" _to148667_))
        (if (f64vector? _from148671_)
            '#!void
            (error '"Bad argument" _from148671_))
        (if (and (fixnum? _at148669_)
                 (fx<= '0 _at148669_ (fx- (f64vector-length _at148669_) '1)))
            '#!void
            (error '"Index out of range" _to148667_ _at148669_))
        (if (and (fixnum? _start148673_)
                 (fx<= '0
                       _start148673_
                       (fx- (f64vector-length _from148671_) '1)))
            '#!void
            (error '"Index out of range" _from148671_ _start148673_))
        (if (and (fixnum? _end148675_)
                 (fx<= _start148673_
                       _end148675_
                       (f64vector-length _from148671_)))
            '#!void
            (error '"Index out of range" _from148671_ _end148675_))
        (if (fx<= (fx- _end148675_ _start148673_)
                  (fx- (f64vector-length _to148667_) _at148669_))
            '#!void
            (error '"Destination area too small"
                   _to148667_
                   _at148669_
                   _from148671_
                   _start148673_
                   _end148675_))
        (let _lp148679_ ((_i148682_ (fx- _end148675_ '1))
                         (_j148684_ _at148669_))
          (if (fx>= _i148682_ _start148673_)
              (begin
                (f64vector-set!
                 _to148667_
                 _j148684_
                 (f64vector-ref _from148671_ _i148682_))
                (_lp148679_ (fx- _i148682_ '1) (fx+ _j148684_ '1)))
              '#!void)))))
  (define std/srfi/160/f64#f64vector-append
    (lambda _args148664_
      (std/srfi/160/f64#f64vector-concatenate _args148664_)))
  (define std/srfi/160/f64#f64vector-concatenate
    (lambda (_lst148604_)
      (let* ((_len148612_
              (foldl1 (lambda (_v148607_ _r148609_)
                        (fx+ (f64vector-length _v148607_) _r148609_))
                      '0
                      _lst148604_))
             (_v148615_ (make-f64vector _len148612_)))
        (declare (not safe))
        (let _lp148619_ ((_rest148622_ _lst148604_) (_at148624_ '0))
          (let* ((_rest148626148634_ _rest148622_)
                 (_else148628148642_ (lambda () _v148615_))
                 (_K148630148652_
                  (lambda (_rest148645_ _u148646_)
                    (let ((_ulen148649_ (f64vector-length _u148646_)))
                      (std/srfi/160/f64#f64vector-copy!
                       _v148615_
                       _at148624_
                       _u148646_
                       '0
                       _ulen148649_)
                      (_lp148619_
                       _rest148645_
                       (fx+ _at148624_ _ulen148649_))))))
            (if (##pair? _rest148626148634_)
                (let ((_hd148631148655_ (##car _rest148626148634_))
                      (_tl148632148657_ (##cdr _rest148626148634_)))
                  (let* ((_u148660_ _hd148631148655_)
                         (_rest148662_ _tl148632148657_))
                    (_K148630148652_ _rest148662_ _u148660_)))
                (_else148628148642_)))))))
  (define std/srfi/160/f64#f64vector-append-subvectors
    (lambda _args148476_
      (let* ((_len148537_
              (let _lp148479_ ((_rest148482_ _args148476_) (_r148484_ '0))
                (let* ((_rest148486148498_ _rest148482_)
                       (_else148488148506_ (lambda () _r148484_))
                       (_K148490148515_
                        (lambda (_rest148509_ _end148510_ _start148512_)
                          (_lp148479_
                           _rest148509_
                           (fx+ _r148484_ (fx- _end148510_ _start148512_))))))
                  (if (let ()
                        (declare (not safe))
                        (##pair? _rest148486148498_))
                      (let ((_tl148492148518_
                             (let ()
                               (declare (not safe))
                               (##cdr _rest148486148498_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl148492148518_))
                            (let ((_hd148493148521_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl148492148518_)))
                                  (_tl148494148523_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl148492148518_))))
                              (let ((_start148526_ _hd148493148521_))
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl148494148523_))
                                    (let ((_hd148495148528_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl148494148523_)))
                                          (_tl148496148530_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl148494148523_))))
                                      (let* ((_end148533_ _hd148495148528_)
                                             (_rest148535_ _tl148496148530_))
                                        (_K148490148515_
                                         _rest148535_
                                         _end148533_
                                         _start148526_)))
                                    (_else148488148506_))))
                            (_else148488148506_)))
                      (_else148488148506_)))))
             (_v148540_ (make-f64vector _len148537_)))
        (let _lp148544_ ((_rest148546_ _args148476_) (_at148547_ '0))
          (let* ((_rest148549148561_ _rest148546_)
                 (_else148551148569_ (lambda () _v148540_))
                 (_K148553148578_
                  (lambda (_rest148572_ _end148573_ _start148574_ _u148575_)
                    (std/srfi/160/f64#f64vector-copy!
                     _v148540_
                     _at148547_
                     _u148575_
                     _start148574_
                     _end148573_)
                    (_lp148544_
                     _rest148572_
                     (fx+ _at148547_ (fx- _end148573_ _start148574_))))))
            (if (let () (declare (not safe)) (##pair? _rest148549148561_))
                (let ((_hd148554148581_
                       (let ()
                         (declare (not safe))
                         (##car _rest148549148561_)))
                      (_tl148555148583_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest148549148561_))))
                  (let ((_u148586_ _hd148554148581_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl148555148583_))
                        (let ((_hd148556148588_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl148555148583_)))
                              (_tl148557148590_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl148555148583_))))
                          (let ((_start148593_ _hd148556148588_))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _tl148557148590_))
                                (let ((_hd148558148595_
                                       (let ()
                                         (declare (not safe))
                                         (##car _tl148557148590_)))
                                      (_tl148559148597_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _tl148557148590_))))
                                  (let* ((_end148600_ _hd148558148595_)
                                         (_rest148602_ _tl148559148597_))
                                    (_K148553148578_
                                     _rest148602_
                                     _end148600_
                                     _start148593_
                                     _u148586_)))
                                (_else148551148569_))))
                        (_else148551148569_))))
                (_else148551148569_)))))))
  (define std/srfi/160/f64#f64vector-empty?
    (lambda (_v148473_) (fxzero? (f64vector-length _v148473_))))
  (define std/srfi/160/f64#f64vector=
    (lambda (_v148415_ . _args148417_)
      (declare (not safe))
      (begin
        (if (f64vector? _v148415_) '#!void (error '"Bad argument" _v148415_))
        (let ((_vlen148421_ (f64vector-length _v148415_)))
          (let _lp148424_ ((_rest148427_ _args148417_))
            (let* ((_rest148429148437_ _rest148427_)
                   (_else148431148445_ (lambda () '#t))
                   (_K148433148461_
                    (lambda (_rest148448_ _u148449_)
                      (if (f64vector? _u148449_)
                          '#!void
                          (error '"Bad argument" _u148449_))
                      (let ((_ulen148452_ (f64vector-length _u148449_)))
                        (if (fx= _vlen148421_ _ulen148452_)
                            (let _cmp148455_ ((_i148458_ '0))
                              (if (fx< _i148458_ _vlen148421_)
                                  (if (= (f64vector-ref _v148415_ _i148458_)
                                         (f64vector-ref _u148449_ _i148458_))
                                      (_cmp148455_ (fx+ _i148458_ '1))
                                      '#f)
                                  (_lp148424_ _rest148448_)))
                            '#f)))))
              (if (##pair? _rest148429148437_)
                  (let ((_hd148434148464_ (##car _rest148429148437_))
                        (_tl148435148466_ (##cdr _rest148429148437_)))
                    (let* ((_u148469_ _hd148434148464_)
                           (_rest148471_ _tl148435148466_))
                      (_K148433148461_ _rest148471_ _u148469_)))
                  (_else148431148445_))))))))
  (define std/srfi/160/f64#f64vector-take
    (lambda (_v148407_ _n148409_)
      (let ((_u148412_ (make-f64vector _n148409_)))
        (std/srfi/160/f64#f64vector-copy! _u148412_ '0 _v148407_ '0 _n148409_)
        _u148412_)))
  (define std/srfi/160/f64#f64vector-take-right
    (lambda (_v148392_ _n148394_)
      (let* ((_vlen148397_ (f64vector-length _v148392_))
             (_ulen148400_ (fx- _vlen148397_ _n148394_))
             (_u148403_ (make-f64vector _ulen148400_)))
        (std/srfi/160/f64#f64vector-copy!
         _u148403_
         '0
         _v148392_
         _n148394_
         _vlen148397_)
        _u148403_)))
  (define std/srfi/160/f64#f64vector-drop
    (lambda (_v148377_ _n148379_)
      (let* ((_vlen148382_ (f64vector-length _v148377_))
             (_ulen148385_ (fx- _vlen148382_ _n148379_))
             (_u148388_ (make-f64vector _ulen148385_)))
        (std/srfi/160/f64#f64vector-copy!
         _u148388_
         '0
         _v148377_
         _n148379_
         _vlen148382_)
        _u148388_)))
  (define std/srfi/160/f64#f64vector-drop-right
    (lambda (_v148362_ _n148364_)
      (let* ((_vlen148367_ (f64vector-length _v148362_))
             (_ulen148370_ (fx- _vlen148367_ _n148364_))
             (_u148373_ (make-f64vector _ulen148370_)))
        (std/srfi/160/f64#f64vector-copy!
         _u148373_
         '0
         _v148362_
         '0
         _ulen148370_)
        _u148373_)))
  (define std/srfi/160/f64#f64vector-segment
    (lambda (_v148344_ _n148346_)
      (let _lp148349_ ((_i148352_ '0)
                       (_rest148354_ (f64vector-length _v148344_))
                       (_r148356_ '()))
        (if (fx> _r148356_ '0)
            (let ((_size148359_ (fxmin _n148346_ _rest148354_)))
              (_lp148349_
               (fx+ _i148352_ _size148359_)
               (fx- _rest148354_ _size148359_)
               (cons (std/srfi/160/f64#f64vector-copy__%
                      _v148344_
                      _i148352_
                      (fx+ _i148352_ _size148359_))
                     _r148356_)))
            (reverse _r148356_)))))
  (define std/srfi/160/f64#f64vector-fold__0
    (lambda (_kons148304_ _knil148306_ _v148308_)
      (if (procedure? _kons148304_)
          '#!void
          (error '"Bad argument; expected procedure" _kons148304_))
      (let ((_end148311_ (f64vector-length _v148308_)))
        (declare (not safe))
        (let _lp148315_ ((_i148318_ '0) (_r148320_ _knil148306_))
          (if (fx< _i148318_ _end148311_)
              (_lp148315_
               (fx+ _i148318_ '1)
               (_kons148304_ _r148320_ (f64vector-ref _v148308_ _i148318_)))
              _r148320_)))))
  (define std/srfi/160/f64#f64vector-fold__1
    (lambda (_kons148323_ _knil148324_ _v148325_ . _vs148326_)
      (if (procedure? _kons148323_)
          '#!void
          (error '"Bad argument; expected procedure" _kons148323_))
      (let* ((_vs148329_ (cons _v148325_ _vs148326_))
             (_end148331_ (apply fxmin (map f64vector-length _vs148329_))))
        (declare (not safe))
        (let _lp148335_ ((_i148337_ '0) (_r148338_ _knil148324_))
          (if (fx< _i148337_ _end148331_)
              (_lp148335_
               (fx+ _i148337_ '1)
               (apply _kons148323_
                      _r148338_
                      (map (lambda (_g148339148341_)
                             (f64vector-ref _g148339148341_ _i148337_))
                           _vs148329_)))
              _r148338_)))))
  (define std/srfi/160/f64#f64vector-fold
    (lambda _g299363_
      (let ((_g299362_ (let () (declare (not safe)) (##length _g299363_))))
        (cond ((let () (declare (not safe)) (##fx= _g299362_ 3))
               (apply std/srfi/160/f64#f64vector-fold__0 _g299363_))
              ((let () (declare (not safe)) (##fx>= _g299362_ 3))
               (apply std/srfi/160/f64#f64vector-fold__1 _g299363_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-fold
                _g299363_))))))
  (define std/srfi/160/f64#f64vector-fold-right__0
    (lambda (_kons148264_ _knil148266_ _v148268_)
      (if (procedure? _kons148264_)
          '#!void
          (error '"Bad argument; expected procedure" _kons148264_))
      (let ((_last148271_ (fx- (f64vector-length _v148268_) '1)))
        (declare (not safe))
        (let _lp148275_ ((_i148278_ _last148271_) (_r148280_ _knil148266_))
          (if (fx>= _i148278_ '0)
              (_lp148275_
               (fx- _i148278_ '1)
               (_kons148264_ _r148280_ (f64vector-ref _v148268_ _i148278_)))
              _r148280_)))))
  (define std/srfi/160/f64#f64vector-fold-right__1
    (lambda (_kons148283_ _knil148284_ _v148285_ . _vs148286_)
      (if (procedure? _kons148283_)
          '#!void
          (error '"Bad argument; expected procedure" _kons148283_))
      (let* ((_vs148289_ (cons _v148285_ _vs148286_))
             (_last148291_
              (fx- (apply min (map f64vector-length _vs148289_)) '1)))
        (declare (not safe))
        (let _lp148295_ ((_i148297_ _last148291_) (_r148298_ _knil148284_))
          (if (fx>= _i148297_ '0)
              (_lp148295_
               (fx- _i148297_ '1)
               (apply _kons148283_
                      _r148298_
                      (map (lambda (_g148299148301_)
                             (f64vector-ref _g148299148301_ _i148297_))
                           _vs148289_)))
              _r148298_)))))
  (define std/srfi/160/f64#f64vector-fold-right
    (lambda _g299365_
      (let ((_g299364_ (let () (declare (not safe)) (##length _g299365_))))
        (cond ((let () (declare (not safe)) (##fx= _g299364_ 3))
               (apply std/srfi/160/f64#f64vector-fold-right__0 _g299365_))
              ((let () (declare (not safe)) (##fx>= _g299364_ 3))
               (apply std/srfi/160/f64#f64vector-fold-right__1 _g299365_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-fold-right
                _g299365_))))))
  (define std/srfi/160/f64#f64vector-map__0
    (lambda (_f148224_ _v148226_)
      (if (procedure? _f148224_)
          '#!void
          (error '"Bad argument; expected procedure" _f148224_))
      (let* ((_len148229_ (f64vector-length _v148226_))
             (_u148232_ (make-f64vector _len148229_)))
        (declare (not safe))
        (let _lp148237_ ((_i148240_ '0))
          (if (fx< _i148240_ _len148229_)
              (begin
                (f64vector-set!
                 _u148232_
                 _i148240_
                 (f64vector-ref _v148226_ _i148240_))
                (_lp148237_ (fx+ _i148240_ '1)))
              _u148232_)))))
  (define std/srfi/160/f64#f64vector-map__1
    (lambda (_f148243_ _v148244_ . _vs148245_)
      (if (procedure? _f148243_)
          '#!void
          (error '"Bad argument; expected procedure" _f148243_))
      (let* ((_vs148248_ (cons _v148244_ _vs148245_))
             (_len148250_ (apply fxmin (map f64vector-length _vs148248_)))
             (_u148252_ (make-f64vector _len148250_)))
        (declare (not safe))
        (let _lp148256_ ((_i148258_ '0))
          (if (fx< _i148258_ _len148250_)
              (begin
                (f64vector-set!
                 _u148252_
                 _i148258_
                 (apply _f148243_
                        (map (lambda (_g148259148261_)
                               (f64vector-ref _g148259148261_ _i148258_))
                             _vs148248_)))
                (_lp148256_ (fx+ _i148258_ '1)))
              _u148252_)))))
  (define std/srfi/160/f64#f64vector-map
    (lambda _g299367_
      (let ((_g299366_ (let () (declare (not safe)) (##length _g299367_))))
        (cond ((let () (declare (not safe)) (##fx= _g299366_ 2))
               (apply std/srfi/160/f64#f64vector-map__0 _g299367_))
              ((let () (declare (not safe)) (##fx>= _g299366_ 2))
               (apply std/srfi/160/f64#f64vector-map__1 _g299367_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-map
                _g299367_))))))
  (define std/srfi/160/f64#f64vector-map!__0
    (lambda (_f148190_ _v148192_)
      (if (procedure? _f148190_)
          '#!void
          (error '"Bad argument; expected procedure" _f148190_))
      (let ((_len148195_ (f64vector-length _v148192_)))
        (declare (not safe))
        (let _lp148199_ ((_i148202_ '0))
          (if (fx< _i148202_ _len148195_)
              (begin
                (f64vector-set!
                 _v148192_
                 _i148202_
                 (_f148190_ (f64vector-ref _v148192_ _i148202_)))
                (_lp148199_ (fx+ _i148202_ '1)))
              _v148192_)))))
  (define std/srfi/160/f64#f64vector-map!__1
    (lambda (_f148205_ _v148206_ . _vs148207_)
      (if (procedure? _f148205_)
          '#!void
          (error '"Bad argument; expected procedure" _f148205_))
      (let* ((_vs148210_ (cons _v148206_ _vs148207_))
             (_len148212_ (apply fxmin (map f64vector-length _vs148210_))))
        (declare (not safe))
        (let _lp148216_ ((_i148218_ '0))
          (if (fx< _i148218_ _len148212_)
              (begin
                (f64vector-set!
                 _v148206_
                 _i148218_
                 (apply _f148205_
                        (map (lambda (_g148219148221_)
                               (f64vector-ref _g148219148221_ _i148218_))
                             _vs148210_)))
                (_lp148216_ (fx+ _i148218_ '1)))
              _v148206_)))))
  (define std/srfi/160/f64#f64vector-map!
    (lambda _g299369_
      (let ((_g299368_ (let () (declare (not safe)) (##length _g299369_))))
        (cond ((let () (declare (not safe)) (##fx= _g299368_ 2))
               (apply std/srfi/160/f64#f64vector-map!__0 _g299369_))
              ((let () (declare (not safe)) (##fx>= _g299368_ 2))
               (apply std/srfi/160/f64#f64vector-map!__1 _g299369_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-map!
                _g299369_))))))
  (define std/srfi/160/f64#f64vector-for-each__0
    (lambda (_f148156_ _v148158_)
      (if (procedure? _f148156_)
          '#!void
          (error '"Bad argument; expected procedure" _f148156_))
      (let ((_len148161_ (f64vector-length _v148158_)))
        (declare (not safe))
        (let _lp148165_ ((_i148168_ '0))
          (if (fx< _i148168_ _len148161_)
              (begin
                (_f148156_ (f64vector-ref _v148158_ _i148168_))
                (_lp148165_ (fx+ _i148168_ '1)))
              '#!void)))))
  (define std/srfi/160/f64#f64vector-for-each__1
    (lambda (_f148171_ _v148172_ . _vs148173_)
      (let* ((_vs148176_ (cons _v148172_ _vs148173_))
             (_len148178_ (apply fxmin (map f64vector-length _vs148176_))))
        (declare (not safe))
        (let _lp148182_ ((_i148184_ '0))
          (if (fx< _i148184_ _len148178_)
              (begin
                (apply _f148171_
                       (map (lambda (_g148185148187_)
                              (f64vector-ref _g148185148187_ _i148184_))
                            _vs148176_))
                (_lp148182_ (fx+ _i148184_ '1)))
              '#!void)))))
  (define std/srfi/160/f64#f64vector-for-each
    (lambda _g299371_
      (let ((_g299370_ (let () (declare (not safe)) (##length _g299371_))))
        (cond ((let () (declare (not safe)) (##fx= _g299370_ 2))
               (apply std/srfi/160/f64#f64vector-for-each__0 _g299371_))
              ((let () (declare (not safe)) (##fx>= _g299370_ 2))
               (apply std/srfi/160/f64#f64vector-for-each__1 _g299371_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-for-each
                _g299371_))))))
  (define std/srfi/160/f64#f64vector-count__0
    (lambda (_pred148119_ _v148121_)
      (if (procedure? _pred148119_)
          '#!void
          (error '"Bad argument; expected procedure" _pred148119_))
      (let ((_end148124_ (f64vector-length _v148121_)))
        (declare (not safe))
        (let _lp148128_ ((_i148131_ '0) (_r148133_ '0))
          (if (fx< _i148131_ _end148124_)
              (if (_pred148119_ (f64vector-ref _v148121_ _i148131_))
                  (_lp148128_ (fx+ _i148131_ '1) (fx+ _r148133_ '1))
                  (_lp148128_ (fx+ _i148131_ '1) _r148133_))
              _r148133_)))))
  (define std/srfi/160/f64#f64vector-count__1
    (lambda (_pred148136_ _v148137_ . _vs148138_)
      (if (procedure? _pred148136_)
          '#!void
          (error '"Bad argument; expected procedure" _pred148136_))
      (let* ((_vs148141_ (cons _v148137_ _vs148138_))
             (_end148143_ (apply fxmin (map f64vector-length _vs148141_))))
        (declare (not safe))
        (let _lp148147_ ((_i148149_ '0) (_r148150_ '0))
          (if (fx< _i148149_ _end148143_)
              (if (apply _pred148136_
                         (map (lambda (_g148151148153_)
                                (f64vector-ref _g148151148153_ _i148149_))
                              _vs148141_))
                  (_lp148147_ (fx+ _i148149_ '1) (fx+ _r148150_ '1))
                  (_lp148147_ (fx+ _i148149_ '1) _r148150_))
              _r148150_)))))
  (define std/srfi/160/f64#f64vector-count
    (lambda _g299373_
      (let ((_g299372_ (let () (declare (not safe)) (##length _g299373_))))
        (cond ((let () (declare (not safe)) (##fx= _g299372_ 2))
               (apply std/srfi/160/f64#f64vector-count__0 _g299373_))
              ((let () (declare (not safe)) (##fx>= _g299372_ 2))
               (apply std/srfi/160/f64#f64vector-count__1 _g299373_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-count
                _g299373_))))))
  (define std/srfi/160/f64#f64vector-cumulate
    (lambda (_f148094_ _knil148096_ _v148098_)
      (if (procedure? _f148094_)
          '#!void
          (error '"Bad argument; expected procedure" _f148094_))
      (let* ((_len148101_ (f64vector-length _v148098_))
             (_r148104_ (make-f64vector _len148101_)))
        (declare (not safe))
        (let _lp148109_ ((_i148112_ '0) (_r148114_ _knil148096_))
          (if (fx< _i148112_ _len148101_)
              (let ((_next148116_
                     (_f148094_
                      _r148114_
                      (f64vector-ref _v148098_ _i148112_))))
                (f64vector-set! _v148098_ _i148112_ _next148116_)
                (_lp148109_ (fx+ _i148112_ '1) _next148116_))
              _v148098_)))))
  (define std/srfi/160/f64#f64vector-take-while
    (lambda (_pred148077_ _v148079_)
      (let* ((_len148082_ (f64vector-length _v148079_))
             (_idx148085_
              (std/srfi/160/f64#f64vector-skip__0 _pred148077_ _v148079_))
             (_idx148091_
              (let ((_$e148088_ _idx148085_))
                (if _$e148088_ _$e148088_ _len148082_))))
        (std/srfi/160/f64#f64vector-copy__% _v148079_ '0 _idx148091_))))
  (define std/srfi/160/f64#f64vector-take-while-right
    (lambda (_pred148063_ _v148065_)
      (let* ((_len148068_ (f64vector-length _v148065_))
             (_idx148071_
              (std/srfi/160/f64#f64vector-skip-right__0
               _pred148063_
               _v148065_))
             (_idx148074_ (if _idx148071_ (fx+ _idx148071_ '1) '0)))
        (std/srfi/160/f64#f64vector-copy__%
         _v148065_
         _idx148074_
         _len148068_))))
  (define std/srfi/160/f64#f64vector-drop-while
    (lambda (_pred148046_ _v148048_)
      (let* ((_len148051_ (f64vector-length _v148048_))
             (_idx148054_
              (std/srfi/160/f64#f64vector-skip__0 _pred148046_ _v148048_))
             (_idx148060_
              (let ((_$e148057_ _idx148054_))
                (if _$e148057_ _$e148057_ _len148051_))))
        (std/srfi/160/f64#f64vector-copy__%
         _v148048_
         _idx148060_
         _len148051_))))
  (define std/srfi/160/f64#f64vector-drop-while-right
    (lambda (_pred148032_ _v148034_)
      (let* ((_len148037_ (f64vector-length _v148034_))
             (_idx148040_
              (std/srfi/160/f64#f64vector-skip-right__0
               _pred148032_
               _v148034_))
             (_idx148043_ (if _idx148040_ (fx+ _idx148040_ '1) '0)))
        (std/srfi/160/f64#f64vector-copy__% _v148034_ '0 _idx148043_))))
  (define std/srfi/160/f64#f64vector-index__0
    (lambda (_pred147998_ _v148000_)
      (if (procedure? _pred147998_)
          '#!void
          (error '"Bad argument; expected procedure" _pred147998_))
      (let ((_end148003_ (f64vector-length _v148000_)))
        (declare (not safe))
        (let _lp148007_ ((_i148010_ '0))
          (if (fx< _i148010_ _end148003_)
              (if (_pred147998_ (f64vector-ref _v148000_ _i148010_))
                  _i148010_
                  (_lp148007_ (fx+ _i148010_ '1)))
              '#f)))))
  (define std/srfi/160/f64#f64vector-index__1
    (lambda (_pred148013_ _v148014_ . _vs148015_)
      (if (procedure? _pred148013_)
          '#!void
          (error '"Bad argument; expected procedure" _pred148013_))
      (let* ((_vs148018_ (cons _v148014_ _vs148015_))
             (_end148020_ (apply fxmin (map f64vector-length _vs148018_))))
        (declare (not safe))
        (let _lp148024_ ((_i148026_ '0))
          (if (fx< _i148026_ _end148020_)
              (if (apply _pred148013_
                         (map (lambda (_g148027148029_)
                                (f64vector-ref _g148027148029_ _i148026_))
                              _vs148018_))
                  _i148026_
                  (_lp148024_ (fx+ _i148026_ '1)))
              '#f)))))
  (define std/srfi/160/f64#f64vector-index
    (lambda _g299375_
      (let ((_g299374_ (let () (declare (not safe)) (##length _g299375_))))
        (cond ((let () (declare (not safe)) (##fx= _g299374_ 2))
               (apply std/srfi/160/f64#f64vector-index__0 _g299375_))
              ((let () (declare (not safe)) (##fx>= _g299374_ 2))
               (apply std/srfi/160/f64#f64vector-index__1 _g299375_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-index
                _g299375_))))))
  (define std/srfi/160/f64#f64vector-index-right__0
    (lambda (_pred147964_ _v147966_)
      (if (procedure? _pred147964_)
          '#!void
          (error '"Bad argument; expected procedure" _pred147964_))
      (let ((_start147969_ (fx- (f64vector-length _v147966_) '1)))
        (declare (not safe))
        (let _lp147973_ ((_i147976_ _start147969_))
          (if (fx>= _i147976_ '0)
              (if (_pred147964_ (f64vector-ref _v147966_ _i147976_))
                  _i147976_
                  (_lp147973_ (fx- _i147976_ '1)))
              '#f)))))
  (define std/srfi/160/f64#f64vector-index-right__1
    (lambda (_pred147979_ _v147980_ . _vs147981_)
      (if (procedure? _pred147979_)
          '#!void
          (error '"Bad argument; expected procedure" _pred147979_))
      (let* ((_vs147984_ (cons _v147980_ _vs147981_))
             (_start147986_
              (fx- (apply fxmin (map f64vector-length _vs147984_)) '1)))
        (declare (not safe))
        (let _lp147990_ ((_i147992_ _start147986_))
          (if (fx>= _i147992_ '0)
              (if (apply _pred147979_
                         (map (lambda (_g147993147995_)
                                (f64vector-ref _g147993147995_ _i147992_))
                              _vs147984_))
                  _i147992_
                  (_lp147990_ (fx- _i147992_ '1)))
              '#f)))))
  (define std/srfi/160/f64#f64vector-index-right
    (lambda _g299377_
      (let ((_g299376_ (let () (declare (not safe)) (##length _g299377_))))
        (cond ((let () (declare (not safe)) (##fx= _g299376_ 2))
               (apply std/srfi/160/f64#f64vector-index-right__0 _g299377_))
              ((let () (declare (not safe)) (##fx>= _g299376_ 2))
               (apply std/srfi/160/f64#f64vector-index-right__1 _g299377_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-index-right
                _g299377_))))))
  (define std/srfi/160/f64#f64vector-skip__0
    (lambda (_pred147948_ _v147950_)
      (std/srfi/160/f64#f64vector-index__0
       (lambda (_$obj147953_) (not (_pred147948_ _$obj147953_)))
       _v147950_)))
  (define std/srfi/160/f64#f64vector-skip__1
    (lambda (_pred147956_ _v147957_ . _vs147958_)
      (apply std/srfi/160/f64#f64vector-index
             (lambda (_$obj147961_) (not (_pred147956_ _$obj147961_)))
             _v147957_
             _vs147958_)))
  (define std/srfi/160/f64#f64vector-skip
    (lambda _g299379_
      (let ((_g299378_ (let () (declare (not safe)) (##length _g299379_))))
        (cond ((let () (declare (not safe)) (##fx= _g299378_ 2))
               (apply std/srfi/160/f64#f64vector-skip__0 _g299379_))
              ((let () (declare (not safe)) (##fx>= _g299378_ 2))
               (apply std/srfi/160/f64#f64vector-skip__1 _g299379_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-skip
                _g299379_))))))
  (define std/srfi/160/f64#f64vector-skip-right__0
    (lambda (_pred147932_ _v147934_)
      (std/srfi/160/f64#f64vector-index-right__0
       (lambda (_$obj147937_) (not (_pred147932_ _$obj147937_)))
       _v147934_)))
  (define std/srfi/160/f64#f64vector-skip-right__1
    (lambda (_pred147940_ _v147941_ . _vs147942_)
      (apply std/srfi/160/f64#f64vector-index-right
             (lambda (_$obj147945_) (not (_pred147940_ _$obj147945_)))
             _v147941_
             _vs147942_)))
  (define std/srfi/160/f64#f64vector-skip-right
    (lambda _g299381_
      (let ((_g299380_ (let () (declare (not safe)) (##length _g299381_))))
        (cond ((let () (declare (not safe)) (##fx= _g299380_ 2))
               (apply std/srfi/160/f64#f64vector-skip-right__0 _g299381_))
              ((let () (declare (not safe)) (##fx>= _g299380_ 2))
               (apply std/srfi/160/f64#f64vector-skip-right__1 _g299381_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-skip-right
                _g299381_))))))
  (define std/srfi/160/f64#f64vector-any__0
    (lambda (_pred147892_ _v147894_)
      (if (procedure? _pred147892_)
          '#!void
          (error '"Bad argument; expected procedure" _pred147892_))
      (let ((_end147897_ (f64vector-length _v147894_)))
        (declare (not safe))
        (let _lp147901_ ((_i147904_ '0))
          (if (fx< _i147904_ _end147897_)
              (let ((_$e147907_
                     (_pred147892_ (f64vector-ref _v147894_ _i147904_))))
                (if _$e147907_
                    (values _$e147907_)
                    (_lp147901_ (fx+ _i147904_ '1))))
              '#f)))))
  (define std/srfi/160/f64#f64vector-any__1
    (lambda (_pred147910_ _v147911_ . _vs147912_)
      (if (procedure? _pred147910_)
          '#!void
          (error '"Bad argument; expected procedure" _pred147910_))
      (let* ((_v147915_ (cons _v147911_ _vs147912_))
             (_end147917_ (apply fxmin (map f64vector-length _vs147912_))))
        (declare (not safe))
        (let _lp147921_ ((_i147923_ '0))
          (if (fx< _i147923_ _end147917_)
              (let ((_$e147929_
                     (apply _pred147910_
                            (map (lambda (_g147924147926_)
                                   (f64vector-ref _g147924147926_ _i147923_))
                                 _vs147912_))))
                (if _$e147929_
                    (values _$e147929_)
                    (_lp147921_ (fx+ _i147923_ '1))))
              '#f)))))
  (define std/srfi/160/f64#f64vector-any
    (lambda _g299383_
      (let ((_g299382_ (let () (declare (not safe)) (##length _g299383_))))
        (cond ((let () (declare (not safe)) (##fx= _g299382_ 2))
               (apply std/srfi/160/f64#f64vector-any__0 _g299383_))
              ((let () (declare (not safe)) (##fx>= _g299382_ 2))
               (apply std/srfi/160/f64#f64vector-any__1 _g299383_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-any
                _g299383_))))))
  (define std/srfi/160/f64#f64vector-every__0
    (lambda (_pred147841_ _v147843_)
      (if (procedure? _pred147841_)
          '#!void
          (error '"Bad argument; expected procedure" _pred147841_))
      (let ((_end147846_ (f64vector-length _v147843_)))
        (declare (not safe))
        (let _lp147850_ ((_i147853_ '0) (_r147855_ '#t))
          (if (fx< _i147853_ _end147846_)
              (let ((_$e147858_
                     (_pred147841_ (f64vector-ref _v147843_ _i147853_))))
                (if _$e147858_
                    ((lambda (_g147860147862_)
                       (_lp147850_ (fx+ _i147853_ '1) _g147860147862_))
                     _$e147858_)
                    '#f))
              _r147855_)))))
  (define std/srfi/160/f64#f64vector-every__1
    (lambda (_pred147865_ _v147866_ . _vs147867_)
      (if (procedure? _pred147865_)
          '#!void
          (error '"Bad argument; expected procedure" _pred147865_))
      (let* ((_v147870_ (cons _v147866_ _vs147867_))
             (_end147872_ (apply fxmin (map f64vector-length _vs147867_))))
        (declare (not safe))
        (let _lp147876_ ((_i147878_ '0) (_r147879_ '#t))
          (if (fx< _i147878_ _end147872_)
              (let ((_$e147885_
                     (apply _pred147865_
                            (map (lambda (_g147880147882_)
                                   (f64vector-ref _g147880147882_ _i147878_))
                                 _vs147867_))))
                (if _$e147885_
                    ((lambda (_g147887147889_)
                       (_lp147876_ (fx+ _i147878_ '1) _g147887147889_))
                     _$e147885_)
                    '#f))
              _r147879_)))))
  (define std/srfi/160/f64#f64vector-every
    (lambda _g299385_
      (let ((_g299384_ (let () (declare (not safe)) (##length _g299385_))))
        (cond ((let () (declare (not safe)) (##fx= _g299384_ 2))
               (apply std/srfi/160/f64#f64vector-every__0 _g299385_))
              ((let () (declare (not safe)) (##fx>= _g299384_ 2))
               (apply std/srfi/160/f64#f64vector-every__1 _g299385_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-every
                _g299385_))))))
  (define std/srfi/160/f64#f64vector-partition
    (lambda (_pred147812_ _v147814_)
      (let* ((_count147817_
              (std/srfi/160/f64#f64vector-count__0 _pred147812_ _v147814_))
             (_len147820_ (f64vector-length _v147814_))
             (_u147823_ (make-f64vector _len147820_)))
        (declare (not safe))
        (let _lp147828_ ((_i147831_ '0)
                         (_left147833_ '0)
                         (_right147835_ _count147817_))
          (if (fx< _i147831_ _len147820_)
              (let ((_x147838_ (f64vector-ref _v147814_ _i147831_)))
                (if (_pred147812_ _x147838_)
                    (begin
                      (f64vector-set! _u147823_ _left147833_ _x147838_)
                      (_lp147828_
                       (fx+ _i147831_ '1)
                       (fx+ _left147833_ '1)
                       _right147835_))
                    (begin
                      (f64vector-set! _u147823_ _right147835_ _x147838_)
                      (_lp147828_
                       (fx+ _i147831_ '1)
                       _left147833_
                       (fx+ _right147835_ '1)))))
              _u147823_)))))
  (define std/srfi/160/f64#f64vector-filter
    (lambda (_pred147785_ _v147787_)
      (let* ((_count147790_
              (std/srfi/160/f64#f64vector-count__0 _pred147785_ _v147787_))
             (_u147793_ (make-f64vector _count147790_))
             (_end147796_ (f64vector-length _v147787_)))
        (declare (not safe))
        (let _lp147801_ ((_i147804_ '0) (_j147806_ '0))
          (if (fx< _i147804_ _end147796_)
              (let ((_x147809_ (f64vector-ref _v147787_ _i147804_)))
                (if (_pred147785_ _x147809_)
                    (begin
                      (f64vector-set! _u147793_ _j147806_ _x147809_)
                      (_lp147801_ (fx+ _i147804_ '1) (fx+ _j147806_ '1)))
                    (_lp147801_ (fx+ _i147804_ '1) _j147806_)))
              _u147793_)))))
  (define std/srfi/160/f64#f64vector-remove
    (lambda (_pred147777_ _v147779_)
      (std/srfi/160/f64#f64vector-filter
       (lambda (_$obj147782_) (not (_pred147777_ _$obj147782_)))
       _v147779_)))
  (define std/srfi/160/f64#f64vector-swap
    (lambda (_v147764_ _i147766_ _j147768_)
      (let ((_iv147771_ (f64vector-ref _v147764_ _i147766_))
            (_jv147773_ (f64vector-ref _v147764_ _j147768_)))
        (declare (not safe))
        (begin
          (f64vector-set! _v147764_ _i147766_ _jv147773_)
          (f64vector-set! _v147764_ _j147768_ _iv147771_)))))
  (define std/srfi/160/f64#f64vector-fill!__%
    (lambda (_v147727_ _fill147729_ _start147731_ _end147733_)
      (declare (not safe))
      (begin
        (if (f64vector? _v147727_) '#!void (error '"Bad argument" _v147727_))
        (if (flonum? _fill147729_)
            '#!void
            (error '"Bad argument" _fill147729_))
        (if (and (fixnum? _start147731_)
                 (fx<= '0 _start147731_ (fx- (f64vector-length _v147727_) '1)))
            '#!void
            (error '"Index out of range" _start147731_))
        (if (and (fixnum? _end147733_)
                 (fx<= _start147731_ _end147733_ (f64vector-length _v147727_)))
            '#!void
            (error '"Index out of range" _end147733_))
        (let _lp147737_ ((_i147740_ _start147731_))
          (if (fx< _i147740_ _end147733_)
              (begin
                (f64vector-set! _v147727_ _i147740_ _fill147729_)
                (_lp147737_ (fx+ _i147740_ '1)))
              '#!void)))))
  (define std/srfi/160/f64#f64vector-fill!__0
    (lambda (_v147746_ _fill147747_)
      (let* ((_start147749_ '0) (_end147751_ (f64vector-length _v147746_)))
        (std/srfi/160/f64#f64vector-fill!__%
         _v147746_
         _fill147747_
         _start147749_
         _end147751_))))
  (define std/srfi/160/f64#f64vector-fill!__1
    (lambda (_v147753_ _fill147754_ _start147755_)
      (let ((_end147757_ (f64vector-length _v147753_)))
        (std/srfi/160/f64#f64vector-fill!__%
         _v147753_
         _fill147754_
         _start147755_
         _end147757_))))
  (define std/srfi/160/f64#f64vector-fill!
    (lambda _g299387_
      (let ((_g299386_ (let () (declare (not safe)) (##length _g299387_))))
        (cond ((let () (declare (not safe)) (##fx= _g299386_ 2))
               (apply std/srfi/160/f64#f64vector-fill!__0 _g299387_))
              ((let () (declare (not safe)) (##fx= _g299386_ 3))
               (apply std/srfi/160/f64#f64vector-fill!__1 _g299387_))
              ((let () (declare (not safe)) (##fx= _g299386_ 4))
               (apply std/srfi/160/f64#f64vector-fill!__% _g299387_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-fill!
                _g299387_))))))
  (define std/srfi/160/f64#f64vector-reverse!__%
    (lambda (_v147687_ _start147689_ _end147691_)
      (declare (not safe))
      (begin
        (if (f64vector? _v147687_) '#!void (error '"Bad argument" _v147687_))
        (if (and (fixnum? _start147689_)
                 (fx<= '0 _start147689_ (fx- (f64vector-length _v147687_) '1)))
            '#!void
            (error '"Index out of range" _start147689_))
        (if (and (fixnum? _end147691_)
                 (fx<= _start147689_ _end147691_ (f64vector-length _v147687_)))
            '#!void
            (error '"Index out of range" _end147691_))
        (let _lp147695_ ((_i147698_ _start147689_)
                         (_j147700_ (fx- _end147691_ '1)))
          (if (fx< _i147698_ _j147700_)
              (let ((_iv147703_ (f64vector-ref _v147687_ _i147698_))
                    (_jv147705_ (f64vector-ref _v147687_ _j147700_)))
                (f64vector-set! _v147687_ _i147698_ _jv147705_)
                (f64vector-set! _v147687_ _j147700_ _iv147703_)
                (_lp147695_ (fx+ _i147698_ '1) (fx- _j147700_ '1)))
              '#!void)))))
  (define std/srfi/160/f64#f64vector-reverse!__0
    (lambda (_v147711_)
      (let* ((_start147713_ '0) (_end147715_ (f64vector-length _v147711_)))
        (std/srfi/160/f64#f64vector-reverse!__%
         _v147711_
         _start147713_
         _end147715_))))
  (define std/srfi/160/f64#f64vector-reverse!__1
    (lambda (_v147717_ _start147718_)
      (let ((_end147720_ (f64vector-length _v147717_)))
        (std/srfi/160/f64#f64vector-reverse!__%
         _v147717_
         _start147718_
         _end147720_))))
  (define std/srfi/160/f64#f64vector-reverse!
    (lambda _g299389_
      (let ((_g299388_ (let () (declare (not safe)) (##length _g299389_))))
        (cond ((let () (declare (not safe)) (##fx= _g299388_ 1))
               (apply std/srfi/160/f64#f64vector-reverse!__0 _g299389_))
              ((let () (declare (not safe)) (##fx= _g299388_ 2))
               (apply std/srfi/160/f64#f64vector-reverse!__1 _g299389_))
              ((let () (declare (not safe)) (##fx= _g299388_ 3))
               (apply std/srfi/160/f64#f64vector-reverse!__% _g299389_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector-reverse!
                _g299389_))))))
  (define std/srfi/160/f64#f64vector-unfold!
    (lambda (_f147662_ _v147664_ _start147666_ _end147668_ _seed147670_)
      (declare (not safe))
      (begin
        (if (procedure? _f147662_)
            '#!void
            (error '"Bad argument; expected procedure" _f147662_))
        (if (f64vector? _v147664_) '#!void (error '"Bad argument" _v147664_))
        (if (and (fixnum? _start147666_)
                 (fx<= '0 _start147666_ (fx- (f64vector-length _v147664_) '1)))
            '#!void
            (error '"Index out of range" _start147666_))
        (if (and (fixnum? _end147668_)
                 (fx<= _start147666_ _end147668_ (f64vector-length _v147664_)))
            '#!void
            (error '"Index out of range" _end147668_))
        (let _lp147674_ ((_i147677_ _start147666_)
                         (_state147679_ _seed147670_))
          (if (fx< _i147677_ _end147668_)
              (let ((_g299390_ (_f147662_ _state147679_)))
                (begin
                  (let ((_g299391_
                         (if (##values? _g299390_)
                             (##vector-length _g299390_)
                             1)))
                    (if (not (##fx= _g299391_ 2))
                        (error "Context expects 2 values" _g299391_)))
                  (let ((_x147682_ (##vector-ref _g299390_ 0))
                        (_state147684_ (##vector-ref _g299390_ 1)))
                    (begin
                      (f64vector-set! _v147664_ _i147677_ _x147682_)
                      (_lp147674_ (fx+ _i147677_ '1) _state147684_)))))
              '#!void)))))
  (define std/srfi/160/f64#f64vector-unfold-right!
    (lambda (_f147638_ _v147640_ _start147642_ _end147644_ _seed147646_)
      (declare (not safe))
      (begin
        (if (procedure? _f147638_)
            '#!void
            (error '"Bad argument; expected procedure" _f147638_))
        (if (f64vector? _v147640_) '#!void (error '"Bad argument" _v147640_))
        (if (and (fixnum? _start147642_)
                 (fx<= '0 _start147642_ (fx- (f64vector-length _v147640_) '1)))
            '#!void
            (error '"Index out of range" _start147642_))
        (if (and (fixnum? _end147644_)
                 (fx<= _start147642_ _end147644_ (f64vector-length _v147640_)))
            '#!void
            (error '"Index out of range" _end147644_))
        (let _lp147650_ ((_i147653_ (fx- _end147644_ '1))
                         (_state147655_ _seed147646_))
          (if (fx>= _i147653_ _start147642_)
              (let ((_g299392_ (_f147638_ _state147655_)))
                (begin
                  (let ((_g299393_
                         (if (##values? _g299392_)
                             (##vector-length _g299392_)
                             1)))
                    (if (not (##fx= _g299393_ 2))
                        (error "Context expects 2 values" _g299393_)))
                  (let ((_x147658_ (##vector-ref _g299392_ 0))
                        (_state147660_ (##vector-ref _g299392_ 1)))
                    (begin
                      (f64vector-set! _v147640_ _i147653_ _x147658_)
                      (_lp147650_ (fx- _i147653_ '1) _state147660_)))))
              '#!void)))))
  (define std/srfi/160/f64#reverse-f64vector->list__%
    (lambda (_v147604_ _start147606_ _end147608_)
      (declare (not safe))
      (begin
        (if (f64vector? _v147604_) '#!void (error '"Bad argument" _v147604_))
        (if (and (fixnum? _start147606_)
                 (fx<= '0 _start147606_ (fx- (f64vector-length _v147604_) '1)))
            '#!void
            (error '"Index out of range" _start147606_))
        (if (and (fixnum? _end147608_)
                 (fx<= _start147606_ _end147608_ (f64vector-length _v147604_)))
            '#!void
            (error '"Index out of range" _end147608_))
        (let _lp147612_ ((_i147615_ _start147606_) (_r147617_ '()))
          (if (fx< _i147615_ _end147608_)
              (_lp147612_
               (fx+ _i147615_ '1)
               (cons (f64vector-ref _v147604_ _i147615_) _r147617_))
              _r147617_)))))
  (define std/srfi/160/f64#reverse-f64vector->list__0
    (lambda (_v147623_)
      (let* ((_start147625_ '0) (_end147627_ (f64vector-length _v147623_)))
        (std/srfi/160/f64#reverse-f64vector->list__%
         _v147623_
         _start147625_
         _end147627_))))
  (define std/srfi/160/f64#reverse-f64vector->list__1
    (lambda (_v147629_ _start147630_)
      (let ((_end147632_ (f64vector-length _v147629_)))
        (std/srfi/160/f64#reverse-f64vector->list__%
         _v147629_
         _start147630_
         _end147632_))))
  (define std/srfi/160/f64#reverse-f64vector->list
    (lambda _g299395_
      (let ((_g299394_ (let () (declare (not safe)) (##length _g299395_))))
        (cond ((let () (declare (not safe)) (##fx= _g299394_ 1))
               (apply std/srfi/160/f64#reverse-f64vector->list__0 _g299395_))
              ((let () (declare (not safe)) (##fx= _g299394_ 2))
               (apply std/srfi/160/f64#reverse-f64vector->list__1 _g299395_))
              ((let () (declare (not safe)) (##fx= _g299394_ 3))
               (apply std/srfi/160/f64#reverse-f64vector->list__% _g299395_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#reverse-f64vector->list
                _g299395_))))))
  (define std/srfi/160/f64#reverse-list->f64vector
    (lambda (_lst147550_)
      (let* ((_len147553_ (length _lst147550_))
             (_v147556_ (make-f64vector _len147553_)))
        (declare (not safe))
        (let _lp147561_ ((_rest147564_ _lst147550_) (_i147566_ '0))
          (let* ((_rest147568147576_ _rest147564_)
                 (_else147570147584_ (lambda () _v147556_))
                 (_K147572147591_
                  (lambda (_rest147587_ _x147588_)
                    (if (flonum? _x147588_)
                        '#!void
                        (error '"Bad element" _x147588_))
                    (f64vector-set! _v147556_ _i147566_ _x147588_)
                    (_lp147561_ _rest147587_ (fx+ _i147566_ '1)))))
            (if (##pair? _rest147568147576_)
                (let ((_hd147573147594_ (##car _rest147568147576_))
                      (_tl147574147596_ (##cdr _rest147568147576_)))
                  (let* ((_x147599_ _hd147573147594_)
                         (_rest147601_ _tl147574147596_))
                    (_K147572147591_ _rest147601_ _x147599_)))
                (_else147570147584_)))))))
  (define std/srfi/160/f64#f64vector->vector__%
    (lambda (_v147511_ _start147513_ _end147515_)
      (declare (not safe))
      (begin
        (if (f64vector? _v147511_) '#!void (error '"Bad argument" _v147511_))
        (if (and (fixnum? _start147513_)
                 (fx<= '0 _start147513_ (fx- (f64vector-length _v147511_) '1)))
            '#!void
            (error '"Index out of range" _start147513_))
        (if (and (fixnum? _end147515_)
                 (fx<= _start147513_ _end147515_ (f64vector-length _v147511_)))
            '#!void
            (error '"Index out of range" _end147515_))
        (let* ((_len147519_ (f64vector-length _v147511_))
               (_u147522_ (make-vector _len147519_)))
          (let _lp147526_ ((_i147529_ '0))
            (if (fx< _i147529_ _len147519_)
                (begin
                  (vector-set!
                   _u147522_
                   _i147529_
                   (f64vector-ref _v147511_ _i147529_))
                  (_lp147526_ (fx+ _i147529_ '1)))
                _u147522_))))))
  (define std/srfi/160/f64#f64vector->vector__0
    (lambda (_v147535_)
      (let* ((_start147537_ '0) (_end147539_ (f64vector-length _v147535_)))
        (std/srfi/160/f64#f64vector->vector__%
         _v147535_
         _start147537_
         _end147539_))))
  (define std/srfi/160/f64#f64vector->vector__1
    (lambda (_v147541_ _start147542_)
      (let ((_end147544_ (f64vector-length _v147541_)))
        (std/srfi/160/f64#f64vector->vector__%
         _v147541_
         _start147542_
         _end147544_))))
  (define std/srfi/160/f64#f64vector->vector
    (lambda _g299397_
      (let ((_g299396_ (let () (declare (not safe)) (##length _g299397_))))
        (cond ((let () (declare (not safe)) (##fx= _g299396_ 1))
               (apply std/srfi/160/f64#f64vector->vector__0 _g299397_))
              ((let () (declare (not safe)) (##fx= _g299396_ 2))
               (apply std/srfi/160/f64#f64vector->vector__1 _g299397_))
              ((let () (declare (not safe)) (##fx= _g299396_ 3))
               (apply std/srfi/160/f64#f64vector->vector__% _g299397_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#f64vector->vector
                _g299397_))))))
  (define std/srfi/160/f64#vector->f64vector__%
    (lambda (_v147471_ _start147473_ _end147475_)
      (declare (not safe))
      (begin
        (if (vector? _v147471_)
            '#!void
            (error '"Bad argument; expected vector" _v147471_))
        (if (and (fixnum? _start147473_)
                 (fx<= '0 _start147473_ (fx- (vector-length _v147471_) '1)))
            '#!void
            (error '"Index out of range" _start147473_))
        (if (and (fixnum? _end147475_)
                 (fx<= _start147473_ _end147475_ (vector-length _v147471_)))
            '#!void
            (error '"Index out of range" _end147475_))
        (let* ((_len147479_ (vector-length _v147471_))
               (_u147482_ (make-f64vector _len147479_)))
          (let _lp147486_ ((_i147489_ '0))
            (if (fx< _i147489_ _len147479_)
                (begin
                  (f64vector-set!
                   _u147482_
                   _i147489_
                   (vector-ref _v147471_ _i147489_))
                  (_lp147486_ (fx+ _i147489_ '1)))
                _u147482_))))))
  (define std/srfi/160/f64#vector->f64vector__0
    (lambda (_v147495_)
      (let* ((_start147497_ '0) (_end147499_ (vector-length _v147495_)))
        (std/srfi/160/f64#vector->f64vector__%
         _v147495_
         _start147497_
         _end147499_))))
  (define std/srfi/160/f64#vector->f64vector__1
    (lambda (_v147501_ _start147502_)
      (let ((_end147504_ (vector-length _v147501_)))
        (std/srfi/160/f64#vector->f64vector__%
         _v147501_
         _start147502_
         _end147504_))))
  (define std/srfi/160/f64#vector->f64vector
    (lambda _g299399_
      (let ((_g299398_ (let () (declare (not safe)) (##length _g299399_))))
        (cond ((let () (declare (not safe)) (##fx= _g299398_ 1))
               (apply std/srfi/160/f64#vector->f64vector__0 _g299399_))
              ((let () (declare (not safe)) (##fx= _g299398_ 2))
               (apply std/srfi/160/f64#vector->f64vector__1 _g299399_))
              ((let () (declare (not safe)) (##fx= _g299398_ 3))
               (apply std/srfi/160/f64#vector->f64vector__% _g299399_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#vector->f64vector
                _g299399_))))))
  (define std/srfi/160/f64#make-f64vector-generator__%
    (lambda (_v147437_ _start147439_ _end147441_)
      (declare (not safe))
      (begin
        (if (f64vector? _v147437_) '#!void (error '"Bad argument" _v147437_))
        (if (and (fixnum? _start147439_)
                 (fx<= '0 _start147439_ (fx- (f64vector-length _v147437_) '1)))
            '#!void
            (error '"Index out of range" _start147439_))
        (if (and (fixnum? _end147441_)
                 (fx<= _start147439_ _end147441_ (f64vector-length _v147437_)))
            '#!void
            (error '"Index out of range" _end147441_))
        (let ((_i147445_ _start147439_))
          (lambda ()
            (if (fx< _i147445_ _end147441_)
                (let ((_next147449_ (f64vector-ref _v147437_ _i147445_)))
                  (set! _i147445_ (fx+ _i147445_ '1))
                  _next147449_)
                '#!eof))))))
  (define std/srfi/160/f64#make-f64vector-generator__0
    (lambda (_v147455_)
      (let* ((_start147457_ '0) (_end147459_ (f64vector-length _v147455_)))
        (std/srfi/160/f64#make-f64vector-generator__%
         _v147455_
         _start147457_
         _end147459_))))
  (define std/srfi/160/f64#make-f64vector-generator__1
    (lambda (_v147461_ _start147462_)
      (let ((_end147464_ (f64vector-length _v147461_)))
        (std/srfi/160/f64#make-f64vector-generator__%
         _v147461_
         _start147462_
         _end147464_))))
  (define std/srfi/160/f64#make-f64vector-generator
    (lambda _g299401_
      (let ((_g299400_ (let () (declare (not safe)) (##length _g299401_))))
        (cond ((let () (declare (not safe)) (##fx= _g299400_ 1))
               (apply std/srfi/160/f64#make-f64vector-generator__0 _g299401_))
              ((let () (declare (not safe)) (##fx= _g299400_ 2))
               (apply std/srfi/160/f64#make-f64vector-generator__1 _g299401_))
              ((let () (declare (not safe)) (##fx= _g299400_ 3))
               (apply std/srfi/160/f64#make-f64vector-generator__% _g299401_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#make-f64vector-generator
                _g299401_))))))
  (define std/srfi/160/f64#f64vector-comparator
    (let ()
      (letrec ((_<?147408_
                (lambda (_a147411_ _b147413_)
                  (let ((_len-a147416_ (f64vector-length _a147411_))
                        (_len-b147418_ (f64vector-length _b147413_)))
                    (declare (not safe))
                    (if (fx< _len-a147416_ _len-b147418_)
                        '#t
                        (if (fx> _len-a147416_ _len-b147418_)
                            '#f
                            (let ((_end147422_ _len-a147416_))
                              (let _lp147425_ ((_i147428_ '0))
                                (if (fx< _i147428_ _end147422_)
                                    (let ((_x147431_
                                           (f64vector-ref _a147411_ _i147428_))
                                          (_y147433_
                                           (f64vector-ref
                                            _b147413_
                                            _i147428_)))
                                      (if (< _x147431_ _y147433_)
                                          '#t
                                          (if (> _x147431_ _y147433_)
                                              '#f
                                              (_lp147425_
                                               (fx+ _i147428_ '1)))))
                                    '#f)))))))))
        (let ()
          (declare (not safe))
          (##structure
           std/srfi/128#comparator::t
           f64vector?
           std/srfi/160/f64#f64vector=
           _<?147408_
           equal?-hash)))))
  (define std/srfi/160/f64#write-f64vector__%
    (lambda (_v147385_ _port147387_)
      (let ((_$e147390_ (find-method _v147385_ ':write)))
        (if _$e147390_
            ((lambda (_g147392147394_)
               (_g147392147394_ _v147385_ _port147387_))
             _$e147390_)
            (write _v147385_ (current-output-port))))))
  (define std/srfi/160/f64#write-f64vector__0
    (lambda (_v147400_)
      (let ((_port147402_ (current-output-port)))
        (std/srfi/160/f64#write-f64vector__% _v147400_ _port147402_))))
  (define std/srfi/160/f64#write-f64vector
    (lambda _g299403_
      (let ((_g299402_ (let () (declare (not safe)) (##length _g299403_))))
        (cond ((let () (declare (not safe)) (##fx= _g299402_ 1))
               (apply std/srfi/160/f64#write-f64vector__0 _g299403_))
              ((let () (declare (not safe)) (##fx= _g299402_ 2))
               (apply std/srfi/160/f64#write-f64vector__% _g299403_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/srfi/160/f64#write-f64vector
                _g299403_)))))))
