(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/srfi-135/etc#string-copy!
    (lambda (_s101176_ _i101177_ _x101178_)
      (substring-move!
       _s101176_
       _i101177_
       _x101178_
       '0
       (string-length _x101178_))))
  (define std/srfi/srfi-135/etc#div-and-mod
    (lambda (_x101163_ _y101164_)
      (if (and (exact-integer? _x101163_) (exact-integer? _y101164_))
          (if (= _y101164_ '0)
              (error '"mod: zero divisor" _x101163_ _y101164_)
              (if (>= _x101163_ '0)
                  (values (quotient _x101163_ _y101164_)
                          (remainder _x101163_ _y101164_))
                  (if (< _y101164_ '0)
                      (let* ((_q101166_ (quotient _x101163_ _y101164_))
                             (_r101168_ (- _x101163_ (* _q101166_ _y101164_))))
                        (if (= _r101168_ '0)
                            (values _q101166_ '0)
                            (values (+ _q101166_ '1) (- _r101168_ _y101164_))))
                      (let* ((_q101171_ (quotient _x101163_ _y101164_))
                             (_r101173_ (- _x101163_ (* _q101171_ _y101164_))))
                        (if (= _r101173_ '0)
                            (values _q101171_ '0)
                            (values (- _q101171_ '1)
                                    (+ _r101173_ _y101164_)))))))
          (error '"div or mod: illegal arguments" _x101163_ _y101164_))))
  (define std/srfi/srfi-135/etc#div
    (lambda (_x101156_ _y101157_)
      (if (and (exact-integer? _x101156_)
               (exact-integer? _y101157_)
               (>= _x101156_ '0))
          (quotient _x101156_ _y101157_)
          (call-with-values
           (lambda () (std/srfi/srfi-135/etc#div-and-mod _x101156_ _y101157_))
           (lambda (_q101160_ _r101161_) _q101160_)))))
  (define std/srfi/srfi-135/etc#mod
    (lambda (_x101149_ _y101150_)
      (if (and (exact-integer? _x101149_)
               (exact-integer? _y101150_)
               (>= _x101149_ '0))
          (remainder _x101149_ _y101150_)
          (call-with-values
           (lambda () (std/srfi/srfi-135/etc#div-and-mod _x101149_ _y101150_))
           (lambda (_q101153_ _r101154_) _r101154_)))))
  (define std/srfi/srfi-135/etc#last-pair
    (lambda (_x101147_)
      (if (and (pair? _x101147_) (pair? (cdr _x101147_)))
          (std/srfi/srfi-135/etc#last-pair (cdr _x101147_))
          _x101147_)))
  (define std/srfi/srfi-135/etc#list-take
    (lambda (_x101138_ _n101139_)
      (let _loop101141_ ((_n101143_ _n101139_)
                         (_x101144_ _x101138_)
                         (_y101145_ '()))
        (if (= _n101143_ '0)
            (reverse _y101145_)
            (_loop101141_
             (- _n101143_ '1)
             (cdr _x101144_)
             (cons (car _x101144_) _y101145_)))))))
