(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/text/csv#+line-endings+
    (cons std/misc/string#+cr+
          (cons std/misc/string#+lf+ (cons std/misc/string#+crlf+ '()))))
  (define std/text/csv#+strict-line-endings+
    (cons std/misc/string#+crlf+ (cons std/misc/string#+lf+ '())))
  (define std/text/csv#csv-options::t
    (make-struct-type
     'std/text/csv#csv-options::t
     '#f
     '10
     'csv-options
     '((transparent: . #t))
     '#f
     '(separator
       quote
       unquoted-quotequote?
       loose-quote?
       allow-binary?
       eol
       accept-lf?
       accept-cr?
       accept-crlf?
       skip-whitespace?)))
  (define std/text/csv#csv-options?
    (make-struct-predicate std/text/csv#csv-options::t))
  (define std/text/csv#make-csv-options
    (lambda _$args169314_
      (apply make-struct-instance std/text/csv#csv-options::t _$args169314_)))
  (define std/text/csv#csv-options-separator
    (make-struct-field-accessor std/text/csv#csv-options::t '0))
  (define std/text/csv#csv-options-quote
    (make-struct-field-accessor std/text/csv#csv-options::t '1))
  (define std/text/csv#csv-options-unquoted-quotequote?
    (make-struct-field-accessor std/text/csv#csv-options::t '2))
  (define std/text/csv#csv-options-loose-quote?
    (make-struct-field-accessor std/text/csv#csv-options::t '3))
  (define std/text/csv#csv-options-allow-binary?
    (make-struct-field-accessor std/text/csv#csv-options::t '4))
  (define std/text/csv#csv-options-eol
    (make-struct-field-accessor std/text/csv#csv-options::t '5))
  (define std/text/csv#csv-options-accept-lf?
    (make-struct-field-accessor std/text/csv#csv-options::t '6))
  (define std/text/csv#csv-options-accept-cr?
    (make-struct-field-accessor std/text/csv#csv-options::t '7))
  (define std/text/csv#csv-options-accept-crlf?
    (make-struct-field-accessor std/text/csv#csv-options::t '8))
  (define std/text/csv#csv-options-skip-whitespace?
    (make-struct-field-accessor std/text/csv#csv-options::t '9))
  (define std/text/csv#csv-options-separator-set!
    (make-struct-field-mutator std/text/csv#csv-options::t '0))
  (define std/text/csv#csv-options-quote-set!
    (make-struct-field-mutator std/text/csv#csv-options::t '1))
  (define std/text/csv#csv-options-unquoted-quotequote?-set!
    (make-struct-field-mutator std/text/csv#csv-options::t '2))
  (define std/text/csv#csv-options-loose-quote?-set!
    (make-struct-field-mutator std/text/csv#csv-options::t '3))
  (define std/text/csv#csv-options-allow-binary?-set!
    (make-struct-field-mutator std/text/csv#csv-options::t '4))
  (define std/text/csv#csv-options-eol-set!
    (make-struct-field-mutator std/text/csv#csv-options::t '5))
  (define std/text/csv#csv-options-accept-lf?-set!
    (make-struct-field-mutator std/text/csv#csv-options::t '6))
  (define std/text/csv#csv-options-accept-cr?-set!
    (make-struct-field-mutator std/text/csv#csv-options::t '7))
  (define std/text/csv#csv-options-accept-crlf?-set!
    (make-struct-field-mutator std/text/csv#csv-options::t '8))
  (define std/text/csv#csv-options-skip-whitespace?-set!
    (make-struct-field-mutator std/text/csv#csv-options::t '9))
  (define std/text/csv#rfc4180-csv-options
    (let ()
      (declare (not safe))
      (##structure
       std/text/csv#csv-options::t
       '#\,
       '#\"
       '#f
       '#f
       '#t
       std/misc/string#+lf+
       '#t
       '#f
       '#t
       '#f)))
  (define std/text/csv#strict-rfc4180-csv-options
    (let ()
      (declare (not safe))
      (##structure
       std/text/csv#csv-options::t
       '#\,
       '#\"
       '#f
       '#f
       '#f
       std/misc/string#+crlf+
       '#f
       '#f
       '#t
       '#f)))
  (define std/text/csv#creativyst-csv-options
    (let ()
      (declare (not safe))
      (##structure
       std/text/csv#csv-options::t
       '#\,
       '#\"
       '#f
       '#f
       '#t
       std/misc/string#+crlf+
       '#t
       '#t
       '#t
       '#t)))
  (define std/text/csv#current-csv-options
    (make-parameter std/text/csv#creativyst-csv-options))
  (define std/text/csv#call-with-rfc4180-csv-syntax
    (lambda (_thunk169311_)
      (call-with-parameters
       (lambda () (_thunk169311_))
       std/text/csv#current-csv-options
       std/text/csv#rfc4180-csv-options)))
  (define std/text/csv#call-with-strict-rfc4180-csv-syntax
    (lambda (_thunk169308_)
      (call-with-parameters
       (lambda () (_thunk169308_))
       std/text/csv#current-csv-options
       std/text/csv#strict-rfc4180-csv-options)))
  (define std/text/csv#call-with-creativyst-csv-syntax
    (lambda (_thunk169305_)
      (call-with-parameters
       (lambda () (_thunk169305_))
       std/text/csv#current-csv-options
       std/text/csv#creativyst-csv-options)))
  (define std/text/csv#valid-eol?
    (lambda (_x169303_) (member _x169303_ std/text/csv#+line-endings+)))
  (define std/text/csv#validate-csv-options__%
    (lambda (_csv-options169241_)
      (let ((_g169246169248_
             (##structure-ref
              _csv-options169241_
              '1
              std/text/csv#csv-options::t
              '#f)))
        (if (char? _g169246169248_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@133.12"
             '(char? {separator})
             (cons (cons '{separator} _g169246169248_) '()))))
      (let ((_g169250169252_
             (##structure-ref
              _csv-options169241_
              '2
              std/text/csv#csv-options::t
              '#f)))
        (if (char? _g169250169252_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@134.12"
             '(char? {quote})
             (cons (cons '{quote} _g169250169252_) '()))))
      (let ((_g169254169256_
             (equal? (##structure-ref
                      _csv-options169241_
                      '1
                      std/text/csv#csv-options::t
                      '#f)
                     (##structure-ref
                      _csv-options169241_
                      '2
                      std/text/csv#csv-options::t
                      '#f))))
        (if (not _g169254169256_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@135.12"
             '(not (equal? {separator} {quote}))
             (cons (cons '(equal? {separator} {quote}) _g169254169256_) '()))))
      (let ((_g169258169260_
             (##structure-ref
              _csv-options169241_
              '3
              std/text/csv#csv-options::t
              '#f)))
        (if (boolean? _g169258169260_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@136.12"
             '(boolean? {unquoted-quotequote?})
             (cons (cons '{unquoted-quotequote?} _g169258169260_) '()))))
      (let ((_g169262169264_
             (##structure-ref
              _csv-options169241_
              '4
              std/text/csv#csv-options::t
              '#f)))
        (if (boolean? _g169262169264_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@137.12"
             '(boolean? {loose-quote?})
             (cons (cons '{loose-quote?} _g169262169264_) '()))))
      (let ((_g169266169268_
             (##structure-ref
              _csv-options169241_
              '10
              std/text/csv#csv-options::t
              '#f)))
        (if (boolean? _g169266169268_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@138.12"
             '(boolean? {skip-whitespace?})
             (cons (cons '{skip-whitespace?} _g169266169268_) '()))))
      (let ((_g169270169272_
             (##structure-ref
              _csv-options169241_
              '6
              std/text/csv#csv-options::t
              '#f)))
        (if (std/text/csv#valid-eol? _g169270169272_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@139.12"
             '(valid-eol? {eol})
             (cons (cons '{eol} _g169270169272_) '()))))
      (let ((_g169274169276_
             (member (string-ref
                      (##structure-ref
                       _csv-options169241_
                       '6
                       std/text/csv#csv-options::t
                       '#f)
                      '0)
                     (cons (##structure-ref
                            _csv-options169241_
                            '1
                            std/text/csv#csv-options::t
                            '#f)
                           (cons (##structure-ref
                                  _csv-options169241_
                                  '2
                                  std/text/csv#csv-options::t
                                  '#f)
                                 '())))))
        (if (not _g169274169276_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@140.12"
             '(not (member (string-ref {eol} 0) [{separator} {quote}]))
             (cons (cons '(member (string-ref {eol} 0) [{separator} {quote}])
                         _g169274169276_)
                   '()))))
      (let ((_g169278169280_
             (##structure-ref
              _csv-options169241_
              '7
              std/text/csv#csv-options::t
              '#f)))
        (if (boolean? _g169278169280_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@141.12"
             '(boolean? {accept-lf?})
             (cons (cons '{accept-lf?} _g169278169280_) '()))))
      (let ((_g169282169284_
             (##structure-ref
              _csv-options169241_
              '8
              std/text/csv#csv-options::t
              '#f)))
        (if (boolean? _g169282169284_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@142.12"
             '(boolean? {accept-cr?})
             (cons (cons '{accept-cr?} _g169282169284_) '()))))
      (let ((_g169286169288_
             (##structure-ref
              _csv-options169241_
              '9
              std/text/csv#csv-options::t
              '#f)))
        (if (boolean? _g169286169288_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@143.12"
             '(boolean? {accept-crlf?})
             (cons (cons '{accept-crlf?} _g169286169288_) '()))))
      (let ((_g169290169292_
             (##structure-ref
              _csv-options169241_
              '10
              std/text/csv#csv-options::t
              '#f)))
        (if (boolean? _g169290169292_)
            '#!void
            (std/assert#assert!/fail
             '"\"text/csv.ss\"@144.12"
             '(boolean? {skip-whitespace?})
             (cons (cons '{skip-whitespace?} _g169290169292_) '()))))))
  (define std/text/csv#validate-csv-options__0
    (lambda ()
      (let ((_csv-options169299_ (std/text/csv#current-csv-options)))
        (std/text/csv#validate-csv-options__% _csv-options169299_))))
  (define std/text/csv#validate-csv-options
    (lambda _g302861_
      (let ((_g302860_ (let () (declare (not safe)) (##length _g302861_))))
        (cond ((let () (declare (not safe)) (##fx= _g302860_ 0))
               (apply std/text/csv#validate-csv-options__0 _g302861_))
              ((let () (declare (not safe)) (##fx= _g302860_ 1))
               (apply std/text/csv#validate-csv-options__% _g302861_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#validate-csv-options
                _g302861_))))))
  (define std/text/csv#char-ascii-text?
    (lambda (_c169230_)
      (let* ((_i169232_ (char->integer _c169230_))
             (_$e169234_ (<= '32 _i169232_ '126)))
        (if _$e169234_
            _$e169234_
            (let ((_$e169237_ (= _i169232_ '10)))
              (if _$e169237_ _$e169237_ (= _i169232_ '13)))))))
  (define std/text/csv#accept
    (lambda (_pred169227_ _port169228_)
      (if (_pred169227_ (peek-char _port169228_))
          (read-char _port169228_)
          '#f)))
  (define std/text/csv#accept=
    (lambda (_c169224_ _port169225_)
      (if (eqv? _c169224_ (peek-char _port169225_))
          (read-char _port169225_)
          '#f)))
  (define std/text/csv#accept-eof
    (lambda (_port169222_) (std/text/csv#accept= '#!eof _port169222_)))
  (define std/text/csv#read-csv-line__%
    (lambda (_port168957_ _csv-options168958_)
      (letrec* ((_ss168964_ (open-output-string))
                (_fields168965_ '())
                (_had-quotes?168966_ '#f)
                (_accept-eol168967_
                 (lambda (_port169198_)
                   (let ((_$e169200_
                          (if (##structure-ref
                               _csv-options168958_
                               '7
                               std/text/csv#csv-options::t
                               '#f)
                              (if (std/text/csv#accept=
                                   '#\newline
                                   _port169198_)
                                  '#t
                                  '#f)
                              '#f)))
                     (if _$e169200_
                         _$e169200_
                         (if (or (##structure-ref
                                  _csv-options168958_
                                  '8
                                  std/text/csv#csv-options::t
                                  '#f)
                                 (##structure-ref
                                  _csv-options168958_
                                  '9
                                  std/text/csv#csv-options::t
                                  '#f))
                             (if (std/text/csv#accept= '#\return _port169198_)
                                 (let ((_$e169206_
                                        (if (##structure-ref
                                             _csv-options168958_
                                             '9
                                             std/text/csv#csv-options::t
                                             '#f)
                                            (std/text/csv#accept=
                                             '#\newline
                                             _port169198_)
                                            '#f)))
                                   (if _$e169206_
                                       _$e169206_
                                       (let ((_$e169209_
                                              (##structure-ref
                                               _csv-options168958_
                                               '8
                                               std/text/csv#csv-options::t
                                               '#f)))
                                         (if _$e169209_
                                             _$e169209_
                                             (std/error#raise-io-error
                                              'accept-eol
                                              '"Carriage-Return without Linefeed!")))))
                                 '#f)
                             '#f)))))
                (_char-csv-space?168968_
                 (lambda (_c169193_)
                   (if (or (eqv? _c169193_ '#\space) (eqv? _c169193_ '#\tab))
                       (not (eqv? _c169193_
                                  (##structure-ref
                                   _csv-options168958_
                                   '1
                                   std/text/csv#csv-options::t
                                   '#f)))
                       '#f)))
                (_accept-space168969_
                 (lambda (_port169191_)
                   (std/text/csv#accept _char-csv-space?168968_ _port169191_)))
                (_accept-spaces168970_
                 (lambda (_port169014_)
                   (let* ((_head169016_ (cons '#f '()))
                          (_tail169019_ _head169016_))
                     (let _loop169183_ ()
                       (let ((_x169186_ (_accept-space168969_ _port169014_)))
                         (if _x169186_
                             (begin
                               (let ((_new-tail169188_ (cons _x169186_ '())))
                                 (let ()
                                   (declare (not safe))
                                   (##set-cdr! _tail169019_ _new-tail169188_))
                                 (set! _tail169019_ _new-tail169188_))
                               (_loop169183_))
                             '#!void)))
                     (let () (declare (not safe)) (##cdr _head169016_)))))
                (_accept-fields168971_
                 (lambda ()
                   (set! _had-quotes?168966_ '#f)
                   (if (##structure-ref
                        _csv-options168958_
                        '10
                        std/text/csv#csv-options::t
                        '#f)
                       (_accept-spaces168970_ _port168957_)
                       '#!void)
                   (if (and (null? _fields168965_)
                            (or (_accept-eol168967_ _port168957_)
                                (std/text/csv#accept-eof _port168957_)))
                       (_done168981_)
                       (_accept-field-start168972_))))
                (_accept-field-start168972_
                 (lambda ()
                   (if (std/text/csv#accept=
                        (##structure-ref
                         _csv-options168958_
                         '1
                         std/text/csv#csv-options::t
                         '#f)
                        _port168957_)
                       (begin (_add168978_ '"") (_accept-fields168971_))
                       (if (std/text/csv#accept=
                            (##structure-ref
                             _csv-options168958_
                             '2
                             std/text/csv#csv-options::t
                             '#f)
                            _port168957_)
                           (if (and (##structure-ref
                                     _csv-options168958_
                                     '3
                                     std/text/csv#csv-options::t
                                     '#f)
                                    (std/text/csv#accept=
                                     (##structure-ref
                                      _csv-options168958_
                                      '2
                                      std/text/csv#csv-options::t
                                      '#f)
                                     _port168957_))
                               (begin
                                 (_add-char168979_
                                  (##structure-ref
                                   _csv-options168958_
                                   '2
                                   std/text/csv#csv-options::t
                                   '#f))
                                 (_accept-field-unquoted168975_))
                               (_accept-field-quoted168973_))
                           (_accept-field-unquoted168975_)))))
                (_accept-field-quoted168973_
                 (lambda ()
                   (set! _had-quotes?168966_ '#t)
                   (if (std/text/csv#accept-eof _port168957_)
                       (std/error#raise-io-error
                        'read-csv-line
                        '"unexpected eof in quotes")
                       (if (std/text/csv#accept=
                            (##structure-ref
                             _csv-options168958_
                             '2
                             std/text/csv#csv-options::t
                             '#f)
                            _port168957_)
                           (if (std/text/csv#accept=
                                (##structure-ref
                                 _csv-options168958_
                                 '2
                                 std/text/csv#csv-options::t
                                 '#f)
                                _port168957_)
                               (_quoted-field-char168974_
                                (##structure-ref
                                 _csv-options168958_
                                 '2
                                 std/text/csv#csv-options::t
                                 '#f))
                               (if (##structure-ref
                                    _csv-options168958_
                                    '4
                                    std/text/csv#csv-options::t
                                    '#f)
                                   (_accept-field-unquoted168975_)
                                   (begin
                                     (_add168978_ (_current-string168980_))
                                     (_end-of-field168977_))))
                           (_quoted-field-char168974_
                            (read-char _port168957_))))))
                (_quoted-field-char168974_
                 (lambda (_c169006_)
                   (_add-char168979_ _c169006_)
                   (_accept-field-quoted168973_)))
                (_accept-field-unquoted168975_
                 (lambda ()
                   (if (##structure-ref
                        _csv-options168958_
                        '10
                        std/text/csv#csv-options::t
                        '#f)
                       (let ((_spaces169001_
                              (_accept-spaces168970_ _port168957_)))
                         (if (std/text/csv#accept=
                              (##structure-ref
                               _csv-options168958_
                               '1
                               std/text/csv#csv-options::t
                               '#f)
                              _port168957_)
                             (begin
                               (_add168978_ (_current-string168980_))
                               (_accept-fields168971_))
                             (if (or (_accept-eol168967_ _port168957_)
                                     (std/text/csv#accept-eof _port168957_))
                                 (begin
                                   (_add168978_ (_current-string168980_))
                                   (_done168981_))
                                 (begin
                                   (for-each _add-char168979_ _spaces169001_)
                                   (_accept-field-unquoted-no-skip168976_)))))
                       (_accept-field-unquoted-no-skip168976_))))
                (_accept-field-unquoted-no-skip168976_
                 (lambda ()
                   (if (std/text/csv#accept=
                        (##structure-ref
                         _csv-options168958_
                         '1
                         std/text/csv#csv-options::t
                         '#f)
                        _port168957_)
                       (begin
                         (_add168978_ (_current-string168980_))
                         (_accept-fields168971_))
                       (if (or (_accept-eol168967_ _port168957_)
                               (std/text/csv#accept-eof _port168957_))
                           (begin
                             (_add168978_ (_current-string168980_))
                             (_done168981_))
                           (if (std/text/csv#accept=
                                (##structure-ref
                                 _csv-options168958_
                                 '2
                                 std/text/csv#csv-options::t
                                 '#f)
                                _port168957_)
                               (if (and (##structure-ref
                                         _csv-options168958_
                                         '3
                                         std/text/csv#csv-options::t
                                         '#f)
                                        (std/text/csv#accept=
                                         (##structure-ref
                                          _csv-options168958_
                                          '2
                                          std/text/csv#csv-options::t
                                          '#f)
                                         _port168957_))
                                   (begin
                                     (_add-char168979_
                                      (##structure-ref
                                       _csv-options168958_
                                       '2
                                       std/text/csv#csv-options::t
                                       '#f))
                                     (_accept-field-unquoted168975_))
                                   (if (##structure-ref
                                        _csv-options168958_
                                        '4
                                        std/text/csv#csv-options::t
                                        '#f)
                                       (_accept-field-quoted168973_)
                                       (std/error#raise-io-error
                                        'read-csv-line
                                        '"unexpected quote in middle of field")))
                               (begin
                                 (_add-char168979_ (read-char _port168957_))
                                 (_accept-field-unquoted168975_)))))))
                (_end-of-field168977_
                 (lambda ()
                   (if (##structure-ref
                        _csv-options168958_
                        '10
                        std/text/csv#csv-options::t
                        '#f)
                       (_accept-spaces168970_ _port168957_)
                       '#!void)
                   (if (or (_accept-eol168967_ _port168957_)
                           (std/text/csv#accept-eof _port168957_))
                       (_done168981_)
                       (if (std/text/csv#accept=
                            (##structure-ref
                             _csv-options168958_
                             '1
                             std/text/csv#csv-options::t
                             '#f)
                            _port168957_)
                           (_accept-fields168971_)
                           (std/error#raise-io-error
                            'read-csv-line
                            '"end of field expected")))))
                (_add168978_
                 (lambda (_x168990_)
                   (set! _fields168965_ (cons _x168990_ _fields168965_))))
                (_add-char168979_
                 (lambda (_c168985_)
                   (if (or (##structure-ref
                            _csv-options168958_
                            '5
                            std/text/csv#csv-options::t
                            '#f)
                           (std/text/csv#char-ascii-text? _c168985_))
                       '#!void
                       (std/error#raise-io-error
                        'read-csv-line
                        '"binary data not allowed"
                        _c168985_))
                   (write-char _c168985_ _ss168964_)))
                (_current-string168980_
                 (lambda () (get-output-string _ss168964_)))
                (_done168981_
                 (lambda () (std/srfi/1#reverse! _fields168965_))))
        (_accept-fields168971_))))
  (define std/text/csv#read-csv-line__0
    (lambda (_port169215_)
      (let ((_csv-options169217_ (std/text/csv#current-csv-options)))
        (std/text/csv#read-csv-line__% _port169215_ _csv-options169217_))))
  (define std/text/csv#read-csv-line
    (lambda _g302863_
      (let ((_g302862_ (let () (declare (not safe)) (##length _g302863_))))
        (cond ((let () (declare (not safe)) (##fx= _g302862_ 1))
               (apply std/text/csv#read-csv-line__0 _g302863_))
              ((let () (declare (not safe)) (##fx= _g302862_ 2))
               (apply std/text/csv#read-csv-line__% _g302863_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#read-csv-line
                _g302863_))))))
  (define std/text/csv#read-csv-lines__%
    (lambda (_port168933_ _csv-options168934_)
      (std/text/csv#validate-csv-options__% _csv-options168934_)
      (std/misc/list-builder#call-with-list-builder
       (lambda (_c168940_ _g302864_)
         (let _lp168942_ ()
           (if (std/text/csv#accept-eof _port168933_)
               '#!void
               (begin
                 (_c168940_
                  (std/text/csv#read-csv-line__%
                   _port168933_
                   _csv-options168934_))
                 (_lp168942_))))))))
  (define std/text/csv#read-csv-lines__0
    (lambda (_port168949_)
      (let ((_csv-options168951_ (std/text/csv#current-csv-options)))
        (std/text/csv#read-csv-lines__% _port168949_ _csv-options168951_))))
  (define std/text/csv#read-csv-lines
    (lambda _g302866_
      (let ((_g302865_ (let () (declare (not safe)) (##length _g302866_))))
        (cond ((let () (declare (not safe)) (##fx= _g302865_ 1))
               (apply std/text/csv#read-csv-lines__0 _g302866_))
              ((let () (declare (not safe)) (##fx= _g302865_ 2))
               (apply std/text/csv#read-csv-lines__% _g302866_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#read-csv-lines
                _g302866_))))))
  (define std/text/csv#read-csv-file__%
    (lambda (_path-or-settings168911_ _csv-options168912_)
      (call-with-input-file
       _path-or-settings168911_
       (lambda (_g168917168919_)
         (std/text/csv#read-csv-lines__%
          _g168917168919_
          _csv-options168912_)))))
  (define std/text/csv#read-csv-file__0
    (lambda (_path-or-settings168925_)
      (let ((_csv-options168927_ (std/text/csv#current-csv-options)))
        (std/text/csv#read-csv-file__%
         _path-or-settings168925_
         _csv-options168927_))))
  (define std/text/csv#read-csv-file
    (lambda _g302868_
      (let ((_g302867_ (let () (declare (not safe)) (##length _g302868_))))
        (cond ((let () (declare (not safe)) (##fx= _g302867_ 1))
               (apply std/text/csv#read-csv-file__0 _g302868_))
              ((let () (declare (not safe)) (##fx= _g302867_ 2))
               (apply std/text/csv#read-csv-file__% _g302868_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#read-csv-file
                _g302868_))))))
  (define std/text/csv#char-needs-quoting?__%
    (lambda (_x168881_ _csv-options168882_)
      (let ((_$e168888_
             (eqv? _x168881_
                   (##structure-ref
                    _csv-options168882_
                    '2
                    std/text/csv#csv-options::t
                    '#f))))
        (if _$e168888_
            _$e168888_
            (let ((_$e168891_
                   (eqv? _x168881_
                         (##structure-ref
                          _csv-options168882_
                          '1
                          std/text/csv#csv-options::t
                          '#f))))
              (if _$e168891_
                  _$e168891_
                  (let ((_$e168894_ (eqv? _x168881_ '#\newline)))
                    (if _$e168894_
                        _$e168894_
                        (let ((_$e168897_ (eqv? _x168881_ '#\return)))
                          (if _$e168897_
                              _$e168897_
                              (not (std/text/csv#char-ascii-text?
                                    _x168881_))))))))))))
  (define std/text/csv#char-needs-quoting?__0
    (lambda (_x168903_)
      (let ((_csv-options168905_ (std/text/csv#current-csv-options)))
        (std/text/csv#char-needs-quoting?__% _x168903_ _csv-options168905_))))
  (define std/text/csv#char-needs-quoting?
    (lambda _g302870_
      (let ((_g302869_ (let () (declare (not safe)) (##length _g302870_))))
        (cond ((let () (declare (not safe)) (##fx= _g302869_ 1))
               (apply std/text/csv#char-needs-quoting?__0 _g302870_))
              ((let () (declare (not safe)) (##fx= _g302869_ 2))
               (apply std/text/csv#char-needs-quoting?__% _g302870_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#char-needs-quoting?
                _g302870_))))))
  (define std/text/csv#char-csv-space?__%
    (lambda (_c168860_ _csv-options168861_)
      (if (or (eqv? _c168860_ '#\space) (eqv? _c168860_ '#\tab))
          (not (eqv? _c168860_
                     (##structure-ref
                      _csv-options168861_
                      '1
                      std/text/csv#csv-options::t
                      '#f)))
          '#f)))
  (define std/text/csv#char-csv-space?__0
    (lambda (_c168873_)
      (let ((_csv-options168875_ (std/text/csv#current-csv-options)))
        (std/text/csv#char-csv-space?__% _c168873_ _csv-options168875_))))
  (define std/text/csv#char-csv-space?
    (lambda _g302872_
      (let ((_g302871_ (let () (declare (not safe)) (##length _g302872_))))
        (cond ((let () (declare (not safe)) (##fx= _g302871_ 1))
               (apply std/text/csv#char-csv-space?__0 _g302872_))
              ((let () (declare (not safe)) (##fx= _g302871_ 2))
               (apply std/text/csv#char-csv-space?__% _g302872_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#char-csv-space?
                _g302872_))))))
  (define std/text/csv#string-needs-quoting?__%
    (lambda (_x168832_ _csv-options168833_)
      (if (not (std/srfi/13#string-null? _x168832_))
          (if (or (std/text/csv#char-csv-space?__%
                   (string-ref _x168832_ '0)
                   _csv-options168833_)
                  (std/text/csv#char-csv-space?__%
                   (string-ref _x168832_ (- (string-length _x168832_) '1))
                   _csv-options168833_)
                  (std/srfi/13#string-any__0
                   (lambda (_g168844168846_)
                     (std/text/csv#char-needs-quoting?__%
                      _g168844168846_
                      _csv-options168833_))
                   _x168832_))
              '#t
              '#f)
          '#f)))
  (define std/text/csv#string-needs-quoting?__0
    (lambda (_x168852_)
      (let ((_csv-options168854_ (std/text/csv#current-csv-options)))
        (std/text/csv#string-needs-quoting?__%
         _x168852_
         _csv-options168854_))))
  (define std/text/csv#string-needs-quoting?
    (lambda _g302874_
      (let ((_g302873_ (let () (declare (not safe)) (##length _g302874_))))
        (cond ((let () (declare (not safe)) (##fx= _g302873_ 1))
               (apply std/text/csv#string-needs-quoting?__0 _g302874_))
              ((let () (declare (not safe)) (##fx= _g302873_ 2))
               (apply std/text/csv#string-needs-quoting?__% _g302874_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#string-needs-quoting?
                _g302874_))))))
  (define std/text/csv#write-csv-lines__%
    (lambda (_lines168807_ _port168808_ _csv-options168809_)
      (for-each
       (lambda (_g168814168816_)
         (std/text/csv#write-csv-line__%
          _g168814168816_
          _port168808_
          _csv-options168809_))
       _lines168807_)))
  (define std/text/csv#write-csv-lines__0
    (lambda (_lines168822_ _port168823_)
      (let ((_csv-options168825_ (std/text/csv#current-csv-options)))
        (std/text/csv#write-csv-lines__%
         _lines168822_
         _port168823_
         _csv-options168825_))))
  (define std/text/csv#write-csv-lines
    (lambda _g302876_
      (let ((_g302875_ (let () (declare (not safe)) (##length _g302876_))))
        (cond ((let () (declare (not safe)) (##fx= _g302875_ 2))
               (apply std/text/csv#write-csv-lines__0 _g302876_))
              ((let () (declare (not safe)) (##fx= _g302875_ 3))
               (apply std/text/csv#write-csv-lines__% _g302876_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#write-csv-lines
                _g302876_))))))
  (define std/text/csv#write-csv-file__%
    (lambda (_path-or-settings168782_ _lines168783_ _csv-options168784_)
      (call-with-output-file
       _path-or-settings168782_
       (lambda (_g168789168791_)
         (std/text/csv#write-csv-lines__%
          _lines168783_
          _g168789168791_
          _csv-options168784_)))))
  (define std/text/csv#write-csv-file__0
    (lambda (_path-or-settings168797_ _lines168798_)
      (let ((_csv-options168800_ (std/text/csv#current-csv-options)))
        (std/text/csv#write-csv-file__%
         _path-or-settings168797_
         _lines168798_
         _csv-options168800_))))
  (define std/text/csv#write-csv-file
    (lambda _g302878_
      (let ((_g302877_ (let () (declare (not safe)) (##length _g302878_))))
        (cond ((let () (declare (not safe)) (##fx= _g302877_ 2))
               (apply std/text/csv#write-csv-file__0 _g302878_))
              ((let () (declare (not safe)) (##fx= _g302877_ 3))
               (apply std/text/csv#write-csv-file__% _g302878_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#write-csv-file
                _g302878_))))))
  (define std/text/csv#write-csv-line__%
    (lambda (_fields168719_ _port168720_ _csv-options168721_)
      (let _loop168727_ ((_fields168729_ _fields168719_))
        (let* ((_fields168730168739_ _fields168729_)
               (_E168733168743_
                (lambda ()
                  (error '"No clause matching" _fields168730168739_))))
          (let ((_K168735168757_
                 (lambda (_rest168754_ _first168755_)
                   (std/text/csv#write-csv-field__0 _first168755_ _port168720_)
                   (if (null? _rest168754_)
                       '#!void
                       (write-char
                        (##structure-ref
                         _csv-options168721_
                         '1
                         std/text/csv#csv-options::t
                         '#f)
                        _port168720_))
                   (_loop168727_ _rest168754_)))
                (_K168734168748_
                 (lambda ()
                   (display (##structure-ref
                             _csv-options168721_
                             '6
                             std/text/csv#csv-options::t
                             '#f)
                            _port168720_))))
            (let ((_try-match168732168751_
                   (lambda ()
                     (if (let ()
                           (declare (not safe))
                           (##null? _fields168730168739_))
                         (_K168734168748_)
                         (_E168733168743_)))))
              (if (let () (declare (not safe)) (##pair? _fields168730168739_))
                  (let ((_tl168737168762_
                         (let ()
                           (declare (not safe))
                           (##cdr _fields168730168739_)))
                        (_hd168736168760_
                         (let ()
                           (declare (not safe))
                           (##car _fields168730168739_))))
                    (let ((_first168765_ _hd168736168760_)
                          (_rest168767_ _tl168737168762_))
                      (_K168735168757_ _rest168767_ _first168765_)))
                  (_try-match168732168751_))))))))
  (define std/text/csv#write-csv-line__0
    (lambda (_fields168772_ _port168773_)
      (let ((_csv-options168775_ (std/text/csv#current-csv-options)))
        (std/text/csv#write-csv-line__%
         _fields168772_
         _port168773_
         _csv-options168775_))))
  (define std/text/csv#write-csv-line
    (lambda _g302880_
      (let ((_g302879_ (let () (declare (not safe)) (##length _g302880_))))
        (cond ((let () (declare (not safe)) (##fx= _g302879_ 2))
               (apply std/text/csv#write-csv-line__0 _g302880_))
              ((let () (declare (not safe)) (##fx= _g302879_ 3))
               (apply std/text/csv#write-csv-line__% _g302880_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#write-csv-line
                _g302880_))))))
  (define std/text/csv#write-csv-field__%
    (lambda (_field168648_ _port168649_ _csv-options168650_)
      (let* ((_field168655168667_ _field168648_)
             (_else168660168675_
              (lambda () (error '"invalid CSV field" _field168648_))))
        (let ((_K168665168703_ (lambda () '#!void))
              (_K168664168696_
               (lambda () (display _field168648_ _port168649_)))
              (_K168663168688_
               (lambda ()
                 (std/text/csv#write-csv-string-safely__%
                  _field168648_
                  _port168649_
                  _csv-options168650_)))
              (_K168662168680_
               (lambda ()
                 (std/text/csv#write-csv-string-safely__%
                  (symbol->string _field168648_)
                  _port168649_
                  _csv-options168650_))))
          (let* ((_try-match168659168683_
                  (lambda ()
                    (if (symbol? _field168655168667_)
                        (_K168662168680_)
                        (_else168660168675_))))
                 (_try-match168658168691_
                  (lambda ()
                    (if (string? _field168655168667_)
                        (_K168663168688_)
                        (_try-match168659168683_))))
                 (_try-match168657168699_
                  (lambda ()
                    (if (number? _field168655168667_)
                        (_K168664168696_)
                        (_try-match168658168691_)))))
            (if (not _field168655168667_)
                '#!void
                (_try-match168657168699_)))))))
  (define std/text/csv#write-csv-field__0
    (lambda (_field168709_ _port168710_)
      (let ((_csv-options168712_ (std/text/csv#current-csv-options)))
        (std/text/csv#write-csv-field__%
         _field168709_
         _port168710_
         _csv-options168712_))))
  (define std/text/csv#write-csv-field
    (lambda _g302882_
      (let ((_g302881_ (let () (declare (not safe)) (##length _g302882_))))
        (cond ((let () (declare (not safe)) (##fx= _g302881_ 2))
               (apply std/text/csv#write-csv-field__0 _g302882_))
              ((let () (declare (not safe)) (##fx= _g302881_ 3))
               (apply std/text/csv#write-csv-field__% _g302882_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#write-csv-field
                _g302882_))))))
  (define std/text/csv#write-csv-string-safely__%
    (lambda (_string168627_ _port168628_ _csv-options168629_)
      (if (std/text/csv#string-needs-quoting?__0 _string168627_)
          (std/text/csv#write-quoted-string__%
           _string168627_
           _port168628_
           _csv-options168629_)
          (display _string168627_ _port168628_))))
  (define std/text/csv#write-csv-string-safely__0
    (lambda (_string168638_ _port168639_)
      (let ((_csv-options168641_ (std/text/csv#current-csv-options)))
        (std/text/csv#write-csv-string-safely__%
         _string168638_
         _port168639_
         _csv-options168641_))))
  (define std/text/csv#write-csv-string-safely
    (lambda _g302884_
      (let ((_g302883_ (let () (declare (not safe)) (##length _g302884_))))
        (cond ((let () (declare (not safe)) (##fx= _g302883_ 2))
               (apply std/text/csv#write-csv-string-safely__0 _g302884_))
              ((let () (declare (not safe)) (##fx= _g302883_ 3))
               (apply std/text/csv#write-csv-string-safely__% _g302884_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#write-csv-string-safely
                _g302884_))))))
  (define std/text/csv#write-quoted-string__%
    (lambda (_string168604_ _port168605_ _csv-options168606_)
      (write-char
       (##structure-ref _csv-options168606_ '2 std/text/csv#csv-options::t '#f)
       _port168605_)
      (std/srfi/13#string-for-each__0
       (lambda (_c168612_)
         (if (char=? _c168612_
                     (##structure-ref
                      _csv-options168606_
                      '2
                      std/text/csv#csv-options::t
                      '#f))
             (write-char _c168612_ _port168605_)
             '#!void)
         (write-char _c168612_ _port168605_))
       _string168604_)
      (write-char
       (##structure-ref _csv-options168606_ '2 std/text/csv#csv-options::t '#f)
       _port168605_)))
  (define std/text/csv#write-quoted-string__0
    (lambda (_string168617_ _port168618_)
      (let ((_csv-options168620_ (std/text/csv#current-csv-options)))
        (std/text/csv#write-quoted-string__%
         _string168617_
         _port168618_
         _csv-options168620_))))
  (define std/text/csv#write-quoted-string
    (lambda _g302886_
      (let ((_g302885_ (let () (declare (not safe)) (##length _g302886_))))
        (cond ((let () (declare (not safe)) (##fx= _g302885_ 2))
               (apply std/text/csv#write-quoted-string__0 _g302886_))
              ((let () (declare (not safe)) (##fx= _g302885_ 3))
               (apply std/text/csv#write-quoted-string__% _g302886_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/csv#write-quoted-string
                _g302886_)))))))
