(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/text/utf16#string->utf16__%
    (lambda (_str167102_ _endianness167103_ _BOM?167104_)
      (if (string? _str167102_) '#!void (error '"Expected string" _str167102_))
      (let ((_u16-set!167109_
             (let ((_$e167106_ _endianness167103_))
               (if (eq? 'big _$e167106_)
                   std/text/utf16#u16-set!/be
                   (if (eq? 'little _$e167106_)
                       std/text/utf16#u16-set!/le
                       (if (eq? 'native _$e167106_)
                           std/misc/bytes#&u8vector-u16-set!/native
                           (error '"Bad endianness" _endianness167103_)))))))
        (std/text/utf16#utf16-encode
         _str167102_
         _u16-set!167109_
         _BOM?167104_))))
  (define std/text/utf16#string->utf16__0
    (lambda (_str167114_)
      (let* ((_endianness167116_ std/misc/bytes#big) (_BOM?167118_ '#f))
        (std/text/utf16#string->utf16__%
         _str167114_
         _endianness167116_
         _BOM?167118_))))
  (define std/text/utf16#string->utf16__1
    (lambda (_str167120_ _endianness167121_)
      (let ((_BOM?167123_ '#f))
        (std/text/utf16#string->utf16__%
         _str167120_
         _endianness167121_
         _BOM?167123_))))
  (define std/text/utf16#string->utf16
    (lambda _g304037_
      (let ((_g304036_ (##length _g304037_)))
        (cond ((##fx= _g304036_ 1)
               (apply std/text/utf16#string->utf16__0 _g304037_))
              ((##fx= _g304036_ 2)
               (apply std/text/utf16#string->utf16__1 _g304037_))
              ((##fx= _g304036_ 3)
               (apply std/text/utf16#string->utf16__% _g304037_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/utf16#string->utf16
                _g304037_))))))
  (define std/text/utf16#utf16-encode
    (lambda (_str167093_ _u16-set!167094_ _BOM?167095_)
      (if _BOM?167095_
          (let ((_bytes167097_
                 (make-u8vector
                  (fx+ (fx* '4 (string-length _str167093_)) '2))))
            (_u16-set!167094_ _bytes167097_ '0 '65279)
            (std/text/utf16#utf16-encode!
             _str167093_
             _bytes167097_
             '2
             _u16-set!167094_))
          (let ((_bytes167099_
                 (make-u8vector (fx* '4 (string-length _str167093_)))))
            (std/text/utf16#utf16-encode!
             _str167093_
             _bytes167099_
             '0
             _u16-set!167094_)))))
  (define std/text/utf16#utf16-encode!
    (lambda (_str167066_ _bytes167067_ _j167068_ _u16-set!167069_)
      (letrec* ((_end167071_ (string-length _str167066_)))
        (let _lp167073_ ((_i167075_ '0) (_j167076_ _j167068_))
          (if (fx< _i167075_ _end167071_)
              (let* ((_char167078_ (string-ref _str167066_ _i167075_))
                     (_int167080_ (char->integer _char167078_)))
                (if (and (fixnum? _int167080_)
                         (or (fx<= '0 _int167080_ '55295)
                             (fx<= '57344 _int167080_ '65535)))
                    (begin
                      (_u16-set!167069_ _bytes167067_ _j167076_ _int167080_)
                      (_lp167073_ (fx+ _i167075_ '1) (fx+ _j167076_ '2)))
                    (if (<= '65536 _int167080_ '1114111)
                        (let* ((_U167086_ (- _int167080_ '65536))
                               (_W1167088_
                                (fx+ (arithmetic-shift _U167086_ '-10) '55296))
                               (_W2167090_
                                (fx+ (bitwise-and _U167086_ '1023) '56320)))
                          (_u16-set!167069_ _bytes167067_ _j167076_ _W1167088_)
                          (_u16-set!167069_
                           _bytes167067_
                           (fx+ _j167076_ '2)
                           _W2167090_)
                          (_lp167073_ (fx+ _i167075_ '1) (fx+ _j167076_ '4)))
                        (std/error#raise-io-error
                         'utf16-encode!
                         '"Illegal codepoint"
                         _char167078_
                         _int167080_))))
              (if (fx< _j167076_ (u8vector-length _bytes167067_))
                  (begin
                    (u8vector-shrink! _bytes167067_ _j167076_)
                    _bytes167067_)
                  _bytes167067_))))))
  (define std/text/utf16#utf16->string__%
    (lambda (_bytes167039_ _endianness167040_ _endianness-mandatory?167041_)
      (if (u8vector? _bytes167039_)
          '#!void
          (error '"Expected u8vector" _bytes167039_))
      (let ((_u16-ref167046_
             (let ((_$e167043_ _endianness167040_))
               (if (eq? 'big _$e167043_)
                   std/text/utf16#u16-ref/be
                   (if (eq? 'little _$e167043_)
                       std/text/utf16#u16-ref/le
                       (if (eq? 'native _$e167043_)
                           std/misc/bytes#&u8vector-u16-ref/native
                           (error '"Bad endianness" _endianness167040_)))))))
        (std/text/utf16#utf16-decode
         _bytes167039_
         _u16-ref167046_
         (not _endianness-mandatory?167041_)))))
  (define std/text/utf16#utf16->string__0
    (lambda (_bytes167051_)
      (let* ((_endianness167053_ std/misc/bytes#big)
             (_endianness-mandatory?167055_ '#f))
        (std/text/utf16#utf16->string__%
         _bytes167051_
         _endianness167053_
         _endianness-mandatory?167055_))))
  (define std/text/utf16#utf16->string__1
    (lambda (_bytes167057_ _endianness167058_)
      (let ((_endianness-mandatory?167060_ '#f))
        (std/text/utf16#utf16->string__%
         _bytes167057_
         _endianness167058_
         _endianness-mandatory?167060_))))
  (define std/text/utf16#utf16->string
    (lambda _g304039_
      (let ((_g304038_ (##length _g304039_)))
        (cond ((##fx= _g304038_ 1)
               (apply std/text/utf16#utf16->string__0 _g304039_))
              ((##fx= _g304038_ 2)
               (apply std/text/utf16#utf16->string__1 _g304039_))
              ((##fx= _g304038_ 3)
               (apply std/text/utf16#utf16->string__% _g304039_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/utf16#utf16->string
                _g304039_))))))
  (define std/text/utf16#utf16-decode
    (lambda (_bytes167029_ _u16-ref167030_ _BOM?167031_)
      (letrec* ((_len167033_ (u8vector-length _bytes167029_)))
        (if (fxeven? _len167033_)
            '#!void
            (std/error#raise-io-error
             'utf16-decode
             '"Cannot decode UTF-16; odd length u8vector"
             _bytes167029_))
        (if _BOM?167031_
            (if (fx>= _len167033_ '2)
                (let ((_b0167035_ (u8vector-ref _bytes167029_ '0))
                      (_b1167036_ (u8vector-ref _bytes167029_ '1)))
                  (if (and (fx= _b0167035_ '254) (fx= _b1167036_ '255))
                      (std/text/utf16#utf16-decode!
                       _bytes167029_
                       '2
                       std/text/utf16#u16-ref/be)
                      (if (and (fx= _b0167035_ '255) (fx= _b1167036_ '254))
                          (std/text/utf16#utf16-decode!
                           _bytes167029_
                           '2
                           std/text/utf16#u16-ref/le)
                          (std/text/utf16#utf16-decode!
                           _bytes167029_
                           '0
                           _u16-ref167030_))))
                '"")
            (std/text/utf16#utf16-decode! _bytes167029_ '0 _u16-ref167030_)))))
  (define std/text/utf16#utf16-decode!
    (lambda (_bytes166990_ _i166991_ _u16-ref166992_)
      (letrec* ((_end166994_ (u8vector-length _bytes166990_))
                (_str166995_ (make-string (fx- _end166994_ _i166991_))))
        (let _lp166997_ ((_i166999_ _i166991_) (_j167000_ '0))
          (if (fx< _i166999_ _end166994_)
              (let ((_W167002_ (_u16-ref166992_ _bytes166990_ _i166999_)))
                (if (or (fx<= '0 _W167002_ '55295)
                        (fx<= '57344 _W167002_ '65535))
                    (let ((_char167007_ (integer->char _W167002_)))
                      (string-set! _str166995_ _j167000_ _char167007_)
                      (_lp166997_ (fx+ _i166999_ '2) (fx+ _j167000_ '1)))
                    (let ((_Whi167009_ (fxarithmetic-shift _W167002_ '-10)))
                      (if (fx= _Whi167009_ '54)
                          (let ((_i+2167011_ (fx+ _i166999_ '2)))
                            (if (fx< _i+2167011_ _end166994_)
                                (let* ((_W2167013_
                                        (_u16-ref166992_
                                         _bytes166990_
                                         _i+2167011_))
                                       (_W2hi167015_
                                        (fxarithmetic-shift _W2167013_ '-10)))
                                  (if (fx= _W2hi167015_ '55)
                                      (let* ((_u1167018_
                                              (fxand _W167002_ '1023))
                                             (_u2167020_
                                              (fxand _W2167013_ '1023))
                                             (_u*167022_
                                              (bitwise-ior
                                               (arithmetic-shift
                                                _u1167018_
                                                '10)
                                               _u2167020_))
                                             (_u167024_ (+ _u*167022_ '65536))
                                             (_char167026_
                                              (integer->char _u167024_)))
                                        (string-set!
                                         _str166995_
                                         _j167000_
                                         _char167026_)
                                        (_lp166997_
                                         (fx+ _i166999_ '4)
                                         (fx+ _j167000_ '1)))
                                      (begin
                                        (string-set!
                                         _str166995_
                                         _j167000_
                                         '65533)
                                        (_lp166997_
                                         (fx+ _i166999_ '4)
                                         (fx+ _j167000_ '1)))))
                                (std/error#raise-io-error
                                 'utf16-decode!
                                 '"Incomplete character"
                                 _W167002_)))
                          (begin
                            (string-set! _str166995_ _j167000_ '#\�)
                            (_lp166997_
                             (fx+ _i166999_ '2)
                             (fx+ _j167000_ '1)))))))
              (if (fx< _j167000_ (string-length _str166995_))
                  (begin (string-shrink! _str166995_ _j167000_) _str166995_)
                  _str166995_))))))
  (define std/text/utf16#u16-ref/be
    (if (eq? std/misc/bytes#native-endianness std/misc/bytes#big)
        std/misc/bytes#&u8vector-u16-ref/native
        (lambda (_v166987_ _i166988_)
          (std/misc/bytes#&u8vector-uint-ref/be _v166987_ _i166988_ '2))))
  (define std/text/utf16#u16-ref/le
    (if (eq? std/misc/bytes#native-endianness std/misc/bytes#little)
        std/misc/bytes#&u8vector-u16-ref/native
        (lambda (_v166984_ _i166985_)
          (std/misc/bytes#&u8vector-uint-ref/le _v166984_ _i166985_ '2))))
  (define std/text/utf16#u16-set!/be
    (if (eq? std/misc/bytes#native-endianness std/misc/bytes#big)
        std/misc/bytes#&u8vector-u16-set!/native
        (lambda (_v166980_ _i166981_ _n166982_)
          (std/misc/bytes#&u8vector-uint-set!/be
           _v166980_
           _i166981_
           _n166982_
           '2))))
  (define std/text/utf16#u16-set!/le
    (if (eq? std/misc/bytes#native-endianness std/misc/bytes#little)
        std/misc/bytes#&u8vector-u16-set!/native
        (lambda (_v166976_ _i166977_ _n166978_)
          (std/misc/bytes#&u8vector-uint-set!/le
           _v166976_
           _i166977_
           _n166978_
           '2)))))
