(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/web/fastcgi#errorf
    (lambda (_fmt258650_ . _args258651_)
      (std/logger#log-message 'fastcgi '0 _fmt258650_ _args258651_)))
  (define std/web/fastcgi#warnf
    (lambda (_fmt258647_ . _args258648_)
      (std/logger#log-message 'fastcgi '1 _fmt258647_ _args258648_)))
  (define std/web/fastcgi#infof
    (lambda (_fmt258644_ . _args258645_)
      (std/logger#log-message 'fastcgi '2 _fmt258644_ _args258645_)))
  (define std/web/fastcgi#debugf
    (lambda (_fmt258641_ . _args258642_)
      (std/logger#log-message 'fastcgi '3 _fmt258641_ _args258642_)))
  (define std/web/fastcgi#verbosef
    (lambda (_fmt258636_ . _args258638_)
      (std/logger#log-message 'fastcgi '4 _fmt258636_ _args258638_)))
  (define std/web/fastcgi#fastcgi-request::t
    (make-struct-type
     'std/web/fastcgi#fastcgi-request::t
     '#f
     '6
     'fastcgi-request
     '()
     '#f
     '(port id keepalive role params stdin)))
  (define std/web/fastcgi#fastcgi-request?
    (make-struct-predicate std/web/fastcgi#fastcgi-request::t))
  (define std/web/fastcgi#make-fastcgi-request
    (lambda _$args258633_
      (apply make-struct-instance
             std/web/fastcgi#fastcgi-request::t
             _$args258633_)))
  (define std/web/fastcgi#fastcgi-request-port
    (make-struct-field-accessor std/web/fastcgi#fastcgi-request::t '0))
  (define std/web/fastcgi#fastcgi-request-id
    (make-struct-field-accessor std/web/fastcgi#fastcgi-request::t '1))
  (define std/web/fastcgi#fastcgi-request-keepalive
    (make-struct-field-accessor std/web/fastcgi#fastcgi-request::t '2))
  (define std/web/fastcgi#fastcgi-request-role
    (make-struct-field-accessor std/web/fastcgi#fastcgi-request::t '3))
  (define std/web/fastcgi#fastcgi-request-params
    (make-struct-field-accessor std/web/fastcgi#fastcgi-request::t '4))
  (define std/web/fastcgi#fastcgi-request-stdin
    (make-struct-field-accessor std/web/fastcgi#fastcgi-request::t '5))
  (define std/web/fastcgi#fastcgi-request-port-set!
    (make-struct-field-mutator std/web/fastcgi#fastcgi-request::t '0))
  (define std/web/fastcgi#fastcgi-request-id-set!
    (make-struct-field-mutator std/web/fastcgi#fastcgi-request::t '1))
  (define std/web/fastcgi#fastcgi-request-keepalive-set!
    (make-struct-field-mutator std/web/fastcgi#fastcgi-request::t '2))
  (define std/web/fastcgi#fastcgi-request-role-set!
    (make-struct-field-mutator std/web/fastcgi#fastcgi-request::t '3))
  (define std/web/fastcgi#fastcgi-request-params-set!
    (make-struct-field-mutator std/web/fastcgi#fastcgi-request::t '4))
  (define std/web/fastcgi#fastcgi-request-stdin-set!
    (make-struct-field-mutator std/web/fastcgi#fastcgi-request::t '5))
  (define std/web/fastcgi#start-fastcgi-server!
    (lambda (_address258630_ _respond258631_)
      (std/logger#start-logger!__0)
      (gerbil/gambit/threads#spawn
       std/web/fastcgi#fastcgi-server
       (open-tcp-server (std/net/address#inet-address->string _address258630_))
       _respond258631_)))
  (define std/web/fastcgi#fastcgi-server
    (lambda (_sock258615_ _respond258616_)
      (let _lp258618_ ()
        (with-exception-catcher
         (lambda (_g258620258622_)
           (if '#t
               (let ((_e258625_ _g258620258622_))
                 (std/web/fastcgi#errorf
                  '"error accepting connection: ~a"
                  _e258625_))
               (raise _g258620258622_)))
         (lambda ()
           (let ((_client258628_ (read _sock258615_)))
             (gerbil/gambit/threads#spawn
              std/web/fastcgi#fastcgi-connection
              _client258628_
              _respond258616_))))
        (_lp258618_))))
  (define std/web/fastcgi#fastcgi-connection
    (lambda (_port258597_ _respond258598_)
      (letrec ((_loop258600_
                (lambda ()
                  (let ((_req258613_
                         (std/web/fastcgi#fastcgi-accept _port258597_)))
                    (if (eof-object? _req258613_)
                        '#!void
                        (if (eq? (##structure-ref
                                  _req258613_
                                  '4
                                  std/web/fastcgi#fastcgi-request::t
                                  '#f)
                                 'FCGI-RESPONDER)
                            (begin
                              (_respond258598_ _req258613_)
                              (std/web/fastcgi#fastcgi-request-end__0
                               _req258613_)
                              (if (##structure-ref
                                   _req258613_
                                   '3
                                   std/web/fastcgi#fastcgi-request::t
                                   '#f)
                                  (_loop258600_)
                                  '#!void))
                            (begin
                              (std/web/fastcgi#fastcgi-request-end__%
                               _req258613_
                               '1
                               std/web/fastcgi#FCGI-UNKNOWN-ROLE)
                              (if (##structure-ref
                                   _req258613_
                                   '3
                                   std/web/fastcgi#fastcgi-request::t
                                   '#f)
                                  (_loop258600_)
                                  '#!void))))))))
        (with-unwind-protect
         (lambda ()
           (with-exception-catcher
            (lambda (_g258601258604_)
              (if '#t
                  (let ((_e258607_ _g258601258604_))
                    (std/web/fastcgi#errorf '"error responding: ~a" _e258607_))
                  (raise _g258601258604_)))
            (lambda () (_loop258600_))))
         (lambda ()
           (with-exception-catcher
            void
            (lambda () (close-port _port258597_))))))))
  (define std/web/fastcgi#fastcgi-accept
    (lambda (_port258353_)
      (letrec ((_begin-request258355_
                (lambda (_port258476_)
                  (let* ((_g258477258487_
                          (std/web/fastcgi#fcgi-read-record _port258476_))
                         (_E258480258491_
                          (lambda ()
                            (error '"No clause matching" _g258477258487_))))
                    (let ((_K258482258579_
                           (lambda (_body258505_ _reqid258506_ _type258507_)
                             (if (eq? _type258507_
                                      std/web/fastcgi#FCGI-BEGIN-REQUEST)
                                 (let ((_g311091_
                                        (std/web/fastcgi#fcgi-begin-request-e
                                         _body258505_)))
                                   (begin
                                     (let ((_g311092_
                                            (let ()
                                              (declare (not safe))
                                              (if (##values? _g311091_)
                                                  (##vector-length _g311091_)
                                                  1))))
                                       (if (not (let ()
                                                  (declare (not safe))
                                                  (##fx= _g311092_ 2)))
                                           (error "Context expects 2 values"
                                                  _g311092_)))
                                     (let ((_role258509_
                                            (let ()
                                              (declare (not safe))
                                              (##vector-ref _g311091_ 0)))
                                           (_flags258510_
                                            (let ()
                                              (declare (not safe))
                                              (##vector-ref _g311091_ 1))))
                                       (let ((_keepalive258512_
                                              (not (zero? (fxand _flags258510_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         std/web/fastcgi#FCGI-KEEP-CONN)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                         (_receive-request-data258356_
                                          _port258476_
                                          _reqid258506_
                                          _keepalive258512_
                                          _role258509_)))))
                                 (if (eq? _type258507_
                                          std/web/fastcgi#FCGI-GET-VALUES)
                                     (let* ((_keys258515_
                                             (std/web/fastcgi#fcgi-get-values-e
                                              _body258505_))
                                            (_resp258574_
                                             (let ((_iterable258542_
                                                    _keys258515_)
                                                   (_iter-do258544_
                                                    (lambda (_val258517_
                                                             _r258519_)
                                                      (let* ((_val258520258525_
                                                              _val258517_)
                                                             (_E258522258529_
                                                              (lambda ()
                                                                (error '"No clause matching"
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                               _val258520258525_)))
                     (_K258523258537_
                      (lambda (_key258532_)
                        (let ((_$e258534_ _key258532_))
                          (if (eq? 'FCGI_MAX_CONNS _$e258534_)
                              (cons (cons _key258532_ '"1") _r258519_)
                              (if (eq? 'FCGI_MAX_REQS _$e258534_)
                                  (cons (cons _key258532_ '"1") _r258519_)
                                  (if (eq? 'FCGI_MPXS_CONNS _$e258534_)
                                      (cons (cons _key258532_ '"0") _r258519_)
                                      _r258519_))))))
                     (_key258540_ _val258520258525_))
                (_K258523258537_ _key258540_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (_r258546_ '()))
                                               (if (pair? _iterable258542_)
                                                   (foldl1 _iter-do258544_
                                                           _r258546_
                                                           _iterable258542_)
                                                   (if (null? _iterable258542_)
                                                       _r258546_
                                                       (let* ((_it258548_
                                                               (std/iter#iter
                                                                _iterable258542_))
                                                              (_next!258551_
                                                               (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (declare (not safe))
                         (##unchecked-structure-ref
                          _it258548_
                          '2
                          std/iter#iterator::t
                          '#f))))
                 (declare (not safe))
                 (let _lp258556_ ((_rval258559_ '()))
                   (let ((_val258562_ (_next!258551_ _it258548_)))
                     (if (eq? std/iter#iter-end _val258562_)
                         (begin
                           (let ((_$e258564_
                                  (##unchecked-structure-ref
                                   _it258548_
                                   '3
                                   std/iter#iterator::t
                                   '#f)))
                             (if _$e258564_
                                 ((lambda (_g258566258568_)
                                    (_g258566258568_ _it258548_))
                                  _$e258564_)
                                 '#!void))
                           _rval258559_)
                         (let ((_xval258571_
                                (_iter-do258544_ _val258562_ _rval258559_)))
                           (_lp258556_ _xval258571_))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                            (_data258576_
                                             (std/web/fastcgi#fcgi-get-values-result-data
                                              _resp258574_)))
                                       (std/web/fastcgi#fcgi-write-record__0
                                        _port258476_
                                        std/web/fastcgi#FCGI-GET-VALUES-RESULT
                                        _reqid258506_
                                        _data258576_)
                                       (_begin-request258355_ _port258476_))
                                     (if (eq? _reqid258506_ '0)
                                         (begin
                                           (std/web/fastcgi#fcgi-write-record__0
                                            _port258476_
                                            std/web/fastcgi#FCGI-UNKNOWN-TYPE
                                            _reqid258506_
                                            (std/web/fastcgi#fcgi-unknown-type-data
                                             _type258507_))
                                           (_begin-request258355_
                                            _port258476_))
                                         (begin
                                           (std/web/fastcgi#warnf
                                            '"fastcgi-accept: unexpected message type ~a"
                                            _type258507_)
                                           (_begin-request258355_
                                            _port258476_)))))))
                          (_K258481258497_ (lambda (_eof258495_) _eof258495_)))
                      (let ((_try-match258479258502_
                             (lambda ()
                               (if (eof-object? _g258477258487_)
                                   (let ((_eof258500_ _g258477258487_))
                                     (_K258481258497_ _eof258500_))
                                   (_E258480258491_)))))
                        (if (let ((__tmp311093
                                   (if (let ()
                                         (declare (not safe))
                                         (##values? _g258477258487_))
                                       (let ()
                                         (declare (not safe))
                                         (##vector-length _g258477258487_))
                                       '1)))
                              (declare (not safe))
                              (##fx= __tmp311093 '3))
                            (let* ((_e258483258582_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _g258477258487_ '0)))
                                   (_e258484258587_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _g258477258487_ '1)))
                                   (_e258485258592_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _g258477258487_ '2))))
                              (let ((_type258585_ _e258483258582_)
                                    (_reqid258590_ _e258484258587_)
                                    (_body258595_ _e258485258592_))
                                (_K258482258579_
                                 _body258595_
                                 _reqid258590_
                                 _type258585_)))
                            (_try-match258479258502_)))))))
               (_receive-request-data258356_
                (lambda (_port258358_
                         _id258359_
                         _keepalive258360_
                         _role258361_)
                  (letrec* ((_params258363_ (make-table 'test: eq?)))
                    (let _lp258365_ ((_end-params258367_ '#f)
                                     (_end-stdin258368_ '#f)
                                     (_stdin258369_ '()))
                      (if (and _end-params258367_ _end-stdin258368_)
                          (let ((__tmp311094
                                 (u8vector-concatenate
                                  (reverse _stdin258369_))))
                            (declare (not safe))
                            (##structure
                             std/web/fastcgi#fastcgi-request::t
                             _port258358_
                             _id258359_
                             _keepalive258360_
                             _role258361_
                             _params258363_
                             __tmp311094))
                          (let* ((_g258370258380_
                                  (std/web/fastcgi#fcgi-read-record
                                   _port258358_))
                                 (_E258373258384_
                                  (lambda ()
                                    (error '"No clause matching"
                                           _g258370258380_))))
                            (let ((_K258375258458_
                                   (lambda (_body258395_
                                            _reqid258396_
                                            _type258397_)
                                     (if (eq? _reqid258396_ _id258359_)
                                         (if (eq? _type258397_
                                                  std/web/fastcgi#FCGI-PARAMS)
                                             (if (zero? (u8vector-length
                                                         _body258395_))
                                                 (_lp258365_
                                                  '#t
                                                  _end-stdin258368_
                                                  _stdin258369_)
                                                 (let ((_alist258399_
                                                        (std/web/fastcgi#fcgi-params-e
                                                         _body258395_)))
                                                   (let ((_iterable258432_
                                                          _alist258399_)
                                                         (_iter-do258434_
                                                          (lambda (_val258401_)
                                                            (let* ((_val258403258410_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _val258401_)
                           (_E258405258414_
                            (lambda ()
                              (error '"No clause matching" _val258403258410_)))
                           (_K258406258420_
                            (lambda (_value258417_ _key258418_)
                              (table-set!
                               _params258363_
                               _key258418_
                               _value258417_))))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _val258403258410_))
                          (let ((_hd258407258423_
                                 (let ()
                                   (declare (not safe))
                                   (##car _val258403258410_)))
                                (_tl258408258425_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _val258403258410_))))
                            (let* ((_key258428_ _hd258407258423_)
                                   (_value258430_ _tl258408258425_))
                              (_K258406258420_ _value258430_ _key258428_)))
                          (_E258405258414_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (if (pair? _iterable258432_)
                                                         (for-each
                                                          _iter-do258434_
                                                          _iterable258432_)
                                                         (if (null? _iterable258432_)
                                                             '#!void
                                                             (let* ((_it258437_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                             (std/iter#iter _iterable258432_))
                            (_next!258440_
                             (let ()
                               (declare (not safe))
                               (##unchecked-structure-ref
                                _it258437_
                                '2
                                std/iter#iterator::t
                                '#f))))
                       (declare (not safe))
                       (begin
                         (let _lp258445_ ()
                           (let ((_val258449_ (_next!258440_ _it258437_)))
                             (if (eq? std/iter#iter-end _val258449_)
                                 '#!void
                                 (begin
                                   (_iter-do258434_ _val258449_)
                                   (_lp258445_)))))
                         (let ((_$e258451_
                                (##unchecked-structure-ref
                                 _it258437_
                                 '3
                                 std/iter#iterator::t
                                 '#f)))
                           (if _$e258451_
                               ((lambda (_g258453258455_)
                                  (_g258453258455_ _it258437_))
                                _$e258451_)
                               '#!void))
                         '#!void)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (_lp258365_
                                                    '#f
                                                    _end-stdin258368_
                                                    _stdin258369_)))
                                             (if (eq? _type258397_
                                                      std/web/fastcgi#FCGI-STDIN)
                                                 (if (zero? (u8vector-length
                                                             _body258395_))
                                                     (_lp258365_
                                                      _end-params258367_
                                                      '#t
                                                      _stdin258369_)
                                                     (_lp258365_
                                                      _end-params258367_
                                                      '#f
                                                      (cons _body258395_
                                                            _stdin258369_)))
                                                 (if (eq? _type258397_
                                                          std/web/fastcgi#FCGI-ABORT-REQUEST)
                                                     (std/error#raise-io-error
                                                      'fastcgi-accept
                                                      '"Connection aborted")
                                                     (begin
                                                       (std/web/fastcgi#warnf
                                                        '"fastcgi-accept: unexpected message type ~a"
                                                        _type258397_)
                                                       (_lp258365_
                                                        _end-params258367_
                                                        _end-stdin258368_
                                                        _stdin258369_)))))
                                         (begin
                                           (std/web/fastcgi#warnf
                                            '"fastcgi-accept: unexpected message request ~a"
                                            _reqid258396_)
                                           (_lp258365_
                                            _end-params258367_
                                            _end-stdin258368_
                                            _stdin258369_)))))
                                  (_K258374258389_
                                   (lambda ()
                                     (std/error#raise-io-error
                                      'fastcgi-accept
                                      '"Premature port end"
                                      _port258358_))))
                              (let ((_try-match258372258392_
                                     (lambda ()
                                       (if (eof-object? _g258370258380_)
                                           (_K258374258389_)
                                           (_E258373258384_)))))
                                (if (let ((__tmp311095
                                           (if (let ()
                                                 (declare (not safe))
                                                 (##values? _g258370258380_))
                                               (let ()
                                                 (declare (not safe))
                                                 (##vector-length
                                                  _g258370258380_))
                                               '1)))
                                      (declare (not safe))
                                      (##fx= __tmp311095 '3))
                                    (let* ((_e258376258461_
                                            (let ()
                                              (declare (not safe))
                                              (##vector-ref
                                               _g258370258380_
                                               '0)))
                                           (_e258377258466_
                                            (let ()
                                              (declare (not safe))
                                              (##vector-ref
                                               _g258370258380_
                                               '1)))
                                           (_e258378258471_
                                            (let ()
                                              (declare (not safe))
                                              (##vector-ref
                                               _g258370258380_
                                               '2))))
                                      (let ((_type258464_ _e258376258461_)
                                            (_reqid258469_ _e258377258466_)
                                            (_body258474_ _e258378258471_))
                                        (_K258375258458_
                                         _body258474_
                                         _reqid258469_
                                         _type258464_)))
                                    (_try-match258372258392_)))))))))))
        (_begin-request258355_ _port258353_))))
  (define std/web/fastcgi#fastcgi-write-stdout
    (lambda (_req258321_ _data258322_)
      (let* ((_req258323258330_ _req258321_)
             (_E258325258334_
              (lambda () (error '"No clause matching" _req258323258330_)))
             (_K258326258340_
              (lambda (_reqid258337_ _port258338_)
                (if _port258338_
                    (std/web/fastcgi#fcgi-write-data
                     _port258338_
                     std/web/fastcgi#FCGI-STDOUT
                     _reqid258337_
                     _data258322_)
                    (error '"request ended; no port" _req258321_)))))
        (if (let ()
              (declare (not safe))
              (##structure-instance-of?
               _req258323258330_
               'std/web/fastcgi#fastcgi-request::t))
            (let* ((_e258327258343_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _req258323258330_ '1)))
                   (_port258346_ _e258327258343_)
                   (_e258328258348_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _req258323258330_ '2)))
                   (_reqid258351_ _e258328258348_))
              (_K258326258340_ _reqid258351_ _port258346_))
            (_E258325258334_)))))
  (define std/web/fastcgi#fastcgi-write-stderr
    (lambda (_req258289_ _data258290_)
      (let* ((_req258291258298_ _req258289_)
             (_E258293258302_
              (lambda () (error '"No clause matching" _req258291258298_)))
             (_K258294258308_
              (lambda (_reqid258305_ _port258306_)
                (if _port258306_
                    (std/web/fastcgi#fcgi-write-data
                     _port258306_
                     std/web/fastcgi#FCGI-STDERR
                     _reqid258305_
                     _data258290_)
                    (error '"request ended; no port" _req258289_)))))
        (if (let ()
              (declare (not safe))
              (##structure-instance-of?
               _req258291258298_
               'std/web/fastcgi#fastcgi-request::t))
            (let* ((_e258295258311_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _req258291258298_ '1)))
                   (_port258314_ _e258295258311_)
                   (_e258296258316_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _req258291258298_ '2)))
                   (_reqid258319_ _e258296258316_))
              (_K258294258308_ _reqid258319_ _port258314_))
            (_E258293258302_)))))
  (define std/web/fastcgi#fastcgi-request-end__%
    (lambda (_req258238_ _app-status258239_ _proto-status258240_)
      (let* ((_req258241258248_ _req258238_)
             (_E258243258252_
              (lambda () (error '"No clause matching" _req258241258248_)))
             (_K258244258258_
              (lambda (_reqid258255_ _port258256_)
                (if _port258256_
                    (begin
                      (std/web/fastcgi#fcgi-write-record__0
                       _port258256_
                       std/web/fastcgi#FCGI-STDOUT
                       _reqid258255_
                       '#u8())
                      (std/web/fastcgi#fcgi-write-record__0
                       _port258256_
                       std/web/fastcgi#FCGI-STDERR
                       _reqid258255_
                       '#u8())
                      (std/web/fastcgi#fcgi-write-record__0
                       _port258256_
                       std/web/fastcgi#FCGI-END-REQUEST
                       _reqid258255_
                       (std/web/fastcgi#fcgi-end-request-data
                        _app-status258239_
                        _proto-status258240_))
                      (##structure-set!
                       _req258238_
                       '#f
                       '1
                       std/web/fastcgi#fastcgi-request::t
                       '#f))
                    '#!void))))
        (if (let ()
              (declare (not safe))
              (##structure-instance-of?
               _req258241258248_
               'std/web/fastcgi#fastcgi-request::t))
            (let* ((_e258245258261_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _req258241258248_ '1)))
                   (_port258264_ _e258245258261_)
                   (_e258246258266_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _req258241258248_ '2)))
                   (_reqid258269_ _e258246258266_))
              (_K258244258258_ _reqid258269_ _port258264_))
            (_E258243258252_)))))
  (define std/web/fastcgi#fastcgi-request-end__0
    (lambda (_req258274_)
      (let* ((_app-status258276_ '0)
             (_proto-status258278_ std/web/fastcgi#FCGI-REQUEST-COMPLETE))
        (std/web/fastcgi#fastcgi-request-end__%
         _req258274_
         _app-status258276_
         _proto-status258278_))))
  (define std/web/fastcgi#fastcgi-request-end__1
    (lambda (_req258280_ _app-status258281_)
      (let ((_proto-status258283_ std/web/fastcgi#FCGI-REQUEST-COMPLETE))
        (std/web/fastcgi#fastcgi-request-end__%
         _req258280_
         _app-status258281_
         _proto-status258283_))))
  (define std/web/fastcgi#fastcgi-request-end
    (lambda _g311097_
      (let ((_g311096_ (let () (declare (not safe)) (##length _g311097_))))
        (cond ((let () (declare (not safe)) (##fx= _g311096_ 1))
               (apply std/web/fastcgi#fastcgi-request-end__0 _g311097_))
              ((let () (declare (not safe)) (##fx= _g311096_ 2))
               (apply std/web/fastcgi#fastcgi-request-end__1 _g311097_))
              ((let () (declare (not safe)) (##fx= _g311096_ 3))
               (apply std/web/fastcgi#fastcgi-request-end__% _g311097_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/web/fastcgi#fastcgi-request-end
                _g311097_))))))
  (define std/web/fastcgi#FCGI-BEGIN-REQUEST '1)
  (define std/web/fastcgi#FCGI-ABORT-REQUEST '2)
  (define std/web/fastcgi#FCGI-END-REQUEST '3)
  (define std/web/fastcgi#FCGI-PARAMS '4)
  (define std/web/fastcgi#FCGI-STDIN '5)
  (define std/web/fastcgi#FCGI-STDOUT '6)
  (define std/web/fastcgi#FCGI-STDERR '7)
  (define std/web/fastcgi#FCGI-DATA '8)
  (define std/web/fastcgi#FCGI-GET-VALUES '9)
  (define std/web/fastcgi#FCGI-GET-VALUES-RESULT '10)
  (define std/web/fastcgi#FCGI-UNKNOWN-TYPE '11)
  (define std/web/fastcgi#FCGI-RESPONDER '1)
  (define std/web/fastcgi#FCGI-AUTHORIZER '2)
  (define std/web/fastcgi#FCGI-FILTER '3)
  (define std/web/fastcgi#FCGI-KEEP-CONN '1)
  (define std/web/fastcgi#FCGI-REQUEST-COMPLETE '0)
  (define std/web/fastcgi#FCGI-CANT-MPX-CONN '1)
  (define std/web/fastcgi#FCGI-OVERLOADED '2)
  (define std/web/fastcgi#FCGI-UNKNOWN-ROLE '3)
  (define std/web/fastcgi#fcgi-read-record
    (lambda (_port258207_)
      (call-with-current-continuation
       (lambda (_return258209_)
         (let* ((_head258211_ (make-u8vector '8))
                (_rd258213_ (read-subu8vector _head258211_ '0 '8 _port258207_))
                (_g311098_
                 (if (zero? _rd258213_) (_return258209_ (eof-object)) '#!void))
                (_g311099_
                 (if (fx< _rd258213_ '8)
                     (std/error#raise-io-error
                      'fcgi-read-record
                      '"incomplete record")
                     '#!void))
                (_ver258217_ (u8vector-ref _head258211_ '0))
                (_g311100_
                 (if (= _ver258217_ '1)
                     '#!void
                     (std/error#raise-io-error
                      'fcgi-read-record
                      '"version mismatch"
                      _ver258217_)))
                (_type258220_ (u8vector-ref _head258211_ '1))
                (_rid258222_
                 (fxior (fxarithmetic-shift (u8vector-ref _head258211_ '2) '8)
                        (u8vector-ref _head258211_ '3)))
                (_clen258224_
                 (fxior (fxarithmetic-shift (u8vector-ref _head258211_ '4) '8)
                        (u8vector-ref _head258211_ '5)))
                (_plen258226_ (u8vector-ref _head258211_ '6))
                (_dlen258228_ (fx+ _clen258224_ _plen258226_))
                (_data258230_ (make-u8vector _dlen258228_))
                (_rd258232_
                 (if (fxpositive? _dlen258228_)
                     (read-subu8vector
                      _data258230_
                      '0
                      _dlen258228_
                      _port258207_)
                     _rd258213_))
                (_g311101_
                 (if (fx< _rd258232_ _dlen258228_)
                     (std/error#raise-io-error
                      'fcgi-read-record
                      '"incomplete record")
                     '#!void))
                (_g311102_
                 (if (fxpositive? _plen258226_)
                     (u8vector-shrink! _data258230_ _clen258224_)
                     '#!void)))
           (values _type258220_ _rid258222_ _data258230_))))))
  (define std/web/fastcgi#fcgi-read-key-value-pairs
    (lambda (_port258164_)
      (letrec ((_read-length258166_
                (lambda (_port258191_)
                  (let ((_nb0258193_ (read-u8 _port258191_)))
                    (if (eof-object? _nb0258193_)
                        _nb0258193_
                        (if (zero? (fxarithmetic-shift _nb0258193_ '-7))
                            _nb0258193_
                            (let* ((_nb3258195_ (fxand _nb0258193_ '127))
                                   (_nb2258197_ (read-u8 _port258191_))
                                   (_g311103_
                                    (if (eof-object? _nb2258197_)
                                        (std/error#raise-io-error
                                         'fcgi-read-key-value-pairs
                                         '"premature port end")
                                        '#!void))
                                   (_nb1258200_ (read-u8 _port258191_))
                                   (_g311104_
                                    (if (eof-object? _nb1258200_)
                                        (std/error#raise-io-error
                                         'fcgi-read-key-value-pairs
                                         '"premature port end")
                                        '#!void))
                                   (_nb0258203_ (read-u8 _port258191_))
                                   (_g311105_
                                    (if (eof-object? _nb0258203_)
                                        (std/error#raise-io-error
                                         'fcgi-read-key-value-pairs
                                         '"premature port end")
                                        '#!void)))
                              (fxior (fxarithmetic-shift _nb3258195_ '24)
                                     (fxarithmetic-shift _nb2258197_ '16)
                                     (fxarithmetic-shift _nb1258200_ '8)
                                     _nb0258203_))))))))
        (let _lp258168_ ((_klen258170_ (_read-length258166_ _port258164_))
                         (_r258171_ '()))
          (if (eof-object? _klen258170_)
              (reverse _r258171_)
              (let* ((_vlen258173_ (_read-length258166_ _port258164_))
                     (_g311106_
                      (if (eof-object? _vlen258173_)
                          (std/error#raise-io-error
                           'fcgi-read-key-value-pairs
                           '"premature port end")
                          '#!void))
                     (_kdata258176_ (make-u8vector _klen258170_))
                     (_rd258178_
                      (read-subu8vector
                       _kdata258176_
                       '0
                       _klen258170_
                       _port258164_))
                     (_g311107_
                      (if (fx< _rd258178_ _klen258170_)
                          (std/error#raise-io-error
                           'fcgi-read-key-value-pairs
                           '"premature port end")
                          '#!void))
                     (_vdata258181_ (make-u8vector _vlen258173_))
                     (_rd258183_
                      (read-subu8vector
                       _vdata258181_
                       '0
                       _vlen258173_
                       _port258164_))
                     (_g311108_
                      (if (fx< _rd258183_ _vlen258173_)
                          (std/error#raise-io-error
                           'fcgi-read-key-value-pairs
                           '"premature port end")
                          '#!void))
                     (_key258186_
                      (string->symbol
                       (std/text/utf8#utf8->string__0 _kdata258176_)))
                     (_value258188_
                      (std/text/utf8#utf8->string__0 _vdata258181_)))
                (_lp258168_
                 (_read-length258166_ _port258164_)
                 (cons (cons _key258186_ _value258188_) _r258171_))))))))
  (define std/web/fastcgi#fcgi-write-record__%
    (lambda (_port258120_
             _type258121_
             _reqid258122_
             _data258123_
             _start258124_
             _end258125_)
      (let* ((_head258127_ (make-u8vector '8))
             (_end258132_
              (let ((_$e258129_ _end258125_))
                (if _$e258129_ _$e258129_ (u8vector-length _data258123_))))
             (_clen258134_ (fx- _end258132_ _start258124_)))
        (u8vector-set! _head258127_ '0 '1)
        (u8vector-set! _head258127_ '1 _type258121_)
        (u8vector-set!
         _head258127_
         '2
         (fxand (fxarithmetic-shift _reqid258122_ '-8) '255))
        (u8vector-set! _head258127_ '3 (fxand _reqid258122_ '255))
        (u8vector-set!
         _head258127_
         '4
         (fxand (fxarithmetic-shift _clen258134_ '-8) '255))
        (u8vector-set! _head258127_ '5 (fxand _clen258134_ '255))
        (write-subu8vector _head258127_ '0 '8 _port258120_)
        (write-subu8vector _data258123_ _start258124_ _end258132_ _port258120_)
        (force-output _port258120_))))
  (define std/web/fastcgi#fcgi-write-record__0
    (lambda (_port258140_ _type258141_ _reqid258142_ _data258143_)
      (let* ((_start258145_ '0) (_end258147_ '#f))
        (std/web/fastcgi#fcgi-write-record__%
         _port258140_
         _type258141_
         _reqid258142_
         _data258143_
         _start258145_
         _end258147_))))
  (define std/web/fastcgi#fcgi-write-record__1
    (lambda (_port258149_
             _type258150_
             _reqid258151_
             _data258152_
             _start258153_)
      (let ((_end258155_ '#f))
        (std/web/fastcgi#fcgi-write-record__%
         _port258149_
         _type258150_
         _reqid258151_
         _data258152_
         _start258153_
         _end258155_))))
  (define std/web/fastcgi#fcgi-write-record
    (lambda _g311110_
      (let ((_g311109_ (let () (declare (not safe)) (##length _g311110_))))
        (cond ((let () (declare (not safe)) (##fx= _g311109_ 4))
               (apply std/web/fastcgi#fcgi-write-record__0 _g311110_))
              ((let () (declare (not safe)) (##fx= _g311109_ 5))
               (apply std/web/fastcgi#fcgi-write-record__1 _g311110_))
              ((let () (declare (not safe)) (##fx= _g311109_ 6))
               (apply std/web/fastcgi#fcgi-write-record__% _g311110_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/web/fastcgi#fcgi-write-record
                _g311110_))))))
  (define std/web/fastcgi#fcgi-write-data
    (lambda (_port258103_ _type258104_ _reqid258105_ _data258106_)
      (let* ((_data258108_
              (if (string? _data258106_)
                  (std/text/utf8#string->utf8__0 _data258106_)
                  _data258106_))
             (_len258110_ (u8vector-length _data258108_)))
        (let _lp258113_ ((_start258115_ '0))
          (if (fx> (fx- _len258110_ _start258115_) '65535)
              (let ((_end258117_ (fx+ _start258115_ '65535)))
                (std/web/fastcgi#fcgi-write-record__%
                 _port258103_
                 _type258104_
                 _reqid258105_
                 _data258108_
                 _start258115_
                 _end258117_)
                (_lp258113_ _end258117_))
              (std/web/fastcgi#fcgi-write-record__%
               _port258103_
               _type258104_
               _reqid258105_
               _data258108_
               _start258115_
               _len258110_))))))
  (define std/web/fastcgi#fcgi-write-key-value-pairs
    (lambda (_port258024_ _alst258025_)
      (letrec ((_write-length258027_
                (lambda (_port258095_ _len258096_)
                  (if (fx< _len258096_ '128)
                      (write-u8 _len258096_ _port258095_)
                      (let ((_nb3258098_
                             (fxior (fxand (fxarithmetic-shift
                                            _len258096_
                                            '-24)
                                           '127)
                                    '128))
                            (_nb2258099_
                             (fxand (fxarithmetic-shift _len258096_ '-16)
                                    '255))
                            (_nb1258100_
                             (fxand (fxarithmetic-shift _len258096_ '-8) '255))
                            (_nb0258101_ (fxand _len258096_ '255)))
                        (write-u8 _nb3258098_ _port258095_)
                        (write-u8 _nb2258099_ _port258095_)
                        (write-u8 _nb1258100_ _port258095_)
                        (write-u8 _nb0258101_ _port258095_))))))
        (let ((_iterable258069_ _alst258025_)
              (_iter-do258071_
               (lambda (_val258029_)
                 (let* ((_val258031258038_ _val258029_)
                        (_E258033258042_
                         (lambda ()
                           (error '"No clause matching" _val258031258038_)))
                        (_K258034258057_
                         (lambda (_value258045_ _key258046_)
                           (let* ((_kdata258048_
                                   (std/text/utf8#string->utf8__0
                                    (symbol->string _key258046_)))
                                  (_klen258050_
                                   (u8vector-length _kdata258048_))
                                  (_vdata258052_
                                   (if (string? _value258045_)
                                       (std/text/utf8#string->utf8__0
                                        _value258045_)
                                       _value258045_))
                                  (_vlen258054_
                                   (u8vector-length _vdata258052_)))
                             (_write-length258027_ _port258024_ _klen258050_)
                             (_write-length258027_ _port258024_ _vlen258054_)
                             (write-subu8vector
                              _kdata258048_
                              '0
                              _klen258050_
                              _port258024_)
                             (write-subu8vector
                              _vdata258052_
                              '0
                              _vlen258054_
                              _port258024_)))))
                   (if (let ()
                         (declare (not safe))
                         (##pair? _val258031258038_))
                       (let ((_hd258035258060_
                              (let ()
                                (declare (not safe))
                                (##car _val258031258038_)))
                             (_tl258036258062_
                              (let ()
                                (declare (not safe))
                                (##cdr _val258031258038_))))
                         (let* ((_key258065_ _hd258035258060_)
                                (_value258067_ _tl258036258062_))
                           (_K258034258057_ _value258067_ _key258065_)))
                       (_E258033258042_))))))
          (if (pair? _iterable258069_)
              (for-each _iter-do258071_ _iterable258069_)
              (if (null? _iterable258069_)
                  '#!void
                  (let* ((_it258074_ (std/iter#iter _iterable258069_))
                         (_next!258077_
                          (let ()
                            (declare (not safe))
                            (##unchecked-structure-ref
                             _it258074_
                             '2
                             std/iter#iterator::t
                             '#f))))
                    (declare (not safe))
                    (begin
                      (let _lp258082_ ()
                        (let ((_val258086_ (_next!258077_ _it258074_)))
                          (if (eq? std/iter#iter-end _val258086_)
                              '#!void
                              (begin
                                (_iter-do258071_ _val258086_)
                                (_lp258082_)))))
                      (let ((_$e258088_
                             (##unchecked-structure-ref
                              _it258074_
                              '3
                              std/iter#iterator::t
                              '#f)))
                        (if _$e258088_
                            ((lambda (_g258090258092_)
                               (_g258090258092_ _it258074_))
                             _$e258088_)
                            '#!void))
                      '#!void))))))))
  (define std/web/fastcgi#fcgi-begin-request-e
    (lambda (_data258019_)
      (let ((_role258021_
             (fxior (fxarithmetic-shift (u8vector-ref _data258019_ '0) '8)
                    (u8vector-ref _data258019_ '1)))
            (_flags258022_ (u8vector-ref _data258019_ '2)))
        (if (eq? _role258021_ std/web/fastcgi#FCGI-RESPONDER)
            (values 'FCGI-RESPONDER _flags258022_)
            (if (eq? _role258021_ std/web/fastcgi#FCGI-AUTHORIZER)
                (values 'FCGI-AUTHORIZER _flags258022_)
                (if (eq? _role258021_ std/web/fastcgi#FCGI-FILTER)
                    (values 'FCGI-FILTER _flags258022_)
                    (values _role258021_ _flags258022_)))))))
  (define std/web/fastcgi#fcgi-get-values-e
    (lambda (_data258017_)
      (map car
           (std/web/fastcgi#fcgi-read-key-value-pairs
            (open-input-u8vector _data258017_)))))
  (define std/web/fastcgi#fcgi-params-e
    (lambda (_data258015_)
      (std/web/fastcgi#fcgi-read-key-value-pairs
       (open-input-u8vector _data258015_))))
  (define std/web/fastcgi#fcgi-get-values-result-data
    (lambda (_alst258011_)
      (let ((_outp258013_ (open-output-u8vector)))
        (std/web/fastcgi#fcgi-write-key-value-pairs _outp258013_ _alst258011_)
        (get-output-u8vector _outp258013_))))
  (define std/web/fastcgi#fcgi-unknown-type-data
    (lambda (_type258007_)
      (let ((_data258009_ (make-u8vector '8)))
        (u8vector-set! _data258009_ '0 _type258007_)
        _data258009_)))
  (define std/web/fastcgi#fcgi-end-request-data
    (lambda (_app-status258002_ _proto-status258003_)
      (let ((_data258005_ (make-u8vector '8)))
        (u8vector-set!
         _data258005_
         '0
         (fxand (fxarithmetic-shift _app-status258002_ '-24) '255))
        (u8vector-set!
         _data258005_
         '1
         (fxand (fxarithmetic-shift _app-status258002_ '-16) '255))
        (u8vector-set!
         _data258005_
         '2
         (fxand (fxarithmetic-shift _app-status258002_ '-8) '255))
        (u8vector-set! _data258005_ '3 (fxand _app-status258002_ '255))
        (u8vector-set! _data258005_ '4 _proto-status258003_)
        _data258005_))))
