(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/web/rack#errorf
    (lambda (_fmt258824_ . _args258825_)
      (std/logger#log-message 'rack '0 _fmt258824_ _args258825_)))
  (define std/web/rack#warnf
    (lambda (_fmt258821_ . _args258822_)
      (std/logger#log-message 'rack '1 _fmt258821_ _args258822_)))
  (define std/web/rack#infof
    (lambda (_fmt258818_ . _args258819_)
      (std/logger#log-message 'rack '2 _fmt258818_ _args258819_)))
  (define std/web/rack#debugf
    (lambda (_fmt258815_ . _args258816_)
      (std/logger#log-message 'rack '3 _fmt258815_ _args258816_)))
  (define std/web/rack#verbosef
    (lambda (_fmt258810_ . _args258812_)
      (std/logger#log-message 'rack '4 _fmt258810_ _args258812_)))
  (define std/web/rack#start-rack-fastcgi-server!
    (lambda (_address258803_ _handler258804_)
      (std/web/fastcgi#start-fastcgi-server!
       _address258803_
       (lambda (_g258805258807_)
         (std/web/rack#rack-fastcgi-respond
          _g258805258807_
          _handler258804_)))))
  (define std/web/rack#rack-fastcgi-respond
    (lambda (_req258656_ _handler258657_)
      (letrec ((_collect-data258659_
                (lambda (_body258752_)
                  (let ((_out258754_ (open-output-u8vector)))
                    (let ((_iterable258777_ _body258752_)
                          (_iter-do258779_
                           (lambda (_val258756_)
                             (let* ((_val258758258763_ _val258756_)
                                    (_E258760258767_
                                     (lambda ()
                                       (error '"No clause matching"
                                              _val258758258763_)))
                                    (_K258761258772_
                                     (lambda (_next258770_)
                                       (if (u8vector? _next258770_)
                                           (write-subu8vector
                                            _next258770_
                                            '0
                                            (u8vector-length _next258770_)
                                            _out258754_)
                                           (if (string? _next258770_)
                                               (write-substring
                                                _next258770_
                                                '0
                                                (string-length _next258770_)
                                                _out258754_)
                                               (std/error#raise-io-error
                                                'rack-fastcgi-respond
                                                '"bad response chunk"
                                                _next258770_)))))
                                    (_next258775_ _val258758258763_))
                               (_K258761258772_ _next258775_)))))
                      (if (pair? _iterable258777_)
                          (for-each _iter-do258779_ _iterable258777_)
                          (if (null? _iterable258777_)
                              '#!void
                              (let* ((_it258782_
                                      (std/iter#iter _iterable258777_))
                                     (_next!258785_
                                      (let ()
                                        (declare (not safe))
                                        (##unchecked-structure-ref
                                         _it258782_
                                         '2
                                         std/iter#iterator::t
                                         '#f))))
                                (declare (not safe))
                                (begin
                                  (let _lp258790_ ()
                                    (let ((_val258794_
                                           (_next!258785_ _it258782_)))
                                      (if (eq? std/iter#iter-end _val258794_)
                                          '#!void
                                          (begin
                                            (_iter-do258779_ _val258794_)
                                            (_lp258790_)))))
                                  (let ((_$e258796_
                                         (##unchecked-structure-ref
                                          _it258782_
                                          '3
                                          std/iter#iterator::t
                                          '#f)))
                                    (if _$e258796_
                                        ((lambda (_g258798258800_)
                                           (_g258798258800_ _it258782_))
                                         _$e258796_)
                                        '#!void))
                                  '#!void)))))
                    (get-output-u8vector _out258754_))))
               (_log-response-error258660_
                (lambda (_e258744_)
                  (std/web/rack#errorf '"rack response error: ~a" _e258744_)
                  (let ((_errstr258750_
                         (call-with-output-string
                          '()
                          (lambda (_g258745258747_)
                            (display-exception _e258744_ _g258745258747_)))))
                    (std/web/fastcgi#fastcgi-write-stderr
                     _req258656_
                     _errstr258750_)))))
        (with-exception-catcher
         (lambda (_g258661258663_)
           (if '#t
               (let ((_e258666_ _g258661258663_))
                 (_log-response-error258660_ _e258666_))
               (raise _g258661258663_)))
         (lambda ()
           (let ((_g311126_
                  (with-exception-catcher
                   (lambda (_g258668258670_)
                     (if '#t
                         (let ((_e258673_ _g258668258670_))
                           (_log-response-error258660_ _e258673_)
                           (values '500 '() '"OOPS! Something went wrong."))
                         (raise _g258668258670_)))
                   (lambda ()
                     (_handler258657_
                      (##structure-ref
                       _req258656_
                       '5
                       std/web/fastcgi#fastcgi-request::t
                       '#f)
                      (##structure-ref
                       _req258656_
                       '6
                       std/web/fastcgi#fastcgi-request::t
                       '#f))))))
             (begin
               (let ((_g311127_
                      (let ()
                        (declare (not safe))
                        (if (##values? _g311126_)
                            (##vector-length _g311126_)
                            1))))
                 (if (not (let () (declare (not safe)) (##fx= _g311127_ 3)))
                     (error "Context expects 3 values" _g311127_)))
               (let ((_status258676_
                      (let () (declare (not safe)) (##vector-ref _g311126_ 0)))
                     (_headers258677_
                      (let () (declare (not safe)) (##vector-ref _g311126_ 1)))
                     (_body258678_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _g311126_ 2))))
                 (let* ((_status-text258680_
                         (table-ref
                          std/web/rack#*http-response-codes*
                          _status258676_
                          '"(Unknown)"))
                        (_body-data258682_
                         (if (u8vector? _body258678_)
                             _body258678_
                             (if (string? _body258678_)
                                 (std/text/utf8#string->utf8__0 _body258678_)
                                 (_collect-data258659_ _body258678_))))
                        (_hout258684_ (open-output-u8vector)))
                   (std/format#fprintf
                    _hout258684_
                    '"Status: ~a ~a\r\n"
                    _status258676_
                    _status-text258680_)
                   (let ((_iterable258718_ _headers258677_)
                         (_iter-do258720_
                          (lambda (_val258687_)
                            (let* ((_val258689258696_ _val258687_)
                                   (_E258691258700_
                                    (lambda ()
                                      (error '"No clause matching"
                                             _val258689258696_)))
                                   (_K258692258706_
                                    (lambda (_value258703_ _key258704_)
                                      (std/format#fprintf
                                       _hout258684_
                                       '"~a: ~a\r\n"
                                       _key258704_
                                       _value258703_))))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _val258689258696_))
                                  (let ((_hd258693258709_
                                         (let ()
                                           (declare (not safe))
                                           (##car _val258689258696_)))
                                        (_tl258694258711_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _val258689258696_))))
                                    (let* ((_key258714_ _hd258693258709_)
                                           (_value258716_ _tl258694258711_))
                                      (_K258692258706_
                                       _value258716_
                                       _key258714_)))
                                  (_E258691258700_))))))
                     (if (pair? _iterable258718_)
                         (for-each _iter-do258720_ _iterable258718_)
                         (if (null? _iterable258718_)
                             '#!void
                             (let* ((_it258723_
                                     (std/iter#iter _iterable258718_))
                                    (_next!258726_
                                     (let ()
                                       (declare (not safe))
                                       (##unchecked-structure-ref
                                        _it258723_
                                        '2
                                        std/iter#iterator::t
                                        '#f))))
                               (declare (not safe))
                               (begin
                                 (let _lp258731_ ()
                                   (let ((_val258735_
                                          (_next!258726_ _it258723_)))
                                     (if (eq? std/iter#iter-end _val258735_)
                                         '#!void
                                         (begin
                                           (_iter-do258720_ _val258735_)
                                           (_lp258731_)))))
                                 (let ((_$e258737_
                                        (##unchecked-structure-ref
                                         _it258723_
                                         '3
                                         std/iter#iterator::t
                                         '#f)))
                                   (if _$e258737_
                                       ((lambda (_g258739258741_)
                                          (_g258739258741_ _it258723_))
                                        _$e258737_)
                                       '#!void))
                                 '#!void)))))
                   (std/format#fprintf
                    _hout258684_
                    '"Content-Length: ~a\r\n"
                    (u8vector-length _body-data258682_))
                   (std/format#fprintf _hout258684_ '"\r\n")
                   (std/web/fastcgi#fastcgi-write-stdout
                    _req258656_
                    (get-output-u8vector _hout258684_))
                   (std/web/fastcgi#fastcgi-write-stdout
                    _req258656_
                    _body-data258682_))))))))))
  (define std/web/rack#*http-response-codes*
    (let ((_ht258653_ (make-table 'test: eq? 'size: '40)))
      (table-set! _ht258653_ '100 '"Continue")
      (table-set! _ht258653_ '101 '"Switching Protocols")
      (table-set! _ht258653_ '200 '"OK")
      (table-set! _ht258653_ '201 '"Created")
      (table-set! _ht258653_ '202 '"Accepted")
      (table-set! _ht258653_ '203 '"Non-Authoritative Information")
      (table-set! _ht258653_ '204 '"No Content")
      (table-set! _ht258653_ '205 '"Reset Content")
      (table-set! _ht258653_ '206 '"Partial Content")
      (table-set! _ht258653_ '300 '"Multiple Choices")
      (table-set! _ht258653_ '301 '"Moved Permanently")
      (table-set! _ht258653_ '302 '"Found")
      (table-set! _ht258653_ '303 '"See Other")
      (table-set! _ht258653_ '304 '"Not Modified")
      (table-set! _ht258653_ '305 '"Use Proxy")
      (table-set! _ht258653_ '307 '"Temporary Redirect")
      (table-set! _ht258653_ '400 '"Bad Request")
      (table-set! _ht258653_ '401 '"Unauthorized")
      (table-set! _ht258653_ '402 '"Payment Required")
      (table-set! _ht258653_ '403 '"Forbidden")
      (table-set! _ht258653_ '404 '"Not Found")
      (table-set! _ht258653_ '405 '"Method Not Allowed")
      (table-set! _ht258653_ '406 '"Not Acceptable")
      (table-set! _ht258653_ '407 '"Proxy Authentication Required")
      (table-set! _ht258653_ '408 '"Request Timeout")
      (table-set! _ht258653_ '409 '"Conflict")
      (table-set! _ht258653_ '410 '"Gone")
      (table-set! _ht258653_ '411 '"Length Required")
      (table-set! _ht258653_ '412 '"Precondition Failed")
      (table-set! _ht258653_ '413 '"Request Entity Too Large")
      (table-set! _ht258653_ '414 '"Request-URI Too Long")
      (table-set! _ht258653_ '415 '"Unsupported Media Type")
      (table-set! _ht258653_ '416 '"Requested Range Not Satisfiable")
      (table-set! _ht258653_ '417 '"Expectation Failed")
      (table-set! _ht258653_ '500 '"Internal Server Error")
      (table-set! _ht258653_ '501 '"Not Implemented")
      (table-set! _ht258653_ '502 '"Bad Gateway")
      (table-set! _ht258653_ '503 '"Service Unavailable")
      (table-set! _ht258653_ '504 '"Gateway Timeout")
      (table-set! _ht258653_ '505 '"HTTP Version Not Supported")
      _ht258653_)))
